/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl__restorezd2valuezd2typesz123349z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33506ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t, obj_t);
	static obj_t
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, BgL_valuez00_bglt, obj_t,
		obj_t);
	static obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	static obj_t BGl__findzd2globalzd2zzast_envz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t BGl__getzd2genvzd2zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	static obj_t BGl__forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	static obj_t BGl__restorezd2valuezd2typesz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_zc3anonymousza33361ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl__getzd2globalzf2modulez20zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	static obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl__bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123352z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123354z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123356z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123359z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl__globalzd2bucketzd2positionz00zzast_envz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern BgL_globalz00_bglt BGl_makezd2globalzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl__findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl__forza7d2eachza7d2gl3638z00, va_generic_entry,
		BGl__forzd2eachzd2globalz12z12zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl__findza7d2globalza7d3639z00, va_generic_entry,
		BGl__findzd2globalzd2zzast_envz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl__initializa7a7eza7d23640z00,
		BGl__initializa7ezd2Genvz12z67zzast_envz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl__globalza7d2bucket3641za7,
		BGl__globalzd2bucketzd2positionz00zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl__alreadyza7d2resto3642za7,
		BGl__alreadyzd2restoredzf3z21zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl__getza7d2genvza7d2za7za73643z00, BGl__getzd2genvzd2zzast_envz00, 0L,
		BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__unbindza7d2global3644za7, BGl__unbindzd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__getza7d2globalza7f23645z00,
		BGl__getzd2globalzf2modulez20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__addza7d2genvza712za7c3646za7, BGl__addzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__restoreza7d2globa3647za7, BGl__restorezd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__setza7d2genvza712za7c3648za7, BGl__setzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl__additionalza7d2he3649za7,
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00, 0L, BUNSPEC,
		0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__findza7d2globalza7f3650z00,
		BGl__findzd2globalzf2modulez20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3618z00zzast_envz00,
		BgL_bgl_za7c3anonymousza7a333651z00,
		BGl_zc3anonymousza33361ze3z83zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3626z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73652z00,
		BGl_restorezd2valuezd2typesz123352z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3627z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73653z00,
		BGl_restorezd2valuezd2typesz123354z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3628z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73654z00,
		BGl_restorezd2valuezd2typesz123356z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3629z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73655z00,
		BGl_restorezd2valuezd2typesz123359z12zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_restorezd2valuezd2typesz123349zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3656za7,
		BGl__restorezd2valuezd2typesz123349z12zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3657za7,
		BGl__restorezd2valuezd2typesz12z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3620z00zzast_envz00,
		BgL_bgl_string3620za700za7za7a3658za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string3619z00zzast_envz00,
		BgL_bgl_string3619za700za7za7a3659za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3621z00zzast_envz00,
		BgL_bgl_string3621za700za7za7a3660za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string3622z00zzast_envz00,
		BgL_bgl_string3622za700za7za7a3661za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string3623z00zzast_envz00,
		BgL_bgl_string3623za700za7za7a3662za7, "eval", 4);
	      DEFINE_STRING(BGl_string3624z00zzast_envz00,
		BgL_bgl_string3624za700za7za7a3663za7, "unbind-global!", 14);
	      DEFINE_STRING(BGl_string3625z00zzast_envz00,
		BgL_bgl_string3625za700za7za7a3664za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string3630z00zzast_envz00,
		BgL_bgl_string3630za700za7za7a3665za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string3631z00zzast_envz00,
		BgL_bgl_string3631za700za7za7a3666za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string3632z00zzast_envz00,
		BgL_bgl_string3632za700za7za7a3667za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string3633z00zzast_envz00,
		BgL_bgl_string3633za700za7za7a3668za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string3634z00zzast_envz00,
		BgL_bgl_string3634za700za7za7a3669za7, "ast_env", 7);
	      DEFINE_STRING(BGl_string3635z00zzast_envz00,
		BgL_bgl_string3635za700za7za7a3670za7,
		"eval now read @ get-global/module foreign the-global-environment ", 65);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__bindza7d2globalza713671z00, BGl__bindzd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_1912, char *BgL_fromz00_1913)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					BGl_toplevelzd2initzd2zzast_envz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_1903;

				BgL_cportz00_1903 =
					bgl_open_input_string(BGl_string3635z00zzast_envz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1904;

					BgL_iz00_1904 = ((long) 6);
				BgL_loopz00_1905:
					if ((BgL_iz00_1904 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg3637z00_1907;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_1909;

										BgL_locationz00_1909 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg3637z00_1907 =
												BGl_readz00zz__readerz00(BgL_cportz00_1903,
												BgL_locationz00_1909);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_auxz00_1936;

									BgL_auxz00_1936 = (int) (BgL_iz00_1904);
									CNST_TABLE_SET(BgL_auxz00_1936, BgL_arg3637z00_1907);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_1910;

								BgL_auxz00_1910 = (int) ((BgL_iz00_1904 - ((long) 1)));
								{
									long BgL_iz00_1941;

									BgL_iz00_1941 = (long) (BgL_auxz00_1910);
									BgL_iz00_1904 = BgL_iz00_1941;
									goto BgL_loopz00_1905;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}
	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_1)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_1, BUNSPEC);
		}
	}



/* _set-genv! */
	obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1843,
		obj_t BgL_genvz00_1844)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_1844);
		}
	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_2)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_2,
				BGl_proc3618z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}
	}



/* _add-genv! */
	obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1846,
		obj_t BgL_genvz00_1847)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_1847);
		}
	}



/* <anonymous:3361> */
	obj_t BGl_zc3anonymousza33361ze3z83zzast_envz00(obj_t BgL_envz00_1848,
		obj_t BgL_kz00_1849, obj_t BgL_bucketz00_1850)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 66 */
			{
				obj_t BgL_kz00_875;

				obj_t BgL_bucketz00_876;

				{	/* Ast/venv.scm 67 */
					bool_t BgL_auxz00_1947;

					BgL_kz00_875 = BgL_kz00_1849;
					BgL_bucketz00_876 = BgL_bucketz00_1850;
					{	/* Ast/venv.scm 67 */
						obj_t BgL_g3343z00_878;

						BgL_g3343z00_878 = CDR(BgL_bucketz00_876);
						{
							obj_t BgL_l3341z00_880;

							BgL_l3341z00_880 = BgL_g3343z00_878;
						BgL_zc3anonymousza33362ze3z83_881:
							if (PAIRP(BgL_l3341z00_880))
								{	/* Ast/venv.scm 87 */
									{	/* Ast/venv.scm 86 */
										obj_t BgL_newz00_883;

										BgL_newz00_883 = CAR(BgL_l3341z00_880);
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
											MAKE_PAIR(BgL_newz00_883,
											BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
										{	/* Ast/venv.scm 69 */
											obj_t BgL_modulez00_884;

											{
												BgL_globalz00_bglt BgL_auxz00_1953;

												BgL_auxz00_1953 = (BgL_globalz00_bglt) (BgL_newz00_883);
												BgL_modulez00_884 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1953))->
													BgL_modulez00);
											}
											{	/* Ast/venv.scm 69 */
												obj_t BgL_idz00_885;

												{
													BgL_variablez00_bglt BgL_auxz00_1956;

													BgL_auxz00_1956 =
														(BgL_variablez00_bglt) (BgL_newz00_883);
													BgL_idz00_885 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1956))->
														BgL_idz00);
												}
												{	/* Ast/venv.scm 70 */
													obj_t BgL_bucketz00_886;

													BgL_bucketz00_886 =
														BGl_hashtablezd2getzd2zz__hashz00
														(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_885);
													{	/* Ast/venv.scm 71 */

														if (PAIRP(BgL_bucketz00_886))
															{	/* Ast/venv.scm 75 */
																bool_t BgL_testz00_1962;

																if (
																	(BgL_modulez00_884 ==
																		BGl_za2moduleza2z00zzmodule_modulez00))
																	{	/* Ast/venv.scm 75 */
																		BgL_testz00_1962 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/venv.scm 76 */
																		bool_t BgL_testz00_1965;

																		{	/* Ast/venv.scm 77 */
																			obj_t BgL_arg3372z00_896;

																			{	/* Ast/venv.scm 77 */
																				BgL_globalz00_bglt BgL_obj1583z00_1559;

																				{	/* Ast/venv.scm 77 */
																					obj_t BgL_pairz00_1555;

																					BgL_pairz00_1555 = BgL_bucketz00_886;
																					{	/* Ast/venv.scm 77 */
																						obj_t BgL_pairz00_1558;

																						BgL_pairz00_1558 =
																							CDR(BgL_pairz00_1555);
																						BgL_obj1583z00_1559 =
																							(BgL_globalz00_bglt) (CAR
																							(BgL_pairz00_1558));
																					}
																				}
																				BgL_arg3372z00_896 =
																					(((BgL_globalz00_bglt)
																						CREF(BgL_obj1583z00_1559))->
																					BgL_modulez00);
																			}
																			BgL_testz00_1965 =
																				(BGl_za2moduleza2z00zzmodule_modulez00
																				== BgL_arg3372z00_896);
																		}
																		if (BgL_testz00_1965)
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1962 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1962 = ((bool_t) 1);
																			}
																	}
																if (BgL_testz00_1962)
																	{	/* Ast/venv.scm 83 */
																		obj_t BgL_newzd2bucketzd2_889;

																		BgL_newzd2bucketzd2_889 =
																			MAKE_PAIR(BgL_newz00_883,
																			CDR(BgL_bucketz00_886));
																		SET_CDR(BgL_bucketz00_886,
																			BgL_newzd2bucketzd2_889);
																	}
																else
																	{	/* Ast/venv.scm 86 */
																		obj_t BgL_arg3367z00_891;

																		obj_t BgL_arg3368z00_892;

																		BgL_arg3367z00_891 = CDR(BgL_bucketz00_886);
																		{	/* Ast/venv.scm 86 */
																			obj_t BgL_arg3369z00_893;

																			{	/* Ast/venv.scm 86 */
																				obj_t BgL_pairz00_1564;

																				BgL_pairz00_1564 = BgL_bucketz00_886;
																				BgL_arg3369z00_893 =
																					CDR(CDR(BgL_pairz00_1564));
																			}
																			BgL_arg3368z00_892 =
																				MAKE_PAIR(BgL_newz00_883,
																				BgL_arg3369z00_893);
																		}
																		SET_CDR(BgL_arg3367z00_891,
																			BgL_arg3368z00_892);
																	}
															}
														else
															{	/* Ast/venv.scm 74 */
																obj_t BgL_arg3374z00_898;

																{	/* Ast/venv.scm 74 */
																	obj_t BgL_list3375z00_899;

																	{	/* Ast/venv.scm 74 */
																		obj_t BgL_arg3376z00_900;

																		BgL_arg3376z00_900 =
																			MAKE_PAIR(BgL_newz00_883, BNIL);
																		BgL_list3375z00_899 =
																			MAKE_PAIR(BgL_idz00_885,
																			BgL_arg3376z00_900);
																	}
																	BgL_arg3374z00_898 = BgL_list3375z00_899;
																}
																BGl_hashtablezd2putz12zc0zz__hashz00
																	(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_885,
																	BgL_arg3374z00_898);
															}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l3341z00_1982;

										BgL_l3341z00_1982 = CDR(BgL_l3341z00_880);
										BgL_l3341z00_880 = BgL_l3341z00_1982;
										goto BgL_zc3anonymousza33362ze3z83_881;
									}
								}
							else
								{	/* Ast/venv.scm 87 */
									BgL_auxz00_1947 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1947);
				}
			}
		}
	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			{
				obj_t BgL_l3344z00_905;

				BgL_l3344z00_905 = BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_zc3anonymousza33378ze3z83_906:
				if (PAIRP(BgL_l3344z00_905))
					{	/* Ast/venv.scm 105 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l3344z00_905));
						{
							obj_t BgL_l3344z00_1989;

							BgL_l3344z00_1989 = CDR(BgL_l3344z00_905);
							BgL_l3344z00_905 = BgL_l3344z00_1989;
							goto BgL_zc3anonymousza33378ze3z83_906;
						}
					}
				else
					{	/* Ast/venv.scm 105 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}
	}



/* _additional-heap-restore-globals! */
	obj_t BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t
		BgL_envz00_1851)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}
	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_4)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_PAIR(BgL_newz00_4, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 114 */
				BgL_typez00_bglt BgL_typez00_912;

				{
					BgL_variablez00_bglt BgL_auxz00_1993;

					BgL_auxz00_1993 = (BgL_variablez00_bglt) (BgL_newz00_4);
					BgL_typez00_912 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_1993))->BgL_typez00);
				}
				{	/* Ast/venv.scm 115 */
					BgL_valuez00_bglt BgL_valuez00_913;

					{
						BgL_variablez00_bglt BgL_auxz00_1996;

						BgL_auxz00_1996 = (BgL_variablez00_bglt) (BgL_newz00_4);
						BgL_valuez00_913 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_1996))->BgL_valuez00);
					}
					{	/* Ast/venv.scm 116 */
						obj_t BgL_typezd2idzd2_914;

						BgL_typezd2idzd2_914 =
							(((BgL_typez00_bglt) CREF(BgL_typez00_912))->BgL_idz00);
						{	/* Ast/venv.scm 117 */

							{
								BgL_typez00_bglt BgL_auxz00_2002;

								BgL_variablez00_bglt BgL_auxz00_2000;

								BgL_auxz00_2002 =
									BGl_findzd2typezd2zztype_envz00(BgL_typezd2idzd2_914);
								BgL_auxz00_2000 = (BgL_variablez00_bglt) (BgL_newz00_4);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2000))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_2002), BUNSPEC);
							}
							{	/* Ast/venv.scm 121 */
								obj_t BgL_method3350z00_1584;

								{	/* Ast/venv.scm 121 */
									BgL_objectz00_bglt BgL_objz00_1585;

									BgL_objz00_1585 = (BgL_objectz00_bglt) (BgL_valuez00_913);
									{	/* Ast/venv.scm 121 */
										long BgL_objzd2classzd2numz00_1586;

										BgL_objzd2classzd2numz00_1586 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1585);
										{	/* Ast/venv.scm 121 */
											obj_t BgL_arg2551z00_1587;

											BgL_arg2551z00_1587 =
												PROCEDURE_REF
												(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
												(int) (((long) 1)));
											{	/* Ast/venv.scm 121 */
												obj_t BgL_arrayz00_1589;

												int BgL_offsetz00_1590;

												BgL_arrayz00_1589 = BgL_arg2551z00_1587;
												BgL_offsetz00_1590 =
													(int) (BgL_objzd2classzd2numz00_1586);
												{	/* Ast/venv.scm 121 */
													long BgL_offsetz00_1591;

													BgL_offsetz00_1591 =
														((long) (BgL_offsetz00_1590) - OBJECT_TYPE);
													{	/* Ast/venv.scm 121 */
														long BgL_modz00_1592;

														{	/* Ast/venv.scm 121 */
															int BgL_arg2553z00_1593;

															BgL_arg2553z00_1593 = (int) (((long) 8));
															{	/* Ast/venv.scm 121 */
																long BgL_auxz00_2013;

																BgL_auxz00_2013 = (long) (BgL_arg2553z00_1593);
																BgL_modz00_1592 =
																	(BgL_offsetz00_1591 / BgL_auxz00_2013);
														}}
														{	/* Ast/venv.scm 121 */
															long BgL_restz00_1594;

															{	/* Ast/venv.scm 121 */
																int BgL_arg2552z00_1595;

																BgL_arg2552z00_1595 = (int) (((long) 8));
																{	/* Ast/venv.scm 121 */
																	long BgL_auxz00_2017;

																	BgL_auxz00_2017 =
																		(long) (BgL_arg2552z00_1595);
																	BgL_restz00_1594 =
																		(BgL_offsetz00_1591 % BgL_auxz00_2017);
															}}
															{	/* Ast/venv.scm 121 */

																BgL_method3350z00_1584 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1589,
																		(int) (BgL_modz00_1592)),
																	(int) (BgL_restz00_1594));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3350z00_1584) (BgL_method3350z00_1584,
									(obj_t) (BgL_valuez00_913), BEOA);
							}
							{	/* Ast/venv.scm 123 */
								bool_t BgL_testz00_2027;

								{	/* Ast/venv.scm 123 */
									bool_t BgL_testz00_2028;

									{	/* Ast/venv.scm 123 */
										obj_t BgL_arg3392z00_925;

										BgL_arg3392z00_925 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										{
											BgL_backendz00_bglt BgL_auxz00_2030;

											BgL_auxz00_2030 =
												(BgL_backendz00_bglt) (BgL_arg3392z00_925);
											BgL_testz00_2028 =
												(((BgL_backendz00_bglt) CREF(BgL_auxz00_2030))->
												BgL_qualifiedzd2typeszd2);
									}}
									if (BgL_testz00_2028)
										{	/* Ast/venv.scm 124 */
											bool_t BgL_testz00_2033;

											{	/* Ast/venv.scm 124 */
												obj_t BgL_auxz00_2034;

												{
													BgL_globalz00_bglt BgL_auxz00_2035;

													BgL_auxz00_2035 = (BgL_globalz00_bglt) (BgL_newz00_4);
													BgL_auxz00_2034 =
														(((BgL_globalz00_bglt) CREF(BgL_auxz00_2035))->
														BgL_modulez00);
												}
												BgL_testz00_2033 =
													(BgL_auxz00_2034 == CNST_TABLE_REF(((long) 1)));
											}
											if (BgL_testz00_2033)
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2027 = ((bool_t) 0);
												}
											else
												{	/* Ast/venv.scm 124 */
													BgL_testz00_2027 = ((bool_t) 1);
												}
										}
									else
										{	/* Ast/venv.scm 123 */
											BgL_testz00_2027 = ((bool_t) 0);
										}
								}
								if (BgL_testz00_2027)
									{	/* Ast/venv.scm 125 */
										obj_t BgL_arg3384z00_917;

										obj_t BgL_arg3385z00_918;

										obj_t BgL_arg3386z00_919;

										{
											BgL_globalz00_bglt BgL_auxz00_2040;

											BgL_auxz00_2040 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3384z00_917 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2040))->
												BgL_modulez00);
										}
										{
											BgL_globalz00_bglt BgL_auxz00_2043;

											BgL_auxz00_2043 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3385z00_918 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2043))->
												BgL_jvmzd2typezd2namez00);
										}
										BgL_arg3386z00_919 =
											BGl_shapez00zztools_shapez00(BgL_newz00_4);
										{	/* Ast/venv.scm 125 */
											obj_t BgL_list3387z00_920;

											BgL_list3387z00_920 = MAKE_PAIR(BgL_arg3386z00_919, BNIL);
											return
												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
												(BgL_arg3384z00_917, BgL_arg3385z00_918,
												BgL_list3387z00_920);
										}
									}
								else
									{	/* Ast/venv.scm 123 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
	}



/* _restore-global! */
	obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1852,
		obj_t BgL_newz00_1853)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_1853);
		}
	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_6)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_6,
				BGl_za2restoredza2z00zzast_envz00);
		}
	}



/* _already-restored? */
	obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t BgL_envz00_1856,
		obj_t BgL_funz00_1857)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_1857);
		}
	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* _get-genv */
	obj_t BGl__getzd2genvzd2zzast_envz00(obj_t BgL_envz00_1858)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}
	}



/* _initialize-Genv! */
	obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t BgL_envz00_1859)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}
	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_13,
		obj_t BgL_modulez00_14)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			{	/* Ast/venv.scm 234 */
				obj_t BgL_bucketz00_927;

				obj_t BgL_modulez00_928;

				BgL_bucketz00_927 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_13);
				if (NULLP(BgL_modulez00_14))
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_928 = BNIL;
					}
				else
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_928 = CAR(BgL_modulez00_14);
					}
				if (PAIRP(BgL_bucketz00_927))
					{	/* Ast/venv.scm 237 */
						if (NULLP(CDR(BgL_bucketz00_927)))
							{	/* Ast/venv.scm 239 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 239 */
								if (NULLP(BgL_modulez00_928))
									{	/* Ast/venv.scm 242 */
										obj_t BgL_pairz00_1619;

										BgL_pairz00_1619 = BgL_bucketz00_927;
										return CAR(CDR(BgL_pairz00_1619));
									}
								else
									{
										obj_t BgL_globalsz00_934;

										BgL_globalsz00_934 = CDR(BgL_bucketz00_927);
									BgL_zc3anonymousza33397ze3z83_935:
										if (NULLP(BgL_globalsz00_934))
											{	/* Ast/venv.scm 246 */
												return BFALSE;
											}
										else
											{	/* Ast/venv.scm 248 */
												bool_t BgL_testz00_2069;

												{	/* Ast/venv.scm 248 */
													obj_t BgL_auxz00_2070;

													{	/* Ast/venv.scm 248 */
														BgL_globalz00_bglt BgL_obj1583z00_1626;

														{	/* Ast/venv.scm 248 */
															obj_t BgL_pairz00_1625;

															BgL_pairz00_1625 = BgL_globalsz00_934;
															BgL_obj1583z00_1626 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1625));
														}
														BgL_auxz00_2070 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1583z00_1626))->BgL_modulez00);
													}
													BgL_testz00_2069 =
														(BgL_auxz00_2070 == BgL_modulez00_928);
												}
												if (BgL_testz00_2069)
													{	/* Ast/venv.scm 248 */
														return CAR(BgL_globalsz00_934);
													}
												else
													{
														obj_t BgL_globalsz00_2076;

														BgL_globalsz00_2076 = CDR(BgL_globalsz00_934);
														BgL_globalsz00_934 = BgL_globalsz00_2076;
														goto BgL_zc3anonymousza33397ze3z83_935;
													}
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 237 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global */
	obj_t BGl__findzd2globalzd2zzast_envz00(obj_t BgL_envz00_1860,
		obj_t BgL_idz00_1861, obj_t BgL_modulez00_1862)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1861, BgL_modulez00_1862);
		}
	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_15, obj_t BgL_modulez00_16)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			{	/* Ast/venv.scm 257 */
				obj_t BgL_bucketz00_944;

				BgL_bucketz00_944 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_15);
				if (PAIRP(BgL_bucketz00_944))
					{	/* Ast/venv.scm 259 */
						if (NULLP(CDR(BgL_bucketz00_944)))
							{	/* Ast/venv.scm 261 */
								return BFALSE;
							}
						else
							{
								obj_t BgL_globalsz00_950;

								BgL_globalsz00_950 = CDR(BgL_bucketz00_944);
							BgL_zc3anonymousza33408ze3z83_951:
								if (NULLP(BgL_globalsz00_950))
									{	/* Ast/venv.scm 268 */
										return BFALSE;
									}
								else
									{	/* Ast/venv.scm 270 */
										bool_t BgL_testz00_2088;

										{	/* Ast/venv.scm 270 */
											obj_t BgL_auxz00_2089;

											{	/* Ast/venv.scm 270 */
												BgL_globalz00_bglt BgL_obj1583z00_1640;

												{	/* Ast/venv.scm 270 */
													obj_t BgL_pairz00_1639;

													BgL_pairz00_1639 = BgL_globalsz00_950;
													BgL_obj1583z00_1640 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1639));
												}
												BgL_auxz00_2089 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1583z00_1640))->
													BgL_modulez00);
											}
											BgL_testz00_2088 = (BgL_auxz00_2089 == BgL_modulez00_16);
										}
										if (BgL_testz00_2088)
											{	/* Ast/venv.scm 270 */
												return CAR(BgL_globalsz00_950);
											}
										else
											{
												obj_t BgL_globalsz00_2095;

												BgL_globalsz00_2095 = CDR(BgL_globalsz00_950);
												BgL_globalsz00_950 = BgL_globalsz00_2095;
												goto BgL_zc3anonymousza33408ze3z83_951;
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 259 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global/module */
	obj_t BGl__findzd2globalzf2modulez20zzast_envz00(obj_t BgL_envz00_1863,
		obj_t BgL_idz00_1864, obj_t BgL_modulez00_1865)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1864,
				BgL_modulez00_1865);
		}
	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_17, obj_t BgL_modulez00_18)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			{	/* Ast/venv.scm 279 */
				obj_t BgL_globalz00_959;

				BgL_globalz00_959 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_17,
					BgL_modulez00_18);
				{	/* Ast/venv.scm 280 */
					bool_t BgL_testz00_2100;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_959,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 280 */
							BgL_testz00_2100 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 280 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2100 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2100 = ((bool_t) 1);
								}
						}
					if (BgL_testz00_2100)
						{	/* Ast/venv.scm 281 */
							obj_t BgL_arg3417z00_961;

							obj_t BgL_arg3419z00_963;

							BgL_arg3417z00_961 = CNST_TABLE_REF(((long) 2));
							{	/* Ast/venv.scm 283 */
								obj_t BgL_list3420z00_964;

								{	/* Ast/venv.scm 283 */
									obj_t BgL_arg3421z00_965;

									BgL_arg3421z00_965 = MAKE_PAIR(BgL_modulez00_18, BNIL);
									BgL_list3420z00_964 =
										MAKE_PAIR(BgL_idz00_17, BgL_arg3421z00_965);
								}
								BgL_arg3419z00_963 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string3619z00zzast_envz00, BgL_list3420z00_964);
							}
							BGl_internalzd2errorzd2zztools_errorz00(BgL_arg3417z00_961,
								BGl_string3620z00zzast_envz00, BgL_arg3419z00_963);
						}
					else
						{	/* Ast/venv.scm 280 */
							BFALSE;
						}
				}
				return BgL_globalz00_959;
			}
		}
	}



/* _get-global/module */
	obj_t BGl__getzd2globalzf2modulez20zzast_envz00(obj_t BgL_envz00_1866,
		obj_t BgL_idz00_1867, obj_t BgL_modulez00_1868)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_1867,
				BgL_modulez00_1868);
		}
	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_19,
		obj_t BgL_oz00_20, obj_t BgL_msgz00_21)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 289 */
			{	/* Ast/venv.scm 290 */
				bool_t BgL_testz00_2111;

				{	/* Ast/venv.scm 290 */
					bool_t BgL_testz00_2112;

					{	/* Ast/venv.scm 290 */
						int BgL_arg3442z00_990;

						BgL_arg3442z00_990 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_testz00_2112 = ((long) (BgL_arg3442z00_990) > ((long) 0));
					}
					if (BgL_testz00_2112)
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2111 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2111 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2111)
					{	/* Ast/venv.scm 292 */
						obj_t BgL_locz00_969;

						obj_t BgL_oldz00_970;

						obj_t BgL_newz00_971;

						obj_t BgL_msgz00_972;

						{	/* Ast/venv.scm 292 */
							obj_t BgL_arg3424z00_973;

							{
								BgL_globalz00_bglt BgL_auxz00_2117;

								BgL_auxz00_2117 = (BgL_globalz00_bglt) (BgL_oz00_20);
								BgL_arg3424z00_973 =
									(((BgL_globalz00_bglt) CREF(BgL_auxz00_2117))->BgL_srcz00);
							}
							BgL_locz00_969 =
								BGl_findzd2locationzd2zztools_locationz00(BgL_arg3424z00_973);
						}
						{	/* Ast/venv.scm 293 */
							obj_t BgL_arg3425z00_974;

							obj_t BgL_arg3426z00_975;

							BgL_arg3425z00_974 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 293 */
								obj_t BgL_arg3427z00_976;

								obj_t BgL_arg3428z00_977;

								{
									BgL_variablez00_bglt BgL_auxz00_2122;

									BgL_auxz00_2122 = (BgL_variablez00_bglt) (BgL_oz00_20);
									BgL_arg3427z00_976 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2122))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2125;

									BgL_auxz00_2125 = (BgL_globalz00_bglt) (BgL_oz00_20);
									BgL_arg3428z00_977 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2125))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 293 */
									obj_t BgL_list3430z00_979;

									{	/* Ast/venv.scm 293 */
										obj_t BgL_arg3431z00_980;

										BgL_arg3431z00_980 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3430z00_979 =
											MAKE_PAIR(BgL_arg3428z00_977, BgL_arg3431z00_980);
									}
									BgL_arg3426z00_975 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3427z00_976, BgL_list3430z00_979);
							}}
							BgL_oldz00_970 =
								MAKE_PAIR(BgL_arg3425z00_974, BgL_arg3426z00_975);
						}
						{	/* Ast/venv.scm 294 */
							obj_t BgL_arg3433z00_981;

							obj_t BgL_arg3434z00_982;

							BgL_arg3433z00_981 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 294 */
								obj_t BgL_arg3435z00_983;

								obj_t BgL_arg3436z00_984;

								{
									BgL_variablez00_bglt BgL_auxz00_2133;

									BgL_auxz00_2133 = (BgL_variablez00_bglt) (BgL_nz00_19);
									BgL_arg3435z00_983 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2133))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2136;

									BgL_auxz00_2136 = (BgL_globalz00_bglt) (BgL_nz00_19);
									BgL_arg3436z00_984 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2136))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 294 */
									obj_t BgL_list3438z00_986;

									{	/* Ast/venv.scm 294 */
										obj_t BgL_arg3439z00_987;

										BgL_arg3439z00_987 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3438z00_986 =
											MAKE_PAIR(BgL_arg3436z00_984, BgL_arg3439z00_987);
									}
									BgL_arg3434z00_982 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3435z00_983, BgL_list3438z00_986);
							}}
							BgL_newz00_971 =
								MAKE_PAIR(BgL_arg3433z00_981, BgL_arg3434z00_982);
						}
						if (PAIRP(BgL_msgz00_21))
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_972 = CAR(BgL_msgz00_21);
							}
						else
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_972 = BGl_string3621z00zzast_envz00;
							}
						if (CBOOL(BgL_locz00_969))
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_969, BgL_oldz00_970, BgL_msgz00_972,
									BgL_newz00_971);
							}
						else
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_970,
									BgL_msgz00_972, BgL_newz00_971);
							}
					}
				else
					{	/* Ast/venv.scm 290 */
						return BFALSE;
					}
			}
		}
	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_22,
		obj_t BgL_srcz00_23)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 303 */
			{	/* Ast/venv.scm 305 */
				obj_t BgL_locz00_993;

				BgL_locz00_993 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_23);
				if (CBOOL(BgL_locz00_993))
					{	/* Ast/venv.scm 308 */
						obj_t BgL_arg3444z00_995;

						obj_t BgL_arg3445z00_996;

						{
							BgL_globalz00_bglt BgL_auxz00_2153;

							BgL_auxz00_2153 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3444z00_995 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2153))->BgL_modulez00);
						}
						BgL_arg3445z00_996 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_993,
							BgL_arg3444z00_995, BGl_string3622z00zzast_envz00,
							BgL_arg3445z00_996, BNIL);
					}
				else
					{	/* Ast/venv.scm 309 */
						obj_t BgL_arg3447z00_998;

						obj_t BgL_arg3448z00_999;

						{
							BgL_globalz00_bglt BgL_auxz00_2158;

							BgL_auxz00_2158 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3447z00_998 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2158))->BgL_modulez00);
						}
						BgL_arg3448z00_999 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg3447z00_998,
							BGl_string3622z00zzast_envz00, BgL_arg3448z00_999, BNIL);
					}
			}
		}
	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_24,
		obj_t BgL_srcz00_25)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 314 */
			{	/* Ast/venv.scm 316 */
				obj_t BgL_locz00_1002;

				BgL_locz00_1002 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_25);
				if (CBOOL(BgL_locz00_1002))
					{	/* Ast/venv.scm 319 */
						obj_t BgL_arg3450z00_1004;

						obj_t BgL_arg3451z00_1005;

						{
							BgL_globalz00_bglt BgL_auxz00_2166;

							BgL_auxz00_2166 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3450z00_1004 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2166))->BgL_modulez00);
						}
						BgL_arg3451z00_1005 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_1002,
							BgL_arg3450z00_1004, BGl_string3622z00zzast_envz00,
							BgL_arg3451z00_1005);
					}
				else
					{	/* Ast/venv.scm 320 */
						obj_t BgL_arg3452z00_1006;

						obj_t BgL_arg3453z00_1007;

						{
							BgL_globalz00_bglt BgL_auxz00_2171;

							BgL_auxz00_2171 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3452z00_1006 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2171))->BgL_modulez00);
						}
						BgL_arg3453z00_1007 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg3452z00_1006,
							BGl_string3622z00zzast_envz00, BgL_arg3453z00_1007);
					}
			}
		}
	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_26, obj_t BgL_modulez00_27, BgL_valuez00_bglt BgL_valuez00_28,
		obj_t BgL_importz00_29, obj_t BgL_srcz00_30)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			{	/* Ast/venv.scm 340 */
				obj_t BgL_oldz00_1008;

				{	/* Ast/venv.scm 340 */
					obj_t BgL_list3485z00_1045;

					BgL_list3485z00_1045 = MAKE_PAIR(BgL_modulez00_27, BNIL);
					BgL_oldz00_1008 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_26,
						BgL_list3485z00_1045);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_oldz00_1008,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 341 */
						if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
							{	/* Ast/venv.scm 343 */
								return (BgL_globalz00_bglt) (BgL_oldz00_1008);
							}
						else
							{	/* Ast/venv.scm 345 */
								bool_t BgL_testz00_2183;

								{	/* Ast/venv.scm 345 */
									obj_t BgL_auxz00_2184;

									{
										BgL_globalz00_bglt BgL_auxz00_2185;

										BgL_auxz00_2185 = (BgL_globalz00_bglt) (BgL_oldz00_1008);
										BgL_auxz00_2184 =
											(((BgL_globalz00_bglt) CREF(BgL_auxz00_2185))->
											BgL_modulez00);
									}
									BgL_testz00_2183 = (BgL_modulez00_27 == BgL_auxz00_2184);
								}
								if (BgL_testz00_2183)
									{	/* Ast/venv.scm 345 */
										BGl_warningzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_1008, BgL_srcz00_30);
										return (BgL_globalz00_bglt) (BgL_oldz00_1008);
									}
								else
									{	/* Ast/venv.scm 345 */
										return
											(BgL_globalz00_bglt)
											(BGl_errorzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_1008, BgL_srcz00_30));
									}
							}
					}
				else
					{	/* Ast/venv.scm 350 */
						obj_t BgL_bucketz00_1012;

						BgL_globalz00_bglt BgL_newz00_1013;

						BgL_bucketz00_1012 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_26);
						{	/* Ast/var.scm 32 */
							obj_t BgL_arg3479z00_1039;

							obj_t BgL_arg3480z00_1040;

							obj_t BgL_arg3483z00_1043;

							BgL_arg3479z00_1039 = CNST_TABLE_REF(((long) 4));
							BgL_arg3480z00_1040 = CNST_TABLE_REF(((long) 5));
							if ((BgL_importz00_29 == CNST_TABLE_REF(((long) 6))))
								{	/* Ast/venv.scm 353 */
									BgL_arg3483z00_1043 = BGl_string3623z00zzast_envz00;
								}
							else
								{	/* Ast/venv.scm 353 */
									BgL_arg3483z00_1043 =
										BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
										(BgL_modulez00_27);
								}
							BgL_newz00_1013 =
								BGl_makezd2globalzd2zzast_varz00(BgL_idz00_26, BFALSE,
								(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00),
								BgL_valuez00_28, BgL_arg3479z00_1039, BUNSPEC,
								BgL_arg3480z00_1040, ((long) 0), BgL_modulez00_27,
								BgL_importz00_29, ((bool_t) 1), BFALSE, ((bool_t) 1), BNIL,
								BgL_srcz00_30, BgL_arg3483z00_1043);
						}
						{	/* Ast/venv.scm 361 */
							bool_t BgL_testz00_2202;

							if (PAIRP(BgL_bucketz00_1012))
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2202 = NULLP(CDR(BgL_bucketz00_1012));
								}
							else
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2202 = ((bool_t) 1);
								}
							if (BgL_testz00_2202)
								{	/* Ast/venv.scm 361 */
									{	/* Ast/venv.scm 363 */
										obj_t BgL_arg3458z00_1015;

										{	/* Ast/venv.scm 363 */
											obj_t BgL_list3459z00_1016;

											{	/* Ast/venv.scm 363 */
												obj_t BgL_arg3460z00_1017;

												BgL_arg3460z00_1017 =
													MAKE_PAIR((obj_t) (BgL_newz00_1013), BNIL);
												BgL_list3459z00_1016 =
													MAKE_PAIR(BgL_idz00_26, BgL_arg3460z00_1017);
											}
											BgL_arg3458z00_1015 = BgL_list3459z00_1016;
										}
										BGl_hashtablezd2putz12zc0zz__hashz00
											(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_26,
											BgL_arg3458z00_1015);
									}
									return BgL_newz00_1013;
								}
							else
								{	/* Ast/venv.scm 366 */
									obj_t BgL_oldza2za2_1018;

									BgL_oldza2za2_1018 = CDR(BgL_bucketz00_1012);
									{	/* Ast/venv.scm 366 */
										obj_t BgL_midz00_1019;

										{	/* Ast/venv.scm 368 */
											obj_t BgL_arg3475z00_1035;

											{	/* Ast/venv.scm 368 */
												BgL_globalz00_bglt BgL_obj1583z00_1666;

												{	/* Ast/venv.scm 368 */
													obj_t BgL_pairz00_1665;

													BgL_pairz00_1665 = BgL_oldza2za2_1018;
													BgL_obj1583z00_1666 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1665));
												}
												BgL_arg3475z00_1035 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1583z00_1666))->
													BgL_modulez00);
											}
											BgL_midz00_1019 =
												BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
												(BgL_arg3475z00_1035);
										}
										{	/* Ast/venv.scm 367 */

											{	/* Ast/venv.scm 370 */
												bool_t BgL_testz00_2216;

												{	/* Ast/venv.scm 370 */
													obj_t BgL_arg3473z00_1033;

													{	/* Ast/venv.scm 370 */
														BgL_globalz00_bglt BgL_obj1583z00_1668;

														{	/* Ast/venv.scm 370 */
															obj_t BgL_pairz00_1667;

															BgL_pairz00_1667 = BgL_oldza2za2_1018;
															BgL_obj1583z00_1668 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1667));
														}
														BgL_arg3473z00_1033 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1583z00_1668))->BgL_modulez00);
													}
													BgL_testz00_2216 =
														(BgL_arg3473z00_1033 ==
														BGl_za2moduleza2z00zzmodule_modulez00);
												}
												if (BgL_testz00_2216)
													{	/* Ast/venv.scm 370 */
														{	/* Ast/venv.scm 372 */
															bool_t BgL_testz00_2221;

															if ((BgL_idz00_26 == BgL_midz00_1019))
																{	/* Ast/venv.scm 372 */
																	BgL_testz00_2221 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 372 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2221 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2221 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2221)
																{	/* Ast/venv.scm 372 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		(CAR(BgL_oldza2za2_1018),
																		(obj_t) (BgL_newz00_1013), BNIL);
																}
															else
																{	/* Ast/venv.scm 372 */
																	BFALSE;
																}
														}
														{	/* Ast/venv.scm 374 */
															obj_t BgL_arg3466z00_1025;

															obj_t BgL_arg3467z00_1026;

															BgL_arg3466z00_1025 = CDR(BgL_bucketz00_1012);
															{	/* Ast/venv.scm 374 */
																obj_t BgL_arg3468z00_1027;

																{	/* Ast/venv.scm 374 */
																	obj_t BgL_pairz00_1671;

																	BgL_pairz00_1671 = BgL_bucketz00_1012;
																	BgL_arg3468z00_1027 =
																		CDR(CDR(BgL_pairz00_1671));
																}
																BgL_arg3467z00_1026 =
																	MAKE_PAIR(
																	(obj_t) (BgL_newz00_1013),
																	BgL_arg3468z00_1027);
															}
															SET_CDR(BgL_arg3466z00_1025, BgL_arg3467z00_1026);
														}
														return BgL_newz00_1013;
													}
												else
													{	/* Ast/venv.scm 377 */
														obj_t BgL_newza2za2_1028;

														BgL_newza2za2_1028 =
															MAKE_PAIR(
															(obj_t) (BgL_newz00_1013), BgL_oldza2za2_1018);
														{	/* Ast/venv.scm 378 */
															bool_t BgL_testz00_2237;

															if ((BgL_idz00_26 == BgL_midz00_1019))
																{	/* Ast/venv.scm 378 */
																	BgL_testz00_2237 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 378 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2237 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2237 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2237)
																{	/* Ast/venv.scm 378 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		((obj_t) (BgL_newz00_1013),
																		CAR(BgL_oldza2za2_1018), BNIL);
																}
															else
																{	/* Ast/venv.scm 378 */
																	BFALSE;
																}
														}
														SET_CDR(BgL_bucketz00_1012, BgL_newza2za2_1028);
														return BgL_newz00_1013;
													}
											}
										}
									}
								}
						}
					}
			}
		}
	}



/* _bind-global! */
	obj_t BGl__bindzd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1869,
		obj_t BgL_idz00_1870, obj_t BgL_modulez00_1871, obj_t BgL_valuez00_1872,
		obj_t BgL_importz00_1873, obj_t BgL_srcz00_1874)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			return
				(obj_t) (BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_1870,
					BgL_modulez00_1871, (BgL_valuez00_bglt) (BgL_valuez00_1872),
					BgL_importz00_1873, BgL_srcz00_1874));
		}
	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_31, obj_t BgL_modulez00_32)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			{	/* Ast/venv.scm 387 */
				obj_t BgL_globalz00_1046;

				{	/* Ast/venv.scm 387 */
					obj_t BgL_list3502z00_1068;

					BgL_list3502z00_1068 = MAKE_PAIR(BgL_modulez00_32, BNIL);
					BgL_globalz00_1046 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_31,
						BgL_list3502z00_1068);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1046,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 390 */
						obj_t BgL_bucketz00_1048;

						BgL_bucketz00_1048 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_31);
						{	/* Ast/venv.scm 391 */
							obj_t BgL_g3339z00_1049;

							BgL_g3339z00_1049 = CDR(BgL_bucketz00_1048);
							{
								obj_t BgL_curz00_1051;

								obj_t BgL_prevz00_1052;

								BgL_curz00_1051 = BgL_g3339z00_1049;
								BgL_prevz00_1052 = BgL_bucketz00_1048;
							BgL_zc3anonymousza33487ze3z83_1053:
								if ((CAR(BgL_curz00_1051) == BgL_globalz00_1046))
									{	/* Ast/venv.scm 394 */
										obj_t BgL_auxz00_2258;

										BgL_auxz00_2258 = CDR(BgL_curz00_1051);
										return SET_CDR(BgL_prevz00_1052, BgL_auxz00_2258);
									}
								else
									{
										obj_t BgL_prevz00_2263;

										obj_t BgL_curz00_2261;

										BgL_curz00_2261 = CDR(BgL_curz00_1051);
										BgL_prevz00_2263 = CDR(BgL_prevz00_1052);
										BgL_prevz00_1052 = BgL_prevz00_2263;
										BgL_curz00_1051 = BgL_curz00_2261;
										goto BgL_zc3anonymousza33487ze3z83_1053;
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 389 */
						obj_t BgL_arg3496z00_1062;

						{	/* Ast/venv.scm 389 */
							obj_t BgL_arg3498z00_1064;

							obj_t BgL_arg3499z00_1065;

							BgL_arg3498z00_1064 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 389 */
								obj_t BgL_list3500z00_1066;

								{	/* Ast/venv.scm 389 */
									obj_t BgL_arg3501z00_1067;

									BgL_arg3501z00_1067 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3500z00_1066 =
										MAKE_PAIR(BgL_modulez00_32, BgL_arg3501z00_1067);
								}
								BgL_arg3499z00_1065 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_idz00_31,
									BgL_list3500z00_1066);
							}
							BgL_arg3496z00_1062 =
								MAKE_PAIR(BgL_arg3498z00_1064, BgL_arg3499z00_1065);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string3624z00zzast_envz00,
							BGl_string3625z00zzast_envz00, BgL_arg3496z00_1062, BNIL);
					}
			}
		}
	}



/* _unbind-global! */
	obj_t BGl__unbindzd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1875,
		obj_t BgL_idz00_1876, obj_t BgL_modulez00_1877)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_1876,
				BgL_modulez00_1877);
		}
	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_33, obj_t BgL_envz00_34)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			{	/* Ast/venv.scm 401 */
				obj_t BgL_arg3503z00_1069;

				if (NULLP(BgL_envz00_34))
					{	/* Ast/venv.scm 401 */
						BgL_arg3503z00_1069 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 401 */
						BgL_arg3503z00_1069 = CAR(BgL_envz00_34);
					}
				{	/* Ast/venv.scm 402 */
					obj_t BgL_zc3anonymousza33506ze3z83_1878;

					BgL_zc3anonymousza33506ze3z83_1878 =
						make_fx_procedure(BGl_zc3anonymousza33506ze3z83zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33506ze3z83_1878,
						(int) (((long) 0)), BgL_procz00_33);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg3503z00_1069,
						BgL_zc3anonymousza33506ze3z83_1878);
				}
			}
		}
	}



/* _for-each-global! */
	obj_t BGl__forzd2eachzd2globalz12z12zzast_envz00(obj_t BgL_envz00_1879,
		obj_t BgL_procz00_1880, obj_t BgL_envz00_1881)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_1880,
				BgL_envz00_1881);
		}
	}



/* <anonymous:3506> */
	obj_t BGl_zc3anonymousza33506ze3z83zzast_envz00(obj_t BgL_envz00_1882,
		obj_t BgL_kz00_1884, obj_t BgL_bucketz00_1885)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 402 */
			{	/* Ast/venv.scm 402 */
				obj_t BgL_procz00_1883;

				BgL_procz00_1883 = PROCEDURE_REF(BgL_envz00_1882, (int) (((long) 0)));
				{
					obj_t BgL_kz00_1072;

					obj_t BgL_bucketz00_1073;

					{	/* Ast/venv.scm 402 */
						bool_t BgL_auxz00_2284;

						BgL_kz00_1072 = BgL_kz00_1884;
						BgL_bucketz00_1073 = BgL_bucketz00_1885;
						{	/* Ast/venv.scm 402 */
							obj_t BgL_g3348z00_1075;

							BgL_g3348z00_1075 = CDR(BgL_bucketz00_1073);
							{
								obj_t BgL_l3346z00_1077;

								BgL_l3346z00_1077 = BgL_g3348z00_1075;
							BgL_zc3anonymousza33507ze3z83_1078:
								if (PAIRP(BgL_l3346z00_1077))
									{	/* Ast/venv.scm 402 */
										{	/* Ast/venv.scm 402 */
											obj_t BgL_arg3509z00_1080;

											BgL_arg3509z00_1080 = CAR(BgL_l3346z00_1077);
											PROCEDURE_ENTRY(BgL_procz00_1883) (BgL_procz00_1883,
												BgL_arg3509z00_1080, BEOA);
										}
										{
											obj_t BgL_l3346z00_2291;

											BgL_l3346z00_2291 = CDR(BgL_l3346z00_1077);
											BgL_l3346z00_1077 = BgL_l3346z00_2291;
											goto BgL_zc3anonymousza33507ze3z83_1078;
										}
									}
								else
									{	/* Ast/venv.scm 402 */
										BgL_auxz00_2284 = ((bool_t) 1);
									}
							}
						}
						return BBOOL(BgL_auxz00_2284);
					}
				}
			}
		}
	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_35, obj_t BgL_modulez00_36)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			{	/* Ast/venv.scm 408 */
				obj_t BgL_bucketz00_1084;

				BgL_bucketz00_1084 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_35);
				if (PAIRP(BgL_bucketz00_1084))
					{
						obj_t BgL_globalsz00_1088;

						long BgL_posz00_1089;

						{	/* Ast/venv.scm 411 */
							long BgL_auxz00_2297;

							BgL_globalsz00_1088 = CDR(BgL_bucketz00_1084);
							BgL_posz00_1089 = ((long) 0);
						BgL_zc3anonymousza33512ze3z83_1090:
							if (NULLP(BgL_globalsz00_1088))
								{	/* Ast/venv.scm 414 */
									BgL_auxz00_2297 = ((long) -1);
								}
							else
								{	/* Ast/venv.scm 416 */
									bool_t BgL_testz00_2300;

									{	/* Ast/venv.scm 416 */
										obj_t BgL_auxz00_2301;

										{	/* Ast/venv.scm 416 */
											BgL_globalz00_bglt BgL_obj1583z00_1698;

											{	/* Ast/venv.scm 416 */
												obj_t BgL_pairz00_1697;

												BgL_pairz00_1697 = BgL_globalsz00_1088;
												BgL_obj1583z00_1698 =
													(BgL_globalz00_bglt) (CAR(BgL_pairz00_1697));
											}
											BgL_auxz00_2301 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1583z00_1698))->
												BgL_modulez00);
										}
										BgL_testz00_2300 = (BgL_auxz00_2301 == BgL_modulez00_36);
									}
									if (BgL_testz00_2300)
										{	/* Ast/venv.scm 416 */
											BgL_auxz00_2297 = BgL_posz00_1089;
										}
									else
										{
											long BgL_posz00_2308;

											obj_t BgL_globalsz00_2306;

											BgL_globalsz00_2306 = CDR(BgL_globalsz00_1088);
											BgL_posz00_2308 = (BgL_posz00_1089 + ((long) 1));
											BgL_posz00_1089 = BgL_posz00_2308;
											BgL_globalsz00_1088 = BgL_globalsz00_2306;
											goto BgL_zc3anonymousza33512ze3z83_1090;
										}
								}
							return BINT(BgL_auxz00_2297);
						}
					}
				else
					{	/* Ast/venv.scm 409 */
						return BINT(((long) -1));
		}}}
	}



/* _global-bucket-position */
	obj_t BGl__globalzd2bucketzd2positionz00zzast_envz00(obj_t BgL_envz00_1886,
		obj_t BgL_idz00_1887, obj_t BgL_modulez00_1888)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_1887,
				BgL_modulez00_1888);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_restorezd2valuezd2typesz123349zd2envzc0zzast_envz00);
		}
	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_7)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			{	/* Ast/venv.scm 152 */
				obj_t BgL_method3350z00_1702;

				{	/* Ast/venv.scm 152 */
					BgL_objectz00_bglt BgL_objz00_1703;

					BgL_objz00_1703 = (BgL_objectz00_bglt) (BgL_valuez00_7);
					{	/* Ast/venv.scm 152 */
						long BgL_objzd2classzd2numz00_1704;

						BgL_objzd2classzd2numz00_1704 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1703);
						{	/* Ast/venv.scm 152 */
							obj_t BgL_arg2551z00_1705;

							BgL_arg2551z00_1705 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 152 */
								obj_t BgL_arrayz00_1707;

								int BgL_offsetz00_1708;

								BgL_arrayz00_1707 = BgL_arg2551z00_1705;
								BgL_offsetz00_1708 = (int) (BgL_objzd2classzd2numz00_1704);
								{	/* Ast/venv.scm 152 */
									long BgL_offsetz00_1709;

									BgL_offsetz00_1709 =
										((long) (BgL_offsetz00_1708) - OBJECT_TYPE);
									{	/* Ast/venv.scm 152 */
										long BgL_modz00_1710;

										{	/* Ast/venv.scm 152 */
											int BgL_arg2553z00_1711;

											BgL_arg2553z00_1711 = (int) (((long) 8));
											{	/* Ast/venv.scm 152 */
												long BgL_auxz00_2323;

												BgL_auxz00_2323 = (long) (BgL_arg2553z00_1711);
												BgL_modz00_1710 =
													(BgL_offsetz00_1709 / BgL_auxz00_2323);
										}}
										{	/* Ast/venv.scm 152 */
											long BgL_restz00_1712;

											{	/* Ast/venv.scm 152 */
												int BgL_arg2552z00_1713;

												BgL_arg2552z00_1713 = (int) (((long) 8));
												{	/* Ast/venv.scm 152 */
													long BgL_auxz00_2327;

													BgL_auxz00_2327 = (long) (BgL_arg2552z00_1713);
													BgL_restz00_1712 =
														(BgL_offsetz00_1709 % BgL_auxz00_2327);
											}}
											{	/* Ast/venv.scm 152 */

												BgL_method3350z00_1702 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1707,
														(int) (BgL_modz00_1710)), (int) (BgL_restz00_1712));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3350z00_1702) (BgL_method3350z00_1702,
					(obj_t) (BgL_valuez00_7), BEOA);
			}
		}
	}



/* _restore-value-types! */
	obj_t BGl__restorezd2valuezd2typesz12z12zzast_envz00(obj_t BgL_envz00_1854,
		obj_t BgL_valuez00_1855)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				(BgL_valuez00_bglt) (BgL_valuez00_1855));
		}
	}



/* _restore-value-types!3349 */
	obj_t BGl__restorezd2valuezd2typesz123349z12zzast_envz00(obj_t
		BgL_envz00_1889, obj_t BgL_valuez00_1890)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc3626z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc3627z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3628z00zzast_envz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc3629z00zzast_envz00);
		}
	}



/* restore-value-types!3359 */
	obj_t BGl_restorezd2valuezd2typesz123359z12zzast_envz00(obj_t BgL_envz00_1895,
		obj_t BgL_valuez00_1896)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 208 */
			{
				BgL_cfunz00_bglt BgL_valuez00_1532;

				{	/* Ast/venv.scm 208 */
					bool_t BgL_auxz00_2343;

					BgL_valuez00_1532 = (BgL_cfunz00_bglt) (BgL_valuez00_1896);
					{

						{	/* Ast/venv.scm 208 */
							obj_t BgL_nextzd2method3358zd2_1546;

							BgL_nextzd2method3358zd2_1546 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_valuez00_1532),
								BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								BGl_cfunz00zzast_varz00);
							if (PROCEDUREP(BgL_nextzd2method3358zd2_1546))
								{	/* Ast/venv.scm 208 */
									PROCEDURE_ENTRY(BgL_nextzd2method3358zd2_1546)
										(BgL_nextzd2method3358zd2_1546, (obj_t) (BgL_valuez00_1532),
										BEOA);
								}
							else
								{	/* Ast/venv.scm 208 */
									{	/* Ast/venv.scm 208 */
										BgL_valuez00_bglt BgL_valuez00_1817;

										BgL_valuez00_1817 = (BgL_valuez00_bglt) (BgL_valuez00_1532);
										{	/* Ast/venv.scm 208 */
											obj_t BgL_method3350z00_1818;

											{	/* Ast/venv.scm 208 */
												BgL_objectz00_bglt BgL_objz00_1819;

												BgL_objz00_1819 =
													(BgL_objectz00_bglt) (BgL_valuez00_1817);
												{	/* Ast/venv.scm 208 */
													long BgL_objzd2classzd2numz00_1820;

													BgL_objzd2classzd2numz00_1820 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1819);
													{	/* Ast/venv.scm 208 */
														obj_t BgL_arg2551z00_1821;

														BgL_arg2551z00_1821 =
															PROCEDURE_REF
															(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
															(int) (((long) 1)));
														{	/* Ast/venv.scm 208 */
															obj_t BgL_arrayz00_1823;

															int BgL_offsetz00_1824;

															BgL_arrayz00_1823 = BgL_arg2551z00_1821;
															BgL_offsetz00_1824 =
																(int) (BgL_objzd2classzd2numz00_1820);
															{	/* Ast/venv.scm 208 */
																long BgL_offsetz00_1825;

																BgL_offsetz00_1825 =
																	((long) (BgL_offsetz00_1824) - OBJECT_TYPE);
																{	/* Ast/venv.scm 208 */
																	long BgL_modz00_1826;

																	{	/* Ast/venv.scm 208 */
																		int BgL_arg2553z00_1827;

																		BgL_arg2553z00_1827 = (int) (((long) 8));
																		{	/* Ast/venv.scm 208 */
																			long BgL_auxz00_2360;

																			BgL_auxz00_2360 =
																				(long) (BgL_arg2553z00_1827);
																			BgL_modz00_1826 =
																				(BgL_offsetz00_1825 / BgL_auxz00_2360);
																	}}
																	{	/* Ast/venv.scm 208 */
																		long BgL_restz00_1828;

																		{	/* Ast/venv.scm 208 */
																			int BgL_arg2552z00_1829;

																			BgL_arg2552z00_1829 = (int) (((long) 8));
																			{	/* Ast/venv.scm 208 */
																				long BgL_auxz00_2364;

																				BgL_auxz00_2364 =
																					(long) (BgL_arg2552z00_1829);
																				BgL_restz00_1828 =
																					(BgL_offsetz00_1825 %
																					BgL_auxz00_2364);
																		}}
																		{	/* Ast/venv.scm 208 */

																			BgL_method3350z00_1818 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1823,
																					(int) (BgL_modz00_1826)),
																				(int) (BgL_restz00_1828));
											}}}}}}}}
											PROCEDURE_ENTRY(BgL_method3350z00_1818)
												(BgL_method3350z00_1818, (obj_t) (BgL_valuez00_1817),
												BEOA);
						}}}}
						{
							obj_t BgL_argsz00_1538;

							{	/* Ast/venv.scm 211 */
								obj_t BgL_arg3598z00_1537;

								BgL_arg3598z00_1537 =
									(((BgL_cfunz00_bglt) CREF(BgL_valuez00_1532))->
									BgL_argszd2typezd2);
								BgL_argsz00_1538 = BgL_arg3598z00_1537;
							BgL_zc3anonymousza33599ze3z83_1539:
								if (PAIRP(BgL_argsz00_1538))
									{	/* Ast/venv.scm 212 */
										{	/* Ast/venv.scm 214 */
											BgL_typez00_bglt BgL_arg3601z00_1541;

											{	/* Ast/venv.scm 214 */
												obj_t BgL_arg3602z00_1542;

												{	/* Ast/venv.scm 214 */
													BgL_typez00_bglt BgL_obj1414z00_1812;

													{	/* Ast/venv.scm 214 */
														obj_t BgL_pairz00_1811;

														BgL_pairz00_1811 = BgL_argsz00_1538;
														BgL_obj1414z00_1812 =
															(BgL_typez00_bglt) (CAR(BgL_pairz00_1811));
													}
													BgL_arg3602z00_1542 =
														(((BgL_typez00_bglt) CREF(BgL_obj1414z00_1812))->
														BgL_idz00);
												}
												BgL_arg3601z00_1541 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3602z00_1542);
											}
											{	/* Ast/venv.scm 214 */
												obj_t BgL_auxz00_2381;

												BgL_auxz00_2381 = (obj_t) (BgL_arg3601z00_1541);
												SET_CAR(BgL_argsz00_1538, BgL_auxz00_2381);
											}
										}
										{
											obj_t BgL_argsz00_2384;

											BgL_argsz00_2384 = CDR(BgL_argsz00_1538);
											BgL_argsz00_1538 = BgL_argsz00_2384;
											goto BgL_zc3anonymousza33599ze3z83_1539;
										}
									}
								else
									{	/* Ast/venv.scm 212 */
										BgL_auxz00_2343 = ((bool_t) 0);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_2343);
				}
			}
		}
	}



/* restore-value-types!3356 */
	obj_t BGl_restorezd2valuezd2typesz123356z12zzast_envz00(obj_t BgL_envz00_1897,
		obj_t BgL_valuez00_1898)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 201 */
			{
				BgL_isfunz00_bglt BgL_valuez00_1526;

				BgL_valuez00_1526 = (BgL_isfunz00_bglt) (BgL_valuez00_1898);
				{

					{	/* Ast/venv.scm 201 */
						obj_t BgL_nextzd2method3355zd2_1530;

						BgL_nextzd2method3355zd2_1530 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1526),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_isfunz00zzinline_inlinez00);
						if (PROCEDUREP(BgL_nextzd2method3355zd2_1530))
							{	/* Ast/venv.scm 201 */
								PROCEDURE_ENTRY(BgL_nextzd2method3355zd2_1530)
									(BgL_nextzd2method3355zd2_1530, (obj_t) (BgL_valuez00_1526),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 201 */
								{	/* Ast/venv.scm 201 */
									BgL_valuez00_bglt BgL_valuez00_1783;

									BgL_valuez00_1783 = (BgL_valuez00_bglt) (BgL_valuez00_1526);
									{	/* Ast/venv.scm 201 */
										obj_t BgL_method3350z00_1784;

										{	/* Ast/venv.scm 201 */
											BgL_objectz00_bglt BgL_objz00_1785;

											BgL_objz00_1785 =
												(BgL_objectz00_bglt) (BgL_valuez00_1783);
											{	/* Ast/venv.scm 201 */
												long BgL_objzd2classzd2numz00_1786;

												BgL_objzd2classzd2numz00_1786 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1785);
												{	/* Ast/venv.scm 201 */
													obj_t BgL_arg2551z00_1787;

													BgL_arg2551z00_1787 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 201 */
														obj_t BgL_arrayz00_1789;

														int BgL_offsetz00_1790;

														BgL_arrayz00_1789 = BgL_arg2551z00_1787;
														BgL_offsetz00_1790 =
															(int) (BgL_objzd2classzd2numz00_1786);
														{	/* Ast/venv.scm 201 */
															long BgL_offsetz00_1791;

															BgL_offsetz00_1791 =
																((long) (BgL_offsetz00_1790) - OBJECT_TYPE);
															{	/* Ast/venv.scm 201 */
																long BgL_modz00_1792;

																{	/* Ast/venv.scm 201 */
																	int BgL_arg2553z00_1793;

																	BgL_arg2553z00_1793 = (int) (((long) 8));
																	{	/* Ast/venv.scm 201 */
																		long BgL_auxz00_2404;

																		BgL_auxz00_2404 =
																			(long) (BgL_arg2553z00_1793);
																		BgL_modz00_1792 =
																			(BgL_offsetz00_1791 / BgL_auxz00_2404);
																}}
																{	/* Ast/venv.scm 201 */
																	long BgL_restz00_1794;

																	{	/* Ast/venv.scm 201 */
																		int BgL_arg2552z00_1795;

																		BgL_arg2552z00_1795 = (int) (((long) 8));
																		{	/* Ast/venv.scm 201 */
																			long BgL_auxz00_2408;

																			BgL_auxz00_2408 =
																				(long) (BgL_arg2552z00_1795);
																			BgL_restz00_1794 =
																				(BgL_offsetz00_1791 % BgL_auxz00_2408);
																	}}
																	{	/* Ast/venv.scm 201 */

																		BgL_method3350z00_1784 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1789,
																				(int) (BgL_modz00_1792)),
																			(int) (BgL_restz00_1794));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3350z00_1784)
											(BgL_method3350z00_1784, (obj_t) (BgL_valuez00_1783),
											BEOA);
					}}}}
					{	/* Ast/venv.scm 203 */
						BgL_nodez00_bglt BgL_arg3596z00_1529;

						{
							obj_t BgL_auxz00_2418;

							{	/* Ast/venv.scm 203 */
								BgL_objectz00_bglt BgL_auxz00_2419;

								BgL_auxz00_2419 = (BgL_objectz00_bglt) (BgL_valuez00_1526);
								BgL_auxz00_2418 = BGL_OBJECT_WIDENING(BgL_auxz00_2419);
							}
							BgL_arg3596z00_1529 =
								(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2418))->
								BgL_originalzd2bodyzd2);
						}
						return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg3596z00_1529);
					}
				}
			}
		}
	}



/* restore-value-types!3354 */
	obj_t BGl_restorezd2valuezd2typesz123354z12zzast_envz00(obj_t BgL_envz00_1899,
		obj_t BgL_valuez00_1900)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 166 */
			{
				BgL_sfunz00_bglt BgL_valuez00_1492;

				BgL_valuez00_1492 = (BgL_sfunz00_bglt) (BgL_valuez00_1900);
				{

					{	/* Ast/venv.scm 166 */
						obj_t BgL_nextzd2method3353zd2_1524;

						BgL_nextzd2method3353zd2_1524 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1492),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_sfunz00zzast_varz00);
						if (PROCEDUREP(BgL_nextzd2method3353zd2_1524))
							{	/* Ast/venv.scm 166 */
								PROCEDURE_ENTRY(BgL_nextzd2method3353zd2_1524)
									(BgL_nextzd2method3353zd2_1524, (obj_t) (BgL_valuez00_1492),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 166 */
								{	/* Ast/venv.scm 166 */
									BgL_valuez00_bglt BgL_valuez00_1755;

									BgL_valuez00_1755 = (BgL_valuez00_bglt) (BgL_valuez00_1492);
									{	/* Ast/venv.scm 166 */
										obj_t BgL_method3350z00_1756;

										{	/* Ast/venv.scm 166 */
											BgL_objectz00_bglt BgL_objz00_1757;

											BgL_objz00_1757 =
												(BgL_objectz00_bglt) (BgL_valuez00_1755);
											{	/* Ast/venv.scm 166 */
												long BgL_objzd2classzd2numz00_1758;

												BgL_objzd2classzd2numz00_1758 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1757);
												{	/* Ast/venv.scm 166 */
													obj_t BgL_arg2551z00_1759;

													BgL_arg2551z00_1759 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 166 */
														obj_t BgL_arrayz00_1761;

														int BgL_offsetz00_1762;

														BgL_arrayz00_1761 = BgL_arg2551z00_1759;
														BgL_offsetz00_1762 =
															(int) (BgL_objzd2classzd2numz00_1758);
														{	/* Ast/venv.scm 166 */
															long BgL_offsetz00_1763;

															BgL_offsetz00_1763 =
																((long) (BgL_offsetz00_1762) - OBJECT_TYPE);
															{	/* Ast/venv.scm 166 */
																long BgL_modz00_1764;

																{	/* Ast/venv.scm 166 */
																	int BgL_arg2553z00_1765;

																	BgL_arg2553z00_1765 = (int) (((long) 8));
																	{	/* Ast/venv.scm 166 */
																		long BgL_auxz00_2441;

																		BgL_auxz00_2441 =
																			(long) (BgL_arg2553z00_1765);
																		BgL_modz00_1764 =
																			(BgL_offsetz00_1763 / BgL_auxz00_2441);
																}}
																{	/* Ast/venv.scm 166 */
																	long BgL_restz00_1766;

																	{	/* Ast/venv.scm 166 */
																		int BgL_arg2552z00_1767;

																		BgL_arg2552z00_1767 = (int) (((long) 8));
																		{	/* Ast/venv.scm 166 */
																			long BgL_auxz00_2445;

																			BgL_auxz00_2445 =
																				(long) (BgL_arg2552z00_1767);
																			BgL_restz00_1766 =
																				(BgL_offsetz00_1763 % BgL_auxz00_2445);
																	}}
																	{	/* Ast/venv.scm 166 */

																		BgL_method3350z00_1756 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1761,
																				(int) (BgL_modz00_1764)),
																			(int) (BgL_restz00_1766));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3350z00_1756)
											(BgL_method3350z00_1756, (obj_t) (BgL_valuez00_1755),
											BEOA);
					}}}}
					{
						obj_t BgL_argsz00_1498;

						{	/* Ast/venv.scm 169 */
							obj_t BgL_arg3573z00_1497;

							BgL_arg3573z00_1497 =
								(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1492))->BgL_argsz00);
							BgL_argsz00_1498 = BgL_arg3573z00_1497;
						BgL_zc3anonymousza33574ze3z83_1499:
							if (PAIRP(BgL_argsz00_1498))
								{	/* Ast/venv.scm 172 */
									obj_t BgL_argz00_1501;

									BgL_argz00_1501 = CAR(BgL_argsz00_1498);
									if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1501,
											BGl_typez00zztype_typez00))
										{	/* Ast/venv.scm 175 */
											BgL_typez00_bglt BgL_arg3577z00_1503;

											{	/* Ast/venv.scm 175 */
												obj_t BgL_arg3578z00_1504;

												{
													BgL_typez00_bglt BgL_auxz00_2461;

													BgL_auxz00_2461 =
														(BgL_typez00_bglt) (BgL_argz00_1501);
													BgL_arg3578z00_1504 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2461))->
														BgL_idz00);
												}
												BgL_arg3577z00_1503 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3578z00_1504);
											}
											{	/* Ast/venv.scm 175 */
												obj_t BgL_auxz00_2465;

												BgL_auxz00_2465 = (obj_t) (BgL_arg3577z00_1503);
												SET_CAR(BgL_argsz00_1498, BgL_auxz00_2465);
											}
										}
									else
										{	/* Ast/venv.scm 174 */
											if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1501,
													BGl_localz00zzast_varz00))
												{	/* Ast/venv.scm 177 */
													BgL_typez00_bglt BgL_newzd2typezd2_1506;

													{	/* Ast/venv.scm 177 */
														obj_t BgL_arg3581z00_1507;

														{	/* Ast/venv.scm 177 */
															BgL_typez00_bglt BgL_obj1414z00_1742;

															{
																BgL_variablez00_bglt BgL_auxz00_2470;

																BgL_auxz00_2470 =
																	(BgL_variablez00_bglt) (BgL_argz00_1501);
																BgL_obj1414z00_1742 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_2470))->BgL_typez00);
															}
															BgL_arg3581z00_1507 =
																(((BgL_typez00_bglt)
																	CREF(BgL_obj1414z00_1742))->BgL_idz00);
														}
														BgL_newzd2typezd2_1506 =
															BGl_findzd2typezd2zztype_envz00
															(BgL_arg3581z00_1507);
													}
													{
														BgL_variablez00_bglt BgL_auxz00_2475;

														BgL_auxz00_2475 =
															(BgL_variablez00_bglt) (BgL_argz00_1501);
														((((BgL_variablez00_bglt) CREF(BgL_auxz00_2475))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_newzd2typezd2_1506),
															BUNSPEC);
													}
												}
											else
												{	/* Ast/venv.scm 176 */
													BGl_errorz00zz__errorz00
														(BGl_string3630z00zzast_envz00,
														BGl_string3631z00zzast_envz00,
														BGl_shapez00zztools_shapez00(BgL_argz00_1501));
												}
										}
									{
										obj_t BgL_argsz00_2480;

										BgL_argsz00_2480 = CDR(BgL_argsz00_1498);
										BgL_argsz00_1498 = BgL_argsz00_2480;
										goto BgL_zc3anonymousza33574ze3z83_1499;
									}
								}
							else
								{	/* Ast/venv.scm 171 */
									if (NULLP(BgL_argsz00_1498))
										{	/* Ast/venv.scm 185 */
											obj_t BgL_bodyz00_1514;

											BgL_bodyz00_1514 =
												(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1492))->
												BgL_bodyz00);
											if (BGl_iszd2azf3z21zz__objectz00(BgL_bodyz00_1514,
													BGl_nodez00zzast_nodez00))
												{	/* Ast/venv.scm 188 */
													BgL_typez00_bglt BgL_tresz00_1516;

													{
														BgL_nodez00_bglt BgL_auxz00_2487;

														BgL_auxz00_2487 =
															(BgL_nodez00_bglt) (BgL_bodyz00_1514);
														BgL_tresz00_1516 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_2487))->
															BgL_typez00);
													}
													BGl_hrtypezd2nodez12zc0zzast_hrtypez00(
														(BgL_nodez00_bglt) (BgL_bodyz00_1514));
													{	/* Ast/venv.scm 190 */
														bool_t BgL_testz00_2492;

														{	/* Ast/venv.scm 190 */
															obj_t BgL_obj1506z00_1750;

															BgL_obj1506z00_1750 = (obj_t) (BgL_tresz00_1516);
															BgL_testz00_2492 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1506z00_1750,
																BGl_typez00zztype_typez00);
														}
														if (BgL_testz00_2492)
															{	/* Ast/venv.scm 192 */
																BgL_typez00_bglt BgL_arg3590z00_1518;

																{	/* Ast/venv.scm 192 */
																	obj_t BgL_arg3591z00_1519;

																	BgL_arg3591z00_1519 =
																		(((BgL_typez00_bglt)
																			CREF(BgL_tresz00_1516))->BgL_idz00);
																	BgL_arg3590z00_1518 =
																		BGl_findzd2typezd2zztype_envz00
																		(BgL_arg3591z00_1519);
																}
																{
																	BgL_nodez00_bglt BgL_auxz00_2497;

																	BgL_auxz00_2497 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_1514);
																	return
																		((((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_2497))->BgL_typez00) =
																		((BgL_typez00_bglt) BgL_arg3590z00_1518),
																		BUNSPEC);
																}
															}
														else
															{	/* Ast/venv.scm 190 */
																return BFALSE;
															}
													}
												}
											else
												{	/* Ast/venv.scm 187 */
													return BFALSE;
												}
										}
									else
										{	/* Ast/venv.scm 184 */
											return
												BGl_errorz00zz__errorz00(BGl_string3632z00zzast_envz00,
												BGl_string3633z00zzast_envz00,
												BGl_shapez00zztools_shapez00(BgL_argsz00_1498));
										}
								}
						}
					}
				}
			}
		}
	}



/* restore-value-types!3352 */
	obj_t BGl_restorezd2valuezd2typesz123352z12zzast_envz00(obj_t BgL_envz00_1901,
		obj_t BgL_valuez00_1902)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 158 */
			{
				BgL_funz00_bglt BgL_valuez00_1481;

				BgL_valuez00_1481 = (BgL_funz00_bglt) (BgL_valuez00_1902);
				{	/* Ast/venv.scm 160 */
					bool_t BgL_testz00_2503;

					{	/* Ast/venv.scm 160 */
						obj_t BgL_arg3571z00_1489;

						BgL_arg3571z00_1489 =
							(((BgL_funz00_bglt) CREF(BgL_valuez00_1481))->
							BgL_predicatezd2ofzd2);
						BgL_testz00_2503 =
							BGl_iszd2azf3z21zz__objectz00(BgL_arg3571z00_1489,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_2503)
						{	/* Ast/venv.scm 161 */
							BgL_typez00_bglt BgL_arg3568z00_1486;

							{	/* Ast/venv.scm 161 */
								obj_t BgL_arg3569z00_1487;

								{	/* Ast/venv.scm 161 */
									BgL_typez00_bglt BgL_obj1414z00_1730;

									BgL_obj1414z00_1730 =
										(BgL_typez00_bglt) (
										(((BgL_funz00_bglt) CREF(BgL_valuez00_1481))->
											BgL_predicatezd2ofzd2));
									BgL_arg3569z00_1487 =
										(((BgL_typez00_bglt) CREF(BgL_obj1414z00_1730))->BgL_idz00);
								}
								BgL_arg3568z00_1486 =
									BGl_findzd2typezd2zztype_envz00(BgL_arg3569z00_1487);
							}
							{
								obj_t BgL_auxz00_2510;

								BgL_auxz00_2510 = (obj_t) (BgL_arg3568z00_1486);
								return
									((((BgL_funz00_bglt) CREF(BgL_valuez00_1481))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_auxz00_2510), BUNSPEC);
							}
						}
					else
						{	/* Ast/venv.scm 160 */
							return BFALSE;
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 346346738),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 326457085),
				BSTRING_TO_STRING(BGl_string3634z00zzast_envz00));
		}
	}

#ifdef __cplusplus
}
#endif
