/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	extern obj_t BGl_typez00zztype_typez00;
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	static obj_t
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_nodezd2setupz12zd2prezd2arit4616zc0zzcfa_arithmeticz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t
		BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00(BgL_approxz00_bglt, obj_t);
	static obj_t BGl_cfaz12zd2arithmeticzd2app4618z12zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	static obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t __cnst[1];


	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4836z00zzcfa_arithmeticz00,
		BgL_bgl_nodeza7d2setupza712za74844za7,
		BGl_nodezd2setupz12zd2prezd2arit4616zc0zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4837z00zzcfa_arithmeticz00,
		BgL_bgl_cfaza712za7d2arithme4845z00,
		BGl_cfaz12zd2arithmeticzd2app4618z12zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4838z00zzcfa_arithmeticz00,
		BgL_bgl_string4838za700za7za7c4846za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string4840z00zzcfa_arithmeticz00,
		BgL_bgl_string4840za700za7za7c4847za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string4839z00zzcfa_arithmeticz00,
		BgL_bgl_string4839za700za7za7c4848za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string4841z00zzcfa_arithmeticz00,
		BgL_bgl_string4841za700za7za7c4849za7, "all ", 4);
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl__cleanupza7d2arith4850za7,
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_1899, char *BgL_fromz00_1900)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_1891;

				BgL_cportz00_1891 =
					bgl_open_input_string(BGl_string4841z00zzcfa_arithmeticz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1892;

					BgL_iz00_1892 = ((long) 0);
				BgL_loopz00_1893:
					if ((BgL_iz00_1892 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg4843z00_1895;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_1897;

										BgL_locationz00_1897 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg4843z00_1895 =
												BGl_readz00zz__readerz00(BgL_cportz00_1891,
												BgL_locationz00_1897);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_auxz00_1919;

									BgL_auxz00_1919 = (int) (BgL_iz00_1892);
									CNST_TABLE_SET(BgL_auxz00_1919, BgL_arg4843z00_1895);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_1898;

								BgL_auxz00_1898 = (int) ((BgL_iz00_1892 - ((long) 1)));
								{
									long BgL_iz00_1924;

									BgL_iz00_1924 = (long) (BgL_auxz00_1898);
									BgL_iz00_1892 = BgL_iz00_1924;
									goto BgL_loopz00_1893;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}
	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l4599z00_1012;

				{	/* Cfa/arithmetic.scm 67 */
					bool_t BgL_auxz00_1926;

					BgL_l4599z00_1012 =
						BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
				BgL_zc3anonymousza34619ze3z83_1013:
					if (PAIRP(BgL_l4599z00_1012))
						{	/* Cfa/arithmetic.scm 67 */
							{	/* Cfa/arithmetic.scm 68 */
								obj_t BgL_nodez00_1015;

								BgL_nodez00_1015 = CAR(BgL_l4599z00_1012);
								{	/* Cfa/arithmetic.scm 69 */
									BgL_variablez00_bglt BgL_fz00_1017;

									{	/* Cfa/arithmetic.scm 69 */
										BgL_varz00_bglt BgL_obj2061z00_1750;

										{
											BgL_appz00_bglt BgL_auxz00_1930;

											BgL_auxz00_1930 = (BgL_appz00_bglt) (BgL_nodez00_1015);
											BgL_obj2061z00_1750 =
												(((BgL_appz00_bglt) CREF(BgL_auxz00_1930))->BgL_funz00);
										}
										BgL_fz00_1017 =
											(((BgL_varz00_bglt) CREF(BgL_obj2061z00_1750))->
											BgL_variablez00);
									}
									{	/* Cfa/arithmetic.scm 69 */
										BgL_valuez00_bglt BgL_valz00_1018;

										BgL_valz00_1018 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1017))->
											BgL_valuez00);
										{	/* Cfa/arithmetic.scm 70 */

											{	/* Cfa/arithmetic.scm 72 */
												bool_t BgL_testz00_1935;

												{	/* Cfa/arithmetic.scm 72 */
													BgL_typez00_bglt BgL_arg4622z00_1020;

													BgL_arg4622z00_1020 =
														(((BgL_variablez00_bglt) CREF(BgL_fz00_1017))->
														BgL_typez00);
													BgL_testz00_1935 =
														((obj_t) (BgL_arg4622z00_1020) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1935)
													{
														BgL_typez00_bglt BgL_auxz00_1939;

														BgL_auxz00_1939 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														((((BgL_variablez00_bglt) CREF(BgL_fz00_1017))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1939), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 72 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 74 */
												bool_t BgL_testz00_1942;

												{	/* Cfa/arithmetic.scm 74 */
													BgL_typez00_bglt BgL_arg4624z00_1022;

													{
														BgL_nodez00_bglt BgL_auxz00_1943;

														BgL_auxz00_1943 =
															(BgL_nodez00_bglt) (BgL_nodez00_1015);
														BgL_arg4624z00_1022 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_1943))->
															BgL_typez00);
													}
													BgL_testz00_1942 =
														(
														(obj_t) (BgL_arg4624z00_1022) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1942)
													{
														BgL_typez00_bglt BgL_auxz00_1950;

														BgL_nodez00_bglt BgL_auxz00_1948;

														BgL_auxz00_1950 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														BgL_auxz00_1948 =
															(BgL_nodez00_bglt) (BgL_nodez00_1015);
														((((BgL_nodez00_bglt) CREF(BgL_auxz00_1948))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1950), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 74 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 77 */
												bool_t BgL_testz00_1953;

												{	/* Cfa/arithmetic.scm 77 */
													obj_t BgL_obj1862z00_1758;

													BgL_obj1862z00_1758 = (obj_t) (BgL_valz00_1018);
													BgL_testz00_1953 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj1862z00_1758,
														BGl_sfunz00zzast_varz00);
												}
												if (BgL_testz00_1953)
													{	/* Cfa/arithmetic.scm 79 */
														obj_t BgL_arg4626z00_1024;

														{	/* Cfa/arithmetic.scm 79 */
															obj_t BgL_l4593z00_1025;

															{
																BgL_sfunz00_bglt BgL_auxz00_1956;

																BgL_auxz00_1956 =
																	(BgL_sfunz00_bglt) (BgL_valz00_1018);
																BgL_l4593z00_1025 =
																	(((BgL_sfunz00_bglt) CREF(BgL_auxz00_1956))->
																	BgL_argsz00);
															}
															if (NULLP(BgL_l4593z00_1025))
																{	/* Cfa/arithmetic.scm 79 */
																	BgL_arg4626z00_1024 = BNIL;
																}
															else
																{	/* Cfa/arithmetic.scm 79 */
																	obj_t BgL_head4595z00_1027;

																	BgL_head4595z00_1027 =
																		MAKE_PAIR
																		(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																		(CAR(BgL_l4593z00_1025)), BNIL);
																	{	/* Cfa/arithmetic.scm 79 */
																		obj_t BgL_g4598z00_1028;

																		BgL_g4598z00_1028 = CDR(BgL_l4593z00_1025);
																		{
																			obj_t BgL_l4593z00_1030;

																			obj_t BgL_tail4596z00_1031;

																			BgL_l4593z00_1030 = BgL_g4598z00_1028;
																			BgL_tail4596z00_1031 =
																				BgL_head4595z00_1027;
																		BgL_zc3anonymousza34628ze3z83_1032:
																			if (NULLP(BgL_l4593z00_1030))
																				{	/* Cfa/arithmetic.scm 79 */
																					BgL_arg4626z00_1024 =
																						BgL_head4595z00_1027;
																				}
																			else
																				{	/* Cfa/arithmetic.scm 79 */
																					obj_t BgL_newtail4597z00_1034;

																					BgL_newtail4597z00_1034 =
																						MAKE_PAIR
																						(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_l4593z00_1030)), BNIL);
																					SET_CDR(BgL_tail4596z00_1031,
																						BgL_newtail4597z00_1034);
																					{
																						obj_t BgL_tail4596z00_1973;

																						obj_t BgL_l4593z00_1971;

																						BgL_l4593z00_1971 =
																							CDR(BgL_l4593z00_1030);
																						BgL_tail4596z00_1973 =
																							BgL_newtail4597z00_1034;
																						BgL_tail4596z00_1031 =
																							BgL_tail4596z00_1973;
																						BgL_l4593z00_1030 =
																							BgL_l4593z00_1971;
																						goto
																							BgL_zc3anonymousza34628ze3z83_1032;
																					}
																				}
																		}
																	}
																}
														}
														{
															BgL_sfunz00_bglt BgL_auxz00_1974;

															BgL_auxz00_1974 =
																(BgL_sfunz00_bglt) (BgL_valz00_1018);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_1974))->
																	BgL_argsz00) =
																((obj_t) BgL_arg4626z00_1024), BUNSPEC);
														}
													}
												else
													{	/* Cfa/arithmetic.scm 80 */
														bool_t BgL_testz00_1977;

														{	/* Cfa/arithmetic.scm 80 */
															obj_t BgL_obj1926z00_1774;

															BgL_obj1926z00_1774 = (obj_t) (BgL_valz00_1018);
															BgL_testz00_1977 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1926z00_1774, BGl_cfunz00zzast_varz00);
														}
														if (BgL_testz00_1977)
															{	/* Cfa/arithmetic.scm 81 */
																obj_t BgL_g4583z00_1044;

																{
																	BgL_cfunz00_bglt BgL_auxz00_1980;

																	BgL_auxz00_1980 =
																		(BgL_cfunz00_bglt) (BgL_valz00_1018);
																	BgL_g4583z00_1044 =
																		(((BgL_cfunz00_bglt)
																			CREF(BgL_auxz00_1980))->
																		BgL_argszd2typezd2);
																}
																{
																	obj_t BgL_lz00_1046;

																	{	/* Cfa/arithmetic.scm 81 */
																		bool_t BgL_auxz00_1983;

																		BgL_lz00_1046 = BgL_g4583z00_1044;
																	BgL_zc3anonymousza34638ze3z83_1047:
																		if (PAIRP(BgL_lz00_1046))
																			{	/* Cfa/arithmetic.scm 82 */
																				{	/* Cfa/arithmetic.scm 84 */
																					obj_t BgL_auxz00_1986;

																					BgL_auxz00_1986 =
																						BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_lz00_1046));
																					SET_CAR(BgL_lz00_1046,
																						BgL_auxz00_1986);
																				}
																				{
																					obj_t BgL_lz00_1990;

																					BgL_lz00_1990 = CDR(BgL_lz00_1046);
																					BgL_lz00_1046 = BgL_lz00_1990;
																					goto
																						BgL_zc3anonymousza34638ze3z83_1047;
																				}
																			}
																		else
																			{	/* Cfa/arithmetic.scm 82 */
																				BgL_auxz00_1983 = ((bool_t) 0);
																			}
																		BBOOL(BgL_auxz00_1983);
																	}
																}
															}
														else
															{	/* Cfa/arithmetic.scm 80 */
																BFALSE;
															}
													}
											}
										}
									}
								}
							}
							{
								obj_t BgL_l4599z00_1993;

								BgL_l4599z00_1993 = CDR(BgL_l4599z00_1012);
								BgL_l4599z00_1012 = BgL_l4599z00_1993;
								goto BgL_zc3anonymousza34619ze3z83_1013;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 67 */
							BgL_auxz00_1926 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1926);
				}
			}
		}
	}



/* cleanup-type */
	obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t BgL_tz00_1056)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 66 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1056,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_1056 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_1056;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1056,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 59 */
							{	/* Cfa/arithmetic.scm 60 */
								bool_t BgL_testz00_2002;

								{	/* Cfa/arithmetic.scm 60 */
									BgL_typez00_bglt BgL_arg4651z00_1062;

									{
										BgL_variablez00_bglt BgL_auxz00_2003;

										BgL_auxz00_2003 = (BgL_variablez00_bglt) (BgL_tz00_1056);
										BgL_arg4651z00_1062 =
											(((BgL_variablez00_bglt) CREF(BgL_auxz00_2003))->
											BgL_typez00);
									}
									BgL_testz00_2002 =
										(
										(obj_t) (BgL_arg4651z00_1062) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_2002)
									{
										BgL_typez00_bglt BgL_auxz00_2010;

										BgL_variablez00_bglt BgL_auxz00_2008;

										BgL_auxz00_2010 =
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
										BgL_auxz00_2008 = (BgL_variablez00_bglt) (BgL_tz00_1056);
										((((BgL_variablez00_bglt) CREF(BgL_auxz00_2008))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_auxz00_2010), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 60 */
										BFALSE;
									}
							}
							return BgL_tz00_1056;
						}
					else
						{	/* Cfa/arithmetic.scm 59 */
							return BgL_tz00_1056;
						}
				}
		}
	}



/* _cleanup-arithmetic-nodes! */
	obj_t BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1880)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			return BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc4836z00zzcfa_arithmeticz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00(BGl_cfaz12zd2envzc0zzcfa_cfaz00,
				BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc4837z00zzcfa_arithmeticz00);
		}
	}



/* cfa!-arithmetic-app4618 */
	obj_t BGl_cfaz12zd2arithmeticzd2app4618z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1883, obj_t BgL_nodez00_1884)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 141 */
			{
				BgL_arithmeticzd2appzd2_bglt BgL_nodez00_1652;

				{	/* Cfa/arithmetic.scm 172 */
					BgL_approxz00_bglt BgL_auxz00_2016;

					BgL_nodez00_1652 = (BgL_arithmeticzd2appzd2_bglt) (BgL_nodez00_1884);
					{
						obj_t BgL_argszd2approxzd2_1696;

						obj_t BgL_speczd2typeszd2_1697;

						obj_t BgL_argszd2approxzd2_1709;

						obj_t BgL_typez00_1710;

						obj_t BgL_speczd2typeszd2_1711;

						obj_t BgL_argszd2approxzd2_1726;

						{	/* Cfa/arithmetic.scm 182 */
							obj_t BgL_argszd2approxzd2_1660;

							{	/* Cfa/arithmetic.scm 182 */
								obj_t BgL_l4607z00_1678;

								{
									BgL_appz00_bglt BgL_auxz00_2017;

									BgL_auxz00_2017 = (BgL_appz00_bglt) (BgL_nodez00_1652);
									BgL_l4607z00_1678 =
										(((BgL_appz00_bglt) CREF(BgL_auxz00_2017))->BgL_argsz00);
								}
								if (NULLP(BgL_l4607z00_1678))
									{	/* Cfa/arithmetic.scm 182 */
										BgL_argszd2approxzd2_1660 = BNIL;
									}
								else
									{	/* Cfa/arithmetic.scm 182 */
										obj_t BgL_head4609z00_1680;

										{	/* Cfa/arithmetic.scm 182 */
											BgL_approxz00_bglt BgL_arg4805z00_1693;

											{	/* Cfa/arithmetic.scm 182 */
												obj_t BgL_arg4807z00_1695;

												BgL_arg4807z00_1695 = CAR(BgL_l4607z00_1678);
												BgL_arg4805z00_1693 =
													BGl_cfaz12z12zzcfa_cfaz00(
													(BgL_nodez00_bglt) (BgL_arg4807z00_1695));
											}
											BgL_head4609z00_1680 =
												MAKE_PAIR((obj_t) (BgL_arg4805z00_1693), BNIL);
										}
										{	/* Cfa/arithmetic.scm 182 */
											obj_t BgL_g4612z00_1681;

											BgL_g4612z00_1681 = CDR(BgL_l4607z00_1678);
											{
												obj_t BgL_l4607z00_1683;

												obj_t BgL_tail4610z00_1684;

												BgL_l4607z00_1683 = BgL_g4612z00_1681;
												BgL_tail4610z00_1684 = BgL_head4609z00_1680;
											BgL_zc3anonymousza34799ze3z83_1685:
												if (NULLP(BgL_l4607z00_1683))
													{	/* Cfa/arithmetic.scm 182 */
														BgL_argszd2approxzd2_1660 = BgL_head4609z00_1680;
													}
												else
													{	/* Cfa/arithmetic.scm 182 */
														obj_t BgL_newtail4611z00_1687;

														{	/* Cfa/arithmetic.scm 182 */
															BgL_approxz00_bglt BgL_arg4802z00_1689;

															{	/* Cfa/arithmetic.scm 182 */
																obj_t BgL_arg4804z00_1691;

																BgL_arg4804z00_1691 = CAR(BgL_l4607z00_1683);
																BgL_arg4802z00_1689 =
																	BGl_cfaz12z12zzcfa_cfaz00(
																	(BgL_nodez00_bglt) (BgL_arg4804z00_1691));
															}
															BgL_newtail4611z00_1687 =
																MAKE_PAIR((obj_t) (BgL_arg4802z00_1689), BNIL);
														}
														SET_CDR(BgL_tail4610z00_1684,
															BgL_newtail4611z00_1687);
														{
															obj_t BgL_tail4610z00_2038;

															obj_t BgL_l4607z00_2036;

															BgL_l4607z00_2036 = CDR(BgL_l4607z00_1683);
															BgL_tail4610z00_2038 = BgL_newtail4611z00_1687;
															BgL_tail4610z00_1684 = BgL_tail4610z00_2038;
															BgL_l4607z00_1683 = BgL_l4607z00_2036;
															goto BgL_zc3anonymousza34799ze3z83_1685;
														}
													}
											}
										}
									}
							}
							{	/* Cfa/arithmetic.scm 184 */
								obj_t BgL_tyz00_1661;

								BgL_argszd2approxzd2_1726 = BgL_argszd2approxzd2_1660;
								{
									obj_t BgL_argsz00_1729;

									BgL_argsz00_1729 = BgL_argszd2approxzd2_1726;
								BgL_zc3anonymousza34825ze3z83_1730:
									if (NULLP(BgL_argsz00_1729))
										{	/* Cfa/arithmetic.scm 150 */
											BgL_tyz00_1661 = BFALSE;
										}
									else
										{	/* Cfa/arithmetic.scm 152 */
											obj_t BgL_tz00_1732;

											{	/* Cfa/arithmetic.scm 152 */
												BgL_typez00_bglt BgL_arg4829z00_1735;

												{	/* Cfa/arithmetic.scm 152 */
													BgL_approxz00_bglt BgL_obj3143z00_1875;

													{	/* Cfa/arithmetic.scm 152 */
														obj_t BgL_pairz00_1874;

														BgL_pairz00_1874 = BgL_argsz00_1729;
														BgL_obj3143z00_1875 =
															(BgL_approxz00_bglt) (CAR(BgL_pairz00_1874));
													}
													BgL_arg4829z00_1735 =
														(((BgL_approxz00_bglt) CREF(BgL_obj3143z00_1875))->
														BgL_typez00);
												}
												if (
													((obj_t) (BgL_arg4829z00_1735) ==
														BGl_za2intza2z00zztype_cachez00))
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1732 = BGl_za2longza2z00zztype_cachez00;
													}
												else
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1732 = (obj_t) (BgL_arg4829z00_1735);
													}
											}
											if ((BgL_tz00_1732 == BGl_za2_za2z00zztype_cachez00))
												{
													obj_t BgL_argsz00_2050;

													BgL_argsz00_2050 = CDR(BgL_argsz00_1729);
													BgL_argsz00_1729 = BgL_argsz00_2050;
													goto BgL_zc3anonymousza34825ze3z83_1730;
												}
											else
												{	/* Cfa/arithmetic.scm 153 */
													BgL_tyz00_1661 = BgL_tz00_1732;
												}
										}
								}
								{	/* Cfa/arithmetic.scm 185 */
									bool_t BgL_testz00_2052;

									BgL_argszd2approxzd2_1709 = BgL_argszd2approxzd2_1660;
									BgL_typez00_1710 = BgL_tyz00_1661;
									{
										obj_t BgL_auxz00_2074;

										{	/* Cfa/arithmetic.scm 185 */
											BgL_objectz00_bglt BgL_auxz00_2075;

											BgL_auxz00_2075 = (BgL_objectz00_bglt) (BgL_nodez00_1652);
											BgL_auxz00_2074 = BGL_OBJECT_WIDENING(BgL_auxz00_2075);
										}
										BgL_speczd2typeszd2_1711 =
											(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2074))->
											BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 159 */
										bool_t BgL__ortest_4589z00_1713;

										if (CBOOL(BgL_typez00_1710))
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4589z00_1713 = ((bool_t) 0);
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4589z00_1713 = ((bool_t) 1);
											}
										if (BgL__ortest_4589z00_1713)
											{	/* Cfa/arithmetic.scm 159 */
												BgL_testz00_2052 = BgL__ortest_4589z00_1713;
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(BgL_typez00_1710, BgL_speczd2typeszd2_1711)))
													{
														obj_t BgL_argsz00_1716;

														BgL_argsz00_1716 = BgL_argszd2approxzd2_1709;
													BgL_zc3anonymousza34817ze3z83_1717:
														if (NULLP(BgL_argsz00_1716))
															{	/* Cfa/arithmetic.scm 162 */
																BgL_testz00_2052 = ((bool_t) 1);
															}
														else
															{	/* Cfa/arithmetic.scm 164 */
																obj_t BgL_tz00_1719;

																{	/* Cfa/arithmetic.scm 164 */
																	BgL_typez00_bglt BgL_arg4822z00_1723;

																	{	/* Cfa/arithmetic.scm 164 */
																		BgL_approxz00_bglt BgL_obj3143z00_1869;

																		{	/* Cfa/arithmetic.scm 164 */
																			obj_t BgL_pairz00_1868;

																			BgL_pairz00_1868 = BgL_argsz00_1716;
																			BgL_obj3143z00_1869 =
																				(BgL_approxz00_bglt) (CAR
																				(BgL_pairz00_1868));
																		}
																		BgL_arg4822z00_1723 =
																			(((BgL_approxz00_bglt)
																				CREF(BgL_obj3143z00_1869))->
																			BgL_typez00);
																	}
																	if (
																		((obj_t) (BgL_arg4822z00_1723) ==
																			BGl_za2intza2z00zztype_cachez00))
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1719 =
																				BGl_za2longza2z00zztype_cachez00;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1719 =
																				(obj_t) (BgL_arg4822z00_1723);
																		}
																}
																{	/* Cfa/arithmetic.scm 165 */
																	bool_t BgL_testz00_2068;

																	if ((BgL_tz00_1719 == BgL_typez00_1710))
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2068 = ((bool_t) 1);
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2068 =
																				(BgL_tz00_1719 ==
																				BGl_za2_za2z00zztype_cachez00);
																		}
																	if (BgL_testz00_2068)
																		{
																			obj_t BgL_argsz00_2072;

																			BgL_argsz00_2072 = CDR(BgL_argsz00_1716);
																			BgL_argsz00_1716 = BgL_argsz00_2072;
																			goto BgL_zc3anonymousza34817ze3z83_1717;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2052 = ((bool_t) 0);
																		}
																}
															}
													}
												else
													{	/* Cfa/arithmetic.scm 160 */
														BgL_testz00_2052 = ((bool_t) 0);
													}
											}
									}
									if (BgL_testz00_2052)
										{	/* Cfa/arithmetic.scm 187 */
											bool_t BgL_testz00_2079;

											BgL_argszd2approxzd2_1696 = BgL_argszd2approxzd2_1660;
											{
												obj_t BgL_auxz00_2094;

												{	/* Cfa/arithmetic.scm 187 */
													BgL_objectz00_bglt BgL_auxz00_2095;

													BgL_auxz00_2095 =
														(BgL_objectz00_bglt) (BgL_nodez00_1652);
													BgL_auxz00_2094 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2095);
												}
												BgL_speczd2typeszd2_1697 =
													(((BgL_arithmeticzd2appzd2_bglt)
														CREF(BgL_auxz00_2094))->BgL_speczd2typeszd2);
											}
											{
												obj_t BgL_argsz00_1700;

												BgL_argsz00_1700 = BgL_argszd2approxzd2_1696;
											BgL_zc3anonymousza34809ze3z83_1701:
												if (NULLP(BgL_argsz00_1700))
													{	/* Cfa/arithmetic.scm 172 */
														BgL_testz00_2079 = ((bool_t) 1);
													}
												else
													{	/* Cfa/arithmetic.scm 174 */
														bool_t BgL_testz00_2082;

														{	/* Cfa/arithmetic.scm 174 */
															obj_t BgL_arg4813z00_1705;

															{	/* Cfa/arithmetic.scm 174 */
																BgL_typez00_bglt BgL_arg4814z00_1706;

																{	/* Cfa/arithmetic.scm 174 */
																	BgL_approxz00_bglt BgL_obj3143z00_1863;

																	{	/* Cfa/arithmetic.scm 174 */
																		obj_t BgL_pairz00_1862;

																		BgL_pairz00_1862 = BgL_argsz00_1700;
																		BgL_obj3143z00_1863 =
																			(BgL_approxz00_bglt) (CAR
																			(BgL_pairz00_1862));
																	}
																	BgL_arg4814z00_1706 =
																		(((BgL_approxz00_bglt)
																			CREF(BgL_obj3143z00_1863))->BgL_typez00);
																}
																if (
																	((obj_t) (BgL_arg4814z00_1706) ==
																		BGl_za2intza2z00zztype_cachez00))
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4813z00_1705 =
																			BGl_za2longza2z00zztype_cachez00;
																	}
																else
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4813z00_1705 =
																			(obj_t) (BgL_arg4814z00_1706);
																	}
															}
															BgL_testz00_2082 =
																CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																(BgL_arg4813z00_1705,
																	BgL_speczd2typeszd2_1697));
														}
														if (BgL_testz00_2082)
															{
																obj_t BgL_argsz00_2092;

																BgL_argsz00_2092 = CDR(BgL_argsz00_1700);
																BgL_argsz00_1700 = BgL_argsz00_2092;
																goto BgL_zc3anonymousza34809ze3z83_1701;
															}
														else
															{	/* Cfa/arithmetic.scm 174 */
																BgL_testz00_2079 = ((bool_t) 0);
															}
													}
											}
											if (BgL_testz00_2079)
												{	/* Cfa/arithmetic.scm 190 */
													bool_t BgL_testz00_2099;

													{	/* Cfa/arithmetic.scm 190 */
														BgL_typez00_bglt BgL_arg4790z00_1666;

														{	/* Cfa/arithmetic.scm 190 */
															BgL_approxz00_bglt BgL_obj3143z00_1854;

															{
																obj_t BgL_auxz00_2100;

																{	/* Cfa/arithmetic.scm 190 */
																	BgL_objectz00_bglt BgL_auxz00_2101;

																	BgL_auxz00_2101 =
																		(BgL_objectz00_bglt) (BgL_nodez00_1652);
																	BgL_auxz00_2100 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_2101);
																}
																BgL_obj3143z00_1854 =
																	(((BgL_arithmeticzd2appzd2_bglt)
																		CREF(BgL_auxz00_2100))->BgL_approxz00);
															}
															BgL_arg4790z00_1666 =
																(((BgL_approxz00_bglt)
																	CREF(BgL_obj3143z00_1854))->BgL_typez00);
														}
														BgL_testz00_2099 =
															(
															(obj_t) (BgL_arg4790z00_1666) ==
															BGl_za2_za2z00zztype_cachez00);
													}
													if (BgL_testz00_2099)
														{	/* Cfa/arithmetic.scm 190 */
															{	/* Cfa/arithmetic.scm 193 */
																BgL_approxz00_bglt BgL_arg4789z00_1665;

																{
																	obj_t BgL_auxz00_2108;

																	{	/* Cfa/arithmetic.scm 193 */
																		BgL_objectz00_bglt BgL_auxz00_2109;

																		BgL_auxz00_2109 =
																			(BgL_objectz00_bglt) (BgL_nodez00_1652);
																		BgL_auxz00_2108 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_2109);
																	}
																	BgL_arg4789z00_1665 =
																		(((BgL_arithmeticzd2appzd2_bglt)
																			CREF(BgL_auxz00_2108))->BgL_approxz00);
																}
																BGl_approxzd2setzd2typez12z12zzcfa_approxz00
																	(BgL_arg4789z00_1665,
																	(BgL_typez00_bglt) (BgL_tyz00_1661));
															}
															BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
														}
													else
														{	/* Cfa/arithmetic.scm 190 */
															BFALSE;
														}
												}
											else
												{	/* Cfa/arithmetic.scm 187 */
													BFALSE;
												}
										}
									else
										{	/* Cfa/arithmetic.scm 185 */
											{
												obj_t BgL_l4613z00_1670;

												BgL_l4613z00_1670 = BgL_argszd2approxzd2_1660;
											BgL_zc3anonymousza34793ze3z83_1671:
												if (PAIRP(BgL_l4613z00_1670))
													{	/* Cfa/arithmetic.scm 197 */
														{	/* Cfa/arithmetic.scm 197 */
															obj_t BgL_az00_1673;

															BgL_az00_1673 = CAR(BgL_l4613z00_1670);
															BGl_loosez12z12zzcfa_loosez00(
																(BgL_approxz00_bglt) (BgL_az00_1673),
																CNST_TABLE_REF(((long) 0)));
														}
														{
															obj_t BgL_l4613z00_2122;

															BgL_l4613z00_2122 = CDR(BgL_l4613z00_1670);
															BgL_l4613z00_1670 = BgL_l4613z00_2122;
															goto BgL_zc3anonymousza34793ze3z83_1671;
														}
													}
												else
													{	/* Cfa/arithmetic.scm 197 */
														((bool_t) 1);
													}
											}
											{	/* Cfa/arithmetic.scm 198 */
												BgL_approxz00_bglt BgL_arg4796z00_1676;

												{
													obj_t BgL_auxz00_2124;

													{	/* Cfa/arithmetic.scm 198 */
														BgL_objectz00_bglt BgL_auxz00_2125;

														BgL_auxz00_2125 =
															(BgL_objectz00_bglt) (BgL_nodez00_1652);
														BgL_auxz00_2124 =
															BGL_OBJECT_WIDENING(BgL_auxz00_2125);
													}
													BgL_arg4796z00_1676 =
														(((BgL_arithmeticzd2appzd2_bglt)
															CREF(BgL_auxz00_2124))->BgL_approxz00);
												}
												BGl_approxzd2setzd2typez12z12zzcfa_approxz00
													(BgL_arg4796z00_1676,
													(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
											}
										}
								}
							}
						}
						{
							obj_t BgL_auxz00_2131;

							{	/* Cfa/arithmetic.scm 200 */
								BgL_objectz00_bglt BgL_auxz00_2132;

								BgL_auxz00_2132 = (BgL_objectz00_bglt) (BgL_nodez00_1652);
								BgL_auxz00_2131 = BGL_OBJECT_WIDENING(BgL_auxz00_2132);
							}
							BgL_auxz00_2016 =
								(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2131))->
								BgL_approxz00);
						}
					}
					return (obj_t) (BgL_auxz00_2016);
				}
			}
		}
	}



/* node-setup!-pre-arit4616 */
	obj_t BGl_nodezd2setupz12zd2prezd2arit4616zc0zzcfa_arithmeticz00(obj_t
		BgL_envz00_1885, obj_t BgL_nodez00_1886)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 96 */
			{
				BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1591;

				{	/* Cfa/arithmetic.scm 99 */
					BgL_appz00_bglt BgL_auxz00_2138;

					BgL_nodez00_1591 =
						(BgL_prezd2arithmeticzd2appz00_bglt) (BgL_nodez00_1886);
					{	/* Cfa/arithmetic.scm 107 */
						BgL_variablez00_bglt BgL_fz00_1596;

						{	/* Cfa/arithmetic.scm 107 */
							BgL_varz00_bglt BgL_obj2061z00_1788;

							{
								BgL_appz00_bglt BgL_auxz00_2139;

								BgL_auxz00_2139 = (BgL_appz00_bglt) (BgL_nodez00_1591);
								BgL_obj2061z00_1788 =
									(((BgL_appz00_bglt) CREF(BgL_auxz00_2139))->BgL_funz00);
							}
							BgL_fz00_1596 =
								(((BgL_varz00_bglt) CREF(BgL_obj2061z00_1788))->
								BgL_variablez00);
						}
						{	/* Cfa/arithmetic.scm 107 */
							BgL_valuez00_bglt BgL_valz00_1597;

							BgL_valz00_1597 =
								(((BgL_variablez00_bglt) CREF(BgL_fz00_1596))->BgL_valuez00);
							{	/* Cfa/arithmetic.scm 108 */

								{	/* Cfa/arithmetic.scm 110 */
									bool_t BgL_testz00_2144;

									{	/* Cfa/arithmetic.scm 110 */
										BgL_typez00_bglt BgL_arg4749z00_1599;

										BgL_arg4749z00_1599 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1596))->
											BgL_typez00);
										BgL_testz00_2144 =
											((obj_t) (BgL_arg4749z00_1599) ==
											BGl_za2objza2z00zztype_cachez00);
									}
									if (BgL_testz00_2144)
										{	/* Cfa/arithmetic.scm 110 */
											{
												BgL_typez00_bglt BgL_auxz00_2148;

												BgL_auxz00_2148 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												((((BgL_variablez00_bglt) CREF(BgL_fz00_1596))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2148), BUNSPEC);
											}
											{
												BgL_typez00_bglt BgL_auxz00_2153;

												BgL_nodez00_bglt BgL_auxz00_2151;

												BgL_auxz00_2153 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												BgL_auxz00_2151 = (BgL_nodez00_bglt) (BgL_nodez00_1591);
												((((BgL_nodez00_bglt) CREF(BgL_auxz00_2151))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2153), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 110 */
											BFALSE;
										}
								}
								{	/* Cfa/arithmetic.scm 117 */
									bool_t BgL_testz00_2156;

									{	/* Cfa/arithmetic.scm 117 */
										obj_t BgL_obj1862z00_1795;

										BgL_obj1862z00_1795 = (obj_t) (BgL_valz00_1597);
										BgL_testz00_2156 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1862z00_1795,
											BGl_sfunz00zzast_varz00);
									}
									if (BgL_testz00_2156)
										{	/* Cfa/arithmetic.scm 119 */
											obj_t BgL_arg4752z00_1601;

											{	/* Cfa/arithmetic.scm 119 */
												obj_t BgL_l4601z00_1602;

												{
													BgL_sfunz00_bglt BgL_auxz00_2159;

													BgL_auxz00_2159 =
														(BgL_sfunz00_bglt) (BgL_valz00_1597);
													BgL_l4601z00_1602 =
														(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2159))->
														BgL_argsz00);
												}
												if (NULLP(BgL_l4601z00_1602))
													{	/* Cfa/arithmetic.scm 119 */
														BgL_arg4752z00_1601 = BNIL;
													}
												else
													{	/* Cfa/arithmetic.scm 119 */
														obj_t BgL_head4603z00_1604;

														BgL_head4603z00_1604 =
															MAKE_PAIR
															(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(CAR
																(BgL_l4601z00_1602)), BNIL);
														{	/* Cfa/arithmetic.scm 119 */
															obj_t BgL_g4606z00_1605;

															BgL_g4606z00_1605 = CDR(BgL_l4601z00_1602);
															{
																obj_t BgL_l4601z00_1607;

																obj_t BgL_tail4604z00_1608;

																BgL_l4601z00_1607 = BgL_g4606z00_1605;
																BgL_tail4604z00_1608 = BgL_head4603z00_1604;
															BgL_zc3anonymousza34754ze3z83_1609:
																if (NULLP(BgL_l4601z00_1607))
																	{	/* Cfa/arithmetic.scm 119 */
																		BgL_arg4752z00_1601 = BgL_head4603z00_1604;
																	}
																else
																	{	/* Cfa/arithmetic.scm 119 */
																		obj_t BgL_newtail4605z00_1611;

																		BgL_newtail4605z00_1611 =
																			MAKE_PAIR
																			(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																			(CAR(BgL_l4601z00_1607)), BNIL);
																		SET_CDR(BgL_tail4604z00_1608,
																			BgL_newtail4605z00_1611);
																		{
																			obj_t BgL_tail4604z00_2176;

																			obj_t BgL_l4601z00_2174;

																			BgL_l4601z00_2174 =
																				CDR(BgL_l4601z00_1607);
																			BgL_tail4604z00_2176 =
																				BgL_newtail4605z00_1611;
																			BgL_tail4604z00_1608 =
																				BgL_tail4604z00_2176;
																			BgL_l4601z00_1607 = BgL_l4601z00_2174;
																			goto BgL_zc3anonymousza34754ze3z83_1609;
																		}
																	}
															}
														}
													}
											}
											{
												BgL_sfunz00_bglt BgL_auxz00_2177;

												BgL_auxz00_2177 = (BgL_sfunz00_bglt) (BgL_valz00_1597);
												((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2177))->
														BgL_argsz00) =
													((obj_t) BgL_arg4752z00_1601), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 120 */
											bool_t BgL_testz00_2180;

											{	/* Cfa/arithmetic.scm 120 */
												obj_t BgL_obj1926z00_1811;

												BgL_obj1926z00_1811 = (obj_t) (BgL_valz00_1597);
												BgL_testz00_2180 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1926z00_1811,
													BGl_cfunz00zzast_varz00);
											}
											if (BgL_testz00_2180)
												{	/* Cfa/arithmetic.scm 121 */
													obj_t BgL_g4586z00_1621;

													{
														BgL_cfunz00_bglt BgL_auxz00_2183;

														BgL_auxz00_2183 =
															(BgL_cfunz00_bglt) (BgL_valz00_1597);
														BgL_g4586z00_1621 =
															(((BgL_cfunz00_bglt) CREF(BgL_auxz00_2183))->
															BgL_argszd2typezd2);
													}
													{
														obj_t BgL_lz00_1623;

														BgL_lz00_1623 = BgL_g4586z00_1621;
													BgL_zc3anonymousza34765ze3z83_1624:
														if (PAIRP(BgL_lz00_1623))
															{	/* Cfa/arithmetic.scm 123 */
																obj_t BgL_auxz00_2188;

																BgL_auxz00_2188 =
																	BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																	(CAR(BgL_lz00_1623));
																SET_CAR(BgL_lz00_1623, BgL_auxz00_2188);
															}
														else
															{
																obj_t BgL_lz00_2192;

																BgL_lz00_2192 = CDR(BgL_lz00_1623);
																BgL_lz00_1623 = BgL_lz00_2192;
																goto BgL_zc3anonymousza34765ze3z83_1624;
															}
													}
												}
											else
												{	/* Cfa/arithmetic.scm 120 */
													BGl_errorz00zz__errorz00
														(BGl_string4838z00zzcfa_arithmeticz00,
														BGl_string4839z00zzcfa_arithmeticz00,
														(obj_t) (BgL_nodez00_1591));
												}
										}
								}
								BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
									MAKE_PAIR(
									(obj_t) (BgL_nodez00_1591),
									BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
								{	/* Cfa/arithmetic.scm 129 */
									obj_t BgL_arg4770z00_1630;

									{
										BgL_appz00_bglt BgL_auxz00_2198;

										BgL_auxz00_2198 = (BgL_appz00_bglt) (BgL_nodez00_1591);
										BgL_arg4770z00_1630 =
											(((BgL_appz00_bglt) CREF(BgL_auxz00_2198))->BgL_argsz00);
									}
									BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg4770z00_1630);
								}
								{	/* Cfa/arithmetic.scm 130 */
									obj_t BgL_speczd2typeszd2_1631;

									{
										obj_t BgL_auxz00_2202;

										{	/* Cfa/arithmetic.scm 130 */
											BgL_objectz00_bglt BgL_auxz00_2203;

											BgL_auxz00_2203 = (BgL_objectz00_bglt) (BgL_nodez00_1591);
											BgL_auxz00_2202 = BGL_OBJECT_WIDENING(BgL_auxz00_2203);
										}
										BgL_speczd2typeszd2_1631 =
											(((BgL_prezd2arithmeticzd2appz00_bglt)
												CREF(BgL_auxz00_2202))->BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 130 */
										BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1632;

										{	/* Cfa/arithmetic.scm 131 */
											long BgL_arg4778z00_1641;

											{	/* Cfa/arithmetic.scm 131 */
												obj_t BgL_arg4779z00_1642;

												{	/* Cfa/arithmetic.scm 131 */
													obj_t BgL_arg4780z00_1643;

													{	/* Cfa/arithmetic.scm 131 */
														BgL_objectz00_bglt BgL_objectz00_1820;

														BgL_objectz00_1820 =
															(BgL_objectz00_bglt) (BgL_nodez00_1591);
														{	/* Cfa/arithmetic.scm 131 */
															long BgL_arg2554z00_1821;

															{	/* Cfa/arithmetic.scm 131 */
																long BgL_arg2556z00_1822;

																BgL_arg2556z00_1822 =
																	BGL_OBJECT_CLASS_NUM(BgL_objectz00_1820);
																BgL_arg2554z00_1821 =
																	(BgL_arg2556z00_1822 - OBJECT_TYPE);
															}
															BgL_arg4780z00_1643 =
																VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
																(int) (BgL_arg2554z00_1821));
													}}
													BgL_arg4779z00_1642 =
														BGl_classzd2superzd2zz__objectz00
														(BgL_arg4780z00_1643);
												}
												BgL_arg4778z00_1641 =
													BGl_classzd2numzd2zz__objectz00(BgL_arg4779z00_1642);
											}
											BGL_OBJECT_CLASS_NUM_SET(
												(BgL_objectz00_bglt) (BgL_nodez00_1591),
												BgL_arg4778z00_1641);
										}
										{	/* Cfa/arithmetic.scm 131 */
											BgL_objectz00_bglt BgL_auxz00_2216;

											BgL_auxz00_2216 = (BgL_objectz00_bglt) (BgL_nodez00_1591);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_2216, BFALSE);
										}
										BgL_nodez00_1632 = BgL_nodez00_1591;
										{	/* Cfa/arithmetic.scm 131 */

											{	/* Cfa/arithmetic.scm 132 */
												BgL_appz00_bglt BgL_obj4588z00_1633;

												BgL_obj4588z00_1633 =
													((BgL_appz00_bglt)
													(BgL_appz00_bglt) (BgL_nodez00_1632));
												{	/* Cfa/arithmetic.scm 134 */
													obj_t BgL_arg4771z00_1634;

													{	/* Cfa/arithmetic.scm 134 */
														BgL_approxz00_bglt BgL_arg4772z00_1635;

														{	/* Cfa/arithmetic.scm 134 */
															bool_t BgL_testz00_2221;

															{	/* Cfa/arithmetic.scm 134 */
																BgL_typez00_bglt BgL_arg4776z00_1638;

																BgL_arg4776z00_1638 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_fz00_1596))->BgL_typez00);
																BgL_testz00_2221 =
																	((obj_t) (BgL_arg4776z00_1638) ==
																	BGl_za2_za2z00zztype_cachez00);
															}
															if (BgL_testz00_2221)
																{	/* Cfa/arithmetic.scm 134 */
																	BgL_arg4772z00_1635 =
																		BGl_makezd2emptyzd2approxz00zzcfa_approxz00
																		();
																}
															else
																{	/* Cfa/arithmetic.scm 136 */
																	BgL_typez00_bglt BgL_arg4775z00_1637;

																	BgL_arg4775z00_1637 =
																		(((BgL_variablez00_bglt)
																			CREF(BgL_fz00_1596))->BgL_typez00);
																	BgL_arg4772z00_1635 =
																		BGl_makezd2typezd2approxz00zzcfa_approxz00
																		(BgL_arg4775z00_1637);
																}
														}
														BgL_arg4771z00_1634 =
															BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00
															(BgL_arg4772z00_1635, BgL_speczd2typeszd2_1631);
													}
													{	/* Cfa/arithmetic.scm 132 */
														BgL_objectz00_bglt BgL_auxz00_2229;

														BgL_auxz00_2229 =
															(BgL_objectz00_bglt) (BgL_obj4588z00_1633);
														BGL_OBJECT_WIDENING_SET(BgL_auxz00_2229,
															BgL_arg4771z00_1634);
													}
												}
												BGL_OBJECT_CLASS_NUM_SET(
													(BgL_objectz00_bglt) (BgL_obj4588z00_1633),
													BGl_classzd2numzd2zz__objectz00
													(BGl_arithmeticzd2appzd2zzcfa_info2z00));
												BgL_auxz00_2138 = BgL_obj4588z00_1633;
											}
										}
									}
								}
							}
						}
					}
					return (obj_t) (BgL_auxz00_2138);
				}
			}
		}
	}



/* unspecified-type */
	obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t BgL_lz00_1645)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 105 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1645,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 99 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 99 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1645,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 101 */
							{
								BgL_typez00_bglt BgL_auxz00_2243;

								BgL_variablez00_bglt BgL_auxz00_2241;

								BgL_auxz00_2243 =
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
								BgL_auxz00_2241 = (BgL_variablez00_bglt) (BgL_lz00_1645);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2241))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_2243), BUNSPEC);
							}
							return BgL_lz00_1645;
						}
					else
						{	/* Cfa/arithmetic.scm 101 */
							return BgL_lz00_1645;
						}
				}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 243010053),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 235614963),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 326518176),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 42139303),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 212645849),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 535144917),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 249450490),
				BSTRING_TO_STRING(BGl_string4840z00zzcfa_arithmeticz00));
		}
	}

#ifdef __cplusplus
}
#endif
