/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/convert.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;


	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt,
		BgL_typez00_bglt, obj_t, BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcoerce_convertz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt, BgL_typez00_bglt,
		BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t, obj_t,
		BgL_typez00_bglt);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__convertz12z12zzcoerce_convertz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern bool_t
		BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nodez00_bglt);
	extern BgL_castz00_bglt BGl_makezd2castzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzcoerce_convertz00();
	extern BgL_typez00_bglt
		BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	static obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t, bool_t);
	extern obj_t BGl_findzd2coercerzd2zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
	static BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2sharedzd2cnstzf3za2z21zzengine_paramz00;
	BGL_IMPORT obj_t string_to_symbol(char *);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STRING(BGl_string3828z00zzcoerce_convertz00,
		BgL_bgl_string3828za700za7za7c3837za7, "Type error", 10);
	      DEFINE_STRING(BGl_string3830z00zzcoerce_convertz00,
		BgL_bgl_string3830za700za7za7c3838za7, "Illegal conversion", 18);
	      DEFINE_STRING(BGl_string3829z00zzcoerce_convertz00,
		BgL_bgl_string3829za700za7za7c3839za7, "", 0);
	      DEFINE_STRING(BGl_string3831z00zzcoerce_convertz00,
		BgL_bgl_string3831za700za7za7c3840za7, "do-convert", 10);
	      DEFINE_STRING(BGl_string3832z00zzcoerce_convertz00,
		BgL_bgl_string3832za700za7za7c3841za7, "Illegal converter", 17);
	      DEFINE_STRING(BGl_string3833z00zzcoerce_convertz00,
		BgL_bgl_string3833za700za7za7c3842za7, "coerce_convert", 14);
	      DEFINE_STRING(BGl_string3834z00zzcoerce_convertz00,
		BgL_bgl_string3834za700za7za7c3843za7,
		"aux2 if coercer bigloo-type-error failure bigloo-type-error/location __error @ begin location bdb ::obj let aux ",
		112);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_convertz12zd2envzc0zzcoerce_convertz00,
		BgL_bgl__convertza712za712za7za73844z00,
		BGl__convertz12z12zzcoerce_convertz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_runtimezd2typezd2errorzd2envzd2zzcoerce_convertz00,
		BgL_bgl__runtimeza7d2typeza73845z00,
		BGl__runtimezd2typezd2errorz00zzcoerce_convertz00, 0L, BUNSPEC, 3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long
		BgL_checksumz00_1828, char *BgL_fromz00_1829)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_convertz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_convertz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
					BGl_cnstzd2initzd2zzcoerce_convertz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"coerce_convert");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			{	/* Coerce/convert.scm 16 */
				obj_t BgL_cportz00_1820;

				BgL_cportz00_1820 =
					bgl_open_input_string(BGl_string3834z00zzcoerce_convertz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1821;

					BgL_iz00_1821 = ((long) 13);
				BgL_loopz00_1822:
					if ((BgL_iz00_1821 == ((long) -1)))
						{	/* Coerce/convert.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/convert.scm 16 */
							{	/* Coerce/convert.scm 16 */
								obj_t BgL_arg3836z00_1824;

								{	/* Coerce/convert.scm 16 */

									{	/* Coerce/convert.scm 16 */
										obj_t BgL_locationz00_1826;

										BgL_locationz00_1826 = BBOOL(((bool_t) 0));
										{	/* Coerce/convert.scm 16 */

											BgL_arg3836z00_1824 =
												BGl_readz00zz__readerz00(BgL_cportz00_1820,
												BgL_locationz00_1826);
										}
									}
								}
								{	/* Coerce/convert.scm 16 */
									int BgL_auxz00_1848;

									BgL_auxz00_1848 = (int) (BgL_iz00_1821);
									CNST_TABLE_SET(BgL_auxz00_1848, BgL_arg3836z00_1824);
							}}
							{	/* Coerce/convert.scm 16 */
								int BgL_auxz00_1827;

								BgL_auxz00_1827 = (int) ((BgL_iz00_1821 - ((long) 1)));
								{
									long BgL_iz00_1853;

									BgL_iz00_1853 = (long) (BgL_auxz00_1827);
									BgL_iz00_1821 = BgL_iz00_1853;
									goto BgL_loopz00_1822;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* runtime-type-error */
	BGL_EXPORTED_DEF obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t
		BgL_locz00_41, obj_t BgL_tiz00_42, obj_t BgL_valuez00_43)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			{

				if (BGl_iszd2azf3z21zz__objectz00(BgL_valuez00_43,
						BGl_nodez00zzast_nodez00))
					{	/* Coerce/convert.scm 107 */
						BgL_nodez00_bglt BgL_auxz00_1857;

						{	/* Coerce/convert.scm 98 */
							obj_t BgL_auxz00_979;

							BgL_auxz00_979 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
							{	/* Coerce/convert.scm 98 */
								BgL_nodez00_bglt BgL_resz00_980;

								{	/* Coerce/convert.scm 100 */
									obj_t BgL_arg3535z00_983;

									{	/* Coerce/convert.scm 100 */
										obj_t BgL_arg3536z00_984;

										obj_t BgL_arg3537z00_985;

										BgL_arg3536z00_984 = CNST_TABLE_REF(((long) 1));
										{	/* Coerce/convert.scm 100 */
											obj_t BgL_arg3538z00_986;

											obj_t BgL_arg3539z00_987;

											{	/* Coerce/convert.scm 100 */
												obj_t BgL_arg3543z00_991;

												{	/* Coerce/convert.scm 100 */
													obj_t BgL_arg3545z00_993;

													obj_t BgL_arg3546z00_994;

													{	/* Coerce/convert.scm 100 */
														obj_t BgL_arg3547z00_995;

														{	/* Coerce/convert.scm 100 */
															obj_t BgL_arg3548z00_996;

															{	/* Coerce/convert.scm 100 */
																obj_t BgL_arg3549z00_997;

																obj_t BgL_arg3550z00_998;

																BgL_arg3549z00_997 =
																	SYMBOL_TO_STRING(BgL_auxz00_979);
																{	/* Coerce/convert.scm 100 */
																	obj_t BgL_symbolz00_1669;

																	BgL_symbolz00_1669 =
																		CNST_TABLE_REF(((long) 2));
																	BgL_arg3550z00_998 =
																		SYMBOL_TO_STRING(BgL_symbolz00_1669);
																}
																{	/* Coerce/convert.scm 100 */
																	obj_t BgL_list3551z00_999;

																	{	/* Coerce/convert.scm 100 */
																		obj_t BgL_arg3552z00_1000;

																		BgL_arg3552z00_1000 =
																			MAKE_PAIR(BgL_arg3550z00_998, BNIL);
																		BgL_list3551z00_999 =
																			MAKE_PAIR(BgL_arg3549z00_997,
																			BgL_arg3552z00_1000);
																	}
																	BgL_arg3548z00_996 =
																		BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																		(BgL_list3551z00_999);
															}}
															BgL_arg3547z00_995 =
																string_to_symbol(BSTRING_TO_STRING
																(BgL_arg3548z00_996));
														}
														BgL_arg3545z00_993 =
															BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
															(BgL_arg3547z00_995);
													}
													{	/* Coerce/convert.scm 100 */
														obj_t BgL_list3553z00_1001;

														BgL_list3553z00_1001 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3546z00_994 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BUNSPEC, BgL_list3553z00_1001);
													}
													BgL_arg3543z00_991 =
														MAKE_PAIR(BgL_arg3545z00_993, BgL_arg3546z00_994);
												}
												BgL_arg3538z00_986 =
													MAKE_PAIR(BgL_arg3543z00_991, BNIL);
											}
											BgL_arg3539z00_987 =
												BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
												(BgL_tiz00_42, BgL_locz00_41, BgL_auxz00_979);
											{	/* Coerce/convert.scm 100 */
												obj_t BgL_list3541z00_989;

												{	/* Coerce/convert.scm 100 */
													obj_t BgL_arg3542z00_990;

													BgL_arg3542z00_990 = MAKE_PAIR(BNIL, BNIL);
													BgL_list3541z00_989 =
														MAKE_PAIR(BgL_arg3539z00_987, BgL_arg3542z00_990);
												}
												BgL_arg3537z00_985 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3538z00_986, BgL_list3541z00_989);
										}}
										BgL_arg3535z00_983 =
											MAKE_PAIR(BgL_arg3536z00_984, BgL_arg3537z00_985);
									}
									BgL_resz00_980 =
										BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
										(BgL_arg3535z00_983, BgL_locz00_41);
								}
								{	/* Coerce/convert.scm 99 */

									{	/* Coerce/convert.scm 104 */
										obj_t BgL_arg3533z00_981;

										{	/* Coerce/convert.scm 104 */
											obj_t BgL_pairz00_1672;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_1880;

												BgL_auxz00_1880 =
													(BgL_letzd2varzd2_bglt) (BgL_resz00_980);
												BgL_pairz00_1672 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_1880))->
													BgL_bindingsz00);
											}
											BgL_arg3533z00_981 = CAR(BgL_pairz00_1672);
										}
										SET_CDR(BgL_arg3533z00_981, BgL_valuez00_43);
									}
									BgL_auxz00_1857 = BgL_resz00_980;
						}}}
						return (obj_t) (BgL_auxz00_1857);
					}
				else
					{	/* Coerce/convert.scm 106 */
						return
							BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
							(BgL_tiz00_42, BgL_locz00_41, BgL_valuez00_43);
					}
			}
		}
	}



/* runtime-type-error/id */
	obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t
		BgL_tiz00_1817, obj_t BgL_locz00_1816, obj_t BgL_idz00_1002)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 73 */
			{	/* Coerce/convert.scm 74 */
				bool_t BgL_testz00_1887;

				{	/* Coerce/convert.scm 74 */
					bool_t BgL_testz00_1888;

					{	/* Coerce/convert.scm 74 */
						bool_t BgL_testz00_1889;

						if (
							((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >
								((long) 0)))
							{	/* Coerce/convert.scm 75 */
								obj_t BgL_arg3618z00_1065;

								obj_t BgL_arg3619z00_1066;

								BgL_arg3618z00_1065 = CNST_TABLE_REF(((long) 3));
								{	/* Coerce/convert.scm 75 */
									obj_t BgL_arg3620z00_1067;

									BgL_arg3620z00_1067 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_1895;

										BgL_auxz00_1895 =
											(BgL_backendz00_bglt) (BgL_arg3620z00_1067);
										BgL_arg3619z00_1066 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_1895))->
											BgL_debugzd2supportzd2);
								}}
								BgL_testz00_1889 =
									CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3618z00_1065, BgL_arg3619z00_1066));
							}
						else
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1889 = ((bool_t) 0);
							}
						if (BgL_testz00_1889)
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1888 = ((bool_t) 1);
							}
						else
							{	/* Coerce/convert.scm 74 */
								if (
									((long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >
										((long) 0)))
									{	/* Coerce/convert.scm 76 */
										BgL_testz00_1888 = ((bool_t) 1);
									}
								else
									{	/* Coerce/convert.scm 76 */
										BgL_testz00_1888 =
											CBOOL(BGl_za2sharedzd2cnstzf3za2z21zzengine_paramz00);
									}
							}
					}
					if (BgL_testz00_1888)
						{	/* Coerce/convert.scm 74 */
							if (STRUCTP(BgL_locz00_1816))
								{	/* Coerce/convert.scm 78 */
									BgL_testz00_1887 =
										(STRUCT_KEY(BgL_locz00_1816) == CNST_TABLE_REF(((long) 4)));
								}
							else
								{	/* Coerce/convert.scm 78 */
									BgL_testz00_1887 = ((bool_t) 0);
								}
						}
					else
						{	/* Coerce/convert.scm 74 */
							BgL_testz00_1887 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_1887)
					{	/* Coerce/convert.scm 79 */
						obj_t BgL_arg3556z00_1005;

						obj_t BgL_arg3557z00_1006;

						BgL_arg3556z00_1005 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 80 */
							obj_t BgL_arg3558z00_1007;

							obj_t BgL_arg3559z00_1008;

							{	/* Coerce/convert.scm 80 */
								obj_t BgL_arg3563z00_1012;

								obj_t BgL_arg3564z00_1013;

								{	/* Coerce/convert.scm 80 */
									obj_t BgL_arg3565z00_1014;

									obj_t BgL_arg3566z00_1015;

									BgL_arg3565z00_1014 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 80 */
										obj_t BgL_list3567z00_1016;

										{	/* Coerce/convert.scm 80 */
											obj_t BgL_arg3568z00_1017;

											obj_t BgL_arg3569z00_1018;

											BgL_arg3568z00_1017 = CNST_TABLE_REF(((long) 7));
											BgL_arg3569z00_1018 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3567z00_1016 =
												MAKE_PAIR(BgL_arg3568z00_1017, BgL_arg3569z00_1018);
										}
										BgL_arg3566z00_1015 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 8)), BgL_list3567z00_1016);
									}
									BgL_arg3563z00_1012 =
										MAKE_PAIR(BgL_arg3565z00_1014, BgL_arg3566z00_1015);
								}
								{	/* Coerce/convert.scm 81 */
									obj_t BgL_arg3570z00_1019;

									obj_t BgL_arg3571z00_1020;

									obj_t BgL_arg3572z00_1021;

									obj_t BgL_arg3573z00_1022;

									BgL_arg3570z00_1019 =
										SYMBOL_TO_STRING(BGl_currentzd2functionzd2zztools_errorz00
										());
									BgL_arg3571z00_1020 = SYMBOL_TO_STRING(BgL_tiz00_1817);
									BgL_arg3572z00_1021 =
										BGl_locationzd2fullzd2fnamez00zztools_locationz00
										(BgL_locz00_1816);
									BgL_arg3573z00_1022 =
										STRUCT_REF(BgL_locz00_1816, (int) (((long) 1)));
									{	/* Coerce/convert.scm 80 */
										obj_t BgL_list3576z00_1024;

										{	/* Coerce/convert.scm 80 */
											obj_t BgL_arg3577z00_1025;

											{	/* Coerce/convert.scm 80 */
												obj_t BgL_arg3578z00_1026;

												{	/* Coerce/convert.scm 80 */
													obj_t BgL_arg3579z00_1027;

													{	/* Coerce/convert.scm 80 */
														obj_t BgL_arg3581z00_1028;

														BgL_arg3581z00_1028 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3579z00_1027 =
															MAKE_PAIR(BgL_arg3573z00_1022,
															BgL_arg3581z00_1028);
													}
													BgL_arg3578z00_1026 =
														MAKE_PAIR(BgL_arg3572z00_1021, BgL_arg3579z00_1027);
												}
												BgL_arg3577z00_1025 =
													MAKE_PAIR(BgL_idz00_1002, BgL_arg3578z00_1026);
											}
											BgL_list3576z00_1024 =
												MAKE_PAIR(BgL_arg3571z00_1020, BgL_arg3577z00_1025);
										}
										BgL_arg3564z00_1013 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3570z00_1019, BgL_list3576z00_1024);
								}}
								BgL_arg3558z00_1007 =
									MAKE_PAIR(BgL_arg3563z00_1012, BgL_arg3564z00_1013);
							}
							{	/* Coerce/convert.scm 89 */
								obj_t BgL_arg3583z00_1030;

								obj_t BgL_arg3584z00_1031;

								BgL_arg3583z00_1030 = CNST_TABLE_REF(((long) 9));
								{	/* Coerce/convert.scm 89 */
									obj_t BgL_list3585z00_1032;

									{	/* Coerce/convert.scm 89 */
										obj_t BgL_arg3586z00_1033;

										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3587z00_1034;

											BgL_arg3587z00_1034 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3586z00_1033 =
												MAKE_PAIR(BFALSE, BgL_arg3587z00_1034);
										}
										BgL_list3585z00_1032 =
											MAKE_PAIR(BFALSE, BgL_arg3586z00_1033);
									}
									BgL_arg3584z00_1031 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3585z00_1032);
								}
								BgL_arg3559z00_1008 =
									MAKE_PAIR(BgL_arg3583z00_1030, BgL_arg3584z00_1031);
							}
							{	/* Coerce/convert.scm 79 */
								obj_t BgL_list3561z00_1010;

								{	/* Coerce/convert.scm 79 */
									obj_t BgL_arg3562z00_1011;

									BgL_arg3562z00_1011 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3561z00_1010 =
										MAKE_PAIR(BgL_arg3559z00_1008, BgL_arg3562z00_1011);
								}
								BgL_arg3557z00_1006 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3558z00_1007, BgL_list3561z00_1010);
						}}
						return MAKE_PAIR(BgL_arg3556z00_1005, BgL_arg3557z00_1006);
					}
				else
					{	/* Coerce/convert.scm 90 */
						obj_t BgL_arg3588z00_1035;

						obj_t BgL_arg3589z00_1036;

						BgL_arg3588z00_1035 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 91 */
							obj_t BgL_arg3590z00_1037;

							obj_t BgL_arg3591z00_1038;

							{	/* Coerce/convert.scm 91 */
								obj_t BgL_arg3595z00_1042;

								obj_t BgL_arg3596z00_1043;

								{	/* Coerce/convert.scm 91 */
									obj_t BgL_arg3597z00_1044;

									obj_t BgL_arg3598z00_1045;

									BgL_arg3597z00_1044 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 91 */
										obj_t BgL_list3599z00_1046;

										{	/* Coerce/convert.scm 91 */
											obj_t BgL_arg3600z00_1047;

											obj_t BgL_arg3601z00_1048;

											BgL_arg3600z00_1047 = CNST_TABLE_REF(((long) 7));
											BgL_arg3601z00_1048 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3599z00_1046 =
												MAKE_PAIR(BgL_arg3600z00_1047, BgL_arg3601z00_1048);
										}
										BgL_arg3598z00_1045 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 10)), BgL_list3599z00_1046);
									}
									BgL_arg3595z00_1042 =
										MAKE_PAIR(BgL_arg3597z00_1044, BgL_arg3598z00_1045);
								}
								{	/* Coerce/convert.scm 92 */
									obj_t BgL_arg3602z00_1049;

									obj_t BgL_arg3603z00_1050;

									BgL_arg3602z00_1049 =
										SYMBOL_TO_STRING(BGl_currentzd2functionzd2zztools_errorz00
										());
									BgL_arg3603z00_1050 = SYMBOL_TO_STRING(BgL_tiz00_1817);
									{	/* Coerce/convert.scm 91 */
										obj_t BgL_list3605z00_1052;

										{	/* Coerce/convert.scm 91 */
											obj_t BgL_arg3606z00_1053;

											{	/* Coerce/convert.scm 91 */
												obj_t BgL_arg3607z00_1054;

												BgL_arg3607z00_1054 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3606z00_1053 =
													MAKE_PAIR(BgL_idz00_1002, BgL_arg3607z00_1054);
											}
											BgL_list3605z00_1052 =
												MAKE_PAIR(BgL_arg3603z00_1050, BgL_arg3606z00_1053);
										}
										BgL_arg3596z00_1043 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3602z00_1049, BgL_list3605z00_1052);
								}}
								BgL_arg3590z00_1037 =
									MAKE_PAIR(BgL_arg3595z00_1042, BgL_arg3596z00_1043);
							}
							{	/* Coerce/convert.scm 95 */
								obj_t BgL_arg3609z00_1056;

								obj_t BgL_arg3610z00_1057;

								BgL_arg3609z00_1056 = CNST_TABLE_REF(((long) 9));
								{	/* Coerce/convert.scm 95 */
									obj_t BgL_list3611z00_1058;

									{	/* Coerce/convert.scm 95 */
										obj_t BgL_arg3612z00_1059;

										{	/* Coerce/convert.scm 95 */
											obj_t BgL_arg3613z00_1060;

											BgL_arg3613z00_1060 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3612z00_1059 =
												MAKE_PAIR(BFALSE, BgL_arg3613z00_1060);
										}
										BgL_list3611z00_1058 =
											MAKE_PAIR(BFALSE, BgL_arg3612z00_1059);
									}
									BgL_arg3610z00_1057 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3611z00_1058);
								}
								BgL_arg3591z00_1038 =
									MAKE_PAIR(BgL_arg3609z00_1056, BgL_arg3610z00_1057);
							}
							{	/* Coerce/convert.scm 90 */
								obj_t BgL_list3593z00_1040;

								{	/* Coerce/convert.scm 90 */
									obj_t BgL_arg3594z00_1041;

									BgL_arg3594z00_1041 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3593z00_1040 =
										MAKE_PAIR(BgL_arg3591z00_1038, BgL_arg3594z00_1041);
								}
								BgL_arg3589z00_1036 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3590z00_1037, BgL_list3593z00_1040);
						}}
						return MAKE_PAIR(BgL_arg3588z00_1035, BgL_arg3589z00_1036);
					}
			}
		}
	}



/* _runtime-type-error */
	obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t BgL_envz00_1807,
		obj_t BgL_locz00_1808, obj_t BgL_tiz00_1809, obj_t BgL_valuez00_1810)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			return
				BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_1808,
				BgL_tiz00_1809, BgL_valuez00_1810);
		}
	}



/* convert-error */
	obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_44, BgL_typez00_bglt BgL_toz00_45, obj_t BgL_locz00_46,
		BgL_nodez00_bglt BgL_nodez00_47)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 117 */
			{	/* Coerce/convert.scm 120 */
				bool_t BgL_testz00_1967;

				if (((obj_t) (BgL_toz00_45) == BGl_za2objza2z00zztype_cachez00))
					{	/* Coerce/convert.scm 120 */
						BgL_testz00_1967 = ((bool_t) 0);
					}
				else
					{	/* Coerce/convert.scm 120 */
						BgL_testz00_1967 =
							BGl_subzd2typezf3z21zztype_envz00(BgL_toz00_45,
							(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
					}
				if (BgL_testz00_1967)
					{	/* Coerce/convert.scm 120 */
						{	/* Coerce/convert.scm 122 */
							obj_t BgL_arg3622z00_1071;

							BgL_arg3622z00_1071 = BGl_currentzd2functionzd2zztools_errorz00();
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_46,
								BgL_arg3622z00_1071, BGl_string3828z00zzcoerce_convertz00,
								BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
								(BGl_string3829z00zzcoerce_convertz00,
									BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
									BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))));
						}
						{	/* Coerce/convert.scm 123 */
							obj_t BgL_arg3623z00_1072;

							{	/* Coerce/convert.scm 123 */
								obj_t BgL_arg3624z00_1073;

								BgL_arg3624z00_1073 =
									(((BgL_typez00_bglt) CREF(BgL_toz00_45))->BgL_idz00);
								BgL_arg3623z00_1072 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_locz00_46, BgL_arg3624z00_1073,
									(obj_t) (BgL_nodez00_47));
							}
							return
								(obj_t) (BGl_coercez12z12zzcoerce_coercez00(
									(BgL_nodez00_bglt) (BgL_arg3623z00_1072), BUNSPEC,
									BgL_fromz00_44, ((bool_t) 0)));
						}
					}
				else
					{	/* Coerce/convert.scm 127 */
						obj_t BgL_arg3625z00_1074;

						BgL_arg3625z00_1074 = BGl_currentzd2functionzd2zztools_errorz00();
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_46,
							BgL_arg3625z00_1074, BGl_string3828z00zzcoerce_convertz00,
							BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
							(BGl_string3829z00zzcoerce_convertz00,
								BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
								BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))), BNIL);
					}
			}
		}
	}



/* convert! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt BgL_nodez00_48,
		BgL_typez00_bglt BgL_fromz00_49, BgL_typez00_bglt BgL_toz00_50,
		bool_t BgL_safez00_51)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 135 */
			{	/* Coerce/convert.scm 139 */
				BgL_typez00_bglt BgL_toz00_1076;

				BgL_typez00_bglt BgL_fromz00_1077;

				BgL_toz00_1076 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_toz00_50);
				BgL_fromz00_1077 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_fromz00_49);
				{	/* Coerce/convert.scm 141 */
					bool_t BgL_testz00_1995;

					if (((obj_t) (BgL_fromz00_1077) == (obj_t) (BgL_toz00_1076)))
						{	/* Coerce/convert.scm 141 */
							BgL_testz00_1995 = ((bool_t) 1);
						}
					else
						{	/* Coerce/convert.scm 141 */
							BgL_testz00_1995 =
								(((BgL_typez00_bglt) CREF(BgL_fromz00_1077))->BgL_magiczf3zf3);
						}
					if (BgL_testz00_1995)
						{	/* Coerce/convert.scm 141 */
							return BgL_nodez00_48;
						}
					else
						{	/* Coerce/convert.scm 143 */
							obj_t BgL_coercerz00_1079;

							obj_t BgL_locz00_1080;

							BgL_coercerz00_1079 =
								BGl_findzd2coercerzd2zztype_coercionz00(BgL_fromz00_1077,
								BgL_toz00_1076);
							BgL_locz00_1080 =
								(((BgL_nodez00_bglt) CREF(BgL_nodez00_48))->BgL_locz00);
							{	/* Coerce/convert.scm 145 */
								bool_t BgL_testz00_2003;

								if (STRUCTP(BgL_coercerz00_1079))
									{	/* Coerce/convert.scm 145 */
										BgL_testz00_2003 =
											(STRUCT_KEY(BgL_coercerz00_1079) ==
											CNST_TABLE_REF(((long) 11)));
									}
								else
									{	/* Coerce/convert.scm 145 */
										BgL_testz00_2003 = ((bool_t) 0);
									}
								if (BgL_testz00_2003)
									{	/* Coerce/convert.scm 149 */
										obj_t BgL_checksz00_1082;

										obj_t BgL_coercesz00_1083;

										BgL_checksz00_1082 =
											STRUCT_REF(BgL_coercerz00_1079, (int) (((long) 2)));
										BgL_coercesz00_1083 =
											STRUCT_REF(BgL_coercerz00_1079, (int) (((long) 3)));
										{
											obj_t BgL_checksz00_1085;

											obj_t BgL_coercesz00_1086;

											obj_t BgL_nodez00_1087;

											{	/* Coerce/convert.scm 154 */
												obj_t BgL_auxz00_2013;

												BgL_checksz00_1085 = BgL_checksz00_1082;
												BgL_coercesz00_1086 = BgL_coercesz00_1083;
												BgL_nodez00_1087 = (obj_t) (BgL_nodez00_48);
											BgL_zc3anonymousza33629ze3z83_1088:
												if (NULLP(BgL_checksz00_1085))
													{	/* Coerce/convert.scm 158 */
														if (NULLP(BgL_coercesz00_1086))
															{	/* Coerce/convert.scm 159 */
																BgL_auxz00_2013 = BgL_nodez00_1087;
															}
														else
															{	/* Coerce/convert.scm 159 */
																BgL_auxz00_2013 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3830z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1077)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1076)));
															}
													}
												else
													{	/* Coerce/convert.scm 158 */
														if (NULLP(BgL_coercesz00_1086))
															{	/* Coerce/convert.scm 164 */
																BgL_auxz00_2013 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3830z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1077)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1076)));
															}
														else
															{
																obj_t BgL_nodez00_2034;

																obj_t BgL_coercesz00_2032;

																obj_t BgL_checksz00_2030;

																BgL_checksz00_2030 = CDR(BgL_checksz00_1085);
																BgL_coercesz00_2032 = CDR(BgL_coercesz00_1086);
																BgL_nodez00_2034 =
																	BGl_makezd2onezd2conversionz00zzcoerce_convertz00
																	(CAR(BgL_checksz00_1085), BgL_fromz00_1077,
																	BgL_toz00_1076, CAR(BgL_checksz00_1085),
																	CAR(BgL_coercesz00_1086), BgL_nodez00_1087,
																	BgL_safez00_51);
																BgL_nodez00_1087 = BgL_nodez00_2034;
																BgL_coercesz00_1086 = BgL_coercesz00_2032;
																BgL_checksz00_1085 = BgL_checksz00_2030;
																goto BgL_zc3anonymousza33629ze3z83_1088;
															}
													}
												return (BgL_nodez00_bglt) (BgL_auxz00_2013);
											}
										}
									}
								else
									{	/* Coerce/convert.scm 145 */
										return
											(BgL_nodez00_bglt)
											(BGl_convertzd2errorzd2zzcoerce_convertz00
											(BgL_fromz00_1077, BgL_toz00_1076, BgL_locz00_1080,
												BgL_nodez00_48));
									}
							}
						}
				}
			}
		}
	}



/* _convert! */
	obj_t BGl__convertz12z12zzcoerce_convertz00(obj_t BgL_envz00_1811,
		obj_t BgL_nodez00_1812, obj_t BgL_fromz00_1813, obj_t BgL_toz00_1814,
		obj_t BgL_safez00_1815)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 135 */
			return
				(obj_t) (BGl_convertz12z12zzcoerce_convertz00(
					(BgL_nodez00_bglt) (BgL_nodez00_1812),
					(BgL_typez00_bglt) (BgL_fromz00_1813),
					(BgL_typez00_bglt) (BgL_toz00_1814), CBOOL(BgL_safez00_1815)));
		}
	}



/* make-one-conversion */
	obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_52, BgL_typez00_bglt BgL_fromz00_53,
		BgL_typez00_bglt BgL_toz00_54, obj_t BgL_checkopz00_55,
		obj_t BgL_coerceopz00_56, obj_t BgL_nodez00_57, bool_t BgL_safez00_58)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 188 */
			{	/* Coerce/convert.scm 189 */
				bool_t BgL_testz00_2049;

				if (NULLP(BgL_checkopz00_55))
					{	/* Coerce/convert.scm 189 */
						BgL_testz00_2049 = ((bool_t) 1);
					}
				else
					{	/* Coerce/convert.scm 189 */
						if (BgL_safez00_58)
							{	/* Coerce/convert.scm 189 */
								BgL_testz00_2049 = ((bool_t) 0);
							}
						else
							{	/* Coerce/convert.scm 189 */
								BgL_testz00_2049 = ((bool_t) 1);
							}
					}
				if (BgL_testz00_2049)
					{	/* Coerce/convert.scm 189 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coerceopz00_56,
							BgL_nodez00_57, BgL_fromz00_53);
					}
				else
					{	/* Coerce/convert.scm 191 */
						bool_t BgL_testz00_2054;

						{	/* Coerce/convert.scm 191 */
							obj_t BgL_obj3278z00_1738;

							BgL_obj3278z00_1738 = (obj_t) (BgL_fromz00_53);
							BgL_testz00_2054 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj3278z00_1738,
								BGl_tclassz00zzobject_classz00);
						}
						if (BgL_testz00_2054)
							{	/* Coerce/convert.scm 191 */
								return
									BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
									BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57);
							}
						else
							{	/* Coerce/convert.scm 191 */
								return
									(obj_t)
									(BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
										BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57));
							}
					}
			}
		}
	}



/* skip-let-var */
	BgL_nodez00_bglt BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt
		BgL_nodez00_59)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 198 */
		BGl_skipzd2letzd2varz00zzcoerce_convertz00:
			{	/* Coerce/convert.scm 199 */
				bool_t BgL_testz00_2060;

				{	/* Coerce/convert.scm 199 */
					obj_t BgL_obj3085z00_1739;

					BgL_obj3085z00_1739 = (obj_t) (BgL_nodez00_59);
					BgL_testz00_2060 =
						BGl_iszd2azf3z21zz__objectz00(BgL_obj3085z00_1739,
						BGl_letzd2varzd2zzast_nodez00);
				}
				if (BgL_testz00_2060)
					{
						BgL_nodez00_bglt BgL_nodez00_2063;

						{
							BgL_letzd2varzd2_bglt BgL_auxz00_2064;

							BgL_auxz00_2064 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_59);
							BgL_nodez00_2063 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2064))->BgL_bodyz00);
						}
						BgL_nodez00_59 = BgL_nodez00_2063;
						goto BGl_skipzd2letzd2varz00zzcoerce_convertz00;
					}
				else
					{	/* Coerce/convert.scm 199 */
						return BgL_nodez00_59;
					}
			}
		}
	}



/* make-one-type-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_60, BgL_typez00_bglt BgL_fromz00_61,
		BgL_typez00_bglt BgL_toz00_62, obj_t BgL_checkzd2opzd2_63,
		obj_t BgL_coercezd2opzd2_64, obj_t BgL_nodez00_65)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 206 */
			{	/* Coerce/convert.scm 209 */
				obj_t BgL_auxz00_1111;

				BgL_auxz00_1111 =
					BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
					(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0))));
				{	/* Coerce/convert.scm 209 */
					obj_t BgL_locz00_1112;

					{
						BgL_nodez00_bglt BgL_auxz00_2070;

						BgL_auxz00_2070 = (BgL_nodez00_bglt) (BgL_nodez00_65);
						BgL_locz00_1112 =
							(((BgL_nodez00_bglt) CREF(BgL_auxz00_2070))->BgL_locz00);
					}
					{	/* Coerce/convert.scm 210 */
						BgL_nodez00_bglt BgL_lnodez00_1113;

						{	/* Coerce/convert.scm 217 */
							obj_t BgL_arg3660z00_1124;

							{	/* Coerce/convert.scm 217 */
								obj_t BgL_arg3661z00_1125;

								obj_t BgL_arg3662z00_1126;

								BgL_arg3661z00_1125 = CNST_TABLE_REF(((long) 1));
								{	/* Coerce/convert.scm 218 */
									obj_t BgL_arg3663z00_1127;

									obj_t BgL_arg3664z00_1128;

									{	/* Coerce/convert.scm 218 */
										obj_t BgL_arg3668z00_1132;

										{	/* Coerce/convert.scm 218 */
											obj_t BgL_arg3670z00_1134;

											obj_t BgL_arg3671z00_1135;

											{	/* Coerce/convert.scm 218 */
												obj_t BgL_arg3672z00_1136;

												{	/* Coerce/convert.scm 218 */
													obj_t BgL_arg3673z00_1137;

													BgL_arg3673z00_1137 =
														(((BgL_typez00_bglt) CREF(BgL_fromz00_61))->
														BgL_idz00);
													BgL_arg3672z00_1136 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_auxz00_1111, BgL_arg3673z00_1137);
												}
												BgL_arg3670z00_1134 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg3672z00_1136);
											}
											{	/* Coerce/convert.scm 217 */
												obj_t BgL_list3674z00_1138;

												BgL_list3674z00_1138 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3671z00_1135 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
													BgL_list3674z00_1138);
											}
											BgL_arg3668z00_1132 =
												MAKE_PAIR(BgL_arg3670z00_1134, BgL_arg3671z00_1135);
										}
										BgL_arg3663z00_1127 = MAKE_PAIR(BgL_arg3668z00_1132, BNIL);
									}
									{	/* Coerce/convert.scm 220 */
										obj_t BgL_arg3675z00_1139;

										obj_t BgL_arg3676z00_1140;

										BgL_arg3675z00_1139 = CNST_TABLE_REF(((long) 12));
										{	/* Coerce/convert.scm 220 */
											obj_t BgL_arg3677z00_1141;

											obj_t BgL_arg3678z00_1142;

											{	/* Coerce/convert.scm 220 */
												obj_t BgL_arg3683z00_1147;

												{	/* Coerce/convert.scm 220 */
													obj_t BgL_list3684z00_1148;

													BgL_list3684z00_1148 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3683z00_1147 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_auxz00_1111, BgL_list3684z00_1148);
												}
												BgL_arg3677z00_1141 =
													MAKE_PAIR(BgL_checkzd2opzd2_63, BgL_arg3683z00_1147);
											}
											{	/* Coerce/convert.scm 222 */
												obj_t BgL_arg3685z00_1149;

												BgL_arg3685z00_1149 =
													(((BgL_typez00_bglt) CREF(BgL_toz00_62))->BgL_idz00);
												BgL_arg3678z00_1142 =
													BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
													(BgL_locz00_1112, BgL_arg3685z00_1149,
													BgL_auxz00_1111);
											}
											{	/* Coerce/convert.scm 220 */
												obj_t BgL_list3680z00_1144;

												{	/* Coerce/convert.scm 220 */
													obj_t BgL_arg3681z00_1145;

													{	/* Coerce/convert.scm 220 */
														obj_t BgL_arg3682z00_1146;

														BgL_arg3682z00_1146 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3681z00_1145 =
															MAKE_PAIR(BgL_arg3678z00_1142,
															BgL_arg3682z00_1146);
													}
													BgL_list3680z00_1144 =
														MAKE_PAIR(BgL_auxz00_1111, BgL_arg3681z00_1145);
												}
												BgL_arg3676z00_1140 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3677z00_1141, BgL_list3680z00_1144);
										}}
										BgL_arg3664z00_1128 =
											MAKE_PAIR(BgL_arg3675z00_1139, BgL_arg3676z00_1140);
									}
									{	/* Coerce/convert.scm 217 */
										obj_t BgL_list3666z00_1130;

										{	/* Coerce/convert.scm 217 */
											obj_t BgL_arg3667z00_1131;

											BgL_arg3667z00_1131 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3666z00_1130 =
												MAKE_PAIR(BgL_arg3664z00_1128, BgL_arg3667z00_1131);
										}
										BgL_arg3662z00_1126 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3663z00_1127, BgL_list3666z00_1130);
								}}
								BgL_arg3660z00_1124 =
									MAKE_PAIR(BgL_arg3661z00_1125, BgL_arg3662z00_1126);
							}
							BgL_lnodez00_1113 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg3660z00_1124, BgL_locz00_1112);
						}
						{	/* Coerce/convert.scm 211 */

							BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1113);
							BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
								(BgL_lnodez00_1113);
							{	/* Coerce/convert.scm 226 */
								obj_t BgL_varz00_1114;

								{	/* Coerce/convert.scm 226 */
									obj_t BgL_pairz00_1746;

									{	/* Coerce/convert.scm 226 */
										obj_t BgL_pairz00_1745;

										{
											BgL_letzd2varzd2_bglt BgL_auxz00_2099;

											BgL_auxz00_2099 =
												(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1113);
											BgL_pairz00_1745 =
												(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2099))->
												BgL_bindingsz00);
										}
										BgL_pairz00_1746 = CAR(BgL_pairz00_1745);
									}
									BgL_varz00_1114 = CAR(BgL_pairz00_1746);
								}
								{	/* Coerce/convert.scm 226 */
									obj_t BgL_coercezd2appzd2_1115;

									{	/* Coerce/convert.scm 228 */
										BgL_varz00_bglt BgL_arg3657z00_1121;

										BgL_arg3657z00_1121 =
											BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1112,
											BgL_fromz00_61, (BgL_variablez00_bglt) (BgL_varz00_1114));
										BgL_coercezd2appzd2_1115 =
											BGl_dozd2convertzd2zzcoerce_convertz00
											(BgL_coercezd2opzd2_64, (obj_t) (BgL_arg3657z00_1121),
											BgL_fromz00_61);
									}
									{	/* Coerce/convert.scm 227 */
										BgL_nodez00_bglt BgL_condnz00_1116;

										BgL_condnz00_1116 =
											BGl_skipzd2letzd2varz00zzcoerce_convertz00
											(BgL_lnodez00_1113);
										{	/* Coerce/convert.scm 233 */

											{
												BgL_variablez00_bglt BgL_auxz00_2109;

												BgL_auxz00_2109 =
													(BgL_variablez00_bglt) (BgL_varz00_1114);
												((((BgL_variablez00_bglt) CREF(BgL_auxz00_2109))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_fromz00_61), BUNSPEC);
											}
											{	/* Coerce/convert.scm 237 */
												obj_t BgL_arg3653z00_1117;

												{	/* Coerce/convert.scm 237 */
													obj_t BgL_pairz00_1750;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2112;

														BgL_auxz00_2112 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1113);
														BgL_pairz00_1750 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2112))->
															BgL_bindingsz00);
													}
													BgL_arg3653z00_1117 = CAR(BgL_pairz00_1750);
												}
												SET_CDR(BgL_arg3653z00_1117, BgL_nodez00_65);
											}
											{
												BgL_nodez00_bglt BgL_auxz00_2119;

												BgL_conditionalz00_bglt BgL_auxz00_2117;

												BgL_auxz00_2119 =
													(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1115);
												BgL_auxz00_2117 =
													(BgL_conditionalz00_bglt) (BgL_condnz00_1116);
												((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2117))->
														BgL_truez00) =
													((BgL_nodez00_bglt) BgL_auxz00_2119), BUNSPEC);
											}
											{	/* Coerce/convert.scm 240 */
												BgL_nodez00_bglt BgL_arg3655z00_1119;

												{	/* Coerce/convert.scm 240 */
													BgL_nodez00_bglt BgL_arg3656z00_1120;

													{
														BgL_conditionalz00_bglt BgL_auxz00_2122;

														BgL_auxz00_2122 =
															(BgL_conditionalz00_bglt) (BgL_condnz00_1116);
														BgL_arg3656z00_1120 =
															(((BgL_conditionalz00_bglt)
																CREF(BgL_auxz00_2122))->BgL_falsez00);
													}
													BgL_arg3655z00_1119 =
														BGl_coercez12z12zzcoerce_coercez00
														(BgL_arg3656z00_1120, BUNSPEC, BgL_fromz00_61,
														((bool_t) 0));
												}
												{
													BgL_conditionalz00_bglt BgL_auxz00_2126;

													BgL_auxz00_2126 =
														(BgL_conditionalz00_bglt) (BgL_condnz00_1116);
													((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2126))->
															BgL_falsez00) =
														((BgL_nodez00_bglt) BgL_arg3655z00_1119), BUNSPEC);
											}}
											return BgL_lnodez00_1113;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* make-one-class-conversion */
	obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_66, BgL_typez00_bglt BgL_fromz00_67,
		BgL_typez00_bglt BgL_toz00_68, obj_t BgL_checkzd2opzd2_69,
		obj_t BgL_coercezd2opzd2_70, obj_t BgL_nodez00_71)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 249 */
			{	/* Coerce/convert.scm 250 */
				bool_t BgL_testz00_2129;

				{	/* Coerce/convert.scm 250 */
					bool_t BgL_testz00_2130;

					{	/* Coerce/convert.scm 250 */
						obj_t BgL_obj3278z00_1758;

						BgL_obj3278z00_1758 = (obj_t) (BgL_toz00_68);
						BgL_testz00_2130 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj3278z00_1758,
							BGl_tclassz00zzobject_classz00);
					}
					if (BgL_testz00_2130)
						{	/* Coerce/convert.scm 250 */
							BgL_testz00_2129 =
								BGl_typezd2subclasszf3z21zzobject_classz00(BgL_fromz00_67,
								BgL_toz00_68);
						}
					else
						{	/* Coerce/convert.scm 250 */
							BgL_testz00_2129 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2129)
					{	/* Coerce/convert.scm 250 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coercezd2opzd2_70,
							BgL_nodez00_71, BgL_fromz00_67);
					}
				else
					{	/* Coerce/convert.scm 252 */
						obj_t BgL_auxz00_1152;

						BgL_auxz00_1152 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
						{	/* Coerce/convert.scm 252 */
							obj_t BgL_aux2z00_1153;

							BgL_aux2z00_1153 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 13)));
							{	/* Coerce/convert.scm 253 */
								obj_t BgL_locz00_1154;

								{
									BgL_nodez00_bglt BgL_auxz00_2139;

									BgL_auxz00_2139 = (BgL_nodez00_bglt) (BgL_nodez00_71);
									BgL_locz00_1154 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_2139))->BgL_locz00);
								}
								{	/* Coerce/convert.scm 254 */
									BgL_nodez00_bglt BgL_lnodez00_1155;

									{	/* Coerce/convert.scm 256 */
										obj_t BgL_arg3699z00_1171;

										{	/* Coerce/convert.scm 256 */
											obj_t BgL_arg3700z00_1172;

											obj_t BgL_arg3701z00_1173;

											BgL_arg3700z00_1172 = CNST_TABLE_REF(((long) 1));
											{	/* Coerce/convert.scm 257 */
												obj_t BgL_arg3702z00_1174;

												obj_t BgL_arg3703z00_1175;

												{	/* Coerce/convert.scm 257 */
													obj_t BgL_arg3707z00_1179;

													{	/* Coerce/convert.scm 257 */
														obj_t BgL_arg3709z00_1181;

														obj_t BgL_arg3710z00_1182;

														{	/* Coerce/convert.scm 257 */
															obj_t BgL_arg3711z00_1183;

															{	/* Coerce/convert.scm 257 */
																obj_t BgL_arg3712z00_1184;

																{	/* Coerce/convert.scm 257 */
																	obj_t BgL_arg3713z00_1185;

																	obj_t BgL_arg3714z00_1186;

																	BgL_arg3713z00_1185 =
																		SYMBOL_TO_STRING(BgL_auxz00_1152);
																	{	/* Coerce/convert.scm 257 */
																		obj_t BgL_symbolz00_1761;

																		BgL_symbolz00_1761 =
																			CNST_TABLE_REF(((long) 2));
																		BgL_arg3714z00_1186 =
																			SYMBOL_TO_STRING(BgL_symbolz00_1761);
																	}
																	{	/* Coerce/convert.scm 257 */
																		obj_t BgL_list3715z00_1187;

																		{	/* Coerce/convert.scm 257 */
																			obj_t BgL_arg3716z00_1188;

																			BgL_arg3716z00_1188 =
																				MAKE_PAIR(BgL_arg3714z00_1186, BNIL);
																			BgL_list3715z00_1187 =
																				MAKE_PAIR(BgL_arg3713z00_1185,
																				BgL_arg3716z00_1188);
																		}
																		BgL_arg3712z00_1184 =
																			BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																			(BgL_list3715z00_1187);
																}}
																BgL_arg3711z00_1183 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_arg3712z00_1184));
															}
															BgL_arg3709z00_1181 =
																BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																(BgL_arg3711z00_1183);
														}
														{	/* Coerce/convert.scm 256 */
															obj_t BgL_list3717z00_1189;

															BgL_list3717z00_1189 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg3710z00_1182 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BUNSPEC, BgL_list3717z00_1189);
														}
														BgL_arg3707z00_1179 =
															MAKE_PAIR(BgL_arg3709z00_1181,
															BgL_arg3710z00_1182);
													}
													BgL_arg3702z00_1174 =
														MAKE_PAIR(BgL_arg3707z00_1179, BNIL);
												}
												{	/* Coerce/convert.scm 258 */
													obj_t BgL_arg3718z00_1190;

													obj_t BgL_arg3719z00_1191;

													BgL_arg3718z00_1190 = CNST_TABLE_REF(((long) 1));
													{	/* Coerce/convert.scm 259 */
														obj_t BgL_arg3720z00_1192;

														obj_t BgL_arg3721z00_1193;

														{	/* Coerce/convert.scm 259 */
															obj_t BgL_arg3725z00_1197;

															{	/* Coerce/convert.scm 259 */
																obj_t BgL_arg3727z00_1199;

																obj_t BgL_arg3728z00_1200;

																{	/* Coerce/convert.scm 259 */
																	obj_t BgL_arg3729z00_1201;

																	{	/* Coerce/convert.scm 259 */
																		obj_t BgL_arg3730z00_1202;

																		{	/* Coerce/convert.scm 259 */
																			obj_t BgL_arg3731z00_1203;

																			obj_t BgL_arg3732z00_1204;

																			BgL_arg3731z00_1203 =
																				SYMBOL_TO_STRING(BgL_aux2z00_1153);
																			{	/* Coerce/convert.scm 259 */
																				obj_t BgL_symbolz00_1764;

																				BgL_symbolz00_1764 =
																					CNST_TABLE_REF(((long) 2));
																				BgL_arg3732z00_1204 =
																					SYMBOL_TO_STRING(BgL_symbolz00_1764);
																			}
																			{	/* Coerce/convert.scm 259 */
																				obj_t BgL_list3733z00_1205;

																				{	/* Coerce/convert.scm 259 */
																					obj_t BgL_arg3734z00_1206;

																					BgL_arg3734z00_1206 =
																						MAKE_PAIR(BgL_arg3732z00_1204,
																						BNIL);
																					BgL_list3733z00_1205 =
																						MAKE_PAIR(BgL_arg3731z00_1203,
																						BgL_arg3734z00_1206);
																				}
																				BgL_arg3730z00_1202 =
																					BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																					(BgL_list3733z00_1205);
																		}}
																		BgL_arg3729z00_1201 =
																			string_to_symbol(BSTRING_TO_STRING
																			(BgL_arg3730z00_1202));
																	}
																	BgL_arg3727z00_1199 =
																		BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																		(BgL_arg3729z00_1201);
																}
																{	/* Coerce/convert.scm 258 */
																	obj_t BgL_list3735z00_1207;

																	BgL_list3735z00_1207 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3728z00_1200 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BUNSPEC, BgL_list3735z00_1207);
																}
																BgL_arg3725z00_1197 =
																	MAKE_PAIR(BgL_arg3727z00_1199,
																	BgL_arg3728z00_1200);
															}
															BgL_arg3720z00_1192 =
																MAKE_PAIR(BgL_arg3725z00_1197, BNIL);
														}
														{	/* Coerce/convert.scm 260 */
															obj_t BgL_arg3736z00_1208;

															obj_t BgL_arg3737z00_1209;

															BgL_arg3736z00_1208 = CNST_TABLE_REF(((long) 12));
															{	/* Coerce/convert.scm 260 */
																obj_t BgL_arg3738z00_1210;

																obj_t BgL_arg3739z00_1211;

																{	/* Coerce/convert.scm 260 */
																	obj_t BgL_arg3744z00_1216;

																	{	/* Coerce/convert.scm 260 */
																		obj_t BgL_list3745z00_1217;

																		BgL_list3745z00_1217 =
																			MAKE_PAIR(BNIL, BNIL);
																		BgL_arg3744z00_1216 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_aux2z00_1153, BgL_list3745z00_1217);
																	}
																	BgL_arg3738z00_1210 =
																		MAKE_PAIR(BgL_checkzd2opzd2_69,
																		BgL_arg3744z00_1216);
																}
																{	/* Coerce/convert.scm 262 */
																	obj_t BgL_arg3746z00_1218;

																	BgL_arg3746z00_1218 =
																		(((BgL_typez00_bglt) CREF(BgL_toz00_68))->
																		BgL_idz00);
																	BgL_arg3739z00_1211 =
																		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																		(BgL_locz00_1154, BgL_arg3746z00_1218,
																		BgL_auxz00_1152);
																}
																{	/* Coerce/convert.scm 260 */
																	obj_t BgL_list3741z00_1213;

																	{	/* Coerce/convert.scm 260 */
																		obj_t BgL_arg3742z00_1214;

																		{	/* Coerce/convert.scm 260 */
																			obj_t BgL_arg3743z00_1215;

																			BgL_arg3743z00_1215 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3742z00_1214 =
																				MAKE_PAIR(BgL_arg3739z00_1211,
																				BgL_arg3743z00_1215);
																		}
																		BgL_list3741z00_1213 =
																			MAKE_PAIR(BgL_auxz00_1152,
																			BgL_arg3742z00_1214);
																	}
																	BgL_arg3737z00_1209 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3738z00_1210, BgL_list3741z00_1213);
															}}
															BgL_arg3721z00_1193 =
																MAKE_PAIR(BgL_arg3736z00_1208,
																BgL_arg3737z00_1209);
														}
														{	/* Coerce/convert.scm 258 */
															obj_t BgL_list3723z00_1195;

															{	/* Coerce/convert.scm 258 */
																obj_t BgL_arg3724z00_1196;

																BgL_arg3724z00_1196 = MAKE_PAIR(BNIL, BNIL);
																BgL_list3723z00_1195 =
																	MAKE_PAIR(BgL_arg3721z00_1193,
																	BgL_arg3724z00_1196);
															}
															BgL_arg3719z00_1191 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg3720z00_1192, BgL_list3723z00_1195);
													}}
													BgL_arg3703z00_1175 =
														MAKE_PAIR(BgL_arg3718z00_1190, BgL_arg3719z00_1191);
												}
												{	/* Coerce/convert.scm 256 */
													obj_t BgL_list3705z00_1177;

													{	/* Coerce/convert.scm 256 */
														obj_t BgL_arg3706z00_1178;

														BgL_arg3706z00_1178 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3705z00_1177 =
															MAKE_PAIR(BgL_arg3703z00_1175,
															BgL_arg3706z00_1178);
													}
													BgL_arg3701z00_1173 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3702z00_1174, BgL_list3705z00_1177);
											}}
											BgL_arg3699z00_1171 =
												MAKE_PAIR(BgL_arg3700z00_1172, BgL_arg3701z00_1173);
										}
										BgL_lnodez00_1155 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg3699z00_1171, BgL_locz00_1154);
									}
									{	/* Coerce/convert.scm 255 */

										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1155);
										BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
											(BgL_lnodez00_1155);
										{	/* Coerce/convert.scm 266 */
											obj_t BgL_varz00_1156;

											{	/* Coerce/convert.scm 266 */
												obj_t BgL_pairz00_1769;

												{	/* Coerce/convert.scm 266 */
													obj_t BgL_pairz00_1768;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2192;

														BgL_auxz00_2192 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1155);
														BgL_pairz00_1768 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2192))->
															BgL_bindingsz00);
													}
													BgL_pairz00_1769 = CAR(BgL_pairz00_1768);
												}
												BgL_varz00_1156 = CAR(BgL_pairz00_1769);
											}
											{	/* Coerce/convert.scm 266 */
												obj_t BgL_coercezd2appzd2_1157;

												{	/* Coerce/convert.scm 268 */
													BgL_varz00_bglt BgL_arg3696z00_1168;

													BgL_arg3696z00_1168 =
														BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1154,
														BgL_fromz00_67,
														(BgL_variablez00_bglt) (BgL_varz00_1156));
													BgL_coercezd2appzd2_1157 =
														BGl_dozd2convertzd2zzcoerce_convertz00
														(BgL_coercezd2opzd2_70,
														(obj_t) (BgL_arg3696z00_1168), BgL_fromz00_67);
												}
												{	/* Coerce/convert.scm 267 */
													BgL_nodez00_bglt BgL_condnz00_1158;

													BgL_condnz00_1158 =
														BGl_skipzd2letzd2varz00zzcoerce_convertz00
														(BgL_lnodez00_1155);
													{	/* Coerce/convert.scm 273 */

														{
															BgL_variablez00_bglt BgL_auxz00_2202;

															BgL_auxz00_2202 =
																(BgL_variablez00_bglt) (BgL_varz00_1156);
															((((BgL_variablez00_bglt) CREF(BgL_auxz00_2202))->
																	BgL_typez00) =
																((BgL_typez00_bglt) BgL_fromz00_67), BUNSPEC);
														}
														{	/* Coerce/convert.scm 277 */
															obj_t BgL_arg3688z00_1159;

															{	/* Coerce/convert.scm 277 */
																obj_t BgL_pairz00_1773;

																{
																	BgL_letzd2varzd2_bglt BgL_auxz00_2205;

																	BgL_auxz00_2205 =
																		(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1155);
																	BgL_pairz00_1773 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_auxz00_2205))->BgL_bindingsz00);
																}
																BgL_arg3688z00_1159 = CAR(BgL_pairz00_1773);
															}
															SET_CDR(BgL_arg3688z00_1159, BgL_nodez00_71);
														}
														{	/* Coerce/convert.scm 278 */
															obj_t BgL_binding2z00_1161;

															{	/* Coerce/convert.scm 278 */
																obj_t BgL_pairz00_1778;

																{	/* Coerce/convert.scm 278 */
																	BgL_letzd2varzd2_bglt BgL_obj3052z00_1777;

																	{	/* Coerce/convert.scm 278 */
																		BgL_letzd2varzd2_bglt BgL_obj3055z00_1776;

																		BgL_obj3055z00_1776 =
																			(BgL_letzd2varzd2_bglt)
																			(BgL_lnodez00_1155);
																		BgL_obj3052z00_1777 =
																			(BgL_letzd2varzd2_bglt) (((
																					(BgL_letzd2varzd2_bglt)
																					CREF(BgL_obj3055z00_1776))->
																				BgL_bodyz00));
																	}
																	BgL_pairz00_1778 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_obj3052z00_1777))->
																		BgL_bindingsz00);
																}
																BgL_binding2z00_1161 = CAR(BgL_pairz00_1778);
															}
															{	/* Coerce/convert.scm 282 */
																BgL_castz00_bglt BgL_arg3690z00_1162;

																{	/* Coerce/convert.scm 282 */
																	BgL_varz00_bglt BgL_arg3691z00_1163;

																	BgL_arg3691z00_1163 =
																		BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_1154, BgL_fromz00_67,
																		(BgL_variablez00_bglt) (BgL_varz00_1156));
																	BgL_arg3690z00_1162 =
																		BGl_makezd2castzd2zzast_nodez00
																		(BgL_locz00_1154,
																		(BgL_typez00_bglt)
																		(BGl_za2objza2z00zztype_cachez00),
																		(BgL_nodez00_bglt) (BgL_arg3691z00_1163));
																}
																{	/* Coerce/convert.scm 279 */
																	obj_t BgL_auxz00_2220;

																	BgL_auxz00_2220 =
																		(obj_t) (BgL_arg3690z00_1162);
																	SET_CDR(BgL_binding2z00_1161,
																		BgL_auxz00_2220);
														}}}
														{
															BgL_nodez00_bglt BgL_auxz00_2225;

															BgL_conditionalz00_bglt BgL_auxz00_2223;

															BgL_auxz00_2225 =
																(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1157);
															BgL_auxz00_2223 =
																(BgL_conditionalz00_bglt) (BgL_condnz00_1158);
															((((BgL_conditionalz00_bglt)
																		CREF(BgL_auxz00_2223))->BgL_truez00) =
																((BgL_nodez00_bglt) BgL_auxz00_2225), BUNSPEC);
														}
														{	/* Coerce/convert.scm 288 */
															BgL_nodez00_bglt BgL_arg3694z00_1166;

															{	/* Coerce/convert.scm 288 */
																BgL_nodez00_bglt BgL_arg3695z00_1167;

																{
																	BgL_conditionalz00_bglt BgL_auxz00_2228;

																	BgL_auxz00_2228 =
																		(BgL_conditionalz00_bglt)
																		(BgL_condnz00_1158);
																	BgL_arg3695z00_1167 =
																		(((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2228))->BgL_falsez00);
																}
																BgL_arg3694z00_1166 =
																	BGl_coercez12z12zzcoerce_coercez00
																	(BgL_arg3695z00_1167, BUNSPEC, BgL_fromz00_67,
																	((bool_t) 0));
															}
															{
																BgL_conditionalz00_bglt BgL_auxz00_2232;

																BgL_auxz00_2232 =
																	(BgL_conditionalz00_bglt) (BgL_condnz00_1158);
																((((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2232))->BgL_falsez00) =
																	((BgL_nodez00_bglt) BgL_arg3694z00_1166),
																	BUNSPEC);
														}}
														return (obj_t) (BgL_lnodez00_1155);
													}
												}
											}
										}
									}
								}
							}
						}
					}
			}
		}
	}



/* do-convert */
	obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t BgL_coercezd2opzd2_72,
		obj_t BgL_nodez00_73, BgL_typez00_bglt BgL_fromz00_74)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 297 */
			if (NULLP(BgL_coercezd2opzd2_72))
				{	/* Coerce/convert.scm 300 */
					return BgL_nodez00_73;
				}
			else
				{	/* Coerce/convert.scm 302 */
					BgL_nodez00_bglt BgL_nnodez00_1221;

					{	/* Coerce/convert.scm 302 */
						obj_t BgL_arg3766z00_1240;

						obj_t BgL_arg3767z00_1241;

						{	/* Coerce/convert.scm 302 */
							obj_t BgL_arg3768z00_1242;

							{	/* Coerce/convert.scm 302 */
								obj_t BgL_list3769z00_1243;

								BgL_list3769z00_1243 = MAKE_PAIR(BNIL, BNIL);
								BgL_arg3768z00_1242 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
									BgL_list3769z00_1243);
							}
							BgL_arg3766z00_1240 =
								MAKE_PAIR(BgL_coercezd2opzd2_72, BgL_arg3768z00_1242);
						}
						{
							BgL_nodez00_bglt BgL_auxz00_2241;

							BgL_auxz00_2241 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							BgL_arg3767z00_1241 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_2241))->BgL_locz00);
						}
						BgL_nnodez00_1221 =
							BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
							(BgL_arg3766z00_1240, BgL_arg3767z00_1241);
					}
					{	/* Coerce/convert.scm 302 */

						{
							BgL_nodez00_bglt BgL_auxz00_2245;

							BgL_auxz00_2245 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							((((BgL_nodez00_bglt) CREF(BgL_auxz00_2245))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
						}
						BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
							(BgL_nnodez00_1221);
						{	/* Coerce/convert.scm 316 */
							bool_t BgL_testz00_2249;

							{	/* Coerce/convert.scm 316 */
								obj_t BgL_obj2267z00_1790;

								BgL_obj2267z00_1790 = (obj_t) (BgL_nnodez00_1221);
								BgL_testz00_2249 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2267z00_1790,
									BGl_appz00zzast_nodez00);
							}
							if (BgL_testz00_2249)
								{	/* Coerce/convert.scm 316 */
									{	/* Coerce/convert.scm 317 */
										obj_t BgL_arg3750z00_1223;

										{	/* Coerce/convert.scm 317 */
											obj_t BgL_list3751z00_1224;

											BgL_list3751z00_1224 = MAKE_PAIR(BgL_nodez00_73, BNIL);
											BgL_arg3750z00_1223 = BgL_list3751z00_1224;
										}
										{
											BgL_appz00_bglt BgL_auxz00_2253;

											BgL_auxz00_2253 = (BgL_appz00_bglt) (BgL_nnodez00_1221);
											((((BgL_appz00_bglt) CREF(BgL_auxz00_2253))->
													BgL_argsz00) =
												((obj_t) BgL_arg3750z00_1223), BUNSPEC);
										}
									}
									return (obj_t) (BgL_nnodez00_1221);
								}
							else
								{	/* Coerce/convert.scm 319 */
									bool_t BgL_testz00_2257;

									{	/* Coerce/convert.scm 319 */
										obj_t BgL_obj3085z00_1795;

										BgL_obj3085z00_1795 = (obj_t) (BgL_nnodez00_1221);
										BgL_testz00_2257 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj3085z00_1795,
											BGl_letzd2varzd2zzast_nodez00);
									}
									if (BgL_testz00_2257)
										{	/* Coerce/convert.scm 320 */
											obj_t BgL_bdgsz00_1226;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_2260;

												BgL_auxz00_2260 =
													(BgL_letzd2varzd2_bglt) (BgL_nnodez00_1221);
												BgL_bdgsz00_1226 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2260))->
													BgL_bindingsz00);
											}
											{	/* Coerce/convert.scm 321 */
												bool_t BgL_testz00_2263;

												if (NULLP(BgL_bdgsz00_1226))
													{	/* Coerce/convert.scm 321 */
														BgL_testz00_2263 = ((bool_t) 1);
													}
												else
													{	/* Coerce/convert.scm 321 */
														if (NULLP(CDR(BgL_bdgsz00_1226)))
															{	/* Coerce/convert.scm 321 */
																BgL_testz00_2263 = ((bool_t) 0);
															}
														else
															{	/* Coerce/convert.scm 321 */
																BgL_testz00_2263 = ((bool_t) 1);
															}
													}
												if (BgL_testz00_2263)
													{	/* Coerce/convert.scm 321 */
														return
															BGl_internalzd2errorzd2zztools_errorz00
															(BGl_string3831z00zzcoerce_convertz00,
															BGl_string3832z00zzcoerce_convertz00,
															BGl_shapez00zztools_shapez00
															(BgL_coercezd2opzd2_72));
													}
												else
													{	/* Coerce/convert.scm 321 */
														{	/* Coerce/convert.scm 326 */
															obj_t BgL_arg3757z00_1231;

															BgL_arg3757z00_1231 = CAR(CAR(BgL_bdgsz00_1226));
															{
																BgL_variablez00_bglt BgL_auxz00_2273;

																BgL_auxz00_2273 =
																	(BgL_variablez00_bglt) (BgL_arg3757z00_1231);
																((((BgL_variablez00_bglt)
																			CREF(BgL_auxz00_2273))->BgL_typez00) =
																	((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
															}
														}
														{	/* Coerce/convert.scm 327 */
															obj_t BgL_auxz00_2276;

															BgL_auxz00_2276 = CAR(BgL_bdgsz00_1226);
															SET_CDR(BgL_auxz00_2276, BgL_nodez00_73);
														}
														return (obj_t) (BgL_nnodez00_1221);
													}
											}
										}
									else
										{	/* Coerce/convert.scm 319 */
											return
												BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string3831z00zzcoerce_convertz00,
												BGl_string3832z00zzcoerce_convertz00,
												BGl_shapez00zztools_shapez00(BgL_coercezd2opzd2_72));
										}
								}
						}
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 451733024),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 80496154),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 498901618),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 476444243),
				BSTRING_TO_STRING(BGl_string3833z00zzcoerce_convertz00));
		}
	}

#ifdef __cplusplus
}
#endif
