/*===========================================================================*/
/*   (Coerce/funcall.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/funcall.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;


	static obj_t BGl_coercez12zd2funcall3241zc0zzcoerce_funcallz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	static obj_t BGl_cnstzd2initzd2zzcoerce_funcallz00();
	extern BgL_nodez00_bglt BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_funcallz00();
	BGL_IMPORT long bgl_list_length(obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_funcallz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_funcallz00 = BUNSPEC;
	extern obj_t BGl_za2unsafezd2arityza2zd2zzengine_paramz00;
	extern BgL_atomz00_bglt BGl_makezd2atomzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	static BgL_nodez00_bglt
		BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00(BgL_localz00_bglt,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcoerce_funcallz00();
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t
		BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_funcallz00_bglt,
		obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00();
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t,
		BgL_typez00_bglt);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	extern BgL_letzd2varzd2_bglt BGl_makezd2letzd2varz00zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, obj_t, BgL_nodez00_bglt, bool_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00();
	static obj_t __cnst[18];


	extern obj_t BGl_coercez12zd2envzc0zzcoerce_coercez00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3445z00zzcoerce_funcallz00,
		BgL_bgl_coerceza712za7d2func3450z00,
		BGl_coercez12zd2funcall3241zc0zzcoerce_funcallz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3444z00zzcoerce_funcallz00,
		BgL_bgl_string3444za700za7za7c3451za7, ":Wrong number of arguments", 26);
	      DEFINE_STRING(BGl_string3446z00zzcoerce_funcallz00,
		BgL_bgl_string3446za700za7za7c3452za7, "coerce_funcall", 14);
	      DEFINE_STRING(BGl_string3447z00zzcoerce_funcallz00,
		BgL_bgl_string3447za700za7za7c3453za7,
		"correct-arity? if let ::int len fun (light elight) dummy __eoa__ _ quote failure error/location __error @ begin location bdb ",
		125);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long
		BgL_checksumz00_1461, char *BgL_fromz00_1462)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_funcallz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_funcallz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00();
					BGl_cnstzd2initzd2zzcoerce_funcallz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00();
					BGl_methodzd2initzd2zzcoerce_funcallz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_funcall");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			{	/* Coerce/funcall.scm 15 */
				obj_t BgL_cportz00_1453;

				BgL_cportz00_1453 =
					bgl_open_input_string(BGl_string3447z00zzcoerce_funcallz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1454;

					BgL_iz00_1454 = ((long) 17);
				BgL_loopz00_1455:
					if ((BgL_iz00_1454 == ((long) -1)))
						{	/* Coerce/funcall.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/funcall.scm 15 */
							{	/* Coerce/funcall.scm 15 */
								obj_t BgL_arg3449z00_1457;

								{	/* Coerce/funcall.scm 15 */

									{	/* Coerce/funcall.scm 15 */
										obj_t BgL_locationz00_1459;

										BgL_locationz00_1459 = BBOOL(((bool_t) 0));
										{	/* Coerce/funcall.scm 15 */

											BgL_arg3449z00_1457 =
												BGl_readz00zz__readerz00(BgL_cportz00_1453,
												BgL_locationz00_1459);
										}
									}
								}
								{	/* Coerce/funcall.scm 15 */
									int BgL_auxz00_1481;

									BgL_auxz00_1481 = (int) (BgL_iz00_1454);
									CNST_TABLE_SET(BgL_auxz00_1481, BgL_arg3449z00_1457);
							}}
							{	/* Coerce/funcall.scm 15 */
								int BgL_auxz00_1460;

								BgL_auxz00_1460 = (int) ((BgL_iz00_1454 - ((long) 1)));
								{
									long BgL_iz00_1486;

									BgL_iz00_1486 = (long) (BgL_auxz00_1460);
									BgL_iz00_1454 = BgL_iz00_1486;
									goto BgL_loopz00_1455;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return BUNSPEC;
		}
	}



/* make-arity-error-node */
	BgL_nodez00_bglt
		BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00(BgL_localz00_bglt
		BgL_funz00_19, obj_t BgL_errorzd2msgzd2_20, obj_t BgL_locz00_21,
		obj_t BgL_callerz00_22, obj_t BgL_toz00_23)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 85 */
			{	/* Coerce/funcall.scm 86 */
				BgL_nodez00_bglt BgL_nodez00_857;

				{	/* Coerce/funcall.scm 87 */
					obj_t BgL_arg3251z00_858;

					{	/* Coerce/funcall.scm 87 */
						bool_t BgL_testz00_1488;

						{	/* Coerce/funcall.scm 87 */
							bool_t BgL_testz00_1489;

							if (
								((long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >
									((long) 0)))
								{	/* Coerce/funcall.scm 87 */
									BgL_testz00_1489 = ((bool_t) 1);
								}
							else
								{	/* Coerce/funcall.scm 87 */
									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >
											((long) 0)))
										{	/* Coerce/funcall.scm 89 */
											obj_t BgL_arg3314z00_917;

											obj_t BgL_arg3315z00_918;

											BgL_arg3314z00_917 = CNST_TABLE_REF(((long) 0));
											{	/* Coerce/funcall.scm 91 */
												obj_t BgL_arg3316z00_919;

												BgL_arg3316z00_919 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_1498;

													BgL_auxz00_1498 =
														(BgL_backendz00_bglt) (BgL_arg3316z00_919);
													BgL_arg3315z00_918 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_1498))->
														BgL_debugzd2supportzd2);
											}}
											BgL_testz00_1489 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_arg3314z00_917, BgL_arg3315z00_918));
										}
									else
										{	/* Coerce/funcall.scm 88 */
											BgL_testz00_1489 = ((bool_t) 0);
										}
								}
							if (BgL_testz00_1489)
								{	/* Coerce/funcall.scm 87 */
									if (STRUCTP(BgL_locz00_21))
										{	/* Coerce/funcall.scm 92 */
											BgL_testz00_1488 =
												(STRUCT_KEY(BgL_locz00_21) ==
												CNST_TABLE_REF(((long) 1)));
										}
									else
										{	/* Coerce/funcall.scm 92 */
											BgL_testz00_1488 = ((bool_t) 0);
										}
								}
							else
								{	/* Coerce/funcall.scm 87 */
									BgL_testz00_1488 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_1488)
							{	/* Coerce/funcall.scm 93 */
								obj_t BgL_arg3253z00_860;

								obj_t BgL_arg3254z00_861;

								BgL_arg3253z00_860 = CNST_TABLE_REF(((long) 2));
								{	/* Coerce/funcall.scm 94 */
									obj_t BgL_arg3255z00_862;

									obj_t BgL_arg3256z00_863;

									{	/* Coerce/funcall.scm 94 */
										obj_t BgL_arg3260z00_867;

										obj_t BgL_arg3261z00_868;

										{	/* Coerce/funcall.scm 94 */
											obj_t BgL_arg3262z00_869;

											obj_t BgL_arg3263z00_870;

											BgL_arg3262z00_869 = CNST_TABLE_REF(((long) 3));
											{	/* Coerce/funcall.scm 94 */
												obj_t BgL_list3264z00_871;

												{	/* Coerce/funcall.scm 94 */
													obj_t BgL_arg3266z00_872;

													obj_t BgL_arg3267z00_873;

													BgL_arg3266z00_872 = CNST_TABLE_REF(((long) 4));
													BgL_arg3267z00_873 = MAKE_PAIR(BNIL, BNIL);
													BgL_list3264z00_871 =
														MAKE_PAIR(BgL_arg3266z00_872, BgL_arg3267z00_873);
												}
												BgL_arg3263z00_870 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(CNST_TABLE_REF(((long) 5)), BgL_list3264z00_871);
											}
											BgL_arg3260z00_867 =
												MAKE_PAIR(BgL_arg3262z00_869, BgL_arg3263z00_870);
										}
										{	/* Coerce/funcall.scm 96 */
											obj_t BgL_arg3268z00_874;

											obj_t BgL_arg3269z00_875;

											obj_t BgL_arg3270z00_876;

											{	/* Coerce/funcall.scm 96 */
												obj_t BgL_arg3278z00_883;

												BgL_arg3278z00_883 =
													SYMBOL_TO_STRING
													(BGl_currentzd2functionzd2zztools_errorz00());
												BgL_arg3268z00_874 =
													string_append(BgL_arg3278z00_883,
													BGl_string3444z00zzcoerce_funcallz00);
											}
											BgL_arg3269z00_875 =
												BGl_locationzd2fullzd2fnamez00zztools_locationz00
												(BgL_locz00_21);
											BgL_arg3270z00_876 =
												STRUCT_REF(BgL_locz00_21, (int) (((long) 1)));
											{	/* Coerce/funcall.scm 94 */
												obj_t BgL_list3272z00_878;

												{	/* Coerce/funcall.scm 94 */
													obj_t BgL_arg3273z00_879;

													{	/* Coerce/funcall.scm 94 */
														obj_t BgL_arg3274z00_880;

														{	/* Coerce/funcall.scm 94 */
															obj_t BgL_arg3275z00_881;

															{	/* Coerce/funcall.scm 94 */
																obj_t BgL_arg3277z00_882;

																BgL_arg3277z00_882 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3275z00_881 =
																	MAKE_PAIR(BgL_arg3270z00_876,
																	BgL_arg3277z00_882);
															}
															BgL_arg3274z00_880 =
																MAKE_PAIR(BgL_arg3269z00_875,
																BgL_arg3275z00_881);
														}
														BgL_arg3273z00_879 =
															MAKE_PAIR(
															(obj_t) (BgL_funz00_19), BgL_arg3274z00_880);
													}
													BgL_list3272z00_878 =
														MAKE_PAIR(BgL_errorzd2msgzd2_20,
														BgL_arg3273z00_879);
												}
												BgL_arg3261z00_868 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3268z00_874, BgL_list3272z00_878);
										}}
										BgL_arg3255z00_862 =
											MAKE_PAIR(BgL_arg3260z00_867, BgL_arg3261z00_868);
									}
									{	/* Coerce/funcall.scm 102 */
										obj_t BgL_arg3281z00_886;

										obj_t BgL_arg3283z00_887;

										BgL_arg3281z00_886 = CNST_TABLE_REF(((long) 6));
										{	/* Coerce/funcall.scm 102 */
											obj_t BgL_arg3284z00_888;

											obj_t BgL_arg3285z00_889;

											obj_t BgL_arg3286z00_890;

											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3291z00_895;

												obj_t BgL_arg3292z00_896;

												BgL_arg3291z00_895 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3293z00_897;

													BgL_list3293z00_897 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3292z00_896 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3293z00_897);
												}
												BgL_arg3284z00_888 =
													MAKE_PAIR(BgL_arg3291z00_895, BgL_arg3292z00_896);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3294z00_898;

												obj_t BgL_arg3295z00_899;

												BgL_arg3294z00_898 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3296z00_900;

													BgL_list3296z00_900 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3295z00_899 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3296z00_900);
												}
												BgL_arg3285z00_889 =
													MAKE_PAIR(BgL_arg3294z00_898, BgL_arg3295z00_899);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3297z00_901;

												obj_t BgL_arg3298z00_902;

												BgL_arg3297z00_901 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3299z00_903;

													BgL_list3299z00_903 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3298z00_902 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3299z00_903);
												}
												BgL_arg3286z00_890 =
													MAKE_PAIR(BgL_arg3297z00_901, BgL_arg3298z00_902);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_list3288z00_892;

												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_arg3289z00_893;

													{	/* Coerce/funcall.scm 102 */
														obj_t BgL_arg3290z00_894;

														BgL_arg3290z00_894 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3289z00_893 =
															MAKE_PAIR(BgL_arg3286z00_890, BgL_arg3290z00_894);
													}
													BgL_list3288z00_892 =
														MAKE_PAIR(BgL_arg3285z00_889, BgL_arg3289z00_893);
												}
												BgL_arg3283z00_887 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3284z00_888, BgL_list3288z00_892);
										}}
										BgL_arg3256z00_863 =
											MAKE_PAIR(BgL_arg3281z00_886, BgL_arg3283z00_887);
									}
									{	/* Coerce/funcall.scm 93 */
										obj_t BgL_list3258z00_865;

										{	/* Coerce/funcall.scm 93 */
											obj_t BgL_arg3259z00_866;

											BgL_arg3259z00_866 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3258z00_865 =
												MAKE_PAIR(BgL_arg3256z00_863, BgL_arg3259z00_866);
										}
										BgL_arg3254z00_861 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3255z00_862, BgL_list3258z00_865);
								}}
								BgL_arg3251z00_858 =
									MAKE_PAIR(BgL_arg3253z00_860, BgL_arg3254z00_861);
							}
						else
							{	/* Coerce/funcall.scm 103 */
								obj_t BgL_arg3300z00_904;

								obj_t BgL_arg3301z00_905;

								BgL_arg3300z00_904 = CNST_TABLE_REF(((long) 6));
								{	/* Coerce/funcall.scm 104 */
									obj_t BgL_arg3302z00_906;

									{	/* Coerce/funcall.scm 104 */
										obj_t BgL_arg3308z00_911;

										BgL_arg3308z00_911 =
											SYMBOL_TO_STRING(BGl_currentzd2functionzd2zztools_errorz00
											());
										BgL_arg3302z00_906 =
											string_append(BgL_arg3308z00_911,
											BGl_string3444z00zzcoerce_funcallz00);
									}
									{	/* Coerce/funcall.scm 103 */
										obj_t BgL_list3304z00_908;

										{	/* Coerce/funcall.scm 103 */
											obj_t BgL_arg3305z00_909;

											{	/* Coerce/funcall.scm 103 */
												obj_t BgL_arg3306z00_910;

												BgL_arg3306z00_910 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3305z00_909 =
													MAKE_PAIR(
													(obj_t) (BgL_funz00_19), BgL_arg3306z00_910);
											}
											BgL_list3304z00_908 =
												MAKE_PAIR(BgL_errorzd2msgzd2_20, BgL_arg3305z00_909);
										}
										BgL_arg3301z00_905 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3302z00_906, BgL_list3304z00_908);
								}}
								BgL_arg3251z00_858 =
									MAKE_PAIR(BgL_arg3300z00_904, BgL_arg3301z00_905);
					}}
					BgL_nodez00_857 =
						BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3251z00_858,
						BgL_locz00_21);
				}
				return
					BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_857, BgL_callerz00_22,
					(BgL_typez00_bglt) (BgL_toz00_23), ((bool_t) 0));
			}
		}
	}



/* coerce-funcall-args! */
	obj_t BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_funcallz00_bglt
		BgL_nodez00_24, obj_t BgL_callerz00_25, obj_t BgL_toz00_26,
		obj_t BgL_safez00_27)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 114 */
			if (NULLP((((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00)))
				{	/* Coerce/funcall.scm 117 */
					obj_t BgL_arg3318z00_921;

					{	/* Coerce/funcall.scm 117 */
						BgL_nodez00_bglt BgL_arg3319z00_922;

						{	/* Coerce/funcall.scm 117 */
							obj_t BgL_arg3321z00_924;

							obj_t BgL_arg3323z00_925;

							BgL_arg3321z00_924 = CNST_TABLE_REF(((long) 9));
							{
								BgL_nodez00_bglt BgL_auxz00_1572;

								BgL_auxz00_1572 = (BgL_nodez00_bglt) (BgL_nodez00_24);
								BgL_arg3323z00_925 =
									(((BgL_nodez00_bglt) CREF(BgL_auxz00_1572))->BgL_locz00);
							}
							BgL_arg3319z00_922 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg3321z00_924, BgL_arg3323z00_925);
						}
						{	/* Coerce/funcall.scm 116 */
							obj_t BgL_list3320z00_923;

							BgL_list3320z00_923 =
								MAKE_PAIR((obj_t) (BgL_arg3319z00_922), BNIL);
							BgL_arg3318z00_921 = BgL_list3320z00_923;
					}}
					return
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00) =
						((obj_t) BgL_arg3318z00_921), BUNSPEC);
				}
			else
				{	/* Coerce/funcall.scm 119 */
					obj_t BgL_g3238z00_926;

					obj_t BgL_g3239z00_927;

					BgL_g3238z00_926 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00);
					BgL_g3239z00_927 = CNST_TABLE_REF(((long) 10));
					{
						obj_t BgL_actualsz00_929;

						obj_t BgL_prevz00_930;

						BgL_actualsz00_929 = BgL_g3238z00_926;
						BgL_prevz00_930 = BgL_g3239z00_927;
					BgL_zc3anonymousza33324ze3z83_931:
						if (NULLP(BgL_actualsz00_929))
							{	/* Coerce/funcall.scm 123 */
								obj_t BgL_arg3326z00_933;

								{	/* Coerce/funcall.scm 123 */
									BgL_nodez00_bglt BgL_arg3327z00_934;

									{	/* Coerce/funcall.scm 123 */
										obj_t BgL_arg3329z00_936;

										obj_t BgL_arg3330z00_937;

										BgL_arg3329z00_936 = CNST_TABLE_REF(((long) 9));
										{
											BgL_nodez00_bglt BgL_auxz00_1584;

											BgL_auxz00_1584 = (BgL_nodez00_bglt) (BgL_nodez00_24);
											BgL_arg3330z00_937 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_1584))->
												BgL_locz00);
										}
										BgL_arg3327z00_934 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg3329z00_936, BgL_arg3330z00_937);
									}
									{	/* Coerce/funcall.scm 122 */
										obj_t BgL_list3328z00_935;

										BgL_list3328z00_935 =
											MAKE_PAIR((obj_t) (BgL_arg3327z00_934), BNIL);
										BgL_arg3326z00_933 = BgL_list3328z00_935;
								}}
								return SET_CDR(BgL_prevz00_930, BgL_arg3326z00_933);
							}
						else
							{	/* Coerce/funcall.scm 121 */
								{	/* Coerce/funcall.scm 126 */
									BgL_nodez00_bglt BgL_arg3331z00_938;

									{	/* Coerce/funcall.scm 126 */
										obj_t BgL_arg3332z00_939;

										BgL_arg3332z00_939 = CAR(BgL_actualsz00_929);
										BgL_arg3331z00_938 =
											BGl_coercez12z12zzcoerce_coercez00(
											(BgL_nodez00_bglt) (BgL_arg3332z00_939), BgL_callerz00_25,
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
											CBOOL(BgL_safez00_27));
									}
									{	/* Coerce/funcall.scm 126 */
										obj_t BgL_auxz00_1596;

										BgL_auxz00_1596 = (obj_t) (BgL_arg3331z00_938);
										SET_CAR(BgL_actualsz00_929, BgL_auxz00_1596);
									}
								}
								{
									obj_t BgL_prevz00_1601;

									obj_t BgL_actualsz00_1599;

									BgL_actualsz00_1599 = CDR(BgL_actualsz00_929);
									BgL_prevz00_1601 = BgL_actualsz00_929;
									BgL_prevz00_930 = BgL_prevz00_1601;
									BgL_actualsz00_929 = BgL_actualsz00_1599;
									goto BgL_zc3anonymousza33324ze3z83_931;
								}
							}
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_funcallz00zzast_nodez00,
				BGl_proc3445z00zzcoerce_funcallz00);
		}
	}



/* coerce!-funcall3241 */
	obj_t BGl_coercez12zd2funcall3241zc0zzcoerce_funcallz00(obj_t BgL_envz00_1442,
		obj_t BgL_nodez00_1443, obj_t BgL_callerz00_1444, obj_t BgL_toz00_1445,
		obj_t BgL_safez00_1446)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 36 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1315;

				obj_t BgL_callerz00_1316;

				obj_t BgL_toz00_1317;

				obj_t BgL_safez00_1318;

				BgL_nodez00_1315 = (BgL_funcallz00_bglt) (BgL_nodez00_1443);
				BgL_callerz00_1316 = BgL_callerz00_1444;
				BgL_toz00_1317 = BgL_toz00_1445;
				BgL_safez00_1318 = BgL_safez00_1446;
				{	/* Coerce/funcall.scm 38 */
					obj_t BgL_errorzd2msgzd2_1321;

					obj_t BgL_strengthz00_1322;

					{	/* Coerce/funcall.scm 38 */
						obj_t BgL_arg3428z00_1374;

						obj_t BgL_arg3429z00_1375;

						BgL_arg3428z00_1374 = CNST_TABLE_REF(((long) 7));
						BgL_arg3429z00_1375 =
							BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1315));
						{	/* Coerce/funcall.scm 38 */
							obj_t BgL_list3430z00_1376;

							{	/* Coerce/funcall.scm 38 */
								obj_t BgL_arg3431z00_1377;

								BgL_arg3431z00_1377 = MAKE_PAIR(BgL_arg3429z00_1375, BNIL);
								BgL_list3430z00_1376 =
									MAKE_PAIR(BgL_arg3428z00_1374, BgL_arg3431z00_1377);
							}
							BgL_errorzd2msgzd2_1321 = BgL_list3430z00_1376;
					}}
					BgL_strengthz00_1322 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->BgL_strengthz00);
					BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_nodez00_1315,
						BgL_callerz00_1316, BgL_toz00_1317, BgL_safez00_1318);
					if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
							(BgL_strengthz00_1322, CNST_TABLE_REF(((long) 11)))))
						{	/* Coerce/funcall.scm 42 */
							return
								(obj_t) (BGl_convertz12z12zzcoerce_convertz00(
									(BgL_nodez00_bglt) (BgL_nodez00_1315),
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
									(BgL_typez00_bglt) (BgL_toz00_1317),
									CBOOL(BgL_safez00_1318)));
						}
					else
						{	/* Coerce/funcall.scm 45 */
							BgL_nodez00_bglt BgL_czd2funzd2_1324;

							{	/* Coerce/funcall.scm 45 */
								BgL_nodez00_bglt BgL_arg3427z00_1373;

								BgL_arg3427z00_1373 =
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->BgL_funz00);
								BgL_czd2funzd2_1324 =
									BGl_coercez12z12zzcoerce_coercez00(BgL_arg3427z00_1373,
									BgL_callerz00_1316,
									(BgL_typez00_bglt) (BGl_za2procedureza2z00zztype_cachez00),
									CBOOL(BgL_safez00_1318));
							}
							if (CBOOL(BGl_za2unsafezd2arityza2zd2zzengine_paramz00))
								{	/* Coerce/funcall.scm 47 */
									((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->
											BgL_funz00) =
										((BgL_nodez00_bglt) BgL_czd2funzd2_1324), BUNSPEC);
									return (obj_t) (BGl_convertz12z12zzcoerce_convertz00(
											(BgL_nodez00_bglt) (BgL_nodez00_1315),
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
											(BgL_typez00_bglt) (BgL_toz00_1317),
											CBOOL(BgL_safez00_1318)));
								}
							else
								{	/* Coerce/funcall.scm 51 */
									BgL_localz00_bglt BgL_funz00_1325;

									BgL_funz00_1325 =
										BGl_makezd2localzd2svarz00zzast_localz00(CNST_TABLE_REF((
												(long) 12)),
										(BgL_typez00_bglt) (BGl_za2procedureza2z00zztype_cachez00));
									{	/* Coerce/funcall.scm 51 */
										obj_t BgL_locz00_1326;

										{
											BgL_nodez00_bglt BgL_auxz00_1636;

											BgL_auxz00_1636 = (BgL_nodez00_bglt) (BgL_nodez00_1315);
											BgL_locz00_1326 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_1636))->
												BgL_locz00);
										}
										{	/* Coerce/funcall.scm 52 */
											BgL_atomz00_bglt BgL_lenz00_1327;

											{	/* Coerce/funcall.scm 56 */
												long BgL_arg3423z00_1369;

												BgL_arg3423z00_1369 =
													(bgl_list_length(
														(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1315))->
															BgL_argsz00)) - ((long) 2));
												BgL_lenz00_1327 =
													BGl_makezd2atomzd2zzast_nodez00(BgL_locz00_1326,
													(BgL_typez00_bglt) (BGl_za2intza2z00zztype_cachez00),
													BINT(BgL_arg3423z00_1369));
											}
											{	/* Coerce/funcall.scm 53 */
												obj_t BgL_azd2lenzd2_1328;

												BgL_azd2lenzd2_1328 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 13))));
												{	/* Coerce/funcall.scm 58 */
													obj_t BgL_azd2tlenzd2_1329;

													{	/* Coerce/funcall.scm 60 */
														obj_t BgL_arg3416z00_1362;

														{	/* Coerce/funcall.scm 60 */
															obj_t BgL_arg3417z00_1363;

															{	/* Coerce/funcall.scm 60 */
																obj_t BgL_arg3418z00_1364;

																obj_t BgL_arg3419z00_1365;

																BgL_arg3418z00_1364 =
																	SYMBOL_TO_STRING(BgL_azd2lenzd2_1328);
																{	/* Coerce/funcall.scm 60 */
																	obj_t BgL_symbolz00_1435;

																	BgL_symbolz00_1435 =
																		CNST_TABLE_REF(((long) 14));
																	BgL_arg3419z00_1365 =
																		SYMBOL_TO_STRING(BgL_symbolz00_1435);
																}
																{	/* Coerce/funcall.scm 60 */
																	obj_t BgL_list3420z00_1366;

																	{	/* Coerce/funcall.scm 60 */
																		obj_t BgL_arg3421z00_1367;

																		BgL_arg3421z00_1367 =
																			MAKE_PAIR(BgL_arg3419z00_1365, BNIL);
																		BgL_list3420z00_1366 =
																			MAKE_PAIR(BgL_arg3418z00_1364,
																			BgL_arg3421z00_1367);
																	}
																	BgL_arg3417z00_1363 =
																		BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																		(BgL_list3420z00_1366);
															}}
															BgL_arg3416z00_1362 =
																string_to_symbol(BSTRING_TO_STRING
																(BgL_arg3417z00_1363));
														}
														BgL_azd2tlenzd2_1329 =
															BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
															(BgL_arg3416z00_1362);
													}
													{	/* Coerce/funcall.scm 59 */
														BgL_letzd2varzd2_bglt BgL_lnodez00_1330;

														{	/* Coerce/funcall.scm 61 */
															obj_t BgL_arg3387z00_1333;

															BgL_nodez00_bglt BgL_arg3388z00_1334;

															{	/* Coerce/funcall.scm 64 */
																obj_t BgL_arg3389z00_1335;

																BgL_arg3389z00_1335 =
																	MAKE_PAIR(
																	(obj_t) (BgL_funz00_1325),
																	(obj_t) (BgL_czd2funzd2_1324));
																{	/* Coerce/funcall.scm 64 */
																	obj_t BgL_list3390z00_1336;

																	BgL_list3390z00_1336 =
																		MAKE_PAIR(BgL_arg3389z00_1335, BNIL);
																	BgL_arg3387z00_1333 = BgL_list3390z00_1336;
															}}
															{	/* Coerce/funcall.scm 66 */
																obj_t BgL_arg3391z00_1337;

																{	/* Coerce/funcall.scm 66 */
																	obj_t BgL_arg3392z00_1338;

																	obj_t BgL_arg3393z00_1339;

																	BgL_arg3392z00_1338 =
																		CNST_TABLE_REF(((long) 15));
																	{	/* Coerce/funcall.scm 66 */
																		obj_t BgL_arg3394z00_1340;

																		obj_t BgL_arg3395z00_1341;

																		{	/* Coerce/funcall.scm 66 */
																			obj_t BgL_arg3399z00_1345;

																			{	/* Coerce/funcall.scm 66 */
																				obj_t BgL_arg3401z00_1347;

																				{	/* Coerce/funcall.scm 66 */
																					obj_t BgL_list3402z00_1348;

																					BgL_list3402z00_1348 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3401z00_1347 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						((obj_t) (BgL_lenz00_1327),
																						BgL_list3402z00_1348);
																				}
																				BgL_arg3399z00_1345 =
																					MAKE_PAIR(BgL_azd2tlenzd2_1329,
																					BgL_arg3401z00_1347);
																			}
																			BgL_arg3394z00_1340 =
																				MAKE_PAIR(BgL_arg3399z00_1345, BNIL);
																		}
																		{	/* Coerce/funcall.scm 67 */
																			obj_t BgL_arg3403z00_1349;

																			obj_t BgL_arg3404z00_1350;

																			BgL_arg3403z00_1349 =
																				CNST_TABLE_REF(((long) 16));
																			{	/* Coerce/funcall.scm 67 */
																				obj_t BgL_arg3405z00_1351;

																				BgL_nodez00_bglt BgL_arg3406z00_1352;

																				BgL_nodez00_bglt BgL_arg3407z00_1353;

																				{	/* Coerce/funcall.scm 67 */
																					obj_t BgL_arg3412z00_1358;

																					obj_t BgL_arg3413z00_1359;

																					BgL_arg3412z00_1358 =
																						CNST_TABLE_REF(((long) 17));
																					{	/* Coerce/funcall.scm 67 */
																						obj_t BgL_list3414z00_1360;

																						{	/* Coerce/funcall.scm 67 */
																							obj_t BgL_arg3415z00_1361;

																							BgL_arg3415z00_1361 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3414z00_1360 =
																								MAKE_PAIR(BgL_azd2lenzd2_1328,
																								BgL_arg3415z00_1361);
																						}
																						BgL_arg3413z00_1359 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							((obj_t) (BgL_funz00_1325),
																							BgL_list3414z00_1360);
																					}
																					BgL_arg3405z00_1351 =
																						MAKE_PAIR(BgL_arg3412z00_1358,
																						BgL_arg3413z00_1359);
																				}
																				BgL_arg3406z00_1352 =
																					BGl_convertz12z12zzcoerce_convertz00(
																					(BgL_nodez00_bglt) (BgL_nodez00_1315),
																					(BgL_typez00_bglt)
																					(BGl_za2objza2z00zztype_cachez00),
																					(BgL_typez00_bglt) (BgL_toz00_1317),
																					CBOOL(BgL_safez00_1318));
																				BgL_arg3407z00_1353 =
																					BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00
																					(BgL_funz00_1325,
																					BgL_errorzd2msgzd2_1321,
																					BgL_locz00_1326, BgL_callerz00_1316,
																					BgL_toz00_1317);
																				{	/* Coerce/funcall.scm 67 */
																					obj_t BgL_list3409z00_1355;

																					{	/* Coerce/funcall.scm 67 */
																						obj_t BgL_arg3410z00_1356;

																						{	/* Coerce/funcall.scm 67 */
																							obj_t BgL_arg3411z00_1357;

																							BgL_arg3411z00_1357 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg3410z00_1356 =
																								MAKE_PAIR(
																								(obj_t) (BgL_arg3407z00_1353),
																								BgL_arg3411z00_1357);
																						}
																						BgL_list3409z00_1355 =
																							MAKE_PAIR(
																							(obj_t) (BgL_arg3406z00_1352),
																							BgL_arg3410z00_1356);
																					}
																					BgL_arg3404z00_1350 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3405z00_1351,
																						BgL_list3409z00_1355);
																			}}
																			BgL_arg3395z00_1341 =
																				MAKE_PAIR(BgL_arg3403z00_1349,
																				BgL_arg3404z00_1350);
																		}
																		{	/* Coerce/funcall.scm 66 */
																			obj_t BgL_list3397z00_1343;

																			{	/* Coerce/funcall.scm 66 */
																				obj_t BgL_arg3398z00_1344;

																				BgL_arg3398z00_1344 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3397z00_1343 =
																					MAKE_PAIR(BgL_arg3395z00_1341,
																					BgL_arg3398z00_1344);
																			}
																			BgL_arg3393z00_1339 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg3394z00_1340,
																				BgL_list3397z00_1343);
																	}}
																	BgL_arg3391z00_1337 =
																		MAKE_PAIR(BgL_arg3392z00_1338,
																		BgL_arg3393z00_1339);
																}
																BgL_arg3388z00_1334 =
																	BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_arg3391z00_1337, BgL_locz00_1326);
															}
															BgL_lnodez00_1330 =
																BGl_makezd2letzd2varz00zzast_nodez00
																(BgL_locz00_1326,
																(BgL_typez00_bglt)
																(BGl_za2objza2z00zztype_cachez00), BUNSPEC,
																BINT(((long) -1)), BgL_arg3387z00_1333,
																BgL_arg3388z00_1334, ((bool_t) 1));
														}
														{	/* Coerce/funcall.scm 61 */

															{	/* Coerce/funcall.scm 76 */
																BgL_varz00_bglt BgL_arg3385z00_1331;

																BgL_arg3385z00_1331 =
																	BGl_makezd2varzd2zzast_nodez00
																	(BgL_locz00_1326,
																	(BgL_typez00_bglt)
																	(BGl_za2objza2z00zztype_cachez00),
																	(BgL_variablez00_bglt) (BgL_funz00_1325));
																{
																	BgL_nodez00_bglt BgL_auxz00_1698;

																	BgL_auxz00_1698 =
																		(BgL_nodez00_bglt) (BgL_arg3385z00_1331);
																	((((BgL_funcallz00_bglt)
																				CREF(BgL_nodez00_1315))->BgL_funz00) =
																		((BgL_nodez00_bglt) BgL_auxz00_1698),
																		BUNSPEC);
															}}
															return (obj_t) (BgL_lnodez00_1330);
														}
													}
												}
											}
										}
									}
								}
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 80496154),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 499216671),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
			return
				BGl_modulezd2initializa7ationz75zzcoerce_convertz00(((long) 65499856),
				BSTRING_TO_STRING(BGl_string3446z00zzcoerce_funcallz00));
		}
	}

#ifdef __cplusplus
}
#endif
