/*===========================================================================*/
/*   (Engine/heap.scm)                                                       */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Engine/heap.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;


	static obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzengine_heapz00 = BUNSPEC;
	static obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzengine_heapz00();
	BGL_EXPORTED_DECL obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t);
	extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
	static obj_t BGl_cnstzd2initzd2zzengine_heapz00();
	extern obj_t BGl_setzd2backendz12zc0zzbackend_backendz00(obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza32420ze3z83zzengine_heapz00(obj_t, obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_zc3anonymousza32444ze3z83zzengine_heapz00(obj_t, obj_t);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32464ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_zc3anonymousza32616ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32472ze3z83zzengine_heapz00(obj_t);
	static obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	static obj_t BGl_zc3anonymousza32503ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	static obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzengine_heapz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2688z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322707z00,
		BGl_zc3anonymousza32444ze3z83zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2689z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322708z00,
		BGl_zc3anonymousza32464ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2702z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322709z00,
		BGl_zc3anonymousza32616ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2698z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322710z00,
		BGl_zc3anonymousza32503ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2686z00zzengine_heapz00,
		BgL_bgl_string2686za700za7za7e2711za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string2687z00zzengine_heapz00,
		BgL_bgl_string2687za700za7za7e2712za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string2700z00zzengine_heapz00,
		BgL_bgl_string2700za700za7za7e2713za7, "\n    ", 5);
	      DEFINE_STRING(BGl_string2690z00zzengine_heapz00,
		BgL_bgl_string2690za700za7za7e2714za7, "(heap \"", 7);
	      DEFINE_STRING(BGl_string2701z00zzengine_heapz00,
		BgL_bgl_string2701za700za7za7e2715za7, "", 0);
	      DEFINE_STRING(BGl_string2691z00zzengine_heapz00,
		BgL_bgl_string2691za700za7za7e2716za7, "\"", 1);
	      DEFINE_STRING(BGl_string2692z00zzengine_heapz00,
		BgL_bgl_string2692za700za7za7e2717za7, " (variables", 11);
	      DEFINE_STRING(BGl_string2703z00zzengine_heapz00,
		BgL_bgl_string2703za700za7za7e2718za7, "engine_heap", 11);
	      DEFINE_STRING(BGl_string2693z00zzengine_heapz00,
		BgL_bgl_string2693za700za7za7e2719za7, " )\n", 3);
	      DEFINE_STRING(BGl_string2704z00zzengine_heapz00,
		BgL_bgl_string2704za700za7za7e2720za7,
		"type super class jvm-type-name inline sifun qualified-type name module id variable native function dump-heap ",
		109);
	      DEFINE_STRING(BGl_string2694z00zzengine_heapz00,
		BgL_bgl_string2694za700za7za7e2721za7, " (types", 7);
	      DEFINE_STRING(BGl_string2695z00zzengine_heapz00,
		BgL_bgl_string2695za700za7za7e2722za7, " )", 2);
	      DEFINE_STRING(BGl_string2696z00zzengine_heapz00,
		BgL_bgl_string2696za700za7za7e2723za7, " (includes", 10);
	      DEFINE_STRING(BGl_string2697z00zzengine_heapz00,
		BgL_bgl_string2697za700za7za7e2724za7, ")\n", 2);
	      DEFINE_STRING(BGl_string2699z00zzengine_heapz00,
		BgL_bgl_string2699za700za7za7e2725za7, "   ", 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_dumpzd2heapszd2envz00zzengine_heapz00,
		BgL_bgl__dumpza7d2heapsza7d22726z00, BGl__dumpzd2heapszd2zzengine_heapz00,
		0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long
		BgL_checksumz00_1032, char *BgL_fromz00_1033)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzengine_heapz00))
				{
					BGl_requirezd2initializa7ationz75zzengine_heapz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
					BGl_cnstzd2initzd2zzengine_heapz00();
					BGl_importedzd2moduleszd2initz00zzengine_heapz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"engine_heap");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			{	/* Engine/heap.scm 15 */
				obj_t BgL_cportz00_1024;

				BgL_cportz00_1024 =
					bgl_open_input_string(BGl_string2704z00zzengine_heapz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1025;

					BgL_iz00_1025 = ((long) 13);
				BgL_loopz00_1026:
					if ((BgL_iz00_1025 == ((long) -1)))
						{	/* Engine/heap.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Engine/heap.scm 15 */
							{	/* Engine/heap.scm 15 */
								obj_t BgL_arg2706z00_1028;

								{	/* Engine/heap.scm 15 */

									{	/* Engine/heap.scm 15 */
										obj_t BgL_locationz00_1030;

										BgL_locationz00_1030 = BBOOL(((bool_t) 0));
										{	/* Engine/heap.scm 15 */

											BgL_arg2706z00_1028 =
												BGl_readz00zz__readerz00(BgL_cportz00_1024,
												BgL_locationz00_1030);
										}
									}
								}
								{	/* Engine/heap.scm 15 */
									int BgL_auxz00_1056;

									BgL_auxz00_1056 = (int) (BgL_iz00_1025);
									CNST_TABLE_SET(BgL_auxz00_1056, BgL_arg2706z00_1028);
							}}
							{	/* Engine/heap.scm 15 */
								int BgL_auxz00_1031;

								BgL_auxz00_1031 = (int) ((BgL_iz00_1025 - ((long) 1)));
								{
									long BgL_iz00_1061;

									BgL_iz00_1061 = (long) (BgL_auxz00_1031);
									BgL_iz00_1025 = BgL_iz00_1061;
									goto BgL_loopz00_1026;
								}
							}
						}
				}
			}
		}
	}



/* dump-heaps */
	BGL_EXPORTED_DEF obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t
		BgL_namesz00_1)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			BGl_setzd2backendz12zc0zzbackend_backendz00
				(BGl_za2targetzd2languageza2zd2zzengine_paramz00);
			BGl_initializa7ezd2Genvz12z67zzast_envz00();
			BGl_initializa7ezd2Tenvz12z67zztype_envz00();
			{
				obj_t BgL_l2367z00_488;

				{	/* Engine/heap.scm 40 */
					bool_t BgL_auxz00_1066;

					BgL_l2367z00_488 = BgL_namesz00_1;
				BgL_zc3anonymousza32394ze3z83_489:
					if (PAIRP(BgL_l2367z00_488))
						{	/* Engine/heap.scm 40 */
							BGl_dumpzd2heapzd2zzengine_heapz00(CAR(BgL_l2367z00_488));
							{
								obj_t BgL_l2367z00_1071;

								BgL_l2367z00_1071 = CDR(BgL_l2367z00_488);
								BgL_l2367z00_488 = BgL_l2367z00_1071;
								goto BgL_zc3anonymousza32394ze3z83_489;
							}
						}
					else
						{	/* Engine/heap.scm 40 */
							BgL_auxz00_1066 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1066);
				}
			}
		}
	}



/* _dump-heaps */
	obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t BgL_envz00_998,
		obj_t BgL_namesz00_999)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			return BGl_dumpzd2heapszd2zzengine_heapz00(BgL_namesz00_999);
		}
	}



/* dump-heap */
	obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t BgL_heapz00_2)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 45 */
			{	/* Engine/heap.scm 46 */
				obj_t BgL_fnamez00_494;

				BgL_fnamez00_494 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_2,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_494))
					{	/* Engine/heap.scm 48 */
						obj_t BgL_portz00_496;

						BgL_portz00_496 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_494);
						if (BINARY_PORTP(BgL_portz00_496))
							{	/* Engine/heap.scm 53 */
								obj_t BgL_val2361z00_498;

								BgL_val2361z00_498 =
									BGl_zc3exitza32420ze3z83zzengine_heapz00(BgL_heapz00_2,
									BgL_portz00_496);
								close_binary_port(BgL_portz00_496);
								if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
										(BgL_val2361z00_498)))
									{	/* Engine/heap.scm 113 */
										return
											BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
											(BgL_val2361z00_498), CDR(BgL_val2361z00_498));
									}
								else
									{	/* Engine/heap.scm 113 */
										return BgL_val2361z00_498;
									}
							}
						else
							{	/* Engine/heap.scm 50 */
								obj_t BgL_arg2497z00_567;

								obj_t BgL_arg2498z00_568;

								BgL_arg2497z00_567 = CNST_TABLE_REF(((long) 0));
								{	/* Engine/heap.scm 51 */
									obj_t BgL_list2499z00_569;

									BgL_list2499z00_569 = MAKE_PAIR(BgL_fnamez00_494, BNIL);
									BgL_arg2498z00_568 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2686z00zzengine_heapz00, BgL_list2499z00_569);
								}
								return
									BGl_errorz00zz__errorz00(BgL_arg2497z00_567,
									BgL_arg2498z00_568, BGl_za2libzd2dirza2zd2zzengine_paramz00);
							}
					}
				else
					{	/* Engine/heap.scm 114 */
						obj_t BgL_mz00_570;

						{	/* Engine/heap.scm 114 */
							obj_t BgL_list2500z00_571;

							BgL_list2500z00_571 = MAKE_PAIR(BgL_heapz00_2, BNIL);
							BgL_mz00_570 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2686z00zzengine_heapz00, BgL_list2500z00_571);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)), BgL_mz00_570,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BFALSE;
					}
			}
		}
	}



/* <exit:2420> */
	obj_t BGl_zc3exitza32420ze3z83zzengine_heapz00(obj_t BgL_heapz00_1022,
		obj_t BgL_portz00_1021)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 113 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2362z00_503;

			if (SET_EXIT(BgL_an_exit2362z00_503))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
					BgL_an_exit2362z00_503 = (void *) jmpbuf;
					{	/* Engine/heap.scm 113 */

						PUSH_EXIT(BgL_an_exit2362z00_503, ((long) 0));
						{	/* Engine/heap.scm 54 */
							obj_t BgL_val2363z00_504;

							{	/* Engine/heap.scm 54 */
								obj_t BgL_envsz00_505;

								BgL_envsz00_505 = input_obj(BgL_portz00_1021);
								{	/* Engine/heap.scm 54 */
									obj_t BgL__z00_506;

									{	/* Engine/heap.scm 55 */
										bool_t BgL_testz00_1101;

										{	/* Engine/heap.scm 55 */
											bool_t BgL_testz00_1102;

											{	/* Engine/heap.scm 55 */
												obj_t BgL_v2369z00_566;

												BgL_v2369z00_566 = create_vector((int) (((long) 1)));
												VECTOR_SET(BgL_v2369z00_566,
													(int) (((long) 0)), BgL_envsz00_505);
												BgL_testz00_1102 = ((bool_t) 1);
											}
											if (BgL_testz00_1102)
												{	/* Engine/heap.scm 56 */
													bool_t BgL__ortest_2364z00_561;

													{	/* Engine/heap.scm 56 */
														int BgL_arg2495z00_564;

														BgL_arg2495z00_564 = VECTOR_LENGTH(BgL_envsz00_505);
														BgL__ortest_2364z00_561 =
															((long) (BgL_arg2495z00_564) == ((long) 5));
													}
													if (BgL__ortest_2364z00_561)
														{	/* Engine/heap.scm 56 */
															BgL_testz00_1101 = BgL__ortest_2364z00_561;
														}
													else
														{	/* Engine/heap.scm 57 */
															int BgL_arg2482z00_562;

															BgL_arg2482z00_562 =
																VECTOR_LENGTH(BgL_envsz00_505);
															BgL_testz00_1101 =
																((long) (BgL_arg2482z00_562) == ((long) 6));
												}}
											else
												{	/* Engine/heap.scm 55 */
													BgL_testz00_1101 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_1101)
											{	/* Engine/heap.scm 55 */
												BgL__z00_506 = BFALSE;
											}
										else
											{	/* Engine/heap.scm 55 */
												BgL__z00_506 =
													BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
													BGl_string2687z00zzengine_heapz00, BgL_heapz00_1022);
									}}
									{	/* Engine/heap.scm 55 */
										obj_t BgL_targetz00_507;

										BgL_targetz00_507 =
											VECTOR_REF(BgL_envsz00_505, (int) (((long) 0)));
										{	/* Engine/heap.scm 59 */
											obj_t BgL_versionz00_508;

											BgL_versionz00_508 =
												VECTOR_REF(BgL_envsz00_505, (int) (((long) 1)));
											{	/* Engine/heap.scm 60 */
												obj_t BgL_specificz00_509;

												BgL_specificz00_509 =
													VECTOR_REF(BgL_envsz00_505, (int) (((long) 2)));
												{	/* Engine/heap.scm 61 */
													obj_t BgL_genvz00_510;

													BgL_genvz00_510 =
														VECTOR_REF(BgL_envsz00_505, (int) (((long) 3)));
													{	/* Engine/heap.scm 62 */
														obj_t BgL_tenvz00_511;

														BgL_tenvz00_511 =
															VECTOR_REF(BgL_envsz00_505, (int) (((long) 4)));
														{	/* Engine/heap.scm 63 */
															obj_t BgL_includesz00_512;

															{	/* Engine/heap.scm 64 */
																bool_t BgL_testz00_1126;

																{	/* Engine/heap.scm 64 */
																	int BgL_arg2478z00_557;

																	BgL_arg2478z00_557 =
																		VECTOR_LENGTH(BgL_envsz00_505);
																	BgL_testz00_1126 =
																		((long) (BgL_arg2478z00_557) == ((long) 6));
																}
																if (BgL_testz00_1126)
																	{	/* Engine/heap.scm 64 */
																		BgL_includesz00_512 =
																			VECTOR_REF(BgL_envsz00_505,
																			(int) (((long) 5)));
																	}
																else
																	{	/* Engine/heap.scm 64 */
																		BgL_includesz00_512 = BNIL;
																	}
															}
															{	/* Engine/heap.scm 64 */

																{	/* Engine/heap.scm 76 */
																	bool_t BgL_testz00_1132;

																	{	/* Engine/heap.scm 76 */
																		int BgL_arg2431z00_514;

																		BgL_arg2431z00_514 =
																			VECTOR_LENGTH(BgL_envsz00_505);
																		BgL_testz00_1132 =
																			(
																			(long) (BgL_arg2431z00_514) ==
																			((long) 6));
																	}
																	if (BgL_testz00_1132)
																		{	/* Engine/heap.scm 76 */
																			BGl_addzd2genvz12zc0zzast_envz00
																				(BgL_genvz00_510);
																		}
																	else
																		{	/* Engine/heap.scm 76 */
																			BGl_setzd2tenvz12zc0zztype_envz00
																				(BgL_tenvz00_511);
																			BGl_setzd2genvz12zc0zzast_envz00
																				(BgL_genvz00_510);
																		}
																}
																{	/* Engine/heap.scm 85 */
																	bool_t BgL_testz00_1139;

																	{	/* Engine/heap.scm 85 */
																		obj_t BgL_arg2462z00_526;

																		BgL_arg2462z00_526 =
																			BGl_thezd2backendzd2zzbackend_backendz00
																			();
																		{
																			BgL_backendz00_bglt BgL_auxz00_1141;

																			BgL_auxz00_1141 =
																				(BgL_backendz00_bglt)
																				(BgL_arg2462z00_526);
																			BgL_testz00_1139 =
																				(((BgL_backendz00_bglt)
																					CREF(BgL_auxz00_1141))->
																				BgL_qualifiedzd2typeszd2);
																		}
																	}
																	if (BgL_testz00_1139)
																		{	/* Engine/heap.scm 85 */
																			BGl_forzd2eachzd2globalz12z12zzast_envz00
																				(BGl_proc2688z00zzengine_heapz00, BNIL);
																		}
																	else
																		{	/* Engine/heap.scm 85 */
																			BFALSE;
																		}
																}
																BGl_hashtablezd2forzd2eachz00zz__hashz00
																	(BgL_genvz00_510,
																	BGl_proc2689z00zzengine_heapz00);
																{	/* Engine/heap.scm 99 */
																	obj_t BgL_arg2470z00_542;

																	{	/* Engine/heap.scm 99 */
																		obj_t BgL_res2673z00_900;

																		{	/* Engine/heap.scm 99 */
																			obj_t BgL_auxz00_1146;

																			BgL_auxz00_1146 =
																				BGL_CURRENT_DYNAMIC_ENV();
																			BgL_res2673z00_900 =
																				BGL_ENV_CURRENT_ERROR_PORT
																				(BgL_auxz00_1146);
																		}
																		BgL_arg2470z00_542 = BgL_res2673z00_900;
																	}
																	{	/* Engine/heap.scm 101 */
																		obj_t BgL_zc3anonymousza32472ze3z83_1000;

																		BgL_zc3anonymousza32472ze3z83_1000 =
																			make_fx_procedure
																			(BGl_zc3anonymousza32472ze3z83zzengine_heapz00,
																			(int) (((long) 0)), (int) (((long) 4)));
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32472ze3z83_1000,
																			(int) (((long) 0)), BgL_heapz00_1022);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32472ze3z83_1000,
																			(int) (((long) 1)), BgL_genvz00_510);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32472ze3z83_1000,
																			(int) (((long) 2)), BgL_tenvz00_511);
																		PROCEDURE_SET
																			(BgL_zc3anonymousza32472ze3z83_1000,
																			(int) (((long) 3)), BgL_includesz00_512);
																		BgL_val2363z00_504 =
																			BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00
																			(BgL_arg2470z00_542,
																			BgL_zc3anonymousza32472ze3z83_1000);
							}}}}}}}}}}}
							POP_EXIT();
							return BgL_val2363z00_504;
						}
					}
				}
		}
	}



/* <anonymous:2472> */
	obj_t BGl_zc3anonymousza32472ze3z83zzengine_heapz00(obj_t BgL_envz00_1003)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 100 */
			{	/* Engine/heap.scm 101 */
				obj_t BgL_heapz00_1004;

				obj_t BgL_genvz00_1005;

				obj_t BgL_tenvz00_1006;

				obj_t BgL_includesz00_1007;

				BgL_heapz00_1004 = PROCEDURE_REF(BgL_envz00_1003, (int) (((long) 0)));
				BgL_genvz00_1005 = PROCEDURE_REF(BgL_envz00_1003, (int) (((long) 1)));
				BgL_tenvz00_1006 = PROCEDURE_REF(BgL_envz00_1003, (int) (((long) 2)));
				BgL_includesz00_1007 =
					PROCEDURE_REF(BgL_envz00_1003, (int) (((long) 3)));
				{

					{	/* Engine/heap.scm 101 */
						obj_t BgL_port2373z00_545;

						{	/* Engine/heap.scm 101 */
							obj_t BgL_res2674z00_902;

							{	/* Engine/heap.scm 101 */
								obj_t BgL_auxz00_1170;

								BgL_auxz00_1170 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2674z00_902 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1170);
							}
							BgL_port2373z00_545 = BgL_res2674z00_902;
						}
						bgl_display_string(BGl_string2690z00zzengine_heapz00,
							BgL_port2373z00_545);
						bgl_display_obj(BgL_heapz00_1004, BgL_port2373z00_545);
						bgl_display_string(BGl_string2691z00zzengine_heapz00,
							BgL_port2373z00_545);
						bgl_display_char(((unsigned char) '\n'), BgL_port2373z00_545);
					}
					{	/* Engine/heap.scm 102 */
						obj_t BgL_port2374z00_546;

						{	/* Engine/heap.scm 102 */
							obj_t BgL_res2675z00_909;

							{	/* Engine/heap.scm 102 */
								obj_t BgL_auxz00_1177;

								BgL_auxz00_1177 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2675z00_909 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1177);
							}
							BgL_port2374z00_546 = BgL_res2675z00_909;
						}
						bgl_display_string(BGl_string2692z00zzengine_heapz00,
							BgL_port2374z00_546);
						bgl_display_char(((unsigned char) '\n'), BgL_port2374z00_546);
					}
					BGl_dumpzd2Genvzd2zzengine_heapz00(BgL_genvz00_1005);
					{	/* Engine/heap.scm 104 */
						obj_t BgL_port2375z00_547;

						{	/* Engine/heap.scm 104 */
							obj_t BgL_res2676z00_914;

							{	/* Engine/heap.scm 104 */
								obj_t BgL_auxz00_1183;

								BgL_auxz00_1183 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2676z00_914 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1183);
							}
							BgL_port2375z00_547 = BgL_res2676z00_914;
						}
						bgl_display_string(BGl_string2693z00zzengine_heapz00,
							BgL_port2375z00_547);
						bgl_display_char(((unsigned char) '\n'), BgL_port2375z00_547);
					}
					{	/* Engine/heap.scm 105 */
						obj_t BgL_port2376z00_548;

						{	/* Engine/heap.scm 105 */
							obj_t BgL_res2677z00_919;

							{	/* Engine/heap.scm 105 */
								obj_t BgL_auxz00_1188;

								BgL_auxz00_1188 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2677z00_919 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1188);
							}
							BgL_port2376z00_548 = BgL_res2677z00_919;
						}
						bgl_display_string(BGl_string2694z00zzengine_heapz00,
							BgL_port2376z00_548);
						bgl_display_char(((unsigned char) '\n'), BgL_port2376z00_548);
					}
					BGl_dumpzd2Tenvzd2zzengine_heapz00(BgL_tenvz00_1006);
					{	/* Engine/heap.scm 107 */
						obj_t BgL_port2377z00_549;

						{	/* Engine/heap.scm 107 */
							obj_t BgL_res2678z00_924;

							{	/* Engine/heap.scm 107 */
								obj_t BgL_auxz00_1194;

								BgL_auxz00_1194 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2678z00_924 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1194);
							}
							BgL_port2377z00_549 = BgL_res2678z00_924;
						}
						bgl_display_string(BGl_string2695z00zzengine_heapz00,
							BgL_port2377z00_549);
						bgl_display_char(((unsigned char) '\n'), BgL_port2377z00_549);
					}
					if (PAIRP(BgL_includesz00_1007))
						{	/* Engine/heap.scm 108 */
							{	/* Engine/heap.scm 109 */
								obj_t BgL_port2378z00_551;

								{	/* Engine/heap.scm 109 */
									obj_t BgL_res2679z00_930;

									{	/* Engine/heap.scm 109 */
										obj_t BgL_auxz00_1201;

										BgL_auxz00_1201 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2679z00_930 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1201);
									}
									BgL_port2378z00_551 = BgL_res2679z00_930;
								}
								bgl_display_string(BGl_string2696z00zzengine_heapz00,
									BgL_port2378z00_551);
								bgl_display_char(((unsigned char) '\n'), BgL_port2378z00_551);
							}
							{	/* Engine/heap.scm 110 */
								obj_t BgL_port2379z00_552;

								{	/* Engine/heap.scm 110 */
									obj_t BgL_res2680z00_935;

									{	/* Engine/heap.scm 110 */
										obj_t BgL_auxz00_1206;

										BgL_auxz00_1206 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2680z00_935 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1206);
									}
									BgL_port2379z00_552 = BgL_res2680z00_935;
								}
								bgl_display_obj(BgL_includesz00_1007, BgL_port2379z00_552);
								bgl_display_char(((unsigned char) '\n'), BgL_port2379z00_552);
							}
							{	/* Engine/heap.scm 111 */
								obj_t BgL_port2380z00_553;

								{	/* Engine/heap.scm 111 */
									obj_t BgL_res2681z00_938;

									{	/* Engine/heap.scm 111 */
										obj_t BgL_auxz00_1211;

										BgL_auxz00_1211 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2681z00_938 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1211);
									}
									BgL_port2380z00_553 = BgL_res2681z00_938;
								}
								bgl_display_string(BGl_string2695z00zzengine_heapz00,
									BgL_port2380z00_553);
								bgl_display_char(((unsigned char) '\n'), BgL_port2380z00_553);
						}}
					else
						{	/* Engine/heap.scm 108 */
							BFALSE;
						}
					{	/* Engine/heap.scm 112 */
						obj_t BgL_port2381z00_554;

						{	/* Engine/heap.scm 112 */
							obj_t BgL_res2682z00_943;

							{	/* Engine/heap.scm 112 */
								obj_t BgL_auxz00_1216;

								BgL_auxz00_1216 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2682z00_943 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1216);
							}
							BgL_port2381z00_554 = BgL_res2682z00_943;
						}
						bgl_display_string(BGl_string2697z00zzengine_heapz00,
							BgL_port2381z00_554);
						return bgl_display_char(((unsigned char) '\n'),
							BgL_port2381z00_554);
		}}}}
	}



/* <anonymous:2464> */
	obj_t BGl_zc3anonymousza32464ze3z83zzengine_heapz00(obj_t BgL_envz00_1008,
		obj_t BgL_kz00_1009, obj_t BgL_bucketz00_1010)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 95 */
			{
				obj_t BgL_kz00_528;

				obj_t BgL_bucketz00_529;

				{	/* Engine/heap.scm 96 */
					bool_t BgL_auxz00_1221;

					BgL_kz00_528 = BgL_kz00_1009;
					BgL_bucketz00_529 = BgL_bucketz00_1010;
					{	/* Engine/heap.scm 96 */
						obj_t BgL_g2372z00_531;

						BgL_g2372z00_531 = CDR(BgL_bucketz00_529);
						{
							obj_t BgL_l2370z00_533;

							BgL_l2370z00_533 = BgL_g2372z00_531;
						BgL_zc3anonymousza32465ze3z83_534:
							if (PAIRP(BgL_l2370z00_533))
								{	/* Engine/heap.scm 98 */
									{	/* Engine/heap.scm 97 */
										obj_t BgL_newz00_536;

										BgL_newz00_536 = CAR(BgL_l2370z00_533);
										{	/* Engine/heap.scm 97 */
											obj_t BgL_arg2467z00_537;

											{
												BgL_globalz00_bglt BgL_auxz00_1226;

												BgL_auxz00_1226 = (BgL_globalz00_bglt) (BgL_newz00_536);
												BgL_arg2467z00_537 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1226))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 97 */
												obj_t BgL_list2468z00_538;

												BgL_list2468z00_538 =
													MAKE_PAIR(BgL_arg2467z00_537, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list2468z00_538);
											}
										}
									}
									{
										obj_t BgL_l2370z00_1231;

										BgL_l2370z00_1231 = CDR(BgL_l2370z00_533);
										BgL_l2370z00_533 = BgL_l2370z00_1231;
										goto BgL_zc3anonymousza32465ze3z83_534;
									}
								}
							else
								{	/* Engine/heap.scm 98 */
									BgL_auxz00_1221 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1221);
				}
			}
		}
	}



/* <anonymous:2444> */
	obj_t BGl_zc3anonymousza32444ze3z83zzengine_heapz00(obj_t BgL_envz00_1011,
		obj_t BgL_newz00_1012)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 87 */
			{
				obj_t BgL_newz00_519;

				BgL_newz00_519 = BgL_newz00_1012;
				{	/* Engine/heap.scm 89 */
					obj_t BgL_arg2446z00_521;

					obj_t BgL_arg2452z00_522;

					obj_t BgL_arg2458z00_523;

					{
						BgL_globalz00_bglt BgL_auxz00_1234;

						BgL_auxz00_1234 = (BgL_globalz00_bglt) (BgL_newz00_519);
						BgL_arg2446z00_521 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1234))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1237;

						BgL_auxz00_1237 = (BgL_globalz00_bglt) (BgL_newz00_519);
						BgL_arg2452z00_522 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1237))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2458z00_523 = BGl_shapez00zztools_shapez00(BgL_newz00_519);
					{	/* Engine/heap.scm 88 */
						obj_t BgL_list2459z00_524;

						BgL_list2459z00_524 = MAKE_PAIR(BgL_arg2458z00_523, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2446z00_521,
							BgL_arg2452z00_522, BgL_list2459z00_524);
					}
				}
			}
		}
	}



/* dump-Genv */
	obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t BgL_genvz00_3)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 121 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_3,
				BGl_proc2698z00zzengine_heapz00);
		}
	}



/* <anonymous:2503> */
	obj_t BGl_zc3anonymousza32503ze3z83zzengine_heapz00(obj_t BgL_envz00_1014,
		obj_t BgL_kz00_1015, obj_t BgL_bucketz00_1016)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 152 */
			{
				obj_t BgL_kz00_574;

				obj_t BgL_bucketz00_575;

				{	/* Engine/heap.scm 152 */
					bool_t BgL_auxz00_1244;

					BgL_kz00_574 = BgL_kz00_1015;
					BgL_bucketz00_575 = BgL_bucketz00_1016;
					{
						obj_t BgL_newz00_586;

						{	/* Engine/heap.scm 152 */
							obj_t BgL_g2385z00_577;

							BgL_g2385z00_577 = CDR(BgL_bucketz00_575);
							{
								obj_t BgL_l2383z00_579;

								BgL_l2383z00_579 = BgL_g2385z00_577;
							BgL_zc3anonymousza32504ze3z83_580:
								if (PAIRP(BgL_l2383z00_579))
									{	/* Engine/heap.scm 152 */
										BgL_newz00_586 = CAR(BgL_l2383z00_579);
										{	/* Engine/heap.scm 123 */
											obj_t BgL_modulez00_588;

											{
												BgL_globalz00_bglt BgL_auxz00_1248;

												BgL_auxz00_1248 = (BgL_globalz00_bglt) (BgL_newz00_586);
												BgL_modulez00_588 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1248))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 123 */
												obj_t BgL_idz00_589;

												{
													BgL_variablez00_bglt BgL_auxz00_1251;

													BgL_auxz00_1251 =
														(BgL_variablez00_bglt) (BgL_newz00_586);
													BgL_idz00_589 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1251))->
														BgL_idz00);
												}
												{	/* Engine/heap.scm 124 */
													obj_t BgL_qtz00_590;

													BgL_qtz00_590 =
														BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
														(BgL_modulez00_588);
													{	/* Engine/heap.scm 125 */
														obj_t BgL_jtz00_591;

														{
															BgL_globalz00_bglt BgL_auxz00_1255;

															BgL_auxz00_1255 =
																(BgL_globalz00_bglt) (BgL_newz00_586);
															BgL_jtz00_591 =
																(((BgL_globalz00_bglt) CREF(BgL_auxz00_1255))->
																BgL_jvmzd2typezd2namez00);
														}
														{	/* Engine/heap.scm 126 */
															BgL_valuez00_bglt BgL_valz00_592;

															{
																BgL_variablez00_bglt BgL_auxz00_1258;

																BgL_auxz00_1258 =
																	(BgL_variablez00_bglt) (BgL_newz00_586);
																BgL_valz00_592 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_1258))->BgL_valuez00);
															}
															{	/* Engine/heap.scm 127 */
																obj_t BgL_kindz00_593;

																{	/* Engine/heap.scm 129 */
																	bool_t BgL_testz00_1261;

																	{	/* Engine/heap.scm 129 */
																		obj_t BgL_obj1853z00_958;

																		BgL_obj1853z00_958 =
																			(obj_t) (BgL_valz00_592);
																		BgL_testz00_1261 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1853z00_958,
																			BGl_sfunz00zzast_varz00);
																	}
																	if (BgL_testz00_1261)
																		{	/* Engine/heap.scm 129 */
																			BgL_kindz00_593 =
																				CNST_TABLE_REF(((long) 1));
																		}
																	else
																		{	/* Engine/heap.scm 130 */
																			bool_t BgL_testz00_1265;

																			{	/* Engine/heap.scm 130 */
																				obj_t BgL_obj1919z00_959;

																				BgL_obj1919z00_959 =
																					(obj_t) (BgL_valz00_592);
																				BgL_testz00_1265 =
																					BGl_iszd2azf3z21zz__objectz00
																					(BgL_obj1919z00_959,
																					BGl_cfunz00zzast_varz00);
																			}
																			if (BgL_testz00_1265)
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_593 =
																						CNST_TABLE_REF(((long) 2));
																				}
																			else
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_593 =
																						CNST_TABLE_REF(((long) 3));
																}}}
																{	/* Engine/heap.scm 128 */

																	{	/* Engine/heap.scm 132 */
																		obj_t BgL_port2382z00_594;

																		{	/* Engine/heap.scm 132 */
																			obj_t BgL_res2683z00_961;

																			{	/* Engine/heap.scm 132 */
																				obj_t BgL_auxz00_1270;

																				BgL_auxz00_1270 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res2683z00_961 =
																					BGL_ENV_CURRENT_OUTPUT_PORT
																					(BgL_auxz00_1270);
																			}
																			BgL_port2382z00_594 = BgL_res2683z00_961;
																		}
																		bgl_display_string
																			(BGl_string2699z00zzengine_heapz00,
																			BgL_port2382z00_594);
																		{	/* Engine/heap.scm 133 */
																			obj_t BgL_arg2523z00_595;

																			{	/* Engine/heap.scm 133 */
																				obj_t BgL_arg2529z00_596;

																				{	/* Engine/heap.scm 133 */
																					obj_t BgL_arg2536z00_597;

																					obj_t BgL_arg2538z00_599;

																					obj_t BgL_arg2555z00_601;

																					obj_t BgL_arg2558z00_603;

																					obj_t BgL_arg2560z00_605;

																					obj_t BgL_arg2561z00_606;

																					obj_t BgL_arg2562z00_607;

																					obj_t BgL_arg2564z00_609;

																					BgL_arg2536z00_597 =
																						BGl_shapez00zztools_shapez00
																						(BgL_newz00_586);
																					{	/* Engine/heap.scm 135 */
																						obj_t BgL_arg2581z00_624;

																						obj_t BgL_arg2582z00_625;

																						BgL_arg2581z00_624 =
																							CNST_TABLE_REF(((long) 4));
																						{	/* Engine/heap.scm 135 */
																							obj_t BgL_list2583z00_626;

																							BgL_list2583z00_626 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2582z00_625 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_idz00_589,
																								BgL_list2583z00_626);
																						}
																						BgL_arg2538z00_599 =
																							MAKE_PAIR(BgL_arg2581z00_624,
																							BgL_arg2582z00_625);
																					}
																					{	/* Engine/heap.scm 137 */
																						obj_t BgL_arg2584z00_627;

																						obj_t BgL_arg2585z00_628;

																						BgL_arg2584z00_627 =
																							CNST_TABLE_REF(((long) 5));
																						{	/* Engine/heap.scm 137 */
																							obj_t BgL_list2586z00_629;

																							BgL_list2586z00_629 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2585z00_628 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_modulez00_588,
																								BgL_list2586z00_629);
																						}
																						BgL_arg2555z00_601 =
																							MAKE_PAIR(BgL_arg2584z00_627,
																							BgL_arg2585z00_628);
																					}
																					{	/* Engine/heap.scm 139 */
																						obj_t BgL_arg2587z00_630;

																						obj_t BgL_arg2588z00_631;

																						BgL_arg2587z00_630 =
																							CNST_TABLE_REF(((long) 6));
																						{	/* Engine/heap.scm 139 */
																							obj_t BgL_arg2589z00_632;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_1284;
																								BgL_auxz00_1284 =
																									(BgL_variablez00_bglt)
																									(BgL_newz00_586);
																								BgL_arg2589z00_632 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_1284))->
																									BgL_namez00);
																							}
																							{	/* Engine/heap.scm 139 */
																								obj_t BgL_list2591z00_634;

																								BgL_list2591z00_634 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2588z00_631 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2589z00_632,
																									BgL_list2591z00_634);
																						}}
																						BgL_arg2558z00_603 =
																							MAKE_PAIR(BgL_arg2587z00_630,
																							BgL_arg2588z00_631);
																					}
																					{	/* Engine/heap.scm 141 */
																						obj_t BgL_arg2592z00_635;

																						obj_t BgL_arg2593z00_636;

																						BgL_arg2592z00_635 =
																							CNST_TABLE_REF(((long) 7));
																						{	/* Engine/heap.scm 141 */
																							obj_t BgL_list2594z00_637;

																							BgL_list2594z00_637 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2593z00_636 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_qtz00_590,
																								BgL_list2594z00_637);
																						}
																						BgL_arg2560z00_605 =
																							MAKE_PAIR(BgL_arg2592z00_635,
																							BgL_arg2593z00_636);
																					}
																					{	/* Engine/heap.scm 142 */
																						bool_t BgL_testz00_1294;

																						{	/* Engine/heap.scm 142 */
																							bool_t BgL_testz00_1295;

																							{	/* Engine/heap.scm 142 */
																								obj_t BgL_obj1853z00_965;

																								BgL_obj1853z00_965 =
																									(obj_t) (BgL_valz00_592);
																								BgL_testz00_1295 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1853z00_965,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1295)
																								{	/* Engine/heap.scm 142 */
																									obj_t BgL_auxz00_1298;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1299;
																										BgL_auxz00_1299 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_592);
																										BgL_auxz00_1298 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1299))->
																											BgL_classz00);
																									}
																									BgL_testz00_1294 =
																										(BgL_auxz00_1298 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 142 */
																									BgL_testz00_1294 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1294)
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2561z00_606 =
																									BGl_string2700z00zzengine_heapz00;
																							}
																						else
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2561z00_606 =
																									BGl_string2701z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 145 */
																						bool_t BgL_testz00_1304;

																						{	/* Engine/heap.scm 145 */
																							bool_t BgL_testz00_1305;

																							{	/* Engine/heap.scm 145 */
																								obj_t BgL_obj1853z00_967;

																								BgL_obj1853z00_967 =
																									(obj_t) (BgL_valz00_592);
																								BgL_testz00_1305 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1853z00_967,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1305)
																								{	/* Engine/heap.scm 145 */
																									obj_t BgL_auxz00_1308;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1309;
																										BgL_auxz00_1309 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_592);
																										BgL_auxz00_1308 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1309))->
																											BgL_classz00);
																									}
																									BgL_testz00_1304 =
																										(BgL_auxz00_1308 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 145 */
																									BgL_testz00_1304 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1304)
																							{	/* Engine/heap.scm 146 */
																								obj_t BgL_arg2600z00_643;

																								obj_t BgL_arg2601z00_644;

																								BgL_arg2600z00_643 =
																									CNST_TABLE_REF(((long) 9));
																								{	/* Engine/heap.scm 146 */
																									obj_t BgL_arg2602z00_645;

																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_arg2606z00_648;

																										{
																											BgL_sfunz00_bglt
																												BgL_auxz00_1315;
																											BgL_auxz00_1315 =
																												(BgL_sfunz00_bglt)
																												(BgL_valz00_592);
																											BgL_arg2606z00_648 =
																												(((BgL_sfunz00_bglt)
																													CREF
																													(BgL_auxz00_1315))->
																												BgL_bodyz00);
																										}
																										BgL_arg2602z00_645 =
																											BGl_shapez00zztools_shapez00
																											(BgL_arg2606z00_648);
																									}
																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_list2604z00_647;

																										BgL_list2604z00_647 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_arg2601z00_644 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2602z00_645,
																											BgL_list2604z00_647);
																								}}
																								BgL_arg2562z00_607 =
																									MAKE_PAIR(BgL_arg2600z00_643,
																									BgL_arg2601z00_644);
																							}
																						else
																							{	/* Engine/heap.scm 145 */
																								BgL_arg2562z00_607 =
																									BGl_string2701z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 149 */
																						obj_t BgL_arg2610z00_652;

																						obj_t BgL_arg2611z00_653;

																						BgL_arg2610z00_652 =
																							CNST_TABLE_REF(((long) 10));
																						{	/* Engine/heap.scm 149 */
																							obj_t BgL_list2612z00_654;

																							BgL_list2612z00_654 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2611z00_653 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_jtz00_591,
																								BgL_list2612z00_654);
																						}
																						BgL_arg2564z00_609 =
																							MAKE_PAIR(BgL_arg2610z00_652,
																							BgL_arg2611z00_653);
																					}
																					{	/* Engine/heap.scm 132 */
																						obj_t BgL_list2566z00_611;

																						{	/* Engine/heap.scm 132 */
																							obj_t BgL_arg2568z00_612;

																							{	/* Engine/heap.scm 132 */
																								obj_t BgL_arg2569z00_613;

																								{	/* Engine/heap.scm 132 */
																									obj_t BgL_arg2570z00_614;

																									{	/* Engine/heap.scm 132 */
																										obj_t BgL_arg2571z00_615;

																										{	/* Engine/heap.scm 132 */
																											obj_t BgL_arg2572z00_616;

																											{	/* Engine/heap.scm 132 */
																												obj_t
																													BgL_arg2574z00_617;
																												{	/* Engine/heap.scm 132 */
																													obj_t
																														BgL_arg2575z00_618;
																													{	/* Engine/heap.scm 132 */
																														obj_t
																															BgL_arg2576z00_619;
																														{	/* Engine/heap.scm 132 */
																															obj_t
																																BgL_arg2577z00_620;
																															{	/* Engine/heap.scm 132 */
																																obj_t
																																	BgL_arg2578z00_621;
																																{	/* Engine/heap.scm 132 */
																																	obj_t
																																		BgL_arg2579z00_622;
																																	{	/* Engine/heap.scm 132 */
																																		obj_t
																																			BgL_arg2580z00_623;
																																		BgL_arg2580z00_623
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_arg2579z00_622
																																			=
																																			MAKE_PAIR
																																			(BgL_arg2564z00_609,
																																			BgL_arg2580z00_623);
																																	}
																																	BgL_arg2578z00_621
																																		=
																																		MAKE_PAIR
																																		(BGl_string2700z00zzengine_heapz00,
																																		BgL_arg2579z00_622);
																																}
																																BgL_arg2577z00_620
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2562z00_607,
																																	BgL_arg2578z00_621);
																															}
																															BgL_arg2576z00_619
																																=
																																MAKE_PAIR
																																(BgL_arg2561z00_606,
																																BgL_arg2577z00_620);
																														}
																														BgL_arg2575z00_618 =
																															MAKE_PAIR
																															(BgL_arg2560z00_605,
																															BgL_arg2576z00_619);
																													}
																													BgL_arg2574z00_617 =
																														MAKE_PAIR
																														(BGl_string2700z00zzengine_heapz00,
																														BgL_arg2575z00_618);
																												}
																												BgL_arg2572z00_616 =
																													MAKE_PAIR
																													(BgL_arg2558z00_603,
																													BgL_arg2574z00_617);
																											}
																											BgL_arg2571z00_615 =
																												MAKE_PAIR
																												(BGl_string2700z00zzengine_heapz00,
																												BgL_arg2572z00_616);
																										}
																										BgL_arg2570z00_614 =
																											MAKE_PAIR
																											(BgL_arg2555z00_601,
																											BgL_arg2571z00_615);
																									}
																									BgL_arg2569z00_613 =
																										MAKE_PAIR
																										(BGl_string2700z00zzengine_heapz00,
																										BgL_arg2570z00_614);
																								}
																								BgL_arg2568z00_612 =
																									MAKE_PAIR(BgL_arg2538z00_599,
																									BgL_arg2569z00_613);
																							}
																							BgL_list2566z00_611 =
																								MAKE_PAIR
																								(BGl_string2700z00zzengine_heapz00,
																								BgL_arg2568z00_612);
																						}
																						BgL_arg2529z00_596 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2536z00_597,
																							BgL_list2566z00_611);
																				}}
																				BgL_arg2523z00_595 =
																					MAKE_PAIR(BgL_kindz00_593,
																					BgL_arg2529z00_596);
																			}
																			bgl_display_obj(BgL_arg2523z00_595,
																				BgL_port2382z00_594);
																		}
																		bgl_display_char(((unsigned char) '\n'),
																			BgL_port2382z00_594);
										}}}}}}}}
										{
											obj_t BgL_l2383z00_1344;

											BgL_l2383z00_1344 = CDR(BgL_l2383z00_579);
											BgL_l2383z00_579 = BgL_l2383z00_1344;
											goto BgL_zc3anonymousza32504ze3z83_580;
										}
									}
								else
									{	/* Engine/heap.scm 152 */
										BgL_auxz00_1244 = ((bool_t) 1);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_1244);
				}
			}
		}
	}



/* dump-Tenv */
	obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t BgL_tenvz00_4)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 157 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_4,
				BGl_proc2702z00zzengine_heapz00);
		}
	}



/* <anonymous:2616> */
	obj_t BGl_zc3anonymousza32616ze3z83zzengine_heapz00(obj_t BgL_envz00_1018,
		obj_t BgL_kz00_1019, obj_t BgL_newz00_1020)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 159 */
			{
				obj_t BgL_kz00_659;

				obj_t BgL_newz00_660;

				BgL_kz00_659 = BgL_kz00_1019;
				BgL_newz00_660 = BgL_newz00_1020;
				{	/* Engine/heap.scm 160 */
					obj_t BgL_idz00_662;

					{
						BgL_typez00_bglt BgL_auxz00_1348;

						BgL_auxz00_1348 = (BgL_typez00_bglt) (BgL_newz00_660);
						BgL_idz00_662 =
							(((BgL_typez00_bglt) CREF(BgL_auxz00_1348))->BgL_idz00);
					}
					{	/* Engine/heap.scm 160 */
						obj_t BgL_namez00_663;

						{
							BgL_typez00_bglt BgL_auxz00_1351;

							BgL_auxz00_1351 = (BgL_typez00_bglt) (BgL_newz00_660);
							BgL_namez00_663 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_1351))->BgL_namez00);
						}
						{	/* Engine/heap.scm 161 */

							if (BGl_iszd2azf3z21zz__objectz00(BgL_newz00_660,
									BGl_tclassz00zzobject_classz00))
								{	/* Engine/heap.scm 164 */
									obj_t BgL_port2392z00_666;

									{	/* Engine/heap.scm 164 */
										obj_t BgL_res2684z00_975;

										{	/* Engine/heap.scm 164 */
											obj_t BgL_auxz00_1356;

											BgL_auxz00_1356 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2684z00_975 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1356);
										}
										BgL_port2392z00_666 = BgL_res2684z00_975;
									}
									bgl_display_string(BGl_string2699z00zzengine_heapz00,
										BgL_port2392z00_666);
									{	/* Engine/heap.scm 165 */
										obj_t BgL_arg2618z00_667;

										{	/* Engine/heap.scm 165 */
											obj_t BgL_arg2619z00_668;

											obj_t BgL_arg2620z00_669;

											BgL_arg2619z00_668 = CNST_TABLE_REF(((long) 11));
											{	/* Engine/heap.scm 165 */
												obj_t BgL_arg2621z00_670;

												obj_t BgL_arg2622z00_671;

												obj_t BgL_arg2623z00_672;

												BgL_arg2621z00_670 =
													BGl_shapez00zztools_shapez00(BgL_newz00_660);
												{	/* Engine/heap.scm 166 */
													obj_t BgL_arg2626z00_675;

													obj_t BgL_arg2627z00_676;

													BgL_arg2626z00_675 = CNST_TABLE_REF(((long) 12));
													{	/* Engine/heap.scm 166 */
														obj_t BgL_arg2628z00_677;

														{	/* Engine/heap.scm 166 */
															obj_t BgL_arg2631z00_680;

															{	/* Engine/heap.scm 166 */
																BgL_tclassz00_bglt BgL_obj2131z00_978;

																BgL_obj2131z00_978 =
																	(BgL_tclassz00_bglt) (BgL_newz00_660);
																{
																	obj_t BgL_auxz00_1364;

																	{	/* Engine/heap.scm 166 */
																		BgL_objectz00_bglt BgL_auxz00_1365;

																		BgL_auxz00_1365 =
																			(BgL_objectz00_bglt) (BgL_obj2131z00_978);
																		BgL_auxz00_1364 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_1365);
																	}
																	BgL_arg2631z00_680 =
																		(((BgL_tclassz00_bglt)
																			CREF(BgL_auxz00_1364))->
																		BgL_itszd2superzd2);
															}}
															BgL_arg2628z00_677 =
																BGl_shapez00zztools_shapez00
																(BgL_arg2631z00_680);
														}
														{	/* Engine/heap.scm 166 */
															obj_t BgL_list2630z00_679;

															BgL_list2630z00_679 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2627z00_676 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2628z00_677, BgL_list2630z00_679);
													}}
													BgL_arg2622z00_671 =
														MAKE_PAIR(BgL_arg2626z00_675, BgL_arg2627z00_676);
												}
												{	/* Engine/heap.scm 167 */
													obj_t BgL_arg2632z00_681;

													{	/* Engine/heap.scm 167 */
														obj_t BgL_l2386z00_683;

														{	/* Engine/heap.scm 167 */
															BgL_tclassz00_bglt BgL_obj2134z00_979;

															BgL_obj2134z00_979 =
																(BgL_tclassz00_bglt) (BgL_newz00_660);
															{
																obj_t BgL_auxz00_1374;

																{	/* Engine/heap.scm 167 */
																	BgL_objectz00_bglt BgL_auxz00_1375;

																	BgL_auxz00_1375 =
																		(BgL_objectz00_bglt) (BgL_obj2134z00_979);
																	BgL_auxz00_1374 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_1375);
																}
																BgL_l2386z00_683 =
																	(((BgL_tclassz00_bglt)
																		CREF(BgL_auxz00_1374))->BgL_slotsz00);
														}}
														if (NULLP(BgL_l2386z00_683))
															{	/* Engine/heap.scm 167 */
																BgL_arg2632z00_681 = BNIL;
															}
														else
															{	/* Engine/heap.scm 167 */
																obj_t BgL_head2388z00_685;

																BgL_head2388z00_685 =
																	MAKE_PAIR(BGl_shapez00zztools_shapez00(CAR
																		(BgL_l2386z00_683)), BNIL);
																{	/* Engine/heap.scm 167 */
																	obj_t BgL_g2391z00_686;

																	BgL_g2391z00_686 = CDR(BgL_l2386z00_683);
																	{
																		obj_t BgL_l2386z00_688;

																		obj_t BgL_tail2389z00_689;

																		BgL_l2386z00_688 = BgL_g2391z00_686;
																		BgL_tail2389z00_689 = BgL_head2388z00_685;
																	BgL_zc3anonymousza32635ze3z83_690:
																		if (NULLP(BgL_l2386z00_688))
																			{	/* Engine/heap.scm 167 */
																				BgL_arg2632z00_681 =
																					BgL_head2388z00_685;
																			}
																		else
																			{	/* Engine/heap.scm 167 */
																				obj_t BgL_newtail2390z00_692;

																				BgL_newtail2390z00_692 =
																					MAKE_PAIR(BGl_shapez00zztools_shapez00
																					(CAR(BgL_l2386z00_688)), BNIL);
																				SET_CDR(BgL_tail2389z00_689,
																					BgL_newtail2390z00_692);
																				{
																					obj_t BgL_tail2389z00_1393;

																					obj_t BgL_l2386z00_1391;

																					BgL_l2386z00_1391 =
																						CDR(BgL_l2386z00_688);
																					BgL_tail2389z00_1393 =
																						BgL_newtail2390z00_692;
																					BgL_tail2389z00_689 =
																						BgL_tail2389z00_1393;
																					BgL_l2386z00_688 = BgL_l2386z00_1391;
																					goto
																						BgL_zc3anonymousza32635ze3z83_690;
																				}
																			}
																	}
																}
															}
													}
													BgL_arg2623z00_672 =
														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2632z00_681, BNIL);
												}
												{	/* Engine/heap.scm 165 */
													obj_t BgL_list2624z00_673;

													{	/* Engine/heap.scm 165 */
														obj_t BgL_arg2625z00_674;

														BgL_arg2625z00_674 =
															MAKE_PAIR(BgL_arg2623z00_672, BNIL);
														BgL_list2624z00_673 =
															MAKE_PAIR(BgL_arg2622z00_671, BgL_arg2625z00_674);
													}
													BgL_arg2620z00_669 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2621z00_670, BgL_list2624z00_673);
												}
											}
											BgL_arg2618z00_667 =
												MAKE_PAIR(BgL_arg2619z00_668, BgL_arg2620z00_669);
										}
										bgl_display_obj(BgL_arg2618z00_667, BgL_port2392z00_666);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2392z00_666);
								}
							else
								{	/* Engine/heap.scm 168 */
									obj_t BgL_port2393z00_701;

									{	/* Engine/heap.scm 168 */
										obj_t BgL_res2685z00_994;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_auxz00_1401;

											BgL_auxz00_1401 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2685z00_994 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1401);
										}
										BgL_port2393z00_701 = BgL_res2685z00_994;
									}
									bgl_display_string(BGl_string2699z00zzengine_heapz00,
										BgL_port2393z00_701);
									{	/* Engine/heap.scm 168 */
										obj_t BgL_arg2644z00_702;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_arg2645z00_703;

											obj_t BgL_arg2646z00_704;

											BgL_arg2645z00_703 = CNST_TABLE_REF(((long) 13));
											{	/* Engine/heap.scm 168 */
												obj_t BgL_arg2647z00_705;

												{	/* Engine/heap.scm 168 */
													obj_t BgL_arg2651z00_709;

													obj_t BgL_arg2652z00_710;

													BgL_arg2651z00_709 = CNST_TABLE_REF(((long) 6));
													{	/* Engine/heap.scm 168 */
														obj_t BgL_list2653z00_711;

														BgL_list2653z00_711 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg2652z00_710 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_namez00_663, BgL_list2653z00_711);
													}
													BgL_arg2647z00_705 =
														MAKE_PAIR(BgL_arg2651z00_709, BgL_arg2652z00_710);
												}
												{	/* Engine/heap.scm 168 */
													obj_t BgL_list2649z00_707;

													{	/* Engine/heap.scm 168 */
														obj_t BgL_arg2650z00_708;

														BgL_arg2650z00_708 = MAKE_PAIR(BNIL, BNIL);
														BgL_list2649z00_707 =
															MAKE_PAIR(BgL_arg2647z00_705, BgL_arg2650z00_708);
													}
													BgL_arg2646z00_704 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_idz00_662, BgL_list2649z00_707);
											}}
											BgL_arg2644z00_702 =
												MAKE_PAIR(BgL_arg2645z00_703, BgL_arg2646z00_704);
										}
										bgl_display_obj(BgL_arg2644z00_702, BgL_port2393z00_701);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2393z00_701);
		}}}}}}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzheap_restorez00(((long) 307873065),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(((long) 284127067),
				BSTRING_TO_STRING(BGl_string2703z00zzengine_heapz00));
		}
	}

#ifdef __cplusplus
}
#endif
