/*===========================================================================*/
/*   (Heap/restore.scm)                                                      */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Heap/restore.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;


	extern obj_t BGl_za2bigloozd2versionza2zd2zzengine_paramz00;
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_addzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzheap_restorez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
	static obj_t BGl_genericzd2initzd2zzheap_restorez00();
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	static obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t);
	static bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t BGl_putpropz12z12zz__r4_symbols_6_4z00(obj_t, obj_t, obj_t);
	extern obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00;
	static obj_t BGl_zc3anonymousza32270ze3z83zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzheap_restorez00();
	static obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00();
	BGL_EXPORTED_DECL obj_t BGl_restorezd2heapzd2zzheap_restorez00();
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00();
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3exitza32420ze3z83zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinit_mainz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_enginez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzheap_restorez00();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32309ze3z83zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_za2callzf2cczf3za2z01zzengine_paramz00;
	BGL_IMPORT obj_t close_binary_port(obj_t);
	extern obj_t BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00;
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse(obj_t);
	extern obj_t BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00;
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	static obj_t BGl__restorezd2additionalzd2heapz00zzheap_restorez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT obj_t BGl_getpropz00zz__r4_symbols_6_4z00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32473ze3z83zzheap_restorez00(obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BUNSPEC;
	static obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
	static obj_t BGl_zc3exitza32196ze3z83zzheap_restorez00(obj_t);
	extern obj_t BGl_compilerzd2exitzd2zzinit_mainz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32495ze3z83zzheap_restorez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2heapzd2nameza2zd2zzengine_paramz00;
	static obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
	static obj_t BGl_za2heapzd2markza2zd2zzheap_restorez00 = BUNSPEC;
	extern obj_t BGl_za2unsafezd2heapza2zd2zzengine_paramz00;
	static obj_t BGl_methodzd2initzd2zzheap_restorez00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2583z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322594z00,
		BGl_zc3anonymousza32270ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2584z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322595z00,
		BGl_zc3anonymousza32309ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2588z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322596z00,
		BGl_zc3anonymousza32473ze3z83zzheap_restorez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2589z00zzheap_restorez00,
		BgL_bgl_za7c3anonymousza7a322597z00,
		BGl_zc3anonymousza32495ze3z83zzheap_restorez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2571z00zzheap_restorez00,
		BgL_bgl_string2571za700za7za7h2598za7, "Heap", 4);
	      DEFINE_STRING(BGl_string2572z00zzheap_restorez00,
		BgL_bgl_string2572za700za7za7h2599za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2573z00zzheap_restorez00,
		BgL_bgl_string2573za700za7za7h2600za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2574z00zzheap_restorez00,
		BgL_bgl_string2574za700za7za7h2601za7, "]", 1);
	      DEFINE_STRING(BGl_string2575z00zzheap_restorez00,
		BgL_bgl_string2575za700za7za7h2602za7, "      [reading ", 15);
	      DEFINE_STRING(BGl_string2576z00zzheap_restorez00,
		BgL_bgl_string2576za700za7za7h2603za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string2577z00zzheap_restorez00,
		BgL_bgl_string2577za700za7za7h2604za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string2578z00zzheap_restorez00,
		BgL_bgl_string2578za700za7za7h2605za7, "~a vs. ~a", 9);
	      DEFINE_STRING(BGl_string2580z00zzheap_restorez00,
		BgL_bgl_string2580za700za7za7h2606za7, "Heap is `~a', Bigloo is `~a'", 28);
	      DEFINE_STRING(BGl_string2579z00zzheap_restorez00,
		BgL_bgl_string2579za700za7za7h2607za7, "Target language mismatch", 24);
	      DEFINE_STRING(BGl_string2581z00zzheap_restorez00,
		BgL_bgl_string2581za700za7za7h2608za7, "Release mismatch", 16);
	      DEFINE_STRING(BGl_string2582z00zzheap_restorez00,
		BgL_bgl_string2582za700za7za7h2609za7, "Specific version mismatch", 25);
	      DEFINE_STRING(BGl_string2585z00zzheap_restorez00,
		BgL_bgl_string2585za700za7za7h2610za7, ".", 1);
	      DEFINE_STRING(BGl_string2586z00zzheap_restorez00,
		BgL_bgl_string2586za700za7za7h2611za7, "Library", 7);
	      DEFINE_STRING(BGl_string2587z00zzheap_restorez00,
		BgL_bgl_string2587za700za7za7h2612za7, "restore-additional-heap", 23);
	      DEFINE_STRING(BGl_string2590z00zzheap_restorez00,
		BgL_bgl_string2590za700za7za7h2613za7, "heap_restore", 12);
	      DEFINE_STRING(BGl_string2591z00zzheap_restorez00,
		BgL_bgl_string2591za700za7za7h2614za7,
		"restore-additional-heap call-with-current-continuation __r4_control_features_6_9 call/cc restore-heap pass-started heap-mark ",
		125);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2heapzd2envz00zzheap_restorez00,
		BgL_bgl__restoreza7d2heapza72615z00,
		BGl__restorezd2heapzd2zzheap_restorez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_heapzd2modulezd2listzd2envzd2zzheap_restorez00,
		BgL_bgl__heapza7d2moduleza7d2616z00, va_generic_entry,
		BGl__heapzd2modulezd2listz00zzheap_restorez00, BUNSPEC, -1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapzd2envzd2zzheap_restorez00,
		BgL_bgl__restoreza7d2addit2617za7,
		BGl__restorezd2additionalzd2heapz00zzheap_restorez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_restorezd2additionalzd2heapszd2envzd2zzheap_restorez00,
		BgL_bgl__restoreza7d2addit2618za7,
		BGl__restorezd2additionalzd2heapsz00zzheap_restorez00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long
		BgL_checksumz00_876, char *BgL_fromz00_877)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzheap_restorez00))
				{
					BGl_requirezd2initializa7ationz75zzheap_restorez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzheap_restorez00();
					BGl_cnstzd2initzd2zzheap_restorez00();
					BGl_importedzd2moduleszd2initz00zzheap_restorez00();
					BGl_toplevelzd2initzd2zzheap_restorez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"heap_restore");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "heap_restore");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"heap_restore");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			{	/* Heap/restore.scm 15 */
				obj_t BgL_cportz00_868;

				BgL_cportz00_868 =
					bgl_open_input_string(BGl_string2591z00zzheap_restorez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_869;

					BgL_iz00_869 = ((long) 6);
				BgL_loopz00_870:
					if ((BgL_iz00_869 == ((long) -1)))
						{	/* Heap/restore.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Heap/restore.scm 15 */
							{	/* Heap/restore.scm 15 */
								obj_t BgL_arg2593z00_872;

								{	/* Heap/restore.scm 15 */

									{	/* Heap/restore.scm 15 */
										obj_t BgL_locationz00_874;

										BgL_locationz00_874 = BBOOL(((bool_t) 0));
										{	/* Heap/restore.scm 15 */

											BgL_arg2593z00_872 =
												BGl_readz00zz__readerz00(BgL_cportz00_868,
												BgL_locationz00_874);
										}
									}
								}
								{	/* Heap/restore.scm 15 */
									int BgL_auxz00_901;

									BgL_auxz00_901 = (int) (BgL_iz00_869);
									CNST_TABLE_SET(BgL_auxz00_901, BgL_arg2593z00_872);
							}}
							{	/* Heap/restore.scm 15 */
								int BgL_auxz00_875;

								BgL_auxz00_875 = (int) ((BgL_iz00_869 - ((long) 1)));
								{
									long BgL_iz00_906;

									BgL_iz00_906 = (long) (BgL_auxz00_875);
									BgL_iz00_869 = BgL_iz00_906;
									goto BgL_loopz00_870;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 = BNIL;
			return (BGl_za2heapzd2markza2zd2zzheap_restorez00 =
				CNST_TABLE_REF(((long) 0)), BUNSPEC);
		}
	}



/* backend-heap-compatible? */
	bool_t BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(obj_t
		BgL_targetz00_1)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 36 */
			{	/* Heap/restore.scm 37 */
				obj_t BgL_instance2082z00_426;

				BgL_instance2082z00_426 = BGl_thezd2backendzd2zzbackend_backendz00();
				{	/* Heap/restore.scm 38 */
					bool_t BgL__ortest_2084z00_427;

					{	/* Heap/restore.scm 38 */
						obj_t BgL_auxz00_910;

						{
							BgL_backendz00_bglt BgL_auxz00_911;

							BgL_auxz00_911 = (BgL_backendz00_bglt) (BgL_instance2082z00_426);
							BgL_auxz00_910 =
								(((BgL_backendz00_bglt) CREF(BgL_auxz00_911))->BgL_languagez00);
						}
						BgL__ortest_2084z00_427 = (BgL_targetz00_1 == BgL_auxz00_910);
					}
					if (BgL__ortest_2084z00_427)
						{	/* Heap/restore.scm 38 */
							return BgL__ortest_2084z00_427;
						}
					else
						{	/* Heap/restore.scm 38 */
							obj_t BgL_auxz00_916;

							{
								BgL_backendz00_bglt BgL_auxz00_917;

								BgL_auxz00_917 =
									(BgL_backendz00_bglt) (BgL_instance2082z00_426);
								BgL_auxz00_916 =
									(((BgL_backendz00_bglt) CREF(BgL_auxz00_917))->
									BgL_heapzd2compatiblezd2);
							}
							return (BgL_targetz00_1 == BgL_auxz00_916);
						}
				}
			}
		}
	}



/* restore-heap */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2heapzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			if (STRINGP(BGl_za2heapzd2nameza2zd2zzengine_paramz00))
				{	/* Heap/restore.scm 44 */
					{	/* Heap/restore.scm 45 */
						obj_t BgL_list2117z00_431;

						{	/* Heap/restore.scm 45 */
							obj_t BgL_arg2134z00_433;

							{	/* Heap/restore.scm 45 */
								obj_t BgL_arg2147z00_435;

								BgL_arg2147z00_435 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg2134z00_433 =
									MAKE_PAIR(BGl_string2571z00zzheap_restorez00,
									BgL_arg2147z00_435);
							}
							BgL_list2117z00_431 =
								MAKE_PAIR(BGl_string2572z00zzheap_restorez00,
								BgL_arg2134z00_433);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list2117z00_431);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string2571z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_439;

						obj_t BgL_hnamesz00_440;

						BgL_hooksz00_439 = BNIL;
						BgL_hnamesz00_440 = BNIL;
					BgL_zc3anonymousza32148ze3z83_441:
						if (NULLP(BgL_hooksz00_439))
							{	/* Heap/restore.scm 45 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 45 */
								bool_t BgL_testz00_933;

								{	/* Heap/restore.scm 45 */
									obj_t BgL_fun2167z00_449;

									BgL_fun2167z00_449 = CAR(BgL_hooksz00_439);
									BgL_testz00_933 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun2167z00_449)
										(BgL_fun2167z00_449, BEOA));
								}
								if (BgL_testz00_933)
									{
										obj_t BgL_hnamesz00_940;

										obj_t BgL_hooksz00_938;

										BgL_hooksz00_938 = CDR(BgL_hooksz00_439);
										BgL_hnamesz00_940 = CDR(BgL_hnamesz00_440);
										BgL_hnamesz00_440 = BgL_hnamesz00_940;
										BgL_hooksz00_439 = BgL_hooksz00_938;
										goto BgL_zc3anonymousza32148ze3z83_441;
									}
								else
									{	/* Heap/restore.scm 45 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string2571z00zzheap_restorez00,
											BGl_string2573z00zzheap_restorez00,
											CAR(BgL_hnamesz00_440));
									}
							}
					}
					{	/* Heap/restore.scm 46 */
						obj_t BgL_fnamez00_452;

						BgL_fnamez00_452 =
							BGl_findzd2filezf2pathz20zz__osz00
							(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						if (STRINGP(BgL_fnamez00_452))
							{	/* Heap/restore.scm 48 */
								obj_t BgL_portz00_454;

								BgL_portz00_454 =
									BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
									(BgL_fnamez00_452);
								if (BINARY_PORTP(BgL_portz00_454))
									{	/* Heap/restore.scm 49 */
										{	/* Heap/restore.scm 54 */
											obj_t BgL_list2171z00_456;

											{	/* Heap/restore.scm 54 */
												obj_t BgL_arg2179z00_458;

												{	/* Heap/restore.scm 54 */
													obj_t BgL_arg2183z00_459;

													{	/* Heap/restore.scm 54 */
														obj_t BgL_arg2191z00_461;

														BgL_arg2191z00_461 =
															MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
														BgL_arg2183z00_459 =
															MAKE_PAIR(BGl_string2574z00zzheap_restorez00,
															BgL_arg2191z00_461);
													}
													BgL_arg2179z00_458 =
														MAKE_PAIR(BgL_fnamez00_452, BgL_arg2183z00_459);
												}
												BgL_list2171z00_456 =
													MAKE_PAIR(BGl_string2575z00zzheap_restorez00,
													BgL_arg2179z00_458);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list2171z00_456);
										}
										{	/* Heap/restore.scm 55 */
											obj_t BgL_val2087z00_462;

											BgL_val2087z00_462 =
												BGl_zc3exitza32196ze3z83zzheap_restorez00
												(BgL_portz00_454);
											close_binary_port(BgL_portz00_454);
											if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
													(BgL_val2087z00_462)))
												{	/* Heap/restore.scm 109 */
													return
														BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
														(BgL_val2087z00_462), CDR(BgL_val2087z00_462));
												}
											else
												{	/* Heap/restore.scm 109 */
													return BgL_val2087z00_462;
												}
										}
									}
								else
									{	/* Heap/restore.scm 50 */
										obj_t BgL_mz00_516;

										{	/* Heap/restore.scm 50 */
											obj_t BgL_list2328z00_517;

											BgL_list2328z00_517 = MAKE_PAIR(BgL_fnamez00_452, BNIL);
											BgL_mz00_516 =
												BGl_formatz00zz__r4_output_6_10_3z00
												(BGl_string2576z00zzheap_restorez00,
												BgL_list2328z00_517);
										}
										BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
											BgL_mz00_516, BGl_za2libzd2dirza2zd2zzengine_paramz00);
										return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long)
													5)));
							}}
						else
							{	/* Heap/restore.scm 110 */
								obj_t BgL_mz00_518;

								{	/* Heap/restore.scm 110 */
									obj_t BgL_list2329z00_519;

									BgL_list2329z00_519 =
										MAKE_PAIR(BGl_za2heapzd2nameza2zd2zzengine_paramz00, BNIL);
									BgL_mz00_518 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2576z00zzheap_restorez00, BgL_list2329z00_519);
								}
								BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
									BgL_mz00_518, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 5)));
				}}}
			else
				{	/* Heap/restore.scm 44 */
					return BFALSE;
				}
		}
	}



/* <exit:2196> */
	obj_t BGl_zc3exitza32196ze3z83zzheap_restorez00(obj_t BgL_portz00_866)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 109 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2088z00_467;

			if (SET_EXIT(BgL_an_exit2088z00_467))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
					BgL_an_exit2088z00_467 = (void *) jmpbuf;
					{	/* Heap/restore.scm 109 */

						PUSH_EXIT(BgL_an_exit2088z00_467, ((long) 0));
						{	/* Heap/restore.scm 56 */
							bool_t BgL_val2089z00_468;

							{	/* Heap/restore.scm 56 */
								obj_t BgL_envsz00_469;

								BgL_envsz00_469 = input_obj(BgL_portz00_866);
								{	/* Heap/restore.scm 56 */
									obj_t BgL__z00_470;

									{	/* Heap/restore.scm 57 */
										bool_t BgL_testz00_981;

										if (VECTORP(BgL_envsz00_469))
											{	/* Heap/restore.scm 58 */
												int BgL_arg2320z00_514;

												BgL_arg2320z00_514 = VECTOR_LENGTH(BgL_envsz00_469);
												BgL_testz00_981 =
													((long) (BgL_arg2320z00_514) == ((long) 5));
											}
										else
											{	/* Heap/restore.scm 57 */
												BgL_testz00_981 = ((bool_t) 0);
											}
										if (BgL_testz00_981)
											{	/* Heap/restore.scm 57 */
												BgL__z00_470 = BFALSE;
											}
										else
											{	/* Heap/restore.scm 57 */
												BgL__z00_470 =
													BGl_errorz00zz__errorz00
													(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
													BGl_string2577z00zzheap_restorez00, BgL_envsz00_469);
											}
									}
									{	/* Heap/restore.scm 57 */
										obj_t BgL_targetz00_471;

										BgL_targetz00_471 =
											VECTOR_REF(BgL_envsz00_469, (int) (((long) 0)));
										{	/* Heap/restore.scm 62 */
											obj_t BgL_versionz00_472;

											BgL_versionz00_472 =
												VECTOR_REF(BgL_envsz00_469, (int) (((long) 1)));
											{	/* Heap/restore.scm 63 */
												obj_t BgL_specificz00_473;

												BgL_specificz00_473 =
													VECTOR_REF(BgL_envsz00_469, (int) (((long) 2)));
												{	/* Heap/restore.scm 64 */
													obj_t BgL_genvz00_474;

													BgL_genvz00_474 =
														VECTOR_REF(BgL_envsz00_469, (int) (((long) 3)));
													{	/* Heap/restore.scm 65 */
														obj_t BgL_tenvz00_475;

														BgL_tenvz00_475 =
															VECTOR_REF(BgL_envsz00_469, (int) (((long) 4)));
														{	/* Heap/restore.scm 66 */

															if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_471))
																{	/* Heap/restore.scm 68 */
																	BFALSE;
																}
															else
																{	/* Heap/restore.scm 69 */
																	obj_t BgL_arg2203z00_478;

																	{	/* Heap/restore.scm 71 */
																		obj_t BgL_arg2214z00_480;

																		{	/* Heap/restore.scm 73 */
																			obj_t BgL_arg2227z00_483;

																			BgL_arg2227z00_483 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_1001;

																				BgL_auxz00_1001 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2227z00_483);
																				BgL_arg2214z00_480 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_1001))->
																					BgL_languagez00);
																			}
																		}
																		{	/* Heap/restore.scm 71 */
																			obj_t BgL_list2215z00_481;

																			{	/* Heap/restore.scm 71 */
																				obj_t BgL_arg2221z00_482;

																				BgL_arg2221z00_482 =
																					MAKE_PAIR(BgL_arg2214z00_480, BNIL);
																				BgL_list2215z00_481 =
																					MAKE_PAIR(BgL_targetz00_471,
																					BgL_arg2221z00_482);
																			}
																			BgL_arg2203z00_478 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2578z00zzheap_restorez00,
																				BgL_list2215z00_481);
																		}
																	}
																	BGl_errorz00zz__errorz00
																		(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																		BGl_string2579z00zzheap_restorez00,
																		BgL_arg2203z00_478);
																}
															{	/* Heap/restore.scm 74 */
																bool_t BgL_testz00_1008;

																if (CBOOL
																	(BGl_za2unsafezd2heapza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 74 */
																		BgL_testz00_1008 = ((bool_t) 1);
																	}
																else
																	{	/* Heap/restore.scm 74 */
																		BgL_testz00_1008 =
																			BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																			(BgL_versionz00_472,
																			BGl_za2bigloozd2versionza2zd2zzengine_paramz00);
																	}
																if (BgL_testz00_1008)
																	{	/* Heap/restore.scm 74 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 76 */
																		obj_t BgL_arg2240z00_486;

																		{	/* Heap/restore.scm 78 */
																			obj_t BgL_list2241z00_487;

																			{	/* Heap/restore.scm 78 */
																				obj_t BgL_arg2248z00_488;

																				BgL_arg2248z00_488 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																					BNIL);
																				BgL_list2241z00_487 =
																					MAKE_PAIR(BgL_versionz00_472,
																					BgL_arg2248z00_488);
																			}
																			BgL_arg2240z00_486 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2580z00zzheap_restorez00,
																				BgL_list2241z00_487);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2581z00zzheap_restorez00,
																			BgL_arg2240z00_486);
																	}
															}
															{	/* Heap/restore.scm 81 */
																bool_t BgL_testz00_1016;

																if (CBOOL
																	(BGl_za2unsafezd2heapza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 81 */
																		BgL_testz00_1016 = ((bool_t) 1);
																	}
																else
																	{	/* Heap/restore.scm 81 */
																		BgL_testz00_1016 =
																			BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																			(BgL_specificz00_473,
																			BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00);
																	}
																if (BgL_testz00_1016)
																	{	/* Heap/restore.scm 81 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 83 */
																		obj_t BgL_arg2255z00_491;

																		{	/* Heap/restore.scm 85 */
																			obj_t BgL_list2256z00_492;

																			{	/* Heap/restore.scm 85 */
																				obj_t BgL_arg2262z00_493;

																				BgL_arg2262z00_493 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																					BNIL);
																				BgL_list2256z00_492 =
																					MAKE_PAIR(BgL_specificz00_473,
																					BgL_arg2262z00_493);
																			}
																			BgL_arg2255z00_491 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2580z00zzheap_restorez00,
																				BgL_list2256z00_492);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2582z00zzheap_restorez00,
																			BgL_arg2255z00_491);
																	}
															}
															BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_474);
															BGl_setzd2tenvz12zc0zztype_envz00
																(BgL_tenvz00_475);
															if (CBOOL
																(BGl_za2callzf2cczf3za2z01zzengine_paramz00))
																{	/* Heap/restore.scm 93 */
																	BFALSE;
																}
															else
																{	/* Heap/restore.scm 93 */
																	BGl_unbindzd2callzf2ccz12z32zzheap_restorez00
																		();
																}
															{	/* Heap/restore.scm 96 */
																bool_t BgL_testz00_1029;

																{	/* Heap/restore.scm 96 */
																	obj_t BgL_arg2301z00_504;

																	BgL_arg2301z00_504 =
																		BGl_thezd2backendzd2zzbackend_backendz00();
																	{
																		BgL_backendz00_bglt BgL_auxz00_1031;

																		BgL_auxz00_1031 =
																			(BgL_backendz00_bglt)
																			(BgL_arg2301z00_504);
																		BgL_testz00_1029 =
																			(((BgL_backendz00_bglt)
																				CREF(BgL_auxz00_1031))->
																			BgL_qualifiedzd2typeszd2);
																	}
																}
																if (BgL_testz00_1029)
																	{	/* Heap/restore.scm 96 */
																		BGl_forzd2eachzd2globalz12z12zzast_envz00
																			(BGl_proc2583z00zzheap_restorez00, BNIL);
																		BgL_genvz00_474;
																	}
																else
																	{	/* Heap/restore.scm 96 */
																		BFALSE;
																	}
															}
															BGl_forzd2eachzd2globalz12z12zzast_envz00
																(BGl_proc2584z00zzheap_restorez00, BNIL);
															BgL_val2089z00_468 = ((bool_t) 1);
														}
													}
												}
											}
										}
									}
								}
							}
							POP_EXIT();
							return BBOOL(BgL_val2089z00_468);
						}
					}
				}
		}
	}



/* _restore-heap */
	obj_t BGl__restorezd2heapzd2zzheap_restorez00(obj_t BgL_envz00_847)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 43 */
			return BGl_restorezd2heapzd2zzheap_restorez00();
		}
	}



/* <anonymous:2309> */
	obj_t BGl_zc3anonymousza32309ze3z83zzheap_restorez00(obj_t BgL_envz00_848,
		obj_t BgL_newz00_849)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 106 */
			{
				obj_t BgL_newz00_507;

				BgL_newz00_507 = BgL_newz00_849;
				{	/* Heap/restore.scm 107 */
					obj_t BgL_arg2314z00_790;

					{
						BgL_globalz00_bglt BgL_auxz00_1039;

						BgL_auxz00_1039 = (BgL_globalz00_bglt) (BgL_newz00_507);
						BgL_arg2314z00_790 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1039))->BgL_modulez00);
					}
					{	/* Heap/restore.scm 107 */
						obj_t BgL_list2315z00_791;

						BgL_list2315z00_791 = MAKE_PAIR(BgL_arg2314z00_790, BNIL);
						return
							BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_list2315z00_791);
					}
				}
			}
		}
	}



/* <anonymous:2270> */
	obj_t BGl_zc3anonymousza32270ze3z83zzheap_restorez00(obj_t BgL_envz00_850,
		obj_t BgL_newz00_851)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 98 */
			{
				obj_t BgL_newz00_497;

				BgL_newz00_497 = BgL_newz00_851;
				{	/* Heap/restore.scm 100 */
					obj_t BgL_arg2275z00_499;

					obj_t BgL_arg2281z00_500;

					obj_t BgL_arg2288z00_501;

					{
						BgL_globalz00_bglt BgL_auxz00_1044;

						BgL_auxz00_1044 = (BgL_globalz00_bglt) (BgL_newz00_497);
						BgL_arg2275z00_499 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1044))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1047;

						BgL_auxz00_1047 = (BgL_globalz00_bglt) (BgL_newz00_497);
						BgL_arg2281z00_500 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1047))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2288z00_501 = BGl_shapez00zztools_shapez00(BgL_newz00_497);
					{	/* Heap/restore.scm 99 */
						obj_t BgL_list2289z00_502;

						BgL_list2289z00_502 = MAKE_PAIR(BgL_arg2288z00_501, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2275z00_499,
							BgL_arg2281z00_500, BgL_list2289z00_502);
					}
				}
			}
		}
	}



/* unbind-call/cc! */
	obj_t BGl_unbindzd2callzf2ccz12z32zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 117 */
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								3)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 118 */
					BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 3)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 118 */
					BFALSE;
				}
			if (CBOOL(BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long)
								5)), CNST_TABLE_REF(((long) 4)))))
				{	/* Heap/restore.scm 120 */
					return
						BGl_unbindzd2globalz12zc0zzast_envz00(CNST_TABLE_REF(((long) 5)),
						CNST_TABLE_REF(((long) 4)));
				}
			else
				{	/* Heap/restore.scm 120 */
					return BFALSE;
				}
		}
	}



/* restore-additional-heaps */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2additionalzd2heapsz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 128 */
			if (PAIRP(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00))
				{	/* Heap/restore.scm 130 */
					obj_t BgL_sufz00_523;

					{	/* Heap/restore.scm 130 */
						obj_t BgL_arg2379z00_555;

						{	/* Heap/restore.scm 130 */
							obj_t BgL_arg2392z00_556;

							BgL_arg2392z00_556 = BGl_thezd2backendzd2zzbackend_backendz00();
							{
								BgL_backendz00_bglt BgL_auxz00_1072;

								BgL_auxz00_1072 = (BgL_backendz00_bglt) (BgL_arg2392z00_556);
								BgL_arg2379z00_555 =
									(((BgL_backendz00_bglt) CREF(BgL_auxz00_1072))->
									BgL_heapzd2suffixzd2);
							}
						}
						BgL_sufz00_523 =
							string_append(BGl_string2585z00zzheap_restorez00,
							BgL_arg2379z00_555);
					}
					{	/* Heap/restore.scm 131 */
						obj_t BgL_list2334z00_524;

						{	/* Heap/restore.scm 131 */
							obj_t BgL_arg2341z00_526;

							{	/* Heap/restore.scm 131 */
								obj_t BgL_arg2348z00_528;

								BgL_arg2348z00_528 =
									MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
								BgL_arg2341z00_526 =
									MAKE_PAIR(BGl_string2586z00zzheap_restorez00,
									BgL_arg2348z00_528);
							}
							BgL_list2334z00_524 =
								MAKE_PAIR(BGl_string2572z00zzheap_restorez00,
								BgL_arg2341z00_526);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list2334z00_524);
					}
					BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 =
						BINT(((long) 0));
					BGl_za2currentzd2passza2zd2zzengine_passz00 =
						BGl_string2586z00zzheap_restorez00;
					{
						obj_t BgL_hooksz00_532;

						obj_t BgL_hnamesz00_533;

						BgL_hooksz00_532 = BNIL;
						BgL_hnamesz00_533 = BNIL;
					BgL_zc3anonymousza32349ze3z83_534:
						if (NULLP(BgL_hooksz00_532))
							{	/* Heap/restore.scm 131 */
								CNST_TABLE_REF(((long) 1));
							}
						else
							{	/* Heap/restore.scm 131 */
								bool_t BgL_testz00_1086;

								{	/* Heap/restore.scm 131 */
									obj_t BgL_fun2363z00_542;

									BgL_fun2363z00_542 = CAR(BgL_hooksz00_532);
									BgL_testz00_1086 =
										CBOOL(PROCEDURE_ENTRY(BgL_fun2363z00_542)
										(BgL_fun2363z00_542, BEOA));
								}
								if (BgL_testz00_1086)
									{
										obj_t BgL_hnamesz00_1093;

										obj_t BgL_hooksz00_1091;

										BgL_hooksz00_1091 = CDR(BgL_hooksz00_532);
										BgL_hnamesz00_1093 = CDR(BgL_hnamesz00_533);
										BgL_hnamesz00_533 = BgL_hnamesz00_1093;
										BgL_hooksz00_532 = BgL_hooksz00_1091;
										goto BgL_zc3anonymousza32349ze3z83_534;
									}
								else
									{	/* Heap/restore.scm 131 */
										BGl_internalzd2errorzd2zztools_errorz00
											(BGl_string2586z00zzheap_restorez00,
											BGl_string2573z00zzheap_restorez00,
											CAR(BgL_hnamesz00_533));
									}
							}
					}
					{	/* Heap/restore.scm 132 */
						obj_t BgL_g2097z00_545;

						BgL_g2097z00_545 =
							bgl_reverse
							(BGl_za2additionalzd2heapzd2namesza2z00zzengine_paramz00);
						{
							obj_t BgL_l2095z00_547;

							{	/* Heap/restore.scm 134 */
								bool_t BgL_auxz00_1098;

								BgL_l2095z00_547 = BgL_g2097z00_545;
							BgL_zc3anonymousza32365ze3z83_548:
								if (PAIRP(BgL_l2095z00_547))
									{	/* Heap/restore.scm 134 */
										{	/* Heap/restore.scm 133 */
											obj_t BgL_hz00_550;

											BgL_hz00_550 = CAR(BgL_l2095z00_547);
											BGl_restorezd2additionalzd2heapz00zzheap_restorez00
												(string_append(BgL_hz00_550, BgL_sufz00_523));
										}
										{
											obj_t BgL_l2095z00_1104;

											BgL_l2095z00_1104 = CDR(BgL_l2095z00_547);
											BgL_l2095z00_547 = BgL_l2095z00_1104;
											goto BgL_zc3anonymousza32365ze3z83_548;
										}
									}
								else
									{	/* Heap/restore.scm 134 */
										BgL_auxz00_1098 = ((bool_t) 1);
									}
								return BBOOL(BgL_auxz00_1098);
							}
						}
					}
				}
			else
				{	/* Heap/restore.scm 129 */
					return BFALSE;
				}
		}
	}



/* _restore-additional-heaps */
	obj_t BGl__restorezd2additionalzd2heapsz00zzheap_restorez00(obj_t
		BgL_envz00_852)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 128 */
			return BGl_restorezd2additionalzd2heapsz00zzheap_restorez00();
		}
	}



/* restore-additional-heap */
	BGL_EXPORTED_DEF obj_t
		BGl_restorezd2additionalzd2heapz00zzheap_restorez00(obj_t BgL_heapz00_2)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 139 */
			{	/* Heap/restore.scm 140 */
				obj_t BgL_fnamez00_557;

				BgL_fnamez00_557 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_2,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_557))
					{	/* Heap/restore.scm 142 */
						obj_t BgL_portz00_559;

						BgL_portz00_559 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_557);
						if (BINARY_PORTP(BgL_portz00_559))
							{	/* Heap/restore.scm 143 */
								{	/* Heap/restore.scm 148 */
									obj_t BgL_list2395z00_561;

									{	/* Heap/restore.scm 148 */
										obj_t BgL_arg2408z00_563;

										{	/* Heap/restore.scm 148 */
											obj_t BgL_arg2409z00_564;

											{	/* Heap/restore.scm 148 */
												obj_t BgL_arg2411z00_566;

												BgL_arg2411z00_566 =
													MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
												BgL_arg2409z00_564 =
													MAKE_PAIR(BGl_string2574z00zzheap_restorez00,
													BgL_arg2411z00_566);
											}
											BgL_arg2408z00_563 =
												MAKE_PAIR(BgL_fnamez00_557, BgL_arg2409z00_564);
										}
										BgL_list2395z00_561 =
											MAKE_PAIR(BGl_string2575z00zzheap_restorez00,
											BgL_arg2408z00_563);
									}
									BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
										BgL_list2395z00_561);
								}
								{	/* Heap/restore.scm 149 */
									obj_t BgL_val2092z00_567;

									BgL_val2092z00_567 =
										BGl_zc3exitza32420ze3z83zzheap_restorez00(BgL_heapz00_2,
										BgL_portz00_559);
									close_binary_port(BgL_portz00_559);
									if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
											(BgL_val2092z00_567)))
										{	/* Heap/restore.scm 212 */
											return
												BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
												(BgL_val2092z00_567), CDR(BgL_val2092z00_567));
										}
									else
										{	/* Heap/restore.scm 212 */
											return BgL_val2092z00_567;
										}
								}
							}
						else
							{	/* Heap/restore.scm 144 */
								obj_t BgL_mz00_631;

								{	/* Heap/restore.scm 144 */
									obj_t BgL_list2524z00_632;

									BgL_list2524z00_632 = MAKE_PAIR(BgL_fnamez00_557, BNIL);
									BgL_mz00_631 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2576z00zzheap_restorez00, BgL_list2524z00_632);
								}
								BGl_errorz00zz__errorz00(BGl_string2587z00zzheap_restorez00,
									BgL_mz00_631, BGl_za2libzd2dirza2zd2zzengine_paramz00);
								return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
					}}
				else
					{	/* Heap/restore.scm 213 */
						obj_t BgL_mz00_633;

						{	/* Heap/restore.scm 213 */
							obj_t BgL_list2525z00_634;

							BgL_list2525z00_634 = MAKE_PAIR(BgL_heapz00_2, BNIL);
							BgL_mz00_633 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2576z00zzheap_restorez00, BgL_list2525z00_634);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 6)), BgL_mz00_633,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BGl_compilerzd2exitzd2zzinit_mainz00(BINT(((long) 6)));
		}}}
	}



/* <exit:2420> */
	obj_t BGl_zc3exitza32420ze3z83zzheap_restorez00(obj_t BgL_heapz00_865,
		obj_t BgL_portz00_864)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 212 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2093z00_572;

			if (SET_EXIT(BgL_an_exit2093z00_572))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
					BgL_an_exit2093z00_572 = (void *) jmpbuf;
					{	/* Heap/restore.scm 212 */

						PUSH_EXIT(BgL_an_exit2093z00_572, ((long) 0));
						{	/* Heap/restore.scm 150 */
							bool_t BgL_val2094z00_573;

							{	/* Heap/restore.scm 150 */
								obj_t BgL_envsz00_574;

								BgL_envsz00_574 = input_obj(BgL_portz00_864);
								{	/* Heap/restore.scm 150 */
									obj_t BgL__z00_575;

									{	/* Heap/restore.scm 151 */
										bool_t BgL_testz00_1144;

										{	/* Heap/restore.scm 151 */
											bool_t BgL_testz00_1145;

											{	/* Heap/restore.scm 151 */
												obj_t BgL_v2098z00_630;

												BgL_v2098z00_630 = create_vector((int) (((long) 1)));
												VECTOR_SET(BgL_v2098z00_630,
													(int) (((long) 0)), BgL_envsz00_574);
												BgL_testz00_1145 = ((bool_t) 1);
											}
											if (BgL_testz00_1145)
												{	/* Heap/restore.scm 152 */
													int BgL_arg2516z00_628;

													BgL_arg2516z00_628 = VECTOR_LENGTH(BgL_envsz00_574);
													BgL_testz00_1144 =
														((long) (BgL_arg2516z00_628) == ((long) 6));
												}
											else
												{	/* Heap/restore.scm 151 */
													BgL_testz00_1144 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_1144)
											{	/* Heap/restore.scm 151 */
												BgL__z00_575 = BFALSE;
											}
										else
											{	/* Heap/restore.scm 151 */
												BgL__z00_575 =
													BGl_errorz00zz__errorz00(BgL_heapz00_865,
													BGl_string2577z00zzheap_restorez00, BgL_envsz00_574);
											}
									}
									{	/* Heap/restore.scm 151 */
										obj_t BgL_targetz00_576;

										BgL_targetz00_576 =
											VECTOR_REF(BgL_envsz00_574, (int) (((long) 0)));
										{	/* Heap/restore.scm 154 */
											obj_t BgL_versionz00_577;

											BgL_versionz00_577 =
												VECTOR_REF(BgL_envsz00_574, (int) (((long) 1)));
											{	/* Heap/restore.scm 155 */
												obj_t BgL_specificz00_578;

												BgL_specificz00_578 =
													VECTOR_REF(BgL_envsz00_574, (int) (((long) 2)));
												{	/* Heap/restore.scm 156 */
													obj_t BgL_genvz00_579;

													BgL_genvz00_579 =
														VECTOR_REF(BgL_envsz00_574, (int) (((long) 3)));
													{	/* Heap/restore.scm 157 */
														obj_t BgL_tenvz00_580;

														BgL_tenvz00_580 =
															VECTOR_REF(BgL_envsz00_574, (int) (((long) 4)));
														{	/* Heap/restore.scm 158 */
															obj_t BgL_includesz00_581;

															BgL_includesz00_581 =
																VECTOR_REF(BgL_envsz00_574, (int) (((long) 5)));
															{	/* Heap/restore.scm 159 */

																if (BGl_backendzd2heapzd2compatiblezf3zf3zzheap_restorez00(BgL_targetz00_576))
																	{	/* Heap/restore.scm 161 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 162 */
																		obj_t BgL_arg2437z00_584;

																		{	/* Heap/restore.scm 164 */
																			obj_t BgL_arg2444z00_586;

																			{	/* Heap/restore.scm 166 */
																				obj_t BgL_arg2452z00_589;

																				BgL_arg2452z00_589 =
																					BGl_thezd2backendzd2zzbackend_backendz00
																					();
																				{
																					BgL_backendz00_bglt BgL_auxz00_1169;

																					BgL_auxz00_1169 =
																						(BgL_backendz00_bglt)
																						(BgL_arg2452z00_589);
																					BgL_arg2444z00_586 =
																						(((BgL_backendz00_bglt)
																							CREF(BgL_auxz00_1169))->
																						BgL_languagez00);
																				}
																			}
																			{	/* Heap/restore.scm 164 */
																				obj_t BgL_list2445z00_587;

																				{	/* Heap/restore.scm 164 */
																					obj_t BgL_arg2446z00_588;

																					BgL_arg2446z00_588 =
																						MAKE_PAIR(BgL_arg2444z00_586, BNIL);
																					BgL_list2445z00_587 =
																						MAKE_PAIR(BgL_targetz00_576,
																						BgL_arg2446z00_588);
																				}
																				BgL_arg2437z00_584 =
																					BGl_formatz00zz__r4_output_6_10_3z00
																					(BGl_string2578z00zzheap_restorez00,
																					BgL_list2445z00_587);
																			}
																		}
																		BGl_errorz00zz__errorz00(BgL_heapz00_865,
																			BGl_string2579z00zzheap_restorez00,
																			BgL_arg2437z00_584);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_versionz00_577,
																		BGl_za2bigloozd2versionza2zd2zzengine_paramz00))
																	{	/* Heap/restore.scm 167 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 168 */
																		obj_t BgL_arg2462z00_592;

																		{	/* Heap/restore.scm 170 */
																			obj_t BgL_list2463z00_593;

																			{	/* Heap/restore.scm 170 */
																				obj_t BgL_arg2464z00_594;

																				BgL_arg2464z00_594 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2versionza2zd2zzengine_paramz00,
																					BNIL);
																				BgL_list2463z00_593 =
																					MAKE_PAIR(BgL_versionz00_577,
																					BgL_arg2464z00_594);
																			}
																			BgL_arg2462z00_592 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2580z00zzheap_restorez00,
																				BgL_list2463z00_593);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2581z00zzheap_restorez00,
																			BgL_arg2462z00_592);
																	}
																if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00
																	(BgL_specificz00_578,
																		BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00))
																	{	/* Heap/restore.scm 173 */
																		BFALSE;
																	}
																else
																	{	/* Heap/restore.scm 174 */
																		obj_t BgL_arg2467z00_597;

																		{	/* Heap/restore.scm 176 */
																			obj_t BgL_list2468z00_598;

																			{	/* Heap/restore.scm 176 */
																				obj_t BgL_arg2469z00_599;

																				BgL_arg2469z00_599 =
																					MAKE_PAIR
																					(BGl_za2bigloozd2specificzd2versionza2z00zzengine_paramz00,
																					BNIL);
																				BgL_list2468z00_598 =
																					MAKE_PAIR(BgL_specificz00_578,
																					BgL_arg2469z00_599);
																			}
																			BgL_arg2467z00_597 =
																				BGl_formatz00zz__r4_output_6_10_3z00
																				(BGl_string2580z00zzheap_restorez00,
																				BgL_list2468z00_598);
																		}
																		BGl_errorz00zz__errorz00
																			(BGl_za2heapzd2nameza2zd2zzengine_paramz00,
																			BGl_string2582z00zzheap_restorez00,
																			BgL_arg2467z00_597);
																	}
																BGl_addzd2tenvz12zc0zztype_envz00
																	(BgL_tenvz00_580);
																BGl_addzd2genvz12zc0zzast_envz00
																	(BgL_genvz00_579);
																{	/* Heap/restore.scm 192 */
																	bool_t BgL_testz00_1190;

																	{	/* Heap/restore.scm 192 */
																		obj_t BgL_arg2482z00_610;

																		BgL_arg2482z00_610 =
																			BGl_thezd2backendzd2zzbackend_backendz00
																			();
																		{
																			BgL_backendz00_bglt BgL_auxz00_1192;

																			BgL_auxz00_1192 =
																				(BgL_backendz00_bglt)
																				(BgL_arg2482z00_610);
																			BgL_testz00_1190 =
																				(((BgL_backendz00_bglt)
																					CREF(BgL_auxz00_1192))->
																				BgL_qualifiedzd2typeszd2);
																		}
																	}
																	if (BgL_testz00_1190)
																		{	/* Heap/restore.scm 192 */
																			BGl_forzd2eachzd2globalz12z12zzast_envz00
																				(BGl_proc2588z00zzheap_restorez00,
																				BNIL);
																		}
																	else
																		{	/* Heap/restore.scm 192 */
																			BFALSE;
																		}
																}
																BGl_hashtablezd2forzd2eachz00zz__hashz00
																	(BgL_genvz00_579,
																	BGl_proc2589z00zzheap_restorez00);
																BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00
																	=
																	bgl_append2
																	(BGl_za2additionalzd2includezd2foreignza2z00zzengine_paramz00,
																	BgL_includesz00_581);
																BgL_val2094z00_573 = ((bool_t) 1);
															}
														}
													}
												}
											}
										}
									}
								}
							}
							POP_EXIT();
							return BBOOL(BgL_val2094z00_573);
						}
					}
				}
		}
	}



/* _restore-additional-heap */
	obj_t BGl__restorezd2additionalzd2heapz00zzheap_restorez00(obj_t
		BgL_envz00_855, obj_t BgL_heapz00_856)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 139 */
			return
				BGl_restorezd2additionalzd2heapz00zzheap_restorez00(BgL_heapz00_856);
		}
	}



/* <anonymous:2495> */
	obj_t BGl_zc3anonymousza32495ze3z83zzheap_restorez00(obj_t BgL_envz00_857,
		obj_t BgL_kz00_858, obj_t BgL_bucketz00_859)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 202 */
			{
				obj_t BgL_kz00_612;

				obj_t BgL_bucketz00_613;

				{	/* Heap/restore.scm 203 */
					bool_t BgL_auxz00_1201;

					BgL_kz00_612 = BgL_kz00_858;
					BgL_bucketz00_613 = BgL_bucketz00_859;
					{	/* Heap/restore.scm 203 */
						obj_t BgL_g2101z00_615;

						BgL_g2101z00_615 = CDR(BgL_bucketz00_613);
						{
							obj_t BgL_l2099z00_617;

							BgL_l2099z00_617 = BgL_g2101z00_615;
						BgL_zc3anonymousza32496ze3z83_618:
							if (PAIRP(BgL_l2099z00_617))
								{	/* Heap/restore.scm 206 */
									{	/* Heap/restore.scm 204 */
										obj_t BgL_newz00_620;

										BgL_newz00_620 = CAR(BgL_l2099z00_617);
										{	/* Heap/restore.scm 205 */
											obj_t BgL_arg2502z00_621;

											{
												BgL_globalz00_bglt BgL_auxz00_1206;

												BgL_auxz00_1206 = (BgL_globalz00_bglt) (BgL_newz00_620);
												BgL_arg2502z00_621 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1206))->
													BgL_modulez00);
											}
											{	/* Heap/restore.scm 204 */
												obj_t BgL_list2503z00_622;

												BgL_list2503z00_622 =
													MAKE_PAIR(BgL_arg2502z00_621, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list2503z00_622);
											}
										}
									}
									{
										obj_t BgL_l2099z00_1211;

										BgL_l2099z00_1211 = CDR(BgL_l2099z00_617);
										BgL_l2099z00_617 = BgL_l2099z00_1211;
										goto BgL_zc3anonymousza32496ze3z83_618;
									}
								}
							else
								{	/* Heap/restore.scm 206 */
									BgL_auxz00_1201 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1201);
				}
			}
		}
	}



/* <anonymous:2473> */
	obj_t BGl_zc3anonymousza32473ze3z83zzheap_restorez00(obj_t BgL_envz00_860,
		obj_t BgL_newz00_861)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 194 */
			{
				obj_t BgL_newz00_603;

				BgL_newz00_603 = BgL_newz00_861;
				{	/* Heap/restore.scm 196 */
					obj_t BgL_arg2474z00_605;

					obj_t BgL_arg2478z00_606;

					obj_t BgL_arg2479z00_607;

					{
						BgL_globalz00_bglt BgL_auxz00_1214;

						BgL_auxz00_1214 = (BgL_globalz00_bglt) (BgL_newz00_603);
						BgL_arg2474z00_605 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1214))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1217;

						BgL_auxz00_1217 = (BgL_globalz00_bglt) (BgL_newz00_603);
						BgL_arg2478z00_606 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1217))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2479z00_607 = BGl_shapez00zztools_shapez00(BgL_newz00_603);
					{	/* Heap/restore.scm 195 */
						obj_t BgL_list2480z00_608;

						BgL_list2480z00_608 = MAKE_PAIR(BgL_arg2479z00_607, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2474z00_605,
							BgL_arg2478z00_606, BgL_list2480z00_608);
					}
				}
			}
		}
	}



/* heap-module-list */
	BGL_EXPORTED_DEF obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t
		BgL_argsz00_3)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 233 */
			if (NULLP(BgL_argsz00_3))
				{	/* Heap/restore.scm 235 */
					return BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00;
				}
			else
				{	/* Heap/restore.scm 237 */
					bool_t BgL_testz00_1225;

					{	/* Heap/restore.scm 237 */
						obj_t BgL_arg2537z00_639;

						BgL_arg2537z00_639 = CAR(BgL_argsz00_3);
						BgL_testz00_1225 =
							CBOOL(BGl_getpropz00zz__r4_symbols_6_4z00(BgL_arg2537z00_639,
								BGl_za2heapzd2markza2zd2zzheap_restorez00));
					}
					if (BgL_testz00_1225)
						{	/* Heap/restore.scm 237 */
							return BFALSE;
						}
					else
						{	/* Heap/restore.scm 237 */
							{	/* Heap/restore.scm 238 */
								obj_t BgL_arg2529z00_637;

								BgL_arg2529z00_637 = CAR(BgL_argsz00_3);
								BGl_putpropz12z12zz__r4_symbols_6_4z00(BgL_arg2529z00_637,
									BGl_za2heapzd2markza2zd2zzheap_restorez00, BTRUE);
							}
							{	/* Heap/restore.scm 239 */
								obj_t BgL_arg2536z00_638;

								BgL_arg2536z00_638 = CAR(BgL_argsz00_3);
								return (BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00 =
									MAKE_PAIR(BgL_arg2536z00_638,
										BGl_za2heapzd2modulezd2listza2z00zzheap_restorez00),
									BUNSPEC);
							}
						}
				}
		}
	}



/* _heap-module-list */
	obj_t BGl__heapzd2modulezd2listz00zzheap_restorez00(obj_t BgL_envz00_862,
		obj_t BgL_argsz00_863)
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 233 */
			return BGl_heapzd2modulezd2listz00zzheap_restorez00(BgL_argsz00_863);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzheap_restorez00()
	{
		AN_OBJECT;
		{	/* Heap/restore.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 216344604),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzengine_enginez00(((long) 528201616),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzinit_mainz00(((long) 230845835),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
			return
				BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2590z00zzheap_restorez00));
		}
	}

#ifdef __cplusplus
}
#endif
