/*===========================================================================*/
/*   (Object/struct.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Object/struct.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;

	typedef struct BgL_slotz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_srcz00;
		obj_t BgL_classzd2ownerzd2;
		obj_t BgL_typez00;
		bool_t BgL_readzd2onlyzf3z21;
		obj_t BgL_defaultzd2valuezd2;
		obj_t BgL_virtualzd2numzd2;
		obj_t BgL_getterz00;
		obj_t BgL_setterz00;
		obj_t BgL_indexedz00;
		obj_t BgL_userzd2infozd2;
	}              *BgL_slotz00_bglt;


	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t, long,
		obj_t);
	extern obj_t
		BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzobject_structz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzobject_structz00();
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static obj_t
		BGl__genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_cnstzd2initzd2zzobject_structz00();
	static obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00();
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt,
		obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	static obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t
		BGl__genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(obj_t, obj_t,
		obj_t);
	extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t,
		BgL_typez00_bglt, long, obj_t);
	static long BGl_slotszd2lengthzd2zzobject_structz00(obj_t);
	static obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t,
		obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00();
	static obj_t BGl_methodzd2initzd2zzobject_structz00();
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00
		(BgL_typez00_bglt, obj_t);
	static obj_t __cnst[47];


	   
		 
		DEFINE_STRING(BGl_string3160z00zzobject_structz00,
		BgL_bgl_string3160za700za7za7o3166za7, "((", 2);
	      DEFINE_STRING(BGl_string3161z00zzobject_structz00,
		BgL_bgl_string3161za700za7za7o3167za7, ")($1))", 6);
	      DEFINE_STRING(BGl_string3162z00zzobject_structz00,
		BgL_bgl_string3162za700za7za7o3168za7, "object_struct", 13);
	      DEFINE_STRING(BGl_string3163z00zzobject_structz00,
		BgL_bgl_string3163za700za7za7o3169za7,
		"@ class-num object-class-num-set! cast pragma new old object-widening-set! s::struct struct+object->object::object vector-ref-ur done o vector-length s struct-ref f ::long v i struct-key struct-key-set! call-next-method aux ::struct quote make-struct object->struct::struct define-method res obj +fx -ref vector-set-ur! begin struct-set! =fx if labels make-vector -len - let len loop j vec ",
		390);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2widezd2classzc3zd2ze3structzd2envz20zzobject_structz00,
		BgL_bgl__genza7d2wideza7d2cl3170z00,
		BGl__genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2plainzd2classzc3zd2ze3structzd2envz20zzobject_structz00,
		BgL_bgl__genza7d2plainza7d2c3171z00,
		BGl__genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00, 0L, BUNSPEC,
		2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long
		BgL_checksumz00_1471, char *BgL_fromz00_1472)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzobject_structz00))
				{
					BGl_requirezd2initializa7ationz75zzobject_structz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzobject_structz00();
					BGl_cnstzd2initzd2zzobject_structz00();
					BGl_importedzd2moduleszd2initz00zzobject_structz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"object_struct");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			{	/* Object/struct.scm 15 */
				obj_t BgL_cportz00_1463;

				BgL_cportz00_1463 =
					bgl_open_input_string(BGl_string3163z00zzobject_structz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1464;

					BgL_iz00_1464 = ((long) 46);
				BgL_loopz00_1465:
					if ((BgL_iz00_1464 == ((long) -1)))
						{	/* Object/struct.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Object/struct.scm 15 */
							{	/* Object/struct.scm 15 */
								obj_t BgL_arg3165z00_1467;

								{	/* Object/struct.scm 15 */

									{	/* Object/struct.scm 15 */
										obj_t BgL_locationz00_1469;

										BgL_locationz00_1469 = BBOOL(((bool_t) 0));
										{	/* Object/struct.scm 15 */

											BgL_arg3165z00_1467 =
												BGl_readz00zz__readerz00(BgL_cportz00_1463,
												BgL_locationz00_1469);
										}
									}
								}
								{	/* Object/struct.scm 15 */
									int BgL_auxz00_1489;

									BgL_auxz00_1489 = (int) (BgL_iz00_1464);
									CNST_TABLE_SET(BgL_auxz00_1489, BgL_arg3165z00_1467);
							}}
							{	/* Object/struct.scm 15 */
								int BgL_auxz00_1470;

								BgL_auxz00_1470 = (int) ((BgL_iz00_1464 - ((long) 1)));
								{
									long BgL_iz00_1494;

									BgL_iz00_1494 = (long) (BgL_auxz00_1470);
									BgL_iz00_1464 = BgL_iz00_1494;
									goto BgL_loopz00_1465;
								}
							}
						}
				}
			}
		}
	}



/* gen-plain-class<->struct */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt
		BgL_classz00_1, obj_t BgL_srczd2defzd2_2)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 38 */
			{	/* Object/struct.scm 40 */
				bool_t BgL_testz00_1496;

				{	/* Object/struct.scm 40 */
					BgL_tclassz00_bglt BgL_obj2143z00_1368;

					BgL_obj2143z00_1368 = (BgL_tclassz00_bglt) (BgL_classz00_1);
					{
						obj_t BgL_auxz00_1498;

						{	/* Object/struct.scm 40 */
							BgL_objectz00_bglt BgL_auxz00_1499;

							BgL_auxz00_1499 = (BgL_objectz00_bglt) (BgL_obj2143z00_1368);
							BgL_auxz00_1498 = BGL_OBJECT_WIDENING(BgL_auxz00_1499);
						}
						BgL_testz00_1496 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1498))->
							BgL_abstractzf3zf3);
					}
				}
				if (BgL_testz00_1496)
					{	/* Object/struct.scm 40 */
						return BNIL;
					}
				else
					{	/* Object/struct.scm 42 */
						obj_t BgL_arg2407z00_539;

						obj_t BgL_arg2408z00_540;

						{	/* Object/struct.scm 42 */
							obj_t BgL_arg2411z00_543;

							obj_t BgL_arg2415z00_544;

							BgL_arg2411z00_543 =
								(((BgL_typez00_bglt) CREF(BgL_classz00_1))->BgL_idz00);
							{	/* Object/struct.scm 42 */
								BgL_tclassz00_bglt BgL_obj2130z00_1370;

								BgL_obj2130z00_1370 = (BgL_tclassz00_bglt) (BgL_classz00_1);
								{
									obj_t BgL_auxz00_1505;

									{	/* Object/struct.scm 42 */
										BgL_objectz00_bglt BgL_auxz00_1506;

										BgL_auxz00_1506 =
											(BgL_objectz00_bglt) (BgL_obj2130z00_1370);
										BgL_auxz00_1505 = BGL_OBJECT_WIDENING(BgL_auxz00_1506);
									}
									BgL_arg2415z00_544 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1505))->
										BgL_slotsz00);
								}
							}
							BgL_arg2407z00_539 =
								BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00
								(BgL_arg2411z00_543, BgL_classz00_1, BgL_arg2415z00_544,
								BgL_srczd2defzd2_2);
						}
						{	/* Object/struct.scm 43 */
							obj_t BgL_arg2419z00_545;

							obj_t BgL_arg2420z00_546;

							BgL_arg2419z00_545 =
								(((BgL_typez00_bglt) CREF(BgL_classz00_1))->BgL_idz00);
							{	/* Object/struct.scm 43 */
								BgL_tclassz00_bglt BgL_obj2130z00_1372;

								BgL_obj2130z00_1372 = (BgL_tclassz00_bglt) (BgL_classz00_1);
								{
									obj_t BgL_auxz00_1513;

									{	/* Object/struct.scm 43 */
										BgL_objectz00_bglt BgL_auxz00_1514;

										BgL_auxz00_1514 =
											(BgL_objectz00_bglt) (BgL_obj2130z00_1372);
										BgL_auxz00_1513 = BGL_OBJECT_WIDENING(BgL_auxz00_1514);
									}
									BgL_arg2420z00_546 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1513))->
										BgL_slotsz00);
								}
							}
							BgL_arg2408z00_540 =
								BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00
								(BgL_arg2419z00_545, BgL_classz00_1, BgL_arg2420z00_546,
								BgL_srczd2defzd2_2);
						}
						{	/* Object/struct.scm 42 */
							obj_t BgL_list2409z00_541;

							{	/* Object/struct.scm 42 */
								obj_t BgL_arg2410z00_542;

								BgL_arg2410z00_542 = MAKE_PAIR(BgL_arg2408z00_540, BNIL);
								BgL_list2409z00_541 =
									MAKE_PAIR(BgL_arg2407z00_539, BgL_arg2410z00_542);
							}
							return BgL_list2409z00_541;
						}
					}
			}
		}
	}



/* _gen-plain-class<->struct */
	obj_t BGl__genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(obj_t
		BgL_envz00_1457, obj_t BgL_classz00_1458, obj_t BgL_srczd2defzd2_1459)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 38 */
			return
				BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(
				(BgL_typez00_bglt) (BgL_classz00_1458), BgL_srczd2defzd2_1459);
		}
	}



/* gen-wide-class<->struct */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt
		BgL_classz00_3, obj_t BgL_srczd2defzd2_4)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 48 */
			{	/* Object/struct.scm 50 */
				obj_t BgL_arg2421z00_548;

				obj_t BgL_arg2431z00_549;

				{	/* Object/struct.scm 50 */
					obj_t BgL_arg2442z00_552;

					obj_t BgL_arg2444z00_553;

					BgL_arg2442z00_552 =
						(((BgL_typez00_bglt) CREF(BgL_classz00_3))->BgL_idz00);
					{	/* Object/struct.scm 50 */
						BgL_tclassz00_bglt BgL_obj2130z00_1376;

						BgL_obj2130z00_1376 = (BgL_tclassz00_bglt) (BgL_classz00_3);
						{
							obj_t BgL_auxz00_1525;

							{	/* Object/struct.scm 50 */
								BgL_objectz00_bglt BgL_auxz00_1526;

								BgL_auxz00_1526 = (BgL_objectz00_bglt) (BgL_obj2130z00_1376);
								BgL_auxz00_1525 = BGL_OBJECT_WIDENING(BgL_auxz00_1526);
							}
							BgL_arg2444z00_553 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1525))->BgL_slotsz00);
						}
					}
					BgL_arg2421z00_548 =
						BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00
						(BgL_arg2442z00_552, BgL_classz00_3, BgL_arg2444z00_553,
						BgL_srczd2defzd2_4);
				}
				{	/* Object/struct.scm 51 */
					obj_t BgL_arg2446z00_554;

					obj_t BgL_arg2452z00_555;

					BgL_arg2446z00_554 =
						(((BgL_typez00_bglt) CREF(BgL_classz00_3))->BgL_idz00);
					{	/* Object/struct.scm 51 */
						BgL_tclassz00_bglt BgL_obj2130z00_1378;

						BgL_obj2130z00_1378 = (BgL_tclassz00_bglt) (BgL_classz00_3);
						{
							obj_t BgL_auxz00_1533;

							{	/* Object/struct.scm 51 */
								BgL_objectz00_bglt BgL_auxz00_1534;

								BgL_auxz00_1534 = (BgL_objectz00_bglt) (BgL_obj2130z00_1378);
								BgL_auxz00_1533 = BGL_OBJECT_WIDENING(BgL_auxz00_1534);
							}
							BgL_arg2452z00_555 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1533))->BgL_slotsz00);
						}
					}
					BgL_arg2431z00_549 =
						BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00
						(BgL_arg2446z00_554, BgL_classz00_3, BgL_arg2452z00_555,
						BgL_srczd2defzd2_4);
				}
				{	/* Object/struct.scm 50 */
					obj_t BgL_list2432z00_550;

					{	/* Object/struct.scm 50 */
						obj_t BgL_arg2437z00_551;

						BgL_arg2437z00_551 = MAKE_PAIR(BgL_arg2431z00_549, BNIL);
						BgL_list2432z00_550 =
							MAKE_PAIR(BgL_arg2421z00_548, BgL_arg2437z00_551);
					}
					return BgL_list2432z00_550;
				}
			}
		}
	}



/* _gen-wide-class<->struct */
	obj_t BGl__genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(obj_t
		BgL_envz00_1460, obj_t BgL_classz00_1461, obj_t BgL_srczd2defzd2_1462)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 48 */
			return
				BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(
				(BgL_typez00_bglt) (BgL_classz00_1461), BgL_srczd2defzd2_1462);
		}
	}



/* save-slot */
	obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_5,
		obj_t BgL_snamez00_6, obj_t BgL_cnamez00_7, long BgL_iz00_8,
		obj_t BgL_slotz00_9)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 56 */
			{

				if (BGl_slotzd2virtualzf3z21zzobject_slotsz00(
						(BgL_slotz00_bglt) (BgL_slotz00_9)))
					{	/* Object/struct.scm 84 */
						return BUNSPEC;
					}
				else
					{	/* Object/struct.scm 86 */
						bool_t BgL_testz00_1546;

						{	/* Object/struct.scm 86 */
							BgL_slotz00_bglt BgL_obj2353z00_1381;

							BgL_obj2353z00_1381 = (BgL_slotz00_bglt) (BgL_slotz00_9);
							BgL_testz00_1546 =
								CBOOL(
								(((BgL_slotz00_bglt) CREF(BgL_obj2353z00_1381))->
									BgL_indexedz00));
						}
						if (BgL_testz00_1546)
							{	/* Object/struct.scm 86 */
								{	/* Object/struct.scm 63 */
									obj_t BgL_vecz00_561;

									obj_t BgL_jz00_562;

									obj_t BgL_loopz00_563;

									obj_t BgL_lenz00_564;

									BgL_vecz00_561 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												0)));
									BgL_jz00_562 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												1)));
									BgL_loopz00_563 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												2)));
									BgL_lenz00_564 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												3)));
									{	/* Object/struct.scm 67 */
										obj_t BgL_arg2458z00_565;

										obj_t BgL_arg2462z00_566;

										BgL_arg2458z00_565 = CNST_TABLE_REF(((long) 4));
										{	/* Object/struct.scm 67 */
											obj_t BgL_arg2463z00_567;

											obj_t BgL_arg2464z00_568;

											{	/* Object/struct.scm 67 */
												obj_t BgL_arg2468z00_572;

												{	/* Object/struct.scm 67 */
													obj_t BgL_arg2470z00_574;

													{	/* Object/struct.scm 67 */
														obj_t BgL_arg2471z00_575;

														{	/* Object/struct.scm 67 */
															obj_t BgL_arg2474z00_578;

															obj_t BgL_arg2478z00_579;

															{	/* Object/struct.scm 67 */
																obj_t BgL_arg2479z00_580;

																obj_t BgL_arg2482z00_581;

																obj_t BgL_arg2494z00_582;

																BgL_arg2479z00_580 = CNST_TABLE_REF(((long) 5));
																{
																	BgL_slotz00_bglt BgL_auxz00_1560;

																	BgL_auxz00_1560 =
																		(BgL_slotz00_bglt) (BgL_slotz00_9);
																	BgL_arg2482z00_581 =
																		(((BgL_slotz00_bglt)
																			CREF(BgL_auxz00_1560))->BgL_idz00);
																}
																BgL_arg2494z00_582 = CNST_TABLE_REF(((long) 6));
																{	/* Object/struct.scm 67 */
																	obj_t BgL_list2495z00_583;

																	{	/* Object/struct.scm 67 */
																		obj_t BgL_arg2496z00_584;

																		{	/* Object/struct.scm 67 */
																			obj_t BgL_arg2497z00_585;

																			{	/* Object/struct.scm 67 */
																				obj_t BgL_arg2498z00_586;

																				BgL_arg2498z00_586 =
																					MAKE_PAIR(BgL_arg2494z00_582, BNIL);
																				BgL_arg2497z00_585 =
																					MAKE_PAIR(BgL_arg2482z00_581,
																					BgL_arg2498z00_586);
																			}
																			BgL_arg2496z00_584 =
																				MAKE_PAIR(BgL_arg2479z00_580,
																				BgL_arg2497z00_585);
																		}
																		BgL_list2495z00_583 =
																			MAKE_PAIR(BgL_cnamez00_7,
																			BgL_arg2496z00_584);
																	}
																	BgL_arg2474z00_578 =
																		BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																		(BgL_list2495z00_583);
															}}
															{	/* Object/struct.scm 67 */
																obj_t BgL_list2499z00_587;

																BgL_list2499z00_587 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg2478z00_579 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_onamez00_5, BgL_list2499z00_587);
															}
															BgL_arg2471z00_575 =
																MAKE_PAIR(BgL_arg2474z00_578,
																BgL_arg2478z00_579);
														}
														{	/* Object/struct.scm 67 */
															obj_t BgL_list2473z00_577;

															BgL_list2473z00_577 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2470z00_574 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2471z00_575, BgL_list2473z00_577);
													}}
													BgL_arg2468z00_572 =
														MAKE_PAIR(BgL_lenz00_564, BgL_arg2470z00_574);
												}
												BgL_arg2463z00_567 =
													MAKE_PAIR(BgL_arg2468z00_572, BNIL);
											}
											{	/* Object/struct.scm 68 */
												obj_t BgL_arg2502z00_588;

												obj_t BgL_arg2510z00_589;

												BgL_arg2502z00_588 = CNST_TABLE_REF(((long) 4));
												{	/* Object/struct.scm 68 */
													obj_t BgL_arg2516z00_590;

													obj_t BgL_arg2523z00_591;

													{	/* Object/struct.scm 68 */
														obj_t BgL_arg2537z00_595;

														{	/* Object/struct.scm 68 */
															obj_t BgL_arg2550z00_597;

															{	/* Object/struct.scm 68 */
																obj_t BgL_arg2555z00_598;

																{	/* Object/struct.scm 68 */
																	obj_t BgL_arg2559z00_601;

																	obj_t BgL_arg2560z00_602;

																	BgL_arg2559z00_601 =
																		CNST_TABLE_REF(((long) 7));
																	{	/* Object/struct.scm 68 */
																		obj_t BgL_list2561z00_603;

																		BgL_list2561z00_603 = MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2560z00_602 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_lenz00_564, BgL_list2561z00_603);
																	}
																	BgL_arg2555z00_598 =
																		MAKE_PAIR(BgL_arg2559z00_601,
																		BgL_arg2560z00_602);
																}
																{	/* Object/struct.scm 68 */
																	obj_t BgL_list2558z00_600;

																	BgL_list2558z00_600 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2550z00_597 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2555z00_598, BgL_list2558z00_600);
															}}
															BgL_arg2537z00_595 =
																MAKE_PAIR(BgL_vecz00_561, BgL_arg2550z00_597);
														}
														BgL_arg2516z00_590 =
															MAKE_PAIR(BgL_arg2537z00_595, BNIL);
													}
													{	/* Object/struct.scm 69 */
														obj_t BgL_arg2562z00_604;

														obj_t BgL_arg2563z00_605;

														BgL_arg2562z00_604 = CNST_TABLE_REF(((long) 8));
														{	/* Object/struct.scm 69 */
															obj_t BgL_arg2564z00_606;

															obj_t BgL_arg2565z00_607;

															{	/* Object/struct.scm 69 */
																obj_t BgL_arg2571z00_611;

																{	/* Object/struct.scm 69 */
																	obj_t BgL_arg2574z00_613;

																	{	/* Object/struct.scm 69 */
																		obj_t BgL_arg2575z00_614;

																		obj_t BgL_arg2576z00_615;

																		BgL_arg2575z00_614 =
																			MAKE_PAIR(BgL_jz00_562, BNIL);
																		{	/* Object/struct.scm 69 */
																			obj_t BgL_arg2580z00_619;

																			obj_t BgL_arg2581z00_620;

																			BgL_arg2580z00_619 =
																				CNST_TABLE_REF(((long) 9));
																			{	/* Object/struct.scm 69 */
																				obj_t BgL_arg2582z00_621;

																				obj_t BgL_arg2583z00_622;

																				obj_t BgL_arg2584z00_623;

																				{	/* Object/struct.scm 69 */
																					obj_t BgL_arg2589z00_628;

																					obj_t BgL_arg2590z00_629;

																					BgL_arg2589z00_628 =
																						CNST_TABLE_REF(((long) 10));
																					{	/* Object/struct.scm 69 */
																						obj_t BgL_list2591z00_630;

																						{	/* Object/struct.scm 69 */
																							obj_t BgL_arg2592z00_631;

																							BgL_arg2592z00_631 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2591z00_630 =
																								MAKE_PAIR(BgL_lenz00_564,
																								BgL_arg2592z00_631);
																						}
																						BgL_arg2590z00_629 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_jz00_562,
																							BgL_list2591z00_630);
																					}
																					BgL_arg2582z00_621 =
																						MAKE_PAIR(BgL_arg2589z00_628,
																						BgL_arg2590z00_629);
																				}
																				{	/* Object/struct.scm 70 */
																					obj_t BgL_arg2593z00_632;

																					obj_t BgL_arg2594z00_633;

																					BgL_arg2593z00_632 =
																						CNST_TABLE_REF(((long) 11));
																					{	/* Object/struct.scm 70 */
																						obj_t BgL_list2595z00_634;

																						{	/* Object/struct.scm 70 */
																							obj_t BgL_arg2596z00_635;

																							{	/* Object/struct.scm 70 */
																								obj_t BgL_arg2597z00_636;

																								BgL_arg2597z00_636 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2596z00_635 =
																									MAKE_PAIR(BgL_vecz00_561,
																									BgL_arg2597z00_636);
																							}
																							BgL_list2595z00_634 =
																								MAKE_PAIR(BINT(BgL_iz00_8),
																								BgL_arg2596z00_635);
																						}
																						BgL_arg2594z00_633 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_snamez00_6,
																							BgL_list2595z00_634);
																					}
																					BgL_arg2583z00_622 =
																						MAKE_PAIR(BgL_arg2593z00_632,
																						BgL_arg2594z00_633);
																				}
																				{	/* Object/struct.scm 71 */
																					obj_t BgL_arg2598z00_637;

																					obj_t BgL_arg2600z00_638;

																					BgL_arg2598z00_637 =
																						CNST_TABLE_REF(((long) 12));
																					{	/* Object/struct.scm 72 */
																						obj_t BgL_arg2601z00_639;

																						obj_t BgL_arg2602z00_640;

																						{	/* Object/struct.scm 72 */
																							obj_t BgL_arg2607z00_644;

																							obj_t BgL_arg2608z00_645;

																							BgL_arg2607z00_644 =
																								CNST_TABLE_REF(((long) 13));
																							{	/* Object/struct.scm 76 */
																								obj_t BgL_arg2609z00_646;

																								{	/* Object/struct.scm 76 */
																									obj_t BgL_arg2614z00_651;

																									obj_t BgL_arg2615z00_652;

																									{	/* Object/struct.scm 76 */
																										obj_t BgL_arg2616z00_653;

																										obj_t BgL_arg2617z00_654;

																										obj_t BgL_arg2618z00_655;

																										BgL_arg2616z00_653 =
																											CNST_TABLE_REF(((long)
																												5));
																										{
																											BgL_slotz00_bglt
																												BgL_auxz00_1603;
																											BgL_auxz00_1603 =
																												(BgL_slotz00_bglt)
																												(BgL_slotz00_9);
																											BgL_arg2617z00_654 =
																												(((BgL_slotz00_bglt)
																													CREF
																													(BgL_auxz00_1603))->
																												BgL_idz00);
																										}
																										BgL_arg2618z00_655 =
																											CNST_TABLE_REF(((long)
																												14));
																										{	/* Object/struct.scm 75 */
																											obj_t BgL_list2619z00_656;

																											{	/* Object/struct.scm 75 */
																												obj_t
																													BgL_arg2620z00_657;
																												{	/* Object/struct.scm 75 */
																													obj_t
																														BgL_arg2621z00_658;
																													{	/* Object/struct.scm 75 */
																														obj_t
																															BgL_arg2622z00_659;
																														BgL_arg2622z00_659 =
																															MAKE_PAIR
																															(BgL_arg2618z00_655,
																															BNIL);
																														BgL_arg2621z00_658 =
																															MAKE_PAIR
																															(BgL_arg2617z00_654,
																															BgL_arg2622z00_659);
																													}
																													BgL_arg2620z00_657 =
																														MAKE_PAIR
																														(BgL_arg2616z00_653,
																														BgL_arg2621z00_658);
																												}
																												BgL_list2619z00_656 =
																													MAKE_PAIR
																													(BgL_cnamez00_7,
																													BgL_arg2620z00_657);
																											}
																											BgL_arg2614z00_651 =
																												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																												(BgL_list2619z00_656);
																									}}
																									{	/* Object/struct.scm 75 */
																										obj_t BgL_list2623z00_660;

																										{	/* Object/struct.scm 75 */
																											obj_t BgL_arg2624z00_661;

																											BgL_arg2624z00_661 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_list2623z00_660 =
																												MAKE_PAIR(BgL_jz00_562,
																												BgL_arg2624z00_661);
																										}
																										BgL_arg2615z00_652 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_onamez00_5,
																											BgL_list2623z00_660);
																									}
																									BgL_arg2609z00_646 =
																										MAKE_PAIR
																										(BgL_arg2614z00_651,
																										BgL_arg2615z00_652);
																								}
																								{	/* Object/struct.scm 72 */
																									obj_t BgL_list2611z00_648;

																									{	/* Object/struct.scm 72 */
																										obj_t BgL_arg2612z00_649;

																										{	/* Object/struct.scm 72 */
																											obj_t BgL_arg2613z00_650;

																											BgL_arg2613z00_650 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2612z00_649 =
																												MAKE_PAIR
																												(BgL_arg2609z00_646,
																												BgL_arg2613z00_650);
																										}
																										BgL_list2611z00_648 =
																											MAKE_PAIR(BgL_jz00_562,
																											BgL_arg2612z00_649);
																									}
																									BgL_arg2608z00_645 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_vecz00_561,
																										BgL_list2611z00_648);
																							}}
																							BgL_arg2601z00_639 =
																								MAKE_PAIR(BgL_arg2607z00_644,
																								BgL_arg2608z00_645);
																						}
																						{	/* Object/struct.scm 81 */
																							obj_t BgL_arg2625z00_662;

																							{	/* Object/struct.scm 81 */
																								obj_t BgL_arg2626z00_663;

																								{	/* Object/struct.scm 81 */
																									obj_t BgL_arg2629z00_666;

																									obj_t BgL_arg2630z00_667;

																									BgL_arg2629z00_666 =
																										CNST_TABLE_REF(((long) 15));
																									{	/* Object/struct.scm 81 */
																										obj_t BgL_list2631z00_668;

																										{	/* Object/struct.scm 81 */
																											obj_t BgL_arg2633z00_670;

																											BgL_arg2633z00_670 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_list2631z00_668 =
																												MAKE_PAIR(BINT(((long)
																														1)),
																												BgL_arg2633z00_670);
																										}
																										BgL_arg2630z00_667 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_jz00_562,
																											BgL_list2631z00_668);
																									}
																									BgL_arg2626z00_663 =
																										MAKE_PAIR
																										(BgL_arg2629z00_666,
																										BgL_arg2630z00_667);
																								}
																								{	/* Object/struct.scm 81 */
																									obj_t BgL_list2628z00_665;

																									BgL_list2628z00_665 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg2625z00_662 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg2626z00_663,
																										BgL_list2628z00_665);
																							}}
																							BgL_arg2602z00_640 =
																								MAKE_PAIR(BgL_loopz00_563,
																								BgL_arg2625z00_662);
																						}
																						{	/* Object/struct.scm 71 */
																							obj_t BgL_list2604z00_642;

																							{	/* Object/struct.scm 71 */
																								obj_t BgL_arg2606z00_643;

																								BgL_arg2606z00_643 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list2604z00_642 =
																									MAKE_PAIR(BgL_arg2602z00_640,
																									BgL_arg2606z00_643);
																							}
																							BgL_arg2600z00_638 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg2601z00_639,
																								BgL_list2604z00_642);
																					}}
																					BgL_arg2584z00_623 =
																						MAKE_PAIR(BgL_arg2598z00_637,
																						BgL_arg2600z00_638);
																				}
																				{	/* Object/struct.scm 69 */
																					obj_t BgL_list2586z00_625;

																					{	/* Object/struct.scm 69 */
																						obj_t BgL_arg2587z00_626;

																						{	/* Object/struct.scm 69 */
																							obj_t BgL_arg2588z00_627;

																							BgL_arg2588z00_627 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2587z00_626 =
																								MAKE_PAIR(BgL_arg2584z00_623,
																								BgL_arg2588z00_627);
																						}
																						BgL_list2586z00_625 =
																							MAKE_PAIR(BgL_arg2583z00_622,
																							BgL_arg2587z00_626);
																					}
																					BgL_arg2581z00_620 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2582z00_621,
																						BgL_list2586z00_625);
																			}}
																			BgL_arg2576z00_615 =
																				MAKE_PAIR(BgL_arg2580z00_619,
																				BgL_arg2581z00_620);
																		}
																		{	/* Object/struct.scm 69 */
																			obj_t BgL_list2578z00_617;

																			{	/* Object/struct.scm 69 */
																				obj_t BgL_arg2579z00_618;

																				BgL_arg2579z00_618 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2578z00_617 =
																					MAKE_PAIR(BgL_arg2576z00_615,
																					BgL_arg2579z00_618);
																			}
																			BgL_arg2574z00_613 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2575z00_614,
																				BgL_list2578z00_617);
																	}}
																	BgL_arg2571z00_611 =
																		MAKE_PAIR(BgL_loopz00_563,
																		BgL_arg2574z00_613);
																}
																BgL_arg2564z00_606 =
																	MAKE_PAIR(BgL_arg2571z00_611, BNIL);
															}
															{	/* Object/struct.scm 82 */
																obj_t BgL_arg2634z00_671;

																{	/* Object/struct.scm 82 */
																	obj_t BgL_list2635z00_672;

																	BgL_list2635z00_672 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2634z00_671 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BINT(((long) 0)), BgL_list2635z00_672);
																}
																BgL_arg2565z00_607 =
																	MAKE_PAIR(BgL_loopz00_563,
																	BgL_arg2634z00_671);
															}
															{	/* Object/struct.scm 69 */
																obj_t BgL_list2569z00_609;

																{	/* Object/struct.scm 69 */
																	obj_t BgL_arg2570z00_610;

																	BgL_arg2570z00_610 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list2569z00_609 =
																		MAKE_PAIR(BgL_arg2565z00_607,
																		BgL_arg2570z00_610);
																}
																BgL_arg2563z00_605 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg2564z00_606, BgL_list2569z00_609);
														}}
														BgL_arg2523z00_591 =
															MAKE_PAIR(BgL_arg2562z00_604, BgL_arg2563z00_605);
													}
													{	/* Object/struct.scm 68 */
														obj_t BgL_list2530z00_593;

														{	/* Object/struct.scm 68 */
															obj_t BgL_arg2536z00_594;

															BgL_arg2536z00_594 = MAKE_PAIR(BNIL, BNIL);
															BgL_list2530z00_593 =
																MAKE_PAIR(BgL_arg2523z00_591,
																BgL_arg2536z00_594);
														}
														BgL_arg2510z00_589 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_arg2516z00_590, BgL_list2530z00_593);
												}}
												BgL_arg2464z00_568 =
													MAKE_PAIR(BgL_arg2502z00_588, BgL_arg2510z00_589);
											}
											{	/* Object/struct.scm 67 */
												obj_t BgL_list2466z00_570;

												{	/* Object/struct.scm 67 */
													obj_t BgL_arg2467z00_571;

													BgL_arg2467z00_571 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2466z00_570 =
														MAKE_PAIR(BgL_arg2464z00_568, BgL_arg2467z00_571);
												}
												BgL_arg2462z00_566 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2463z00_567, BgL_list2466z00_570);
										}}
										return MAKE_PAIR(BgL_arg2458z00_565, BgL_arg2462z00_566);
									}
								}
							}
						else
							{	/* Object/struct.scm 86 */
								{	/* Object/struct.scm 58 */
									obj_t BgL_arg2637z00_674;

									obj_t BgL_arg2638z00_675;

									BgL_arg2637z00_674 = CNST_TABLE_REF(((long) 11));
									{	/* Object/struct.scm 60 */
										obj_t BgL_arg2639z00_676;

										{	/* Object/struct.scm 60 */
											obj_t BgL_arg2644z00_681;

											obj_t BgL_arg2645z00_682;

											{	/* Object/struct.scm 60 */
												obj_t BgL_arg2646z00_683;

												obj_t BgL_arg2647z00_684;

												BgL_arg2646z00_683 = CNST_TABLE_REF(((long) 5));
												{
													BgL_slotz00_bglt BgL_auxz00_1662;

													BgL_auxz00_1662 = (BgL_slotz00_bglt) (BgL_slotz00_9);
													BgL_arg2647z00_684 =
														(((BgL_slotz00_bglt) CREF(BgL_auxz00_1662))->
														BgL_idz00);
												}
												{	/* Object/struct.scm 60 */
													obj_t BgL_list2648z00_685;

													{	/* Object/struct.scm 60 */
														obj_t BgL_arg2649z00_686;

														{	/* Object/struct.scm 60 */
															obj_t BgL_arg2650z00_687;

															BgL_arg2650z00_687 =
																MAKE_PAIR(BgL_arg2647z00_684, BNIL);
															BgL_arg2649z00_686 =
																MAKE_PAIR(BgL_arg2646z00_683,
																BgL_arg2650z00_687);
														}
														BgL_list2648z00_685 =
															MAKE_PAIR(BgL_cnamez00_7, BgL_arg2649z00_686);
													}
													BgL_arg2644z00_681 =
														BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
														(BgL_list2648z00_685);
											}}
											{	/* Object/struct.scm 60 */
												obj_t BgL_list2651z00_688;

												BgL_list2651z00_688 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg2645z00_682 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_onamez00_5, BgL_list2651z00_688);
											}
											BgL_arg2639z00_676 =
												MAKE_PAIR(BgL_arg2644z00_681, BgL_arg2645z00_682);
										}
										{	/* Object/struct.scm 58 */
											obj_t BgL_list2641z00_678;

											{	/* Object/struct.scm 58 */
												obj_t BgL_arg2642z00_679;

												{	/* Object/struct.scm 58 */
													obj_t BgL_arg2643z00_680;

													BgL_arg2643z00_680 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg2642z00_679 =
														MAKE_PAIR(BgL_arg2639z00_676, BgL_arg2643z00_680);
												}
												BgL_list2641z00_678 =
													MAKE_PAIR(BINT(BgL_iz00_8), BgL_arg2642z00_679);
											}
											BgL_arg2638z00_675 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_snamez00_6, BgL_list2641z00_678);
									}}
									return MAKE_PAIR(BgL_arg2637z00_674, BgL_arg2638z00_675);
								}
							}
					}
			}
		}
	}



/* slots-length */
	long BGl_slotszd2lengthzd2zzobject_structz00(obj_t BgL_slotsz00_10)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 94 */
			{
				obj_t BgL_slotsz00_692;

				long BgL_lenz00_693;

				BgL_slotsz00_692 = BgL_slotsz00_10;
				BgL_lenz00_693 = ((long) 0);
			BgL_zc3anonymousza32652ze3z83_694:
				if (NULLP(BgL_slotsz00_692))
					{	/* Object/struct.scm 98 */
						return BgL_lenz00_693;
					}
				else
					{	/* Object/struct.scm 100 */
						bool_t BgL_testz00_1680;

						{	/* Object/struct.scm 100 */
							obj_t BgL_arg2659z00_700;

							BgL_arg2659z00_700 = CAR(BgL_slotsz00_692);
							BgL_testz00_1680 =
								BGl_slotzd2virtualzf3z21zzobject_slotsz00(
								(BgL_slotz00_bglt) (BgL_arg2659z00_700));
						}
						if (BgL_testz00_1680)
							{
								obj_t BgL_slotsz00_1684;

								BgL_slotsz00_1684 = CDR(BgL_slotsz00_692);
								BgL_slotsz00_692 = BgL_slotsz00_1684;
								goto BgL_zc3anonymousza32652ze3z83_694;
							}
						else
							{
								long BgL_lenz00_1688;

								obj_t BgL_slotsz00_1686;

								BgL_slotsz00_1686 = CDR(BgL_slotsz00_692);
								BgL_lenz00_1688 = (((long) 1) + BgL_lenz00_693);
								BgL_lenz00_693 = BgL_lenz00_1688;
								BgL_slotsz00_692 = BgL_slotsz00_1686;
								goto BgL_zc3anonymousza32652ze3z83_694;
							}
					}
			}
		}
	}



/* gen-plain-class->struct */
	obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t
		BgL_cnamez00_11, BgL_typez00_bglt BgL_typez00_12, obj_t BgL_slotsz00_13,
		obj_t BgL_srczd2defzd2_14)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 108 */
			{	/* Object/struct.scm 109 */
				long BgL_lenz00_702;

				obj_t BgL_onamez00_703;

				obj_t BgL_snamez00_704;

				BgL_lenz00_702 =
					(((long) 1) +
					BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_13));
				BgL_onamez00_703 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 16)));
				BgL_snamez00_704 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 17)));
				{	/* Object/struct.scm 113 */
					obj_t BgL_arg2660z00_705;

					{	/* Object/struct.scm 113 */
						obj_t BgL_arg2661z00_706;

						obj_t BgL_arg2662z00_707;

						BgL_arg2661z00_706 = CNST_TABLE_REF(((long) 18));
						{	/* Object/struct.scm 113 */
							obj_t BgL_arg2663z00_708;

							obj_t BgL_arg2664z00_709;

							{	/* Object/struct.scm 113 */
								obj_t BgL_arg2669z00_713;

								obj_t BgL_arg2670z00_714;

								BgL_arg2669z00_713 = CNST_TABLE_REF(((long) 19));
								{	/* Object/struct.scm 113 */
									obj_t BgL_arg2671z00_715;

									BgL_arg2671z00_715 =
										BGl_makezd2typedzd2identz00zzast_identz00(BgL_onamez00_703,
										BgL_cnamez00_11);
									{	/* Object/struct.scm 113 */
										obj_t BgL_list2673z00_717;

										BgL_list2673z00_717 = MAKE_PAIR(BNIL, BNIL);
										BgL_arg2670z00_714 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg2671z00_715, BgL_list2673z00_717);
								}}
								BgL_arg2663z00_708 =
									MAKE_PAIR(BgL_arg2669z00_713, BgL_arg2670z00_714);
							}
							{	/* Object/struct.scm 114 */
								obj_t BgL_arg2674z00_718;

								obj_t BgL_arg2675z00_719;

								BgL_arg2674z00_718 = CNST_TABLE_REF(((long) 4));
								{	/* Object/struct.scm 114 */
									obj_t BgL_arg2676z00_720;

									obj_t BgL_arg2677z00_721;

									{	/* Object/struct.scm 114 */
										obj_t BgL_arg2681z00_725;

										{	/* Object/struct.scm 114 */
											obj_t BgL_arg2683z00_727;

											{	/* Object/struct.scm 114 */
												obj_t BgL_arg2684z00_728;

												{	/* Object/struct.scm 114 */
													obj_t BgL_arg2687z00_731;

													obj_t BgL_arg2688z00_732;

													BgL_arg2687z00_731 = CNST_TABLE_REF(((long) 20));
													{	/* Object/struct.scm 114 */
														obj_t BgL_arg2689z00_733;

														{	/* Object/struct.scm 114 */
															obj_t BgL_arg2695z00_738;

															obj_t BgL_arg2696z00_739;

															BgL_arg2695z00_738 = CNST_TABLE_REF(((long) 21));
															{	/* Object/struct.scm 114 */
																obj_t BgL_list2697z00_740;

																BgL_list2697z00_740 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg2696z00_739 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_cnamez00_11, BgL_list2697z00_740);
															}
															BgL_arg2689z00_733 =
																MAKE_PAIR(BgL_arg2695z00_738,
																BgL_arg2696z00_739);
														}
														{	/* Object/struct.scm 114 */
															obj_t BgL_list2691z00_735;

															{	/* Object/struct.scm 114 */
																obj_t BgL_arg2693z00_736;

																{	/* Object/struct.scm 114 */
																	obj_t BgL_arg2694z00_737;

																	BgL_arg2694z00_737 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2693z00_736 =
																		MAKE_PAIR(BUNSPEC, BgL_arg2694z00_737);
																}
																BgL_list2691z00_735 =
																	MAKE_PAIR(BINT(BgL_lenz00_702),
																	BgL_arg2693z00_736);
															}
															BgL_arg2688z00_732 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2689z00_733, BgL_list2691z00_735);
													}}
													BgL_arg2684z00_728 =
														MAKE_PAIR(BgL_arg2687z00_731, BgL_arg2688z00_732);
												}
												{	/* Object/struct.scm 114 */
													obj_t BgL_list2686z00_730;

													BgL_list2686z00_730 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg2683z00_727 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2684z00_728, BgL_list2686z00_730);
											}}
											BgL_arg2681z00_725 =
												MAKE_PAIR(BgL_snamez00_704, BgL_arg2683z00_727);
										}
										BgL_arg2676z00_720 = MAKE_PAIR(BgL_arg2681z00_725, BNIL);
									}
									{	/* Object/struct.scm 115 */
										obj_t BgL_arg2698z00_741;

										obj_t BgL_arg2699z00_742;

										BgL_arg2698z00_741 = CNST_TABLE_REF(((long) 12));
										{	/* Object/struct.scm 116 */
											obj_t BgL_arg2700z00_743;

											obj_t BgL_arg2701z00_744;

											{	/* Object/struct.scm 116 */
												obj_t BgL_arg2703z00_746;

												obj_t BgL_arg2704z00_747;

												BgL_arg2703z00_746 = CNST_TABLE_REF(((long) 11));
												{	/* Object/struct.scm 116 */
													obj_t BgL_list2705z00_748;

													{	/* Object/struct.scm 116 */
														obj_t BgL_arg2707z00_750;

														{	/* Object/struct.scm 116 */
															obj_t BgL_arg2708z00_751;

															BgL_arg2708z00_751 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2707z00_750 =
																MAKE_PAIR(BFALSE, BgL_arg2708z00_751);
														}
														BgL_list2705z00_748 =
															MAKE_PAIR(BINT(((long) 0)), BgL_arg2707z00_750);
													}
													BgL_arg2704z00_747 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_snamez00_704, BgL_list2705z00_748);
												}
												BgL_arg2700z00_743 =
													MAKE_PAIR(BgL_arg2703z00_746, BgL_arg2704z00_747);
											}
											{	/* Object/struct.scm 117 */
												obj_t BgL_arg2709z00_752;

												obj_t BgL_arg2710z00_753;

												{
													long BgL_iz00_756;

													obj_t BgL_slotsz00_757;

													obj_t BgL_resz00_758;

													BgL_iz00_756 = ((long) 1);
													BgL_slotsz00_757 = BgL_slotsz00_13;
													BgL_resz00_758 = BNIL;
												BgL_zc3anonymousza32711ze3z83_759:
													if ((BgL_iz00_756 == BgL_lenz00_702))
														{	/* Object/struct.scm 121 */
															BgL_arg2709z00_752 =
																bgl_reverse_bang(BgL_resz00_758);
														}
													else
														{	/* Object/struct.scm 123 */
															bool_t BgL_testz00_1729;

															{	/* Object/struct.scm 123 */
																obj_t BgL_arg2721z00_769;

																BgL_arg2721z00_769 = CAR(BgL_slotsz00_757);
																BgL_testz00_1729 =
																	BGl_slotzd2virtualzf3z21zzobject_slotsz00(
																	(BgL_slotz00_bglt) (BgL_arg2721z00_769));
															}
															if (BgL_testz00_1729)
																{
																	obj_t BgL_slotsz00_1735;

																	long BgL_iz00_1733;

																	BgL_iz00_1733 = (BgL_iz00_756 + ((long) 1));
																	BgL_slotsz00_1735 = CDR(BgL_slotsz00_757);
																	BgL_slotsz00_757 = BgL_slotsz00_1735;
																	BgL_iz00_756 = BgL_iz00_1733;
																	goto BgL_zc3anonymousza32711ze3z83_759;
																}
															else
																{	/* Object/struct.scm 128 */
																	long BgL_arg2716z00_764;

																	obj_t BgL_arg2717z00_765;

																	obj_t BgL_arg2718z00_766;

																	BgL_arg2716z00_764 =
																		(BgL_iz00_756 + ((long) 1));
																	BgL_arg2717z00_765 = CDR(BgL_slotsz00_757);
																	BgL_arg2718z00_766 =
																		MAKE_PAIR
																		(BGl_savezd2slotzd2zzobject_structz00
																		(BgL_onamez00_703, BgL_snamez00_704,
																			BgL_cnamez00_11, BgL_iz00_756,
																			CAR(BgL_slotsz00_757)), BgL_resz00_758);
																	{
																		obj_t BgL_resz00_1744;

																		obj_t BgL_slotsz00_1743;

																		long BgL_iz00_1742;

																		BgL_iz00_1742 = BgL_arg2716z00_764;
																		BgL_slotsz00_1743 = BgL_arg2717z00_765;
																		BgL_resz00_1744 = BgL_arg2718z00_766;
																		BgL_resz00_758 = BgL_resz00_1744;
																		BgL_slotsz00_757 = BgL_slotsz00_1743;
																		BgL_iz00_756 = BgL_iz00_1742;
																		goto BgL_zc3anonymousza32711ze3z83_759;
																	}
																}
														}
												}
												BgL_arg2710z00_753 = MAKE_PAIR(BgL_snamez00_704, BNIL);
												BgL_arg2701z00_744 =
													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2709z00_752, BgL_arg2710z00_753);
											}
											{	/* Object/struct.scm 115 */
												obj_t BgL_list2702z00_745;

												BgL_list2702z00_745 =
													MAKE_PAIR(BgL_arg2701z00_744, BNIL);
												BgL_arg2699z00_742 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2700z00_743, BgL_list2702z00_745);
											}
										}
										BgL_arg2677z00_721 =
											MAKE_PAIR(BgL_arg2698z00_741, BgL_arg2699z00_742);
									}
									{	/* Object/struct.scm 114 */
										obj_t BgL_list2679z00_723;

										{	/* Object/struct.scm 114 */
											obj_t BgL_arg2680z00_724;

											BgL_arg2680z00_724 = MAKE_PAIR(BNIL, BNIL);
											BgL_list2679z00_723 =
												MAKE_PAIR(BgL_arg2677z00_721, BgL_arg2680z00_724);
										}
										BgL_arg2675z00_719 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg2676z00_720, BgL_list2679z00_723);
									}
								}
								BgL_arg2664z00_709 =
									MAKE_PAIR(BgL_arg2674z00_718, BgL_arg2675z00_719);
							}
							{	/* Object/struct.scm 113 */
								obj_t BgL_list2667z00_711;

								{	/* Object/struct.scm 113 */
									obj_t BgL_arg2668z00_712;

									BgL_arg2668z00_712 = MAKE_PAIR(BNIL, BNIL);
									BgL_list2667z00_711 =
										MAKE_PAIR(BgL_arg2664z00_709, BgL_arg2668z00_712);
								}
								BgL_arg2662z00_707 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg2663z00_708, BgL_list2667z00_711);
							}
						}
						BgL_arg2660z00_705 =
							MAKE_PAIR(BgL_arg2661z00_706, BgL_arg2662z00_707);
					}
					return
						BGl_epairifyz00zztools_miscz00(BgL_arg2660z00_705,
						BgL_srczd2defzd2_14);
				}
			}
		}
	}



/* gen-wide-class->struct */
	obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t
		BgL_cnamez00_15, BgL_typez00_bglt BgL_typez00_16, obj_t BgL_slotsz00_17,
		obj_t BgL_srczd2defzd2_18)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 142 */
			{	/* Object/struct.scm 143 */
				long BgL_lenz00_773;

				BgL_lenz00_773 =
					BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_17);
				{	/* Object/struct.scm 143 */
					obj_t BgL_onamez00_774;

					BgL_onamez00_774 =
						BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 16)));
					{	/* Object/struct.scm 144 */
						obj_t BgL_resz00_775;

						BgL_resz00_775 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 17)));
						{	/* Object/struct.scm 145 */
							obj_t BgL_tresz00_776;

							{	/* Object/struct.scm 146 */
								obj_t BgL_arg2825z00_876;

								{	/* Object/struct.scm 146 */
									obj_t BgL_arg2826z00_877;

									obj_t BgL_arg2827z00_878;

									BgL_arg2826z00_877 = SYMBOL_TO_STRING(BgL_resz00_775);
									{	/* Object/struct.scm 146 */
										obj_t BgL_symbolz00_1404;

										BgL_symbolz00_1404 = CNST_TABLE_REF(((long) 22));
										BgL_arg2827z00_878 = SYMBOL_TO_STRING(BgL_symbolz00_1404);
									}
									{	/* Object/struct.scm 146 */
										obj_t BgL_list2828z00_879;

										{	/* Object/struct.scm 146 */
											obj_t BgL_arg2829z00_880;

											BgL_arg2829z00_880 = MAKE_PAIR(BgL_arg2827z00_878, BNIL);
											BgL_list2828z00_879 =
												MAKE_PAIR(BgL_arg2826z00_877, BgL_arg2829z00_880);
										}
										BgL_arg2825z00_876 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2828z00_879);
								}}
								BgL_tresz00_776 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2825z00_876));
							}
							{	/* Object/struct.scm 146 */
								obj_t BgL_auxz00_777;

								BgL_auxz00_777 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											23)));
								{	/* Object/struct.scm 147 */

									{	/* Object/struct.scm 149 */
										obj_t BgL_arg2725z00_778;

										{	/* Object/struct.scm 149 */
											obj_t BgL_arg2726z00_779;

											obj_t BgL_arg2727z00_780;

											BgL_arg2726z00_779 = CNST_TABLE_REF(((long) 18));
											{	/* Object/struct.scm 149 */
												obj_t BgL_arg2729z00_781;

												obj_t BgL_arg2730z00_782;

												{	/* Object/struct.scm 149 */
													obj_t BgL_arg2734z00_786;

													obj_t BgL_arg2735z00_787;

													BgL_arg2734z00_786 = CNST_TABLE_REF(((long) 19));
													{	/* Object/struct.scm 149 */
														obj_t BgL_arg2736z00_788;

														BgL_arg2736z00_788 =
															BGl_makezd2typedzd2identz00zzast_identz00
															(BgL_onamez00_774, BgL_cnamez00_15);
														{	/* Object/struct.scm 149 */
															obj_t BgL_list2738z00_790;

															BgL_list2738z00_790 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2735z00_787 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2736z00_788, BgL_list2738z00_790);
													}}
													BgL_arg2729z00_781 =
														MAKE_PAIR(BgL_arg2734z00_786, BgL_arg2735z00_787);
												}
												{	/* Object/struct.scm 150 */
													obj_t BgL_arg2739z00_791;

													obj_t BgL_arg2740z00_792;

													BgL_arg2739z00_791 = CNST_TABLE_REF(((long) 4));
													{	/* Object/struct.scm 150 */
														obj_t BgL_arg2741z00_793;

														obj_t BgL_arg2742z00_794;

														{	/* Object/struct.scm 150 */
															obj_t BgL_arg2746z00_798;

															{	/* Object/struct.scm 150 */
																obj_t BgL_arg2748z00_800;

																{	/* Object/struct.scm 150 */
																	obj_t BgL_arg2749z00_801;

																	BgL_arg2749z00_801 =
																		MAKE_PAIR(CNST_TABLE_REF(((long) 24)),
																		BNIL);
																	{	/* Object/struct.scm 150 */
																		obj_t BgL_list2751z00_803;

																		BgL_list2751z00_803 = MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2748z00_800 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2749z00_801, BgL_list2751z00_803);
																}}
																BgL_arg2746z00_798 =
																	MAKE_PAIR(BgL_tresz00_776,
																	BgL_arg2748z00_800);
															}
															BgL_arg2741z00_793 =
																MAKE_PAIR(BgL_arg2746z00_798, BNIL);
														}
														{	/* Object/struct.scm 151 */
															obj_t BgL_arg2752z00_804;

															obj_t BgL_arg2753z00_805;

															BgL_arg2752z00_804 = CNST_TABLE_REF(((long) 4));
															{	/* Object/struct.scm 151 */
																obj_t BgL_arg2754z00_806;

																obj_t BgL_arg2755z00_807;

																{	/* Object/struct.scm 151 */
																	obj_t BgL_arg2757z00_809;

																	{	/* Object/struct.scm 151 */
																		obj_t BgL_arg2760z00_811;

																		{	/* Object/struct.scm 151 */
																			obj_t BgL_arg2761z00_812;

																			{	/* Object/struct.scm 151 */
																				obj_t BgL_arg2765z00_815;

																				obj_t BgL_arg2766z00_816;

																				BgL_arg2765z00_815 =
																					CNST_TABLE_REF(((long) 20));
																				{	/* Object/struct.scm 151 */
																					obj_t BgL_arg2767z00_817;

																					{	/* Object/struct.scm 151 */
																						obj_t BgL_arg2772z00_822;

																						obj_t BgL_arg2773z00_823;

																						BgL_arg2772z00_822 =
																							CNST_TABLE_REF(((long) 21));
																						{	/* Object/struct.scm 151 */
																							obj_t BgL_list2774z00_824;

																							BgL_list2774z00_824 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2773z00_823 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_cnamez00_15,
																								BgL_list2774z00_824);
																						}
																						BgL_arg2767z00_817 =
																							MAKE_PAIR(BgL_arg2772z00_822,
																							BgL_arg2773z00_823);
																					}
																					{	/* Object/struct.scm 151 */
																						obj_t BgL_list2769z00_819;

																						{	/* Object/struct.scm 151 */
																							obj_t BgL_arg2770z00_820;

																							{	/* Object/struct.scm 151 */
																								obj_t BgL_arg2771z00_821;

																								BgL_arg2771z00_821 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2770z00_820 =
																									MAKE_PAIR(BUNSPEC,
																									BgL_arg2771z00_821);
																							}
																							BgL_list2769z00_819 =
																								MAKE_PAIR(BINT(BgL_lenz00_773),
																								BgL_arg2770z00_820);
																						}
																						BgL_arg2766z00_816 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2767z00_817,
																							BgL_list2769z00_819);
																				}}
																				BgL_arg2761z00_812 =
																					MAKE_PAIR(BgL_arg2765z00_815,
																					BgL_arg2766z00_816);
																			}
																			{	/* Object/struct.scm 151 */
																				obj_t BgL_list2763z00_814;

																				BgL_list2763z00_814 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2760z00_811 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2761z00_812,
																					BgL_list2763z00_814);
																		}}
																		BgL_arg2757z00_809 =
																			MAKE_PAIR(BgL_auxz00_777,
																			BgL_arg2760z00_811);
																	}
																	BgL_arg2754z00_806 =
																		MAKE_PAIR(BgL_arg2757z00_809, BNIL);
																}
																{	/* Object/struct.scm 152 */
																	obj_t BgL_arg2775z00_825;

																	obj_t BgL_arg2776z00_826;

																	{
																		long BgL_iz00_829;

																		obj_t BgL_slotsz00_830;

																		obj_t BgL_resz00_831;

																		BgL_iz00_829 = ((long) 0);
																		BgL_slotsz00_830 = BgL_slotsz00_17;
																		BgL_resz00_831 = BNIL;
																	BgL_zc3anonymousza32777ze3z83_832:
																		if ((BgL_iz00_829 == BgL_lenz00_773))
																			{	/* Object/struct.scm 156 */
																				BgL_arg2775z00_825 =
																					bgl_reverse_bang(BgL_resz00_831);
																			}
																		else
																			{	/* Object/struct.scm 158 */
																				bool_t BgL_testz00_1806;

																				{	/* Object/struct.scm 158 */
																					obj_t BgL_arg2788z00_842;

																					BgL_arg2788z00_842 =
																						CAR(BgL_slotsz00_830);
																					BgL_testz00_1806 =
																						BGl_slotzd2virtualzf3z21zzobject_slotsz00
																						((BgL_slotz00_bglt)
																						(BgL_arg2788z00_842));
																				}
																				if (BgL_testz00_1806)
																					{
																						obj_t BgL_slotsz00_1812;

																						long BgL_iz00_1810;

																						BgL_iz00_1810 =
																							(BgL_iz00_829 + ((long) 1));
																						BgL_slotsz00_1812 =
																							CDR(BgL_slotsz00_830);
																						BgL_slotsz00_830 =
																							BgL_slotsz00_1812;
																						BgL_iz00_829 = BgL_iz00_1810;
																						goto
																							BgL_zc3anonymousza32777ze3z83_832;
																					}
																				else
																					{	/* Object/struct.scm 163 */
																						long BgL_arg2783z00_837;

																						obj_t BgL_arg2784z00_838;

																						obj_t BgL_arg2785z00_839;

																						BgL_arg2783z00_837 =
																							(BgL_iz00_829 + ((long) 1));
																						BgL_arg2784z00_838 =
																							CDR(BgL_slotsz00_830);
																						BgL_arg2785z00_839 =
																							MAKE_PAIR
																							(BGl_savezd2slotzd2zzobject_structz00
																							(BgL_onamez00_774, BgL_auxz00_777,
																								BgL_cnamez00_15, BgL_iz00_829,
																								CAR(BgL_slotsz00_830)),
																							BgL_resz00_831);
																						{
																							obj_t BgL_resz00_1821;

																							obj_t BgL_slotsz00_1820;

																							long BgL_iz00_1819;

																							BgL_iz00_1819 =
																								BgL_arg2783z00_837;
																							BgL_slotsz00_1820 =
																								BgL_arg2784z00_838;
																							BgL_resz00_1821 =
																								BgL_arg2785z00_839;
																							BgL_resz00_831 = BgL_resz00_1821;
																							BgL_slotsz00_830 =
																								BgL_slotsz00_1820;
																							BgL_iz00_829 = BgL_iz00_1819;
																							goto
																								BgL_zc3anonymousza32777ze3z83_832;
																						}
																					}
																			}
																	}
																	{	/* Object/struct.scm 167 */
																		obj_t BgL_arg2789z00_844;

																		obj_t BgL_arg2790z00_845;

																		{	/* Object/struct.scm 167 */
																			obj_t BgL_arg2791z00_846;

																			obj_t BgL_arg2792z00_847;

																			BgL_arg2791z00_846 =
																				CNST_TABLE_REF(((long) 11));
																			{	/* Object/struct.scm 167 */
																				obj_t BgL_list2793z00_848;

																				{	/* Object/struct.scm 167 */
																					obj_t BgL_arg2796z00_850;

																					{	/* Object/struct.scm 167 */
																						obj_t BgL_arg2797z00_851;

																						BgL_arg2797z00_851 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2796z00_850 =
																							MAKE_PAIR(BgL_auxz00_777,
																							BgL_arg2797z00_851);
																					}
																					BgL_list2793z00_848 =
																						MAKE_PAIR(BINT(((long) 0)),
																						BgL_arg2796z00_850);
																				}
																				BgL_arg2792z00_847 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_resz00_775, BgL_list2793z00_848);
																			}
																			BgL_arg2789z00_844 =
																				MAKE_PAIR(BgL_arg2791z00_846,
																				BgL_arg2792z00_847);
																		}
																		{	/* Object/struct.scm 169 */
																			obj_t BgL_arg2798z00_852;

																			obj_t BgL_arg2800z00_853;

																			{	/* Object/struct.scm 169 */
																				obj_t BgL_arg2806z00_858;

																				obj_t BgL_arg2807z00_859;

																				BgL_arg2806z00_858 =
																					CNST_TABLE_REF(((long) 25));
																				{	/* Object/struct.scm 169 */
																					obj_t BgL_arg2808z00_860;

																					{	/* Object/struct.scm 169 */
																						obj_t BgL_arg2812z00_864;

																						obj_t BgL_arg2813z00_865;

																						BgL_arg2812z00_864 =
																							CNST_TABLE_REF(((long) 26));
																						{	/* Object/struct.scm 169 */
																							obj_t BgL_list2814z00_866;

																							BgL_list2814z00_866 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2813z00_865 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_resz00_775,
																								BgL_list2814z00_866);
																						}
																						BgL_arg2808z00_860 =
																							MAKE_PAIR(BgL_arg2812z00_864,
																							BgL_arg2813z00_865);
																					}
																					{	/* Object/struct.scm 169 */
																						obj_t BgL_list2810z00_862;

																						{	/* Object/struct.scm 169 */
																							obj_t BgL_arg2811z00_863;

																							BgL_arg2811z00_863 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2810z00_862 =
																								MAKE_PAIR(BgL_arg2808z00_860,
																								BgL_arg2811z00_863);
																						}
																						BgL_arg2807z00_859 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_auxz00_777,
																							BgL_list2810z00_862);
																				}}
																				BgL_arg2798z00_852 =
																					MAKE_PAIR(BgL_arg2806z00_858,
																					BgL_arg2807z00_859);
																			}
																			{	/* Object/struct.scm 170 */
																				obj_t BgL_arg2815z00_867;

																				obj_t BgL_arg2816z00_868;

																				BgL_arg2815z00_867 =
																					CNST_TABLE_REF(((long) 25));
																				{	/* Object/struct.scm 170 */
																					obj_t BgL_arg2818z00_869;

																					{	/* Object/struct.scm 170 */
																						obj_t BgL_arg2822z00_873;

																						obj_t BgL_arg2823z00_874;

																						BgL_arg2822z00_873 =
																							CNST_TABLE_REF(((long) 21));
																						{	/* Object/struct.scm 170 */
																							obj_t BgL_list2824z00_875;

																							BgL_list2824z00_875 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2823z00_874 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_cnamez00_15,
																								BgL_list2824z00_875);
																						}
																						BgL_arg2818z00_869 =
																							MAKE_PAIR(BgL_arg2822z00_873,
																							BgL_arg2823z00_874);
																					}
																					{	/* Object/struct.scm 170 */
																						obj_t BgL_list2820z00_871;

																						{	/* Object/struct.scm 170 */
																							obj_t BgL_arg2821z00_872;

																							BgL_arg2821z00_872 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2820z00_871 =
																								MAKE_PAIR(BgL_arg2818z00_869,
																								BgL_arg2821z00_872);
																						}
																						BgL_arg2816z00_868 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_resz00_775,
																							BgL_list2820z00_871);
																				}}
																				BgL_arg2800z00_853 =
																					MAKE_PAIR(BgL_arg2815z00_867,
																					BgL_arg2816z00_868);
																			}
																			{	/* Object/struct.scm 151 */
																				obj_t BgL_list2803z00_855;

																				{	/* Object/struct.scm 151 */
																					obj_t BgL_arg2804z00_856;

																					{	/* Object/struct.scm 151 */
																						obj_t BgL_arg2805z00_857;

																						BgL_arg2805z00_857 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2804z00_856 =
																							MAKE_PAIR(BgL_resz00_775,
																							BgL_arg2805z00_857);
																					}
																					BgL_list2803z00_855 =
																						MAKE_PAIR(BgL_arg2800z00_853,
																						BgL_arg2804z00_856);
																				}
																				BgL_arg2790z00_845 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2798z00_852,
																					BgL_list2803z00_855);
																		}}
																		BgL_arg2776z00_826 =
																			MAKE_PAIR(BgL_arg2789z00_844,
																			BgL_arg2790z00_845);
																	}
																	BgL_arg2755z00_807 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2775z00_825, BgL_arg2776z00_826);
																}
																{	/* Object/struct.scm 151 */
																	obj_t BgL_list2756z00_808;

																	BgL_list2756z00_808 =
																		MAKE_PAIR(BgL_arg2755z00_807, BNIL);
																	BgL_arg2753z00_805 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2754z00_806, BgL_list2756z00_808);
															}}
															BgL_arg2742z00_794 =
																MAKE_PAIR(BgL_arg2752z00_804,
																BgL_arg2753z00_805);
														}
														{	/* Object/struct.scm 150 */
															obj_t BgL_list2744z00_796;

															{	/* Object/struct.scm 150 */
																obj_t BgL_arg2745z00_797;

																BgL_arg2745z00_797 = MAKE_PAIR(BNIL, BNIL);
																BgL_list2744z00_796 =
																	MAKE_PAIR(BgL_arg2742z00_794,
																	BgL_arg2745z00_797);
															}
															BgL_arg2740z00_792 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2741z00_793, BgL_list2744z00_796);
													}}
													BgL_arg2730z00_782 =
														MAKE_PAIR(BgL_arg2739z00_791, BgL_arg2740z00_792);
												}
												{	/* Object/struct.scm 149 */
													obj_t BgL_list2732z00_784;

													{	/* Object/struct.scm 149 */
														obj_t BgL_arg2733z00_785;

														BgL_arg2733z00_785 = MAKE_PAIR(BNIL, BNIL);
														BgL_list2732z00_784 =
															MAKE_PAIR(BgL_arg2730z00_782, BgL_arg2733z00_785);
													}
													BgL_arg2727z00_780 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2729z00_781, BgL_list2732z00_784);
											}}
											BgL_arg2725z00_778 =
												MAKE_PAIR(BgL_arg2726z00_779, BgL_arg2727z00_780);
										}
										return
											BGl_epairifyz00zztools_miscz00(BgL_arg2725z00_778,
											BgL_srczd2defzd2_18);
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* restore-slot */
	obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_19,
		obj_t BgL_snamez00_20, obj_t BgL_cnamez00_21,
		BgL_typez00_bglt BgL_typez00_22, long BgL_iz00_23, obj_t BgL_slotz00_24)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 178 */
			{	/* Object/struct.scm 179 */
				obj_t BgL_loopz00_881;

				BgL_loopz00_881 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 2)));
				{	/* Object/struct.scm 179 */
					obj_t BgL_runnerz00_882;

					BgL_runnerz00_882 =
						BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 27)));
					{	/* Object/struct.scm 180 */
						obj_t BgL_vz00_883;

						BgL_vz00_883 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 28)));
						{	/* Object/struct.scm 181 */
							obj_t BgL_lenz00_884;

							BgL_lenz00_884 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 3)));
							{	/* Object/struct.scm 182 */
								obj_t BgL_runnerzd2typedzd2_885;

								{	/* Object/struct.scm 183 */
									obj_t BgL_arg2959z00_1014;

									{	/* Object/struct.scm 183 */
										obj_t BgL_arg2960z00_1015;

										obj_t BgL_arg2961z00_1016;

										BgL_arg2960z00_1015 = SYMBOL_TO_STRING(BgL_runnerz00_882);
										{	/* Object/struct.scm 183 */
											obj_t BgL_symbolz00_1417;

											BgL_symbolz00_1417 = CNST_TABLE_REF(((long) 29));
											BgL_arg2961z00_1016 =
												SYMBOL_TO_STRING(BgL_symbolz00_1417);
										}
										{	/* Object/struct.scm 183 */
											obj_t BgL_list2962z00_1017;

											{	/* Object/struct.scm 183 */
												obj_t BgL_arg2963z00_1018;

												BgL_arg2963z00_1018 =
													MAKE_PAIR(BgL_arg2961z00_1016, BNIL);
												BgL_list2962z00_1017 =
													MAKE_PAIR(BgL_arg2960z00_1015, BgL_arg2963z00_1018);
											}
											BgL_arg2959z00_1014 =
												BGl_stringzd2appendzd2zz__r4_strings_6_7z00
												(BgL_list2962z00_1017);
									}}
									BgL_runnerzd2typedzd2_885 =
										string_to_symbol(BSTRING_TO_STRING(BgL_arg2959z00_1014));
								}
								{	/* Object/struct.scm 183 */

									if (BGl_slotzd2virtualzf3z21zzobject_slotsz00(
											(BgL_slotz00_bglt) (BgL_slotz00_24)))
										{	/* Object/struct.scm 185 */
											return BUNSPEC;
										}
									else
										{	/* Object/struct.scm 187 */
											bool_t BgL_testz00_1884;

											{	/* Object/struct.scm 187 */
												BgL_slotz00_bglt BgL_obj2353z00_1419;

												BgL_obj2353z00_1419 =
													(BgL_slotz00_bglt) (BgL_slotz00_24);
												BgL_testz00_1884 =
													CBOOL(
													(((BgL_slotz00_bglt) CREF(BgL_obj2353z00_1419))->
														BgL_indexedz00));
											}
											if (BgL_testz00_1884)
												{	/* Object/struct.scm 195 */
													obj_t BgL_fz00_888;

													BgL_fz00_888 =
														BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 30)));
													{	/* Object/struct.scm 195 */
														obj_t BgL_tfz00_889;

														{	/* Object/struct.scm 196 */
															obj_t BgL_arg2936z00_992;

															{	/* Object/struct.scm 196 */
																BgL_typez00_bglt BgL_obj1414z00_1421;

																{	/* Object/struct.scm 196 */
																	BgL_slotz00_bglt BgL_obj2341z00_1420;

																	BgL_obj2341z00_1420 =
																		(BgL_slotz00_bglt) (BgL_slotz00_24);
																	BgL_obj1414z00_1421 =
																		(BgL_typez00_bglt) (
																		(((BgL_slotz00_bglt)
																				CREF(BgL_obj2341z00_1420))->
																			BgL_typez00));
																}
																BgL_arg2936z00_992 =
																	(((BgL_typez00_bglt)
																		CREF(BgL_obj1414z00_1421))->BgL_idz00);
															}
															BgL_tfz00_889 =
																BGl_makezd2typedzd2identz00zzast_identz00
																(BgL_fz00_888, BgL_arg2936z00_992);
														}
														{	/* Object/struct.scm 196 */

															{	/* Object/struct.scm 197 */
																obj_t BgL_arg2832z00_890;

																obj_t BgL_arg2833z00_891;

																BgL_arg2832z00_890 = CNST_TABLE_REF(((long) 4));
																{	/* Object/struct.scm 197 */
																	obj_t BgL_arg2834z00_892;

																	obj_t BgL_arg2835z00_893;

																	{	/* Object/struct.scm 197 */
																		obj_t BgL_arg2840z00_897;

																		{	/* Object/struct.scm 197 */
																			obj_t BgL_arg2842z00_899;

																			{	/* Object/struct.scm 197 */
																				obj_t BgL_arg2843z00_900;

																				{	/* Object/struct.scm 197 */
																					obj_t BgL_arg2846z00_903;

																					obj_t BgL_arg2847z00_904;

																					BgL_arg2846z00_903 =
																						CNST_TABLE_REF(((long) 31));
																					{	/* Object/struct.scm 197 */
																						obj_t BgL_list2848z00_905;

																						{	/* Object/struct.scm 197 */
																							obj_t BgL_arg2849z00_906;

																							BgL_arg2849z00_906 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2848z00_905 =
																								MAKE_PAIR(BINT(BgL_iz00_23),
																								BgL_arg2849z00_906);
																						}
																						BgL_arg2847z00_904 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 32)),
																							BgL_list2848z00_905);
																					}
																					BgL_arg2843z00_900 =
																						MAKE_PAIR(BgL_arg2846z00_903,
																						BgL_arg2847z00_904);
																				}
																				{	/* Object/struct.scm 197 */
																					obj_t BgL_list2845z00_902;

																					BgL_list2845z00_902 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg2842z00_899 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2843z00_900,
																						BgL_list2845z00_902);
																			}}
																			BgL_arg2840z00_897 =
																				MAKE_PAIR(BgL_vz00_883,
																				BgL_arg2842z00_899);
																		}
																		BgL_arg2834z00_892 =
																			MAKE_PAIR(BgL_arg2840z00_897, BNIL);
																	}
																	{	/* Object/struct.scm 198 */
																		obj_t BgL_arg2850z00_907;

																		obj_t BgL_arg2851z00_908;

																		BgL_arg2850z00_907 =
																			CNST_TABLE_REF(((long) 4));
																		{	/* Object/struct.scm 198 */
																			obj_t BgL_arg2852z00_909;

																			obj_t BgL_arg2853z00_910;

																			obj_t BgL_arg2854z00_911;

																			{	/* Object/struct.scm 198 */
																				obj_t BgL_arg2859z00_916;

																				{	/* Object/struct.scm 198 */
																					obj_t BgL_arg2861z00_918;

																					obj_t BgL_arg2862z00_919;

																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2863z00_920;

																						{	/* Object/struct.scm 198 */
																							obj_t BgL_arg2864z00_921;

																							obj_t BgL_arg2865z00_922;

																							BgL_arg2864z00_921 =
																								SYMBOL_TO_STRING
																								(BgL_lenz00_884);
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_symbolz00_1423;

																								BgL_symbolz00_1423 =
																									CNST_TABLE_REF(((long) 29));
																								BgL_arg2865z00_922 =
																									SYMBOL_TO_STRING
																									(BgL_symbolz00_1423);
																							}
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_list2866z00_923;

																								{	/* Object/struct.scm 198 */
																									obj_t BgL_arg2867z00_924;

																									BgL_arg2867z00_924 =
																										MAKE_PAIR
																										(BgL_arg2865z00_922, BNIL);
																									BgL_list2866z00_923 =
																										MAKE_PAIR
																										(BgL_arg2864z00_921,
																										BgL_arg2867z00_924);
																								}
																								BgL_arg2863z00_920 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list2866z00_923);
																						}}
																						BgL_arg2861z00_918 =
																							string_to_symbol(BSTRING_TO_STRING
																							(BgL_arg2863z00_920));
																					}
																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2868z00_925;

																						{	/* Object/struct.scm 198 */
																							obj_t BgL_arg2871z00_928;

																							obj_t BgL_arg2872z00_929;

																							BgL_arg2871z00_928 =
																								CNST_TABLE_REF(((long) 33));
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_list2873z00_930;

																								BgL_list2873z00_930 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2872z00_929 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_vz00_883,
																									BgL_list2873z00_930);
																							}
																							BgL_arg2868z00_925 =
																								MAKE_PAIR(BgL_arg2871z00_928,
																								BgL_arg2872z00_929);
																						}
																						{	/* Object/struct.scm 198 */
																							obj_t BgL_list2870z00_927;

																							BgL_list2870z00_927 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2862z00_919 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg2868z00_925,
																								BgL_list2870z00_927);
																					}}
																					BgL_arg2859z00_916 =
																						MAKE_PAIR(BgL_arg2861z00_918,
																						BgL_arg2862z00_919);
																				}
																				BgL_arg2852z00_909 =
																					MAKE_PAIR(BgL_arg2859z00_916, BNIL);
																			}
																			BgL_arg2853z00_910 =
																				BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
																				(BgL_typez00_22,
																				(BgL_slotz00_bglt) (BgL_slotz00_24),
																				CNST_TABLE_REF(((long) 34)),
																				BgL_lenz00_884);
																			{	/* Object/struct.scm 201 */
																				obj_t BgL_arg2874z00_931;

																				obj_t BgL_arg2875z00_932;

																				BgL_arg2874z00_931 =
																					CNST_TABLE_REF(((long) 8));
																				{	/* Object/struct.scm 201 */
																					obj_t BgL_arg2876z00_933;

																					obj_t BgL_arg2877z00_934;

																					{	/* Object/struct.scm 201 */
																						obj_t BgL_arg2881z00_938;

																						{	/* Object/struct.scm 201 */
																							obj_t BgL_arg2883z00_940;

																							{	/* Object/struct.scm 201 */
																								obj_t BgL_arg2884z00_941;

																								obj_t BgL_arg2885z00_942;

																								BgL_arg2884z00_941 =
																									MAKE_PAIR
																									(BgL_runnerzd2typedzd2_885,
																									BNIL);
																								{	/* Object/struct.scm 202 */
																									obj_t BgL_arg2890z00_946;

																									obj_t BgL_arg2891z00_947;

																									BgL_arg2890z00_946 =
																										CNST_TABLE_REF(((long) 9));
																									{	/* Object/struct.scm 202 */
																										obj_t BgL_arg2892z00_948;

																										obj_t BgL_arg2893z00_949;

																										obj_t BgL_arg2894z00_950;

																										{	/* Object/struct.scm 202 */
																											obj_t BgL_arg2899z00_955;

																											obj_t BgL_arg2900z00_956;

																											BgL_arg2899z00_955 =
																												CNST_TABLE_REF(((long)
																													10));
																											{	/* Object/struct.scm 202 */
																												obj_t
																													BgL_list2901z00_957;
																												{	/* Object/struct.scm 202 */
																													obj_t
																														BgL_arg2902z00_958;
																													BgL_arg2902z00_958 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list2901z00_957 =
																														MAKE_PAIR
																														(BgL_lenz00_884,
																														BgL_arg2902z00_958);
																												}
																												BgL_arg2900z00_956 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_runnerz00_882,
																													BgL_list2901z00_957);
																											}
																											BgL_arg2892z00_948 =
																												MAKE_PAIR
																												(BgL_arg2899z00_955,
																												BgL_arg2900z00_956);
																										}
																										{	/* Object/struct.scm 203 */
																											obj_t BgL_arg2903z00_959;

																											obj_t BgL_arg2904z00_960;

																											BgL_arg2903z00_959 =
																												CNST_TABLE_REF(((long)
																													21));
																											{	/* Object/struct.scm 203 */
																												obj_t
																													BgL_list2905z00_961;
																												BgL_list2905z00_961 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_arg2904z00_960 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(CNST_TABLE_REF((
																															(long) 35)),
																													BgL_list2905z00_961);
																											}
																											BgL_arg2893z00_949 =
																												MAKE_PAIR
																												(BgL_arg2903z00_959,
																												BgL_arg2904z00_960);
																										}
																										{	/* Object/struct.scm 204 */
																											obj_t BgL_arg2906z00_962;

																											obj_t BgL_arg2907z00_963;

																											BgL_arg2906z00_962 =
																												CNST_TABLE_REF(((long)
																													4));
																											{	/* Object/struct.scm 204 */
																												obj_t
																													BgL_arg2908z00_964;
																												obj_t
																													BgL_arg2909z00_965;
																												obj_t
																													BgL_arg2910z00_966;
																												{	/* Object/struct.scm 204 */
																													obj_t
																														BgL_arg2915z00_971;
																													{	/* Object/struct.scm 204 */
																														obj_t
																															BgL_arg2917z00_973;
																														{	/* Object/struct.scm 204 */
																															obj_t
																																BgL_arg2918z00_974;
																															{	/* Object/struct.scm 204 */
																																obj_t
																																	BgL_arg2921z00_977;
																																obj_t
																																	BgL_arg2922z00_978;
																																BgL_arg2921z00_977
																																	=
																																	CNST_TABLE_REF
																																	(((long) 36));
																																{	/* Object/struct.scm 204 */
																																	obj_t
																																		BgL_list2923z00_979;
																																	{	/* Object/struct.scm 204 */
																																		obj_t
																																			BgL_arg2924z00_980;
																																		BgL_arg2924z00_980
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_list2923z00_979
																																			=
																																			MAKE_PAIR
																																			(BgL_runnerz00_882,
																																			BgL_arg2924z00_980);
																																	}
																																	BgL_arg2922z00_978
																																		=
																																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																		(BgL_vz00_883,
																																		BgL_list2923z00_979);
																																}
																																BgL_arg2918z00_974
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2921z00_977,
																																	BgL_arg2922z00_978);
																															}
																															{	/* Object/struct.scm 204 */
																																obj_t
																																	BgL_list2920z00_976;
																																BgL_list2920z00_976
																																	=
																																	MAKE_PAIR
																																	(BNIL, BNIL);
																																BgL_arg2917z00_973
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_arg2918z00_974,
																																	BgL_list2920z00_976);
																														}}
																														BgL_arg2915z00_971 =
																															MAKE_PAIR
																															(BgL_tfz00_889,
																															BgL_arg2917z00_973);
																													}
																													BgL_arg2908z00_964 =
																														MAKE_PAIR
																														(BgL_arg2915z00_971,
																														BNIL);
																												}
																												BgL_arg2909z00_965 =
																													BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00
																													(BgL_typez00_22,
																													(BgL_slotz00_bglt)
																													(BgL_slotz00_24),
																													CNST_TABLE_REF(((long)
																															34)),
																													BgL_fz00_888,
																													BgL_runnerz00_882);
																												{	/* Object/struct.scm 211 */
																													obj_t
																														BgL_arg2925z00_981;
																													{	/* Object/struct.scm 211 */
																														obj_t
																															BgL_arg2926z00_982;
																														{	/* Object/struct.scm 211 */
																															obj_t
																																BgL_arg2929z00_985;
																															obj_t
																																BgL_arg2930z00_986;
																															BgL_arg2929z00_985
																																=
																																CNST_TABLE_REF((
																																	(long) 15));
																															{	/* Object/struct.scm 211 */
																																obj_t
																																	BgL_list2931z00_987;
																																{	/* Object/struct.scm 211 */
																																	obj_t
																																		BgL_arg2933z00_989;
																																	BgL_arg2933z00_989
																																		=
																																		MAKE_PAIR
																																		(BNIL,
																																		BNIL);
																																	BgL_list2931z00_987
																																		=
																																		MAKE_PAIR
																																		(BINT((
																																				(long)
																																				1)),
																																		BgL_arg2933z00_989);
																																}
																																BgL_arg2930z00_986
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_runnerz00_882,
																																	BgL_list2931z00_987);
																															}
																															BgL_arg2926z00_982
																																=
																																MAKE_PAIR
																																(BgL_arg2929z00_985,
																																BgL_arg2930z00_986);
																														}
																														{	/* Object/struct.scm 211 */
																															obj_t
																																BgL_list2928z00_984;
																															BgL_list2928z00_984
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg2925z00_981
																																=
																																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																(BgL_arg2926z00_982,
																																BgL_list2928z00_984);
																													}}
																													BgL_arg2910z00_966 =
																														MAKE_PAIR
																														(BgL_loopz00_881,
																														BgL_arg2925z00_981);
																												}
																												{	/* Object/struct.scm 204 */
																													obj_t
																														BgL_list2912z00_968;
																													{	/* Object/struct.scm 204 */
																														obj_t
																															BgL_arg2913z00_969;
																														{	/* Object/struct.scm 204 */
																															obj_t
																																BgL_arg2914z00_970;
																															BgL_arg2914z00_970
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg2913z00_969
																																=
																																MAKE_PAIR
																																(BgL_arg2910z00_966,
																																BgL_arg2914z00_970);
																														}
																														BgL_list2912z00_968
																															=
																															MAKE_PAIR
																															(BgL_arg2909z00_965,
																															BgL_arg2913z00_969);
																													}
																													BgL_arg2907z00_963 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg2908z00_964,
																														BgL_list2912z00_968);
																											}}
																											BgL_arg2894z00_950 =
																												MAKE_PAIR
																												(BgL_arg2906z00_962,
																												BgL_arg2907z00_963);
																										}
																										{	/* Object/struct.scm 202 */
																											obj_t BgL_list2896z00_952;

																											{	/* Object/struct.scm 202 */
																												obj_t
																													BgL_arg2897z00_953;
																												{	/* Object/struct.scm 202 */
																													obj_t
																														BgL_arg2898z00_954;
																													BgL_arg2898z00_954 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_arg2897z00_953 =
																														MAKE_PAIR
																														(BgL_arg2894z00_950,
																														BgL_arg2898z00_954);
																												}
																												BgL_list2896z00_952 =
																													MAKE_PAIR
																													(BgL_arg2893z00_949,
																													BgL_arg2897z00_953);
																											}
																											BgL_arg2891z00_947 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2892z00_948,
																												BgL_list2896z00_952);
																									}}
																									BgL_arg2885z00_942 =
																										MAKE_PAIR
																										(BgL_arg2890z00_946,
																										BgL_arg2891z00_947);
																								}
																								{	/* Object/struct.scm 201 */
																									obj_t BgL_list2887z00_944;

																									{	/* Object/struct.scm 201 */
																										obj_t BgL_arg2889z00_945;

																										BgL_arg2889z00_945 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list2887z00_944 =
																											MAKE_PAIR
																											(BgL_arg2885z00_942,
																											BgL_arg2889z00_945);
																									}
																									BgL_arg2883z00_940 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg2884z00_941,
																										BgL_list2887z00_944);
																							}}
																							BgL_arg2881z00_938 =
																								MAKE_PAIR(BgL_loopz00_881,
																								BgL_arg2883z00_940);
																						}
																						BgL_arg2876z00_933 =
																							MAKE_PAIR(BgL_arg2881z00_938,
																							BNIL);
																					}
																					{	/* Object/struct.scm 212 */
																						obj_t BgL_arg2934z00_990;

																						{	/* Object/struct.scm 212 */
																							obj_t BgL_list2935z00_991;

																							BgL_list2935z00_991 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2934z00_990 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BINT(((long) 0)),
																								BgL_list2935z00_991);
																						}
																						BgL_arg2877z00_934 =
																							MAKE_PAIR(BgL_loopz00_881,
																							BgL_arg2934z00_990);
																					}
																					{	/* Object/struct.scm 201 */
																						obj_t BgL_list2879z00_936;

																						{	/* Object/struct.scm 201 */
																							obj_t BgL_arg2880z00_937;

																							BgL_arg2880z00_937 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2879z00_936 =
																								MAKE_PAIR(BgL_arg2877z00_934,
																								BgL_arg2880z00_937);
																						}
																						BgL_arg2875z00_932 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2876z00_933,
																							BgL_list2879z00_936);
																				}}
																				BgL_arg2854z00_911 =
																					MAKE_PAIR(BgL_arg2874z00_931,
																					BgL_arg2875z00_932);
																			}
																			{	/* Object/struct.scm 198 */
																				obj_t BgL_list2856z00_913;

																				{	/* Object/struct.scm 198 */
																					obj_t BgL_arg2857z00_914;

																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2858z00_915;

																						BgL_arg2858z00_915 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2857z00_914 =
																							MAKE_PAIR(BgL_arg2854z00_911,
																							BgL_arg2858z00_915);
																					}
																					BgL_list2856z00_913 =
																						MAKE_PAIR(BgL_arg2853z00_910,
																						BgL_arg2857z00_914);
																				}
																				BgL_arg2851z00_908 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2852z00_909,
																					BgL_list2856z00_913);
																		}}
																		BgL_arg2835z00_893 =
																			MAKE_PAIR(BgL_arg2850z00_907,
																			BgL_arg2851z00_908);
																	}
																	{	/* Object/struct.scm 197 */
																		obj_t BgL_list2838z00_895;

																		{	/* Object/struct.scm 197 */
																			obj_t BgL_arg2839z00_896;

																			BgL_arg2839z00_896 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2838z00_895 =
																				MAKE_PAIR(BgL_arg2835z00_893,
																				BgL_arg2839z00_896);
																		}
																		BgL_arg2833z00_891 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2834z00_892, BgL_list2838z00_895);
																}}
																return
																	MAKE_PAIR(BgL_arg2832z00_890,
																	BgL_arg2833z00_891);
															}
														}
													}
												}
											else
												{	/* Object/struct.scm 214 */
													obj_t BgL_arg2938z00_994;

													obj_t BgL_arg2939z00_995;

													BgL_arg2938z00_994 = CNST_TABLE_REF(((long) 4));
													{	/* Object/struct.scm 214 */
														obj_t BgL_arg2940z00_996;

														obj_t BgL_arg2941z00_997;

														{	/* Object/struct.scm 214 */
															obj_t BgL_arg2946z00_1001;

															{	/* Object/struct.scm 214 */
																obj_t BgL_arg2948z00_1003;

																obj_t BgL_arg2949z00_1004;

																{	/* Object/struct.scm 214 */
																	obj_t BgL_arg2950z00_1005;

																	{	/* Object/struct.scm 214 */
																		BgL_typez00_bglt BgL_obj1414z00_1426;

																		{	/* Object/struct.scm 214 */
																			BgL_slotz00_bglt BgL_obj2341z00_1425;

																			BgL_obj2341z00_1425 =
																				(BgL_slotz00_bglt) (BgL_slotz00_24);
																			BgL_obj1414z00_1426 =
																				(BgL_typez00_bglt) (
																				(((BgL_slotz00_bglt)
																						CREF(BgL_obj2341z00_1425))->
																					BgL_typez00));
																		}
																		BgL_arg2950z00_1005 =
																			(((BgL_typez00_bglt)
																				CREF(BgL_obj1414z00_1426))->BgL_idz00);
																	}
																	BgL_arg2948z00_1003 =
																		BGl_makezd2typedzd2identz00zzast_identz00
																		(BgL_vz00_883, BgL_arg2950z00_1005);
																}
																{	/* Object/struct.scm 215 */
																	obj_t BgL_arg2952z00_1007;

																	{	/* Object/struct.scm 215 */
																		obj_t BgL_arg2955z00_1010;

																		obj_t BgL_arg2956z00_1011;

																		BgL_arg2955z00_1010 =
																			CNST_TABLE_REF(((long) 31));
																		{	/* Object/struct.scm 215 */
																			obj_t BgL_list2957z00_1012;

																			{	/* Object/struct.scm 215 */
																				obj_t BgL_arg2958z00_1013;

																				BgL_arg2958z00_1013 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2957z00_1012 =
																					MAKE_PAIR(BINT(BgL_iz00_23),
																					BgL_arg2958z00_1013);
																			}
																			BgL_arg2956z00_1011 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(CNST_TABLE_REF(((long) 32)),
																				BgL_list2957z00_1012);
																		}
																		BgL_arg2952z00_1007 =
																			MAKE_PAIR(BgL_arg2955z00_1010,
																			BgL_arg2956z00_1011);
																	}
																	{	/* Object/struct.scm 214 */
																		obj_t BgL_list2954z00_1009;

																		BgL_list2954z00_1009 =
																			MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2949z00_1004 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2952z00_1007,
																			BgL_list2954z00_1009);
																}}
																BgL_arg2946z00_1001 =
																	MAKE_PAIR(BgL_arg2948z00_1003,
																	BgL_arg2949z00_1004);
															}
															BgL_arg2940z00_996 =
																MAKE_PAIR(BgL_arg2946z00_1001, BNIL);
														}
														BgL_arg2941z00_997 =
															BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00
															(BgL_typez00_22,
															(BgL_slotz00_bglt) (BgL_slotz00_24),
															CNST_TABLE_REF(((long) 34)), BgL_vz00_883);
														{	/* Object/struct.scm 214 */
															obj_t BgL_list2944z00_999;

															{	/* Object/struct.scm 214 */
																obj_t BgL_arg2945z00_1000;

																BgL_arg2945z00_1000 = MAKE_PAIR(BNIL, BNIL);
																BgL_list2944z00_999 =
																	MAKE_PAIR(BgL_arg2941z00_997,
																	BgL_arg2945z00_1000);
															}
															BgL_arg2939z00_995 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2940z00_996, BgL_list2944z00_999);
													}}
													return
														MAKE_PAIR(BgL_arg2938z00_994, BgL_arg2939z00_995);
												}
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-struct->plain-class */
	obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t
		BgL_cnamez00_25, BgL_typez00_bglt BgL_typez00_26, obj_t BgL_slotsz00_27,
		obj_t BgL_srczd2defzd2_28)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 227 */
			{	/* Object/struct.scm 229 */
				obj_t BgL_arg2964z00_1019;

				{	/* Object/struct.scm 229 */
					obj_t BgL_arg2965z00_1020;

					obj_t BgL_arg2966z00_1021;

					BgL_arg2965z00_1020 = CNST_TABLE_REF(((long) 18));
					{	/* Object/struct.scm 229 */
						obj_t BgL_arg2967z00_1022;

						obj_t BgL_arg2968z00_1023;

						{	/* Object/struct.scm 229 */
							obj_t BgL_arg2973z00_1027;

							obj_t BgL_arg2974z00_1028;

							BgL_arg2973z00_1027 = CNST_TABLE_REF(((long) 37));
							{	/* Object/struct.scm 229 */
								obj_t BgL_arg2975z00_1029;

								obj_t BgL_arg2976z00_1030;

								BgL_arg2975z00_1029 =
									BGl_makezd2typedzd2identz00zzast_identz00(CNST_TABLE_REF((
											(long) 34)), BgL_cnamez00_25);
								BgL_arg2976z00_1030 = CNST_TABLE_REF(((long) 38));
								{	/* Object/struct.scm 229 */
									obj_t BgL_list2978z00_1032;

									{	/* Object/struct.scm 229 */
										obj_t BgL_arg2979z00_1033;

										BgL_arg2979z00_1033 = MAKE_PAIR(BNIL, BNIL);
										BgL_list2978z00_1032 =
											MAKE_PAIR(BgL_arg2976z00_1030, BgL_arg2979z00_1033);
									}
									BgL_arg2974z00_1028 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg2975z00_1029, BgL_list2978z00_1032);
							}}
							BgL_arg2967z00_1022 =
								MAKE_PAIR(BgL_arg2973z00_1027, BgL_arg2974z00_1028);
						}
						{	/* Object/struct.scm 231 */
							obj_t BgL_arg2980z00_1034;

							obj_t BgL_arg2981z00_1035;

							BgL_arg2980z00_1034 = CNST_TABLE_REF(((long) 12));
							{	/* Object/struct.scm 232 */
								obj_t BgL_arg2982z00_1036;

								obj_t BgL_arg2983z00_1037;

								{	/* Object/struct.scm 232 */
									obj_t BgL_arg2986z00_1039;

									obj_t BgL_arg2987z00_1040;

									BgL_arg2986z00_1039 = CNST_TABLE_REF(((long) 39));
									{	/* Object/struct.scm 232 */
										obj_t BgL_arg2990z00_1041;

										obj_t BgL_arg2991z00_1042;

										BgL_arg2990z00_1041 = CNST_TABLE_REF(((long) 34));
										{	/* Object/struct.scm 232 */
											obj_t BgL_arg2995z00_1046;

											obj_t BgL_arg2996z00_1047;

											BgL_arg2995z00_1046 = CNST_TABLE_REF(((long) 31));
											{	/* Object/struct.scm 232 */
												obj_t BgL_list2997z00_1048;

												{	/* Object/struct.scm 232 */
													obj_t BgL_arg2999z00_1050;

													BgL_arg2999z00_1050 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2997z00_1048 =
														MAKE_PAIR(BINT(((long) 0)), BgL_arg2999z00_1050);
												}
												BgL_arg2996z00_1047 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(CNST_TABLE_REF(((long) 32)), BgL_list2997z00_1048);
											}
											BgL_arg2991z00_1042 =
												MAKE_PAIR(BgL_arg2995z00_1046, BgL_arg2996z00_1047);
										}
										{	/* Object/struct.scm 232 */
											obj_t BgL_list2993z00_1044;

											{	/* Object/struct.scm 232 */
												obj_t BgL_arg2994z00_1045;

												BgL_arg2994z00_1045 = MAKE_PAIR(BNIL, BNIL);
												BgL_list2993z00_1044 =
													MAKE_PAIR(BgL_arg2991z00_1042, BgL_arg2994z00_1045);
											}
											BgL_arg2987z00_1040 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg2990z00_1041, BgL_list2993z00_1044);
									}}
									BgL_arg2982z00_1036 =
										MAKE_PAIR(BgL_arg2986z00_1039, BgL_arg2987z00_1040);
								}
								{	/* Object/struct.scm 233 */
									obj_t BgL_arg3000z00_1051;

									obj_t BgL_arg3001z00_1052;

									{
										long BgL_iz00_1055;

										obj_t BgL_slotsz00_1056;

										obj_t BgL_resz00_1057;

										BgL_iz00_1055 = ((long) 1);
										BgL_slotsz00_1056 = BgL_slotsz00_27;
										BgL_resz00_1057 = BNIL;
									BgL_zc3anonymousza33002ze3z83_1058:
										if (NULLP(BgL_slotsz00_1056))
											{	/* Object/struct.scm 237 */
												BgL_arg3000z00_1051 = bgl_reverse_bang(BgL_resz00_1057);
											}
										else
											{	/* Object/struct.scm 239 */
												bool_t BgL_testz00_2044;

												{	/* Object/struct.scm 239 */
													obj_t BgL_arg3014z00_1070;

													BgL_arg3014z00_1070 = CAR(BgL_slotsz00_1056);
													BgL_testz00_2044 =
														BGl_slotzd2virtualzf3z21zzobject_slotsz00(
														(BgL_slotz00_bglt) (BgL_arg3014z00_1070));
												}
												if (BgL_testz00_2044)
													{
														obj_t BgL_slotsz00_2050;

														long BgL_iz00_2048;

														BgL_iz00_2048 = (BgL_iz00_1055 + ((long) 1));
														BgL_slotsz00_2050 = CDR(BgL_slotsz00_1056);
														BgL_slotsz00_1056 = BgL_slotsz00_2050;
														BgL_iz00_1055 = BgL_iz00_2048;
														goto BgL_zc3anonymousza33002ze3z83_1058;
													}
												else
													{	/* Object/struct.scm 244 */
														obj_t BgL_newz00_1063;

														{	/* Object/struct.scm 244 */
															obj_t BgL_arg3011z00_1067;

															obj_t BgL_arg3012z00_1068;

															obj_t BgL_arg3013z00_1069;

															BgL_arg3011z00_1067 = CNST_TABLE_REF(((long) 34));
															BgL_arg3012z00_1068 = CNST_TABLE_REF(((long) 32));
															BgL_arg3013z00_1069 = CAR(BgL_slotsz00_1056);
															BgL_newz00_1063 =
																BGl_restorezd2slotzd2zzobject_structz00
																(BgL_arg3011z00_1067, BgL_arg3012z00_1068,
																BgL_cnamez00_25, BgL_typez00_26, BgL_iz00_1055,
																BgL_arg3013z00_1069);
														}
														{	/* Object/struct.scm 245 */
															long BgL_arg3008z00_1064;

															obj_t BgL_arg3009z00_1065;

															obj_t BgL_arg3010z00_1066;

															BgL_arg3008z00_1064 =
																(BgL_iz00_1055 + ((long) 1));
															BgL_arg3009z00_1065 = CDR(BgL_slotsz00_1056);
															BgL_arg3010z00_1066 =
																MAKE_PAIR(BgL_newz00_1063, BgL_resz00_1057);
															{
																obj_t BgL_resz00_2061;

																obj_t BgL_slotsz00_2060;

																long BgL_iz00_2059;

																BgL_iz00_2059 = BgL_arg3008z00_1064;
																BgL_slotsz00_2060 = BgL_arg3009z00_1065;
																BgL_resz00_2061 = BgL_arg3010z00_1066;
																BgL_resz00_1057 = BgL_resz00_2061;
																BgL_slotsz00_1056 = BgL_slotsz00_2060;
																BgL_iz00_1055 = BgL_iz00_2059;
																goto BgL_zc3anonymousza33002ze3z83_1058;
															}
														}
													}
											}
									}
									BgL_arg3001z00_1052 =
										MAKE_PAIR(CNST_TABLE_REF(((long) 34)), BNIL);
									BgL_arg2983z00_1037 =
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3000z00_1051, BgL_arg3001z00_1052);
								}
								{	/* Object/struct.scm 231 */
									obj_t BgL_list2984z00_1038;

									BgL_list2984z00_1038 = MAKE_PAIR(BgL_arg2983z00_1037, BNIL);
									BgL_arg2981z00_1035 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg2982z00_1036, BgL_list2984z00_1038);
							}}
							BgL_arg2968z00_1023 =
								MAKE_PAIR(BgL_arg2980z00_1034, BgL_arg2981z00_1035);
						}
						{	/* Object/struct.scm 229 */
							obj_t BgL_list2971z00_1025;

							{	/* Object/struct.scm 229 */
								obj_t BgL_arg2972z00_1026;

								BgL_arg2972z00_1026 = MAKE_PAIR(BNIL, BNIL);
								BgL_list2971z00_1025 =
									MAKE_PAIR(BgL_arg2968z00_1023, BgL_arg2972z00_1026);
							}
							BgL_arg2966z00_1021 =
								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg2967z00_1022,
								BgL_list2971z00_1025);
					}}
					BgL_arg2964z00_1019 =
						MAKE_PAIR(BgL_arg2965z00_1020, BgL_arg2966z00_1021);
				}
				return
					BGl_epairifyz00zztools_miscz00(BgL_arg2964z00_1019,
					BgL_srczd2defzd2_28);
			}
		}
	}



/* gen-struct->wide-class */
	obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t
		BgL_cnamez00_29, BgL_typez00_bglt BgL_typez00_30, obj_t BgL_slotsz00_31,
		obj_t BgL_srczd2defzd2_32)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 254 */
			{	/* Object/struct.scm 255 */
				obj_t BgL_oldz00_1072;

				BgL_oldz00_1072 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 40)));
				{	/* Object/struct.scm 255 */
					long BgL_lenz00_1073;

					BgL_lenz00_1073 =
						BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_31);
					{	/* Object/struct.scm 256 */
						obj_t BgL_auxz00_1074;

						BgL_auxz00_1074 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 23)));
						{	/* Object/struct.scm 257 */
							obj_t BgL_tauxz00_1075;

							{	/* Object/struct.scm 258 */
								obj_t BgL_arg3136z00_1210;

								{	/* Object/struct.scm 258 */
									obj_t BgL_arg3137z00_1211;

									obj_t BgL_arg3138z00_1212;

									BgL_arg3137z00_1211 = SYMBOL_TO_STRING(BgL_auxz00_1074);
									{	/* Object/struct.scm 258 */
										obj_t BgL_symbolz00_1437;

										BgL_symbolz00_1437 = CNST_TABLE_REF(((long) 22));
										BgL_arg3138z00_1212 = SYMBOL_TO_STRING(BgL_symbolz00_1437);
									}
									{	/* Object/struct.scm 258 */
										obj_t BgL_list3139z00_1213;

										{	/* Object/struct.scm 258 */
											obj_t BgL_arg3140z00_1214;

											BgL_arg3140z00_1214 =
												MAKE_PAIR(BgL_arg3138z00_1212, BNIL);
											BgL_list3139z00_1213 =
												MAKE_PAIR(BgL_arg3137z00_1211, BgL_arg3140z00_1214);
										}
										BgL_arg3136z00_1210 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list3139z00_1213);
								}}
								BgL_tauxz00_1075 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg3136z00_1210));
							}
							{	/* Object/struct.scm 258 */
								obj_t BgL_newz00_1076;

								BgL_newz00_1076 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											41)));
								{	/* Object/struct.scm 259 */
									obj_t BgL_tidz00_1077;

									BgL_tidz00_1077 =
										(((BgL_typez00_bglt) CREF(BgL_typez00_30))->BgL_idz00);
									{	/* Object/struct.scm 260 */
										BgL_globalz00_bglt BgL_holderz00_1078;

										{	/* Object/struct.scm 261 */
											BgL_tclassz00_bglt BgL_obj2133z00_1440;

											BgL_obj2133z00_1440 =
												(BgL_tclassz00_bglt) (BgL_typez00_30);
											{
												obj_t BgL_auxz00_2090;

												{	/* Object/struct.scm 261 */
													BgL_objectz00_bglt BgL_auxz00_2091;

													BgL_auxz00_2091 =
														(BgL_objectz00_bglt) (BgL_obj2133z00_1440);
													BgL_auxz00_2090 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2091);
												}
												BgL_holderz00_1078 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2090))->
													BgL_holderz00);
										}}
										{	/* Object/struct.scm 261 */
											obj_t BgL_wideningz00_1079;

											{	/* Object/struct.scm 262 */
												obj_t BgL_arg3131z00_1205;

												obj_t BgL_arg3132z00_1206;

												{	/* Object/struct.scm 262 */
													BgL_tclassz00_bglt BgL_obj2134z00_1441;

													BgL_obj2134z00_1441 =
														(BgL_tclassz00_bglt) (BgL_typez00_30);
													{
														obj_t BgL_auxz00_2096;

														{	/* Object/struct.scm 262 */
															BgL_objectz00_bglt BgL_auxz00_2097;

															BgL_auxz00_2097 =
																(BgL_objectz00_bglt) (BgL_obj2134z00_1441);
															BgL_auxz00_2096 =
																BGL_OBJECT_WIDENING(BgL_auxz00_2097);
														}
														BgL_arg3131z00_1205 =
															(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2096))->
															BgL_wideningz00);
												}}
												BgL_arg3132z00_1206 = CNST_TABLE_REF(((long) 5));
												{	/* Object/struct.scm 262 */
													obj_t BgL_list3133z00_1207;

													{	/* Object/struct.scm 262 */
														obj_t BgL_arg3134z00_1208;

														{	/* Object/struct.scm 262 */
															obj_t BgL_arg3135z00_1209;

															BgL_arg3135z00_1209 =
																MAKE_PAIR(BgL_tidz00_1077, BNIL);
															BgL_arg3134z00_1208 =
																MAKE_PAIR(BgL_arg3132z00_1206,
																BgL_arg3135z00_1209);
														}
														BgL_list3133z00_1207 =
															MAKE_PAIR(BgL_arg3131z00_1205,
															BgL_arg3134z00_1208);
													}
													BgL_wideningz00_1079 =
														BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
														(BgL_list3133z00_1207);
											}}
											{	/* Object/struct.scm 262 */

												{
													BgL_typez00_bglt BgL_typez00_1185;

													obj_t BgL_exprz00_1186;

													{	/* Object/struct.scm 270 */
														obj_t BgL_arg3015z00_1081;

														{	/* Object/struct.scm 270 */
															obj_t BgL_arg3016z00_1082;

															obj_t BgL_arg3017z00_1083;

															BgL_arg3016z00_1082 = CNST_TABLE_REF(((long) 18));
															{	/* Object/struct.scm 270 */
																obj_t BgL_arg3018z00_1084;

																obj_t BgL_arg3019z00_1085;

																{	/* Object/struct.scm 270 */
																	obj_t BgL_arg3023z00_1089;

																	obj_t BgL_arg3024z00_1090;

																	BgL_arg3023z00_1089 =
																		CNST_TABLE_REF(((long) 37));
																	{	/* Object/struct.scm 271 */
																		obj_t BgL_arg3025z00_1091;

																		obj_t BgL_arg3026z00_1092;

																		BgL_arg3025z00_1091 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(CNST_TABLE_REF(((long) 34)),
																			BgL_cnamez00_29);
																		BgL_arg3026z00_1092 =
																			CNST_TABLE_REF(((long) 38));
																		{	/* Object/struct.scm 270 */
																			obj_t BgL_list3028z00_1094;

																			{	/* Object/struct.scm 270 */
																				obj_t BgL_arg3029z00_1095;

																				BgL_arg3029z00_1095 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3028z00_1094 =
																					MAKE_PAIR(BgL_arg3026z00_1092,
																					BgL_arg3029z00_1095);
																			}
																			BgL_arg3024z00_1090 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg3025z00_1091,
																				BgL_list3028z00_1094);
																	}}
																	BgL_arg3018z00_1084 =
																		MAKE_PAIR(BgL_arg3023z00_1089,
																		BgL_arg3024z00_1090);
																}
																{	/* Object/struct.scm 273 */
																	obj_t BgL_arg3030z00_1096;

																	obj_t BgL_arg3031z00_1097;

																	BgL_arg3030z00_1096 =
																		CNST_TABLE_REF(((long) 4));
																	{	/* Object/struct.scm 273 */
																		obj_t BgL_arg3032z00_1098;

																		obj_t BgL_arg3033z00_1099;

																		{	/* Object/struct.scm 273 */
																			obj_t BgL_arg3037z00_1103;

																			obj_t BgL_arg3038z00_1104;

																			{	/* Object/struct.scm 273 */
																				obj_t BgL_arg3039z00_1105;

																				{	/* Object/struct.scm 273 */
																					obj_t BgL_arg3040z00_1106;

																					BgL_arg3040z00_1106 =
																						MAKE_PAIR(CNST_TABLE_REF(((long)
																								24)), BNIL);
																					{	/* Object/struct.scm 273 */
																						obj_t BgL_list3042z00_1108;

																						BgL_list3042z00_1108 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3039z00_1105 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg3040z00_1106,
																							BgL_list3042z00_1108);
																				}}
																				BgL_arg3037z00_1103 =
																					MAKE_PAIR(BgL_oldz00_1072,
																					BgL_arg3039z00_1105);
																			}
																			{	/* Object/struct.scm 274 */
																				obj_t BgL_arg3043z00_1109;

																				{	/* Object/struct.scm 274 */
																					obj_t BgL_arg3046z00_1112;

																					{	/* Object/struct.scm 274 */
																						obj_t BgL_arg3047z00_1113;

																						{	/* Object/struct.scm 274 */
																							obj_t BgL_arg3050z00_1116;

																							obj_t BgL_arg3051z00_1117;

																							BgL_arg3050z00_1116 =
																								CNST_TABLE_REF(((long) 31));
																							{	/* Object/struct.scm 274 */
																								obj_t BgL_list3052z00_1118;

																								{	/* Object/struct.scm 274 */
																									obj_t BgL_arg3054z00_1120;

																									BgL_arg3054z00_1120 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3052z00_1118 =
																										MAKE_PAIR(BINT(((long) 0)),
																										BgL_arg3054z00_1120);
																								}
																								BgL_arg3051z00_1117 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(CNST_TABLE_REF(((long) 32)),
																									BgL_list3052z00_1118);
																							}
																							BgL_arg3047z00_1113 =
																								MAKE_PAIR(BgL_arg3050z00_1116,
																								BgL_arg3051z00_1117);
																						}
																						{	/* Object/struct.scm 274 */
																							obj_t BgL_list3049z00_1115;

																							BgL_list3049z00_1115 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg3046z00_1112 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg3047z00_1113,
																								BgL_list3049z00_1115);
																					}}
																					BgL_arg3043z00_1109 =
																						MAKE_PAIR(BgL_tauxz00_1075,
																						BgL_arg3046z00_1112);
																				}
																				{	/* Object/struct.scm 273 */
																					obj_t BgL_list3045z00_1111;

																					BgL_list3045z00_1111 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3038z00_1104 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3043z00_1109,
																						BgL_list3045z00_1111);
																			}}
																			BgL_arg3032z00_1098 =
																				MAKE_PAIR(BgL_arg3037z00_1103,
																				BgL_arg3038z00_1104);
																		}
																		{	/* Object/struct.scm 275 */
																			obj_t BgL_arg3055z00_1121;

																			obj_t BgL_arg3056z00_1122;

																			BgL_arg3055z00_1121 =
																				CNST_TABLE_REF(((long) 4));
																			{	/* Object/struct.scm 275 */
																				obj_t BgL_arg3057z00_1123;

																				obj_t BgL_arg3058z00_1124;

																				obj_t BgL_arg3059z00_1125;

																				{	/* Object/struct.scm 275 */
																					obj_t BgL_arg3066z00_1131;

																					{	/* Object/struct.scm 275 */
																						obj_t BgL_arg3068z00_1133;

																						obj_t BgL_arg3069z00_1134;

																						BgL_arg3068z00_1133 =
																							BGl_makezd2typedzd2identz00zzast_identz00
																							(BgL_newz00_1076,
																							BgL_tidz00_1077);
																						{	/* Object/struct.scm 276 */
																							obj_t BgL_arg3070z00_1135;

																							BgL_typez00_1185 = BgL_typez00_30;
																							BgL_exprz00_1186 =
																								BgL_oldz00_1072;
																							{	/* Object/struct.scm 264 */
																								bool_t BgL_testz00_2136;

																								{	/* Object/struct.scm 264 */
																									obj_t BgL_arg3130z00_1203;

																									BgL_arg3130z00_1203 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_2138;
																										BgL_auxz00_2138 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3130z00_1203);
																										BgL_testz00_2136 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_2138))->
																											BgL_pragmazd2supportzd2);
																								}}
																								if (BgL_testz00_2136)
																									{	/* Object/struct.scm 265 */
																										obj_t BgL_arg3116z00_1189;

																										obj_t BgL_arg3117z00_1190;

																										{	/* Object/struct.scm 265 */
																											obj_t BgL_arg3118z00_1191;

																											obj_t BgL_arg3119z00_1192;

																											BgL_arg3118z00_1191 =
																												CNST_TABLE_REF(((long)
																													42));
																											BgL_arg3119z00_1192 =
																												(((BgL_typez00_bglt)
																													CREF
																													(BgL_typez00_1185))->
																												BgL_idz00);
																											BgL_arg3116z00_1189 =
																												BGl_makezd2typedzd2identz00zzast_identz00
																												(BgL_arg3118z00_1191,
																												BgL_arg3119z00_1192);
																										}
																										{	/* Object/struct.scm 266 */
																											obj_t BgL_arg3120z00_1193;

																											{	/* Object/struct.scm 266 */
																												obj_t
																													BgL_arg3125z00_1198;
																												BgL_arg3125z00_1198 =
																													(((BgL_typez00_bglt)
																														CREF
																														(BgL_typez00_1185))->
																													BgL_namez00);
																												BgL_arg3120z00_1193 =
																													string_append_3
																													(BGl_string3160z00zzobject_structz00,
																													BgL_arg3125z00_1198,
																													BGl_string3161z00zzobject_structz00);
																											}
																											{	/* Object/struct.scm 265 */
																												obj_t
																													BgL_list3122z00_1195;
																												{	/* Object/struct.scm 265 */
																													obj_t
																														BgL_arg3123z00_1196;
																													BgL_arg3123z00_1196 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list3122z00_1195 =
																														MAKE_PAIR
																														(BgL_exprz00_1186,
																														BgL_arg3123z00_1196);
																												}
																												BgL_arg3117z00_1190 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_arg3120z00_1193,
																													BgL_list3122z00_1195);
																										}}
																										BgL_arg3070z00_1135 =
																											MAKE_PAIR
																											(BgL_arg3116z00_1189,
																											BgL_arg3117z00_1190);
																									}
																								else
																									{	/* Object/struct.scm 268 */
																										obj_t BgL_arg3127z00_1200;

																										obj_t BgL_arg3128z00_1201;

																										BgL_arg3127z00_1200 =
																											CNST_TABLE_REF(((long)
																												43));
																										BgL_arg3128z00_1201 =
																											(((BgL_typez00_bglt)
																												CREF
																												(BgL_typez00_1185))->
																											BgL_idz00);
																										{	/* Object/struct.scm 268 */
																											obj_t
																												BgL_list3129z00_1202;
																											BgL_list3129z00_1202 =
																												MAKE_PAIR
																												(BgL_exprz00_1186,
																												BNIL);
																											BgL_arg3070z00_1135 =
																												BGl_makezd2privatezd2sexpz00zzast_privatez00
																												(BgL_arg3127z00_1200,
																												BgL_arg3128z00_1201,
																												BgL_list3129z00_1202);
																							}}}
																							{	/* Object/struct.scm 275 */
																								obj_t BgL_list3072z00_1137;

																								BgL_list3072z00_1137 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3069z00_1134 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3070z00_1135,
																									BgL_list3072z00_1137);
																						}}
																						BgL_arg3066z00_1131 =
																							MAKE_PAIR(BgL_arg3068z00_1133,
																							BgL_arg3069z00_1134);
																					}
																					BgL_arg3057z00_1123 =
																						MAKE_PAIR(BgL_arg3066z00_1131,
																						BNIL);
																				}
																				{	/* Object/struct.scm 277 */
																					obj_t BgL_arg3073z00_1138;

																					obj_t BgL_arg3074z00_1139;

																					BgL_arg3073z00_1138 =
																						CNST_TABLE_REF(((long) 44));
																					{	/* Object/struct.scm 278 */
																						obj_t BgL_arg3075z00_1140;

																						{	/* Object/struct.scm 278 */
																							obj_t BgL_arg3079z00_1144;

																							obj_t BgL_arg3080z00_1145;

																							BgL_arg3079z00_1144 =
																								CNST_TABLE_REF(((long) 45));
																							{	/* Object/struct.scm 279 */
																								obj_t BgL_arg3081z00_1146;

																								{	/* Object/struct.scm 279 */
																									obj_t BgL_arg3084z00_1149;

																									obj_t BgL_arg3085z00_1150;

																									BgL_arg3084z00_1149 =
																										CNST_TABLE_REF(((long) 46));
																									{	/* Object/struct.scm 279 */
																										obj_t BgL_arg3086z00_1151;

																										obj_t BgL_arg3087z00_1152;

																										{
																											BgL_variablez00_bglt
																												BgL_auxz00_2161;
																											BgL_auxz00_2161 =
																												(BgL_variablez00_bglt)
																												(BgL_holderz00_1078);
																											BgL_arg3086z00_1151 =
																												(((BgL_variablez00_bglt)
																													CREF
																													(BgL_auxz00_2161))->
																												BgL_idz00);
																										}
																										BgL_arg3087z00_1152 =
																											(((BgL_globalz00_bglt)
																												CREF
																												(BgL_holderz00_1078))->
																											BgL_modulez00);
																										{	/* Object/struct.scm 279 */
																											obj_t
																												BgL_list3089z00_1154;
																											{	/* Object/struct.scm 279 */
																												obj_t
																													BgL_arg3090z00_1155;
																												BgL_arg3090z00_1155 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_list3089z00_1154 =
																													MAKE_PAIR
																													(BgL_arg3087z00_1152,
																													BgL_arg3090z00_1155);
																											}
																											BgL_arg3085z00_1150 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg3086z00_1151,
																												BgL_list3089z00_1154);
																									}}
																									BgL_arg3081z00_1146 =
																										MAKE_PAIR
																										(BgL_arg3084z00_1149,
																										BgL_arg3085z00_1150);
																								}
																								{	/* Object/struct.scm 278 */
																									obj_t BgL_list3083z00_1148;

																									BgL_list3083z00_1148 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg3080z00_1145 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3081z00_1146,
																										BgL_list3083z00_1148);
																							}}
																							BgL_arg3075z00_1140 =
																								MAKE_PAIR(BgL_arg3079z00_1144,
																								BgL_arg3080z00_1145);
																						}
																						{	/* Object/struct.scm 277 */
																							obj_t BgL_list3077z00_1142;

																							{	/* Object/struct.scm 277 */
																								obj_t BgL_arg3078z00_1143;

																								BgL_arg3078z00_1143 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list3077z00_1142 =
																									MAKE_PAIR(BgL_arg3075z00_1140,
																									BgL_arg3078z00_1143);
																							}
																							BgL_arg3074z00_1139 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_newz00_1076,
																								BgL_list3077z00_1142);
																					}}
																					BgL_arg3058z00_1124 =
																						MAKE_PAIR(BgL_arg3073z00_1138,
																						BgL_arg3074z00_1139);
																				}
																				{	/* Object/struct.scm 281 */
																					obj_t BgL_arg3091z00_1156;

																					obj_t BgL_arg3092z00_1157;

																					BgL_arg3091z00_1156 =
																						CNST_TABLE_REF(((long) 39));
																					{	/* Object/struct.scm 283 */
																						obj_t BgL_arg3093z00_1158;

																						{	/* Object/struct.scm 283 */
																							obj_t BgL_arg3097z00_1162;

																							{	/* Object/struct.scm 283 */
																								obj_t BgL_arg3098z00_1163;

																								{
																									long BgL_iz00_1167;

																									obj_t BgL_slotsz00_1168;

																									obj_t BgL_refza2za2_1169;

																									BgL_iz00_1167 = ((long) 0);
																									BgL_slotsz00_1168 =
																										BgL_slotsz00_31;
																									BgL_refza2za2_1169 = BNIL;
																								BgL_zc3anonymousza33100ze3z83_1170:
																									if (
																										(BgL_iz00_1167 ==
																											BgL_lenz00_1073))
																										{	/* Object/struct.scm 287 */
																											BgL_arg3098z00_1163 =
																												bgl_reverse_bang
																												(BgL_refza2za2_1169);
																										}
																									else
																										{	/* Object/struct.scm 289 */
																											bool_t BgL_testz00_2180;

																											{	/* Object/struct.scm 289 */
																												obj_t
																													BgL_arg3113z00_1183;
																												BgL_arg3113z00_1183 =
																													CAR
																													(BgL_slotsz00_1168);
																												BgL_testz00_2180 =
																													BGl_slotzd2virtualzf3z21zzobject_slotsz00
																													((BgL_slotz00_bglt)
																													(BgL_arg3113z00_1183));
																											}
																											if (BgL_testz00_2180)
																												{
																													obj_t
																														BgL_slotsz00_2186;
																													long BgL_iz00_2184;

																													BgL_iz00_2184 =
																														(BgL_iz00_1167 +
																														((long) 1));
																													BgL_slotsz00_2186 =
																														CDR
																														(BgL_slotsz00_1168);
																													BgL_slotsz00_1168 =
																														BgL_slotsz00_2186;
																													BgL_iz00_1167 =
																														BgL_iz00_2184;
																													goto
																														BgL_zc3anonymousza33100ze3z83_1170;
																												}
																											else
																												{	/* Object/struct.scm 294 */
																													long
																														BgL_arg3105z00_1175;
																													obj_t
																														BgL_arg3106z00_1176;
																													obj_t
																														BgL_arg3107z00_1177;
																													BgL_arg3105z00_1175 =
																														(BgL_iz00_1167 +
																														((long) 1));
																													BgL_arg3106z00_1176 =
																														CDR
																														(BgL_slotsz00_1168);
																													{	/* Object/struct.scm 296 */
																														obj_t
																															BgL_arg3108z00_1178;
																														{	/* Object/struct.scm 296 */
																															obj_t
																																BgL_arg3109z00_1179;
																															obj_t
																																BgL_arg3110z00_1180;
																															BgL_arg3109z00_1179
																																=
																																CNST_TABLE_REF((
																																	(long) 31));
																															{	/* Object/struct.scm 296 */
																																obj_t
																																	BgL_list3111z00_1181;
																																{	/* Object/struct.scm 296 */
																																	obj_t
																																		BgL_arg3112z00_1182;
																																	BgL_arg3112z00_1182
																																		=
																																		MAKE_PAIR
																																		(BNIL,
																																		BNIL);
																																	BgL_list3111z00_1181
																																		=
																																		MAKE_PAIR
																																		(BINT
																																		(BgL_iz00_1167),
																																		BgL_arg3112z00_1182);
																																}
																																BgL_arg3110z00_1180
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_auxz00_1074,
																																	BgL_list3111z00_1181);
																															}
																															BgL_arg3108z00_1178
																																=
																																MAKE_PAIR
																																(BgL_arg3109z00_1179,
																																BgL_arg3110z00_1180);
																														}
																														BgL_arg3107z00_1177
																															=
																															MAKE_PAIR
																															(BgL_arg3108z00_1178,
																															BgL_refza2za2_1169);
																													}
																													{
																														obj_t
																															BgL_refza2za2_2199;
																														obj_t
																															BgL_slotsz00_2198;
																														long BgL_iz00_2197;

																														BgL_iz00_2197 =
																															BgL_arg3105z00_1175;
																														BgL_slotsz00_2198 =
																															BgL_arg3106z00_1176;
																														BgL_refza2za2_2199 =
																															BgL_arg3107z00_1177;
																														BgL_refza2za2_1169 =
																															BgL_refza2za2_2199;
																														BgL_slotsz00_1168 =
																															BgL_slotsz00_2198;
																														BgL_iz00_1167 =
																															BgL_iz00_2197;
																														goto
																															BgL_zc3anonymousza33100ze3z83_1170;
																													}
																												}
																										}
																								}
																								BgL_arg3097z00_1162 =
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3098z00_1163, BNIL);
																							}
																							BgL_arg3093z00_1158 =
																								MAKE_PAIR(BgL_wideningz00_1079,
																								BgL_arg3097z00_1162);
																						}
																						{	/* Object/struct.scm 281 */
																							obj_t BgL_list3095z00_1160;

																							{	/* Object/struct.scm 281 */
																								obj_t BgL_arg3096z00_1161;

																								BgL_arg3096z00_1161 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list3095z00_1160 =
																									MAKE_PAIR(BgL_arg3093z00_1158,
																									BgL_arg3096z00_1161);
																							}
																							BgL_arg3092z00_1157 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_newz00_1076,
																								BgL_list3095z00_1160);
																						}
																					}
																					BgL_arg3059z00_1125 =
																						MAKE_PAIR(BgL_arg3091z00_1156,
																						BgL_arg3092z00_1157);
																				}
																				{	/* Object/struct.scm 275 */
																					obj_t BgL_list3061z00_1127;

																					{	/* Object/struct.scm 275 */
																						obj_t BgL_arg3062z00_1128;

																						{	/* Object/struct.scm 275 */
																							obj_t BgL_arg3063z00_1129;

																							{	/* Object/struct.scm 275 */
																								obj_t BgL_arg3065z00_1130;

																								BgL_arg3065z00_1130 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3063z00_1129 =
																									MAKE_PAIR(BgL_newz00_1076,
																									BgL_arg3065z00_1130);
																							}
																							BgL_arg3062z00_1128 =
																								MAKE_PAIR(BgL_arg3059z00_1125,
																								BgL_arg3063z00_1129);
																						}
																						BgL_list3061z00_1127 =
																							MAKE_PAIR(BgL_arg3058z00_1124,
																							BgL_arg3062z00_1128);
																					}
																					BgL_arg3056z00_1122 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3057z00_1123,
																						BgL_list3061z00_1127);
																				}
																			}
																			BgL_arg3033z00_1099 =
																				MAKE_PAIR(BgL_arg3055z00_1121,
																				BgL_arg3056z00_1122);
																		}
																		{	/* Object/struct.scm 273 */
																			obj_t BgL_list3035z00_1101;

																			{	/* Object/struct.scm 273 */
																				obj_t BgL_arg3036z00_1102;

																				BgL_arg3036z00_1102 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3035z00_1101 =
																					MAKE_PAIR(BgL_arg3033z00_1099,
																					BgL_arg3036z00_1102);
																			}
																			BgL_arg3031z00_1097 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg3032z00_1098,
																				BgL_list3035z00_1101);
																		}
																	}
																	BgL_arg3019z00_1085 =
																		MAKE_PAIR(BgL_arg3030z00_1096,
																		BgL_arg3031z00_1097);
																}
																{	/* Object/struct.scm 270 */
																	obj_t BgL_list3021z00_1087;

																	{	/* Object/struct.scm 270 */
																		obj_t BgL_arg3022z00_1088;

																		BgL_arg3022z00_1088 = MAKE_PAIR(BNIL, BNIL);
																		BgL_list3021z00_1087 =
																			MAKE_PAIR(BgL_arg3019z00_1085,
																			BgL_arg3022z00_1088);
																	}
																	BgL_arg3017z00_1083 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3018z00_1084, BgL_list3021z00_1087);
																}
															}
															BgL_arg3015z00_1081 =
																MAKE_PAIR(BgL_arg3016z00_1082,
																BgL_arg3017z00_1083);
														}
														return
															BGl_epairifyz00zztools_miscz00
															(BgL_arg3015z00_1081, BgL_srczd2defzd2_32);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 195902195),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long) 405988581),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 17869975),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
			return
				BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string3162z00zzobject_structz00));
		}
	}

#ifdef __cplusplus
}
#endif
