/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;


	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_liipz00zzast_sexpz00(obj_t);
	static obj_t BGl__ifzd2symzd2zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_appz00_bglt BGl_makezd2appzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		obj_t, obj_t, BgL_varz00_bglt, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	static obj_t BGl__locationzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static obj_t BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	extern BgL_kwotez00_bglt BGl_makezd2kwotezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33811ze3z83zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern BgL_sequencez00_bglt BGl_makezd2sequencezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern BgL_closurez00_bglt BGl_makezd2closurezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_variablez00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_to_bstring(char *);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	static obj_t BGl_zc3anonymousza33276ze3z83zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_loopz00zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33277ze3z83zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	extern BgL_setqz00_bglt BGl_makezd2setqzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_varz00_bglt, BgL_nodez00_bglt);
	static obj_t BGl_zc3exitza33273ze3z83zzast_sexpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern BgL_selectz00_bglt BGl_makezd2selectzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, obj_t, BgL_typez00_bglt);
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	static obj_t BGl__usezd2variablez12zc0zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern bool_t BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	extern BgL_atomz00_bglt BGl_makezd2atomzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	extern BgL_failz00_bglt BGl_makezd2failzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	static obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__errorz00(obj_t);
	extern BgL_conditionalz00_bglt BGl_makezd2conditionalzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, BgL_nodez00_bglt,
		BgL_nodez00_bglt);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_privatezd2ze3nodez31zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	static obj_t BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t string_to_symbol(char *);
	static obj_t BGl__sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_lookupz00zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl__sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	BGL_IMPORT char *BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typeofzd2atomzd2zztype_typeofz00(obj_t);
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t __cnst[40];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl__ifza7d2symza7d2za7za7as4155z00, BGl__ifzd2symzd2zzast_sexpz00, 0L,
		BUNSPEC, 0);
	      DEFINE_STRING(BGl_string4122z00zzast_sexpz00,
		BgL_bgl_string4122za700za7za7a4156za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string4123z00zzast_sexpz00,
		BgL_bgl_string4123za700za7za7a4157za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string4124z00zzast_sexpz00,
		BgL_bgl_string4124za700za7za7a4158za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string4125z00zzast_sexpz00,
		BgL_bgl_string4125za700za7za7a4159za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string4126z00zzast_sexpz00,
		BgL_bgl_string4126za700za7za7a4160za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string4127z00zzast_sexpz00,
		BgL_bgl_string4127za700za7za7a4161za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string4128z00zzast_sexpz00,
		BgL_bgl_string4128za700za7za7a4162za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string4130z00zzast_sexpz00,
		BgL_bgl_string4130za700za7za7a4163za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string4129z00zzast_sexpz00,
		BgL_bgl_string4129za700za7za7a4164za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string4131z00zzast_sexpz00,
		BgL_bgl_string4131za700za7za7a4165za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string4132z00zzast_sexpz00,
		BgL_bgl_string4132za700za7za7a4166za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string4133z00zzast_sexpz00,
		BgL_bgl_string4133za700za7za7a4167za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string4134z00zzast_sexpz00,
		BgL_bgl_string4134za700za7za7a4168za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string4135z00zzast_sexpz00,
		BgL_bgl_string4135za700za7za7a4169za7,
		"This backend (~a) does not support external first class value functions",
		71);
	      DEFINE_STRING(BGl_string4136z00zzast_sexpz00,
		BgL_bgl_string4136za700za7za7a4170za7, "Illegal atom", 12);
	      DEFINE_STRING(BGl_string4137z00zzast_sexpz00,
		BgL_bgl_string4137za700za7za7a4171za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string4138z00zzast_sexpz00,
		BgL_bgl_string4138za700za7za7a4172za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string4140z00zzast_sexpz00,
		BgL_bgl_string4140za700za7za7a4173za7, "Illegal `pragma/effect' form", 28);
	      DEFINE_STRING(BGl_string4139z00zzast_sexpz00,
		BgL_bgl_string4139za700za7za7a4174za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string4141z00zzast_sexpz00,
		BgL_bgl_string4141za700za7za7a4175za7, "Illegal `free-pragma/effect' form",
		33);
	      DEFINE_STRING(BGl_string4142z00zzast_sexpz00,
		BgL_bgl_string4142za700za7za7a4176za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string4143z00zzast_sexpz00,
		BgL_bgl_string4143za700za7za7a4177za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string4144z00zzast_sexpz00,
		BgL_bgl_string4144za700za7za7a4178za7, "($1)", 4);
	      DEFINE_STRING(BGl_string4145z00zzast_sexpz00,
		BgL_bgl_string4145za700za7za7a4179za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string4146z00zzast_sexpz00,
		BgL_bgl_string4146za700za7za7a4180za7, "<", 1);
	      DEFINE_STRING(BGl_string4147z00zzast_sexpz00,
		BgL_bgl_string4147za700za7za7a4181za7, ":", 1);
	      DEFINE_STRING(BGl_string4148z00zzast_sexpz00,
		BgL_bgl_string4148za700za7za7a4182za7, "./", 2);
	      DEFINE_STRING(BGl_string4150z00zzast_sexpz00,
		BgL_bgl_string4150za700za7za7a4183za7, "-", 1);
	      DEFINE_STRING(BGl_string4149z00zzast_sexpz00,
		BgL_bgl_string4149za700za7za7a4184za7, ">", 1);
	      DEFINE_STRING(BGl_string4151z00zzast_sexpz00,
		BgL_bgl_string4151za700za7za7a4185za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string4152z00zzast_sexpz00,
		BgL_bgl_string4152za700za7za7a4186za7,
		"> bdb pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write exp car cons (quote ()) jump-exit set-exit case failure free-pragma/effect free-pragma pragma/effect labels letrec let lambda define begin __r4_control_features_6_9 apply quote @ app eval not ::bool test location set! pragma else value if (value apply app set!) ",
		376);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__errorza7d2sexpza7d24187z00,
		BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__defineza7d2primop4188za7,
		BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__sexpza7d2za7e3nodeza74189za7, BGl__sexpzd2ze3nodez31zzast_sexpz00,
		0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__locationza7d2za7e3n4190z00,
		BGl__locationzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl__useza7d2variableza74191z00, BGl__usezd2variablez12zc0zzast_sexpz00,
		0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl__sexpza7a2za7d2za7e3no4192za7,
		BGl__sexpza2zd2ze3nodez93zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl__makeza7d2anonymou4193za7, va_generic_entry,
		BGl__makezd2anonymouszd2namez00zzast_sexpz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__topza7d2levelza7d2s4194z00,
		BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__defineza7d2primop4195za7,
		BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_2894, char *BgL_fromz00_2895)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					BGl_toplevelzd2initzd2zzast_sexpz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_2886;

				BgL_cportz00_2886 =
					bgl_open_input_string(BGl_string4152z00zzast_sexpz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2887;

					BgL_iz00_2887 = ((long) 39);
				BgL_loopz00_2888:
					if ((BgL_iz00_2887 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg4154z00_2890;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_2892;

										BgL_locationz00_2892 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg4154z00_2890 =
												BGl_readz00zz__readerz00(BgL_cportz00_2886,
												BgL_locationz00_2892);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_auxz00_2920;

									BgL_auxz00_2920 = (int) (BgL_iz00_2887);
									CNST_TABLE_SET(BgL_auxz00_2920, BgL_arg4154z00_2890);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_2893;

								BgL_auxz00_2893 = (int) ((BgL_iz00_2887 - ((long) 1)));
								{
									long BgL_iz00_2925;

									BgL_iz00_2925 = (long) (BgL_auxz00_2893);
									BgL_iz00_2887 = BgL_iz00_2925;
									goto BgL_loopz00_2888;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}
	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_15,
		obj_t BgL_locz00_16)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 59 */
			return
				(BgL_nodez00_bglt) (BGl_zc3exitza33273ze3z83zzast_sexpz00(BgL_locz00_16,
					BgL_expz00_15));
		}
	}



/* <exit:3273> */
	obj_t BGl_zc3exitza33273ze3z83zzast_sexpz00(obj_t BgL_locz00_2884,
		obj_t BgL_expz00_2883)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 60 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit3234z00_874;

			if (SET_EXIT(BgL_an_exit3234z00_874))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
					BgL_an_exit3234z00_874 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 60 */

						PUSH_EXIT(BgL_an_exit3234z00_874, ((long) 1));
						{	/* Ast/sexp.scm 60 */
							obj_t BgL_an_exitd3235z00_875;

							BgL_an_exitd3235z00_875 = BGL_EXITD_TOP_AS_OBJ();
							{	/* Ast/sexp.scm 63 */
								obj_t BgL_res3237z00_878;

								{	/* Ast/sexp.scm 63 */
									obj_t BgL_zc3anonymousza33277ze3z83_2835;

									obj_t BgL_zc3anonymousza33276ze3z83_2836;

									BgL_zc3anonymousza33277ze3z83_2835 =
										make_fx_procedure
										(BGl_zc3anonymousza33277ze3z83zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3anonymousza33276ze3z83_2836 =
										make_fx_procedure
										(BGl_zc3anonymousza33276ze3z83zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza33277ze3z83_2835,
										(int) (((long) 0)), BgL_expz00_2883);
									PROCEDURE_SET(BgL_zc3anonymousza33277ze3z83_2835,
										(int) (((long) 1)), BgL_locz00_2884);
									PROCEDURE_SET(BgL_zc3anonymousza33276ze3z83_2836,
										(int) (((long) 0)), BgL_an_exitd3235z00_875);
									BgL_res3237z00_878 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3anonymousza33276ze3z83_2836,
										BgL_zc3anonymousza33277ze3z83_2835);
								}
								POP_EXIT();
								return BgL_res3237z00_878;
							}
						}
					}
				}
		}
	}



/* _top-level-sexp->node */
	obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2837,
		obj_t BgL_expz00_2838, obj_t BgL_locz00_2839)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 59 */
			return
				(obj_t) (BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
				(BgL_expz00_2838, BgL_locz00_2839));
		}
	}



/* <anonymous:3277> */
	obj_t BGl_zc3anonymousza33277ze3z83zzast_sexpz00(obj_t BgL_envz00_2840)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 65 */
			{	/* Ast/sexp.scm 66 */
				obj_t BgL_expz00_2841;

				obj_t BgL_locz00_2842;

				BgL_expz00_2841 = PROCEDURE_REF(BgL_envz00_2840, (int) (((long) 0)));
				BgL_locz00_2842 = PROCEDURE_REF(BgL_envz00_2840, (int) (((long) 1)));
				{

					{	/* Ast/sexp.scm 66 */
						BgL_nodez00_bglt BgL_auxz00_2956;

						BgL_auxz00_2956 =
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2841, BNIL,
							BgL_locz00_2842, CNST_TABLE_REF(((long) 2)));
						return (obj_t) (BgL_auxz00_2956);
					}
				}
			}
		}
	}



/* <anonymous:3276> */
	obj_t BGl_zc3anonymousza33276ze3z83zzast_sexpz00(obj_t BgL_envz00_2843,
		obj_t BgL_ez00_2845)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 62 */
			{	/* Ast/sexp.scm 63 */
				obj_t BgL_an_exitd3235z00_2844;

				BgL_an_exitd3235z00_2844 =
					PROCEDURE_REF(BgL_envz00_2843, (int) (((long) 0)));
				{
					obj_t BgL_ez00_881;

					BgL_ez00_881 = BgL_ez00_2845;
					BGl_exceptionzd2notifyzd2zz__errorz00(BgL_ez00_881);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd3235z00_2844,
						BUNSPEC);
				}
			}
		}
	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 81 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}
	}



/* _if-sym */
	obj_t BGl__ifzd2symzd2zzast_sexpz00(obj_t BgL_envz00_2846)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 81 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}
	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_18, obj_t BgL_stackz00_19, obj_t BgL_locz00_20,
		obj_t BgL_sitez00_21)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 98 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_888;

				obj_t BgL_bodyz00_894;

				obj_t BgL_bodyz00_899;

				obj_t BgL_argsz00_900;

				obj_t BgL_varsz00_904;

				obj_t BgL_bodyz00_905;

				obj_t BgL_argsz00_906;

				obj_t BgL_effectz00_910;

				obj_t BgL_restz00_911;

				obj_t BgL_effectz00_914;

				obj_t BgL_restz00_915;

				if (NULLP(BgL_expz00_18))
					{	/* Ast/sexp.scm 103 */
						return
							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string4137z00zzast_sexpz00, BgL_expz00_18, BgL_locz00_20);
					}
				else
					{	/* Ast/sexp.scm 103 */
						if (BGl_iszd2azf3z21zz__objectz00(BgL_expz00_18,
								BGl_nodez00zzast_nodez00))
							{	/* Ast/sexp.scm 103 */
								return (BgL_nodez00_bglt) (BgL_expz00_18);
							}
						else
							{	/* Ast/sexp.scm 103 */
								if (PAIRP(BgL_expz00_18))
									{	/* Ast/sexp.scm 103 */
										obj_t BgL_carzd21519zd2_929;

										BgL_carzd21519zd2_929 = CAR(BgL_expz00_18);
										if (SYMBOLP(BgL_carzd21519zd2_929))
											{	/* Ast/sexp.scm 103 */
												bool_t BgL_testz00_2975;

												{	/* Ast/sexp.scm 103 */
													obj_t BgL__ortest_3258z00_1079;

													BgL__ortest_3258z00_1079 =
														BGl_lookupz00zzast_sexpz00(BgL_carzd21519zd2_929,
														BgL_stackz00_19);
													if (CBOOL(BgL__ortest_3258z00_1079))
														{	/* Ast/sexp.scm 103 */
															BgL_testz00_2975 =
																CBOOL(BgL__ortest_3258z00_1079);
														}
													else
														{	/* Ast/sexp.scm 103 */
															obj_t BgL_gz00_1080;

															BgL_gz00_1080 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd21519zd2_929, BNIL);
															if (CBOOL(BgL_gz00_1080))
																{	/* Ast/sexp.scm 103 */
																	bool_t BgL_testz00_2983;

																	{	/* Ast/sexp.scm 103 */
																		obj_t BgL_auxz00_2984;

																		{
																			BgL_globalz00_bglt BgL_auxz00_2985;

																			BgL_auxz00_2985 =
																				(BgL_globalz00_bglt) (BgL_gz00_1080);
																			BgL_auxz00_2984 =
																				(((BgL_globalz00_bglt)
																					CREF(BgL_auxz00_2985))->
																				BgL_modulez00);
																		}
																		BgL_testz00_2983 =
																			(BgL_auxz00_2984 ==
																			CNST_TABLE_REF(((long) 15)));
																	}
																	if (BgL_testz00_2983)
																		{	/* Ast/sexp.scm 103 */
																			BgL_testz00_2975 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 103 */
																			BgL_testz00_2975 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 103 */
																	BgL_testz00_2975 = ((bool_t) 0);
																}
														}
												}
												if (BgL_testz00_2975)
													{	/* Ast/sexp.scm 103 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_18,
															BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
													}
												else
													{	/* Ast/sexp.scm 103 */
														if (
															(CAR(BgL_expz00_18) ==
																CNST_TABLE_REF(((long) 12))))
															{	/* Ast/sexp.scm 103 */
																obj_t BgL_auxz00_2995;

															BgL_tagzd21467zd2_892:
																{	/* Ast/sexp.scm 187 */
																	obj_t BgL_locz00_1281;

																	BgL_locz00_1281 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_18, BgL_locz00_20);
																	{
																		obj_t BgL_namez00_1282;

																		obj_t BgL_modulez00_1283;

																		if (PAIRP(BgL_expz00_18))
																			{	/* Ast/sexp.scm 188 */
																				obj_t BgL_cdrzd22253zd2_1288;

																				BgL_cdrzd22253zd2_1288 =
																					CDR(BgL_expz00_18);
																				if (
																					(CAR(BgL_expz00_18) ==
																						CNST_TABLE_REF(((long) 12))))
																					{	/* Ast/sexp.scm 188 */
																						if (PAIRP(BgL_cdrzd22253zd2_1288))
																							{	/* Ast/sexp.scm 188 */
																								obj_t BgL_carzd22256zd2_1291;

																								obj_t BgL_cdrzd22257zd2_1292;

																								BgL_carzd22256zd2_1291 =
																									CAR(BgL_cdrzd22253zd2_1288);
																								BgL_cdrzd22257zd2_1292 =
																									CDR(BgL_cdrzd22253zd2_1288);
																								if (SYMBOLP
																									(BgL_carzd22256zd2_1291))
																									{	/* Ast/sexp.scm 188 */
																										if (PAIRP
																											(BgL_cdrzd22257zd2_1292))
																											{	/* Ast/sexp.scm 188 */
																												obj_t
																													BgL_carzd22262zd2_1295;
																												BgL_carzd22262zd2_1295 =
																													CAR
																													(BgL_cdrzd22257zd2_1292);
																												if (SYMBOLP
																													(BgL_carzd22262zd2_1295))
																													{	/* Ast/sexp.scm 188 */
																														if (NULLP(CDR
																																(BgL_cdrzd22257zd2_1292)))
																															{	/* Ast/sexp.scm 188 */
																																BgL_namez00_1282
																																	=
																																	BgL_carzd22256zd2_1291;
																																BgL_modulez00_1283
																																	=
																																	BgL_carzd22262zd2_1295;
																																{	/* Ast/sexp.scm 190 */
																																	obj_t
																																		BgL_globalz00_1301;
																																	BgL_globalz00_1301
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_1282,
																																		BgL_modulez00_1283);
																																	if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1301, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 194 */
																																			bool_t
																																				BgL_testz00_3021;
																																			{	/* Ast/sexp.scm 194 */
																																				obj_t
																																					BgL_auxz00_3022;
																																				{
																																					BgL_globalz00_bglt
																																						BgL_auxz00_3023;
																																					BgL_auxz00_3023
																																						=
																																						(BgL_globalz00_bglt)
																																						(BgL_globalz00_1301);
																																					BgL_auxz00_3022
																																						=
																																						(((BgL_globalz00_bglt) CREF(BgL_auxz00_3023))->BgL_importz00);
																																				}
																																				BgL_testz00_3021
																																					=
																																					(BgL_auxz00_3022
																																					==
																																					CNST_TABLE_REF
																																					(((long) 10)));
																																			}
																																			if (BgL_testz00_3021)
																																				{	/* Ast/sexp.scm 195 */
																																					obj_t
																																						BgL_arg3611z00_1304;
																																					{	/* Ast/sexp.scm 195 */
																																						obj_t
																																							BgL_arg3612z00_1305;
																																						obj_t
																																							BgL_arg3613z00_1306;
																																						BgL_arg3612z00_1305
																																							=
																																							CNST_TABLE_REF
																																							(((long) 10));
																																						{	/* Ast/sexp.scm 195 */
																																							obj_t
																																								BgL_list3614z00_1307;
																																							BgL_list3614z00_1307
																																								=
																																								MAKE_PAIR
																																								(BNIL,
																																								BNIL);
																																							BgL_arg3613z00_1306
																																								=
																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																								(BGl_atomz00zzast_nodez00,
																																								BgL_list3614z00_1307);
																																						}
																																						BgL_arg3611z00_1304
																																							=
																																							MAKE_PAIR
																																							(BgL_arg3612z00_1305,
																																							BgL_arg3613z00_1306);
																																					}
																																					BgL_auxz00_2995
																																						=
																																						(obj_t)
																																						(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg3611z00_1304,
																																							BgL_stackz00_19,
																																							BgL_locz00_1281,
																																							BgL_sitez00_21));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 194 */
																																					BGl_usezd2variablez12zc0zzast_sexpz00
																																						(
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1301),
																																						BgL_locz00_1281,
																																						BgL_sitez00_21);
																																					{	/* Ast/sexp.scm 198 */
																																						bool_t
																																							BgL_testz00_3036;
																																						if (
																																							(BgL_sitez00_21
																																								==
																																								CNST_TABLE_REF
																																								(((long) 11))))
																																							{	/* Ast/sexp.scm 198 */
																																								BgL_testz00_3036
																																									=
																																									(
																																									(bool_t)
																																									0);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 199 */
																																								BgL_valuez00_bglt
																																									BgL_arg3619z00_1312;
																																								{
																																									BgL_variablez00_bglt
																																										BgL_auxz00_3040;
																																									BgL_auxz00_3040
																																										=
																																										(BgL_variablez00_bglt)
																																										(BgL_globalz00_1301);
																																									BgL_arg3619z00_1312
																																										=
																																										(
																																										((BgL_variablez00_bglt) CREF(BgL_auxz00_3040))->BgL_valuez00);
																																								}
																																								{	/* Ast/sexp.scm 199 */
																																									obj_t
																																										BgL_obj1844z00_2498;
																																									BgL_obj1844z00_2498
																																										=
																																										(obj_t)
																																										(BgL_arg3619z00_1312);
																																									BgL_testz00_3036
																																										=
																																										BGl_iszd2azf3z21zz__objectz00
																																										(BgL_obj1844z00_2498,
																																										BGl_funz00zzast_varz00);
																																								}
																																							}
																																						if (BgL_testz00_3036)
																																							{	/* Ast/sexp.scm 201 */
																																								BgL_typez00_bglt
																																									BgL_arg3616z00_1309;
																																								{
																																									BgL_variablez00_bglt
																																										BgL_auxz00_3045;
																																									BgL_auxz00_3045
																																										=
																																										(BgL_variablez00_bglt)
																																										(BgL_globalz00_1301);
																																									BgL_arg3616z00_1309
																																										=
																																										(
																																										((BgL_variablez00_bglt) CREF(BgL_auxz00_3045))->BgL_typez00);
																																								}
																																								BgL_auxz00_2995
																																									=
																																									(obj_t)
																																									(BGl_makezd2closurezd2zzast_nodez00
																																									(BgL_locz00_1281,
																																										BgL_arg3616z00_1309,
																																										(BgL_variablez00_bglt)
																																										(BgL_globalz00_1301)));
																																							}
																																						else
																																							{	/* Ast/sexp.scm 204 */
																																								BgL_typez00_bglt
																																									BgL_arg3617z00_1310;
																																								{
																																									BgL_variablez00_bglt
																																										BgL_auxz00_3051;
																																									BgL_auxz00_3051
																																										=
																																										(BgL_variablez00_bglt)
																																										(BgL_globalz00_1301);
																																									BgL_arg3617z00_1310
																																										=
																																										(
																																										((BgL_variablez00_bglt) CREF(BgL_auxz00_3051))->BgL_typez00);
																																								}
																																								BgL_auxz00_2995
																																									=
																																									(obj_t)
																																									(BGl_makezd2varzd2zzast_nodez00
																																									(BgL_locz00_1281,
																																										BgL_arg3617z00_1310,
																																										(BgL_variablez00_bglt)
																																										(BgL_globalz00_1301)));
																																							}
																																					}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 192 */
																																			BgL_auxz00_2995
																																				=
																																				(obj_t)
																																				(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																				(BGl_string4134z00zzast_sexpz00,
																																					BgL_expz00_18,
																																					BgL_locz00_1281));
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 188 */
																																BgL_nodez00_bglt
																																	BgL_auxz00_3059;
																															BgL_tagzd22246zd2_1285:
																																BgL_auxz00_3059
																																	=
																																	BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																	(BGl_string4133z00zzast_sexpz00,
																																	BgL_expz00_18,
																																	BgL_locz00_1281);
																																BgL_auxz00_2995
																																	=
																																	(obj_t)
																																	(BgL_auxz00_3059);
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 188 */
																														BgL_nodez00_bglt
																															BgL_auxz00_3062;
																														goto
																															BgL_tagzd22246zd2_1285;
																														BgL_auxz00_2995 =
																															(obj_t)
																															(BgL_auxz00_3062);
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 188 */
																												BgL_nodez00_bglt
																													BgL_auxz00_3064;
																												goto
																													BgL_tagzd22246zd2_1285;
																												BgL_auxz00_2995 =
																													(obj_t)
																													(BgL_auxz00_3064);
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 188 */
																										BgL_nodez00_bglt
																											BgL_auxz00_3066;
																										goto BgL_tagzd22246zd2_1285;
																										BgL_auxz00_2995 =
																											(obj_t) (BgL_auxz00_3066);
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 188 */
																								BgL_nodez00_bglt
																									BgL_auxz00_3068;
																								goto BgL_tagzd22246zd2_1285;
																								BgL_auxz00_2995 =
																									(obj_t) (BgL_auxz00_3068);
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 188 */
																						BgL_nodez00_bglt BgL_auxz00_3070;

																						goto BgL_tagzd22246zd2_1285;
																						BgL_auxz00_2995 =
																							(obj_t) (BgL_auxz00_3070);
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 188 */
																				BgL_nodez00_bglt BgL_auxz00_3072;

																				goto BgL_tagzd22246zd2_1285;
																				BgL_auxz00_2995 =
																					(obj_t) (BgL_auxz00_3072);
																			}
																	}
																}
																return (BgL_nodez00_bglt) (BgL_auxz00_2995);
															}
														else
															{	/* Ast/sexp.scm 103 */
																if (
																	(CAR(BgL_expz00_18) ==
																		CNST_TABLE_REF(((long) 13))))
																	{	/* Ast/sexp.scm 103 */
																		obj_t BgL_auxz00_3079;

																	BgL_tagzd21468zd2_893:
																		{
																			obj_t BgL_valuez00_1315;

																			if (PAIRP(BgL_expz00_18))
																				{	/* Ast/sexp.scm 103 */
																					obj_t BgL_cdrzd22273zd2_1320;

																					BgL_cdrzd22273zd2_1320 =
																						CDR(BgL_expz00_18);
																					if (PAIRP(BgL_cdrzd22273zd2_1320))
																						{	/* Ast/sexp.scm 103 */
																							if (NULLP(CDR
																									(BgL_cdrzd22273zd2_1320)))
																								{	/* Ast/sexp.scm 103 */
																									BgL_valuez00_1315 =
																										CAR(BgL_cdrzd22273zd2_1320);
																									{	/* Ast/sexp.scm 212 */
																										obj_t BgL_locz00_1325;

																										BgL_locz00_1325 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_18,
																											BgL_locz00_20);
																										if (NULLP
																											(BgL_valuez00_1315))
																											{	/* Ast/sexp.scm 214 */
																												BgL_auxz00_3079 =
																													(obj_t)
																													(BGl_makezd2atomzd2zzast_nodez00
																													(BgL_locz00_1325,
																														(BgL_typez00_bglt)
																														(BGl_za2bnilza2z00zztype_cachez00),
																														BNIL));
																											}
																										else
																											{	/* Ast/sexp.scm 218 */
																												bool_t BgL_testz00_3094;

																												if (PAIRP
																													(BgL_valuez00_1315))
																													{	/* Ast/sexp.scm 218 */
																														BgL_testz00_3094 =
																															((bool_t) 1);
																													}
																												else
																													{	/* Ast/sexp.scm 218 */
																														if (VECTORP
																															(BgL_valuez00_1315))
																															{	/* Ast/sexp.scm 219 */
																																BgL_testz00_3094
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 219 */
																																if (BGL_HVECTORP
																																	(BgL_valuez00_1315))
																																	{	/* Ast/sexp.scm 220 */
																																		BgL_testz00_3094
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 220 */
																																		if (STRUCTP
																																			(BgL_valuez00_1315))
																																			{	/* Ast/sexp.scm 221 */
																																				BgL_testz00_3094
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 221 */
																																				if (SYMBOLP(BgL_valuez00_1315))
																																					{	/* Ast/sexp.scm 222 */
																																						BgL_testz00_3094
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 222 */
																																						BgL_testz00_3094
																																							=
																																							KEYWORDP
																																							(BgL_valuez00_1315);
																																					}
																																			}
																																	}
																															}
																													}
																												if (BgL_testz00_3094)
																													{	/* Ast/sexp.scm 218 */
																														BgL_auxz00_3079 =
																															(obj_t)
																															(BGl_makezd2kwotezd2zzast_nodez00
																															(BgL_locz00_1325,
																																(BgL_typez00_bglt)
																																(BGl_za2_za2z00zztype_cachez00),
																																BgL_valuez00_1315));
																													}
																												else
																													{	/* Ast/sexp.scm 227 */
																														bool_t
																															BgL_testz00_3109;
																														{	/* Ast/sexp.scm 227 */
																															bool_t
																																BgL_testz00_3110;
																															if (INTEGERP
																																(BgL_valuez00_1315))
																																{	/* Ast/sexp.scm 227 */
																																	BgL_testz00_3110
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 227 */
																																	if (REALP
																																		(BgL_valuez00_1315))
																																		{	/* Ast/sexp.scm 227 */
																																			BgL_testz00_3110
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 227 */
																																			if (ELONGP
																																				(BgL_valuez00_1315))
																																				{	/* Ast/sexp.scm 227 */
																																					BgL_testz00_3110
																																						=
																																						(
																																						(bool_t)
																																						1);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 227 */
																																					if (LLONGP(BgL_valuez00_1315))
																																						{	/* Ast/sexp.scm 227 */
																																							BgL_testz00_3110
																																								=
																																								(
																																								(bool_t)
																																								1);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 227 */
																																							BgL_testz00_3110
																																								=
																																								BIGNUMP
																																								(BgL_valuez00_1315);
																																						}
																																				}
																																		}
																																}
																															if (BgL_testz00_3110)
																																{	/* Ast/sexp.scm 227 */
																																	BgL_testz00_3109
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 227 */
																																	if (STRINGP
																																		(BgL_valuez00_1315))
																																		{	/* Ast/sexp.scm 228 */
																																			BgL_testz00_3109
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 228 */
																																			if (CNSTP
																																				(BgL_valuez00_1315))
																																				{	/* Ast/sexp.scm 229 */
																																					BgL_testz00_3109
																																						=
																																						(
																																						(bool_t)
																																						1);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 229 */
																																					if (CHARP(BgL_valuez00_1315))
																																						{	/* Ast/sexp.scm 233 */
																																							BgL_testz00_3109
																																								=
																																								(
																																								(bool_t)
																																								1);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 233 */
																																							BgL_testz00_3109
																																								=
																																								BOOLEANP
																																								(BgL_valuez00_1315);
																																						}
																																				}
																																		}
																																}
																														}
																														if (BgL_testz00_3109)
																															{	/* Ast/sexp.scm 227 */
																																BgL_auxz00_3079
																																	=
																																	(obj_t)
																																	(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																	(BgL_valuez00_1315,
																																		BgL_stackz00_19,
																																		BgL_locz00_1325,
																																		BgL_sitez00_21));
																															}
																														else
																															{	/* Ast/sexp.scm 227 */
																																BgL_auxz00_3079
																																	=
																																	(obj_t)
																																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																	(BGl_string4132z00zzast_sexpz00,
																																		BgL_expz00_18,
																																		BgL_locz00_1325));
																															}
																													}
																											}
																									}
																								}
																							else
																								{	/* Ast/sexp.scm 103 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3132;
																								BgL_tagzd22268zd2_1317:
																									BgL_auxz00_3132 =
																										BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																										(BGl_string4132z00zzast_sexpz00,
																										BgL_expz00_18,
																										BgL_locz00_20);
																									BgL_auxz00_3079 =
																										(obj_t) (BgL_auxz00_3132);
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 103 */
																							BgL_nodez00_bglt BgL_auxz00_3135;

																							goto BgL_tagzd22268zd2_1317;
																							BgL_auxz00_3079 =
																								(obj_t) (BgL_auxz00_3135);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 103 */
																					BgL_nodez00_bglt BgL_auxz00_3137;

																					goto BgL_tagzd22268zd2_1317;
																					BgL_auxz00_3079 =
																						(obj_t) (BgL_auxz00_3137);
																				}
																		}
																		return (BgL_nodez00_bglt) (BgL_auxz00_3079);
																	}
																else
																	{	/* Ast/sexp.scm 103 */
																		if (
																			(CAR(BgL_expz00_18) ==
																				CNST_TABLE_REF(((long) 16))))
																			{	/* Ast/sexp.scm 103 */
																				obj_t BgL_arg3287z00_936;

																				BgL_arg3287z00_936 = CDR(BgL_expz00_18);
																				{	/* Ast/sexp.scm 103 */
																					BgL_sequencez00_bglt BgL_auxz00_3145;

																					BgL_bodyz00_894 = BgL_arg3287z00_936;
																				BgL_tagzd21469zd2_895:
																					{	/* Ast/sexp.scm 242 */
																						obj_t BgL_bodyz00_1338;

																						if (NULLP(BgL_bodyz00_894))
																							{	/* Ast/sexp.scm 243 */
																								obj_t BgL_list3640z00_1342;

																								BgL_list3640z00_1342 =
																									MAKE_PAIR(BUNSPEC, BNIL);
																								BgL_bodyz00_1338 =
																									BgL_list3640z00_1342;
																							}
																						else
																							{	/* Ast/sexp.scm 242 */
																								BgL_bodyz00_1338 =
																									BgL_bodyz00_894;
																							}
																						{	/* Ast/sexp.scm 245 */
																							obj_t BgL_locz00_1339;

																							BgL_locz00_1339 =
																								BGl_findzd2locationzf2locz20zztools_locationz00
																								(BgL_expz00_18, BgL_locz00_20);
																							{	/* Ast/sexp.scm 245 */
																								obj_t BgL_nodesz00_1340;

																								BgL_nodesz00_1340 =
																									BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																									(BgL_bodyz00_1338,
																									BgL_stackz00_19,
																									BgL_locz00_1339,
																									BgL_sitez00_21);
																								{	/* Ast/sexp.scm 246 */

																									BgL_auxz00_3145 =
																										BGl_makezd2sequencezd2zzast_nodez00
																										(BgL_locz00_1339,
																										(BgL_typez00_bglt)
																										(BGl_za2_za2z00zztype_cachez00),
																										BUNSPEC, BINT(((long) -1)),
																										BgL_nodesz00_1340);
																					}}}}
																					return
																						(BgL_nodez00_bglt)
																						(BgL_auxz00_3145);
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 103 */
																				obj_t BgL_carzd21550zd2_937;

																				BgL_carzd21550zd2_937 =
																					CAR(BgL_expz00_18);
																				if (
																					(BgL_carzd21550zd2_937 ==
																						CNST_TABLE_REF(((long) 1))))
																					{	/* Ast/sexp.scm 103 */
																						obj_t BgL_auxz00_3159;

																					BgL_tagzd21470zd2_896:
																						{
																							obj_t BgL_siz00_1343;

																							obj_t BgL_alorsz00_1344;

																							obj_t BgL_sinonz00_1345;

																							obj_t BgL_siz00_1347;

																							obj_t BgL_alorsz00_1348;

																							if (PAIRP(BgL_expz00_18))
																								{	/* Ast/sexp.scm 103 */
																									obj_t BgL_cdrzd22289zd2_1353;

																									BgL_cdrzd22289zd2_1353 =
																										CDR(BgL_expz00_18);
																									if (PAIRP
																										(BgL_cdrzd22289zd2_1353))
																										{	/* Ast/sexp.scm 103 */
																											obj_t
																												BgL_cdrzd22294zd2_1355;
																											BgL_cdrzd22294zd2_1355 =
																												CDR
																												(BgL_cdrzd22289zd2_1353);
																											if (PAIRP
																												(BgL_cdrzd22294zd2_1355))
																												{	/* Ast/sexp.scm 103 */
																													obj_t
																														BgL_cdrzd22299zd2_1357;
																													BgL_cdrzd22299zd2_1357
																														=
																														CDR
																														(BgL_cdrzd22294zd2_1355);
																													if (PAIRP
																														(BgL_cdrzd22299zd2_1357))
																														{	/* Ast/sexp.scm 103 */
																															if (NULLP(CDR
																																	(BgL_cdrzd22299zd2_1357)))
																																{	/* Ast/sexp.scm 103 */
																																	BgL_siz00_1343
																																		=
																																		CAR
																																		(BgL_cdrzd22289zd2_1353);
																																	BgL_alorsz00_1344
																																		=
																																		CAR
																																		(BgL_cdrzd22294zd2_1355);
																																	BgL_sinonz00_1345
																																		=
																																		CAR
																																		(BgL_cdrzd22299zd2_1357);
																																	{
																																		obj_t
																																			BgL_siz00_1370;
																																		if (PAIRP
																																			(BgL_siz00_1343))
																																			{	/* Ast/sexp.scm 103 */
																																				obj_t
																																					BgL_cdrzd22354zd2_1375;
																																				BgL_cdrzd22354zd2_1375
																																					=
																																					CDR
																																					(BgL_siz00_1343);
																																				if ((CAR
																																						(BgL_siz00_1343)
																																						==
																																						CNST_TABLE_REF
																																						(((long) 1))))
																																					{	/* Ast/sexp.scm 103 */
																																						if (PAIRP(BgL_cdrzd22354zd2_1375))
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_cdrzd22357zd2_1378;
																																								BgL_cdrzd22357zd2_1378
																																									=
																																									CDR
																																									(BgL_cdrzd22354zd2_1375);
																																								if (PAIRP(BgL_cdrzd22357zd2_1378))
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_cdrzd22360zd2_1380;
																																										BgL_cdrzd22360zd2_1380
																																											=
																																											CDR
																																											(BgL_cdrzd22357zd2_1378);
																																										if ((CAR(BgL_cdrzd22357zd2_1378) == BFALSE))
																																											{	/* Ast/sexp.scm 103 */
																																												if (PAIRP(BgL_cdrzd22360zd2_1380))
																																													{	/* Ast/sexp.scm 103 */
																																														if ((CAR(BgL_cdrzd22360zd2_1380) == BTRUE))
																																															{	/* Ast/sexp.scm 103 */
																																																if (NULLP(CDR(BgL_cdrzd22360zd2_1380)))
																																																	{	/* Ast/sexp.scm 103 */
																																																		obj_t
																																																			BgL_arg3662z00_1385;
																																																		BgL_arg3662z00_1385
																																																			=
																																																			CAR
																																																			(BgL_cdrzd22354zd2_1375);
																																																		{	/* Ast/sexp.scm 103 */
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_3199;
																																																			BgL_siz00_1370
																																																				=
																																																				BgL_arg3662z00_1385;
																																																		BgL_tagzd22346zd2_1371:
																																																			{	/* Ast/sexp.scm 256 */
																																																				obj_t
																																																					BgL_auxz00_3200;
																																																				BgL_auxz00_3200
																																																					=
																																																					CDR
																																																					(BgL_expz00_18);
																																																				SET_CAR
																																																					(BgL_auxz00_3200,
																																																					BgL_siz00_1370);
																																																			}
																																																			{	/* Ast/sexp.scm 257 */
																																																				obj_t
																																																					BgL_arg3678z00_1402;
																																																				{	/* Ast/sexp.scm 257 */
																																																					obj_t
																																																						BgL_pairz00_2572;
																																																					BgL_pairz00_2572
																																																						=
																																																						BgL_expz00_18;
																																																					BgL_arg3678z00_1402
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_pairz00_2572));
																																																				}
																																																				SET_CAR
																																																					(BgL_arg3678z00_1402,
																																																					BgL_sinonz00_1345);
																																																			}
																																																			{	/* Ast/sexp.scm 258 */
																																																				obj_t
																																																					BgL_arg3679z00_1403;
																																																				{	/* Ast/sexp.scm 258 */
																																																					obj_t
																																																						BgL_pairz00_2578;
																																																					BgL_pairz00_2578
																																																						=
																																																						BgL_expz00_18;
																																																					BgL_arg3679z00_1403
																																																						=
																																																						CDR
																																																						(CDR
																																																						(CDR
																																																							(BgL_pairz00_2578)));
																																																				}
																																																				SET_CAR
																																																					(BgL_arg3679z00_1403,
																																																					BgL_alorsz00_1344);
																																																			}
																																																			BgL_auxz00_3199
																																																				=
																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																				(BgL_expz00_18,
																																																				BgL_stackz00_19,
																																																				BgL_locz00_20,
																																																				BgL_sitez00_21);
																																																			BgL_auxz00_3159
																																																				=
																																																				(obj_t)
																																																				(BgL_auxz00_3199);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																	BgL_tagzd22347zd2_1372:
																																																		{	/* Ast/sexp.scm 261 */
																																																			bool_t
																																																				BgL_testz00_3212;
																																																			if (SYMBOLP(BgL_siz00_1343))
																																																				{	/* Ast/sexp.scm 261 */
																																																					BgL_testz00_3212
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 261 */
																																																					BgL_testz00_3212
																																																						=
																																																						BGl_iszd2azf3z21zz__objectz00
																																																						(BgL_siz00_1343,
																																																						BGl_atomz00zzast_nodez00);
																																																				}
																																																			if (BgL_testz00_3212)
																																																				{	/* Ast/sexp.scm 262 */
																																																					obj_t
																																																						BgL_olocz00_1405;
																																																					BgL_olocz00_1405
																																																						=
																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																						(BgL_expz00_18,
																																																						BgL_locz00_20);
																																																					{	/* Ast/sexp.scm 262 */
																																																						obj_t
																																																							BgL_cdlocz00_1406;
																																																						BgL_cdlocz00_1406
																																																							=
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(CDR
																																																							(BgL_expz00_18),
																																																							BgL_locz00_20);
																																																						{	/* Ast/sexp.scm 263 */
																																																							obj_t
																																																								BgL_cddlocz00_1407;
																																																							{	/* Ast/sexp.scm 264 */
																																																								obj_t
																																																									BgL_arg3684z00_1420;
																																																								{	/* Ast/sexp.scm 264 */
																																																									obj_t
																																																										BgL_pairz00_2589;
																																																									BgL_pairz00_2589
																																																										=
																																																										BgL_expz00_18;
																																																									BgL_arg3684z00_1420
																																																										=
																																																										CDR
																																																										(CDR
																																																										(BgL_pairz00_2589));
																																																								}
																																																								BgL_cddlocz00_1407
																																																									=
																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																									(BgL_arg3684z00_1420,
																																																									BgL_locz00_20);
																																																							}
																																																							{	/* Ast/sexp.scm 264 */
																																																								obj_t
																																																									BgL_cdddlocz00_1408;
																																																								{	/* Ast/sexp.scm 265 */
																																																									obj_t
																																																										BgL_arg3683z00_1419;
																																																									{	/* Ast/sexp.scm 265 */
																																																										obj_t
																																																											BgL_pairz00_2593;
																																																										BgL_pairz00_2593
																																																											=
																																																											BgL_expz00_18;
																																																										BgL_arg3683z00_1419
																																																											=
																																																											CDR
																																																											(CDR
																																																											(CDR
																																																												(BgL_pairz00_2593)));
																																																									}
																																																									BgL_cdddlocz00_1408
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg3683z00_1419,
																																																										BgL_locz00_20);
																																																								}
																																																								{	/* Ast/sexp.scm 265 */
																																																									obj_t
																																																										BgL_lzd2sizd2_1409;
																																																									BgL_lzd2sizd2_1409
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_siz00_1343,
																																																										BgL_cdlocz00_1406);
																																																									{	/* Ast/sexp.scm 266 */
																																																										obj_t
																																																											BgL_lzd2alorszd2_1410;
																																																										BgL_lzd2alorszd2_1410
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_alorsz00_1344,
																																																											BgL_cddlocz00_1407);
																																																										{	/* Ast/sexp.scm 267 */
																																																											obj_t
																																																												BgL_lzd2sinonzd2_1411;
																																																											BgL_lzd2sinonzd2_1411
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_sinonz00_1345,
																																																												BgL_cdddlocz00_1408);
																																																											{	/* Ast/sexp.scm 268 */
																																																												BgL_nodez00_bglt
																																																													BgL_siz00_1412;
																																																												BgL_siz00_1412
																																																													=
																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																													(BgL_siz00_1343,
																																																													BgL_stackz00_19,
																																																													BgL_lzd2sizd2_1409,
																																																													CNST_TABLE_REF
																																																													(((long) 2)));
																																																												{	/* Ast/sexp.scm 269 */
																																																													BgL_nodez00_bglt
																																																														BgL_alorsz00_1413;
																																																													BgL_alorsz00_1413
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_alorsz00_1344,
																																																														BgL_stackz00_19,
																																																														BgL_lzd2alorszd2_1410,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 270 */
																																																														BgL_nodez00_bglt
																																																															BgL_sinonz00_1414;
																																																														BgL_sinonz00_1414
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_sinonz00_1345,
																																																															BgL_stackz00_19,
																																																															BgL_lzd2sinonzd2_1411,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														{	/* Ast/sexp.scm 271 */
																																																															obj_t
																																																																BgL_locz00_1415;
																																																															{	/* Ast/sexp.scm 272 */
																																																																obj_t
																																																																	BgL_locz00_1416;
																																																																{	/* Ast/sexp.scm 274 */
																																																																	obj_t
																																																																		BgL_arg3682z00_1418;
																																																																	BgL_arg3682z00_1418
																																																																		=
																																																																		(
																																																																		((BgL_nodez00_bglt) CREF(BgL_siz00_1412))->BgL_locz00);
																																																																	BgL_locz00_1416
																																																																		=
																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																		(BgL_expz00_18,
																																																																		BgL_arg3682z00_1418);
																																																																}
																																																																{	/* Ast/sexp.scm 275 */
																																																																	bool_t
																																																																		BgL_testz00_3237;
																																																																	if (STRUCTP(BgL_locz00_1416))
																																																																		{	/* Ast/sexp.scm 275 */
																																																																			BgL_testz00_3237
																																																																				=
																																																																				(STRUCT_KEY
																																																																				(BgL_locz00_1416)
																																																																				==
																																																																				CNST_TABLE_REF
																																																																				(((long) 6)));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 275 */
																																																																			BgL_testz00_3237
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	if (BgL_testz00_3237)
																																																																		{	/* Ast/sexp.scm 275 */
																																																																			BgL_locz00_1415
																																																																				=
																																																																				BgL_locz00_1416;
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 275 */
																																																																			BgL_locz00_1415
																																																																				=
																																																																				BgL_olocz00_1405;
																																																																		}
																																																																}
																																																															}
																																																															{	/* Ast/sexp.scm 272 */

																																																																BgL_auxz00_3159
																																																																	=
																																																																	(obj_t)
																																																																	(BGl_makezd2conditionalzd2zzast_nodez00
																																																																	(BgL_locz00_1415,
																																																																		(BgL_typez00_bglt)
																																																																		(BGl_za2_za2z00zztype_cachez00),
																																																																		BUNSPEC,
																																																																		BINT
																																																																		(((long) -1)), BgL_siz00_1412, BgL_alorsz00_1413, BgL_sinonz00_1414));
																																																				}}}}}}}}}}}}
																																																			else
																																																				{	/* Ast/sexp.scm 283 */
																																																					obj_t
																																																						BgL_testz00_1422;
																																																					BgL_testz00_1422
																																																						=
																																																						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																						(BGl_gensymz00zz__r4_symbols_6_4z00
																																																						(CNST_TABLE_REF
																																																							(((long) 7))));
																																																					{	/* Ast/sexp.scm 285 */
																																																						obj_t
																																																							BgL_arg3686z00_1423;
																																																						{	/* Ast/sexp.scm 285 */
																																																							obj_t
																																																								BgL_arg3687z00_1424;
																																																							obj_t
																																																								BgL_arg3688z00_1425;
																																																							BgL_arg3687z00_1424
																																																								=
																																																								BGl_letzd2symzd2zzast_letz00
																																																								();
																																																							{	/* Ast/sexp.scm 285 */
																																																								obj_t
																																																									BgL_arg3689z00_1426;
																																																								obj_t
																																																									BgL_arg3690z00_1427;
																																																								{	/* Ast/sexp.scm 285 */
																																																									obj_t
																																																										BgL_arg3694z00_1431;
																																																									{	/* Ast/sexp.scm 285 */
																																																										obj_t
																																																											BgL_arg3696z00_1433;
																																																										obj_t
																																																											BgL_arg3697z00_1434;
																																																										{	/* Ast/sexp.scm 285 */
																																																											obj_t
																																																												BgL_arg3698z00_1435;
																																																											{	/* Ast/sexp.scm 285 */
																																																												obj_t
																																																													BgL_arg3699z00_1436;
																																																												obj_t
																																																													BgL_arg3700z00_1437;
																																																												BgL_arg3699z00_1436
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_testz00_1422);
																																																												{	/* Ast/sexp.scm 285 */
																																																													obj_t
																																																														BgL_symbolz00_2608;
																																																													BgL_symbolz00_2608
																																																														=
																																																														CNST_TABLE_REF
																																																														(
																																																														((long) 8));
																																																													BgL_arg3700z00_1437
																																																														=
																																																														SYMBOL_TO_STRING
																																																														(BgL_symbolz00_2608);
																																																												}
																																																												{	/* Ast/sexp.scm 285 */
																																																													obj_t
																																																														BgL_list3701z00_1438;
																																																													{	/* Ast/sexp.scm 285 */
																																																														obj_t
																																																															BgL_arg3702z00_1439;
																																																														BgL_arg3702z00_1439
																																																															=
																																																															MAKE_PAIR
																																																															(BgL_arg3700z00_1437,
																																																															BNIL);
																																																														BgL_list3701z00_1438
																																																															=
																																																															MAKE_PAIR
																																																															(BgL_arg3699z00_1436,
																																																															BgL_arg3702z00_1439);
																																																													}
																																																													BgL_arg3698z00_1435
																																																														=
																																																														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																																																														(BgL_list3701z00_1438);
																																																											}}
																																																											BgL_arg3696z00_1433
																																																												=
																																																												string_to_symbol
																																																												(BSTRING_TO_STRING
																																																												(BgL_arg3698z00_1435));
																																																										}
																																																										{	/* Ast/sexp.scm 285 */
																																																											obj_t
																																																												BgL_list3703z00_1440;
																																																											BgL_list3703z00_1440
																																																												=
																																																												MAKE_PAIR
																																																												(BNIL,
																																																												BNIL);
																																																											BgL_arg3697z00_1434
																																																												=
																																																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																												(BgL_siz00_1343,
																																																												BgL_list3703z00_1440);
																																																										}
																																																										BgL_arg3694z00_1431
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3696z00_1433,
																																																											BgL_arg3697z00_1434);
																																																									}
																																																									BgL_arg3689z00_1426
																																																										=
																																																										MAKE_PAIR
																																																										(BgL_arg3694z00_1431,
																																																										BNIL);
																																																								}
																																																								{	/* Ast/sexp.scm 286 */
																																																									obj_t
																																																										BgL_arg3704z00_1441;
																																																									{	/* Ast/sexp.scm 286 */
																																																										obj_t
																																																											BgL_arg3705z00_1442;
																																																										obj_t
																																																											BgL_arg3706z00_1443;
																																																										BgL_arg3705z00_1442
																																																											=
																																																											CNST_TABLE_REF
																																																											(
																																																											((long) 1));
																																																										{	/* Ast/sexp.scm 286 */
																																																											obj_t
																																																												BgL_list3707z00_1444;
																																																											{	/* Ast/sexp.scm 286 */
																																																												obj_t
																																																													BgL_arg3708z00_1445;
																																																												{	/* Ast/sexp.scm 286 */
																																																													obj_t
																																																														BgL_arg3709z00_1446;
																																																													BgL_arg3709z00_1446
																																																														=
																																																														MAKE_PAIR
																																																														(BNIL,
																																																														BNIL);
																																																													BgL_arg3708z00_1445
																																																														=
																																																														MAKE_PAIR
																																																														(BgL_sinonz00_1345,
																																																														BgL_arg3709z00_1446);
																																																												}
																																																												BgL_list3707z00_1444
																																																													=
																																																													MAKE_PAIR
																																																													(BgL_alorsz00_1344,
																																																													BgL_arg3708z00_1445);
																																																											}
																																																											BgL_arg3706z00_1443
																																																												=
																																																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																												(BgL_testz00_1422,
																																																												BgL_list3707z00_1444);
																																																										}
																																																										BgL_arg3704z00_1441
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3705z00_1442,
																																																											BgL_arg3706z00_1443);
																																																									}
																																																									BgL_arg3690z00_1427
																																																										=
																																																										BGl_epairifyzd2reczd2zztools_miscz00
																																																										(BgL_arg3704z00_1441,
																																																										BgL_expz00_18);
																																																								}
																																																								{	/* Ast/sexp.scm 285 */
																																																									obj_t
																																																										BgL_list3692z00_1429;
																																																									{	/* Ast/sexp.scm 285 */
																																																										obj_t
																																																											BgL_arg3693z00_1430;
																																																										BgL_arg3693z00_1430
																																																											=
																																																											MAKE_PAIR
																																																											(BNIL,
																																																											BNIL);
																																																										BgL_list3692z00_1429
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3690z00_1427,
																																																											BgL_arg3693z00_1430);
																																																									}
																																																									BgL_arg3688z00_1425
																																																										=
																																																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																										(BgL_arg3689z00_1426,
																																																										BgL_list3692z00_1429);
																																																							}}
																																																							BgL_arg3686z00_1423
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_arg3687z00_1424,
																																																								BgL_arg3688z00_1425);
																																																						}
																																																						BGl_replacez12z12zztools_miscz00
																																																							(BgL_expz00_18,
																																																							BgL_arg3686z00_1423);
																																																					}
																																																					BgL_auxz00_3159
																																																						=
																																																						(obj_t)
																																																						(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																						(BgL_expz00_18,
																																																							BgL_stackz00_19,
																																																							BgL_locz00_20,
																																																							BgL_sitez00_21));
																																															}}}}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																goto
																																																	BgL_tagzd22347zd2_1372;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														goto
																																															BgL_tagzd22347zd2_1372;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												goto
																																													BgL_tagzd22347zd2_1372;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 103 */
																																										goto
																																											BgL_tagzd22347zd2_1372;
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 103 */
																																								goto
																																									BgL_tagzd22347zd2_1372;
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 103 */
																																						if (
																																							(CAR
																																								(BgL_siz00_1343)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 9))))
																																							{	/* Ast/sexp.scm 103 */
																																								if (PAIRP(BgL_cdrzd22354zd2_1375))
																																									{	/* Ast/sexp.scm 103 */
																																										if (NULLP(CDR(BgL_cdrzd22354zd2_1375)))
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_arg3671z00_1395;
																																												BgL_arg3671z00_1395
																																													=
																																													CAR
																																													(BgL_cdrzd22354zd2_1375);
																																												{	/* Ast/sexp.scm 103 */
																																													BgL_nodez00_bglt
																																														BgL_auxz00_3287;
																																													{
																																														obj_t
																																															BgL_siz00_3288;
																																														BgL_siz00_3288
																																															=
																																															BgL_arg3671z00_1395;
																																														BgL_siz00_1370
																																															=
																																															BgL_siz00_3288;
																																														goto
																																															BgL_tagzd22346zd2_1371;
																																													}
																																													BgL_auxz00_3159
																																														=
																																														(obj_t)
																																														(BgL_auxz00_3287);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												goto
																																													BgL_tagzd22347zd2_1372;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 103 */
																																										goto
																																											BgL_tagzd22347zd2_1372;
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 103 */
																																								goto
																																									BgL_tagzd22347zd2_1372;
																																							}
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 103 */
																																				goto
																																					BgL_tagzd22347zd2_1372;
																																			}
																																	}
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	BgL_nodez00_bglt
																																		BgL_auxz00_3293;
																																BgL_tagzd22280zd2_1350:
																																	BgL_auxz00_3293 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4131z00zzast_sexpz00, BgL_expz00_18, BgL_locz00_20);
																																	BgL_auxz00_3159
																																		=
																																		(obj_t)
																																		(BgL_auxz00_3293);
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 103 */
																															obj_t
																																BgL_cdrzd22324zd2_1365;
																															BgL_cdrzd22324zd2_1365
																																=
																																CDR
																																(BgL_cdrzd22289zd2_1353);
																															if (NULLP(CDR
																																	(BgL_cdrzd22324zd2_1365)))
																																{	/* Ast/sexp.scm 103 */
																																	obj_t
																																		BgL_arg3651z00_1367;
																																	obj_t
																																		BgL_arg3652z00_1368;
																																	BgL_arg3651z00_1367
																																		=
																																		CAR
																																		(BgL_cdrzd22289zd2_1353);
																																	BgL_arg3652z00_1368
																																		=
																																		CAR
																																		(BgL_cdrzd22324zd2_1365);
																																	{	/* Ast/sexp.scm 103 */
																																		BgL_nodez00_bglt
																																			BgL_auxz00_3302;
																																		BgL_siz00_1347
																																			=
																																			BgL_arg3651z00_1367;
																																		BgL_alorsz00_1348
																																			=
																																			BgL_arg3652z00_1368;
																																		{	/* Ast/sexp.scm 290 */
																																			obj_t
																																				BgL_arg3712z00_1449;
																																			obj_t
																																				BgL_arg3713z00_1450;
																																			{	/* Ast/sexp.scm 290 */
																																				obj_t
																																					BgL_pairz00_2610;
																																				BgL_pairz00_2610
																																					=
																																					BgL_expz00_18;
																																				BgL_arg3712z00_1449
																																					=
																																					CDR
																																					(CDR
																																					(BgL_pairz00_2610));
																																			}
																																			{	/* Ast/sexp.scm 290 */
																																				obj_t
																																					BgL_list3714z00_1451;
																																				BgL_list3714z00_1451
																																					=
																																					MAKE_PAIR
																																					(BUNSPEC,
																																					BNIL);
																																				BgL_arg3713z00_1450
																																					=
																																					BgL_list3714z00_1451;
																																			}
																																			SET_CDR
																																				(BgL_arg3712z00_1449,
																																				BgL_arg3713z00_1450);
																																		}
																																		BgL_auxz00_3302
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(BgL_expz00_18,
																																			BgL_stackz00_19,
																																			BgL_locz00_20,
																																			BgL_sitez00_21);
																																		BgL_auxz00_3159
																																			=
																																			(obj_t)
																																			(BgL_auxz00_3302);
																																	}
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	BgL_nodez00_bglt
																																		BgL_auxz00_3309;
																																	goto
																																		BgL_tagzd22280zd2_1350;
																																	BgL_auxz00_3159
																																		=
																																		(obj_t)
																																		(BgL_auxz00_3309);
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 103 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3311;
																													goto
																														BgL_tagzd22280zd2_1350;
																													BgL_auxz00_3159 =
																														(obj_t)
																														(BgL_auxz00_3311);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 103 */
																											BgL_nodez00_bglt
																												BgL_auxz00_3313;
																											goto
																												BgL_tagzd22280zd2_1350;
																											BgL_auxz00_3159 =
																												(obj_t)
																												(BgL_auxz00_3313);
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 103 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3315;
																									goto BgL_tagzd22280zd2_1350;
																									BgL_auxz00_3159 =
																										(obj_t) (BgL_auxz00_3315);
																								}
																						}
																						return
																							(BgL_nodez00_bglt)
																							(BgL_auxz00_3159);
																					}
																				else
																					{	/* Ast/sexp.scm 103 */
																						if (
																							(BgL_carzd21550zd2_937 ==
																								BGl_za2ifza2z00zzast_sexpz00))
																							{	/* Ast/sexp.scm 103 */
																								obj_t BgL_auxz00_3320;

																								goto BgL_tagzd21470zd2_896;
																								return
																									(BgL_nodez00_bglt)
																									(BgL_auxz00_3320);
																							}
																						else
																							{	/* Ast/sexp.scm 103 */
																								if (
																									(CAR(BgL_expz00_18) ==
																										CNST_TABLE_REF(((long) 5))))
																									{	/* Ast/sexp.scm 103 */
																										obj_t BgL_auxz00_3326;

																									BgL_tagzd21471zd2_897:
																										{
																											obj_t BgL_varz00_1452;

																											obj_t BgL_valz00_1453;

																											if (PAIRP(BgL_expz00_18))
																												{	/* Ast/sexp.scm 103 */
																													obj_t
																														BgL_cdrzd22385zd2_1458;
																													BgL_cdrzd22385zd2_1458
																														=
																														CDR(BgL_expz00_18);
																													if (PAIRP
																														(BgL_cdrzd22385zd2_1458))
																														{	/* Ast/sexp.scm 103 */
																															obj_t
																																BgL_cdrzd22389zd2_1460;
																															BgL_cdrzd22389zd2_1460
																																=
																																CDR
																																(BgL_cdrzd22385zd2_1458);
																															if (PAIRP
																																(BgL_cdrzd22389zd2_1460))
																																{	/* Ast/sexp.scm 103 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd22389zd2_1460)))
																																		{	/* Ast/sexp.scm 103 */
																																			BgL_varz00_1452
																																				=
																																				CAR
																																				(BgL_cdrzd22385zd2_1458);
																																			BgL_valz00_1453
																																				=
																																				CAR
																																				(BgL_cdrzd22389zd2_1460);
																																			{	/* Ast/sexp.scm 298 */
																																				obj_t
																																					BgL_locz00_1466;
																																				BgL_locz00_1466
																																					=
																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																					(BgL_expz00_18,
																																					BgL_locz00_20);
																																				{	/* Ast/sexp.scm 298 */
																																					obj_t
																																						BgL_cdlocz00_1467;
																																					BgL_cdlocz00_1467
																																						=
																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																						(CDR
																																						(BgL_expz00_18),
																																						BgL_locz00_1466);
																																					{	/* Ast/sexp.scm 299 */
																																						obj_t
																																							BgL_cddlocz00_1468;
																																						{	/* Ast/sexp.scm 300 */
																																							obj_t
																																								BgL_arg3727z00_1478;
																																							{	/* Ast/sexp.scm 300 */
																																								obj_t
																																									BgL_pairz00_2628;
																																								BgL_pairz00_2628
																																									=
																																									BgL_expz00_18;
																																								BgL_arg3727z00_1478
																																									=
																																									CDR
																																									(CDR
																																									(BgL_pairz00_2628));
																																							}
																																							BgL_cddlocz00_1468
																																								=
																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																								(BgL_arg3727z00_1478,
																																								BgL_locz00_1466);
																																						}
																																						{	/* Ast/sexp.scm 300 */
																																							obj_t
																																								BgL_valzd2loczd2_1469;
																																							BgL_valzd2loczd2_1469
																																								=
																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																								(BgL_valz00_1453,
																																								BgL_cddlocz00_1468);
																																							{	/* Ast/sexp.scm 301 */
																																								BgL_nodez00_bglt
																																									BgL_valz00_1470;
																																								BgL_valz00_1470
																																									=
																																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																																									(BgL_valz00_1453,
																																									BgL_stackz00_19,
																																									BgL_valzd2loczd2_1469,
																																									CNST_TABLE_REF
																																									(((long) 2)));
																																								{	/* Ast/sexp.scm 302 */

																																									{	/* Ast/sexp.scm 303 */
																																										BgL_nodez00_bglt
																																											BgL_astz00_1471;
																																										BgL_astz00_1471
																																											=
																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																											(BgL_varz00_1452,
																																											BgL_stackz00_19,
																																											BgL_cdlocz00_1467,
																																											CNST_TABLE_REF
																																											(((long) 5)));
																																										{	/* Ast/sexp.scm 304 */
																																											bool_t
																																												BgL_testz00_3349;
																																											{	/* Ast/sexp.scm 304 */
																																												obj_t
																																													BgL_obj2157z00_2632;
																																												BgL_obj2157z00_2632
																																													=
																																													(obj_t)
																																													(BgL_astz00_1471);
																																												BgL_testz00_3349
																																													=
																																													BGl_iszd2azf3z21zz__objectz00
																																													(BgL_obj2157z00_2632,
																																													BGl_varz00zzast_nodez00);
																																											}
																																											if (BgL_testz00_3349)
																																												{	/* Ast/sexp.scm 306 */
																																													bool_t
																																														BgL_testz00_3352;
																																													{	/* Ast/sexp.scm 306 */
																																														bool_t
																																															BgL_testz00_3353;
																																														{	/* Ast/sexp.scm 306 */
																																															BgL_variablez00_bglt
																																																BgL_arg3726z00_1477;
																																															{
																																																BgL_varz00_bglt
																																																	BgL_auxz00_3354;
																																																BgL_auxz00_3354
																																																	=
																																																	(BgL_varz00_bglt)
																																																	(BgL_astz00_1471);
																																																BgL_arg3726z00_1477
																																																	=
																																																	(
																																																	((BgL_varz00_bglt) CREF(BgL_auxz00_3354))->BgL_variablez00);
																																															}
																																															{	/* Ast/sexp.scm 306 */
																																																obj_t
																																																	BgL_obj1739z00_2634;
																																																BgL_obj1739z00_2634
																																																	=
																																																	(obj_t)
																																																	(BgL_arg3726z00_1477);
																																																BgL_testz00_3353
																																																	=
																																																	BGl_iszd2azf3z21zz__objectz00
																																																	(BgL_obj1739z00_2634,
																																																	BGl_globalz00zzast_varz00);
																																															}
																																														}
																																														if (BgL_testz00_3353)
																																															{	/* Ast/sexp.scm 307 */
																																																BgL_variablez00_bglt
																																																	BgL_arg3725z00_1476;
																																																{
																																																	BgL_varz00_bglt
																																																		BgL_auxz00_3359;
																																																	BgL_auxz00_3359
																																																		=
																																																		(BgL_varz00_bglt)
																																																		(BgL_astz00_1471);
																																																	BgL_arg3725z00_1476
																																																		=
																																																		(
																																																		((BgL_varz00_bglt) CREF(BgL_auxz00_3359))->BgL_variablez00);
																																																}
																																																BgL_testz00_3352
																																																	=
																																																	BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																	(
																																																	(BgL_globalz00_bglt)
																																																	(BgL_arg3725z00_1476));
																																															}
																																														else
																																															{	/* Ast/sexp.scm 306 */
																																																BgL_testz00_3352
																																																	=
																																																	(
																																																	(bool_t)
																																																	0);
																																															}
																																													}
																																													if (BgL_testz00_3352)
																																														{	/* Ast/sexp.scm 306 */
																																															BgL_auxz00_3326
																																																=
																																																(obj_t)
																																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																(BGl_string4129z00zzast_sexpz00,
																																																	BgL_expz00_18,
																																																	BgL_cdlocz00_1467));
																																														}
																																													else
																																														{	/* Ast/sexp.scm 306 */
																																															BgL_auxz00_3326
																																																=
																																																(obj_t)
																																																(BGl_makezd2setqzd2zzast_nodez00
																																																(BgL_locz00_1466,
																																																	(BgL_typez00_bglt)
																																																	(BGl_za2unspecza2z00zztype_cachez00),
																																																	(BgL_varz00_bglt)
																																																	(BgL_astz00_1471),
																																																	BgL_valz00_1470));
																																														}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 304 */
																																													BgL_auxz00_3326
																																														=
																																														(obj_t)
																																														(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																														(BGl_string4130z00zzast_sexpz00,
																																															BgL_expz00_18,
																																															BgL_locz00_1466));
																																												}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			BgL_nodez00_bglt
																																				BgL_auxz00_3374;
																																		BgL_tagzd22378zd2_1455:
																																			BgL_auxz00_3374 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4128z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																			BgL_auxz00_3326
																																				=
																																				(obj_t)
																																				(BgL_auxz00_3374);
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	BgL_nodez00_bglt
																																		BgL_auxz00_3378;
																																	goto
																																		BgL_tagzd22378zd2_1455;
																																	BgL_auxz00_3326
																																		=
																																		(obj_t)
																																		(BgL_auxz00_3378);
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 103 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3380;
																															goto
																																BgL_tagzd22378zd2_1455;
																															BgL_auxz00_3326 =
																																(obj_t)
																																(BgL_auxz00_3380);
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 103 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3382;
																													goto
																														BgL_tagzd22378zd2_1455;
																													BgL_auxz00_3326 =
																														(obj_t)
																														(BgL_auxz00_3382);
																												}
																										}
																										return
																											(BgL_nodez00_bglt)
																											(BgL_auxz00_3326);
																									}
																								else
																									{	/* Ast/sexp.scm 103 */
																										if (
																											(CAR(BgL_expz00_18) ==
																												CNST_TABLE_REF(((long)
																														17))))
																											{	/* Ast/sexp.scm 103 */
																												obj_t BgL_auxz00_3389;

																											BgL_tagzd21472zd2_898:
																												{
																													obj_t BgL_varz00_1482;

																													obj_t BgL_valz00_1483;

																													if (PAIRP
																														(BgL_expz00_18))
																														{	/* Ast/sexp.scm 103 */
																															obj_t
																																BgL_cdrzd22403zd2_1488;
																															BgL_cdrzd22403zd2_1488
																																=
																																CDR
																																(BgL_expz00_18);
																															if (PAIRP
																																(BgL_cdrzd22403zd2_1488))
																																{	/* Ast/sexp.scm 103 */
																																	obj_t
																																		BgL_cdrzd22407zd2_1490;
																																	BgL_cdrzd22407zd2_1490
																																		=
																																		CDR
																																		(BgL_cdrzd22403zd2_1488);
																																	if (PAIRP
																																		(BgL_cdrzd22407zd2_1490))
																																		{	/* Ast/sexp.scm 103 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd22407zd2_1490)))
																																				{	/* Ast/sexp.scm 103 */
																																					BgL_varz00_1482
																																						=
																																						CAR
																																						(BgL_cdrzd22403zd2_1488);
																																					BgL_valz00_1483
																																						=
																																						CAR
																																						(BgL_cdrzd22407zd2_1490);
																																					{	/* Ast/sexp.scm 329 */
																																						obj_t
																																							BgL_locz00_1496;
																																						BgL_locz00_1496
																																							=
																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																							(BgL_expz00_18,
																																							BgL_locz00_20);
																																						{	/* Ast/sexp.scm 329 */
																																							obj_t
																																								BgL_cdlocz00_1497;
																																							BgL_cdlocz00_1497
																																								=
																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																								(CDR
																																								(BgL_expz00_18),
																																								BgL_locz00_1496);
																																							{	/* Ast/sexp.scm 330 */
																																								obj_t
																																									BgL_cddlocz00_1498;
																																								{	/* Ast/sexp.scm 331 */
																																									obj_t
																																										BgL_arg3742z00_1506;
																																									{	/* Ast/sexp.scm 331 */
																																										obj_t
																																											BgL_pairz00_2646;
																																										BgL_pairz00_2646
																																											=
																																											BgL_expz00_18;
																																										BgL_arg3742z00_1506
																																											=
																																											CDR
																																											(CDR
																																											(BgL_pairz00_2646));
																																									}
																																									BgL_cddlocz00_1498
																																										=
																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																										(BgL_arg3742z00_1506,
																																										BgL_locz00_1496);
																																								}
																																								{	/* Ast/sexp.scm 331 */
																																									obj_t
																																										BgL_valzd2loczd2_1499;
																																									BgL_valzd2loczd2_1499
																																										=
																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																										(BgL_valz00_1483,
																																										BgL_cddlocz00_1498);
																																									{	/* Ast/sexp.scm 332 */
																																										BgL_nodez00_bglt
																																											BgL_valz00_1500;
																																										BgL_valz00_1500
																																											=
																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																											(BgL_valz00_1483,
																																											BgL_stackz00_19,
																																											BgL_valzd2loczd2_1499,
																																											CNST_TABLE_REF
																																											(((long) 2)));
																																										{	/* Ast/sexp.scm 333 */

																																											{	/* Ast/sexp.scm 334 */
																																												BgL_nodez00_bglt
																																													BgL_astz00_1501;
																																												BgL_astz00_1501
																																													=
																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																													(BgL_varz00_1482,
																																													BgL_stackz00_19,
																																													BgL_cdlocz00_1497,
																																													CNST_TABLE_REF
																																													(((long) 2)));
																																												{	/* Ast/sexp.scm 335 */
																																													bool_t
																																														BgL_testz00_3412;
																																													{	/* Ast/sexp.scm 335 */
																																														bool_t
																																															BgL_testz00_3413;
																																														{	/* Ast/sexp.scm 335 */
																																															obj_t
																																																BgL_obj2157z00_2650;
																																															BgL_obj2157z00_2650
																																																=
																																																(obj_t)
																																																(BgL_astz00_1501);
																																															BgL_testz00_3413
																																																=
																																																BGl_iszd2azf3z21zz__objectz00
																																																(BgL_obj2157z00_2650,
																																																BGl_varz00zzast_nodez00);
																																														}
																																														if (BgL_testz00_3413)
																																															{	/* Ast/sexp.scm 335 */
																																																BgL_variablez00_bglt
																																																	BgL_arg3741z00_1505;
																																																{
																																																	BgL_varz00_bglt
																																																		BgL_auxz00_3416;
																																																	BgL_auxz00_3416
																																																		=
																																																		(BgL_varz00_bglt)
																																																		(BgL_astz00_1501);
																																																	BgL_arg3741z00_1505
																																																		=
																																																		(
																																																		((BgL_varz00_bglt) CREF(BgL_auxz00_3416))->BgL_variablez00);
																																																}
																																																{	/* Ast/sexp.scm 335 */
																																																	obj_t
																																																		BgL_obj1739z00_2652;
																																																	BgL_obj1739z00_2652
																																																		=
																																																		(obj_t)
																																																		(BgL_arg3741z00_1505);
																																																	BgL_testz00_3412
																																																		=
																																																		BGl_iszd2azf3z21zz__objectz00
																																																		(BgL_obj1739z00_2652,
																																																		BGl_globalz00zzast_varz00);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 335 */
																																																BgL_testz00_3412
																																																	=
																																																	(
																																																	(bool_t)
																																																	0);
																																															}
																																													}
																																													if (BgL_testz00_3412)
																																														{	/* Ast/sexp.scm 335 */
																																															{	/* Ast/sexp.scm 337 */
																																																BgL_variablez00_bglt
																																																	BgL_arg3739z00_1503;
																																																{
																																																	BgL_varz00_bglt
																																																		BgL_auxz00_3421;
																																																	BgL_auxz00_3421
																																																		=
																																																		(BgL_varz00_bglt)
																																																		(BgL_astz00_1501);
																																																	BgL_arg3739z00_1503
																																																		=
																																																		(
																																																		((BgL_varz00_bglt) CREF(BgL_auxz00_3421))->BgL_variablez00);
																																																}
																																																{
																																																	obj_t
																																																		BgL_auxz00_3426;
																																																	BgL_globalz00_bglt
																																																		BgL_auxz00_3424;
																																																	BgL_auxz00_3426
																																																		=
																																																		(obj_t)
																																																		(BgL_valz00_1500);
																																																	BgL_auxz00_3424
																																																		=
																																																		(BgL_globalz00_bglt)
																																																		(BgL_arg3739z00_1503);
																																																	((((BgL_globalz00_bglt) CREF(BgL_auxz00_3424))->BgL_srcz00) = ((obj_t) BgL_auxz00_3426), BUNSPEC);
																																																}
																																															}
																																															BgL_auxz00_3389
																																																=
																																																(obj_t)
																																																(BGl_makezd2setqzd2zzast_nodez00
																																																(BgL_locz00_1496,
																																																	(BgL_typez00_bglt)
																																																	(BGl_za2unspecza2z00zztype_cachez00),
																																																	(BgL_varz00_bglt)
																																																	(BgL_astz00_1501),
																																																	BgL_valz00_1500));
																																														}
																																													else
																																														{	/* Ast/sexp.scm 335 */
																																															BgL_auxz00_3389
																																																=
																																																(obj_t)
																																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																(BGl_string4127z00zzast_sexpz00,
																																																	BgL_expz00_18,
																																																	BgL_locz00_1496));
																																														}
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					BgL_nodez00_bglt
																																						BgL_auxz00_3437;
																																				BgL_tagzd22396zd2_1485:
																																					BgL_auxz00_3437 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4126z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																					BgL_auxz00_3389
																																						=
																																						(obj_t)
																																						(BgL_auxz00_3437);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			BgL_nodez00_bglt
																																				BgL_auxz00_3441;
																																			goto
																																				BgL_tagzd22396zd2_1485;
																																			BgL_auxz00_3389
																																				=
																																				(obj_t)
																																				(BgL_auxz00_3441);
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	BgL_nodez00_bglt
																																		BgL_auxz00_3443;
																																	goto
																																		BgL_tagzd22396zd2_1485;
																																	BgL_auxz00_3389
																																		=
																																		(obj_t)
																																		(BgL_auxz00_3443);
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 103 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3445;
																															goto
																																BgL_tagzd22396zd2_1485;
																															BgL_auxz00_3389 =
																																(obj_t)
																																(BgL_auxz00_3445);
																														}
																												}
																												return
																													(BgL_nodez00_bglt)
																													(BgL_auxz00_3389);
																											}
																										else
																											{	/* Ast/sexp.scm 103 */
																												obj_t
																													BgL_carzd21574zd2_942;
																												BgL_carzd21574zd2_942 =
																													CAR(BgL_expz00_18);
																												if (PAIRP
																													(BgL_carzd21574zd2_942))
																													{	/* Ast/sexp.scm 103 */
																														obj_t
																															BgL_carzd21577zd2_944;
																														obj_t
																															BgL_cdrzd21578zd2_945;
																														BgL_carzd21577zd2_944
																															=
																															CAR
																															(BgL_carzd21574zd2_942);
																														BgL_cdrzd21578zd2_945
																															=
																															CDR
																															(BgL_carzd21574zd2_942);
																														{

																															if (
																																(BgL_carzd21577zd2_944
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			19))))
																																{	/* Ast/sexp.scm 103 */
																																	obj_t
																																		BgL_auxz00_3456;
																																BgL_kapzd21579zd2_946:
																																	if (PAIRP
																																		(BgL_cdrzd21578zd2_945))
																																		{	/* Ast/sexp.scm 103 */
																																			obj_t
																																				BgL_cdrzd21582zd2_968;
																																			BgL_cdrzd21582zd2_968
																																				=
																																				CDR
																																				(BgL_cdrzd21578zd2_945);
																																			if (PAIRP
																																				(BgL_cdrzd21582zd2_968))
																																				{	/* Ast/sexp.scm 103 */
																																					if (NULLP(CDR(BgL_cdrzd21582zd2_968)))
																																						{	/* Ast/sexp.scm 103 */
																																							obj_t
																																								BgL_arg3315z00_971;
																																							obj_t
																																								BgL_arg3316z00_972;
																																							BgL_arg3315z00_971
																																								=
																																								CAR
																																								(BgL_cdrzd21582zd2_968);
																																							BgL_arg3316z00_972
																																								=
																																								CDR
																																								(BgL_expz00_18);
																																							{	/* Ast/sexp.scm 103 */
																																								BgL_nodez00_bglt
																																									BgL_auxz00_3467;
																																								BgL_bodyz00_899
																																									=
																																									BgL_arg3315z00_971;
																																								BgL_argsz00_900
																																									=
																																									BgL_arg3316z00_972;
																																							BgL_tagzd21473zd2_901:
																																								{	/* Ast/sexp.scm 352 */
																																									obj_t
																																										BgL_letzd2partzd2_1510;
																																									BgL_letzd2partzd2_1510
																																										=
																																										CAR
																																										(BgL_expz00_18);
																																									{	/* Ast/sexp.scm 352 */
																																										obj_t
																																											BgL_nexpz00_1511;
																																										{	/* Ast/sexp.scm 353 */
																																											obj_t
																																												BgL_arg3746z00_1512;
																																											obj_t
																																												BgL_arg3747z00_1513;
																																											BgL_arg3746z00_1512
																																												=
																																												CAR
																																												(BgL_letzd2partzd2_1510);
																																											{	/* Ast/sexp.scm 353 */
																																												obj_t
																																													BgL_arg3748z00_1514;
																																												obj_t
																																													BgL_arg3749z00_1515;
																																												{	/* Ast/sexp.scm 353 */
																																													obj_t
																																														BgL_pairz00_2658;
																																													BgL_pairz00_2658
																																														=
																																														BgL_letzd2partzd2_1510;
																																													BgL_arg3748z00_1514
																																														=
																																														CAR
																																														(CDR
																																														(BgL_pairz00_2658));
																																												}
																																												BgL_arg3749z00_1515
																																													=
																																													MAKE_PAIR
																																													(BgL_bodyz00_899,
																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																													(BgL_argsz00_900,
																																														BNIL));
																																												{	/* Ast/sexp.scm 353 */
																																													obj_t
																																														BgL_list3751z00_1517;
																																													{	/* Ast/sexp.scm 353 */
																																														obj_t
																																															BgL_arg3752z00_1518;
																																														BgL_arg3752z00_1518
																																															=
																																															MAKE_PAIR
																																															(BNIL,
																																															BNIL);
																																														BgL_list3751z00_1517
																																															=
																																															MAKE_PAIR
																																															(BgL_arg3749z00_1515,
																																															BgL_arg3752z00_1518);
																																													}
																																													BgL_arg3747z00_1513
																																														=
																																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																														(BgL_arg3748z00_1514,
																																														BgL_list3751z00_1517);
																																												}
																																											}
																																											BgL_nexpz00_1511
																																												=
																																												MAKE_PAIR
																																												(BgL_arg3746z00_1512,
																																												BgL_arg3747z00_1513);
																																										}
																																										{	/* Ast/sexp.scm 353 */

																																											BgL_auxz00_3467
																																												=
																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																												(BgL_nexpz00_1511,
																																												BgL_stackz00_19,
																																												BgL_locz00_20,
																																												BgL_sitez00_21);
																																										}
																																									}
																																								}
																																								BgL_auxz00_3456
																																									=
																																									(obj_t)
																																									(BgL_auxz00_3467);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							bool_t
																																								BgL_testz00_3480;
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_arg3328z00_985;
																																								BgL_arg3328z00_985
																																									=
																																									CAR
																																									(BgL_expz00_18);
																																								BgL_testz00_3480
																																									=
																																									CBOOL
																																									(BGl_letzd2symzf3z21zzast_letz00
																																									(BgL_arg3328z00_985));
																																							}
																																							if (BgL_testz00_3480)
																																								{	/* Ast/sexp.scm 103 */
																																									BgL_nodez00_bglt
																																										BgL_auxz00_3484;
																																								BgL_tagzd21474zd2_902:
																																									BgL_auxz00_3484 = BGl_letzd2ze3nodez31zzast_letz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, CNST_TABLE_REF(((long) 2)));
																																									BgL_auxz00_3456
																																										=
																																										(obj_t)
																																										(BgL_auxz00_3484);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									bool_t
																																										BgL_testz00_3488;
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_arg3327z00_984;
																																										BgL_arg3327z00_984
																																											=
																																											CAR
																																											(BgL_expz00_18);
																																										BgL_testz00_3488
																																											=
																																											CBOOL
																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																											(BgL_arg3327z00_984));
																																									}
																																									if (BgL_testz00_3488)
																																										{	/* Ast/sexp.scm 103 */
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_3492;
																																										BgL_tagzd21475zd2_903:
																																											BgL_auxz00_3492 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, CNST_TABLE_REF(((long) 2)));
																																											BgL_auxz00_3456
																																												=
																																												(obj_t)
																																												(BgL_auxz00_3492);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 103 */
																																											obj_t
																																												BgL_carzd21613zd2_975;
																																											BgL_carzd21613zd2_975
																																												=
																																												CAR
																																												(BgL_expz00_18);
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_cdrzd21618zd2_976;
																																												BgL_cdrzd21618zd2_976
																																													=
																																													CDR
																																													(BgL_carzd21613zd2_975);
																																												if ((CAR(BgL_carzd21613zd2_975) == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 103 */
																																														obj_t
																																															BgL_arg3320z00_978;
																																														obj_t
																																															BgL_arg3321z00_979;
																																														obj_t
																																															BgL_arg3323z00_980;
																																														BgL_arg3320z00_978
																																															=
																																															CAR
																																															(BgL_cdrzd21618zd2_976);
																																														BgL_arg3321z00_979
																																															=
																																															CDR
																																															(BgL_cdrzd21618zd2_976);
																																														BgL_arg3323z00_980
																																															=
																																															CDR
																																															(BgL_expz00_18);
																																														{	/* Ast/sexp.scm 103 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_3505;
																																															BgL_varsz00_904
																																																=
																																																BgL_arg3320z00_978;
																																															BgL_bodyz00_905
																																																=
																																																BgL_arg3321z00_979;
																																															BgL_argsz00_906
																																																=
																																																BgL_arg3323z00_980;
																																														BgL_tagzd21476zd2_907:
																																															{	/* Ast/sexp.scm 363 */
																																																obj_t
																																																	BgL_locz00_1520;
																																																obj_t
																																																	BgL_nexpz00_1521;
																																																BgL_locz00_1520
																																																	=
																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																	(BgL_expz00_18,
																																																	BgL_locz00_20);
																																																{	/* Ast/sexp.scm 364 */
																																																	obj_t
																																																		BgL_arg3754z00_1522;
																																																	obj_t
																																																		BgL_arg3755z00_1523;
																																																	BgL_arg3754z00_1522
																																																		=
																																																		BGl_letzd2symzd2zzast_letz00
																																																		();
																																																	{	/* Ast/sexp.scm 367 */
																																																		obj_t
																																																			BgL_arg3756z00_1524;
																																																		obj_t
																																																			BgL_arg3757z00_1525;
																																																		BgL_arg3756z00_1524
																																																			=
																																																			BGl_loopz00zzast_sexpz00
																																																			(BgL_expz00_18,
																																																			BgL_locz00_20,
																																																			BgL_varsz00_904,
																																																			BgL_argsz00_906);
																																																		{	/* Ast/sexp.scm 406 */
																																																			obj_t
																																																				BgL_arg3807z00_1582;
																																																			obj_t
																																																				BgL_arg3808z00_1583;
																																																			BgL_arg3807z00_1582
																																																				=
																																																				BGl_shapez00zztools_shapez00
																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																				());
																																																			BgL_arg3808z00_1583
																																																				=
																																																				BGl_normaliza7ezd2prognz75zztools_prognz00
																																																				(BgL_bodyz00_905);
																																																			{	/* Ast/sexp.scm 410 */
																																																				obj_t
																																																					BgL_zc3anonymousza33811ze3z83_2847;
																																																				BgL_zc3anonymousza33811ze3z83_2847
																																																					=
																																																					make_fx_procedure
																																																					(BGl_zc3anonymousza33811ze3z83zzast_sexpz00,
																																																					(int)
																																																					(((long) 3)), (int) (((long) 1)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3anonymousza33811ze3z83_2847,
																																																					(int)
																																																					(((long) 0)), BgL_locz00_20);
																																																				BgL_arg3757z00_1525
																																																					=
																																																					BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																					(BgL_arg3807z00_1582,
																																																					BgL_varsz00_904,
																																																					BgL_arg3808z00_1583,
																																																					BgL_zc3anonymousza33811ze3z83_2847);
																																																		}}
																																																		{	/* Ast/sexp.scm 364 */
																																																			obj_t
																																																				BgL_list3759z00_1527;
																																																			{	/* Ast/sexp.scm 364 */
																																																				obj_t
																																																					BgL_arg3760z00_1528;
																																																				BgL_arg3760z00_1528
																																																					=
																																																					MAKE_PAIR
																																																					(BNIL,
																																																					BNIL);
																																																				BgL_list3759z00_1527
																																																					=
																																																					MAKE_PAIR
																																																					(BgL_arg3757z00_1525,
																																																					BgL_arg3760z00_1528);
																																																			}
																																																			BgL_arg3755z00_1523
																																																				=
																																																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																				(BgL_arg3756z00_1524,
																																																				BgL_list3759z00_1527);
																																																	}}
																																																	BgL_nexpz00_1521
																																																		=
																																																		MAKE_PAIR
																																																		(BgL_arg3754z00_1522,
																																																		BgL_arg3755z00_1523);
																																																}
																																																BgL_auxz00_3505
																																																	=
																																																	BGl_letzd2ze3nodez31zzast_letz00
																																																	(BgL_nexpz00_1521,
																																																	BgL_stackz00_19,
																																																	BgL_locz00_1520,
																																																	BgL_sitez00_21);
																																															}
																																															BgL_auxz00_3456
																																																=
																																																(obj_t)
																																																(BgL_auxz00_3505);
																																													}}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																															{	/* Ast/sexp.scm 103 */
																																															BgL_tagzd21488zd2_923:
																																																BgL_auxz00_3456 = BGl_privatezd2ze3nodez31zzast_privatez00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_3527;
																																															BgL_tagzd21489zd2_924:
																																																BgL_auxz00_3527 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																BgL_auxz00_3456
																																																	=
																																																	(obj_t)
																																																	(BgL_auxz00_3527);
																																															}
																																													}
																																											}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					bool_t
																																						BgL_testz00_3530;
																																					{	/* Ast/sexp.scm 103 */
																																						obj_t
																																							BgL_arg3342z00_999;
																																						BgL_arg3342z00_999
																																							=
																																							CAR
																																							(BgL_expz00_18);
																																						BgL_testz00_3530
																																							=
																																							CBOOL
																																							(BGl_letzd2symzf3z21zzast_letz00
																																							(BgL_arg3342z00_999));
																																					}
																																					if (BgL_testz00_3530)
																																						{	/* Ast/sexp.scm 103 */
																																							BgL_nodez00_bglt
																																								BgL_auxz00_3534;
																																							goto
																																								BgL_tagzd21474zd2_902;
																																							BgL_auxz00_3456
																																								=
																																								(obj_t)
																																								(BgL_auxz00_3534);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							bool_t
																																								BgL_testz00_3536;
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_arg3341z00_998;
																																								BgL_arg3341z00_998
																																									=
																																									CAR
																																									(BgL_expz00_18);
																																								BgL_testz00_3536
																																									=
																																									CBOOL
																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																									(BgL_arg3341z00_998));
																																							}
																																							if (BgL_testz00_3536)
																																								{	/* Ast/sexp.scm 103 */
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_3540;
																																									goto
																																										BgL_tagzd21475zd2_903;
																																									BgL_auxz00_3456
																																										=
																																										(obj_t)
																																										(BgL_auxz00_3540);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									obj_t
																																										BgL_carzd21665zd2_989;
																																									BgL_carzd21665zd2_989
																																										=
																																										CAR
																																										(BgL_expz00_18);
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_cdrzd21670zd2_990;
																																										BgL_cdrzd21670zd2_990
																																											=
																																											CDR
																																											(BgL_carzd21665zd2_989);
																																										if ((CAR(BgL_carzd21665zd2_989) == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_arg3333z00_992;
																																												obj_t
																																													BgL_arg3334z00_993;
																																												obj_t
																																													BgL_arg3335z00_994;
																																												BgL_arg3333z00_992
																																													=
																																													CAR
																																													(BgL_cdrzd21670zd2_990);
																																												BgL_arg3334z00_993
																																													=
																																													CDR
																																													(BgL_cdrzd21670zd2_990);
																																												BgL_arg3335z00_994
																																													=
																																													CDR
																																													(BgL_expz00_18);
																																												{	/* Ast/sexp.scm 103 */
																																													BgL_nodez00_bglt
																																														BgL_auxz00_3551;
																																													{
																																														obj_t
																																															BgL_argsz00_3554;
																																														obj_t
																																															BgL_bodyz00_3553;
																																														obj_t
																																															BgL_varsz00_3552;
																																														BgL_varsz00_3552
																																															=
																																															BgL_arg3333z00_992;
																																														BgL_bodyz00_3553
																																															=
																																															BgL_arg3334z00_993;
																																														BgL_argsz00_3554
																																															=
																																															BgL_arg3335z00_994;
																																														BgL_argsz00_906
																																															=
																																															BgL_argsz00_3554;
																																														BgL_bodyz00_905
																																															=
																																															BgL_bodyz00_3553;
																																														BgL_varsz00_904
																																															=
																																															BgL_varsz00_3552;
																																														goto
																																															BgL_tagzd21476zd2_907;
																																													}
																																													BgL_auxz00_3456
																																														=
																																														(obj_t)
																																														(BgL_auxz00_3551);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																													{	/* Ast/sexp.scm 103 */
																																														goto
																																															BgL_tagzd21488zd2_923;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														BgL_nodez00_bglt
																																															BgL_auxz00_3558;
																																														goto
																																															BgL_tagzd21489zd2_924;
																																														BgL_auxz00_3456
																																															=
																																															(obj_t)
																																															(BgL_auxz00_3558);
																																													}
																																											}
																																									}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			bool_t
																																				BgL_testz00_3560;
																																			{	/* Ast/sexp.scm 103 */
																																				obj_t
																																					BgL_arg3347z00_1004;
																																				BgL_arg3347z00_1004
																																					=
																																					CAR
																																					(BgL_expz00_18);
																																				BgL_testz00_3560
																																					=
																																					CBOOL
																																					(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_arg3347z00_1004));
																																			}
																																			if (BgL_testz00_3560)
																																				{	/* Ast/sexp.scm 103 */
																																					BgL_nodez00_bglt
																																						BgL_auxz00_3564;
																																					goto
																																						BgL_tagzd21474zd2_902;
																																					BgL_auxz00_3456
																																						=
																																						(obj_t)
																																						(BgL_auxz00_3564);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					bool_t
																																						BgL_testz00_3566;
																																					{	/* Ast/sexp.scm 103 */
																																						obj_t
																																							BgL_arg3346z00_1003;
																																						BgL_arg3346z00_1003
																																							=
																																							CAR
																																							(BgL_expz00_18);
																																						BgL_testz00_3566
																																							=
																																							CBOOL
																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																							(BgL_arg3346z00_1003));
																																					}
																																					if (BgL_testz00_3566)
																																						{	/* Ast/sexp.scm 103 */
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_3570;
																																							goto
																																								BgL_tagzd21475zd2_903;
																																							BgL_auxz00_3456
																																								=
																																								(obj_t)
																																								(BgL_auxz00_3570);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																								{	/* Ast/sexp.scm 103 */
																																									goto
																																										BgL_tagzd21488zd2_923;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									BgL_nodez00_bglt
																																										BgL_auxz00_3574;
																																									goto
																																										BgL_tagzd21489zd2_924;
																																									BgL_auxz00_3456
																																										=
																																										(obj_t)
																																										(BgL_auxz00_3574);
																																								}
																																						}
																																				}
																																		}
																																	return
																																		(BgL_nodez00_bglt)
																																		(BgL_auxz00_3456);
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	if (CBOOL
																																		(BGl_letzd2symzf3z21zzast_letz00
																																			(BgL_carzd21577zd2_944)))
																																		{	/* Ast/sexp.scm 103 */
																																			obj_t
																																				BgL_auxz00_3580;
																																			goto
																																				BgL_kapzd21579zd2_946;
																																			return
																																				(BgL_nodez00_bglt)
																																				(BgL_auxz00_3580);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			if (
																																				(BgL_carzd21577zd2_944
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{	/* Ast/sexp.scm 103 */
																																					obj_t
																																						BgL_auxz00_3585;
																																					goto
																																						BgL_kapzd21579zd2_946;
																																					return
																																						(BgL_nodez00_bglt)
																																						(BgL_auxz00_3585);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					if (
																																						(BgL_carzd21577zd2_944
																																							==
																																							CNST_TABLE_REF
																																							(((long) 21))))
																																						{	/* Ast/sexp.scm 103 */
																																							obj_t
																																								BgL_auxz00_3590;
																																							goto
																																								BgL_kapzd21579zd2_946;
																																							return
																																								(BgL_nodez00_bglt)
																																								(BgL_auxz00_3590);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd21577zd2_944)))
																																								{	/* Ast/sexp.scm 103 */
																																									obj_t
																																										BgL_auxz00_3595;
																																									goto
																																										BgL_kapzd21579zd2_946;
																																									return
																																										(BgL_nodez00_bglt)
																																										(BgL_auxz00_3595);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									bool_t
																																										BgL_testz00_3597;
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_arg3311z00_966;
																																										BgL_arg3311z00_966
																																											=
																																											CAR
																																											(BgL_expz00_18);
																																										BgL_testz00_3597
																																											=
																																											CBOOL
																																											(BGl_letzd2symzf3z21zzast_letz00
																																											(BgL_arg3311z00_966));
																																									}
																																									if (BgL_testz00_3597)
																																										{	/* Ast/sexp.scm 103 */
																																											goto
																																												BgL_tagzd21474zd2_902;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 103 */
																																											bool_t
																																												BgL_testz00_3601;
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_arg3310z00_965;
																																												BgL_arg3310z00_965
																																													=
																																													CAR
																																													(BgL_expz00_18);
																																												BgL_testz00_3601
																																													=
																																													CBOOL
																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																													(BgL_arg3310z00_965));
																																											}
																																											if (BgL_testz00_3601)
																																												{	/* Ast/sexp.scm 103 */
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_3605;
																																													goto
																																														BgL_tagzd21475zd2_903;
																																													return
																																														(BgL_nodez00_bglt)
																																														(BgL_auxz00_3605);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 103 */
																																													obj_t
																																														BgL_carzd21759zd2_954;
																																													BgL_carzd21759zd2_954
																																														=
																																														CAR
																																														(BgL_expz00_18);
																																													{	/* Ast/sexp.scm 103 */
																																														obj_t
																																															BgL_cdrzd21764zd2_955;
																																														BgL_cdrzd21764zd2_955
																																															=
																																															CDR
																																															(BgL_carzd21759zd2_954);
																																														if ((CAR(BgL_carzd21759zd2_954) == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 103 */
																																																if (PAIRP(BgL_cdrzd21764zd2_955))
																																																	{
																																																		obj_t
																																																			BgL_argsz00_3619;
																																																		obj_t
																																																			BgL_bodyz00_3617;
																																																		obj_t
																																																			BgL_varsz00_3615;
																																																		BgL_varsz00_3615
																																																			=
																																																			CAR
																																																			(BgL_cdrzd21764zd2_955);
																																																		BgL_bodyz00_3617
																																																			=
																																																			CDR
																																																			(BgL_cdrzd21764zd2_955);
																																																		BgL_argsz00_3619
																																																			=
																																																			CDR
																																																			(BgL_expz00_18);
																																																		BgL_argsz00_906
																																																			=
																																																			BgL_argsz00_3619;
																																																		BgL_bodyz00_905
																																																			=
																																																			BgL_bodyz00_3617;
																																																		BgL_varsz00_904
																																																			=
																																																			BgL_varsz00_3615;
																																																		goto
																																																			BgL_tagzd21476zd2_907;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																			{	/* Ast/sexp.scm 103 */
																																																				obj_t
																																																					BgL_auxz00_3623;
																																																				goto
																																																					BgL_tagzd21488zd2_923;
																																																				return
																																																					(BgL_nodez00_bglt)
																																																					(BgL_auxz00_3623);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 103 */
																																																				goto
																																																					BgL_tagzd21489zd2_924;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																	{	/* Ast/sexp.scm 103 */
																																																		obj_t
																																																			BgL_auxz00_3627;
																																																		goto
																																																			BgL_tagzd21488zd2_923;
																																																		return
																																																			(BgL_nodez00_bglt)
																																																			(BgL_auxz00_3627);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		goto
																																																			BgL_tagzd21489zd2_924;
																																																	}
																																															}
																																													}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													}
																												else
																													{	/* Ast/sexp.scm 103 */
																														if (
																															(BgL_carzd21574zd2_942
																																==
																																CNST_TABLE_REF((
																																		(long)
																																		19))))
																															{	/* Ast/sexp.scm 103 */
																																goto
																																	BgL_tagzd21474zd2_902;
																															}
																														else
																															{	/* Ast/sexp.scm 103 */
																																if (CBOOL
																																	(BGl_letzd2symzf3z21zzast_letz00
																																		(BgL_carzd21574zd2_942)))
																																	{	/* Ast/sexp.scm 103 */
																																		goto
																																			BgL_tagzd21474zd2_902;
																																	}
																																else
																																	{	/* Ast/sexp.scm 103 */
																																		if (
																																			(BgL_carzd21574zd2_942
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						20))))
																																			{	/* Ast/sexp.scm 103 */
																																				goto
																																					BgL_tagzd21474zd2_902;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 103 */
																																				obj_t
																																					BgL_carzd21814zd2_1009;
																																				BgL_carzd21814zd2_1009
																																					=
																																					CAR
																																					(BgL_expz00_18);
																																				if (
																																					(BgL_carzd21814zd2_1009
																																						==
																																						CNST_TABLE_REF
																																						(((long) 21))))
																																					{	/* Ast/sexp.scm 103 */
																																						BgL_letzd2funzd2_bglt
																																							BgL_auxz00_3642;
																																						goto
																																							BgL_tagzd21475zd2_903;
																																						return
																																							(BgL_nodez00_bglt)
																																							(BgL_auxz00_3642);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 103 */
																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd21814zd2_1009)))
																																							{	/* Ast/sexp.scm 103 */
																																								BgL_letzd2funzd2_bglt
																																									BgL_auxz00_3647;
																																								goto
																																									BgL_tagzd21475zd2_903;
																																								return
																																									(BgL_nodez00_bglt)
																																									(BgL_auxz00_3647);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 103 */
																																								if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 103 */
																																									BgL_tagzd21477zd2_908:
																																										{
																																											obj_t
																																												BgL_argsz00_1592;
																																											obj_t
																																												BgL_bodyz00_1593;
																																											if (PAIRP(BgL_expz00_18))
																																												{	/* Ast/sexp.scm 103 */
																																													obj_t
																																														BgL_cdrzd22421zd2_1598;
																																													BgL_cdrzd22421zd2_1598
																																														=
																																														CDR
																																														(BgL_expz00_18);
																																													if (PAIRP(BgL_cdrzd22421zd2_1598))
																																														{	/* Ast/sexp.scm 103 */
																																															BgL_argsz00_1592
																																																=
																																																CAR
																																																(BgL_cdrzd22421zd2_1598);
																																															BgL_bodyz00_1593
																																																=
																																																CDR
																																																(BgL_cdrzd22421zd2_1598);
																																															{	/* Ast/sexp.scm 416 */
																																																obj_t
																																																	BgL_locz00_1602;
																																																obj_t
																																																	BgL_funz00_1603;
																																																BgL_locz00_1602
																																																	=
																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																	(BgL_expz00_18,
																																																	BgL_locz00_20);
																																																BgL_funz00_1603
																																																	=
																																																	BGl_makezd2anonymouszd2namez00zzast_sexpz00
																																																	(BgL_locz00_20,
																																																	BNIL);
																																																{	/* Ast/sexp.scm 418 */
																																																	obj_t
																																																		BgL_arg3818z00_1604;
																																																	{	/* Ast/sexp.scm 418 */
																																																		obj_t
																																																			BgL_arg3819z00_1605;
																																																		obj_t
																																																			BgL_arg3820z00_1606;
																																																		BgL_arg3819z00_1605
																																																			=
																																																			BGl_labelszd2symzd2zzast_labelsz00
																																																			();
																																																		{	/* Ast/sexp.scm 418 */
																																																			obj_t
																																																				BgL_arg3821z00_1607;
																																																			{	/* Ast/sexp.scm 418 */
																																																				obj_t
																																																					BgL_arg3825z00_1611;
																																																				{	/* Ast/sexp.scm 418 */
																																																					obj_t
																																																						BgL_arg3827z00_1613;
																																																					{	/* Ast/sexp.scm 418 */
																																																						obj_t
																																																							BgL_arg3828z00_1614;
																																																						BgL_arg3828z00_1614
																																																							=
																																																							BGl_normaliza7ezd2prognz75zztools_prognz00
																																																							(BgL_bodyz00_1593);
																																																						{	/* Ast/sexp.scm 418 */
																																																							obj_t
																																																								BgL_list3830z00_1616;
																																																							{	/* Ast/sexp.scm 418 */
																																																								obj_t
																																																									BgL_arg3831z00_1617;
																																																								BgL_arg3831z00_1617
																																																									=
																																																									MAKE_PAIR
																																																									(BNIL,
																																																									BNIL);
																																																								BgL_list3830z00_1616
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_arg3828z00_1614,
																																																									BgL_arg3831z00_1617);
																																																							}
																																																							BgL_arg3827z00_1613
																																																								=
																																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																								(BgL_argsz00_1592,
																																																								BgL_list3830z00_1616);
																																																						}
																																																					}
																																																					BgL_arg3825z00_1611
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_funz00_1603,
																																																						BgL_arg3827z00_1613);
																																																				}
																																																				BgL_arg3821z00_1607
																																																					=
																																																					MAKE_PAIR
																																																					(BgL_arg3825z00_1611,
																																																					BNIL);
																																																			}
																																																			{	/* Ast/sexp.scm 418 */
																																																				obj_t
																																																					BgL_list3823z00_1609;
																																																				{	/* Ast/sexp.scm 418 */
																																																					obj_t
																																																						BgL_arg3824z00_1610;
																																																					BgL_arg3824z00_1610
																																																						=
																																																						MAKE_PAIR
																																																						(BNIL,
																																																						BNIL);
																																																					BgL_list3823z00_1609
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_funz00_1603,
																																																						BgL_arg3824z00_1610);
																																																				}
																																																				BgL_arg3820z00_1606
																																																					=
																																																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																					(BgL_arg3821z00_1607,
																																																					BgL_list3823z00_1609);
																																																			}
																																																		}
																																																		BgL_arg3818z00_1604
																																																			=
																																																			MAKE_PAIR
																																																			(BgL_arg3819z00_1605,
																																																			BgL_arg3820z00_1606);
																																																	}
																																																	{
																																																		obj_t
																																																			BgL_locz00_3672;
																																																		obj_t
																																																			BgL_expz00_3671;
																																																		BgL_expz00_3671
																																																			=
																																																			BgL_arg3818z00_1604;
																																																		BgL_locz00_3672
																																																			=
																																																			BgL_locz00_1602;
																																																		BgL_locz00_20
																																																			=
																																																			BgL_locz00_3672;
																																																		BgL_expz00_18
																																																			=
																																																			BgL_expz00_3671;
																																																		goto
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																																	}
																																																}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 103 */
																																														BgL_tagzd22414zd2_1595:
																																															return BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4125z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																														}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 103 */
																																													goto
																																														BgL_tagzd22414zd2_1595;
																																												}
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 103 */
																																										if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 4))))
																																											{	/* Ast/sexp.scm 103 */
																																											BgL_tagzd21478zd2_909:
																																												return BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_cdrzd21838zd2_1014;
																																												BgL_cdrzd21838zd2_1014
																																													=
																																													CDR
																																													(BgL_expz00_18);
																																												if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 22))))
																																													{	/* Ast/sexp.scm 103 */
																																														if (PAIRP(BgL_cdrzd21838zd2_1014))
																																															{	/* Ast/sexp.scm 103 */
																																																BgL_effectz00_910
																																																	=
																																																	CAR
																																																	(BgL_cdrzd21838zd2_1014);
																																																BgL_restz00_911
																																																	=
																																																	CDR
																																																	(BgL_cdrzd21838zd2_1014);
																																															BgL_tagzd21479zd2_912:
																																																{	/* Ast/sexp.scm 432 */
																																																	BgL_feffectz00_bglt
																																																		BgL_arg3835z00_1621;
																																																	obj_t
																																																		BgL_arg3836z00_1622;
																																																	BgL_arg3835z00_1621
																																																		=
																																																		BGl_parsezd2effectzd2zzeffect_feffectz00
																																																		(BgL_effectz00_910);
																																																	{	/* Ast/sexp.scm 433 */
																																																		obj_t
																																																			BgL_arg3837z00_1623;
																																																		obj_t
																																																			BgL_arg3838z00_1624;
																																																		BgL_arg3837z00_1623
																																																			=
																																																			CNST_TABLE_REF
																																																			(
																																																			((long) 4));
																																																		BgL_arg3838z00_1624
																																																			=
																																																			BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																			(BgL_restz00_911,
																																																			BNIL);
																																																		BgL_arg3836z00_1622
																																																			=
																																																			MAKE_PAIR
																																																			(BgL_arg3837z00_1623,
																																																			BgL_arg3838z00_1624);
																																																	}
																																																	return
																																																		BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																		(
																																																		((bool_t) 0), (obj_t) (BgL_arg3835z00_1621), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3836z00_1622, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																	{	/* Ast/sexp.scm 103 */
																																																		obj_t
																																																			BgL_auxz00_3701;
																																																		goto
																																																			BgL_tagzd21488zd2_923;
																																																		return
																																																			(BgL_nodez00_bglt)
																																																			(BgL_auxz00_3701);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		goto
																																																			BgL_tagzd21489zd2_924;
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 23))))
																																															{	/* Ast/sexp.scm 103 */
																																															BgL_tagzd21480zd2_913:
																																																return BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 24))))
																																																	{	/* Ast/sexp.scm 103 */
																																																		if (PAIRP(BgL_cdrzd21838zd2_1014))
																																																			{	/* Ast/sexp.scm 103 */
																																																				BgL_effectz00_914
																																																					=
																																																					CAR
																																																					(BgL_cdrzd21838zd2_1014);
																																																				BgL_restz00_915
																																																					=
																																																					CDR
																																																					(BgL_cdrzd21838zd2_1014);
																																																			BgL_tagzd21481zd2_916:
																																																				{	/* Ast/sexp.scm 440 */
																																																					BgL_feffectz00_bglt
																																																						BgL_arg3839z00_1625;
																																																					obj_t
																																																						BgL_arg3840z00_1626;
																																																					BgL_arg3839z00_1625
																																																						=
																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																						(BgL_effectz00_914);
																																																					{	/* Ast/sexp.scm 441 */
																																																						obj_t
																																																							BgL_arg3841z00_1627;
																																																						obj_t
																																																							BgL_arg3842z00_1628;
																																																						BgL_arg3841z00_1627
																																																							=
																																																							CNST_TABLE_REF
																																																							(
																																																							((long) 4));
																																																						BgL_arg3842z00_1628
																																																							=
																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																							(BgL_restz00_915,
																																																							BNIL);
																																																						BgL_arg3840z00_1626
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3841z00_1627,
																																																							BgL_arg3842z00_1628);
																																																					}
																																																					return
																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																						(
																																																						((bool_t) 1), (obj_t) (BgL_arg3839z00_1625), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3840z00_1626, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 103 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																					{	/* Ast/sexp.scm 103 */
																																																						obj_t
																																																							BgL_auxz00_3726;
																																																						goto
																																																							BgL_tagzd21488zd2_923;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3726);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 103 */
																																																						goto
																																																							BgL_tagzd21489zd2_924;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 25))))
																																																			{	/* Ast/sexp.scm 103 */
																																																				obj_t
																																																					BgL_auxz00_3732;
																																																			BgL_tagzd21482zd2_917:
																																																				{
																																																					obj_t
																																																						BgL_procz00_1629;
																																																					obj_t
																																																						BgL_msgz00_1630;
																																																					obj_t
																																																						BgL_objz00_1631;
																																																					if (PAIRP(BgL_expz00_18))
																																																						{	/* Ast/sexp.scm 103 */
																																																							obj_t
																																																								BgL_cdrzd22438zd2_1636;
																																																							BgL_cdrzd22438zd2_1636
																																																								=
																																																								CDR
																																																								(BgL_expz00_18);
																																																							if (PAIRP(BgL_cdrzd22438zd2_1636))
																																																								{	/* Ast/sexp.scm 103 */
																																																									obj_t
																																																										BgL_cdrzd22443zd2_1638;
																																																									BgL_cdrzd22443zd2_1638
																																																										=
																																																										CDR
																																																										(BgL_cdrzd22438zd2_1636);
																																																									if (PAIRP(BgL_cdrzd22443zd2_1638))
																																																										{	/* Ast/sexp.scm 103 */
																																																											obj_t
																																																												BgL_cdrzd22448zd2_1640;
																																																											BgL_cdrzd22448zd2_1640
																																																												=
																																																												CDR
																																																												(BgL_cdrzd22443zd2_1638);
																																																											if (PAIRP(BgL_cdrzd22448zd2_1640))
																																																												{	/* Ast/sexp.scm 103 */
																																																													if (NULLP(CDR(BgL_cdrzd22448zd2_1640)))
																																																														{	/* Ast/sexp.scm 103 */
																																																															obj_t
																																																																BgL_arg3848z00_1643;
																																																															obj_t
																																																																BgL_arg3849z00_1644;
																																																															obj_t
																																																																BgL_arg3850z00_1645;
																																																															BgL_arg3848z00_1643
																																																																=
																																																																CAR
																																																																(BgL_cdrzd22438zd2_1636);
																																																															BgL_arg3849z00_1644
																																																																=
																																																																CAR
																																																																(BgL_cdrzd22443zd2_1638);
																																																															BgL_arg3850z00_1645
																																																																=
																																																																CAR
																																																																(BgL_cdrzd22448zd2_1640);
																																																															{	/* Ast/sexp.scm 103 */
																																																																BgL_failz00_bglt
																																																																	BgL_auxz00_3750;
																																																																BgL_procz00_1629
																																																																	=
																																																																	BgL_arg3848z00_1643;
																																																																BgL_msgz00_1630
																																																																	=
																																																																	BgL_arg3849z00_1644;
																																																																BgL_objz00_1631
																																																																	=
																																																																	BgL_arg3850z00_1645;
																																																																{	/* Ast/sexp.scm 446 */
																																																																	obj_t
																																																																		BgL_locz00_1647;
																																																																	BgL_locz00_1647
																																																																		=
																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																		(BgL_expz00_18,
																																																																		BgL_locz00_20);
																																																																	{	/* Ast/sexp.scm 446 */
																																																																		obj_t
																																																																			BgL_cdlocz00_1648;
																																																																		BgL_cdlocz00_1648
																																																																			=
																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																			(CDR
																																																																			(BgL_expz00_18),
																																																																			BgL_locz00_1647);
																																																																		{	/* Ast/sexp.scm 447 */
																																																																			obj_t
																																																																				BgL_cddlocz00_1649;
																																																																			{	/* Ast/sexp.scm 448 */
																																																																				obj_t
																																																																					BgL_arg3854z00_1658;
																																																																				{	/* Ast/sexp.scm 448 */
																																																																					obj_t
																																																																						BgL_pairz00_2702;
																																																																					BgL_pairz00_2702
																																																																						=
																																																																						BgL_expz00_18;
																																																																					BgL_arg3854z00_1658
																																																																						=
																																																																						CDR
																																																																						(CDR
																																																																						(BgL_pairz00_2702));
																																																																				}
																																																																				BgL_cddlocz00_1649
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_arg3854z00_1658,
																																																																					BgL_locz00_1647);
																																																																			}
																																																																			{	/* Ast/sexp.scm 448 */
																																																																				obj_t
																																																																					BgL_cdddlocz00_1650;
																																																																				{	/* Ast/sexp.scm 449 */
																																																																					obj_t
																																																																						BgL_arg3852z00_1657;
																																																																					{	/* Ast/sexp.scm 449 */
																																																																						obj_t
																																																																							BgL_pairz00_2706;
																																																																						BgL_pairz00_2706
																																																																							=
																																																																							BgL_expz00_18;
																																																																						BgL_arg3852z00_1657
																																																																							=
																																																																							CDR
																																																																							(CDR
																																																																							(CDR
																																																																								(BgL_pairz00_2706)));
																																																																					}
																																																																					BgL_cdddlocz00_1650
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_arg3852z00_1657,
																																																																						BgL_locz00_1647);
																																																																				}
																																																																				{	/* Ast/sexp.scm 449 */
																																																																					obj_t
																																																																						BgL_loczd2proczd2_1651;
																																																																					BgL_loczd2proczd2_1651
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_procz00_1629,
																																																																						BgL_cdlocz00_1648);
																																																																					{	/* Ast/sexp.scm 450 */
																																																																						obj_t
																																																																							BgL_loczd2msgzd2_1652;
																																																																						BgL_loczd2msgzd2_1652
																																																																							=
																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																							(BgL_msgz00_1630,
																																																																							BgL_cddlocz00_1649);
																																																																						{	/* Ast/sexp.scm 451 */
																																																																							obj_t
																																																																								BgL_loczd2objzd2_1653;
																																																																							BgL_loczd2objzd2_1653
																																																																								=
																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																								(BgL_objz00_1631,
																																																																								BgL_cdddlocz00_1650);
																																																																							{	/* Ast/sexp.scm 452 */
																																																																								BgL_nodez00_bglt
																																																																									BgL_procz00_1654;
																																																																								BgL_procz00_1654
																																																																									=
																																																																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																									(BgL_procz00_1629,
																																																																									BgL_stackz00_19,
																																																																									BgL_loczd2proczd2_1651,
																																																																									CNST_TABLE_REF
																																																																									(((long) 2)));
																																																																								{	/* Ast/sexp.scm 453 */
																																																																									BgL_nodez00_bglt
																																																																										BgL_msgz00_1655;
																																																																									BgL_msgz00_1655
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_msgz00_1630,
																																																																										BgL_stackz00_19,
																																																																										BgL_loczd2msgzd2_1652,
																																																																										CNST_TABLE_REF
																																																																										(((long) 2)));
																																																																									{	/* Ast/sexp.scm 454 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_objz00_1656;
																																																																										BgL_objz00_1656
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BgL_objz00_1631,
																																																																											BgL_stackz00_19,
																																																																											BgL_loczd2objzd2_1653,
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																										{	/* Ast/sexp.scm 455 */

																																																																											BgL_auxz00_3750
																																																																												=
																																																																												BGl_makezd2failzd2zzast_nodez00
																																																																												(BgL_locz00_1647,
																																																																												(BgL_typez00_bglt)
																																																																												(BGl_za2magicza2z00zztype_cachez00),
																																																																												BgL_procz00_1654,
																																																																												BgL_msgz00_1655,
																																																																												BgL_objz00_1656);
																																																																}}}}}}}}}}}
																																																																BgL_auxz00_3732
																																																																	=
																																																																	(obj_t)
																																																																	(BgL_auxz00_3750);
																																																														}}
																																																													else
																																																														{	/* Ast/sexp.scm 103 */
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_3773;
																																																														BgL_tagzd22429zd2_1633:
																																																															BgL_auxz00_3773 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4124z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																																															BgL_auxz00_3732
																																																																=
																																																																(obj_t)
																																																																(BgL_auxz00_3773);
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 103 */
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_3777;
																																																													goto
																																																														BgL_tagzd22429zd2_1633;
																																																													BgL_auxz00_3732
																																																														=
																																																														(obj_t)
																																																														(BgL_auxz00_3777);
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 103 */
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_3779;
																																																											goto
																																																												BgL_tagzd22429zd2_1633;
																																																											BgL_auxz00_3732
																																																												=
																																																												(obj_t)
																																																												(BgL_auxz00_3779);
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 103 */
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_3781;
																																																									goto
																																																										BgL_tagzd22429zd2_1633;
																																																									BgL_auxz00_3732
																																																										=
																																																										(obj_t)
																																																										(BgL_auxz00_3781);
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 103 */
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_3783;
																																																							goto
																																																								BgL_tagzd22429zd2_1633;
																																																							BgL_auxz00_3732
																																																								=
																																																								(obj_t)
																																																								(BgL_auxz00_3783);
																																																						}
																																																				}
																																																				return
																																																					(BgL_nodez00_bglt)
																																																					(BgL_auxz00_3732);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 103 */
																																																				if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 26))))
																																																					{	/* Ast/sexp.scm 103 */
																																																						obj_t
																																																							BgL_auxz00_3790;
																																																					BgL_tagzd21483zd2_918:
																																																						{
																																																							obj_t
																																																								BgL_testz00_1662;
																																																							obj_t
																																																								BgL_clausesz00_1663;
																																																							if (PAIRP(BgL_expz00_18))
																																																								{	/* Ast/sexp.scm 103 */
																																																									obj_t
																																																										BgL_cdrzd22462zd2_1668;
																																																									BgL_cdrzd22462zd2_1668
																																																										=
																																																										CDR
																																																										(BgL_expz00_18);
																																																									if (PAIRP(BgL_cdrzd22462zd2_1668))
																																																										{	/* Ast/sexp.scm 103 */
																																																											BgL_testz00_1662
																																																												=
																																																												CAR
																																																												(BgL_cdrzd22462zd2_1668);
																																																											BgL_clausesz00_1663
																																																												=
																																																												CDR
																																																												(BgL_cdrzd22462zd2_1668);
																																																											{	/* Ast/sexp.scm 475 */
																																																												obj_t
																																																													BgL_locz00_1672;
																																																												BgL_locz00_1672
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_expz00_18,
																																																													BgL_locz00_20);
																																																												{	/* Ast/sexp.scm 475 */
																																																													obj_t
																																																														BgL_cdlocz00_1673;
																																																													BgL_cdlocz00_1673
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(CDR
																																																														(BgL_expz00_18),
																																																														BgL_locz00_1672);
																																																													{	/* Ast/sexp.scm 476 */
																																																														obj_t
																																																															BgL_cddlocz00_1674;
																																																														BgL_cddlocz00_1674
																																																															=
																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																															(CDR
																																																															(BgL_expz00_18),
																																																															BgL_locz00_1672);
																																																														{	/* Ast/sexp.scm 477 */
																																																															BgL_nodez00_bglt
																																																																BgL_testz00_1675;
																																																															{	/* Ast/sexp.scm 480 */
																																																																obj_t
																																																																	BgL_arg3888z00_1708;
																																																																obj_t
																																																																	BgL_arg3889z00_1709;
																																																																BgL_arg3888z00_1708
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_testz00_1662,
																																																																	BgL_cdlocz00_1673);
																																																																BgL_arg3889z00_1709
																																																																	=
																																																																	CNST_TABLE_REF
																																																																	(
																																																																	((long) 2));
																																																																BgL_testz00_1675
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(BgL_testz00_1662,
																																																																	BgL_stackz00_19,
																																																																	BgL_arg3888z00_1708,
																																																																	BgL_arg3889z00_1709);
																																																															}
																																																															{	/* Ast/sexp.scm 478 */

																																																																{
																																																																	obj_t
																																																																		BgL_clsz00_1678;
																																																																	obj_t
																																																																		BgL_nclausesz00_1679;
																																																																	BgL_clsz00_1678
																																																																		=
																																																																		BgL_clausesz00_1663;
																																																																	BgL_nclausesz00_1679
																																																																		=
																																																																		BNIL;
																																																																BgL_zc3anonymousza33863ze3z83_1680:
																																																																	if (NULLP(BgL_clsz00_1678))
																																																																		{	/* Ast/sexp.scm 485 */
																																																																			obj_t
																																																																				BgL_arg3866z00_1683;
																																																																			BgL_typez00_bglt
																																																																				BgL_arg3868z00_1684;
																																																																			BgL_arg3866z00_1683
																																																																				=
																																																																				bgl_reverse_bang
																																																																				(BgL_nclausesz00_1679);
																																																																			BgL_arg3868z00_1684
																																																																				=
																																																																				BGl_typeofzd2atomzd2zztype_typeofz00
																																																																				(CAR
																																																																				(CAR
																																																																					(CAR
																																																																						(BgL_clausesz00_1663))));
																																																																			BgL_auxz00_3790
																																																																				=
																																																																				(obj_t)
																																																																				(BGl_makezd2selectzd2zzast_nodez00
																																																																				(BgL_locz00_1672,
																																																																					(BgL_typez00_bglt)
																																																																					(BGl_za2_za2z00zztype_cachez00),
																																																																					BUNSPEC,
																																																																					BINT
																																																																					(((long) -1)), BgL_testz00_1675, BgL_arg3866z00_1683, BgL_arg3868z00_1684));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 491 */
																																																																			obj_t
																																																																				BgL_clausez00_1688;
																																																																			BgL_clausez00_1688
																																																																				=
																																																																				CAR
																																																																				(BgL_clsz00_1678);
																																																																			{	/* Ast/sexp.scm 491 */
																																																																				BgL_nodez00_bglt
																																																																					BgL_bodyz00_1689;
																																																																				{	/* Ast/sexp.scm 492 */
																																																																					obj_t
																																																																						BgL_arg3884z00_1703;
																																																																					obj_t
																																																																						BgL_arg3885z00_1704;
																																																																					obj_t
																																																																						BgL_arg3886z00_1705;
																																																																					BgL_arg3884z00_1703
																																																																						=
																																																																						BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																						(CDR
																																																																						(BgL_clausez00_1688));
																																																																					BgL_arg3885z00_1704
																																																																						=
																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																						(BgL_clausez00_1688,
																																																																						BgL_cddlocz00_1674);
																																																																					BgL_arg3886z00_1705
																																																																						=
																																																																						CNST_TABLE_REF
																																																																						(
																																																																						((long) 2));
																																																																					BgL_bodyz00_1689
																																																																						=
																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																						(BgL_arg3884z00_1703,
																																																																						BgL_stackz00_19,
																																																																						BgL_arg3885z00_1704,
																																																																						BgL_arg3886z00_1705);
																																																																				}
																																																																				{	/* Ast/sexp.scm 492 */
																																																																					obj_t
																																																																						BgL_nclausez00_1690;
																																																																					BgL_nclausez00_1690
																																																																						=
																																																																						MAKE_PAIR
																																																																						(CAR
																																																																						(BgL_clausez00_1688),
																																																																						(obj_t)
																																																																						(BgL_bodyz00_1689));
																																																																					{	/* Ast/sexp.scm 496 */

																																																																						{	/* Ast/sexp.scm 498 */
																																																																							bool_t
																																																																								BgL_testz00_3824;
																																																																							if ((CAR(BgL_clausez00_1688) == CNST_TABLE_REF(((long) 3))))
																																																																								{	/* Ast/sexp.scm 498 */
																																																																									if (NULLP(CDR(BgL_clsz00_1678)))
																																																																										{	/* Ast/sexp.scm 499 */
																																																																											BgL_testz00_3824
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 499 */
																																																																											BgL_testz00_3824
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 498 */
																																																																									BgL_testz00_3824
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							if (BgL_testz00_3824)
																																																																								{	/* Ast/sexp.scm 500 */
																																																																									obj_t
																																																																										BgL_arg3874z00_1693;
																																																																									BgL_arg3874z00_1693
																																																																										=
																																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																																										(BgL_expz00_18,
																																																																										BgL_locz00_1672);
																																																																									BgL_auxz00_3790
																																																																										=
																																																																										(obj_t)
																																																																										(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																																										(BGl_string4123z00zzast_sexpz00,
																																																																											BgL_expz00_18,
																																																																											BgL_arg3874z00_1693));
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 503 */
																																																																									obj_t
																																																																										BgL_arg3875z00_1694;
																																																																									obj_t
																																																																										BgL_arg3876z00_1695;
																																																																									BgL_arg3875z00_1694
																																																																										=
																																																																										CDR
																																																																										(BgL_clsz00_1678);
																																																																									BgL_arg3876z00_1695
																																																																										=
																																																																										MAKE_PAIR
																																																																										(BGl_epairifyz00zztools_miscz00
																																																																										(BgL_nclausez00_1690,
																																																																											BgL_clausez00_1688),
																																																																										BgL_nclausesz00_1679);
																																																																									{
																																																																										obj_t
																																																																											BgL_nclausesz00_3839;
																																																																										obj_t
																																																																											BgL_clsz00_3838;
																																																																										BgL_clsz00_3838
																																																																											=
																																																																											BgL_arg3875z00_1694;
																																																																										BgL_nclausesz00_3839
																																																																											=
																																																																											BgL_arg3876z00_1695;
																																																																										BgL_nclausesz00_1679
																																																																											=
																																																																											BgL_nclausesz00_3839;
																																																																										BgL_clsz00_1678
																																																																											=
																																																																											BgL_clsz00_3838;
																																																																										goto
																																																																											BgL_zc3anonymousza33863ze3z83_1680;
																																																																									}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																												}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 103 */
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_3842;
																																																										BgL_tagzd22455zd2_1665:
																																																											BgL_auxz00_3842 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4123z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																																											BgL_auxz00_3790
																																																												=
																																																												(obj_t)
																																																												(BgL_auxz00_3842);
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 103 */
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_3846;
																																																									goto
																																																										BgL_tagzd22455zd2_1665;
																																																									BgL_auxz00_3790
																																																										=
																																																										(obj_t)
																																																										(BgL_auxz00_3846);
																																																								}
																																																						}
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3790);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 103 */
																																																						if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 27))))
																																																							{	/* Ast/sexp.scm 103 */
																																																								BgL_letzd2funzd2_bglt
																																																									BgL_auxz00_3853;
																																																							BgL_tagzd21484zd2_919:
																																																								BgL_auxz00_3853 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_3853);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 103 */
																																																								if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 28))))
																																																									{	/* Ast/sexp.scm 103 */
																																																										BgL_jumpzd2exzd2itz00_bglt
																																																											BgL_auxz00_3860;
																																																									BgL_tagzd21485zd2_920:
																																																										BgL_auxz00_3860 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																										return
																																																											(BgL_nodez00_bglt)
																																																											(BgL_auxz00_3860);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 103 */
																																																										obj_t
																																																											BgL_cdrzd21876zd2_1031;
																																																										BgL_cdrzd21876zd2_1031
																																																											=
																																																											CDR
																																																											(BgL_expz00_18);
																																																										if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 14))))
																																																											{	/* Ast/sexp.scm 103 */
																																																												if (PAIRP(BgL_cdrzd21876zd2_1031))
																																																													{	/* Ast/sexp.scm 103 */
																																																														obj_t
																																																															BgL_cdrzd21878zd2_1034;
																																																														BgL_cdrzd21878zd2_1034
																																																															=
																																																															CDR
																																																															(BgL_cdrzd21876zd2_1031);
																																																														if (PAIRP(BgL_cdrzd21878zd2_1034))
																																																															{	/* Ast/sexp.scm 103 */
																																																																if (NULLP(CDR(BgL_cdrzd21878zd2_1034)))
																																																																	{	/* Ast/sexp.scm 103 */
																																																																	BgL_tagzd21486zd2_921:
																																																																		return BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_18, BgL_stackz00_19, BgL_locz00_20, BgL_sitez00_21);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																																			{	/* Ast/sexp.scm 103 */
																																																																				obj_t
																																																																					BgL_auxz00_3879;
																																																																				goto
																																																																					BgL_tagzd21488zd2_923;
																																																																				return
																																																																					(BgL_nodez00_bglt)
																																																																					(BgL_auxz00_3879);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 103 */
																																																																				goto
																																																																					BgL_tagzd21489zd2_924;
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		obj_t
																																																																			BgL_auxz00_3883;
																																																																		goto
																																																																			BgL_tagzd21488zd2_923;
																																																																		return
																																																																			(BgL_nodez00_bglt)
																																																																			(BgL_auxz00_3883);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		goto
																																																																			BgL_tagzd21489zd2_924;
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																															{	/* Ast/sexp.scm 103 */
																																																																obj_t
																																																																	BgL_auxz00_3887;
																																																																goto
																																																																	BgL_tagzd21488zd2_923;
																																																																return
																																																																	(BgL_nodez00_bglt)
																																																																	(BgL_auxz00_3887);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																goto
																																																																	BgL_tagzd21489zd2_924;
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 103 */
																																																												if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_18), BUNSPEC))
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (NULLP(BgL_cdrzd21876zd2_1031))
																																																															{	/* Ast/sexp.scm 103 */
																																																															BgL_tagzd21487zd2_922:
																																																																return BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string4122z00zzast_sexpz00, BgL_expz00_18, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_18, BgL_locz00_20));
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		obj_t
																																																																			BgL_auxz00_3898;
																																																																		goto
																																																																			BgL_tagzd21488zd2_923;
																																																																		return
																																																																			(BgL_nodez00_bglt)
																																																																			(BgL_auxz00_3898);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		goto
																																																																			BgL_tagzd21489zd2_924;
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																															{	/* Ast/sexp.scm 103 */
																																																																obj_t
																																																																	BgL_auxz00_3902;
																																																																goto
																																																																	BgL_tagzd21488zd2_923;
																																																																return
																																																																	(BgL_nodez00_bglt)
																																																																	(BgL_auxz00_3902);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																goto
																																																																	BgL_tagzd21489zd2_924;
																																																															}
																																																													}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 103 */
												if (
													(BgL_carzd21519zd2_929 ==
														CNST_TABLE_REF(((long) 12))))
													{	/* Ast/sexp.scm 103 */
														obj_t BgL_auxz00_3907;

														goto BgL_tagzd21467zd2_892;
														return (BgL_nodez00_bglt) (BgL_auxz00_3907);
													}
												else
													{	/* Ast/sexp.scm 103 */
														if (
															(CAR(BgL_expz00_18) ==
																CNST_TABLE_REF(((long) 13))))
															{	/* Ast/sexp.scm 103 */
																obj_t BgL_auxz00_3913;

																goto BgL_tagzd21468zd2_893;
																return (BgL_nodez00_bglt) (BgL_auxz00_3913);
															}
														else
															{	/* Ast/sexp.scm 103 */
																if (
																	(CAR(BgL_expz00_18) ==
																		CNST_TABLE_REF(((long) 16))))
																	{	/* Ast/sexp.scm 103 */
																		obj_t BgL_arg3423z00_1088;

																		BgL_arg3423z00_1088 = CDR(BgL_expz00_18);
																		{	/* Ast/sexp.scm 103 */
																			BgL_sequencez00_bglt BgL_auxz00_3920;

																			{
																				obj_t BgL_bodyz00_3921;

																				BgL_bodyz00_3921 = BgL_arg3423z00_1088;
																				BgL_bodyz00_894 = BgL_bodyz00_3921;
																				goto BgL_tagzd21469zd2_895;
																			}
																			return
																				(BgL_nodez00_bglt) (BgL_auxz00_3920);
																		}
																	}
																else
																	{	/* Ast/sexp.scm 103 */
																		obj_t BgL_carzd21911zd2_1089;

																		BgL_carzd21911zd2_1089 = CAR(BgL_expz00_18);
																		if (
																			(BgL_carzd21911zd2_1089 ==
																				CNST_TABLE_REF(((long) 1))))
																			{	/* Ast/sexp.scm 103 */
																				obj_t BgL_auxz00_3927;

																				goto BgL_tagzd21470zd2_896;
																				return
																					(BgL_nodez00_bglt) (BgL_auxz00_3927);
																			}
																		else
																			{	/* Ast/sexp.scm 103 */
																				if (
																					(BgL_carzd21911zd2_1089 ==
																						BGl_za2ifza2z00zzast_sexpz00))
																					{	/* Ast/sexp.scm 103 */
																						obj_t BgL_auxz00_3931;

																						goto BgL_tagzd21470zd2_896;
																						return
																							(BgL_nodez00_bglt)
																							(BgL_auxz00_3931);
																					}
																				else
																					{	/* Ast/sexp.scm 103 */
																						if (
																							(CAR(BgL_expz00_18) ==
																								CNST_TABLE_REF(((long) 5))))
																							{	/* Ast/sexp.scm 103 */
																								obj_t BgL_auxz00_3937;

																								goto BgL_tagzd21471zd2_897;
																								return
																									(BgL_nodez00_bglt)
																									(BgL_auxz00_3937);
																							}
																						else
																							{	/* Ast/sexp.scm 103 */
																								if (
																									(CAR(BgL_expz00_18) ==
																										CNST_TABLE_REF(((long)
																												17))))
																									{	/* Ast/sexp.scm 103 */
																										obj_t BgL_auxz00_3943;

																										goto BgL_tagzd21472zd2_898;
																										return
																											(BgL_nodez00_bglt)
																											(BgL_auxz00_3943);
																									}
																								else
																									{	/* Ast/sexp.scm 103 */
																										obj_t
																											BgL_carzd21935zd2_1094;
																										BgL_carzd21935zd2_1094 =
																											CAR(BgL_expz00_18);
																										if (PAIRP
																											(BgL_carzd21935zd2_1094))
																											{	/* Ast/sexp.scm 103 */
																												obj_t
																													BgL_carzd21938zd2_1096;
																												obj_t
																													BgL_cdrzd21939zd2_1097;
																												BgL_carzd21938zd2_1096 =
																													CAR
																													(BgL_carzd21935zd2_1094);
																												BgL_cdrzd21939zd2_1097 =
																													CDR
																													(BgL_carzd21935zd2_1094);
																												{

																													if (
																														(BgL_carzd21938zd2_1096
																															==
																															CNST_TABLE_REF((
																																	(long) 19))))
																														{	/* Ast/sexp.scm 103 */
																															obj_t
																																BgL_auxz00_3953;
																														BgL_kapzd21940zd2_1098:
																															if (PAIRP
																																(BgL_cdrzd21939zd2_1097))
																																{	/* Ast/sexp.scm 103 */
																																	obj_t
																																		BgL_cdrzd21943zd2_1120;
																																	BgL_cdrzd21943zd2_1120
																																		=
																																		CDR
																																		(BgL_cdrzd21939zd2_1097);
																																	if (PAIRP
																																		(BgL_cdrzd21943zd2_1120))
																																		{	/* Ast/sexp.scm 103 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd21943zd2_1120)))
																																				{	/* Ast/sexp.scm 103 */
																																					obj_t
																																						BgL_arg3451z00_1123;
																																					obj_t
																																						BgL_arg3452z00_1124;
																																					BgL_arg3451z00_1123
																																						=
																																						CAR
																																						(BgL_cdrzd21943zd2_1120);
																																					BgL_arg3452z00_1124
																																						=
																																						CDR
																																						(BgL_expz00_18);
																																					{	/* Ast/sexp.scm 103 */
																																						BgL_nodez00_bglt
																																							BgL_auxz00_3964;
																																						{
																																							obj_t
																																								BgL_argsz00_3966;
																																							obj_t
																																								BgL_bodyz00_3965;
																																							BgL_bodyz00_3965
																																								=
																																								BgL_arg3451z00_1123;
																																							BgL_argsz00_3966
																																								=
																																								BgL_arg3452z00_1124;
																																							BgL_argsz00_900
																																								=
																																								BgL_argsz00_3966;
																																							BgL_bodyz00_899
																																								=
																																								BgL_bodyz00_3965;
																																							goto
																																								BgL_tagzd21473zd2_901;
																																						}
																																						BgL_auxz00_3953
																																							=
																																							(obj_t)
																																							(BgL_auxz00_3964);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					bool_t
																																						BgL_testz00_3968;
																																					{	/* Ast/sexp.scm 103 */
																																						obj_t
																																							BgL_arg3463z00_1137;
																																						BgL_arg3463z00_1137
																																							=
																																							CAR
																																							(BgL_expz00_18);
																																						BgL_testz00_3968
																																							=
																																							CBOOL
																																							(BGl_letzd2symzf3z21zzast_letz00
																																							(BgL_arg3463z00_1137));
																																					}
																																					if (BgL_testz00_3968)
																																						{	/* Ast/sexp.scm 103 */
																																							BgL_nodez00_bglt
																																								BgL_auxz00_3972;
																																							goto
																																								BgL_tagzd21474zd2_902;
																																							BgL_auxz00_3953
																																								=
																																								(obj_t)
																																								(BgL_auxz00_3972);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							bool_t
																																								BgL_testz00_3974;
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_arg3462z00_1136;
																																								BgL_arg3462z00_1136
																																									=
																																									CAR
																																									(BgL_expz00_18);
																																								BgL_testz00_3974
																																									=
																																									CBOOL
																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																									(BgL_arg3462z00_1136));
																																							}
																																							if (BgL_testz00_3974)
																																								{	/* Ast/sexp.scm 103 */
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_3978;
																																									goto
																																										BgL_tagzd21475zd2_903;
																																									BgL_auxz00_3953
																																										=
																																										(obj_t)
																																										(BgL_auxz00_3978);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									obj_t
																																										BgL_carzd21974zd2_1127;
																																									BgL_carzd21974zd2_1127
																																										=
																																										CAR
																																										(BgL_expz00_18);
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_cdrzd21979zd2_1128;
																																										BgL_cdrzd21979zd2_1128
																																											=
																																											CDR
																																											(BgL_carzd21974zd2_1127);
																																										if ((CAR(BgL_carzd21974zd2_1127) == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_arg3456z00_1130;
																																												obj_t
																																													BgL_arg3457z00_1131;
																																												obj_t
																																													BgL_arg3458z00_1132;
																																												BgL_arg3456z00_1130
																																													=
																																													CAR
																																													(BgL_cdrzd21979zd2_1128);
																																												BgL_arg3457z00_1131
																																													=
																																													CDR
																																													(BgL_cdrzd21979zd2_1128);
																																												BgL_arg3458z00_1132
																																													=
																																													CDR
																																													(BgL_expz00_18);
																																												{	/* Ast/sexp.scm 103 */
																																													BgL_nodez00_bglt
																																														BgL_auxz00_3989;
																																													{
																																														obj_t
																																															BgL_argsz00_3992;
																																														obj_t
																																															BgL_bodyz00_3991;
																																														obj_t
																																															BgL_varsz00_3990;
																																														BgL_varsz00_3990
																																															=
																																															BgL_arg3456z00_1130;
																																														BgL_bodyz00_3991
																																															=
																																															BgL_arg3457z00_1131;
																																														BgL_argsz00_3992
																																															=
																																															BgL_arg3458z00_1132;
																																														BgL_argsz00_906
																																															=
																																															BgL_argsz00_3992;
																																														BgL_bodyz00_905
																																															=
																																															BgL_bodyz00_3991;
																																														BgL_varsz00_904
																																															=
																																															BgL_varsz00_3990;
																																														goto
																																															BgL_tagzd21476zd2_907;
																																													}
																																													BgL_auxz00_3953
																																														=
																																														(obj_t)
																																														(BgL_auxz00_3989);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																													{	/* Ast/sexp.scm 103 */
																																														goto
																																															BgL_tagzd21488zd2_923;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														BgL_nodez00_bglt
																																															BgL_auxz00_3996;
																																														goto
																																															BgL_tagzd21489zd2_924;
																																														BgL_auxz00_3953
																																															=
																																															(obj_t)
																																															(BgL_auxz00_3996);
																																													}
																																											}
																																									}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			bool_t
																																				BgL_testz00_3998;
																																			{	/* Ast/sexp.scm 103 */
																																				obj_t
																																					BgL_arg3475z00_1151;
																																				BgL_arg3475z00_1151
																																					=
																																					CAR
																																					(BgL_expz00_18);
																																				BgL_testz00_3998
																																					=
																																					CBOOL
																																					(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_arg3475z00_1151));
																																			}
																																			if (BgL_testz00_3998)
																																				{	/* Ast/sexp.scm 103 */
																																					BgL_nodez00_bglt
																																						BgL_auxz00_4002;
																																					goto
																																						BgL_tagzd21474zd2_902;
																																					BgL_auxz00_3953
																																						=
																																						(obj_t)
																																						(BgL_auxz00_4002);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					bool_t
																																						BgL_testz00_4004;
																																					{	/* Ast/sexp.scm 103 */
																																						obj_t
																																							BgL_arg3474z00_1150;
																																						BgL_arg3474z00_1150
																																							=
																																							CAR
																																							(BgL_expz00_18);
																																						BgL_testz00_4004
																																							=
																																							CBOOL
																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																							(BgL_arg3474z00_1150));
																																					}
																																					if (BgL_testz00_4004)
																																						{	/* Ast/sexp.scm 103 */
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_4008;
																																							goto
																																								BgL_tagzd21475zd2_903;
																																							BgL_auxz00_3953
																																								=
																																								(obj_t)
																																								(BgL_auxz00_4008);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							obj_t
																																								BgL_carzd22026zd2_1141;
																																							BgL_carzd22026zd2_1141
																																								=
																																								CAR
																																								(BgL_expz00_18);
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_cdrzd22031zd2_1142;
																																								BgL_cdrzd22031zd2_1142
																																									=
																																									CDR
																																									(BgL_carzd22026zd2_1141);
																																								if ((CAR(BgL_carzd22026zd2_1141) == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_arg3468z00_1144;
																																										obj_t
																																											BgL_arg3469z00_1145;
																																										obj_t
																																											BgL_arg3470z00_1146;
																																										BgL_arg3468z00_1144
																																											=
																																											CAR
																																											(BgL_cdrzd22031zd2_1142);
																																										BgL_arg3469z00_1145
																																											=
																																											CDR
																																											(BgL_cdrzd22031zd2_1142);
																																										BgL_arg3470z00_1146
																																											=
																																											CDR
																																											(BgL_expz00_18);
																																										{	/* Ast/sexp.scm 103 */
																																											BgL_nodez00_bglt
																																												BgL_auxz00_4019;
																																											{
																																												obj_t
																																													BgL_argsz00_4022;
																																												obj_t
																																													BgL_bodyz00_4021;
																																												obj_t
																																													BgL_varsz00_4020;
																																												BgL_varsz00_4020
																																													=
																																													BgL_arg3468z00_1144;
																																												BgL_bodyz00_4021
																																													=
																																													BgL_arg3469z00_1145;
																																												BgL_argsz00_4022
																																													=
																																													BgL_arg3470z00_1146;
																																												BgL_argsz00_906
																																													=
																																													BgL_argsz00_4022;
																																												BgL_bodyz00_905
																																													=
																																													BgL_bodyz00_4021;
																																												BgL_varsz00_904
																																													=
																																													BgL_varsz00_4020;
																																												goto
																																													BgL_tagzd21476zd2_907;
																																											}
																																											BgL_auxz00_3953
																																												=
																																												(obj_t)
																																												(BgL_auxz00_4019);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 103 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																											{	/* Ast/sexp.scm 103 */
																																												goto
																																													BgL_tagzd21488zd2_923;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												BgL_nodez00_bglt
																																													BgL_auxz00_4026;
																																												goto
																																													BgL_tagzd21489zd2_924;
																																												BgL_auxz00_3953
																																													=
																																													(obj_t)
																																													(BgL_auxz00_4026);
																																											}
																																									}
																																							}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	bool_t
																																		BgL_testz00_4028;
																																	{	/* Ast/sexp.scm 103 */
																																		obj_t
																																			BgL_arg3480z00_1156;
																																		BgL_arg3480z00_1156
																																			=
																																			CAR
																																			(BgL_expz00_18);
																																		BgL_testz00_4028
																																			=
																																			CBOOL
																																			(BGl_letzd2symzf3z21zzast_letz00
																																			(BgL_arg3480z00_1156));
																																	}
																																	if (BgL_testz00_4028)
																																		{	/* Ast/sexp.scm 103 */
																																			BgL_nodez00_bglt
																																				BgL_auxz00_4032;
																																			goto
																																				BgL_tagzd21474zd2_902;
																																			BgL_auxz00_3953
																																				=
																																				(obj_t)
																																				(BgL_auxz00_4032);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			bool_t
																																				BgL_testz00_4034;
																																			{	/* Ast/sexp.scm 103 */
																																				obj_t
																																					BgL_arg3479z00_1155;
																																				BgL_arg3479z00_1155
																																					=
																																					CAR
																																					(BgL_expz00_18);
																																				BgL_testz00_4034
																																					=
																																					CBOOL
																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																					(BgL_arg3479z00_1155));
																																			}
																																			if (BgL_testz00_4034)
																																				{	/* Ast/sexp.scm 103 */
																																					BgL_letzd2funzd2_bglt
																																						BgL_auxz00_4038;
																																					goto
																																						BgL_tagzd21475zd2_903;
																																					BgL_auxz00_3953
																																						=
																																						(obj_t)
																																						(BgL_auxz00_4038);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																						{	/* Ast/sexp.scm 103 */
																																							goto
																																								BgL_tagzd21488zd2_923;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							BgL_nodez00_bglt
																																								BgL_auxz00_4042;
																																							goto
																																								BgL_tagzd21489zd2_924;
																																							BgL_auxz00_3953
																																								=
																																								(obj_t)
																																								(BgL_auxz00_4042);
																																						}
																																				}
																																		}
																																}
																															return
																																(BgL_nodez00_bglt)
																																(BgL_auxz00_3953);
																														}
																													else
																														{	/* Ast/sexp.scm 103 */
																															if (CBOOL
																																(BGl_letzd2symzf3z21zzast_letz00
																																	(BgL_carzd21938zd2_1096)))
																																{	/* Ast/sexp.scm 103 */
																																	obj_t
																																		BgL_auxz00_4048;
																																	goto
																																		BgL_kapzd21940zd2_1098;
																																	return
																																		(BgL_nodez00_bglt)
																																		(BgL_auxz00_4048);
																																}
																															else
																																{	/* Ast/sexp.scm 103 */
																																	if (
																																		(BgL_carzd21938zd2_1096
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					20))))
																																		{	/* Ast/sexp.scm 103 */
																																			obj_t
																																				BgL_auxz00_4053;
																																			goto
																																				BgL_kapzd21940zd2_1098;
																																			return
																																				(BgL_nodez00_bglt)
																																				(BgL_auxz00_4053);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 103 */
																																			if (
																																				(BgL_carzd21938zd2_1096
																																					==
																																					CNST_TABLE_REF
																																					(((long) 21))))
																																				{	/* Ast/sexp.scm 103 */
																																					obj_t
																																						BgL_auxz00_4058;
																																					goto
																																						BgL_kapzd21940zd2_1098;
																																					return
																																						(BgL_nodez00_bglt)
																																						(BgL_auxz00_4058);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 103 */
																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd21938zd2_1096)))
																																						{	/* Ast/sexp.scm 103 */
																																							obj_t
																																								BgL_auxz00_4063;
																																							goto
																																								BgL_kapzd21940zd2_1098;
																																							return
																																								(BgL_nodez00_bglt)
																																								(BgL_auxz00_4063);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 103 */
																																							bool_t
																																								BgL_testz00_4065;
																																							{	/* Ast/sexp.scm 103 */
																																								obj_t
																																									BgL_arg3447z00_1118;
																																								BgL_arg3447z00_1118
																																									=
																																									CAR
																																									(BgL_expz00_18);
																																								BgL_testz00_4065
																																									=
																																									CBOOL
																																									(BGl_letzd2symzf3z21zzast_letz00
																																									(BgL_arg3447z00_1118));
																																							}
																																							if (BgL_testz00_4065)
																																								{	/* Ast/sexp.scm 103 */
																																									goto
																																										BgL_tagzd21474zd2_902;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 103 */
																																									bool_t
																																										BgL_testz00_4069;
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_arg3445z00_1117;
																																										BgL_arg3445z00_1117
																																											=
																																											CAR
																																											(BgL_expz00_18);
																																										BgL_testz00_4069
																																											=
																																											CBOOL
																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																											(BgL_arg3445z00_1117));
																																									}
																																									if (BgL_testz00_4069)
																																										{	/* Ast/sexp.scm 103 */
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_4073;
																																											goto
																																												BgL_tagzd21475zd2_903;
																																											return
																																												(BgL_nodez00_bglt)
																																												(BgL_auxz00_4073);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 103 */
																																											obj_t
																																												BgL_carzd22120zd2_1106;
																																											BgL_carzd22120zd2_1106
																																												=
																																												CAR
																																												(BgL_expz00_18);
																																											{	/* Ast/sexp.scm 103 */
																																												obj_t
																																													BgL_cdrzd22125zd2_1107;
																																												BgL_cdrzd22125zd2_1107
																																													=
																																													CDR
																																													(BgL_carzd22120zd2_1106);
																																												if ((CAR(BgL_carzd22120zd2_1106) == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 103 */
																																														if (PAIRP(BgL_cdrzd22125zd2_1107))
																																															{
																																																obj_t
																																																	BgL_argsz00_4087;
																																																obj_t
																																																	BgL_bodyz00_4085;
																																																obj_t
																																																	BgL_varsz00_4083;
																																																BgL_varsz00_4083
																																																	=
																																																	CAR
																																																	(BgL_cdrzd22125zd2_1107);
																																																BgL_bodyz00_4085
																																																	=
																																																	CDR
																																																	(BgL_cdrzd22125zd2_1107);
																																																BgL_argsz00_4087
																																																	=
																																																	CDR
																																																	(BgL_expz00_18);
																																																BgL_argsz00_906
																																																	=
																																																	BgL_argsz00_4087;
																																																BgL_bodyz00_905
																																																	=
																																																	BgL_bodyz00_4085;
																																																BgL_varsz00_904
																																																	=
																																																	BgL_varsz00_4083;
																																																goto
																																																	BgL_tagzd21476zd2_907;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																	{	/* Ast/sexp.scm 103 */
																																																		obj_t
																																																			BgL_auxz00_4091;
																																																		goto
																																																			BgL_tagzd21488zd2_923;
																																																		return
																																																			(BgL_nodez00_bglt)
																																																			(BgL_auxz00_4091);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		goto
																																																			BgL_tagzd21489zd2_924;
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																															{	/* Ast/sexp.scm 103 */
																																																obj_t
																																																	BgL_auxz00_4095;
																																																goto
																																																	BgL_tagzd21488zd2_923;
																																																return
																																																	(BgL_nodez00_bglt)
																																																	(BgL_auxz00_4095);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																goto
																																																	BgL_tagzd21489zd2_924;
																																															}
																																													}
																																											}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											}
																										else
																											{	/* Ast/sexp.scm 103 */
																												if (
																													(BgL_carzd21935zd2_1094
																														==
																														CNST_TABLE_REF((
																																(long) 19))))
																													{	/* Ast/sexp.scm 103 */
																														goto
																															BgL_tagzd21474zd2_902;
																													}
																												else
																													{	/* Ast/sexp.scm 103 */
																														if (CBOOL
																															(BGl_letzd2symzf3z21zzast_letz00
																																(BgL_carzd21935zd2_1094)))
																															{	/* Ast/sexp.scm 103 */
																																goto
																																	BgL_tagzd21474zd2_902;
																															}
																														else
																															{	/* Ast/sexp.scm 103 */
																																if (
																																	(BgL_carzd21935zd2_1094
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				20))))
																																	{	/* Ast/sexp.scm 103 */
																																		goto
																																			BgL_tagzd21474zd2_902;
																																	}
																																else
																																	{	/* Ast/sexp.scm 103 */
																																		obj_t
																																			BgL_carzd22175zd2_1161;
																																		BgL_carzd22175zd2_1161
																																			=
																																			CAR
																																			(BgL_expz00_18);
																																		if (
																																			(BgL_carzd22175zd2_1161
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						21))))
																																			{	/* Ast/sexp.scm 103 */
																																				BgL_letzd2funzd2_bglt
																																					BgL_auxz00_4110;
																																				goto
																																					BgL_tagzd21475zd2_903;
																																				return
																																					(BgL_nodez00_bglt)
																																					(BgL_auxz00_4110);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 103 */
																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd22175zd2_1161)))
																																					{	/* Ast/sexp.scm 103 */
																																						BgL_letzd2funzd2_bglt
																																							BgL_auxz00_4115;
																																						goto
																																							BgL_tagzd21475zd2_903;
																																						return
																																							(BgL_nodez00_bglt)
																																							(BgL_auxz00_4115);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 103 */
																																						if (
																																							(CAR
																																								(BgL_expz00_18)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{	/* Ast/sexp.scm 103 */
																																								goto
																																									BgL_tagzd21477zd2_908;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 103 */
																																								if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 4))))
																																									{	/* Ast/sexp.scm 103 */
																																										goto
																																											BgL_tagzd21478zd2_909;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 103 */
																																										obj_t
																																											BgL_cdrzd22199zd2_1166;
																																										BgL_cdrzd22199zd2_1166
																																											=
																																											CDR
																																											(BgL_expz00_18);
																																										if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 22))))
																																											{	/* Ast/sexp.scm 103 */
																																												if (PAIRP(BgL_cdrzd22199zd2_1166))
																																													{
																																														obj_t
																																															BgL_restz00_4134;
																																														obj_t
																																															BgL_effectz00_4132;
																																														BgL_effectz00_4132
																																															=
																																															CAR
																																															(BgL_cdrzd22199zd2_1166);
																																														BgL_restz00_4134
																																															=
																																															CDR
																																															(BgL_cdrzd22199zd2_1166);
																																														BgL_restz00_911
																																															=
																																															BgL_restz00_4134;
																																														BgL_effectz00_910
																																															=
																																															BgL_effectz00_4132;
																																														goto
																																															BgL_tagzd21479zd2_912;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																															{	/* Ast/sexp.scm 103 */
																																																obj_t
																																																	BgL_auxz00_4138;
																																																goto
																																																	BgL_tagzd21488zd2_923;
																																																return
																																																	(BgL_nodez00_bglt)
																																																	(BgL_auxz00_4138);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																goto
																																																	BgL_tagzd21489zd2_924;
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 103 */
																																												if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 23))))
																																													{	/* Ast/sexp.scm 103 */
																																														goto
																																															BgL_tagzd21480zd2_913;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 103 */
																																														if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 24))))
																																															{	/* Ast/sexp.scm 103 */
																																																if (PAIRP(BgL_cdrzd22199zd2_1166))
																																																	{
																																																		obj_t
																																																			BgL_restz00_4152;
																																																		obj_t
																																																			BgL_effectz00_4150;
																																																		BgL_effectz00_4150
																																																			=
																																																			CAR
																																																			(BgL_cdrzd22199zd2_1166);
																																																		BgL_restz00_4152
																																																			=
																																																			CDR
																																																			(BgL_cdrzd22199zd2_1166);
																																																		BgL_restz00_915
																																																			=
																																																			BgL_restz00_4152;
																																																		BgL_effectz00_914
																																																			=
																																																			BgL_effectz00_4150;
																																																		goto
																																																			BgL_tagzd21481zd2_916;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																			{	/* Ast/sexp.scm 103 */
																																																				obj_t
																																																					BgL_auxz00_4156;
																																																				goto
																																																					BgL_tagzd21488zd2_923;
																																																				return
																																																					(BgL_nodez00_bglt)
																																																					(BgL_auxz00_4156);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 103 */
																																																				goto
																																																					BgL_tagzd21489zd2_924;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 103 */
																																																if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 25))))
																																																	{	/* Ast/sexp.scm 103 */
																																																		obj_t
																																																			BgL_auxz00_4162;
																																																		goto
																																																			BgL_tagzd21482zd2_917;
																																																		return
																																																			(BgL_nodez00_bglt)
																																																			(BgL_auxz00_4162);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 103 */
																																																		if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 26))))
																																																			{	/* Ast/sexp.scm 103 */
																																																				obj_t
																																																					BgL_auxz00_4168;
																																																				goto
																																																					BgL_tagzd21483zd2_918;
																																																				return
																																																					(BgL_nodez00_bglt)
																																																					(BgL_auxz00_4168);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 103 */
																																																				if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 27))))
																																																					{	/* Ast/sexp.scm 103 */
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_4174;
																																																						goto
																																																							BgL_tagzd21484zd2_919;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_4174);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 103 */
																																																						if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 28))))
																																																							{	/* Ast/sexp.scm 103 */
																																																								BgL_jumpzd2exzd2itz00_bglt
																																																									BgL_auxz00_4180;
																																																								goto
																																																									BgL_tagzd21485zd2_920;
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_4180);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 103 */
																																																								obj_t
																																																									BgL_cdrzd22237zd2_1183;
																																																								BgL_cdrzd22237zd2_1183
																																																									=
																																																									CDR
																																																									(BgL_expz00_18);
																																																								if ((CAR(BgL_expz00_18) == CNST_TABLE_REF(((long) 14))))
																																																									{	/* Ast/sexp.scm 103 */
																																																										if (PAIRP(BgL_cdrzd22237zd2_1183))
																																																											{	/* Ast/sexp.scm 103 */
																																																												obj_t
																																																													BgL_cdrzd22239zd2_1186;
																																																												BgL_cdrzd22239zd2_1186
																																																													=
																																																													CDR
																																																													(BgL_cdrzd22237zd2_1183);
																																																												if (PAIRP(BgL_cdrzd22239zd2_1186))
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (NULLP(CDR(BgL_cdrzd22239zd2_1186)))
																																																															{	/* Ast/sexp.scm 103 */
																																																																goto
																																																																	BgL_tagzd21486zd2_921;
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		obj_t
																																																																			BgL_auxz00_4197;
																																																																		goto
																																																																			BgL_tagzd21488zd2_923;
																																																																		return
																																																																			(BgL_nodez00_bglt)
																																																																			(BgL_auxz00_4197);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 103 */
																																																																		goto
																																																																			BgL_tagzd21489zd2_924;
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																															{	/* Ast/sexp.scm 103 */
																																																																obj_t
																																																																	BgL_auxz00_4201;
																																																																goto
																																																																	BgL_tagzd21488zd2_923;
																																																																return
																																																																	(BgL_nodez00_bglt)
																																																																	(BgL_auxz00_4201);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																goto
																																																																	BgL_tagzd21489zd2_924;
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 103 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																													{	/* Ast/sexp.scm 103 */
																																																														obj_t
																																																															BgL_auxz00_4205;
																																																														goto
																																																															BgL_tagzd21488zd2_923;
																																																														return
																																																															(BgL_nodez00_bglt)
																																																															(BgL_auxz00_4205);
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														goto
																																																															BgL_tagzd21489zd2_924;
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 103 */
																																																										if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_18), BUNSPEC))
																																																											{	/* Ast/sexp.scm 103 */
																																																												if (NULLP(BgL_cdrzd22237zd2_1183))
																																																													{	/* Ast/sexp.scm 103 */
																																																														goto
																																																															BgL_tagzd21487zd2_922;
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																															{	/* Ast/sexp.scm 103 */
																																																																obj_t
																																																																	BgL_auxz00_4214;
																																																																goto
																																																																	BgL_tagzd21488zd2_923;
																																																																return
																																																																	(BgL_nodez00_bglt)
																																																																	(BgL_auxz00_4214);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 103 */
																																																																goto
																																																																	BgL_tagzd21489zd2_924;
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 103 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_18))
																																																													{	/* Ast/sexp.scm 103 */
																																																														obj_t
																																																															BgL_auxz00_4218;
																																																														goto
																																																															BgL_tagzd21488zd2_923;
																																																														return
																																																															(BgL_nodez00_bglt)
																																																															(BgL_auxz00_4218);
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 103 */
																																																														goto
																																																															BgL_tagzd21489zd2_924;
																																																													}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 103 */
										obj_t BgL_auxz00_4220;

										BgL_atomz00_888 = BgL_expz00_18;
										if (SYMBOLP(BgL_atomz00_888))
											{	/* Ast/sexp.scm 113 */
												if (CBOOL(BGl_lookupz00zzast_sexpz00(BgL_atomz00_888,
															BgL_stackz00_19)))
													{	/* Ast/sexp.scm 136 */
														obj_t BgL_localz00_1232;

														BgL_localz00_1232 =
															BGl_lookupz00zzast_sexpz00(BgL_atomz00_888,
															BgL_stackz00_19);
														{	/* Ast/sexp.scm 136 */
															obj_t BgL_varz00_1233;

															{	/* Ast/sexp.scm 137 */
																bool_t BgL_testz00_4227;

																if (
																	(BgL_sitez00_21 ==
																		CNST_TABLE_REF(((long) 11))))
																	{	/* Ast/sexp.scm 137 */
																		BgL_testz00_4227 = ((bool_t) 0);
																	}
																else
																	{	/* Ast/sexp.scm 138 */
																		BgL_valuez00_bglt BgL_arg3555z00_1238;

																		{
																			BgL_variablez00_bglt BgL_auxz00_4231;

																			BgL_auxz00_4231 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1232);
																			BgL_arg3555z00_1238 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_4231))->BgL_valuez00);
																		}
																		{	/* Ast/sexp.scm 138 */
																			obj_t BgL_obj1844z00_2461;

																			BgL_obj1844z00_2461 =
																				(obj_t) (BgL_arg3555z00_1238);
																			BgL_testz00_4227 =
																				BGl_iszd2azf3z21zz__objectz00
																				(BgL_obj1844z00_2461,
																				BGl_funz00zzast_varz00);
																		}
																	}
																if (BgL_testz00_4227)
																	{	/* Ast/sexp.scm 141 */
																		BgL_typez00_bglt BgL_arg3552z00_1235;

																		{
																			BgL_variablez00_bglt BgL_auxz00_4236;

																			BgL_auxz00_4236 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1232);
																			BgL_arg3552z00_1235 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_4236))->BgL_typez00);
																		}
																		BgL_varz00_1233 =
																			(obj_t)
																			(BGl_makezd2closurezd2zzast_nodez00
																			(BgL_locz00_20, BgL_arg3552z00_1235,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1232)));
																	}
																else
																	{	/* Ast/sexp.scm 145 */
																		BgL_typez00_bglt BgL_arg3553z00_1236;

																		{
																			BgL_variablez00_bglt BgL_auxz00_4242;

																			BgL_auxz00_4242 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1232);
																			BgL_arg3553z00_1236 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_4242))->BgL_typez00);
																		}
																		BgL_varz00_1233 =
																			(obj_t) (BGl_makezd2varzd2zzast_nodez00
																			(BgL_locz00_20, BgL_arg3553z00_1236,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1232)));
																	}
															}
															{	/* Ast/sexp.scm 137 */

																BGl_usezd2variablez12zc0zzast_sexpz00(
																	(BgL_variablez00_bglt) (BgL_localz00_1232),
																	BgL_locz00_20, BgL_sitez00_21);
																BgL_auxz00_4220 = BgL_varz00_1233;
															}
														}
													}
												else
													{	/* Ast/sexp.scm 150 */
														obj_t BgL_globalz00_1239;

														BgL_globalz00_1239 =
															BGl_findzd2globalzd2zzast_envz00(BgL_atomz00_888,
															BNIL);
														if (BGl_iszd2azf3z21zz__objectz00
															(BgL_globalz00_1239, BGl_globalz00zzast_varz00))
															{	/* Ast/sexp.scm 154 */
																bool_t BgL_testz00_4253;

																{	/* Ast/sexp.scm 154 */
																	obj_t BgL_auxz00_4254;

																	{
																		BgL_globalz00_bglt BgL_auxz00_4255;

																		BgL_auxz00_4255 =
																			(BgL_globalz00_bglt) (BgL_globalz00_1239);
																		BgL_auxz00_4254 =
																			(((BgL_globalz00_bglt)
																				CREF(BgL_auxz00_4255))->BgL_importz00);
																	}
																	BgL_testz00_4253 =
																		(BgL_auxz00_4254 ==
																		CNST_TABLE_REF(((long) 10)));
																}
																if (BgL_testz00_4253)
																	{	/* Ast/sexp.scm 155 */
																		obj_t BgL_arg3558z00_1242;

																		{	/* Ast/sexp.scm 155 */
																			obj_t BgL_arg3559z00_1243;

																			obj_t BgL_arg3560z00_1244;

																			BgL_arg3559z00_1243 =
																				CNST_TABLE_REF(((long) 10));
																			{	/* Ast/sexp.scm 155 */
																				obj_t BgL_arg3561z00_1245;

																				{	/* Ast/sexp.scm 155 */
																					obj_t BgL_arg3564z00_1248;

																					obj_t BgL_arg3565z00_1249;

																					BgL_arg3564z00_1248 =
																						CNST_TABLE_REF(((long) 13));
																					{	/* Ast/sexp.scm 155 */
																						obj_t BgL_list3566z00_1250;

																						BgL_list3566z00_1250 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3565z00_1249 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_atomz00_888,
																							BgL_list3566z00_1250);
																					}
																					BgL_arg3561z00_1245 =
																						MAKE_PAIR(BgL_arg3564z00_1248,
																						BgL_arg3565z00_1249);
																				}
																				{	/* Ast/sexp.scm 155 */
																					obj_t BgL_list3563z00_1247;

																					BgL_list3563z00_1247 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3560z00_1244 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3561z00_1245,
																						BgL_list3563z00_1247);
																			}}
																			BgL_arg3558z00_1242 =
																				MAKE_PAIR(BgL_arg3559z00_1243,
																				BgL_arg3560z00_1244);
																		}
																		BgL_auxz00_4220 =
																			(obj_t)
																			(BGl_sexpzd2ze3nodez31zzast_sexpz00
																			(BgL_arg3558z00_1242, BgL_stackz00_19,
																				BgL_locz00_20, BgL_sitez00_21));
																	}
																else
																	{	/* Ast/sexp.scm 154 */
																		BGl_usezd2variablez12zc0zzast_sexpz00(
																			(BgL_variablez00_bglt)
																			(BgL_globalz00_1239), BgL_locz00_20,
																			BgL_sitez00_21);
																		{	/* Ast/sexp.scm 158 */
																			bool_t BgL_testz00_4272;

																			if (
																				(BgL_sitez00_21 ==
																					CNST_TABLE_REF(((long) 11))))
																				{	/* Ast/sexp.scm 158 */
																					BgL_testz00_4272 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/sexp.scm 158 */
																					BgL_valuez00_bglt BgL_arg3584z00_1266;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_4276;
																						BgL_auxz00_4276 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1239);
																						BgL_arg3584z00_1266 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_4276))->
																							BgL_valuez00);
																					}
																					{	/* Ast/sexp.scm 158 */
																						obj_t BgL_obj1844z00_2467;

																						BgL_obj1844z00_2467 =
																							(obj_t) (BgL_arg3584z00_1266);
																						BgL_testz00_4272 =
																							BGl_iszd2azf3z21zz__objectz00
																							(BgL_obj1844z00_2467,
																							BGl_funz00zzast_varz00);
																					}
																				}
																			if (BgL_testz00_4272)
																				{	/* Ast/sexp.scm 159 */
																					bool_t BgL_testz00_4281;

																					{	/* Ast/sexp.scm 159 */
																						bool_t BgL_testz00_4282;

																						{	/* Ast/sexp.scm 159 */
																							BgL_valuez00_bglt
																								BgL_arg3581z00_1263;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_4283;
																								BgL_auxz00_4283 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1239);
																								BgL_arg3581z00_1263 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_4283))->
																									BgL_valuez00);
																							}
																							{	/* Ast/sexp.scm 159 */
																								obj_t BgL_obj2006z00_2469;

																								BgL_obj2006z00_2469 =
																									(obj_t) (BgL_arg3581z00_1263);
																								BgL_testz00_4282 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj2006z00_2469,
																									BGl_cfunz00zzast_varz00);
																							}
																						}
																						if (BgL_testz00_4282)
																							{	/* Ast/sexp.scm 160 */
																								bool_t BgL_testz00_4288;

																								{	/* Ast/sexp.scm 160 */
																									obj_t BgL_arg3579z00_1262;

																									BgL_arg3579z00_1262 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_4290;
																										BgL_auxz00_4290 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3579z00_1262);
																										BgL_testz00_4288 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_4290))->
																											BgL_foreignzd2closurezd2);
																									}
																								}
																								if (BgL_testz00_4288)
																									{	/* Ast/sexp.scm 160 */
																										BgL_testz00_4281 =
																											((bool_t) 0);
																									}
																								else
																									{	/* Ast/sexp.scm 160 */
																										if (
																											(BgL_sitez00_21 ==
																												CNST_TABLE_REF(((long)
																														14))))
																											{	/* Ast/sexp.scm 161 */
																												BgL_testz00_4281 =
																													((bool_t) 0);
																											}
																										else
																											{	/* Ast/sexp.scm 161 */
																												BgL_testz00_4281 =
																													((bool_t) 1);
																											}
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 159 */
																								BgL_testz00_4281 = ((bool_t) 0);
																							}
																					}
																					if (BgL_testz00_4281)
																						{	/* Ast/sexp.scm 163 */
																							obj_t BgL_arg3569z00_1253;

																							{	/* Ast/sexp.scm 163 */
																								obj_t BgL_arg3571z00_1255;

																								{	/* Ast/sexp.scm 163 */
																									obj_t BgL_arg3573z00_1257;

																									BgL_arg3573z00_1257 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_4297;
																										BgL_auxz00_4297 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3573z00_1257);
																										BgL_arg3571z00_1255 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_4297))->
																											BgL_namez00);
																									}
																								}
																								{	/* Ast/sexp.scm 163 */
																									obj_t BgL_list3572z00_1256;

																									BgL_list3572z00_1256 =
																										MAKE_PAIR
																										(BgL_arg3571z00_1255, BNIL);
																									BgL_arg3569z00_1253 =
																										BGl_formatz00zz__r4_output_6_10_3z00
																										(BGl_string4135z00zzast_sexpz00,
																										BgL_list3572z00_1256);
																								}
																							}
																							BgL_auxz00_4220 =
																								(obj_t)
																								(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																								(BgL_arg3569z00_1253,
																									BgL_expz00_18,
																									BgL_locz00_20));
																						}
																					else
																						{	/* Ast/sexp.scm 167 */
																							BgL_typez00_bglt
																								BgL_arg3575z00_1258;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_4304;
																								BgL_auxz00_4304 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1239);
																								BgL_arg3575z00_1258 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_4304))->
																									BgL_typez00);
																							}
																							BgL_auxz00_4220 =
																								(obj_t)
																								(BGl_makezd2closurezd2zzast_nodez00
																								(BgL_locz00_20,
																									BgL_arg3575z00_1258,
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1239)));
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 171 */
																					BgL_typez00_bglt BgL_arg3582z00_1264;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_4310;
																						BgL_auxz00_4310 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1239);
																						BgL_arg3582z00_1264 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_4310))->
																							BgL_typez00);
																					}
																					BgL_auxz00_4220 =
																						(obj_t)
																						(BGl_makezd2varzd2zzast_nodez00
																						(BgL_locz00_20, BgL_arg3582z00_1264,
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1239)));
																				}
																		}
																	}
															}
														else
															{	/* Ast/sexp.scm 152 */
																BgL_auxz00_4220 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string4134z00zzast_sexpz00,
																		BgL_expz00_18, BgL_locz00_20));
															}
													}
											}
										else
											{	/* Ast/sexp.scm 115 */
												bool_t BgL_testz00_4318;

												if (BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_888,
														BGl_localz00zzast_varz00))
													{	/* Ast/sexp.scm 115 */
														BgL_testz00_4318 = ((bool_t) 1);
													}
												else
													{	/* Ast/sexp.scm 115 */
														BgL_testz00_4318 =
															BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_888,
															BGl_globalz00zzast_varz00);
													}
												if (BgL_testz00_4318)
													{	/* Ast/sexp.scm 115 */
														BGl_usezd2variablez12zc0zzast_sexpz00(
															(BgL_variablez00_bglt) (BgL_atomz00_888),
															BgL_locz00_20, BgL_sitez00_21);
														{	/* Ast/sexp.scm 117 */
															bool_t BgL_testz00_4324;

															if (
																(BgL_sitez00_21 == CNST_TABLE_REF(((long) 11))))
																{	/* Ast/sexp.scm 117 */
																	BgL_testz00_4324 = ((bool_t) 0);
																}
															else
																{	/* Ast/sexp.scm 117 */
																	BgL_valuez00_bglt BgL_arg3593z00_1275;

																	{
																		BgL_variablez00_bglt BgL_auxz00_4328;

																		BgL_auxz00_4328 =
																			(BgL_variablez00_bglt) (BgL_atomz00_888);
																		BgL_arg3593z00_1275 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_4328))->BgL_valuez00);
																	}
																	{	/* Ast/sexp.scm 117 */
																		obj_t BgL_obj1844z00_2477;

																		BgL_obj1844z00_2477 =
																			(obj_t) (BgL_arg3593z00_1275);
																		BgL_testz00_4324 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1844z00_2477,
																			BGl_funz00zzast_varz00);
																	}
																}
															if (BgL_testz00_4324)
																{	/* Ast/sexp.scm 120 */
																	BgL_typez00_bglt BgL_arg3590z00_1272;

																	{
																		BgL_variablez00_bglt BgL_auxz00_4333;

																		BgL_auxz00_4333 =
																			(BgL_variablez00_bglt) (BgL_atomz00_888);
																		BgL_arg3590z00_1272 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_4333))->BgL_typez00);
																	}
																	BgL_auxz00_4220 =
																		(obj_t) (BGl_makezd2closurezd2zzast_nodez00
																		(BgL_locz00_20, BgL_arg3590z00_1272,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_888)));
																}
															else
																{	/* Ast/sexp.scm 124 */
																	BgL_typez00_bglt BgL_arg3591z00_1273;

																	{
																		BgL_variablez00_bglt BgL_auxz00_4339;

																		BgL_auxz00_4339 =
																			(BgL_variablez00_bglt) (BgL_atomz00_888);
																		BgL_arg3591z00_1273 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_4339))->BgL_typez00);
																	}
																	BgL_auxz00_4220 =
																		(obj_t) (BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_20, BgL_arg3591z00_1273,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_888)));
																}
														}
													}
												else
													{	/* Ast/sexp.scm 126 */
														bool_t BgL_testz00_4345;

														if (STRUCTP(BgL_atomz00_888))
															{	/* Ast/sexp.scm 126 */
																BgL_testz00_4345 = ((bool_t) 1);
															}
														else
															{	/* Ast/sexp.scm 126 */
																if (VECTORP(BgL_atomz00_888))
																	{	/* Ast/sexp.scm 127 */
																		BgL_testz00_4345 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/sexp.scm 127 */
																		BgL_testz00_4345 =
																			BGL_OBJECTP(BgL_atomz00_888);
																	}
															}
														if (BgL_testz00_4345)
															{	/* Ast/sexp.scm 126 */
																BgL_auxz00_4220 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string4136z00zzast_sexpz00,
																		BgL_expz00_18, BgL_locz00_20));
															}
														else
															{	/* Ast/sexp.scm 133 */
																BgL_typez00_bglt BgL_arg3595z00_1277;

																BgL_arg3595z00_1277 =
																	BGl_typeofzd2atomzd2zztype_typeofz00
																	(BgL_atomz00_888);
																BgL_auxz00_4220 =
																	(obj_t) (BGl_makezd2atomzd2zzast_nodez00
																	(BgL_locz00_20, BgL_arg3595z00_1277,
																		BgL_atomz00_888));
															}
													}
											}
										return (BgL_nodez00_bglt) (BgL_auxz00_4220);
									}
							}
					}
			}
		}
	}



/* liip */
	obj_t BGl_liipz00zzast_sexpz00(obj_t BgL_argsz00_1569)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 379 */
			if (NULLP(BgL_argsz00_1569))
				{	/* Ast/sexp.scm 380 */
					return CNST_TABLE_REF(((long) 29));
				}
			else
				{	/* Ast/sexp.scm 382 */
					obj_t BgL_arg3798z00_1572;

					obj_t BgL_arg3799z00_1573;

					BgL_arg3798z00_1572 = CNST_TABLE_REF(((long) 30));
					{	/* Ast/sexp.scm 382 */
						obj_t BgL_arg3800z00_1574;

						obj_t BgL_arg3801z00_1575;

						BgL_arg3800z00_1574 = CAR(BgL_argsz00_1569);
						BgL_arg3801z00_1575 =
							BGl_liipz00zzast_sexpz00(CDR(BgL_argsz00_1569));
						{	/* Ast/sexp.scm 382 */
							obj_t BgL_list3804z00_1577;

							{	/* Ast/sexp.scm 382 */
								obj_t BgL_arg3805z00_1578;

								BgL_arg3805z00_1578 = MAKE_PAIR(BNIL, BNIL);
								BgL_list3804z00_1577 =
									MAKE_PAIR(BgL_arg3801z00_1575, BgL_arg3805z00_1578);
							}
							BgL_arg3799z00_1573 =
								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg3800z00_1574,
								BgL_list3804z00_1577);
					}}
					return MAKE_PAIR(BgL_arg3798z00_1572, BgL_arg3799z00_1573);
				}
		}
	}



/* loop */
	obj_t BGl_loopz00zzast_sexpz00(obj_t BgL_expz00_2882, obj_t BgL_locz00_2881,
		obj_t BgL_varsz00_1530, obj_t BgL_argsz00_1531)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 364 */
		BGl_loopz00zzast_sexpz00:
			if (NULLP(BgL_varsz00_1530))
				{	/* Ast/sexp.scm 367 */
					if (NULLP(BgL_argsz00_1531))
						{	/* Ast/sexp.scm 368 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 368 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2881,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string4138z00zzast_sexpz00, BgL_expz00_2882, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 367 */
					if (PAIRP(BgL_varsz00_1530))
						{	/* Ast/sexp.scm 375 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(CAR
									(BgL_varsz00_1530)))
								{	/* Ast/sexp.scm 385 */
									obj_t BgL_argz00_1541;

									BgL_argz00_1541 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_1530));
									if (CBOOL(BgL_argz00_1541))
										{
											obj_t BgL_varsz00_4384;

											BgL_varsz00_4384 = BgL_argz00_1541;
											BgL_varsz00_1530 = BgL_varsz00_4384;
											goto BGl_loopz00zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_4385;

											BgL_varsz00_4385 = BNIL;
											BgL_varsz00_1530 = BgL_varsz00_4385;
											goto BGl_loopz00zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 390 */
									bool_t BgL_testz00_4386;

									{	/* Ast/sexp.scm 390 */
										obj_t BgL_auxz00_4387;

										BgL_auxz00_4387 = CAR(BgL_varsz00_1530);
										BgL_testz00_4386 = SYMBOLP(BgL_auxz00_4387);
									}
									if (BgL_testz00_4386)
										{	/* Ast/sexp.scm 390 */
											if (NULLP(BgL_argsz00_1531))
												{	/* Ast/sexp.scm 396 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_2881,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string4138z00zzast_sexpz00, BgL_expz00_2882,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 403 */
													obj_t BgL_arg3777z00_1549;

													obj_t BgL_arg3778z00_1550;

													{	/* Ast/sexp.scm 403 */
														obj_t BgL_arg3779z00_1551;

														obj_t BgL_arg3780z00_1552;

														BgL_arg3779z00_1551 = CAR(BgL_varsz00_1530);
														BgL_arg3780z00_1552 = CAR(BgL_argsz00_1531);
														{	/* Ast/sexp.scm 403 */
															obj_t BgL_list3781z00_1553;

															{	/* Ast/sexp.scm 403 */
																obj_t BgL_arg3782z00_1554;

																BgL_arg3782z00_1554 =
																	MAKE_PAIR(BgL_arg3780z00_1552, BNIL);
																BgL_list3781z00_1553 =
																	MAKE_PAIR(BgL_arg3779z00_1551,
																	BgL_arg3782z00_1554);
															}
															BgL_arg3777z00_1549 = BgL_list3781z00_1553;
														}
													}
													BgL_arg3778z00_1550 =
														BGl_loopz00zzast_sexpz00(BgL_expz00_2882,
														BgL_locz00_2881, CDR(BgL_varsz00_1530),
														CDR(BgL_argsz00_1531));
													return MAKE_PAIR(BgL_arg3777z00_1549,
														BgL_arg3778z00_1550);
												}
										}
									else
										{	/* Ast/sexp.scm 390 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_2881,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string4139z00zzast_sexpz00, BgL_expz00_2882, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 380 */
							obj_t BgL_arg3791z00_1563;

							{	/* Ast/sexp.scm 380 */
								obj_t BgL_arg3793z00_1565;

								BgL_arg3793z00_1565 =
									BGl_liipz00zzast_sexpz00(BgL_argsz00_1531);
								{	/* Ast/sexp.scm 377 */
									obj_t BgL_list3794z00_1566;

									{	/* Ast/sexp.scm 377 */
										obj_t BgL_arg3795z00_1567;

										BgL_arg3795z00_1567 = MAKE_PAIR(BgL_arg3793z00_1565, BNIL);
										BgL_list3794z00_1566 =
											MAKE_PAIR(BgL_varsz00_1530, BgL_arg3795z00_1567);
									}
									BgL_arg3791z00_1563 = BgL_list3794z00_1566;
								}
							}
							{	/* Ast/sexp.scm 376 */
								obj_t BgL_list3792z00_1564;

								BgL_list3792z00_1564 = MAKE_PAIR(BgL_arg3791z00_1563, BNIL);
								return BgL_list3792z00_1564;
							}
						}
				}
		}
	}



/* _sexp->node */
	obj_t BGl__sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2848,
		obj_t BgL_expz00_2849, obj_t BgL_stackz00_2850, obj_t BgL_locz00_2851,
		obj_t BgL_sitez00_2852)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 98 */
			return
				(obj_t) (BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2849,
					BgL_stackz00_2850, BgL_locz00_2851, BgL_sitez00_2852));
		}
	}



/* <anonymous:3811> */
	obj_t BGl_zc3anonymousza33811ze3z83zzast_sexpz00(obj_t BgL_envz00_2853,
		obj_t BgL_objz00_2855, obj_t BgL_procz00_2856, obj_t BgL_msgz00_2857)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 409 */
			{	/* Ast/sexp.scm 410 */
				obj_t BgL_locz00_2854;

				BgL_locz00_2854 = PROCEDURE_REF(BgL_envz00_2853, (int) (((long) 0)));
				{
					obj_t BgL_objz00_1586;

					obj_t BgL_procz00_1587;

					obj_t BgL_msgz00_1588;

					BgL_objz00_1586 = BgL_objz00_2855;
					BgL_procz00_1587 = BgL_procz00_2856;
					BgL_msgz00_1588 = BgL_msgz00_2857;
					return
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2854,
						BgL_objz00_1586, BgL_procz00_1587, BgL_msgz00_1588, BNIL);
				}
			}
		}
	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_22,
		obj_t BgL_stackz00_23, obj_t BgL_locz00_24, obj_t BgL_sitez00_25)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 538 */
			{	/* Ast/sexp.scm 539 */
				obj_t BgL_callerz00_1716;

				obj_t BgL_locz00_1717;

				BgL_callerz00_1716 = CAR(BgL_expz00_22);
				BgL_locz00_1717 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_22,
					BgL_locz00_24);
				if (SYMBOLP(BgL_callerz00_1716))
					{	/* Ast/sexp.scm 543 */
						obj_t BgL_pidz00_1719;

						BgL_pidz00_1719 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_1716,
							BgL_locz00_1717);
						{	/* Ast/sexp.scm 543 */
							obj_t BgL_idz00_1720;

							BgL_idz00_1720 = CAR(BgL_pidz00_1719);
							{	/* Ast/sexp.scm 544 */
								obj_t BgL_typez00_1721;

								BgL_typez00_1721 = CDR(BgL_pidz00_1719);
								{	/* Ast/sexp.scm 545 */

									if ((BgL_idz00_1720 == CNST_TABLE_REF(((long) 4))))
										{	/* Ast/sexp.scm 546 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, (BgL_typez00_bglt) (BgL_typez00_1721),
												BgL_expz00_22, BgL_stackz00_23, BgL_locz00_1717,
												BgL_sitez00_25);
										}
									else
										{	/* Ast/sexp.scm 546 */
											if ((BgL_idz00_1720 == CNST_TABLE_REF(((long) 22))))
												{	/* Ast/sexp.scm 550 */
													bool_t BgL_testz00_4430;

													{	/* Ast/sexp.scm 550 */
														obj_t BgL_auxz00_4431;

														BgL_auxz00_4431 = CDR(BgL_expz00_22);
														BgL_testz00_4430 = PAIRP(BgL_auxz00_4431);
													}
													if (BgL_testz00_4430)
														{	/* Ast/sexp.scm 554 */
															BgL_feffectz00_bglt BgL_arg3900z00_1726;

															obj_t BgL_arg3901z00_1727;

															{	/* Ast/sexp.scm 554 */
																obj_t BgL_arg3902z00_1728;

																{	/* Ast/sexp.scm 554 */
																	obj_t BgL_pairz00_2740;

																	BgL_pairz00_2740 = BgL_expz00_22;
																	BgL_arg3902z00_1728 =
																		CAR(CDR(BgL_pairz00_2740));
																}
																BgL_arg3900z00_1726 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg3902z00_1728);
															}
															{	/* Ast/sexp.scm 555 */
																obj_t BgL_arg3903z00_1729;

																obj_t BgL_arg3905z00_1730;

																{	/* Ast/sexp.scm 555 */
																	obj_t BgL_arg3906z00_1731;

																	obj_t BgL_arg3907z00_1732;

																	BgL_arg3906z00_1731 =
																		CNST_TABLE_REF(((long) 31));
																	{	/* Ast/sexp.scm 555 */
																		obj_t BgL_list3908z00_1733;

																		BgL_list3908z00_1733 =
																			MAKE_PAIR(BNIL, BNIL);
																		BgL_arg3907z00_1732 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(CNST_TABLE_REF(((long) 32)),
																			BgL_list3908z00_1733);
																	}
																	BgL_arg3903z00_1729 =
																		MAKE_PAIR(BgL_arg3906z00_1731,
																		BgL_arg3907z00_1732);
																}
																{	/* Ast/sexp.scm 555 */
																	obj_t BgL_auxz00_4442;

																	{	/* Ast/sexp.scm 555 */
																		obj_t BgL_pairz00_2744;

																		BgL_pairz00_2744 = BgL_expz00_22;
																		BgL_auxz00_4442 =
																			CDR(CDR(BgL_pairz00_2744));
																	}
																	BgL_arg3905z00_1730 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_4442, BNIL);
																}
																BgL_arg3901z00_1727 =
																	MAKE_PAIR(BgL_arg3903z00_1729,
																	BgL_arg3905z00_1730);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), (obj_t) (BgL_arg3900z00_1726),
																(BgL_typez00_bglt) (BgL_typez00_1721),
																BgL_arg3901z00_1727, BgL_stackz00_23,
																BgL_locz00_1717, BgL_sitez00_25);
														}
													else
														{	/* Ast/sexp.scm 550 */
															return
																BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																(BGl_string4140z00zzast_sexpz00, BgL_expz00_22,
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_22, BgL_locz00_1717));
														}
												}
											else
												{	/* Ast/sexp.scm 546 */
													if ((BgL_idz00_1720 == CNST_TABLE_REF(((long) 23))))
														{	/* Ast/sexp.scm 546 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																(BgL_typez00_bglt) (BgL_typez00_1721),
																BgL_expz00_22, BgL_stackz00_23, BgL_locz00_1717,
																BgL_sitez00_25);
														}
													else
														{	/* Ast/sexp.scm 546 */
															if (
																(BgL_idz00_1720 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 560 */
																	bool_t BgL_testz00_4460;

																	{	/* Ast/sexp.scm 560 */
																		obj_t BgL_auxz00_4461;

																		BgL_auxz00_4461 = CDR(BgL_expz00_22);
																		BgL_testz00_4460 = PAIRP(BgL_auxz00_4461);
																	}
																	if (BgL_testz00_4460)
																		{	/* Ast/sexp.scm 564 */
																			BgL_feffectz00_bglt BgL_arg3917z00_1742;

																			obj_t BgL_arg3918z00_1743;

																			{	/* Ast/sexp.scm 564 */
																				obj_t BgL_arg3919z00_1744;

																				{	/* Ast/sexp.scm 564 */
																					obj_t BgL_pairz00_2754;

																					BgL_pairz00_2754 = BgL_expz00_22;
																					BgL_arg3919z00_1744 =
																						CAR(CDR(BgL_pairz00_2754));
																				}
																				BgL_arg3917z00_1742 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg3919z00_1744);
																			}
																			{	/* Ast/sexp.scm 565 */
																				obj_t BgL_arg3920z00_1745;

																				obj_t BgL_arg3921z00_1746;

																				{	/* Ast/sexp.scm 565 */
																					obj_t BgL_arg3922z00_1747;

																					obj_t BgL_arg3923z00_1748;

																					BgL_arg3922z00_1747 =
																						CNST_TABLE_REF(((long) 31));
																					{	/* Ast/sexp.scm 565 */
																						obj_t BgL_list3924z00_1749;

																						BgL_list3924z00_1749 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3923z00_1748 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 32)),
																							BgL_list3924z00_1749);
																					}
																					BgL_arg3920z00_1745 =
																						MAKE_PAIR(BgL_arg3922z00_1747,
																						BgL_arg3923z00_1748);
																				}
																				{	/* Ast/sexp.scm 565 */
																					obj_t BgL_auxz00_4472;

																					{	/* Ast/sexp.scm 565 */
																						obj_t BgL_pairz00_2758;

																						BgL_pairz00_2758 = BgL_expz00_22;
																						BgL_auxz00_4472 =
																							CDR(CDR(BgL_pairz00_2758));
																					}
																					BgL_arg3921z00_1746 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_4472, BNIL);
																				}
																				BgL_arg3918z00_1743 =
																					MAKE_PAIR(BgL_arg3920z00_1745,
																					BgL_arg3921z00_1746);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				(obj_t) (BgL_arg3917z00_1742),
																				(BgL_typez00_bglt) (BgL_typez00_1721),
																				BgL_arg3918z00_1743, BgL_stackz00_23,
																				BgL_locz00_1717, BgL_sitez00_25);
																		}
																	else
																		{	/* Ast/sexp.scm 560 */
																			return
																				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																				(BGl_string4141z00zzast_sexpz00,
																				BgL_expz00_22,
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_22, BgL_locz00_1717));
																		}
																}
															else
																{	/* Ast/sexp.scm 546 */
																	if (
																		(BgL_idz00_1720 ==
																			CNST_TABLE_REF(((long) 18))))
																		{
																			obj_t BgL_argsz00_1756;

																			obj_t BgL_bodyz00_1757;

																			if (PAIRP(BgL_expz00_22))
																				{	/* Ast/sexp.scm 568 */
																					obj_t BgL_cdrzd22477zd2_1762;

																					BgL_cdrzd22477zd2_1762 =
																						CDR(BgL_expz00_22);
																					if (PAIRP(BgL_cdrzd22477zd2_1762))
																						{	/* Ast/sexp.scm 568 */
																							BgL_argsz00_1756 =
																								CAR(BgL_cdrzd22477zd2_1762);
																							BgL_bodyz00_1757 =
																								CDR(BgL_cdrzd22477zd2_1762);
																							{	/* Ast/sexp.scm 570 */
																								obj_t BgL_locz00_1766;

																								BgL_locz00_1766 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_22,
																									BgL_locz00_1717);
																								{	/* Ast/sexp.scm 570 */
																									obj_t BgL_funz00_1767;

																									BgL_funz00_1767 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													18))));
																									{	/* Ast/sexp.scm 571 */
																										obj_t BgL_tfunz00_1768;

																										{	/* Ast/sexp.scm 572 */
																											obj_t BgL_arg3949z00_1783;

																											{
																												BgL_typez00_bglt
																													BgL_auxz00_4494;
																												BgL_auxz00_4494 =
																													(BgL_typez00_bglt)
																													(BgL_typez00_1721);
																												BgL_arg3949z00_1783 =
																													(((BgL_typez00_bglt)
																														CREF
																														(BgL_auxz00_4494))->
																													BgL_idz00);
																											}
																											BgL_tfunz00_1768 =
																												BGl_makezd2typedzd2identz00zzast_identz00
																												(BgL_funz00_1767,
																												BgL_arg3949z00_1783);
																										}
																										{	/* Ast/sexp.scm 572 */

																											{	/* Ast/sexp.scm 574 */
																												obj_t
																													BgL_arg3935z00_1769;
																												{	/* Ast/sexp.scm 574 */
																													obj_t
																														BgL_arg3936z00_1770;
																													obj_t
																														BgL_arg3937z00_1771;
																													BgL_arg3936z00_1770 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 574 */
																														obj_t
																															BgL_arg3938z00_1772;
																														{	/* Ast/sexp.scm 574 */
																															obj_t
																																BgL_arg3942z00_1776;
																															{	/* Ast/sexp.scm 574 */
																																obj_t
																																	BgL_arg3944z00_1778;
																																{	/* Ast/sexp.scm 574 */
																																	obj_t
																																		BgL_arg3945z00_1779;
																																	BgL_arg3945z00_1779
																																		=
																																		BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_1757);
																																	{	/* Ast/sexp.scm 574 */
																																		obj_t
																																			BgL_list3947z00_1781;
																																		{	/* Ast/sexp.scm 574 */
																																			obj_t
																																				BgL_arg3948z00_1782;
																																			BgL_arg3948z00_1782
																																				=
																																				MAKE_PAIR
																																				(BNIL,
																																				BNIL);
																																			BgL_list3947z00_1781
																																				=
																																				MAKE_PAIR
																																				(BgL_arg3945z00_1779,
																																				BgL_arg3948z00_1782);
																																		}
																																		BgL_arg3944z00_1778
																																			=
																																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																			(BgL_argsz00_1756,
																																			BgL_list3947z00_1781);
																																}}
																																BgL_arg3942z00_1776
																																	=
																																	MAKE_PAIR
																																	(BgL_tfunz00_1768,
																																	BgL_arg3944z00_1778);
																															}
																															BgL_arg3938z00_1772
																																=
																																MAKE_PAIR
																																(BgL_arg3942z00_1776,
																																BNIL);
																														}
																														{	/* Ast/sexp.scm 574 */
																															obj_t
																																BgL_list3940z00_1774;
																															{	/* Ast/sexp.scm 574 */
																																obj_t
																																	BgL_arg3941z00_1775;
																																BgL_arg3941z00_1775
																																	=
																																	MAKE_PAIR
																																	(BNIL, BNIL);
																																BgL_list3940z00_1774
																																	=
																																	MAKE_PAIR
																																	(BgL_funz00_1767,
																																	BgL_arg3941z00_1775);
																															}
																															BgL_arg3937z00_1771
																																=
																																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																(BgL_arg3938z00_1772,
																																BgL_list3940z00_1774);
																													}}
																													BgL_arg3935z00_1769 =
																														MAKE_PAIR
																														(BgL_arg3936z00_1770,
																														BgL_arg3937z00_1771);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg3935z00_1769,
																													BgL_stackz00_23,
																													BgL_locz00_1766,
																													BgL_sitez00_25);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 568 */
																						BgL_tagzd22470zd2_1759:
																							return
																								BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																								(BGl_string4125z00zzast_sexpz00,
																								BgL_expz00_22, BgL_locz00_1717);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 568 */
																					goto BgL_tagzd22470zd2_1759;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 546 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_22, BgL_stackz00_23,
																				BgL_locz00_1717, BgL_sitez00_25);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 541 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_22,
							BgL_stackz00_23, BgL_locz00_1717, BgL_sitez00_25);
					}
			}
		}
	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_26, obj_t BgL_stackz00_27, obj_t BgL_locz00_28,
		obj_t BgL_sitez00_29)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 588 */
			{
				obj_t BgL_expsz00_1787;

				obj_t BgL_resz00_1788;

				obj_t BgL_locz00_1789;

				BgL_expsz00_1787 = BgL_expza2za2_26;
				BgL_resz00_1788 = BNIL;
				BgL_locz00_1789 = BgL_locz00_28;
			BgL_zc3anonymousza33951ze3z83_1790:
				if (NULLP(BgL_expsz00_1787))
					{	/* Ast/sexp.scm 593 */
						return
							(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string4142z00zzast_sexpz00, BgL_expsz00_1787,
								BgL_locz00_1789));
					}
				else
					{	/* Ast/sexp.scm 593 */
						if (NULLP(CDR(BgL_expsz00_1787)))
							{	/* Ast/sexp.scm 596 */
								obj_t BgL_locz00_1793;

								obj_t BgL_nsitez00_1794;

								BgL_locz00_1793 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1787),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1787, BgL_locz00_1789));
								if ((BgL_sitez00_29 == CNST_TABLE_REF(((long) 11))))
									{	/* Ast/sexp.scm 598 */
										BgL_nsitez00_1794 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 598 */
										BgL_nsitez00_1794 = BgL_sitez00_29;
									}
								{	/* Ast/sexp.scm 599 */
									obj_t BgL_arg3954z00_1795;

									{	/* Ast/sexp.scm 599 */
										BgL_nodez00_bglt BgL_arg3955z00_1796;

										BgL_arg3955z00_1796 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CAR(BgL_expsz00_1787),
											BgL_stackz00_27, BgL_locz00_1793, BgL_nsitez00_1794);
										BgL_arg3954z00_1795 =
											MAKE_PAIR((obj_t) (BgL_arg3955z00_1796), BgL_resz00_1788);
									}
									return bgl_reverse_bang(BgL_arg3954z00_1795);
								}
							}
						else
							{	/* Ast/sexp.scm 601 */
								obj_t BgL_locz00_1801;

								BgL_locz00_1801 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1787),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1787, BgL_locz00_1789));
								{	/* Ast/sexp.scm 603 */
									obj_t BgL_arg3960z00_1802;

									obj_t BgL_arg3961z00_1803;

									BgL_arg3960z00_1802 = CDR(BgL_expsz00_1787);
									{	/* Ast/sexp.scm 604 */
										BgL_nodez00_bglt BgL_arg3962z00_1804;

										{	/* Ast/sexp.scm 604 */
											obj_t BgL_arg3963z00_1805;

											obj_t BgL_arg3964z00_1806;

											BgL_arg3963z00_1805 = CAR(BgL_expsz00_1787);
											BgL_arg3964z00_1806 = CNST_TABLE_REF(((long) 2));
											BgL_arg3962z00_1804 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3963z00_1805,
												BgL_stackz00_27, BgL_locz00_1801, BgL_arg3964z00_1806);
										}
										BgL_arg3961z00_1803 =
											MAKE_PAIR((obj_t) (BgL_arg3962z00_1804), BgL_resz00_1788);
									}
									{
										obj_t BgL_locz00_4545;

										obj_t BgL_resz00_4544;

										obj_t BgL_expsz00_4543;

										BgL_expsz00_4543 = BgL_arg3960z00_1802;
										BgL_resz00_4544 = BgL_arg3961z00_1803;
										BgL_locz00_4545 = BgL_locz00_1801;
										BgL_locz00_1789 = BgL_locz00_4545;
										BgL_resz00_1788 = BgL_resz00_4544;
										BgL_expsz00_1787 = BgL_expsz00_4543;
										goto BgL_zc3anonymousza33951ze3z83_1790;
									}
								}
							}
					}
			}
		}
	}



/* _sexp*->node */
	obj_t BGl__sexpza2zd2ze3nodez93zzast_sexpz00(obj_t BgL_envz00_2858,
		obj_t BgL_expza2za2_2859, obj_t BgL_stackz00_2860, obj_t BgL_locz00_2861,
		obj_t BgL_sitez00_2862)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 588 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_2859,
				BgL_stackz00_2860, BgL_locz00_2861, BgL_sitez00_2862);
		}
	}



/* lookup */
	obj_t BGl_lookupz00zzast_sexpz00(obj_t BgL_namez00_30, obj_t BgL_stackz00_31)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 617 */
			{	/* Ast/sexp.scm 618 */
				bool_t BgL_testz00_4547;

				if ((BgL_namez00_30 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 618 */
						BgL_testz00_4547 =
							(BgL_stackz00_31 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 618 */
						BgL_testz00_4547 = ((bool_t) 0);
					}
				if (BgL_testz00_4547)
					{	/* Ast/sexp.scm 618 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 618 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_30;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_31;
						{
							obj_t BgL_stackz00_1813;

							BgL_stackz00_1813 = BgL_stackz00_31;
						BgL_zc3anonymousza33969ze3z83_1814:
							if (NULLP(BgL_stackz00_1813))
								{	/* Ast/sexp.scm 626 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 629 */
									bool_t BgL_testz00_4553;

									{	/* Ast/sexp.scm 629 */
										obj_t BgL_auxz00_4554;

										{	/* Ast/sexp.scm 629 */
											BgL_variablez00_bglt BgL_obj1591z00_2780;

											{	/* Ast/sexp.scm 629 */
												obj_t BgL_pairz00_2779;

												BgL_pairz00_2779 = BgL_stackz00_1813;
												BgL_obj1591z00_2780 =
													(BgL_variablez00_bglt) (CAR(BgL_pairz00_2779));
											}
											BgL_auxz00_4554 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1591z00_2780))->
												BgL_idz00);
										}
										BgL_testz00_4553 = (BgL_auxz00_4554 == BgL_namez00_30);
									}
									if (BgL_testz00_4553)
										{	/* Ast/sexp.scm 629 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(BgL_stackz00_1813);
											return CAR(BgL_stackz00_1813);
										}
									else
										{
											obj_t BgL_stackz00_4561;

											BgL_stackz00_4561 = CDR(BgL_stackz00_1813);
											BgL_stackz00_1813 = BgL_stackz00_4561;
											goto BgL_zc3anonymousza33969ze3z83_1814;
										}
								}
						}
					}
			}
		}
	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_32,
		obj_t BgL_locz00_33, obj_t BgL_sitez00_34)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 638 */
			if ((BgL_sitez00_34 == CNST_TABLE_REF(((long) 5))))
				{	/* Ast/sexp.scm 641 */
					BgL_variablez00_bglt BgL_obj1603z00_2784;

					obj_t BgL_val1602z00_2785;

					BgL_obj1603z00_2784 = BgL_varz00_32;
					BgL_val1602z00_2785 = CNST_TABLE_REF(((long) 33));
					((((BgL_variablez00_bglt) CREF(BgL_obj1603z00_2784))->BgL_accessz00) =
						((obj_t) BgL_val1602z00_2785), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 640 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 642 */
				BgL_valuez00_bglt BgL_valz00_1823;

				BgL_valz00_1823 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_32))->BgL_valuez00);
				{	/* Ast/sexp.scm 643 */
					bool_t BgL_testz00_4569;

					if ((BgL_sitez00_34 == CNST_TABLE_REF(((long) 5))))
						{	/* Ast/sexp.scm 643 */
							obj_t BgL_obj1844z00_2787;

							BgL_obj1844z00_2787 = (obj_t) (BgL_valz00_1823);
							BgL_testz00_4569 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj1844z00_2787,
								BGl_funz00zzast_varz00);
						}
					else
						{	/* Ast/sexp.scm 643 */
							BgL_testz00_4569 = ((bool_t) 0);
						}
					if (BgL_testz00_4569)
						{	/* Ast/sexp.scm 644 */
							obj_t BgL_arg3979z00_1826;

							BgL_arg3979z00_1826 =
								BGl_shapez00zztools_shapez00((obj_t) (BgL_varz00_32));
							return
								(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
								(BGl_string4143z00zzast_sexpz00, BgL_arg3979z00_1826,
									BgL_locz00_33));
						}
					else
						{	/* Ast/sexp.scm 643 */
							return BFALSE;
						}
				}
			}
		}
	}



/* _use-variable! */
	obj_t BGl__usezd2variablez12zc0zzast_sexpz00(obj_t BgL_envz00_2863,
		obj_t BgL_varz00_2864, obj_t BgL_locz00_2865, obj_t BgL_sitez00_2866)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 638 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_varz00_2864), BgL_locz00_2865,
				BgL_sitez00_2866);
		}
	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_35,
		obj_t BgL_expz00_36, obj_t BgL_locz00_37)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 649 */
			{	/* Ast/sexp.scm 651 */
				obj_t BgL_arg3981z00_1828;

				BgL_nodez00_bglt BgL_arg3982z00_1829;

				BgL_arg3981z00_1828 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg3982z00_1829 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 29)), BNIL,
					BgL_locz00_37, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 650 */
					obj_t BgL_list3983z00_1830;

					BgL_list3983z00_1830 = MAKE_PAIR((obj_t) (BgL_arg3982z00_1829), BNIL);
					return
						(BgL_nodez00_bglt) (BGl_userzd2errorzf2locationz20zztools_errorz00
						(BgL_locz00_37, BgL_arg3981z00_1828, BgL_msgz00_35, BgL_expz00_36,
							BgL_list3983z00_1830));
				}
			}
		}
	}



/* _error-sexp->node */
	obj_t BGl__errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_envz00_2867,
		obj_t BgL_msgz00_2868, obj_t BgL_expz00_2869, obj_t BgL_locz00_2870)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 649 */
			return
				(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_2868,
					BgL_expz00_2869, BgL_locz00_2870));
		}
	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_38, BgL_nodez00_bglt BgL_refz00_39)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 659 */
			{	/* Ast/sexp.scm 660 */
				BgL_nodez00_bglt BgL_funz00_1832;

				BgL_funz00_1832 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 34)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 11)));
				{	/* Ast/sexp.scm 661 */
					bool_t BgL_testz00_4595;

					{	/* Ast/sexp.scm 661 */
						obj_t BgL_obj2157z00_2788;

						BgL_obj2157z00_2788 = (obj_t) (BgL_funz00_1832);
						BgL_testz00_4595 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2157z00_2788,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_4595)
						{	/* Ast/sexp.scm 662 */
							obj_t BgL_arg3988z00_1835;

							{	/* Ast/sexp.scm 664 */
								BgL_nodez00_bglt BgL_arg3989z00_1836;

								{	/* Ast/sexp.scm 664 */
									obj_t BgL_arg3992z00_1839;

									obj_t BgL_arg3995z00_1841;

									{	/* Ast/sexp.scm 664 */
										obj_t BgL_arg3996z00_1842;

										obj_t BgL_arg3997z00_1843;

										BgL_arg3996z00_1842 = CNST_TABLE_REF(((long) 13));
										{	/* Ast/sexp.scm 664 */
											obj_t BgL_arg3998z00_1844;

											{
												BgL_variablez00_bglt BgL_auxz00_4599;

												BgL_auxz00_4599 =
													(BgL_variablez00_bglt) (BgL_globalz00_38);
												BgL_arg3998z00_1844 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_4599))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 664 */
												obj_t BgL_list4000z00_1846;

												BgL_list4000z00_1846 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3997z00_1843 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3998z00_1844, BgL_list4000z00_1846);
										}}
										BgL_arg3992z00_1839 =
											MAKE_PAIR(BgL_arg3996z00_1842, BgL_arg3997z00_1843);
									}
									BgL_arg3995z00_1841 = CNST_TABLE_REF(((long) 2));
									BgL_arg3989z00_1836 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3992z00_1839,
										BNIL, BFALSE, BgL_arg3995z00_1841);
								}
								{	/* Ast/sexp.scm 664 */
									obj_t BgL_list3990z00_1837;

									{	/* Ast/sexp.scm 664 */
										obj_t BgL_arg3991z00_1838;

										BgL_arg3991z00_1838 =
											MAKE_PAIR((obj_t) (BgL_refz00_39), BNIL);
										BgL_list3990z00_1837 =
											MAKE_PAIR(
											(obj_t) (BgL_arg3989z00_1836), BgL_arg3991z00_1838);
									}
									BgL_arg3988z00_1835 = BgL_list3990z00_1837;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1832), BgL_arg3988z00_1835));
						}
					else
						{	/* Ast/sexp.scm 661 */
							return BgL_funz00_1832;
						}
				}
			}
		}
	}



/* _define-primop-ref->node */
	obj_t BGl__definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_envz00_2871, obj_t BgL_globalz00_2872, obj_t BgL_refz00_2873)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 659 */
			return
				(obj_t) (BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2872),
					(BgL_nodez00_bglt) (BgL_refz00_2873)));
		}
	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_40)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 674 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_40), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 676 */
				BgL_nodez00_bglt BgL_funz00_1847;

				BgL_funz00_1847 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 35)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 11)));
				{	/* Ast/sexp.scm 677 */
					bool_t BgL_testz00_4626;

					{	/* Ast/sexp.scm 677 */
						obj_t BgL_obj2157z00_2792;

						BgL_obj2157z00_2792 = (obj_t) (BgL_funz00_1847);
						BgL_testz00_4626 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2157z00_2792,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_4626)
						{	/* Ast/sexp.scm 678 */
							obj_t BgL_arg4003z00_1850;

							{	/* Ast/sexp.scm 680 */
								BgL_nodez00_bglt BgL_arg4004z00_1851;

								BgL_nodez00_bglt BgL_arg4005z00_1852;

								{	/* Ast/sexp.scm 680 */
									obj_t BgL_arg4008z00_1855;

									obj_t BgL_arg4010z00_1857;

									{	/* Ast/sexp.scm 680 */
										obj_t BgL_arg4011z00_1858;

										obj_t BgL_arg4012z00_1859;

										BgL_arg4011z00_1858 = CNST_TABLE_REF(((long) 13));
										{	/* Ast/sexp.scm 680 */
											obj_t BgL_arg4013z00_1860;

											{
												BgL_variablez00_bglt BgL_auxz00_4630;

												BgL_auxz00_4630 =
													(BgL_variablez00_bglt) (BgL_globalz00_40);
												BgL_arg4013z00_1860 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_4630))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 680 */
												obj_t BgL_list4015z00_1862;

												BgL_list4015z00_1862 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg4012z00_1859 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg4013z00_1860, BgL_list4015z00_1862);
										}}
										BgL_arg4008z00_1855 =
											MAKE_PAIR(BgL_arg4011z00_1858, BgL_arg4012z00_1859);
									}
									BgL_arg4010z00_1857 = CNST_TABLE_REF(((long) 2));
									BgL_arg4004z00_1851 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg4008z00_1855,
										BNIL, BFALSE, BgL_arg4010z00_1857);
								}
								BgL_arg4005z00_1852 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(
									(obj_t) (BgL_globalz00_40), BNIL, BFALSE,
									CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 680 */
									obj_t BgL_list4006z00_1853;

									{	/* Ast/sexp.scm 680 */
										obj_t BgL_arg4007z00_1854;

										BgL_arg4007z00_1854 =
											MAKE_PAIR((obj_t) (BgL_arg4005z00_1852), BNIL);
										BgL_list4006z00_1853 =
											MAKE_PAIR(
											(obj_t) (BgL_arg4004z00_1851), BgL_arg4007z00_1854);
									}
									BgL_arg4003z00_1850 = BgL_list4006z00_1853;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1847), BgL_arg4003z00_1850));
						}
					else
						{	/* Ast/sexp.scm 677 */
							return BgL_funz00_1847;
						}
				}
			}
		}
	}



/* _define-primop->node */
	obj_t BGl__definezd2primopzd2ze3nodeze3zzast_sexpz00(obj_t BgL_envz00_2874,
		obj_t BgL_globalz00_2875)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 674 */
			return
				(obj_t) (BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2875)));
		}
	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_41)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 693 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_41), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 695 */
				BgL_nodez00_bglt BgL_funz00_1863;

				BgL_funz00_1863 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 36)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 11)));
				{	/* Ast/sexp.scm 696 */
					bool_t BgL_testz00_4659;

					{	/* Ast/sexp.scm 696 */
						obj_t BgL_obj2157z00_2796;

						BgL_obj2157z00_2796 = (obj_t) (BgL_funz00_1863);
						BgL_testz00_4659 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2157z00_2796,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_4659)
						{	/* Ast/sexp.scm 697 */
							obj_t BgL_exprz00_1865;

							{	/* Ast/sexp.scm 697 */
								bool_t BgL_testz00_4662;

								{	/* Ast/sexp.scm 697 */
									obj_t BgL_arg4026z00_1875;

									BgL_arg4026z00_1875 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_4664;

										BgL_auxz00_4664 =
											(BgL_backendz00_bglt) (BgL_arg4026z00_1875);
										BgL_testz00_4662 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_4664))->
											BgL_pragmazd2supportzd2);
									}
								}
								if (BgL_testz00_4662)
									{	/* Ast/sexp.scm 698 */
										obj_t BgL_arg4022z00_1871;

										obj_t BgL_arg4023z00_1872;

										BgL_arg4022z00_1871 = CNST_TABLE_REF(((long) 37));
										{	/* Ast/sexp.scm 698 */
											obj_t BgL_list4024z00_1873;

											{	/* Ast/sexp.scm 698 */
												obj_t BgL_arg4025z00_1874;

												BgL_arg4025z00_1874 = MAKE_PAIR(BNIL, BNIL);
												BgL_list4024z00_1873 =
													MAKE_PAIR(
													(obj_t) (BgL_globalz00_41), BgL_arg4025z00_1874);
											}
											BgL_arg4023z00_1872 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BGl_string4144z00zzast_sexpz00, BgL_list4024z00_1873);
										}
										BgL_exprz00_1865 =
											MAKE_PAIR(BgL_arg4022z00_1871, BgL_arg4023z00_1872);
									}
								else
									{	/* Ast/sexp.scm 697 */
										BgL_exprz00_1865 = (obj_t) (BgL_globalz00_41);
									}
							}
							{	/* Ast/sexp.scm 700 */
								obj_t BgL_arg4018z00_1867;

								{	/* Ast/sexp.scm 702 */
									BgL_nodez00_bglt BgL_arg4019z00_1868;

									BgL_arg4019z00_1868 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_1865, BNIL,
										BFALSE, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 702 */
										obj_t BgL_list4020z00_1869;

										BgL_list4020z00_1869 =
											MAKE_PAIR((obj_t) (BgL_arg4019z00_1868), BNIL);
										BgL_arg4018z00_1867 = BgL_list4020z00_1869;
								}}
								return
									(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
										BUNSPEC, BINT(((long) -1)),
										(BgL_varz00_bglt) (BgL_funz00_1863), BgL_arg4018z00_1867));
						}}
					else
						{	/* Ast/sexp.scm 696 */
							return BgL_funz00_1863;
						}
				}
			}
		}
	}



/* _location->node */
	obj_t BGl__locationzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2876,
		obj_t BgL_globalz00_2877)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 693 */
			return
				(obj_t) (BGl_locationzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2877)));
		}
	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_42, obj_t BgL_prefz00_43)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 708 */
			{	/* Ast/sexp.scm 709 */
				obj_t BgL_prefz00_1876;

				{	/* Ast/sexp.scm 709 */
					bool_t BgL_testz00_4686;

					if (PAIRP(BgL_prefz00_43))
						{	/* Ast/sexp.scm 709 */
							obj_t BgL_auxz00_4689;

							BgL_auxz00_4689 = CAR(BgL_prefz00_43);
							BgL_testz00_4686 = STRINGP(BgL_auxz00_4689);
						}
					else
						{	/* Ast/sexp.scm 709 */
							BgL_testz00_4686 = ((bool_t) 0);
						}
					if (BgL_testz00_4686)
						{	/* Ast/sexp.scm 709 */
							BgL_prefz00_1876 = CAR(BgL_prefz00_43);
						}
					else
						{	/* Ast/sexp.scm 709 */
							BgL_prefz00_1876 = BGl_string4145z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 712 */
					bool_t BgL_testz00_4693;

					if (STRUCTP(BgL_locz00_42))
						{	/* Ast/sexp.scm 712 */
							BgL_testz00_4693 =
								(STRUCT_KEY(BgL_locz00_42) == CNST_TABLE_REF(((long) 6)));
						}
					else
						{	/* Ast/sexp.scm 712 */
							BgL_testz00_4693 = ((bool_t) 0);
						}
					if (BgL_testz00_4693)
						{	/* Ast/sexp.scm 713 */
							obj_t BgL_filez00_1878;

							obj_t BgL_linez00_1879;

							obj_t BgL_basez00_1880;

							BgL_filez00_1878 = STRUCT_REF(BgL_locz00_42, (int) (((long) 0)));
							BgL_linez00_1879 = STRUCT_REF(BgL_locz00_42, (int) (((long) 2)));
							BgL_basez00_1880 =
								SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
								(string_append_3(BGl_string4146z00zzast_sexpz00,
										BgL_prefz00_1876, BGl_string4147z00zzast_sexpz00)));
							{	/* Ast/sexp.scm 717 */
								bool_t BgL_testz00_4706;

								{	/* Ast/sexp.scm 717 */
									bool_t BgL_testz00_4707;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 1)))
										{	/* Ast/sexp.scm 718 */
											obj_t BgL_arg4046z00_1902;

											obj_t BgL_arg4047z00_1903;

											BgL_arg4046z00_1902 = CNST_TABLE_REF(((long) 38));
											{	/* Ast/sexp.scm 718 */
												obj_t BgL_arg4048z00_1904;

												BgL_arg4048z00_1904 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_4713;

													BgL_auxz00_4713 =
														(BgL_backendz00_bglt) (BgL_arg4048z00_1904);
													BgL_arg4047z00_1903 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_4713))->
														BgL_debugzd2supportzd2);
											}}
											BgL_testz00_4707 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_arg4046z00_1902, BgL_arg4047z00_1903));
										}
									else
										{	/* Ast/sexp.scm 717 */
											BgL_testz00_4707 = ((bool_t) 0);
										}
									if (BgL_testz00_4707)
										{	/* Ast/sexp.scm 717 */
											BgL_testz00_4706 = ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 717 */
											BgL_testz00_4706 =
												(
												(long)
												CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
												((long) 1));
								}}
								if (BgL_testz00_4706)
									{	/* Ast/sexp.scm 720 */
										obj_t BgL_filez00_1882;

										if (bigloo_strncmp(BgL_filez00_1878,
												BGl_string4148z00zzast_sexpz00, ((long) 2)))
											{	/* Ast/sexp.scm 720 */
												BgL_filez00_1882 =
													c_substring(BgL_filez00_1878, ((long) 2),
													STRING_LENGTH(BgL_filez00_1878));
											}
										else
											{	/* Ast/sexp.scm 720 */
												BgL_filez00_1882 = BgL_filez00_1878;
											}
										{	/* Ast/sexp.scm 724 */
											obj_t BgL_arg4029z00_1883;

											{	/* Ast/sexp.scm 724 */
												char *BgL_arg4032z00_1886;

												{	/* Ast/sexp.scm 725 */

													BgL_arg4032z00_1886 =
														BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
														(BgL_linez00_1879, BINT(((long) 10)));
												}
												{	/* Ast/sexp.scm 724 */
													obj_t BgL_list4034z00_1888;

													{	/* Ast/sexp.scm 724 */
														obj_t BgL_arg4035z00_1889;

														{	/* Ast/sexp.scm 724 */
															obj_t BgL_arg4036z00_1890;

															{	/* Ast/sexp.scm 724 */
																obj_t BgL_arg4037z00_1891;

																{	/* Ast/sexp.scm 724 */
																	obj_t BgL_arg4038z00_1892;

																	{	/* Ast/sexp.scm 724 */
																		obj_t BgL_arg4039z00_1893;

																		BgL_arg4039z00_1893 =
																			MAKE_PAIR(BGl_string4149z00zzast_sexpz00,
																			BNIL);
																		BgL_arg4038z00_1892 =
																			MAKE_PAIR(string_to_bstring
																			(BgL_arg4032z00_1886),
																			BgL_arg4039z00_1893);
																	}
																	BgL_arg4037z00_1891 =
																		MAKE_PAIR(BGl_string4147z00zzast_sexpz00,
																		BgL_arg4038z00_1892);
																}
																BgL_arg4036z00_1890 =
																	MAKE_PAIR(BgL_filez00_1882,
																	BgL_arg4037z00_1891);
															}
															BgL_arg4035z00_1889 =
																MAKE_PAIR(BGl_string4147z00zzast_sexpz00,
																BgL_arg4036z00_1890);
														}
														BgL_list4034z00_1888 =
															MAKE_PAIR(BgL_basez00_1880, BgL_arg4035z00_1889);
													}
													BgL_arg4029z00_1883 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list4034z00_1888);
											}}
											return
												string_to_symbol(BSTRING_TO_STRING
												(BgL_arg4029z00_1883));
										}
									}
								else
									{	/* Ast/sexp.scm 728 */
										obj_t BgL_arg4043z00_1899;

										BgL_arg4043z00_1899 =
											string_append(BgL_basez00_1880,
											BGl_string4149z00zzast_sexpz00);
										return
											string_to_symbol(BSTRING_TO_STRING(BgL_arg4043z00_1899));
									}
							}
						}
					else
						{	/* Ast/sexp.scm 729 */
							obj_t BgL_arg4051z00_1907;

							{	/* Ast/sexp.scm 729 */
								obj_t BgL_arg4052z00_1908;

								obj_t BgL_arg4053z00_1909;

								BgL_arg4052z00_1908 =
									SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
									(string_append_3(BGl_string4146z00zzast_sexpz00,
											BgL_prefz00_1876, BGl_string4150z00zzast_sexpz00)));
								{	/* Ast/sexp.scm 729 */
									obj_t BgL_symbolz00_2833;

									BgL_symbolz00_2833 = CNST_TABLE_REF(((long) 39));
									BgL_arg4053z00_1909 = SYMBOL_TO_STRING(BgL_symbolz00_2833);
								}
								{	/* Ast/sexp.scm 729 */
									obj_t BgL_list4054z00_1910;

									{	/* Ast/sexp.scm 729 */
										obj_t BgL_arg4055z00_1911;

										BgL_arg4055z00_1911 = MAKE_PAIR(BgL_arg4053z00_1909, BNIL);
										BgL_list4054z00_1910 =
											MAKE_PAIR(BgL_arg4052z00_1908, BgL_arg4055z00_1911);
									}
									BgL_arg4051z00_1907 =
										BGl_stringzd2appendzd2zz__r4_strings_6_7z00
										(BgL_list4054z00_1910);
							}}
							return string_to_symbol(BSTRING_TO_STRING(BgL_arg4051z00_1907));
						}
				}
			}
		}
	}



/* _make-anonymous-name */
	obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t BgL_envz00_2878,
		obj_t BgL_locz00_2879, obj_t BgL_prefz00_2880)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 708 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_2879,
				BgL_prefz00_2880);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 139728077),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 315458190),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 46924743),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 292906466),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 365507801),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 352861756),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 341189244),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 271227279),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 121557513),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 53594424),
				BSTRING_TO_STRING(BGl_string4151z00zzast_sexpz00));
		}
	}

#ifdef __cplusplus
}
#endif
