/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t
		BGl_shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t BGl_shrinkzd2nodez12zd2cast3198z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2funcall3194z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl__shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2setq3200z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2conditi3202z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2extern3196z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2appzd2ly3192zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3210zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl__shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2fail3204z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2app3190z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	static obj_t
		BGl_shrinkzd2nodez12zd2setzd2exzd23218z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2kwote3186z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2select3206z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2letzd2fun3214zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2letzd2var3216zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3220zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2var3184z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2set3212zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2sequenc3188z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_shrinkzd2nodez12zd2atom3182z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2makezd2bo3208zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00
		(BgL_variablez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t __cnst[1];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2variablez12zd2def3177zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3520za7,
		BGl__shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2nodez12zd2default3179zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713521z00,
		BGl__shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3522za7,
		BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3500z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123523z00,
		BGl_shrinkzd2nodez12zd2app3190z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3501z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123524z00,
		BGl_shrinkzd2nodez12zd2appzd2ly3192zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3502z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123525z00,
		BGl_shrinkzd2nodez12zd2funcall3194z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3503z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123526z00,
		BGl_shrinkzd2nodez12zd2extern3196z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3504z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123527z00,
		BGl_shrinkzd2nodez12zd2cast3198z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3505z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123528z00,
		BGl_shrinkzd2nodez12zd2setq3200z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3506z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123529z00,
		BGl_shrinkzd2nodez12zd2conditi3202z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3496z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123530z00,
		BGl_shrinkzd2nodez12zd2atom3182z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3507z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123531z00,
		BGl_shrinkzd2nodez12zd2fail3204z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3497z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123532z00,
		BGl_shrinkzd2nodez12zd2var3184z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3508z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123533z00,
		BGl_shrinkzd2nodez12zd2select3206z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3498z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123534z00,
		BGl_shrinkzd2nodez12zd2kwote3186z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3510z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123535z00,
		BGl_shrinkzd2nodez12zd2boxzd2ref3210zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3509z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123536z00,
		BGl_shrinkzd2nodez12zd2makezd2bo3208zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3499z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123537z00,
		BGl_shrinkzd2nodez12zd2sequenc3188z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3511z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123538z00,
		BGl_shrinkzd2nodez12zd2boxzd2set3212zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3512z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123539z00,
		BGl_shrinkzd2nodez12zd2letzd2fun3214zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3513z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123540z00,
		BGl_shrinkzd2nodez12zd2letzd2var3216zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3514z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123541z00,
		BGl_shrinkzd2nodez12zd2setzd2exzd23218z12zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3515z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123542z00,
		BGl_shrinkzd2nodez12zd2jumpzd2ex3220zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkifyza712za7123543z00, BGl__shrinkifyz12z12zzast_shrinkifyz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3495z00zzast_shrinkifyz00,
		BgL_bgl_string3495za700za7za7a3544za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3516z00zzast_shrinkifyz00,
		BgL_bgl_string3516za700za7za7a3545za7, "ast_shrinkify", 13);
	      DEFINE_STRING(BGl_string3517z00zzast_shrinkifyz00,
		BgL_bgl_string3517za700za7za7a3546za7, "shrink-node!-default3179 ", 25);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713547z00,
		BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_2584, char *BgL_fromz00_2585)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_2573;

				BgL_cportz00_2573 =
					bgl_open_input_string(BGl_string3517z00zzast_shrinkifyz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2574;

					BgL_iz00_2574 = ((long) 0);
				BgL_loopz00_2575:
					if ((BgL_iz00_2574 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg3519z00_2577;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_2579;

										BgL_locationz00_2579 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg3519z00_2577 =
												BGl_readz00zz__readerz00(BgL_cportz00_2573,
												BgL_locationz00_2579);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_auxz00_2603;

									BgL_auxz00_2603 = (int) (BgL_iz00_2574);
									CNST_TABLE_SET(BgL_auxz00_2603, BgL_arg3519z00_2577);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_2580;

								BgL_auxz00_2580 = (int) ((BgL_iz00_2574 - ((long) 1)));
								{
									long BgL_iz00_2608;

									BgL_iz00_2608 = (long) (BgL_auxz00_2580);
									BgL_iz00_2574 = BgL_iz00_2608;
									goto BgL_loopz00_2575;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}
	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l3161z00_769;

				BgL_l3161z00_769 = BgL_globalsz00_1;
			BgL_zc3anonymousza33222ze3z83_770:
				if (PAIRP(BgL_l3161z00_769))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_772;

							BgL_globalz00_772 = CAR(BgL_l3161z00_769);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_773;

								{
									BgL_variablez00_bglt BgL_auxz00_2614;

									BgL_auxz00_2614 = (BgL_variablez00_bglt) (BgL_globalz00_772);
									BgL_sfunz00_773 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2614))->
										BgL_valuez00);
								}
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g3160z00_774;

									{
										BgL_sfunz00_bglt BgL_auxz00_2617;

										BgL_auxz00_2617 = (BgL_sfunz00_bglt) (BgL_sfunz00_773);
										BgL_g3160z00_774 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2617))->BgL_argsz00);
									}
									{
										obj_t BgL_l3158z00_776;

										BgL_l3158z00_776 = BgL_g3160z00_774;
									BgL_zc3anonymousza33224ze3z83_777:
										if (PAIRP(BgL_l3158z00_776))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg3226z00_779;

													BgL_arg3226z00_779 = CAR(BgL_l3158z00_776);
													{	/* Ast/shrinkify.scm 29 */
														BgL_variablez00_bglt BgL_variablez00_1386;

														BgL_variablez00_1386 =
															(BgL_variablez00_bglt) (BgL_arg3226z00_779);
														{	/* Ast/shrinkify.scm 29 */
															obj_t BgL_method3178z00_1387;

															{	/* Ast/shrinkify.scm 29 */
																BgL_objectz00_bglt BgL_objz00_1388;

																BgL_objz00_1388 =
																	(BgL_objectz00_bglt) (BgL_variablez00_1386);
																{	/* Ast/shrinkify.scm 29 */
																	long BgL_objzd2classzd2numz00_1389;

																	BgL_objzd2classzd2numz00_1389 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_1388);
																	{	/* Ast/shrinkify.scm 29 */
																		obj_t BgL_arg2551z00_1390;

																		BgL_arg2551z00_1390 =
																			PROCEDURE_REF
																			(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																			(int) (((long) 1)));
																		{	/* Ast/shrinkify.scm 29 */
																			obj_t BgL_arrayz00_1392;

																			int BgL_offsetz00_1393;

																			BgL_arrayz00_1392 = BgL_arg2551z00_1390;
																			BgL_offsetz00_1393 =
																				(int) (BgL_objzd2classzd2numz00_1389);
																			{	/* Ast/shrinkify.scm 29 */
																				long BgL_offsetz00_1394;

																				BgL_offsetz00_1394 =
																					(
																					(long) (BgL_offsetz00_1393) -
																					OBJECT_TYPE);
																				{	/* Ast/shrinkify.scm 29 */
																					long BgL_modz00_1395;

																					{	/* Ast/shrinkify.scm 29 */
																						int BgL_arg2553z00_1396;

																						BgL_arg2553z00_1396 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 29 */
																							long BgL_auxz00_2632;

																							BgL_auxz00_2632 =
																								(long) (BgL_arg2553z00_1396);
																							BgL_modz00_1395 =
																								(BgL_offsetz00_1394 /
																								BgL_auxz00_2632);
																					}}
																					{	/* Ast/shrinkify.scm 29 */
																						long BgL_restz00_1397;

																						{	/* Ast/shrinkify.scm 29 */
																							int BgL_arg2552z00_1398;

																							BgL_arg2552z00_1398 =
																								(int) (((long) 8));
																							{	/* Ast/shrinkify.scm 29 */
																								long BgL_auxz00_2636;

																								BgL_auxz00_2636 =
																									(long) (BgL_arg2552z00_1398);
																								BgL_restz00_1397 =
																									(BgL_offsetz00_1394 %
																									BgL_auxz00_2636);
																						}}
																						{	/* Ast/shrinkify.scm 29 */

																							BgL_method3178z00_1387 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_1392,
																									(int) (BgL_modz00_1395)),
																								(int) (BgL_restz00_1397));
															}}}}}}}}
															PROCEDURE_ENTRY(BgL_method3178z00_1387)
																(BgL_method3178z00_1387,
																(obj_t) (BgL_variablez00_1386), BEOA);
												}}}
												{
													obj_t BgL_l3158z00_2646;

													BgL_l3158z00_2646 = CDR(BgL_l3158z00_776);
													BgL_l3158z00_776 = BgL_l3158z00_2646;
													goto BgL_zc3anonymousza33224ze3z83_777;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg3228z00_782;

									{	/* Ast/shrinkify.scm 30 */
										BgL_sfunz00_bglt BgL_obj1791z00_1414;

										{	/* Ast/shrinkify.scm 30 */
											BgL_variablez00_bglt BgL_obj1518z00_1413;

											BgL_obj1518z00_1413 =
												(BgL_variablez00_bglt) (BgL_globalz00_772);
											BgL_obj1791z00_1414 =
												(BgL_sfunz00_bglt) (
												(((BgL_variablez00_bglt) CREF(BgL_obj1518z00_1413))->
													BgL_valuez00));
										}
										BgL_arg3228z00_782 =
											(((BgL_sfunz00_bglt) CREF(BgL_obj1791z00_1414))->
											BgL_bodyz00);
									}
									{	/* Ast/shrinkify.scm 30 */
										obj_t BgL_res3394z00_1441;

										{	/* Ast/shrinkify.scm 30 */
											BgL_nodez00_bglt BgL_nodez00_1415;

											BgL_nodez00_1415 =
												(BgL_nodez00_bglt) (BgL_arg3228z00_782);
											{	/* Ast/shrinkify.scm 30 */
												obj_t BgL_method3180z00_1416;

												{	/* Ast/shrinkify.scm 30 */
													BgL_objectz00_bglt BgL_objz00_1417;

													BgL_objz00_1417 =
														(BgL_objectz00_bglt) (BgL_nodez00_1415);
													{	/* Ast/shrinkify.scm 30 */
														long BgL_objzd2classzd2numz00_1418;

														BgL_objzd2classzd2numz00_1418 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1417);
														{	/* Ast/shrinkify.scm 30 */
															obj_t BgL_arg2551z00_1419;

															BgL_arg2551z00_1419 =
																PROCEDURE_REF
																(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 30 */
																obj_t BgL_arrayz00_1421;

																int BgL_offsetz00_1422;

																BgL_arrayz00_1421 = BgL_arg2551z00_1419;
																BgL_offsetz00_1422 =
																	(int) (BgL_objzd2classzd2numz00_1418);
																{	/* Ast/shrinkify.scm 30 */
																	long BgL_offsetz00_1423;

																	BgL_offsetz00_1423 =
																		((long) (BgL_offsetz00_1422) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 30 */
																		long BgL_modz00_1424;

																		{	/* Ast/shrinkify.scm 30 */
																			int BgL_arg2553z00_1425;

																			BgL_arg2553z00_1425 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 30 */
																				long BgL_auxz00_2661;

																				BgL_auxz00_2661 =
																					(long) (BgL_arg2553z00_1425);
																				BgL_modz00_1424 =
																					(BgL_offsetz00_1423 /
																					BgL_auxz00_2661);
																		}}
																		{	/* Ast/shrinkify.scm 30 */
																			long BgL_restz00_1426;

																			{	/* Ast/shrinkify.scm 30 */
																				int BgL_arg2552z00_1427;

																				BgL_arg2552z00_1427 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 30 */
																					long BgL_auxz00_2665;

																					BgL_auxz00_2665 =
																						(long) (BgL_arg2552z00_1427);
																					BgL_restz00_1426 =
																						(BgL_offsetz00_1423 %
																						BgL_auxz00_2665);
																			}}
																			{	/* Ast/shrinkify.scm 30 */

																				BgL_method3180z00_1416 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1421,
																						(int) (BgL_modz00_1424)),
																					(int) (BgL_restz00_1426));
												}}}}}}}}
												{	/* Ast/shrinkify.scm 30 */
													obj_t BgL_xz00_2543;

													BgL_xz00_2543 =
														PROCEDURE_ENTRY(BgL_method3180z00_1416)
														(BgL_method3180z00_1416, (obj_t) (BgL_nodez00_1415),
														BEOA);
													BgL_res3394z00_1441 = BUNSPEC;
										}}} BgL_res3394z00_1441;
						}}}}
						{
							obj_t BgL_l3161z00_2675;

							BgL_l3161z00_2675 = CDR(BgL_l3161z00_769);
							BgL_l3161z00_769 = BgL_l3161z00_2675;
							goto BgL_zc3anonymousza33222ze3z83_770;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_1;
		}
	}



/* _shrinkify! */
	obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_envz00_2473,
		obj_t BgL_globalsz00_2474)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2474);
		}
	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_26)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 221 */
			{
				obj_t BgL_l3175z00_787;

				BgL_l3175z00_787 = BgL_nodeza2za2_26;
			BgL_zc3anonymousza33231ze3z83_788:
				if (PAIRP(BgL_l3175z00_787))
					{	/* Ast/shrinkify.scm 222 */
						{	/* Ast/shrinkify.scm 222 */
							obj_t BgL_arg3233z00_790;

							BgL_arg3233z00_790 = CAR(BgL_l3175z00_787);
							{	/* Ast/shrinkify.scm 222 */
								obj_t BgL_res3397z00_1471;

								{	/* Ast/shrinkify.scm 222 */
									BgL_nodez00_bglt BgL_nodez00_1445;

									BgL_nodez00_1445 = (BgL_nodez00_bglt) (BgL_arg3233z00_790);
									{	/* Ast/shrinkify.scm 222 */
										obj_t BgL_method3180z00_1446;

										{	/* Ast/shrinkify.scm 222 */
											BgL_objectz00_bglt BgL_objz00_1447;

											BgL_objz00_1447 = (BgL_objectz00_bglt) (BgL_nodez00_1445);
											{	/* Ast/shrinkify.scm 222 */
												long BgL_objzd2classzd2numz00_1448;

												BgL_objzd2classzd2numz00_1448 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1447);
												{	/* Ast/shrinkify.scm 222 */
													obj_t BgL_arg2551z00_1449;

													BgL_arg2551z00_1449 =
														PROCEDURE_REF
														(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
														(int) (((long) 1)));
													{	/* Ast/shrinkify.scm 222 */
														obj_t BgL_arrayz00_1451;

														int BgL_offsetz00_1452;

														BgL_arrayz00_1451 = BgL_arg2551z00_1449;
														BgL_offsetz00_1452 =
															(int) (BgL_objzd2classzd2numz00_1448);
														{	/* Ast/shrinkify.scm 222 */
															long BgL_offsetz00_1453;

															BgL_offsetz00_1453 =
																((long) (BgL_offsetz00_1452) - OBJECT_TYPE);
															{	/* Ast/shrinkify.scm 222 */
																long BgL_modz00_1454;

																{	/* Ast/shrinkify.scm 222 */
																	int BgL_arg2553z00_1455;

																	BgL_arg2553z00_1455 = (int) (((long) 8));
																	{	/* Ast/shrinkify.scm 222 */
																		long BgL_auxz00_2690;

																		BgL_auxz00_2690 =
																			(long) (BgL_arg2553z00_1455);
																		BgL_modz00_1454 =
																			(BgL_offsetz00_1453 / BgL_auxz00_2690);
																}}
																{	/* Ast/shrinkify.scm 222 */
																	long BgL_restz00_1456;

																	{	/* Ast/shrinkify.scm 222 */
																		int BgL_arg2552z00_1457;

																		BgL_arg2552z00_1457 = (int) (((long) 8));
																		{	/* Ast/shrinkify.scm 222 */
																			long BgL_auxz00_2694;

																			BgL_auxz00_2694 =
																				(long) (BgL_arg2552z00_1457);
																			BgL_restz00_1456 =
																				(BgL_offsetz00_1453 % BgL_auxz00_2694);
																	}}
																	{	/* Ast/shrinkify.scm 222 */

																		BgL_method3180z00_1446 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1451,
																				(int) (BgL_modz00_1454)),
																			(int) (BgL_restz00_1456));
										}}}}}}}}
										{	/* Ast/shrinkify.scm 222 */
											obj_t BgL_xz00_2544;

											BgL_xz00_2544 =
												PROCEDURE_ENTRY(BgL_method3180z00_1446)
												(BgL_method3180z00_1446, (obj_t) (BgL_nodez00_1445),
												BEOA);
											BgL_res3397z00_1471 = BUNSPEC;
								}}} BgL_res3397z00_1471;
						}}
						{
							obj_t BgL_l3175z00_2704;

							BgL_l3175z00_2704 = CDR(BgL_l3175z00_787);
							BgL_l3175z00_787 = BgL_l3175z00_2704;
							goto BgL_zc3anonymousza33231ze3z83_788;
						}
					}
				else
					{	/* Ast/shrinkify.scm 222 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2variablez12zd2def3177zd2envzc0zzast_shrinkifyz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2nodez12zd2default3179zd2envzc0zzast_shrinkifyz00);
		}
	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_2)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method3178z00_1473;

				{	/* Ast/shrinkify.scm 37 */
					BgL_objectz00_bglt BgL_objz00_1474;

					BgL_objz00_1474 = (BgL_objectz00_bglt) (BgL_variablez00_2);
					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1475;

						BgL_objzd2classzd2numz00_1475 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1474);
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg2551z00_1476;

							BgL_arg2551z00_1476 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								obj_t BgL_arrayz00_1478;

								int BgL_offsetz00_1479;

								BgL_arrayz00_1478 = BgL_arg2551z00_1476;
								BgL_offsetz00_1479 = (int) (BgL_objzd2classzd2numz00_1475);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1480;

									BgL_offsetz00_1480 =
										((long) (BgL_offsetz00_1479) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1481;

										{	/* Ast/shrinkify.scm 37 */
											int BgL_arg2553z00_1482;

											BgL_arg2553z00_1482 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 37 */
												long BgL_auxz00_2716;

												BgL_auxz00_2716 = (long) (BgL_arg2553z00_1482);
												BgL_modz00_1481 =
													(BgL_offsetz00_1480 / BgL_auxz00_2716);
										}}
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1483;

											{	/* Ast/shrinkify.scm 37 */
												int BgL_arg2552z00_1484;

												BgL_arg2552z00_1484 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 37 */
													long BgL_auxz00_2720;

													BgL_auxz00_2720 = (long) (BgL_arg2552z00_1484);
													BgL_restz00_1483 =
														(BgL_offsetz00_1480 % BgL_auxz00_2720);
											}}
											{	/* Ast/shrinkify.scm 37 */

												BgL_method3178z00_1473 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1478,
														(int) (BgL_modz00_1481)), (int) (BgL_restz00_1483));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3178z00_1473) (BgL_method3178z00_1473,
					(obj_t) (BgL_variablez00_2), BEOA);
			}
		}
	}



/* _shrink-variable! */
	obj_t BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00(obj_t BgL_envz00_2475,
		obj_t BgL_variablez00_2476)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2476));
		}
	}



/* shrink-variable!-def3177 */
	obj_t
		BGl_shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_3)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 38 */
				bool_t BgL_testz00_2732;

				{	/* Ast/shrinkify.scm 38 */
					bool_t BgL_testz00_2733;

					{	/* Ast/shrinkify.scm 38 */
						obj_t BgL_auxz00_2734;

						{	/* Ast/shrinkify.scm 38 */
							BgL_objectz00_bglt BgL_auxz00_2735;

							BgL_auxz00_2735 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BgL_auxz00_2734 = BGL_OBJECT_WIDENING(BgL_auxz00_2735);
						}
						BgL_testz00_2733 = CBOOL(BgL_auxz00_2734);
					}
					if (BgL_testz00_2733)
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2732 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2732 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2732)
					{	/* Ast/shrinkify.scm 38 */
						{	/* Ast/shrinkify.scm 39 */
							long BgL_arg3285z00_1168;

							{	/* Ast/shrinkify.scm 39 */
								obj_t BgL_arg3286z00_1169;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg3287z00_1170;

									{	/* Ast/shrinkify.scm 39 */
										BgL_objectz00_bglt BgL_objectz00_1501;

										BgL_objectz00_1501 =
											(BgL_objectz00_bglt) (BgL_variablez00_3);
										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg2554z00_1502;

											{	/* Ast/shrinkify.scm 39 */
												long BgL_arg2556z00_1503;

												BgL_arg2556z00_1503 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1501);
												BgL_arg2554z00_1502 =
													(BgL_arg2556z00_1503 - OBJECT_TYPE);
											}
											BgL_arg3287z00_1170 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2554z00_1502));
									}}
									BgL_arg3286z00_1169 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3287z00_1170);
								}
								BgL_arg3285z00_1168 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3286z00_1169);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_variablez00_3), BgL_arg3285z00_1168);
						}
						{	/* Ast/shrinkify.scm 39 */
							BgL_objectz00_bglt BgL_auxz00_2748;

							BgL_auxz00_2748 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2748, BFALSE);
						}
						(obj_t) (BgL_variablez00_3);
					}
				else
					{	/* Ast/shrinkify.scm 38 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 40 */
				bool_t BgL_testz00_2752;

				{	/* Ast/shrinkify.scm 40 */
					bool_t BgL_testz00_2753;

					{	/* Ast/shrinkify.scm 40 */
						obj_t BgL_auxz00_2754;

						{	/* Ast/shrinkify.scm 40 */
							BgL_objectz00_bglt BgL_auxz00_2755;

							BgL_auxz00_2755 =
								(BgL_objectz00_bglt) (
								(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->
									BgL_valuez00));
							BgL_auxz00_2754 = BGL_OBJECT_WIDENING(BgL_auxz00_2755);
						}
						BgL_testz00_2753 = CBOOL(BgL_auxz00_2754);
					}
					if (BgL_testz00_2753)
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2752 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2752 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2752)
					{	/* Ast/shrinkify.scm 41 */
						BgL_valuez00_bglt BgL_o3144z00_1172;

						BgL_o3144z00_1172 =
							(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->BgL_valuez00);
						{	/* Ast/shrinkify.scm 41 */
							long BgL_arg3289z00_1173;

							{	/* Ast/shrinkify.scm 41 */
								obj_t BgL_arg3290z00_1174;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg3291z00_1175;

									{	/* Ast/shrinkify.scm 41 */
										BgL_objectz00_bglt BgL_objectz00_1516;

										BgL_objectz00_1516 =
											(BgL_objectz00_bglt) (BgL_o3144z00_1172);
										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg2554z00_1517;

											{	/* Ast/shrinkify.scm 41 */
												long BgL_arg2556z00_1518;

												BgL_arg2556z00_1518 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1516);
												BgL_arg2554z00_1517 =
													(BgL_arg2556z00_1518 - OBJECT_TYPE);
											}
											BgL_arg3291z00_1175 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2554z00_1517));
									}}
									BgL_arg3290z00_1174 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3291z00_1175);
								}
								BgL_arg3289z00_1173 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3290z00_1174);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_o3144z00_1172), BgL_arg3289z00_1173);
						}
						{	/* Ast/shrinkify.scm 41 */
							BgL_objectz00_bglt BgL_auxz00_2770;

							BgL_auxz00_2770 = (BgL_objectz00_bglt) (BgL_o3144z00_1172);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2770, BFALSE);
						}
						return (obj_t) (BgL_o3144z00_1172);
					}
				else
					{	/* Ast/shrinkify.scm 40 */
						return BFALSE;
					}
			}
		}
	}



/* _shrink-variable!-def3177 */
	obj_t BGl__shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2479, obj_t BgL_variablez00_2480)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2variablez12zd2def3177z12zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2480));
		}
	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_4)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method3180z00_1526;

				{	/* Ast/shrinkify.scm 46 */
					BgL_objectz00_bglt BgL_objz00_1527;

					BgL_objz00_1527 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1528;

						BgL_objzd2classzd2numz00_1528 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1527);
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg2551z00_1529;

							BgL_arg2551z00_1529 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								obj_t BgL_arrayz00_1531;

								int BgL_offsetz00_1532;

								BgL_arrayz00_1531 = BgL_arg2551z00_1529;
								BgL_offsetz00_1532 = (int) (BgL_objzd2classzd2numz00_1528);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1533;

									BgL_offsetz00_1533 =
										((long) (BgL_offsetz00_1532) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1534;

										{	/* Ast/shrinkify.scm 46 */
											int BgL_arg2553z00_1535;

											BgL_arg2553z00_1535 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 46 */
												long BgL_auxz00_2784;

												BgL_auxz00_2784 = (long) (BgL_arg2553z00_1535);
												BgL_modz00_1534 =
													(BgL_offsetz00_1533 / BgL_auxz00_2784);
										}}
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1536;

											{	/* Ast/shrinkify.scm 46 */
												int BgL_arg2552z00_1537;

												BgL_arg2552z00_1537 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 46 */
													long BgL_auxz00_2788;

													BgL_auxz00_2788 = (long) (BgL_arg2552z00_1537);
													BgL_restz00_1536 =
														(BgL_offsetz00_1533 % BgL_auxz00_2788);
											}}
											{	/* Ast/shrinkify.scm 46 */

												BgL_method3180z00_1526 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1531,
														(int) (BgL_modz00_1534)), (int) (BgL_restz00_1536));
				}}}}}}}}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_2545;

					BgL_xz00_2545 =
						PROCEDURE_ENTRY(BgL_method3180z00_1526) (BgL_method3180z00_1526,
						(obj_t) (BgL_nodez00_4), BEOA);
					return BUNSPEC;
				}
			}
		}
	}



/* _shrink-node! */
	obj_t BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00(obj_t BgL_envz00_2477,
		obj_t BgL_nodez00_2478)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2478));
		}
	}



/* shrink-node!-default3179 */
	obj_t BGl_shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_xz00_2546;

				BgL_xz00_2546 =
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string3495z00zzast_shrinkifyz00, (obj_t) (BgL_nodez00_5));
				return BUNSPEC;
			}
		}
	}



/* _shrink-node!-default3179 */
	obj_t BGl__shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2481, obj_t BgL_nodez00_2482)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2nodez12zd2default3179z12zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2482));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc3496z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc3497z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc3498z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3499z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc3500z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3501z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3502z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc3503z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc3504z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc3505z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3506z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc3507z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_selectz00zzast_nodez00, BGl_proc3508z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3509z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3510z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3511z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3512z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3513z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3514z00zzast_shrinkifyz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3515z00zzast_shrinkifyz00);
		}
	}



/* shrink-node!-jump-ex3220 */
	obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3220zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2503, obj_t BgL_nodez00_2504)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 213 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1373;

				BgL_nodez00_1373 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2504);
				{	/* Ast/shrinkify.scm 214 */
					BgL_nodez00_bglt BgL_arg3387z00_1376;

					BgL_arg3387z00_1376 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1373))->
						BgL_exitz00);
					{	/* Ast/shrinkify.scm 214 */
						obj_t BgL_res3491z00_2444;

						{	/* Ast/shrinkify.scm 214 */
							obj_t BgL_method3180z00_2419;

							{	/* Ast/shrinkify.scm 214 */
								BgL_objectz00_bglt BgL_objz00_2420;

								BgL_objz00_2420 = (BgL_objectz00_bglt) (BgL_arg3387z00_1376);
								{	/* Ast/shrinkify.scm 214 */
									long BgL_objzd2classzd2numz00_2421;

									BgL_objzd2classzd2numz00_2421 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2420);
									{	/* Ast/shrinkify.scm 214 */
										obj_t BgL_arg2551z00_2422;

										BgL_arg2551z00_2422 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 214 */
											obj_t BgL_arrayz00_2424;

											int BgL_offsetz00_2425;

											BgL_arrayz00_2424 = BgL_arg2551z00_2422;
											BgL_offsetz00_2425 =
												(int) (BgL_objzd2classzd2numz00_2421);
											{	/* Ast/shrinkify.scm 214 */
												long BgL_offsetz00_2426;

												BgL_offsetz00_2426 =
													((long) (BgL_offsetz00_2425) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 214 */
													long BgL_modz00_2427;

													{	/* Ast/shrinkify.scm 214 */
														int BgL_arg2553z00_2428;

														BgL_arg2553z00_2428 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 214 */
															long BgL_auxz00_2834;

															BgL_auxz00_2834 = (long) (BgL_arg2553z00_2428);
															BgL_modz00_2427 =
																(BgL_offsetz00_2426 / BgL_auxz00_2834);
													}}
													{	/* Ast/shrinkify.scm 214 */
														long BgL_restz00_2429;

														{	/* Ast/shrinkify.scm 214 */
															int BgL_arg2552z00_2430;

															BgL_arg2552z00_2430 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 214 */
																long BgL_auxz00_2838;

																BgL_auxz00_2838 = (long) (BgL_arg2552z00_2430);
																BgL_restz00_2429 =
																	(BgL_offsetz00_2426 % BgL_auxz00_2838);
														}}
														{	/* Ast/shrinkify.scm 214 */

															BgL_method3180z00_2419 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2424,
																	(int) (BgL_modz00_2427)),
																(int) (BgL_restz00_2429));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 214 */
								obj_t BgL_xz00_2547;

								BgL_xz00_2547 =
									PROCEDURE_ENTRY(BgL_method3180z00_2419)
									(BgL_method3180z00_2419, (obj_t) (BgL_arg3387z00_1376), BEOA);
								BgL_res3491z00_2444 = BUNSPEC;
						}} BgL_res3491z00_2444;
				}}
				{	/* Ast/shrinkify.scm 215 */
					BgL_nodez00_bglt BgL_arg3388z00_1377;

					BgL_arg3388z00_1377 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1373))->
						BgL_valuez00);
					{	/* Ast/shrinkify.scm 215 */
						obj_t BgL_res3494z00_2472;

						{	/* Ast/shrinkify.scm 215 */
							obj_t BgL_method3180z00_2447;

							{	/* Ast/shrinkify.scm 215 */
								BgL_objectz00_bglt BgL_objz00_2448;

								BgL_objz00_2448 = (BgL_objectz00_bglt) (BgL_arg3388z00_1377);
								{	/* Ast/shrinkify.scm 215 */
									long BgL_objzd2classzd2numz00_2449;

									BgL_objzd2classzd2numz00_2449 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2448);
									{	/* Ast/shrinkify.scm 215 */
										obj_t BgL_arg2551z00_2450;

										BgL_arg2551z00_2450 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 215 */
											obj_t BgL_arrayz00_2452;

											int BgL_offsetz00_2453;

											BgL_arrayz00_2452 = BgL_arg2551z00_2450;
											BgL_offsetz00_2453 =
												(int) (BgL_objzd2classzd2numz00_2449);
											{	/* Ast/shrinkify.scm 215 */
												long BgL_offsetz00_2454;

												BgL_offsetz00_2454 =
													((long) (BgL_offsetz00_2453) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 215 */
													long BgL_modz00_2455;

													{	/* Ast/shrinkify.scm 215 */
														int BgL_arg2553z00_2456;

														BgL_arg2553z00_2456 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 215 */
															long BgL_auxz00_2857;

															BgL_auxz00_2857 = (long) (BgL_arg2553z00_2456);
															BgL_modz00_2455 =
																(BgL_offsetz00_2454 / BgL_auxz00_2857);
													}}
													{	/* Ast/shrinkify.scm 215 */
														long BgL_restz00_2457;

														{	/* Ast/shrinkify.scm 215 */
															int BgL_arg2552z00_2458;

															BgL_arg2552z00_2458 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 215 */
																long BgL_auxz00_2861;

																BgL_auxz00_2861 = (long) (BgL_arg2552z00_2458);
																BgL_restz00_2457 =
																	(BgL_offsetz00_2454 % BgL_auxz00_2861);
														}}
														{	/* Ast/shrinkify.scm 215 */

															BgL_method3180z00_2447 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2452,
																	(int) (BgL_modz00_2455)),
																(int) (BgL_restz00_2457));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 215 */
								obj_t BgL_xz00_2548;

								BgL_xz00_2548 =
									PROCEDURE_ENTRY(BgL_method3180z00_2447)
									(BgL_method3180z00_2447, (obj_t) (BgL_arg3388z00_1377), BEOA);
								BgL_res3494z00_2472 = BUNSPEC;
						}} BgL_res3494z00_2472;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-set-ex-3218 */
	obj_t BGl_shrinkzd2nodez12zd2setzd2exzd23218z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2505, obj_t BgL_nodez00_2506)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 204 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1365;

				BgL_nodez00_1365 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2506);
				{	/* Ast/shrinkify.scm 206 */
					BgL_varz00_bglt BgL_arg3384z00_1369;

					BgL_arg3384z00_1369 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1365))->BgL_varz00);
					{	/* Ast/shrinkify.scm 206 */
						obj_t BgL_res3485z00_2388;

						{	/* Ast/shrinkify.scm 206 */
							BgL_nodez00_bglt BgL_nodez00_2362;

							BgL_nodez00_2362 = (BgL_nodez00_bglt) (BgL_arg3384z00_1369);
							{	/* Ast/shrinkify.scm 206 */
								obj_t BgL_method3180z00_2363;

								{	/* Ast/shrinkify.scm 206 */
									BgL_objectz00_bglt BgL_objz00_2364;

									BgL_objz00_2364 = (BgL_objectz00_bglt) (BgL_nodez00_2362);
									{	/* Ast/shrinkify.scm 206 */
										long BgL_objzd2classzd2numz00_2365;

										BgL_objzd2classzd2numz00_2365 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2364);
										{	/* Ast/shrinkify.scm 206 */
											obj_t BgL_arg2551z00_2366;

											BgL_arg2551z00_2366 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 206 */
												obj_t BgL_arrayz00_2368;

												int BgL_offsetz00_2369;

												BgL_arrayz00_2368 = BgL_arg2551z00_2366;
												BgL_offsetz00_2369 =
													(int) (BgL_objzd2classzd2numz00_2365);
												{	/* Ast/shrinkify.scm 206 */
													long BgL_offsetz00_2370;

													BgL_offsetz00_2370 =
														((long) (BgL_offsetz00_2369) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 206 */
														long BgL_modz00_2371;

														{	/* Ast/shrinkify.scm 206 */
															int BgL_arg2553z00_2372;

															BgL_arg2553z00_2372 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 206 */
																long BgL_auxz00_2882;

																BgL_auxz00_2882 = (long) (BgL_arg2553z00_2372);
																BgL_modz00_2371 =
																	(BgL_offsetz00_2370 / BgL_auxz00_2882);
														}}
														{	/* Ast/shrinkify.scm 206 */
															long BgL_restz00_2373;

															{	/* Ast/shrinkify.scm 206 */
																int BgL_arg2552z00_2374;

																BgL_arg2552z00_2374 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 206 */
																	long BgL_auxz00_2886;

																	BgL_auxz00_2886 =
																		(long) (BgL_arg2552z00_2374);
																	BgL_restz00_2373 =
																		(BgL_offsetz00_2370 % BgL_auxz00_2886);
															}}
															{	/* Ast/shrinkify.scm 206 */

																BgL_method3180z00_2363 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2368,
																		(int) (BgL_modz00_2371)),
																	(int) (BgL_restz00_2373));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 206 */
									obj_t BgL_xz00_2549;

									BgL_xz00_2549 =
										PROCEDURE_ENTRY(BgL_method3180z00_2363)
										(BgL_method3180z00_2363, (obj_t) (BgL_nodez00_2362), BEOA);
									BgL_res3485z00_2388 = BUNSPEC;
						}}} BgL_res3485z00_2388;
				}}
				{	/* Ast/shrinkify.scm 207 */
					BgL_nodez00_bglt BgL_arg3385z00_1370;

					BgL_arg3385z00_1370 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1365))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 207 */
						obj_t BgL_res3488z00_2416;

						{	/* Ast/shrinkify.scm 207 */
							obj_t BgL_method3180z00_2391;

							{	/* Ast/shrinkify.scm 207 */
								BgL_objectz00_bglt BgL_objz00_2392;

								BgL_objz00_2392 = (BgL_objectz00_bglt) (BgL_arg3385z00_1370);
								{	/* Ast/shrinkify.scm 207 */
									long BgL_objzd2classzd2numz00_2393;

									BgL_objzd2classzd2numz00_2393 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2392);
									{	/* Ast/shrinkify.scm 207 */
										obj_t BgL_arg2551z00_2394;

										BgL_arg2551z00_2394 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 207 */
											obj_t BgL_arrayz00_2396;

											int BgL_offsetz00_2397;

											BgL_arrayz00_2396 = BgL_arg2551z00_2394;
											BgL_offsetz00_2397 =
												(int) (BgL_objzd2classzd2numz00_2393);
											{	/* Ast/shrinkify.scm 207 */
												long BgL_offsetz00_2398;

												BgL_offsetz00_2398 =
													((long) (BgL_offsetz00_2397) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 207 */
													long BgL_modz00_2399;

													{	/* Ast/shrinkify.scm 207 */
														int BgL_arg2553z00_2400;

														BgL_arg2553z00_2400 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 207 */
															long BgL_auxz00_2905;

															BgL_auxz00_2905 = (long) (BgL_arg2553z00_2400);
															BgL_modz00_2399 =
																(BgL_offsetz00_2398 / BgL_auxz00_2905);
													}}
													{	/* Ast/shrinkify.scm 207 */
														long BgL_restz00_2401;

														{	/* Ast/shrinkify.scm 207 */
															int BgL_arg2552z00_2402;

															BgL_arg2552z00_2402 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 207 */
																long BgL_auxz00_2909;

																BgL_auxz00_2909 = (long) (BgL_arg2552z00_2402);
																BgL_restz00_2401 =
																	(BgL_offsetz00_2398 % BgL_auxz00_2909);
														}}
														{	/* Ast/shrinkify.scm 207 */

															BgL_method3180z00_2391 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2396,
																	(int) (BgL_modz00_2399)),
																(int) (BgL_restz00_2401));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 207 */
								obj_t BgL_xz00_2550;

								BgL_xz00_2550 =
									PROCEDURE_ENTRY(BgL_method3180z00_2391)
									(BgL_method3180z00_2391, (obj_t) (BgL_arg3385z00_1370), BEOA);
								BgL_res3488z00_2416 = BUNSPEC;
						}} BgL_res3488z00_2416;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-var3216 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2var3216zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2507, obj_t BgL_nodez00_2508)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 192 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1348;

				BgL_nodez00_1348 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2508);
				{	/* Ast/shrinkify.scm 194 */
					BgL_nodez00_bglt BgL_arg3376z00_1352;

					BgL_arg3376z00_1352 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1348))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 194 */
						obj_t BgL_res3477z00_2301;

						{	/* Ast/shrinkify.scm 194 */
							obj_t BgL_method3180z00_2276;

							{	/* Ast/shrinkify.scm 194 */
								BgL_objectz00_bglt BgL_objz00_2277;

								BgL_objz00_2277 = (BgL_objectz00_bglt) (BgL_arg3376z00_1352);
								{	/* Ast/shrinkify.scm 194 */
									long BgL_objzd2classzd2numz00_2278;

									BgL_objzd2classzd2numz00_2278 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2277);
									{	/* Ast/shrinkify.scm 194 */
										obj_t BgL_arg2551z00_2279;

										BgL_arg2551z00_2279 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 194 */
											obj_t BgL_arrayz00_2281;

											int BgL_offsetz00_2282;

											BgL_arrayz00_2281 = BgL_arg2551z00_2279;
											BgL_offsetz00_2282 =
												(int) (BgL_objzd2classzd2numz00_2278);
											{	/* Ast/shrinkify.scm 194 */
												long BgL_offsetz00_2283;

												BgL_offsetz00_2283 =
													((long) (BgL_offsetz00_2282) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 194 */
													long BgL_modz00_2284;

													{	/* Ast/shrinkify.scm 194 */
														int BgL_arg2553z00_2285;

														BgL_arg2553z00_2285 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 194 */
															long BgL_auxz00_2929;

															BgL_auxz00_2929 = (long) (BgL_arg2553z00_2285);
															BgL_modz00_2284 =
																(BgL_offsetz00_2283 / BgL_auxz00_2929);
													}}
													{	/* Ast/shrinkify.scm 194 */
														long BgL_restz00_2286;

														{	/* Ast/shrinkify.scm 194 */
															int BgL_arg2552z00_2287;

															BgL_arg2552z00_2287 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 194 */
																long BgL_auxz00_2933;

																BgL_auxz00_2933 = (long) (BgL_arg2552z00_2287);
																BgL_restz00_2286 =
																	(BgL_offsetz00_2283 % BgL_auxz00_2933);
														}}
														{	/* Ast/shrinkify.scm 194 */

															BgL_method3180z00_2276 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2281,
																	(int) (BgL_modz00_2284)),
																(int) (BgL_restz00_2286));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 194 */
								obj_t BgL_xz00_2551;

								BgL_xz00_2551 =
									PROCEDURE_ENTRY(BgL_method3180z00_2276)
									(BgL_method3180z00_2276, (obj_t) (BgL_arg3376z00_1352), BEOA);
								BgL_res3477z00_2301 = BUNSPEC;
						}} BgL_res3477z00_2301;
				}}
				{	/* Ast/shrinkify.scm 195 */
					obj_t BgL_g3174z00_1353;

					BgL_g3174z00_1353 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1348))->BgL_bindingsz00);
					{
						obj_t BgL_l3172z00_1355;

						BgL_l3172z00_1355 = BgL_g3174z00_1353;
					BgL_zc3anonymousza33377ze3z83_1356:
						if (PAIRP(BgL_l3172z00_1355))
							{	/* Ast/shrinkify.scm 195 */
								{	/* Ast/shrinkify.scm 197 */
									obj_t BgL_bindingz00_1358;

									BgL_bindingz00_1358 = CAR(BgL_l3172z00_1355);
									{	/* Ast/shrinkify.scm 196 */
										obj_t BgL_arg3380z00_1359;

										BgL_arg3380z00_1359 = CAR(BgL_bindingz00_1358);
										{	/* Ast/shrinkify.scm 196 */
											BgL_variablez00_bglt BgL_variablez00_2306;

											BgL_variablez00_2306 =
												(BgL_variablez00_bglt) (BgL_arg3380z00_1359);
											{	/* Ast/shrinkify.scm 196 */
												obj_t BgL_method3178z00_2307;

												{	/* Ast/shrinkify.scm 196 */
													BgL_objectz00_bglt BgL_objz00_2308;

													BgL_objz00_2308 =
														(BgL_objectz00_bglt) (BgL_variablez00_2306);
													{	/* Ast/shrinkify.scm 196 */
														long BgL_objzd2classzd2numz00_2309;

														BgL_objzd2classzd2numz00_2309 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2308);
														{	/* Ast/shrinkify.scm 196 */
															obj_t BgL_arg2551z00_2310;

															BgL_arg2551z00_2310 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 196 */
																obj_t BgL_arrayz00_2312;

																int BgL_offsetz00_2313;

																BgL_arrayz00_2312 = BgL_arg2551z00_2310;
																BgL_offsetz00_2313 =
																	(int) (BgL_objzd2classzd2numz00_2309);
																{	/* Ast/shrinkify.scm 196 */
																	long BgL_offsetz00_2314;

																	BgL_offsetz00_2314 =
																		((long) (BgL_offsetz00_2313) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 196 */
																		long BgL_modz00_2315;

																		{	/* Ast/shrinkify.scm 196 */
																			int BgL_arg2553z00_2316;

																			BgL_arg2553z00_2316 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 196 */
																				long BgL_auxz00_2957;

																				BgL_auxz00_2957 =
																					(long) (BgL_arg2553z00_2316);
																				BgL_modz00_2315 =
																					(BgL_offsetz00_2314 /
																					BgL_auxz00_2957);
																		}}
																		{	/* Ast/shrinkify.scm 196 */
																			long BgL_restz00_2317;

																			{	/* Ast/shrinkify.scm 196 */
																				int BgL_arg2552z00_2318;

																				BgL_arg2552z00_2318 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 196 */
																					long BgL_auxz00_2961;

																					BgL_auxz00_2961 =
																						(long) (BgL_arg2552z00_2318);
																					BgL_restz00_2317 =
																						(BgL_offsetz00_2314 %
																						BgL_auxz00_2961);
																			}}
																			{	/* Ast/shrinkify.scm 196 */

																				BgL_method3178z00_2307 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2312,
																						(int) (BgL_modz00_2315)),
																					(int) (BgL_restz00_2317));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3178z00_2307)
													(BgL_method3178z00_2307,
													(obj_t) (BgL_variablez00_2306), BEOA);
									}}}
									{	/* Ast/shrinkify.scm 197 */
										obj_t BgL_arg3381z00_1360;

										BgL_arg3381z00_1360 = CDR(BgL_bindingz00_1358);
										{	/* Ast/shrinkify.scm 197 */
											obj_t BgL_res3482z00_2359;

											{	/* Ast/shrinkify.scm 197 */
												BgL_nodez00_bglt BgL_nodez00_2333;

												BgL_nodez00_2333 =
													(BgL_nodez00_bglt) (BgL_arg3381z00_1360);
												{	/* Ast/shrinkify.scm 197 */
													obj_t BgL_method3180z00_2334;

													{	/* Ast/shrinkify.scm 197 */
														BgL_objectz00_bglt BgL_objz00_2335;

														BgL_objz00_2335 =
															(BgL_objectz00_bglt) (BgL_nodez00_2333);
														{	/* Ast/shrinkify.scm 197 */
															long BgL_objzd2classzd2numz00_2336;

															BgL_objzd2classzd2numz00_2336 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2335);
															{	/* Ast/shrinkify.scm 197 */
																obj_t BgL_arg2551z00_2337;

																BgL_arg2551z00_2337 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 197 */
																	obj_t BgL_arrayz00_2339;

																	int BgL_offsetz00_2340;

																	BgL_arrayz00_2339 = BgL_arg2551z00_2337;
																	BgL_offsetz00_2340 =
																		(int) (BgL_objzd2classzd2numz00_2336);
																	{	/* Ast/shrinkify.scm 197 */
																		long BgL_offsetz00_2341;

																		BgL_offsetz00_2341 =
																			(
																			(long) (BgL_offsetz00_2340) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 197 */
																			long BgL_modz00_2342;

																			{	/* Ast/shrinkify.scm 197 */
																				int BgL_arg2553z00_2343;

																				BgL_arg2553z00_2343 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 197 */
																					long BgL_auxz00_2981;

																					BgL_auxz00_2981 =
																						(long) (BgL_arg2553z00_2343);
																					BgL_modz00_2342 =
																						(BgL_offsetz00_2341 /
																						BgL_auxz00_2981);
																			}}
																			{	/* Ast/shrinkify.scm 197 */
																				long BgL_restz00_2344;

																				{	/* Ast/shrinkify.scm 197 */
																					int BgL_arg2552z00_2345;

																					BgL_arg2552z00_2345 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 197 */
																						long BgL_auxz00_2985;

																						BgL_auxz00_2985 =
																							(long) (BgL_arg2552z00_2345);
																						BgL_restz00_2344 =
																							(BgL_offsetz00_2341 %
																							BgL_auxz00_2985);
																				}}
																				{	/* Ast/shrinkify.scm 197 */

																					BgL_method3180z00_2334 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2339,
																							(int) (BgL_modz00_2342)),
																						(int) (BgL_restz00_2344));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 197 */
														obj_t BgL_xz00_2552;

														BgL_xz00_2552 =
															PROCEDURE_ENTRY(BgL_method3180z00_2334)
															(BgL_method3180z00_2334,
															(obj_t) (BgL_nodez00_2333), BEOA);
														BgL_res3482z00_2359 = BUNSPEC;
											}}} BgL_res3482z00_2359;
								}}}
								{
									obj_t BgL_l3172z00_2995;

									BgL_l3172z00_2995 = CDR(BgL_l3172z00_1355);
									BgL_l3172z00_1355 = BgL_l3172z00_2995;
									goto BgL_zc3anonymousza33377ze3z83_1356;
								}
							}
						else
							{	/* Ast/shrinkify.scm 195 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-fun3214 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2fun3214zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2509, obj_t BgL_nodez00_2510)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 178 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1323;

				BgL_nodez00_1323 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2510);
				{	/* Ast/shrinkify.scm 180 */
					BgL_nodez00_bglt BgL_arg3366z00_1327;

					BgL_arg3366z00_1327 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1323))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 180 */
						obj_t BgL_res3467z00_2184;

						{	/* Ast/shrinkify.scm 180 */
							obj_t BgL_method3180z00_2159;

							{	/* Ast/shrinkify.scm 180 */
								BgL_objectz00_bglt BgL_objz00_2160;

								BgL_objz00_2160 = (BgL_objectz00_bglt) (BgL_arg3366z00_1327);
								{	/* Ast/shrinkify.scm 180 */
									long BgL_objzd2classzd2numz00_2161;

									BgL_objzd2classzd2numz00_2161 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2160);
									{	/* Ast/shrinkify.scm 180 */
										obj_t BgL_arg2551z00_2162;

										BgL_arg2551z00_2162 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 180 */
											obj_t BgL_arrayz00_2164;

											int BgL_offsetz00_2165;

											BgL_arrayz00_2164 = BgL_arg2551z00_2162;
											BgL_offsetz00_2165 =
												(int) (BgL_objzd2classzd2numz00_2161);
											{	/* Ast/shrinkify.scm 180 */
												long BgL_offsetz00_2166;

												BgL_offsetz00_2166 =
													((long) (BgL_offsetz00_2165) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 180 */
													long BgL_modz00_2167;

													{	/* Ast/shrinkify.scm 180 */
														int BgL_arg2553z00_2168;

														BgL_arg2553z00_2168 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 180 */
															long BgL_auxz00_3007;

															BgL_auxz00_3007 = (long) (BgL_arg2553z00_2168);
															BgL_modz00_2167 =
																(BgL_offsetz00_2166 / BgL_auxz00_3007);
													}}
													{	/* Ast/shrinkify.scm 180 */
														long BgL_restz00_2169;

														{	/* Ast/shrinkify.scm 180 */
															int BgL_arg2552z00_2170;

															BgL_arg2552z00_2170 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 180 */
																long BgL_auxz00_3011;

																BgL_auxz00_3011 = (long) (BgL_arg2552z00_2170);
																BgL_restz00_2169 =
																	(BgL_offsetz00_2166 % BgL_auxz00_3011);
														}}
														{	/* Ast/shrinkify.scm 180 */

															BgL_method3180z00_2159 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2164,
																	(int) (BgL_modz00_2167)),
																(int) (BgL_restz00_2169));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 180 */
								obj_t BgL_xz00_2553;

								BgL_xz00_2553 =
									PROCEDURE_ENTRY(BgL_method3180z00_2159)
									(BgL_method3180z00_2159, (obj_t) (BgL_arg3366z00_1327), BEOA);
								BgL_res3467z00_2184 = BUNSPEC;
						}} BgL_res3467z00_2184;
				}}
				{	/* Ast/shrinkify.scm 181 */
					obj_t BgL_g3171z00_1328;

					BgL_g3171z00_1328 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1323))->BgL_localsz00);
					{
						obj_t BgL_l3169z00_1330;

						BgL_l3169z00_1330 = BgL_g3171z00_1328;
					BgL_zc3anonymousza33367ze3z83_1331:
						if (PAIRP(BgL_l3169z00_1330))
							{	/* Ast/shrinkify.scm 181 */
								{	/* Ast/shrinkify.scm 182 */
									obj_t BgL_localz00_1333;

									BgL_localz00_1333 = CAR(BgL_l3169z00_1330);
									{	/* Ast/shrinkify.scm 182 */
										BgL_valuez00_bglt BgL_sfunz00_1334;

										{
											BgL_variablez00_bglt BgL_auxz00_3025;

											BgL_auxz00_3025 =
												(BgL_variablez00_bglt) (BgL_localz00_1333);
											BgL_sfunz00_1334 =
												(((BgL_variablez00_bglt) CREF(BgL_auxz00_3025))->
												BgL_valuez00);
										}
										{	/* Ast/shrinkify.scm 183 */
											BgL_variablez00_bglt BgL_variablez00_2189;

											BgL_variablez00_2189 =
												(BgL_variablez00_bglt) (BgL_localz00_1333);
											{	/* Ast/shrinkify.scm 183 */
												obj_t BgL_method3178z00_2190;

												{	/* Ast/shrinkify.scm 183 */
													BgL_objectz00_bglt BgL_objz00_2191;

													BgL_objz00_2191 =
														(BgL_objectz00_bglt) (BgL_variablez00_2189);
													{	/* Ast/shrinkify.scm 183 */
														long BgL_objzd2classzd2numz00_2192;

														BgL_objzd2classzd2numz00_2192 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2191);
														{	/* Ast/shrinkify.scm 183 */
															obj_t BgL_arg2551z00_2193;

															BgL_arg2551z00_2193 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 183 */
																obj_t BgL_arrayz00_2195;

																int BgL_offsetz00_2196;

																BgL_arrayz00_2195 = BgL_arg2551z00_2193;
																BgL_offsetz00_2196 =
																	(int) (BgL_objzd2classzd2numz00_2192);
																{	/* Ast/shrinkify.scm 183 */
																	long BgL_offsetz00_2197;

																	BgL_offsetz00_2197 =
																		((long) (BgL_offsetz00_2196) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 183 */
																		long BgL_modz00_2198;

																		{	/* Ast/shrinkify.scm 183 */
																			int BgL_arg2553z00_2199;

																			BgL_arg2553z00_2199 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 183 */
																				long BgL_auxz00_3037;

																				BgL_auxz00_3037 =
																					(long) (BgL_arg2553z00_2199);
																				BgL_modz00_2198 =
																					(BgL_offsetz00_2197 /
																					BgL_auxz00_3037);
																		}}
																		{	/* Ast/shrinkify.scm 183 */
																			long BgL_restz00_2200;

																			{	/* Ast/shrinkify.scm 183 */
																				int BgL_arg2552z00_2201;

																				BgL_arg2552z00_2201 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 183 */
																					long BgL_auxz00_3041;

																					BgL_auxz00_3041 =
																						(long) (BgL_arg2552z00_2201);
																					BgL_restz00_2200 =
																						(BgL_offsetz00_2197 %
																						BgL_auxz00_3041);
																			}}
																			{	/* Ast/shrinkify.scm 183 */

																				BgL_method3178z00_2190 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2195,
																						(int) (BgL_modz00_2198)),
																					(int) (BgL_restz00_2200));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3178z00_2190)
													(BgL_method3178z00_2190,
													(obj_t) (BgL_variablez00_2189), BEOA);
										}}
										{	/* Ast/shrinkify.scm 184 */
											obj_t BgL_g3168z00_1335;

											{
												BgL_sfunz00_bglt BgL_auxz00_3051;

												BgL_auxz00_3051 = (BgL_sfunz00_bglt) (BgL_sfunz00_1334);
												BgL_g3168z00_1335 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3051))->
													BgL_argsz00);
											}
											{
												obj_t BgL_l3166z00_1337;

												BgL_l3166z00_1337 = BgL_g3168z00_1335;
											BgL_zc3anonymousza33369ze3z83_1338:
												if (PAIRP(BgL_l3166z00_1337))
													{	/* Ast/shrinkify.scm 184 */
														{	/* Ast/shrinkify.scm 184 */
															obj_t BgL_arg3371z00_1340;

															BgL_arg3371z00_1340 = CAR(BgL_l3166z00_1337);
															{	/* Ast/shrinkify.scm 184 */
																BgL_variablez00_bglt BgL_variablez00_2218;

																BgL_variablez00_2218 =
																	(BgL_variablez00_bglt) (BgL_arg3371z00_1340);
																{	/* Ast/shrinkify.scm 184 */
																	obj_t BgL_method3178z00_2219;

																	{	/* Ast/shrinkify.scm 184 */
																		BgL_objectz00_bglt BgL_objz00_2220;

																		BgL_objz00_2220 =
																			(BgL_objectz00_bglt)
																			(BgL_variablez00_2218);
																		{	/* Ast/shrinkify.scm 184 */
																			long BgL_objzd2classzd2numz00_2221;

																			BgL_objzd2classzd2numz00_2221 =
																				BGL_OBJECT_CLASS_NUM(BgL_objz00_2220);
																			{	/* Ast/shrinkify.scm 184 */
																				obj_t BgL_arg2551z00_2222;

																				BgL_arg2551z00_2222 =
																					PROCEDURE_REF
																					(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																					(int) (((long) 1)));
																				{	/* Ast/shrinkify.scm 184 */
																					obj_t BgL_arrayz00_2224;

																					int BgL_offsetz00_2225;

																					BgL_arrayz00_2224 =
																						BgL_arg2551z00_2222;
																					BgL_offsetz00_2225 =
																						(int)
																						(BgL_objzd2classzd2numz00_2221);
																					{	/* Ast/shrinkify.scm 184 */
																						long BgL_offsetz00_2226;

																						BgL_offsetz00_2226 =
																							(
																							(long) (BgL_offsetz00_2225) -
																							OBJECT_TYPE);
																						{	/* Ast/shrinkify.scm 184 */
																							long BgL_modz00_2227;

																							{	/* Ast/shrinkify.scm 184 */
																								int BgL_arg2553z00_2228;

																								BgL_arg2553z00_2228 =
																									(int) (((long) 8));
																								{	/* Ast/shrinkify.scm 184 */
																									long BgL_auxz00_3066;

																									BgL_auxz00_3066 =
																										(long)
																										(BgL_arg2553z00_2228);
																									BgL_modz00_2227 =
																										(BgL_offsetz00_2226 /
																										BgL_auxz00_3066);
																							}}
																							{	/* Ast/shrinkify.scm 184 */
																								long BgL_restz00_2229;

																								{	/* Ast/shrinkify.scm 184 */
																									int BgL_arg2552z00_2230;

																									BgL_arg2552z00_2230 =
																										(int) (((long) 8));
																									{	/* Ast/shrinkify.scm 184 */
																										long BgL_auxz00_3070;

																										BgL_auxz00_3070 =
																											(long)
																											(BgL_arg2552z00_2230);
																										BgL_restz00_2229 =
																											(BgL_offsetz00_2226 %
																											BgL_auxz00_3070);
																								}}
																								{	/* Ast/shrinkify.scm 184 */

																									BgL_method3178z00_2219 =
																										VECTOR_REF(VECTOR_REF
																										(BgL_arrayz00_2224,
																											(int) (BgL_modz00_2227)),
																										(int) (BgL_restz00_2229));
																	}}}}}}}}
																	PROCEDURE_ENTRY(BgL_method3178z00_2219)
																		(BgL_method3178z00_2219,
																		(obj_t) (BgL_variablez00_2218), BEOA);
														}}}
														{
															obj_t BgL_l3166z00_3080;

															BgL_l3166z00_3080 = CDR(BgL_l3166z00_1337);
															BgL_l3166z00_1337 = BgL_l3166z00_3080;
															goto BgL_zc3anonymousza33369ze3z83_1338;
														}
													}
												else
													{	/* Ast/shrinkify.scm 184 */
														((bool_t) 1);
													}
											}
										}
										{	/* Ast/shrinkify.scm 185 */
											obj_t BgL_arg3373z00_1343;

											{
												BgL_sfunz00_bglt BgL_auxz00_3082;

												BgL_auxz00_3082 = (BgL_sfunz00_bglt) (BgL_sfunz00_1334);
												BgL_arg3373z00_1343 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3082))->
													BgL_bodyz00);
											}
											{	/* Ast/shrinkify.scm 185 */
												obj_t BgL_res3474z00_2272;

												{	/* Ast/shrinkify.scm 185 */
													BgL_nodez00_bglt BgL_nodez00_2246;

													BgL_nodez00_2246 =
														(BgL_nodez00_bglt) (BgL_arg3373z00_1343);
													{	/* Ast/shrinkify.scm 185 */
														obj_t BgL_method3180z00_2247;

														{	/* Ast/shrinkify.scm 185 */
															BgL_objectz00_bglt BgL_objz00_2248;

															BgL_objz00_2248 =
																(BgL_objectz00_bglt) (BgL_nodez00_2246);
															{	/* Ast/shrinkify.scm 185 */
																long BgL_objzd2classzd2numz00_2249;

																BgL_objzd2classzd2numz00_2249 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2248);
																{	/* Ast/shrinkify.scm 185 */
																	obj_t BgL_arg2551z00_2250;

																	BgL_arg2551z00_2250 =
																		PROCEDURE_REF
																		(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																		(int) (((long) 1)));
																	{	/* Ast/shrinkify.scm 185 */
																		obj_t BgL_arrayz00_2252;

																		int BgL_offsetz00_2253;

																		BgL_arrayz00_2252 = BgL_arg2551z00_2250;
																		BgL_offsetz00_2253 =
																			(int) (BgL_objzd2classzd2numz00_2249);
																		{	/* Ast/shrinkify.scm 185 */
																			long BgL_offsetz00_2254;

																			BgL_offsetz00_2254 =
																				(
																				(long) (BgL_offsetz00_2253) -
																				OBJECT_TYPE);
																			{	/* Ast/shrinkify.scm 185 */
																				long BgL_modz00_2255;

																				{	/* Ast/shrinkify.scm 185 */
																					int BgL_arg2553z00_2256;

																					BgL_arg2553z00_2256 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 185 */
																						long BgL_auxz00_3094;

																						BgL_auxz00_3094 =
																							(long) (BgL_arg2553z00_2256);
																						BgL_modz00_2255 =
																							(BgL_offsetz00_2254 /
																							BgL_auxz00_3094);
																				}}
																				{	/* Ast/shrinkify.scm 185 */
																					long BgL_restz00_2257;

																					{	/* Ast/shrinkify.scm 185 */
																						int BgL_arg2552z00_2258;

																						BgL_arg2552z00_2258 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 185 */
																							long BgL_auxz00_3098;

																							BgL_auxz00_3098 =
																								(long) (BgL_arg2552z00_2258);
																							BgL_restz00_2257 =
																								(BgL_offsetz00_2254 %
																								BgL_auxz00_3098);
																					}}
																					{	/* Ast/shrinkify.scm 185 */

																						BgL_method3180z00_2247 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2252,
																								(int) (BgL_modz00_2255)),
																							(int) (BgL_restz00_2257));
														}}}}}}}}
														{	/* Ast/shrinkify.scm 185 */
															obj_t BgL_xz00_2554;

															BgL_xz00_2554 =
																PROCEDURE_ENTRY(BgL_method3180z00_2247)
																(BgL_method3180z00_2247,
																(obj_t) (BgL_nodez00_2246), BEOA);
															BgL_res3474z00_2272 = BUNSPEC;
												}}} BgL_res3474z00_2272;
								}}}}
								{
									obj_t BgL_l3169z00_3108;

									BgL_l3169z00_3108 = CDR(BgL_l3169z00_1330);
									BgL_l3169z00_1330 = BgL_l3169z00_3108;
									goto BgL_zc3anonymousza33367ze3z83_1331;
								}
							}
						else
							{	/* Ast/shrinkify.scm 181 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-set3212 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2set3212zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2511, obj_t BgL_nodez00_2512)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 169 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1311;

				BgL_nodez00_1311 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2512);
				{	/* Ast/shrinkify.scm 170 */
					bool_t BgL_testz00_3111;

					{	/* Ast/shrinkify.scm 170 */
						bool_t BgL_testz00_3112;

						{	/* Ast/shrinkify.scm 170 */
							obj_t BgL_auxz00_3113;

							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3114;

								BgL_auxz00_3114 = (BgL_objectz00_bglt) (BgL_nodez00_1311);
								BgL_auxz00_3113 = BGL_OBJECT_WIDENING(BgL_auxz00_3114);
							}
							BgL_testz00_3112 = CBOOL(BgL_auxz00_3113);
						}
						if (BgL_testz00_3112)
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3111 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3111 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3111)
						{	/* Ast/shrinkify.scm 170 */
							{	/* Ast/shrinkify.scm 170 */
								long BgL_arg3360z00_1316;

								{	/* Ast/shrinkify.scm 170 */
									obj_t BgL_arg3361z00_1317;

									{	/* Ast/shrinkify.scm 170 */
										obj_t BgL_arg3362z00_1318;

										{	/* Ast/shrinkify.scm 170 */
											BgL_objectz00_bglt BgL_objectz00_2091;

											BgL_objectz00_2091 =
												(BgL_objectz00_bglt) (BgL_nodez00_1311);
											{	/* Ast/shrinkify.scm 170 */
												long BgL_arg2554z00_2092;

												{	/* Ast/shrinkify.scm 170 */
													long BgL_arg2556z00_2093;

													BgL_arg2556z00_2093 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2091);
													BgL_arg2554z00_2092 =
														(BgL_arg2556z00_2093 - OBJECT_TYPE);
												}
												BgL_arg3362z00_1318 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_2092));
										}}
										BgL_arg3361z00_1317 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3362z00_1318);
									}
									BgL_arg3360z00_1316 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3361z00_1317);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1311), BgL_arg3360z00_1316);
							}
							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3127;

								BgL_auxz00_3127 = (BgL_objectz00_bglt) (BgL_nodez00_1311);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3127, BFALSE);
							}
							(obj_t) (BgL_nodez00_1311);
						}
					else
						{	/* Ast/shrinkify.scm 170 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 171 */
					BgL_varz00_bglt BgL_arg3363z00_1319;

					BgL_arg3363z00_1319 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1311))->BgL_varz00);
					{	/* Ast/shrinkify.scm 171 */
						obj_t BgL_res3461z00_2128;

						{	/* Ast/shrinkify.scm 171 */
							BgL_nodez00_bglt BgL_nodez00_2102;

							BgL_nodez00_2102 = (BgL_nodez00_bglt) (BgL_arg3363z00_1319);
							{	/* Ast/shrinkify.scm 171 */
								obj_t BgL_method3180z00_2103;

								{	/* Ast/shrinkify.scm 171 */
									BgL_objectz00_bglt BgL_objz00_2104;

									BgL_objz00_2104 = (BgL_objectz00_bglt) (BgL_nodez00_2102);
									{	/* Ast/shrinkify.scm 171 */
										long BgL_objzd2classzd2numz00_2105;

										BgL_objzd2classzd2numz00_2105 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2104);
										{	/* Ast/shrinkify.scm 171 */
											obj_t BgL_arg2551z00_2106;

											BgL_arg2551z00_2106 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 171 */
												obj_t BgL_arrayz00_2108;

												int BgL_offsetz00_2109;

												BgL_arrayz00_2108 = BgL_arg2551z00_2106;
												BgL_offsetz00_2109 =
													(int) (BgL_objzd2classzd2numz00_2105);
												{	/* Ast/shrinkify.scm 171 */
													long BgL_offsetz00_2110;

													BgL_offsetz00_2110 =
														((long) (BgL_offsetz00_2109) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 171 */
														long BgL_modz00_2111;

														{	/* Ast/shrinkify.scm 171 */
															int BgL_arg2553z00_2112;

															BgL_arg2553z00_2112 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 171 */
																long BgL_auxz00_3141;

																BgL_auxz00_3141 = (long) (BgL_arg2553z00_2112);
																BgL_modz00_2111 =
																	(BgL_offsetz00_2110 / BgL_auxz00_3141);
														}}
														{	/* Ast/shrinkify.scm 171 */
															long BgL_restz00_2113;

															{	/* Ast/shrinkify.scm 171 */
																int BgL_arg2552z00_2114;

																BgL_arg2552z00_2114 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 171 */
																	long BgL_auxz00_3145;

																	BgL_auxz00_3145 =
																		(long) (BgL_arg2552z00_2114);
																	BgL_restz00_2113 =
																		(BgL_offsetz00_2110 % BgL_auxz00_3145);
															}}
															{	/* Ast/shrinkify.scm 171 */

																BgL_method3180z00_2103 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2108,
																		(int) (BgL_modz00_2111)),
																	(int) (BgL_restz00_2113));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_xz00_2555;

									BgL_xz00_2555 =
										PROCEDURE_ENTRY(BgL_method3180z00_2103)
										(BgL_method3180z00_2103, (obj_t) (BgL_nodez00_2102), BEOA);
									BgL_res3461z00_2128 = BUNSPEC;
						}}} BgL_res3461z00_2128;
				}}
				{	/* Ast/shrinkify.scm 172 */
					BgL_nodez00_bglt BgL_arg3364z00_1320;

					BgL_arg3364z00_1320 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1311))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 172 */
						obj_t BgL_res3464z00_2156;

						{	/* Ast/shrinkify.scm 172 */
							obj_t BgL_method3180z00_2131;

							{	/* Ast/shrinkify.scm 172 */
								BgL_objectz00_bglt BgL_objz00_2132;

								BgL_objz00_2132 = (BgL_objectz00_bglt) (BgL_arg3364z00_1320);
								{	/* Ast/shrinkify.scm 172 */
									long BgL_objzd2classzd2numz00_2133;

									BgL_objzd2classzd2numz00_2133 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2132);
									{	/* Ast/shrinkify.scm 172 */
										obj_t BgL_arg2551z00_2134;

										BgL_arg2551z00_2134 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 172 */
											obj_t BgL_arrayz00_2136;

											int BgL_offsetz00_2137;

											BgL_arrayz00_2136 = BgL_arg2551z00_2134;
											BgL_offsetz00_2137 =
												(int) (BgL_objzd2classzd2numz00_2133);
											{	/* Ast/shrinkify.scm 172 */
												long BgL_offsetz00_2138;

												BgL_offsetz00_2138 =
													((long) (BgL_offsetz00_2137) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 172 */
													long BgL_modz00_2139;

													{	/* Ast/shrinkify.scm 172 */
														int BgL_arg2553z00_2140;

														BgL_arg2553z00_2140 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 172 */
															long BgL_auxz00_3164;

															BgL_auxz00_3164 = (long) (BgL_arg2553z00_2140);
															BgL_modz00_2139 =
																(BgL_offsetz00_2138 / BgL_auxz00_3164);
													}}
													{	/* Ast/shrinkify.scm 172 */
														long BgL_restz00_2141;

														{	/* Ast/shrinkify.scm 172 */
															int BgL_arg2552z00_2142;

															BgL_arg2552z00_2142 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 172 */
																long BgL_auxz00_3168;

																BgL_auxz00_3168 = (long) (BgL_arg2552z00_2142);
																BgL_restz00_2141 =
																	(BgL_offsetz00_2138 % BgL_auxz00_3168);
														}}
														{	/* Ast/shrinkify.scm 172 */

															BgL_method3180z00_2131 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2136,
																	(int) (BgL_modz00_2139)),
																(int) (BgL_restz00_2141));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 172 */
								obj_t BgL_xz00_2556;

								BgL_xz00_2556 =
									PROCEDURE_ENTRY(BgL_method3180z00_2131)
									(BgL_method3180z00_2131, (obj_t) (BgL_arg3364z00_1320), BEOA);
								BgL_res3464z00_2156 = BUNSPEC;
						}} BgL_res3464z00_2156;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-ref3210 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3210zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2513, obj_t BgL_nodez00_2514)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 161 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1300;

				BgL_nodez00_1300 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2514);
				{	/* Ast/shrinkify.scm 162 */
					bool_t BgL_testz00_3179;

					{	/* Ast/shrinkify.scm 162 */
						bool_t BgL_testz00_3180;

						{	/* Ast/shrinkify.scm 162 */
							obj_t BgL_auxz00_3181;

							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3182;

								BgL_auxz00_3182 = (BgL_objectz00_bglt) (BgL_nodez00_1300);
								BgL_auxz00_3181 = BGL_OBJECT_WIDENING(BgL_auxz00_3182);
							}
							BgL_testz00_3180 = CBOOL(BgL_auxz00_3181);
						}
						if (BgL_testz00_3180)
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3179 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3179 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3179)
						{	/* Ast/shrinkify.scm 162 */
							{	/* Ast/shrinkify.scm 162 */
								long BgL_arg3354z00_1305;

								{	/* Ast/shrinkify.scm 162 */
									obj_t BgL_arg3355z00_1306;

									{	/* Ast/shrinkify.scm 162 */
										obj_t BgL_arg3356z00_1307;

										{	/* Ast/shrinkify.scm 162 */
											BgL_objectz00_bglt BgL_objectz00_2050;

											BgL_objectz00_2050 =
												(BgL_objectz00_bglt) (BgL_nodez00_1300);
											{	/* Ast/shrinkify.scm 162 */
												long BgL_arg2554z00_2051;

												{	/* Ast/shrinkify.scm 162 */
													long BgL_arg2556z00_2052;

													BgL_arg2556z00_2052 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2050);
													BgL_arg2554z00_2051 =
														(BgL_arg2556z00_2052 - OBJECT_TYPE);
												}
												BgL_arg3356z00_1307 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_2051));
										}}
										BgL_arg3355z00_1306 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3356z00_1307);
									}
									BgL_arg3354z00_1305 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3355z00_1306);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1300), BgL_arg3354z00_1305);
							}
							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3195;

								BgL_auxz00_3195 = (BgL_objectz00_bglt) (BgL_nodez00_1300);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3195, BFALSE);
							}
							(obj_t) (BgL_nodez00_1300);
						}
					else
						{	/* Ast/shrinkify.scm 162 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 163 */
					BgL_varz00_bglt BgL_arg3357z00_1308;

					BgL_arg3357z00_1308 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1300))->BgL_varz00);
					{	/* Ast/shrinkify.scm 163 */
						obj_t BgL_res3457z00_2087;

						{	/* Ast/shrinkify.scm 163 */
							BgL_nodez00_bglt BgL_nodez00_2061;

							BgL_nodez00_2061 = (BgL_nodez00_bglt) (BgL_arg3357z00_1308);
							{	/* Ast/shrinkify.scm 163 */
								obj_t BgL_method3180z00_2062;

								{	/* Ast/shrinkify.scm 163 */
									BgL_objectz00_bglt BgL_objz00_2063;

									BgL_objz00_2063 = (BgL_objectz00_bglt) (BgL_nodez00_2061);
									{	/* Ast/shrinkify.scm 163 */
										long BgL_objzd2classzd2numz00_2064;

										BgL_objzd2classzd2numz00_2064 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2063);
										{	/* Ast/shrinkify.scm 163 */
											obj_t BgL_arg2551z00_2065;

											BgL_arg2551z00_2065 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 163 */
												obj_t BgL_arrayz00_2067;

												int BgL_offsetz00_2068;

												BgL_arrayz00_2067 = BgL_arg2551z00_2065;
												BgL_offsetz00_2068 =
													(int) (BgL_objzd2classzd2numz00_2064);
												{	/* Ast/shrinkify.scm 163 */
													long BgL_offsetz00_2069;

													BgL_offsetz00_2069 =
														((long) (BgL_offsetz00_2068) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 163 */
														long BgL_modz00_2070;

														{	/* Ast/shrinkify.scm 163 */
															int BgL_arg2553z00_2071;

															BgL_arg2553z00_2071 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 163 */
																long BgL_auxz00_3209;

																BgL_auxz00_3209 = (long) (BgL_arg2553z00_2071);
																BgL_modz00_2070 =
																	(BgL_offsetz00_2069 / BgL_auxz00_3209);
														}}
														{	/* Ast/shrinkify.scm 163 */
															long BgL_restz00_2072;

															{	/* Ast/shrinkify.scm 163 */
																int BgL_arg2552z00_2073;

																BgL_arg2552z00_2073 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 163 */
																	long BgL_auxz00_3213;

																	BgL_auxz00_3213 =
																		(long) (BgL_arg2552z00_2073);
																	BgL_restz00_2072 =
																		(BgL_offsetz00_2069 % BgL_auxz00_3213);
															}}
															{	/* Ast/shrinkify.scm 163 */

																BgL_method3180z00_2062 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2067,
																		(int) (BgL_modz00_2070)),
																	(int) (BgL_restz00_2072));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_xz00_2557;

									BgL_xz00_2557 =
										PROCEDURE_ENTRY(BgL_method3180z00_2062)
										(BgL_method3180z00_2062, (obj_t) (BgL_nodez00_2061), BEOA);
									BgL_res3457z00_2087 = BUNSPEC;
						}}} BgL_res3457z00_2087;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-make-bo3208 */
	obj_t BGl_shrinkzd2nodez12zd2makezd2bo3208zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2515, obj_t BgL_nodez00_2516)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 153 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1289;

				BgL_nodez00_1289 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2516);
				{	/* Ast/shrinkify.scm 154 */
					bool_t BgL_testz00_3224;

					{	/* Ast/shrinkify.scm 154 */
						bool_t BgL_testz00_3225;

						{	/* Ast/shrinkify.scm 154 */
							obj_t BgL_auxz00_3226;

							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3227;

								BgL_auxz00_3227 = (BgL_objectz00_bglt) (BgL_nodez00_1289);
								BgL_auxz00_3226 = BGL_OBJECT_WIDENING(BgL_auxz00_3227);
							}
							BgL_testz00_3225 = CBOOL(BgL_auxz00_3226);
						}
						if (BgL_testz00_3225)
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3224 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3224 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3224)
						{	/* Ast/shrinkify.scm 154 */
							{	/* Ast/shrinkify.scm 154 */
								long BgL_arg3348z00_1294;

								{	/* Ast/shrinkify.scm 154 */
									obj_t BgL_arg3349z00_1295;

									{	/* Ast/shrinkify.scm 154 */
										obj_t BgL_arg3350z00_1296;

										{	/* Ast/shrinkify.scm 154 */
											BgL_objectz00_bglt BgL_objectz00_2009;

											BgL_objectz00_2009 =
												(BgL_objectz00_bglt) (BgL_nodez00_1289);
											{	/* Ast/shrinkify.scm 154 */
												long BgL_arg2554z00_2010;

												{	/* Ast/shrinkify.scm 154 */
													long BgL_arg2556z00_2011;

													BgL_arg2556z00_2011 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2009);
													BgL_arg2554z00_2010 =
														(BgL_arg2556z00_2011 - OBJECT_TYPE);
												}
												BgL_arg3350z00_1296 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_2010));
										}}
										BgL_arg3349z00_1295 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3350z00_1296);
									}
									BgL_arg3348z00_1294 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3349z00_1295);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1289), BgL_arg3348z00_1294);
							}
							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3240;

								BgL_auxz00_3240 = (BgL_objectz00_bglt) (BgL_nodez00_1289);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3240, BFALSE);
							}
							(obj_t) (BgL_nodez00_1289);
						}
					else
						{	/* Ast/shrinkify.scm 154 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 155 */
					BgL_nodez00_bglt BgL_arg3351z00_1297;

					BgL_arg3351z00_1297 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1289))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 155 */
						obj_t BgL_res3453z00_2046;

						{	/* Ast/shrinkify.scm 155 */
							obj_t BgL_method3180z00_2021;

							{	/* Ast/shrinkify.scm 155 */
								BgL_objectz00_bglt BgL_objz00_2022;

								BgL_objz00_2022 = (BgL_objectz00_bglt) (BgL_arg3351z00_1297);
								{	/* Ast/shrinkify.scm 155 */
									long BgL_objzd2classzd2numz00_2023;

									BgL_objzd2classzd2numz00_2023 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2022);
									{	/* Ast/shrinkify.scm 155 */
										obj_t BgL_arg2551z00_2024;

										BgL_arg2551z00_2024 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 155 */
											obj_t BgL_arrayz00_2026;

											int BgL_offsetz00_2027;

											BgL_arrayz00_2026 = BgL_arg2551z00_2024;
											BgL_offsetz00_2027 =
												(int) (BgL_objzd2classzd2numz00_2023);
											{	/* Ast/shrinkify.scm 155 */
												long BgL_offsetz00_2028;

												BgL_offsetz00_2028 =
													((long) (BgL_offsetz00_2027) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 155 */
													long BgL_modz00_2029;

													{	/* Ast/shrinkify.scm 155 */
														int BgL_arg2553z00_2030;

														BgL_arg2553z00_2030 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 155 */
															long BgL_auxz00_3253;

															BgL_auxz00_3253 = (long) (BgL_arg2553z00_2030);
															BgL_modz00_2029 =
																(BgL_offsetz00_2028 / BgL_auxz00_3253);
													}}
													{	/* Ast/shrinkify.scm 155 */
														long BgL_restz00_2031;

														{	/* Ast/shrinkify.scm 155 */
															int BgL_arg2552z00_2032;

															BgL_arg2552z00_2032 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 155 */
																long BgL_auxz00_3257;

																BgL_auxz00_3257 = (long) (BgL_arg2552z00_2032);
																BgL_restz00_2031 =
																	(BgL_offsetz00_2028 % BgL_auxz00_3257);
														}}
														{	/* Ast/shrinkify.scm 155 */

															BgL_method3180z00_2021 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2026,
																	(int) (BgL_modz00_2029)),
																(int) (BgL_restz00_2031));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 155 */
								obj_t BgL_xz00_2558;

								BgL_xz00_2558 =
									PROCEDURE_ENTRY(BgL_method3180z00_2021)
									(BgL_method3180z00_2021, (obj_t) (BgL_arg3351z00_1297), BEOA);
								BgL_res3453z00_2046 = BUNSPEC;
						}} BgL_res3453z00_2046;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-select3206 */
	obj_t BGl_shrinkzd2nodez12zd2select3206z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2517, obj_t BgL_nodez00_2518)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 143 */
			{
				BgL_selectz00_bglt BgL_nodez00_1274;

				BgL_nodez00_1274 = (BgL_selectz00_bglt) (BgL_nodez00_2518);
				{	/* Ast/shrinkify.scm 144 */
					BgL_nodez00_bglt BgL_arg3341z00_1277;

					BgL_arg3341z00_1277 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1274))->BgL_testz00);
					{	/* Ast/shrinkify.scm 144 */
						obj_t BgL_res3446z00_1973;

						{	/* Ast/shrinkify.scm 144 */
							obj_t BgL_method3180z00_1948;

							{	/* Ast/shrinkify.scm 144 */
								BgL_objectz00_bglt BgL_objz00_1949;

								BgL_objz00_1949 = (BgL_objectz00_bglt) (BgL_arg3341z00_1277);
								{	/* Ast/shrinkify.scm 144 */
									long BgL_objzd2classzd2numz00_1950;

									BgL_objzd2classzd2numz00_1950 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1949);
									{	/* Ast/shrinkify.scm 144 */
										obj_t BgL_arg2551z00_1951;

										BgL_arg2551z00_1951 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 144 */
											obj_t BgL_arrayz00_1953;

											int BgL_offsetz00_1954;

											BgL_arrayz00_1953 = BgL_arg2551z00_1951;
											BgL_offsetz00_1954 =
												(int) (BgL_objzd2classzd2numz00_1950);
											{	/* Ast/shrinkify.scm 144 */
												long BgL_offsetz00_1955;

												BgL_offsetz00_1955 =
													((long) (BgL_offsetz00_1954) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 144 */
													long BgL_modz00_1956;

													{	/* Ast/shrinkify.scm 144 */
														int BgL_arg2553z00_1957;

														BgL_arg2553z00_1957 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 144 */
															long BgL_auxz00_3277;

															BgL_auxz00_3277 = (long) (BgL_arg2553z00_1957);
															BgL_modz00_1956 =
																(BgL_offsetz00_1955 / BgL_auxz00_3277);
													}}
													{	/* Ast/shrinkify.scm 144 */
														long BgL_restz00_1958;

														{	/* Ast/shrinkify.scm 144 */
															int BgL_arg2552z00_1959;

															BgL_arg2552z00_1959 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 144 */
																long BgL_auxz00_3281;

																BgL_auxz00_3281 = (long) (BgL_arg2552z00_1959);
																BgL_restz00_1958 =
																	(BgL_offsetz00_1955 % BgL_auxz00_3281);
														}}
														{	/* Ast/shrinkify.scm 144 */

															BgL_method3180z00_1948 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1953,
																	(int) (BgL_modz00_1956)),
																(int) (BgL_restz00_1958));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 144 */
								obj_t BgL_xz00_2559;

								BgL_xz00_2559 =
									PROCEDURE_ENTRY(BgL_method3180z00_1948)
									(BgL_method3180z00_1948, (obj_t) (BgL_arg3341z00_1277), BEOA);
								BgL_res3446z00_1973 = BUNSPEC;
						}} BgL_res3446z00_1973;
				}}
				{	/* Ast/shrinkify.scm 145 */
					obj_t BgL_g3165z00_1278;

					BgL_g3165z00_1278 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1274))->BgL_clausesz00);
					{
						obj_t BgL_l3163z00_1280;

						BgL_l3163z00_1280 = BgL_g3165z00_1278;
					BgL_zc3anonymousza33342ze3z83_1281:
						if (PAIRP(BgL_l3163z00_1280))
							{	/* Ast/shrinkify.scm 147 */
								{	/* Ast/shrinkify.scm 146 */
									obj_t BgL_clausez00_1283;

									BgL_clausez00_1283 = CAR(BgL_l3163z00_1280);
									{	/* Ast/shrinkify.scm 146 */
										obj_t BgL_arg3344z00_1284;

										BgL_arg3344z00_1284 = CDR(BgL_clausez00_1283);
										{	/* Ast/shrinkify.scm 146 */
											obj_t BgL_res3449z00_2004;

											{	/* Ast/shrinkify.scm 146 */
												BgL_nodez00_bglt BgL_nodez00_1978;

												BgL_nodez00_1978 =
													(BgL_nodez00_bglt) (BgL_arg3344z00_1284);
												{	/* Ast/shrinkify.scm 146 */
													obj_t BgL_method3180z00_1979;

													{	/* Ast/shrinkify.scm 146 */
														BgL_objectz00_bglt BgL_objz00_1980;

														BgL_objz00_1980 =
															(BgL_objectz00_bglt) (BgL_nodez00_1978);
														{	/* Ast/shrinkify.scm 146 */
															long BgL_objzd2classzd2numz00_1981;

															BgL_objzd2classzd2numz00_1981 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1980);
															{	/* Ast/shrinkify.scm 146 */
																obj_t BgL_arg2551z00_1982;

																BgL_arg2551z00_1982 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 146 */
																	obj_t BgL_arrayz00_1984;

																	int BgL_offsetz00_1985;

																	BgL_arrayz00_1984 = BgL_arg2551z00_1982;
																	BgL_offsetz00_1985 =
																		(int) (BgL_objzd2classzd2numz00_1981);
																	{	/* Ast/shrinkify.scm 146 */
																		long BgL_offsetz00_1986;

																		BgL_offsetz00_1986 =
																			(
																			(long) (BgL_offsetz00_1985) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 146 */
																			long BgL_modz00_1987;

																			{	/* Ast/shrinkify.scm 146 */
																				int BgL_arg2553z00_1988;

																				BgL_arg2553z00_1988 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 146 */
																					long BgL_auxz00_3305;

																					BgL_auxz00_3305 =
																						(long) (BgL_arg2553z00_1988);
																					BgL_modz00_1987 =
																						(BgL_offsetz00_1986 /
																						BgL_auxz00_3305);
																			}}
																			{	/* Ast/shrinkify.scm 146 */
																				long BgL_restz00_1989;

																				{	/* Ast/shrinkify.scm 146 */
																					int BgL_arg2552z00_1990;

																					BgL_arg2552z00_1990 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 146 */
																						long BgL_auxz00_3309;

																						BgL_auxz00_3309 =
																							(long) (BgL_arg2552z00_1990);
																						BgL_restz00_1989 =
																							(BgL_offsetz00_1986 %
																							BgL_auxz00_3309);
																				}}
																				{	/* Ast/shrinkify.scm 146 */

																					BgL_method3180z00_1979 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1984,
																							(int) (BgL_modz00_1987)),
																						(int) (BgL_restz00_1989));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 146 */
														obj_t BgL_xz00_2560;

														BgL_xz00_2560 =
															PROCEDURE_ENTRY(BgL_method3180z00_1979)
															(BgL_method3180z00_1979,
															(obj_t) (BgL_nodez00_1978), BEOA);
														BgL_res3449z00_2004 = BUNSPEC;
											}}} BgL_res3449z00_2004;
								}}}
								{
									obj_t BgL_l3163z00_3319;

									BgL_l3163z00_3319 = CDR(BgL_l3163z00_1280);
									BgL_l3163z00_1280 = BgL_l3163z00_3319;
									goto BgL_zc3anonymousza33342ze3z83_1281;
								}
							}
						else
							{	/* Ast/shrinkify.scm 147 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-fail3204 */
	obj_t BGl_shrinkzd2nodez12zd2fail3204z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2519, obj_t BgL_nodez00_2520)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 134 */
			{
				BgL_failz00_bglt BgL_nodez00_1266;

				BgL_nodez00_1266 = (BgL_failz00_bglt) (BgL_nodez00_2520);
				{	/* Ast/shrinkify.scm 135 */
					BgL_nodez00_bglt BgL_arg3335z00_1269;

					BgL_arg3335z00_1269 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1266))->BgL_procz00);
					{	/* Ast/shrinkify.scm 135 */
						obj_t BgL_res3437z00_1889;

						{	/* Ast/shrinkify.scm 135 */
							obj_t BgL_method3180z00_1864;

							{	/* Ast/shrinkify.scm 135 */
								BgL_objectz00_bglt BgL_objz00_1865;

								BgL_objz00_1865 = (BgL_objectz00_bglt) (BgL_arg3335z00_1269);
								{	/* Ast/shrinkify.scm 135 */
									long BgL_objzd2classzd2numz00_1866;

									BgL_objzd2classzd2numz00_1866 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1865);
									{	/* Ast/shrinkify.scm 135 */
										obj_t BgL_arg2551z00_1867;

										BgL_arg2551z00_1867 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 135 */
											obj_t BgL_arrayz00_1869;

											int BgL_offsetz00_1870;

											BgL_arrayz00_1869 = BgL_arg2551z00_1867;
											BgL_offsetz00_1870 =
												(int) (BgL_objzd2classzd2numz00_1866);
											{	/* Ast/shrinkify.scm 135 */
												long BgL_offsetz00_1871;

												BgL_offsetz00_1871 =
													((long) (BgL_offsetz00_1870) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 135 */
													long BgL_modz00_1872;

													{	/* Ast/shrinkify.scm 135 */
														int BgL_arg2553z00_1873;

														BgL_arg2553z00_1873 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 135 */
															long BgL_auxz00_3331;

															BgL_auxz00_3331 = (long) (BgL_arg2553z00_1873);
															BgL_modz00_1872 =
																(BgL_offsetz00_1871 / BgL_auxz00_3331);
													}}
													{	/* Ast/shrinkify.scm 135 */
														long BgL_restz00_1874;

														{	/* Ast/shrinkify.scm 135 */
															int BgL_arg2552z00_1875;

															BgL_arg2552z00_1875 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 135 */
																long BgL_auxz00_3335;

																BgL_auxz00_3335 = (long) (BgL_arg2552z00_1875);
																BgL_restz00_1874 =
																	(BgL_offsetz00_1871 % BgL_auxz00_3335);
														}}
														{	/* Ast/shrinkify.scm 135 */

															BgL_method3180z00_1864 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1869,
																	(int) (BgL_modz00_1872)),
																(int) (BgL_restz00_1874));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 135 */
								obj_t BgL_xz00_2561;

								BgL_xz00_2561 =
									PROCEDURE_ENTRY(BgL_method3180z00_1864)
									(BgL_method3180z00_1864, (obj_t) (BgL_arg3335z00_1269), BEOA);
								BgL_res3437z00_1889 = BUNSPEC;
						}} BgL_res3437z00_1889;
				}}
				{	/* Ast/shrinkify.scm 136 */
					BgL_nodez00_bglt BgL_arg3336z00_1270;

					BgL_arg3336z00_1270 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1266))->BgL_msgz00);
					{	/* Ast/shrinkify.scm 136 */
						obj_t BgL_res3440z00_1917;

						{	/* Ast/shrinkify.scm 136 */
							obj_t BgL_method3180z00_1892;

							{	/* Ast/shrinkify.scm 136 */
								BgL_objectz00_bglt BgL_objz00_1893;

								BgL_objz00_1893 = (BgL_objectz00_bglt) (BgL_arg3336z00_1270);
								{	/* Ast/shrinkify.scm 136 */
									long BgL_objzd2classzd2numz00_1894;

									BgL_objzd2classzd2numz00_1894 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1893);
									{	/* Ast/shrinkify.scm 136 */
										obj_t BgL_arg2551z00_1895;

										BgL_arg2551z00_1895 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 136 */
											obj_t BgL_arrayz00_1897;

											int BgL_offsetz00_1898;

											BgL_arrayz00_1897 = BgL_arg2551z00_1895;
											BgL_offsetz00_1898 =
												(int) (BgL_objzd2classzd2numz00_1894);
											{	/* Ast/shrinkify.scm 136 */
												long BgL_offsetz00_1899;

												BgL_offsetz00_1899 =
													((long) (BgL_offsetz00_1898) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 136 */
													long BgL_modz00_1900;

													{	/* Ast/shrinkify.scm 136 */
														int BgL_arg2553z00_1901;

														BgL_arg2553z00_1901 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 136 */
															long BgL_auxz00_3354;

															BgL_auxz00_3354 = (long) (BgL_arg2553z00_1901);
															BgL_modz00_1900 =
																(BgL_offsetz00_1899 / BgL_auxz00_3354);
													}}
													{	/* Ast/shrinkify.scm 136 */
														long BgL_restz00_1902;

														{	/* Ast/shrinkify.scm 136 */
															int BgL_arg2552z00_1903;

															BgL_arg2552z00_1903 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 136 */
																long BgL_auxz00_3358;

																BgL_auxz00_3358 = (long) (BgL_arg2552z00_1903);
																BgL_restz00_1902 =
																	(BgL_offsetz00_1899 % BgL_auxz00_3358);
														}}
														{	/* Ast/shrinkify.scm 136 */

															BgL_method3180z00_1892 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1897,
																	(int) (BgL_modz00_1900)),
																(int) (BgL_restz00_1902));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 136 */
								obj_t BgL_xz00_2562;

								BgL_xz00_2562 =
									PROCEDURE_ENTRY(BgL_method3180z00_1892)
									(BgL_method3180z00_1892, (obj_t) (BgL_arg3336z00_1270), BEOA);
								BgL_res3440z00_1917 = BUNSPEC;
						}} BgL_res3440z00_1917;
				}}
				{	/* Ast/shrinkify.scm 137 */
					BgL_nodez00_bglt BgL_arg3339z00_1271;

					BgL_arg3339z00_1271 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1266))->BgL_objz00);
					{	/* Ast/shrinkify.scm 137 */
						obj_t BgL_res3443z00_1945;

						{	/* Ast/shrinkify.scm 137 */
							obj_t BgL_method3180z00_1920;

							{	/* Ast/shrinkify.scm 137 */
								BgL_objectz00_bglt BgL_objz00_1921;

								BgL_objz00_1921 = (BgL_objectz00_bglt) (BgL_arg3339z00_1271);
								{	/* Ast/shrinkify.scm 137 */
									long BgL_objzd2classzd2numz00_1922;

									BgL_objzd2classzd2numz00_1922 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1921);
									{	/* Ast/shrinkify.scm 137 */
										obj_t BgL_arg2551z00_1923;

										BgL_arg2551z00_1923 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 137 */
											obj_t BgL_arrayz00_1925;

											int BgL_offsetz00_1926;

											BgL_arrayz00_1925 = BgL_arg2551z00_1923;
											BgL_offsetz00_1926 =
												(int) (BgL_objzd2classzd2numz00_1922);
											{	/* Ast/shrinkify.scm 137 */
												long BgL_offsetz00_1927;

												BgL_offsetz00_1927 =
													((long) (BgL_offsetz00_1926) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 137 */
													long BgL_modz00_1928;

													{	/* Ast/shrinkify.scm 137 */
														int BgL_arg2553z00_1929;

														BgL_arg2553z00_1929 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 137 */
															long BgL_auxz00_3377;

															BgL_auxz00_3377 = (long) (BgL_arg2553z00_1929);
															BgL_modz00_1928 =
																(BgL_offsetz00_1927 / BgL_auxz00_3377);
													}}
													{	/* Ast/shrinkify.scm 137 */
														long BgL_restz00_1930;

														{	/* Ast/shrinkify.scm 137 */
															int BgL_arg2552z00_1931;

															BgL_arg2552z00_1931 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 137 */
																long BgL_auxz00_3381;

																BgL_auxz00_3381 = (long) (BgL_arg2552z00_1931);
																BgL_restz00_1930 =
																	(BgL_offsetz00_1927 % BgL_auxz00_3381);
														}}
														{	/* Ast/shrinkify.scm 137 */

															BgL_method3180z00_1920 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1925,
																	(int) (BgL_modz00_1928)),
																(int) (BgL_restz00_1930));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 137 */
								obj_t BgL_xz00_2563;

								BgL_xz00_2563 =
									PROCEDURE_ENTRY(BgL_method3180z00_1920)
									(BgL_method3180z00_1920, (obj_t) (BgL_arg3339z00_1271), BEOA);
								BgL_res3443z00_1945 = BUNSPEC;
						}} BgL_res3443z00_1945;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-conditi3202 */
	obj_t BGl_shrinkzd2nodez12zd2conditi3202z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2521, obj_t BgL_nodez00_2522)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 125 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1258;

				BgL_nodez00_1258 = (BgL_conditionalz00_bglt) (BgL_nodez00_2522);
				{	/* Ast/shrinkify.scm 126 */
					BgL_nodez00_bglt BgL_arg3331z00_1261;

					BgL_arg3331z00_1261 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1258))->BgL_testz00);
					{	/* Ast/shrinkify.scm 126 */
						obj_t BgL_res3428z00_1805;

						{	/* Ast/shrinkify.scm 126 */
							obj_t BgL_method3180z00_1780;

							{	/* Ast/shrinkify.scm 126 */
								BgL_objectz00_bglt BgL_objz00_1781;

								BgL_objz00_1781 = (BgL_objectz00_bglt) (BgL_arg3331z00_1261);
								{	/* Ast/shrinkify.scm 126 */
									long BgL_objzd2classzd2numz00_1782;

									BgL_objzd2classzd2numz00_1782 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1781);
									{	/* Ast/shrinkify.scm 126 */
										obj_t BgL_arg2551z00_1783;

										BgL_arg2551z00_1783 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 126 */
											obj_t BgL_arrayz00_1785;

											int BgL_offsetz00_1786;

											BgL_arrayz00_1785 = BgL_arg2551z00_1783;
											BgL_offsetz00_1786 =
												(int) (BgL_objzd2classzd2numz00_1782);
											{	/* Ast/shrinkify.scm 126 */
												long BgL_offsetz00_1787;

												BgL_offsetz00_1787 =
													((long) (BgL_offsetz00_1786) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 126 */
													long BgL_modz00_1788;

													{	/* Ast/shrinkify.scm 126 */
														int BgL_arg2553z00_1789;

														BgL_arg2553z00_1789 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 126 */
															long BgL_auxz00_3401;

															BgL_auxz00_3401 = (long) (BgL_arg2553z00_1789);
															BgL_modz00_1788 =
																(BgL_offsetz00_1787 / BgL_auxz00_3401);
													}}
													{	/* Ast/shrinkify.scm 126 */
														long BgL_restz00_1790;

														{	/* Ast/shrinkify.scm 126 */
															int BgL_arg2552z00_1791;

															BgL_arg2552z00_1791 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 126 */
																long BgL_auxz00_3405;

																BgL_auxz00_3405 = (long) (BgL_arg2552z00_1791);
																BgL_restz00_1790 =
																	(BgL_offsetz00_1787 % BgL_auxz00_3405);
														}}
														{	/* Ast/shrinkify.scm 126 */

															BgL_method3180z00_1780 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1785,
																	(int) (BgL_modz00_1788)),
																(int) (BgL_restz00_1790));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 126 */
								obj_t BgL_xz00_2564;

								BgL_xz00_2564 =
									PROCEDURE_ENTRY(BgL_method3180z00_1780)
									(BgL_method3180z00_1780, (obj_t) (BgL_arg3331z00_1261), BEOA);
								BgL_res3428z00_1805 = BUNSPEC;
						}} BgL_res3428z00_1805;
				}}
				{	/* Ast/shrinkify.scm 127 */
					BgL_nodez00_bglt BgL_arg3332z00_1262;

					BgL_arg3332z00_1262 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1258))->BgL_truez00);
					{	/* Ast/shrinkify.scm 127 */
						obj_t BgL_res3431z00_1833;

						{	/* Ast/shrinkify.scm 127 */
							obj_t BgL_method3180z00_1808;

							{	/* Ast/shrinkify.scm 127 */
								BgL_objectz00_bglt BgL_objz00_1809;

								BgL_objz00_1809 = (BgL_objectz00_bglt) (BgL_arg3332z00_1262);
								{	/* Ast/shrinkify.scm 127 */
									long BgL_objzd2classzd2numz00_1810;

									BgL_objzd2classzd2numz00_1810 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1809);
									{	/* Ast/shrinkify.scm 127 */
										obj_t BgL_arg2551z00_1811;

										BgL_arg2551z00_1811 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 127 */
											obj_t BgL_arrayz00_1813;

											int BgL_offsetz00_1814;

											BgL_arrayz00_1813 = BgL_arg2551z00_1811;
											BgL_offsetz00_1814 =
												(int) (BgL_objzd2classzd2numz00_1810);
											{	/* Ast/shrinkify.scm 127 */
												long BgL_offsetz00_1815;

												BgL_offsetz00_1815 =
													((long) (BgL_offsetz00_1814) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 127 */
													long BgL_modz00_1816;

													{	/* Ast/shrinkify.scm 127 */
														int BgL_arg2553z00_1817;

														BgL_arg2553z00_1817 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 127 */
															long BgL_auxz00_3424;

															BgL_auxz00_3424 = (long) (BgL_arg2553z00_1817);
															BgL_modz00_1816 =
																(BgL_offsetz00_1815 / BgL_auxz00_3424);
													}}
													{	/* Ast/shrinkify.scm 127 */
														long BgL_restz00_1818;

														{	/* Ast/shrinkify.scm 127 */
															int BgL_arg2552z00_1819;

															BgL_arg2552z00_1819 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 127 */
																long BgL_auxz00_3428;

																BgL_auxz00_3428 = (long) (BgL_arg2552z00_1819);
																BgL_restz00_1818 =
																	(BgL_offsetz00_1815 % BgL_auxz00_3428);
														}}
														{	/* Ast/shrinkify.scm 127 */

															BgL_method3180z00_1808 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1813,
																	(int) (BgL_modz00_1816)),
																(int) (BgL_restz00_1818));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 127 */
								obj_t BgL_xz00_2565;

								BgL_xz00_2565 =
									PROCEDURE_ENTRY(BgL_method3180z00_1808)
									(BgL_method3180z00_1808, (obj_t) (BgL_arg3332z00_1262), BEOA);
								BgL_res3431z00_1833 = BUNSPEC;
						}} BgL_res3431z00_1833;
				}}
				{	/* Ast/shrinkify.scm 128 */
					BgL_nodez00_bglt BgL_arg3333z00_1263;

					BgL_arg3333z00_1263 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1258))->BgL_falsez00);
					{	/* Ast/shrinkify.scm 128 */
						obj_t BgL_res3434z00_1861;

						{	/* Ast/shrinkify.scm 128 */
							obj_t BgL_method3180z00_1836;

							{	/* Ast/shrinkify.scm 128 */
								BgL_objectz00_bglt BgL_objz00_1837;

								BgL_objz00_1837 = (BgL_objectz00_bglt) (BgL_arg3333z00_1263);
								{	/* Ast/shrinkify.scm 128 */
									long BgL_objzd2classzd2numz00_1838;

									BgL_objzd2classzd2numz00_1838 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1837);
									{	/* Ast/shrinkify.scm 128 */
										obj_t BgL_arg2551z00_1839;

										BgL_arg2551z00_1839 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 128 */
											obj_t BgL_arrayz00_1841;

											int BgL_offsetz00_1842;

											BgL_arrayz00_1841 = BgL_arg2551z00_1839;
											BgL_offsetz00_1842 =
												(int) (BgL_objzd2classzd2numz00_1838);
											{	/* Ast/shrinkify.scm 128 */
												long BgL_offsetz00_1843;

												BgL_offsetz00_1843 =
													((long) (BgL_offsetz00_1842) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 128 */
													long BgL_modz00_1844;

													{	/* Ast/shrinkify.scm 128 */
														int BgL_arg2553z00_1845;

														BgL_arg2553z00_1845 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 128 */
															long BgL_auxz00_3447;

															BgL_auxz00_3447 = (long) (BgL_arg2553z00_1845);
															BgL_modz00_1844 =
																(BgL_offsetz00_1843 / BgL_auxz00_3447);
													}}
													{	/* Ast/shrinkify.scm 128 */
														long BgL_restz00_1846;

														{	/* Ast/shrinkify.scm 128 */
															int BgL_arg2552z00_1847;

															BgL_arg2552z00_1847 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 128 */
																long BgL_auxz00_3451;

																BgL_auxz00_3451 = (long) (BgL_arg2552z00_1847);
																BgL_restz00_1846 =
																	(BgL_offsetz00_1843 % BgL_auxz00_3451);
														}}
														{	/* Ast/shrinkify.scm 128 */

															BgL_method3180z00_1836 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1841,
																	(int) (BgL_modz00_1844)),
																(int) (BgL_restz00_1846));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 128 */
								obj_t BgL_xz00_2566;

								BgL_xz00_2566 =
									PROCEDURE_ENTRY(BgL_method3180z00_1836)
									(BgL_method3180z00_1836, (obj_t) (BgL_arg3333z00_1263), BEOA);
								BgL_res3434z00_1861 = BUNSPEC;
						}} BgL_res3434z00_1861;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-setq3200 */
	obj_t BGl_shrinkzd2nodez12zd2setq3200z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2523, obj_t BgL_nodez00_2524)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 118 */
			{
				BgL_setqz00_bglt BgL_nodez00_1252;

				BgL_nodez00_1252 = (BgL_setqz00_bglt) (BgL_nodez00_2524);
				{	/* Ast/shrinkify.scm 119 */
					BgL_nodez00_bglt BgL_arg3329z00_1749;

					BgL_arg3329z00_1749 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1252))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 119 */
						obj_t BgL_res3425z00_1777;

						{	/* Ast/shrinkify.scm 119 */
							obj_t BgL_method3180z00_1752;

							{	/* Ast/shrinkify.scm 119 */
								BgL_objectz00_bglt BgL_objz00_1753;

								BgL_objz00_1753 = (BgL_objectz00_bglt) (BgL_arg3329z00_1749);
								{	/* Ast/shrinkify.scm 119 */
									long BgL_objzd2classzd2numz00_1754;

									BgL_objzd2classzd2numz00_1754 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1753);
									{	/* Ast/shrinkify.scm 119 */
										obj_t BgL_arg2551z00_1755;

										BgL_arg2551z00_1755 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 119 */
											obj_t BgL_arrayz00_1757;

											int BgL_offsetz00_1758;

											BgL_arrayz00_1757 = BgL_arg2551z00_1755;
											BgL_offsetz00_1758 =
												(int) (BgL_objzd2classzd2numz00_1754);
											{	/* Ast/shrinkify.scm 119 */
												long BgL_offsetz00_1759;

												BgL_offsetz00_1759 =
													((long) (BgL_offsetz00_1758) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 119 */
													long BgL_modz00_1760;

													{	/* Ast/shrinkify.scm 119 */
														int BgL_arg2553z00_1761;

														BgL_arg2553z00_1761 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 119 */
															long BgL_auxz00_3471;

															BgL_auxz00_3471 = (long) (BgL_arg2553z00_1761);
															BgL_modz00_1760 =
																(BgL_offsetz00_1759 / BgL_auxz00_3471);
													}}
													{	/* Ast/shrinkify.scm 119 */
														long BgL_restz00_1762;

														{	/* Ast/shrinkify.scm 119 */
															int BgL_arg2552z00_1763;

															BgL_arg2552z00_1763 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 119 */
																long BgL_auxz00_3475;

																BgL_auxz00_3475 = (long) (BgL_arg2552z00_1763);
																BgL_restz00_1762 =
																	(BgL_offsetz00_1759 % BgL_auxz00_3475);
														}}
														{	/* Ast/shrinkify.scm 119 */

															BgL_method3180z00_1752 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1757,
																	(int) (BgL_modz00_1760)),
																(int) (BgL_restz00_1762));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 119 */
								obj_t BgL_xz00_2567;

								BgL_xz00_2567 =
									PROCEDURE_ENTRY(BgL_method3180z00_1752)
									(BgL_method3180z00_1752, (obj_t) (BgL_arg3329z00_1749), BEOA);
								BgL_res3425z00_1777 = BUNSPEC;
						}} BgL_res3425z00_1777;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-cast3198 */
	obj_t BGl_shrinkzd2nodez12zd2cast3198z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2525, obj_t BgL_nodez00_2526)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 111 */
			{
				BgL_castz00_bglt BgL_nodez00_1246;

				{	/* Ast/shrinkify.scm 112 */
					BgL_castz00_bglt BgL_auxz00_3486;

					BgL_nodez00_1246 = (BgL_castz00_bglt) (BgL_nodez00_2526);
					{	/* Ast/shrinkify.scm 112 */
						BgL_nodez00_bglt BgL_arg3327z00_1720;

						BgL_arg3327z00_1720 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1246))->BgL_argz00);
						{	/* Ast/shrinkify.scm 112 */
							obj_t BgL_res3422z00_1748;

							{	/* Ast/shrinkify.scm 112 */
								obj_t BgL_method3180z00_1723;

								{	/* Ast/shrinkify.scm 112 */
									BgL_objectz00_bglt BgL_objz00_1724;

									BgL_objz00_1724 = (BgL_objectz00_bglt) (BgL_arg3327z00_1720);
									{	/* Ast/shrinkify.scm 112 */
										long BgL_objzd2classzd2numz00_1725;

										BgL_objzd2classzd2numz00_1725 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1724);
										{	/* Ast/shrinkify.scm 112 */
											obj_t BgL_arg2551z00_1726;

											BgL_arg2551z00_1726 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 112 */
												obj_t BgL_arrayz00_1728;

												int BgL_offsetz00_1729;

												BgL_arrayz00_1728 = BgL_arg2551z00_1726;
												BgL_offsetz00_1729 =
													(int) (BgL_objzd2classzd2numz00_1725);
												{	/* Ast/shrinkify.scm 112 */
													long BgL_offsetz00_1730;

													BgL_offsetz00_1730 =
														((long) (BgL_offsetz00_1729) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 112 */
														long BgL_modz00_1731;

														{	/* Ast/shrinkify.scm 112 */
															int BgL_arg2553z00_1732;

															BgL_arg2553z00_1732 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 112 */
																long BgL_auxz00_3496;

																BgL_auxz00_3496 = (long) (BgL_arg2553z00_1732);
																BgL_modz00_1731 =
																	(BgL_offsetz00_1730 / BgL_auxz00_3496);
														}}
														{	/* Ast/shrinkify.scm 112 */
															long BgL_restz00_1733;

															{	/* Ast/shrinkify.scm 112 */
																int BgL_arg2552z00_1734;

																BgL_arg2552z00_1734 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 112 */
																	long BgL_auxz00_3500;

																	BgL_auxz00_3500 =
																		(long) (BgL_arg2552z00_1734);
																	BgL_restz00_1733 =
																		(BgL_offsetz00_1730 % BgL_auxz00_3500);
															}}
															{	/* Ast/shrinkify.scm 112 */

																BgL_method3180z00_1723 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1728,
																		(int) (BgL_modz00_1731)),
																	(int) (BgL_restz00_1733));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 112 */
									obj_t BgL_xz00_2568;

									BgL_xz00_2568 =
										PROCEDURE_ENTRY(BgL_method3180z00_1723)
										(BgL_method3180z00_1723, (obj_t) (BgL_arg3327z00_1720),
										BEOA);
									BgL_res3422z00_1748 = BUNSPEC;
							}} BgL_res3422z00_1748;
					}}
					BgL_auxz00_3486 = BgL_nodez00_1246;
					return (obj_t) (BgL_auxz00_3486);
				}
			}
		}
	}



/* shrink-node!-extern3196 */
	obj_t BGl_shrinkzd2nodez12zd2extern3196z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2527, obj_t BgL_nodez00_2528)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 103 */
			{
				BgL_externz00_bglt BgL_nodez00_1235;

				{	/* Ast/shrinkify.scm 104 */
					BgL_externz00_bglt BgL_auxz00_3512;

					BgL_nodez00_1235 = (BgL_externz00_bglt) (BgL_nodez00_2528);
					{	/* Ast/shrinkify.scm 104 */
						bool_t BgL_testz00_3513;

						{	/* Ast/shrinkify.scm 104 */
							bool_t BgL_testz00_3514;

							{	/* Ast/shrinkify.scm 104 */
								obj_t BgL_auxz00_3515;

								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3516;

									BgL_auxz00_3516 = (BgL_objectz00_bglt) (BgL_nodez00_1235);
									BgL_auxz00_3515 = BGL_OBJECT_WIDENING(BgL_auxz00_3516);
								}
								BgL_testz00_3514 = CBOOL(BgL_auxz00_3515);
							}
							if (BgL_testz00_3514)
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3513 = ((bool_t) 1);
								}
							else
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3513 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3513)
							{	/* Ast/shrinkify.scm 104 */
								{	/* Ast/shrinkify.scm 104 */
									long BgL_arg3321z00_1240;

									{	/* Ast/shrinkify.scm 104 */
										obj_t BgL_arg3323z00_1241;

										{	/* Ast/shrinkify.scm 104 */
											obj_t BgL_arg3324z00_1242;

											{	/* Ast/shrinkify.scm 104 */
												BgL_objectz00_bglt BgL_objectz00_1709;

												BgL_objectz00_1709 =
													(BgL_objectz00_bglt) (BgL_nodez00_1235);
												{	/* Ast/shrinkify.scm 104 */
													long BgL_arg2554z00_1710;

													{	/* Ast/shrinkify.scm 104 */
														long BgL_arg2556z00_1711;

														BgL_arg2556z00_1711 =
															BGL_OBJECT_CLASS_NUM(BgL_objectz00_1709);
														BgL_arg2554z00_1710 =
															(BgL_arg2556z00_1711 - OBJECT_TYPE);
													}
													BgL_arg3324z00_1242 =
														VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
														(int) (BgL_arg2554z00_1710));
											}}
											BgL_arg3323z00_1241 =
												BGl_classzd2superzd2zz__objectz00(BgL_arg3324z00_1242);
										}
										BgL_arg3321z00_1240 =
											BGl_classzd2numzd2zz__objectz00(BgL_arg3323z00_1241);
									}
									BGL_OBJECT_CLASS_NUM_SET(
										(BgL_objectz00_bglt) (BgL_nodez00_1235),
										BgL_arg3321z00_1240);
								}
								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3529;

									BgL_auxz00_3529 = (BgL_objectz00_bglt) (BgL_nodez00_1235);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_3529, BFALSE);
								}
								(obj_t) (BgL_nodez00_1235);
							}
						else
							{	/* Ast/shrinkify.scm 104 */
								BFALSE;
							}
					}
					{	/* Ast/shrinkify.scm 105 */
						obj_t BgL_arg3325z00_1243;

						BgL_arg3325z00_1243 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1235))->BgL_exprza2za2);
						BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3325z00_1243);
					}
					BgL_auxz00_3512 = BgL_nodez00_1235;
					return (obj_t) (BgL_auxz00_3512);
				}
			}
		}
	}



/* shrink-node!-funcall3194 */
	obj_t BGl_shrinkzd2nodez12zd2funcall3194z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2529, obj_t BgL_nodez00_2530)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 94 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1223;

				BgL_nodez00_1223 = (BgL_funcallz00_bglt) (BgL_nodez00_2530);
				{	/* Ast/shrinkify.scm 95 */
					bool_t BgL_testz00_3537;

					{	/* Ast/shrinkify.scm 95 */
						bool_t BgL_testz00_3538;

						{	/* Ast/shrinkify.scm 95 */
							obj_t BgL_auxz00_3539;

							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3540;

								BgL_auxz00_3540 = (BgL_objectz00_bglt) (BgL_nodez00_1223);
								BgL_auxz00_3539 = BGL_OBJECT_WIDENING(BgL_auxz00_3540);
							}
							BgL_testz00_3538 = CBOOL(BgL_auxz00_3539);
						}
						if (BgL_testz00_3538)
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3537 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3537 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3537)
						{	/* Ast/shrinkify.scm 95 */
							{	/* Ast/shrinkify.scm 95 */
								long BgL_arg3314z00_1228;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg3315z00_1229;

									{	/* Ast/shrinkify.scm 95 */
										obj_t BgL_arg3316z00_1230;

										{	/* Ast/shrinkify.scm 95 */
											BgL_objectz00_bglt BgL_objectz00_1667;

											BgL_objectz00_1667 =
												(BgL_objectz00_bglt) (BgL_nodez00_1223);
											{	/* Ast/shrinkify.scm 95 */
												long BgL_arg2554z00_1668;

												{	/* Ast/shrinkify.scm 95 */
													long BgL_arg2556z00_1669;

													BgL_arg2556z00_1669 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1667);
													BgL_arg2554z00_1668 =
														(BgL_arg2556z00_1669 - OBJECT_TYPE);
												}
												BgL_arg3316z00_1230 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_1668));
										}}
										BgL_arg3315z00_1229 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3316z00_1230);
									}
									BgL_arg3314z00_1228 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3315z00_1229);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1223), BgL_arg3314z00_1228);
							}
							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3553;

								BgL_auxz00_3553 = (BgL_objectz00_bglt) (BgL_nodez00_1223);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3553, BFALSE);
							}
							(obj_t) (BgL_nodez00_1223);
						}
					else
						{	/* Ast/shrinkify.scm 95 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 96 */
					BgL_nodez00_bglt BgL_arg3317z00_1231;

					BgL_arg3317z00_1231 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1223))->BgL_funz00);
					{	/* Ast/shrinkify.scm 96 */
						obj_t BgL_res3418z00_1704;

						{	/* Ast/shrinkify.scm 96 */
							obj_t BgL_method3180z00_1679;

							{	/* Ast/shrinkify.scm 96 */
								BgL_objectz00_bglt BgL_objz00_1680;

								BgL_objz00_1680 = (BgL_objectz00_bglt) (BgL_arg3317z00_1231);
								{	/* Ast/shrinkify.scm 96 */
									long BgL_objzd2classzd2numz00_1681;

									BgL_objzd2classzd2numz00_1681 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1680);
									{	/* Ast/shrinkify.scm 96 */
										obj_t BgL_arg2551z00_1682;

										BgL_arg2551z00_1682 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 96 */
											obj_t BgL_arrayz00_1684;

											int BgL_offsetz00_1685;

											BgL_arrayz00_1684 = BgL_arg2551z00_1682;
											BgL_offsetz00_1685 =
												(int) (BgL_objzd2classzd2numz00_1681);
											{	/* Ast/shrinkify.scm 96 */
												long BgL_offsetz00_1686;

												BgL_offsetz00_1686 =
													((long) (BgL_offsetz00_1685) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 96 */
													long BgL_modz00_1687;

													{	/* Ast/shrinkify.scm 96 */
														int BgL_arg2553z00_1688;

														BgL_arg2553z00_1688 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 96 */
															long BgL_auxz00_3566;

															BgL_auxz00_3566 = (long) (BgL_arg2553z00_1688);
															BgL_modz00_1687 =
																(BgL_offsetz00_1686 / BgL_auxz00_3566);
													}}
													{	/* Ast/shrinkify.scm 96 */
														long BgL_restz00_1689;

														{	/* Ast/shrinkify.scm 96 */
															int BgL_arg2552z00_1690;

															BgL_arg2552z00_1690 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 96 */
																long BgL_auxz00_3570;

																BgL_auxz00_3570 = (long) (BgL_arg2552z00_1690);
																BgL_restz00_1689 =
																	(BgL_offsetz00_1686 % BgL_auxz00_3570);
														}}
														{	/* Ast/shrinkify.scm 96 */

															BgL_method3180z00_1679 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1684,
																	(int) (BgL_modz00_1687)),
																(int) (BgL_restz00_1689));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 96 */
								obj_t BgL_xz00_2569;

								BgL_xz00_2569 =
									PROCEDURE_ENTRY(BgL_method3180z00_1679)
									(BgL_method3180z00_1679, (obj_t) (BgL_arg3317z00_1231), BEOA);
								BgL_res3418z00_1704 = BUNSPEC;
						}} BgL_res3418z00_1704;
				}}
				{	/* Ast/shrinkify.scm 97 */
					obj_t BgL_arg3318z00_1232;

					BgL_arg3318z00_1232 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1223))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3318z00_1232);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app-ly3192 */
	obj_t BGl_shrinkzd2nodez12zd2appzd2ly3192zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2531, obj_t BgL_nodez00_2532)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 85 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1211;

				BgL_nodez00_1211 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2532);
				{	/* Ast/shrinkify.scm 86 */
					bool_t BgL_testz00_3583;

					{	/* Ast/shrinkify.scm 86 */
						bool_t BgL_testz00_3584;

						{	/* Ast/shrinkify.scm 86 */
							obj_t BgL_auxz00_3585;

							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3586;

								BgL_auxz00_3586 = (BgL_objectz00_bglt) (BgL_nodez00_1211);
								BgL_auxz00_3585 = BGL_OBJECT_WIDENING(BgL_auxz00_3586);
							}
							BgL_testz00_3584 = CBOOL(BgL_auxz00_3585);
						}
						if (BgL_testz00_3584)
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3583 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3583 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3583)
						{	/* Ast/shrinkify.scm 86 */
							{	/* Ast/shrinkify.scm 86 */
								long BgL_arg3306z00_1216;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg3308z00_1217;

									{	/* Ast/shrinkify.scm 86 */
										obj_t BgL_arg3309z00_1218;

										{	/* Ast/shrinkify.scm 86 */
											BgL_objectz00_bglt BgL_objectz00_1598;

											BgL_objectz00_1598 =
												(BgL_objectz00_bglt) (BgL_nodez00_1211);
											{	/* Ast/shrinkify.scm 86 */
												long BgL_arg2554z00_1599;

												{	/* Ast/shrinkify.scm 86 */
													long BgL_arg2556z00_1600;

													BgL_arg2556z00_1600 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1598);
													BgL_arg2554z00_1599 =
														(BgL_arg2556z00_1600 - OBJECT_TYPE);
												}
												BgL_arg3309z00_1218 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_1599));
										}}
										BgL_arg3308z00_1217 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3309z00_1218);
									}
									BgL_arg3306z00_1216 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3308z00_1217);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1211), BgL_arg3306z00_1216);
							}
							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3599;

								BgL_auxz00_3599 = (BgL_objectz00_bglt) (BgL_nodez00_1211);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3599, BFALSE);
							}
							(obj_t) (BgL_nodez00_1211);
						}
					else
						{	/* Ast/shrinkify.scm 86 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 87 */
					BgL_nodez00_bglt BgL_arg3310z00_1219;

					BgL_arg3310z00_1219 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1211))->BgL_funz00);
					{	/* Ast/shrinkify.scm 87 */
						obj_t BgL_res3411z00_1635;

						{	/* Ast/shrinkify.scm 87 */
							obj_t BgL_method3180z00_1610;

							{	/* Ast/shrinkify.scm 87 */
								BgL_objectz00_bglt BgL_objz00_1611;

								BgL_objz00_1611 = (BgL_objectz00_bglt) (BgL_arg3310z00_1219);
								{	/* Ast/shrinkify.scm 87 */
									long BgL_objzd2classzd2numz00_1612;

									BgL_objzd2classzd2numz00_1612 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1611);
									{	/* Ast/shrinkify.scm 87 */
										obj_t BgL_arg2551z00_1613;

										BgL_arg2551z00_1613 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 87 */
											obj_t BgL_arrayz00_1615;

											int BgL_offsetz00_1616;

											BgL_arrayz00_1615 = BgL_arg2551z00_1613;
											BgL_offsetz00_1616 =
												(int) (BgL_objzd2classzd2numz00_1612);
											{	/* Ast/shrinkify.scm 87 */
												long BgL_offsetz00_1617;

												BgL_offsetz00_1617 =
													((long) (BgL_offsetz00_1616) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 87 */
													long BgL_modz00_1618;

													{	/* Ast/shrinkify.scm 87 */
														int BgL_arg2553z00_1619;

														BgL_arg2553z00_1619 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 87 */
															long BgL_auxz00_3612;

															BgL_auxz00_3612 = (long) (BgL_arg2553z00_1619);
															BgL_modz00_1618 =
																(BgL_offsetz00_1617 / BgL_auxz00_3612);
													}}
													{	/* Ast/shrinkify.scm 87 */
														long BgL_restz00_1620;

														{	/* Ast/shrinkify.scm 87 */
															int BgL_arg2552z00_1621;

															BgL_arg2552z00_1621 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 87 */
																long BgL_auxz00_3616;

																BgL_auxz00_3616 = (long) (BgL_arg2552z00_1621);
																BgL_restz00_1620 =
																	(BgL_offsetz00_1617 % BgL_auxz00_3616);
														}}
														{	/* Ast/shrinkify.scm 87 */

															BgL_method3180z00_1610 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1615,
																	(int) (BgL_modz00_1618)),
																(int) (BgL_restz00_1620));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 87 */
								obj_t BgL_xz00_2570;

								BgL_xz00_2570 =
									PROCEDURE_ENTRY(BgL_method3180z00_1610)
									(BgL_method3180z00_1610, (obj_t) (BgL_arg3310z00_1219), BEOA);
								BgL_res3411z00_1635 = BUNSPEC;
						}} BgL_res3411z00_1635;
				}}
				{	/* Ast/shrinkify.scm 88 */
					BgL_nodez00_bglt BgL_arg3311z00_1220;

					BgL_arg3311z00_1220 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1211))->BgL_argz00);
					{	/* Ast/shrinkify.scm 88 */
						obj_t BgL_res3414z00_1663;

						{	/* Ast/shrinkify.scm 88 */
							obj_t BgL_method3180z00_1638;

							{	/* Ast/shrinkify.scm 88 */
								BgL_objectz00_bglt BgL_objz00_1639;

								BgL_objz00_1639 = (BgL_objectz00_bglt) (BgL_arg3311z00_1220);
								{	/* Ast/shrinkify.scm 88 */
									long BgL_objzd2classzd2numz00_1640;

									BgL_objzd2classzd2numz00_1640 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1639);
									{	/* Ast/shrinkify.scm 88 */
										obj_t BgL_arg2551z00_1641;

										BgL_arg2551z00_1641 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 88 */
											obj_t BgL_arrayz00_1643;

											int BgL_offsetz00_1644;

											BgL_arrayz00_1643 = BgL_arg2551z00_1641;
											BgL_offsetz00_1644 =
												(int) (BgL_objzd2classzd2numz00_1640);
											{	/* Ast/shrinkify.scm 88 */
												long BgL_offsetz00_1645;

												BgL_offsetz00_1645 =
													((long) (BgL_offsetz00_1644) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 88 */
													long BgL_modz00_1646;

													{	/* Ast/shrinkify.scm 88 */
														int BgL_arg2553z00_1647;

														BgL_arg2553z00_1647 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 88 */
															long BgL_auxz00_3635;

															BgL_auxz00_3635 = (long) (BgL_arg2553z00_1647);
															BgL_modz00_1646 =
																(BgL_offsetz00_1645 / BgL_auxz00_3635);
													}}
													{	/* Ast/shrinkify.scm 88 */
														long BgL_restz00_1648;

														{	/* Ast/shrinkify.scm 88 */
															int BgL_arg2552z00_1649;

															BgL_arg2552z00_1649 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 88 */
																long BgL_auxz00_3639;

																BgL_auxz00_3639 = (long) (BgL_arg2552z00_1649);
																BgL_restz00_1648 =
																	(BgL_offsetz00_1645 % BgL_auxz00_3639);
														}}
														{	/* Ast/shrinkify.scm 88 */

															BgL_method3180z00_1638 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1643,
																	(int) (BgL_modz00_1646)),
																(int) (BgL_restz00_1648));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 88 */
								obj_t BgL_xz00_2571;

								BgL_xz00_2571 =
									PROCEDURE_ENTRY(BgL_method3180z00_1638)
									(BgL_method3180z00_1638, (obj_t) (BgL_arg3311z00_1220), BEOA);
								BgL_res3414z00_1663 = BUNSPEC;
						}} BgL_res3414z00_1663;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app3190 */
	obj_t BGl_shrinkzd2nodez12zd2app3190z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2533, obj_t BgL_nodez00_2534)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 76 */
			{
				BgL_appz00_bglt BgL_nodez00_1199;

				BgL_nodez00_1199 = (BgL_appz00_bglt) (BgL_nodez00_2534);
				{	/* Ast/shrinkify.scm 77 */
					bool_t BgL_testz00_3650;

					{	/* Ast/shrinkify.scm 77 */
						bool_t BgL_testz00_3651;

						{	/* Ast/shrinkify.scm 77 */
							obj_t BgL_auxz00_3652;

							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3653;

								BgL_auxz00_3653 = (BgL_objectz00_bglt) (BgL_nodez00_1199);
								BgL_auxz00_3652 = BGL_OBJECT_WIDENING(BgL_auxz00_3653);
							}
							BgL_testz00_3651 = CBOOL(BgL_auxz00_3652);
						}
						if (BgL_testz00_3651)
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3650 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3650 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3650)
						{	/* Ast/shrinkify.scm 77 */
							{	/* Ast/shrinkify.scm 77 */
								long BgL_arg3299z00_1204;

								{	/* Ast/shrinkify.scm 77 */
									obj_t BgL_arg3300z00_1205;

									{	/* Ast/shrinkify.scm 77 */
										obj_t BgL_arg3301z00_1206;

										{	/* Ast/shrinkify.scm 77 */
											BgL_objectz00_bglt BgL_objectz00_1556;

											BgL_objectz00_1556 =
												(BgL_objectz00_bglt) (BgL_nodez00_1199);
											{	/* Ast/shrinkify.scm 77 */
												long BgL_arg2554z00_1557;

												{	/* Ast/shrinkify.scm 77 */
													long BgL_arg2556z00_1558;

													BgL_arg2556z00_1558 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1556);
													BgL_arg2554z00_1557 =
														(BgL_arg2556z00_1558 - OBJECT_TYPE);
												}
												BgL_arg3301z00_1206 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_1557));
										}}
										BgL_arg3300z00_1205 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3301z00_1206);
									}
									BgL_arg3299z00_1204 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3300z00_1205);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1199), BgL_arg3299z00_1204);
							}
							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3666;

								BgL_auxz00_3666 = (BgL_objectz00_bglt) (BgL_nodez00_1199);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3666, BFALSE);
							}
							(obj_t) (BgL_nodez00_1199);
						}
					else
						{	/* Ast/shrinkify.scm 77 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 78 */
					BgL_varz00_bglt BgL_arg3302z00_1207;

					BgL_arg3302z00_1207 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1199))->BgL_funz00);
					{	/* Ast/shrinkify.scm 78 */
						obj_t BgL_res3407z00_1593;

						{	/* Ast/shrinkify.scm 78 */
							BgL_nodez00_bglt BgL_nodez00_1567;

							BgL_nodez00_1567 = (BgL_nodez00_bglt) (BgL_arg3302z00_1207);
							{	/* Ast/shrinkify.scm 78 */
								obj_t BgL_method3180z00_1568;

								{	/* Ast/shrinkify.scm 78 */
									BgL_objectz00_bglt BgL_objz00_1569;

									BgL_objz00_1569 = (BgL_objectz00_bglt) (BgL_nodez00_1567);
									{	/* Ast/shrinkify.scm 78 */
										long BgL_objzd2classzd2numz00_1570;

										BgL_objzd2classzd2numz00_1570 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1569);
										{	/* Ast/shrinkify.scm 78 */
											obj_t BgL_arg2551z00_1571;

											BgL_arg2551z00_1571 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 78 */
												obj_t BgL_arrayz00_1573;

												int BgL_offsetz00_1574;

												BgL_arrayz00_1573 = BgL_arg2551z00_1571;
												BgL_offsetz00_1574 =
													(int) (BgL_objzd2classzd2numz00_1570);
												{	/* Ast/shrinkify.scm 78 */
													long BgL_offsetz00_1575;

													BgL_offsetz00_1575 =
														((long) (BgL_offsetz00_1574) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 78 */
														long BgL_modz00_1576;

														{	/* Ast/shrinkify.scm 78 */
															int BgL_arg2553z00_1577;

															BgL_arg2553z00_1577 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 78 */
																long BgL_auxz00_3680;

																BgL_auxz00_3680 = (long) (BgL_arg2553z00_1577);
																BgL_modz00_1576 =
																	(BgL_offsetz00_1575 / BgL_auxz00_3680);
														}}
														{	/* Ast/shrinkify.scm 78 */
															long BgL_restz00_1578;

															{	/* Ast/shrinkify.scm 78 */
																int BgL_arg2552z00_1579;

																BgL_arg2552z00_1579 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 78 */
																	long BgL_auxz00_3684;

																	BgL_auxz00_3684 =
																		(long) (BgL_arg2552z00_1579);
																	BgL_restz00_1578 =
																		(BgL_offsetz00_1575 % BgL_auxz00_3684);
															}}
															{	/* Ast/shrinkify.scm 78 */

																BgL_method3180z00_1568 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1573,
																		(int) (BgL_modz00_1576)),
																	(int) (BgL_restz00_1578));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 78 */
									obj_t BgL_xz00_2572;

									BgL_xz00_2572 =
										PROCEDURE_ENTRY(BgL_method3180z00_1568)
										(BgL_method3180z00_1568, (obj_t) (BgL_nodez00_1567), BEOA);
									BgL_res3407z00_1593 = BUNSPEC;
						}}} BgL_res3407z00_1593;
				}}
				{	/* Ast/shrinkify.scm 79 */
					obj_t BgL_arg3303z00_1208;

					BgL_arg3303z00_1208 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1199))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3303z00_1208);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-sequenc3188 */
	obj_t BGl_shrinkzd2nodez12zd2sequenc3188z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2535, obj_t BgL_nodez00_2536)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 69 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1193;

				BgL_nodez00_1193 = (BgL_sequencez00_bglt) (BgL_nodez00_2536);
				{	/* Ast/shrinkify.scm 70 */
					obj_t BgL_arg3296z00_1551;

					BgL_arg3296z00_1551 =
						(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1193))->BgL_nodesz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3296z00_1551);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-kwote3186 */
	obj_t BGl_shrinkzd2nodez12zd2kwote3186z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2537, obj_t BgL_nodez00_2538)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}
	}



/* shrink-node!-var3184 */
	obj_t BGl_shrinkzd2nodez12zd2var3184z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2539, obj_t BgL_nodez00_2540)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}
	}



/* shrink-node!-atom3182 */
	obj_t BGl_shrinkzd2nodez12zd2atom3182z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2541, obj_t BgL_nodez00_2542)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3516z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3516z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3516z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3516z00zzast_shrinkifyz00));
		}
	}

#ifdef __cplusplus
}
#endif
