/*===========================================================================*/
/*   (Ast/substitute.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/substitute.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	static obj_t BGl_dozd2substitutez12zd2makezd23218zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2setq3202z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2jumpzd23216zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substituteza2z12z62zzast_substitutez00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2boxzd2s3222zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2exter3198z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_substitutez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_dozd2substitutez12zd2fail3206z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2letzd2f3210zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_substitutez00();
	extern BgL_closurez00_bglt BGl_makezd2closurezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_variablez00_bglt);
	static obj_t BGl_dozd2substitutez12zd2appzd2l3194zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_dozd2substitutez12zc0zzast_substitutez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2app3192z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_globalzd2optionalzf3z21zzast_varz00(obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2setzd2e3214zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_dozd2substitutez12zd2defau3181z12zzast_substitutez00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_methodzd2initzd2zzast_substitutez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2letzd2v3212zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_substitutez00 = BUNSPEC;
	extern obj_t BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_knownzd2appzd2lyzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, BgL_nodez00_bglt, BgL_nodez00_bglt, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2kwote3188z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	extern BgL_nodez00_bglt BGl_makezd2appzd2nodez00zzast_appz00(obj_t, obj_t,
		obj_t, BgL_varz00_bglt, obj_t);
	static obj_t BGl_dozd2substitutez12zd2var3186z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2atom3184z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern bool_t
		BGl_correctzd2arityzd2appzf3zf3zzast_appz00(BgL_variablez00_bglt, obj_t);
	static obj_t BGl_dozd2substitutez12zd2selec3208z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_substitutez00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_substitutez12z12zzast_substitutez00(obj_t, obj_t, BgL_nodez00_bglt,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl__dozd2substitutez12zc0zzast_substitutez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_dozd2substitutez12zd2funca3196z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl__dozd2substitutez12zd2defau3181z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_dozd2substitutez12zd2seque3190z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2condi3204z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__substitutez12z12zzast_substitutez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2cast3200z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	static obj_t BGl_dozd2substitutez12zd2boxzd2r3220zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_globalzd2keyzf3z21zzast_varz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_substitutez00();
	static obj_t __cnst[7];


	   
		 
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
		BgL_bgl__doza7d2substitute3565za7,
		BGl__dozd2substitutez12zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_substitutez12zd2envzc0zzast_substitutez00,
		BgL_bgl__substituteza712za713566z00,
		BGl__substitutez12z12zzast_substitutez00, 0L, BUNSPEC, 4);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_dozd2substitutez12zd2defau3181zd2envzc0zzast_substitutez00,
		BgL_bgl__doza7d2substitute3567za7,
		BGl__dozd2substitutez12zd2defau3181z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3537z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73568z00,
		BGl_dozd2substitutez12zd2atom3184z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3538z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73569z00,
		BGl_dozd2substitutez12zd2var3186z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3540z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73570z00,
		BGl_dozd2substitutez12zd2seque3190z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3539z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73571z00,
		BGl_dozd2substitutez12zd2kwote3188z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3541z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73572z00,
		BGl_dozd2substitutez12zd2app3192z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3542z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73573z00,
		BGl_dozd2substitutez12zd2appzd2l3194zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3543z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73574z00,
		BGl_dozd2substitutez12zd2funca3196z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3544z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73575z00,
		BGl_dozd2substitutez12zd2exter3198z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3545z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73576z00,
		BGl_dozd2substitutez12zd2cast3200z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3546z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73577z00,
		BGl_dozd2substitutez12zd2setq3202z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3547z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73578z00,
		BGl_dozd2substitutez12zd2condi3204z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3548z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73579z00,
		BGl_dozd2substitutez12zd2fail3206z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3550z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73580z00,
		BGl_dozd2substitutez12zd2letzd2f3210zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3549z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73581z00,
		BGl_dozd2substitutez12zd2selec3208z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3551z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73582z00,
		BGl_dozd2substitutez12zd2letzd2v3212zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3552z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73583z00,
		BGl_dozd2substitutez12zd2setzd2e3214zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3553z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73584z00,
		BGl_dozd2substitutez12zd2jumpzd23216zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3554z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73585z00,
		BGl_dozd2substitutez12zd2makezd23218zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3555z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73586z00,
		BGl_dozd2substitutez12zd2boxzd2r3220zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3556z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73587z00,
		BGl_dozd2substitutez12zd2boxzd2s3222zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3536z00zzast_substitutez00,
		BgL_bgl_string3536za700za7za7a3588za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3557z00zzast_substitutez00,
		BgL_bgl_string3557za700za7za7a3589za7, "Illegal application", 19);
	      DEFINE_STRING(BGl_string3558z00zzast_substitutez00,
		BgL_bgl_string3558za700za7za7a3590za7, "wrong number of argument(s)", 27);
	      DEFINE_STRING(BGl_string3560z00zzast_substitutez00,
		BgL_bgl_string3560za700za7za7a3591za7, "Illegal substitution", 20);
	      DEFINE_STRING(BGl_string3559z00zzast_substitutez00,
		BgL_bgl_string3559za700za7za7a3592za7, "duplicate", 9);
	      DEFINE_STRING(BGl_string3561z00zzast_substitutez00,
		BgL_bgl_string3561za700za7za7a3593za7, "ast_substitute", 14);
	      DEFINE_STRING(BGl_string3562z00zzast_substitutez00,
		BgL_bgl_string3562za700za7za7a3594za7,
		"apply funcall set! app do-substitute!-defau3181 value done ", 59);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzast_substitutez00(long
		BgL_checksumz00_2620, char *BgL_fromz00_2621)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_substitutez00))
				{
					BGl_requirezd2initializa7ationz75zzast_substitutez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_substitutez00();
					BGl_cnstzd2initzd2zzast_substitutez00();
					BGl_importedzd2moduleszd2initz00zzast_substitutez00();
					BGl_genericzd2initzd2zzast_substitutez00();
					BGl_methodzd2initzd2zzast_substitutez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_substitute");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"ast_substitute");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_substitute");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			{	/* Ast/substitute.scm 14 */
				obj_t BgL_cportz00_2608;

				BgL_cportz00_2608 =
					bgl_open_input_string(BGl_string3562z00zzast_substitutez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2609;

					BgL_iz00_2609 = ((long) 6);
				BgL_loopz00_2610:
					if ((BgL_iz00_2609 == ((long) -1)))
						{	/* Ast/substitute.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/substitute.scm 14 */
							{	/* Ast/substitute.scm 14 */
								obj_t BgL_arg3564z00_2612;

								{	/* Ast/substitute.scm 14 */

									{	/* Ast/substitute.scm 14 */
										obj_t BgL_locationz00_2614;

										BgL_locationz00_2614 = BBOOL(((bool_t) 0));
										{	/* Ast/substitute.scm 14 */

											BgL_arg3564z00_2612 =
												BGl_readz00zz__readerz00(BgL_cportz00_2608,
												BgL_locationz00_2614);
										}
									}
								}
								{	/* Ast/substitute.scm 14 */
									int BgL_auxz00_2639;

									BgL_auxz00_2639 = (int) (BgL_iz00_2609);
									CNST_TABLE_SET(BgL_auxz00_2639, BgL_arg3564z00_2612);
							}}
							{	/* Ast/substitute.scm 14 */
								int BgL_auxz00_2615;

								BgL_auxz00_2615 = (int) ((BgL_iz00_2609 - ((long) 1)));
								{
									long BgL_iz00_2644;

									BgL_iz00_2644 = (long) (BgL_auxz00_2615);
									BgL_iz00_2609 = BgL_iz00_2644;
									goto BgL_loopz00_2610;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return BUNSPEC;
		}
	}



/* substitute! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_substitutez12z12zzast_substitutez00(obj_t BgL_whatza2za2_1,
		obj_t BgL_byza2za2_2, BgL_nodez00_bglt BgL_nodez00_3, obj_t BgL_sitez00_4)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 34 */
			{
				obj_t BgL_ll3162z00_792;

				obj_t BgL_ll3163z00_793;

				BgL_ll3162z00_792 = BgL_whatza2za2_1;
				BgL_ll3163z00_793 = BgL_byza2za2_2;
			BgL_zc3anonymousza33223ze3z83_794:
				if (NULLP(BgL_ll3162z00_792))
					{	/* Ast/substitute.scm 37 */
						((bool_t) 1);
					}
				else
					{	/* Ast/substitute.scm 37 */
						{	/* Ast/substitute.scm 39 */
							obj_t BgL_whatz00_796;

							obj_t BgL_byz00_797;

							BgL_whatz00_796 = CAR(BgL_ll3162z00_792);
							BgL_byz00_797 = CAR(BgL_ll3163z00_793);
							{
								BgL_variablez00_bglt BgL_auxz00_2650;

								BgL_auxz00_2650 = (BgL_variablez00_bglt) (BgL_whatz00_796);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2650))->
										BgL_fastzd2alphazd2) = ((obj_t) BgL_byz00_797), BUNSPEC);
							}
						}
						{
							obj_t BgL_ll3163z00_2655;

							obj_t BgL_ll3162z00_2653;

							BgL_ll3162z00_2653 = CDR(BgL_ll3162z00_792);
							BgL_ll3163z00_2655 = CDR(BgL_ll3163z00_793);
							BgL_ll3163z00_793 = BgL_ll3163z00_2655;
							BgL_ll3162z00_792 = BgL_ll3162z00_2653;
							goto BgL_zc3anonymousza33223ze3z83_794;
						}
					}
			}
			{	/* Ast/substitute.scm 42 */
				BgL_nodez00_bglt BgL_resz00_801;

				{	/* Ast/substitute.scm 42 */
					BgL_nodez00_bglt BgL_res3446z00_1517;

					{	/* Ast/substitute.scm 42 */
						obj_t BgL_method3182z00_1492;

						{	/* Ast/substitute.scm 42 */
							BgL_objectz00_bglt BgL_objz00_1493;

							BgL_objz00_1493 = (BgL_objectz00_bglt) (BgL_nodez00_3);
							{	/* Ast/substitute.scm 42 */
								long BgL_objzd2classzd2numz00_1494;

								BgL_objzd2classzd2numz00_1494 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_1493);
								{	/* Ast/substitute.scm 42 */
									obj_t BgL_arg2551z00_1495;

									BgL_arg2551z00_1495 =
										PROCEDURE_REF
										(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
										(int) (((long) 1)));
									{	/* Ast/substitute.scm 42 */
										obj_t BgL_arrayz00_1497;

										int BgL_offsetz00_1498;

										BgL_arrayz00_1497 = BgL_arg2551z00_1495;
										BgL_offsetz00_1498 = (int) (BgL_objzd2classzd2numz00_1494);
										{	/* Ast/substitute.scm 42 */
											long BgL_offsetz00_1499;

											BgL_offsetz00_1499 =
												((long) (BgL_offsetz00_1498) - OBJECT_TYPE);
											{	/* Ast/substitute.scm 42 */
												long BgL_modz00_1500;

												{	/* Ast/substitute.scm 42 */
													int BgL_arg2553z00_1501;

													BgL_arg2553z00_1501 = (int) (((long) 8));
													{	/* Ast/substitute.scm 42 */
														long BgL_auxz00_2665;

														BgL_auxz00_2665 = (long) (BgL_arg2553z00_1501);
														BgL_modz00_1500 =
															(BgL_offsetz00_1499 / BgL_auxz00_2665);
												}}
												{	/* Ast/substitute.scm 42 */
													long BgL_restz00_1502;

													{	/* Ast/substitute.scm 42 */
														int BgL_arg2552z00_1503;

														BgL_arg2552z00_1503 = (int) (((long) 8));
														{	/* Ast/substitute.scm 42 */
															long BgL_auxz00_2669;

															BgL_auxz00_2669 = (long) (BgL_arg2552z00_1503);
															BgL_restz00_1502 =
																(BgL_offsetz00_1499 % BgL_auxz00_2669);
													}}
													{	/* Ast/substitute.scm 42 */

														BgL_method3182z00_1492 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_1497,
																(int) (BgL_modz00_1500)),
															(int) (BgL_restz00_1502));
						}}}}}}}}
						BgL_res3446z00_1517 =
							(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1492)
							(BgL_method3182z00_1492, (obj_t) (BgL_nodez00_3), BgL_sitez00_4,
								BEOA));
					}
					BgL_resz00_801 = BgL_res3446z00_1517;
				}
				{
					obj_t BgL_l3165z00_803;

					BgL_l3165z00_803 = BgL_whatza2za2_1;
				BgL_zc3anonymousza33227ze3z83_804:
					if (PAIRP(BgL_l3165z00_803))
						{	/* Ast/substitute.scm 44 */
							{	/* Ast/substitute.scm 45 */
								obj_t BgL_whatz00_806;

								BgL_whatz00_806 = CAR(BgL_l3165z00_803);
								{
									BgL_variablez00_bglt BgL_auxz00_2683;

									BgL_auxz00_2683 = (BgL_variablez00_bglt) (BgL_whatz00_806);
									((((BgL_variablez00_bglt) CREF(BgL_auxz00_2683))->
											BgL_fastzd2alphazd2) = ((obj_t) BUNSPEC), BUNSPEC);
								}
							}
							{
								obj_t BgL_l3165z00_2686;

								BgL_l3165z00_2686 = CDR(BgL_l3165z00_803);
								BgL_l3165z00_803 = BgL_l3165z00_2686;
								goto BgL_zc3anonymousza33227ze3z83_804;
							}
						}
					else
						{	/* Ast/substitute.scm 44 */
							((bool_t) 1);
						}
				}
				return BgL_resz00_801;
			}
		}
	}



/* _substitute! */
	obj_t BGl__substitutez12z12zzast_substitutez00(obj_t BgL_envz00_2517,
		obj_t BgL_whatza2za2_2518, obj_t BgL_byza2za2_2519, obj_t BgL_nodez00_2520,
		obj_t BgL_sitez00_2521)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 34 */
			return
				(obj_t) (BGl_substitutez12z12zzast_substitutez00(BgL_whatza2za2_2518,
					BgL_byza2za2_2519, (BgL_nodez00_bglt) (BgL_nodez00_2520),
					BgL_sitez00_2521));
		}
	}



/* do-substitute*! */
	obj_t BGl_dozd2substituteza2z12z62zzast_substitutez00(obj_t BgL_nodeza2za2_49,
		obj_t BgL_sitez00_50)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 271 */
		BGl_dozd2substituteza2z12z62zzast_substitutez00:
			if (NULLP(BgL_nodeza2za2_49))
				{	/* Ast/substitute.scm 273 */
					return CNST_TABLE_REF(((long) 0));
				}
			else
				{	/* Ast/substitute.scm 273 */
					if (NULLP(CDR(BgL_nodeza2za2_49)))
						{	/* Ast/substitute.scm 275 */
							{	/* Ast/substitute.scm 276 */
								BgL_nodez00_bglt BgL_arg3232z00_811;

								{	/* Ast/substitute.scm 276 */
									obj_t BgL_arg3233z00_812;

									BgL_arg3233z00_812 = CAR(BgL_nodeza2za2_49);
									{	/* Ast/substitute.scm 276 */
										BgL_nodez00_bglt BgL_res3449z00_1554;

										{	/* Ast/substitute.scm 276 */
											BgL_nodez00_bglt BgL_nodez00_1527;

											BgL_nodez00_1527 =
												(BgL_nodez00_bglt) (BgL_arg3233z00_812);
											{	/* Ast/substitute.scm 276 */
												obj_t BgL_method3182z00_1529;

												{	/* Ast/substitute.scm 276 */
													BgL_objectz00_bglt BgL_objz00_1530;

													BgL_objz00_1530 =
														(BgL_objectz00_bglt) (BgL_nodez00_1527);
													{	/* Ast/substitute.scm 276 */
														long BgL_objzd2classzd2numz00_1531;

														BgL_objzd2classzd2numz00_1531 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1530);
														{	/* Ast/substitute.scm 276 */
															obj_t BgL_arg2551z00_1532;

															BgL_arg2551z00_1532 =
																PROCEDURE_REF
																(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																(int) (((long) 1)));
															{	/* Ast/substitute.scm 276 */
																obj_t BgL_arrayz00_1534;

																int BgL_offsetz00_1535;

																BgL_arrayz00_1534 = BgL_arg2551z00_1532;
																BgL_offsetz00_1535 =
																	(int) (BgL_objzd2classzd2numz00_1531);
																{	/* Ast/substitute.scm 276 */
																	long BgL_offsetz00_1536;

																	BgL_offsetz00_1536 =
																		((long) (BgL_offsetz00_1535) - OBJECT_TYPE);
																	{	/* Ast/substitute.scm 276 */
																		long BgL_modz00_1537;

																		{	/* Ast/substitute.scm 276 */
																			int BgL_arg2553z00_1538;

																			BgL_arg2553z00_1538 = (int) (((long) 8));
																			{	/* Ast/substitute.scm 276 */
																				long BgL_auxz00_2707;

																				BgL_auxz00_2707 =
																					(long) (BgL_arg2553z00_1538);
																				BgL_modz00_1537 =
																					(BgL_offsetz00_1536 /
																					BgL_auxz00_2707);
																		}}
																		{	/* Ast/substitute.scm 276 */
																			long BgL_restz00_1539;

																			{	/* Ast/substitute.scm 276 */
																				int BgL_arg2552z00_1540;

																				BgL_arg2552z00_1540 =
																					(int) (((long) 8));
																				{	/* Ast/substitute.scm 276 */
																					long BgL_auxz00_2711;

																					BgL_auxz00_2711 =
																						(long) (BgL_arg2552z00_1540);
																					BgL_restz00_1539 =
																						(BgL_offsetz00_1536 %
																						BgL_auxz00_2711);
																			}}
																			{	/* Ast/substitute.scm 276 */

																				BgL_method3182z00_1529 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1534,
																						(int) (BgL_modz00_1537)),
																					(int) (BgL_restz00_1539));
												}}}}}}}}
												BgL_res3449z00_1554 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3182z00_1529) (BgL_method3182z00_1529,
														(obj_t) (BgL_nodez00_1527), BgL_sitez00_50, BEOA));
										}}
										BgL_arg3232z00_811 = BgL_res3449z00_1554;
								}}
								{	/* Ast/substitute.scm 276 */
									obj_t BgL_auxz00_2722;

									BgL_auxz00_2722 = (obj_t) (BgL_arg3232z00_811);
									SET_CAR(BgL_nodeza2za2_49, BgL_auxz00_2722);
							}}
							return CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Ast/substitute.scm 275 */
							{	/* Ast/substitute.scm 279 */
								BgL_nodez00_bglt BgL_arg3234z00_813;

								{	/* Ast/substitute.scm 279 */
									obj_t BgL_arg3235z00_814;

									obj_t BgL_arg3236z00_815;

									BgL_arg3235z00_814 = CAR(BgL_nodeza2za2_49);
									BgL_arg3236z00_815 = CNST_TABLE_REF(((long) 1));
									{	/* Ast/substitute.scm 279 */
										BgL_nodez00_bglt BgL_res3452z00_1585;

										{	/* Ast/substitute.scm 279 */
											BgL_nodez00_bglt BgL_nodez00_1558;

											BgL_nodez00_1558 =
												(BgL_nodez00_bglt) (BgL_arg3235z00_814);
											{	/* Ast/substitute.scm 279 */
												obj_t BgL_method3182z00_1560;

												{	/* Ast/substitute.scm 279 */
													BgL_objectz00_bglt BgL_objz00_1561;

													BgL_objz00_1561 =
														(BgL_objectz00_bglt) (BgL_nodez00_1558);
													{	/* Ast/substitute.scm 279 */
														long BgL_objzd2classzd2numz00_1562;

														BgL_objzd2classzd2numz00_1562 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1561);
														{	/* Ast/substitute.scm 279 */
															obj_t BgL_arg2551z00_1563;

															BgL_arg2551z00_1563 =
																PROCEDURE_REF
																(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																(int) (((long) 1)));
															{	/* Ast/substitute.scm 279 */
																obj_t BgL_arrayz00_1565;

																int BgL_offsetz00_1566;

																BgL_arrayz00_1565 = BgL_arg2551z00_1563;
																BgL_offsetz00_1566 =
																	(int) (BgL_objzd2classzd2numz00_1562);
																{	/* Ast/substitute.scm 279 */
																	long BgL_offsetz00_1567;

																	BgL_offsetz00_1567 =
																		((long) (BgL_offsetz00_1566) - OBJECT_TYPE);
																	{	/* Ast/substitute.scm 279 */
																		long BgL_modz00_1568;

																		{	/* Ast/substitute.scm 279 */
																			int BgL_arg2553z00_1569;

																			BgL_arg2553z00_1569 = (int) (((long) 8));
																			{	/* Ast/substitute.scm 279 */
																				long BgL_auxz00_2737;

																				BgL_auxz00_2737 =
																					(long) (BgL_arg2553z00_1569);
																				BgL_modz00_1568 =
																					(BgL_offsetz00_1567 /
																					BgL_auxz00_2737);
																		}}
																		{	/* Ast/substitute.scm 279 */
																			long BgL_restz00_1570;

																			{	/* Ast/substitute.scm 279 */
																				int BgL_arg2552z00_1571;

																				BgL_arg2552z00_1571 =
																					(int) (((long) 8));
																				{	/* Ast/substitute.scm 279 */
																					long BgL_auxz00_2741;

																					BgL_auxz00_2741 =
																						(long) (BgL_arg2552z00_1571);
																					BgL_restz00_1570 =
																						(BgL_offsetz00_1567 %
																						BgL_auxz00_2741);
																			}}
																			{	/* Ast/substitute.scm 279 */

																				BgL_method3182z00_1560 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1565,
																						(int) (BgL_modz00_1568)),
																					(int) (BgL_restz00_1570));
												}}}}}}}}
												BgL_res3452z00_1585 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3182z00_1560) (BgL_method3182z00_1560,
														(obj_t) (BgL_nodez00_1558), BgL_arg3236z00_815,
														BEOA));
										}}
										BgL_arg3234z00_813 = BgL_res3452z00_1585;
								}}
								{	/* Ast/substitute.scm 279 */
									obj_t BgL_auxz00_2752;

									BgL_auxz00_2752 = (obj_t) (BgL_arg3234z00_813);
									SET_CAR(BgL_nodeza2za2_49, BgL_auxz00_2752);
							}}
							{
								obj_t BgL_nodeza2za2_2755;

								BgL_nodeza2za2_2755 = CDR(BgL_nodeza2za2_49);
								BgL_nodeza2za2_49 = BgL_nodeza2za2_2755;
								goto BGl_dozd2substituteza2z12z62zzast_substitutez00;
							}
						}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_dozd2substitutez12zd2defau3181zd2envzc0zzast_substitutez00);
		}
	}



/* do-substitute! */
	BgL_nodez00_bglt BGl_dozd2substitutez12zc0zzast_substitutez00(BgL_nodez00_bglt
		BgL_nodez00_5, obj_t BgL_sitez00_6)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 52 */
			{	/* Ast/substitute.scm 52 */
				obj_t BgL_method3182z00_1589;

				{	/* Ast/substitute.scm 52 */
					BgL_objectz00_bglt BgL_objz00_1590;

					BgL_objz00_1590 = (BgL_objectz00_bglt) (BgL_nodez00_5);
					{	/* Ast/substitute.scm 52 */
						long BgL_objzd2classzd2numz00_1591;

						BgL_objzd2classzd2numz00_1591 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1590);
						{	/* Ast/substitute.scm 52 */
							obj_t BgL_arg2551z00_1592;

							BgL_arg2551z00_1592 =
								PROCEDURE_REF
								(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
								(int) (((long) 1)));
							{	/* Ast/substitute.scm 52 */
								obj_t BgL_arrayz00_1594;

								int BgL_offsetz00_1595;

								BgL_arrayz00_1594 = BgL_arg2551z00_1592;
								BgL_offsetz00_1595 = (int) (BgL_objzd2classzd2numz00_1591);
								{	/* Ast/substitute.scm 52 */
									long BgL_offsetz00_1596;

									BgL_offsetz00_1596 =
										((long) (BgL_offsetz00_1595) - OBJECT_TYPE);
									{	/* Ast/substitute.scm 52 */
										long BgL_modz00_1597;

										{	/* Ast/substitute.scm 52 */
											int BgL_arg2553z00_1598;

											BgL_arg2553z00_1598 = (int) (((long) 8));
											{	/* Ast/substitute.scm 52 */
												long BgL_auxz00_2766;

												BgL_auxz00_2766 = (long) (BgL_arg2553z00_1598);
												BgL_modz00_1597 =
													(BgL_offsetz00_1596 / BgL_auxz00_2766);
										}}
										{	/* Ast/substitute.scm 52 */
											long BgL_restz00_1599;

											{	/* Ast/substitute.scm 52 */
												int BgL_arg2552z00_1600;

												BgL_arg2552z00_1600 = (int) (((long) 8));
												{	/* Ast/substitute.scm 52 */
													long BgL_auxz00_2770;

													BgL_auxz00_2770 = (long) (BgL_arg2552z00_1600);
													BgL_restz00_1599 =
														(BgL_offsetz00_1596 % BgL_auxz00_2770);
											}}
											{	/* Ast/substitute.scm 52 */

												BgL_method3182z00_1589 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1594,
														(int) (BgL_modz00_1597)), (int) (BgL_restz00_1599));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1589)
					(BgL_method3182z00_1589, (obj_t) (BgL_nodez00_5), BgL_sitez00_6,
						BEOA));
			}
		}
	}



/* _do-substitute! */
	obj_t BGl__dozd2substitutez12zc0zzast_substitutez00(obj_t BgL_envz00_2522,
		obj_t BgL_nodez00_2523, obj_t BgL_sitez00_2524)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 52 */
			return
				(obj_t) (BGl_dozd2substitutez12zc0zzast_substitutez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2523), BgL_sitez00_2524));
		}
	}



/* do-substitute!-defau3181 */
	BgL_nodez00_bglt
		BGl_dozd2substitutez12zd2defau3181z12zzast_substitutez00(BgL_nodez00_bglt
		BgL_nodez00_7, obj_t BgL_sitez00_8)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string3536z00zzast_substitutez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _do-substitute!-defau3181 */
	obj_t BGl__dozd2substitutez12zd2defau3181z12zzast_substitutez00(obj_t
		BgL_envz00_2525, obj_t BgL_nodez00_2526, obj_t BgL_sitez00_2527)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				(obj_t) (BGl_dozd2substitutez12zd2defau3181z12zzast_substitutez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2526), BgL_sitez00_2527));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_atomz00zzast_nodez00, BGl_proc3537z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_varz00zzast_nodez00, BGl_proc3538z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_kwotez00zzast_nodez00, BGl_proc3539z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_sequencez00zzast_nodez00, BGl_proc3540z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_appz00zzast_nodez00, BGl_proc3541z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3542z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_funcallz00zzast_nodez00, BGl_proc3543z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_externz00zzast_nodez00, BGl_proc3544z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_castz00zzast_nodez00, BGl_proc3545z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_setqz00zzast_nodez00, BGl_proc3546z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3547z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_failz00zzast_nodez00, BGl_proc3548z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_selectz00zzast_nodez00, BGl_proc3549z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3550z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3551z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3552z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3553z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3554z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3555z00zzast_substitutez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3556z00zzast_substitutez00);
		}
	}



/* do-substitute!-box-s3222 */
	obj_t BGl_dozd2substitutez12zd2boxzd2s3222zc0zzast_substitutez00(obj_t
		BgL_envz00_2548, obj_t BgL_nodez00_2549, obj_t BgL_sitez00_2550)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 263 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1471;

				obj_t BgL_sitez00_1472;

				{	/* Ast/substitute.scm 264 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_2811;

					BgL_nodez00_1471 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2549);
					BgL_sitez00_1472 = BgL_sitez00_2550;
					{	/* Ast/substitute.scm 264 */
						BgL_nodez00_bglt BgL_arg3437z00_1475;

						{	/* Ast/substitute.scm 264 */
							BgL_varz00_bglt BgL_arg3438z00_1476;

							obj_t BgL_arg3439z00_1477;

							BgL_arg3438z00_1476 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1471))->
								BgL_varz00);
							BgL_arg3439z00_1477 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 264 */
								BgL_nodez00_bglt BgL_res3532z00_2483;

								{	/* Ast/substitute.scm 264 */
									BgL_nodez00_bglt BgL_nodez00_2456;

									BgL_nodez00_2456 = (BgL_nodez00_bglt) (BgL_arg3438z00_1476);
									{	/* Ast/substitute.scm 264 */
										obj_t BgL_method3182z00_2458;

										{	/* Ast/substitute.scm 264 */
											BgL_objectz00_bglt BgL_objz00_2459;

											BgL_objz00_2459 = (BgL_objectz00_bglt) (BgL_nodez00_2456);
											{	/* Ast/substitute.scm 264 */
												long BgL_objzd2classzd2numz00_2460;

												BgL_objzd2classzd2numz00_2460 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2459);
												{	/* Ast/substitute.scm 264 */
													obj_t BgL_arg2551z00_2461;

													BgL_arg2551z00_2461 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 264 */
														obj_t BgL_arrayz00_2463;

														int BgL_offsetz00_2464;

														BgL_arrayz00_2463 = BgL_arg2551z00_2461;
														BgL_offsetz00_2464 =
															(int) (BgL_objzd2classzd2numz00_2460);
														{	/* Ast/substitute.scm 264 */
															long BgL_offsetz00_2465;

															BgL_offsetz00_2465 =
																((long) (BgL_offsetz00_2464) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 264 */
																long BgL_modz00_2466;

																{	/* Ast/substitute.scm 264 */
																	int BgL_arg2553z00_2467;

																	BgL_arg2553z00_2467 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 264 */
																		long BgL_auxz00_2823;

																		BgL_auxz00_2823 =
																			(long) (BgL_arg2553z00_2467);
																		BgL_modz00_2466 =
																			(BgL_offsetz00_2465 / BgL_auxz00_2823);
																}}
																{	/* Ast/substitute.scm 264 */
																	long BgL_restz00_2468;

																	{	/* Ast/substitute.scm 264 */
																		int BgL_arg2552z00_2469;

																		BgL_arg2552z00_2469 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 264 */
																			long BgL_auxz00_2827;

																			BgL_auxz00_2827 =
																				(long) (BgL_arg2552z00_2469);
																			BgL_restz00_2468 =
																				(BgL_offsetz00_2465 % BgL_auxz00_2827);
																	}}
																	{	/* Ast/substitute.scm 264 */

																		BgL_method3182z00_2458 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2463,
																				(int) (BgL_modz00_2466)),
																			(int) (BgL_restz00_2468));
										}}}}}}}}
										BgL_res3532z00_2483 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3182z00_2458) (BgL_method3182z00_2458,
												(obj_t) (BgL_nodez00_2456), BgL_arg3439z00_1477, BEOA));
								}}
								BgL_arg3437z00_1475 = BgL_res3532z00_2483;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2838;

							BgL_auxz00_2838 = (BgL_varz00_bglt) (BgL_arg3437z00_1475);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1471))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_2838), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 265 */
						BgL_nodez00_bglt BgL_arg3440z00_1478;

						{	/* Ast/substitute.scm 265 */
							BgL_nodez00_bglt BgL_arg3441z00_1479;

							obj_t BgL_arg3442z00_1480;

							BgL_arg3441z00_1479 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1471))->
								BgL_valuez00);
							BgL_arg3442z00_1480 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 265 */
								BgL_nodez00_bglt BgL_res3535z00_2514;

								{	/* Ast/substitute.scm 265 */
									obj_t BgL_method3182z00_2489;

									{	/* Ast/substitute.scm 265 */
										BgL_objectz00_bglt BgL_objz00_2490;

										BgL_objz00_2490 =
											(BgL_objectz00_bglt) (BgL_arg3441z00_1479);
										{	/* Ast/substitute.scm 265 */
											long BgL_objzd2classzd2numz00_2491;

											BgL_objzd2classzd2numz00_2491 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2490);
											{	/* Ast/substitute.scm 265 */
												obj_t BgL_arg2551z00_2492;

												BgL_arg2551z00_2492 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 265 */
													obj_t BgL_arrayz00_2494;

													int BgL_offsetz00_2495;

													BgL_arrayz00_2494 = BgL_arg2551z00_2492;
													BgL_offsetz00_2495 =
														(int) (BgL_objzd2classzd2numz00_2491);
													{	/* Ast/substitute.scm 265 */
														long BgL_offsetz00_2496;

														BgL_offsetz00_2496 =
															((long) (BgL_offsetz00_2495) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 265 */
															long BgL_modz00_2497;

															{	/* Ast/substitute.scm 265 */
																int BgL_arg2553z00_2498;

																BgL_arg2553z00_2498 = (int) (((long) 8));
																{	/* Ast/substitute.scm 265 */
																	long BgL_auxz00_2851;

																	BgL_auxz00_2851 =
																		(long) (BgL_arg2553z00_2498);
																	BgL_modz00_2497 =
																		(BgL_offsetz00_2496 / BgL_auxz00_2851);
															}}
															{	/* Ast/substitute.scm 265 */
																long BgL_restz00_2499;

																{	/* Ast/substitute.scm 265 */
																	int BgL_arg2552z00_2500;

																	BgL_arg2552z00_2500 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 265 */
																		long BgL_auxz00_2855;

																		BgL_auxz00_2855 =
																			(long) (BgL_arg2552z00_2500);
																		BgL_restz00_2499 =
																			(BgL_offsetz00_2496 % BgL_auxz00_2855);
																}}
																{	/* Ast/substitute.scm 265 */

																	BgL_method3182z00_2489 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2494,
																			(int) (BgL_modz00_2497)),
																		(int) (BgL_restz00_2499));
									}}}}}}}}
									BgL_res3535z00_2514 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2489)
										(BgL_method3182z00_2489, (obj_t) (BgL_arg3441z00_1479),
											BgL_arg3442z00_1480, BEOA));
								}
								BgL_arg3440z00_1478 = BgL_res3535z00_2514;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1471))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3440z00_1478), BUNSPEC);
					}
					BgL_auxz00_2811 = BgL_nodez00_1471;
					return (obj_t) (BgL_auxz00_2811);
				}
			}
		}
	}



/* do-substitute!-box-r3220 */
	obj_t BGl_dozd2substitutez12zd2boxzd2r3220zc0zzast_substitutez00(obj_t
		BgL_envz00_2551, obj_t BgL_nodez00_2552, obj_t BgL_sitez00_2553)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 256 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1462;

				obj_t BgL_sitez00_1463;

				{	/* Ast/substitute.scm 257 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_2869;

					BgL_nodez00_1462 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2552);
					BgL_sitez00_1463 = BgL_sitez00_2553;
					{	/* Ast/substitute.scm 257 */
						BgL_nodez00_bglt BgL_arg3433z00_2421;

						{	/* Ast/substitute.scm 257 */
							BgL_varz00_bglt BgL_arg3434z00_2422;

							obj_t BgL_arg3435z00_2423;

							BgL_arg3434z00_2422 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1462))->BgL_varz00);
							BgL_arg3435z00_2423 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 257 */
								BgL_nodez00_bglt BgL_res3529z00_2452;

								{	/* Ast/substitute.scm 257 */
									BgL_nodez00_bglt BgL_nodez00_2425;

									BgL_nodez00_2425 = (BgL_nodez00_bglt) (BgL_arg3434z00_2422);
									{	/* Ast/substitute.scm 257 */
										obj_t BgL_method3182z00_2427;

										{	/* Ast/substitute.scm 257 */
											BgL_objectz00_bglt BgL_objz00_2428;

											BgL_objz00_2428 = (BgL_objectz00_bglt) (BgL_nodez00_2425);
											{	/* Ast/substitute.scm 257 */
												long BgL_objzd2classzd2numz00_2429;

												BgL_objzd2classzd2numz00_2429 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2428);
												{	/* Ast/substitute.scm 257 */
													obj_t BgL_arg2551z00_2430;

													BgL_arg2551z00_2430 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 257 */
														obj_t BgL_arrayz00_2432;

														int BgL_offsetz00_2433;

														BgL_arrayz00_2432 = BgL_arg2551z00_2430;
														BgL_offsetz00_2433 =
															(int) (BgL_objzd2classzd2numz00_2429);
														{	/* Ast/substitute.scm 257 */
															long BgL_offsetz00_2434;

															BgL_offsetz00_2434 =
																((long) (BgL_offsetz00_2433) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 257 */
																long BgL_modz00_2435;

																{	/* Ast/substitute.scm 257 */
																	int BgL_arg2553z00_2436;

																	BgL_arg2553z00_2436 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 257 */
																		long BgL_auxz00_2881;

																		BgL_auxz00_2881 =
																			(long) (BgL_arg2553z00_2436);
																		BgL_modz00_2435 =
																			(BgL_offsetz00_2434 / BgL_auxz00_2881);
																}}
																{	/* Ast/substitute.scm 257 */
																	long BgL_restz00_2437;

																	{	/* Ast/substitute.scm 257 */
																		int BgL_arg2552z00_2438;

																		BgL_arg2552z00_2438 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 257 */
																			long BgL_auxz00_2885;

																			BgL_auxz00_2885 =
																				(long) (BgL_arg2552z00_2438);
																			BgL_restz00_2437 =
																				(BgL_offsetz00_2434 % BgL_auxz00_2885);
																	}}
																	{	/* Ast/substitute.scm 257 */

																		BgL_method3182z00_2427 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2432,
																				(int) (BgL_modz00_2435)),
																			(int) (BgL_restz00_2437));
										}}}}}}}}
										BgL_res3529z00_2452 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3182z00_2427) (BgL_method3182z00_2427,
												(obj_t) (BgL_nodez00_2425), BgL_arg3435z00_2423, BEOA));
								}}
								BgL_arg3433z00_2421 = BgL_res3529z00_2452;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2896;

							BgL_auxz00_2896 = (BgL_varz00_bglt) (BgL_arg3433z00_2421);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1462))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_2896), BUNSPEC);
					}}
					BgL_auxz00_2869 = BgL_nodez00_1462;
					return (obj_t) (BgL_auxz00_2869);
				}
			}
		}
	}



/* do-substitute!-make-3218 */
	obj_t BGl_dozd2substitutez12zd2makezd23218zc0zzast_substitutez00(obj_t
		BgL_envz00_2554, obj_t BgL_nodez00_2555, obj_t BgL_sitez00_2556)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 249 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1453;

				obj_t BgL_sitez00_1454;

				{	/* Ast/substitute.scm 250 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_2901;

					BgL_nodez00_1453 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2555);
					BgL_sitez00_1454 = BgL_sitez00_2556;
					{	/* Ast/substitute.scm 250 */
						BgL_nodez00_bglt BgL_arg3428z00_2387;

						{	/* Ast/substitute.scm 250 */
							BgL_nodez00_bglt BgL_arg3429z00_2388;

							obj_t BgL_arg3430z00_2389;

							BgL_arg3429z00_2388 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1453))->
								BgL_valuez00);
							BgL_arg3430z00_2389 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 250 */
								BgL_nodez00_bglt BgL_res3526z00_2418;

								{	/* Ast/substitute.scm 250 */
									obj_t BgL_method3182z00_2393;

									{	/* Ast/substitute.scm 250 */
										BgL_objectz00_bglt BgL_objz00_2394;

										BgL_objz00_2394 =
											(BgL_objectz00_bglt) (BgL_arg3429z00_2388);
										{	/* Ast/substitute.scm 250 */
											long BgL_objzd2classzd2numz00_2395;

											BgL_objzd2classzd2numz00_2395 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2394);
											{	/* Ast/substitute.scm 250 */
												obj_t BgL_arg2551z00_2396;

												BgL_arg2551z00_2396 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 250 */
													obj_t BgL_arrayz00_2398;

													int BgL_offsetz00_2399;

													BgL_arrayz00_2398 = BgL_arg2551z00_2396;
													BgL_offsetz00_2399 =
														(int) (BgL_objzd2classzd2numz00_2395);
													{	/* Ast/substitute.scm 250 */
														long BgL_offsetz00_2400;

														BgL_offsetz00_2400 =
															((long) (BgL_offsetz00_2399) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 250 */
															long BgL_modz00_2401;

															{	/* Ast/substitute.scm 250 */
																int BgL_arg2553z00_2402;

																BgL_arg2553z00_2402 = (int) (((long) 8));
																{	/* Ast/substitute.scm 250 */
																	long BgL_auxz00_2912;

																	BgL_auxz00_2912 =
																		(long) (BgL_arg2553z00_2402);
																	BgL_modz00_2401 =
																		(BgL_offsetz00_2400 / BgL_auxz00_2912);
															}}
															{	/* Ast/substitute.scm 250 */
																long BgL_restz00_2403;

																{	/* Ast/substitute.scm 250 */
																	int BgL_arg2552z00_2404;

																	BgL_arg2552z00_2404 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 250 */
																		long BgL_auxz00_2916;

																		BgL_auxz00_2916 =
																			(long) (BgL_arg2552z00_2404);
																		BgL_restz00_2403 =
																			(BgL_offsetz00_2400 % BgL_auxz00_2916);
																}}
																{	/* Ast/substitute.scm 250 */

																	BgL_method3182z00_2393 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2398,
																			(int) (BgL_modz00_2401)),
																		(int) (BgL_restz00_2403));
									}}}}}}}}
									BgL_res3526z00_2418 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2393)
										(BgL_method3182z00_2393, (obj_t) (BgL_arg3429z00_2388),
											BgL_arg3430z00_2389, BEOA));
								}
								BgL_arg3428z00_2387 = BgL_res3526z00_2418;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1453))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3428z00_2387), BUNSPEC);
					}
					BgL_auxz00_2901 = BgL_nodez00_1453;
					return (obj_t) (BgL_auxz00_2901);
				}
			}
		}
	}



/* do-substitute!-jump-3216 */
	obj_t BGl_dozd2substitutez12zd2jumpzd23216zc0zzast_substitutez00(obj_t
		BgL_envz00_2557, obj_t BgL_nodez00_2558, obj_t BgL_sitez00_2559)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 241 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1441;

				obj_t BgL_sitez00_1442;

				{	/* Ast/substitute.scm 242 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_2930;

					BgL_nodez00_1441 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2558);
					BgL_sitez00_1442 = BgL_sitez00_2559;
					{	/* Ast/substitute.scm 242 */
						BgL_nodez00_bglt BgL_arg3421z00_1445;

						{	/* Ast/substitute.scm 242 */
							BgL_nodez00_bglt BgL_arg3422z00_1446;

							obj_t BgL_arg3423z00_1447;

							BgL_arg3422z00_1446 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1441))->
								BgL_exitz00);
							BgL_arg3423z00_1447 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/substitute.scm 242 */
								BgL_nodez00_bglt BgL_res3520z00_2353;

								{	/* Ast/substitute.scm 242 */
									obj_t BgL_method3182z00_2328;

									{	/* Ast/substitute.scm 242 */
										BgL_objectz00_bglt BgL_objz00_2329;

										BgL_objz00_2329 =
											(BgL_objectz00_bglt) (BgL_arg3422z00_1446);
										{	/* Ast/substitute.scm 242 */
											long BgL_objzd2classzd2numz00_2330;

											BgL_objzd2classzd2numz00_2330 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2329);
											{	/* Ast/substitute.scm 242 */
												obj_t BgL_arg2551z00_2331;

												BgL_arg2551z00_2331 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 242 */
													obj_t BgL_arrayz00_2333;

													int BgL_offsetz00_2334;

													BgL_arrayz00_2333 = BgL_arg2551z00_2331;
													BgL_offsetz00_2334 =
														(int) (BgL_objzd2classzd2numz00_2330);
													{	/* Ast/substitute.scm 242 */
														long BgL_offsetz00_2335;

														BgL_offsetz00_2335 =
															((long) (BgL_offsetz00_2334) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 242 */
															long BgL_modz00_2336;

															{	/* Ast/substitute.scm 242 */
																int BgL_arg2553z00_2337;

																BgL_arg2553z00_2337 = (int) (((long) 8));
																{	/* Ast/substitute.scm 242 */
																	long BgL_auxz00_2941;

																	BgL_auxz00_2941 =
																		(long) (BgL_arg2553z00_2337);
																	BgL_modz00_2336 =
																		(BgL_offsetz00_2335 / BgL_auxz00_2941);
															}}
															{	/* Ast/substitute.scm 242 */
																long BgL_restz00_2338;

																{	/* Ast/substitute.scm 242 */
																	int BgL_arg2552z00_2339;

																	BgL_arg2552z00_2339 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 242 */
																		long BgL_auxz00_2945;

																		BgL_auxz00_2945 =
																			(long) (BgL_arg2552z00_2339);
																		BgL_restz00_2338 =
																			(BgL_offsetz00_2335 % BgL_auxz00_2945);
																}}
																{	/* Ast/substitute.scm 242 */

																	BgL_method3182z00_2328 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2333,
																			(int) (BgL_modz00_2336)),
																		(int) (BgL_restz00_2338));
									}}}}}}}}
									BgL_res3520z00_2353 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2328)
										(BgL_method3182z00_2328, (obj_t) (BgL_arg3422z00_1446),
											BgL_arg3423z00_1447, BEOA));
								}
								BgL_arg3421z00_1445 = BgL_res3520z00_2353;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1441))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3421z00_1445), BUNSPEC);
					}
					{	/* Ast/substitute.scm 243 */
						BgL_nodez00_bglt BgL_arg3424z00_1448;

						{	/* Ast/substitute.scm 243 */
							BgL_nodez00_bglt BgL_arg3425z00_1449;

							obj_t BgL_arg3426z00_1450;

							BgL_arg3425z00_1449 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1441))->
								BgL_valuez00);
							BgL_arg3426z00_1450 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 243 */
								BgL_nodez00_bglt BgL_res3523z00_2384;

								{	/* Ast/substitute.scm 243 */
									obj_t BgL_method3182z00_2359;

									{	/* Ast/substitute.scm 243 */
										BgL_objectz00_bglt BgL_objz00_2360;

										BgL_objz00_2360 =
											(BgL_objectz00_bglt) (BgL_arg3425z00_1449);
										{	/* Ast/substitute.scm 243 */
											long BgL_objzd2classzd2numz00_2361;

											BgL_objzd2classzd2numz00_2361 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2360);
											{	/* Ast/substitute.scm 243 */
												obj_t BgL_arg2551z00_2362;

												BgL_arg2551z00_2362 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 243 */
													obj_t BgL_arrayz00_2364;

													int BgL_offsetz00_2365;

													BgL_arrayz00_2364 = BgL_arg2551z00_2362;
													BgL_offsetz00_2365 =
														(int) (BgL_objzd2classzd2numz00_2361);
													{	/* Ast/substitute.scm 243 */
														long BgL_offsetz00_2366;

														BgL_offsetz00_2366 =
															((long) (BgL_offsetz00_2365) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 243 */
															long BgL_modz00_2367;

															{	/* Ast/substitute.scm 243 */
																int BgL_arg2553z00_2368;

																BgL_arg2553z00_2368 = (int) (((long) 8));
																{	/* Ast/substitute.scm 243 */
																	long BgL_auxz00_2967;

																	BgL_auxz00_2967 =
																		(long) (BgL_arg2553z00_2368);
																	BgL_modz00_2367 =
																		(BgL_offsetz00_2366 / BgL_auxz00_2967);
															}}
															{	/* Ast/substitute.scm 243 */
																long BgL_restz00_2369;

																{	/* Ast/substitute.scm 243 */
																	int BgL_arg2552z00_2370;

																	BgL_arg2552z00_2370 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 243 */
																		long BgL_auxz00_2971;

																		BgL_auxz00_2971 =
																			(long) (BgL_arg2552z00_2370);
																		BgL_restz00_2369 =
																			(BgL_offsetz00_2366 % BgL_auxz00_2971);
																}}
																{	/* Ast/substitute.scm 243 */

																	BgL_method3182z00_2359 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2364,
																			(int) (BgL_modz00_2367)),
																		(int) (BgL_restz00_2369));
									}}}}}}}}
									BgL_res3523z00_2384 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2359)
										(BgL_method3182z00_2359, (obj_t) (BgL_arg3425z00_1449),
											BgL_arg3426z00_1450, BEOA));
								}
								BgL_arg3424z00_1448 = BgL_res3523z00_2384;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1441))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3424z00_1448), BUNSPEC);
					}
					BgL_auxz00_2930 = BgL_nodez00_1441;
					return (obj_t) (BgL_auxz00_2930);
				}
			}
		}
	}



/* do-substitute!-set-e3214 */
	obj_t BGl_dozd2substitutez12zd2setzd2e3214zc0zzast_substitutez00(obj_t
		BgL_envz00_2560, obj_t BgL_nodez00_2561, obj_t BgL_sitez00_2562)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 234 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1433;

				obj_t BgL_sitez00_1434;

				{	/* Ast/substitute.scm 235 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_2985;

					BgL_nodez00_1433 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2561);
					BgL_sitez00_1434 = BgL_sitez00_2562;
					{	/* Ast/substitute.scm 235 */
						BgL_nodez00_bglt BgL_arg3418z00_2292;

						{	/* Ast/substitute.scm 235 */
							BgL_nodez00_bglt BgL_arg3419z00_2293;

							BgL_arg3419z00_2293 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1433))->
								BgL_bodyz00);
							{	/* Ast/substitute.scm 235 */
								BgL_nodez00_bglt BgL_res3517z00_2322;

								{	/* Ast/substitute.scm 235 */
									obj_t BgL_method3182z00_2297;

									{	/* Ast/substitute.scm 235 */
										BgL_objectz00_bglt BgL_objz00_2298;

										BgL_objz00_2298 =
											(BgL_objectz00_bglt) (BgL_arg3419z00_2293);
										{	/* Ast/substitute.scm 235 */
											long BgL_objzd2classzd2numz00_2299;

											BgL_objzd2classzd2numz00_2299 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2298);
											{	/* Ast/substitute.scm 235 */
												obj_t BgL_arg2551z00_2300;

												BgL_arg2551z00_2300 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 235 */
													obj_t BgL_arrayz00_2302;

													int BgL_offsetz00_2303;

													BgL_arrayz00_2302 = BgL_arg2551z00_2300;
													BgL_offsetz00_2303 =
														(int) (BgL_objzd2classzd2numz00_2299);
													{	/* Ast/substitute.scm 235 */
														long BgL_offsetz00_2304;

														BgL_offsetz00_2304 =
															((long) (BgL_offsetz00_2303) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 235 */
															long BgL_modz00_2305;

															{	/* Ast/substitute.scm 235 */
																int BgL_arg2553z00_2306;

																BgL_arg2553z00_2306 = (int) (((long) 8));
																{	/* Ast/substitute.scm 235 */
																	long BgL_auxz00_2995;

																	BgL_auxz00_2995 =
																		(long) (BgL_arg2553z00_2306);
																	BgL_modz00_2305 =
																		(BgL_offsetz00_2304 / BgL_auxz00_2995);
															}}
															{	/* Ast/substitute.scm 235 */
																long BgL_restz00_2307;

																{	/* Ast/substitute.scm 235 */
																	int BgL_arg2552z00_2308;

																	BgL_arg2552z00_2308 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 235 */
																		long BgL_auxz00_2999;

																		BgL_auxz00_2999 =
																			(long) (BgL_arg2552z00_2308);
																		BgL_restz00_2307 =
																			(BgL_offsetz00_2304 % BgL_auxz00_2999);
																}}
																{	/* Ast/substitute.scm 235 */

																	BgL_method3182z00_2297 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2302,
																			(int) (BgL_modz00_2305)),
																		(int) (BgL_restz00_2307));
									}}}}}}}}
									BgL_res3517z00_2322 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2297)
										(BgL_method3182z00_2297, (obj_t) (BgL_arg3419z00_2293),
											BgL_sitez00_1434, BEOA));
								}
								BgL_arg3418z00_2292 = BgL_res3517z00_2322;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1433))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3418z00_2292), BUNSPEC);
					}
					BgL_auxz00_2985 = BgL_nodez00_1433;
					return (obj_t) (BgL_auxz00_2985);
				}
			}
		}
	}



/* do-substitute!-let-v3212 */
	obj_t BGl_dozd2substitutez12zd2letzd2v3212zc0zzast_substitutez00(obj_t
		BgL_envz00_2563, obj_t BgL_nodez00_2564, obj_t BgL_sitez00_2565)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 224 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1414;

				obj_t BgL_sitez00_1415;

				{	/* Ast/substitute.scm 225 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3013;

					BgL_nodez00_1414 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2564);
					BgL_sitez00_1415 = BgL_sitez00_2565;
					{	/* Ast/substitute.scm 225 */
						obj_t BgL_g3180z00_1418;

						BgL_g3180z00_1418 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1414))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3178z00_1420;

							BgL_l3178z00_1420 = BgL_g3180z00_1418;
						BgL_zc3anonymousza33408ze3z83_1421:
							if (PAIRP(BgL_l3178z00_1420))
								{	/* Ast/substitute.scm 227 */
									{	/* Ast/substitute.scm 226 */
										obj_t BgL_bindingz00_1423;

										BgL_bindingz00_1423 = CAR(BgL_l3178z00_1420);
										{	/* Ast/substitute.scm 226 */
											BgL_nodez00_bglt BgL_arg3410z00_1424;

											{	/* Ast/substitute.scm 226 */
												obj_t BgL_arg3411z00_1425;

												obj_t BgL_arg3412z00_1426;

												BgL_arg3411z00_1425 = CDR(BgL_bindingz00_1423);
												BgL_arg3412z00_1426 = CNST_TABLE_REF(((long) 1));
												{	/* Ast/substitute.scm 226 */
													BgL_nodez00_bglt BgL_res3511z00_2257;

													{	/* Ast/substitute.scm 226 */
														BgL_nodez00_bglt BgL_nodez00_2230;

														BgL_nodez00_2230 =
															(BgL_nodez00_bglt) (BgL_arg3411z00_1425);
														{	/* Ast/substitute.scm 226 */
															obj_t BgL_method3182z00_2232;

															{	/* Ast/substitute.scm 226 */
																BgL_objectz00_bglt BgL_objz00_2233;

																BgL_objz00_2233 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2230);
																{	/* Ast/substitute.scm 226 */
																	long BgL_objzd2classzd2numz00_2234;

																	BgL_objzd2classzd2numz00_2234 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2233);
																	{	/* Ast/substitute.scm 226 */
																		obj_t BgL_arg2551z00_2235;

																		BgL_arg2551z00_2235 =
																			PROCEDURE_REF
																			(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																			(int) (((long) 1)));
																		{	/* Ast/substitute.scm 226 */
																			obj_t BgL_arrayz00_2237;

																			int BgL_offsetz00_2238;

																			BgL_arrayz00_2237 = BgL_arg2551z00_2235;
																			BgL_offsetz00_2238 =
																				(int) (BgL_objzd2classzd2numz00_2234);
																			{	/* Ast/substitute.scm 226 */
																				long BgL_offsetz00_2239;

																				BgL_offsetz00_2239 =
																					(
																					(long) (BgL_offsetz00_2238) -
																					OBJECT_TYPE);
																				{	/* Ast/substitute.scm 226 */
																					long BgL_modz00_2240;

																					{	/* Ast/substitute.scm 226 */
																						int BgL_arg2553z00_2241;

																						BgL_arg2553z00_2241 =
																							(int) (((long) 8));
																						{	/* Ast/substitute.scm 226 */
																							long BgL_auxz00_3029;

																							BgL_auxz00_3029 =
																								(long) (BgL_arg2553z00_2241);
																							BgL_modz00_2240 =
																								(BgL_offsetz00_2239 /
																								BgL_auxz00_3029);
																					}}
																					{	/* Ast/substitute.scm 226 */
																						long BgL_restz00_2242;

																						{	/* Ast/substitute.scm 226 */
																							int BgL_arg2552z00_2243;

																							BgL_arg2552z00_2243 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 226 */
																								long BgL_auxz00_3033;

																								BgL_auxz00_3033 =
																									(long) (BgL_arg2552z00_2243);
																								BgL_restz00_2242 =
																									(BgL_offsetz00_2239 %
																									BgL_auxz00_3033);
																						}}
																						{	/* Ast/substitute.scm 226 */

																							BgL_method3182z00_2232 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2237,
																									(int) (BgL_modz00_2240)),
																								(int) (BgL_restz00_2242));
															}}}}}}}}
															BgL_res3511z00_2257 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3182z00_2232)
																(BgL_method3182z00_2232,
																	(obj_t) (BgL_nodez00_2230),
																	BgL_arg3412z00_1426, BEOA));
													}}
													BgL_arg3410z00_1424 = BgL_res3511z00_2257;
											}}
											{	/* Ast/substitute.scm 226 */
												obj_t BgL_auxz00_3044;

												BgL_auxz00_3044 = (obj_t) (BgL_arg3410z00_1424);
												SET_CDR(BgL_bindingz00_1423, BgL_auxz00_3044);
									}}}
									{
										obj_t BgL_l3178z00_3047;

										BgL_l3178z00_3047 = CDR(BgL_l3178z00_1420);
										BgL_l3178z00_1420 = BgL_l3178z00_3047;
										goto BgL_zc3anonymousza33408ze3z83_1421;
									}
								}
							else
								{	/* Ast/substitute.scm 227 */
									((bool_t) 1);
								}
						}
					}
					{	/* Ast/substitute.scm 228 */
						BgL_nodez00_bglt BgL_arg3415z00_1429;

						{	/* Ast/substitute.scm 228 */
							BgL_nodez00_bglt BgL_arg3416z00_1430;

							BgL_arg3416z00_1430 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1414))->BgL_bodyz00);
							{	/* Ast/substitute.scm 228 */
								BgL_nodez00_bglt BgL_res3514z00_2289;

								{	/* Ast/substitute.scm 228 */
									obj_t BgL_method3182z00_2264;

									{	/* Ast/substitute.scm 228 */
										BgL_objectz00_bglt BgL_objz00_2265;

										BgL_objz00_2265 =
											(BgL_objectz00_bglt) (BgL_arg3416z00_1430);
										{	/* Ast/substitute.scm 228 */
											long BgL_objzd2classzd2numz00_2266;

											BgL_objzd2classzd2numz00_2266 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2265);
											{	/* Ast/substitute.scm 228 */
												obj_t BgL_arg2551z00_2267;

												BgL_arg2551z00_2267 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 228 */
													obj_t BgL_arrayz00_2269;

													int BgL_offsetz00_2270;

													BgL_arrayz00_2269 = BgL_arg2551z00_2267;
													BgL_offsetz00_2270 =
														(int) (BgL_objzd2classzd2numz00_2266);
													{	/* Ast/substitute.scm 228 */
														long BgL_offsetz00_2271;

														BgL_offsetz00_2271 =
															((long) (BgL_offsetz00_2270) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 228 */
															long BgL_modz00_2272;

															{	/* Ast/substitute.scm 228 */
																int BgL_arg2553z00_2273;

																BgL_arg2553z00_2273 = (int) (((long) 8));
																{	/* Ast/substitute.scm 228 */
																	long BgL_auxz00_3058;

																	BgL_auxz00_3058 =
																		(long) (BgL_arg2553z00_2273);
																	BgL_modz00_2272 =
																		(BgL_offsetz00_2271 / BgL_auxz00_3058);
															}}
															{	/* Ast/substitute.scm 228 */
																long BgL_restz00_2274;

																{	/* Ast/substitute.scm 228 */
																	int BgL_arg2552z00_2275;

																	BgL_arg2552z00_2275 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 228 */
																		long BgL_auxz00_3062;

																		BgL_auxz00_3062 =
																			(long) (BgL_arg2552z00_2275);
																		BgL_restz00_2274 =
																			(BgL_offsetz00_2271 % BgL_auxz00_3062);
																}}
																{	/* Ast/substitute.scm 228 */

																	BgL_method3182z00_2264 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2269,
																			(int) (BgL_modz00_2272)),
																		(int) (BgL_restz00_2274));
									}}}}}}}}
									BgL_res3514z00_2289 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2264)
										(BgL_method3182z00_2264, (obj_t) (BgL_arg3416z00_1430),
											BgL_sitez00_1415, BEOA));
								}
								BgL_arg3415z00_1429 = BgL_res3514z00_2289;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1414))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3415z00_1429), BUNSPEC);
					}
					BgL_auxz00_3013 = BgL_nodez00_1414;
					return (obj_t) (BgL_auxz00_3013);
				}
			}
		}
	}



/* do-substitute!-let-f3210 */
	obj_t BGl_dozd2substitutez12zd2letzd2f3210zc0zzast_substitutez00(obj_t
		BgL_envz00_2566, obj_t BgL_nodez00_2567, obj_t BgL_sitez00_2568)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 212 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1394;

				obj_t BgL_sitez00_1395;

				{	/* Ast/substitute.scm 213 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3076;

					BgL_nodez00_1394 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2567);
					BgL_sitez00_1395 = BgL_sitez00_2568;
					{	/* Ast/substitute.scm 213 */
						obj_t BgL_g3177z00_1398;

						BgL_g3177z00_1398 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1394))->BgL_localsz00);
						{
							obj_t BgL_l3175z00_1400;

							BgL_l3175z00_1400 = BgL_g3177z00_1398;
						BgL_zc3anonymousza33399ze3z83_1401:
							if (PAIRP(BgL_l3175z00_1400))
								{	/* Ast/substitute.scm 217 */
									{	/* Ast/substitute.scm 214 */
										obj_t BgL_localz00_1403;

										BgL_localz00_1403 = CAR(BgL_l3175z00_1400);
										{	/* Ast/substitute.scm 214 */
											BgL_valuez00_bglt BgL_funz00_1404;

											{
												BgL_variablez00_bglt BgL_auxz00_3081;

												BgL_auxz00_3081 =
													(BgL_variablez00_bglt) (BgL_localz00_1403);
												BgL_funz00_1404 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3081))->
													BgL_valuez00);
											}
											{	/* Ast/substitute.scm 215 */
												BgL_nodez00_bglt BgL_arg3401z00_1405;

												{	/* Ast/substitute.scm 215 */
													obj_t BgL_arg3402z00_1406;

													obj_t BgL_arg3403z00_1407;

													{
														BgL_sfunz00_bglt BgL_auxz00_3084;

														BgL_auxz00_3084 =
															(BgL_sfunz00_bglt) (BgL_funz00_1404);
														BgL_arg3402z00_1406 =
															(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3084))->
															BgL_bodyz00);
													}
													BgL_arg3403z00_1407 = CNST_TABLE_REF(((long) 1));
													{	/* Ast/substitute.scm 215 */
														BgL_nodez00_bglt BgL_res3505z00_2191;

														{	/* Ast/substitute.scm 215 */
															BgL_nodez00_bglt BgL_nodez00_2164;

															BgL_nodez00_2164 =
																(BgL_nodez00_bglt) (BgL_arg3402z00_1406);
															{	/* Ast/substitute.scm 215 */
																obj_t BgL_method3182z00_2166;

																{	/* Ast/substitute.scm 215 */
																	BgL_objectz00_bglt BgL_objz00_2167;

																	BgL_objz00_2167 =
																		(BgL_objectz00_bglt) (BgL_nodez00_2164);
																	{	/* Ast/substitute.scm 215 */
																		long BgL_objzd2classzd2numz00_2168;

																		BgL_objzd2classzd2numz00_2168 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_2167);
																		{	/* Ast/substitute.scm 215 */
																			obj_t BgL_arg2551z00_2169;

																			BgL_arg2551z00_2169 =
																				PROCEDURE_REF
																				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																				(int) (((long) 1)));
																			{	/* Ast/substitute.scm 215 */
																				obj_t BgL_arrayz00_2171;

																				int BgL_offsetz00_2172;

																				BgL_arrayz00_2171 = BgL_arg2551z00_2169;
																				BgL_offsetz00_2172 =
																					(int) (BgL_objzd2classzd2numz00_2168);
																				{	/* Ast/substitute.scm 215 */
																					long BgL_offsetz00_2173;

																					BgL_offsetz00_2173 =
																						(
																						(long) (BgL_offsetz00_2172) -
																						OBJECT_TYPE);
																					{	/* Ast/substitute.scm 215 */
																						long BgL_modz00_2174;

																						{	/* Ast/substitute.scm 215 */
																							int BgL_arg2553z00_2175;

																							BgL_arg2553z00_2175 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 215 */
																								long BgL_auxz00_3097;

																								BgL_auxz00_3097 =
																									(long) (BgL_arg2553z00_2175);
																								BgL_modz00_2174 =
																									(BgL_offsetz00_2173 /
																									BgL_auxz00_3097);
																						}}
																						{	/* Ast/substitute.scm 215 */
																							long BgL_restz00_2176;

																							{	/* Ast/substitute.scm 215 */
																								int BgL_arg2552z00_2177;

																								BgL_arg2552z00_2177 =
																									(int) (((long) 8));
																								{	/* Ast/substitute.scm 215 */
																									long BgL_auxz00_3101;

																									BgL_auxz00_3101 =
																										(long)
																										(BgL_arg2552z00_2177);
																									BgL_restz00_2176 =
																										(BgL_offsetz00_2173 %
																										BgL_auxz00_3101);
																							}}
																							{	/* Ast/substitute.scm 215 */

																								BgL_method3182z00_2166 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_2171,
																										(int) (BgL_modz00_2174)),
																									(int) (BgL_restz00_2176));
																}}}}}}}}
																BgL_res3505z00_2191 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3182z00_2166)
																	(BgL_method3182z00_2166,
																		(obj_t) (BgL_nodez00_2164),
																		BgL_arg3403z00_1407, BEOA));
														}}
														BgL_arg3401z00_1405 = BgL_res3505z00_2191;
												}}
												{
													obj_t BgL_auxz00_3114;

													BgL_sfunz00_bglt BgL_auxz00_3112;

													BgL_auxz00_3114 = (obj_t) (BgL_arg3401z00_1405);
													BgL_auxz00_3112 =
														(BgL_sfunz00_bglt) (BgL_funz00_1404);
													((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3112))->
															BgL_bodyz00) =
														((obj_t) BgL_auxz00_3114), BUNSPEC);
									}}}}
									{
										obj_t BgL_l3175z00_3117;

										BgL_l3175z00_3117 = CDR(BgL_l3175z00_1400);
										BgL_l3175z00_1400 = BgL_l3175z00_3117;
										goto BgL_zc3anonymousza33399ze3z83_1401;
									}
								}
							else
								{	/* Ast/substitute.scm 217 */
									((bool_t) 1);
								}
						}
					}
					{	/* Ast/substitute.scm 218 */
						BgL_nodez00_bglt BgL_arg3405z00_1410;

						{	/* Ast/substitute.scm 218 */
							BgL_nodez00_bglt BgL_arg3406z00_1411;

							BgL_arg3406z00_1411 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1394))->BgL_bodyz00);
							{	/* Ast/substitute.scm 218 */
								BgL_nodez00_bglt BgL_res3508z00_2223;

								{	/* Ast/substitute.scm 218 */
									obj_t BgL_method3182z00_2198;

									{	/* Ast/substitute.scm 218 */
										BgL_objectz00_bglt BgL_objz00_2199;

										BgL_objz00_2199 =
											(BgL_objectz00_bglt) (BgL_arg3406z00_1411);
										{	/* Ast/substitute.scm 218 */
											long BgL_objzd2classzd2numz00_2200;

											BgL_objzd2classzd2numz00_2200 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2199);
											{	/* Ast/substitute.scm 218 */
												obj_t BgL_arg2551z00_2201;

												BgL_arg2551z00_2201 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 218 */
													obj_t BgL_arrayz00_2203;

													int BgL_offsetz00_2204;

													BgL_arrayz00_2203 = BgL_arg2551z00_2201;
													BgL_offsetz00_2204 =
														(int) (BgL_objzd2classzd2numz00_2200);
													{	/* Ast/substitute.scm 218 */
														long BgL_offsetz00_2205;

														BgL_offsetz00_2205 =
															((long) (BgL_offsetz00_2204) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 218 */
															long BgL_modz00_2206;

															{	/* Ast/substitute.scm 218 */
																int BgL_arg2553z00_2207;

																BgL_arg2553z00_2207 = (int) (((long) 8));
																{	/* Ast/substitute.scm 218 */
																	long BgL_auxz00_3128;

																	BgL_auxz00_3128 =
																		(long) (BgL_arg2553z00_2207);
																	BgL_modz00_2206 =
																		(BgL_offsetz00_2205 / BgL_auxz00_3128);
															}}
															{	/* Ast/substitute.scm 218 */
																long BgL_restz00_2208;

																{	/* Ast/substitute.scm 218 */
																	int BgL_arg2552z00_2209;

																	BgL_arg2552z00_2209 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 218 */
																		long BgL_auxz00_3132;

																		BgL_auxz00_3132 =
																			(long) (BgL_arg2552z00_2209);
																		BgL_restz00_2208 =
																			(BgL_offsetz00_2205 % BgL_auxz00_3132);
																}}
																{	/* Ast/substitute.scm 218 */

																	BgL_method3182z00_2198 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2203,
																			(int) (BgL_modz00_2206)),
																		(int) (BgL_restz00_2208));
									}}}}}}}}
									BgL_res3508z00_2223 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2198)
										(BgL_method3182z00_2198, (obj_t) (BgL_arg3406z00_1411),
											BgL_sitez00_1395, BEOA));
								}
								BgL_arg3405z00_1410 = BgL_res3508z00_2223;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1394))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3405z00_1410), BUNSPEC);
					}
					BgL_auxz00_3076 = BgL_nodez00_1394;
					return (obj_t) (BgL_auxz00_3076);
				}
			}
		}
	}



/* do-substitute!-selec3208 */
	obj_t BGl_dozd2substitutez12zd2selec3208z12zzast_substitutez00(obj_t
		BgL_envz00_2569, obj_t BgL_nodez00_2570, obj_t BgL_sitez00_2571)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 202 */
			{
				BgL_selectz00_bglt BgL_nodez00_1375;

				obj_t BgL_sitez00_1376;

				{	/* Ast/substitute.scm 203 */
					BgL_selectz00_bglt BgL_auxz00_3146;

					BgL_nodez00_1375 = (BgL_selectz00_bglt) (BgL_nodez00_2570);
					BgL_sitez00_1376 = BgL_sitez00_2571;
					{	/* Ast/substitute.scm 203 */
						BgL_nodez00_bglt BgL_arg3390z00_1379;

						{	/* Ast/substitute.scm 203 */
							BgL_nodez00_bglt BgL_arg3391z00_1380;

							obj_t BgL_arg3392z00_1381;

							BgL_arg3391z00_1380 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1375))->BgL_testz00);
							BgL_arg3392z00_1381 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 203 */
								BgL_nodez00_bglt BgL_res3499z00_2121;

								{	/* Ast/substitute.scm 203 */
									obj_t BgL_method3182z00_2096;

									{	/* Ast/substitute.scm 203 */
										BgL_objectz00_bglt BgL_objz00_2097;

										BgL_objz00_2097 =
											(BgL_objectz00_bglt) (BgL_arg3391z00_1380);
										{	/* Ast/substitute.scm 203 */
											long BgL_objzd2classzd2numz00_2098;

											BgL_objzd2classzd2numz00_2098 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2097);
											{	/* Ast/substitute.scm 203 */
												obj_t BgL_arg2551z00_2099;

												BgL_arg2551z00_2099 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 203 */
													obj_t BgL_arrayz00_2101;

													int BgL_offsetz00_2102;

													BgL_arrayz00_2101 = BgL_arg2551z00_2099;
													BgL_offsetz00_2102 =
														(int) (BgL_objzd2classzd2numz00_2098);
													{	/* Ast/substitute.scm 203 */
														long BgL_offsetz00_2103;

														BgL_offsetz00_2103 =
															((long) (BgL_offsetz00_2102) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 203 */
															long BgL_modz00_2104;

															{	/* Ast/substitute.scm 203 */
																int BgL_arg2553z00_2105;

																BgL_arg2553z00_2105 = (int) (((long) 8));
																{	/* Ast/substitute.scm 203 */
																	long BgL_auxz00_3157;

																	BgL_auxz00_3157 =
																		(long) (BgL_arg2553z00_2105);
																	BgL_modz00_2104 =
																		(BgL_offsetz00_2103 / BgL_auxz00_3157);
															}}
															{	/* Ast/substitute.scm 203 */
																long BgL_restz00_2106;

																{	/* Ast/substitute.scm 203 */
																	int BgL_arg2552z00_2107;

																	BgL_arg2552z00_2107 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 203 */
																		long BgL_auxz00_3161;

																		BgL_auxz00_3161 =
																			(long) (BgL_arg2552z00_2107);
																		BgL_restz00_2106 =
																			(BgL_offsetz00_2103 % BgL_auxz00_3161);
																}}
																{	/* Ast/substitute.scm 203 */

																	BgL_method3182z00_2096 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2101,
																			(int) (BgL_modz00_2104)),
																		(int) (BgL_restz00_2106));
									}}}}}}}}
									BgL_res3499z00_2121 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2096)
										(BgL_method3182z00_2096, (obj_t) (BgL_arg3391z00_1380),
											BgL_arg3392z00_1381, BEOA));
								}
								BgL_arg3390z00_1379 = BgL_res3499z00_2121;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1375))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3390z00_1379), BUNSPEC);
					}
					{	/* Ast/substitute.scm 204 */
						obj_t BgL_g3174z00_1382;

						BgL_g3174z00_1382 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1375))->BgL_clausesz00);
						{
							obj_t BgL_l3172z00_1384;

							BgL_l3172z00_1384 = BgL_g3174z00_1382;
						BgL_zc3anonymousza33393ze3z83_1385:
							if (PAIRP(BgL_l3172z00_1384))
								{	/* Ast/substitute.scm 206 */
									{	/* Ast/substitute.scm 205 */
										obj_t BgL_clausez00_1387;

										BgL_clausez00_1387 = CAR(BgL_l3172z00_1384);
										{	/* Ast/substitute.scm 205 */
											BgL_nodez00_bglt BgL_arg3395z00_1388;

											{	/* Ast/substitute.scm 205 */
												obj_t BgL_arg3396z00_1389;

												BgL_arg3396z00_1389 = CDR(BgL_clausez00_1387);
												{	/* Ast/substitute.scm 205 */
													BgL_nodez00_bglt BgL_res3502z00_2155;

													{	/* Ast/substitute.scm 205 */
														BgL_nodez00_bglt BgL_nodez00_2128;

														BgL_nodez00_2128 =
															(BgL_nodez00_bglt) (BgL_arg3396z00_1389);
														{	/* Ast/substitute.scm 205 */
															obj_t BgL_method3182z00_2130;

															{	/* Ast/substitute.scm 205 */
																BgL_objectz00_bglt BgL_objz00_2131;

																BgL_objz00_2131 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2128);
																{	/* Ast/substitute.scm 205 */
																	long BgL_objzd2classzd2numz00_2132;

																	BgL_objzd2classzd2numz00_2132 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2131);
																	{	/* Ast/substitute.scm 205 */
																		obj_t BgL_arg2551z00_2133;

																		BgL_arg2551z00_2133 =
																			PROCEDURE_REF
																			(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																			(int) (((long) 1)));
																		{	/* Ast/substitute.scm 205 */
																			obj_t BgL_arrayz00_2135;

																			int BgL_offsetz00_2136;

																			BgL_arrayz00_2135 = BgL_arg2551z00_2133;
																			BgL_offsetz00_2136 =
																				(int) (BgL_objzd2classzd2numz00_2132);
																			{	/* Ast/substitute.scm 205 */
																				long BgL_offsetz00_2137;

																				BgL_offsetz00_2137 =
																					(
																					(long) (BgL_offsetz00_2136) -
																					OBJECT_TYPE);
																				{	/* Ast/substitute.scm 205 */
																					long BgL_modz00_2138;

																					{	/* Ast/substitute.scm 205 */
																						int BgL_arg2553z00_2139;

																						BgL_arg2553z00_2139 =
																							(int) (((long) 8));
																						{	/* Ast/substitute.scm 205 */
																							long BgL_auxz00_3187;

																							BgL_auxz00_3187 =
																								(long) (BgL_arg2553z00_2139);
																							BgL_modz00_2138 =
																								(BgL_offsetz00_2137 /
																								BgL_auxz00_3187);
																					}}
																					{	/* Ast/substitute.scm 205 */
																						long BgL_restz00_2140;

																						{	/* Ast/substitute.scm 205 */
																							int BgL_arg2552z00_2141;

																							BgL_arg2552z00_2141 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 205 */
																								long BgL_auxz00_3191;

																								BgL_auxz00_3191 =
																									(long) (BgL_arg2552z00_2141);
																								BgL_restz00_2140 =
																									(BgL_offsetz00_2137 %
																									BgL_auxz00_3191);
																						}}
																						{	/* Ast/substitute.scm 205 */

																							BgL_method3182z00_2130 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2135,
																									(int) (BgL_modz00_2138)),
																								(int) (BgL_restz00_2140));
															}}}}}}}}
															BgL_res3502z00_2155 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3182z00_2130)
																(BgL_method3182z00_2130,
																	(obj_t) (BgL_nodez00_2128), BgL_sitez00_1376,
																	BEOA));
													}}
													BgL_arg3395z00_1388 = BgL_res3502z00_2155;
											}}
											{	/* Ast/substitute.scm 205 */
												obj_t BgL_auxz00_3202;

												BgL_auxz00_3202 = (obj_t) (BgL_arg3395z00_1388);
												SET_CDR(BgL_clausez00_1387, BgL_auxz00_3202);
									}}}
									{
										obj_t BgL_l3172z00_3205;

										BgL_l3172z00_3205 = CDR(BgL_l3172z00_1384);
										BgL_l3172z00_1384 = BgL_l3172z00_3205;
										goto BgL_zc3anonymousza33393ze3z83_1385;
									}
								}
							else
								{	/* Ast/substitute.scm 206 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3146 = BgL_nodez00_1375;
					return (obj_t) (BgL_auxz00_3146);
				}
			}
		}
	}



/* do-substitute!-fail3206 */
	obj_t BGl_dozd2substitutez12zd2fail3206z12zzast_substitutez00(obj_t
		BgL_envz00_2572, obj_t BgL_nodez00_2573, obj_t BgL_sitez00_2574)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 192 */
			{
				BgL_failz00_bglt BgL_nodez00_1359;

				obj_t BgL_sitez00_1360;

				{	/* Ast/substitute.scm 193 */
					BgL_failz00_bglt BgL_auxz00_3209;

					BgL_nodez00_1359 = (BgL_failz00_bglt) (BgL_nodez00_2573);
					BgL_sitez00_1360 = BgL_sitez00_2574;
					{	/* Ast/substitute.scm 194 */
						BgL_nodez00_bglt BgL_arg3380z00_1364;

						{	/* Ast/substitute.scm 194 */
							BgL_nodez00_bglt BgL_arg3381z00_1365;

							obj_t BgL_arg3382z00_1366;

							BgL_arg3381z00_1365 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_procz00);
							BgL_arg3382z00_1366 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 194 */
								BgL_nodez00_bglt BgL_res3490z00_2028;

								{	/* Ast/substitute.scm 194 */
									obj_t BgL_method3182z00_2003;

									{	/* Ast/substitute.scm 194 */
										BgL_objectz00_bglt BgL_objz00_2004;

										BgL_objz00_2004 =
											(BgL_objectz00_bglt) (BgL_arg3381z00_1365);
										{	/* Ast/substitute.scm 194 */
											long BgL_objzd2classzd2numz00_2005;

											BgL_objzd2classzd2numz00_2005 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2004);
											{	/* Ast/substitute.scm 194 */
												obj_t BgL_arg2551z00_2006;

												BgL_arg2551z00_2006 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 194 */
													obj_t BgL_arrayz00_2008;

													int BgL_offsetz00_2009;

													BgL_arrayz00_2008 = BgL_arg2551z00_2006;
													BgL_offsetz00_2009 =
														(int) (BgL_objzd2classzd2numz00_2005);
													{	/* Ast/substitute.scm 194 */
														long BgL_offsetz00_2010;

														BgL_offsetz00_2010 =
															((long) (BgL_offsetz00_2009) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 194 */
															long BgL_modz00_2011;

															{	/* Ast/substitute.scm 194 */
																int BgL_arg2553z00_2012;

																BgL_arg2553z00_2012 = (int) (((long) 8));
																{	/* Ast/substitute.scm 194 */
																	long BgL_auxz00_3220;

																	BgL_auxz00_3220 =
																		(long) (BgL_arg2553z00_2012);
																	BgL_modz00_2011 =
																		(BgL_offsetz00_2010 / BgL_auxz00_3220);
															}}
															{	/* Ast/substitute.scm 194 */
																long BgL_restz00_2013;

																{	/* Ast/substitute.scm 194 */
																	int BgL_arg2552z00_2014;

																	BgL_arg2552z00_2014 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 194 */
																		long BgL_auxz00_3224;

																		BgL_auxz00_3224 =
																			(long) (BgL_arg2552z00_2014);
																		BgL_restz00_2013 =
																			(BgL_offsetz00_2010 % BgL_auxz00_3224);
																}}
																{	/* Ast/substitute.scm 194 */

																	BgL_method3182z00_2003 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2008,
																			(int) (BgL_modz00_2011)),
																		(int) (BgL_restz00_2013));
									}}}}}}}}
									BgL_res3490z00_2028 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2003)
										(BgL_method3182z00_2003, (obj_t) (BgL_arg3381z00_1365),
											BgL_arg3382z00_1366, BEOA));
								}
								BgL_arg3380z00_1364 = BgL_res3490z00_2028;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3380z00_1364), BUNSPEC);
					}
					{	/* Ast/substitute.scm 195 */
						BgL_nodez00_bglt BgL_arg3383z00_1367;

						{	/* Ast/substitute.scm 195 */
							BgL_nodez00_bglt BgL_arg3384z00_1368;

							obj_t BgL_arg3385z00_1369;

							BgL_arg3384z00_1368 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_msgz00);
							BgL_arg3385z00_1369 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 195 */
								BgL_nodez00_bglt BgL_res3493z00_2059;

								{	/* Ast/substitute.scm 195 */
									obj_t BgL_method3182z00_2034;

									{	/* Ast/substitute.scm 195 */
										BgL_objectz00_bglt BgL_objz00_2035;

										BgL_objz00_2035 =
											(BgL_objectz00_bglt) (BgL_arg3384z00_1368);
										{	/* Ast/substitute.scm 195 */
											long BgL_objzd2classzd2numz00_2036;

											BgL_objzd2classzd2numz00_2036 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2035);
											{	/* Ast/substitute.scm 195 */
												obj_t BgL_arg2551z00_2037;

												BgL_arg2551z00_2037 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 195 */
													obj_t BgL_arrayz00_2039;

													int BgL_offsetz00_2040;

													BgL_arrayz00_2039 = BgL_arg2551z00_2037;
													BgL_offsetz00_2040 =
														(int) (BgL_objzd2classzd2numz00_2036);
													{	/* Ast/substitute.scm 195 */
														long BgL_offsetz00_2041;

														BgL_offsetz00_2041 =
															((long) (BgL_offsetz00_2040) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 195 */
															long BgL_modz00_2042;

															{	/* Ast/substitute.scm 195 */
																int BgL_arg2553z00_2043;

																BgL_arg2553z00_2043 = (int) (((long) 8));
																{	/* Ast/substitute.scm 195 */
																	long BgL_auxz00_3246;

																	BgL_auxz00_3246 =
																		(long) (BgL_arg2553z00_2043);
																	BgL_modz00_2042 =
																		(BgL_offsetz00_2041 / BgL_auxz00_3246);
															}}
															{	/* Ast/substitute.scm 195 */
																long BgL_restz00_2044;

																{	/* Ast/substitute.scm 195 */
																	int BgL_arg2552z00_2045;

																	BgL_arg2552z00_2045 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 195 */
																		long BgL_auxz00_3250;

																		BgL_auxz00_3250 =
																			(long) (BgL_arg2552z00_2045);
																		BgL_restz00_2044 =
																			(BgL_offsetz00_2041 % BgL_auxz00_3250);
																}}
																{	/* Ast/substitute.scm 195 */

																	BgL_method3182z00_2034 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2039,
																			(int) (BgL_modz00_2042)),
																		(int) (BgL_restz00_2044));
									}}}}}}}}
									BgL_res3493z00_2059 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2034)
										(BgL_method3182z00_2034, (obj_t) (BgL_arg3384z00_1368),
											BgL_arg3385z00_1369, BEOA));
								}
								BgL_arg3383z00_1367 = BgL_res3493z00_2059;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3383z00_1367), BUNSPEC);
					}
					{	/* Ast/substitute.scm 196 */
						BgL_nodez00_bglt BgL_arg3386z00_1370;

						{	/* Ast/substitute.scm 196 */
							BgL_nodez00_bglt BgL_arg3387z00_1371;

							obj_t BgL_arg3388z00_1372;

							BgL_arg3387z00_1371 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_objz00);
							BgL_arg3388z00_1372 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 196 */
								BgL_nodez00_bglt BgL_res3496z00_2090;

								{	/* Ast/substitute.scm 196 */
									obj_t BgL_method3182z00_2065;

									{	/* Ast/substitute.scm 196 */
										BgL_objectz00_bglt BgL_objz00_2066;

										BgL_objz00_2066 =
											(BgL_objectz00_bglt) (BgL_arg3387z00_1371);
										{	/* Ast/substitute.scm 196 */
											long BgL_objzd2classzd2numz00_2067;

											BgL_objzd2classzd2numz00_2067 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2066);
											{	/* Ast/substitute.scm 196 */
												obj_t BgL_arg2551z00_2068;

												BgL_arg2551z00_2068 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 196 */
													obj_t BgL_arrayz00_2070;

													int BgL_offsetz00_2071;

													BgL_arrayz00_2070 = BgL_arg2551z00_2068;
													BgL_offsetz00_2071 =
														(int) (BgL_objzd2classzd2numz00_2067);
													{	/* Ast/substitute.scm 196 */
														long BgL_offsetz00_2072;

														BgL_offsetz00_2072 =
															((long) (BgL_offsetz00_2071) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 196 */
															long BgL_modz00_2073;

															{	/* Ast/substitute.scm 196 */
																int BgL_arg2553z00_2074;

																BgL_arg2553z00_2074 = (int) (((long) 8));
																{	/* Ast/substitute.scm 196 */
																	long BgL_auxz00_3272;

																	BgL_auxz00_3272 =
																		(long) (BgL_arg2553z00_2074);
																	BgL_modz00_2073 =
																		(BgL_offsetz00_2072 / BgL_auxz00_3272);
															}}
															{	/* Ast/substitute.scm 196 */
																long BgL_restz00_2075;

																{	/* Ast/substitute.scm 196 */
																	int BgL_arg2552z00_2076;

																	BgL_arg2552z00_2076 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 196 */
																		long BgL_auxz00_3276;

																		BgL_auxz00_3276 =
																			(long) (BgL_arg2552z00_2076);
																		BgL_restz00_2075 =
																			(BgL_offsetz00_2072 % BgL_auxz00_3276);
																}}
																{	/* Ast/substitute.scm 196 */

																	BgL_method3182z00_2065 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2070,
																			(int) (BgL_modz00_2073)),
																		(int) (BgL_restz00_2075));
									}}}}}}}}
									BgL_res3496z00_2090 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_2065)
										(BgL_method3182z00_2065, (obj_t) (BgL_arg3387z00_1371),
											BgL_arg3388z00_1372, BEOA));
								}
								BgL_arg3386z00_1370 = BgL_res3496z00_2090;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1359))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3386z00_1370), BUNSPEC);
					}
					BgL_auxz00_3209 = BgL_nodez00_1359;
					return (obj_t) (BgL_auxz00_3209);
				}
			}
		}
	}



/* do-substitute!-condi3204 */
	obj_t BGl_dozd2substitutez12zd2condi3204z12zzast_substitutez00(obj_t
		BgL_envz00_2575, obj_t BgL_nodez00_2576, obj_t BgL_sitez00_2577)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 182 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1345;

				obj_t BgL_sitez00_1346;

				{	/* Ast/substitute.scm 183 */
					BgL_conditionalz00_bglt BgL_auxz00_3290;

					BgL_nodez00_1345 = (BgL_conditionalz00_bglt) (BgL_nodez00_2576);
					BgL_sitez00_1346 = BgL_sitez00_2577;
					{	/* Ast/substitute.scm 184 */
						BgL_nodez00_bglt BgL_arg3372z00_1350;

						{	/* Ast/substitute.scm 184 */
							BgL_nodez00_bglt BgL_arg3373z00_1351;

							obj_t BgL_arg3374z00_1352;

							BgL_arg3373z00_1351 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->
								BgL_testz00);
							BgL_arg3374z00_1352 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 184 */
								BgL_nodez00_bglt BgL_res3481z00_1935;

								{	/* Ast/substitute.scm 184 */
									obj_t BgL_method3182z00_1910;

									{	/* Ast/substitute.scm 184 */
										BgL_objectz00_bglt BgL_objz00_1911;

										BgL_objz00_1911 =
											(BgL_objectz00_bglt) (BgL_arg3373z00_1351);
										{	/* Ast/substitute.scm 184 */
											long BgL_objzd2classzd2numz00_1912;

											BgL_objzd2classzd2numz00_1912 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1911);
											{	/* Ast/substitute.scm 184 */
												obj_t BgL_arg2551z00_1913;

												BgL_arg2551z00_1913 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 184 */
													obj_t BgL_arrayz00_1915;

													int BgL_offsetz00_1916;

													BgL_arrayz00_1915 = BgL_arg2551z00_1913;
													BgL_offsetz00_1916 =
														(int) (BgL_objzd2classzd2numz00_1912);
													{	/* Ast/substitute.scm 184 */
														long BgL_offsetz00_1917;

														BgL_offsetz00_1917 =
															((long) (BgL_offsetz00_1916) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 184 */
															long BgL_modz00_1918;

															{	/* Ast/substitute.scm 184 */
																int BgL_arg2553z00_1919;

																BgL_arg2553z00_1919 = (int) (((long) 8));
																{	/* Ast/substitute.scm 184 */
																	long BgL_auxz00_3301;

																	BgL_auxz00_3301 =
																		(long) (BgL_arg2553z00_1919);
																	BgL_modz00_1918 =
																		(BgL_offsetz00_1917 / BgL_auxz00_3301);
															}}
															{	/* Ast/substitute.scm 184 */
																long BgL_restz00_1920;

																{	/* Ast/substitute.scm 184 */
																	int BgL_arg2552z00_1921;

																	BgL_arg2552z00_1921 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 184 */
																		long BgL_auxz00_3305;

																		BgL_auxz00_3305 =
																			(long) (BgL_arg2552z00_1921);
																		BgL_restz00_1920 =
																			(BgL_offsetz00_1917 % BgL_auxz00_3305);
																}}
																{	/* Ast/substitute.scm 184 */

																	BgL_method3182z00_1910 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1915,
																			(int) (BgL_modz00_1918)),
																		(int) (BgL_restz00_1920));
									}}}}}}}}
									BgL_res3481z00_1935 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1910)
										(BgL_method3182z00_1910, (obj_t) (BgL_arg3373z00_1351),
											BgL_arg3374z00_1352, BEOA));
								}
								BgL_arg3372z00_1350 = BgL_res3481z00_1935;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3372z00_1350), BUNSPEC);
					}
					{	/* Ast/substitute.scm 185 */
						BgL_nodez00_bglt BgL_arg3375z00_1353;

						{	/* Ast/substitute.scm 185 */
							BgL_nodez00_bglt BgL_arg3376z00_1354;

							BgL_arg3376z00_1354 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->
								BgL_truez00);
							{	/* Ast/substitute.scm 185 */
								BgL_nodez00_bglt BgL_res3484z00_1966;

								{	/* Ast/substitute.scm 185 */
									obj_t BgL_method3182z00_1941;

									{	/* Ast/substitute.scm 185 */
										BgL_objectz00_bglt BgL_objz00_1942;

										BgL_objz00_1942 =
											(BgL_objectz00_bglt) (BgL_arg3376z00_1354);
										{	/* Ast/substitute.scm 185 */
											long BgL_objzd2classzd2numz00_1943;

											BgL_objzd2classzd2numz00_1943 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1942);
											{	/* Ast/substitute.scm 185 */
												obj_t BgL_arg2551z00_1944;

												BgL_arg2551z00_1944 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 185 */
													obj_t BgL_arrayz00_1946;

													int BgL_offsetz00_1947;

													BgL_arrayz00_1946 = BgL_arg2551z00_1944;
													BgL_offsetz00_1947 =
														(int) (BgL_objzd2classzd2numz00_1943);
													{	/* Ast/substitute.scm 185 */
														long BgL_offsetz00_1948;

														BgL_offsetz00_1948 =
															((long) (BgL_offsetz00_1947) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 185 */
															long BgL_modz00_1949;

															{	/* Ast/substitute.scm 185 */
																int BgL_arg2553z00_1950;

																BgL_arg2553z00_1950 = (int) (((long) 8));
																{	/* Ast/substitute.scm 185 */
																	long BgL_auxz00_3326;

																	BgL_auxz00_3326 =
																		(long) (BgL_arg2553z00_1950);
																	BgL_modz00_1949 =
																		(BgL_offsetz00_1948 / BgL_auxz00_3326);
															}}
															{	/* Ast/substitute.scm 185 */
																long BgL_restz00_1951;

																{	/* Ast/substitute.scm 185 */
																	int BgL_arg2552z00_1952;

																	BgL_arg2552z00_1952 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 185 */
																		long BgL_auxz00_3330;

																		BgL_auxz00_3330 =
																			(long) (BgL_arg2552z00_1952);
																		BgL_restz00_1951 =
																			(BgL_offsetz00_1948 % BgL_auxz00_3330);
																}}
																{	/* Ast/substitute.scm 185 */

																	BgL_method3182z00_1941 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1946,
																			(int) (BgL_modz00_1949)),
																		(int) (BgL_restz00_1951));
									}}}}}}}}
									BgL_res3484z00_1966 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1941)
										(BgL_method3182z00_1941, (obj_t) (BgL_arg3376z00_1354),
											BgL_sitez00_1346, BEOA));
								}
								BgL_arg3375z00_1353 = BgL_res3484z00_1966;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3375z00_1353), BUNSPEC);
					}
					{	/* Ast/substitute.scm 186 */
						BgL_nodez00_bglt BgL_arg3377z00_1355;

						{	/* Ast/substitute.scm 186 */
							BgL_nodez00_bglt BgL_arg3378z00_1356;

							BgL_arg3378z00_1356 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->
								BgL_falsez00);
							{	/* Ast/substitute.scm 186 */
								BgL_nodez00_bglt BgL_res3487z00_1997;

								{	/* Ast/substitute.scm 186 */
									obj_t BgL_method3182z00_1972;

									{	/* Ast/substitute.scm 186 */
										BgL_objectz00_bglt BgL_objz00_1973;

										BgL_objz00_1973 =
											(BgL_objectz00_bglt) (BgL_arg3378z00_1356);
										{	/* Ast/substitute.scm 186 */
											long BgL_objzd2classzd2numz00_1974;

											BgL_objzd2classzd2numz00_1974 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1973);
											{	/* Ast/substitute.scm 186 */
												obj_t BgL_arg2551z00_1975;

												BgL_arg2551z00_1975 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 186 */
													obj_t BgL_arrayz00_1977;

													int BgL_offsetz00_1978;

													BgL_arrayz00_1977 = BgL_arg2551z00_1975;
													BgL_offsetz00_1978 =
														(int) (BgL_objzd2classzd2numz00_1974);
													{	/* Ast/substitute.scm 186 */
														long BgL_offsetz00_1979;

														BgL_offsetz00_1979 =
															((long) (BgL_offsetz00_1978) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 186 */
															long BgL_modz00_1980;

															{	/* Ast/substitute.scm 186 */
																int BgL_arg2553z00_1981;

																BgL_arg2553z00_1981 = (int) (((long) 8));
																{	/* Ast/substitute.scm 186 */
																	long BgL_auxz00_3351;

																	BgL_auxz00_3351 =
																		(long) (BgL_arg2553z00_1981);
																	BgL_modz00_1980 =
																		(BgL_offsetz00_1979 / BgL_auxz00_3351);
															}}
															{	/* Ast/substitute.scm 186 */
																long BgL_restz00_1982;

																{	/* Ast/substitute.scm 186 */
																	int BgL_arg2552z00_1983;

																	BgL_arg2552z00_1983 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 186 */
																		long BgL_auxz00_3355;

																		BgL_auxz00_3355 =
																			(long) (BgL_arg2552z00_1983);
																		BgL_restz00_1982 =
																			(BgL_offsetz00_1979 % BgL_auxz00_3355);
																}}
																{	/* Ast/substitute.scm 186 */

																	BgL_method3182z00_1972 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1977,
																			(int) (BgL_modz00_1980)),
																		(int) (BgL_restz00_1982));
									}}}}}}}}
									BgL_res3487z00_1997 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1972)
										(BgL_method3182z00_1972, (obj_t) (BgL_arg3378z00_1356),
											BgL_sitez00_1346, BEOA));
								}
								BgL_arg3377z00_1355 = BgL_res3487z00_1997;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1345))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3377z00_1355), BUNSPEC);
					}
					BgL_auxz00_3290 = BgL_nodez00_1345;
					return (obj_t) (BgL_auxz00_3290);
				}
			}
		}
	}



/* do-substitute!-setq3202 */
	obj_t BGl_dozd2substitutez12zd2setq3202z12zzast_substitutez00(obj_t
		BgL_envz00_2578, obj_t BgL_nodez00_2579, obj_t BgL_sitez00_2580)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 173 */
			{
				BgL_setqz00_bglt BgL_nodez00_1333;

				obj_t BgL_sitez00_1334;

				{	/* Ast/substitute.scm 174 */
					BgL_setqz00_bglt BgL_auxz00_3369;

					BgL_nodez00_1333 = (BgL_setqz00_bglt) (BgL_nodez00_2579);
					BgL_sitez00_1334 = BgL_sitez00_2580;
					{	/* Ast/substitute.scm 175 */
						BgL_nodez00_bglt BgL_arg3366z00_1338;

						{	/* Ast/substitute.scm 175 */
							BgL_varz00_bglt BgL_arg3367z00_1339;

							obj_t BgL_arg3368z00_1340;

							BgL_arg3367z00_1339 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1333))->BgL_varz00);
							BgL_arg3368z00_1340 = CNST_TABLE_REF(((long) 4));
							{	/* Ast/substitute.scm 175 */
								BgL_nodez00_bglt BgL_res3475z00_1873;

								{	/* Ast/substitute.scm 175 */
									BgL_nodez00_bglt BgL_nodez00_1846;

									BgL_nodez00_1846 = (BgL_nodez00_bglt) (BgL_arg3367z00_1339);
									{	/* Ast/substitute.scm 175 */
										obj_t BgL_method3182z00_1848;

										{	/* Ast/substitute.scm 175 */
											BgL_objectz00_bglt BgL_objz00_1849;

											BgL_objz00_1849 = (BgL_objectz00_bglt) (BgL_nodez00_1846);
											{	/* Ast/substitute.scm 175 */
												long BgL_objzd2classzd2numz00_1850;

												BgL_objzd2classzd2numz00_1850 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1849);
												{	/* Ast/substitute.scm 175 */
													obj_t BgL_arg2551z00_1851;

													BgL_arg2551z00_1851 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 175 */
														obj_t BgL_arrayz00_1853;

														int BgL_offsetz00_1854;

														BgL_arrayz00_1853 = BgL_arg2551z00_1851;
														BgL_offsetz00_1854 =
															(int) (BgL_objzd2classzd2numz00_1850);
														{	/* Ast/substitute.scm 175 */
															long BgL_offsetz00_1855;

															BgL_offsetz00_1855 =
																((long) (BgL_offsetz00_1854) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 175 */
																long BgL_modz00_1856;

																{	/* Ast/substitute.scm 175 */
																	int BgL_arg2553z00_1857;

																	BgL_arg2553z00_1857 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 175 */
																		long BgL_auxz00_3381;

																		BgL_auxz00_3381 =
																			(long) (BgL_arg2553z00_1857);
																		BgL_modz00_1856 =
																			(BgL_offsetz00_1855 / BgL_auxz00_3381);
																}}
																{	/* Ast/substitute.scm 175 */
																	long BgL_restz00_1858;

																	{	/* Ast/substitute.scm 175 */
																		int BgL_arg2552z00_1859;

																		BgL_arg2552z00_1859 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 175 */
																			long BgL_auxz00_3385;

																			BgL_auxz00_3385 =
																				(long) (BgL_arg2552z00_1859);
																			BgL_restz00_1858 =
																				(BgL_offsetz00_1855 % BgL_auxz00_3385);
																	}}
																	{	/* Ast/substitute.scm 175 */

																		BgL_method3182z00_1848 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1853,
																				(int) (BgL_modz00_1856)),
																			(int) (BgL_restz00_1858));
										}}}}}}}}
										BgL_res3475z00_1873 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3182z00_1848) (BgL_method3182z00_1848,
												(obj_t) (BgL_nodez00_1846), BgL_arg3368z00_1340, BEOA));
								}}
								BgL_arg3366z00_1338 = BgL_res3475z00_1873;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3396;

							BgL_auxz00_3396 = (BgL_varz00_bglt) (BgL_arg3366z00_1338);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1333))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3396), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 176 */
						BgL_nodez00_bglt BgL_arg3369z00_1341;

						{	/* Ast/substitute.scm 176 */
							BgL_nodez00_bglt BgL_arg3370z00_1342;

							BgL_arg3370z00_1342 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1333))->BgL_valuez00);
							{	/* Ast/substitute.scm 176 */
								BgL_nodez00_bglt BgL_res3478z00_1904;

								{	/* Ast/substitute.scm 176 */
									obj_t BgL_method3182z00_1879;

									{	/* Ast/substitute.scm 176 */
										BgL_objectz00_bglt BgL_objz00_1880;

										BgL_objz00_1880 =
											(BgL_objectz00_bglt) (BgL_arg3370z00_1342);
										{	/* Ast/substitute.scm 176 */
											long BgL_objzd2classzd2numz00_1881;

											BgL_objzd2classzd2numz00_1881 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1880);
											{	/* Ast/substitute.scm 176 */
												obj_t BgL_arg2551z00_1882;

												BgL_arg2551z00_1882 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 176 */
													obj_t BgL_arrayz00_1884;

													int BgL_offsetz00_1885;

													BgL_arrayz00_1884 = BgL_arg2551z00_1882;
													BgL_offsetz00_1885 =
														(int) (BgL_objzd2classzd2numz00_1881);
													{	/* Ast/substitute.scm 176 */
														long BgL_offsetz00_1886;

														BgL_offsetz00_1886 =
															((long) (BgL_offsetz00_1885) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 176 */
															long BgL_modz00_1887;

															{	/* Ast/substitute.scm 176 */
																int BgL_arg2553z00_1888;

																BgL_arg2553z00_1888 = (int) (((long) 8));
																{	/* Ast/substitute.scm 176 */
																	long BgL_auxz00_3408;

																	BgL_auxz00_3408 =
																		(long) (BgL_arg2553z00_1888);
																	BgL_modz00_1887 =
																		(BgL_offsetz00_1886 / BgL_auxz00_3408);
															}}
															{	/* Ast/substitute.scm 176 */
																long BgL_restz00_1889;

																{	/* Ast/substitute.scm 176 */
																	int BgL_arg2552z00_1890;

																	BgL_arg2552z00_1890 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 176 */
																		long BgL_auxz00_3412;

																		BgL_auxz00_3412 =
																			(long) (BgL_arg2552z00_1890);
																		BgL_restz00_1889 =
																			(BgL_offsetz00_1886 % BgL_auxz00_3412);
																}}
																{	/* Ast/substitute.scm 176 */

																	BgL_method3182z00_1879 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1884,
																			(int) (BgL_modz00_1887)),
																		(int) (BgL_restz00_1889));
									}}}}}}}}
									BgL_res3478z00_1904 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1879)
										(BgL_method3182z00_1879, (obj_t) (BgL_arg3370z00_1342),
											BgL_sitez00_1334, BEOA));
								}
								BgL_arg3369z00_1341 = BgL_res3478z00_1904;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1333))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3369z00_1341), BUNSPEC);
					}
					BgL_auxz00_3369 = BgL_nodez00_1333;
					return (obj_t) (BgL_auxz00_3369);
				}
			}
		}
	}



/* do-substitute!-cast3200 */
	obj_t BGl_dozd2substitutez12zd2cast3200z12zzast_substitutez00(obj_t
		BgL_envz00_2581, obj_t BgL_nodez00_2582, obj_t BgL_sitez00_2583)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 166 */
			{
				BgL_castz00_bglt BgL_nodez00_1326;

				obj_t BgL_sitez00_1327;

				{	/* Ast/substitute.scm 167 */
					BgL_castz00_bglt BgL_auxz00_3426;

					BgL_nodez00_1326 = (BgL_castz00_bglt) (BgL_nodez00_2582);
					BgL_sitez00_1327 = BgL_sitez00_2583;
					{	/* Ast/substitute.scm 167 */
						BgL_nodez00_bglt BgL_arg3364z00_1815;

						BgL_arg3364z00_1815 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1326))->BgL_argz00);
						{	/* Ast/substitute.scm 167 */
							BgL_nodez00_bglt BgL_res3472z00_1844;

							{	/* Ast/substitute.scm 167 */
								obj_t BgL_method3182z00_1819;

								{	/* Ast/substitute.scm 167 */
									BgL_objectz00_bglt BgL_objz00_1820;

									BgL_objz00_1820 = (BgL_objectz00_bglt) (BgL_arg3364z00_1815);
									{	/* Ast/substitute.scm 167 */
										long BgL_objzd2classzd2numz00_1821;

										BgL_objzd2classzd2numz00_1821 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1820);
										{	/* Ast/substitute.scm 167 */
											obj_t BgL_arg2551z00_1822;

											BgL_arg2551z00_1822 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 167 */
												obj_t BgL_arrayz00_1824;

												int BgL_offsetz00_1825;

												BgL_arrayz00_1824 = BgL_arg2551z00_1822;
												BgL_offsetz00_1825 =
													(int) (BgL_objzd2classzd2numz00_1821);
												{	/* Ast/substitute.scm 167 */
													long BgL_offsetz00_1826;

													BgL_offsetz00_1826 =
														((long) (BgL_offsetz00_1825) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 167 */
														long BgL_modz00_1827;

														{	/* Ast/substitute.scm 167 */
															int BgL_arg2553z00_1828;

															BgL_arg2553z00_1828 = (int) (((long) 8));
															{	/* Ast/substitute.scm 167 */
																long BgL_auxz00_3436;

																BgL_auxz00_3436 = (long) (BgL_arg2553z00_1828);
																BgL_modz00_1827 =
																	(BgL_offsetz00_1826 / BgL_auxz00_3436);
														}}
														{	/* Ast/substitute.scm 167 */
															long BgL_restz00_1829;

															{	/* Ast/substitute.scm 167 */
																int BgL_arg2552z00_1830;

																BgL_arg2552z00_1830 = (int) (((long) 8));
																{	/* Ast/substitute.scm 167 */
																	long BgL_auxz00_3440;

																	BgL_auxz00_3440 =
																		(long) (BgL_arg2552z00_1830);
																	BgL_restz00_1829 =
																		(BgL_offsetz00_1826 % BgL_auxz00_3440);
															}}
															{	/* Ast/substitute.scm 167 */

																BgL_method3182z00_1819 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1824,
																		(int) (BgL_modz00_1827)),
																	(int) (BgL_restz00_1829));
								}}}}}}}}
								BgL_res3472z00_1844 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1819)
									(BgL_method3182z00_1819, (obj_t) (BgL_arg3364z00_1815),
										BgL_sitez00_1327, BEOA));
							} BgL_res3472z00_1844;
					}}
					BgL_auxz00_3426 = BgL_nodez00_1326;
					return (obj_t) (BgL_auxz00_3426);
				}
			}
		}
	}



/* do-substitute!-exter3198 */
	obj_t BGl_dozd2substitutez12zd2exter3198z12zzast_substitutez00(obj_t
		BgL_envz00_2584, obj_t BgL_nodez00_2585, obj_t BgL_sitez00_2586)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 159 */
			{
				BgL_externz00_bglt BgL_nodez00_1319;

				obj_t BgL_sitez00_1320;

				{	/* Ast/substitute.scm 160 */
					BgL_externz00_bglt BgL_auxz00_3453;

					BgL_nodez00_1319 = (BgL_externz00_bglt) (BgL_nodez00_2585);
					BgL_sitez00_1320 = BgL_sitez00_2586;
					{	/* Ast/substitute.scm 160 */
						obj_t BgL_arg3362z00_1813;

						BgL_arg3362z00_1813 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1319))->BgL_exprza2za2);
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3362z00_1813,
							BgL_sitez00_1320);
					}
					BgL_auxz00_3453 = BgL_nodez00_1319;
					return (obj_t) (BgL_auxz00_3453);
				}
			}
		}
	}



/* do-substitute!-funca3196 */
	obj_t BGl_dozd2substitutez12zd2funca3196z12zzast_substitutez00(obj_t
		BgL_envz00_2587, obj_t BgL_nodez00_2588, obj_t BgL_sitez00_2589)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 133 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1277;

				obj_t BgL_sitez00_1278;

				BgL_nodez00_1277 = (BgL_funcallz00_bglt) (BgL_nodez00_2588);
				BgL_sitez00_1278 = BgL_sitez00_2589;
				{	/* Ast/substitute.scm 135 */
					BgL_nodez00_bglt BgL_nfunz00_1282;

					obj_t BgL_nargsz00_1283;

					{	/* Ast/substitute.scm 135 */
						BgL_nodez00_bglt BgL_arg3353z00_1301;

						obj_t BgL_arg3354z00_1302;

						BgL_arg3353z00_1301 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1277))->BgL_funz00);
						BgL_arg3354z00_1302 = CNST_TABLE_REF(((long) 1));
						{	/* Ast/substitute.scm 135 */
							BgL_nodez00_bglt BgL_res3466z00_1758;

							{	/* Ast/substitute.scm 135 */
								obj_t BgL_method3182z00_1733;

								{	/* Ast/substitute.scm 135 */
									BgL_objectz00_bglt BgL_objz00_1734;

									BgL_objz00_1734 = (BgL_objectz00_bglt) (BgL_arg3353z00_1301);
									{	/* Ast/substitute.scm 135 */
										long BgL_objzd2classzd2numz00_1735;

										BgL_objzd2classzd2numz00_1735 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1734);
										{	/* Ast/substitute.scm 135 */
											obj_t BgL_arg2551z00_1736;

											BgL_arg2551z00_1736 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 135 */
												obj_t BgL_arrayz00_1738;

												int BgL_offsetz00_1739;

												BgL_arrayz00_1738 = BgL_arg2551z00_1736;
												BgL_offsetz00_1739 =
													(int) (BgL_objzd2classzd2numz00_1735);
												{	/* Ast/substitute.scm 135 */
													long BgL_offsetz00_1740;

													BgL_offsetz00_1740 =
														((long) (BgL_offsetz00_1739) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 135 */
														long BgL_modz00_1741;

														{	/* Ast/substitute.scm 135 */
															int BgL_arg2553z00_1742;

															BgL_arg2553z00_1742 = (int) (((long) 8));
															{	/* Ast/substitute.scm 135 */
																long BgL_auxz00_3468;

																BgL_auxz00_3468 = (long) (BgL_arg2553z00_1742);
																BgL_modz00_1741 =
																	(BgL_offsetz00_1740 / BgL_auxz00_3468);
														}}
														{	/* Ast/substitute.scm 135 */
															long BgL_restz00_1743;

															{	/* Ast/substitute.scm 135 */
																int BgL_arg2552z00_1744;

																BgL_arg2552z00_1744 = (int) (((long) 8));
																{	/* Ast/substitute.scm 135 */
																	long BgL_auxz00_3472;

																	BgL_auxz00_3472 =
																		(long) (BgL_arg2552z00_1744);
																	BgL_restz00_1743 =
																		(BgL_offsetz00_1740 % BgL_auxz00_3472);
															}}
															{	/* Ast/substitute.scm 135 */

																BgL_method3182z00_1733 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1738,
																		(int) (BgL_modz00_1741)),
																	(int) (BgL_restz00_1743));
								}}}}}}}}
								BgL_res3466z00_1758 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1733)
									(BgL_method3182z00_1733, (obj_t) (BgL_arg3353z00_1301),
										BgL_arg3354z00_1302, BEOA));
							}
							BgL_nfunz00_1282 = BgL_res3466z00_1758;
					}}
					{	/* Ast/substitute.scm 136 */
						obj_t BgL_l3167z00_1303;

						BgL_l3167z00_1303 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1277))->BgL_argsz00);
						if (NULLP(BgL_l3167z00_1303))
							{	/* Ast/substitute.scm 136 */
								BgL_nargsz00_1283 = BNIL;
							}
						else
							{	/* Ast/substitute.scm 136 */
								obj_t BgL_head3169z00_1305;

								BgL_head3169z00_1305 = MAKE_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l3167z00_1307;

									obj_t BgL_tail3170z00_1308;

									BgL_l3167z00_1307 = BgL_l3167z00_1303;
									BgL_tail3170z00_1308 = BgL_head3169z00_1305;
								BgL_zc3anonymousza33356ze3z83_1309:
									if (NULLP(BgL_l3167z00_1307))
										{	/* Ast/substitute.scm 136 */
											BgL_nargsz00_1283 = CDR(BgL_head3169z00_1305);
										}
									else
										{	/* Ast/substitute.scm 136 */
											obj_t BgL_newtail3171z00_1311;

											{	/* Ast/substitute.scm 136 */
												BgL_nodez00_bglt BgL_arg3359z00_1313;

												{	/* Ast/substitute.scm 136 */
													obj_t BgL_az00_1315;

													BgL_az00_1315 = CAR(BgL_l3167z00_1307);
													{	/* Ast/substitute.scm 136 */
														BgL_nodez00_bglt BgL_res3469z00_1793;

														{	/* Ast/substitute.scm 136 */
															BgL_nodez00_bglt BgL_nodez00_1766;

															obj_t BgL_sitez00_1767;

															BgL_nodez00_1766 =
																(BgL_nodez00_bglt) (BgL_az00_1315);
															BgL_sitez00_1767 = CNST_TABLE_REF(((long) 1));
															{	/* Ast/substitute.scm 136 */
																obj_t BgL_method3182z00_1768;

																{	/* Ast/substitute.scm 136 */
																	BgL_objectz00_bglt BgL_objz00_1769;

																	BgL_objz00_1769 =
																		(BgL_objectz00_bglt) (BgL_nodez00_1766);
																	{	/* Ast/substitute.scm 136 */
																		long BgL_objzd2classzd2numz00_1770;

																		BgL_objzd2classzd2numz00_1770 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_1769);
																		{	/* Ast/substitute.scm 136 */
																			obj_t BgL_arg2551z00_1771;

																			BgL_arg2551z00_1771 =
																				PROCEDURE_REF
																				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																				(int) (((long) 1)));
																			{	/* Ast/substitute.scm 136 */
																				obj_t BgL_arrayz00_1773;

																				int BgL_offsetz00_1774;

																				BgL_arrayz00_1773 = BgL_arg2551z00_1771;
																				BgL_offsetz00_1774 =
																					(int) (BgL_objzd2classzd2numz00_1770);
																				{	/* Ast/substitute.scm 136 */
																					long BgL_offsetz00_1775;

																					BgL_offsetz00_1775 =
																						(
																						(long) (BgL_offsetz00_1774) -
																						OBJECT_TYPE);
																					{	/* Ast/substitute.scm 136 */
																						long BgL_modz00_1776;

																						{	/* Ast/substitute.scm 136 */
																							int BgL_arg2553z00_1777;

																							BgL_arg2553z00_1777 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 136 */
																								long BgL_auxz00_3501;

																								BgL_auxz00_3501 =
																									(long) (BgL_arg2553z00_1777);
																								BgL_modz00_1776 =
																									(BgL_offsetz00_1775 /
																									BgL_auxz00_3501);
																						}}
																						{	/* Ast/substitute.scm 136 */
																							long BgL_restz00_1778;

																							{	/* Ast/substitute.scm 136 */
																								int BgL_arg2552z00_1779;

																								BgL_arg2552z00_1779 =
																									(int) (((long) 8));
																								{	/* Ast/substitute.scm 136 */
																									long BgL_auxz00_3505;

																									BgL_auxz00_3505 =
																										(long)
																										(BgL_arg2552z00_1779);
																									BgL_restz00_1778 =
																										(BgL_offsetz00_1775 %
																										BgL_auxz00_3505);
																							}}
																							{	/* Ast/substitute.scm 136 */

																								BgL_method3182z00_1768 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_1773,
																										(int) (BgL_modz00_1776)),
																									(int) (BgL_restz00_1778));
																}}}}}}}}
																BgL_res3469z00_1793 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3182z00_1768)
																	(BgL_method3182z00_1768,
																		(obj_t) (BgL_nodez00_1766),
																		BgL_sitez00_1767, BEOA));
														}}
														BgL_arg3359z00_1313 = BgL_res3469z00_1793;
												}}
												BgL_newtail3171z00_1311 =
													MAKE_PAIR((obj_t) (BgL_arg3359z00_1313), BNIL);
											}
											SET_CDR(BgL_tail3170z00_1308, BgL_newtail3171z00_1311);
											{
												obj_t BgL_tail3170z00_3521;

												obj_t BgL_l3167z00_3519;

												BgL_l3167z00_3519 = CDR(BgL_l3167z00_1307);
												BgL_tail3170z00_3521 = BgL_newtail3171z00_1311;
												BgL_tail3170z00_1308 = BgL_tail3170z00_3521;
												BgL_l3167z00_1307 = BgL_l3167z00_3519;
												goto BgL_zc3anonymousza33356ze3z83_1309;
											}
										}
								}
							}
					}
					{	/* Ast/substitute.scm 137 */
						bool_t BgL_testz00_3522;

						{	/* Ast/substitute.scm 137 */
							bool_t BgL_testz00_3523;

							{	/* Ast/substitute.scm 137 */
								obj_t BgL_obj2097z00_1799;

								BgL_obj2097z00_1799 = (obj_t) (BgL_nfunz00_1282);
								BgL_testz00_3523 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2097z00_1799,
									BGl_closurez00zzast_nodez00);
							}
							if (BgL_testz00_3523)
								{	/* Ast/substitute.scm 137 */
									BgL_testz00_3522 = ((bool_t) 1);
								}
							else
								{	/* Ast/substitute.scm 138 */
									bool_t BgL_testz00_3526;

									{	/* Ast/substitute.scm 138 */
										obj_t BgL_obj2077z00_1800;

										BgL_obj2077z00_1800 = (obj_t) (BgL_nfunz00_1282);
										BgL_testz00_3526 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj2077z00_1800,
											BGl_varz00zzast_nodez00);
									}
									if (BgL_testz00_3526)
										{	/* Ast/substitute.scm 139 */
											BgL_valuez00_bglt BgL_arg3351z00_1299;

											{	/* Ast/substitute.scm 139 */
												BgL_variablez00_bglt BgL_obj1518z00_1802;

												{
													BgL_varz00_bglt BgL_auxz00_3529;

													BgL_auxz00_3529 =
														(BgL_varz00_bglt) (BgL_nfunz00_1282);
													BgL_obj1518z00_1802 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3529))->
														BgL_variablez00);
												}
												BgL_arg3351z00_1299 =
													(((BgL_variablez00_bglt) CREF(BgL_obj1518z00_1802))->
													BgL_valuez00);
											}
											{	/* Ast/substitute.scm 139 */
												obj_t BgL_obj1764z00_1803;

												BgL_obj1764z00_1803 = (obj_t) (BgL_arg3351z00_1299);
												BgL_testz00_3522 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1764z00_1803,
													BGl_funz00zzast_varz00);
											}
										}
									else
										{	/* Ast/substitute.scm 138 */
											BgL_testz00_3522 = ((bool_t) 0);
										}
								}
						}
						if (BgL_testz00_3522)
							{	/* Ast/substitute.scm 140 */
								bool_t BgL_testz00_3535;

								{	/* Ast/substitute.scm 140 */
									BgL_variablez00_bglt BgL_arg3348z00_1295;

									obj_t BgL_arg3349z00_1296;

									{
										BgL_varz00_bglt BgL_auxz00_3536;

										BgL_auxz00_3536 = (BgL_varz00_bglt) (BgL_nfunz00_1282);
										BgL_arg3348z00_1295 =
											(((BgL_varz00_bglt) CREF(BgL_auxz00_3536))->
											BgL_variablez00);
									}
									BgL_arg3349z00_1296 = CDR(BgL_nargsz00_1283);
									BgL_testz00_3535 =
										BGl_correctzd2arityzd2appzf3zf3zzast_appz00
										(BgL_arg3348z00_1295, BgL_arg3349z00_1296);
								}
								if (BgL_testz00_3535)
									{	/* Ast/substitute.scm 142 */
										obj_t BgL_arg3340z00_1287;

										obj_t BgL_arg3341z00_1288;

										obj_t BgL_arg3342z00_1289;

										{
											BgL_nodez00_bglt BgL_auxz00_3541;

											BgL_auxz00_3541 = (BgL_nodez00_bglt) (BgL_nodez00_1277);
											BgL_arg3340z00_1287 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_3541))->
												BgL_locz00);
										}
										BgL_arg3341z00_1288 = CNST_TABLE_REF(((long) 5));
										BgL_arg3342z00_1289 = CDR(BgL_nargsz00_1283);
										return
											(obj_t) (BGl_makezd2appzd2nodez00zzast_appz00(BNIL,
												BgL_arg3340z00_1287, BgL_arg3341z00_1288,
												(BgL_varz00_bglt) (BgL_nfunz00_1282),
												BgL_arg3342z00_1289));
									}
								else
									{	/* Ast/substitute.scm 147 */
										obj_t BgL_arg3343z00_1290;

										obj_t BgL_arg3346z00_1293;

										{
											BgL_nodez00_bglt BgL_auxz00_3549;

											BgL_auxz00_3549 = (BgL_nodez00_bglt) (BgL_nodez00_1277);
											BgL_arg3343z00_1290 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_3549))->
												BgL_locz00);
										}
										BgL_arg3346z00_1293 =
											BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1277));
										return
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_arg3343z00_1290,
											BGl_string3557z00zzast_substitutez00,
											BGl_string3558z00zzast_substitutez00, BgL_arg3346z00_1293,
											BNIL);
									}
							}
						else
							{	/* Ast/substitute.scm 137 */
								((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1277))->BgL_funz00) =
									((BgL_nodez00_bglt) BgL_nfunz00_1282), BUNSPEC);
								((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1277))->BgL_argsz00) =
									((obj_t) BgL_nargsz00_1283), BUNSPEC);
								return (obj_t) (BgL_nodez00_1277);
							}
					}
				}
			}
		}
	}



/* do-substitute!-app-l3194 */
	obj_t BGl_dozd2substitutez12zd2appzd2l3194zc0zzast_substitutez00(obj_t
		BgL_envz00_2590, obj_t BgL_nodez00_2591, obj_t BgL_sitez00_2592)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 114 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1250;

				obj_t BgL_sitez00_1251;

				BgL_nodez00_1250 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2591);
				BgL_sitez00_1251 = BgL_sitez00_2592;
				{	/* Ast/substitute.scm 116 */
					BgL_nodez00_bglt BgL_nfunz00_1255;

					BgL_nodez00_bglt BgL_nargz00_1256;

					{	/* Ast/substitute.scm 116 */
						BgL_nodez00_bglt BgL_arg3332z00_1271;

						obj_t BgL_arg3333z00_1272;

						BgL_arg3332z00_1271 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1250))->BgL_funz00);
						BgL_arg3333z00_1272 = CNST_TABLE_REF(((long) 6));
						{	/* Ast/substitute.scm 116 */
							BgL_nodez00_bglt BgL_res3460z00_1689;

							{	/* Ast/substitute.scm 116 */
								obj_t BgL_method3182z00_1664;

								{	/* Ast/substitute.scm 116 */
									BgL_objectz00_bglt BgL_objz00_1665;

									BgL_objz00_1665 = (BgL_objectz00_bglt) (BgL_arg3332z00_1271);
									{	/* Ast/substitute.scm 116 */
										long BgL_objzd2classzd2numz00_1666;

										BgL_objzd2classzd2numz00_1666 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1665);
										{	/* Ast/substitute.scm 116 */
											obj_t BgL_arg2551z00_1667;

											BgL_arg2551z00_1667 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 116 */
												obj_t BgL_arrayz00_1669;

												int BgL_offsetz00_1670;

												BgL_arrayz00_1669 = BgL_arg2551z00_1667;
												BgL_offsetz00_1670 =
													(int) (BgL_objzd2classzd2numz00_1666);
												{	/* Ast/substitute.scm 116 */
													long BgL_offsetz00_1671;

													BgL_offsetz00_1671 =
														((long) (BgL_offsetz00_1670) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 116 */
														long BgL_modz00_1672;

														{	/* Ast/substitute.scm 116 */
															int BgL_arg2553z00_1673;

															BgL_arg2553z00_1673 = (int) (((long) 8));
															{	/* Ast/substitute.scm 116 */
																long BgL_auxz00_3569;

																BgL_auxz00_3569 = (long) (BgL_arg2553z00_1673);
																BgL_modz00_1672 =
																	(BgL_offsetz00_1671 / BgL_auxz00_3569);
														}}
														{	/* Ast/substitute.scm 116 */
															long BgL_restz00_1674;

															{	/* Ast/substitute.scm 116 */
																int BgL_arg2552z00_1675;

																BgL_arg2552z00_1675 = (int) (((long) 8));
																{	/* Ast/substitute.scm 116 */
																	long BgL_auxz00_3573;

																	BgL_auxz00_3573 =
																		(long) (BgL_arg2552z00_1675);
																	BgL_restz00_1674 =
																		(BgL_offsetz00_1671 % BgL_auxz00_3573);
															}}
															{	/* Ast/substitute.scm 116 */

																BgL_method3182z00_1664 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1669,
																		(int) (BgL_modz00_1672)),
																	(int) (BgL_restz00_1674));
								}}}}}}}}
								BgL_res3460z00_1689 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1664)
									(BgL_method3182z00_1664, (obj_t) (BgL_arg3332z00_1271),
										BgL_arg3333z00_1272, BEOA));
							}
							BgL_nfunz00_1255 = BgL_res3460z00_1689;
					}}
					{	/* Ast/substitute.scm 117 */
						BgL_nodez00_bglt BgL_arg3334z00_1273;

						obj_t BgL_arg3335z00_1274;

						BgL_arg3334z00_1273 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1250))->BgL_argz00);
						BgL_arg3335z00_1274 = CNST_TABLE_REF(((long) 1));
						{	/* Ast/substitute.scm 117 */
							BgL_nodez00_bglt BgL_res3463z00_1718;

							{	/* Ast/substitute.scm 117 */
								obj_t BgL_method3182z00_1693;

								{	/* Ast/substitute.scm 117 */
									BgL_objectz00_bglt BgL_objz00_1694;

									BgL_objz00_1694 = (BgL_objectz00_bglt) (BgL_arg3334z00_1273);
									{	/* Ast/substitute.scm 117 */
										long BgL_objzd2classzd2numz00_1695;

										BgL_objzd2classzd2numz00_1695 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1694);
										{	/* Ast/substitute.scm 117 */
											obj_t BgL_arg2551z00_1696;

											BgL_arg2551z00_1696 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 117 */
												obj_t BgL_arrayz00_1698;

												int BgL_offsetz00_1699;

												BgL_arrayz00_1698 = BgL_arg2551z00_1696;
												BgL_offsetz00_1699 =
													(int) (BgL_objzd2classzd2numz00_1695);
												{	/* Ast/substitute.scm 117 */
													long BgL_offsetz00_1700;

													BgL_offsetz00_1700 =
														((long) (BgL_offsetz00_1699) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 117 */
														long BgL_modz00_1701;

														{	/* Ast/substitute.scm 117 */
															int BgL_arg2553z00_1702;

															BgL_arg2553z00_1702 = (int) (((long) 8));
															{	/* Ast/substitute.scm 117 */
																long BgL_auxz00_3594;

																BgL_auxz00_3594 = (long) (BgL_arg2553z00_1702);
																BgL_modz00_1701 =
																	(BgL_offsetz00_1700 / BgL_auxz00_3594);
														}}
														{	/* Ast/substitute.scm 117 */
															long BgL_restz00_1703;

															{	/* Ast/substitute.scm 117 */
																int BgL_arg2552z00_1704;

																BgL_arg2552z00_1704 = (int) (((long) 8));
																{	/* Ast/substitute.scm 117 */
																	long BgL_auxz00_3598;

																	BgL_auxz00_3598 =
																		(long) (BgL_arg2552z00_1704);
																	BgL_restz00_1703 =
																		(BgL_offsetz00_1700 % BgL_auxz00_3598);
															}}
															{	/* Ast/substitute.scm 117 */

																BgL_method3182z00_1693 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1698,
																		(int) (BgL_modz00_1701)),
																	(int) (BgL_restz00_1703));
								}}}}}}}}
								BgL_res3463z00_1718 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3182z00_1693)
									(BgL_method3182z00_1693, (obj_t) (BgL_arg3334z00_1273),
										BgL_arg3335z00_1274, BEOA));
							}
							BgL_nargz00_1256 = BgL_res3463z00_1718;
					}}
					{	/* Ast/substitute.scm 118 */
						bool_t BgL_testz00_3609;

						{	/* Ast/substitute.scm 118 */
							bool_t BgL_testz00_3610;

							{	/* Ast/substitute.scm 118 */
								obj_t BgL_obj2097z00_1719;

								BgL_obj2097z00_1719 = (obj_t) (BgL_nfunz00_1255);
								BgL_testz00_3610 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2097z00_1719,
									BGl_closurez00zzast_nodez00);
							}
							if (BgL_testz00_3610)
								{	/* Ast/substitute.scm 119 */
									bool_t BgL_testz00_3613;

									{	/* Ast/substitute.scm 119 */
										BgL_variablez00_bglt BgL_arg3331z00_1270;

										{
											BgL_varz00_bglt BgL_auxz00_3614;

											BgL_auxz00_3614 = (BgL_varz00_bglt) (BgL_nfunz00_1255);
											BgL_arg3331z00_1270 =
												(((BgL_varz00_bglt) CREF(BgL_auxz00_3614))->
												BgL_variablez00);
										}
										BgL_testz00_3613 =
											BGl_globalzd2optionalzf3z21zzast_varz00(
											(obj_t) (BgL_arg3331z00_1270));
									}
									if (BgL_testz00_3613)
										{	/* Ast/substitute.scm 119 */
											BgL_testz00_3609 = ((bool_t) 0);
										}
									else
										{	/* Ast/substitute.scm 120 */
											bool_t BgL_testz00_3619;

											{	/* Ast/substitute.scm 120 */
												BgL_variablez00_bglt BgL_arg3330z00_1269;

												{
													BgL_varz00_bglt BgL_auxz00_3620;

													BgL_auxz00_3620 =
														(BgL_varz00_bglt) (BgL_nfunz00_1255);
													BgL_arg3330z00_1269 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3620))->
														BgL_variablez00);
												}
												BgL_testz00_3619 =
													BGl_globalzd2keyzf3z21zzast_varz00(
													(obj_t) (BgL_arg3330z00_1269));
											}
											if (BgL_testz00_3619)
												{	/* Ast/substitute.scm 120 */
													BgL_testz00_3609 = ((bool_t) 0);
												}
											else
												{	/* Ast/substitute.scm 120 */
													BgL_testz00_3609 = ((bool_t) 1);
												}
										}
								}
							else
								{	/* Ast/substitute.scm 118 */
									BgL_testz00_3609 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3609)
							{	/* Ast/substitute.scm 121 */
								obj_t BgL_arg3321z00_1259;

								BgL_varz00_bglt BgL_arg3323z00_1260;

								{
									BgL_nodez00_bglt BgL_auxz00_3625;

									BgL_auxz00_3625 = (BgL_nodez00_bglt) (BgL_nodez00_1250);
									BgL_arg3321z00_1259 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3625))->BgL_locz00);
								}
								{	/* Ast/substitute.scm 121 */
									BgL_varz00_bglt BgL_duplicated3151z00_1261;

									BgL_duplicated3151z00_1261 =
										(BgL_varz00_bglt) (BgL_nfunz00_1255);
									{	/* Ast/substitute.scm 121 */
										BgL_varz00_bglt BgL_new3152z00_1262;

										{	/* Ast/substitute.scm 121 */
											obj_t BgL_arg3324z00_1263;

											BgL_typez00_bglt BgL_arg3325z00_1264;

											BgL_variablez00_bglt BgL_arg3326z00_1265;

											{
												BgL_nodez00_bglt BgL_auxz00_3629;

												BgL_auxz00_3629 =
													(BgL_nodez00_bglt) (BgL_duplicated3151z00_1261);
												BgL_arg3324z00_1263 =
													(((BgL_nodez00_bglt) CREF(BgL_auxz00_3629))->
													BgL_locz00);
											}
											{
												BgL_nodez00_bglt BgL_auxz00_3632;

												BgL_auxz00_3632 =
													(BgL_nodez00_bglt) (BgL_duplicated3151z00_1261);
												BgL_arg3325z00_1264 =
													(((BgL_nodez00_bglt) CREF(BgL_auxz00_3632))->
													BgL_typez00);
											}
											BgL_arg3326z00_1265 =
												(((BgL_varz00_bglt) CREF(BgL_duplicated3151z00_1261))->
												BgL_variablez00);
											BgL_new3152z00_1262 =
												BGl_makezd2varzd2zzast_nodez00(BgL_arg3324z00_1263,
												BgL_arg3325z00_1264, BgL_arg3326z00_1265);
										}
										{	/* Ast/substitute.scm 121 */

											BgL_arg3323z00_1260 = BgL_new3152z00_1262;
										}
									}
								}
								return
									(obj_t) (BGl_knownzd2appzd2lyzd2ze3nodez31zzast_applyz00(BNIL,
										BgL_arg3321z00_1259,
										(BgL_nodez00_bglt) (BgL_arg3323z00_1260), BgL_nargz00_1256,
										BgL_sitez00_1251));
							}
						else
							{	/* Ast/substitute.scm 118 */
								((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1250))->BgL_funz00) =
									((BgL_nodez00_bglt) BgL_nfunz00_1255), BUNSPEC);
								((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1250))->BgL_argz00) =
									((BgL_nodez00_bglt) BgL_nargz00_1256), BUNSPEC);
								return (obj_t) (BgL_nodez00_1250);
							}
					}
				}
			}
		}
	}



/* do-substitute!-app3192 */
	obj_t BGl_dozd2substitutez12zd2app3192z12zzast_substitutez00(obj_t
		BgL_envz00_2593, obj_t BgL_nodez00_2594, obj_t BgL_sitez00_2595)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 106 */
			{
				BgL_appz00_bglt BgL_nodez00_1239;

				obj_t BgL_sitez00_1240;

				{	/* Ast/substitute.scm 107 */
					BgL_appz00_bglt BgL_auxz00_3644;

					BgL_nodez00_1239 = (BgL_appz00_bglt) (BgL_nodez00_2594);
					BgL_sitez00_1240 = BgL_sitez00_2595;
					{	/* Ast/substitute.scm 107 */
						BgL_nodez00_bglt BgL_arg3311z00_1243;

						{	/* Ast/substitute.scm 107 */
							BgL_varz00_bglt BgL_arg3314z00_1244;

							obj_t BgL_arg3315z00_1245;

							BgL_arg3314z00_1244 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1239))->BgL_funz00);
							BgL_arg3315z00_1245 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/substitute.scm 107 */
								BgL_nodez00_bglt BgL_res3457z00_1657;

								{	/* Ast/substitute.scm 107 */
									BgL_nodez00_bglt BgL_nodez00_1630;

									BgL_nodez00_1630 = (BgL_nodez00_bglt) (BgL_arg3314z00_1244);
									{	/* Ast/substitute.scm 107 */
										obj_t BgL_method3182z00_1632;

										{	/* Ast/substitute.scm 107 */
											BgL_objectz00_bglt BgL_objz00_1633;

											BgL_objz00_1633 = (BgL_objectz00_bglt) (BgL_nodez00_1630);
											{	/* Ast/substitute.scm 107 */
												long BgL_objzd2classzd2numz00_1634;

												BgL_objzd2classzd2numz00_1634 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1633);
												{	/* Ast/substitute.scm 107 */
													obj_t BgL_arg2551z00_1635;

													BgL_arg2551z00_1635 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 107 */
														obj_t BgL_arrayz00_1637;

														int BgL_offsetz00_1638;

														BgL_arrayz00_1637 = BgL_arg2551z00_1635;
														BgL_offsetz00_1638 =
															(int) (BgL_objzd2classzd2numz00_1634);
														{	/* Ast/substitute.scm 107 */
															long BgL_offsetz00_1639;

															BgL_offsetz00_1639 =
																((long) (BgL_offsetz00_1638) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 107 */
																long BgL_modz00_1640;

																{	/* Ast/substitute.scm 107 */
																	int BgL_arg2553z00_1641;

																	BgL_arg2553z00_1641 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 107 */
																		long BgL_auxz00_3656;

																		BgL_auxz00_3656 =
																			(long) (BgL_arg2553z00_1641);
																		BgL_modz00_1640 =
																			(BgL_offsetz00_1639 / BgL_auxz00_3656);
																}}
																{	/* Ast/substitute.scm 107 */
																	long BgL_restz00_1642;

																	{	/* Ast/substitute.scm 107 */
																		int BgL_arg2552z00_1643;

																		BgL_arg2552z00_1643 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 107 */
																			long BgL_auxz00_3660;

																			BgL_auxz00_3660 =
																				(long) (BgL_arg2552z00_1643);
																			BgL_restz00_1642 =
																				(BgL_offsetz00_1639 % BgL_auxz00_3660);
																	}}
																	{	/* Ast/substitute.scm 107 */

																		BgL_method3182z00_1632 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1637,
																				(int) (BgL_modz00_1640)),
																			(int) (BgL_restz00_1642));
										}}}}}}}}
										BgL_res3457z00_1657 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3182z00_1632) (BgL_method3182z00_1632,
												(obj_t) (BgL_nodez00_1630), BgL_arg3315z00_1245, BEOA));
								}}
								BgL_arg3311z00_1243 = BgL_res3457z00_1657;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3671;

							BgL_auxz00_3671 = (BgL_varz00_bglt) (BgL_arg3311z00_1243);
							((((BgL_appz00_bglt) CREF(BgL_nodez00_1239))->BgL_funz00) =
								((BgL_varz00_bglt) BgL_auxz00_3671), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 108 */
						obj_t BgL_arg3316z00_1246;

						obj_t BgL_arg3317z00_1247;

						BgL_arg3316z00_1246 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1239))->BgL_argsz00);
						BgL_arg3317z00_1247 = CNST_TABLE_REF(((long) 1));
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3316z00_1246,
							BgL_arg3317z00_1247);
					}
					BgL_auxz00_3644 = BgL_nodez00_1239;
					return (obj_t) (BgL_auxz00_3644);
				}
			}
		}
	}



/* do-substitute!-seque3190 */
	obj_t BGl_dozd2substitutez12zd2seque3190z12zzast_substitutez00(obj_t
		BgL_envz00_2596, obj_t BgL_nodez00_2597, obj_t BgL_sitez00_2598)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 99 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1232;

				obj_t BgL_sitez00_1233;

				{	/* Ast/substitute.scm 100 */
					BgL_sequencez00_bglt BgL_auxz00_3679;

					BgL_nodez00_1232 = (BgL_sequencez00_bglt) (BgL_nodez00_2597);
					BgL_sitez00_1233 = BgL_sitez00_2598;
					{	/* Ast/substitute.scm 100 */
						obj_t BgL_arg3309z00_1627;

						BgL_arg3309z00_1627 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1232))->BgL_nodesz00);
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3309z00_1627,
							BgL_sitez00_1233);
					}
					BgL_auxz00_3679 = BgL_nodez00_1232;
					return (obj_t) (BgL_auxz00_3679);
				}
			}
		}
	}



/* do-substitute!-kwote3188 */
	obj_t BGl_dozd2substitutez12zd2kwote3188z12zzast_substitutez00(obj_t
		BgL_envz00_2599, obj_t BgL_nodez00_2600, obj_t BgL_sitez00_2601)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 93 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2600));
		}
	}



/* do-substitute!-var3186 */
	obj_t BGl_dozd2substitutez12zd2var3186z12zzast_substitutez00(obj_t
		BgL_envz00_2602, obj_t BgL_nodez00_2603, obj_t BgL_sitez00_2604)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 63 */
			{
				BgL_varz00_bglt BgL_nodez00_1197;

				obj_t BgL_sitez00_1198;

				BgL_nodez00_1197 = (BgL_varz00_bglt) (BgL_nodez00_2603);
				BgL_sitez00_1198 = BgL_sitez00_2604;
				{	/* Ast/substitute.scm 64 */
					BgL_variablez00_bglt BgL_varz00_1201;

					BgL_varz00_1201 =
						(((BgL_varz00_bglt) CREF(BgL_nodez00_1197))->BgL_variablez00);
					{	/* Ast/substitute.scm 64 */
						obj_t BgL_alphaz00_1202;

						BgL_alphaz00_1202 =
							(((BgL_variablez00_bglt) CREF(BgL_varz00_1201))->
							BgL_fastzd2alphazd2);
						{	/* Ast/substitute.scm 65 */

							{
								obj_t BgL_alphaz00_1204;

								BgL_alphaz00_1204 = BgL_alphaz00_1202;
							BgL_zc3anonymousza33289ze3z83_1205:
								if ((BgL_alphaz00_1204 == BUNSPEC))
									{	/* Ast/substitute.scm 68 */
										return (obj_t) (BgL_nodez00_1197);
									}
								else
									{	/* Ast/substitute.scm 68 */
										if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1204,
												BGl_varz00zzast_nodez00))
											{	/* Ast/substitute.scm 71 */
												BgL_variablez00_bglt BgL_arg3292z00_1208;

												{
													BgL_varz00_bglt BgL_auxz00_3693;

													BgL_auxz00_3693 =
														(BgL_varz00_bglt) (BgL_alphaz00_1204);
													BgL_arg3292z00_1208 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3693))->
														BgL_variablez00);
												}
												{
													obj_t BgL_alphaz00_3696;

													BgL_alphaz00_3696 = (obj_t) (BgL_arg3292z00_1208);
													BgL_alphaz00_1204 = BgL_alphaz00_3696;
													goto BgL_zc3anonymousza33289ze3z83_1205;
												}
											}
										else
											{	/* Ast/substitute.scm 70 */
												if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1204,
														BGl_variablez00zzast_varz00))
													{	/* Ast/substitute.scm 72 */
														{	/* Ast/substitute.scm 73 */
															obj_t BgL_arg3294z00_1210;

															{
																BgL_nodez00_bglt BgL_auxz00_3700;

																BgL_auxz00_3700 =
																	(BgL_nodez00_bglt) (BgL_nodez00_1197);
																BgL_arg3294z00_1210 =
																	(((BgL_nodez00_bglt) CREF(BgL_auxz00_3700))->
																	BgL_locz00);
															}
															BGl_usezd2variablez12zc0zzast_sexpz00(
																(BgL_variablez00_bglt) (BgL_alphaz00_1204),
																BgL_arg3294z00_1210, BgL_sitez00_1198);
														}
														{	/* Ast/substitute.scm 74 */
															bool_t BgL_testz00_3705;

															{	/* Ast/substitute.scm 74 */
																bool_t BgL_testz00_3706;

																{	/* Ast/substitute.scm 74 */
																	BgL_valuez00_bglt BgL_arg3302z00_1218;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3707;

																		BgL_auxz00_3707 =
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1204);
																		BgL_arg3302z00_1218 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3707))->BgL_valuez00);
																	}
																	{	/* Ast/substitute.scm 74 */
																		obj_t BgL_obj1764z00_1621;

																		BgL_obj1764z00_1621 =
																			(obj_t) (BgL_arg3302z00_1218);
																		BgL_testz00_3706 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1764z00_1621,
																			BGl_funz00zzast_varz00);
																	}
																}
																if (BgL_testz00_3706)
																	{	/* Ast/substitute.scm 74 */
																		if (
																			(BgL_sitez00_1198 ==
																				CNST_TABLE_REF(((long) 3))))
																			{	/* Ast/substitute.scm 74 */
																				BgL_testz00_3705 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/substitute.scm 74 */
																				BgL_testz00_3705 = ((bool_t) 1);
																			}
																	}
																else
																	{	/* Ast/substitute.scm 74 */
																		BgL_testz00_3705 = ((bool_t) 0);
																	}
															}
															if (BgL_testz00_3705)
																{	/* Ast/substitute.scm 76 */
																	obj_t BgL_arg3296z00_1212;

																	BgL_typez00_bglt BgL_arg3297z00_1213;

																	{
																		BgL_nodez00_bglt BgL_auxz00_3715;

																		BgL_auxz00_3715 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1197);
																		BgL_arg3296z00_1212 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3715))->BgL_locz00);
																	}
																	{
																		BgL_nodez00_bglt BgL_auxz00_3718;

																		BgL_auxz00_3718 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1197);
																		BgL_arg3297z00_1213 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3718))->BgL_typez00);
																	}
																	return
																		(obj_t) (BGl_makezd2closurezd2zzast_nodez00
																		(BgL_arg3296z00_1212, BgL_arg3297z00_1213,
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1204)));
																}
															else
																{	/* Ast/substitute.scm 80 */
																	obj_t BgL_arg3298z00_1214;

																	BgL_typez00_bglt BgL_arg3299z00_1215;

																	{
																		BgL_nodez00_bglt BgL_auxz00_3724;

																		BgL_auxz00_3724 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1197);
																		BgL_arg3298z00_1214 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3724))->BgL_locz00);
																	}
																	{
																		BgL_nodez00_bglt BgL_auxz00_3727;

																		BgL_auxz00_3727 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1197);
																		BgL_arg3299z00_1215 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3727))->BgL_typez00);
																	}
																	return
																		(obj_t) (BGl_makezd2varzd2zzast_nodez00
																		(BgL_arg3298z00_1214, BgL_arg3299z00_1215,
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1204)));
																}
														}
													}
												else
													{	/* Ast/substitute.scm 72 */
														if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1204,
																BGl_atomz00zzast_nodez00))
															{	/* Ast/substitute.scm 83 */
																return BgL_alphaz00_1204;
															}
														else
															{	/* Ast/substitute.scm 83 */
																return
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3559z00zzast_substitutez00,
																	BGl_string3560z00zzast_substitutez00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_nodez00_1197)));
															}
													}
											}
									}
							}
						}
					}
				}
			}
		}
	}



/* do-substitute!-atom3184 */
	obj_t BGl_dozd2substitutez12zd2atom3184z12zzast_substitutez00(obj_t
		BgL_envz00_2605, obj_t BgL_nodez00_2606, obj_t BgL_sitez00_2607)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 57 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2606));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 121557513),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 271227279),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
			return
				BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 80496154),
				BSTRING_TO_STRING(BGl_string3561z00zzast_substitutez00));
		}
	}

#ifdef __cplusplus
}
#endif
