/*===========================================================================*/
/*   (Cfa/specialize.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/specialize.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_specializa7edzd2globalz75_bgl
	{
		obj_t BgL_fixz00;
	}                                *BgL_specializa7edzd2globalz75_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_structzb2objectzd2ze3objec3509z83zzcfa_specializa7eza7(obj_t,
		obj_t, obj_t);
	static bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	static obj_t BGl_patchz12zd2kwote3467zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_patchz12zd2select3489zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t);
	static obj_t BGl__specializa7ez12zb5zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 =
		BUNSPEC;
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7();
	extern BgL_valuez00_bglt BGl_valuezd2nilzd2zzast_varz00();
	extern obj_t BGl_za2bintza2z00zztype_cachez00;
	static obj_t BGl__arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_patchz12zd2boxzd2ref3503z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	static BgL_specializa7edzd2globalz75_bglt
		BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7();
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_patchz12zd2atom3465zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_patchz12zd2jumpzd2exzd2it3497zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
		BUNSPEC;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t
		BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_patchz12zd2app3505zc0zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	static obj_t BGl_patchz12zd2letzd2fun3491z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2realza2z00zztype_cachez00;
	static obj_t BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BUNSPEC;
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_patchz12zd2closure3471zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl__patchz12z12zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_patchz12zd2setzd2exzd2it3495zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt);
	static obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_patchz12zd2letzd2var3493z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7
		= BUNSPEC;
	static obj_t BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_typez00_bglt BGl_typeofz00zztype_typeofz00(BgL_nodez00_bglt);
	static obj_t BGl_patchz12zd2cast3481zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl__arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12zd2sequence3473zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_typezd2nilzd2zztype_typez00();
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt);
	static obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2var3469zc0zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	static obj_t BGl_patchz12zd2boxzd2setz123501z00zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_patchz12zd2setq3483zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_za2brealza2z00zztype_cachez00;
	static obj_t BGl_objectzd2ze3structzd2speci3507ze3zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12zd2extern3479zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2bcharza2z00zztype_cachez00;
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl__patchz12zd2default3461zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12zd2appzd2ly3475z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_patchz12zd2conditional3485zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t
		BGl_patchz12zd2default3461zc0zzcfa_specializa7eza7(BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t
		BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
	static bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
	static obj_t
		BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7();
	BGL_EXPORTED_DECL obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_patchz12zd2fail3487zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_patchz12zd2makezd2box3499z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2funcall3477zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t __cnst[10];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_z52allocatezd2specializa7edzd2globalzd2envz27zzcfa_specializa7eza7,
		BgL_bgl__za752allocateza7d2s3989z00,
		BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7, 0L,
		BUNSPEC, 0);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3958z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2atom33990z00,
		BGl_patchz12zd2atom3465zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3960z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2var343991z00,
		BGl_patchz12zd2var3469zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3959z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2kwote3992z00,
		BGl_patchz12zd2kwote3467zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3961z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2closu3993z00,
		BGl_patchz12zd2closure3471zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3962z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2seque3994z00,
		BGl_patchz12zd2sequence3473zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3963z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2appza7d3995za7,
		BGl_patchz12zd2appzd2ly3475z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3964z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2funca3996z00,
		BGl_patchz12zd2funcall3477zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3965z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2exter3997z00,
		BGl_patchz12zd2extern3479zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3966z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2cast33998z00,
		BGl_patchz12zd2cast3481zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3967z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2setq33999z00,
		BGl_patchz12zd2setq3483zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3968z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2condi4000z00,
		BGl_patchz12zd2conditional3485zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3970z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2selec4001z00,
		BGl_patchz12zd2select3489zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3969z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2fail34002z00,
		BGl_patchz12zd2fail3487zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3971z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2letza7d4003za7,
		BGl_patchz12zd2letzd2fun3491z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3972z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2letza7d4004za7,
		BGl_patchz12zd2letzd2var3493z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3973z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2setza7d4005za7,
		BGl_patchz12zd2setzd2exzd2it3495zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3974z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2jumpza74006za7,
		BGl_patchz12zd2jumpzd2exzd2it3497zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3975z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2makeza74007za7,
		BGl_patchz12zd2makezd2box3499z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3976z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2boxza7d4008za7,
		BGl_patchz12zd2boxzd2setz123501z00zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3977z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2boxza7d4009za7,
		BGl_patchz12zd2boxzd2ref3503z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3978z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2app354010z00,
		BGl_patchz12zd2app3505zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3980z00zzcfa_specializa7eza7,
		BgL_bgl_structza7b2objectza74011z00,
		BGl_structzb2objectzd2ze3objec3509z83zzcfa_specializa7eza7, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3979z00zzcfa_specializa7eza7,
		BgL_bgl_objectza7d2za7e3stru4012z00,
		BGl_objectzd2ze3structzd2speci3507ze3zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3942z00zzcfa_specializa7eza7,
		BgL_bgl_string3942za700za7za7c4013za7, "arithmetic-spec-types", 21);
	      DEFINE_STRING(BGl_string3943z00zzcfa_specializa7eza7,
		BgL_bgl_string3943za700za7za7c4014za7, "Null specification for", 22);
	      DEFINE_STRING(BGl_string3944z00zzcfa_specializa7eza7,
		BgL_bgl_string3944za700za7za7c4015za7, "   . specializing", 17);
	      DEFINE_STRING(BGl_string3945z00zzcfa_specializa7eza7,
		BgL_bgl_string3945za700za7za7c4016za7, ")\n", 2);
	      DEFINE_STRING(BGl_string3946z00zzcfa_specializa7eza7,
		BgL_bgl_string3946za700za7za7c4017za7, ": ", 2);
	      DEFINE_STRING(BGl_string3947z00zzcfa_specializa7eza7,
		BgL_bgl_string3947za700za7za7c4018za7, "        (-> ", 12);
	      DEFINE_STRING(BGl_string3948z00zzcfa_specializa7eza7,
		BgL_bgl_string3948za700za7za7c4019za7, "        (eq? ", 13);
	      DEFINE_STRING(BGl_string3950z00zzcfa_specializa7eza7,
		BgL_bgl_string3950za700za7za7c4020za7, "Unspecialized type", 18);
	      DEFINE_STRING(BGl_string3949z00zzcfa_specializa7eza7,
		BgL_bgl_string3949za700za7za7c4021za7, "add-specialized-type!", 21);
	      DEFINE_STRING(BGl_string3951z00zzcfa_specializa7eza7,
		BgL_bgl_string3951za700za7za7c4022za7, "install-specialize", 18);
	      DEFINE_STRING(BGl_string3952z00zzcfa_specializa7eza7,
		BgL_bgl_string3952za700za7za7c4023za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string3953z00zzcfa_specializa7eza7,
		BgL_bgl_string3953za700za7za7c4024za7, " -- ", 4);
	      DEFINE_STRING(BGl_string3954z00zzcfa_specializa7eza7,
		BgL_bgl_string3954za700za7za7c4025za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string3955z00zzcfa_specializa7eza7,
		BgL_bgl_string3955za700za7za7c4026za7, "install-specialize!", 19);
	      DEFINE_STRING(BGl_string3956z00zzcfa_specializa7eza7,
		BgL_bgl_string3956za700za7za7c4027za7, "", 0);
	      DEFINE_STRING(BGl_string3957z00zzcfa_specializa7eza7,
		BgL_bgl_string3957za700za7za7c4028za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3981z00zzcfa_specializa7eza7,
		BgL_bgl_string3981za700za7za7c4029za7, "patch!", 6);
	      DEFINE_STRING(BGl_string3982z00zzcfa_specializa7eza7,
		BgL_bgl_string3982za700za7za7c4030za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string3983z00zzcfa_specializa7eza7,
		BgL_bgl_string3983za700za7za7c4031za7, "cfa_specialize", 14);
	      DEFINE_STRING(BGl_string3984z00zzcfa_specializa7eza7,
		BgL_bgl_string3984za700za7za7c4032za7,
		"patch!-default3461 _ specialized-global done c-eq? c-boxed-eq? foreign __r4_numbers_6_5_flonum __r4_numbers_6_5_fixnum ((c-eq? (c-eq? foreign) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2= (2= __r4_numbers_6_5) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2< (2< __r4_numbers_6_5) (<fx __r4_numbers_6_5_fixnum) (<fl __r4_numbers_6_5_flonum)) (2> (2> __r4_numbers_6_5) (>fx __r4_numbers_6_5_fixnum) (>fl __r4_numbers_6_5_flonum)) (2<= (2<= __r4_numbers_6_5) (<=fx __r4_numbers_6_5_fixnum) (<=fl __r4_numbers_6_5_flonum)) (2>= (2>= __r4_numbers_6_5) (>=fx __r4_numbers_6_5_fixnum) (>=fl __r4_numbers_6_5_flonum)) (zero? (zero? __r4_numbers_6_5) (zerofx? __r4_numbers_6_5_fixnum) (zerofl? __r4_numbers_6_5_flonum)) (positive? (positive? __r4_numbers_6_5) (positivefx? __r4_numbers_6_5_fixnum) (positivefl? __r4_numbers_6_5_flonum)) (negative? (negative? __r4_numbers_6_5) (negativefx? __r4_numbers_6_5_fixnum) (negativefl? __r4_numbers_6_5_flonum)) (2+ (2+ __r4_numbers_6_5) (+fx __r4_number"
		"s_6_5_fixnum) (+fl __r4_numbers_6_5_flonum)) (2- (2- __r4_numbers_6_5) (-fx __r4_numbers_6_5_fixnum) (-fl __r4_numbers_6_5_flonum)) (2* (2* __r4_numbers_6_5) (*fx __r4_numbers_6_5_fixnum) (*fl __r4_numbers_6_5_flonum)) (2/ (2/ __r4_numbers_6_5) (/fl __r4_numbers_6_5_flonum)) (abs (abs __r4_numbers_6_5) (absfx __r4_numbers_6_5_fixnum) (absfl __r4_numbers_6_5_flonum)) (log (log __r4_numbers_6_5) (logfl __r4_numbers_6_5_flonum)) (exp (exp __r4_numbers_6_5) (expfl __r4_numbers_6_5_flonum)) (sin (sin __r4_numbers_6_5) (sinfl __r4_numbers_6_5_flonum)) (cos (cos __r4_numbers_6_5) (cosfl __r4_numbers_6_5_flonum)) (tan (tan __r4_numbers_6_5) (tanfl __r4_numbers_6_5_flonum)) (atan (atan __r4_numbers_6_5) (atanfl __r4_numbers_6_5_flonum)) (asin (asin __r4_numbers_6_5) (asinfl __r4_numbers_6_5_flonum)) (acos (acos __r4_numbers_6_5) (acosfl __r4_numbers_6_5_flonum)) (sqrt (sqrt __r4_numbers_6_5) (sqrtfl __r4_numbers_6_5_flonum))) ",
		1955);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2operatorzf3zd2envzf3zzcfa_specializa7eza7,
		BgL_bgl__arithmeticza7d2op4033za7,
		BGl__arithmeticzd2operatorzf3z21zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_specializa7edzd2globalzd2nilzd2envz75zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7edza7d4034z00,
		BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7, 0L, BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_specializa7edzd2globalzf3zd2envz54zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7edza7d4035z00,
		BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2speczd2typeszd2envzd2zzcfa_specializa7eza7,
		BgL_bgl__arithmeticza7d2sp4036za7,
		BGl__arithmeticzd2speczd2typesz00zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_patchz12zd2default3461zd2envz12zzcfa_specializa7eza7,
		BgL_bgl__patchza712za7d2defa4037z00,
		BGl__patchz12zd2default3461zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_specializa7ez12zd2envz67zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7eza7124038z00,
		BGl__specializa7ez12zb5zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
		BgL_bgl__patchza712za712za7za7cf4039z00,
		BGl__patchz12z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long
		BgL_checksumz00_3018, char *BgL_fromz00_3019)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7))
				{
					BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_cnstzd2initzd2zzcfa_specializa7eza7();
					BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_objectzd2initzd2zzcfa_specializa7eza7();
					BGl_genericzd2initzd2zzcfa_specializa7eza7();
					BGl_methodzd2initzd2zzcfa_specializa7eza7();
					BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_specialize");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 19 */
				obj_t BgL_cportz00_3001;

				BgL_cportz00_3001 =
					bgl_open_input_string(BGl_string3984z00zzcfa_specializa7eza7,
					(int) (((long) 0)));
				{
					long BgL_iz00_3002;

					BgL_iz00_3002 = ((long) 9);
				BgL_loopz00_3003:
					if ((BgL_iz00_3002 == ((long) -1)))
						{	/* Cfa/specialize.scm 19 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/specialize.scm 19 */
							{	/* Cfa/specialize.scm 19 */
								obj_t BgL_arg3987z00_3005;

								{	/* Cfa/specialize.scm 19 */

									{	/* Cfa/specialize.scm 19 */
										obj_t BgL_locationz00_3007;

										BgL_locationz00_3007 = BBOOL(((bool_t) 0));
										{	/* Cfa/specialize.scm 19 */

											BgL_arg3987z00_3005 =
												BGl_readz00zz__readerz00(BgL_cportz00_3001,
												BgL_locationz00_3007);
										}
									}
								}
								{	/* Cfa/specialize.scm 19 */
									int BgL_auxz00_3040;

									BgL_auxz00_3040 = (int) (BgL_iz00_3002);
									CNST_TABLE_SET(BgL_auxz00_3040, BgL_arg3987z00_3005);
							}}
							{	/* Cfa/specialize.scm 19 */
								int BgL_auxz00_3008;

								BgL_auxz00_3008 = (int) ((BgL_iz00_3002 - ((long) 1)));
								{
									long BgL_iz00_3045;

									BgL_iz00_3045 = (long) (BgL_auxz00_3008);
									BgL_iz00_3002 = BgL_iz00_3045;
									goto BgL_loopz00_3003;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 =
				CNST_TABLE_REF(((long) 0));
			BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			return BUNSPEC;
		}
	}



/* specialize! */
	BGL_EXPORTED_DEF obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 43 */
			if (BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7())
				{	/* Cfa/specialize.scm 45 */
					{
						obj_t BgL_l3441z00_891;

						BgL_l3441z00_891 =
							BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7;
					BgL_zc3anonymousza33511ze3z83_892:
						if (PAIRP(BgL_l3441z00_891))
							{	/* Cfa/specialize.scm 47 */
								{	/* Cfa/specialize.scm 48 */
									obj_t BgL_specz00_894;

									BgL_specz00_894 = CAR(BgL_l3441z00_891);
									{	/* Cfa/specialize.scm 48 */
										obj_t BgL_runner3514z00_896;

										BgL_runner3514z00_896 = CDR(BgL_specz00_894);
										{	/* Cfa/specialize.scm 48 */
											obj_t BgL_aux3513z00_895;

											BgL_aux3513z00_895 = CAR(BgL_runner3514z00_896);
											BgL_runner3514z00_896 = CDR(BgL_runner3514z00_896);
											BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7
												(BgL_aux3513z00_895, BgL_runner3514z00_896);
										}
									}
								}
								{
									obj_t BgL_l3441z00_3057;

									BgL_l3441z00_3057 = CDR(BgL_l3441z00_891);
									BgL_l3441z00_891 = BgL_l3441z00_3057;
									goto BgL_zc3anonymousza33511ze3z83_892;
								}
							}
						else
							{	/* Cfa/specialize.scm 47 */
								((bool_t) 1);
							}
					}
					BGl_patchzd2treez12zc0zzcfa_specializa7eza7(BgL_globalsz00_1);
					BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
					BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
				}
			else
				{	/* Cfa/specialize.scm 45 */
					BFALSE;
				}
			return BgL_globalsz00_1;
		}
	}



/* _specialize! */
	obj_t BGl__specializa7ez12zb5zzcfa_specializa7eza7(obj_t BgL_envz00_2912,
		obj_t BgL_globalsz00_2913)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 43 */
			return BGl_specializa7ez12zb5zzcfa_specializa7eza7(BgL_globalsz00_2913);
		}
	}



/* arithmetic-operator? */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_2)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 58 */
			{	/* Cfa/specialize.scm 60 */
				obj_t BgL_cellz00_900;

				{	/* Cfa/specialize.scm 60 */
					obj_t BgL_arg3519z00_905;

					{
						BgL_variablez00_bglt BgL_auxz00_3063;

						BgL_auxz00_3063 = (BgL_variablez00_bglt) (BgL_globalz00_2);
						BgL_arg3519z00_905 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3063))->BgL_idz00);
					}
					BgL_cellz00_900 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3519z00_905,
						BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7);
				}
				if (PAIRP(BgL_cellz00_900))
					{	/* Cfa/specialize.scm 62 */
						bool_t BgL_auxz00_3069;

						{	/* Cfa/specialize.scm 62 */
							obj_t BgL_auxz00_3070;

							{	/* Cfa/specialize.scm 62 */
								obj_t BgL_pairz00_1795;

								{	/* Cfa/specialize.scm 62 */
									obj_t BgL_pairz00_1791;

									BgL_pairz00_1791 = BgL_cellz00_900;
									BgL_pairz00_1795 = CAR(CDR(BgL_pairz00_1791));
								}
								BgL_auxz00_3070 = CAR(CDR(BgL_pairz00_1795));
							}
							BgL_auxz00_3069 =
								(BgL_auxz00_3070 ==
								(((BgL_globalz00_bglt) CREF(BgL_globalz00_2))->BgL_modulez00));
						}
						return BBOOL(BgL_auxz00_3069);
					}
				else
					{	/* Cfa/specialize.scm 61 */
						return BFALSE;
					}
			}
		}
	}



/* _arithmetic-operator? */
	obj_t BGl__arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(obj_t
		BgL_envz00_2914, obj_t BgL_globalz00_2915)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 58 */
			return
				BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(
				(BgL_globalz00_bglt) (BgL_globalz00_2915));
		}
	}



/* arithmetic-spec-types */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 71 */
			{	/* Cfa/specialize.scm 73 */
				obj_t BgL_cellz00_907;

				{	/* Cfa/specialize.scm 73 */
					obj_t BgL_arg3540z00_934;

					{
						BgL_variablez00_bglt BgL_auxz00_3080;

						BgL_auxz00_3080 = (BgL_variablez00_bglt) (BgL_globalz00_3);
						BgL_arg3540z00_934 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3080))->BgL_idz00);
					}
					BgL_cellz00_907 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3540z00_934,
						BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7);
				}
				if (PAIRP(BgL_cellz00_907))
					{	/* Cfa/specialize.scm 76 */
						obj_t BgL_g3396z00_909;

						{	/* Cfa/specialize.scm 76 */
							obj_t BgL_pairz00_1802;

							BgL_pairz00_1802 = BgL_cellz00_907;
							BgL_g3396z00_909 = CDR(CDR(BgL_pairz00_1802));
						}
						{
							obj_t BgL_specz00_912;

							obj_t BgL_typesz00_913;

							BgL_specz00_912 = BgL_g3396z00_909;
							BgL_typesz00_913 = BNIL;
						BgL_zc3anonymousza33521ze3z83_914:
							if (NULLP(BgL_specz00_912))
								{	/* Cfa/specialize.scm 79 */
									if (NULLP(BgL_typesz00_913))
										{	/* Cfa/specialize.scm 80 */
											return
												BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string3942z00zzcfa_specializa7eza7,
												BGl_string3943z00zzcfa_specializa7eza7,
												BGl_shapez00zztools_shapez00((obj_t)
													(BgL_globalz00_3)));
										}
									else
										{	/* Cfa/specialize.scm 80 */
											return BgL_typesz00_913;
										}
								}
							else
								{	/* Cfa/specialize.scm 85 */
									bool_t BgL_testz00_3095;

									{	/* Cfa/specialize.scm 85 */
										obj_t BgL_auxz00_3096;

										{	/* Cfa/specialize.scm 85 */
											obj_t BgL_pairz00_1809;

											BgL_pairz00_1809 = CAR(BgL_specz00_912);
											BgL_auxz00_3096 = CAR(CDR(BgL_pairz00_1809));
										}
										BgL_testz00_3095 =
											(BgL_auxz00_3096 == CNST_TABLE_REF(((long) 1)));
									}
									if (BgL_testz00_3095)
										{	/* Cfa/specialize.scm 86 */
											obj_t BgL_arg3528z00_921;

											obj_t BgL_arg3529z00_922;

											BgL_arg3528z00_921 = CDR(BgL_specz00_912);
											BgL_arg3529z00_922 =
												MAKE_PAIR(BGl_za2longza2z00zztype_cachez00,
												BgL_typesz00_913);
											{
												obj_t BgL_typesz00_3105;

												obj_t BgL_specz00_3104;

												BgL_specz00_3104 = BgL_arg3528z00_921;
												BgL_typesz00_3105 = BgL_arg3529z00_922;
												BgL_typesz00_913 = BgL_typesz00_3105;
												BgL_specz00_912 = BgL_specz00_3104;
												goto BgL_zc3anonymousza33521ze3z83_914;
											}
										}
									else
										{	/* Cfa/specialize.scm 87 */
											bool_t BgL_testz00_3106;

											{	/* Cfa/specialize.scm 87 */
												obj_t BgL_auxz00_3107;

												{	/* Cfa/specialize.scm 87 */
													obj_t BgL_pairz00_1815;

													BgL_pairz00_1815 = CAR(BgL_specz00_912);
													BgL_auxz00_3107 = CAR(CDR(BgL_pairz00_1815));
												}
												BgL_testz00_3106 =
													(BgL_auxz00_3107 == CNST_TABLE_REF(((long) 2)));
											}
											if (BgL_testz00_3106)
												{	/* Cfa/specialize.scm 88 */
													obj_t BgL_arg3531z00_924;

													obj_t BgL_arg3532z00_925;

													BgL_arg3531z00_924 = CDR(BgL_specz00_912);
													BgL_arg3532z00_925 =
														MAKE_PAIR(BGl_za2realza2z00zztype_cachez00,
														BgL_typesz00_913);
													{
														obj_t BgL_typesz00_3116;

														obj_t BgL_specz00_3115;

														BgL_specz00_3115 = BgL_arg3531z00_924;
														BgL_typesz00_3116 = BgL_arg3532z00_925;
														BgL_typesz00_913 = BgL_typesz00_3116;
														BgL_specz00_912 = BgL_specz00_3115;
														goto BgL_zc3anonymousza33521ze3z83_914;
													}
												}
											else
												{
													obj_t BgL_specz00_3117;

													BgL_specz00_3117 = CDR(BgL_specz00_912);
													BgL_specz00_912 = BgL_specz00_3117;
													goto BgL_zc3anonymousza33521ze3z83_914;
												}
										}
								}
						}
					}
				else
					{	/* Cfa/specialize.scm 74 */
						return BNIL;
					}
			}
		}
	}



/* _arithmetic-spec-types */
	obj_t BGl__arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(obj_t
		BgL_envz00_2916, obj_t BgL_globalz00_2917)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 71 */
			return
				BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(
				(BgL_globalz00_bglt) (BgL_globalz00_2917));
		}
	}



/* specialize-optimization? */
	bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 161 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 1)))
				{	/* Cfa/specialize.scm 162 */
					if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
						{	/* Cfa/specialize.scm 162 */
							return ((bool_t) 0);
						}
					else
						{	/* Cfa/specialize.scm 162 */
							return ((bool_t) 1);
						}
				}
			else
				{	/* Cfa/specialize.scm 162 */
					return ((bool_t) 0);
				}
		}
	}



/* show-specialize */
	bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 167 */
			{	/* Cfa/specialize.scm 168 */
				obj_t BgL_list3541z00_936;

				{	/* Cfa/specialize.scm 168 */
					obj_t BgL_arg3543z00_938;

					BgL_arg3543z00_938 = MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
					BgL_list3541z00_936 =
						MAKE_PAIR(BGl_string3944z00zzcfa_specializa7eza7,
						BgL_arg3543z00_938);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list3541z00_936);
			}
			{
				obj_t BgL_l3443z00_940;

				BgL_l3443z00_940 =
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7;
			BgL_zc3anonymousza33544ze3z83_941:
				if (PAIRP(BgL_l3443z00_940))
					{	/* Cfa/specialize.scm 169 */
						{	/* Cfa/specialize.scm 170 */
							obj_t BgL_typeze2numze2_943;

							BgL_typeze2numze2_943 = CAR(BgL_l3443z00_940);
							{	/* Cfa/specialize.scm 170 */
								bool_t BgL_testz00_3134;

								{	/* Cfa/specialize.scm 170 */
									long BgL_auxz00_3135;

									{	/* Cfa/specialize.scm 170 */
										obj_t BgL_pairz00_1825;

										BgL_pairz00_1825 = BgL_typeze2numze2_943;
										BgL_auxz00_3135 = (long) CINT(CDR(BgL_pairz00_1825));
									}
									BgL_testz00_3134 = (BgL_auxz00_3135 > ((long) 0));
								}
								if (BgL_testz00_3134)
									{	/* Cfa/specialize.scm 171 */
										obj_t BgL_arg3549z00_947;

										obj_t BgL_arg3551z00_949;

										BgL_arg3549z00_947 =
											BGl_shapez00zztools_shapez00(CAR(BgL_typeze2numze2_943));
										BgL_arg3551z00_949 = CDR(BgL_typeze2numze2_943);
										{	/* Cfa/specialize.scm 171 */
											obj_t BgL_list3553z00_951;

											{	/* Cfa/specialize.scm 171 */
												obj_t BgL_arg3554z00_952;

												{	/* Cfa/specialize.scm 171 */
													obj_t BgL_arg3555z00_953;

													{	/* Cfa/specialize.scm 171 */
														obj_t BgL_arg3556z00_954;

														{	/* Cfa/specialize.scm 171 */
															obj_t BgL_arg3557z00_955;

															BgL_arg3557z00_955 =
																MAKE_PAIR
																(BGl_string3945z00zzcfa_specializa7eza7, BNIL);
															BgL_arg3556z00_954 =
																MAKE_PAIR(BgL_arg3551z00_949,
																BgL_arg3557z00_955);
														}
														BgL_arg3555z00_953 =
															MAKE_PAIR(BGl_string3946z00zzcfa_specializa7eza7,
															BgL_arg3556z00_954);
													}
													BgL_arg3554z00_952 =
														MAKE_PAIR(BgL_arg3549z00_947, BgL_arg3555z00_953);
												}
												BgL_list3553z00_951 =
													MAKE_PAIR(BGl_string3947z00zzcfa_specializa7eza7,
													BgL_arg3554z00_952);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list3553z00_951);
									}}
								else
									{	/* Cfa/specialize.scm 170 */
										BFALSE;
									}
							}
						}
						{
							obj_t BgL_l3443z00_3149;

							BgL_l3443z00_3149 = CDR(BgL_l3443z00_940);
							BgL_l3443z00_940 = BgL_l3443z00_3149;
							goto BgL_zc3anonymousza33544ze3z83_941;
						}
					}
				else
					{	/* Cfa/specialize.scm 169 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l3445z00_962;

				BgL_l3445z00_962 =
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7;
			BgL_zc3anonymousza33562ze3z83_963:
				if (PAIRP(BgL_l3445z00_962))
					{	/* Cfa/specialize.scm 174 */
						{	/* Cfa/specialize.scm 175 */
							obj_t BgL_typeze2numze2_965;

							BgL_typeze2numze2_965 = CAR(BgL_l3445z00_962);
							{	/* Cfa/specialize.scm 175 */
								bool_t BgL_testz00_3154;

								{	/* Cfa/specialize.scm 175 */
									long BgL_auxz00_3155;

									{	/* Cfa/specialize.scm 175 */
										obj_t BgL_pairz00_1833;

										BgL_pairz00_1833 = BgL_typeze2numze2_965;
										BgL_auxz00_3155 = (long) CINT(CDR(BgL_pairz00_1833));
									}
									BgL_testz00_3154 = (BgL_auxz00_3155 > ((long) 0));
								}
								if (BgL_testz00_3154)
									{	/* Cfa/specialize.scm 176 */
										obj_t BgL_arg3567z00_969;

										obj_t BgL_arg3569z00_971;

										BgL_arg3567z00_969 =
											BGl_shapez00zztools_shapez00(CAR(BgL_typeze2numze2_965));
										BgL_arg3569z00_971 = CDR(BgL_typeze2numze2_965);
										{	/* Cfa/specialize.scm 176 */
											obj_t BgL_list3571z00_973;

											{	/* Cfa/specialize.scm 176 */
												obj_t BgL_arg3572z00_974;

												{	/* Cfa/specialize.scm 176 */
													obj_t BgL_arg3573z00_975;

													{	/* Cfa/specialize.scm 176 */
														obj_t BgL_arg3575z00_976;

														{	/* Cfa/specialize.scm 176 */
															obj_t BgL_arg3576z00_977;

															BgL_arg3576z00_977 =
																MAKE_PAIR
																(BGl_string3945z00zzcfa_specializa7eza7, BNIL);
															BgL_arg3575z00_976 =
																MAKE_PAIR(BgL_arg3569z00_971,
																BgL_arg3576z00_977);
														}
														BgL_arg3573z00_975 =
															MAKE_PAIR(BGl_string3946z00zzcfa_specializa7eza7,
															BgL_arg3575z00_976);
													}
													BgL_arg3572z00_974 =
														MAKE_PAIR(BgL_arg3567z00_969, BgL_arg3573z00_975);
												}
												BgL_list3571z00_973 =
													MAKE_PAIR(BGl_string3948z00zzcfa_specializa7eza7,
													BgL_arg3572z00_974);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list3571z00_973);
									}}
								else
									{	/* Cfa/specialize.scm 175 */
										BFALSE;
									}
							}
						}
						{
							obj_t BgL_l3445z00_3169;

							BgL_l3445z00_3169 = CDR(BgL_l3445z00_962);
							BgL_l3445z00_962 = BgL_l3445z00_3169;
							goto BgL_zc3anonymousza33562ze3z83_963;
						}
					}
				else
					{	/* Cfa/specialize.scm 174 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* install-specialized-type! */
	obj_t BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_4)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 191 */
			{	/* Cfa/specialize.scm 192 */
				bool_t BgL_testz00_3171;

				{	/* Cfa/specialize.scm 192 */
					obj_t BgL_auxz00_3172;

					BgL_auxz00_3172 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_4,
						BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
					BgL_testz00_3171 = PAIRP(BgL_auxz00_3172);
				}
				if (BgL_testz00_3171)
					{	/* Cfa/specialize.scm 192 */
						return BFALSE;
					}
				else
					{	/* Cfa/specialize.scm 192 */
						{	/* Cfa/specialize.scm 194 */
							obj_t BgL_arg3583z00_984;

							BgL_arg3583z00_984 = MAKE_PAIR(BgL_typez00_4, BINT(((long) 0)));
							BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
								MAKE_PAIR(BgL_arg3583z00_984,
								BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
						}
						{	/* Cfa/specialize.scm 195 */
							obj_t BgL_list3584z00_985;

							BgL_list3584z00_985 = MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 4)),
								BgL_list3584z00_985);
						}
						{	/* Cfa/specialize.scm 196 */
							obj_t BgL_list3585z00_986;

							BgL_list3585z00_986 = MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							return (BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 5)),
									BgL_list3585z00_986), BUNSPEC);
		}}}}
	}



/* add-specialized-type! */
	obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_5)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 201 */
			{	/* Cfa/specialize.scm 202 */
				obj_t BgL_cellz00_988;

				BgL_cellz00_988 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_5,
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_988))
					{	/* Cfa/specialize.scm 207 */
						long BgL_arg3588z00_990;

						{	/* Cfa/specialize.scm 207 */
							long BgL_auxz00_3189;

							{	/* Cfa/specialize.scm 207 */
								obj_t BgL_pairz00_1841;

								BgL_pairz00_1841 = BgL_cellz00_988;
								BgL_auxz00_3189 = (long) CINT(CDR(BgL_pairz00_1841));
							}
							BgL_arg3588z00_990 = (((long) 1) + BgL_auxz00_3189);
						}
						{	/* Cfa/specialize.scm 207 */
							obj_t BgL_auxz00_3193;

							BgL_auxz00_3193 = BINT(BgL_arg3588z00_990);
							return SET_CDR(BgL_cellz00_988, BgL_auxz00_3193);
						}
					}
				else
					{	/* Cfa/specialize.scm 203 */
						return
							BGl_internalzd2errorzd2zztools_errorz00
							(BGl_string3949z00zzcfa_specializa7eza7,
							BGl_string3950z00zzcfa_specializa7eza7,
							BGl_shapez00zztools_shapez00(BgL_typez00_5));
					}
			}
		}
	}



/* add-specialized-eq-type! */
	obj_t BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t
		BgL_typez00_6)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 212 */
			{	/* Cfa/specialize.scm 213 */
				obj_t BgL_cellz00_996;

				BgL_cellz00_996 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_6,
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_996))
					{	/* Cfa/specialize.scm 217 */
						long BgL_arg3595z00_998;

						{	/* Cfa/specialize.scm 217 */
							long BgL_auxz00_3201;

							{	/* Cfa/specialize.scm 217 */
								obj_t BgL_pairz00_1847;

								BgL_pairz00_1847 = BgL_cellz00_996;
								BgL_auxz00_3201 = (long) CINT(CDR(BgL_pairz00_1847));
							}
							BgL_arg3595z00_998 = (((long) 1) + BgL_auxz00_3201);
						}
						{	/* Cfa/specialize.scm 217 */
							obj_t BgL_auxz00_3205;

							BgL_auxz00_3205 = BINT(BgL_arg3595z00_998);
							return SET_CDR(BgL_cellz00_996, BgL_auxz00_3205);
						}
					}
				else
					{	/* Cfa/specialize.scm 215 */
						obj_t BgL_arg3598z00_1001;

						BgL_arg3598z00_1001 = MAKE_PAIR(BgL_typez00_6, BINT(((long) 1)));
						return (BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7
							=
							MAKE_PAIR(BgL_arg3598z00_1001,
								BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7),
							BUNSPEC);
					}
			}
		}
	}



/* install-specialize! */
	obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t
		BgL_genz00_7, obj_t BgL_fixesz00_8)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 222 */
			{	/* Cfa/specialize.scm 223 */
				obj_t BgL_genzd2idzd2_1002;

				BgL_genzd2idzd2_1002 = CAR(BgL_genz00_7);
				{	/* Cfa/specialize.scm 223 */
					obj_t BgL_genzd2modzd2_1003;

					{	/* Cfa/specialize.scm 224 */
						obj_t BgL_pairz00_1853;

						BgL_pairz00_1853 = BgL_genz00_7;
						BgL_genzd2modzd2_1003 = CAR(CDR(BgL_pairz00_1853));
					}
					{	/* Cfa/specialize.scm 224 */
						obj_t BgL_genericz00_1004;

						BgL_genericz00_1004 =
							BGl_findzd2globalzf2modulez20zzast_envz00(BgL_genzd2idzd2_1002,
							BgL_genzd2modzd2_1003);
						{	/* Cfa/specialize.scm 225 */

							if (BGl_iszd2azf3z21zz__objectz00(BgL_genericz00_1004,
									BGl_globalz00zzast_varz00))
								{
									obj_t BgL_fixesz00_1008;

									obj_t BgL_resz00_1009;

									BgL_fixesz00_1008 = BgL_fixesz00_8;
									BgL_resz00_1009 = BNIL;
								BgL_zc3anonymousza33600ze3z83_1010:
									if (NULLP(BgL_fixesz00_1008))
										{	/* Cfa/specialize.scm 229 */
											{	/* Cfa/specialize.scm 231 */
												BgL_globalz00_bglt BgL_obj3400z00_1012;

												BgL_obj3400z00_1012 =
													((BgL_globalz00_bglt)
													(BgL_globalz00_bglt) (BgL_genericz00_1004));
												{	/* Cfa/specialize.scm 231 */
													BgL_specializa7edzd2globalz75_bglt
														BgL_arg3602z00_1013;
													{	/* Cfa/specialize.scm 231 */
														BgL_specializa7edzd2globalz75_bglt
															BgL_res3872z00_1865;
														{	/* Cfa/specialize.scm 231 */
															BgL_specializa7edzd2globalz75_bglt
																BgL_new3306z00_1860;
															BgL_new3306z00_1860 =
																((BgL_specializa7edzd2globalz75_bglt)
																BREF(GC_MALLOC(sizeof(struct
																			BgL_specializa7edzd2globalz75_bgl))));
															{	/* Cfa/specialize.scm 231 */
																BgL_specializa7edzd2globalz75_bglt
																	BgL_res3871z00_1864;
																{	/* Cfa/specialize.scm 231 */
																	BgL_specializa7edzd2globalz75_bglt
																		BgL_new3328z00_1861;
																	BgL_new3328z00_1861 = BgL_new3306z00_1860;
																	{	/* Cfa/specialize.scm 231 */
																		obj_t BgL_fix3327z00_1863;

																		BgL_fix3327z00_1863 = BgL_resz00_1009;
																		((((BgL_specializa7edzd2globalz75_bglt)
																					CREF(BgL_new3328z00_1861))->
																				BgL_fixz00) =
																			((obj_t) BgL_fix3327z00_1863), BUNSPEC);
																		BgL_res3871z00_1864 = BgL_new3328z00_1861;
																}} BgL_res3871z00_1864;
															}
															BgL_res3872z00_1865 = BgL_new3306z00_1860;
														}
														BgL_arg3602z00_1013 = BgL_res3872z00_1865;
													}
													{	/* Cfa/specialize.scm 231 */
														obj_t BgL_auxz00_3225;

														BgL_objectz00_bglt BgL_auxz00_3223;

														BgL_auxz00_3225 = (obj_t) (BgL_arg3602z00_1013);
														BgL_auxz00_3223 =
															(BgL_objectz00_bglt) (BgL_obj3400z00_1012);
														BGL_OBJECT_WIDENING_SET(BgL_auxz00_3223,
															BgL_auxz00_3225);
												}}
												BGL_OBJECT_CLASS_NUM_SET(
													(BgL_objectz00_bglt) (BgL_obj3400z00_1012),
													BGl_classzd2numzd2zz__objectz00
													(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
												BgL_obj3400z00_1012;
											}
											return (BGl_za2specializa7eza2za7zzcfa_specializa7eza7 =
												MAKE_PAIR(BgL_genericz00_1004,
													BGl_za2specializa7eza2za7zzcfa_specializa7eza7),
												BUNSPEC);
										}
									else
										{	/* Cfa/specialize.scm 234 */
											obj_t BgL_fixz00_1015;

											BgL_fixz00_1015 = CAR(BgL_fixesz00_1008);
											{	/* Cfa/specialize.scm 234 */
												obj_t BgL_idz00_1016;

												BgL_idz00_1016 = CAR(BgL_fixz00_1015);
												{	/* Cfa/specialize.scm 235 */
													obj_t BgL_modz00_1017;

													{	/* Cfa/specialize.scm 236 */
														obj_t BgL_pairz00_1870;

														BgL_pairz00_1870 = BgL_fixz00_1015;
														BgL_modz00_1017 = CAR(CDR(BgL_pairz00_1870));
													}
													{	/* Cfa/specialize.scm 236 */
														obj_t BgL_globalz00_1018;

														BgL_globalz00_1018 =
															BGl_findzd2globalzf2modulez20zzast_envz00
															(BgL_idz00_1016, BgL_modz00_1017);
														{	/* Cfa/specialize.scm 237 */

															if (BGl_iszd2azf3z21zz__objectz00
																(BgL_globalz00_1018, BGl_globalz00zzast_varz00))
																{	/* Cfa/specialize.scm 239 */
																	BgL_valuez00_bglt BgL_valz00_1020;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3239;

																		BgL_auxz00_3239 =
																			(BgL_variablez00_bglt)
																			(BgL_globalz00_1018);
																		BgL_valz00_1020 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3239))->BgL_valuez00);
																	}
																	{	/* Cfa/specialize.scm 241 */
																		bool_t BgL_testz00_3242;

																		{	/* Cfa/specialize.scm 241 */
																			bool_t BgL_testz00_3243;

																			{	/* Cfa/specialize.scm 241 */
																				obj_t BgL_obj1942z00_1876;

																				BgL_obj1942z00_1876 =
																					(obj_t) (BgL_valz00_1020);
																				BgL_testz00_3243 =
																					BGl_iszd2azf3z21zz__objectz00
																					(BgL_obj1942z00_1876,
																					BGl_sfunz00zzast_varz00);
																			}
																			if (BgL_testz00_3243)
																				{	/* Cfa/specialize.scm 241 */
																					obj_t BgL_auxz00_3246;

																					{
																						BgL_sfunz00_bglt BgL_auxz00_3247;

																						BgL_auxz00_3247 =
																							(BgL_sfunz00_bglt)
																							(BgL_valz00_1020);
																						BgL_auxz00_3246 =
																							(((BgL_sfunz00_bglt)
																								CREF(BgL_auxz00_3247))->
																							BgL_argsz00);
																					}
																					BgL_testz00_3242 =
																						PAIRP(BgL_auxz00_3246);
																				}
																			else
																				{	/* Cfa/specialize.scm 241 */
																					BgL_testz00_3242 = ((bool_t) 0);
																				}
																		}
																		if (BgL_testz00_3242)
																			{	/* Cfa/specialize.scm 242 */
																				obj_t BgL_typez00_1022;

																				{	/* Cfa/specialize.scm 242 */
																					obj_t BgL_vz00_1026;

																					{	/* Cfa/specialize.scm 242 */
																						obj_t BgL_pairz00_1880;

																						{
																							BgL_sfunz00_bglt BgL_auxz00_3251;

																							BgL_auxz00_3251 =
																								(BgL_sfunz00_bglt)
																								(BgL_valz00_1020);
																							BgL_pairz00_1880 =
																								(((BgL_sfunz00_bglt)
																									CREF(BgL_auxz00_3251))->
																								BgL_argsz00);
																						}
																						BgL_vz00_1026 =
																							CAR(BgL_pairz00_1880);
																					}
																					if (BGl_iszd2azf3z21zz__objectz00
																						(BgL_vz00_1026,
																							BGl_typez00zztype_typez00))
																						{	/* Cfa/specialize.scm 246 */
																							BgL_typez00_1022 = BgL_vz00_1026;
																						}
																					else
																						{	/* Cfa/specialize.scm 246 */
																							if (BGl_iszd2azf3z21zz__objectz00
																								(BgL_vz00_1026,
																									BGl_localz00zzast_varz00))
																								{	/* Cfa/specialize.scm 249 */
																									BgL_variablez00_bglt
																										BgL_obj1595z00_1883;
																									BgL_obj1595z00_1883 =
																										(BgL_variablez00_bglt)
																										(BgL_vz00_1026);
																									BgL_typez00_1022 =
																										(obj_t) (((
																												(BgL_variablez00_bglt)
																												CREF
																												(BgL_obj1595z00_1883))->
																											BgL_typez00));
																								}
																							else
																								{	/* Cfa/specialize.scm 251 */
																									obj_t BgL_arg3613z00_1031;

																									{
																										BgL_variablez00_bglt
																											BgL_auxz00_3262;
																										BgL_auxz00_3262 =
																											(BgL_variablez00_bglt)
																											(BgL_globalz00_1018);
																										BgL_arg3613z00_1031 =
																											(((BgL_variablez00_bglt)
																												CREF(BgL_auxz00_3262))->
																											BgL_idz00);
																									}
																									BgL_typez00_1022 =
																										BGl_internalzd2errorzd2zztools_errorz00
																										(BGl_string3951z00zzcfa_specializa7eza7,
																										BGl_string3952z00zzcfa_specializa7eza7,
																										BgL_arg3613z00_1031);
																								}
																						}
																				}
																				BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																					(BgL_typez00_1022);
																				{	/* Cfa/specialize.scm 256 */
																					obj_t BgL_arg3606z00_1023;

																					obj_t BgL_arg3607z00_1024;

																					BgL_arg3606z00_1023 =
																						CDR(BgL_fixesz00_1008);
																					{	/* Cfa/specialize.scm 257 */
																						obj_t BgL_arg3608z00_1025;

																						BgL_arg3608z00_1025 =
																							MAKE_PAIR(BgL_typez00_1022,
																							BgL_globalz00_1018);
																						BgL_arg3607z00_1024 =
																							MAKE_PAIR(BgL_arg3608z00_1025,
																							BgL_resz00_1009);
																					}
																					{
																						obj_t BgL_resz00_3271;

																						obj_t BgL_fixesz00_3270;

																						BgL_fixesz00_3270 =
																							BgL_arg3606z00_1023;
																						BgL_resz00_3271 =
																							BgL_arg3607z00_1024;
																						BgL_resz00_1009 = BgL_resz00_3271;
																						BgL_fixesz00_1008 =
																							BgL_fixesz00_3270;
																						goto
																							BgL_zc3anonymousza33600ze3z83_1010;
																					}
																				}
																			}
																		else
																			{	/* Cfa/specialize.scm 258 */
																				bool_t BgL_testz00_3272;

																				{	/* Cfa/specialize.scm 258 */
																					bool_t BgL_testz00_3273;

																					{	/* Cfa/specialize.scm 258 */
																						obj_t BgL_obj2006z00_1886;

																						BgL_obj2006z00_1886 =
																							(obj_t) (BgL_valz00_1020);
																						BgL_testz00_3273 =
																							BGl_iszd2azf3z21zz__objectz00
																							(BgL_obj2006z00_1886,
																							BGl_cfunz00zzast_varz00);
																					}
																					if (BgL_testz00_3273)
																						{	/* Cfa/specialize.scm 258 */
																							obj_t BgL_auxz00_3276;

																							{
																								BgL_cfunz00_bglt
																									BgL_auxz00_3277;
																								BgL_auxz00_3277 =
																									(BgL_cfunz00_bglt)
																									(BgL_valz00_1020);
																								BgL_auxz00_3276 =
																									(((BgL_cfunz00_bglt)
																										CREF(BgL_auxz00_3277))->
																									BgL_argszd2typezd2);
																							}
																							BgL_testz00_3272 =
																								PAIRP(BgL_auxz00_3276);
																						}
																					else
																						{	/* Cfa/specialize.scm 258 */
																							BgL_testz00_3272 = ((bool_t) 0);
																						}
																				}
																				if (BgL_testz00_3272)
																					{	/* Cfa/specialize.scm 259 */
																						obj_t BgL_typez00_1034;

																						{	/* Cfa/specialize.scm 259 */
																							obj_t BgL_pairz00_1890;

																							{
																								BgL_cfunz00_bglt
																									BgL_auxz00_3281;
																								BgL_auxz00_3281 =
																									(BgL_cfunz00_bglt)
																									(BgL_valz00_1020);
																								BgL_pairz00_1890 =
																									(((BgL_cfunz00_bglt)
																										CREF(BgL_auxz00_3281))->
																									BgL_argszd2typezd2);
																							}
																							BgL_typez00_1034 =
																								CAR(BgL_pairz00_1890);
																						}
																						BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																							(BgL_typez00_1034);
																						{	/* Cfa/specialize.scm 261 */
																							obj_t BgL_arg3616z00_1035;

																							obj_t BgL_arg3617z00_1036;

																							BgL_arg3616z00_1035 =
																								CDR(BgL_fixesz00_1008);
																							{	/* Cfa/specialize.scm 262 */
																								obj_t BgL_arg3618z00_1037;

																								BgL_arg3618z00_1037 =
																									MAKE_PAIR(BgL_typez00_1034,
																									BgL_globalz00_1018);
																								BgL_arg3617z00_1036 =
																									MAKE_PAIR(BgL_arg3618z00_1037,
																									BgL_resz00_1009);
																							}
																							{
																								obj_t BgL_resz00_3290;

																								obj_t BgL_fixesz00_3289;

																								BgL_fixesz00_3289 =
																									BgL_arg3616z00_1035;
																								BgL_resz00_3290 =
																									BgL_arg3617z00_1036;
																								BgL_resz00_1009 =
																									BgL_resz00_3290;
																								BgL_fixesz00_1008 =
																									BgL_fixesz00_3289;
																								goto
																									BgL_zc3anonymousza33600ze3z83_1010;
																							}
																						}
																					}
																				else
																					{	/* Cfa/specialize.scm 258 */
																						return BFALSE;
																					}
																			}
																	}
																}
															else
																{	/* Cfa/specialize.scm 238 */
																	{	/* Cfa/specialize.scm 264 */
																		obj_t BgL_arg3627z00_1046;

																		BgL_arg3627z00_1046 =
																			MAKE_PAIR(BgL_idz00_1016,
																			BgL_modz00_1017);
																		{	/* Cfa/specialize.scm 264 */
																			obj_t BgL_list3628z00_1047;

																			{	/* Cfa/specialize.scm 264 */
																				obj_t BgL_arg3629z00_1048;

																				{	/* Cfa/specialize.scm 264 */
																					obj_t BgL_arg3630z00_1049;

																					{	/* Cfa/specialize.scm 264 */
																						obj_t BgL_arg3631z00_1050;

																						BgL_arg3631z00_1050 =
																							MAKE_PAIR(BgL_arg3627z00_1046,
																							BNIL);
																						BgL_arg3630z00_1049 =
																							MAKE_PAIR
																							(BGl_string3953z00zzcfa_specializa7eza7,
																							BgL_arg3631z00_1050);
																					}
																					BgL_arg3629z00_1048 =
																						MAKE_PAIR
																						(BGl_string3954z00zzcfa_specializa7eza7,
																						BgL_arg3630z00_1049);
																				}
																				BgL_list3628z00_1047 =
																					MAKE_PAIR
																					(BGl_string3955z00zzcfa_specializa7eza7,
																					BgL_arg3629z00_1048);
																			}
																			BGl_warningz00zz__errorz00
																				(BgL_list3628z00_1047);
																		}
																	}
																	{
																		obj_t BgL_fixesz00_3297;

																		BgL_fixesz00_3297 = CDR(BgL_fixesz00_1008);
																		BgL_fixesz00_1008 = BgL_fixesz00_3297;
																		goto BgL_zc3anonymousza33600ze3z83_1010;
																	}
																}
														}
													}
												}
											}
										}
								}
							else
								{	/* Cfa/specialize.scm 269 */
									obj_t BgL_arg3638z00_1056;

									BgL_arg3638z00_1056 =
										MAKE_PAIR(BgL_genzd2idzd2_1002, BgL_genzd2modzd2_1003);
									{	/* Cfa/specialize.scm 269 */
										obj_t BgL_list3639z00_1057;

										{	/* Cfa/specialize.scm 269 */
											obj_t BgL_arg3640z00_1058;

											{	/* Cfa/specialize.scm 269 */
												obj_t BgL_arg3641z00_1059;

												{	/* Cfa/specialize.scm 269 */
													obj_t BgL_arg3642z00_1060;

													BgL_arg3642z00_1060 =
														MAKE_PAIR(BgL_arg3638z00_1056, BNIL);
													BgL_arg3641z00_1059 =
														MAKE_PAIR(BGl_string3953z00zzcfa_specializa7eza7,
														BgL_arg3642z00_1060);
												}
												BgL_arg3640z00_1058 =
													MAKE_PAIR(BGl_string3954z00zzcfa_specializa7eza7,
													BgL_arg3641z00_1059);
											}
											BgL_list3639z00_1057 =
												MAKE_PAIR(BGl_string3955z00zzcfa_specializa7eza7,
												BgL_arg3640z00_1058);
										}
										return BGl_warningz00zz__errorz00(BgL_list3639z00_1057);
									}
								}
						}
					}
				}
			}
		}
	}



/* uninstall-specializes! */
	obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 277 */
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			{
				obj_t BgL_l3447z00_1062;

				BgL_l3447z00_1062 = BGl_za2specializa7eza2za7zzcfa_specializa7eza7;
			BgL_zc3anonymousza33643ze3z83_1063:
				if (PAIRP(BgL_l3447z00_1062))
					{	/* Cfa/specialize.scm 279 */
						{	/* Cfa/specialize.scm 279 */
							obj_t BgL_oz00_1065;

							BgL_oz00_1065 = CAR(BgL_l3447z00_1062);
							{	/* Cfa/specialize.scm 279 */
								long BgL_arg3645z00_1067;

								{	/* Cfa/specialize.scm 279 */
									obj_t BgL_arg3646z00_1068;

									{	/* Cfa/specialize.scm 279 */
										obj_t BgL_arg3647z00_1069;

										{	/* Cfa/specialize.scm 279 */
											BgL_objectz00_bglt BgL_objectz00_1895;

											BgL_objectz00_1895 = (BgL_objectz00_bglt) (BgL_oz00_1065);
											{	/* Cfa/specialize.scm 279 */
												long BgL_arg2554z00_1896;

												{	/* Cfa/specialize.scm 279 */
													long BgL_arg2556z00_1897;

													BgL_arg2556z00_1897 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1895);
													BgL_arg2554z00_1896 =
														(BgL_arg2556z00_1897 - OBJECT_TYPE);
												}
												BgL_arg3647z00_1069 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2554z00_1896));
										}}
										BgL_arg3646z00_1068 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3647z00_1069);
									}
									BgL_arg3645z00_1067 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3646z00_1068);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_oz00_1065), BgL_arg3645z00_1067);
							}
							{	/* Cfa/specialize.scm 279 */
								BgL_objectz00_bglt BgL_auxz00_3317;

								BgL_auxz00_3317 = (BgL_objectz00_bglt) (BgL_oz00_1065);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3317, BFALSE);
							} BgL_oz00_1065;
						}
						{
							obj_t BgL_l3447z00_3320;

							BgL_l3447z00_3320 = CDR(BgL_l3447z00_1062);
							BgL_l3447z00_1062 = BgL_l3447z00_3320;
							goto BgL_zc3anonymousza33643ze3z83_1063;
						}
					}
				else
					{	/* Cfa/specialize.scm 279 */
						((bool_t) 1);
					}
			}
			return (BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL, BUNSPEC);
		}
	}



/* patch-tree! */
	bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t BgL_globalsz00_9)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 285 */
			{
				obj_t BgL_l3449z00_1073;

				BgL_l3449z00_1073 = BgL_globalsz00_9;
			BgL_zc3anonymousza33649ze3z83_1074:
				if (PAIRP(BgL_l3449z00_1073))
					{	/* Cfa/specialize.scm 286 */
						BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR(BgL_l3449z00_1073));
						{
							obj_t BgL_l3449z00_3326;

							BgL_l3449z00_3326 = CDR(BgL_l3449z00_1073);
							BgL_l3449z00_1073 = BgL_l3449z00_3326;
							goto BgL_zc3anonymousza33649ze3z83_1074;
						}
					}
				else
					{	/* Cfa/specialize.scm 286 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* patch-fun! */
	obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t BgL_variablez00_10)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 291 */
			{	/* Cfa/specialize.scm 292 */
				BgL_valuez00_bglt BgL_funz00_1079;

				{
					BgL_variablez00_bglt BgL_auxz00_3328;

					BgL_auxz00_3328 = (BgL_variablez00_bglt) (BgL_variablez00_10);
					BgL_funz00_1079 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_3328))->BgL_valuez00);
				}
				{	/* Cfa/specialize.scm 293 */
					obj_t BgL_arg3653z00_1080;

					{	/* Cfa/specialize.scm 293 */
						obj_t BgL_arg3654z00_1081;

						{
							BgL_sfunz00_bglt BgL_auxz00_3331;

							BgL_auxz00_3331 = (BgL_sfunz00_bglt) (BgL_funz00_1079);
							BgL_arg3654z00_1081 =
								(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3331))->BgL_bodyz00);
						}
						{	/* Cfa/specialize.scm 293 */
							BgL_nodez00_bglt BgL_nodez00_1911;

							BgL_nodez00_1911 = (BgL_nodez00_bglt) (BgL_arg3654z00_1081);
							{	/* Cfa/specialize.scm 293 */
								obj_t BgL_method3463z00_1912;

								{	/* Cfa/specialize.scm 293 */
									BgL_objectz00_bglt BgL_objz00_1913;

									BgL_objz00_1913 = (BgL_objectz00_bglt) (BgL_nodez00_1911);
									{	/* Cfa/specialize.scm 293 */
										long BgL_objzd2classzd2numz00_1914;

										BgL_objzd2classzd2numz00_1914 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1913);
										{	/* Cfa/specialize.scm 293 */
											obj_t BgL_arg2551z00_1915;

											BgL_arg2551z00_1915 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 293 */
												obj_t BgL_arrayz00_1917;

												int BgL_offsetz00_1918;

												BgL_arrayz00_1917 = BgL_arg2551z00_1915;
												BgL_offsetz00_1918 =
													(int) (BgL_objzd2classzd2numz00_1914);
												{	/* Cfa/specialize.scm 293 */
													long BgL_offsetz00_1919;

													BgL_offsetz00_1919 =
														((long) (BgL_offsetz00_1918) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 293 */
														long BgL_modz00_1920;

														{	/* Cfa/specialize.scm 293 */
															int BgL_arg2553z00_1921;

															BgL_arg2553z00_1921 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 293 */
																long BgL_auxz00_3343;

																BgL_auxz00_3343 = (long) (BgL_arg2553z00_1921);
																BgL_modz00_1920 =
																	(BgL_offsetz00_1919 / BgL_auxz00_3343);
														}}
														{	/* Cfa/specialize.scm 293 */
															long BgL_restz00_1922;

															{	/* Cfa/specialize.scm 293 */
																int BgL_arg2552z00_1923;

																BgL_arg2552z00_1923 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 293 */
																	long BgL_auxz00_3347;

																	BgL_auxz00_3347 =
																		(long) (BgL_arg2552z00_1923);
																	BgL_restz00_1922 =
																		(BgL_offsetz00_1919 % BgL_auxz00_3347);
															}}
															{	/* Cfa/specialize.scm 293 */

																BgL_method3463z00_1912 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1917,
																		(int) (BgL_modz00_1920)),
																	(int) (BgL_restz00_1922));
								}}}}}}}}
								BgL_arg3653z00_1080 =
									PROCEDURE_ENTRY(BgL_method3463z00_1912)
									(BgL_method3463z00_1912, (obj_t) (BgL_nodez00_1911), BEOA);
					}}}
					{
						BgL_sfunz00_bglt BgL_auxz00_3357;

						BgL_auxz00_3357 = (BgL_sfunz00_bglt) (BgL_funz00_1079);
						return
							((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3357))->BgL_bodyz00) =
							((obj_t) BgL_arg3653z00_1080), BUNSPEC);
					}
				}
			}
		}
	}



/* patch*! */
	obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t BgL_nodeza2za2_33)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 473 */
			{
				obj_t BgL_nodeza2za2_1083;

				BgL_nodeza2za2_1083 = BgL_nodeza2za2_33;
			BgL_zc3anonymousza33655ze3z83_1084:
				if (NULLP(BgL_nodeza2za2_1083))
					{	/* Cfa/specialize.scm 475 */
						return CNST_TABLE_REF(((long) 6));
					}
				else
					{	/* Cfa/specialize.scm 475 */
						{	/* Cfa/specialize.scm 478 */
							obj_t BgL_arg3657z00_1086;

							{	/* Cfa/specialize.scm 478 */
								obj_t BgL_arg3658z00_1087;

								BgL_arg3658z00_1087 = CAR(BgL_nodeza2za2_1083);
								{	/* Cfa/specialize.scm 478 */
									BgL_nodez00_bglt BgL_nodez00_1941;

									BgL_nodez00_1941 = (BgL_nodez00_bglt) (BgL_arg3658z00_1087);
									{	/* Cfa/specialize.scm 478 */
										obj_t BgL_method3463z00_1942;

										{	/* Cfa/specialize.scm 478 */
											BgL_objectz00_bglt BgL_objz00_1943;

											BgL_objz00_1943 = (BgL_objectz00_bglt) (BgL_nodez00_1941);
											{	/* Cfa/specialize.scm 478 */
												long BgL_objzd2classzd2numz00_1944;

												BgL_objzd2classzd2numz00_1944 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1943);
												{	/* Cfa/specialize.scm 478 */
													obj_t BgL_arg2551z00_1945;

													BgL_arg2551z00_1945 =
														PROCEDURE_REF
														(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
														(int) (((long) 1)));
													{	/* Cfa/specialize.scm 478 */
														obj_t BgL_arrayz00_1947;

														int BgL_offsetz00_1948;

														BgL_arrayz00_1947 = BgL_arg2551z00_1945;
														BgL_offsetz00_1948 =
															(int) (BgL_objzd2classzd2numz00_1944);
														{	/* Cfa/specialize.scm 478 */
															long BgL_offsetz00_1949;

															BgL_offsetz00_1949 =
																((long) (BgL_offsetz00_1948) - OBJECT_TYPE);
															{	/* Cfa/specialize.scm 478 */
																long BgL_modz00_1950;

																{	/* Cfa/specialize.scm 478 */
																	int BgL_arg2553z00_1951;

																	BgL_arg2553z00_1951 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 478 */
																		long BgL_auxz00_3373;

																		BgL_auxz00_3373 =
																			(long) (BgL_arg2553z00_1951);
																		BgL_modz00_1950 =
																			(BgL_offsetz00_1949 / BgL_auxz00_3373);
																}}
																{	/* Cfa/specialize.scm 478 */
																	long BgL_restz00_1952;

																	{	/* Cfa/specialize.scm 478 */
																		int BgL_arg2552z00_1953;

																		BgL_arg2552z00_1953 = (int) (((long) 8));
																		{	/* Cfa/specialize.scm 478 */
																			long BgL_auxz00_3377;

																			BgL_auxz00_3377 =
																				(long) (BgL_arg2552z00_1953);
																			BgL_restz00_1952 =
																				(BgL_offsetz00_1949 % BgL_auxz00_3377);
																	}}
																	{	/* Cfa/specialize.scm 478 */

																		BgL_method3463z00_1942 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1947,
																				(int) (BgL_modz00_1950)),
																			(int) (BgL_restz00_1952));
										}}}}}}}}
										BgL_arg3657z00_1086 =
											PROCEDURE_ENTRY(BgL_method3463z00_1942)
											(BgL_method3463z00_1942, (obj_t) (BgL_nodez00_1941),
											BEOA);
							}}}
							SET_CAR(BgL_nodeza2za2_1083, BgL_arg3657z00_1086);
						}
						{
							obj_t BgL_nodeza2za2_3388;

							BgL_nodeza2za2_3388 = CDR(BgL_nodeza2za2_1083);
							BgL_nodeza2za2_1083 = BgL_nodeza2za2_3388;
							goto BgL_zc3anonymousza33655ze3z83_1084;
						}
					}
			}
		}
	}



/* specialize-app! */
	BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_35)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 498 */
			if (NULLP((((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00)))
				{	/* Cfa/specialize.scm 505 */
					return BgL_nodez00_35;
				}
			else
				{	/* Cfa/specialize.scm 509 */
					obj_t BgL_typez00_1093;

					{	/* Cfa/specialize.scm 509 */
						obj_t BgL_arg3673z00_1112;

						{	/* Cfa/specialize.scm 509 */
							obj_t BgL_pairz00_1973;

							BgL_pairz00_1973 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00);
							BgL_arg3673z00_1112 = CAR(BgL_pairz00_1973);
						}
						BgL_typez00_1093 =
							BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7
							(BgL_arg3673z00_1112);
					}
					{	/* Cfa/specialize.scm 509 */
						BgL_variablez00_bglt BgL_gloz00_1094;

						{	/* Cfa/specialize.scm 510 */
							BgL_varz00_bglt BgL_obj2142z00_1975;

							BgL_obj2142z00_1975 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_funz00);
							BgL_gloz00_1094 =
								(((BgL_varz00_bglt) CREF(BgL_obj2142z00_1975))->
								BgL_variablez00);
						}
						{	/* Cfa/specialize.scm 510 */
							obj_t BgL_specz00_1095;

							{	/* Cfa/specialize.scm 511 */
								obj_t BgL_auxz00_3398;

								{	/* Cfa/specialize.scm 511 */
									BgL_specializa7edzd2globalz75_bglt BgL_obj3339z00_1976;

									BgL_obj3339z00_1976 =
										(BgL_specializa7edzd2globalz75_bglt) (BgL_gloz00_1094);
									{
										obj_t BgL_auxz00_3400;

										{	/* Cfa/specialize.scm 511 */
											BgL_objectz00_bglt BgL_auxz00_3401;

											BgL_auxz00_3401 =
												(BgL_objectz00_bglt) (BgL_obj3339z00_1976);
											BgL_auxz00_3400 = BGL_OBJECT_WIDENING(BgL_auxz00_3401);
										}
										BgL_auxz00_3398 =
											(((BgL_specializa7edzd2globalz75_bglt)
												CREF(BgL_auxz00_3400))->BgL_fixz00);
									}
								}
								BgL_specz00_1095 =
									BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_1093,
									BgL_auxz00_3398);
							}
							{	/* Cfa/specialize.scm 511 */

								if (PAIRP(BgL_specz00_1095))
									{	/* Cfa/specialize.scm 513 */
										obj_t BgL_g3438z00_1097;

										{	/* Cfa/specialize.scm 513 */
											obj_t BgL_pairz00_1979;

											BgL_pairz00_1979 =
												(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00);
											BgL_g3438z00_1097 = CDR(BgL_pairz00_1979);
										}
										{
											obj_t BgL_argsz00_1099;

											BgL_argsz00_1099 = BgL_g3438z00_1097;
										BgL_zc3anonymousza33662ze3z83_1100:
											if (NULLP(BgL_argsz00_1099))
												{	/* Cfa/specialize.scm 515 */
													BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
														(BgL_typez00_1093);
													{	/* Cfa/specialize.scm 517 */
														BgL_varz00_bglt BgL_arg3664z00_1102;

														obj_t BgL_arg3665z00_1103;

														BgL_arg3664z00_1102 =
															(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->
															BgL_funz00);
														BgL_arg3665z00_1103 = CDR(BgL_specz00_1095);
														{
															BgL_variablez00_bglt BgL_auxz00_3415;

															BgL_auxz00_3415 =
																(BgL_variablez00_bglt) (BgL_arg3665z00_1103);
															((((BgL_varz00_bglt) CREF(BgL_arg3664z00_1102))->
																	BgL_variablez00) =
																((BgL_variablez00_bglt) BgL_auxz00_3415),
																BUNSPEC);
														}
													}
													{
														BgL_typez00_bglt BgL_auxz00_3420;

														BgL_nodez00_bglt BgL_auxz00_3418;

														BgL_auxz00_3420 =
															(BgL_typez00_bglt) (BgL_typez00_1093);
														BgL_auxz00_3418 =
															(BgL_nodez00_bglt) (BgL_nodez00_35);
														((((BgL_nodez00_bglt) CREF(BgL_auxz00_3418))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_3420), BUNSPEC);
													}
													return BgL_nodez00_35;
												}
											else
												{	/* Cfa/specialize.scm 515 */
													if (
														(BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7
															(CAR(BgL_argsz00_1099)) == BgL_typez00_1093))
														{
															obj_t BgL_argsz00_3427;

															BgL_argsz00_3427 = CDR(BgL_argsz00_1099);
															BgL_argsz00_1099 = BgL_argsz00_3427;
															goto BgL_zc3anonymousza33662ze3z83_1100;
														}
													else
														{	/* Cfa/specialize.scm 520 */
															return
																BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
																(BgL_nodez00_35);
														}
												}
										}
									}
								else
									{	/* Cfa/specialize.scm 512 */
										return
											BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
											(BgL_nodez00_35);
									}
							}
						}
					}
				}
		}
	}



/* normalize-typeof */
	obj_t BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7(obj_t BgL_valz00_1115)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 503 */
			{	/* Cfa/specialize.scm 500 */
				BgL_typez00_bglt BgL_tyz00_1117;

				BgL_tyz00_1117 =
					BGl_typeofz00zztype_typeofz00((BgL_nodez00_bglt) (BgL_valz00_1115));
				if (((obj_t) (BgL_tyz00_1117) == BGl_za2intza2z00zztype_cachez00))
					{	/* Cfa/specialize.scm 501 */
						return BGl_za2longza2z00zztype_cachez00;
					}
				else
					{	/* Cfa/specialize.scm 501 */
						return (obj_t) (BgL_tyz00_1117);
					}
			}
		}
	}



/* specialize-eq? */
	BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_36)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 534 */
			{
				BgL_appz00_bglt BgL_nodez00_1149;

				obj_t BgL_typez00_1150;

				{	/* Cfa/specialize.scm 541 */
					bool_t BgL_testz00_3437;

					{	/* Cfa/specialize.scm 541 */
						bool_t BgL_testz00_3438;

						{	/* Cfa/specialize.scm 541 */
							BgL_variablez00_bglt BgL_arg3701z00_1147;

							{	/* Cfa/specialize.scm 541 */
								BgL_varz00_bglt BgL_obj2142z00_1990;

								BgL_obj2142z00_1990 =
									(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_funz00);
								BgL_arg3701z00_1147 =
									(((BgL_varz00_bglt) CREF(BgL_obj2142z00_1990))->
									BgL_variablez00);
							}
							BgL_testz00_3438 =
								(
								(obj_t) (BgL_arg3701z00_1147) ==
								BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7);
						}
						if (BgL_testz00_3438)
							{	/* Cfa/specialize.scm 542 */
								obj_t BgL_arg3700z00_1146;

								BgL_arg3700z00_1146 =
									BGl_thezd2backendzd2zzbackend_backendz00();
								{
									BgL_backendz00_bglt BgL_auxz00_3444;

									BgL_auxz00_3444 = (BgL_backendz00_bglt) (BgL_arg3700z00_1146);
									BgL_testz00_3437 =
										(((BgL_backendz00_bglt) CREF(BgL_auxz00_3444))->
										BgL_typedzd2eqzd2);
								}
							}
						else
							{	/* Cfa/specialize.scm 541 */
								BgL_testz00_3437 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3437)
						{	/* Cfa/specialize.scm 544 */
							BgL_typez00_bglt BgL_t1z00_1123;

							BgL_typez00_bglt BgL_t2z00_1124;

							{	/* Cfa/specialize.scm 544 */
								obj_t BgL_arg3695z00_1141;

								{	/* Cfa/specialize.scm 544 */
									obj_t BgL_pairz00_1993;

									BgL_pairz00_1993 =
										(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_argsz00);
									BgL_arg3695z00_1141 = CAR(BgL_pairz00_1993);
								}
								BgL_t1z00_1123 =
									BGl_typeofz00zztype_typeofz00(
									(BgL_nodez00_bglt) (BgL_arg3695z00_1141));
							}
							{	/* Cfa/specialize.scm 545 */
								obj_t BgL_arg3697z00_1143;

								{	/* Cfa/specialize.scm 545 */
									obj_t BgL_pairz00_1995;

									BgL_pairz00_1995 =
										(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_argsz00);
									BgL_arg3697z00_1143 = CAR(CDR(BgL_pairz00_1995));
								}
								BgL_t2z00_1124 =
									BGl_typeofz00zztype_typeofz00(
									(BgL_nodez00_bglt) (BgL_arg3697z00_1143));
							}
							{	/* Cfa/specialize.scm 547 */
								bool_t BgL_testz00_3456;

								if (
									((obj_t) (BgL_t1z00_1123) == BGl_za2objza2z00zztype_cachez00))
									{	/* Cfa/specialize.scm 547 */
										BgL_testz00_3456 =
											(
											(obj_t) (BgL_t2z00_1124) ==
											BGl_za2objza2z00zztype_cachez00);
									}
								else
									{	/* Cfa/specialize.scm 547 */
										BgL_testz00_3456 = ((bool_t) 0);
									}
								if (BgL_testz00_3456)
									{	/* Cfa/specialize.scm 547 */
										BUNSPEC;
									}
								else
									{	/* Cfa/specialize.scm 547 */
										if (
											((obj_t) (BgL_t1z00_1123) ==
												BGl_za2bintza2z00zztype_cachez00))
											{	/* Cfa/specialize.scm 549 */
												if (
													((obj_t) (BgL_t2z00_1124) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 550 */
														BgL_nodez00_1149 = BgL_nodez00_36;
														BgL_typez00_1150 = BGl_za2bintza2z00zztype_cachez00;
													BgL_zc3anonymousza33703ze3z83_1151:
														{	/* Cfa/specialize.scm 537 */
															bool_t BgL_testz00_3468;

															{	/* Cfa/specialize.scm 537 */
																obj_t BgL_obj1739z00_1999;

																BgL_obj1739z00_1999 =
																	BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7;
																BgL_testz00_3468 =
																	BGl_iszd2azf3z21zz__objectz00
																	(BgL_obj1739z00_1999,
																	BGl_globalz00zzast_varz00);
															}
															if (BgL_testz00_3468)
																{	/* Cfa/specialize.scm 537 */
																	{	/* Cfa/specialize.scm 539 */
																		BgL_varz00_bglt BgL_arg3705z00_1153;

																		BgL_arg3705z00_1153 =
																			(((BgL_appz00_bglt)
																				CREF(BgL_nodez00_36))->BgL_funz00);
																		{
																			BgL_variablez00_bglt BgL_auxz00_3471;

																			BgL_auxz00_3471 =
																				(BgL_variablez00_bglt)
																				(BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7);
																			((((BgL_varz00_bglt)
																						CREF(BgL_arg3705z00_1153))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt)
																					BgL_auxz00_3471), BUNSPEC);
																		}
																	}
																	BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7
																		(BgL_typez00_1150);
																}
															else
																{	/* Cfa/specialize.scm 537 */
																	BFALSE;
																}
														}
													}
												else
													{	/* Cfa/specialize.scm 550 */
														BFALSE;
													}
											}
										else
											{	/* Cfa/specialize.scm 549 */
												if (
													((obj_t) (BgL_t2z00_1124) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 553 */
														BUNSPEC;
													}
												else
													{	/* Cfa/specialize.scm 553 */
														if (
															((obj_t) (BgL_t1z00_1123) ==
																BGl_za2brealza2z00zztype_cachez00))
															{	/* Cfa/specialize.scm 555 */
																if (
																	((obj_t) (BgL_t2z00_1124) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{
																		obj_t BgL_typez00_3485;

																		BgL_appz00_bglt BgL_nodez00_3484;

																		BgL_nodez00_3484 = BgL_nodez00_36;
																		BgL_typez00_3485 =
																			BGl_za2brealza2z00zztype_cachez00;
																		BgL_typez00_1150 = BgL_typez00_3485;
																		BgL_nodez00_1149 = BgL_nodez00_3484;
																		goto BgL_zc3anonymousza33703ze3z83_1151;
																	}
																else
																	{	/* Cfa/specialize.scm 556 */
																		BFALSE;
																	}
															}
														else
															{	/* Cfa/specialize.scm 555 */
																if (
																	((obj_t) (BgL_t2z00_1124) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{	/* Cfa/specialize.scm 559 */
																		BUNSPEC;
																	}
																else
																	{	/* Cfa/specialize.scm 559 */
																		if (
																			((obj_t) (BgL_t2z00_1124) ==
																				BGl_za2bintza2z00zztype_cachez00))
																			{	/* Cfa/specialize.scm 561 */
																				BUNSPEC;
																			}
																		else
																			{	/* Cfa/specialize.scm 561 */
																				if (
																					((obj_t) (BgL_t1z00_1123) ==
																						BGl_za2bcharza2z00zztype_cachez00))
																					{	/* Cfa/specialize.scm 563 */
																						if (
																							((obj_t) (BgL_t2z00_1124) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{
																								obj_t BgL_typez00_3499;

																								BgL_appz00_bglt
																									BgL_nodez00_3498;
																								BgL_nodez00_3498 =
																									BgL_nodez00_36;
																								BgL_typez00_3499 =
																									BGl_za2bcharza2z00zztype_cachez00;
																								BgL_typez00_1150 =
																									BgL_typez00_3499;
																								BgL_nodez00_1149 =
																									BgL_nodez00_3498;
																								goto
																									BgL_zc3anonymousza33703ze3z83_1151;
																							}
																						else
																							{	/* Cfa/specialize.scm 564 */
																								BFALSE;
																							}
																					}
																				else
																					{	/* Cfa/specialize.scm 563 */
																						if (
																							((obj_t) (BgL_t2z00_1124) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{	/* Cfa/specialize.scm 567 */
																								BUNSPEC;
																							}
																						else
																							{	/* Cfa/specialize.scm 569 */
																								bool_t BgL_testz00_3503;

																								if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t1z00_1123))
																									{	/* Cfa/specialize.scm 569 */
																										BgL_testz00_3503 =
																											BGl_bigloozd2typezf3z21zztype_typez00
																											(BgL_t2z00_1124);
																									}
																								else
																									{	/* Cfa/specialize.scm 569 */
																										BgL_testz00_3503 =
																											((bool_t) 0);
																									}
																								if (BgL_testz00_3503)
																									{	/* Cfa/specialize.scm 571 */
																										BgL_typez00_bglt
																											BgL_arg3691z00_1137;
																										if (((obj_t)
																												(BgL_t1z00_1123) ==
																												BGl_za2objza2z00zztype_cachez00))
																											{	/* Cfa/specialize.scm 571 */
																												BgL_arg3691z00_1137 =
																													BgL_t2z00_1124;
																											}
																										else
																											{	/* Cfa/specialize.scm 571 */
																												BgL_arg3691z00_1137 =
																													BgL_t1z00_1123;
																											}
																										{
																											obj_t BgL_typez00_3511;

																											BgL_appz00_bglt
																												BgL_nodez00_3510;
																											BgL_nodez00_3510 =
																												BgL_nodez00_36;
																											BgL_typez00_3511 =
																												(obj_t)
																												(BgL_arg3691z00_1137);
																											BgL_typez00_1150 =
																												BgL_typez00_3511;
																											BgL_nodez00_1149 =
																												BgL_nodez00_3510;
																											goto
																												BgL_zc3anonymousza33703ze3z83_1151;
																										}
																									}
																								else
																									{	/* Cfa/specialize.scm 569 */
																										BUNSPEC;
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
							return BgL_nodez00_36;
						}
					else
						{	/* Cfa/specialize.scm 541 */
							return BgL_nodez00_36;
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 34 */
				obj_t BgL_arg3706z00_1155;

				obj_t BgL_arg3707z00_1156;

				obj_t BgL_arg3710z00_1159;

				BgL_arg3706z00_1155 = CNST_TABLE_REF(((long) 7));
				BgL_arg3707z00_1156 = BGl_globalz00zzast_varz00;
				{	/* Cfa/specialize.scm 34 */
					obj_t BgL_v3460z00_1160;

					BgL_v3460z00_1160 = create_vector((int) (((long) 0)));
					BgL_arg3710z00_1159 = BgL_v3460z00_1160;
				}
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3706z00_1155,
					BgL_arg3707z00_1156, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2specializa7edzd2globalzd2envz27zzcfa_specializa7eza7,
					BGl_specializa7edzd2globalzd2nilzd2envz75zzcfa_specializa7eza7,
					BGl_specializa7edzd2globalzf3zd2envz54zzcfa_specializa7eza7,
					((long) 420446428), BFALSE, BFALSE, BgL_arg3710z00_1159);
			}
			return (BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7
				= BUNSPEC, BUNSPEC);
		}
	}



/* _specialized-global? */
	obj_t BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7(obj_t
		BgL_envz00_2922, obj_t BgL_obj3338z00_2923)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3338z00_2923,
					BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
		}
	}



/* _%allocate-specialized-global */
	obj_t BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7(obj_t
		BgL_envz00_2920)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{	/* Cfa/specialize.scm 34 */
				BgL_globalz00_bglt BgL_auxz00_3519;

				{	/* Cfa/specialize.scm 34 */
					BgL_globalz00_bglt BgL_res3988z00_3014;

					{	/* Cfa/specialize.scm 34 */
						BgL_globalz00_bglt BgL_new3331z00_3012;

						BgL_new3331z00_3012 =
							((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_globalz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3331z00_3012),
							BGl_classzd2numzd2zz__objectz00
							(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
						{	/* Cfa/specialize.scm 34 */
							BgL_objectz00_bglt BgL_auxz00_3524;

							BgL_auxz00_3524 = (BgL_objectz00_bglt) (BgL_new3331z00_3012);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3524, BFALSE);
						}
						BgL_res3988z00_3014 = BgL_new3331z00_3012;
					}
					BgL_auxz00_3519 = BgL_res3988z00_3014;
				}
				return (obj_t) (BgL_auxz00_3519);
			}
		}
	}



/* specialized-global-nil */
	BgL_specializa7edzd2globalz75_bglt
		BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			if (
				(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7 ==
					BUNSPEC))
				{	/* Cfa/specialize.scm 34 */
					{	/* Cfa/specialize.scm 34 */
						BgL_globalz00_bglt BgL_res3878z00_2017;

						{	/* Cfa/specialize.scm 34 */
							BgL_globalz00_bglt BgL_new1738z00_2013;

							BgL_new1738z00_2013 =
								((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1738z00_2013),
								BGl_classzd2numzd2zz__objectz00(BGl_globalz00zzast_varz00));
							{	/* Cfa/specialize.scm 34 */
								BgL_objectz00_bglt BgL_auxz00_3534;

								BgL_auxz00_3534 = (BgL_objectz00_bglt) (BgL_new1738z00_2013);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3534, BFALSE);
							}
							BgL_res3878z00_2017 = BgL_new1738z00_2013;
						}
						BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7 =
							(obj_t) (BgL_res3878z00_2017);
					}
					{	/* Cfa/specialize.scm 34 */
						obj_t BgL_arg3715z00_1170;

						BgL_typez00_bglt BgL_arg3716z00_1171;

						BgL_valuez00_bglt BgL_arg3717z00_1172;

						obj_t BgL_arg3719z00_1174;

						BgL_arg3715z00_1170 = CNST_TABLE_REF(((long) 8));
						BgL_arg3716z00_1171 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3717z00_1172 = BGl_valuezd2nilzd2zzast_varz00();
						BgL_arg3719z00_1174 = CNST_TABLE_REF(((long) 8));
						{	/* Cfa/specialize.scm 34 */
							BgL_globalz00_bglt BgL_res3879z00_2051;

							{	/* Cfa/specialize.scm 34 */
								BgL_globalz00_bglt BgL_new1720z00_2018;

								BgL_new1720z00_2018 =
									(BgL_globalz00_bglt)
									(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
								{	/* Cfa/specialize.scm 34 */
									obj_t BgL_id1704z00_2035;

									obj_t BgL_name1705z00_2036;

									BgL_typez00_bglt BgL_type1706z00_2037;

									BgL_valuez00_bglt BgL_value1707z00_2038;

									obj_t BgL_access1708z00_2039;

									obj_t BgL_fastzd2alpha1709zd2_2040;

									obj_t BgL_removable1710z00_2041;

									long BgL_occurrence1711z00_2042;

									obj_t BgL_module1712z00_2043;

									obj_t BgL_import1713z00_2044;

									bool_t BgL_evaluablezf31714zf3_2045;

									obj_t BgL_library1715z00_2046;

									bool_t BgL_userzf31716zf3_2047;

									obj_t BgL_pragma1717z00_2048;

									obj_t BgL_src1718z00_2049;

									obj_t BgL_jvmzd2typezd2name1719z00_2050;

									BgL_id1704z00_2035 = BgL_arg3715z00_1170;
									BgL_name1705z00_2036 = BUNSPEC;
									BgL_type1706z00_2037 = BgL_arg3716z00_1171;
									BgL_value1707z00_2038 = BgL_arg3717z00_1172;
									BgL_access1708z00_2039 = BUNSPEC;
									BgL_fastzd2alpha1709zd2_2040 = BUNSPEC;
									BgL_removable1710z00_2041 = BUNSPEC;
									BgL_occurrence1711z00_2042 = ((long) 0);
									BgL_module1712z00_2043 = BgL_arg3719z00_1174;
									BgL_import1713z00_2044 = BUNSPEC;
									BgL_evaluablezf31714zf3_2045 = ((bool_t) 0);
									BgL_library1715z00_2046 = BUNSPEC;
									BgL_userzf31716zf3_2047 = ((bool_t) 0);
									BgL_pragma1717z00_2048 = BUNSPEC;
									BgL_src1718z00_2049 = BUNSPEC;
									BgL_jvmzd2typezd2name1719z00_2050 =
										BGl_string3956z00zzcfa_specializa7eza7;
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_idz00) = ((obj_t) BgL_id1704z00_2035), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_namez00) = ((obj_t) BgL_name1705z00_2036), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1706z00_2037), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1707z00_2038), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_accessz00) =
										((obj_t) BgL_access1708z00_2039), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1709zd2_2040), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_removablez00) =
										((obj_t) BgL_removable1710z00_2041), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1711z00_2042), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_modulez00) =
										((obj_t) BgL_module1712z00_2043), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_importz00) =
										((obj_t) BgL_import1713z00_2044), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_evaluablezf3zf3) =
										((bool_t) BgL_evaluablezf31714zf3_2045), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_libraryz00) =
										((obj_t) BgL_library1715z00_2046), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31716zf3_2047), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_pragmaz00) =
										((obj_t) BgL_pragma1717z00_2048), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_srcz00) = ((obj_t) BgL_src1718z00_2049), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1720z00_2018))->
											BgL_jvmzd2typezd2namez00) =
										((obj_t) BgL_jvmzd2typezd2name1719z00_2050), BUNSPEC);
									BgL_res3879z00_2051 = BgL_new1720z00_2018;
							}} BgL_res3879z00_2051;
					}}
					{	/* Cfa/specialize.scm 34 */
						long BgL_arg3721z00_1176;

						BgL_arg3721z00_1176 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7),
							BgL_arg3721z00_1176);
					}
					{	/* Cfa/specialize.scm 34 */
						BgL_specializa7edzd2globalz75_bglt BgL_arg3722z00_1177;

						{	/* Cfa/specialize.scm 34 */
							BgL_specializa7edzd2globalz75_bglt BgL_res3881z00_2060;

							{	/* Cfa/specialize.scm 34 */
								BgL_specializa7edzd2globalz75_bglt BgL_new3306z00_2055;

								BgL_new3306z00_2055 =
									((BgL_specializa7edzd2globalz75_bglt)
									BREF(GC_MALLOC(sizeof(struct
												BgL_specializa7edzd2globalz75_bgl))));
								{	/* Cfa/specialize.scm 34 */
									BgL_specializa7edzd2globalz75_bglt BgL_res3880z00_2059;

									{	/* Cfa/specialize.scm 34 */
										BgL_specializa7edzd2globalz75_bglt BgL_new3328z00_2056;

										BgL_new3328z00_2056 = BgL_new3306z00_2055;
										{	/* Cfa/specialize.scm 34 */
											obj_t BgL_fix3327z00_2058;

											BgL_fix3327z00_2058 = BUNSPEC;
											((((BgL_specializa7edzd2globalz75_bglt)
														CREF(BgL_new3328z00_2056))->BgL_fixz00) =
												((obj_t) BgL_fix3327z00_2058), BUNSPEC);
											BgL_res3880z00_2059 = BgL_new3328z00_2056;
									}} BgL_res3880z00_2059;
								}
								BgL_res3881z00_2060 = BgL_new3306z00_2055;
							}
							BgL_arg3722z00_1177 = BgL_res3881z00_2060;
						}
						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_auxz00_3566;

							BgL_objectz00_bglt BgL_auxz00_3564;

							BgL_auxz00_3566 = (obj_t) (BgL_arg3722z00_1177);
							BgL_auxz00_3564 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3564, BgL_auxz00_3566);
				}}}
			else
				{	/* Cfa/specialize.scm 34 */
					BFALSE;
				}
			return
				(BgL_specializa7edzd2globalz75_bglt)
				(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
		}
	}



/* _specialized-global-nil */
	obj_t BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7(obj_t
		BgL_envz00_2921)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			return
				(obj_t) (BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7());
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_patchz12zd2default3461zd2envz12zzcfa_specializa7eza7);
		}
	}



/* patch! */
	obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt BgL_nodez00_11)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 298 */
			{	/* Cfa/specialize.scm 298 */
				obj_t BgL_method3463z00_2081;

				{	/* Cfa/specialize.scm 298 */
					BgL_objectz00_bglt BgL_objz00_2082;

					BgL_objz00_2082 = (BgL_objectz00_bglt) (BgL_nodez00_11);
					{	/* Cfa/specialize.scm 298 */
						long BgL_objzd2classzd2numz00_2083;

						BgL_objzd2classzd2numz00_2083 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2082);
						{	/* Cfa/specialize.scm 298 */
							obj_t BgL_arg2551z00_2084;

							BgL_arg2551z00_2084 =
								PROCEDURE_REF(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
								(int) (((long) 1)));
							{	/* Cfa/specialize.scm 298 */
								obj_t BgL_arrayz00_2086;

								int BgL_offsetz00_2087;

								BgL_arrayz00_2086 = BgL_arg2551z00_2084;
								BgL_offsetz00_2087 = (int) (BgL_objzd2classzd2numz00_2083);
								{	/* Cfa/specialize.scm 298 */
									long BgL_offsetz00_2088;

									BgL_offsetz00_2088 =
										((long) (BgL_offsetz00_2087) - OBJECT_TYPE);
									{	/* Cfa/specialize.scm 298 */
										long BgL_modz00_2089;

										{	/* Cfa/specialize.scm 298 */
											int BgL_arg2553z00_2090;

											BgL_arg2553z00_2090 = (int) (((long) 8));
											{	/* Cfa/specialize.scm 298 */
												long BgL_auxz00_3581;

												BgL_auxz00_3581 = (long) (BgL_arg2553z00_2090);
												BgL_modz00_2089 =
													(BgL_offsetz00_2088 / BgL_auxz00_3581);
										}}
										{	/* Cfa/specialize.scm 298 */
											long BgL_restz00_2091;

											{	/* Cfa/specialize.scm 298 */
												int BgL_arg2552z00_2092;

												BgL_arg2552z00_2092 = (int) (((long) 8));
												{	/* Cfa/specialize.scm 298 */
													long BgL_auxz00_3585;

													BgL_auxz00_3585 = (long) (BgL_arg2552z00_2092);
													BgL_restz00_2091 =
														(BgL_offsetz00_2088 % BgL_auxz00_3585);
											}}
											{	/* Cfa/specialize.scm 298 */

												BgL_method3463z00_2081 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2086,
														(int) (BgL_modz00_2089)), (int) (BgL_restz00_2091));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3463z00_2081) (BgL_method3463z00_2081,
					(obj_t) (BgL_nodez00_11), BEOA);
			}
		}
	}



/* _patch! */
	obj_t BGl__patchz12z12zzcfa_specializa7eza7(obj_t BgL_envz00_2918,
		obj_t BgL_nodez00_2919)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 298 */
			return
				BGl_patchz12z12zzcfa_specializa7eza7(
				(BgL_nodez00_bglt) (BgL_nodez00_2919));
		}
	}



/* patch!-default3461 */
	obj_t BGl_patchz12zd2default3461zc0zzcfa_specializa7eza7(BgL_nodez00_bglt
		BgL_nodez00_12)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 9)),
				BGl_string3957z00zzcfa_specializa7eza7, (obj_t) (BgL_nodez00_12));
		}
	}



/* _patch!-default3461 */
	obj_t BGl__patchz12zd2default3461zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2924, obj_t BgL_nodez00_2925)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_patchz12zd2default3461zc0zzcfa_specializa7eza7(
				(BgL_nodez00_bglt) (BgL_nodez00_2925));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_atomz00zzast_nodez00,
				BGl_proc3958z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_kwotez00zzast_nodez00,
				BGl_proc3959z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_varz00zzast_nodez00,
				BGl_proc3960z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_closurez00zzast_nodez00, BGl_proc3961z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_sequencez00zzast_nodez00, BGl_proc3962z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3963z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_funcallz00zzast_nodez00, BGl_proc3964z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_externz00zzast_nodez00,
				BGl_proc3965z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_castz00zzast_nodez00,
				BGl_proc3966z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_setqz00zzast_nodez00,
				BGl_proc3967z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_conditionalz00zzast_nodez00, BGl_proc3968z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_failz00zzast_nodez00,
				BGl_proc3969z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_selectz00zzast_nodez00,
				BGl_proc3970z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3971z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3972z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3973z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3974z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3975z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3976z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3977z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_appz00zzast_nodez00,
				BGl_proc3978z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7,
				BGl_proc3979z00zzcfa_specializa7eza7);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7,
				BGl_proc3980z00zzcfa_specializa7eza7);
		}
	}



/* struct+object->objec3509 */
	obj_t BGl_structzb2objectzd2ze3objec3509z83zzcfa_specializa7eza7(obj_t
		BgL_envz00_2954, obj_t BgL_oz00_2955, obj_t BgL_sz00_2956)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_oz00_1771;

				obj_t BgL_sz00_1772;

				{	/* Cfa/specialize.scm 34 */
					BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3625;

					BgL_oz00_1771 = (BgL_specializa7edzd2globalz75_bglt) (BgL_oz00_2955);
					BgL_sz00_1772 = BgL_sz00_2956;
					{

						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_old3335z00_1775;

							obj_t BgL_aux3336z00_1776;

							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_nextzd2method3508zd2_1781;

								BgL_nextzd2method3508zd2_1781 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1771),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
								if (PROCEDUREP(BgL_nextzd2method3508zd2_1781))
									{	/* Cfa/specialize.scm 34 */
										BgL_old3335z00_1775 =
											PROCEDURE_ENTRY(BgL_nextzd2method3508zd2_1781)
											(BgL_nextzd2method3508zd2_1781, (obj_t) (BgL_oz00_1771),
											BgL_sz00_1772, BEOA);
									}
								else
									{	/* Cfa/specialize.scm 34 */
										BgL_old3335z00_1775 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1771), BgL_sz00_1772));
									}
							}
							BgL_aux3336z00_1776 =
								STRUCT_REF(BgL_sz00_1772, (int) (((long) 0)));
							{	/* Cfa/specialize.scm 34 */
								BgL_specializa7edzd2globalz75_bglt BgL_new3337z00_1777;

								BgL_new3337z00_1777 =
									((BgL_specializa7edzd2globalz75_bglt) (BgL_old3335z00_1775));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3337z00_1777),
									BGl_classzd2numzd2zz__objectz00
									(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
								{	/* Cfa/specialize.scm 34 */
									BgL_specializa7edzd2globalz75_bglt BgL_arg3868z00_1779;

									{	/* Cfa/specialize.scm 34 */
										obj_t BgL_arg3869z00_1780;

										BgL_arg3869z00_1780 =
											STRUCT_REF(BgL_aux3336z00_1776, (int) (((long) 0)));
										{	/* Cfa/specialize.scm 34 */
											BgL_specializa7edzd2globalz75_bglt BgL_res3938z00_2910;

											{	/* Cfa/specialize.scm 34 */
												BgL_specializa7edzd2globalz75_bglt BgL_new3306z00_2905;

												BgL_new3306z00_2905 =
													((BgL_specializa7edzd2globalz75_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_specializa7edzd2globalz75_bgl))));
												{	/* Cfa/specialize.scm 34 */
													BgL_specializa7edzd2globalz75_bglt
														BgL_res3937z00_2909;
													{	/* Cfa/specialize.scm 34 */
														BgL_specializa7edzd2globalz75_bglt
															BgL_new3328z00_2906;
														BgL_new3328z00_2906 = BgL_new3306z00_2905;
														{	/* Cfa/specialize.scm 34 */
															obj_t BgL_fix3327z00_2908;

															BgL_fix3327z00_2908 = BgL_arg3869z00_1780;
															((((BgL_specializa7edzd2globalz75_bglt)
																		CREF(BgL_new3328z00_2906))->BgL_fixz00) =
																((obj_t) BgL_fix3327z00_2908), BUNSPEC);
															BgL_res3937z00_2909 = BgL_new3328z00_2906;
													}} BgL_res3937z00_2909;
												}
												BgL_res3938z00_2910 = BgL_new3306z00_2905;
											}
											BgL_arg3868z00_1779 = BgL_res3938z00_2910;
									}}
									{	/* Cfa/specialize.scm 34 */
										obj_t BgL_auxz00_3648;

										BgL_objectz00_bglt BgL_auxz00_3646;

										BgL_auxz00_3648 = (obj_t) (BgL_arg3868z00_1779);
										BgL_auxz00_3646 =
											(BgL_objectz00_bglt) (BgL_new3337z00_1777);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3646, BgL_auxz00_3648);
								}}
								BgL_auxz00_3625 = BgL_new3337z00_1777;
					}}}
					return (obj_t) (BgL_auxz00_3625);
				}
			}
		}
	}



/* object->struct-speci3507 */
	obj_t BGl_objectzd2ze3structzd2speci3507ze3zzcfa_specializa7eza7(obj_t
		BgL_envz00_2957, obj_t BgL_obj3332z00_2958)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_obj3332z00_1761;

				BgL_obj3332z00_1761 =
					(BgL_specializa7edzd2globalz75_bglt) (BgL_obj3332z00_2958);
				{

					{	/* Cfa/specialize.scm 34 */
						obj_t BgL_res3333z00_1764;

						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_nextzd2method3506zd2_1769;

							BgL_nextzd2method3506zd2_1769 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3332z00_1761),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
							if (PROCEDUREP(BgL_nextzd2method3506zd2_1769))
								{	/* Cfa/specialize.scm 34 */
									BgL_res3333z00_1764 =
										PROCEDURE_ENTRY(BgL_nextzd2method3506zd2_1769)
										(BgL_nextzd2method3506zd2_1769,
										(obj_t) (BgL_obj3332z00_1761), BEOA);
								}
							else
								{	/* Cfa/specialize.scm 34 */
									BgL_res3333z00_1764 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3332z00_1761));
								}
						}
						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_aux3334z00_1765;

							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_keyz00_2881;

								BgL_keyz00_2881 = CNST_TABLE_REF(((long) 7));
								BgL_aux3334z00_1765 =
									make_struct(BgL_keyz00_2881, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_arg3863z00_1767;

								{
									obj_t BgL_auxz00_3665;

									{	/* Cfa/specialize.scm 34 */
										BgL_objectz00_bglt BgL_auxz00_3666;

										BgL_auxz00_3666 =
											(BgL_objectz00_bglt) (BgL_obj3332z00_1761);
										BgL_auxz00_3665 = BGL_OBJECT_WIDENING(BgL_auxz00_3666);
									}
									BgL_arg3863z00_1767 =
										(((BgL_specializa7edzd2globalz75_bglt)
											CREF(BgL_auxz00_3665))->BgL_fixz00);
								}
								{	/* Cfa/specialize.scm 34 */
									int BgL_auxz00_3670;

									BgL_auxz00_3670 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3334z00_1765, BgL_auxz00_3670,
										BgL_arg3863z00_1767);
							}}
							{	/* Cfa/specialize.scm 34 */
								int BgL_auxz00_3673;

								BgL_auxz00_3673 = (int) (((long) 0));
								STRUCT_SET(BgL_res3333z00_1764, BgL_auxz00_3673,
									BgL_aux3334z00_1765);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_auxz00_3676;

								BgL_auxz00_3676 = STRUCT_KEY(BgL_res3333z00_1764);
								STRUCT_KEY_SET(BgL_aux3334z00_1765, BgL_auxz00_3676);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_kz00_2896;

								BgL_kz00_2896 = CNST_TABLE_REF(((long) 7));
								STRUCT_KEY_SET(BgL_res3333z00_1764, BgL_kz00_2896);
							}
							return BgL_res3333z00_1764;
						}
					}
				}
			}
		}
	}



/* patch!-app3505 */
	obj_t BGl_patchz12zd2app3505zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2959,
		obj_t BgL_nodez00_2960)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 484 */
			{
				BgL_appz00_bglt BgL_nodez00_1749;

				{	/* Cfa/specialize.scm 485 */
					BgL_appz00_bglt BgL_auxz00_3682;

					BgL_nodez00_1749 = (BgL_appz00_bglt) (BgL_nodez00_2960);
					{	/* Cfa/specialize.scm 486 */
						obj_t BgL_arg3856z00_1753;

						BgL_arg3856z00_1753 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1749))->BgL_argsz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3856z00_1753);
					}
					{	/* Cfa/specialize.scm 487 */
						obj_t BgL_arg3857z00_1754;

						{	/* Cfa/specialize.scm 487 */
							BgL_varz00_bglt BgL_arg3858z00_1755;

							BgL_arg3858z00_1755 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1749))->BgL_funz00);
							{	/* Cfa/specialize.scm 487 */
								BgL_nodez00_bglt BgL_nodez00_2850;

								BgL_nodez00_2850 = (BgL_nodez00_bglt) (BgL_arg3858z00_1755);
								{	/* Cfa/specialize.scm 487 */
									obj_t BgL_method3463z00_2851;

									{	/* Cfa/specialize.scm 487 */
										BgL_objectz00_bglt BgL_objz00_2852;

										BgL_objz00_2852 = (BgL_objectz00_bglt) (BgL_nodez00_2850);
										{	/* Cfa/specialize.scm 487 */
											long BgL_objzd2classzd2numz00_2853;

											BgL_objzd2classzd2numz00_2853 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2852);
											{	/* Cfa/specialize.scm 487 */
												obj_t BgL_arg2551z00_2854;

												BgL_arg2551z00_2854 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 487 */
													obj_t BgL_arrayz00_2856;

													int BgL_offsetz00_2857;

													BgL_arrayz00_2856 = BgL_arg2551z00_2854;
													BgL_offsetz00_2857 =
														(int) (BgL_objzd2classzd2numz00_2853);
													{	/* Cfa/specialize.scm 487 */
														long BgL_offsetz00_2858;

														BgL_offsetz00_2858 =
															((long) (BgL_offsetz00_2857) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 487 */
															long BgL_modz00_2859;

															{	/* Cfa/specialize.scm 487 */
																int BgL_arg2553z00_2860;

																BgL_arg2553z00_2860 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 487 */
																	long BgL_auxz00_3695;

																	BgL_auxz00_3695 =
																		(long) (BgL_arg2553z00_2860);
																	BgL_modz00_2859 =
																		(BgL_offsetz00_2858 / BgL_auxz00_3695);
															}}
															{	/* Cfa/specialize.scm 487 */
																long BgL_restz00_2861;

																{	/* Cfa/specialize.scm 487 */
																	int BgL_arg2552z00_2862;

																	BgL_arg2552z00_2862 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 487 */
																		long BgL_auxz00_3699;

																		BgL_auxz00_3699 =
																			(long) (BgL_arg2552z00_2862);
																		BgL_restz00_2861 =
																			(BgL_offsetz00_2858 % BgL_auxz00_3699);
																}}
																{	/* Cfa/specialize.scm 487 */

																	BgL_method3463z00_2851 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2856,
																			(int) (BgL_modz00_2859)),
																		(int) (BgL_restz00_2861));
									}}}}}}}}
									BgL_arg3857z00_1754 =
										PROCEDURE_ENTRY(BgL_method3463z00_2851)
										(BgL_method3463z00_2851, (obj_t) (BgL_nodez00_2850), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3709;

							BgL_auxz00_3709 = (BgL_varz00_bglt) (BgL_arg3857z00_1754);
							((((BgL_appz00_bglt) CREF(BgL_nodez00_1749))->BgL_funz00) =
								((BgL_varz00_bglt) BgL_auxz00_3709), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 488 */
						BgL_variablez00_bglt BgL_vz00_1756;

						{	/* Cfa/specialize.scm 488 */
							BgL_varz00_bglt BgL_obj2142z00_2879;

							BgL_obj2142z00_2879 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1749))->BgL_funz00);
							BgL_vz00_1756 =
								(((BgL_varz00_bglt) CREF(BgL_obj2142z00_2879))->
								BgL_variablez00);
						}
						{	/* Cfa/specialize.scm 490 */
							bool_t BgL_testz00_3714;

							{	/* Cfa/specialize.scm 490 */
								obj_t BgL_obj3338z00_2880;

								BgL_obj3338z00_2880 = (obj_t) (BgL_vz00_1756);
								BgL_testz00_3714 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj3338z00_2880,
									BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
							}
							if (BgL_testz00_3714)
								{	/* Cfa/specialize.scm 490 */
									BgL_auxz00_3682 =
										BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7
										(BgL_nodez00_1749);
								}
							else
								{	/* Cfa/specialize.scm 490 */
									BgL_auxz00_3682 = BgL_nodez00_1749;
								}
						}
					}
					return (obj_t) (BgL_auxz00_3682);
				}
			}
		}
	}



/* patch!-box-ref3503 */
	obj_t BGl_patchz12zd2boxzd2ref3503z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2961, obj_t BgL_nodez00_2962)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 465 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1741;

				{	/* Cfa/specialize.scm 466 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_3720;

					BgL_nodez00_1741 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2962);
					{	/* Cfa/specialize.scm 467 */
						obj_t BgL_arg3852z00_1745;

						{	/* Cfa/specialize.scm 467 */
							BgL_varz00_bglt BgL_arg3854z00_1746;

							BgL_arg3854z00_1746 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1741))->BgL_varz00);
							{	/* Cfa/specialize.scm 467 */
								BgL_nodez00_bglt BgL_nodez00_2820;

								BgL_nodez00_2820 = (BgL_nodez00_bglt) (BgL_arg3854z00_1746);
								{	/* Cfa/specialize.scm 467 */
									obj_t BgL_method3463z00_2821;

									{	/* Cfa/specialize.scm 467 */
										BgL_objectz00_bglt BgL_objz00_2822;

										BgL_objz00_2822 = (BgL_objectz00_bglt) (BgL_nodez00_2820);
										{	/* Cfa/specialize.scm 467 */
											long BgL_objzd2classzd2numz00_2823;

											BgL_objzd2classzd2numz00_2823 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2822);
											{	/* Cfa/specialize.scm 467 */
												obj_t BgL_arg2551z00_2824;

												BgL_arg2551z00_2824 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 467 */
													obj_t BgL_arrayz00_2826;

													int BgL_offsetz00_2827;

													BgL_arrayz00_2826 = BgL_arg2551z00_2824;
													BgL_offsetz00_2827 =
														(int) (BgL_objzd2classzd2numz00_2823);
													{	/* Cfa/specialize.scm 467 */
														long BgL_offsetz00_2828;

														BgL_offsetz00_2828 =
															((long) (BgL_offsetz00_2827) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 467 */
															long BgL_modz00_2829;

															{	/* Cfa/specialize.scm 467 */
																int BgL_arg2553z00_2830;

																BgL_arg2553z00_2830 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 467 */
																	long BgL_auxz00_3731;

																	BgL_auxz00_3731 =
																		(long) (BgL_arg2553z00_2830);
																	BgL_modz00_2829 =
																		(BgL_offsetz00_2828 / BgL_auxz00_3731);
															}}
															{	/* Cfa/specialize.scm 467 */
																long BgL_restz00_2831;

																{	/* Cfa/specialize.scm 467 */
																	int BgL_arg2552z00_2832;

																	BgL_arg2552z00_2832 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 467 */
																		long BgL_auxz00_3735;

																		BgL_auxz00_3735 =
																			(long) (BgL_arg2552z00_2832);
																		BgL_restz00_2831 =
																			(BgL_offsetz00_2828 % BgL_auxz00_3735);
																}}
																{	/* Cfa/specialize.scm 467 */

																	BgL_method3463z00_2821 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2826,
																			(int) (BgL_modz00_2829)),
																		(int) (BgL_restz00_2831));
									}}}}}}}}
									BgL_arg3852z00_1745 =
										PROCEDURE_ENTRY(BgL_method3463z00_2821)
										(BgL_method3463z00_2821, (obj_t) (BgL_nodez00_2820), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3745;

							BgL_auxz00_3745 = (BgL_varz00_bglt) (BgL_arg3852z00_1745);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1741))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3745), BUNSPEC);
					}}
					BgL_auxz00_3720 = BgL_nodez00_1741;
					return (obj_t) (BgL_auxz00_3720);
				}
			}
		}
	}



/* patch!-box-set!3501 */
	obj_t BGl_patchz12zd2boxzd2setz123501z00zzcfa_specializa7eza7(obj_t
		BgL_envz00_2963, obj_t BgL_nodez00_2964)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 456 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1731;

				{	/* Cfa/specialize.scm 457 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_3750;

					BgL_nodez00_1731 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2964);
					{	/* Cfa/specialize.scm 458 */
						obj_t BgL_arg3847z00_1735;

						{	/* Cfa/specialize.scm 458 */
							BgL_varz00_bglt BgL_arg3848z00_1736;

							BgL_arg3848z00_1736 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1731))->
								BgL_varz00);
							{	/* Cfa/specialize.scm 458 */
								BgL_nodez00_bglt BgL_nodez00_2762;

								BgL_nodez00_2762 = (BgL_nodez00_bglt) (BgL_arg3848z00_1736);
								{	/* Cfa/specialize.scm 458 */
									obj_t BgL_method3463z00_2763;

									{	/* Cfa/specialize.scm 458 */
										BgL_objectz00_bglt BgL_objz00_2764;

										BgL_objz00_2764 = (BgL_objectz00_bglt) (BgL_nodez00_2762);
										{	/* Cfa/specialize.scm 458 */
											long BgL_objzd2classzd2numz00_2765;

											BgL_objzd2classzd2numz00_2765 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2764);
											{	/* Cfa/specialize.scm 458 */
												obj_t BgL_arg2551z00_2766;

												BgL_arg2551z00_2766 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 458 */
													obj_t BgL_arrayz00_2768;

													int BgL_offsetz00_2769;

													BgL_arrayz00_2768 = BgL_arg2551z00_2766;
													BgL_offsetz00_2769 =
														(int) (BgL_objzd2classzd2numz00_2765);
													{	/* Cfa/specialize.scm 458 */
														long BgL_offsetz00_2770;

														BgL_offsetz00_2770 =
															((long) (BgL_offsetz00_2769) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 458 */
															long BgL_modz00_2771;

															{	/* Cfa/specialize.scm 458 */
																int BgL_arg2553z00_2772;

																BgL_arg2553z00_2772 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 458 */
																	long BgL_auxz00_3761;

																	BgL_auxz00_3761 =
																		(long) (BgL_arg2553z00_2772);
																	BgL_modz00_2771 =
																		(BgL_offsetz00_2770 / BgL_auxz00_3761);
															}}
															{	/* Cfa/specialize.scm 458 */
																long BgL_restz00_2773;

																{	/* Cfa/specialize.scm 458 */
																	int BgL_arg2552z00_2774;

																	BgL_arg2552z00_2774 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 458 */
																		long BgL_auxz00_3765;

																		BgL_auxz00_3765 =
																			(long) (BgL_arg2552z00_2774);
																		BgL_restz00_2773 =
																			(BgL_offsetz00_2770 % BgL_auxz00_3765);
																}}
																{	/* Cfa/specialize.scm 458 */

																	BgL_method3463z00_2763 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2768,
																			(int) (BgL_modz00_2771)),
																		(int) (BgL_restz00_2773));
									}}}}}}}}
									BgL_arg3847z00_1735 =
										PROCEDURE_ENTRY(BgL_method3463z00_2763)
										(BgL_method3463z00_2763, (obj_t) (BgL_nodez00_2762), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3775;

							BgL_auxz00_3775 = (BgL_varz00_bglt) (BgL_arg3847z00_1735);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1731))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3775), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 459 */
						obj_t BgL_arg3849z00_1737;

						{	/* Cfa/specialize.scm 459 */
							BgL_nodez00_bglt BgL_arg3850z00_1738;

							BgL_arg3850z00_1738 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1731))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 459 */
								obj_t BgL_method3463z00_2792;

								{	/* Cfa/specialize.scm 459 */
									BgL_objectz00_bglt BgL_objz00_2793;

									BgL_objz00_2793 = (BgL_objectz00_bglt) (BgL_arg3850z00_1738);
									{	/* Cfa/specialize.scm 459 */
										long BgL_objzd2classzd2numz00_2794;

										BgL_objzd2classzd2numz00_2794 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2793);
										{	/* Cfa/specialize.scm 459 */
											obj_t BgL_arg2551z00_2795;

											BgL_arg2551z00_2795 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 459 */
												obj_t BgL_arrayz00_2797;

												int BgL_offsetz00_2798;

												BgL_arrayz00_2797 = BgL_arg2551z00_2795;
												BgL_offsetz00_2798 =
													(int) (BgL_objzd2classzd2numz00_2794);
												{	/* Cfa/specialize.scm 459 */
													long BgL_offsetz00_2799;

													BgL_offsetz00_2799 =
														((long) (BgL_offsetz00_2798) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 459 */
														long BgL_modz00_2800;

														{	/* Cfa/specialize.scm 459 */
															int BgL_arg2553z00_2801;

															BgL_arg2553z00_2801 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 459 */
																long BgL_auxz00_3787;

																BgL_auxz00_3787 = (long) (BgL_arg2553z00_2801);
																BgL_modz00_2800 =
																	(BgL_offsetz00_2799 / BgL_auxz00_3787);
														}}
														{	/* Cfa/specialize.scm 459 */
															long BgL_restz00_2802;

															{	/* Cfa/specialize.scm 459 */
																int BgL_arg2552z00_2803;

																BgL_arg2552z00_2803 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 459 */
																	long BgL_auxz00_3791;

																	BgL_auxz00_3791 =
																		(long) (BgL_arg2552z00_2803);
																	BgL_restz00_2802 =
																		(BgL_offsetz00_2799 % BgL_auxz00_3791);
															}}
															{	/* Cfa/specialize.scm 459 */

																BgL_method3463z00_2792 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2797,
																		(int) (BgL_modz00_2800)),
																	(int) (BgL_restz00_2802));
								}}}}}}}}
								BgL_arg3849z00_1737 =
									PROCEDURE_ENTRY(BgL_method3463z00_2792)
									(BgL_method3463z00_2792, (obj_t) (BgL_arg3850z00_1738), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3801;

							BgL_auxz00_3801 = (BgL_nodez00_bglt) (BgL_arg3849z00_1737);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1731))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3801), BUNSPEC);
					}}
					BgL_auxz00_3750 = BgL_nodez00_1731;
					return (obj_t) (BgL_auxz00_3750);
				}
			}
		}
	}



/* patch!-make-box3499 */
	obj_t BGl_patchz12zd2makezd2box3499z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2965, obj_t BgL_nodez00_2966)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 448 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1723;

				{	/* Cfa/specialize.scm 449 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3806;

					BgL_nodez00_1723 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2966);
					{	/* Cfa/specialize.scm 450 */
						obj_t BgL_arg3844z00_1727;

						{	/* Cfa/specialize.scm 450 */
							BgL_nodez00_bglt BgL_arg3845z00_1728;

							BgL_arg3845z00_1728 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1723))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 450 */
								obj_t BgL_method3463z00_2734;

								{	/* Cfa/specialize.scm 450 */
									BgL_objectz00_bglt BgL_objz00_2735;

									BgL_objz00_2735 = (BgL_objectz00_bglt) (BgL_arg3845z00_1728);
									{	/* Cfa/specialize.scm 450 */
										long BgL_objzd2classzd2numz00_2736;

										BgL_objzd2classzd2numz00_2736 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2735);
										{	/* Cfa/specialize.scm 450 */
											obj_t BgL_arg2551z00_2737;

											BgL_arg2551z00_2737 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 450 */
												obj_t BgL_arrayz00_2739;

												int BgL_offsetz00_2740;

												BgL_arrayz00_2739 = BgL_arg2551z00_2737;
												BgL_offsetz00_2740 =
													(int) (BgL_objzd2classzd2numz00_2736);
												{	/* Cfa/specialize.scm 450 */
													long BgL_offsetz00_2741;

													BgL_offsetz00_2741 =
														((long) (BgL_offsetz00_2740) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 450 */
														long BgL_modz00_2742;

														{	/* Cfa/specialize.scm 450 */
															int BgL_arg2553z00_2743;

															BgL_arg2553z00_2743 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 450 */
																long BgL_auxz00_3816;

																BgL_auxz00_3816 = (long) (BgL_arg2553z00_2743);
																BgL_modz00_2742 =
																	(BgL_offsetz00_2741 / BgL_auxz00_3816);
														}}
														{	/* Cfa/specialize.scm 450 */
															long BgL_restz00_2744;

															{	/* Cfa/specialize.scm 450 */
																int BgL_arg2552z00_2745;

																BgL_arg2552z00_2745 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 450 */
																	long BgL_auxz00_3820;

																	BgL_auxz00_3820 =
																		(long) (BgL_arg2552z00_2745);
																	BgL_restz00_2744 =
																		(BgL_offsetz00_2741 % BgL_auxz00_3820);
															}}
															{	/* Cfa/specialize.scm 450 */

																BgL_method3463z00_2734 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2739,
																		(int) (BgL_modz00_2742)),
																	(int) (BgL_restz00_2744));
								}}}}}}}}
								BgL_arg3844z00_1727 =
									PROCEDURE_ENTRY(BgL_method3463z00_2734)
									(BgL_method3463z00_2734, (obj_t) (BgL_arg3845z00_1728), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3830;

							BgL_auxz00_3830 = (BgL_nodez00_bglt) (BgL_arg3844z00_1727);
							((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1723))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3830), BUNSPEC);
					}}
					BgL_auxz00_3806 = BgL_nodez00_1723;
					return (obj_t) (BgL_auxz00_3806);
				}
			}
		}
	}



/* patch!-jump-ex-it3497 */
	obj_t BGl_patchz12zd2jumpzd2exzd2it3497zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2967, obj_t BgL_nodez00_2968)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 439 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1713;

				{	/* Cfa/specialize.scm 440 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3835;

					BgL_nodez00_1713 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2968);
					{	/* Cfa/specialize.scm 441 */
						obj_t BgL_arg3839z00_1717;

						{	/* Cfa/specialize.scm 441 */
							BgL_nodez00_bglt BgL_arg3840z00_1718;

							BgL_arg3840z00_1718 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1713))->
								BgL_exitz00);
							{	/* Cfa/specialize.scm 441 */
								obj_t BgL_method3463z00_2676;

								{	/* Cfa/specialize.scm 441 */
									BgL_objectz00_bglt BgL_objz00_2677;

									BgL_objz00_2677 = (BgL_objectz00_bglt) (BgL_arg3840z00_1718);
									{	/* Cfa/specialize.scm 441 */
										long BgL_objzd2classzd2numz00_2678;

										BgL_objzd2classzd2numz00_2678 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2677);
										{	/* Cfa/specialize.scm 441 */
											obj_t BgL_arg2551z00_2679;

											BgL_arg2551z00_2679 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 441 */
												obj_t BgL_arrayz00_2681;

												int BgL_offsetz00_2682;

												BgL_arrayz00_2681 = BgL_arg2551z00_2679;
												BgL_offsetz00_2682 =
													(int) (BgL_objzd2classzd2numz00_2678);
												{	/* Cfa/specialize.scm 441 */
													long BgL_offsetz00_2683;

													BgL_offsetz00_2683 =
														((long) (BgL_offsetz00_2682) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 441 */
														long BgL_modz00_2684;

														{	/* Cfa/specialize.scm 441 */
															int BgL_arg2553z00_2685;

															BgL_arg2553z00_2685 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 441 */
																long BgL_auxz00_3845;

																BgL_auxz00_3845 = (long) (BgL_arg2553z00_2685);
																BgL_modz00_2684 =
																	(BgL_offsetz00_2683 / BgL_auxz00_3845);
														}}
														{	/* Cfa/specialize.scm 441 */
															long BgL_restz00_2686;

															{	/* Cfa/specialize.scm 441 */
																int BgL_arg2552z00_2687;

																BgL_arg2552z00_2687 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 441 */
																	long BgL_auxz00_3849;

																	BgL_auxz00_3849 =
																		(long) (BgL_arg2552z00_2687);
																	BgL_restz00_2686 =
																		(BgL_offsetz00_2683 % BgL_auxz00_3849);
															}}
															{	/* Cfa/specialize.scm 441 */

																BgL_method3463z00_2676 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2681,
																		(int) (BgL_modz00_2684)),
																	(int) (BgL_restz00_2686));
								}}}}}}}}
								BgL_arg3839z00_1717 =
									PROCEDURE_ENTRY(BgL_method3463z00_2676)
									(BgL_method3463z00_2676, (obj_t) (BgL_arg3840z00_1718), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3859;

							BgL_auxz00_3859 = (BgL_nodez00_bglt) (BgL_arg3839z00_1717);
							((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1713))->
									BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3859), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 442 */
						obj_t BgL_arg3841z00_1719;

						{	/* Cfa/specialize.scm 442 */
							BgL_nodez00_bglt BgL_arg3842z00_1720;

							BgL_arg3842z00_1720 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1713))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 442 */
								obj_t BgL_method3463z00_2705;

								{	/* Cfa/specialize.scm 442 */
									BgL_objectz00_bglt BgL_objz00_2706;

									BgL_objz00_2706 = (BgL_objectz00_bglt) (BgL_arg3842z00_1720);
									{	/* Cfa/specialize.scm 442 */
										long BgL_objzd2classzd2numz00_2707;

										BgL_objzd2classzd2numz00_2707 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2706);
										{	/* Cfa/specialize.scm 442 */
											obj_t BgL_arg2551z00_2708;

											BgL_arg2551z00_2708 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 442 */
												obj_t BgL_arrayz00_2710;

												int BgL_offsetz00_2711;

												BgL_arrayz00_2710 = BgL_arg2551z00_2708;
												BgL_offsetz00_2711 =
													(int) (BgL_objzd2classzd2numz00_2707);
												{	/* Cfa/specialize.scm 442 */
													long BgL_offsetz00_2712;

													BgL_offsetz00_2712 =
														((long) (BgL_offsetz00_2711) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 442 */
														long BgL_modz00_2713;

														{	/* Cfa/specialize.scm 442 */
															int BgL_arg2553z00_2714;

															BgL_arg2553z00_2714 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 442 */
																long BgL_auxz00_3871;

																BgL_auxz00_3871 = (long) (BgL_arg2553z00_2714);
																BgL_modz00_2713 =
																	(BgL_offsetz00_2712 / BgL_auxz00_3871);
														}}
														{	/* Cfa/specialize.scm 442 */
															long BgL_restz00_2715;

															{	/* Cfa/specialize.scm 442 */
																int BgL_arg2552z00_2716;

																BgL_arg2552z00_2716 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 442 */
																	long BgL_auxz00_3875;

																	BgL_auxz00_3875 =
																		(long) (BgL_arg2552z00_2716);
																	BgL_restz00_2715 =
																		(BgL_offsetz00_2712 % BgL_auxz00_3875);
															}}
															{	/* Cfa/specialize.scm 442 */

																BgL_method3463z00_2705 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2710,
																		(int) (BgL_modz00_2713)),
																	(int) (BgL_restz00_2715));
								}}}}}}}}
								BgL_arg3841z00_1719 =
									PROCEDURE_ENTRY(BgL_method3463z00_2705)
									(BgL_method3463z00_2705, (obj_t) (BgL_arg3842z00_1720), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3885;

							BgL_auxz00_3885 = (BgL_nodez00_bglt) (BgL_arg3841z00_1719);
							((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1713))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3885), BUNSPEC);
					}}
					BgL_auxz00_3835 = BgL_nodez00_1713;
					return (obj_t) (BgL_auxz00_3835);
				}
			}
		}
	}



/* patch!-set-ex-it3495 */
	obj_t BGl_patchz12zd2setzd2exzd2it3495zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2969, obj_t BgL_nodez00_2970)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 430 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1704;

				{	/* Cfa/specialize.scm 431 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3890;

					BgL_nodez00_1704 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2970);
					{	/* Cfa/specialize.scm 432 */
						obj_t BgL_arg3835z00_1708;

						{	/* Cfa/specialize.scm 432 */
							BgL_nodez00_bglt BgL_arg3836z00_1709;

							BgL_arg3836z00_1709 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1704))->
								BgL_bodyz00);
							{	/* Cfa/specialize.scm 432 */
								obj_t BgL_method3463z00_2620;

								{	/* Cfa/specialize.scm 432 */
									BgL_objectz00_bglt BgL_objz00_2621;

									BgL_objz00_2621 = (BgL_objectz00_bglt) (BgL_arg3836z00_1709);
									{	/* Cfa/specialize.scm 432 */
										long BgL_objzd2classzd2numz00_2622;

										BgL_objzd2classzd2numz00_2622 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2621);
										{	/* Cfa/specialize.scm 432 */
											obj_t BgL_arg2551z00_2623;

											BgL_arg2551z00_2623 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 432 */
												obj_t BgL_arrayz00_2625;

												int BgL_offsetz00_2626;

												BgL_arrayz00_2625 = BgL_arg2551z00_2623;
												BgL_offsetz00_2626 =
													(int) (BgL_objzd2classzd2numz00_2622);
												{	/* Cfa/specialize.scm 432 */
													long BgL_offsetz00_2627;

													BgL_offsetz00_2627 =
														((long) (BgL_offsetz00_2626) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 432 */
														long BgL_modz00_2628;

														{	/* Cfa/specialize.scm 432 */
															int BgL_arg2553z00_2629;

															BgL_arg2553z00_2629 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 432 */
																long BgL_auxz00_3900;

																BgL_auxz00_3900 = (long) (BgL_arg2553z00_2629);
																BgL_modz00_2628 =
																	(BgL_offsetz00_2627 / BgL_auxz00_3900);
														}}
														{	/* Cfa/specialize.scm 432 */
															long BgL_restz00_2630;

															{	/* Cfa/specialize.scm 432 */
																int BgL_arg2552z00_2631;

																BgL_arg2552z00_2631 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 432 */
																	long BgL_auxz00_3904;

																	BgL_auxz00_3904 =
																		(long) (BgL_arg2552z00_2631);
																	BgL_restz00_2630 =
																		(BgL_offsetz00_2627 % BgL_auxz00_3904);
															}}
															{	/* Cfa/specialize.scm 432 */

																BgL_method3463z00_2620 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2625,
																		(int) (BgL_modz00_2628)),
																	(int) (BgL_restz00_2630));
								}}}}}}}}
								BgL_arg3835z00_1708 =
									PROCEDURE_ENTRY(BgL_method3463z00_2620)
									(BgL_method3463z00_2620, (obj_t) (BgL_arg3836z00_1709), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3914;

							BgL_auxz00_3914 = (BgL_nodez00_bglt) (BgL_arg3835z00_1708);
							((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1704))->
									BgL_bodyz00) = ((BgL_nodez00_bglt) BgL_auxz00_3914), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 433 */
						BgL_varz00_bglt BgL_arg3837z00_1710;

						BgL_arg3837z00_1710 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1704))->
							BgL_varz00);
						{	/* Cfa/specialize.scm 433 */
							BgL_nodez00_bglt BgL_nodez00_2648;

							BgL_nodez00_2648 = (BgL_nodez00_bglt) (BgL_arg3837z00_1710);
							{	/* Cfa/specialize.scm 433 */
								obj_t BgL_method3463z00_2649;

								{	/* Cfa/specialize.scm 433 */
									BgL_objectz00_bglt BgL_objz00_2650;

									BgL_objz00_2650 = (BgL_objectz00_bglt) (BgL_nodez00_2648);
									{	/* Cfa/specialize.scm 433 */
										long BgL_objzd2classzd2numz00_2651;

										BgL_objzd2classzd2numz00_2651 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2650);
										{	/* Cfa/specialize.scm 433 */
											obj_t BgL_arg2551z00_2652;

											BgL_arg2551z00_2652 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 433 */
												obj_t BgL_arrayz00_2654;

												int BgL_offsetz00_2655;

												BgL_arrayz00_2654 = BgL_arg2551z00_2652;
												BgL_offsetz00_2655 =
													(int) (BgL_objzd2classzd2numz00_2651);
												{	/* Cfa/specialize.scm 433 */
													long BgL_offsetz00_2656;

													BgL_offsetz00_2656 =
														((long) (BgL_offsetz00_2655) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 433 */
														long BgL_modz00_2657;

														{	/* Cfa/specialize.scm 433 */
															int BgL_arg2553z00_2658;

															BgL_arg2553z00_2658 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 433 */
																long BgL_auxz00_3927;

																BgL_auxz00_3927 = (long) (BgL_arg2553z00_2658);
																BgL_modz00_2657 =
																	(BgL_offsetz00_2656 / BgL_auxz00_3927);
														}}
														{	/* Cfa/specialize.scm 433 */
															long BgL_restz00_2659;

															{	/* Cfa/specialize.scm 433 */
																int BgL_arg2552z00_2660;

																BgL_arg2552z00_2660 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 433 */
																	long BgL_auxz00_3931;

																	BgL_auxz00_3931 =
																		(long) (BgL_arg2552z00_2660);
																	BgL_restz00_2659 =
																		(BgL_offsetz00_2656 % BgL_auxz00_3931);
															}}
															{	/* Cfa/specialize.scm 433 */

																BgL_method3463z00_2649 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2654,
																		(int) (BgL_modz00_2657)),
																	(int) (BgL_restz00_2659));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3463z00_2649) (BgL_method3463z00_2649,
									(obj_t) (BgL_nodez00_2648), BEOA);
					}}}
					BgL_auxz00_3890 = BgL_nodez00_1704;
					return (obj_t) (BgL_auxz00_3890);
				}
			}
		}
	}



/* patch!-let-var3493 */
	obj_t BGl_patchz12zd2letzd2var3493z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2971, obj_t BgL_nodez00_2972)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 418 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1686;

				{	/* Cfa/specialize.scm 419 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3943;

					BgL_nodez00_1686 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2972);
					{	/* Cfa/specialize.scm 420 */
						obj_t BgL_g3459z00_1690;

						BgL_g3459z00_1690 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3457z00_1692;

							BgL_l3457z00_1692 = BgL_g3459z00_1690;
						BgL_zc3anonymousza33828ze3z83_1693:
							if (PAIRP(BgL_l3457z00_1692))
								{	/* Cfa/specialize.scm 420 */
									{	/* Cfa/specialize.scm 421 */
										obj_t BgL_bindingz00_1695;

										BgL_bindingz00_1695 = CAR(BgL_l3457z00_1692);
										{	/* Cfa/specialize.scm 421 */
											obj_t BgL_valz00_1696;

											BgL_valz00_1696 = CDR(BgL_bindingz00_1695);
											{	/* Cfa/specialize.scm 422 */
												obj_t BgL_arg3830z00_1697;

												{	/* Cfa/specialize.scm 422 */
													BgL_nodez00_bglt BgL_nodez00_2560;

													BgL_nodez00_2560 =
														(BgL_nodez00_bglt) (BgL_valz00_1696);
													{	/* Cfa/specialize.scm 422 */
														obj_t BgL_method3463z00_2561;

														{	/* Cfa/specialize.scm 422 */
															BgL_objectz00_bglt BgL_objz00_2562;

															BgL_objz00_2562 =
																(BgL_objectz00_bglt) (BgL_nodez00_2560);
															{	/* Cfa/specialize.scm 422 */
																long BgL_objzd2classzd2numz00_2563;

																BgL_objzd2classzd2numz00_2563 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2562);
																{	/* Cfa/specialize.scm 422 */
																	obj_t BgL_arg2551z00_2564;

																	BgL_arg2551z00_2564 =
																		PROCEDURE_REF
																		(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
																		(int) (((long) 1)));
																	{	/* Cfa/specialize.scm 422 */
																		obj_t BgL_arrayz00_2566;

																		int BgL_offsetz00_2567;

																		BgL_arrayz00_2566 = BgL_arg2551z00_2564;
																		BgL_offsetz00_2567 =
																			(int) (BgL_objzd2classzd2numz00_2563);
																		{	/* Cfa/specialize.scm 422 */
																			long BgL_offsetz00_2568;

																			BgL_offsetz00_2568 =
																				(
																				(long) (BgL_offsetz00_2567) -
																				OBJECT_TYPE);
																			{	/* Cfa/specialize.scm 422 */
																				long BgL_modz00_2569;

																				{	/* Cfa/specialize.scm 422 */
																					int BgL_arg2553z00_2570;

																					BgL_arg2553z00_2570 =
																						(int) (((long) 8));
																					{	/* Cfa/specialize.scm 422 */
																						long BgL_auxz00_3958;

																						BgL_auxz00_3958 =
																							(long) (BgL_arg2553z00_2570);
																						BgL_modz00_2569 =
																							(BgL_offsetz00_2568 /
																							BgL_auxz00_3958);
																				}}
																				{	/* Cfa/specialize.scm 422 */
																					long BgL_restz00_2571;

																					{	/* Cfa/specialize.scm 422 */
																						int BgL_arg2552z00_2572;

																						BgL_arg2552z00_2572 =
																							(int) (((long) 8));
																						{	/* Cfa/specialize.scm 422 */
																							long BgL_auxz00_3962;

																							BgL_auxz00_3962 =
																								(long) (BgL_arg2552z00_2572);
																							BgL_restz00_2571 =
																								(BgL_offsetz00_2568 %
																								BgL_auxz00_3962);
																					}}
																					{	/* Cfa/specialize.scm 422 */

																						BgL_method3463z00_2561 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2566,
																								(int) (BgL_modz00_2569)),
																							(int) (BgL_restz00_2571));
														}}}}}}}}
														BgL_arg3830z00_1697 =
															PROCEDURE_ENTRY(BgL_method3463z00_2561)
															(BgL_method3463z00_2561,
															(obj_t) (BgL_nodez00_2560), BEOA);
												}}
												SET_CDR(BgL_bindingz00_1695, BgL_arg3830z00_1697);
									}}}
									{
										obj_t BgL_l3457z00_3973;

										BgL_l3457z00_3973 = CDR(BgL_l3457z00_1692);
										BgL_l3457z00_1692 = BgL_l3457z00_3973;
										goto BgL_zc3anonymousza33828ze3z83_1693;
									}
								}
							else
								{	/* Cfa/specialize.scm 420 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/specialize.scm 424 */
						obj_t BgL_arg3832z00_1700;

						{	/* Cfa/specialize.scm 424 */
							BgL_nodez00_bglt BgL_arg3833z00_1701;

							BgL_arg3833z00_1701 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->BgL_bodyz00);
							{	/* Cfa/specialize.scm 424 */
								obj_t BgL_method3463z00_2591;

								{	/* Cfa/specialize.scm 424 */
									BgL_objectz00_bglt BgL_objz00_2592;

									BgL_objz00_2592 = (BgL_objectz00_bglt) (BgL_arg3833z00_1701);
									{	/* Cfa/specialize.scm 424 */
										long BgL_objzd2classzd2numz00_2593;

										BgL_objzd2classzd2numz00_2593 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2592);
										{	/* Cfa/specialize.scm 424 */
											obj_t BgL_arg2551z00_2594;

											BgL_arg2551z00_2594 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 424 */
												obj_t BgL_arrayz00_2596;

												int BgL_offsetz00_2597;

												BgL_arrayz00_2596 = BgL_arg2551z00_2594;
												BgL_offsetz00_2597 =
													(int) (BgL_objzd2classzd2numz00_2593);
												{	/* Cfa/specialize.scm 424 */
													long BgL_offsetz00_2598;

													BgL_offsetz00_2598 =
														((long) (BgL_offsetz00_2597) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 424 */
														long BgL_modz00_2599;

														{	/* Cfa/specialize.scm 424 */
															int BgL_arg2553z00_2600;

															BgL_arg2553z00_2600 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 424 */
																long BgL_auxz00_3984;

																BgL_auxz00_3984 = (long) (BgL_arg2553z00_2600);
																BgL_modz00_2599 =
																	(BgL_offsetz00_2598 / BgL_auxz00_3984);
														}}
														{	/* Cfa/specialize.scm 424 */
															long BgL_restz00_2601;

															{	/* Cfa/specialize.scm 424 */
																int BgL_arg2552z00_2602;

																BgL_arg2552z00_2602 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 424 */
																	long BgL_auxz00_3988;

																	BgL_auxz00_3988 =
																		(long) (BgL_arg2552z00_2602);
																	BgL_restz00_2601 =
																		(BgL_offsetz00_2598 % BgL_auxz00_3988);
															}}
															{	/* Cfa/specialize.scm 424 */

																BgL_method3463z00_2591 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2596,
																		(int) (BgL_modz00_2599)),
																	(int) (BgL_restz00_2601));
								}}}}}}}}
								BgL_arg3832z00_1700 =
									PROCEDURE_ENTRY(BgL_method3463z00_2591)
									(BgL_method3463z00_2591, (obj_t) (BgL_arg3833z00_1701), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3998;

							BgL_auxz00_3998 = (BgL_nodez00_bglt) (BgL_arg3832z00_1700);
							((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->BgL_bodyz00) =
								((BgL_nodez00_bglt) BgL_auxz00_3998), BUNSPEC);
					}}
					BgL_auxz00_3943 = BgL_nodez00_1686;
					return (obj_t) (BgL_auxz00_3943);
				}
			}
		}
	}



/* patch!-let-fun3491 */
	obj_t BGl_patchz12zd2letzd2fun3491z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2973, obj_t BgL_nodez00_2974)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 409 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1670;

				{	/* Cfa/specialize.scm 410 */
					BgL_letzd2funzd2_bglt BgL_auxz00_4003;

					BgL_nodez00_1670 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2974);
					{	/* Cfa/specialize.scm 411 */
						obj_t BgL_g3456z00_1674;

						BgL_g3456z00_1674 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1670))->BgL_localsz00);
						{
							obj_t BgL_l3454z00_1676;

							BgL_l3454z00_1676 = BgL_g3456z00_1674;
						BgL_zc3anonymousza33821ze3z83_1677:
							if (PAIRP(BgL_l3454z00_1676))
								{	/* Cfa/specialize.scm 411 */
									BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR
										(BgL_l3454z00_1676));
									{
										obj_t BgL_l3454z00_4009;

										BgL_l3454z00_4009 = CDR(BgL_l3454z00_1676);
										BgL_l3454z00_1676 = BgL_l3454z00_4009;
										goto BgL_zc3anonymousza33821ze3z83_1677;
									}
								}
							else
								{	/* Cfa/specialize.scm 411 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/specialize.scm 412 */
						obj_t BgL_arg3825z00_1682;

						{	/* Cfa/specialize.scm 412 */
							BgL_nodez00_bglt BgL_arg3826z00_1683;

							BgL_arg3826z00_1683 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1670))->BgL_bodyz00);
							{	/* Cfa/specialize.scm 412 */
								obj_t BgL_method3463z00_2529;

								{	/* Cfa/specialize.scm 412 */
									BgL_objectz00_bglt BgL_objz00_2530;

									BgL_objz00_2530 = (BgL_objectz00_bglt) (BgL_arg3826z00_1683);
									{	/* Cfa/specialize.scm 412 */
										long BgL_objzd2classzd2numz00_2531;

										BgL_objzd2classzd2numz00_2531 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2530);
										{	/* Cfa/specialize.scm 412 */
											obj_t BgL_arg2551z00_2532;

											BgL_arg2551z00_2532 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 412 */
												obj_t BgL_arrayz00_2534;

												int BgL_offsetz00_2535;

												BgL_arrayz00_2534 = BgL_arg2551z00_2532;
												BgL_offsetz00_2535 =
													(int) (BgL_objzd2classzd2numz00_2531);
												{	/* Cfa/specialize.scm 412 */
													long BgL_offsetz00_2536;

													BgL_offsetz00_2536 =
														((long) (BgL_offsetz00_2535) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 412 */
														long BgL_modz00_2537;

														{	/* Cfa/specialize.scm 412 */
															int BgL_arg2553z00_2538;

															BgL_arg2553z00_2538 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 412 */
																long BgL_auxz00_4020;

																BgL_auxz00_4020 = (long) (BgL_arg2553z00_2538);
																BgL_modz00_2537 =
																	(BgL_offsetz00_2536 / BgL_auxz00_4020);
														}}
														{	/* Cfa/specialize.scm 412 */
															long BgL_restz00_2539;

															{	/* Cfa/specialize.scm 412 */
																int BgL_arg2552z00_2540;

																BgL_arg2552z00_2540 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 412 */
																	long BgL_auxz00_4024;

																	BgL_auxz00_4024 =
																		(long) (BgL_arg2552z00_2540);
																	BgL_restz00_2539 =
																		(BgL_offsetz00_2536 % BgL_auxz00_4024);
															}}
															{	/* Cfa/specialize.scm 412 */

																BgL_method3463z00_2529 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2534,
																		(int) (BgL_modz00_2537)),
																	(int) (BgL_restz00_2539));
								}}}}}}}}
								BgL_arg3825z00_1682 =
									PROCEDURE_ENTRY(BgL_method3463z00_2529)
									(BgL_method3463z00_2529, (obj_t) (BgL_arg3826z00_1683), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4034;

							BgL_auxz00_4034 = (BgL_nodez00_bglt) (BgL_arg3825z00_1682);
							((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1670))->BgL_bodyz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4034), BUNSPEC);
					}}
					BgL_auxz00_4003 = BgL_nodez00_1670;
					return (obj_t) (BgL_auxz00_4003);
				}
			}
		}
	}



/* patch!-select3489 */
	obj_t BGl_patchz12zd2select3489zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2975,
		obj_t BgL_nodez00_2976)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 398 */
			{
				BgL_selectz00_bglt BgL_nodez00_1652;

				{	/* Cfa/specialize.scm 399 */
					BgL_selectz00_bglt BgL_auxz00_4039;

					BgL_nodez00_1652 = (BgL_selectz00_bglt) (BgL_nodez00_2976);
					{	/* Cfa/specialize.scm 400 */
						obj_t BgL_arg3812z00_1656;

						{	/* Cfa/specialize.scm 400 */
							BgL_nodez00_bglt BgL_arg3813z00_1657;

							BgL_arg3813z00_1657 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1652))->BgL_testz00);
							{	/* Cfa/specialize.scm 400 */
								obj_t BgL_method3463z00_2463;

								{	/* Cfa/specialize.scm 400 */
									BgL_objectz00_bglt BgL_objz00_2464;

									BgL_objz00_2464 = (BgL_objectz00_bglt) (BgL_arg3813z00_1657);
									{	/* Cfa/specialize.scm 400 */
										long BgL_objzd2classzd2numz00_2465;

										BgL_objzd2classzd2numz00_2465 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2464);
										{	/* Cfa/specialize.scm 400 */
											obj_t BgL_arg2551z00_2466;

											BgL_arg2551z00_2466 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 400 */
												obj_t BgL_arrayz00_2468;

												int BgL_offsetz00_2469;

												BgL_arrayz00_2468 = BgL_arg2551z00_2466;
												BgL_offsetz00_2469 =
													(int) (BgL_objzd2classzd2numz00_2465);
												{	/* Cfa/specialize.scm 400 */
													long BgL_offsetz00_2470;

													BgL_offsetz00_2470 =
														((long) (BgL_offsetz00_2469) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 400 */
														long BgL_modz00_2471;

														{	/* Cfa/specialize.scm 400 */
															int BgL_arg2553z00_2472;

															BgL_arg2553z00_2472 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 400 */
																long BgL_auxz00_4049;

																BgL_auxz00_4049 = (long) (BgL_arg2553z00_2472);
																BgL_modz00_2471 =
																	(BgL_offsetz00_2470 / BgL_auxz00_4049);
														}}
														{	/* Cfa/specialize.scm 400 */
															long BgL_restz00_2473;

															{	/* Cfa/specialize.scm 400 */
																int BgL_arg2552z00_2474;

																BgL_arg2552z00_2474 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 400 */
																	long BgL_auxz00_4053;

																	BgL_auxz00_4053 =
																		(long) (BgL_arg2552z00_2474);
																	BgL_restz00_2473 =
																		(BgL_offsetz00_2470 % BgL_auxz00_4053);
															}}
															{	/* Cfa/specialize.scm 400 */

																BgL_method3463z00_2463 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2468,
																		(int) (BgL_modz00_2471)),
																	(int) (BgL_restz00_2473));
								}}}}}}}}
								BgL_arg3812z00_1656 =
									PROCEDURE_ENTRY(BgL_method3463z00_2463)
									(BgL_method3463z00_2463, (obj_t) (BgL_arg3813z00_1657), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4063;

							BgL_auxz00_4063 = (BgL_nodez00_bglt) (BgL_arg3812z00_1656);
							((((BgL_selectz00_bglt) CREF(BgL_nodez00_1652))->BgL_testz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4063), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 401 */
						obj_t BgL_g3453z00_1658;

						BgL_g3453z00_1658 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1652))->BgL_clausesz00);
						{
							obj_t BgL_l3451z00_1660;

							BgL_l3451z00_1660 = BgL_g3453z00_1658;
						BgL_zc3anonymousza33814ze3z83_1661:
							if (PAIRP(BgL_l3451z00_1660))
								{	/* Cfa/specialize.scm 401 */
									{	/* Cfa/specialize.scm 402 */
										obj_t BgL_clausez00_1663;

										BgL_clausez00_1663 = CAR(BgL_l3451z00_1660);
										{	/* Cfa/specialize.scm 402 */
											obj_t BgL_arg3817z00_1664;

											{	/* Cfa/specialize.scm 402 */
												obj_t BgL_arg3818z00_1665;

												BgL_arg3818z00_1665 = CDR(BgL_clausez00_1663);
												{	/* Cfa/specialize.scm 402 */
													BgL_nodez00_bglt BgL_nodez00_2494;

													BgL_nodez00_2494 =
														(BgL_nodez00_bglt) (BgL_arg3818z00_1665);
													{	/* Cfa/specialize.scm 402 */
														obj_t BgL_method3463z00_2495;

														{	/* Cfa/specialize.scm 402 */
															BgL_objectz00_bglt BgL_objz00_2496;

															BgL_objz00_2496 =
																(BgL_objectz00_bglt) (BgL_nodez00_2494);
															{	/* Cfa/specialize.scm 402 */
																long BgL_objzd2classzd2numz00_2497;

																BgL_objzd2classzd2numz00_2497 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2496);
																{	/* Cfa/specialize.scm 402 */
																	obj_t BgL_arg2551z00_2498;

																	BgL_arg2551z00_2498 =
																		PROCEDURE_REF
																		(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
																		(int) (((long) 1)));
																	{	/* Cfa/specialize.scm 402 */
																		obj_t BgL_arrayz00_2500;

																		int BgL_offsetz00_2501;

																		BgL_arrayz00_2500 = BgL_arg2551z00_2498;
																		BgL_offsetz00_2501 =
																			(int) (BgL_objzd2classzd2numz00_2497);
																		{	/* Cfa/specialize.scm 402 */
																			long BgL_offsetz00_2502;

																			BgL_offsetz00_2502 =
																				(
																				(long) (BgL_offsetz00_2501) -
																				OBJECT_TYPE);
																			{	/* Cfa/specialize.scm 402 */
																				long BgL_modz00_2503;

																				{	/* Cfa/specialize.scm 402 */
																					int BgL_arg2553z00_2504;

																					BgL_arg2553z00_2504 =
																						(int) (((long) 8));
																					{	/* Cfa/specialize.scm 402 */
																						long BgL_auxz00_4080;

																						BgL_auxz00_4080 =
																							(long) (BgL_arg2553z00_2504);
																						BgL_modz00_2503 =
																							(BgL_offsetz00_2502 /
																							BgL_auxz00_4080);
																				}}
																				{	/* Cfa/specialize.scm 402 */
																					long BgL_restz00_2505;

																					{	/* Cfa/specialize.scm 402 */
																						int BgL_arg2552z00_2506;

																						BgL_arg2552z00_2506 =
																							(int) (((long) 8));
																						{	/* Cfa/specialize.scm 402 */
																							long BgL_auxz00_4084;

																							BgL_auxz00_4084 =
																								(long) (BgL_arg2552z00_2506);
																							BgL_restz00_2505 =
																								(BgL_offsetz00_2502 %
																								BgL_auxz00_4084);
																					}}
																					{	/* Cfa/specialize.scm 402 */

																						BgL_method3463z00_2495 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2500,
																								(int) (BgL_modz00_2503)),
																							(int) (BgL_restz00_2505));
														}}}}}}}}
														BgL_arg3817z00_1664 =
															PROCEDURE_ENTRY(BgL_method3463z00_2495)
															(BgL_method3463z00_2495,
															(obj_t) (BgL_nodez00_2494), BEOA);
											}}}
											SET_CDR(BgL_clausez00_1663, BgL_arg3817z00_1664);
									}}
									{
										obj_t BgL_l3451z00_4095;

										BgL_l3451z00_4095 = CDR(BgL_l3451z00_1660);
										BgL_l3451z00_1660 = BgL_l3451z00_4095;
										goto BgL_zc3anonymousza33814ze3z83_1661;
									}
								}
							else
								{	/* Cfa/specialize.scm 401 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_4039 = BgL_nodez00_1652;
					return (obj_t) (BgL_auxz00_4039);
				}
			}
		}
	}



/* patch!-fail3487 */
	obj_t BGl_patchz12zd2fail3487zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2977,
		obj_t BgL_nodez00_2978)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 388 */
			{
				BgL_failz00_bglt BgL_nodez00_1640;

				{	/* Cfa/specialize.scm 389 */
					BgL_failz00_bglt BgL_auxz00_4099;

					BgL_nodez00_1640 = (BgL_failz00_bglt) (BgL_nodez00_2978);
					{	/* Cfa/specialize.scm 390 */
						obj_t BgL_arg3805z00_1644;

						{	/* Cfa/specialize.scm 390 */
							BgL_nodez00_bglt BgL_arg3806z00_1645;

							BgL_arg3806z00_1645 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_procz00);
							{	/* Cfa/specialize.scm 390 */
								obj_t BgL_method3463z00_2376;

								{	/* Cfa/specialize.scm 390 */
									BgL_objectz00_bglt BgL_objz00_2377;

									BgL_objz00_2377 = (BgL_objectz00_bglt) (BgL_arg3806z00_1645);
									{	/* Cfa/specialize.scm 390 */
										long BgL_objzd2classzd2numz00_2378;

										BgL_objzd2classzd2numz00_2378 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2377);
										{	/* Cfa/specialize.scm 390 */
											obj_t BgL_arg2551z00_2379;

											BgL_arg2551z00_2379 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 390 */
												obj_t BgL_arrayz00_2381;

												int BgL_offsetz00_2382;

												BgL_arrayz00_2381 = BgL_arg2551z00_2379;
												BgL_offsetz00_2382 =
													(int) (BgL_objzd2classzd2numz00_2378);
												{	/* Cfa/specialize.scm 390 */
													long BgL_offsetz00_2383;

													BgL_offsetz00_2383 =
														((long) (BgL_offsetz00_2382) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 390 */
														long BgL_modz00_2384;

														{	/* Cfa/specialize.scm 390 */
															int BgL_arg2553z00_2385;

															BgL_arg2553z00_2385 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 390 */
																long BgL_auxz00_4109;

																BgL_auxz00_4109 = (long) (BgL_arg2553z00_2385);
																BgL_modz00_2384 =
																	(BgL_offsetz00_2383 / BgL_auxz00_4109);
														}}
														{	/* Cfa/specialize.scm 390 */
															long BgL_restz00_2386;

															{	/* Cfa/specialize.scm 390 */
																int BgL_arg2552z00_2387;

																BgL_arg2552z00_2387 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 390 */
																	long BgL_auxz00_4113;

																	BgL_auxz00_4113 =
																		(long) (BgL_arg2552z00_2387);
																	BgL_restz00_2386 =
																		(BgL_offsetz00_2383 % BgL_auxz00_4113);
															}}
															{	/* Cfa/specialize.scm 390 */

																BgL_method3463z00_2376 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2381,
																		(int) (BgL_modz00_2384)),
																	(int) (BgL_restz00_2386));
								}}}}}}}}
								BgL_arg3805z00_1644 =
									PROCEDURE_ENTRY(BgL_method3463z00_2376)
									(BgL_method3463z00_2376, (obj_t) (BgL_arg3806z00_1645), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4123;

							BgL_auxz00_4123 = (BgL_nodez00_bglt) (BgL_arg3805z00_1644);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_procz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4123), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 391 */
						obj_t BgL_arg3807z00_1646;

						{	/* Cfa/specialize.scm 391 */
							BgL_nodez00_bglt BgL_arg3808z00_1647;

							BgL_arg3808z00_1647 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_msgz00);
							{	/* Cfa/specialize.scm 391 */
								obj_t BgL_method3463z00_2405;

								{	/* Cfa/specialize.scm 391 */
									BgL_objectz00_bglt BgL_objz00_2406;

									BgL_objz00_2406 = (BgL_objectz00_bglt) (BgL_arg3808z00_1647);
									{	/* Cfa/specialize.scm 391 */
										long BgL_objzd2classzd2numz00_2407;

										BgL_objzd2classzd2numz00_2407 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2406);
										{	/* Cfa/specialize.scm 391 */
											obj_t BgL_arg2551z00_2408;

											BgL_arg2551z00_2408 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 391 */
												obj_t BgL_arrayz00_2410;

												int BgL_offsetz00_2411;

												BgL_arrayz00_2410 = BgL_arg2551z00_2408;
												BgL_offsetz00_2411 =
													(int) (BgL_objzd2classzd2numz00_2407);
												{	/* Cfa/specialize.scm 391 */
													long BgL_offsetz00_2412;

													BgL_offsetz00_2412 =
														((long) (BgL_offsetz00_2411) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 391 */
														long BgL_modz00_2413;

														{	/* Cfa/specialize.scm 391 */
															int BgL_arg2553z00_2414;

															BgL_arg2553z00_2414 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 391 */
																long BgL_auxz00_4135;

																BgL_auxz00_4135 = (long) (BgL_arg2553z00_2414);
																BgL_modz00_2413 =
																	(BgL_offsetz00_2412 / BgL_auxz00_4135);
														}}
														{	/* Cfa/specialize.scm 391 */
															long BgL_restz00_2415;

															{	/* Cfa/specialize.scm 391 */
																int BgL_arg2552z00_2416;

																BgL_arg2552z00_2416 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 391 */
																	long BgL_auxz00_4139;

																	BgL_auxz00_4139 =
																		(long) (BgL_arg2552z00_2416);
																	BgL_restz00_2415 =
																		(BgL_offsetz00_2412 % BgL_auxz00_4139);
															}}
															{	/* Cfa/specialize.scm 391 */

																BgL_method3463z00_2405 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2410,
																		(int) (BgL_modz00_2413)),
																	(int) (BgL_restz00_2415));
								}}}}}}}}
								BgL_arg3807z00_1646 =
									PROCEDURE_ENTRY(BgL_method3463z00_2405)
									(BgL_method3463z00_2405, (obj_t) (BgL_arg3808z00_1647), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4149;

							BgL_auxz00_4149 = (BgL_nodez00_bglt) (BgL_arg3807z00_1646);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_msgz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4149), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 392 */
						obj_t BgL_arg3809z00_1648;

						{	/* Cfa/specialize.scm 392 */
							BgL_nodez00_bglt BgL_arg3810z00_1649;

							BgL_arg3810z00_1649 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_objz00);
							{	/* Cfa/specialize.scm 392 */
								obj_t BgL_method3463z00_2434;

								{	/* Cfa/specialize.scm 392 */
									BgL_objectz00_bglt BgL_objz00_2435;

									BgL_objz00_2435 = (BgL_objectz00_bglt) (BgL_arg3810z00_1649);
									{	/* Cfa/specialize.scm 392 */
										long BgL_objzd2classzd2numz00_2436;

										BgL_objzd2classzd2numz00_2436 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2435);
										{	/* Cfa/specialize.scm 392 */
											obj_t BgL_arg2551z00_2437;

											BgL_arg2551z00_2437 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 392 */
												obj_t BgL_arrayz00_2439;

												int BgL_offsetz00_2440;

												BgL_arrayz00_2439 = BgL_arg2551z00_2437;
												BgL_offsetz00_2440 =
													(int) (BgL_objzd2classzd2numz00_2436);
												{	/* Cfa/specialize.scm 392 */
													long BgL_offsetz00_2441;

													BgL_offsetz00_2441 =
														((long) (BgL_offsetz00_2440) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 392 */
														long BgL_modz00_2442;

														{	/* Cfa/specialize.scm 392 */
															int BgL_arg2553z00_2443;

															BgL_arg2553z00_2443 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 392 */
																long BgL_auxz00_4161;

																BgL_auxz00_4161 = (long) (BgL_arg2553z00_2443);
																BgL_modz00_2442 =
																	(BgL_offsetz00_2441 / BgL_auxz00_4161);
														}}
														{	/* Cfa/specialize.scm 392 */
															long BgL_restz00_2444;

															{	/* Cfa/specialize.scm 392 */
																int BgL_arg2552z00_2445;

																BgL_arg2552z00_2445 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 392 */
																	long BgL_auxz00_4165;

																	BgL_auxz00_4165 =
																		(long) (BgL_arg2552z00_2445);
																	BgL_restz00_2444 =
																		(BgL_offsetz00_2441 % BgL_auxz00_4165);
															}}
															{	/* Cfa/specialize.scm 392 */

																BgL_method3463z00_2434 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2439,
																		(int) (BgL_modz00_2442)),
																	(int) (BgL_restz00_2444));
								}}}}}}}}
								BgL_arg3809z00_1648 =
									PROCEDURE_ENTRY(BgL_method3463z00_2434)
									(BgL_method3463z00_2434, (obj_t) (BgL_arg3810z00_1649), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4175;

							BgL_auxz00_4175 = (BgL_nodez00_bglt) (BgL_arg3809z00_1648);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1640))->BgL_objz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4175), BUNSPEC);
					}}
					BgL_auxz00_4099 = BgL_nodez00_1640;
					return (obj_t) (BgL_auxz00_4099);
				}
			}
		}
	}



/* patch!-conditional3485 */
	obj_t BGl_patchz12zd2conditional3485zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2979, obj_t BgL_nodez00_2980)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 378 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1628;

				{	/* Cfa/specialize.scm 379 */
					BgL_conditionalz00_bglt BgL_auxz00_4180;

					BgL_nodez00_1628 = (BgL_conditionalz00_bglt) (BgL_nodez00_2980);
					{	/* Cfa/specialize.scm 380 */
						obj_t BgL_arg3797z00_1632;

						{	/* Cfa/specialize.scm 380 */
							BgL_nodez00_bglt BgL_arg3798z00_1633;

							BgL_arg3798z00_1633 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
								BgL_testz00);
							{	/* Cfa/specialize.scm 380 */
								obj_t BgL_method3463z00_2289;

								{	/* Cfa/specialize.scm 380 */
									BgL_objectz00_bglt BgL_objz00_2290;

									BgL_objz00_2290 = (BgL_objectz00_bglt) (BgL_arg3798z00_1633);
									{	/* Cfa/specialize.scm 380 */
										long BgL_objzd2classzd2numz00_2291;

										BgL_objzd2classzd2numz00_2291 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2290);
										{	/* Cfa/specialize.scm 380 */
											obj_t BgL_arg2551z00_2292;

											BgL_arg2551z00_2292 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 380 */
												obj_t BgL_arrayz00_2294;

												int BgL_offsetz00_2295;

												BgL_arrayz00_2294 = BgL_arg2551z00_2292;
												BgL_offsetz00_2295 =
													(int) (BgL_objzd2classzd2numz00_2291);
												{	/* Cfa/specialize.scm 380 */
													long BgL_offsetz00_2296;

													BgL_offsetz00_2296 =
														((long) (BgL_offsetz00_2295) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 380 */
														long BgL_modz00_2297;

														{	/* Cfa/specialize.scm 380 */
															int BgL_arg2553z00_2298;

															BgL_arg2553z00_2298 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 380 */
																long BgL_auxz00_4190;

																BgL_auxz00_4190 = (long) (BgL_arg2553z00_2298);
																BgL_modz00_2297 =
																	(BgL_offsetz00_2296 / BgL_auxz00_4190);
														}}
														{	/* Cfa/specialize.scm 380 */
															long BgL_restz00_2299;

															{	/* Cfa/specialize.scm 380 */
																int BgL_arg2552z00_2300;

																BgL_arg2552z00_2300 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 380 */
																	long BgL_auxz00_4194;

																	BgL_auxz00_4194 =
																		(long) (BgL_arg2552z00_2300);
																	BgL_restz00_2299 =
																		(BgL_offsetz00_2296 % BgL_auxz00_4194);
															}}
															{	/* Cfa/specialize.scm 380 */

																BgL_method3463z00_2289 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2294,
																		(int) (BgL_modz00_2297)),
																	(int) (BgL_restz00_2299));
								}}}}}}}}
								BgL_arg3797z00_1632 =
									PROCEDURE_ENTRY(BgL_method3463z00_2289)
									(BgL_method3463z00_2289, (obj_t) (BgL_arg3798z00_1633), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4204;

							BgL_auxz00_4204 = (BgL_nodez00_bglt) (BgL_arg3797z00_1632);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
									BgL_testz00) = ((BgL_nodez00_bglt) BgL_auxz00_4204), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 381 */
						obj_t BgL_arg3799z00_1634;

						{	/* Cfa/specialize.scm 381 */
							BgL_nodez00_bglt BgL_arg3800z00_1635;

							BgL_arg3800z00_1635 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
								BgL_truez00);
							{	/* Cfa/specialize.scm 381 */
								obj_t BgL_method3463z00_2318;

								{	/* Cfa/specialize.scm 381 */
									BgL_objectz00_bglt BgL_objz00_2319;

									BgL_objz00_2319 = (BgL_objectz00_bglt) (BgL_arg3800z00_1635);
									{	/* Cfa/specialize.scm 381 */
										long BgL_objzd2classzd2numz00_2320;

										BgL_objzd2classzd2numz00_2320 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2319);
										{	/* Cfa/specialize.scm 381 */
											obj_t BgL_arg2551z00_2321;

											BgL_arg2551z00_2321 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 381 */
												obj_t BgL_arrayz00_2323;

												int BgL_offsetz00_2324;

												BgL_arrayz00_2323 = BgL_arg2551z00_2321;
												BgL_offsetz00_2324 =
													(int) (BgL_objzd2classzd2numz00_2320);
												{	/* Cfa/specialize.scm 381 */
													long BgL_offsetz00_2325;

													BgL_offsetz00_2325 =
														((long) (BgL_offsetz00_2324) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 381 */
														long BgL_modz00_2326;

														{	/* Cfa/specialize.scm 381 */
															int BgL_arg2553z00_2327;

															BgL_arg2553z00_2327 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 381 */
																long BgL_auxz00_4216;

																BgL_auxz00_4216 = (long) (BgL_arg2553z00_2327);
																BgL_modz00_2326 =
																	(BgL_offsetz00_2325 / BgL_auxz00_4216);
														}}
														{	/* Cfa/specialize.scm 381 */
															long BgL_restz00_2328;

															{	/* Cfa/specialize.scm 381 */
																int BgL_arg2552z00_2329;

																BgL_arg2552z00_2329 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 381 */
																	long BgL_auxz00_4220;

																	BgL_auxz00_4220 =
																		(long) (BgL_arg2552z00_2329);
																	BgL_restz00_2328 =
																		(BgL_offsetz00_2325 % BgL_auxz00_4220);
															}}
															{	/* Cfa/specialize.scm 381 */

																BgL_method3463z00_2318 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2323,
																		(int) (BgL_modz00_2326)),
																	(int) (BgL_restz00_2328));
								}}}}}}}}
								BgL_arg3799z00_1634 =
									PROCEDURE_ENTRY(BgL_method3463z00_2318)
									(BgL_method3463z00_2318, (obj_t) (BgL_arg3800z00_1635), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4230;

							BgL_auxz00_4230 = (BgL_nodez00_bglt) (BgL_arg3799z00_1634);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
									BgL_truez00) = ((BgL_nodez00_bglt) BgL_auxz00_4230), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 382 */
						obj_t BgL_arg3801z00_1636;

						{	/* Cfa/specialize.scm 382 */
							BgL_nodez00_bglt BgL_arg3803z00_1637;

							BgL_arg3803z00_1637 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
								BgL_falsez00);
							{	/* Cfa/specialize.scm 382 */
								obj_t BgL_method3463z00_2347;

								{	/* Cfa/specialize.scm 382 */
									BgL_objectz00_bglt BgL_objz00_2348;

									BgL_objz00_2348 = (BgL_objectz00_bglt) (BgL_arg3803z00_1637);
									{	/* Cfa/specialize.scm 382 */
										long BgL_objzd2classzd2numz00_2349;

										BgL_objzd2classzd2numz00_2349 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2348);
										{	/* Cfa/specialize.scm 382 */
											obj_t BgL_arg2551z00_2350;

											BgL_arg2551z00_2350 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 382 */
												obj_t BgL_arrayz00_2352;

												int BgL_offsetz00_2353;

												BgL_arrayz00_2352 = BgL_arg2551z00_2350;
												BgL_offsetz00_2353 =
													(int) (BgL_objzd2classzd2numz00_2349);
												{	/* Cfa/specialize.scm 382 */
													long BgL_offsetz00_2354;

													BgL_offsetz00_2354 =
														((long) (BgL_offsetz00_2353) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 382 */
														long BgL_modz00_2355;

														{	/* Cfa/specialize.scm 382 */
															int BgL_arg2553z00_2356;

															BgL_arg2553z00_2356 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 382 */
																long BgL_auxz00_4242;

																BgL_auxz00_4242 = (long) (BgL_arg2553z00_2356);
																BgL_modz00_2355 =
																	(BgL_offsetz00_2354 / BgL_auxz00_4242);
														}}
														{	/* Cfa/specialize.scm 382 */
															long BgL_restz00_2357;

															{	/* Cfa/specialize.scm 382 */
																int BgL_arg2552z00_2358;

																BgL_arg2552z00_2358 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 382 */
																	long BgL_auxz00_4246;

																	BgL_auxz00_4246 =
																		(long) (BgL_arg2552z00_2358);
																	BgL_restz00_2357 =
																		(BgL_offsetz00_2354 % BgL_auxz00_4246);
															}}
															{	/* Cfa/specialize.scm 382 */

																BgL_method3463z00_2347 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2352,
																		(int) (BgL_modz00_2355)),
																	(int) (BgL_restz00_2357));
								}}}}}}}}
								BgL_arg3801z00_1636 =
									PROCEDURE_ENTRY(BgL_method3463z00_2347)
									(BgL_method3463z00_2347, (obj_t) (BgL_arg3803z00_1637), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4256;

							BgL_auxz00_4256 = (BgL_nodez00_bglt) (BgL_arg3801z00_1636);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1628))->
									BgL_falsez00) =
								((BgL_nodez00_bglt) BgL_auxz00_4256), BUNSPEC);
					}}
					BgL_auxz00_4180 = BgL_nodez00_1628;
					return (obj_t) (BgL_auxz00_4180);
				}
			}
		}
	}



/* patch!-setq3483 */
	obj_t BGl_patchz12zd2setq3483zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2981,
		obj_t BgL_nodez00_2982)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 369 */
			{
				BgL_setqz00_bglt BgL_nodez00_1618;

				{	/* Cfa/specialize.scm 370 */
					BgL_setqz00_bglt BgL_auxz00_4261;

					BgL_nodez00_1618 = (BgL_setqz00_bglt) (BgL_nodez00_2982);
					{	/* Cfa/specialize.scm 371 */
						obj_t BgL_arg3792z00_1622;

						{	/* Cfa/specialize.scm 371 */
							BgL_nodez00_bglt BgL_arg3793z00_1623;

							BgL_arg3793z00_1623 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1618))->BgL_valuez00);
							{	/* Cfa/specialize.scm 371 */
								obj_t BgL_method3463z00_2231;

								{	/* Cfa/specialize.scm 371 */
									BgL_objectz00_bglt BgL_objz00_2232;

									BgL_objz00_2232 = (BgL_objectz00_bglt) (BgL_arg3793z00_1623);
									{	/* Cfa/specialize.scm 371 */
										long BgL_objzd2classzd2numz00_2233;

										BgL_objzd2classzd2numz00_2233 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2232);
										{	/* Cfa/specialize.scm 371 */
											obj_t BgL_arg2551z00_2234;

											BgL_arg2551z00_2234 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 371 */
												obj_t BgL_arrayz00_2236;

												int BgL_offsetz00_2237;

												BgL_arrayz00_2236 = BgL_arg2551z00_2234;
												BgL_offsetz00_2237 =
													(int) (BgL_objzd2classzd2numz00_2233);
												{	/* Cfa/specialize.scm 371 */
													long BgL_offsetz00_2238;

													BgL_offsetz00_2238 =
														((long) (BgL_offsetz00_2237) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 371 */
														long BgL_modz00_2239;

														{	/* Cfa/specialize.scm 371 */
															int BgL_arg2553z00_2240;

															BgL_arg2553z00_2240 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 371 */
																long BgL_auxz00_4271;

																BgL_auxz00_4271 = (long) (BgL_arg2553z00_2240);
																BgL_modz00_2239 =
																	(BgL_offsetz00_2238 / BgL_auxz00_4271);
														}}
														{	/* Cfa/specialize.scm 371 */
															long BgL_restz00_2241;

															{	/* Cfa/specialize.scm 371 */
																int BgL_arg2552z00_2242;

																BgL_arg2552z00_2242 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 371 */
																	long BgL_auxz00_4275;

																	BgL_auxz00_4275 =
																		(long) (BgL_arg2552z00_2242);
																	BgL_restz00_2241 =
																		(BgL_offsetz00_2238 % BgL_auxz00_4275);
															}}
															{	/* Cfa/specialize.scm 371 */

																BgL_method3463z00_2231 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2236,
																		(int) (BgL_modz00_2239)),
																	(int) (BgL_restz00_2241));
								}}}}}}}}
								BgL_arg3792z00_1622 =
									PROCEDURE_ENTRY(BgL_method3463z00_2231)
									(BgL_method3463z00_2231, (obj_t) (BgL_arg3793z00_1623), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4285;

							BgL_auxz00_4285 = (BgL_nodez00_bglt) (BgL_arg3792z00_1622);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1618))->BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_4285), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 372 */
						obj_t BgL_arg3794z00_1624;

						{	/* Cfa/specialize.scm 372 */
							BgL_varz00_bglt BgL_arg3795z00_1625;

							BgL_arg3795z00_1625 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1618))->BgL_varz00);
							{	/* Cfa/specialize.scm 372 */
								BgL_nodez00_bglt BgL_nodez00_2259;

								BgL_nodez00_2259 = (BgL_nodez00_bglt) (BgL_arg3795z00_1625);
								{	/* Cfa/specialize.scm 372 */
									obj_t BgL_method3463z00_2260;

									{	/* Cfa/specialize.scm 372 */
										BgL_objectz00_bglt BgL_objz00_2261;

										BgL_objz00_2261 = (BgL_objectz00_bglt) (BgL_nodez00_2259);
										{	/* Cfa/specialize.scm 372 */
											long BgL_objzd2classzd2numz00_2262;

											BgL_objzd2classzd2numz00_2262 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2261);
											{	/* Cfa/specialize.scm 372 */
												obj_t BgL_arg2551z00_2263;

												BgL_arg2551z00_2263 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 372 */
													obj_t BgL_arrayz00_2265;

													int BgL_offsetz00_2266;

													BgL_arrayz00_2265 = BgL_arg2551z00_2263;
													BgL_offsetz00_2266 =
														(int) (BgL_objzd2classzd2numz00_2262);
													{	/* Cfa/specialize.scm 372 */
														long BgL_offsetz00_2267;

														BgL_offsetz00_2267 =
															((long) (BgL_offsetz00_2266) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 372 */
															long BgL_modz00_2268;

															{	/* Cfa/specialize.scm 372 */
																int BgL_arg2553z00_2269;

																BgL_arg2553z00_2269 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 372 */
																	long BgL_auxz00_4298;

																	BgL_auxz00_4298 =
																		(long) (BgL_arg2553z00_2269);
																	BgL_modz00_2268 =
																		(BgL_offsetz00_2267 / BgL_auxz00_4298);
															}}
															{	/* Cfa/specialize.scm 372 */
																long BgL_restz00_2270;

																{	/* Cfa/specialize.scm 372 */
																	int BgL_arg2552z00_2271;

																	BgL_arg2552z00_2271 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 372 */
																		long BgL_auxz00_4302;

																		BgL_auxz00_4302 =
																			(long) (BgL_arg2552z00_2271);
																		BgL_restz00_2270 =
																			(BgL_offsetz00_2267 % BgL_auxz00_4302);
																}}
																{	/* Cfa/specialize.scm 372 */

																	BgL_method3463z00_2260 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2265,
																			(int) (BgL_modz00_2268)),
																		(int) (BgL_restz00_2270));
									}}}}}}}}
									BgL_arg3794z00_1624 =
										PROCEDURE_ENTRY(BgL_method3463z00_2260)
										(BgL_method3463z00_2260, (obj_t) (BgL_nodez00_2259), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_4312;

							BgL_auxz00_4312 = (BgL_varz00_bglt) (BgL_arg3794z00_1624);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1618))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_4312), BUNSPEC);
					}}
					BgL_auxz00_4261 = BgL_nodez00_1618;
					return (obj_t) (BgL_auxz00_4261);
				}
			}
		}
	}



/* patch!-cast3481 */
	obj_t BGl_patchz12zd2cast3481zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2983,
		obj_t BgL_nodez00_2984)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 361 */
			{
				BgL_castz00_bglt BgL_nodez00_1611;

				{	/* Cfa/specialize.scm 362 */
					BgL_castz00_bglt BgL_auxz00_4317;

					BgL_nodez00_1611 = (BgL_castz00_bglt) (BgL_nodez00_2984);
					{	/* Cfa/specialize.scm 362 */
						BgL_nodez00_bglt BgL_arg3790z00_2201;

						BgL_arg3790z00_2201 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1611))->BgL_argz00);
						{	/* Cfa/specialize.scm 362 */
							obj_t BgL_method3463z00_2204;

							{	/* Cfa/specialize.scm 362 */
								BgL_objectz00_bglt BgL_objz00_2205;

								BgL_objz00_2205 = (BgL_objectz00_bglt) (BgL_arg3790z00_2201);
								{	/* Cfa/specialize.scm 362 */
									long BgL_objzd2classzd2numz00_2206;

									BgL_objzd2classzd2numz00_2206 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2205);
									{	/* Cfa/specialize.scm 362 */
										obj_t BgL_arg2551z00_2207;

										BgL_arg2551z00_2207 =
											PROCEDURE_REF(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
											(int) (((long) 1)));
										{	/* Cfa/specialize.scm 362 */
											obj_t BgL_arrayz00_2209;

											int BgL_offsetz00_2210;

											BgL_arrayz00_2209 = BgL_arg2551z00_2207;
											BgL_offsetz00_2210 =
												(int) (BgL_objzd2classzd2numz00_2206);
											{	/* Cfa/specialize.scm 362 */
												long BgL_offsetz00_2211;

												BgL_offsetz00_2211 =
													((long) (BgL_offsetz00_2210) - OBJECT_TYPE);
												{	/* Cfa/specialize.scm 362 */
													long BgL_modz00_2212;

													{	/* Cfa/specialize.scm 362 */
														int BgL_arg2553z00_2213;

														BgL_arg2553z00_2213 = (int) (((long) 8));
														{	/* Cfa/specialize.scm 362 */
															long BgL_auxz00_4327;

															BgL_auxz00_4327 = (long) (BgL_arg2553z00_2213);
															BgL_modz00_2212 =
																(BgL_offsetz00_2211 / BgL_auxz00_4327);
													}}
													{	/* Cfa/specialize.scm 362 */
														long BgL_restz00_2214;

														{	/* Cfa/specialize.scm 362 */
															int BgL_arg2552z00_2215;

															BgL_arg2552z00_2215 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 362 */
																long BgL_auxz00_4331;

																BgL_auxz00_4331 = (long) (BgL_arg2552z00_2215);
																BgL_restz00_2214 =
																	(BgL_offsetz00_2211 % BgL_auxz00_4331);
														}}
														{	/* Cfa/specialize.scm 362 */

															BgL_method3463z00_2204 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2209,
																	(int) (BgL_modz00_2212)),
																(int) (BgL_restz00_2214));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3463z00_2204) (BgL_method3463z00_2204,
								(obj_t) (BgL_arg3790z00_2201), BEOA);
					}}
					BgL_auxz00_4317 = BgL_nodez00_1611;
					return (obj_t) (BgL_auxz00_4317);
				}
			}
		}
	}



/* patch!-extern3479 */
	obj_t BGl_patchz12zd2extern3479zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2985,
		obj_t BgL_nodez00_2986)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 353 */
			{
				BgL_externz00_bglt BgL_nodez00_1604;

				{	/* Cfa/specialize.scm 354 */
					BgL_externz00_bglt BgL_auxz00_4343;

					BgL_nodez00_1604 = (BgL_externz00_bglt) (BgL_nodez00_2986);
					{	/* Cfa/specialize.scm 354 */
						obj_t BgL_arg3788z00_2198;

						BgL_arg3788z00_2198 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1604))->BgL_exprza2za2);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3788z00_2198);
					}
					BgL_auxz00_4343 = BgL_nodez00_1604;
					return (obj_t) (BgL_auxz00_4343);
				}
			}
		}
	}



/* patch!-funcall3477 */
	obj_t BGl_patchz12zd2funcall3477zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2987, obj_t BgL_nodez00_2988)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 344 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1595;

				{	/* Cfa/specialize.scm 345 */
					BgL_funcallz00_bglt BgL_auxz00_4348;

					BgL_nodez00_1595 = (BgL_funcallz00_bglt) (BgL_nodez00_2988);
					{	/* Cfa/specialize.scm 346 */
						obj_t BgL_arg3784z00_1599;

						{	/* Cfa/specialize.scm 346 */
							BgL_nodez00_bglt BgL_arg3785z00_1600;

							BgL_arg3785z00_1600 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1595))->BgL_funz00);
							{	/* Cfa/specialize.scm 346 */
								obj_t BgL_method3463z00_2169;

								{	/* Cfa/specialize.scm 346 */
									BgL_objectz00_bglt BgL_objz00_2170;

									BgL_objz00_2170 = (BgL_objectz00_bglt) (BgL_arg3785z00_1600);
									{	/* Cfa/specialize.scm 346 */
										long BgL_objzd2classzd2numz00_2171;

										BgL_objzd2classzd2numz00_2171 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2170);
										{	/* Cfa/specialize.scm 346 */
											obj_t BgL_arg2551z00_2172;

											BgL_arg2551z00_2172 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 346 */
												obj_t BgL_arrayz00_2174;

												int BgL_offsetz00_2175;

												BgL_arrayz00_2174 = BgL_arg2551z00_2172;
												BgL_offsetz00_2175 =
													(int) (BgL_objzd2classzd2numz00_2171);
												{	/* Cfa/specialize.scm 346 */
													long BgL_offsetz00_2176;

													BgL_offsetz00_2176 =
														((long) (BgL_offsetz00_2175) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 346 */
														long BgL_modz00_2177;

														{	/* Cfa/specialize.scm 346 */
															int BgL_arg2553z00_2178;

															BgL_arg2553z00_2178 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 346 */
																long BgL_auxz00_4358;

																BgL_auxz00_4358 = (long) (BgL_arg2553z00_2178);
																BgL_modz00_2177 =
																	(BgL_offsetz00_2176 / BgL_auxz00_4358);
														}}
														{	/* Cfa/specialize.scm 346 */
															long BgL_restz00_2179;

															{	/* Cfa/specialize.scm 346 */
																int BgL_arg2552z00_2180;

																BgL_arg2552z00_2180 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 346 */
																	long BgL_auxz00_4362;

																	BgL_auxz00_4362 =
																		(long) (BgL_arg2552z00_2180);
																	BgL_restz00_2179 =
																		(BgL_offsetz00_2176 % BgL_auxz00_4362);
															}}
															{	/* Cfa/specialize.scm 346 */

																BgL_method3463z00_2169 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2174,
																		(int) (BgL_modz00_2177)),
																	(int) (BgL_restz00_2179));
								}}}}}}}}
								BgL_arg3784z00_1599 =
									PROCEDURE_ENTRY(BgL_method3463z00_2169)
									(BgL_method3463z00_2169, (obj_t) (BgL_arg3785z00_1600), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4372;

							BgL_auxz00_4372 = (BgL_nodez00_bglt) (BgL_arg3784z00_1599);
							((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1595))->BgL_funz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4372), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 347 */
						obj_t BgL_arg3786z00_1601;

						BgL_arg3786z00_1601 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1595))->BgL_argsz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3786z00_1601);
					}
					BgL_auxz00_4348 = BgL_nodez00_1595;
					return (obj_t) (BgL_auxz00_4348);
				}
			}
		}
	}



/* patch!-app-ly3475 */
	obj_t BGl_patchz12zd2appzd2ly3475z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2989, obj_t BgL_nodez00_2990)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 335 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1585;

				{	/* Cfa/specialize.scm 336 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_4379;

					BgL_nodez00_1585 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2990);
					{	/* Cfa/specialize.scm 337 */
						obj_t BgL_arg3779z00_1589;

						{	/* Cfa/specialize.scm 337 */
							BgL_nodez00_bglt BgL_arg3780z00_1590;

							BgL_arg3780z00_1590 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1585))->BgL_funz00);
							{	/* Cfa/specialize.scm 337 */
								obj_t BgL_method3463z00_2111;

								{	/* Cfa/specialize.scm 337 */
									BgL_objectz00_bglt BgL_objz00_2112;

									BgL_objz00_2112 = (BgL_objectz00_bglt) (BgL_arg3780z00_1590);
									{	/* Cfa/specialize.scm 337 */
										long BgL_objzd2classzd2numz00_2113;

										BgL_objzd2classzd2numz00_2113 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2112);
										{	/* Cfa/specialize.scm 337 */
											obj_t BgL_arg2551z00_2114;

											BgL_arg2551z00_2114 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 337 */
												obj_t BgL_arrayz00_2116;

												int BgL_offsetz00_2117;

												BgL_arrayz00_2116 = BgL_arg2551z00_2114;
												BgL_offsetz00_2117 =
													(int) (BgL_objzd2classzd2numz00_2113);
												{	/* Cfa/specialize.scm 337 */
													long BgL_offsetz00_2118;

													BgL_offsetz00_2118 =
														((long) (BgL_offsetz00_2117) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 337 */
														long BgL_modz00_2119;

														{	/* Cfa/specialize.scm 337 */
															int BgL_arg2553z00_2120;

															BgL_arg2553z00_2120 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 337 */
																long BgL_auxz00_4389;

																BgL_auxz00_4389 = (long) (BgL_arg2553z00_2120);
																BgL_modz00_2119 =
																	(BgL_offsetz00_2118 / BgL_auxz00_4389);
														}}
														{	/* Cfa/specialize.scm 337 */
															long BgL_restz00_2121;

															{	/* Cfa/specialize.scm 337 */
																int BgL_arg2552z00_2122;

																BgL_arg2552z00_2122 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 337 */
																	long BgL_auxz00_4393;

																	BgL_auxz00_4393 =
																		(long) (BgL_arg2552z00_2122);
																	BgL_restz00_2121 =
																		(BgL_offsetz00_2118 % BgL_auxz00_4393);
															}}
															{	/* Cfa/specialize.scm 337 */

																BgL_method3463z00_2111 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2116,
																		(int) (BgL_modz00_2119)),
																	(int) (BgL_restz00_2121));
								}}}}}}}}
								BgL_arg3779z00_1589 =
									PROCEDURE_ENTRY(BgL_method3463z00_2111)
									(BgL_method3463z00_2111, (obj_t) (BgL_arg3780z00_1590), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4403;

							BgL_auxz00_4403 = (BgL_nodez00_bglt) (BgL_arg3779z00_1589);
							((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1585))->BgL_funz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4403), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 338 */
						obj_t BgL_arg3781z00_1591;

						{	/* Cfa/specialize.scm 338 */
							BgL_nodez00_bglt BgL_arg3782z00_1592;

							BgL_arg3782z00_1592 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1585))->BgL_argz00);
							{	/* Cfa/specialize.scm 338 */
								obj_t BgL_method3463z00_2140;

								{	/* Cfa/specialize.scm 338 */
									BgL_objectz00_bglt BgL_objz00_2141;

									BgL_objz00_2141 = (BgL_objectz00_bglt) (BgL_arg3782z00_1592);
									{	/* Cfa/specialize.scm 338 */
										long BgL_objzd2classzd2numz00_2142;

										BgL_objzd2classzd2numz00_2142 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2141);
										{	/* Cfa/specialize.scm 338 */
											obj_t BgL_arg2551z00_2143;

											BgL_arg2551z00_2143 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 338 */
												obj_t BgL_arrayz00_2145;

												int BgL_offsetz00_2146;

												BgL_arrayz00_2145 = BgL_arg2551z00_2143;
												BgL_offsetz00_2146 =
													(int) (BgL_objzd2classzd2numz00_2142);
												{	/* Cfa/specialize.scm 338 */
													long BgL_offsetz00_2147;

													BgL_offsetz00_2147 =
														((long) (BgL_offsetz00_2146) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 338 */
														long BgL_modz00_2148;

														{	/* Cfa/specialize.scm 338 */
															int BgL_arg2553z00_2149;

															BgL_arg2553z00_2149 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 338 */
																long BgL_auxz00_4415;

																BgL_auxz00_4415 = (long) (BgL_arg2553z00_2149);
																BgL_modz00_2148 =
																	(BgL_offsetz00_2147 / BgL_auxz00_4415);
														}}
														{	/* Cfa/specialize.scm 338 */
															long BgL_restz00_2150;

															{	/* Cfa/specialize.scm 338 */
																int BgL_arg2552z00_2151;

																BgL_arg2552z00_2151 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 338 */
																	long BgL_auxz00_4419;

																	BgL_auxz00_4419 =
																		(long) (BgL_arg2552z00_2151);
																	BgL_restz00_2150 =
																		(BgL_offsetz00_2147 % BgL_auxz00_4419);
															}}
															{	/* Cfa/specialize.scm 338 */

																BgL_method3463z00_2140 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2145,
																		(int) (BgL_modz00_2148)),
																	(int) (BgL_restz00_2150));
								}}}}}}}}
								BgL_arg3781z00_1591 =
									PROCEDURE_ENTRY(BgL_method3463z00_2140)
									(BgL_method3463z00_2140, (obj_t) (BgL_arg3782z00_1592), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4429;

							BgL_auxz00_4429 = (BgL_nodez00_bglt) (BgL_arg3781z00_1591);
							((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1585))->BgL_argz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4429), BUNSPEC);
					}}
					BgL_auxz00_4379 = BgL_nodez00_1585;
					return (obj_t) (BgL_auxz00_4379);
				}
			}
		}
	}



/* patch!-sequence3473 */
	obj_t BGl_patchz12zd2sequence3473zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2991, obj_t BgL_nodez00_2992)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 327 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1578;

				{	/* Cfa/specialize.scm 328 */
					BgL_sequencez00_bglt BgL_auxz00_4434;

					BgL_nodez00_1578 = (BgL_sequencez00_bglt) (BgL_nodez00_2992);
					{	/* Cfa/specialize.scm 328 */
						obj_t BgL_arg3777z00_2107;

						BgL_arg3777z00_2107 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1578))->BgL_nodesz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3777z00_2107);
					}
					BgL_auxz00_4434 = BgL_nodez00_1578;
					return (obj_t) (BgL_auxz00_4434);
				}
			}
		}
	}



/* patch!-closure3471 */
	obj_t BGl_patchz12zd2closure3471zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2993, obj_t BgL_nodez00_2994)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 321 */
			{
				BgL_closurez00_bglt BgL_nodez00_1570;

				BgL_nodez00_1570 = (BgL_closurez00_bglt) (BgL_nodez00_2994);
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string3981z00zzcfa_specializa7eza7,
					BGl_string3982z00zzcfa_specializa7eza7,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1570)));
			}
		}
	}



/* patch!-var3469 */
	obj_t BGl_patchz12zd2var3469zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2995,
		obj_t BgL_nodez00_2996)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 315 */
			return (obj_t) ((BgL_varz00_bglt) (BgL_nodez00_2996));
		}
	}



/* patch!-kwote3467 */
	obj_t BGl_patchz12zd2kwote3467zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2997,
		obj_t BgL_nodez00_2998)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 309 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2998));
		}
	}



/* patch!-atom3465 */
	obj_t BGl_patchz12zd2atom3465zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2999,
		obj_t BgL_nodez00_3000)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 303 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_3000));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 326457085),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
			return
				BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 175384950),
				BSTRING_TO_STRING(BGl_string3983z00zzcfa_specializa7eza7));
		}
	}

#ifdef __cplusplus
}
#endif
