/*===========================================================================*/
/*   (Cfa/type.scm)                                                          */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/type.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;

	typedef struct BgL_cvarz00_bgl
	{
		header_t header;
		obj_t widening;
		bool_t BgL_macrozf3zf3;
	}              *BgL_cvarz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_vallocz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2heapzd2formatz00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                *BgL_vallocz00_bglt;

	typedef struct BgL_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}              *BgL_vrefz00_bglt;

	typedef struct BgL_vsetz12z12_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vsetz12z12_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_internzd2sfunzf2cinfoz20_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		long BgL_stampz00;
	}                               *BgL_internzd2sfunzf2cinfoz20_bglt;

	typedef struct BgL_svarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		bool_t BgL_clozd2envzf3z21;
	}                      *BgL_svarzf2cinfozf2_bglt;

	typedef struct BgL_cvarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
	}                      *BgL_cvarzf2cinfozf2_bglt;

	typedef struct BgL_makezd2vectorzd2appz00_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		struct BgL_approxz00_bgl *BgL_valuezd2approxzd2;
		long BgL_lostzd2stampzd2;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		obj_t BgL_stackzd2stampzd2;
		bool_t BgL_seenzf3zf3;
	}                             *BgL_makezd2vectorzd2appz00_bglt;

	typedef struct BgL_valloczf2cinfozb2optimz40_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		struct BgL_approxz00_bgl *BgL_valuezd2approxzd2;
		long BgL_lostzd2stampzd2;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		bool_t BgL_stackablezf3zf3;
		obj_t BgL_stackzd2stampzd2;
		bool_t BgL_seenzf3zf3;
	}                                *BgL_valloczf2cinfozb2optimz40_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_vrefz00zzast_nodez00;
	extern obj_t BGl_sexitzf2Cinfozf2zzcfa_infoz00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl__typezd2variablez12zc0zzcfa_typez00(obj_t, obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2atom5197z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_typezd2nodez12zd2funcall5211z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_valloczf2Cinfozb2optimz40zzcfa_info3z00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_typez00();
	static obj_t BGl_typezd2nodez12zd2app5207z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2vsetz125217z00zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_cvarzf2Cinfozf2zzcfa_infoz00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2makezd2box5237zc0zzcfa_typez00(obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztvector_tvectorz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcfa_typez00();
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00;
	static obj_t BGl_typezd2nodez12zd2boxzd2ref5241zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2jumpzd2exzd2i5235z12zzcfa_typez00(obj_t,
		obj_t);
	static obj_t BGl_typezd2nodez12zd2cast5219z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zd2cvarzf25189ze0zzcfa_typez00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt);
	extern obj_t BGl_closurez00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zd2sexit5191z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_typezd2nodez12zd2var5201z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2vref5215z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_tvecz00zztvector_tvectorz00;
	static obj_t BGl_typezd2nodez12zd2extern5213z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2setq5221z12zzcfa_typez00(obj_t, obj_t);
	static obj_t
		BGl_typezd2variablez12zd2defau5182z12zzcfa_typez00(BgL_valuez00_bglt,
		BgL_variablez00_bglt);
	extern obj_t BGl_vsetz12z12zzast_nodez00;
	static obj_t BGl_typezd2nodez12zd2appzd2ly5209zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2condition5223z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_typez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_setzd2ze3listz31zzcfa_setz00(obj_t);
	static obj_t BGl_typezd2nodez12zc0zzcfa_typez00(BgL_nodez00_bglt);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_typezd2variablez12zd2inter5193z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_typez00 = BUNSPEC;
	static obj_t BGl_typezd2funz12zc0zzcfa_typez00(BgL_variablez00_bglt);
	static obj_t BGl_genericzd2initzd2zzcfa_typez00();
	static obj_t BGl_typezd2nodez12zd2letzd2fun5229zc0zzcfa_typez00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_typezd2settingsz12zc0zzcfa_typez00(obj_t);
	extern BgL_typez00_bglt
		BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(BgL_nodez00_bglt);
	static obj_t BGl_typezd2nodez12zd2closure5203z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_typezd2nodez12zd2letzd2var5231zc0zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_makezd2vectorzd2appz00zzcfa_info2z00;
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zc0zzcfa_typez00(BgL_valuez00_bglt,
		BgL_variablez00_bglt);
	extern BgL_typez00_bglt BGl_getzd2defaultzd2typez00zztype_cachez00();
	static obj_t BGl_typezd2nodez12zd2fail5225z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_typez00();
	static obj_t BGl_typezd2nodez12zd2kwote5199z12zzcfa_typez00(obj_t, obj_t);
	static bool_t BGl_typezd2nodeza2z12z62zzcfa_typez00(obj_t);
	static obj_t BGl_typezd2nodez12zd2setzd2exzd2it5233z12zzcfa_typez00(obj_t,
		obj_t);
	extern obj_t BGl_svarzf2Cinfozf2zzcfa_infoz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_typezd2nodez12zd2select5227z12zzcfa_typez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_tvectorzd2optimiza7ationzf3z86zzcfa_tvectorz00();
	static obj_t BGl__typezd2variablez12zd2defau5182z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2vectorza2z00zztype_cachez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl__typezd2nodez12zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2sequence5205z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2variablez12zd2svarzf25185ze0zzcfa_typez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2boxzd2setz125239zd2zzcfa_typez00(obj_t,
		obj_t);
	static obj_t BGl_typezd2variablez12zd2scnst5187z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_typez00();
	static obj_t BGl__getzd2approxzd2typez00zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl__typezd2settingsz12zc0zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_scnstzf2Cinfozf2zzcfa_infoz00;
	static obj_t BGl__typezd2nodez12zd2default5194z12zzcfa_typez00(obj_t, obj_t);
	static obj_t
		BGl_typezd2nodez12zd2default5194z12zzcfa_typez00(BgL_nodez00_bglt);
	static obj_t __cnst[4];


	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2nodeza712za75584za7, BGl__typezd2nodez12zc0zzcfa_typez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2variable5585za7, BGl__typezd2variablez12zc0zzcfa_typez00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_typezd2settingsz12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2settings5586za7, BGl__typezd2settingsz12zc0zzcfa_typez00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_typezd2nodez12zd2default5194zd2envzc0zzcfa_typez00,
		BgL_bgl__typeza7d2nodeza712za75587za7,
		BGl__typezd2nodez12zd2default5194z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5547z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75588z00,
		BGl_typezd2variablez12zd2svarzf25185ze0zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5548z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75589z00,
		BGl_typezd2variablez12zd2scnst5187z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5550z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75590z00,
		BGl_typezd2variablez12zd2sexit5191z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5549z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75591z00,
		BGl_typezd2variablez12zd2cvarzf25189ze0zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5551z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75592z00,
		BGl_typezd2variablez12zd2inter5193z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5552z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5593za7,
		BGl_typezd2nodez12zd2atom5197z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5553z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5594za7,
		BGl_typezd2nodez12zd2kwote5199z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5554z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5595za7,
		BGl_typezd2nodez12zd2var5201z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5555z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5596za7,
		BGl_typezd2nodez12zd2closure5203z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5556z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5597za7,
		BGl_typezd2nodez12zd2sequence5205z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5557z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5598za7,
		BGl_typezd2nodez12zd2app5207z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5558z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5599za7,
		BGl_typezd2nodez12zd2appzd2ly5209zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5560z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5600za7,
		BGl_typezd2nodez12zd2extern5213z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5559z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5601za7,
		BGl_typezd2nodez12zd2funcall5211z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5561z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5602za7,
		BGl_typezd2nodez12zd2vref5215z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5562z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5603za7,
		BGl_typezd2nodez12zd2vsetz125217z00zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5563z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5604za7,
		BGl_typezd2nodez12zd2cast5219z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5564z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5605za7,
		BGl_typezd2nodez12zd2setq5221z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5565z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5606za7,
		BGl_typezd2nodez12zd2condition5223z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5566z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5607za7,
		BGl_typezd2nodez12zd2fail5225z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5567z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5608za7,
		BGl_typezd2nodez12zd2select5227z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5568z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5609za7,
		BGl_typezd2nodez12zd2letzd2fun5229zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5570z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5610za7,
		BGl_typezd2nodez12zd2setzd2exzd2it5233z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5569z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5611za7,
		BGl_typezd2nodez12zd2letzd2var5231zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5571z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5612za7,
		BGl_typezd2nodez12zd2jumpzd2exzd2i5235z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5572z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5613za7,
		BGl_typezd2nodez12zd2makezd2box5237zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5573z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5614za7,
		BGl_typezd2nodez12zd2boxzd2setz125239zd2zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5574z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5615za7,
		BGl_typezd2nodez12zd2boxzd2ref5241zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5546z00zzcfa_typez00,
		BgL_bgl_string5546za700za7za7c5616za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string5575z00zzcfa_typez00,
		BgL_bgl_string5575za700za7za7c5617za7, "type-node!", 10);
	      DEFINE_STRING(BGl_string5576z00zzcfa_typez00,
		BgL_bgl_string5576za700za7za7c5618za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string5577z00zzcfa_typez00,
		BgL_bgl_string5577za700za7za7c5619za7, "cfa_type", 8);
	      DEFINE_STRING(BGl_string5578z00zzcfa_typez00,
		BgL_bgl_string5578za700za7za7c5620za7,
		"static type-node!-default5194 nothing bigloo ", 45);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2approxzd2typezd2envzd2zzcfa_typez00,
		BgL_bgl__getza7d2approxza7d25621z00,
		BGl__getzd2approxzd2typez00zzcfa_typez00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_typezd2variablez12zd2defau5182zd2envzc0zzcfa_typez00,
		BgL_bgl__typeza7d2variable5622za7,
		BGl__typezd2variablez12zd2defau5182z12zzcfa_typez00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long
		BgL_checksumz00_3188, char *BgL_fromz00_3189)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_typez00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_typez00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_typez00();
					BGl_cnstzd2initzd2zzcfa_typez00();
					BGl_importedzd2moduleszd2initz00zzcfa_typez00();
					BGl_genericzd2initzd2zzcfa_typez00();
					BGl_methodzd2initzd2zzcfa_typez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "cfa_type");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "cfa_type");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "cfa_type");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			{	/* Cfa/type.scm 15 */
				obj_t BgL_cportz00_3169;

				BgL_cportz00_3169 =
					bgl_open_input_string(BGl_string5578z00zzcfa_typez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3170;

					BgL_iz00_3170 = ((long) 3);
				BgL_loopz00_3171:
					if ((BgL_iz00_3170 == ((long) -1)))
						{	/* Cfa/type.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/type.scm 15 */
							{	/* Cfa/type.scm 15 */
								obj_t BgL_arg5580z00_3173;

								{	/* Cfa/type.scm 15 */

									{	/* Cfa/type.scm 15 */
										obj_t BgL_locationz00_3175;

										BgL_locationz00_3175 = BBOOL(((bool_t) 0));
										{	/* Cfa/type.scm 15 */

											BgL_arg5580z00_3173 =
												BGl_readz00zz__readerz00(BgL_cportz00_3169,
												BgL_locationz00_3175);
										}
									}
								}
								{	/* Cfa/type.scm 15 */
									int BgL_auxz00_3207;

									BgL_auxz00_3207 = (int) (BgL_iz00_3170);
									CNST_TABLE_SET(BgL_auxz00_3207, BgL_arg5580z00_3173);
							}}
							{	/* Cfa/type.scm 15 */
								int BgL_auxz00_3176;

								BgL_auxz00_3176 = (int) ((BgL_iz00_3170 - ((long) 1)));
								{
									long BgL_iz00_3212;

									BgL_iz00_3212 = (long) (BgL_auxz00_3176);
									BgL_iz00_3170 = BgL_iz00_3212;
									goto BgL_loopz00_3171;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return BUNSPEC;
		}
	}



/* type-settings! */
	BGL_EXPORTED_DEF obj_t BGl_typezd2settingsz12zc0zzcfa_typez00(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 38 */
			{
				obj_t BgL_l5166z00_1137;

				{	/* Cfa/type.scm 39 */
					bool_t BgL_auxz00_3214;

					BgL_l5166z00_1137 = BgL_globalsz00_1;
				BgL_zc3anonymousza35242ze3z83_1138:
					if (PAIRP(BgL_l5166z00_1137))
						{	/* Cfa/type.scm 39 */
							{	/* Cfa/type.scm 39 */
								obj_t BgL_arg5244z00_1140;

								BgL_arg5244z00_1140 = CAR(BgL_l5166z00_1137);
								BGl_typezd2funz12zc0zzcfa_typez00(
									(BgL_variablez00_bglt) (BgL_arg5244z00_1140));
							}
							{
								obj_t BgL_l5166z00_3220;

								BgL_l5166z00_3220 = CDR(BgL_l5166z00_1137);
								BgL_l5166z00_1137 = BgL_l5166z00_3220;
								goto BgL_zc3anonymousza35242ze3z83_1138;
							}
						}
					else
						{	/* Cfa/type.scm 39 */
							BgL_auxz00_3214 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_3214);
				}
			}
		}
	}



/* _type-settings! */
	obj_t BGl__typezd2settingsz12zc0zzcfa_typez00(obj_t BgL_envz00_3066,
		obj_t BgL_globalsz00_3067)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 38 */
			return BGl_typezd2settingsz12zc0zzcfa_typez00(BgL_globalsz00_3067);
		}
	}



/* type-fun! */
	obj_t BGl_typezd2funz12zc0zzcfa_typez00(BgL_variablez00_bglt BgL_varz00_2)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 44 */
			{	/* Cfa/type.scm 45 */
				BgL_valuez00_bglt BgL_funz00_1143;

				BgL_funz00_1143 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_2))->BgL_valuez00);
				{	/* Cfa/type.scm 46 */
					bool_t BgL_testz00_3225;

					{	/* Cfa/type.scm 46 */
						obj_t BgL_obj3317z00_2028;

						BgL_obj3317z00_2028 = (obj_t) (BgL_funz00_1143);
						BgL_testz00_3225 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj3317z00_2028,
							BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00);
					}
					if (BgL_testz00_3225)
						{	/* Cfa/type.scm 46 */
							{	/* Cfa/type.scm 51 */
								obj_t BgL_g5170z00_1146;

								{
									BgL_sfunz00_bglt BgL_auxz00_3228;

									BgL_auxz00_3228 = (BgL_sfunz00_bglt) (BgL_funz00_1143);
									BgL_g5170z00_1146 =
										(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3228))->BgL_argsz00);
								}
								{
									obj_t BgL_l5168z00_1148;

									BgL_l5168z00_1148 = BgL_g5170z00_1146;
								BgL_zc3anonymousza35247ze3z83_1149:
									if (PAIRP(BgL_l5168z00_1148))
										{	/* Cfa/type.scm 51 */
											{	/* Cfa/type.scm 51 */
												obj_t BgL_varz00_1151;

												BgL_varz00_1151 = CAR(BgL_l5168z00_1148);
												{	/* Cfa/type.scm 51 */
													BgL_valuez00_bglt BgL_arg5249z00_1152;

													{
														BgL_variablez00_bglt BgL_auxz00_3234;

														BgL_auxz00_3234 =
															(BgL_variablez00_bglt) (BgL_varz00_1151);
														BgL_arg5249z00_1152 =
															(((BgL_variablez00_bglt) CREF(BgL_auxz00_3234))->
															BgL_valuez00);
													}
													{	/* Cfa/type.scm 51 */
														BgL_variablez00_bglt BgL_variablez00_2034;

														BgL_variablez00_2034 =
															(BgL_variablez00_bglt) (BgL_varz00_1151);
														{	/* Cfa/type.scm 51 */
															obj_t BgL_method5183z00_2035;

															{	/* Cfa/type.scm 51 */
																BgL_objectz00_bglt BgL_objz00_2036;

																BgL_objz00_2036 =
																	(BgL_objectz00_bglt) (BgL_arg5249z00_1152);
																{	/* Cfa/type.scm 51 */
																	long BgL_objzd2classzd2numz00_2037;

																	BgL_objzd2classzd2numz00_2037 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2036);
																	{	/* Cfa/type.scm 51 */
																		obj_t BgL_arg2551z00_2038;

																		BgL_arg2551z00_2038 =
																			PROCEDURE_REF
																			(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
																			(int) (((long) 1)));
																		{	/* Cfa/type.scm 51 */
																			obj_t BgL_arrayz00_2040;

																			int BgL_offsetz00_2041;

																			BgL_arrayz00_2040 = BgL_arg2551z00_2038;
																			BgL_offsetz00_2041 =
																				(int) (BgL_objzd2classzd2numz00_2037);
																			{	/* Cfa/type.scm 51 */
																				long BgL_offsetz00_2042;

																				BgL_offsetz00_2042 =
																					(
																					(long) (BgL_offsetz00_2041) -
																					OBJECT_TYPE);
																				{	/* Cfa/type.scm 51 */
																					long BgL_modz00_2043;

																					{	/* Cfa/type.scm 51 */
																						int BgL_arg2553z00_2044;

																						BgL_arg2553z00_2044 =
																							(int) (((long) 8));
																						{	/* Cfa/type.scm 51 */
																							long BgL_auxz00_3246;

																							BgL_auxz00_3246 =
																								(long) (BgL_arg2553z00_2044);
																							BgL_modz00_2043 =
																								(BgL_offsetz00_2042 /
																								BgL_auxz00_3246);
																					}}
																					{	/* Cfa/type.scm 51 */
																						long BgL_restz00_2045;

																						{	/* Cfa/type.scm 51 */
																							int BgL_arg2552z00_2046;

																							BgL_arg2552z00_2046 =
																								(int) (((long) 8));
																							{	/* Cfa/type.scm 51 */
																								long BgL_auxz00_3250;

																								BgL_auxz00_3250 =
																									(long) (BgL_arg2552z00_2046);
																								BgL_restz00_2045 =
																									(BgL_offsetz00_2042 %
																									BgL_auxz00_3250);
																						}}
																						{	/* Cfa/type.scm 51 */

																							BgL_method5183z00_2035 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2040,
																									(int) (BgL_modz00_2043)),
																								(int) (BgL_restz00_2045));
															}}}}}}}}
															PROCEDURE_ENTRY(BgL_method5183z00_2035)
																(BgL_method5183z00_2035,
																(obj_t) (BgL_arg5249z00_1152),
																(obj_t) (BgL_variablez00_2034), BEOA);
											}}}}
											{
												obj_t BgL_l5168z00_3261;

												BgL_l5168z00_3261 = CDR(BgL_l5168z00_1148);
												BgL_l5168z00_1148 = BgL_l5168z00_3261;
												goto BgL_zc3anonymousza35247ze3z83_1149;
											}
										}
									else
										{	/* Cfa/type.scm 51 */
											((bool_t) 1);
										}
								}
							}
							{	/* Cfa/type.scm 54 */
								obj_t BgL_arg5251z00_1155;

								{
									BgL_sfunz00_bglt BgL_auxz00_3263;

									BgL_auxz00_3263 = (BgL_sfunz00_bglt) (BgL_funz00_1143);
									BgL_arg5251z00_1155 =
										(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3263))->BgL_bodyz00);
								}
								{	/* Cfa/type.scm 54 */
									BgL_nodez00_bglt BgL_nodez00_2062;

									BgL_nodez00_2062 = (BgL_nodez00_bglt) (BgL_arg5251z00_1155);
									{	/* Cfa/type.scm 54 */
										obj_t BgL_method5195z00_2063;

										{	/* Cfa/type.scm 54 */
											BgL_objectz00_bglt BgL_objz00_2064;

											BgL_objz00_2064 = (BgL_objectz00_bglt) (BgL_nodez00_2062);
											{	/* Cfa/type.scm 54 */
												long BgL_objzd2classzd2numz00_2065;

												BgL_objzd2classzd2numz00_2065 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2064);
												{	/* Cfa/type.scm 54 */
													obj_t BgL_arg2551z00_2066;

													BgL_arg2551z00_2066 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 54 */
														obj_t BgL_arrayz00_2068;

														int BgL_offsetz00_2069;

														BgL_arrayz00_2068 = BgL_arg2551z00_2066;
														BgL_offsetz00_2069 =
															(int) (BgL_objzd2classzd2numz00_2065);
														{	/* Cfa/type.scm 54 */
															long BgL_offsetz00_2070;

															BgL_offsetz00_2070 =
																((long) (BgL_offsetz00_2069) - OBJECT_TYPE);
															{	/* Cfa/type.scm 54 */
																long BgL_modz00_2071;

																{	/* Cfa/type.scm 54 */
																	int BgL_arg2553z00_2072;

																	BgL_arg2553z00_2072 = (int) (((long) 8));
																	{	/* Cfa/type.scm 54 */
																		long BgL_auxz00_3275;

																		BgL_auxz00_3275 =
																			(long) (BgL_arg2553z00_2072);
																		BgL_modz00_2071 =
																			(BgL_offsetz00_2070 / BgL_auxz00_3275);
																}}
																{	/* Cfa/type.scm 54 */
																	long BgL_restz00_2073;

																	{	/* Cfa/type.scm 54 */
																		int BgL_arg2552z00_2074;

																		BgL_arg2552z00_2074 = (int) (((long) 8));
																		{	/* Cfa/type.scm 54 */
																			long BgL_auxz00_3279;

																			BgL_auxz00_3279 =
																				(long) (BgL_arg2552z00_2074);
																			BgL_restz00_2073 =
																				(BgL_offsetz00_2070 % BgL_auxz00_3279);
																	}}
																	{	/* Cfa/type.scm 54 */

																		BgL_method5195z00_2063 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2068,
																				(int) (BgL_modz00_2071)),
																			(int) (BgL_restz00_2073));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5195z00_2063)
											(BgL_method5195z00_2063, (obj_t) (BgL_nodez00_2062),
											BEOA);
							}}}
							{	/* Cfa/type.scm 56 */
								obj_t BgL_arg5252z00_1156;

								{	/* Cfa/type.scm 56 */
									BgL_approxz00_bglt BgL_arg5253z00_1157;

									{	/* Cfa/type.scm 56 */
										BgL_internzd2sfunzf2cinfoz20_bglt BgL_obj3318z00_2088;

										BgL_obj3318z00_2088 =
											(BgL_internzd2sfunzf2cinfoz20_bglt) (BgL_funz00_1143);
										{
											obj_t BgL_auxz00_3290;

											{	/* Cfa/type.scm 56 */
												BgL_objectz00_bglt BgL_auxz00_3291;

												BgL_auxz00_3291 =
													(BgL_objectz00_bglt) (BgL_obj3318z00_2088);
												BgL_auxz00_3290 = BGL_OBJECT_WIDENING(BgL_auxz00_3291);
											}
											BgL_arg5253z00_1157 =
												(((BgL_internzd2sfunzf2cinfoz20_bglt)
													CREF(BgL_auxz00_3290))->BgL_approxz00);
									}}
									BgL_arg5252z00_1156 =
										BGl_getzd2approxzd2typez00zzcfa_typez00
										(BgL_arg5253z00_1157);
								}
								return
									BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_varz00_2,
									(BgL_typez00_bglt) (BgL_arg5252z00_1156));
							}
						}
					else
						{	/* Cfa/type.scm 46 */
							return BFALSE;
						}
				}
			}
		}
	}



/* get-approx-type */
	BGL_EXPORTED_DEF obj_t
		BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt BgL_approxz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 61 */
			{	/* Cfa/type.scm 62 */
				BgL_typez00_bglt BgL_typez00_1158;

				obj_t BgL_alloczd2listzd2_1159;

				BgL_typez00_1158 =
					(((BgL_approxz00_bglt) CREF(BgL_approxz00_3))->BgL_typez00);
				{	/* Cfa/type.scm 63 */
					obj_t BgL_arg5262z00_1178;

					BgL_arg5262z00_1178 =
						(((BgL_approxz00_bglt) CREF(BgL_approxz00_3))->BgL_allocsz00);
					BgL_alloczd2listzd2_1159 =
						BGl_setzd2ze3listz31zzcfa_setz00(BgL_arg5262z00_1178);
				}
				if (PAIRP(BgL_alloczd2listzd2_1159))
					{	/* Cfa/type.scm 65 */
						if (CBOOL(BGl_tvectorzd2optimiza7ationzf3z86zzcfa_tvectorz00()))
							{	/* Cfa/type.scm 69 */
								bool_t BgL_testz00_3306;

								{	/* Cfa/type.scm 69 */
									obj_t BgL_arg5261z00_1177;

									BgL_arg5261z00_1177 = CAR(BgL_alloczd2listzd2_1159);
									BgL_testz00_3306 =
										BGl_iszd2azf3z21zz__objectz00(BgL_arg5261z00_1177,
										BGl_makezd2vectorzd2appz00zzcfa_info2z00);
								}
								if (BgL_testz00_3306)
									{	/* Cfa/type.scm 70 */
										obj_t BgL_appz00_1163;

										BgL_appz00_1163 = CAR(BgL_alloczd2listzd2_1159);
										{	/* Cfa/type.scm 70 */
											BgL_typez00_bglt BgL_tvzd2typezd2_1164;

											BgL_tvzd2typezd2_1164 =
												BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(
												(BgL_nodez00_bglt) (BgL_appz00_1163));
											{	/* Cfa/type.scm 71 */
												BgL_approxz00_bglt BgL_valuezd2approxzd2_1165;

												{	/* Cfa/type.scm 72 */
													BgL_makezd2vectorzd2appz00_bglt BgL_obj4352z00_2095;

													BgL_obj4352z00_2095 =
														(BgL_makezd2vectorzd2appz00_bglt) (BgL_appz00_1163);
													{
														obj_t BgL_auxz00_3313;

														{	/* Cfa/type.scm 72 */
															BgL_objectz00_bglt BgL_auxz00_3314;

															BgL_auxz00_3314 =
																(BgL_objectz00_bglt) (BgL_obj4352z00_2095);
															BgL_auxz00_3313 =
																BGL_OBJECT_WIDENING(BgL_auxz00_3314);
														}
														BgL_valuezd2approxzd2_1165 =
															(((BgL_makezd2vectorzd2appz00_bglt)
																CREF(BgL_auxz00_3313))->BgL_valuezd2approxzd2);
													}
												}
												{	/* Cfa/type.scm 72 */
													BgL_typez00_bglt BgL_itemzd2typezd2_1166;

													BgL_itemzd2typezd2_1166 =
														(((BgL_approxz00_bglt)
															CREF(BgL_valuezd2approxzd2_1165))->BgL_typez00);
													{	/* Cfa/type.scm 73 */
														obj_t BgL_tvz00_1167;

														BgL_tvz00_1167 =
															(((BgL_typez00_bglt)
																CREF(BgL_itemzd2typezd2_1166))->BgL_tvectorz00);
														{	/* Cfa/type.scm 74 */

															if (BGl_iszd2azf3z21zz__objectz00(BgL_tvz00_1167,
																	BGl_typez00zztype_typez00))
																{	/* Cfa/type.scm 75 */
																	return BgL_tvz00_1167;
																}
															else
																{	/* Cfa/type.scm 75 */
																	return (obj_t) (BgL_typez00_1158);
																}
														}
													}
												}
											}
										}
									}
								else
									{	/* Cfa/type.scm 78 */
										bool_t BgL_testz00_3323;

										{	/* Cfa/type.scm 78 */
											obj_t BgL_arg5260z00_1176;

											BgL_arg5260z00_1176 = CAR(BgL_alloczd2listzd2_1159);
											BgL_testz00_3323 =
												BGl_iszd2azf3z21zz__objectz00(BgL_arg5260z00_1176,
												BGl_valloczf2Cinfozb2optimz40zzcfa_info3z00);
										}
										if (BgL_testz00_3323)
											{	/* Cfa/type.scm 79 */
												obj_t BgL_appz00_1170;

												BgL_appz00_1170 = CAR(BgL_alloczd2listzd2_1159);
												{	/* Cfa/type.scm 79 */
													BgL_typez00_bglt BgL_tvzd2typezd2_1171;

													BgL_tvzd2typezd2_1171 =
														BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(
														(BgL_nodez00_bglt) (BgL_appz00_1170));
													{	/* Cfa/type.scm 80 */
														BgL_approxz00_bglt BgL_valuezd2approxzd2_1172;

														{	/* Cfa/type.scm 81 */
															BgL_valloczf2cinfozb2optimz40_bglt
																BgL_obj5021z00_2102;
															BgL_obj5021z00_2102 =
																(BgL_valloczf2cinfozb2optimz40_bglt)
																(BgL_appz00_1170);
															{
																obj_t BgL_auxz00_3330;

																{	/* Cfa/type.scm 81 */
																	BgL_objectz00_bglt BgL_auxz00_3331;

																	BgL_auxz00_3331 =
																		(BgL_objectz00_bglt) (BgL_obj5021z00_2102);
																	BgL_auxz00_3330 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_3331);
																}
																BgL_valuezd2approxzd2_1172 =
																	(((BgL_valloczf2cinfozb2optimz40_bglt)
																		CREF(BgL_auxz00_3330))->
																	BgL_valuezd2approxzd2);
															}
														}
														{	/* Cfa/type.scm 81 */
															BgL_typez00_bglt BgL_itemzd2typezd2_1173;

															BgL_itemzd2typezd2_1173 =
																(((BgL_approxz00_bglt)
																	CREF(BgL_valuezd2approxzd2_1172))->
																BgL_typez00);
															{	/* Cfa/type.scm 82 */
																obj_t BgL_tvz00_1174;

																BgL_tvz00_1174 =
																	(((BgL_typez00_bglt)
																		CREF(BgL_itemzd2typezd2_1173))->
																	BgL_tvectorz00);
																{	/* Cfa/type.scm 83 */

																	if (BGl_iszd2azf3z21zz__objectz00
																		(BgL_tvz00_1174, BGl_typez00zztype_typez00))
																		{	/* Cfa/type.scm 84 */
																			return BgL_tvz00_1174;
																		}
																	else
																		{	/* Cfa/type.scm 84 */
																			return (obj_t) (BgL_typez00_1158);
																		}
																}
															}
														}
													}
												}
											}
										else
											{	/* Cfa/type.scm 78 */
												return (obj_t) (BgL_typez00_1158);
											}
									}
							}
						else
							{	/* Cfa/type.scm 67 */
								return (obj_t) (BgL_typez00_1158);
							}
					}
				else
					{	/* Cfa/type.scm 65 */
						return (obj_t) (BgL_typez00_1158);
					}
			}
		}
	}



/* _get-approx-type */
	obj_t BGl__getzd2approxzd2typez00zzcfa_typez00(obj_t BgL_envz00_3073,
		obj_t BgL_approxz00_3074)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 61 */
			return
				BGl_getzd2approxzd2typez00zzcfa_typez00(
				(BgL_approxz00_bglt) (BgL_approxz00_3074));
		}
	}



/* set-variable-type! */
	obj_t BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_bglt
		BgL_variablez00_18, BgL_typez00_bglt BgL_typez00_19)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 143 */
			{	/* Cfa/type.scm 144 */
				obj_t BgL_ntypez00_1179;

				BgL_typez00_bglt BgL_otypez00_1180;

				if (((obj_t) (BgL_typez00_19) == BGl_za2_za2z00zztype_cachez00))
					{	/* Cfa/type.scm 144 */
						BgL_ntypez00_1179 = BGl_za2objza2z00zztype_cachez00;
					}
				else
					{	/* Cfa/type.scm 144 */
						BgL_ntypez00_1179 = (obj_t) (BgL_typez00_19);
					}
				BgL_otypez00_1180 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->BgL_typez00);
				if (((obj_t) (BgL_otypez00_1180) == BGl_za2_za2z00zztype_cachez00))
					{	/* Cfa/type.scm 148 */
						bool_t BgL_testz00_3353;

						{	/* Cfa/type.scm 148 */
							bool_t BgL_testz00_3354;

							{	/* Cfa/type.scm 148 */
								obj_t BgL_obj1658z00_2107;

								BgL_obj1658z00_2107 = (obj_t) (BgL_variablez00_18);
								BgL_testz00_3354 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_2107,
									BGl_globalz00zzast_varz00);
							}
							if (BgL_testz00_3354)
								{	/* Cfa/type.scm 149 */
									bool_t BgL_testz00_3357;

									{	/* Cfa/type.scm 149 */
										BgL_valuez00_bglt BgL_arg5270z00_1188;

										BgL_arg5270z00_1188 =
											(((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
											BgL_valuez00);
										{	/* Cfa/type.scm 149 */
											obj_t BgL_obj1764z00_2109;

											BgL_obj1764z00_2109 = (obj_t) (BgL_arg5270z00_1188);
											BgL_testz00_3357 =
												BGl_iszd2azf3z21zz__objectz00(BgL_obj1764z00_2109,
												BGl_funz00zzast_varz00);
										}
									}
									if (BgL_testz00_3357)
										{	/* Cfa/type.scm 149 */
											BgL_testz00_3353 = ((bool_t) 0);
										}
									else
										{	/* Cfa/type.scm 149 */
											if (CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
												{	/* Cfa/type.scm 150 */
													BgL_testz00_3353 = ((bool_t) 0);
												}
											else
												{	/* Cfa/type.scm 151 */
													bool_t BgL_testz00_3363;

													{	/* Cfa/type.scm 151 */
														obj_t BgL_auxz00_3364;

														{
															BgL_typez00_bglt BgL_auxz00_3365;

															BgL_auxz00_3365 =
																(BgL_typez00_bglt) (BgL_ntypez00_1179);
															BgL_auxz00_3364 =
																(((BgL_typez00_bglt) CREF(BgL_auxz00_3365))->
																BgL_classz00);
														}
														BgL_testz00_3363 =
															(BgL_auxz00_3364 == CNST_TABLE_REF(((long) 0)));
													}
													if (BgL_testz00_3363)
														{	/* Cfa/type.scm 151 */
															BgL_testz00_3353 = ((bool_t) 0);
														}
													else
														{	/* Cfa/type.scm 151 */
															BgL_testz00_3353 = ((bool_t) 1);
														}
												}
										}
								}
							else
								{	/* Cfa/type.scm 148 */
									BgL_testz00_3353 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3353)
							{
								BgL_typez00_bglt BgL_auxz00_3370;

								BgL_auxz00_3370 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3370), BUNSPEC);
							}
						else
							{
								BgL_typez00_bglt BgL_auxz00_3373;

								BgL_auxz00_3373 = (BgL_typez00_bglt) (BgL_ntypez00_1179);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3373), BUNSPEC);
							}
					}
				else
					{	/* Cfa/type.scm 158 */
						bool_t BgL_testz00_3376;

						if (
							((obj_t) (BgL_otypez00_1180) ==
								BGl_za2vectorza2z00zztype_cachez00))
							{	/* Cfa/type.scm 158 */
								BgL_testz00_3376 =
									BGl_iszd2azf3z21zz__objectz00(BgL_ntypez00_1179,
									BGl_tvecz00zztvector_tvectorz00);
							}
						else
							{	/* Cfa/type.scm 158 */
								BgL_testz00_3376 = ((bool_t) 0);
							}
						if (BgL_testz00_3376)
							{
								BgL_typez00_bglt BgL_auxz00_3381;

								BgL_auxz00_3381 = (BgL_typez00_bglt) (BgL_ntypez00_1179);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3381), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 158 */
								return BFALSE;
							}
					}
			}
		}
	}



/* type-node*! */
	bool_t BGl_typezd2nodeza2z12z62zzcfa_typez00(obj_t BgL_nodeza2za2_45)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 354 */
			{
				obj_t BgL_l5180z00_1193;

				BgL_l5180z00_1193 = BgL_nodeza2za2_45;
			BgL_zc3anonymousza35274ze3z83_1194:
				if (PAIRP(BgL_l5180z00_1193))
					{	/* Cfa/type.scm 355 */
						{	/* Cfa/type.scm 355 */
							obj_t BgL_arg5276z00_1196;

							BgL_arg5276z00_1196 = CAR(BgL_l5180z00_1193);
							{	/* Cfa/type.scm 355 */
								BgL_nodez00_bglt BgL_nodez00_2120;

								BgL_nodez00_2120 = (BgL_nodez00_bglt) (BgL_arg5276z00_1196);
								{	/* Cfa/type.scm 355 */
									obj_t BgL_method5195z00_2121;

									{	/* Cfa/type.scm 355 */
										BgL_objectz00_bglt BgL_objz00_2122;

										BgL_objz00_2122 = (BgL_objectz00_bglt) (BgL_nodez00_2120);
										{	/* Cfa/type.scm 355 */
											long BgL_objzd2classzd2numz00_2123;

											BgL_objzd2classzd2numz00_2123 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2122);
											{	/* Cfa/type.scm 355 */
												obj_t BgL_arg2551z00_2124;

												BgL_arg2551z00_2124 =
													PROCEDURE_REF
													(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
													(int) (((long) 1)));
												{	/* Cfa/type.scm 355 */
													obj_t BgL_arrayz00_2126;

													int BgL_offsetz00_2127;

													BgL_arrayz00_2126 = BgL_arg2551z00_2124;
													BgL_offsetz00_2127 =
														(int) (BgL_objzd2classzd2numz00_2123);
													{	/* Cfa/type.scm 355 */
														long BgL_offsetz00_2128;

														BgL_offsetz00_2128 =
															((long) (BgL_offsetz00_2127) - OBJECT_TYPE);
														{	/* Cfa/type.scm 355 */
															long BgL_modz00_2129;

															{	/* Cfa/type.scm 355 */
																int BgL_arg2553z00_2130;

																BgL_arg2553z00_2130 = (int) (((long) 8));
																{	/* Cfa/type.scm 355 */
																	long BgL_auxz00_3396;

																	BgL_auxz00_3396 =
																		(long) (BgL_arg2553z00_2130);
																	BgL_modz00_2129 =
																		(BgL_offsetz00_2128 / BgL_auxz00_3396);
															}}
															{	/* Cfa/type.scm 355 */
																long BgL_restz00_2131;

																{	/* Cfa/type.scm 355 */
																	int BgL_arg2552z00_2132;

																	BgL_arg2552z00_2132 = (int) (((long) 8));
																	{	/* Cfa/type.scm 355 */
																		long BgL_auxz00_3400;

																		BgL_auxz00_3400 =
																			(long) (BgL_arg2552z00_2132);
																		BgL_restz00_2131 =
																			(BgL_offsetz00_2128 % BgL_auxz00_3400);
																}}
																{	/* Cfa/type.scm 355 */

																	BgL_method5195z00_2121 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2126,
																			(int) (BgL_modz00_2129)),
																		(int) (BgL_restz00_2131));
									}}}}}}}}
									PROCEDURE_ENTRY(BgL_method5195z00_2121)
										(BgL_method5195z00_2121, (obj_t) (BgL_nodez00_2120), BEOA);
						}}}
						{
							obj_t BgL_l5180z00_3410;

							BgL_l5180z00_3410 = CDR(BgL_l5180z00_1193);
							BgL_l5180z00_1193 = BgL_l5180z00_3410;
							goto BgL_zc3anonymousza35274ze3z83_1194;
						}
					}
				else
					{	/* Cfa/type.scm 355 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_typezd2variablez12zd2defau5182zd2envzc0zzcfa_typez00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_typezd2nodez12zd2default5194zd2envzc0zzcfa_typez00);
		}
	}



/* type-variable! */
	obj_t BGl_typezd2variablez12zc0zzcfa_typez00(BgL_valuez00_bglt BgL_valuez00_4,
		BgL_variablez00_bglt BgL_variablez00_5)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 93 */
			{	/* Cfa/type.scm 93 */
				obj_t BgL_method5183z00_2147;

				{	/* Cfa/type.scm 93 */
					BgL_objectz00_bglt BgL_objz00_2148;

					BgL_objz00_2148 = (BgL_objectz00_bglt) (BgL_valuez00_4);
					{	/* Cfa/type.scm 93 */
						long BgL_objzd2classzd2numz00_2149;

						BgL_objzd2classzd2numz00_2149 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2148);
						{	/* Cfa/type.scm 93 */
							obj_t BgL_arg2551z00_2150;

							BgL_arg2551z00_2150 =
								PROCEDURE_REF(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
								(int) (((long) 1)));
							{	/* Cfa/type.scm 93 */
								obj_t BgL_arrayz00_2152;

								int BgL_offsetz00_2153;

								BgL_arrayz00_2152 = BgL_arg2551z00_2150;
								BgL_offsetz00_2153 = (int) (BgL_objzd2classzd2numz00_2149);
								{	/* Cfa/type.scm 93 */
									long BgL_offsetz00_2154;

									BgL_offsetz00_2154 =
										((long) (BgL_offsetz00_2153) - OBJECT_TYPE);
									{	/* Cfa/type.scm 93 */
										long BgL_modz00_2155;

										{	/* Cfa/type.scm 93 */
											int BgL_arg2553z00_2156;

											BgL_arg2553z00_2156 = (int) (((long) 8));
											{	/* Cfa/type.scm 93 */
												long BgL_auxz00_3422;

												BgL_auxz00_3422 = (long) (BgL_arg2553z00_2156);
												BgL_modz00_2155 =
													(BgL_offsetz00_2154 / BgL_auxz00_3422);
										}}
										{	/* Cfa/type.scm 93 */
											long BgL_restz00_2157;

											{	/* Cfa/type.scm 93 */
												int BgL_arg2552z00_2158;

												BgL_arg2552z00_2158 = (int) (((long) 8));
												{	/* Cfa/type.scm 93 */
													long BgL_auxz00_3426;

													BgL_auxz00_3426 = (long) (BgL_arg2552z00_2158);
													BgL_restz00_2157 =
														(BgL_offsetz00_2154 % BgL_auxz00_3426);
											}}
											{	/* Cfa/type.scm 93 */

												BgL_method5183z00_2147 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2152,
														(int) (BgL_modz00_2155)), (int) (BgL_restz00_2157));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method5183z00_2147) (BgL_method5183z00_2147,
					(obj_t) (BgL_valuez00_4), (obj_t) (BgL_variablez00_5), BEOA);
			}
		}
	}



/* _type-variable! */
	obj_t BGl__typezd2variablez12zc0zzcfa_typez00(obj_t BgL_envz00_3068,
		obj_t BgL_valuez00_3069, obj_t BgL_variablez00_3070)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 93 */
			return
				BGl_typezd2variablez12zc0zzcfa_typez00(
				(BgL_valuez00_bglt) (BgL_valuez00_3069),
				(BgL_variablez00_bglt) (BgL_variablez00_3070));
		}
	}



/* type-variable!-defau5182 */
	obj_t BGl_typezd2variablez12zd2defau5182z12zzcfa_typez00(BgL_valuez00_bglt
		BgL_valuez00_6, BgL_variablez00_bglt BgL_variablez00_7)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			{	/* Cfa/type.scm 94 */
				BgL_typez00_bglt BgL_typez00_2172;

				BgL_typez00_2172 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_7))->BgL_typez00);
				{	/* Cfa/type.scm 94 */
					bool_t BgL_testz00_3441;

					{	/* Cfa/type.scm 94 */
						obj_t BgL_obj1506z00_2176;

						BgL_obj1506z00_2176 = (obj_t) (BgL_typez00_2172);
						BgL_testz00_3441 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj1506z00_2176,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_3441)
						{	/* Cfa/type.scm 94 */
							return CNST_TABLE_REF(((long) 1));
						}
					else
						{	/* Cfa/type.scm 94 */
							return
								BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_7,
								BGl_getzd2defaultzd2typez00zztype_cachez00());
						}
				}
			}
		}
	}



/* _type-variable!-defau5182 */
	obj_t BGl__typezd2variablez12zd2defau5182z12zzcfa_typez00(obj_t
		BgL_envz00_3075, obj_t BgL_valuez00_3076, obj_t BgL_variablez00_3077)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_typezd2variablez12zd2defau5182z12zzcfa_typez00(
				(BgL_valuez00_bglt) (BgL_valuez00_3076),
				(BgL_variablez00_bglt) (BgL_variablez00_3077));
		}
	}



/* type-node! */
	obj_t BGl_typezd2nodez12zc0zzcfa_typez00(BgL_nodez00_bglt BgL_nodez00_20)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 164 */
			{	/* Cfa/type.scm 164 */
				obj_t BgL_method5195z00_2177;

				{	/* Cfa/type.scm 164 */
					BgL_objectz00_bglt BgL_objz00_2178;

					BgL_objz00_2178 = (BgL_objectz00_bglt) (BgL_nodez00_20);
					{	/* Cfa/type.scm 164 */
						long BgL_objzd2classzd2numz00_2179;

						BgL_objzd2classzd2numz00_2179 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2178);
						{	/* Cfa/type.scm 164 */
							obj_t BgL_arg2551z00_2180;

							BgL_arg2551z00_2180 =
								PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
								(int) (((long) 1)));
							{	/* Cfa/type.scm 164 */
								obj_t BgL_arrayz00_2182;

								int BgL_offsetz00_2183;

								BgL_arrayz00_2182 = BgL_arg2551z00_2180;
								BgL_offsetz00_2183 = (int) (BgL_objzd2classzd2numz00_2179);
								{	/* Cfa/type.scm 164 */
									long BgL_offsetz00_2184;

									BgL_offsetz00_2184 =
										((long) (BgL_offsetz00_2183) - OBJECT_TYPE);
									{	/* Cfa/type.scm 164 */
										long BgL_modz00_2185;

										{	/* Cfa/type.scm 164 */
											int BgL_arg2553z00_2186;

											BgL_arg2553z00_2186 = (int) (((long) 8));
											{	/* Cfa/type.scm 164 */
												long BgL_auxz00_3458;

												BgL_auxz00_3458 = (long) (BgL_arg2553z00_2186);
												BgL_modz00_2185 =
													(BgL_offsetz00_2184 / BgL_auxz00_3458);
										}}
										{	/* Cfa/type.scm 164 */
											long BgL_restz00_2187;

											{	/* Cfa/type.scm 164 */
												int BgL_arg2552z00_2188;

												BgL_arg2552z00_2188 = (int) (((long) 8));
												{	/* Cfa/type.scm 164 */
													long BgL_auxz00_3462;

													BgL_auxz00_3462 = (long) (BgL_arg2552z00_2188);
													BgL_restz00_2187 =
														(BgL_offsetz00_2184 % BgL_auxz00_3462);
											}}
											{	/* Cfa/type.scm 164 */

												BgL_method5195z00_2177 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2182,
														(int) (BgL_modz00_2185)), (int) (BgL_restz00_2187));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method5195z00_2177) (BgL_method5195z00_2177,
					(obj_t) (BgL_nodez00_20), BEOA);
			}
		}
	}



/* _type-node! */
	obj_t BGl__typezd2nodez12zc0zzcfa_typez00(obj_t BgL_envz00_3071,
		obj_t BgL_nodez00_3072)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 164 */
			return
				BGl_typezd2nodez12zc0zzcfa_typez00(
				(BgL_nodez00_bglt) (BgL_nodez00_3072));
		}
	}



/* type-node!-default5194 */
	obj_t BGl_typezd2nodez12zd2default5194z12zzcfa_typez00(BgL_nodez00_bglt
		BgL_nodez00_21)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
				BGl_string5546z00zzcfa_typez00, (obj_t) (BgL_nodez00_21));
		}
	}



/* _type-node!-default5194 */
	obj_t BGl__typezd2nodez12zd2default5194z12zzcfa_typez00(obj_t BgL_envz00_3078,
		obj_t BgL_nodez00_3079)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_typezd2nodez12zd2default5194z12zzcfa_typez00(
				(BgL_nodez00_bglt) (BgL_nodez00_3079));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_svarzf2Cinfozf2zzcfa_infoz00, BGl_proc5547z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_scnstzf2Cinfozf2zzcfa_infoz00, BGl_proc5548z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_cvarzf2Cinfozf2zzcfa_infoz00, BGl_proc5549z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_sexitzf2Cinfozf2zzcfa_infoz00, BGl_proc5550z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00,
				BGl_proc5551z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_atomz00zzast_nodez00,
				BGl_proc5552z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_kwotez00zzast_nodez00,
				BGl_proc5553z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_varz00zzast_nodez00,
				BGl_proc5554z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_closurez00zzast_nodez00,
				BGl_proc5555z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_sequencez00zzast_nodez00,
				BGl_proc5556z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_appz00zzast_nodez00,
				BGl_proc5557z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc5558z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_funcallz00zzast_nodez00,
				BGl_proc5559z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_externz00zzast_nodez00,
				BGl_proc5560z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_vrefz00zzast_nodez00,
				BGl_proc5561z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_vsetz12z12zzast_nodez00,
				BGl_proc5562z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_castz00zzast_nodez00,
				BGl_proc5563z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_setqz00zzast_nodez00,
				BGl_proc5564z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc5565z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_failz00zzast_nodez00,
				BGl_proc5566z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_selectz00zzast_nodez00,
				BGl_proc5567z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc5568z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc5569z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc5570z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc5571z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc5572z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc5573z00zzcfa_typez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc5574z00zzcfa_typez00);
		}
	}



/* type-node!-box-ref5241 */
	obj_t BGl_typezd2nodez12zd2boxzd2ref5241zc0zzcfa_typez00(obj_t
		BgL_envz00_3108, obj_t BgL_nodez00_3109)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 347 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_2017;

				BgL_nodez00_2017 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3109);
				{	/* Cfa/type.scm 348 */
					BgL_varz00_bglt BgL_arg5474z00_3038;

					BgL_arg5474z00_3038 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_2017))->BgL_varz00);
					{	/* Cfa/type.scm 348 */
						BgL_nodez00_bglt BgL_nodez00_3040;

						BgL_nodez00_3040 = (BgL_nodez00_bglt) (BgL_arg5474z00_3038);
						{	/* Cfa/type.scm 348 */
							obj_t BgL_method5195z00_3041;

							{	/* Cfa/type.scm 348 */
								BgL_objectz00_bglt BgL_objz00_3042;

								BgL_objz00_3042 = (BgL_objectz00_bglt) (BgL_nodez00_3040);
								{	/* Cfa/type.scm 348 */
									long BgL_objzd2classzd2numz00_3043;

									BgL_objzd2classzd2numz00_3043 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_3042);
									{	/* Cfa/type.scm 348 */
										obj_t BgL_arg2551z00_3044;

										BgL_arg2551z00_3044 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 348 */
											obj_t BgL_arrayz00_3046;

											int BgL_offsetz00_3047;

											BgL_arrayz00_3046 = BgL_arg2551z00_3044;
											BgL_offsetz00_3047 =
												(int) (BgL_objzd2classzd2numz00_3043);
											{	/* Cfa/type.scm 348 */
												long BgL_offsetz00_3048;

												BgL_offsetz00_3048 =
													((long) (BgL_offsetz00_3047) - OBJECT_TYPE);
												{	/* Cfa/type.scm 348 */
													long BgL_modz00_3049;

													{	/* Cfa/type.scm 348 */
														int BgL_arg2553z00_3050;

														BgL_arg2553z00_3050 = (int) (((long) 8));
														{	/* Cfa/type.scm 348 */
															long BgL_auxz00_3517;

															BgL_auxz00_3517 = (long) (BgL_arg2553z00_3050);
															BgL_modz00_3049 =
																(BgL_offsetz00_3048 / BgL_auxz00_3517);
													}}
													{	/* Cfa/type.scm 348 */
														long BgL_restz00_3051;

														{	/* Cfa/type.scm 348 */
															int BgL_arg2552z00_3052;

															BgL_arg2552z00_3052 = (int) (((long) 8));
															{	/* Cfa/type.scm 348 */
																long BgL_auxz00_3521;

																BgL_auxz00_3521 = (long) (BgL_arg2552z00_3052);
																BgL_restz00_3051 =
																	(BgL_offsetz00_3048 % BgL_auxz00_3521);
														}}
														{	/* Cfa/type.scm 348 */

															BgL_method5195z00_3041 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_3046,
																	(int) (BgL_modz00_3049)),
																(int) (BgL_restz00_3051));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5195z00_3041) (BgL_method5195z00_3041,
								(obj_t) (BgL_nodez00_3040), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-box-set!5239 */
	obj_t BGl_typezd2nodez12zd2boxzd2setz125239zd2zzcfa_typez00(obj_t
		BgL_envz00_3110, obj_t BgL_nodez00_3111)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 339 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_2009;

				BgL_nodez00_2009 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3111);
				{	/* Cfa/type.scm 341 */
					BgL_varz00_bglt BgL_arg5471z00_2013;

					BgL_arg5471z00_2013 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_2009))->BgL_varz00);
					{	/* Cfa/type.scm 341 */
						BgL_nodez00_bglt BgL_nodez00_2984;

						BgL_nodez00_2984 = (BgL_nodez00_bglt) (BgL_arg5471z00_2013);
						{	/* Cfa/type.scm 341 */
							obj_t BgL_method5195z00_2985;

							{	/* Cfa/type.scm 341 */
								BgL_objectz00_bglt BgL_objz00_2986;

								BgL_objz00_2986 = (BgL_objectz00_bglt) (BgL_nodez00_2984);
								{	/* Cfa/type.scm 341 */
									long BgL_objzd2classzd2numz00_2987;

									BgL_objzd2classzd2numz00_2987 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2986);
									{	/* Cfa/type.scm 341 */
										obj_t BgL_arg2551z00_2988;

										BgL_arg2551z00_2988 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 341 */
											obj_t BgL_arrayz00_2990;

											int BgL_offsetz00_2991;

											BgL_arrayz00_2990 = BgL_arg2551z00_2988;
											BgL_offsetz00_2991 =
												(int) (BgL_objzd2classzd2numz00_2987);
											{	/* Cfa/type.scm 341 */
												long BgL_offsetz00_2992;

												BgL_offsetz00_2992 =
													((long) (BgL_offsetz00_2991) - OBJECT_TYPE);
												{	/* Cfa/type.scm 341 */
													long BgL_modz00_2993;

													{	/* Cfa/type.scm 341 */
														int BgL_arg2553z00_2994;

														BgL_arg2553z00_2994 = (int) (((long) 8));
														{	/* Cfa/type.scm 341 */
															long BgL_auxz00_3542;

															BgL_auxz00_3542 = (long) (BgL_arg2553z00_2994);
															BgL_modz00_2993 =
																(BgL_offsetz00_2992 / BgL_auxz00_3542);
													}}
													{	/* Cfa/type.scm 341 */
														long BgL_restz00_2995;

														{	/* Cfa/type.scm 341 */
															int BgL_arg2552z00_2996;

															BgL_arg2552z00_2996 = (int) (((long) 8));
															{	/* Cfa/type.scm 341 */
																long BgL_auxz00_3546;

																BgL_auxz00_3546 = (long) (BgL_arg2552z00_2996);
																BgL_restz00_2995 =
																	(BgL_offsetz00_2992 % BgL_auxz00_3546);
														}}
														{	/* Cfa/type.scm 341 */

															BgL_method5195z00_2985 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2990,
																	(int) (BgL_modz00_2993)),
																(int) (BgL_restz00_2995));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5195z00_2985) (BgL_method5195z00_2985,
								(obj_t) (BgL_nodez00_2984), BEOA);
				}}}
				{	/* Cfa/type.scm 342 */
					BgL_nodez00_bglt BgL_arg5472z00_2014;

					BgL_arg5472z00_2014 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_2009))->BgL_valuez00);
					{	/* Cfa/type.scm 342 */
						obj_t BgL_method5195z00_3012;

						{	/* Cfa/type.scm 342 */
							BgL_objectz00_bglt BgL_objz00_3013;

							BgL_objz00_3013 = (BgL_objectz00_bglt) (BgL_arg5472z00_2014);
							{	/* Cfa/type.scm 342 */
								long BgL_objzd2classzd2numz00_3014;

								BgL_objzd2classzd2numz00_3014 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_3013);
								{	/* Cfa/type.scm 342 */
									obj_t BgL_arg2551z00_3015;

									BgL_arg2551z00_3015 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 342 */
										obj_t BgL_arrayz00_3017;

										int BgL_offsetz00_3018;

										BgL_arrayz00_3017 = BgL_arg2551z00_3015;
										BgL_offsetz00_3018 = (int) (BgL_objzd2classzd2numz00_3014);
										{	/* Cfa/type.scm 342 */
											long BgL_offsetz00_3019;

											BgL_offsetz00_3019 =
												((long) (BgL_offsetz00_3018) - OBJECT_TYPE);
											{	/* Cfa/type.scm 342 */
												long BgL_modz00_3020;

												{	/* Cfa/type.scm 342 */
													int BgL_arg2553z00_3021;

													BgL_arg2553z00_3021 = (int) (((long) 8));
													{	/* Cfa/type.scm 342 */
														long BgL_auxz00_3565;

														BgL_auxz00_3565 = (long) (BgL_arg2553z00_3021);
														BgL_modz00_3020 =
															(BgL_offsetz00_3019 / BgL_auxz00_3565);
												}}
												{	/* Cfa/type.scm 342 */
													long BgL_restz00_3022;

													{	/* Cfa/type.scm 342 */
														int BgL_arg2552z00_3023;

														BgL_arg2552z00_3023 = (int) (((long) 8));
														{	/* Cfa/type.scm 342 */
															long BgL_auxz00_3569;

															BgL_auxz00_3569 = (long) (BgL_arg2552z00_3023);
															BgL_restz00_3022 =
																(BgL_offsetz00_3019 % BgL_auxz00_3569);
													}}
													{	/* Cfa/type.scm 342 */

														BgL_method5195z00_3012 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_3017,
																(int) (BgL_modz00_3020)),
															(int) (BgL_restz00_3022));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_3012) (BgL_method5195z00_3012,
							(obj_t) (BgL_arg5472z00_2014), BEOA);
					}
				}
			}
		}
	}



/* type-node!-make-box5237 */
	obj_t BGl_typezd2nodez12zd2makezd2box5237zc0zzcfa_typez00(obj_t
		BgL_envz00_3112, obj_t BgL_nodez00_3113)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 332 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_2002;

				BgL_nodez00_2002 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3113);
				{	/* Cfa/type.scm 333 */
					BgL_nodez00_bglt BgL_arg5469z00_2955;

					BgL_arg5469z00_2955 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_2002))->BgL_valuez00);
					{	/* Cfa/type.scm 333 */
						obj_t BgL_method5195z00_2958;

						{	/* Cfa/type.scm 333 */
							BgL_objectz00_bglt BgL_objz00_2959;

							BgL_objz00_2959 = (BgL_objectz00_bglt) (BgL_arg5469z00_2955);
							{	/* Cfa/type.scm 333 */
								long BgL_objzd2classzd2numz00_2960;

								BgL_objzd2classzd2numz00_2960 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2959);
								{	/* Cfa/type.scm 333 */
									obj_t BgL_arg2551z00_2961;

									BgL_arg2551z00_2961 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 333 */
										obj_t BgL_arrayz00_2963;

										int BgL_offsetz00_2964;

										BgL_arrayz00_2963 = BgL_arg2551z00_2961;
										BgL_offsetz00_2964 = (int) (BgL_objzd2classzd2numz00_2960);
										{	/* Cfa/type.scm 333 */
											long BgL_offsetz00_2965;

											BgL_offsetz00_2965 =
												((long) (BgL_offsetz00_2964) - OBJECT_TYPE);
											{	/* Cfa/type.scm 333 */
												long BgL_modz00_2966;

												{	/* Cfa/type.scm 333 */
													int BgL_arg2553z00_2967;

													BgL_arg2553z00_2967 = (int) (((long) 8));
													{	/* Cfa/type.scm 333 */
														long BgL_auxz00_3589;

														BgL_auxz00_3589 = (long) (BgL_arg2553z00_2967);
														BgL_modz00_2966 =
															(BgL_offsetz00_2965 / BgL_auxz00_3589);
												}}
												{	/* Cfa/type.scm 333 */
													long BgL_restz00_2968;

													{	/* Cfa/type.scm 333 */
														int BgL_arg2552z00_2969;

														BgL_arg2552z00_2969 = (int) (((long) 8));
														{	/* Cfa/type.scm 333 */
															long BgL_auxz00_3593;

															BgL_auxz00_3593 = (long) (BgL_arg2552z00_2969);
															BgL_restz00_2968 =
																(BgL_offsetz00_2965 % BgL_auxz00_3593);
													}}
													{	/* Cfa/type.scm 333 */

														BgL_method5195z00_2958 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2963,
																(int) (BgL_modz00_2966)),
															(int) (BgL_restz00_2968));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2958) (BgL_method5195z00_2958,
							(obj_t) (BgL_arg5469z00_2955), BEOA);
					}
				}
			}
		}
	}



/* type-node!-jump-ex-i5235 */
	obj_t BGl_typezd2nodez12zd2jumpzd2exzd2i5235z12zzcfa_typez00(obj_t
		BgL_envz00_3114, obj_t BgL_nodez00_3115)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 324 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1994;

				BgL_nodez00_1994 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3115);
				{	/* Cfa/type.scm 326 */
					BgL_nodez00_bglt BgL_arg5466z00_1998;

					BgL_arg5466z00_1998 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1994))->
						BgL_exitz00);
					{	/* Cfa/type.scm 326 */
						obj_t BgL_method5195z00_2902;

						{	/* Cfa/type.scm 326 */
							BgL_objectz00_bglt BgL_objz00_2903;

							BgL_objz00_2903 = (BgL_objectz00_bglt) (BgL_arg5466z00_1998);
							{	/* Cfa/type.scm 326 */
								long BgL_objzd2classzd2numz00_2904;

								BgL_objzd2classzd2numz00_2904 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2903);
								{	/* Cfa/type.scm 326 */
									obj_t BgL_arg2551z00_2905;

									BgL_arg2551z00_2905 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 326 */
										obj_t BgL_arrayz00_2907;

										int BgL_offsetz00_2908;

										BgL_arrayz00_2907 = BgL_arg2551z00_2905;
										BgL_offsetz00_2908 = (int) (BgL_objzd2classzd2numz00_2904);
										{	/* Cfa/type.scm 326 */
											long BgL_offsetz00_2909;

											BgL_offsetz00_2909 =
												((long) (BgL_offsetz00_2908) - OBJECT_TYPE);
											{	/* Cfa/type.scm 326 */
												long BgL_modz00_2910;

												{	/* Cfa/type.scm 326 */
													int BgL_arg2553z00_2911;

													BgL_arg2553z00_2911 = (int) (((long) 8));
													{	/* Cfa/type.scm 326 */
														long BgL_auxz00_3613;

														BgL_auxz00_3613 = (long) (BgL_arg2553z00_2911);
														BgL_modz00_2910 =
															(BgL_offsetz00_2909 / BgL_auxz00_3613);
												}}
												{	/* Cfa/type.scm 326 */
													long BgL_restz00_2912;

													{	/* Cfa/type.scm 326 */
														int BgL_arg2552z00_2913;

														BgL_arg2552z00_2913 = (int) (((long) 8));
														{	/* Cfa/type.scm 326 */
															long BgL_auxz00_3617;

															BgL_auxz00_3617 = (long) (BgL_arg2552z00_2913);
															BgL_restz00_2912 =
																(BgL_offsetz00_2909 % BgL_auxz00_3617);
													}}
													{	/* Cfa/type.scm 326 */

														BgL_method5195z00_2902 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2907,
																(int) (BgL_modz00_2910)),
															(int) (BgL_restz00_2912));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2902) (BgL_method5195z00_2902,
							(obj_t) (BgL_arg5466z00_1998), BEOA);
				}}
				{	/* Cfa/type.scm 327 */
					BgL_nodez00_bglt BgL_arg5467z00_1999;

					BgL_arg5467z00_1999 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1994))->
						BgL_valuez00);
					{	/* Cfa/type.scm 327 */
						obj_t BgL_method5195z00_2929;

						{	/* Cfa/type.scm 327 */
							BgL_objectz00_bglt BgL_objz00_2930;

							BgL_objz00_2930 = (BgL_objectz00_bglt) (BgL_arg5467z00_1999);
							{	/* Cfa/type.scm 327 */
								long BgL_objzd2classzd2numz00_2931;

								BgL_objzd2classzd2numz00_2931 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2930);
								{	/* Cfa/type.scm 327 */
									obj_t BgL_arg2551z00_2932;

									BgL_arg2551z00_2932 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 327 */
										obj_t BgL_arrayz00_2934;

										int BgL_offsetz00_2935;

										BgL_arrayz00_2934 = BgL_arg2551z00_2932;
										BgL_offsetz00_2935 = (int) (BgL_objzd2classzd2numz00_2931);
										{	/* Cfa/type.scm 327 */
											long BgL_offsetz00_2936;

											BgL_offsetz00_2936 =
												((long) (BgL_offsetz00_2935) - OBJECT_TYPE);
											{	/* Cfa/type.scm 327 */
												long BgL_modz00_2937;

												{	/* Cfa/type.scm 327 */
													int BgL_arg2553z00_2938;

													BgL_arg2553z00_2938 = (int) (((long) 8));
													{	/* Cfa/type.scm 327 */
														long BgL_auxz00_3636;

														BgL_auxz00_3636 = (long) (BgL_arg2553z00_2938);
														BgL_modz00_2937 =
															(BgL_offsetz00_2936 / BgL_auxz00_3636);
												}}
												{	/* Cfa/type.scm 327 */
													long BgL_restz00_2939;

													{	/* Cfa/type.scm 327 */
														int BgL_arg2552z00_2940;

														BgL_arg2552z00_2940 = (int) (((long) 8));
														{	/* Cfa/type.scm 327 */
															long BgL_auxz00_3640;

															BgL_auxz00_3640 = (long) (BgL_arg2552z00_2940);
															BgL_restz00_2939 =
																(BgL_offsetz00_2936 % BgL_auxz00_3640);
													}}
													{	/* Cfa/type.scm 327 */

														BgL_method5195z00_2929 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2934,
																(int) (BgL_modz00_2937)),
															(int) (BgL_restz00_2939));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2929) (BgL_method5195z00_2929,
							(obj_t) (BgL_arg5467z00_1999), BEOA);
					}
				}
			}
		}
	}



/* type-node!-set-ex-it5233 */
	obj_t BGl_typezd2nodez12zd2setzd2exzd2it5233z12zzcfa_typez00(obj_t
		BgL_envz00_3116, obj_t BgL_nodez00_3117)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 314 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1983;

				BgL_nodez00_1983 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3117);
				{	/* Cfa/type.scm 316 */
					BgL_variablez00_bglt BgL_vz00_1987;

					{	/* Cfa/type.scm 316 */
						BgL_varz00_bglt BgL_obj2061z00_2817;

						BgL_obj2061z00_2817 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1983))->
							BgL_varz00);
						BgL_vz00_1987 =
							(((BgL_varz00_bglt) CREF(BgL_obj2061z00_2817))->BgL_variablez00);
					}
					{	/* Cfa/type.scm 317 */
						BgL_valuez00_bglt BgL_arg5461z00_1988;

						BgL_arg5461z00_1988 =
							(((BgL_variablez00_bglt) CREF(BgL_vz00_1987))->BgL_valuez00);
						{	/* Cfa/type.scm 317 */
							obj_t BgL_method5183z00_2821;

							{	/* Cfa/type.scm 317 */
								BgL_objectz00_bglt BgL_objz00_2822;

								BgL_objz00_2822 = (BgL_objectz00_bglt) (BgL_arg5461z00_1988);
								{	/* Cfa/type.scm 317 */
									long BgL_objzd2classzd2numz00_2823;

									BgL_objzd2classzd2numz00_2823 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2822);
									{	/* Cfa/type.scm 317 */
										obj_t BgL_arg2551z00_2824;

										BgL_arg2551z00_2824 =
											PROCEDURE_REF
											(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 317 */
											obj_t BgL_arrayz00_2826;

											int BgL_offsetz00_2827;

											BgL_arrayz00_2826 = BgL_arg2551z00_2824;
											BgL_offsetz00_2827 =
												(int) (BgL_objzd2classzd2numz00_2823);
											{	/* Cfa/type.scm 317 */
												long BgL_offsetz00_2828;

												BgL_offsetz00_2828 =
													((long) (BgL_offsetz00_2827) - OBJECT_TYPE);
												{	/* Cfa/type.scm 317 */
													long BgL_modz00_2829;

													{	/* Cfa/type.scm 317 */
														int BgL_arg2553z00_2830;

														BgL_arg2553z00_2830 = (int) (((long) 8));
														{	/* Cfa/type.scm 317 */
															long BgL_auxz00_3662;

															BgL_auxz00_3662 = (long) (BgL_arg2553z00_2830);
															BgL_modz00_2829 =
																(BgL_offsetz00_2828 / BgL_auxz00_3662);
													}}
													{	/* Cfa/type.scm 317 */
														long BgL_restz00_2831;

														{	/* Cfa/type.scm 317 */
															int BgL_arg2552z00_2832;

															BgL_arg2552z00_2832 = (int) (((long) 8));
															{	/* Cfa/type.scm 317 */
																long BgL_auxz00_3666;

																BgL_auxz00_3666 = (long) (BgL_arg2552z00_2832);
																BgL_restz00_2831 =
																	(BgL_offsetz00_2828 % BgL_auxz00_3666);
														}}
														{	/* Cfa/type.scm 317 */

															BgL_method5183z00_2821 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2826,
																	(int) (BgL_modz00_2829)),
																(int) (BgL_restz00_2831));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5183z00_2821) (BgL_method5183z00_2821,
								(obj_t) (BgL_arg5461z00_1988), (obj_t) (BgL_vz00_1987), BEOA);
				}}}
				{	/* Cfa/type.scm 318 */
					BgL_nodez00_bglt BgL_arg5463z00_1990;

					BgL_arg5463z00_1990 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1983))->BgL_bodyz00);
					{	/* Cfa/type.scm 318 */
						obj_t BgL_method5195z00_2848;

						{	/* Cfa/type.scm 318 */
							BgL_objectz00_bglt BgL_objz00_2849;

							BgL_objz00_2849 = (BgL_objectz00_bglt) (BgL_arg5463z00_1990);
							{	/* Cfa/type.scm 318 */
								long BgL_objzd2classzd2numz00_2850;

								BgL_objzd2classzd2numz00_2850 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2849);
								{	/* Cfa/type.scm 318 */
									obj_t BgL_arg2551z00_2851;

									BgL_arg2551z00_2851 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 318 */
										obj_t BgL_arrayz00_2853;

										int BgL_offsetz00_2854;

										BgL_arrayz00_2853 = BgL_arg2551z00_2851;
										BgL_offsetz00_2854 = (int) (BgL_objzd2classzd2numz00_2850);
										{	/* Cfa/type.scm 318 */
											long BgL_offsetz00_2855;

											BgL_offsetz00_2855 =
												((long) (BgL_offsetz00_2854) - OBJECT_TYPE);
											{	/* Cfa/type.scm 318 */
												long BgL_modz00_2856;

												{	/* Cfa/type.scm 318 */
													int BgL_arg2553z00_2857;

													BgL_arg2553z00_2857 = (int) (((long) 8));
													{	/* Cfa/type.scm 318 */
														long BgL_auxz00_3686;

														BgL_auxz00_3686 = (long) (BgL_arg2553z00_2857);
														BgL_modz00_2856 =
															(BgL_offsetz00_2855 / BgL_auxz00_3686);
												}}
												{	/* Cfa/type.scm 318 */
													long BgL_restz00_2858;

													{	/* Cfa/type.scm 318 */
														int BgL_arg2552z00_2859;

														BgL_arg2552z00_2859 = (int) (((long) 8));
														{	/* Cfa/type.scm 318 */
															long BgL_auxz00_3690;

															BgL_auxz00_3690 = (long) (BgL_arg2552z00_2859);
															BgL_restz00_2858 =
																(BgL_offsetz00_2855 % BgL_auxz00_3690);
													}}
													{	/* Cfa/type.scm 318 */

														BgL_method5195z00_2848 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2853,
																(int) (BgL_modz00_2856)),
															(int) (BgL_restz00_2858));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2848) (BgL_method5195z00_2848,
							(obj_t) (BgL_arg5463z00_1990), BEOA);
				}}
				{	/* Cfa/type.scm 319 */
					BgL_varz00_bglt BgL_arg5464z00_1991;

					BgL_arg5464z00_1991 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1983))->BgL_varz00);
					{	/* Cfa/type.scm 319 */
						BgL_nodez00_bglt BgL_nodez00_2874;

						BgL_nodez00_2874 = (BgL_nodez00_bglt) (BgL_arg5464z00_1991);
						{	/* Cfa/type.scm 319 */
							obj_t BgL_method5195z00_2875;

							{	/* Cfa/type.scm 319 */
								BgL_objectz00_bglt BgL_objz00_2876;

								BgL_objz00_2876 = (BgL_objectz00_bglt) (BgL_nodez00_2874);
								{	/* Cfa/type.scm 319 */
									long BgL_objzd2classzd2numz00_2877;

									BgL_objzd2classzd2numz00_2877 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2876);
									{	/* Cfa/type.scm 319 */
										obj_t BgL_arg2551z00_2878;

										BgL_arg2551z00_2878 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 319 */
											obj_t BgL_arrayz00_2880;

											int BgL_offsetz00_2881;

											BgL_arrayz00_2880 = BgL_arg2551z00_2878;
											BgL_offsetz00_2881 =
												(int) (BgL_objzd2classzd2numz00_2877);
											{	/* Cfa/type.scm 319 */
												long BgL_offsetz00_2882;

												BgL_offsetz00_2882 =
													((long) (BgL_offsetz00_2881) - OBJECT_TYPE);
												{	/* Cfa/type.scm 319 */
													long BgL_modz00_2883;

													{	/* Cfa/type.scm 319 */
														int BgL_arg2553z00_2884;

														BgL_arg2553z00_2884 = (int) (((long) 8));
														{	/* Cfa/type.scm 319 */
															long BgL_auxz00_3710;

															BgL_auxz00_3710 = (long) (BgL_arg2553z00_2884);
															BgL_modz00_2883 =
																(BgL_offsetz00_2882 / BgL_auxz00_3710);
													}}
													{	/* Cfa/type.scm 319 */
														long BgL_restz00_2885;

														{	/* Cfa/type.scm 319 */
															int BgL_arg2552z00_2886;

															BgL_arg2552z00_2886 = (int) (((long) 8));
															{	/* Cfa/type.scm 319 */
																long BgL_auxz00_3714;

																BgL_auxz00_3714 = (long) (BgL_arg2552z00_2886);
																BgL_restz00_2885 =
																	(BgL_offsetz00_2882 % BgL_auxz00_3714);
														}}
														{	/* Cfa/type.scm 319 */

															BgL_method5195z00_2875 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2880,
																	(int) (BgL_modz00_2883)),
																(int) (BgL_restz00_2885));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5195z00_2875) (BgL_method5195z00_2875,
								(obj_t) (BgL_nodez00_2874), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-let-var5231 */
	obj_t BGl_typezd2nodez12zd2letzd2var5231zc0zzcfa_typez00(obj_t
		BgL_envz00_3118, obj_t BgL_nodez00_3119)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 301 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1965;

				BgL_nodez00_1965 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3119);
				{	/* Cfa/type.scm 303 */
					obj_t BgL_g5179z00_1969;

					BgL_g5179z00_1969 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1965))->BgL_bindingsz00);
					{
						obj_t BgL_l5177z00_1971;

						BgL_l5177z00_1971 = BgL_g5179z00_1969;
					BgL_zc3anonymousza35455ze3z83_1972:
						if (PAIRP(BgL_l5177z00_1971))
							{	/* Cfa/type.scm 303 */
								{	/* Cfa/type.scm 304 */
									obj_t BgL_bindingz00_1974;

									BgL_bindingz00_1974 = CAR(BgL_l5177z00_1971);
									{	/* Cfa/type.scm 304 */
										obj_t BgL_varz00_1975;

										obj_t BgL_valz00_1976;

										BgL_varz00_1975 = CAR(BgL_bindingz00_1974);
										BgL_valz00_1976 = CDR(BgL_bindingz00_1974);
										{	/* Cfa/type.scm 306 */
											BgL_nodez00_bglt BgL_nodez00_2734;

											BgL_nodez00_2734 = (BgL_nodez00_bglt) (BgL_valz00_1976);
											{	/* Cfa/type.scm 306 */
												obj_t BgL_method5195z00_2735;

												{	/* Cfa/type.scm 306 */
													BgL_objectz00_bglt BgL_objz00_2736;

													BgL_objz00_2736 =
														(BgL_objectz00_bglt) (BgL_nodez00_2734);
													{	/* Cfa/type.scm 306 */
														long BgL_objzd2classzd2numz00_2737;

														BgL_objzd2classzd2numz00_2737 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2736);
														{	/* Cfa/type.scm 306 */
															obj_t BgL_arg2551z00_2738;

															BgL_arg2551z00_2738 =
																PROCEDURE_REF
																(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
																(int) (((long) 1)));
															{	/* Cfa/type.scm 306 */
																obj_t BgL_arrayz00_2740;

																int BgL_offsetz00_2741;

																BgL_arrayz00_2740 = BgL_arg2551z00_2738;
																BgL_offsetz00_2741 =
																	(int) (BgL_objzd2classzd2numz00_2737);
																{	/* Cfa/type.scm 306 */
																	long BgL_offsetz00_2742;

																	BgL_offsetz00_2742 =
																		((long) (BgL_offsetz00_2741) - OBJECT_TYPE);
																	{	/* Cfa/type.scm 306 */
																		long BgL_modz00_2743;

																		{	/* Cfa/type.scm 306 */
																			int BgL_arg2553z00_2744;

																			BgL_arg2553z00_2744 = (int) (((long) 8));
																			{	/* Cfa/type.scm 306 */
																				long BgL_auxz00_3740;

																				BgL_auxz00_3740 =
																					(long) (BgL_arg2553z00_2744);
																				BgL_modz00_2743 =
																					(BgL_offsetz00_2742 /
																					BgL_auxz00_3740);
																		}}
																		{	/* Cfa/type.scm 306 */
																			long BgL_restz00_2745;

																			{	/* Cfa/type.scm 306 */
																				int BgL_arg2552z00_2746;

																				BgL_arg2552z00_2746 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 306 */
																					long BgL_auxz00_3744;

																					BgL_auxz00_3744 =
																						(long) (BgL_arg2552z00_2746);
																					BgL_restz00_2745 =
																						(BgL_offsetz00_2742 %
																						BgL_auxz00_3744);
																			}}
																			{	/* Cfa/type.scm 306 */

																				BgL_method5195z00_2735 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2740,
																						(int) (BgL_modz00_2743)),
																					(int) (BgL_restz00_2745));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method5195z00_2735)
													(BgL_method5195z00_2735, (obj_t) (BgL_nodez00_2734),
													BEOA);
										}}
										{	/* Cfa/type.scm 307 */
											BgL_valuez00_bglt BgL_arg5457z00_1977;

											{
												BgL_variablez00_bglt BgL_auxz00_3754;

												BgL_auxz00_3754 =
													(BgL_variablez00_bglt) (BgL_varz00_1975);
												BgL_arg5457z00_1977 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3754))->
													BgL_valuez00);
											}
											{	/* Cfa/type.scm 307 */
												BgL_variablez00_bglt BgL_variablez00_2762;

												BgL_variablez00_2762 =
													(BgL_variablez00_bglt) (BgL_varz00_1975);
												{	/* Cfa/type.scm 307 */
													obj_t BgL_method5183z00_2763;

													{	/* Cfa/type.scm 307 */
														BgL_objectz00_bglt BgL_objz00_2764;

														BgL_objz00_2764 =
															(BgL_objectz00_bglt) (BgL_arg5457z00_1977);
														{	/* Cfa/type.scm 307 */
															long BgL_objzd2classzd2numz00_2765;

															BgL_objzd2classzd2numz00_2765 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2764);
															{	/* Cfa/type.scm 307 */
																obj_t BgL_arg2551z00_2766;

																BgL_arg2551z00_2766 =
																	PROCEDURE_REF
																	(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
																	(int) (((long) 1)));
																{	/* Cfa/type.scm 307 */
																	obj_t BgL_arrayz00_2768;

																	int BgL_offsetz00_2769;

																	BgL_arrayz00_2768 = BgL_arg2551z00_2766;
																	BgL_offsetz00_2769 =
																		(int) (BgL_objzd2classzd2numz00_2765);
																	{	/* Cfa/type.scm 307 */
																		long BgL_offsetz00_2770;

																		BgL_offsetz00_2770 =
																			(
																			(long) (BgL_offsetz00_2769) -
																			OBJECT_TYPE);
																		{	/* Cfa/type.scm 307 */
																			long BgL_modz00_2771;

																			{	/* Cfa/type.scm 307 */
																				int BgL_arg2553z00_2772;

																				BgL_arg2553z00_2772 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 307 */
																					long BgL_auxz00_3766;

																					BgL_auxz00_3766 =
																						(long) (BgL_arg2553z00_2772);
																					BgL_modz00_2771 =
																						(BgL_offsetz00_2770 /
																						BgL_auxz00_3766);
																			}}
																			{	/* Cfa/type.scm 307 */
																				long BgL_restz00_2773;

																				{	/* Cfa/type.scm 307 */
																					int BgL_arg2552z00_2774;

																					BgL_arg2552z00_2774 =
																						(int) (((long) 8));
																					{	/* Cfa/type.scm 307 */
																						long BgL_auxz00_3770;

																						BgL_auxz00_3770 =
																							(long) (BgL_arg2552z00_2774);
																						BgL_restz00_2773 =
																							(BgL_offsetz00_2770 %
																							BgL_auxz00_3770);
																				}}
																				{	/* Cfa/type.scm 307 */

																					BgL_method5183z00_2763 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2768,
																							(int) (BgL_modz00_2771)),
																						(int) (BgL_restz00_2773));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method5183z00_2763)
														(BgL_method5183z00_2763,
														(obj_t) (BgL_arg5457z00_1977),
														(obj_t) (BgL_variablez00_2762), BEOA);
								}}}}}
								{
									obj_t BgL_l5177z00_3781;

									BgL_l5177z00_3781 = CDR(BgL_l5177z00_1971);
									BgL_l5177z00_1971 = BgL_l5177z00_3781;
									goto BgL_zc3anonymousza35455ze3z83_1972;
								}
							}
						else
							{	/* Cfa/type.scm 303 */
								((bool_t) 1);
							}
					}
				}
				{	/* Cfa/type.scm 309 */
					BgL_nodez00_bglt BgL_arg5459z00_1980;

					BgL_arg5459z00_1980 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1965))->BgL_bodyz00);
					{	/* Cfa/type.scm 309 */
						obj_t BgL_method5195z00_2791;

						{	/* Cfa/type.scm 309 */
							BgL_objectz00_bglt BgL_objz00_2792;

							BgL_objz00_2792 = (BgL_objectz00_bglt) (BgL_arg5459z00_1980);
							{	/* Cfa/type.scm 309 */
								long BgL_objzd2classzd2numz00_2793;

								BgL_objzd2classzd2numz00_2793 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2792);
								{	/* Cfa/type.scm 309 */
									obj_t BgL_arg2551z00_2794;

									BgL_arg2551z00_2794 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 309 */
										obj_t BgL_arrayz00_2796;

										int BgL_offsetz00_2797;

										BgL_arrayz00_2796 = BgL_arg2551z00_2794;
										BgL_offsetz00_2797 = (int) (BgL_objzd2classzd2numz00_2793);
										{	/* Cfa/type.scm 309 */
											long BgL_offsetz00_2798;

											BgL_offsetz00_2798 =
												((long) (BgL_offsetz00_2797) - OBJECT_TYPE);
											{	/* Cfa/type.scm 309 */
												long BgL_modz00_2799;

												{	/* Cfa/type.scm 309 */
													int BgL_arg2553z00_2800;

													BgL_arg2553z00_2800 = (int) (((long) 8));
													{	/* Cfa/type.scm 309 */
														long BgL_auxz00_3792;

														BgL_auxz00_3792 = (long) (BgL_arg2553z00_2800);
														BgL_modz00_2799 =
															(BgL_offsetz00_2798 / BgL_auxz00_3792);
												}}
												{	/* Cfa/type.scm 309 */
													long BgL_restz00_2801;

													{	/* Cfa/type.scm 309 */
														int BgL_arg2552z00_2802;

														BgL_arg2552z00_2802 = (int) (((long) 8));
														{	/* Cfa/type.scm 309 */
															long BgL_auxz00_3796;

															BgL_auxz00_3796 = (long) (BgL_arg2552z00_2802);
															BgL_restz00_2801 =
																(BgL_offsetz00_2798 % BgL_auxz00_3796);
													}}
													{	/* Cfa/type.scm 309 */

														BgL_method5195z00_2791 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2796,
																(int) (BgL_modz00_2799)),
															(int) (BgL_restz00_2801));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2791) (BgL_method5195z00_2791,
							(obj_t) (BgL_arg5459z00_1980), BEOA);
					}
				}
			}
		}
	}



/* type-node!-let-fun5229 */
	obj_t BGl_typezd2nodez12zd2letzd2fun5229zc0zzcfa_typez00(obj_t
		BgL_envz00_3120, obj_t BgL_nodez00_3121)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 293 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1950;

				BgL_nodez00_1950 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3121);
				{	/* Cfa/type.scm 295 */
					obj_t BgL_g5176z00_1954;

					BgL_g5176z00_1954 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1950))->BgL_localsz00);
					{
						obj_t BgL_l5174z00_1956;

						BgL_l5174z00_1956 = BgL_g5176z00_1954;
					BgL_zc3anonymousza35449ze3z83_1957:
						if (PAIRP(BgL_l5174z00_1956))
							{	/* Cfa/type.scm 295 */
								{	/* Cfa/type.scm 295 */
									obj_t BgL_arg5451z00_1959;

									BgL_arg5451z00_1959 = CAR(BgL_l5174z00_1956);
									BGl_typezd2funz12zc0zzcfa_typez00(
										(BgL_variablez00_bglt) (BgL_arg5451z00_1959));
								}
								{
									obj_t BgL_l5174z00_3813;

									BgL_l5174z00_3813 = CDR(BgL_l5174z00_1956);
									BgL_l5174z00_1956 = BgL_l5174z00_3813;
									goto BgL_zc3anonymousza35449ze3z83_1957;
								}
							}
						else
							{	/* Cfa/type.scm 295 */
								((bool_t) 1);
							}
					}
				}
				{	/* Cfa/type.scm 296 */
					BgL_nodez00_bglt BgL_arg5453z00_1962;

					BgL_arg5453z00_1962 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1950))->BgL_bodyz00);
					{	/* Cfa/type.scm 296 */
						obj_t BgL_method5195z00_2704;

						{	/* Cfa/type.scm 296 */
							BgL_objectz00_bglt BgL_objz00_2705;

							BgL_objz00_2705 = (BgL_objectz00_bglt) (BgL_arg5453z00_1962);
							{	/* Cfa/type.scm 296 */
								long BgL_objzd2classzd2numz00_2706;

								BgL_objzd2classzd2numz00_2706 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2705);
								{	/* Cfa/type.scm 296 */
									obj_t BgL_arg2551z00_2707;

									BgL_arg2551z00_2707 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 296 */
										obj_t BgL_arrayz00_2709;

										int BgL_offsetz00_2710;

										BgL_arrayz00_2709 = BgL_arg2551z00_2707;
										BgL_offsetz00_2710 = (int) (BgL_objzd2classzd2numz00_2706);
										{	/* Cfa/type.scm 296 */
											long BgL_offsetz00_2711;

											BgL_offsetz00_2711 =
												((long) (BgL_offsetz00_2710) - OBJECT_TYPE);
											{	/* Cfa/type.scm 296 */
												long BgL_modz00_2712;

												{	/* Cfa/type.scm 296 */
													int BgL_arg2553z00_2713;

													BgL_arg2553z00_2713 = (int) (((long) 8));
													{	/* Cfa/type.scm 296 */
														long BgL_auxz00_3824;

														BgL_auxz00_3824 = (long) (BgL_arg2553z00_2713);
														BgL_modz00_2712 =
															(BgL_offsetz00_2711 / BgL_auxz00_3824);
												}}
												{	/* Cfa/type.scm 296 */
													long BgL_restz00_2714;

													{	/* Cfa/type.scm 296 */
														int BgL_arg2552z00_2715;

														BgL_arg2552z00_2715 = (int) (((long) 8));
														{	/* Cfa/type.scm 296 */
															long BgL_auxz00_3828;

															BgL_auxz00_3828 = (long) (BgL_arg2552z00_2715);
															BgL_restz00_2714 =
																(BgL_offsetz00_2711 % BgL_auxz00_3828);
													}}
													{	/* Cfa/type.scm 296 */

														BgL_method5195z00_2704 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2709,
																(int) (BgL_modz00_2712)),
															(int) (BgL_restz00_2714));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2704) (BgL_method5195z00_2704,
							(obj_t) (BgL_arg5453z00_1962), BEOA);
					}
				}
			}
		}
	}



/* type-node!-select5227 */
	obj_t BGl_typezd2nodez12zd2select5227z12zzcfa_typez00(obj_t BgL_envz00_3122,
		obj_t BgL_nodez00_3123)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 283 */
			{
				BgL_selectz00_bglt BgL_nodez00_1934;

				{	/* Cfa/type.scm 284 */
					bool_t BgL_auxz00_3839;

					BgL_nodez00_1934 = (BgL_selectz00_bglt) (BgL_nodez00_3123);
					{	/* Cfa/type.scm 285 */
						BgL_nodez00_bglt BgL_arg5443z00_1938;

						BgL_arg5443z00_1938 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1934))->BgL_testz00);
						{	/* Cfa/type.scm 285 */
							obj_t BgL_method5195z00_2642;

							{	/* Cfa/type.scm 285 */
								BgL_objectz00_bglt BgL_objz00_2643;

								BgL_objz00_2643 = (BgL_objectz00_bglt) (BgL_arg5443z00_1938);
								{	/* Cfa/type.scm 285 */
									long BgL_objzd2classzd2numz00_2644;

									BgL_objzd2classzd2numz00_2644 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2643);
									{	/* Cfa/type.scm 285 */
										obj_t BgL_arg2551z00_2645;

										BgL_arg2551z00_2645 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 285 */
											obj_t BgL_arrayz00_2647;

											int BgL_offsetz00_2648;

											BgL_arrayz00_2647 = BgL_arg2551z00_2645;
											BgL_offsetz00_2648 =
												(int) (BgL_objzd2classzd2numz00_2644);
											{	/* Cfa/type.scm 285 */
												long BgL_offsetz00_2649;

												BgL_offsetz00_2649 =
													((long) (BgL_offsetz00_2648) - OBJECT_TYPE);
												{	/* Cfa/type.scm 285 */
													long BgL_modz00_2650;

													{	/* Cfa/type.scm 285 */
														int BgL_arg2553z00_2651;

														BgL_arg2553z00_2651 = (int) (((long) 8));
														{	/* Cfa/type.scm 285 */
															long BgL_auxz00_3849;

															BgL_auxz00_3849 = (long) (BgL_arg2553z00_2651);
															BgL_modz00_2650 =
																(BgL_offsetz00_2649 / BgL_auxz00_3849);
													}}
													{	/* Cfa/type.scm 285 */
														long BgL_restz00_2652;

														{	/* Cfa/type.scm 285 */
															int BgL_arg2552z00_2653;

															BgL_arg2552z00_2653 = (int) (((long) 8));
															{	/* Cfa/type.scm 285 */
																long BgL_auxz00_3853;

																BgL_auxz00_3853 = (long) (BgL_arg2552z00_2653);
																BgL_restz00_2652 =
																	(BgL_offsetz00_2649 % BgL_auxz00_3853);
														}}
														{	/* Cfa/type.scm 285 */

															BgL_method5195z00_2642 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2647,
																	(int) (BgL_modz00_2650)),
																(int) (BgL_restz00_2652));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5195z00_2642) (BgL_method5195z00_2642,
								(obj_t) (BgL_arg5443z00_1938), BEOA);
					}}
					{	/* Cfa/type.scm 286 */
						obj_t BgL_g5173z00_1939;

						BgL_g5173z00_1939 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1934))->BgL_clausesz00);
						{
							obj_t BgL_l5171z00_1941;

							BgL_l5171z00_1941 = BgL_g5173z00_1939;
						BgL_zc3anonymousza35444ze3z83_1942:
							if (PAIRP(BgL_l5171z00_1941))
								{	/* Cfa/type.scm 286 */
									{	/* Cfa/type.scm 287 */
										obj_t BgL_clausez00_1944;

										BgL_clausez00_1944 = CAR(BgL_l5171z00_1941);
										{	/* Cfa/type.scm 287 */
											obj_t BgL_arg5446z00_1945;

											BgL_arg5446z00_1945 = CDR(BgL_clausez00_1944);
											{	/* Cfa/type.scm 287 */
												BgL_nodez00_bglt BgL_nodez00_2671;

												BgL_nodez00_2671 =
													(BgL_nodez00_bglt) (BgL_arg5446z00_1945);
												{	/* Cfa/type.scm 287 */
													obj_t BgL_method5195z00_2672;

													{	/* Cfa/type.scm 287 */
														BgL_objectz00_bglt BgL_objz00_2673;

														BgL_objz00_2673 =
															(BgL_objectz00_bglt) (BgL_nodez00_2671);
														{	/* Cfa/type.scm 287 */
															long BgL_objzd2classzd2numz00_2674;

															BgL_objzd2classzd2numz00_2674 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2673);
															{	/* Cfa/type.scm 287 */
																obj_t BgL_arg2551z00_2675;

																BgL_arg2551z00_2675 =
																	PROCEDURE_REF
																	(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
																	(int) (((long) 1)));
																{	/* Cfa/type.scm 287 */
																	obj_t BgL_arrayz00_2677;

																	int BgL_offsetz00_2678;

																	BgL_arrayz00_2677 = BgL_arg2551z00_2675;
																	BgL_offsetz00_2678 =
																		(int) (BgL_objzd2classzd2numz00_2674);
																	{	/* Cfa/type.scm 287 */
																		long BgL_offsetz00_2679;

																		BgL_offsetz00_2679 =
																			(
																			(long) (BgL_offsetz00_2678) -
																			OBJECT_TYPE);
																		{	/* Cfa/type.scm 287 */
																			long BgL_modz00_2680;

																			{	/* Cfa/type.scm 287 */
																				int BgL_arg2553z00_2681;

																				BgL_arg2553z00_2681 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 287 */
																					long BgL_auxz00_3877;

																					BgL_auxz00_3877 =
																						(long) (BgL_arg2553z00_2681);
																					BgL_modz00_2680 =
																						(BgL_offsetz00_2679 /
																						BgL_auxz00_3877);
																			}}
																			{	/* Cfa/type.scm 287 */
																				long BgL_restz00_2682;

																				{	/* Cfa/type.scm 287 */
																					int BgL_arg2552z00_2683;

																					BgL_arg2552z00_2683 =
																						(int) (((long) 8));
																					{	/* Cfa/type.scm 287 */
																						long BgL_auxz00_3881;

																						BgL_auxz00_3881 =
																							(long) (BgL_arg2552z00_2683);
																						BgL_restz00_2682 =
																							(BgL_offsetz00_2679 %
																							BgL_auxz00_3881);
																				}}
																				{	/* Cfa/type.scm 287 */

																					BgL_method5195z00_2672 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2677,
																							(int) (BgL_modz00_2680)),
																						(int) (BgL_restz00_2682));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method5195z00_2672)
														(BgL_method5195z00_2672, (obj_t) (BgL_nodez00_2671),
														BEOA);
									}}}}
									{
										obj_t BgL_l5171z00_3891;

										BgL_l5171z00_3891 = CDR(BgL_l5171z00_1941);
										BgL_l5171z00_1941 = BgL_l5171z00_3891;
										goto BgL_zc3anonymousza35444ze3z83_1942;
									}
								}
							else
								{	/* Cfa/type.scm 286 */
									BgL_auxz00_3839 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3839);
				}
			}
		}
	}



/* type-node!-fail5225 */
	obj_t BGl_typezd2nodez12zd2fail5225z12zzcfa_typez00(obj_t BgL_envz00_3124,
		obj_t BgL_nodez00_3125)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 274 */
			{
				BgL_failz00_bglt BgL_nodez00_1925;

				BgL_nodez00_1925 = (BgL_failz00_bglt) (BgL_nodez00_3125);
				{	/* Cfa/type.scm 276 */
					BgL_nodez00_bglt BgL_arg5439z00_1929;

					BgL_arg5439z00_1929 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1925))->BgL_procz00);
					{	/* Cfa/type.scm 276 */
						obj_t BgL_method5195z00_2561;

						{	/* Cfa/type.scm 276 */
							BgL_objectz00_bglt BgL_objz00_2562;

							BgL_objz00_2562 = (BgL_objectz00_bglt) (BgL_arg5439z00_1929);
							{	/* Cfa/type.scm 276 */
								long BgL_objzd2classzd2numz00_2563;

								BgL_objzd2classzd2numz00_2563 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2562);
								{	/* Cfa/type.scm 276 */
									obj_t BgL_arg2551z00_2564;

									BgL_arg2551z00_2564 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 276 */
										obj_t BgL_arrayz00_2566;

										int BgL_offsetz00_2567;

										BgL_arrayz00_2566 = BgL_arg2551z00_2564;
										BgL_offsetz00_2567 = (int) (BgL_objzd2classzd2numz00_2563);
										{	/* Cfa/type.scm 276 */
											long BgL_offsetz00_2568;

											BgL_offsetz00_2568 =
												((long) (BgL_offsetz00_2567) - OBJECT_TYPE);
											{	/* Cfa/type.scm 276 */
												long BgL_modz00_2569;

												{	/* Cfa/type.scm 276 */
													int BgL_arg2553z00_2570;

													BgL_arg2553z00_2570 = (int) (((long) 8));
													{	/* Cfa/type.scm 276 */
														long BgL_auxz00_3904;

														BgL_auxz00_3904 = (long) (BgL_arg2553z00_2570);
														BgL_modz00_2569 =
															(BgL_offsetz00_2568 / BgL_auxz00_3904);
												}}
												{	/* Cfa/type.scm 276 */
													long BgL_restz00_2571;

													{	/* Cfa/type.scm 276 */
														int BgL_arg2552z00_2572;

														BgL_arg2552z00_2572 = (int) (((long) 8));
														{	/* Cfa/type.scm 276 */
															long BgL_auxz00_3908;

															BgL_auxz00_3908 = (long) (BgL_arg2552z00_2572);
															BgL_restz00_2571 =
																(BgL_offsetz00_2568 % BgL_auxz00_3908);
													}}
													{	/* Cfa/type.scm 276 */

														BgL_method5195z00_2561 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2566,
																(int) (BgL_modz00_2569)),
															(int) (BgL_restz00_2571));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2561) (BgL_method5195z00_2561,
							(obj_t) (BgL_arg5439z00_1929), BEOA);
				}}
				{	/* Cfa/type.scm 277 */
					BgL_nodez00_bglt BgL_arg5440z00_1930;

					BgL_arg5440z00_1930 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1925))->BgL_msgz00);
					{	/* Cfa/type.scm 277 */
						obj_t BgL_method5195z00_2588;

						{	/* Cfa/type.scm 277 */
							BgL_objectz00_bglt BgL_objz00_2589;

							BgL_objz00_2589 = (BgL_objectz00_bglt) (BgL_arg5440z00_1930);
							{	/* Cfa/type.scm 277 */
								long BgL_objzd2classzd2numz00_2590;

								BgL_objzd2classzd2numz00_2590 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2589);
								{	/* Cfa/type.scm 277 */
									obj_t BgL_arg2551z00_2591;

									BgL_arg2551z00_2591 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 277 */
										obj_t BgL_arrayz00_2593;

										int BgL_offsetz00_2594;

										BgL_arrayz00_2593 = BgL_arg2551z00_2591;
										BgL_offsetz00_2594 = (int) (BgL_objzd2classzd2numz00_2590);
										{	/* Cfa/type.scm 277 */
											long BgL_offsetz00_2595;

											BgL_offsetz00_2595 =
												((long) (BgL_offsetz00_2594) - OBJECT_TYPE);
											{	/* Cfa/type.scm 277 */
												long BgL_modz00_2596;

												{	/* Cfa/type.scm 277 */
													int BgL_arg2553z00_2597;

													BgL_arg2553z00_2597 = (int) (((long) 8));
													{	/* Cfa/type.scm 277 */
														long BgL_auxz00_3927;

														BgL_auxz00_3927 = (long) (BgL_arg2553z00_2597);
														BgL_modz00_2596 =
															(BgL_offsetz00_2595 / BgL_auxz00_3927);
												}}
												{	/* Cfa/type.scm 277 */
													long BgL_restz00_2598;

													{	/* Cfa/type.scm 277 */
														int BgL_arg2552z00_2599;

														BgL_arg2552z00_2599 = (int) (((long) 8));
														{	/* Cfa/type.scm 277 */
															long BgL_auxz00_3931;

															BgL_auxz00_3931 = (long) (BgL_arg2552z00_2599);
															BgL_restz00_2598 =
																(BgL_offsetz00_2595 % BgL_auxz00_3931);
													}}
													{	/* Cfa/type.scm 277 */

														BgL_method5195z00_2588 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2593,
																(int) (BgL_modz00_2596)),
															(int) (BgL_restz00_2598));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2588) (BgL_method5195z00_2588,
							(obj_t) (BgL_arg5440z00_1930), BEOA);
				}}
				{	/* Cfa/type.scm 278 */
					BgL_nodez00_bglt BgL_arg5441z00_1931;

					BgL_arg5441z00_1931 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1925))->BgL_objz00);
					{	/* Cfa/type.scm 278 */
						obj_t BgL_method5195z00_2615;

						{	/* Cfa/type.scm 278 */
							BgL_objectz00_bglt BgL_objz00_2616;

							BgL_objz00_2616 = (BgL_objectz00_bglt) (BgL_arg5441z00_1931);
							{	/* Cfa/type.scm 278 */
								long BgL_objzd2classzd2numz00_2617;

								BgL_objzd2classzd2numz00_2617 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2616);
								{	/* Cfa/type.scm 278 */
									obj_t BgL_arg2551z00_2618;

									BgL_arg2551z00_2618 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 278 */
										obj_t BgL_arrayz00_2620;

										int BgL_offsetz00_2621;

										BgL_arrayz00_2620 = BgL_arg2551z00_2618;
										BgL_offsetz00_2621 = (int) (BgL_objzd2classzd2numz00_2617);
										{	/* Cfa/type.scm 278 */
											long BgL_offsetz00_2622;

											BgL_offsetz00_2622 =
												((long) (BgL_offsetz00_2621) - OBJECT_TYPE);
											{	/* Cfa/type.scm 278 */
												long BgL_modz00_2623;

												{	/* Cfa/type.scm 278 */
													int BgL_arg2553z00_2624;

													BgL_arg2553z00_2624 = (int) (((long) 8));
													{	/* Cfa/type.scm 278 */
														long BgL_auxz00_3950;

														BgL_auxz00_3950 = (long) (BgL_arg2553z00_2624);
														BgL_modz00_2623 =
															(BgL_offsetz00_2622 / BgL_auxz00_3950);
												}}
												{	/* Cfa/type.scm 278 */
													long BgL_restz00_2625;

													{	/* Cfa/type.scm 278 */
														int BgL_arg2552z00_2626;

														BgL_arg2552z00_2626 = (int) (((long) 8));
														{	/* Cfa/type.scm 278 */
															long BgL_auxz00_3954;

															BgL_auxz00_3954 = (long) (BgL_arg2552z00_2626);
															BgL_restz00_2625 =
																(BgL_offsetz00_2622 % BgL_auxz00_3954);
													}}
													{	/* Cfa/type.scm 278 */

														BgL_method5195z00_2615 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2620,
																(int) (BgL_modz00_2623)),
															(int) (BgL_restz00_2625));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2615) (BgL_method5195z00_2615,
							(obj_t) (BgL_arg5441z00_1931), BEOA);
					}
				}
			}
		}
	}



/* type-node!-condition5223 */
	obj_t BGl_typezd2nodez12zd2condition5223z12zzcfa_typez00(obj_t
		BgL_envz00_3126, obj_t BgL_nodez00_3127)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 265 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1916;

				BgL_nodez00_1916 = (BgL_conditionalz00_bglt) (BgL_nodez00_3127);
				{	/* Cfa/type.scm 267 */
					BgL_nodez00_bglt BgL_arg5435z00_1920;

					BgL_arg5435z00_1920 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1916))->BgL_testz00);
					{	/* Cfa/type.scm 267 */
						obj_t BgL_method5195z00_2480;

						{	/* Cfa/type.scm 267 */
							BgL_objectz00_bglt BgL_objz00_2481;

							BgL_objz00_2481 = (BgL_objectz00_bglt) (BgL_arg5435z00_1920);
							{	/* Cfa/type.scm 267 */
								long BgL_objzd2classzd2numz00_2482;

								BgL_objzd2classzd2numz00_2482 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2481);
								{	/* Cfa/type.scm 267 */
									obj_t BgL_arg2551z00_2483;

									BgL_arg2551z00_2483 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 267 */
										obj_t BgL_arrayz00_2485;

										int BgL_offsetz00_2486;

										BgL_arrayz00_2485 = BgL_arg2551z00_2483;
										BgL_offsetz00_2486 = (int) (BgL_objzd2classzd2numz00_2482);
										{	/* Cfa/type.scm 267 */
											long BgL_offsetz00_2487;

											BgL_offsetz00_2487 =
												((long) (BgL_offsetz00_2486) - OBJECT_TYPE);
											{	/* Cfa/type.scm 267 */
												long BgL_modz00_2488;

												{	/* Cfa/type.scm 267 */
													int BgL_arg2553z00_2489;

													BgL_arg2553z00_2489 = (int) (((long) 8));
													{	/* Cfa/type.scm 267 */
														long BgL_auxz00_3974;

														BgL_auxz00_3974 = (long) (BgL_arg2553z00_2489);
														BgL_modz00_2488 =
															(BgL_offsetz00_2487 / BgL_auxz00_3974);
												}}
												{	/* Cfa/type.scm 267 */
													long BgL_restz00_2490;

													{	/* Cfa/type.scm 267 */
														int BgL_arg2552z00_2491;

														BgL_arg2552z00_2491 = (int) (((long) 8));
														{	/* Cfa/type.scm 267 */
															long BgL_auxz00_3978;

															BgL_auxz00_3978 = (long) (BgL_arg2552z00_2491);
															BgL_restz00_2490 =
																(BgL_offsetz00_2487 % BgL_auxz00_3978);
													}}
													{	/* Cfa/type.scm 267 */

														BgL_method5195z00_2480 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2485,
																(int) (BgL_modz00_2488)),
															(int) (BgL_restz00_2490));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2480) (BgL_method5195z00_2480,
							(obj_t) (BgL_arg5435z00_1920), BEOA);
				}}
				{	/* Cfa/type.scm 268 */
					BgL_nodez00_bglt BgL_arg5436z00_1921;

					BgL_arg5436z00_1921 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1916))->BgL_truez00);
					{	/* Cfa/type.scm 268 */
						obj_t BgL_method5195z00_2507;

						{	/* Cfa/type.scm 268 */
							BgL_objectz00_bglt BgL_objz00_2508;

							BgL_objz00_2508 = (BgL_objectz00_bglt) (BgL_arg5436z00_1921);
							{	/* Cfa/type.scm 268 */
								long BgL_objzd2classzd2numz00_2509;

								BgL_objzd2classzd2numz00_2509 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2508);
								{	/* Cfa/type.scm 268 */
									obj_t BgL_arg2551z00_2510;

									BgL_arg2551z00_2510 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 268 */
										obj_t BgL_arrayz00_2512;

										int BgL_offsetz00_2513;

										BgL_arrayz00_2512 = BgL_arg2551z00_2510;
										BgL_offsetz00_2513 = (int) (BgL_objzd2classzd2numz00_2509);
										{	/* Cfa/type.scm 268 */
											long BgL_offsetz00_2514;

											BgL_offsetz00_2514 =
												((long) (BgL_offsetz00_2513) - OBJECT_TYPE);
											{	/* Cfa/type.scm 268 */
												long BgL_modz00_2515;

												{	/* Cfa/type.scm 268 */
													int BgL_arg2553z00_2516;

													BgL_arg2553z00_2516 = (int) (((long) 8));
													{	/* Cfa/type.scm 268 */
														long BgL_auxz00_3997;

														BgL_auxz00_3997 = (long) (BgL_arg2553z00_2516);
														BgL_modz00_2515 =
															(BgL_offsetz00_2514 / BgL_auxz00_3997);
												}}
												{	/* Cfa/type.scm 268 */
													long BgL_restz00_2517;

													{	/* Cfa/type.scm 268 */
														int BgL_arg2552z00_2518;

														BgL_arg2552z00_2518 = (int) (((long) 8));
														{	/* Cfa/type.scm 268 */
															long BgL_auxz00_4001;

															BgL_auxz00_4001 = (long) (BgL_arg2552z00_2518);
															BgL_restz00_2517 =
																(BgL_offsetz00_2514 % BgL_auxz00_4001);
													}}
													{	/* Cfa/type.scm 268 */

														BgL_method5195z00_2507 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2512,
																(int) (BgL_modz00_2515)),
															(int) (BgL_restz00_2517));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2507) (BgL_method5195z00_2507,
							(obj_t) (BgL_arg5436z00_1921), BEOA);
				}}
				{	/* Cfa/type.scm 269 */
					BgL_nodez00_bglt BgL_arg5437z00_1922;

					BgL_arg5437z00_1922 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1916))->BgL_falsez00);
					{	/* Cfa/type.scm 269 */
						obj_t BgL_method5195z00_2534;

						{	/* Cfa/type.scm 269 */
							BgL_objectz00_bglt BgL_objz00_2535;

							BgL_objz00_2535 = (BgL_objectz00_bglt) (BgL_arg5437z00_1922);
							{	/* Cfa/type.scm 269 */
								long BgL_objzd2classzd2numz00_2536;

								BgL_objzd2classzd2numz00_2536 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2535);
								{	/* Cfa/type.scm 269 */
									obj_t BgL_arg2551z00_2537;

									BgL_arg2551z00_2537 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 269 */
										obj_t BgL_arrayz00_2539;

										int BgL_offsetz00_2540;

										BgL_arrayz00_2539 = BgL_arg2551z00_2537;
										BgL_offsetz00_2540 = (int) (BgL_objzd2classzd2numz00_2536);
										{	/* Cfa/type.scm 269 */
											long BgL_offsetz00_2541;

											BgL_offsetz00_2541 =
												((long) (BgL_offsetz00_2540) - OBJECT_TYPE);
											{	/* Cfa/type.scm 269 */
												long BgL_modz00_2542;

												{	/* Cfa/type.scm 269 */
													int BgL_arg2553z00_2543;

													BgL_arg2553z00_2543 = (int) (((long) 8));
													{	/* Cfa/type.scm 269 */
														long BgL_auxz00_4020;

														BgL_auxz00_4020 = (long) (BgL_arg2553z00_2543);
														BgL_modz00_2542 =
															(BgL_offsetz00_2541 / BgL_auxz00_4020);
												}}
												{	/* Cfa/type.scm 269 */
													long BgL_restz00_2544;

													{	/* Cfa/type.scm 269 */
														int BgL_arg2552z00_2545;

														BgL_arg2552z00_2545 = (int) (((long) 8));
														{	/* Cfa/type.scm 269 */
															long BgL_auxz00_4024;

															BgL_auxz00_4024 = (long) (BgL_arg2552z00_2545);
															BgL_restz00_2544 =
																(BgL_offsetz00_2541 % BgL_auxz00_4024);
													}}
													{	/* Cfa/type.scm 269 */

														BgL_method5195z00_2534 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2539,
																(int) (BgL_modz00_2542)),
															(int) (BgL_restz00_2544));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2534) (BgL_method5195z00_2534,
							(obj_t) (BgL_arg5437z00_1922), BEOA);
					}
				}
			}
		}
	}



/* type-node!-setq5221 */
	obj_t BGl_typezd2nodez12zd2setq5221z12zzcfa_typez00(obj_t BgL_envz00_3128,
		obj_t BgL_nodez00_3129)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 257 */
			{
				BgL_setqz00_bglt BgL_nodez00_1908;

				BgL_nodez00_1908 = (BgL_setqz00_bglt) (BgL_nodez00_3129);
				{	/* Cfa/type.scm 259 */
					BgL_nodez00_bglt BgL_arg5432z00_1912;

					BgL_arg5432z00_1912 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1908))->BgL_valuez00);
					{	/* Cfa/type.scm 259 */
						obj_t BgL_method5195z00_2426;

						{	/* Cfa/type.scm 259 */
							BgL_objectz00_bglt BgL_objz00_2427;

							BgL_objz00_2427 = (BgL_objectz00_bglt) (BgL_arg5432z00_1912);
							{	/* Cfa/type.scm 259 */
								long BgL_objzd2classzd2numz00_2428;

								BgL_objzd2classzd2numz00_2428 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2427);
								{	/* Cfa/type.scm 259 */
									obj_t BgL_arg2551z00_2429;

									BgL_arg2551z00_2429 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 259 */
										obj_t BgL_arrayz00_2431;

										int BgL_offsetz00_2432;

										BgL_arrayz00_2431 = BgL_arg2551z00_2429;
										BgL_offsetz00_2432 = (int) (BgL_objzd2classzd2numz00_2428);
										{	/* Cfa/type.scm 259 */
											long BgL_offsetz00_2433;

											BgL_offsetz00_2433 =
												((long) (BgL_offsetz00_2432) - OBJECT_TYPE);
											{	/* Cfa/type.scm 259 */
												long BgL_modz00_2434;

												{	/* Cfa/type.scm 259 */
													int BgL_arg2553z00_2435;

													BgL_arg2553z00_2435 = (int) (((long) 8));
													{	/* Cfa/type.scm 259 */
														long BgL_auxz00_4044;

														BgL_auxz00_4044 = (long) (BgL_arg2553z00_2435);
														BgL_modz00_2434 =
															(BgL_offsetz00_2433 / BgL_auxz00_4044);
												}}
												{	/* Cfa/type.scm 259 */
													long BgL_restz00_2436;

													{	/* Cfa/type.scm 259 */
														int BgL_arg2552z00_2437;

														BgL_arg2552z00_2437 = (int) (((long) 8));
														{	/* Cfa/type.scm 259 */
															long BgL_auxz00_4048;

															BgL_auxz00_4048 = (long) (BgL_arg2552z00_2437);
															BgL_restz00_2436 =
																(BgL_offsetz00_2433 % BgL_auxz00_4048);
													}}
													{	/* Cfa/type.scm 259 */

														BgL_method5195z00_2426 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2431,
																(int) (BgL_modz00_2434)),
															(int) (BgL_restz00_2436));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2426) (BgL_method5195z00_2426,
							(obj_t) (BgL_arg5432z00_1912), BEOA);
				}}
				{	/* Cfa/type.scm 260 */
					BgL_varz00_bglt BgL_arg5433z00_1913;

					BgL_arg5433z00_1913 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1908))->BgL_varz00);
					{	/* Cfa/type.scm 260 */
						BgL_nodez00_bglt BgL_nodez00_2452;

						BgL_nodez00_2452 = (BgL_nodez00_bglt) (BgL_arg5433z00_1913);
						{	/* Cfa/type.scm 260 */
							obj_t BgL_method5195z00_2453;

							{	/* Cfa/type.scm 260 */
								BgL_objectz00_bglt BgL_objz00_2454;

								BgL_objz00_2454 = (BgL_objectz00_bglt) (BgL_nodez00_2452);
								{	/* Cfa/type.scm 260 */
									long BgL_objzd2classzd2numz00_2455;

									BgL_objzd2classzd2numz00_2455 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2454);
									{	/* Cfa/type.scm 260 */
										obj_t BgL_arg2551z00_2456;

										BgL_arg2551z00_2456 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 260 */
											obj_t BgL_arrayz00_2458;

											int BgL_offsetz00_2459;

											BgL_arrayz00_2458 = BgL_arg2551z00_2456;
											BgL_offsetz00_2459 =
												(int) (BgL_objzd2classzd2numz00_2455);
											{	/* Cfa/type.scm 260 */
												long BgL_offsetz00_2460;

												BgL_offsetz00_2460 =
													((long) (BgL_offsetz00_2459) - OBJECT_TYPE);
												{	/* Cfa/type.scm 260 */
													long BgL_modz00_2461;

													{	/* Cfa/type.scm 260 */
														int BgL_arg2553z00_2462;

														BgL_arg2553z00_2462 = (int) (((long) 8));
														{	/* Cfa/type.scm 260 */
															long BgL_auxz00_4068;

															BgL_auxz00_4068 = (long) (BgL_arg2553z00_2462);
															BgL_modz00_2461 =
																(BgL_offsetz00_2460 / BgL_auxz00_4068);
													}}
													{	/* Cfa/type.scm 260 */
														long BgL_restz00_2463;

														{	/* Cfa/type.scm 260 */
															int BgL_arg2552z00_2464;

															BgL_arg2552z00_2464 = (int) (((long) 8));
															{	/* Cfa/type.scm 260 */
																long BgL_auxz00_4072;

																BgL_auxz00_4072 = (long) (BgL_arg2552z00_2464);
																BgL_restz00_2463 =
																	(BgL_offsetz00_2460 % BgL_auxz00_4072);
														}}
														{	/* Cfa/type.scm 260 */

															BgL_method5195z00_2453 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2458,
																	(int) (BgL_modz00_2461)),
																(int) (BgL_restz00_2463));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5195z00_2453) (BgL_method5195z00_2453,
								(obj_t) (BgL_nodez00_2452), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-cast5219 */
	obj_t BGl_typezd2nodez12zd2cast5219z12zzcfa_typez00(obj_t BgL_envz00_3130,
		obj_t BgL_nodez00_3131)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 250 */
			{
				BgL_castz00_bglt BgL_nodez00_1901;

				BgL_nodez00_1901 = (BgL_castz00_bglt) (BgL_nodez00_3131);
				{	/* Cfa/type.scm 251 */
					BgL_nodez00_bglt BgL_arg5430z00_2396;

					BgL_arg5430z00_2396 =
						(((BgL_castz00_bglt) CREF(BgL_nodez00_1901))->BgL_argz00);
					{	/* Cfa/type.scm 251 */
						obj_t BgL_method5195z00_2399;

						{	/* Cfa/type.scm 251 */
							BgL_objectz00_bglt BgL_objz00_2400;

							BgL_objz00_2400 = (BgL_objectz00_bglt) (BgL_arg5430z00_2396);
							{	/* Cfa/type.scm 251 */
								long BgL_objzd2classzd2numz00_2401;

								BgL_objzd2classzd2numz00_2401 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2400);
								{	/* Cfa/type.scm 251 */
									obj_t BgL_arg2551z00_2402;

									BgL_arg2551z00_2402 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 251 */
										obj_t BgL_arrayz00_2404;

										int BgL_offsetz00_2405;

										BgL_arrayz00_2404 = BgL_arg2551z00_2402;
										BgL_offsetz00_2405 = (int) (BgL_objzd2classzd2numz00_2401);
										{	/* Cfa/type.scm 251 */
											long BgL_offsetz00_2406;

											BgL_offsetz00_2406 =
												((long) (BgL_offsetz00_2405) - OBJECT_TYPE);
											{	/* Cfa/type.scm 251 */
												long BgL_modz00_2407;

												{	/* Cfa/type.scm 251 */
													int BgL_arg2553z00_2408;

													BgL_arg2553z00_2408 = (int) (((long) 8));
													{	/* Cfa/type.scm 251 */
														long BgL_auxz00_4092;

														BgL_auxz00_4092 = (long) (BgL_arg2553z00_2408);
														BgL_modz00_2407 =
															(BgL_offsetz00_2406 / BgL_auxz00_4092);
												}}
												{	/* Cfa/type.scm 251 */
													long BgL_restz00_2409;

													{	/* Cfa/type.scm 251 */
														int BgL_arg2552z00_2410;

														BgL_arg2552z00_2410 = (int) (((long) 8));
														{	/* Cfa/type.scm 251 */
															long BgL_auxz00_4096;

															BgL_auxz00_4096 = (long) (BgL_arg2552z00_2410);
															BgL_restz00_2409 =
																(BgL_offsetz00_2406 % BgL_auxz00_4096);
													}}
													{	/* Cfa/type.scm 251 */

														BgL_method5195z00_2399 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2404,
																(int) (BgL_modz00_2407)),
															(int) (BgL_restz00_2409));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2399) (BgL_method5195z00_2399,
							(obj_t) (BgL_arg5430z00_2396), BEOA);
					}
				}
			}
		}
	}



/* type-node!-vset!5217 */
	obj_t BGl_typezd2nodez12zd2vsetz125217z00zzcfa_typez00(obj_t BgL_envz00_3132,
		obj_t BgL_nodez00_3133)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 241 */
			{
				BgL_vsetz12z12_bglt BgL_nodez00_1893;

				BgL_nodez00_1893 = (BgL_vsetz12z12_bglt) (BgL_nodez00_3133);
				{

					{	/* Cfa/type.scm 241 */
						obj_t BgL_nextzd2method5216zd2_1899;

						BgL_nextzd2method5216zd2_1899 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_nodez00_1893),
							BGl_typezd2nodez12zd2envz12zzcfa_typez00,
							BGl_vsetz12z12zzast_nodez00);
						if (PROCEDUREP(BgL_nextzd2method5216zd2_1899))
							{	/* Cfa/type.scm 241 */
								PROCEDURE_ENTRY(BgL_nextzd2method5216zd2_1899)
									(BgL_nextzd2method5216zd2_1899, (obj_t) (BgL_nodez00_1893),
									BEOA);
							}
						else
							{	/* Cfa/type.scm 241 */
								{	/* Cfa/type.scm 241 */
									BgL_nodez00_bglt BgL_nodez00_2369;

									BgL_nodez00_2369 = (BgL_nodez00_bglt) (BgL_nodez00_1893);
									{	/* Cfa/type.scm 241 */
										obj_t BgL_method5195z00_2370;

										{	/* Cfa/type.scm 241 */
											BgL_objectz00_bglt BgL_objz00_2371;

											BgL_objz00_2371 = (BgL_objectz00_bglt) (BgL_nodez00_2369);
											{	/* Cfa/type.scm 241 */
												long BgL_objzd2classzd2numz00_2372;

												BgL_objzd2classzd2numz00_2372 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2371);
												{	/* Cfa/type.scm 241 */
													obj_t BgL_arg2551z00_2373;

													BgL_arg2551z00_2373 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 241 */
														obj_t BgL_arrayz00_2375;

														int BgL_offsetz00_2376;

														BgL_arrayz00_2375 = BgL_arg2551z00_2373;
														BgL_offsetz00_2376 =
															(int) (BgL_objzd2classzd2numz00_2372);
														{	/* Cfa/type.scm 241 */
															long BgL_offsetz00_2377;

															BgL_offsetz00_2377 =
																((long) (BgL_offsetz00_2376) - OBJECT_TYPE);
															{	/* Cfa/type.scm 241 */
																long BgL_modz00_2378;

																{	/* Cfa/type.scm 241 */
																	int BgL_arg2553z00_2379;

																	BgL_arg2553z00_2379 = (int) (((long) 8));
																	{	/* Cfa/type.scm 241 */
																		long BgL_auxz00_4123;

																		BgL_auxz00_4123 =
																			(long) (BgL_arg2553z00_2379);
																		BgL_modz00_2378 =
																			(BgL_offsetz00_2377 / BgL_auxz00_4123);
																}}
																{	/* Cfa/type.scm 241 */
																	long BgL_restz00_2380;

																	{	/* Cfa/type.scm 241 */
																		int BgL_arg2552z00_2381;

																		BgL_arg2552z00_2381 = (int) (((long) 8));
																		{	/* Cfa/type.scm 241 */
																			long BgL_auxz00_4127;

																			BgL_auxz00_4127 =
																				(long) (BgL_arg2552z00_2381);
																			BgL_restz00_2380 =
																				(BgL_offsetz00_2377 % BgL_auxz00_4127);
																	}}
																	{	/* Cfa/type.scm 241 */

																		BgL_method5195z00_2370 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2375,
																				(int) (BgL_modz00_2378)),
																			(int) (BgL_restz00_2380));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5195z00_2370)
											(BgL_method5195z00_2370, (obj_t) (BgL_nodez00_2369),
											BEOA);
					}}}}
					{	/* Cfa/type.scm 244 */
						bool_t BgL_testz00_4137;

						{	/* Cfa/type.scm 244 */
							BgL_typez00_bglt BgL_arg5428z00_1898;

							BgL_arg5428z00_1898 =
								(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1893))->BgL_ftypez00);
							BgL_testz00_4137 =
								(
								(obj_t) (BgL_arg5428z00_1898) == BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_testz00_4137)
							{
								BgL_typez00_bglt BgL_auxz00_4141;

								BgL_auxz00_4141 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1893))->
										BgL_ftypez00) =
									((BgL_typez00_bglt) BgL_auxz00_4141), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 244 */
								return BFALSE;
							}
					}
				}
			}
		}
	}



/* type-node!-vref5215 */
	obj_t BGl_typezd2nodez12zd2vref5215z12zzcfa_typez00(obj_t BgL_envz00_3134,
		obj_t BgL_nodez00_3135)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 232 */
			{
				BgL_vrefz00_bglt BgL_nodez00_1885;

				BgL_nodez00_1885 = (BgL_vrefz00_bglt) (BgL_nodez00_3135);
				{

					{	/* Cfa/type.scm 232 */
						obj_t BgL_nextzd2method5214zd2_1891;

						BgL_nextzd2method5214zd2_1891 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_nodez00_1885),
							BGl_typezd2nodez12zd2envz12zzcfa_typez00,
							BGl_vrefz00zzast_nodez00);
						if (PROCEDUREP(BgL_nextzd2method5214zd2_1891))
							{	/* Cfa/type.scm 232 */
								PROCEDURE_ENTRY(BgL_nextzd2method5214zd2_1891)
									(BgL_nextzd2method5214zd2_1891, (obj_t) (BgL_nodez00_1885),
									BEOA);
							}
						else
							{	/* Cfa/type.scm 232 */
								{	/* Cfa/type.scm 232 */
									BgL_nodez00_bglt BgL_nodez00_2339;

									BgL_nodez00_2339 = (BgL_nodez00_bglt) (BgL_nodez00_1885);
									{	/* Cfa/type.scm 232 */
										obj_t BgL_method5195z00_2340;

										{	/* Cfa/type.scm 232 */
											BgL_objectz00_bglt BgL_objz00_2341;

											BgL_objz00_2341 = (BgL_objectz00_bglt) (BgL_nodez00_2339);
											{	/* Cfa/type.scm 232 */
												long BgL_objzd2classzd2numz00_2342;

												BgL_objzd2classzd2numz00_2342 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2341);
												{	/* Cfa/type.scm 232 */
													obj_t BgL_arg2551z00_2343;

													BgL_arg2551z00_2343 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 232 */
														obj_t BgL_arrayz00_2345;

														int BgL_offsetz00_2346;

														BgL_arrayz00_2345 = BgL_arg2551z00_2343;
														BgL_offsetz00_2346 =
															(int) (BgL_objzd2classzd2numz00_2342);
														{	/* Cfa/type.scm 232 */
															long BgL_offsetz00_2347;

															BgL_offsetz00_2347 =
																((long) (BgL_offsetz00_2346) - OBJECT_TYPE);
															{	/* Cfa/type.scm 232 */
																long BgL_modz00_2348;

																{	/* Cfa/type.scm 232 */
																	int BgL_arg2553z00_2349;

																	BgL_arg2553z00_2349 = (int) (((long) 8));
																	{	/* Cfa/type.scm 232 */
																		long BgL_auxz00_4161;

																		BgL_auxz00_4161 =
																			(long) (BgL_arg2553z00_2349);
																		BgL_modz00_2348 =
																			(BgL_offsetz00_2347 / BgL_auxz00_4161);
																}}
																{	/* Cfa/type.scm 232 */
																	long BgL_restz00_2350;

																	{	/* Cfa/type.scm 232 */
																		int BgL_arg2552z00_2351;

																		BgL_arg2552z00_2351 = (int) (((long) 8));
																		{	/* Cfa/type.scm 232 */
																			long BgL_auxz00_4165;

																			BgL_auxz00_4165 =
																				(long) (BgL_arg2552z00_2351);
																			BgL_restz00_2350 =
																				(BgL_offsetz00_2347 % BgL_auxz00_4165);
																	}}
																	{	/* Cfa/type.scm 232 */

																		BgL_method5195z00_2340 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2345,
																				(int) (BgL_modz00_2348)),
																			(int) (BgL_restz00_2350));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5195z00_2340)
											(BgL_method5195z00_2340, (obj_t) (BgL_nodez00_2339),
											BEOA);
					}}}}
					{	/* Cfa/type.scm 235 */
						bool_t BgL_testz00_4175;

						{	/* Cfa/type.scm 235 */
							BgL_typez00_bglt BgL_arg5425z00_1890;

							BgL_arg5425z00_1890 =
								(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1885))->BgL_ftypez00);
							BgL_testz00_4175 =
								(
								(obj_t) (BgL_arg5425z00_1890) == BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_testz00_4175)
							{
								BgL_typez00_bglt BgL_auxz00_4179;

								BgL_auxz00_4179 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_vrefz00_bglt) CREF(BgL_nodez00_1885))->BgL_ftypez00) =
									((BgL_typez00_bglt) BgL_auxz00_4179), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 235 */
								return BFALSE;
							}
					}
				}
			}
		}
	}



/* type-node!-extern5213 */
	obj_t BGl_typezd2nodez12zd2extern5213z12zzcfa_typez00(obj_t BgL_envz00_3136,
		obj_t BgL_nodez00_3137)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 225 */
			{
				BgL_externz00_bglt BgL_nodez00_1878;

				{	/* Cfa/type.scm 226 */
					bool_t BgL_auxz00_4183;

					BgL_nodez00_1878 = (BgL_externz00_bglt) (BgL_nodez00_3137);
					{	/* Cfa/type.scm 226 */
						obj_t BgL_arg5422z00_2333;

						BgL_arg5422z00_2333 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1878))->BgL_exprza2za2);
						BgL_auxz00_4183 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5422z00_2333);
					}
					return BBOOL(BgL_auxz00_4183);
				}
			}
		}
	}



/* type-node!-funcall5211 */
	obj_t BGl_typezd2nodez12zd2funcall5211z12zzcfa_typez00(obj_t BgL_envz00_3138,
		obj_t BgL_nodez00_3139)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 217 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1870;

				{	/* Cfa/type.scm 218 */
					bool_t BgL_auxz00_4188;

					BgL_nodez00_1870 = (BgL_funcallz00_bglt) (BgL_nodez00_3139);
					{	/* Cfa/type.scm 219 */
						BgL_nodez00_bglt BgL_arg5419z00_1874;

						BgL_arg5419z00_1874 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1870))->BgL_funz00);
						{	/* Cfa/type.scm 219 */
							obj_t BgL_method5195z00_2306;

							{	/* Cfa/type.scm 219 */
								BgL_objectz00_bglt BgL_objz00_2307;

								BgL_objz00_2307 = (BgL_objectz00_bglt) (BgL_arg5419z00_1874);
								{	/* Cfa/type.scm 219 */
									long BgL_objzd2classzd2numz00_2308;

									BgL_objzd2classzd2numz00_2308 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2307);
									{	/* Cfa/type.scm 219 */
										obj_t BgL_arg2551z00_2309;

										BgL_arg2551z00_2309 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 219 */
											obj_t BgL_arrayz00_2311;

											int BgL_offsetz00_2312;

											BgL_arrayz00_2311 = BgL_arg2551z00_2309;
											BgL_offsetz00_2312 =
												(int) (BgL_objzd2classzd2numz00_2308);
											{	/* Cfa/type.scm 219 */
												long BgL_offsetz00_2313;

												BgL_offsetz00_2313 =
													((long) (BgL_offsetz00_2312) - OBJECT_TYPE);
												{	/* Cfa/type.scm 219 */
													long BgL_modz00_2314;

													{	/* Cfa/type.scm 219 */
														int BgL_arg2553z00_2315;

														BgL_arg2553z00_2315 = (int) (((long) 8));
														{	/* Cfa/type.scm 219 */
															long BgL_auxz00_4198;

															BgL_auxz00_4198 = (long) (BgL_arg2553z00_2315);
															BgL_modz00_2314 =
																(BgL_offsetz00_2313 / BgL_auxz00_4198);
													}}
													{	/* Cfa/type.scm 219 */
														long BgL_restz00_2316;

														{	/* Cfa/type.scm 219 */
															int BgL_arg2552z00_2317;

															BgL_arg2552z00_2317 = (int) (((long) 8));
															{	/* Cfa/type.scm 219 */
																long BgL_auxz00_4202;

																BgL_auxz00_4202 = (long) (BgL_arg2552z00_2317);
																BgL_restz00_2316 =
																	(BgL_offsetz00_2313 % BgL_auxz00_4202);
														}}
														{	/* Cfa/type.scm 219 */

															BgL_method5195z00_2306 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2311,
																	(int) (BgL_modz00_2314)),
																(int) (BgL_restz00_2316));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5195z00_2306) (BgL_method5195z00_2306,
								(obj_t) (BgL_arg5419z00_1874), BEOA);
					}}
					{	/* Cfa/type.scm 220 */
						obj_t BgL_arg5420z00_1875;

						BgL_arg5420z00_1875 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1870))->BgL_argsz00);
						BgL_auxz00_4188 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5420z00_1875);
					}
					return BBOOL(BgL_auxz00_4188);
				}
			}
		}
	}



/* type-node!-app-ly5209 */
	obj_t BGl_typezd2nodez12zd2appzd2ly5209zc0zzcfa_typez00(obj_t BgL_envz00_3140,
		obj_t BgL_nodez00_3141)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 209 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1862;

				BgL_nodez00_1862 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3141);
				{	/* Cfa/type.scm 211 */
					BgL_nodez00_bglt BgL_arg5416z00_1866;

					BgL_arg5416z00_1866 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1862))->BgL_funz00);
					{	/* Cfa/type.scm 211 */
						obj_t BgL_method5195z00_2252;

						{	/* Cfa/type.scm 211 */
							BgL_objectz00_bglt BgL_objz00_2253;

							BgL_objz00_2253 = (BgL_objectz00_bglt) (BgL_arg5416z00_1866);
							{	/* Cfa/type.scm 211 */
								long BgL_objzd2classzd2numz00_2254;

								BgL_objzd2classzd2numz00_2254 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2253);
								{	/* Cfa/type.scm 211 */
									obj_t BgL_arg2551z00_2255;

									BgL_arg2551z00_2255 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 211 */
										obj_t BgL_arrayz00_2257;

										int BgL_offsetz00_2258;

										BgL_arrayz00_2257 = BgL_arg2551z00_2255;
										BgL_offsetz00_2258 = (int) (BgL_objzd2classzd2numz00_2254);
										{	/* Cfa/type.scm 211 */
											long BgL_offsetz00_2259;

											BgL_offsetz00_2259 =
												((long) (BgL_offsetz00_2258) - OBJECT_TYPE);
											{	/* Cfa/type.scm 211 */
												long BgL_modz00_2260;

												{	/* Cfa/type.scm 211 */
													int BgL_arg2553z00_2261;

													BgL_arg2553z00_2261 = (int) (((long) 8));
													{	/* Cfa/type.scm 211 */
														long BgL_auxz00_4225;

														BgL_auxz00_4225 = (long) (BgL_arg2553z00_2261);
														BgL_modz00_2260 =
															(BgL_offsetz00_2259 / BgL_auxz00_4225);
												}}
												{	/* Cfa/type.scm 211 */
													long BgL_restz00_2262;

													{	/* Cfa/type.scm 211 */
														int BgL_arg2552z00_2263;

														BgL_arg2552z00_2263 = (int) (((long) 8));
														{	/* Cfa/type.scm 211 */
															long BgL_auxz00_4229;

															BgL_auxz00_4229 = (long) (BgL_arg2552z00_2263);
															BgL_restz00_2262 =
																(BgL_offsetz00_2259 % BgL_auxz00_4229);
													}}
													{	/* Cfa/type.scm 211 */

														BgL_method5195z00_2252 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2257,
																(int) (BgL_modz00_2260)),
															(int) (BgL_restz00_2262));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5195z00_2252) (BgL_method5195z00_2252,
							(obj_t) (BgL_arg5416z00_1866), BEOA);
				}}
				{	/* Cfa/type.scm 212 */
					BgL_nodez00_bglt BgL_arg5417z00_1867;

					BgL_arg5417z00_1867 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1862))->BgL_argz00);
					{	/* Cfa/type.scm 212 */
						obj_t BgL_method5195z00_2279;

						{	/* Cfa/type.scm 212 */
							BgL_objectz00_bglt BgL_objz00_2280;

							BgL_objz00_2280 = (BgL_objectz00_bglt) (BgL_arg5417z00_1867);
							{	/* Cfa/type.scm 212 */
								long BgL_objzd2classzd2numz00_2281;

								BgL_objzd2classzd2numz00_2281 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2280);
								{	/* Cfa/type.scm 212 */
									obj_t BgL_arg2551z00_2282;

									BgL_arg2551z00_2282 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 212 */
										obj_t BgL_arrayz00_2284;

										int BgL_offsetz00_2285;

										BgL_arrayz00_2284 = BgL_arg2551z00_2282;
										BgL_offsetz00_2285 = (int) (BgL_objzd2classzd2numz00_2281);
										{	/* Cfa/type.scm 212 */
											long BgL_offsetz00_2286;

											BgL_offsetz00_2286 =
												((long) (BgL_offsetz00_2285) - OBJECT_TYPE);
											{	/* Cfa/type.scm 212 */
												long BgL_modz00_2287;

												{	/* Cfa/type.scm 212 */
													int BgL_arg2553z00_2288;

													BgL_arg2553z00_2288 = (int) (((long) 8));
													{	/* Cfa/type.scm 212 */
														long BgL_auxz00_4248;

														BgL_auxz00_4248 = (long) (BgL_arg2553z00_2288);
														BgL_modz00_2287 =
															(BgL_offsetz00_2286 / BgL_auxz00_4248);
												}}
												{	/* Cfa/type.scm 212 */
													long BgL_restz00_2289;

													{	/* Cfa/type.scm 212 */
														int BgL_arg2552z00_2290;

														BgL_arg2552z00_2290 = (int) (((long) 8));
														{	/* Cfa/type.scm 212 */
															long BgL_auxz00_4252;

															BgL_auxz00_4252 = (long) (BgL_arg2552z00_2290);
															BgL_restz00_2289 =
																(BgL_offsetz00_2286 % BgL_auxz00_4252);
													}}
													{	/* Cfa/type.scm 212 */

														BgL_method5195z00_2279 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2284,
																(int) (BgL_modz00_2287)),
															(int) (BgL_restz00_2289));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5195z00_2279) (BgL_method5195z00_2279,
							(obj_t) (BgL_arg5417z00_1867), BEOA);
					}
				}
			}
		}
	}



/* type-node!-app5207 */
	obj_t BGl_typezd2nodez12zd2app5207z12zzcfa_typez00(obj_t BgL_envz00_3142,
		obj_t BgL_nodez00_3143)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 202 */
			{
				BgL_appz00_bglt BgL_nodez00_1855;

				{	/* Cfa/type.scm 203 */
					bool_t BgL_auxz00_4263;

					BgL_nodez00_1855 = (BgL_appz00_bglt) (BgL_nodez00_3143);
					{	/* Cfa/type.scm 203 */
						obj_t BgL_arg5414z00_2248;

						BgL_arg5414z00_2248 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1855))->BgL_argsz00);
						BgL_auxz00_4263 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5414z00_2248);
					}
					return BBOOL(BgL_auxz00_4263);
				}
			}
		}
	}



/* type-node!-sequence5205 */
	obj_t BGl_typezd2nodez12zd2sequence5205z12zzcfa_typez00(obj_t BgL_envz00_3144,
		obj_t BgL_nodez00_3145)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 195 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1848;

				{	/* Cfa/type.scm 196 */
					bool_t BgL_auxz00_4268;

					BgL_nodez00_1848 = (BgL_sequencez00_bglt) (BgL_nodez00_3145);
					{	/* Cfa/type.scm 196 */
						obj_t BgL_arg5412z00_2245;

						BgL_arg5412z00_2245 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1848))->BgL_nodesz00);
						BgL_auxz00_4268 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5412z00_2245);
					}
					return BBOOL(BgL_auxz00_4268);
				}
			}
		}
	}



/* type-node!-closure5203 */
	obj_t BGl_typezd2nodez12zd2closure5203z12zzcfa_typez00(obj_t BgL_envz00_3146,
		obj_t BgL_nodez00_3147)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 189 */
			{
				BgL_closurez00_bglt BgL_nodez00_1840;

				BgL_nodez00_1840 = (BgL_closurez00_bglt) (BgL_nodez00_3147);
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string5575z00zzcfa_typez00, BGl_string5576z00zzcfa_typez00,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1840)));
			}
		}
	}



/* type-node!-var5201 */
	obj_t BGl_typezd2nodez12zd2var5201z12zzcfa_typez00(obj_t BgL_envz00_3148,
		obj_t BgL_nodez00_3149)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 181 */
			{
				BgL_varz00_bglt BgL_nodez00_1825;

				BgL_nodez00_1825 = (BgL_varz00_bglt) (BgL_nodez00_3149);
				{	/* Cfa/type.scm 183 */
					bool_t BgL_testz00_4277;

					{	/* Cfa/type.scm 183 */
						bool_t BgL_testz00_4278;

						{	/* Cfa/type.scm 183 */
							BgL_variablez00_bglt BgL_arg5406z00_1837;

							BgL_arg5406z00_1837 =
								(((BgL_varz00_bglt) CREF(BgL_nodez00_1825))->BgL_variablez00);
							{	/* Cfa/type.scm 183 */
								obj_t BgL_obj1658z00_2211;

								BgL_obj1658z00_2211 = (obj_t) (BgL_arg5406z00_1837);
								BgL_testz00_4278 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_2211,
									BGl_globalz00zzast_varz00);
							}
						}
						if (BgL_testz00_4278)
							{	/* Cfa/type.scm 183 */
								obj_t BgL_auxz00_4282;

								{	/* Cfa/type.scm 183 */
									BgL_globalz00_bglt BgL_obj1586z00_2213;

									BgL_obj1586z00_2213 =
										(BgL_globalz00_bglt) (
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1825))->
											BgL_variablez00));
									BgL_auxz00_4282 =
										(((BgL_globalz00_bglt) CREF(BgL_obj1586z00_2213))->
										BgL_importz00);
								}
								BgL_testz00_4277 =
									(BgL_auxz00_4282 == CNST_TABLE_REF(((long) 3)));
							}
						else
							{	/* Cfa/type.scm 183 */
								BgL_testz00_4277 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_4277)
						{	/* Cfa/type.scm 184 */
							BgL_valuez00_bglt BgL_arg5399z00_1830;

							BgL_variablez00_bglt BgL_arg5400z00_1831;

							{	/* Cfa/type.scm 184 */
								BgL_variablez00_bglt BgL_obj1518z00_2215;

								BgL_obj1518z00_2215 =
									(((BgL_varz00_bglt) CREF(BgL_nodez00_1825))->BgL_variablez00);
								BgL_arg5399z00_1830 =
									(((BgL_variablez00_bglt) CREF(BgL_obj1518z00_2215))->
									BgL_valuez00);
							}
							BgL_arg5400z00_1831 =
								(((BgL_varz00_bglt) CREF(BgL_nodez00_1825))->BgL_variablez00);
							{	/* Cfa/type.scm 184 */
								obj_t BgL_method5183z00_2219;

								{	/* Cfa/type.scm 184 */
									BgL_objectz00_bglt BgL_objz00_2220;

									BgL_objz00_2220 = (BgL_objectz00_bglt) (BgL_arg5399z00_1830);
									{	/* Cfa/type.scm 184 */
										long BgL_objzd2classzd2numz00_2221;

										BgL_objzd2classzd2numz00_2221 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2220);
										{	/* Cfa/type.scm 184 */
											obj_t BgL_arg2551z00_2222;

											BgL_arg2551z00_2222 =
												PROCEDURE_REF
												(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
												(int) (((long) 1)));
											{	/* Cfa/type.scm 184 */
												obj_t BgL_arrayz00_2224;

												int BgL_offsetz00_2225;

												BgL_arrayz00_2224 = BgL_arg2551z00_2222;
												BgL_offsetz00_2225 =
													(int) (BgL_objzd2classzd2numz00_2221);
												{	/* Cfa/type.scm 184 */
													long BgL_offsetz00_2226;

													BgL_offsetz00_2226 =
														((long) (BgL_offsetz00_2225) - OBJECT_TYPE);
													{	/* Cfa/type.scm 184 */
														long BgL_modz00_2227;

														{	/* Cfa/type.scm 184 */
															int BgL_arg2553z00_2228;

															BgL_arg2553z00_2228 = (int) (((long) 8));
															{	/* Cfa/type.scm 184 */
																long BgL_auxz00_4299;

																BgL_auxz00_4299 = (long) (BgL_arg2553z00_2228);
																BgL_modz00_2227 =
																	(BgL_offsetz00_2226 / BgL_auxz00_4299);
														}}
														{	/* Cfa/type.scm 184 */
															long BgL_restz00_2229;

															{	/* Cfa/type.scm 184 */
																int BgL_arg2552z00_2230;

																BgL_arg2552z00_2230 = (int) (((long) 8));
																{	/* Cfa/type.scm 184 */
																	long BgL_auxz00_4303;

																	BgL_auxz00_4303 =
																		(long) (BgL_arg2552z00_2230);
																	BgL_restz00_2229 =
																		(BgL_offsetz00_2226 % BgL_auxz00_4303);
															}}
															{	/* Cfa/type.scm 184 */

																BgL_method5183z00_2219 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2224,
																		(int) (BgL_modz00_2227)),
																	(int) (BgL_restz00_2229));
								}}}}}}}}
								return
									PROCEDURE_ENTRY(BgL_method5183z00_2219)
									(BgL_method5183z00_2219, (obj_t) (BgL_arg5399z00_1830),
									(obj_t) (BgL_arg5400z00_1831), BEOA);
							}
						}
					else
						{	/* Cfa/type.scm 183 */
							return BFALSE;
						}
				}
			}
		}
	}



/* type-node!-kwote5199 */
	obj_t BGl_typezd2nodez12zd2kwote5199z12zzcfa_typez00(obj_t BgL_envz00_3150,
		obj_t BgL_nodez00_3151)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 175 */
			return BUNSPEC;
		}
	}



/* type-node!-atom5197 */
	obj_t BGl_typezd2nodez12zd2atom5197z12zzcfa_typez00(obj_t BgL_envz00_3152,
		obj_t BgL_nodez00_3153)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 169 */
			return BUNSPEC;
		}
	}



/* type-variable!-inter5193 */
	obj_t BGl_typezd2variablez12zd2inter5193z12zzcfa_typez00(obj_t
		BgL_envz00_3154, obj_t BgL_valuez00_3155, obj_t BgL_variablez00_3156)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 132 */
			{	/* Cfa/type.scm 133 */
				obj_t BgL_res5581z00_3181;

				BgL_res5581z00_3181 = CNST_TABLE_REF(((long) 1));
				return BgL_res5581z00_3181;
			}
		}
	}



/* type-variable!-sexit5191 */
	obj_t BGl_typezd2variablez12zd2sexit5191z12zzcfa_typez00(obj_t
		BgL_envz00_3157, obj_t BgL_valuez00_3158, obj_t BgL_variablez00_3159)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 122 */
			{	/* Cfa/type.scm 123 */
				obj_t BgL_res5582z00_3184;

				BgL_res5582z00_3184 = CNST_TABLE_REF(((long) 1));
				return BgL_res5582z00_3184;
			}
		}
	}



/* type-variable!-cvar/5189 */
	obj_t BGl_typezd2variablez12zd2cvarzf25189ze0zzcfa_typez00(obj_t
		BgL_envz00_3160, obj_t BgL_valuez00_3161, obj_t BgL_variablez00_3162)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 115 */
			{
				BgL_cvarzf2cinfozf2_bglt BgL_valuez00_1794;

				obj_t BgL_variablez00_1795;

				BgL_valuez00_1794 = (BgL_cvarzf2cinfozf2_bglt) (BgL_valuez00_3161);
				BgL_variablez00_1795 = BgL_variablez00_3162;
				{	/* Cfa/type.scm 116 */
					obj_t BgL_arg5391z00_2207;

					{	/* Cfa/type.scm 116 */
						BgL_approxz00_bglt BgL_arg5392z00_2208;

						{
							obj_t BgL_auxz00_4317;

							{	/* Cfa/type.scm 116 */
								BgL_objectz00_bglt BgL_auxz00_4318;

								BgL_auxz00_4318 = (BgL_objectz00_bglt) (BgL_valuez00_1794);
								BgL_auxz00_4317 = BGL_OBJECT_WIDENING(BgL_auxz00_4318);
							}
							BgL_arg5392z00_2208 =
								(((BgL_cvarzf2cinfozf2_bglt) CREF(BgL_auxz00_4317))->
								BgL_approxz00);
						}
						BgL_arg5391z00_2207 =
							BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_arg5392z00_2208);
					}
					return
						BGl_setzd2variablezd2typez12z12zzcfa_typez00(
						(BgL_variablez00_bglt) (BgL_variablez00_1795),
						(BgL_typez00_bglt) (BgL_arg5391z00_2207));
				}
			}
		}
	}



/* type-variable!-scnst5187 */
	obj_t BGl_typezd2variablez12zd2scnst5187z12zzcfa_typez00(obj_t
		BgL_envz00_3163, obj_t BgL_valuez00_3164, obj_t BgL_variablez00_3165)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 109 */
			{	/* Cfa/type.scm 110 */
				obj_t BgL_res5583z00_3187;

				BgL_res5583z00_3187 = CNST_TABLE_REF(((long) 1));
				return BgL_res5583z00_3187;
			}
		}
	}



/* type-variable!-svar/5185 */
	obj_t BGl_typezd2variablez12zd2svarzf25185ze0zzcfa_typez00(obj_t
		BgL_envz00_3166, obj_t BgL_valuez00_3167, obj_t BgL_variablez00_3168)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 102 */
			{
				BgL_svarzf2cinfozf2_bglt BgL_valuez00_1779;

				obj_t BgL_variablez00_1780;

				BgL_valuez00_1779 = (BgL_svarzf2cinfozf2_bglt) (BgL_valuez00_3167);
				BgL_variablez00_1780 = BgL_variablez00_3168;
				{	/* Cfa/type.scm 103 */
					obj_t BgL_arg5387z00_2203;

					{	/* Cfa/type.scm 103 */
						BgL_approxz00_bglt BgL_arg5388z00_2204;

						{
							obj_t BgL_auxz00_4328;

							{	/* Cfa/type.scm 103 */
								BgL_objectz00_bglt BgL_auxz00_4329;

								BgL_auxz00_4329 = (BgL_objectz00_bglt) (BgL_valuez00_1779);
								BgL_auxz00_4328 = BGL_OBJECT_WIDENING(BgL_auxz00_4329);
							}
							BgL_arg5388z00_2204 =
								(((BgL_svarzf2cinfozf2_bglt) CREF(BgL_auxz00_4328))->
								BgL_approxz00);
						}
						BgL_arg5387z00_2203 =
							BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_arg5388z00_2204);
					}
					return
						BGl_setzd2variablezd2typez12z12zzcfa_typez00(
						(BgL_variablez00_bglt) (BgL_variablez00_1780),
						(BgL_typez00_bglt) (BgL_arg5387z00_2203));
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 243010053),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_info3z00(((long) 0),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_setz00(((long) 474371048),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 249450490),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
			return
				BGl_modulezd2initializa7ationz75zztvector_tvectorz00(((long) 2222742),
				BSTRING_TO_STRING(BGl_string5577z00zzcfa_typez00));
		}
	}

#ifdef __cplusplus
}
#endif
