/*===========================================================================*/
/*   (Coerce/coerce.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/coerce.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_getfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_getfieldz00_bglt;

	typedef struct BgL_setfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_setfieldz00_bglt;

	typedef struct BgL_newz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
	}             *BgL_newz00_bglt;

	typedef struct BgL_vallocz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2heapzd2formatz00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                *BgL_vallocz00_bglt;

	typedef struct BgL_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}              *BgL_vrefz00_bglt;

	typedef struct BgL_vsetz12z12_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vsetz12z12_bglt;

	typedef struct BgL_vlengthz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vlengthz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	extern obj_t BGl_vrefz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_coercez12zd2default3483zc0zzcoerce_coercez00(BgL_nodez00_bglt, obj_t,
		BgL_typez00_bglt, bool_t);
	static obj_t BGl_coercez12zd2new3503zc0zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_coercez12zd2kwote3488zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2cast3513zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_pvariablezd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_coercez12zd2vref3507zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2setq3515zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_coercez12zd2jumpzd2exzd2it3530zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2vlength3511zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_vallocz00zzast_nodez00;
	extern bool_t BGl_sidezd2effectzf3z21zzeffect_effectz00(BgL_nodez00_bglt);
	static obj_t BGl_coercez12zd2makezd2box3532z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_coercez12zd2getfield3499zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	BGL_EXPORTED_DECL obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt, bool_t);
	static obj_t BGl_coercez12zd2boxzd2ref3534z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_coercez12zd2setfield3501zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_vlengthz00zzast_nodez00;
	static obj_t BGl_coercez12zd2fail3520zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	extern obj_t BGl_vsetz12z12zzast_nodez00;
	static obj_t BGl_methodzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_coercez12zd2vsetz123509zd2zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__coercez12zd2default3483zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_coercez00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzcoerce_coercez00();
	static obj_t BGl__coercezd2functionz12zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	extern bool_t BGl_coercerzd2existszf3z21zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
	static obj_t BGl_coercez12zd2extern3497zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_typez00_bglt BGl_typeofz00zztype_typeofz00(BgL_nodez00_bglt);
	static obj_t BGl_coercez12zd2letzd2fun3524z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_coercez12zd2closure3492zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2var3490zc0zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_typezd2disjointzf3z21zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_coercez12zd2letzd2var3526z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt, obj_t,
		BgL_typez00_bglt, bool_t);
	extern obj_t BGl_getfieldz00zzast_nodez00;
	static obj_t BGl_coercez12zd2conditional3517zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2valloc3505zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2atom3486zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_newz00zzast_nodez00;
	extern obj_t BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	static obj_t BGl_coercez12zd2select3522zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2evalza2zd2zzengine_paramz00;
	extern obj_t BGl_setfieldz00zzast_nodez00;
	static obj_t BGl_coercez12zd2setzd2exzd2it3528zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2sequence3495zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2exitza2z00zztype_cachez00;
	extern obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__coercez12z12zzcoerce_coercez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern bool_t BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
	static obj_t BGl_coercez12zd2boxzd2setz123536z00zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t __cnst[3];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3943z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2atom3974z00,
		BGl_coercez12zd2atom3486zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3944z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2kwot3975z00,
		BGl_coercez12zd2kwote3488zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3945z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2var33976z00,
		BGl_coercez12zd2var3490zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3946z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2clos3977z00,
		BGl_coercez12zd2closure3492zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3947z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2sequ3978z00,
		BGl_coercez12zd2sequence3495zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3948z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2exte3979z00,
		BGl_coercez12zd2extern3497zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3950z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setf3980z00,
		BGl_coercez12zd2setfield3501zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3949z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2getf3981z00,
		BGl_coercez12zd2getfield3499zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3951z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2new33982z00,
		BGl_coercez12zd2new3503zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3952z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vall3983z00,
		BGl_coercez12zd2valloc3505zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3953z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vref3984z00,
		BGl_coercez12zd2vref3507zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3954z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vset3985z00,
		BGl_coercez12zd2vsetz123509zd2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3955z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vlen3986z00,
		BGl_coercez12zd2vlength3511zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3956z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2cast3987z00,
		BGl_coercez12zd2cast3513zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3957z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setq3988z00,
		BGl_coercez12zd2setq3515zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3958z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2cond3989z00,
		BGl_coercez12zd2conditional3517zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3960z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2sele3990z00,
		BGl_coercez12zd2select3522zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3959z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2fail3991z00,
		BGl_coercez12zd2fail3520zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3961z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2letza73992za7,
		BGl_coercez12zd2letzd2fun3524z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3962z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2letza73993za7,
		BGl_coercez12zd2letzd2var3526z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3963z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setza73994za7,
		BGl_coercez12zd2setzd2exzd2it3528zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3964z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2jump3995z00,
		BGl_coercez12zd2jumpzd2exzd2it3530zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3965z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2make3996z00,
		BGl_coercez12zd2makezd2box3532z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3966z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2boxza73997za7,
		BGl_coercez12zd2boxzd2ref3534z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3967z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2boxza73998za7,
		BGl_coercez12zd2boxzd2setz123536z00zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3942z00zzcoerce_coercez00,
		BgL_bgl_string3942za700za7za7c3999za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3968z00zzcoerce_coercez00,
		BgL_bgl_string3968za700za7za7c4000za7, "coerce!", 7);
	      DEFINE_STRING(BGl_string3970z00zzcoerce_coercez00,
		BgL_bgl_string3970za700za7za7c4001za7, "coerce_coerce", 13);
	      DEFINE_STRING(BGl_string3969z00zzcoerce_coercez00,
		BgL_bgl_string3969za700za7za7c4002za7, "Unexepected `closure' node", 26);
	      DEFINE_STRING(BGl_string3971z00zzcoerce_coercez00,
		BgL_bgl_string3971za700za7za7c4003za7, "false true coerce!-default3483 ",
		31);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_coercez12zd2envzc0zzcoerce_coercez00,
		BgL_bgl__coerceza712za712za7za7c4004z00,
		BGl__coercez12z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_coercezd2functionz12zd2envz12zzcoerce_coercez00,
		BgL_bgl__coerceza7d2functi4005za7,
		BGl__coercezd2functionz12zc0zzcoerce_coercez00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_coercez12zd2default3483zd2envz12zzcoerce_coercez00,
		BgL_bgl__coerceza712za7d2def4006z00,
		BGl__coercez12zd2default3483zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long
		BgL_checksumz00_3390, char *BgL_fromz00_3391)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_coercez00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_coercez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_cnstzd2initzd2zzcoerce_coercez00();
					BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_genericzd2initzd2zzcoerce_coercez00();
					BGl_methodzd2initzd2zzcoerce_coercez00();
					BGl_toplevelzd2initzd2zzcoerce_coercez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_coerce");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			{	/* Coerce/coerce.scm 15 */
				obj_t BgL_cportz00_3382;

				BgL_cportz00_3382 =
					bgl_open_input_string(BGl_string3971z00zzcoerce_coercez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3383;

					BgL_iz00_3383 = ((long) 2);
				BgL_loopz00_3384:
					if ((BgL_iz00_3383 == ((long) -1)))
						{	/* Coerce/coerce.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/coerce.scm 15 */
							{	/* Coerce/coerce.scm 15 */
								obj_t BgL_arg3973z00_3386;

								{	/* Coerce/coerce.scm 15 */

									{	/* Coerce/coerce.scm 15 */
										obj_t BgL_locationz00_3388;

										BgL_locationz00_3388 = BBOOL(((bool_t) 0));
										{	/* Coerce/coerce.scm 15 */

											BgL_arg3973z00_3386 =
												BGl_readz00zz__readerz00(BgL_cportz00_3382,
												BgL_locationz00_3388);
										}
									}
								}
								{	/* Coerce/coerce.scm 15 */
									int BgL_auxz00_3410;

									BgL_auxz00_3410 = (int) (BgL_iz00_3383);
									CNST_TABLE_SET(BgL_auxz00_3410, BgL_arg3973z00_3386);
							}}
							{	/* Coerce/coerce.scm 15 */
								int BgL_auxz00_3389;

								BgL_auxz00_3389 = (int) ((BgL_iz00_3383 - ((long) 1)));
								{
									long BgL_iz00_3415;

									BgL_iz00_3415 = (long) (BgL_auxz00_3389);
									BgL_iz00_3383 = BgL_iz00_3415;
									goto BgL_loopz00_3384;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
			return BUNSPEC;
		}
	}



/* coerce-function! */
	BGL_EXPORTED_DEF obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt
		BgL_variablez00_1, bool_t BgL_typezd2safezd2_2)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 45 */
			{	/* Coerce/coerce.scm 47 */
				obj_t BgL_arg3537z00_901;

				BgL_arg3537z00_901 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_idz00);
				BGl_enterzd2functionzd2zztools_errorz00(BgL_arg3537z00_901);
			}
			{	/* Coerce/coerce.scm 48 */
				BgL_valuez00_bglt BgL_funz00_902;

				BgL_funz00_902 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00);
				{	/* Coerce/coerce.scm 48 */
					obj_t BgL_bodyz00_903;

					{
						BgL_sfunz00_bglt BgL_auxz00_3420;

						BgL_auxz00_3420 = (BgL_sfunz00_bglt) (BgL_funz00_902);
						BgL_bodyz00_903 =
							(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3420))->BgL_bodyz00);
					}
					{	/* Coerce/coerce.scm 49 */
						BgL_typez00_bglt BgL_tresz00_904;

						BgL_tresz00_904 =
							(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_typez00);
						{	/* Coerce/coerce.scm 50 */
							obj_t BgL_cloz00_905;

							{
								BgL_sfunz00_bglt BgL_auxz00_3424;

								BgL_auxz00_3424 = (BgL_sfunz00_bglt) (BgL_funz00_902);
								BgL_cloz00_905 =
									(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3424))->
									BgL_thezd2closurezd2globalz00);
							}
							{	/* Coerce/coerce.scm 51 */
								bool_t BgL_typezd2safetyzd2enforcedz00_906;

								{	/* Coerce/coerce.scm 52 */
									bool_t BgL_testz00_3427;

									if (CBOOL(BGl_za2unsafezd2evalza2zd2zzengine_paramz00))
										{	/* Coerce/coerce.scm 52 */
											BgL_testz00_3427 = ((bool_t) 0);
										}
									else
										{	/* Coerce/coerce.scm 52 */
											BgL_testz00_3427 = ((bool_t) 1);
										}
									if (BgL_testz00_3427)
										{	/* Coerce/coerce.scm 53 */
											bool_t BgL_testz00_3430;

											{	/* Coerce/coerce.scm 53 */
												obj_t BgL_obj1920z00_1805;

												BgL_obj1920z00_1805 = (obj_t) (BgL_variablez00_1);
												BgL_testz00_3430 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1920z00_1805,
													BGl_globalz00zzast_varz00);
											}
											if (BgL_testz00_3430)
												{	/* Coerce/coerce.scm 53 */
													if (BGl_iszd2azf3z21zz__objectz00(BgL_cloz00_905,
															BGl_globalz00zzast_varz00))
														{	/* Coerce/coerce.scm 55 */
															bool_t BgL_testz00_3435;

															{
																BgL_globalz00_bglt BgL_auxz00_3436;

																BgL_auxz00_3436 =
																	(BgL_globalz00_bglt) (BgL_cloz00_905);
																BgL_testz00_3435 =
																	(((BgL_globalz00_bglt)
																		CREF(BgL_auxz00_3436))->
																	BgL_evaluablezf3zf3);
															}
															if (BgL_testz00_3435)
																{
																	BgL_globalz00_bglt BgL_auxz00_3439;

																	BgL_auxz00_3439 =
																		(BgL_globalz00_bglt) (BgL_cloz00_905);
																	BgL_typezd2safetyzd2enforcedz00_906 =
																		(((BgL_globalz00_bglt)
																			CREF(BgL_auxz00_3439))->BgL_userzf3zf3);
																}
															else
																{	/* Coerce/coerce.scm 55 */
																	BgL_typezd2safetyzd2enforcedz00_906 =
																		((bool_t) 0);
																}
														}
													else
														{	/* Coerce/coerce.scm 54 */
															BgL_typezd2safetyzd2enforcedz00_906 =
																((bool_t) 0);
														}
												}
											else
												{	/* Coerce/coerce.scm 53 */
													BgL_typezd2safetyzd2enforcedz00_906 = ((bool_t) 0);
												}
										}
									else
										{	/* Coerce/coerce.scm 52 */
											BgL_typezd2safetyzd2enforcedz00_906 = ((bool_t) 0);
										}
								}
								{	/* Coerce/coerce.scm 52 */
									bool_t BgL_typezd2safezd2_907;

									if (BgL_typezd2safezd2_2)
										{	/* Coerce/coerce.scm 57 */
											BgL_typezd2safezd2_907 = BgL_typezd2safezd2_2;
										}
									else
										{	/* Coerce/coerce.scm 57 */
											BgL_typezd2safezd2_907 =
												BgL_typezd2safetyzd2enforcedz00_906;
										}
									{	/* Coerce/coerce.scm 57 */

										{	/* Coerce/coerce.scm 58 */
											bool_t BgL_testz00_3443;

											{	/* Coerce/coerce.scm 58 */
												obj_t BgL_obj1920z00_1809;

												BgL_obj1920z00_1809 = (obj_t) (BgL_variablez00_1);
												BgL_testz00_3443 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1920z00_1809,
													BGl_globalz00zzast_varz00);
											}
											if (BgL_testz00_3443)
												{	/* Coerce/coerce.scm 58 */
													BNIL;
												}
											else
												{	/* Coerce/coerce.scm 58 */
													BNIL;
												}
										}
										BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(((long) 3),
											BgL_variablez00_1);
										BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 =
											(obj_t) (BgL_variablez00_1);
										{	/* Coerce/coerce.scm 68 */
											BgL_nodez00_bglt BgL_arg3539z00_909;

											{	/* Coerce/coerce.scm 68 */
												BgL_nodez00_bglt BgL_res3831z00_1839;

												{	/* Coerce/coerce.scm 68 */
													BgL_nodez00_bglt BgL_nodez00_1810;

													obj_t BgL_callerz00_1811;

													BgL_nodez00_1810 =
														(BgL_nodez00_bglt) (BgL_bodyz00_903);
													BgL_callerz00_1811 = (obj_t) (BgL_variablez00_1);
													{	/* Coerce/coerce.scm 68 */
														obj_t BgL_method3484z00_1814;

														{	/* Coerce/coerce.scm 68 */
															BgL_objectz00_bglt BgL_objz00_1815;

															BgL_objz00_1815 =
																(BgL_objectz00_bglt) (BgL_nodez00_1810);
															{	/* Coerce/coerce.scm 68 */
																long BgL_objzd2classzd2numz00_1816;

																BgL_objzd2classzd2numz00_1816 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1815);
																{	/* Coerce/coerce.scm 68 */
																	obj_t BgL_arg2551z00_1817;

																	BgL_arg2551z00_1817 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 68 */
																		obj_t BgL_arrayz00_1819;

																		int BgL_offsetz00_1820;

																		BgL_arrayz00_1819 = BgL_arg2551z00_1817;
																		BgL_offsetz00_1820 =
																			(int) (BgL_objzd2classzd2numz00_1816);
																		{	/* Coerce/coerce.scm 68 */
																			long BgL_offsetz00_1821;

																			BgL_offsetz00_1821 =
																				(
																				(long) (BgL_offsetz00_1820) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 68 */
																				long BgL_modz00_1822;

																				{	/* Coerce/coerce.scm 68 */
																					int BgL_arg2553z00_1823;

																					BgL_arg2553z00_1823 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 68 */
																						long BgL_auxz00_3458;

																						BgL_auxz00_3458 =
																							(long) (BgL_arg2553z00_1823);
																						BgL_modz00_1822 =
																							(BgL_offsetz00_1821 /
																							BgL_auxz00_3458);
																				}}
																				{	/* Coerce/coerce.scm 68 */
																					long BgL_restz00_1824;

																					{	/* Coerce/coerce.scm 68 */
																						int BgL_arg2552z00_1825;

																						BgL_arg2552z00_1825 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 68 */
																							long BgL_auxz00_3462;

																							BgL_auxz00_3462 =
																								(long) (BgL_arg2552z00_1825);
																							BgL_restz00_1824 =
																								(BgL_offsetz00_1821 %
																								BgL_auxz00_3462);
																					}}
																					{	/* Coerce/coerce.scm 68 */

																						BgL_method3484z00_1814 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1819,
																								(int) (BgL_modz00_1822)),
																							(int) (BgL_restz00_1824));
														}}}}}}}}
														BgL_res3831z00_1839 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3484z00_1814) (BgL_method3484z00_1814,
																(obj_t) (BgL_nodez00_1810), BgL_callerz00_1811,
																(obj_t) (BgL_tresz00_904),
																BBOOL(BgL_typezd2safezd2_907), BEOA));
												}}
												BgL_arg3539z00_909 = BgL_res3831z00_1839;
											}
											{
												obj_t BgL_auxz00_3477;

												BgL_sfunz00_bglt BgL_auxz00_3475;

												BgL_auxz00_3477 = (obj_t) (BgL_arg3539z00_909);
												BgL_auxz00_3475 = (BgL_sfunz00_bglt) (BgL_funz00_902);
												((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3475))->
														BgL_bodyz00) = ((obj_t) BgL_auxz00_3477), BUNSPEC);
										}}
										return BGl_leavezd2functionzd2zztools_errorz00();
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* _coerce-function! */
	obj_t BGl__coercezd2functionz12zc0zzcoerce_coercez00(obj_t BgL_envz00_3219,
		obj_t BgL_variablez00_3220, obj_t BgL_typezd2safezd2_3221)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 45 */
			return
				BGl_coercezd2functionz12zc0zzcoerce_coercez00(
				(BgL_variablez00_bglt) (BgL_variablez00_3220),
				CBOOL(BgL_typezd2safezd2_3221));
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_coercez12zd2default3483zd2envz12zzcoerce_coercez00);
		}
	}



/* coerce! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt BgL_nodez00_3,
		obj_t BgL_callerz00_4, BgL_typez00_bglt BgL_toz00_5, bool_t BgL_safez00_6)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 74 */
			{	/* Coerce/coerce.scm 74 */
				obj_t BgL_method3484z00_1842;

				{	/* Coerce/coerce.scm 74 */
					BgL_objectz00_bglt BgL_objz00_1843;

					BgL_objz00_1843 = (BgL_objectz00_bglt) (BgL_nodez00_3);
					{	/* Coerce/coerce.scm 74 */
						long BgL_objzd2classzd2numz00_1844;

						BgL_objzd2classzd2numz00_1844 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1843);
						{	/* Coerce/coerce.scm 74 */
							obj_t BgL_arg2551z00_1845;

							BgL_arg2551z00_1845 =
								PROCEDURE_REF(BGl_coercez12zd2envzc0zzcoerce_coercez00,
								(int) (((long) 1)));
							{	/* Coerce/coerce.scm 74 */
								obj_t BgL_arrayz00_1847;

								int BgL_offsetz00_1848;

								BgL_arrayz00_1847 = BgL_arg2551z00_1845;
								BgL_offsetz00_1848 = (int) (BgL_objzd2classzd2numz00_1844);
								{	/* Coerce/coerce.scm 74 */
									long BgL_offsetz00_1849;

									BgL_offsetz00_1849 =
										((long) (BgL_offsetz00_1848) - OBJECT_TYPE);
									{	/* Coerce/coerce.scm 74 */
										long BgL_modz00_1850;

										{	/* Coerce/coerce.scm 74 */
											int BgL_arg2553z00_1851;

											BgL_arg2553z00_1851 = (int) (((long) 8));
											{	/* Coerce/coerce.scm 74 */
												long BgL_auxz00_3493;

												BgL_auxz00_3493 = (long) (BgL_arg2553z00_1851);
												BgL_modz00_1850 =
													(BgL_offsetz00_1849 / BgL_auxz00_3493);
										}}
										{	/* Coerce/coerce.scm 74 */
											long BgL_restz00_1852;

											{	/* Coerce/coerce.scm 74 */
												int BgL_arg2552z00_1853;

												BgL_arg2552z00_1853 = (int) (((long) 8));
												{	/* Coerce/coerce.scm 74 */
													long BgL_auxz00_3497;

													BgL_auxz00_3497 = (long) (BgL_arg2552z00_1853);
													BgL_restz00_1852 =
														(BgL_offsetz00_1849 % BgL_auxz00_3497);
											}}
											{	/* Coerce/coerce.scm 74 */

												BgL_method3484z00_1842 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1847,
														(int) (BgL_modz00_1850)), (int) (BgL_restz00_1852));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3484z00_1842)
					(BgL_method3484z00_1842, (obj_t) (BgL_nodez00_3), BgL_callerz00_4,
						(obj_t) (BgL_toz00_5), BBOOL(BgL_safez00_6), BEOA));
			}
		}
	}



/* _coerce! */
	obj_t BGl__coercez12z12zzcoerce_coercez00(obj_t BgL_envz00_3222,
		obj_t BgL_nodez00_3223, obj_t BgL_callerz00_3224, obj_t BgL_toz00_3225,
		obj_t BgL_safez00_3226)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 74 */
			return
				(obj_t) (BGl_coercez12z12zzcoerce_coercez00(
					(BgL_nodez00_bglt) (BgL_nodez00_3223), BgL_callerz00_3224,
					(BgL_typez00_bglt) (BgL_toz00_3225), CBOOL(BgL_safez00_3226)));
		}
	}



/* coerce!-default3483 */
	BgL_nodez00_bglt
		BGl_coercez12zd2default3483zc0zzcoerce_coercez00(BgL_nodez00_bglt
		BgL_nodez00_7, obj_t BgL_callerz00_8, BgL_typez00_bglt BgL_toz00_9,
		bool_t BgL_safez00_10)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string3942z00zzcoerce_coercez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _coerce!-default3483 */
	obj_t BGl__coercez12zd2default3483zc0zzcoerce_coercez00(obj_t BgL_envz00_3227,
		obj_t BgL_nodez00_3228, obj_t BgL_callerz00_3229, obj_t BgL_toz00_3230,
		obj_t BgL_safez00_3231)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				(obj_t) (BGl_coercez12zd2default3483zc0zzcoerce_coercez00(
					(BgL_nodez00_bglt) (BgL_nodez00_3228), BgL_callerz00_3229,
					(BgL_typez00_bglt) (BgL_toz00_3230), CBOOL(BgL_safez00_3231)));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_atomz00zzast_nodez00,
				BGl_proc3943z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_kwotez00zzast_nodez00,
				BGl_proc3944z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_varz00zzast_nodez00,
				BGl_proc3945z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_closurez00zzast_nodez00,
				BGl_proc3946z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_sequencez00zzast_nodez00,
				BGl_proc3947z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_externz00zzast_nodez00,
				BGl_proc3948z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_getfieldz00zzast_nodez00,
				BGl_proc3949z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setfieldz00zzast_nodez00,
				BGl_proc3950z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_newz00zzast_nodez00,
				BGl_proc3951z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vallocz00zzast_nodez00,
				BGl_proc3952z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vrefz00zzast_nodez00,
				BGl_proc3953z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vsetz12z12zzast_nodez00,
				BGl_proc3954z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vlengthz00zzast_nodez00,
				BGl_proc3955z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_castz00zzast_nodez00,
				BGl_proc3956z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setqz00zzast_nodez00,
				BGl_proc3957z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3958z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_failz00zzast_nodez00,
				BGl_proc3959z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_selectz00zzast_nodez00,
				BGl_proc3960z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3961z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3962z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3963z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3964z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3965z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3966z00zzcoerce_coercez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3967z00zzcoerce_coercez00);
		}
	}



/* coerce!-box-set!3536 */
	obj_t BGl_coercez12zd2boxzd2setz123536z00zzcoerce_coercez00(obj_t
		BgL_envz00_3257, obj_t BgL_nodez00_3258, obj_t BgL_callerz00_3259,
		obj_t BgL_toz00_3260, obj_t BgL_safez00_3261)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 438 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1787;

				obj_t BgL_callerz00_1788;

				obj_t BgL_toz00_1789;

				obj_t BgL_safez00_1790;

				{	/* Coerce/coerce.scm 439 */
					BgL_nodez00_bglt BgL_auxz00_3549;

					BgL_nodez00_1787 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3258);
					BgL_callerz00_1788 = BgL_callerz00_3259;
					BgL_toz00_1789 = BgL_toz00_3260;
					BgL_safez00_1790 = BgL_safez00_3261;
					{	/* Coerce/coerce.scm 440 */
						BgL_variablez00_bglt BgL_arg3824z00_1794;

						{	/* Coerce/coerce.scm 440 */
							BgL_varz00_bglt BgL_obj2324z00_3183;

							BgL_obj2324z00_3183 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1787))->
								BgL_varz00);
							BgL_arg3824z00_1794 =
								(((BgL_varz00_bglt) CREF(BgL_obj2324z00_3183))->
								BgL_variablez00);
						}
						{
							BgL_typez00_bglt BgL_auxz00_3552;

							BgL_auxz00_3552 =
								(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
							((((BgL_variablez00_bglt) CREF(BgL_arg3824z00_1794))->
									BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_3552), BUNSPEC);
						}
					}
					{	/* Coerce/coerce.scm 441 */
						BgL_nodez00_bglt BgL_arg3826z00_1796;

						{	/* Coerce/coerce.scm 441 */
							BgL_nodez00_bglt BgL_arg3827z00_1797;

							BgL_arg3827z00_1797 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1787))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 441 */
								BgL_nodez00_bglt BgL_res3941z00_3216;

								{	/* Coerce/coerce.scm 441 */
									BgL_typez00_bglt BgL_toz00_3189;

									bool_t BgL_safez00_3190;

									BgL_toz00_3189 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_3190 = CBOOL(BgL_safez00_1790);
									{	/* Coerce/coerce.scm 441 */
										obj_t BgL_method3484z00_3191;

										{	/* Coerce/coerce.scm 441 */
											BgL_objectz00_bglt BgL_objz00_3192;

											BgL_objz00_3192 =
												(BgL_objectz00_bglt) (BgL_arg3827z00_1797);
											{	/* Coerce/coerce.scm 441 */
												long BgL_objzd2classzd2numz00_3193;

												BgL_objzd2classzd2numz00_3193 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3192);
												{	/* Coerce/coerce.scm 441 */
													obj_t BgL_arg2551z00_3194;

													BgL_arg2551z00_3194 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 441 */
														obj_t BgL_arrayz00_3196;

														int BgL_offsetz00_3197;

														BgL_arrayz00_3196 = BgL_arg2551z00_3194;
														BgL_offsetz00_3197 =
															(int) (BgL_objzd2classzd2numz00_3193);
														{	/* Coerce/coerce.scm 441 */
															long BgL_offsetz00_3198;

															BgL_offsetz00_3198 =
																((long) (BgL_offsetz00_3197) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 441 */
																long BgL_modz00_3199;

																{	/* Coerce/coerce.scm 441 */
																	int BgL_arg2553z00_3200;

																	BgL_arg2553z00_3200 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 441 */
																		long BgL_auxz00_3566;

																		BgL_auxz00_3566 =
																			(long) (BgL_arg2553z00_3200);
																		BgL_modz00_3199 =
																			(BgL_offsetz00_3198 / BgL_auxz00_3566);
																}}
																{	/* Coerce/coerce.scm 441 */
																	long BgL_restz00_3201;

																	{	/* Coerce/coerce.scm 441 */
																		int BgL_arg2552z00_3202;

																		BgL_arg2552z00_3202 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 441 */
																			long BgL_auxz00_3570;

																			BgL_auxz00_3570 =
																				(long) (BgL_arg2552z00_3202);
																			BgL_restz00_3201 =
																				(BgL_offsetz00_3198 % BgL_auxz00_3570);
																	}}
																	{	/* Coerce/coerce.scm 441 */

																		BgL_method3484z00_3191 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3196,
																				(int) (BgL_modz00_3199)),
																			(int) (BgL_restz00_3201));
										}}}}}}}}
										BgL_res3941z00_3216 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3191) (BgL_method3484z00_3191,
												(obj_t) (BgL_arg3827z00_1797), BgL_callerz00_1788,
												(obj_t) (BgL_toz00_3189), BBOOL(BgL_safez00_3190),
												BEOA));
								}}
								BgL_arg3826z00_1796 = BgL_res3941z00_3216;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1787))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3826z00_1796), BUNSPEC);
					}
					BgL_auxz00_3549 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1787),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1789), CBOOL(BgL_safez00_1790));
					return (obj_t) (BgL_auxz00_3549);
				}
			}
		}
	}



/* coerce!-box-ref3534 */
	obj_t BGl_coercez12zd2boxzd2ref3534z12zzcoerce_coercez00(obj_t
		BgL_envz00_3262, obj_t BgL_nodez00_3263, obj_t BgL_callerz00_3264,
		obj_t BgL_toz00_3265, obj_t BgL_safez00_3266)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 431 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1778;

				obj_t BgL_callerz00_1779;

				obj_t BgL_toz00_1780;

				obj_t BgL_safez00_1781;

				{	/* Coerce/coerce.scm 433 */
					BgL_nodez00_bglt BgL_auxz00_3591;

					BgL_nodez00_1778 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3263);
					BgL_callerz00_1779 = BgL_callerz00_3264;
					BgL_toz00_1780 = BgL_toz00_3265;
					BgL_safez00_1781 = BgL_safez00_3266;
					BgL_auxz00_3591 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1778),
						(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1780), CBOOL(BgL_safez00_1781));
					return (obj_t) (BgL_auxz00_3591);
				}
			}
		}
	}



/* coerce!-make-box3532 */
	obj_t BGl_coercez12zd2makezd2box3532z12zzcoerce_coercez00(obj_t
		BgL_envz00_3267, obj_t BgL_nodez00_3268, obj_t BgL_callerz00_3269,
		obj_t BgL_toz00_3270, obj_t BgL_safez00_3271)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 423 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1767;

				obj_t BgL_callerz00_1768;

				obj_t BgL_toz00_1769;

				obj_t BgL_safez00_1770;

				{	/* Coerce/coerce.scm 424 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3599;

					BgL_nodez00_1767 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3268);
					BgL_callerz00_1768 = BgL_callerz00_3269;
					BgL_toz00_1769 = BgL_toz00_3270;
					BgL_safez00_1770 = BgL_safez00_3271;
					{	/* Coerce/coerce.scm 424 */
						BgL_nodez00_bglt BgL_arg3820z00_3147;

						{	/* Coerce/coerce.scm 424 */
							BgL_nodez00_bglt BgL_arg3821z00_3148;

							BgL_arg3821z00_3148 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1767))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 424 */
								BgL_nodez00_bglt BgL_res3938z00_3179;

								{	/* Coerce/coerce.scm 424 */
									BgL_typez00_bglt BgL_toz00_3152;

									bool_t BgL_safez00_3153;

									BgL_toz00_3152 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_3153 = CBOOL(BgL_safez00_1770);
									{	/* Coerce/coerce.scm 424 */
										obj_t BgL_method3484z00_3154;

										{	/* Coerce/coerce.scm 424 */
											BgL_objectz00_bglt BgL_objz00_3155;

											BgL_objz00_3155 =
												(BgL_objectz00_bglt) (BgL_arg3821z00_3148);
											{	/* Coerce/coerce.scm 424 */
												long BgL_objzd2classzd2numz00_3156;

												BgL_objzd2classzd2numz00_3156 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3155);
												{	/* Coerce/coerce.scm 424 */
													obj_t BgL_arg2551z00_3157;

													BgL_arg2551z00_3157 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 424 */
														obj_t BgL_arrayz00_3159;

														int BgL_offsetz00_3160;

														BgL_arrayz00_3159 = BgL_arg2551z00_3157;
														BgL_offsetz00_3160 =
															(int) (BgL_objzd2classzd2numz00_3156);
														{	/* Coerce/coerce.scm 424 */
															long BgL_offsetz00_3161;

															BgL_offsetz00_3161 =
																((long) (BgL_offsetz00_3160) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 424 */
																long BgL_modz00_3162;

																{	/* Coerce/coerce.scm 424 */
																	int BgL_arg2553z00_3163;

																	BgL_arg2553z00_3163 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 424 */
																		long BgL_auxz00_3611;

																		BgL_auxz00_3611 =
																			(long) (BgL_arg2553z00_3163);
																		BgL_modz00_3162 =
																			(BgL_offsetz00_3161 / BgL_auxz00_3611);
																}}
																{	/* Coerce/coerce.scm 424 */
																	long BgL_restz00_3164;

																	{	/* Coerce/coerce.scm 424 */
																		int BgL_arg2552z00_3165;

																		BgL_arg2552z00_3165 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 424 */
																			long BgL_auxz00_3615;

																			BgL_auxz00_3615 =
																				(long) (BgL_arg2552z00_3165);
																			BgL_restz00_3164 =
																				(BgL_offsetz00_3161 % BgL_auxz00_3615);
																	}}
																	{	/* Coerce/coerce.scm 424 */

																		BgL_method3484z00_3154 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3159,
																				(int) (BgL_modz00_3162)),
																			(int) (BgL_restz00_3164));
										}}}}}}}}
										BgL_res3938z00_3179 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3154) (BgL_method3484z00_3154,
												(obj_t) (BgL_arg3821z00_3148), BgL_callerz00_1768,
												(obj_t) (BgL_toz00_3152), BBOOL(BgL_safez00_3153),
												BEOA));
								}}
								BgL_arg3820z00_3147 = BgL_res3938z00_3179;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1767))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3820z00_3147), BUNSPEC);
					}
					BgL_auxz00_3599 = BgL_nodez00_1767;
					return (obj_t) (BgL_auxz00_3599);
				}
			}
		}
	}



/* coerce!-jump-ex-it3530 */
	obj_t BGl_coercez12zd2jumpzd2exzd2it3530zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3272, obj_t BgL_nodez00_3273, obj_t BgL_callerz00_3274,
		obj_t BgL_toz00_3275, obj_t BgL_safez00_3276)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 414 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1754;

				obj_t BgL_callerz00_1755;

				obj_t BgL_toz00_1756;

				obj_t BgL_safez00_1757;

				{	/* Coerce/coerce.scm 415 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3631;

					BgL_nodez00_1754 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3273);
					BgL_callerz00_1755 = BgL_callerz00_3274;
					BgL_toz00_1756 = BgL_toz00_3275;
					BgL_safez00_1757 = BgL_safez00_3276;
					{	/* Coerce/coerce.scm 416 */
						BgL_nodez00_bglt BgL_arg3814z00_1761;

						{	/* Coerce/coerce.scm 416 */
							BgL_nodez00_bglt BgL_arg3815z00_1762;

							BgL_arg3815z00_1762 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_exitz00);
							{	/* Coerce/coerce.scm 416 */
								BgL_nodez00_bglt BgL_res3932z00_3110;

								{	/* Coerce/coerce.scm 416 */
									BgL_typez00_bglt BgL_toz00_3083;

									bool_t BgL_safez00_3084;

									BgL_toz00_3083 =
										(BgL_typez00_bglt) (BGl_za2exitza2z00zztype_cachez00);
									BgL_safez00_3084 = CBOOL(BgL_safez00_1757);
									{	/* Coerce/coerce.scm 416 */
										obj_t BgL_method3484z00_3085;

										{	/* Coerce/coerce.scm 416 */
											BgL_objectz00_bglt BgL_objz00_3086;

											BgL_objz00_3086 =
												(BgL_objectz00_bglt) (BgL_arg3815z00_1762);
											{	/* Coerce/coerce.scm 416 */
												long BgL_objzd2classzd2numz00_3087;

												BgL_objzd2classzd2numz00_3087 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3086);
												{	/* Coerce/coerce.scm 416 */
													obj_t BgL_arg2551z00_3088;

													BgL_arg2551z00_3088 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 416 */
														obj_t BgL_arrayz00_3090;

														int BgL_offsetz00_3091;

														BgL_arrayz00_3090 = BgL_arg2551z00_3088;
														BgL_offsetz00_3091 =
															(int) (BgL_objzd2classzd2numz00_3087);
														{	/* Coerce/coerce.scm 416 */
															long BgL_offsetz00_3092;

															BgL_offsetz00_3092 =
																((long) (BgL_offsetz00_3091) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 416 */
																long BgL_modz00_3093;

																{	/* Coerce/coerce.scm 416 */
																	int BgL_arg2553z00_3094;

																	BgL_arg2553z00_3094 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 416 */
																		long BgL_auxz00_3643;

																		BgL_auxz00_3643 =
																			(long) (BgL_arg2553z00_3094);
																		BgL_modz00_3093 =
																			(BgL_offsetz00_3092 / BgL_auxz00_3643);
																}}
																{	/* Coerce/coerce.scm 416 */
																	long BgL_restz00_3095;

																	{	/* Coerce/coerce.scm 416 */
																		int BgL_arg2552z00_3096;

																		BgL_arg2552z00_3096 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 416 */
																			long BgL_auxz00_3647;

																			BgL_auxz00_3647 =
																				(long) (BgL_arg2552z00_3096);
																			BgL_restz00_3095 =
																				(BgL_offsetz00_3092 % BgL_auxz00_3647);
																	}}
																	{	/* Coerce/coerce.scm 416 */

																		BgL_method3484z00_3085 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3090,
																				(int) (BgL_modz00_3093)),
																			(int) (BgL_restz00_3095));
										}}}}}}}}
										BgL_res3932z00_3110 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3085) (BgL_method3484z00_3085,
												(obj_t) (BgL_arg3815z00_1762), BgL_callerz00_1755,
												(obj_t) (BgL_toz00_3083), BBOOL(BgL_safez00_3084),
												BEOA));
								}}
								BgL_arg3814z00_1761 = BgL_res3932z00_3110;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3814z00_1761), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 417 */
						BgL_nodez00_bglt BgL_arg3817z00_1763;

						{	/* Coerce/coerce.scm 417 */
							BgL_nodez00_bglt BgL_arg3818z00_1764;

							BgL_arg3818z00_1764 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 417 */
								BgL_nodez00_bglt BgL_res3935z00_3143;

								{	/* Coerce/coerce.scm 417 */
									BgL_typez00_bglt BgL_toz00_3116;

									bool_t BgL_safez00_3117;

									BgL_toz00_3116 = (BgL_typez00_bglt) (BgL_toz00_1756);
									BgL_safez00_3117 = CBOOL(BgL_safez00_1757);
									{	/* Coerce/coerce.scm 417 */
										obj_t BgL_method3484z00_3118;

										{	/* Coerce/coerce.scm 417 */
											BgL_objectz00_bglt BgL_objz00_3119;

											BgL_objz00_3119 =
												(BgL_objectz00_bglt) (BgL_arg3818z00_1764);
											{	/* Coerce/coerce.scm 417 */
												long BgL_objzd2classzd2numz00_3120;

												BgL_objzd2classzd2numz00_3120 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3119);
												{	/* Coerce/coerce.scm 417 */
													obj_t BgL_arg2551z00_3121;

													BgL_arg2551z00_3121 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 417 */
														obj_t BgL_arrayz00_3123;

														int BgL_offsetz00_3124;

														BgL_arrayz00_3123 = BgL_arg2551z00_3121;
														BgL_offsetz00_3124 =
															(int) (BgL_objzd2classzd2numz00_3120);
														{	/* Coerce/coerce.scm 417 */
															long BgL_offsetz00_3125;

															BgL_offsetz00_3125 =
																((long) (BgL_offsetz00_3124) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 417 */
																long BgL_modz00_3126;

																{	/* Coerce/coerce.scm 417 */
																	int BgL_arg2553z00_3127;

																	BgL_arg2553z00_3127 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 417 */
																		long BgL_auxz00_3672;

																		BgL_auxz00_3672 =
																			(long) (BgL_arg2553z00_3127);
																		BgL_modz00_3126 =
																			(BgL_offsetz00_3125 / BgL_auxz00_3672);
																}}
																{	/* Coerce/coerce.scm 417 */
																	long BgL_restz00_3128;

																	{	/* Coerce/coerce.scm 417 */
																		int BgL_arg2552z00_3129;

																		BgL_arg2552z00_3129 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 417 */
																			long BgL_auxz00_3676;

																			BgL_auxz00_3676 =
																				(long) (BgL_arg2552z00_3129);
																			BgL_restz00_3128 =
																				(BgL_offsetz00_3125 % BgL_auxz00_3676);
																	}}
																	{	/* Coerce/coerce.scm 417 */

																		BgL_method3484z00_3118 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3123,
																				(int) (BgL_modz00_3126)),
																			(int) (BgL_restz00_3128));
										}}}}}}}}
										BgL_res3935z00_3143 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3118) (BgL_method3484z00_3118,
												(obj_t) (BgL_arg3818z00_1764), BgL_callerz00_1755,
												(obj_t) (BgL_toz00_3116), BBOOL(BgL_safez00_3117),
												BEOA));
								}}
								BgL_arg3817z00_1763 = BgL_res3935z00_3143;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3817z00_1763), BUNSPEC);
					}
					BgL_auxz00_3631 = BgL_nodez00_1754;
					return (obj_t) (BgL_auxz00_3631);
				}
			}
		}
	}



/* coerce!-set-ex-it3528 */
	obj_t BGl_coercez12zd2setzd2exzd2it3528zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3277, obj_t BgL_nodez00_3278, obj_t BgL_callerz00_3279,
		obj_t BgL_toz00_3280, obj_t BgL_safez00_3281)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 404 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1738;

				obj_t BgL_callerz00_1739;

				obj_t BgL_toz00_1740;

				obj_t BgL_safez00_1741;

				{	/* Coerce/coerce.scm 405 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3692;

					BgL_nodez00_1738 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3278);
					BgL_callerz00_1739 = BgL_callerz00_3279;
					BgL_toz00_1740 = BgL_toz00_3280;
					BgL_safez00_1741 = BgL_safez00_3281;
					{	/* Coerce/coerce.scm 406 */
						BgL_nodez00_bglt BgL_arg3806z00_1745;

						{	/* Coerce/coerce.scm 406 */
							BgL_varz00_bglt BgL_arg3807z00_1746;

							BgL_arg3807z00_1746 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1738))->
								BgL_varz00);
							{	/* Coerce/coerce.scm 406 */
								BgL_nodez00_bglt BgL_res3926z00_3042;

								{	/* Coerce/coerce.scm 406 */
									BgL_nodez00_bglt BgL_nodez00_3013;

									BgL_typez00_bglt BgL_toz00_3015;

									bool_t BgL_safez00_3016;

									BgL_nodez00_3013 = (BgL_nodez00_bglt) (BgL_arg3807z00_1746);
									BgL_toz00_3015 =
										(BgL_typez00_bglt) (BGl_za2exitza2z00zztype_cachez00);
									BgL_safez00_3016 = CBOOL(BgL_safez00_1741);
									{	/* Coerce/coerce.scm 406 */
										obj_t BgL_method3484z00_3017;

										{	/* Coerce/coerce.scm 406 */
											BgL_objectz00_bglt BgL_objz00_3018;

											BgL_objz00_3018 = (BgL_objectz00_bglt) (BgL_nodez00_3013);
											{	/* Coerce/coerce.scm 406 */
												long BgL_objzd2classzd2numz00_3019;

												BgL_objzd2classzd2numz00_3019 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3018);
												{	/* Coerce/coerce.scm 406 */
													obj_t BgL_arg2551z00_3020;

													BgL_arg2551z00_3020 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 406 */
														obj_t BgL_arrayz00_3022;

														int BgL_offsetz00_3023;

														BgL_arrayz00_3022 = BgL_arg2551z00_3020;
														BgL_offsetz00_3023 =
															(int) (BgL_objzd2classzd2numz00_3019);
														{	/* Coerce/coerce.scm 406 */
															long BgL_offsetz00_3024;

															BgL_offsetz00_3024 =
																((long) (BgL_offsetz00_3023) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 406 */
																long BgL_modz00_3025;

																{	/* Coerce/coerce.scm 406 */
																	int BgL_arg2553z00_3026;

																	BgL_arg2553z00_3026 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 406 */
																		long BgL_auxz00_3705;

																		BgL_auxz00_3705 =
																			(long) (BgL_arg2553z00_3026);
																		BgL_modz00_3025 =
																			(BgL_offsetz00_3024 / BgL_auxz00_3705);
																}}
																{	/* Coerce/coerce.scm 406 */
																	long BgL_restz00_3027;

																	{	/* Coerce/coerce.scm 406 */
																		int BgL_arg2552z00_3028;

																		BgL_arg2552z00_3028 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 406 */
																			long BgL_auxz00_3709;

																			BgL_auxz00_3709 =
																				(long) (BgL_arg2552z00_3028);
																			BgL_restz00_3027 =
																				(BgL_offsetz00_3024 % BgL_auxz00_3709);
																	}}
																	{	/* Coerce/coerce.scm 406 */

																		BgL_method3484z00_3017 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3022,
																				(int) (BgL_modz00_3025)),
																			(int) (BgL_restz00_3027));
										}}}}}}}}
										BgL_res3926z00_3042 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3017) (BgL_method3484z00_3017,
												(obj_t) (BgL_nodez00_3013), BgL_callerz00_1739,
												(obj_t) (BgL_toz00_3015), BBOOL(BgL_safez00_3016),
												BEOA));
								}}
								BgL_arg3806z00_1745 = BgL_res3926z00_3042;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3722;

							BgL_auxz00_3722 = (BgL_varz00_bglt) (BgL_arg3806z00_1745);
							((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1738))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3722), BUNSPEC);
					}}
					{	/* Coerce/coerce.scm 407 */
						BgL_variablez00_bglt BgL_arg3809z00_1748;

						{	/* Coerce/coerce.scm 407 */
							BgL_varz00_bglt BgL_obj2324z00_3046;

							BgL_obj2324z00_3046 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1738))->
								BgL_varz00);
							BgL_arg3809z00_1748 =
								(((BgL_varz00_bglt) CREF(BgL_obj2324z00_3046))->
								BgL_variablez00);
						}
						BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
							BgL_arg3809z00_1748);
					}
					{	/* Coerce/coerce.scm 408 */
						BgL_nodez00_bglt BgL_arg3811z00_1750;

						{	/* Coerce/coerce.scm 408 */
							BgL_nodez00_bglt BgL_arg3812z00_1751;

							BgL_arg3812z00_1751 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1738))->
								BgL_bodyz00);
							{	/* Coerce/coerce.scm 408 */
								BgL_nodez00_bglt BgL_res3929z00_3077;

								{	/* Coerce/coerce.scm 408 */
									BgL_typez00_bglt BgL_toz00_3050;

									bool_t BgL_safez00_3051;

									BgL_toz00_3050 = (BgL_typez00_bglt) (BgL_toz00_1740);
									BgL_safez00_3051 = CBOOL(BgL_safez00_1741);
									{	/* Coerce/coerce.scm 408 */
										obj_t BgL_method3484z00_3052;

										{	/* Coerce/coerce.scm 408 */
											BgL_objectz00_bglt BgL_objz00_3053;

											BgL_objz00_3053 =
												(BgL_objectz00_bglt) (BgL_arg3812z00_1751);
											{	/* Coerce/coerce.scm 408 */
												long BgL_objzd2classzd2numz00_3054;

												BgL_objzd2classzd2numz00_3054 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3053);
												{	/* Coerce/coerce.scm 408 */
													obj_t BgL_arg2551z00_3055;

													BgL_arg2551z00_3055 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 408 */
														obj_t BgL_arrayz00_3057;

														int BgL_offsetz00_3058;

														BgL_arrayz00_3057 = BgL_arg2551z00_3055;
														BgL_offsetz00_3058 =
															(int) (BgL_objzd2classzd2numz00_3054);
														{	/* Coerce/coerce.scm 408 */
															long BgL_offsetz00_3059;

															BgL_offsetz00_3059 =
																((long) (BgL_offsetz00_3058) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 408 */
																long BgL_modz00_3060;

																{	/* Coerce/coerce.scm 408 */
																	int BgL_arg2553z00_3061;

																	BgL_arg2553z00_3061 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 408 */
																		long BgL_auxz00_3739;

																		BgL_auxz00_3739 =
																			(long) (BgL_arg2553z00_3061);
																		BgL_modz00_3060 =
																			(BgL_offsetz00_3059 / BgL_auxz00_3739);
																}}
																{	/* Coerce/coerce.scm 408 */
																	long BgL_restz00_3062;

																	{	/* Coerce/coerce.scm 408 */
																		int BgL_arg2552z00_3063;

																		BgL_arg2552z00_3063 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 408 */
																			long BgL_auxz00_3743;

																			BgL_auxz00_3743 =
																				(long) (BgL_arg2552z00_3063);
																			BgL_restz00_3062 =
																				(BgL_offsetz00_3059 % BgL_auxz00_3743);
																	}}
																	{	/* Coerce/coerce.scm 408 */

																		BgL_method3484z00_3052 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3057,
																				(int) (BgL_modz00_3060)),
																			(int) (BgL_restz00_3062));
										}}}}}}}}
										BgL_res3929z00_3077 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_3052) (BgL_method3484z00_3052,
												(obj_t) (BgL_arg3812z00_1751), BgL_callerz00_1739,
												(obj_t) (BgL_toz00_3050), BBOOL(BgL_safez00_3051),
												BEOA));
								}}
								BgL_arg3811z00_1750 = BgL_res3929z00_3077;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1738))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3811z00_1750), BUNSPEC);
					}
					BgL_auxz00_3692 = BgL_nodez00_1738;
					return (obj_t) (BgL_auxz00_3692);
				}
			}
		}
	}



/* coerce!-let-var3526 */
	obj_t BGl_coercez12zd2letzd2var3526z12zzcoerce_coercez00(obj_t
		BgL_envz00_3282, obj_t BgL_nodez00_3283, obj_t BgL_callerz00_3284,
		obj_t BgL_toz00_3285, obj_t BgL_safez00_3286)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 385 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1713;

				obj_t BgL_callerz00_1714;

				obj_t BgL_toz00_1715;

				obj_t BgL_safez00_1716;

				{	/* Tools/trace.sch 53 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3759;

					BgL_nodez00_1713 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3283);
					BgL_callerz00_1714 = BgL_callerz00_3284;
					BgL_toz00_1715 = BgL_toz00_3285;
					BgL_safez00_1716 = BgL_safez00_3286;
					BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
					{	/* Coerce/coerce.scm 390 */
						obj_t BgL_g3482z00_1720;

						BgL_g3482z00_1720 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1713))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3480z00_1722;

							BgL_l3480z00_1722 = BgL_g3482z00_1720;
						BgL_zc3anonymousza33793ze3z83_1723:
							if (PAIRP(BgL_l3480z00_1722))
								{	/* Coerce/coerce.scm 390 */
									{	/* Coerce/coerce.scm 395 */
										obj_t BgL_bindingz00_1725;

										BgL_bindingz00_1725 = CAR(BgL_l3480z00_1722);
										{	/* Coerce/coerce.scm 391 */
											obj_t BgL_arg3796z00_1727;

											BgL_arg3796z00_1727 = CAR(BgL_bindingz00_1725);
											BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
												(BgL_variablez00_bglt) (BgL_arg3796z00_1727));
										}
										{	/* Coerce/coerce.scm 392 */
											BgL_nodez00_bglt BgL_arg3797z00_1728;

											{	/* Coerce/coerce.scm 392 */
												obj_t BgL_arg3798z00_1729;

												BgL_typez00_bglt BgL_arg3799z00_1730;

												BgL_arg3798z00_1729 = CDR(BgL_bindingz00_1725);
												{	/* Coerce/coerce.scm 394 */
													BgL_variablez00_bglt BgL_obj1777z00_2945;

													{	/* Coerce/coerce.scm 394 */
														obj_t BgL_pairz00_2944;

														BgL_pairz00_2944 = BgL_bindingz00_1725;
														BgL_obj1777z00_2945 =
															(BgL_variablez00_bglt) (CAR(BgL_pairz00_2944));
													}
													BgL_arg3799z00_1730 =
														(((BgL_variablez00_bglt)
															CREF(BgL_obj1777z00_2945))->BgL_typez00);
												}
												{	/* Coerce/coerce.scm 392 */
													BgL_nodez00_bglt BgL_res3920z00_2975;

													{	/* Coerce/coerce.scm 392 */
														BgL_nodez00_bglt BgL_nodez00_2946;

														bool_t BgL_safez00_2949;

														BgL_nodez00_2946 =
															(BgL_nodez00_bglt) (BgL_arg3798z00_1729);
														BgL_safez00_2949 = CBOOL(BgL_safez00_1716);
														{	/* Coerce/coerce.scm 392 */
															obj_t BgL_method3484z00_2950;

															{	/* Coerce/coerce.scm 392 */
																BgL_objectz00_bglt BgL_objz00_2951;

																BgL_objz00_2951 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2946);
																{	/* Coerce/coerce.scm 392 */
																	long BgL_objzd2classzd2numz00_2952;

																	BgL_objzd2classzd2numz00_2952 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2951);
																	{	/* Coerce/coerce.scm 392 */
																		obj_t BgL_arg2551z00_2953;

																		BgL_arg2551z00_2953 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 392 */
																			obj_t BgL_arrayz00_2955;

																			int BgL_offsetz00_2956;

																			BgL_arrayz00_2955 = BgL_arg2551z00_2953;
																			BgL_offsetz00_2956 =
																				(int) (BgL_objzd2classzd2numz00_2952);
																			{	/* Coerce/coerce.scm 392 */
																				long BgL_offsetz00_2957;

																				BgL_offsetz00_2957 =
																					(
																					(long) (BgL_offsetz00_2956) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 392 */
																					long BgL_modz00_2958;

																					{	/* Coerce/coerce.scm 392 */
																						int BgL_arg2553z00_2959;

																						BgL_arg2553z00_2959 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 392 */
																							long BgL_auxz00_3782;

																							BgL_auxz00_3782 =
																								(long) (BgL_arg2553z00_2959);
																							BgL_modz00_2958 =
																								(BgL_offsetz00_2957 /
																								BgL_auxz00_3782);
																					}}
																					{	/* Coerce/coerce.scm 392 */
																						long BgL_restz00_2960;

																						{	/* Coerce/coerce.scm 392 */
																							int BgL_arg2552z00_2961;

																							BgL_arg2552z00_2961 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 392 */
																								long BgL_auxz00_3786;

																								BgL_auxz00_3786 =
																									(long) (BgL_arg2552z00_2961);
																								BgL_restz00_2960 =
																									(BgL_offsetz00_2957 %
																									BgL_auxz00_3786);
																						}}
																						{	/* Coerce/coerce.scm 392 */

																							BgL_method3484z00_2950 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2955,
																									(int) (BgL_modz00_2958)),
																								(int) (BgL_restz00_2960));
															}}}}}}}}
															BgL_res3920z00_2975 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3484z00_2950)
																(BgL_method3484z00_2950,
																	(obj_t) (BgL_nodez00_2946),
																	BgL_callerz00_1714,
																	(obj_t) (BgL_arg3799z00_1730),
																	BBOOL(BgL_safez00_2949), BEOA));
													}}
													BgL_arg3797z00_1728 = BgL_res3920z00_2975;
											}}
											{	/* Coerce/coerce.scm 392 */
												obj_t BgL_auxz00_3799;

												BgL_auxz00_3799 = (obj_t) (BgL_arg3797z00_1728);
												SET_CDR(BgL_bindingz00_1725, BgL_auxz00_3799);
									}}}
									{
										obj_t BgL_l3480z00_3802;

										BgL_l3480z00_3802 = CDR(BgL_l3480z00_1722);
										BgL_l3480z00_1722 = BgL_l3480z00_3802;
										goto BgL_zc3anonymousza33793ze3z83_1723;
									}
								}
							else
								{	/* Coerce/coerce.scm 390 */
									((bool_t) 1);
								}
						}
					}
					{	/* Coerce/coerce.scm 397 */
						BgL_nodez00_bglt BgL_arg3803z00_1734;

						{	/* Coerce/coerce.scm 397 */
							BgL_nodez00_bglt BgL_arg3804z00_1735;

							BgL_arg3804z00_1735 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1713))->BgL_bodyz00);
							{	/* Coerce/coerce.scm 397 */
								BgL_nodez00_bglt BgL_res3923z00_3009;

								{	/* Coerce/coerce.scm 397 */
									BgL_typez00_bglt BgL_toz00_2982;

									bool_t BgL_safez00_2983;

									BgL_toz00_2982 = (BgL_typez00_bglt) (BgL_toz00_1715);
									BgL_safez00_2983 = CBOOL(BgL_safez00_1716);
									{	/* Coerce/coerce.scm 397 */
										obj_t BgL_method3484z00_2984;

										{	/* Coerce/coerce.scm 397 */
											BgL_objectz00_bglt BgL_objz00_2985;

											BgL_objz00_2985 =
												(BgL_objectz00_bglt) (BgL_arg3804z00_1735);
											{	/* Coerce/coerce.scm 397 */
												long BgL_objzd2classzd2numz00_2986;

												BgL_objzd2classzd2numz00_2986 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2985);
												{	/* Coerce/coerce.scm 397 */
													obj_t BgL_arg2551z00_2987;

													BgL_arg2551z00_2987 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 397 */
														obj_t BgL_arrayz00_2989;

														int BgL_offsetz00_2990;

														BgL_arrayz00_2989 = BgL_arg2551z00_2987;
														BgL_offsetz00_2990 =
															(int) (BgL_objzd2classzd2numz00_2986);
														{	/* Coerce/coerce.scm 397 */
															long BgL_offsetz00_2991;

															BgL_offsetz00_2991 =
																((long) (BgL_offsetz00_2990) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 397 */
																long BgL_modz00_2992;

																{	/* Coerce/coerce.scm 397 */
																	int BgL_arg2553z00_2993;

																	BgL_arg2553z00_2993 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 397 */
																		long BgL_auxz00_3815;

																		BgL_auxz00_3815 =
																			(long) (BgL_arg2553z00_2993);
																		BgL_modz00_2992 =
																			(BgL_offsetz00_2991 / BgL_auxz00_3815);
																}}
																{	/* Coerce/coerce.scm 397 */
																	long BgL_restz00_2994;

																	{	/* Coerce/coerce.scm 397 */
																		int BgL_arg2552z00_2995;

																		BgL_arg2552z00_2995 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 397 */
																			long BgL_auxz00_3819;

																			BgL_auxz00_3819 =
																				(long) (BgL_arg2552z00_2995);
																			BgL_restz00_2994 =
																				(BgL_offsetz00_2991 % BgL_auxz00_3819);
																	}}
																	{	/* Coerce/coerce.scm 397 */

																		BgL_method3484z00_2984 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2989,
																				(int) (BgL_modz00_2992)),
																			(int) (BgL_restz00_2994));
										}}}}}}}}
										BgL_res3923z00_3009 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2984) (BgL_method3484z00_2984,
												(obj_t) (BgL_arg3804z00_1735), BgL_callerz00_1714,
												(obj_t) (BgL_toz00_2982), BBOOL(BgL_safez00_2983),
												BEOA));
								}}
								BgL_arg3803z00_1734 = BgL_res3923z00_3009;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1713))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3803z00_1734), BUNSPEC);
					}
					BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
					BgL_auxz00_3759 = BgL_nodez00_1713;
					return (obj_t) (BgL_auxz00_3759);
				}
			}
		}
	}



/* coerce!-let-fun3524 */
	obj_t BGl_coercez12zd2letzd2fun3524z12zzcoerce_coercez00(obj_t
		BgL_envz00_3287, obj_t BgL_nodez00_3288, obj_t BgL_callerz00_3289,
		obj_t BgL_toz00_3290, obj_t BgL_safez00_3291)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 374 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1693;

				obj_t BgL_callerz00_1694;

				obj_t BgL_toz00_1695;

				obj_t BgL_safez00_1696;

				{	/* Coerce/coerce.scm 375 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3836;

					BgL_nodez00_1693 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3288);
					BgL_callerz00_1694 = BgL_callerz00_3289;
					BgL_toz00_1695 = BgL_toz00_3290;
					BgL_safez00_1696 = BgL_safez00_3291;
					BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
					{	/* Coerce/coerce.scm 377 */
						obj_t BgL_g3479z00_1700;

						BgL_g3479z00_1700 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1693))->BgL_localsz00);
						{
							obj_t BgL_l3477z00_1702;

							BgL_l3477z00_1702 = BgL_g3479z00_1700;
						BgL_zc3anonymousza33786ze3z83_1703:
							if (PAIRP(BgL_l3477z00_1702))
								{	/* Coerce/coerce.scm 377 */
									{	/* Coerce/coerce.scm 377 */
										obj_t BgL_fz00_1705;

										BgL_fz00_1705 = CAR(BgL_l3477z00_1702);
										{	/* Coerce/coerce.scm 377 */
											bool_t BgL_arg3788z00_1706;

											if (CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
												{	/* Coerce/coerce.scm 377 */
													BgL_arg3788z00_1706 = ((bool_t) 0);
												}
											else
												{	/* Coerce/coerce.scm 377 */
													BgL_arg3788z00_1706 = ((bool_t) 1);
												}
											BGl_coercezd2functionz12zc0zzcoerce_coercez00(
												(BgL_variablez00_bglt) (BgL_fz00_1705),
												BgL_arg3788z00_1706);
										}
									}
									{
										obj_t BgL_l3477z00_3846;

										BgL_l3477z00_3846 = CDR(BgL_l3477z00_1702);
										BgL_l3477z00_1702 = BgL_l3477z00_3846;
										goto BgL_zc3anonymousza33786ze3z83_1703;
									}
								}
							else
								{	/* Coerce/coerce.scm 377 */
									((bool_t) 1);
								}
						}
					}
					{	/* Coerce/coerce.scm 378 */
						BgL_nodez00_bglt BgL_arg3790z00_1709;

						{	/* Coerce/coerce.scm 378 */
							BgL_nodez00_bglt BgL_arg3791z00_1710;

							BgL_arg3791z00_1710 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1693))->BgL_bodyz00);
							{	/* Coerce/coerce.scm 378 */
								BgL_nodez00_bglt BgL_res3917z00_2936;

								{	/* Coerce/coerce.scm 378 */
									BgL_typez00_bglt BgL_toz00_2909;

									bool_t BgL_safez00_2910;

									BgL_toz00_2909 = (BgL_typez00_bglt) (BgL_toz00_1695);
									BgL_safez00_2910 = CBOOL(BgL_safez00_1696);
									{	/* Coerce/coerce.scm 378 */
										obj_t BgL_method3484z00_2911;

										{	/* Coerce/coerce.scm 378 */
											BgL_objectz00_bglt BgL_objz00_2912;

											BgL_objz00_2912 =
												(BgL_objectz00_bglt) (BgL_arg3791z00_1710);
											{	/* Coerce/coerce.scm 378 */
												long BgL_objzd2classzd2numz00_2913;

												BgL_objzd2classzd2numz00_2913 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2912);
												{	/* Coerce/coerce.scm 378 */
													obj_t BgL_arg2551z00_2914;

													BgL_arg2551z00_2914 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 378 */
														obj_t BgL_arrayz00_2916;

														int BgL_offsetz00_2917;

														BgL_arrayz00_2916 = BgL_arg2551z00_2914;
														BgL_offsetz00_2917 =
															(int) (BgL_objzd2classzd2numz00_2913);
														{	/* Coerce/coerce.scm 378 */
															long BgL_offsetz00_2918;

															BgL_offsetz00_2918 =
																((long) (BgL_offsetz00_2917) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 378 */
																long BgL_modz00_2919;

																{	/* Coerce/coerce.scm 378 */
																	int BgL_arg2553z00_2920;

																	BgL_arg2553z00_2920 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 378 */
																		long BgL_auxz00_3859;

																		BgL_auxz00_3859 =
																			(long) (BgL_arg2553z00_2920);
																		BgL_modz00_2919 =
																			(BgL_offsetz00_2918 / BgL_auxz00_3859);
																}}
																{	/* Coerce/coerce.scm 378 */
																	long BgL_restz00_2921;

																	{	/* Coerce/coerce.scm 378 */
																		int BgL_arg2552z00_2922;

																		BgL_arg2552z00_2922 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 378 */
																			long BgL_auxz00_3863;

																			BgL_auxz00_3863 =
																				(long) (BgL_arg2552z00_2922);
																			BgL_restz00_2921 =
																				(BgL_offsetz00_2918 % BgL_auxz00_3863);
																	}}
																	{	/* Coerce/coerce.scm 378 */

																		BgL_method3484z00_2911 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2916,
																				(int) (BgL_modz00_2919)),
																			(int) (BgL_restz00_2921));
										}}}}}}}}
										BgL_res3917z00_2936 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2911) (BgL_method3484z00_2911,
												(obj_t) (BgL_arg3791z00_1710), BgL_callerz00_1694,
												(obj_t) (BgL_toz00_2909), BBOOL(BgL_safez00_2910),
												BEOA));
								}}
								BgL_arg3790z00_1709 = BgL_res3917z00_2936;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1693))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3790z00_1709), BUNSPEC);
					}
					BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
					BgL_auxz00_3836 = BgL_nodez00_1693;
					return (obj_t) (BgL_auxz00_3836);
				}
			}
		}
	}



/* coerce!-select3522 */
	obj_t BGl_coercez12zd2select3522zc0zzcoerce_coercez00(obj_t BgL_envz00_3292,
		obj_t BgL_nodez00_3293, obj_t BgL_callerz00_3294, obj_t BgL_toz00_3295,
		obj_t BgL_safez00_3296)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 343 */
			{
				BgL_selectz00_bglt BgL_nodez00_1664;

				obj_t BgL_callerz00_1665;

				obj_t BgL_toz00_1666;

				obj_t BgL_safez00_1667;

				BgL_nodez00_1664 = (BgL_selectz00_bglt) (BgL_nodez00_3293);
				BgL_callerz00_1665 = BgL_callerz00_3294;
				BgL_toz00_1666 = BgL_toz00_3295;
				BgL_safez00_1667 = BgL_safez00_3296;
				{
					BgL_typez00_bglt BgL_auxz00_3882;

					BgL_nodez00_bglt BgL_auxz00_3880;

					BgL_auxz00_3882 = (BgL_typez00_bglt) (BgL_toz00_1666);
					BgL_auxz00_3880 = (BgL_nodez00_bglt) (BgL_nodez00_1664);
					((((BgL_nodez00_bglt) CREF(BgL_auxz00_3880))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3882), BUNSPEC);
				}
				{	/* Coerce/coerce.scm 346 */
					obj_t BgL_clausesz00_1671;

					BgL_typez00_bglt BgL_testzd2typezd2_1672;

					BgL_typez00_bglt BgL_testzd2nodezd2typez00_1673;

					BgL_clausesz00_1671 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->BgL_clausesz00);
					BgL_testzd2typezd2_1672 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->BgL_itemzd2typezd2);
					{	/* Coerce/coerce.scm 348 */
						BgL_nodez00_bglt BgL_arg3784z00_1690;

						BgL_arg3784z00_1690 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->BgL_testz00);
						BgL_testzd2nodezd2typez00_1673 =
							BGl_typeofz00zztype_typeofz00(BgL_arg3784z00_1690);
					}
					if (BGl_coercerzd2existszf3z21zztype_coercionz00
						(BgL_testzd2nodezd2typez00_1673, BgL_testzd2typezd2_1672))
						{	/* Coerce/coerce.scm 356 */
							{	/* Coerce/coerce.scm 362 */
								BgL_nodez00_bglt BgL_arg3773z00_1675;

								{	/* Coerce/coerce.scm 362 */
									BgL_nodez00_bglt BgL_arg3774z00_1676;

									BgL_arg3774z00_1676 =
										(((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->
										BgL_testz00);
									{	/* Coerce/coerce.scm 362 */
										BgL_nodez00_bglt BgL_res3908z00_2830;

										{	/* Coerce/coerce.scm 362 */
											bool_t BgL_safez00_2804;

											BgL_safez00_2804 = CBOOL(BgL_safez00_1667);
											{	/* Coerce/coerce.scm 362 */
												obj_t BgL_method3484z00_2805;

												{	/* Coerce/coerce.scm 362 */
													BgL_objectz00_bglt BgL_objz00_2806;

													BgL_objz00_2806 =
														(BgL_objectz00_bglt) (BgL_arg3774z00_1676);
													{	/* Coerce/coerce.scm 362 */
														long BgL_objzd2classzd2numz00_2807;

														BgL_objzd2classzd2numz00_2807 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2806);
														{	/* Coerce/coerce.scm 362 */
															obj_t BgL_arg2551z00_2808;

															BgL_arg2551z00_2808 =
																PROCEDURE_REF
																(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																(int) (((long) 1)));
															{	/* Coerce/coerce.scm 362 */
																obj_t BgL_arrayz00_2810;

																int BgL_offsetz00_2811;

																BgL_arrayz00_2810 = BgL_arg2551z00_2808;
																BgL_offsetz00_2811 =
																	(int) (BgL_objzd2classzd2numz00_2807);
																{	/* Coerce/coerce.scm 362 */
																	long BgL_offsetz00_2812;

																	BgL_offsetz00_2812 =
																		((long) (BgL_offsetz00_2811) - OBJECT_TYPE);
																	{	/* Coerce/coerce.scm 362 */
																		long BgL_modz00_2813;

																		{	/* Coerce/coerce.scm 362 */
																			int BgL_arg2553z00_2814;

																			BgL_arg2553z00_2814 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 362 */
																				long BgL_auxz00_3901;

																				BgL_auxz00_3901 =
																					(long) (BgL_arg2553z00_2814);
																				BgL_modz00_2813 =
																					(BgL_offsetz00_2812 /
																					BgL_auxz00_3901);
																		}}
																		{	/* Coerce/coerce.scm 362 */
																			long BgL_restz00_2815;

																			{	/* Coerce/coerce.scm 362 */
																				int BgL_arg2552z00_2816;

																				BgL_arg2552z00_2816 =
																					(int) (((long) 8));
																				{	/* Coerce/coerce.scm 362 */
																					long BgL_auxz00_3905;

																					BgL_auxz00_3905 =
																						(long) (BgL_arg2552z00_2816);
																					BgL_restz00_2815 =
																						(BgL_offsetz00_2812 %
																						BgL_auxz00_3905);
																			}}
																			{	/* Coerce/coerce.scm 362 */

																				BgL_method3484z00_2805 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2810,
																						(int) (BgL_modz00_2813)),
																					(int) (BgL_restz00_2815));
												}}}}}}}}
												BgL_res3908z00_2830 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3484z00_2805) (BgL_method3484z00_2805,
														(obj_t) (BgL_arg3774z00_1676), BgL_callerz00_1665,
														(obj_t) (BgL_testzd2typezd2_1672),
														BBOOL(BgL_safez00_2804), BEOA));
										}}
										BgL_arg3773z00_1675 = BgL_res3908z00_2830;
								}}
								((((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->BgL_testz00) =
									((BgL_nodez00_bglt) BgL_arg3773z00_1675), BUNSPEC);
							}
							{
								obj_t BgL_l3475z00_1678;

								BgL_l3475z00_1678 = BgL_clausesz00_1671;
							BgL_zc3anonymousza33775ze3z83_1679:
								if (PAIRP(BgL_l3475z00_1678))
									{	/* Coerce/coerce.scm 363 */
										{	/* Coerce/coerce.scm 364 */
											obj_t BgL_clausez00_1681;

											BgL_clausez00_1681 = CAR(BgL_l3475z00_1678);
											{	/* Coerce/coerce.scm 364 */
												BgL_nodez00_bglt BgL_arg3777z00_1682;

												{	/* Coerce/coerce.scm 364 */
													obj_t BgL_arg3778z00_1683;

													BgL_arg3778z00_1683 = CDR(BgL_clausez00_1681);
													{	/* Coerce/coerce.scm 364 */
														BgL_nodez00_bglt BgL_res3911z00_2865;

														{	/* Coerce/coerce.scm 364 */
															BgL_nodez00_bglt BgL_nodez00_2836;

															BgL_typez00_bglt BgL_toz00_2838;

															bool_t BgL_safez00_2839;

															BgL_nodez00_2836 =
																(BgL_nodez00_bglt) (BgL_arg3778z00_1683);
															BgL_toz00_2838 =
																(BgL_typez00_bglt) (BgL_toz00_1666);
															BgL_safez00_2839 = CBOOL(BgL_safez00_1667);
															{	/* Coerce/coerce.scm 364 */
																obj_t BgL_method3484z00_2840;

																{	/* Coerce/coerce.scm 364 */
																	BgL_objectz00_bglt BgL_objz00_2841;

																	BgL_objz00_2841 =
																		(BgL_objectz00_bglt) (BgL_nodez00_2836);
																	{	/* Coerce/coerce.scm 364 */
																		long BgL_objzd2classzd2numz00_2842;

																		BgL_objzd2classzd2numz00_2842 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_2841);
																		{	/* Coerce/coerce.scm 364 */
																			obj_t BgL_arg2551z00_2843;

																			BgL_arg2551z00_2843 =
																				PROCEDURE_REF
																				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																				(int) (((long) 1)));
																			{	/* Coerce/coerce.scm 364 */
																				obj_t BgL_arrayz00_2845;

																				int BgL_offsetz00_2846;

																				BgL_arrayz00_2845 = BgL_arg2551z00_2843;
																				BgL_offsetz00_2846 =
																					(int) (BgL_objzd2classzd2numz00_2842);
																				{	/* Coerce/coerce.scm 364 */
																					long BgL_offsetz00_2847;

																					BgL_offsetz00_2847 =
																						(
																						(long) (BgL_offsetz00_2846) -
																						OBJECT_TYPE);
																					{	/* Coerce/coerce.scm 364 */
																						long BgL_modz00_2848;

																						{	/* Coerce/coerce.scm 364 */
																							int BgL_arg2553z00_2849;

																							BgL_arg2553z00_2849 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 364 */
																								long BgL_auxz00_3934;

																								BgL_auxz00_3934 =
																									(long) (BgL_arg2553z00_2849);
																								BgL_modz00_2848 =
																									(BgL_offsetz00_2847 /
																									BgL_auxz00_3934);
																						}}
																						{	/* Coerce/coerce.scm 364 */
																							long BgL_restz00_2850;

																							{	/* Coerce/coerce.scm 364 */
																								int BgL_arg2552z00_2851;

																								BgL_arg2552z00_2851 =
																									(int) (((long) 8));
																								{	/* Coerce/coerce.scm 364 */
																									long BgL_auxz00_3938;

																									BgL_auxz00_3938 =
																										(long)
																										(BgL_arg2552z00_2851);
																									BgL_restz00_2850 =
																										(BgL_offsetz00_2847 %
																										BgL_auxz00_3938);
																							}}
																							{	/* Coerce/coerce.scm 364 */

																								BgL_method3484z00_2840 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_2845,
																										(int) (BgL_modz00_2848)),
																									(int) (BgL_restz00_2850));
																}}}}}}}}
																BgL_res3911z00_2865 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3484z00_2840)
																	(BgL_method3484z00_2840,
																		(obj_t) (BgL_nodez00_2836),
																		BgL_callerz00_1665,
																		(obj_t) (BgL_toz00_2838),
																		BBOOL(BgL_safez00_2839), BEOA));
														}}
														BgL_arg3777z00_1682 = BgL_res3911z00_2865;
												}}
												{	/* Coerce/coerce.scm 364 */
													obj_t BgL_auxz00_3951;

													BgL_auxz00_3951 = (obj_t) (BgL_arg3777z00_1682);
													SET_CDR(BgL_clausez00_1681, BgL_auxz00_3951);
										}}}
										{
											obj_t BgL_l3475z00_3954;

											BgL_l3475z00_3954 = CDR(BgL_l3475z00_1678);
											BgL_l3475z00_1678 = BgL_l3475z00_3954;
											goto BgL_zc3anonymousza33775ze3z83_1679;
										}
									}
								else
									{	/* Coerce/coerce.scm 363 */
										((bool_t) 1);
									}
							}
							return (obj_t) (BgL_nodez00_1664);
						}
					else
						{	/* Coerce/coerce.scm 357 */
							obj_t BgL_arg3780z00_1686;

							{	/* Coerce/coerce.scm 357 */
								obj_t BgL_arg3781z00_1687;

								obj_t BgL_arg3782z00_1688;

								BgL_nodez00_bglt BgL_arg3783z00_1689;

								{
									BgL_nodez00_bglt BgL_auxz00_3957;

									BgL_auxz00_3957 = (BgL_nodez00_bglt) (BgL_nodez00_1664);
									BgL_arg3781z00_1687 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3957))->BgL_locz00);
								}
								BgL_arg3782z00_1688 =
									(((BgL_typez00_bglt) CREF(BgL_testzd2typezd2_1672))->
									BgL_idz00);
								BgL_arg3783z00_1689 =
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1664))->BgL_testz00);
								BgL_arg3780z00_1686 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_arg3781z00_1687, BgL_arg3782z00_1688,
									(obj_t) (BgL_arg3783z00_1689));
							}
							{	/* Coerce/coerce.scm 357 */
								BgL_nodez00_bglt BgL_res3914z00_2901;

								{	/* Coerce/coerce.scm 357 */
									BgL_nodez00_bglt BgL_nodez00_2872;

									BgL_typez00_bglt BgL_toz00_2874;

									bool_t BgL_safez00_2875;

									BgL_nodez00_2872 = (BgL_nodez00_bglt) (BgL_arg3780z00_1686);
									BgL_toz00_2874 = (BgL_typez00_bglt) (BgL_toz00_1666);
									BgL_safez00_2875 = CBOOL(BgL_safez00_1667);
									{	/* Coerce/coerce.scm 357 */
										obj_t BgL_method3484z00_2876;

										{	/* Coerce/coerce.scm 357 */
											BgL_objectz00_bglt BgL_objz00_2877;

											BgL_objz00_2877 = (BgL_objectz00_bglt) (BgL_nodez00_2872);
											{	/* Coerce/coerce.scm 357 */
												long BgL_objzd2classzd2numz00_2878;

												BgL_objzd2classzd2numz00_2878 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2877);
												{	/* Coerce/coerce.scm 357 */
													obj_t BgL_arg2551z00_2879;

													BgL_arg2551z00_2879 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 357 */
														obj_t BgL_arrayz00_2881;

														int BgL_offsetz00_2882;

														BgL_arrayz00_2881 = BgL_arg2551z00_2879;
														BgL_offsetz00_2882 =
															(int) (BgL_objzd2classzd2numz00_2878);
														{	/* Coerce/coerce.scm 357 */
															long BgL_offsetz00_2883;

															BgL_offsetz00_2883 =
																((long) (BgL_offsetz00_2882) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 357 */
																long BgL_modz00_2884;

																{	/* Coerce/coerce.scm 357 */
																	int BgL_arg2553z00_2885;

																	BgL_arg2553z00_2885 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 357 */
																		long BgL_auxz00_3975;

																		BgL_auxz00_3975 =
																			(long) (BgL_arg2553z00_2885);
																		BgL_modz00_2884 =
																			(BgL_offsetz00_2883 / BgL_auxz00_3975);
																}}
																{	/* Coerce/coerce.scm 357 */
																	long BgL_restz00_2886;

																	{	/* Coerce/coerce.scm 357 */
																		int BgL_arg2552z00_2887;

																		BgL_arg2552z00_2887 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 357 */
																			long BgL_auxz00_3979;

																			BgL_auxz00_3979 =
																				(long) (BgL_arg2552z00_2887);
																			BgL_restz00_2886 =
																				(BgL_offsetz00_2883 % BgL_auxz00_3979);
																	}}
																	{	/* Coerce/coerce.scm 357 */

																		BgL_method3484z00_2876 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2881,
																				(int) (BgL_modz00_2884)),
																			(int) (BgL_restz00_2886));
										}}}}}}}}
										BgL_res3914z00_2901 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2876) (BgL_method3484z00_2876,
												(obj_t) (BgL_nodez00_2872), BgL_callerz00_1665,
												(obj_t) (BgL_toz00_2874), BBOOL(BgL_safez00_2875),
												BEOA));
								}}
								return (obj_t) (BgL_res3914z00_2901);
							}
						}
				}
			}
		}
	}



/* coerce!-fail3520 */
	obj_t BGl_coercez12zd2fail3520zc0zzcoerce_coercez00(obj_t BgL_envz00_3297,
		obj_t BgL_nodez00_3298, obj_t BgL_callerz00_3299, obj_t BgL_toz00_3300,
		obj_t BgL_safez00_3301)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 333 */
			{
				BgL_failz00_bglt BgL_nodez00_1649;

				obj_t BgL_callerz00_1650;

				obj_t BgL_toz00_1651;

				obj_t BgL_safez00_1652;

				{	/* Coerce/coerce.scm 334 */
					BgL_nodez00_bglt BgL_auxz00_3994;

					BgL_nodez00_1649 = (BgL_failz00_bglt) (BgL_nodez00_3298);
					BgL_callerz00_1650 = BgL_callerz00_3299;
					BgL_toz00_1651 = BgL_toz00_3300;
					BgL_safez00_1652 = BgL_safez00_3301;
					{	/* Coerce/coerce.scm 335 */
						BgL_nodez00_bglt BgL_arg3765z00_1656;

						{	/* Coerce/coerce.scm 335 */
							BgL_nodez00_bglt BgL_arg3766z00_1657;

							BgL_arg3766z00_1657 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_procz00);
							{	/* Coerce/coerce.scm 335 */
								BgL_nodez00_bglt BgL_res3899z00_2726;

								{	/* Coerce/coerce.scm 335 */
									BgL_typez00_bglt BgL_toz00_2699;

									bool_t BgL_safez00_2700;

									BgL_toz00_2699 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2700 = CBOOL(BgL_safez00_1652);
									{	/* Coerce/coerce.scm 335 */
										obj_t BgL_method3484z00_2701;

										{	/* Coerce/coerce.scm 335 */
											BgL_objectz00_bglt BgL_objz00_2702;

											BgL_objz00_2702 =
												(BgL_objectz00_bglt) (BgL_arg3766z00_1657);
											{	/* Coerce/coerce.scm 335 */
												long BgL_objzd2classzd2numz00_2703;

												BgL_objzd2classzd2numz00_2703 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2702);
												{	/* Coerce/coerce.scm 335 */
													obj_t BgL_arg2551z00_2704;

													BgL_arg2551z00_2704 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 335 */
														obj_t BgL_arrayz00_2706;

														int BgL_offsetz00_2707;

														BgL_arrayz00_2706 = BgL_arg2551z00_2704;
														BgL_offsetz00_2707 =
															(int) (BgL_objzd2classzd2numz00_2703);
														{	/* Coerce/coerce.scm 335 */
															long BgL_offsetz00_2708;

															BgL_offsetz00_2708 =
																((long) (BgL_offsetz00_2707) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 335 */
																long BgL_modz00_2709;

																{	/* Coerce/coerce.scm 335 */
																	int BgL_arg2553z00_2710;

																	BgL_arg2553z00_2710 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 335 */
																		long BgL_auxz00_4006;

																		BgL_auxz00_4006 =
																			(long) (BgL_arg2553z00_2710);
																		BgL_modz00_2709 =
																			(BgL_offsetz00_2708 / BgL_auxz00_4006);
																}}
																{	/* Coerce/coerce.scm 335 */
																	long BgL_restz00_2711;

																	{	/* Coerce/coerce.scm 335 */
																		int BgL_arg2552z00_2712;

																		BgL_arg2552z00_2712 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 335 */
																			long BgL_auxz00_4010;

																			BgL_auxz00_4010 =
																				(long) (BgL_arg2552z00_2712);
																			BgL_restz00_2711 =
																				(BgL_offsetz00_2708 % BgL_auxz00_4010);
																	}}
																	{	/* Coerce/coerce.scm 335 */

																		BgL_method3484z00_2701 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2706,
																				(int) (BgL_modz00_2709)),
																			(int) (BgL_restz00_2711));
										}}}}}}}}
										BgL_res3899z00_2726 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2701) (BgL_method3484z00_2701,
												(obj_t) (BgL_arg3766z00_1657), BgL_callerz00_1650,
												(obj_t) (BgL_toz00_2699), BBOOL(BgL_safez00_2700),
												BEOA));
								}}
								BgL_arg3765z00_1656 = BgL_res3899z00_2726;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3765z00_1656), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 336 */
						BgL_nodez00_bglt BgL_arg3767z00_1658;

						{	/* Coerce/coerce.scm 336 */
							BgL_nodez00_bglt BgL_arg3768z00_1659;

							BgL_arg3768z00_1659 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_msgz00);
							{	/* Coerce/coerce.scm 336 */
								BgL_nodez00_bglt BgL_res3902z00_2759;

								{	/* Coerce/coerce.scm 336 */
									BgL_typez00_bglt BgL_toz00_2732;

									bool_t BgL_safez00_2733;

									BgL_toz00_2732 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2733 = CBOOL(BgL_safez00_1652);
									{	/* Coerce/coerce.scm 336 */
										obj_t BgL_method3484z00_2734;

										{	/* Coerce/coerce.scm 336 */
											BgL_objectz00_bglt BgL_objz00_2735;

											BgL_objz00_2735 =
												(BgL_objectz00_bglt) (BgL_arg3768z00_1659);
											{	/* Coerce/coerce.scm 336 */
												long BgL_objzd2classzd2numz00_2736;

												BgL_objzd2classzd2numz00_2736 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2735);
												{	/* Coerce/coerce.scm 336 */
													obj_t BgL_arg2551z00_2737;

													BgL_arg2551z00_2737 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 336 */
														obj_t BgL_arrayz00_2739;

														int BgL_offsetz00_2740;

														BgL_arrayz00_2739 = BgL_arg2551z00_2737;
														BgL_offsetz00_2740 =
															(int) (BgL_objzd2classzd2numz00_2736);
														{	/* Coerce/coerce.scm 336 */
															long BgL_offsetz00_2741;

															BgL_offsetz00_2741 =
																((long) (BgL_offsetz00_2740) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 336 */
																long BgL_modz00_2742;

																{	/* Coerce/coerce.scm 336 */
																	int BgL_arg2553z00_2743;

																	BgL_arg2553z00_2743 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 336 */
																		long BgL_auxz00_4035;

																		BgL_auxz00_4035 =
																			(long) (BgL_arg2553z00_2743);
																		BgL_modz00_2742 =
																			(BgL_offsetz00_2741 / BgL_auxz00_4035);
																}}
																{	/* Coerce/coerce.scm 336 */
																	long BgL_restz00_2744;

																	{	/* Coerce/coerce.scm 336 */
																		int BgL_arg2552z00_2745;

																		BgL_arg2552z00_2745 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 336 */
																			long BgL_auxz00_4039;

																			BgL_auxz00_4039 =
																				(long) (BgL_arg2552z00_2745);
																			BgL_restz00_2744 =
																				(BgL_offsetz00_2741 % BgL_auxz00_4039);
																	}}
																	{	/* Coerce/coerce.scm 336 */

																		BgL_method3484z00_2734 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2739,
																				(int) (BgL_modz00_2742)),
																			(int) (BgL_restz00_2744));
										}}}}}}}}
										BgL_res3902z00_2759 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2734) (BgL_method3484z00_2734,
												(obj_t) (BgL_arg3768z00_1659), BgL_callerz00_1650,
												(obj_t) (BgL_toz00_2732), BBOOL(BgL_safez00_2733),
												BEOA));
								}}
								BgL_arg3767z00_1658 = BgL_res3902z00_2759;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3767z00_1658), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 337 */
						BgL_nodez00_bglt BgL_arg3769z00_1660;

						{	/* Coerce/coerce.scm 337 */
							BgL_nodez00_bglt BgL_arg3770z00_1661;

							BgL_arg3770z00_1661 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_objz00);
							{	/* Coerce/coerce.scm 337 */
								BgL_nodez00_bglt BgL_res3905z00_2792;

								{	/* Coerce/coerce.scm 337 */
									BgL_typez00_bglt BgL_toz00_2765;

									bool_t BgL_safez00_2766;

									BgL_toz00_2765 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2766 = CBOOL(BgL_safez00_1652);
									{	/* Coerce/coerce.scm 337 */
										obj_t BgL_method3484z00_2767;

										{	/* Coerce/coerce.scm 337 */
											BgL_objectz00_bglt BgL_objz00_2768;

											BgL_objz00_2768 =
												(BgL_objectz00_bglt) (BgL_arg3770z00_1661);
											{	/* Coerce/coerce.scm 337 */
												long BgL_objzd2classzd2numz00_2769;

												BgL_objzd2classzd2numz00_2769 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2768);
												{	/* Coerce/coerce.scm 337 */
													obj_t BgL_arg2551z00_2770;

													BgL_arg2551z00_2770 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 337 */
														obj_t BgL_arrayz00_2772;

														int BgL_offsetz00_2773;

														BgL_arrayz00_2772 = BgL_arg2551z00_2770;
														BgL_offsetz00_2773 =
															(int) (BgL_objzd2classzd2numz00_2769);
														{	/* Coerce/coerce.scm 337 */
															long BgL_offsetz00_2774;

															BgL_offsetz00_2774 =
																((long) (BgL_offsetz00_2773) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 337 */
																long BgL_modz00_2775;

																{	/* Coerce/coerce.scm 337 */
																	int BgL_arg2553z00_2776;

																	BgL_arg2553z00_2776 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 337 */
																		long BgL_auxz00_4064;

																		BgL_auxz00_4064 =
																			(long) (BgL_arg2553z00_2776);
																		BgL_modz00_2775 =
																			(BgL_offsetz00_2774 / BgL_auxz00_4064);
																}}
																{	/* Coerce/coerce.scm 337 */
																	long BgL_restz00_2777;

																	{	/* Coerce/coerce.scm 337 */
																		int BgL_arg2552z00_2778;

																		BgL_arg2552z00_2778 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 337 */
																			long BgL_auxz00_4068;

																			BgL_auxz00_4068 =
																				(long) (BgL_arg2552z00_2778);
																			BgL_restz00_2777 =
																				(BgL_offsetz00_2774 % BgL_auxz00_4068);
																	}}
																	{	/* Coerce/coerce.scm 337 */

																		BgL_method3484z00_2767 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2772,
																				(int) (BgL_modz00_2775)),
																			(int) (BgL_restz00_2777));
										}}}}}}}}
										BgL_res3905z00_2792 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2767) (BgL_method3484z00_2767,
												(obj_t) (BgL_arg3770z00_1661), BgL_callerz00_1650,
												(obj_t) (BgL_toz00_2765), BBOOL(BgL_safez00_2766),
												BEOA));
								}}
								BgL_arg3769z00_1660 = BgL_res3905z00_2792;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1649))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3769z00_1660), BUNSPEC);
					}
					BgL_auxz00_3994 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1649),
						(BgL_typez00_bglt) (BGl_za2magicza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1651), CBOOL(BgL_safez00_1652));
					return (obj_t) (BgL_auxz00_3994);
				}
			}
		}
	}



/* coerce!-conditional3517 */
	obj_t BGl_coercez12zd2conditional3517zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3302, obj_t BgL_nodez00_3303, obj_t BgL_callerz00_3304,
		obj_t BgL_toz00_3305, obj_t BgL_safez00_3306)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 253 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1554;

				obj_t BgL_callerz00_1555;

				obj_t BgL_toz00_1556;

				obj_t BgL_safez00_1557;

				BgL_nodez00_1554 = (BgL_conditionalz00_bglt) (BgL_nodez00_3303);
				BgL_callerz00_1555 = BgL_callerz00_3304;
				BgL_toz00_1556 = BgL_toz00_3305;
				BgL_safez00_1557 = BgL_safez00_3306;
				{
					BgL_nodez00_bglt BgL_nodez00_1576;

					BgL_nodez00_bglt BgL_nodez00_1580;

					BgL_nodez00_bglt BgL_nodez00_1621;

					{	/* Coerce/coerce.scm 318 */
						BgL_nodez00_bglt BgL_arg3710z00_1564;

						{	/* Coerce/coerce.scm 318 */
							BgL_nodez00_bglt BgL_arg3711z00_1565;

							BgL_arg3711z00_1565 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
								BgL_testz00);
							{	/* Coerce/coerce.scm 318 */
								BgL_nodez00_bglt BgL_res3884z00_2510;

								{	/* Coerce/coerce.scm 318 */
									BgL_typez00_bglt BgL_toz00_2483;

									bool_t BgL_safez00_2484;

									BgL_toz00_2483 =
										(BgL_typez00_bglt) (BGl_za2boolza2z00zztype_cachez00);
									BgL_safez00_2484 = CBOOL(BgL_safez00_1557);
									{	/* Coerce/coerce.scm 318 */
										obj_t BgL_method3484z00_2485;

										{	/* Coerce/coerce.scm 318 */
											BgL_objectz00_bglt BgL_objz00_2486;

											BgL_objz00_2486 =
												(BgL_objectz00_bglt) (BgL_arg3711z00_1565);
											{	/* Coerce/coerce.scm 318 */
												long BgL_objzd2classzd2numz00_2487;

												BgL_objzd2classzd2numz00_2487 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2486);
												{	/* Coerce/coerce.scm 318 */
													obj_t BgL_arg2551z00_2488;

													BgL_arg2551z00_2488 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 318 */
														obj_t BgL_arrayz00_2490;

														int BgL_offsetz00_2491;

														BgL_arrayz00_2490 = BgL_arg2551z00_2488;
														BgL_offsetz00_2491 =
															(int) (BgL_objzd2classzd2numz00_2487);
														{	/* Coerce/coerce.scm 318 */
															long BgL_offsetz00_2492;

															BgL_offsetz00_2492 =
																((long) (BgL_offsetz00_2491) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 318 */
																long BgL_modz00_2493;

																{	/* Coerce/coerce.scm 318 */
																	int BgL_arg2553z00_2494;

																	BgL_arg2553z00_2494 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 318 */
																		long BgL_auxz00_4100;

																		BgL_auxz00_4100 =
																			(long) (BgL_arg2553z00_2494);
																		BgL_modz00_2493 =
																			(BgL_offsetz00_2492 / BgL_auxz00_4100);
																}}
																{	/* Coerce/coerce.scm 318 */
																	long BgL_restz00_2495;

																	{	/* Coerce/coerce.scm 318 */
																		int BgL_arg2552z00_2496;

																		BgL_arg2552z00_2496 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 318 */
																			long BgL_auxz00_4104;

																			BgL_auxz00_4104 =
																				(long) (BgL_arg2552z00_2496);
																			BgL_restz00_2495 =
																				(BgL_offsetz00_2492 % BgL_auxz00_4104);
																	}}
																	{	/* Coerce/coerce.scm 318 */

																		BgL_method3484z00_2485 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2490,
																				(int) (BgL_modz00_2493)),
																			(int) (BgL_restz00_2495));
										}}}}}}}}
										BgL_res3884z00_2510 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2485) (BgL_method3484z00_2485,
												(obj_t) (BgL_arg3711z00_1565), BgL_callerz00_1555,
												(obj_t) (BgL_toz00_2483), BBOOL(BgL_safez00_2484),
												BEOA));
								}}
								BgL_arg3710z00_1564 = BgL_res3884z00_2510;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3710z00_1564), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 319 */
						obj_t BgL_casezd2valuezd2_1566;

						{	/* Coerce/coerce.scm 319 */
							BgL_nodez00_bglt BgL_arg3720z00_1575;

							BgL_arg3720z00_1575 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
								BgL_testz00);
							BgL_nodez00_1576 = BgL_arg3720z00_1575;
							{	/* Coerce/coerce.scm 311 */
								bool_t BgL_testz00_4119;

								{	/* Coerce/coerce.scm 311 */
									obj_t BgL_obj2445z00_2648;

									BgL_obj2445z00_2648 = (obj_t) (BgL_nodez00_1576);
									BgL_testz00_4119 =
										BGl_iszd2azf3z21zz__objectz00(BgL_obj2445z00_2648,
										BGl_appz00zzast_nodez00);
								}
								if (BgL_testz00_4119)
									{	/* Coerce/coerce.scm 311 */
										BgL_nodez00_1621 = BgL_nodez00_1576;
										{	/* Coerce/coerce.scm 256 */
											bool_t BgL_testz00_4122;

											{	/* Coerce/coerce.scm 256 */
												obj_t BgL_auxz00_4123;

												{
													BgL_appz00_bglt BgL_auxz00_4124;

													BgL_auxz00_4124 =
														(BgL_appz00_bglt) (BgL_nodez00_1621);
													BgL_auxz00_4123 =
														(((BgL_appz00_bglt) CREF(BgL_auxz00_4124))->
														BgL_argsz00);
												}
												BgL_testz00_4122 = PAIRP(BgL_auxz00_4123);
											}
											if (BgL_testz00_4122)
												{	/* Coerce/coerce.scm 257 */
													bool_t BgL_testz00_4128;

													{	/* Coerce/coerce.scm 257 */
														obj_t BgL_auxz00_4129;

														{	/* Coerce/coerce.scm 257 */
															obj_t BgL_pairz00_2685;

															{
																BgL_appz00_bglt BgL_auxz00_4130;

																BgL_auxz00_4130 =
																	(BgL_appz00_bglt) (BgL_nodez00_1621);
																BgL_pairz00_2685 =
																	(((BgL_appz00_bglt) CREF(BgL_auxz00_4130))->
																	BgL_argsz00);
															}
															BgL_auxz00_4129 = CDR(BgL_pairz00_2685);
														}
														BgL_testz00_4128 = NULLP(BgL_auxz00_4129);
													}
													if (BgL_testz00_4128)
														{	/* Coerce/coerce.scm 258 */
															bool_t BgL_testz00_4135;

															{	/* Coerce/coerce.scm 258 */
																bool_t BgL_testz00_4136;

																{	/* Coerce/coerce.scm 258 */
																	obj_t BgL_arg3759z00_1639;

																	{	/* Coerce/coerce.scm 258 */
																		obj_t BgL_pairz00_2688;

																		{
																			BgL_appz00_bglt BgL_auxz00_4137;

																			BgL_auxz00_4137 =
																				(BgL_appz00_bglt) (BgL_nodez00_1621);
																			BgL_pairz00_2688 =
																				(((BgL_appz00_bglt)
																					CREF(BgL_auxz00_4137))->BgL_argsz00);
																		}
																		BgL_arg3759z00_1639 = CAR(BgL_pairz00_2688);
																	}
																	BgL_testz00_4136 =
																		BGl_sidezd2effectzf3z21zzeffect_effectz00(
																		(BgL_nodez00_bglt) (BgL_arg3759z00_1639));
																}
																if (BgL_testz00_4136)
																	{	/* Coerce/coerce.scm 258 */
																		BgL_testz00_4135 = ((bool_t) 0);
																	}
																else
																	{	/* Coerce/coerce.scm 258 */
																		BgL_testz00_4135 = ((bool_t) 1);
																	}
															}
															if (BgL_testz00_4135)
																{	/* Coerce/coerce.scm 259 */
																	BgL_varz00_bglt BgL_funz00_1627;

																	{
																		BgL_appz00_bglt BgL_auxz00_4143;

																		BgL_auxz00_4143 =
																			(BgL_appz00_bglt) (BgL_nodez00_1621);
																		BgL_funz00_1627 =
																			(((BgL_appz00_bglt)
																				CREF(BgL_auxz00_4143))->BgL_funz00);
																	}
																	{	/* Coerce/coerce.scm 259 */
																		BgL_valuez00_bglt BgL_valz00_1628;

																		{	/* Coerce/coerce.scm 260 */
																			BgL_variablez00_bglt BgL_obj1780z00_2691;

																			BgL_obj1780z00_2691 =
																				(((BgL_varz00_bglt)
																					CREF(BgL_funz00_1627))->
																				BgL_variablez00);
																			BgL_valz00_1628 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_obj1780z00_2691))->
																				BgL_valuez00);
																		}
																		{	/* Coerce/coerce.scm 260 */
																			obj_t BgL_typecz00_1629;

																			{
																				BgL_funz00_bglt BgL_auxz00_4148;

																				BgL_auxz00_4148 =
																					(BgL_funz00_bglt) (BgL_valz00_1628);
																				BgL_typecz00_1629 =
																					(((BgL_funz00_bglt)
																						CREF(BgL_auxz00_4148))->
																					BgL_predicatezd2ofzd2);
																			}
																			{	/* Coerce/coerce.scm 261 */
																				BgL_typez00_bglt BgL_typevz00_1630;

																				{	/* Coerce/coerce.scm 262 */
																					obj_t BgL_arg3755z00_1635;

																					{	/* Coerce/coerce.scm 262 */
																						obj_t BgL_pairz00_2694;

																						{
																							BgL_appz00_bglt BgL_auxz00_4151;

																							BgL_auxz00_4151 =
																								(BgL_appz00_bglt)
																								(BgL_nodez00_1621);
																							BgL_pairz00_2694 =
																								(((BgL_appz00_bglt)
																									CREF(BgL_auxz00_4151))->
																								BgL_argsz00);
																						}
																						BgL_arg3755z00_1635 =
																							CAR(BgL_pairz00_2694);
																					}
																					BgL_typevz00_1630 =
																						BGl_typeofz00zztype_typeofz00(
																						(BgL_nodez00_bglt)
																						(BgL_arg3755z00_1635));
																				}
																				{	/* Coerce/coerce.scm 262 */

																					if (BGl_iszd2azf3z21zz__objectz00
																						(BgL_typecz00_1629,
																							BGl_typez00zztype_typez00))
																						{	/* Coerce/coerce.scm 264 */
																							if (
																								((obj_t) (BgL_typevz00_1630) ==
																									BGl_za2objza2z00zztype_cachez00))
																								{	/* Coerce/coerce.scm 267 */
																									BgL_casezd2valuezd2_1566 =
																										BFALSE;
																								}
																							else
																								{	/* Coerce/coerce.scm 267 */
																									if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1629), BgL_typevz00_1630))
																										{	/* Coerce/coerce.scm 270 */
																											BgL_casezd2valuezd2_1566 =
																												CNST_TABLE_REF(((long)
																													1));
																										}
																									else
																										{	/* Coerce/coerce.scm 270 */
																											if (BGl_typezd2disjointzf3z21zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1629), BgL_typevz00_1630))
																												{	/* Coerce/coerce.scm 272 */
																													BgL_casezd2valuezd2_1566
																														=
																														CNST_TABLE_REF((
																															(long) 2));
																												}
																											else
																												{	/* Coerce/coerce.scm 272 */
																													BgL_casezd2valuezd2_1566
																														= BFALSE;
																												}
																										}
																								}
																						}
																					else
																						{	/* Coerce/coerce.scm 264 */
																							BgL_casezd2valuezd2_1566 = BFALSE;
																						}
																				}
																			}
																		}
																	}
																}
															else
																{	/* Coerce/coerce.scm 258 */
																	BgL_casezd2valuezd2_1566 = BFALSE;
																}
														}
													else
														{	/* Coerce/coerce.scm 257 */
															BgL_casezd2valuezd2_1566 = BFALSE;
														}
												}
											else
												{	/* Coerce/coerce.scm 256 */
													BgL_casezd2valuezd2_1566 = BFALSE;
												}
										}
									}
								else
									{	/* Coerce/coerce.scm 313 */
										bool_t BgL_testz00_4170;

										{	/* Coerce/coerce.scm 313 */
											obj_t BgL_obj3265z00_2649;

											BgL_obj3265z00_2649 = (obj_t) (BgL_nodez00_1576);
											BgL_testz00_4170 =
												BGl_iszd2azf3z21zz__objectz00(BgL_obj3265z00_2649,
												BGl_letzd2varzd2zzast_nodez00);
										}
										if (BgL_testz00_4170)
											{	/* Coerce/coerce.scm 313 */
												BgL_nodez00_1580 = BgL_nodez00_1576;
												{	/* Coerce/coerce.scm 278 */
													bool_t BgL_testz00_4173;

													{	/* Coerce/coerce.scm 278 */
														obj_t BgL_auxz00_4174;

														{
															BgL_letzd2varzd2_bglt BgL_auxz00_4175;

															BgL_auxz00_4175 =
																(BgL_letzd2varzd2_bglt) (BgL_nodez00_1580);
															BgL_auxz00_4174 =
																(((BgL_letzd2varzd2_bglt)
																	CREF(BgL_auxz00_4175))->BgL_bindingsz00);
														}
														BgL_testz00_4173 = PAIRP(BgL_auxz00_4174);
													}
													if (BgL_testz00_4173)
														{	/* Coerce/coerce.scm 279 */
															bool_t BgL_testz00_4179;

															{	/* Coerce/coerce.scm 279 */
																obj_t BgL_auxz00_4180;

																{	/* Coerce/coerce.scm 279 */
																	obj_t BgL_pairz00_2653;

																	{
																		BgL_letzd2varzd2_bglt BgL_auxz00_4181;

																		BgL_auxz00_4181 =
																			(BgL_letzd2varzd2_bglt)
																			(BgL_nodez00_1580);
																		BgL_pairz00_2653 =
																			(((BgL_letzd2varzd2_bglt)
																				CREF(BgL_auxz00_4181))->
																			BgL_bindingsz00);
																	}
																	BgL_auxz00_4180 = CDR(BgL_pairz00_2653);
																}
																BgL_testz00_4179 = NULLP(BgL_auxz00_4180);
															}
															if (BgL_testz00_4179)
																{	/* Coerce/coerce.scm 280 */
																	bool_t BgL_testz00_4186;

																	{	/* Coerce/coerce.scm 280 */
																		BgL_nodez00_bglt BgL_arg3746z00_1617;

																		{
																			BgL_letzd2varzd2_bglt BgL_auxz00_4187;

																			BgL_auxz00_4187 =
																				(BgL_letzd2varzd2_bglt)
																				(BgL_nodez00_1580);
																			BgL_arg3746z00_1617 =
																				(((BgL_letzd2varzd2_bglt)
																					CREF(BgL_auxz00_4187))->BgL_bodyz00);
																		}
																		{	/* Coerce/coerce.scm 280 */
																			obj_t BgL_obj2445z00_2656;

																			BgL_obj2445z00_2656 =
																				(obj_t) (BgL_arg3746z00_1617);
																			BgL_testz00_4186 =
																				BGl_iszd2azf3z21zz__objectz00
																				(BgL_obj2445z00_2656,
																				BGl_appz00zzast_nodez00);
																		}
																	}
																	if (BgL_testz00_4186)
																		{	/* Coerce/coerce.scm 281 */
																			BgL_varz00_bglt BgL_funz00_1586;

																			{	/* Coerce/coerce.scm 281 */
																				BgL_appz00_bglt BgL_obj2418z00_2658;

																				{	/* Coerce/coerce.scm 281 */
																					BgL_letzd2varzd2_bglt
																						BgL_obj3235z00_2657;
																					BgL_obj3235z00_2657 =
																						(BgL_letzd2varzd2_bglt)
																						(BgL_nodez00_1580);
																					BgL_obj2418z00_2658 =
																						(BgL_appz00_bglt) (((
																								(BgL_letzd2varzd2_bglt)
																								CREF(BgL_obj3235z00_2657))->
																							BgL_bodyz00));
																				}
																				BgL_funz00_1586 =
																					(((BgL_appz00_bglt)
																						CREF(BgL_obj2418z00_2658))->
																					BgL_funz00);
																			}
																			{	/* Coerce/coerce.scm 281 */
																				obj_t BgL_varz00_1587;

																				{	/* Coerce/coerce.scm 282 */
																					obj_t BgL_argsz00_1608;

																					{	/* Coerce/coerce.scm 282 */
																						BgL_appz00_bglt BgL_obj2421z00_2660;

																						{	/* Coerce/coerce.scm 282 */
																							BgL_letzd2varzd2_bglt
																								BgL_obj3235z00_2659;
																							BgL_obj3235z00_2659 =
																								(BgL_letzd2varzd2_bglt)
																								(BgL_nodez00_1580);
																							BgL_obj2421z00_2660 =
																								(BgL_appz00_bglt) (((
																										(BgL_letzd2varzd2_bglt)
																										CREF(BgL_obj3235z00_2659))->
																									BgL_bodyz00));
																						}
																						BgL_argsz00_1608 =
																							(((BgL_appz00_bglt)
																								CREF(BgL_obj2421z00_2660))->
																							BgL_argsz00);
																					}
																					if (PAIRP(BgL_argsz00_1608))
																						{	/* Coerce/coerce.scm 283 */
																							if (NULLP(CDR(BgL_argsz00_1608)))
																								{	/* Coerce/coerce.scm 285 */
																									bool_t BgL_testz00_4205;

																									{	/* Coerce/coerce.scm 285 */
																										obj_t BgL_arg3742z00_1613;

																										BgL_arg3742z00_1613 =
																											CAR(BgL_argsz00_1608);
																										BgL_testz00_4205 =
																											BGl_iszd2azf3z21zz__objectz00
																											(BgL_arg3742z00_1613,
																											BGl_varz00zzast_nodez00);
																									}
																									if (BgL_testz00_4205)
																										{	/* Coerce/coerce.scm 286 */
																											BgL_varz00_bglt
																												BgL_obj2324z00_2667;
																											{	/* Coerce/coerce.scm 286 */
																												obj_t BgL_pairz00_2666;

																												BgL_pairz00_2666 =
																													BgL_argsz00_1608;
																												BgL_obj2324z00_2667 =
																													(BgL_varz00_bglt) (CAR
																													(BgL_pairz00_2666));
																											}
																											BgL_varz00_1587 =
																												(obj_t) (
																												(((BgL_varz00_bglt)
																														CREF
																														(BgL_obj2324z00_2667))->
																													BgL_variablez00));
																										}
																									else
																										{	/* Coerce/coerce.scm 285 */
																											BgL_varz00_1587 = BFALSE;
																										}
																								}
																							else
																								{	/* Coerce/coerce.scm 284 */
																									BgL_varz00_1587 = BFALSE;
																								}
																						}
																					else
																						{	/* Coerce/coerce.scm 283 */
																							BgL_varz00_1587 = BFALSE;
																						}
																				}
																				{	/* Coerce/coerce.scm 282 */
																					BgL_valuez00_bglt BgL_valz00_1588;

																					{	/* Coerce/coerce.scm 287 */
																						BgL_variablez00_bglt
																							BgL_obj1780z00_2669;
																						BgL_obj1780z00_2669 =
																							(((BgL_varz00_bglt)
																								CREF(BgL_funz00_1586))->
																							BgL_variablez00);
																						BgL_valz00_1588 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_obj1780z00_2669))->
																							BgL_valuez00);
																					}
																					{	/* Coerce/coerce.scm 287 */
																						obj_t BgL_typecz00_1589;

																						{
																							BgL_funz00_bglt BgL_auxz00_4214;

																							BgL_auxz00_4214 =
																								(BgL_funz00_bglt)
																								(BgL_valz00_1588);
																							BgL_typecz00_1589 =
																								(((BgL_funz00_bglt)
																									CREF(BgL_auxz00_4214))->
																								BgL_predicatezd2ofzd2);
																						}
																						{	/* Coerce/coerce.scm 288 */
																							BgL_typez00_bglt
																								BgL_typepz00_1590;
																							{	/* Coerce/coerce.scm 289 */
																								BgL_variablez00_bglt
																									BgL_obj1777z00_2674;
																								{	/* Coerce/coerce.scm 289 */
																									obj_t BgL_auxz00_4217;

																									{	/* Coerce/coerce.scm 289 */
																										obj_t BgL_pairz00_2673;

																										{	/* Coerce/coerce.scm 289 */
																											obj_t BgL_pairz00_2672;

																											{
																												BgL_letzd2varzd2_bglt
																													BgL_auxz00_4218;
																												BgL_auxz00_4218 =
																													(BgL_letzd2varzd2_bglt)
																													(BgL_nodez00_1580);
																												BgL_pairz00_2672 =
																													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4218))->BgL_bindingsz00);
																											}
																											BgL_pairz00_2673 =
																												CAR(BgL_pairz00_2672);
																										}
																										BgL_auxz00_4217 =
																											CAR(BgL_pairz00_2673);
																									}
																									BgL_obj1777z00_2674 =
																										(BgL_variablez00_bglt)
																										(BgL_auxz00_4217);
																								}
																								BgL_typepz00_1590 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_obj1777z00_2674))->
																									BgL_typez00);
																							}
																							{	/* Coerce/coerce.scm 289 */
																								BgL_typez00_bglt
																									BgL_typevz00_1591;
																								if (((obj_t) (BgL_typepz00_1590)
																										==
																										BGl_za2objza2z00zztype_cachez00))
																									{	/* Coerce/coerce.scm 291 */
																										obj_t BgL_arg3734z00_1601;

																										{	/* Coerce/coerce.scm 291 */
																											obj_t BgL_pairz00_2677;

																											{	/* Coerce/coerce.scm 291 */
																												obj_t BgL_pairz00_2676;

																												{
																													BgL_letzd2varzd2_bglt
																														BgL_auxz00_4228;
																													BgL_auxz00_4228 =
																														(BgL_letzd2varzd2_bglt)
																														(BgL_nodez00_1580);
																													BgL_pairz00_2676 =
																														(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4228))->BgL_bindingsz00);
																												}
																												BgL_pairz00_2677 =
																													CAR(BgL_pairz00_2676);
																											}
																											BgL_arg3734z00_1601 =
																												CDR(BgL_pairz00_2677);
																										}
																										BgL_typevz00_1591 =
																											BGl_typeofz00zztype_typeofz00
																											((BgL_nodez00_bglt)
																											(BgL_arg3734z00_1601));
																									}
																								else
																									{	/* Coerce/coerce.scm 290 */
																										BgL_typevz00_1591 =
																											BgL_typepz00_1590;
																									}
																								{	/* Coerce/coerce.scm 290 */

																									if (BGl_iszd2azf3z21zz__objectz00(BgL_typecz00_1589, BGl_typez00zztype_typez00))
																										{	/* Coerce/coerce.scm 297 */
																											bool_t BgL_testz00_4237;

																											{	/* Coerce/coerce.scm 297 */
																												obj_t BgL_auxz00_4238;

																												{	/* Coerce/coerce.scm 297 */
																													obj_t
																														BgL_pairz00_2681;
																													{	/* Coerce/coerce.scm 297 */
																														obj_t
																															BgL_pairz00_2680;
																														{
																															BgL_letzd2varzd2_bglt
																																BgL_auxz00_4239;
																															BgL_auxz00_4239 =
																																(BgL_letzd2varzd2_bglt)
																																(BgL_nodez00_1580);
																															BgL_pairz00_2680 =
																																(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4239))->BgL_bindingsz00);
																														}
																														BgL_pairz00_2681 =
																															CAR
																															(BgL_pairz00_2680);
																													}
																													BgL_auxz00_4238 =
																														CAR
																														(BgL_pairz00_2681);
																												}
																												BgL_testz00_4237 =
																													(BgL_varz00_1587 ==
																													BgL_auxz00_4238);
																											}
																											if (BgL_testz00_4237)
																												{	/* Coerce/coerce.scm 297 */
																													if (
																														((obj_t)
																															(BgL_typevz00_1591)
																															==
																															BGl_za2objza2z00zztype_cachez00))
																														{	/* Coerce/coerce.scm 300 */
																															BgL_casezd2valuezd2_1566
																																= BFALSE;
																														}
																													else
																														{	/* Coerce/coerce.scm 300 */
																															if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1589), BgL_typevz00_1591))
																																{	/* Coerce/coerce.scm 303 */
																																	BgL_casezd2valuezd2_1566
																																		=
																																		CNST_TABLE_REF
																																		(((long)
																																			1));
																																}
																															else
																																{	/* Coerce/coerce.scm 303 */
																																	if (BGl_typezd2disjointzf3z21zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1589), BgL_typevz00_1591))
																																		{	/* Coerce/coerce.scm 305 */
																																			BgL_casezd2valuezd2_1566
																																				=
																																				CNST_TABLE_REF
																																				(((long)
																																					2));
																																		}
																																	else
																																		{	/* Coerce/coerce.scm 305 */
																																			BgL_casezd2valuezd2_1566
																																				=
																																				BFALSE;
																																		}
																																}
																														}
																												}
																											else
																												{	/* Coerce/coerce.scm 297 */
																													BgL_casezd2valuezd2_1566
																														= BFALSE;
																												}
																										}
																									else
																										{	/* Coerce/coerce.scm 294 */
																											BgL_casezd2valuezd2_1566 =
																												BFALSE;
																										}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	else
																		{	/* Coerce/coerce.scm 280 */
																			BgL_casezd2valuezd2_1566 = BFALSE;
																		}
																}
															else
																{	/* Coerce/coerce.scm 279 */
																	BgL_casezd2valuezd2_1566 = BFALSE;
																}
														}
													else
														{	/* Coerce/coerce.scm 278 */
															BgL_casezd2valuezd2_1566 = BFALSE;
														}
												}
											}
										else
											{	/* Coerce/coerce.scm 313 */
												BgL_casezd2valuezd2_1566 = BFALSE;
											}
									}
							}
						}
						if ((BgL_casezd2valuezd2_1566 == CNST_TABLE_REF(((long) 1))))
							{	/* Coerce/coerce.scm 321 */
								BgL_nodez00_bglt BgL_arg3713z00_1568;

								BgL_arg3713z00_1568 =
									(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
									BgL_truez00);
								{	/* Coerce/coerce.scm 321 */
									BgL_nodez00_bglt BgL_res3887z00_2546;

									{	/* Coerce/coerce.scm 321 */
										BgL_typez00_bglt BgL_toz00_2519;

										bool_t BgL_safez00_2520;

										BgL_toz00_2519 = (BgL_typez00_bglt) (BgL_toz00_1556);
										BgL_safez00_2520 = CBOOL(BgL_safez00_1557);
										{	/* Coerce/coerce.scm 321 */
											obj_t BgL_method3484z00_2521;

											{	/* Coerce/coerce.scm 321 */
												BgL_objectz00_bglt BgL_objz00_2522;

												BgL_objz00_2522 =
													(BgL_objectz00_bglt) (BgL_arg3713z00_1568);
												{	/* Coerce/coerce.scm 321 */
													long BgL_objzd2classzd2numz00_2523;

													BgL_objzd2classzd2numz00_2523 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2522);
													{	/* Coerce/coerce.scm 321 */
														obj_t BgL_arg2551z00_2524;

														BgL_arg2551z00_2524 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 321 */
															obj_t BgL_arrayz00_2526;

															int BgL_offsetz00_2527;

															BgL_arrayz00_2526 = BgL_arg2551z00_2524;
															BgL_offsetz00_2527 =
																(int) (BgL_objzd2classzd2numz00_2523);
															{	/* Coerce/coerce.scm 321 */
																long BgL_offsetz00_2528;

																BgL_offsetz00_2528 =
																	((long) (BgL_offsetz00_2527) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 321 */
																	long BgL_modz00_2529;

																	{	/* Coerce/coerce.scm 321 */
																		int BgL_arg2553z00_2530;

																		BgL_arg2553z00_2530 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 321 */
																			long BgL_auxz00_4270;

																			BgL_auxz00_4270 =
																				(long) (BgL_arg2553z00_2530);
																			BgL_modz00_2529 =
																				(BgL_offsetz00_2528 / BgL_auxz00_4270);
																	}}
																	{	/* Coerce/coerce.scm 321 */
																		long BgL_restz00_2531;

																		{	/* Coerce/coerce.scm 321 */
																			int BgL_arg2552z00_2532;

																			BgL_arg2552z00_2532 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 321 */
																				long BgL_auxz00_4274;

																				BgL_auxz00_4274 =
																					(long) (BgL_arg2552z00_2532);
																				BgL_restz00_2531 =
																					(BgL_offsetz00_2528 %
																					BgL_auxz00_4274);
																		}}
																		{	/* Coerce/coerce.scm 321 */

																			BgL_method3484z00_2521 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2526,
																					(int) (BgL_modz00_2529)),
																				(int) (BgL_restz00_2531));
											}}}}}}}}
											BgL_res3887z00_2546 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2521) (BgL_method3484z00_2521,
													(obj_t) (BgL_arg3713z00_1568), BgL_callerz00_1555,
													(obj_t) (BgL_toz00_2519), BBOOL(BgL_safez00_2520),
													BEOA));
									}}
									return (obj_t) (BgL_res3887z00_2546);
								}
							}
						else
							{	/* Coerce/coerce.scm 319 */
								if ((BgL_casezd2valuezd2_1566 == CNST_TABLE_REF(((long) 2))))
									{	/* Coerce/coerce.scm 323 */
										BgL_nodez00_bglt BgL_arg3715z00_1570;

										BgL_arg3715z00_1570 =
											(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
											BgL_falsez00);
										{	/* Coerce/coerce.scm 323 */
											BgL_nodez00_bglt BgL_res3890z00_2579;

											{	/* Coerce/coerce.scm 323 */
												BgL_typez00_bglt BgL_toz00_2552;

												bool_t BgL_safez00_2553;

												BgL_toz00_2552 = (BgL_typez00_bglt) (BgL_toz00_1556);
												BgL_safez00_2553 = CBOOL(BgL_safez00_1557);
												{	/* Coerce/coerce.scm 323 */
													obj_t BgL_method3484z00_2554;

													{	/* Coerce/coerce.scm 323 */
														BgL_objectz00_bglt BgL_objz00_2555;

														BgL_objz00_2555 =
															(BgL_objectz00_bglt) (BgL_arg3715z00_1570);
														{	/* Coerce/coerce.scm 323 */
															long BgL_objzd2classzd2numz00_2556;

															BgL_objzd2classzd2numz00_2556 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2555);
															{	/* Coerce/coerce.scm 323 */
																obj_t BgL_arg2551z00_2557;

																BgL_arg2551z00_2557 =
																	PROCEDURE_REF
																	(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																	(int) (((long) 1)));
																{	/* Coerce/coerce.scm 323 */
																	obj_t BgL_arrayz00_2559;

																	int BgL_offsetz00_2560;

																	BgL_arrayz00_2559 = BgL_arg2551z00_2557;
																	BgL_offsetz00_2560 =
																		(int) (BgL_objzd2classzd2numz00_2556);
																	{	/* Coerce/coerce.scm 323 */
																		long BgL_offsetz00_2561;

																		BgL_offsetz00_2561 =
																			(
																			(long) (BgL_offsetz00_2560) -
																			OBJECT_TYPE);
																		{	/* Coerce/coerce.scm 323 */
																			long BgL_modz00_2562;

																			{	/* Coerce/coerce.scm 323 */
																				int BgL_arg2553z00_2563;

																				BgL_arg2553z00_2563 =
																					(int) (((long) 8));
																				{	/* Coerce/coerce.scm 323 */
																					long BgL_auxz00_4302;

																					BgL_auxz00_4302 =
																						(long) (BgL_arg2553z00_2563);
																					BgL_modz00_2562 =
																						(BgL_offsetz00_2561 /
																						BgL_auxz00_4302);
																			}}
																			{	/* Coerce/coerce.scm 323 */
																				long BgL_restz00_2564;

																				{	/* Coerce/coerce.scm 323 */
																					int BgL_arg2552z00_2565;

																					BgL_arg2552z00_2565 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 323 */
																						long BgL_auxz00_4306;

																						BgL_auxz00_4306 =
																							(long) (BgL_arg2552z00_2565);
																						BgL_restz00_2564 =
																							(BgL_offsetz00_2561 %
																							BgL_auxz00_4306);
																				}}
																				{	/* Coerce/coerce.scm 323 */

																					BgL_method3484z00_2554 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2559,
																							(int) (BgL_modz00_2562)),
																						(int) (BgL_restz00_2564));
													}}}}}}}}
													BgL_res3890z00_2579 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3484z00_2554) (BgL_method3484z00_2554,
															(obj_t) (BgL_arg3715z00_1570), BgL_callerz00_1555,
															(obj_t) (BgL_toz00_2552), BBOOL(BgL_safez00_2553),
															BEOA));
											}}
											return (obj_t) (BgL_res3890z00_2579);
										}
									}
								else
									{	/* Coerce/coerce.scm 319 */
										{	/* Coerce/coerce.scm 325 */
											BgL_nodez00_bglt BgL_arg3716z00_1571;

											{	/* Coerce/coerce.scm 325 */
												BgL_nodez00_bglt BgL_arg3717z00_1572;

												BgL_arg3717z00_1572 =
													(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
													BgL_truez00);
												{	/* Coerce/coerce.scm 325 */
													BgL_nodez00_bglt BgL_res3893z00_2610;

													{	/* Coerce/coerce.scm 325 */
														BgL_typez00_bglt BgL_toz00_2583;

														bool_t BgL_safez00_2584;

														BgL_toz00_2583 =
															(BgL_typez00_bglt) (BgL_toz00_1556);
														BgL_safez00_2584 = CBOOL(BgL_safez00_1557);
														{	/* Coerce/coerce.scm 325 */
															obj_t BgL_method3484z00_2585;

															{	/* Coerce/coerce.scm 325 */
																BgL_objectz00_bglt BgL_objz00_2586;

																BgL_objz00_2586 =
																	(BgL_objectz00_bglt) (BgL_arg3717z00_1572);
																{	/* Coerce/coerce.scm 325 */
																	long BgL_objzd2classzd2numz00_2587;

																	BgL_objzd2classzd2numz00_2587 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2586);
																	{	/* Coerce/coerce.scm 325 */
																		obj_t BgL_arg2551z00_2588;

																		BgL_arg2551z00_2588 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 325 */
																			obj_t BgL_arrayz00_2590;

																			int BgL_offsetz00_2591;

																			BgL_arrayz00_2590 = BgL_arg2551z00_2588;
																			BgL_offsetz00_2591 =
																				(int) (BgL_objzd2classzd2numz00_2587);
																			{	/* Coerce/coerce.scm 325 */
																				long BgL_offsetz00_2592;

																				BgL_offsetz00_2592 =
																					(
																					(long) (BgL_offsetz00_2591) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 325 */
																					long BgL_modz00_2593;

																					{	/* Coerce/coerce.scm 325 */
																						int BgL_arg2553z00_2594;

																						BgL_arg2553z00_2594 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 325 */
																							long BgL_auxz00_4331;

																							BgL_auxz00_4331 =
																								(long) (BgL_arg2553z00_2594);
																							BgL_modz00_2593 =
																								(BgL_offsetz00_2592 /
																								BgL_auxz00_4331);
																					}}
																					{	/* Coerce/coerce.scm 325 */
																						long BgL_restz00_2595;

																						{	/* Coerce/coerce.scm 325 */
																							int BgL_arg2552z00_2596;

																							BgL_arg2552z00_2596 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 325 */
																								long BgL_auxz00_4335;

																								BgL_auxz00_4335 =
																									(long) (BgL_arg2552z00_2596);
																								BgL_restz00_2595 =
																									(BgL_offsetz00_2592 %
																									BgL_auxz00_4335);
																						}}
																						{	/* Coerce/coerce.scm 325 */

																							BgL_method3484z00_2585 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2590,
																									(int) (BgL_modz00_2593)),
																								(int) (BgL_restz00_2595));
															}}}}}}}}
															BgL_res3893z00_2610 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3484z00_2585)
																(BgL_method3484z00_2585,
																	(obj_t) (BgL_arg3717z00_1572),
																	BgL_callerz00_1555, (obj_t) (BgL_toz00_2583),
																	BBOOL(BgL_safez00_2584), BEOA));
													}}
													BgL_arg3716z00_1571 = BgL_res3893z00_2610;
											}}
											((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
													BgL_truez00) =
												((BgL_nodez00_bglt) BgL_arg3716z00_1571), BUNSPEC);
										}
										{	/* Coerce/coerce.scm 326 */
											BgL_nodez00_bglt BgL_arg3718z00_1573;

											{	/* Coerce/coerce.scm 326 */
												BgL_nodez00_bglt BgL_arg3719z00_1574;

												BgL_arg3719z00_1574 =
													(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
													BgL_falsez00);
												{	/* Coerce/coerce.scm 326 */
													BgL_nodez00_bglt BgL_res3896z00_2643;

													{	/* Coerce/coerce.scm 326 */
														BgL_typez00_bglt BgL_toz00_2616;

														bool_t BgL_safez00_2617;

														BgL_toz00_2616 =
															(BgL_typez00_bglt) (BgL_toz00_1556);
														BgL_safez00_2617 = CBOOL(BgL_safez00_1557);
														{	/* Coerce/coerce.scm 326 */
															obj_t BgL_method3484z00_2618;

															{	/* Coerce/coerce.scm 326 */
																BgL_objectz00_bglt BgL_objz00_2619;

																BgL_objz00_2619 =
																	(BgL_objectz00_bglt) (BgL_arg3719z00_1574);
																{	/* Coerce/coerce.scm 326 */
																	long BgL_objzd2classzd2numz00_2620;

																	BgL_objzd2classzd2numz00_2620 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2619);
																	{	/* Coerce/coerce.scm 326 */
																		obj_t BgL_arg2551z00_2621;

																		BgL_arg2551z00_2621 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 326 */
																			obj_t BgL_arrayz00_2623;

																			int BgL_offsetz00_2624;

																			BgL_arrayz00_2623 = BgL_arg2551z00_2621;
																			BgL_offsetz00_2624 =
																				(int) (BgL_objzd2classzd2numz00_2620);
																			{	/* Coerce/coerce.scm 326 */
																				long BgL_offsetz00_2625;

																				BgL_offsetz00_2625 =
																					(
																					(long) (BgL_offsetz00_2624) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 326 */
																					long BgL_modz00_2626;

																					{	/* Coerce/coerce.scm 326 */
																						int BgL_arg2553z00_2627;

																						BgL_arg2553z00_2627 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 326 */
																							long BgL_auxz00_4360;

																							BgL_auxz00_4360 =
																								(long) (BgL_arg2553z00_2627);
																							BgL_modz00_2626 =
																								(BgL_offsetz00_2625 /
																								BgL_auxz00_4360);
																					}}
																					{	/* Coerce/coerce.scm 326 */
																						long BgL_restz00_2628;

																						{	/* Coerce/coerce.scm 326 */
																							int BgL_arg2552z00_2629;

																							BgL_arg2552z00_2629 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 326 */
																								long BgL_auxz00_4364;

																								BgL_auxz00_4364 =
																									(long) (BgL_arg2552z00_2629);
																								BgL_restz00_2628 =
																									(BgL_offsetz00_2625 %
																									BgL_auxz00_4364);
																						}}
																						{	/* Coerce/coerce.scm 326 */

																							BgL_method3484z00_2618 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2623,
																									(int) (BgL_modz00_2626)),
																								(int) (BgL_restz00_2628));
															}}}}}}}}
															BgL_res3896z00_2643 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3484z00_2618)
																(BgL_method3484z00_2618,
																	(obj_t) (BgL_arg3719z00_1574),
																	BgL_callerz00_1555, (obj_t) (BgL_toz00_2616),
																	BBOOL(BgL_safez00_2617), BEOA));
													}}
													BgL_arg3718z00_1573 = BgL_res3896z00_2643;
											}}
											((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1554))->
													BgL_falsez00) =
												((BgL_nodez00_bglt) BgL_arg3718z00_1573), BUNSPEC);
										}
										{
											BgL_typez00_bglt BgL_auxz00_4380;

											BgL_nodez00_bglt BgL_auxz00_4378;

											BgL_auxz00_4380 = (BgL_typez00_bglt) (BgL_toz00_1556);
											BgL_auxz00_4378 = (BgL_nodez00_bglt) (BgL_nodez00_1554);
											((((BgL_nodez00_bglt) CREF(BgL_auxz00_4378))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_auxz00_4380), BUNSPEC);
										}
										return (obj_t) (BgL_nodez00_1554);
									}
							}
					}
				}
			}
		}
	}



/* coerce!-setq3515 */
	obj_t BGl_coercez12zd2setq3515zc0zzcoerce_coercez00(obj_t BgL_envz00_3307,
		obj_t BgL_nodez00_3308, obj_t BgL_callerz00_3309, obj_t BgL_toz00_3310,
		obj_t BgL_safez00_3311)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 229 */
			{
				BgL_setqz00_bglt BgL_nodez00_1540;

				obj_t BgL_callerz00_1541;

				obj_t BgL_toz00_1542;

				obj_t BgL_safez00_1543;

				{	/* Coerce/coerce.scm 230 */
					BgL_nodez00_bglt BgL_auxz00_4385;

					BgL_nodez00_1540 = (BgL_setqz00_bglt) (BgL_nodez00_3308);
					BgL_callerz00_1541 = BgL_callerz00_3309;
					BgL_toz00_1542 = BgL_toz00_3310;
					BgL_safez00_1543 = BgL_safez00_3311;
					{	/* Coerce/coerce.scm 231 */
						BgL_nodez00_bglt BgL_arg3704z00_1547;

						{	/* Coerce/coerce.scm 231 */
							BgL_nodez00_bglt BgL_arg3705z00_1548;

							BgL_typez00_bglt BgL_arg3706z00_1549;

							BgL_arg3705z00_1548 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1540))->BgL_valuez00);
							{	/* Coerce/coerce.scm 233 */
								BgL_variablez00_bglt BgL_arg3707z00_1550;

								{	/* Coerce/coerce.scm 233 */
									BgL_varz00_bglt BgL_obj2324z00_2446;

									BgL_obj2324z00_2446 =
										(((BgL_setqz00_bglt) CREF(BgL_nodez00_1540))->BgL_varz00);
									BgL_arg3707z00_1550 =
										(((BgL_varz00_bglt) CREF(BgL_obj2324z00_2446))->
										BgL_variablez00);
								}
								BgL_arg3706z00_1549 =
									(((BgL_variablez00_bglt) CREF(BgL_arg3707z00_1550))->
									BgL_typez00);
							}
							{	/* Coerce/coerce.scm 231 */
								BgL_nodez00_bglt BgL_res3881z00_2477;

								{	/* Coerce/coerce.scm 231 */
									bool_t BgL_safez00_2451;

									BgL_safez00_2451 = CBOOL(BgL_safez00_1543);
									{	/* Coerce/coerce.scm 231 */
										obj_t BgL_method3484z00_2452;

										{	/* Coerce/coerce.scm 231 */
											BgL_objectz00_bglt BgL_objz00_2453;

											BgL_objz00_2453 =
												(BgL_objectz00_bglt) (BgL_arg3705z00_1548);
											{	/* Coerce/coerce.scm 231 */
												long BgL_objzd2classzd2numz00_2454;

												BgL_objzd2classzd2numz00_2454 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2453);
												{	/* Coerce/coerce.scm 231 */
													obj_t BgL_arg2551z00_2455;

													BgL_arg2551z00_2455 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 231 */
														obj_t BgL_arrayz00_2457;

														int BgL_offsetz00_2458;

														BgL_arrayz00_2457 = BgL_arg2551z00_2455;
														BgL_offsetz00_2458 =
															(int) (BgL_objzd2classzd2numz00_2454);
														{	/* Coerce/coerce.scm 231 */
															long BgL_offsetz00_2459;

															BgL_offsetz00_2459 =
																((long) (BgL_offsetz00_2458) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 231 */
																long BgL_modz00_2460;

																{	/* Coerce/coerce.scm 231 */
																	int BgL_arg2553z00_2461;

																	BgL_arg2553z00_2461 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 231 */
																		long BgL_auxz00_4399;

																		BgL_auxz00_4399 =
																			(long) (BgL_arg2553z00_2461);
																		BgL_modz00_2460 =
																			(BgL_offsetz00_2459 / BgL_auxz00_4399);
																}}
																{	/* Coerce/coerce.scm 231 */
																	long BgL_restz00_2462;

																	{	/* Coerce/coerce.scm 231 */
																		int BgL_arg2552z00_2463;

																		BgL_arg2552z00_2463 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 231 */
																			long BgL_auxz00_4403;

																			BgL_auxz00_4403 =
																				(long) (BgL_arg2552z00_2463);
																			BgL_restz00_2462 =
																				(BgL_offsetz00_2459 % BgL_auxz00_4403);
																	}}
																	{	/* Coerce/coerce.scm 231 */

																		BgL_method3484z00_2452 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2457,
																				(int) (BgL_modz00_2460)),
																			(int) (BgL_restz00_2462));
										}}}}}}}}
										BgL_res3881z00_2477 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2452) (BgL_method3484z00_2452,
												(obj_t) (BgL_arg3705z00_1548), BgL_callerz00_1541,
												(obj_t) (BgL_arg3706z00_1549), BBOOL(BgL_safez00_2451),
												BEOA));
								}}
								BgL_arg3704z00_1547 = BgL_res3881z00_2477;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1540))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3704z00_1547), BUNSPEC);
					}
					BgL_auxz00_4385 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1540),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1542), CBOOL(BgL_safez00_1543));
					return (obj_t) (BgL_auxz00_4385);
				}
			}
		}
	}



/* coerce!-cast3513 */
	obj_t BGl_coercez12zd2cast3513zc0zzcoerce_coercez00(obj_t BgL_envz00_3312,
		obj_t BgL_nodez00_3313, obj_t BgL_callerz00_3314, obj_t BgL_toz00_3315,
		obj_t BgL_safez00_3316)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 219 */
			{
				BgL_castz00_bglt BgL_nodez00_1528;

				obj_t BgL_callerz00_1529;

				obj_t BgL_toz00_1530;

				obj_t BgL_safez00_1531;

				{	/* Coerce/coerce.scm 220 */
					BgL_nodez00_bglt BgL_auxz00_4424;

					BgL_nodez00_1528 = (BgL_castz00_bglt) (BgL_nodez00_3313);
					BgL_callerz00_1529 = BgL_callerz00_3314;
					BgL_toz00_1530 = BgL_toz00_3315;
					BgL_safez00_1531 = BgL_safez00_3316;
					{	/* Coerce/coerce.scm 220 */
						BgL_nodez00_bglt BgL_arg3700z00_2407;

						{	/* Coerce/coerce.scm 220 */
							BgL_nodez00_bglt BgL_arg3701z00_2408;

							BgL_arg3701z00_2408 =
								(((BgL_castz00_bglt) CREF(BgL_nodez00_1528))->BgL_argz00);
							{	/* Coerce/coerce.scm 220 */
								BgL_nodez00_bglt BgL_res3878z00_2440;

								{	/* Coerce/coerce.scm 220 */
									BgL_typez00_bglt BgL_toz00_2413;

									bool_t BgL_safez00_2414;

									BgL_toz00_2413 = (BgL_typez00_bglt) (BgL_toz00_1530);
									BgL_safez00_2414 = CBOOL(BgL_safez00_1531);
									{	/* Coerce/coerce.scm 220 */
										obj_t BgL_method3484z00_2415;

										{	/* Coerce/coerce.scm 220 */
											BgL_objectz00_bglt BgL_objz00_2416;

											BgL_objz00_2416 =
												(BgL_objectz00_bglt) (BgL_arg3701z00_2408);
											{	/* Coerce/coerce.scm 220 */
												long BgL_objzd2classzd2numz00_2417;

												BgL_objzd2classzd2numz00_2417 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2416);
												{	/* Coerce/coerce.scm 220 */
													obj_t BgL_arg2551z00_2418;

													BgL_arg2551z00_2418 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 220 */
														obj_t BgL_arrayz00_2420;

														int BgL_offsetz00_2421;

														BgL_arrayz00_2420 = BgL_arg2551z00_2418;
														BgL_offsetz00_2421 =
															(int) (BgL_objzd2classzd2numz00_2417);
														{	/* Coerce/coerce.scm 220 */
															long BgL_offsetz00_2422;

															BgL_offsetz00_2422 =
																((long) (BgL_offsetz00_2421) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 220 */
																long BgL_modz00_2423;

																{	/* Coerce/coerce.scm 220 */
																	int BgL_arg2553z00_2424;

																	BgL_arg2553z00_2424 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 220 */
																		long BgL_auxz00_4436;

																		BgL_auxz00_4436 =
																			(long) (BgL_arg2553z00_2424);
																		BgL_modz00_2423 =
																			(BgL_offsetz00_2422 / BgL_auxz00_4436);
																}}
																{	/* Coerce/coerce.scm 220 */
																	long BgL_restz00_2425;

																	{	/* Coerce/coerce.scm 220 */
																		int BgL_arg2552z00_2426;

																		BgL_arg2552z00_2426 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 220 */
																			long BgL_auxz00_4440;

																			BgL_auxz00_4440 =
																				(long) (BgL_arg2552z00_2426);
																			BgL_restz00_2425 =
																				(BgL_offsetz00_2422 % BgL_auxz00_4440);
																	}}
																	{	/* Coerce/coerce.scm 220 */

																		BgL_method3484z00_2415 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2420,
																				(int) (BgL_modz00_2423)),
																			(int) (BgL_restz00_2425));
										}}}}}}}}
										BgL_res3878z00_2440 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2415) (BgL_method3484z00_2415,
												(obj_t) (BgL_arg3701z00_2408), BgL_callerz00_1529,
												(obj_t) (BgL_toz00_2413), BBOOL(BgL_safez00_2414),
												BEOA));
								}}
								BgL_arg3700z00_2407 = BgL_res3878z00_2440;
						}}
						((((BgL_castz00_bglt) CREF(BgL_nodez00_1528))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3700z00_2407), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 220 */
						BgL_typez00_bglt BgL_arg3702z00_2409;

						{
							BgL_nodez00_bglt BgL_auxz00_4454;

							BgL_auxz00_4454 = (BgL_nodez00_bglt) (BgL_nodez00_1528);
							BgL_arg3702z00_2409 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4454))->BgL_typez00);
						}
						BgL_auxz00_4424 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1528), BgL_arg3702z00_2409,
							(BgL_typez00_bglt) (BgL_toz00_1530), CBOOL(BgL_safez00_1531));
					}
					return (obj_t) (BgL_auxz00_4424);
				}
			}
		}
	}



/* coerce!-vlength3511 */
	obj_t BGl_coercez12zd2vlength3511zc0zzcoerce_coercez00(obj_t BgL_envz00_3317,
		obj_t BgL_nodez00_3318, obj_t BgL_callerz00_3319, obj_t BgL_toz00_3320,
		obj_t BgL_safez00_3321)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 211 */
			{
				BgL_vlengthz00_bglt BgL_nodez00_1513;

				obj_t BgL_callerz00_1514;

				obj_t BgL_toz00_1515;

				obj_t BgL_safez00_1516;

				{	/* Coerce/coerce.scm 212 */
					BgL_nodez00_bglt BgL_auxz00_4463;

					BgL_nodez00_1513 = (BgL_vlengthz00_bglt) (BgL_nodez00_3318);
					BgL_callerz00_1514 = BgL_callerz00_3319;
					BgL_toz00_1515 = BgL_toz00_3320;
					BgL_safez00_1516 = BgL_safez00_3321;
					{	/* Coerce/coerce.scm 213 */
						obj_t BgL_arg3693z00_1520;

						BgL_nodez00_bglt BgL_arg3694z00_1521;

						{
							BgL_externz00_bglt BgL_auxz00_4464;

							BgL_auxz00_4464 = (BgL_externz00_bglt) (BgL_nodez00_1513);
							BgL_arg3693z00_1520 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4464))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 213 */
							obj_t BgL_arg3695z00_1522;

							BgL_typez00_bglt BgL_arg3696z00_1523;

							{	/* Coerce/coerce.scm 213 */
								obj_t BgL_pairz00_2371;

								{
									BgL_externz00_bglt BgL_auxz00_4467;

									BgL_auxz00_4467 = (BgL_externz00_bglt) (BgL_nodez00_1513);
									BgL_pairz00_2371 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4467))->
										BgL_exprza2za2);
								}
								BgL_arg3695z00_1522 = CAR(BgL_pairz00_2371);
							}
							BgL_arg3696z00_1523 =
								(((BgL_vlengthz00_bglt) CREF(BgL_nodez00_1513))->BgL_vtypez00);
							{	/* Coerce/coerce.scm 213 */
								BgL_nodez00_bglt BgL_res3875z00_2402;

								{	/* Coerce/coerce.scm 213 */
									BgL_nodez00_bglt BgL_nodez00_2373;

									bool_t BgL_safez00_2376;

									BgL_nodez00_2373 = (BgL_nodez00_bglt) (BgL_arg3695z00_1522);
									BgL_safez00_2376 = CBOOL(BgL_safez00_1516);
									{	/* Coerce/coerce.scm 213 */
										obj_t BgL_method3484z00_2377;

										{	/* Coerce/coerce.scm 213 */
											BgL_objectz00_bglt BgL_objz00_2378;

											BgL_objz00_2378 = (BgL_objectz00_bglt) (BgL_nodez00_2373);
											{	/* Coerce/coerce.scm 213 */
												long BgL_objzd2classzd2numz00_2379;

												BgL_objzd2classzd2numz00_2379 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2378);
												{	/* Coerce/coerce.scm 213 */
													obj_t BgL_arg2551z00_2380;

													BgL_arg2551z00_2380 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 213 */
														obj_t BgL_arrayz00_2382;

														int BgL_offsetz00_2383;

														BgL_arrayz00_2382 = BgL_arg2551z00_2380;
														BgL_offsetz00_2383 =
															(int) (BgL_objzd2classzd2numz00_2379);
														{	/* Coerce/coerce.scm 213 */
															long BgL_offsetz00_2384;

															BgL_offsetz00_2384 =
																((long) (BgL_offsetz00_2383) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 213 */
																long BgL_modz00_2385;

																{	/* Coerce/coerce.scm 213 */
																	int BgL_arg2553z00_2386;

																	BgL_arg2553z00_2386 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 213 */
																		long BgL_auxz00_4482;

																		BgL_auxz00_4482 =
																			(long) (BgL_arg2553z00_2386);
																		BgL_modz00_2385 =
																			(BgL_offsetz00_2384 / BgL_auxz00_4482);
																}}
																{	/* Coerce/coerce.scm 213 */
																	long BgL_restz00_2387;

																	{	/* Coerce/coerce.scm 213 */
																		int BgL_arg2552z00_2388;

																		BgL_arg2552z00_2388 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 213 */
																			long BgL_auxz00_4486;

																			BgL_auxz00_4486 =
																				(long) (BgL_arg2552z00_2388);
																			BgL_restz00_2387 =
																				(BgL_offsetz00_2384 % BgL_auxz00_4486);
																	}}
																	{	/* Coerce/coerce.scm 213 */

																		BgL_method3484z00_2377 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2382,
																				(int) (BgL_modz00_2385)),
																			(int) (BgL_restz00_2387));
										}}}}}}}}
										BgL_res3875z00_2402 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2377) (BgL_method3484z00_2377,
												(obj_t) (BgL_nodez00_2373), BgL_callerz00_1514,
												(obj_t) (BgL_arg3696z00_1523), BBOOL(BgL_safez00_2376),
												BEOA));
								}}
								BgL_arg3694z00_1521 = BgL_res3875z00_2402;
						}}
						{	/* Coerce/coerce.scm 213 */
							obj_t BgL_auxz00_4499;

							BgL_auxz00_4499 = (obj_t) (BgL_arg3694z00_1521);
							SET_CAR(BgL_arg3693z00_1520, BgL_auxz00_4499);
					}}
					{	/* Coerce/coerce.scm 214 */
						BgL_typez00_bglt BgL_arg3698z00_1525;

						{
							BgL_nodez00_bglt BgL_auxz00_4502;

							BgL_auxz00_4502 = (BgL_nodez00_bglt) (BgL_nodez00_1513);
							BgL_arg3698z00_1525 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4502))->BgL_typez00);
						}
						BgL_auxz00_4463 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1513), BgL_arg3698z00_1525,
							(BgL_typez00_bglt) (BgL_toz00_1515), CBOOL(BgL_safez00_1516));
					}
					return (obj_t) (BgL_auxz00_4463);
				}
			}
		}
	}



/* coerce!-vset!3509 */
	obj_t BGl_coercez12zd2vsetz123509zd2zzcoerce_coercez00(obj_t BgL_envz00_3322,
		obj_t BgL_nodez00_3323, obj_t BgL_callerz00_3324, obj_t BgL_toz00_3325,
		obj_t BgL_safez00_3326)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 199 */
			{
				BgL_vsetz12z12_bglt BgL_nodez00_1484;

				obj_t BgL_callerz00_1485;

				obj_t BgL_toz00_1486;

				obj_t BgL_safez00_1487;

				{	/* Coerce/coerce.scm 200 */
					BgL_nodez00_bglt BgL_auxz00_4511;

					BgL_nodez00_1484 = (BgL_vsetz12z12_bglt) (BgL_nodez00_3323);
					BgL_callerz00_1485 = BgL_callerz00_3324;
					BgL_toz00_1486 = BgL_toz00_3325;
					BgL_safez00_1487 = BgL_safez00_3326;
					{	/* Coerce/coerce.scm 202 */
						obj_t BgL_ftypez00_1491;

						{	/* Coerce/coerce.scm 202 */
							bool_t BgL_testz00_4512;

							{	/* Coerce/coerce.scm 202 */
								BgL_typez00_bglt BgL_arg3691z00_1510;

								BgL_arg3691z00_1510 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1484))->
									BgL_ftypez00);
								BgL_testz00_4512 =
									((obj_t) (BgL_arg3691z00_1510) ==
									BGl_za2_za2z00zztype_cachez00);
							}
							if (BgL_testz00_4512)
								{	/* Coerce/coerce.scm 202 */
									BgL_ftypez00_1491 = BGl_za2objza2z00zztype_cachez00;
								}
							else
								{	/* Coerce/coerce.scm 202 */
									BgL_ftypez00_1491 =
										(obj_t) (
										(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1484))->
											BgL_ftypez00));
								}
						}
						{	/* Coerce/coerce.scm 203 */
							obj_t BgL_arg3673z00_1492;

							BgL_nodez00_bglt BgL_arg3674z00_1493;

							{
								BgL_externz00_bglt BgL_auxz00_4518;

								BgL_auxz00_4518 = (BgL_externz00_bglt) (BgL_nodez00_1484);
								BgL_arg3673z00_1492 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4518))->
									BgL_exprza2za2);
							}
							{	/* Coerce/coerce.scm 203 */
								obj_t BgL_arg3675z00_1494;

								BgL_typez00_bglt BgL_arg3676z00_1495;

								{	/* Coerce/coerce.scm 203 */
									obj_t BgL_pairz00_2250;

									{
										BgL_externz00_bglt BgL_auxz00_4521;

										BgL_auxz00_4521 = (BgL_externz00_bglt) (BgL_nodez00_1484);
										BgL_pairz00_2250 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4521))->
											BgL_exprza2za2);
									}
									BgL_arg3675z00_1494 = CAR(BgL_pairz00_2250);
								}
								BgL_arg3676z00_1495 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1484))->
									BgL_vtypez00);
								{	/* Coerce/coerce.scm 203 */
									BgL_nodez00_bglt BgL_res3866z00_2281;

									{	/* Coerce/coerce.scm 203 */
										BgL_nodez00_bglt BgL_nodez00_2252;

										bool_t BgL_safez00_2255;

										BgL_nodez00_2252 = (BgL_nodez00_bglt) (BgL_arg3675z00_1494);
										BgL_safez00_2255 = CBOOL(BgL_safez00_1487);
										{	/* Coerce/coerce.scm 203 */
											obj_t BgL_method3484z00_2256;

											{	/* Coerce/coerce.scm 203 */
												BgL_objectz00_bglt BgL_objz00_2257;

												BgL_objz00_2257 =
													(BgL_objectz00_bglt) (BgL_nodez00_2252);
												{	/* Coerce/coerce.scm 203 */
													long BgL_objzd2classzd2numz00_2258;

													BgL_objzd2classzd2numz00_2258 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2257);
													{	/* Coerce/coerce.scm 203 */
														obj_t BgL_arg2551z00_2259;

														BgL_arg2551z00_2259 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 203 */
															obj_t BgL_arrayz00_2261;

															int BgL_offsetz00_2262;

															BgL_arrayz00_2261 = BgL_arg2551z00_2259;
															BgL_offsetz00_2262 =
																(int) (BgL_objzd2classzd2numz00_2258);
															{	/* Coerce/coerce.scm 203 */
																long BgL_offsetz00_2263;

																BgL_offsetz00_2263 =
																	((long) (BgL_offsetz00_2262) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 203 */
																	long BgL_modz00_2264;

																	{	/* Coerce/coerce.scm 203 */
																		int BgL_arg2553z00_2265;

																		BgL_arg2553z00_2265 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 203 */
																			long BgL_auxz00_4536;

																			BgL_auxz00_4536 =
																				(long) (BgL_arg2553z00_2265);
																			BgL_modz00_2264 =
																				(BgL_offsetz00_2263 / BgL_auxz00_4536);
																	}}
																	{	/* Coerce/coerce.scm 203 */
																		long BgL_restz00_2266;

																		{	/* Coerce/coerce.scm 203 */
																			int BgL_arg2552z00_2267;

																			BgL_arg2552z00_2267 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 203 */
																				long BgL_auxz00_4540;

																				BgL_auxz00_4540 =
																					(long) (BgL_arg2552z00_2267);
																				BgL_restz00_2266 =
																					(BgL_offsetz00_2263 %
																					BgL_auxz00_4540);
																		}}
																		{	/* Coerce/coerce.scm 203 */

																			BgL_method3484z00_2256 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2261,
																					(int) (BgL_modz00_2264)),
																				(int) (BgL_restz00_2266));
											}}}}}}}}
											BgL_res3866z00_2281 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2256) (BgL_method3484z00_2256,
													(obj_t) (BgL_nodez00_2252), BgL_callerz00_1485,
													(obj_t) (BgL_arg3676z00_1495),
													BBOOL(BgL_safez00_2255), BEOA));
									}}
									BgL_arg3674z00_1493 = BgL_res3866z00_2281;
							}}
							{	/* Coerce/coerce.scm 203 */
								obj_t BgL_auxz00_4553;

								BgL_auxz00_4553 = (obj_t) (BgL_arg3674z00_1493);
								SET_CAR(BgL_arg3673z00_1492, BgL_auxz00_4553);
						}}
						{	/* Coerce/coerce.scm 204 */
							obj_t BgL_arg3678z00_1497;

							BgL_nodez00_bglt BgL_arg3679z00_1498;

							{	/* Coerce/coerce.scm 204 */
								obj_t BgL_pairz00_2285;

								{
									BgL_externz00_bglt BgL_auxz00_4556;

									BgL_auxz00_4556 = (BgL_externz00_bglt) (BgL_nodez00_1484);
									BgL_pairz00_2285 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4556))->
										BgL_exprza2za2);
								}
								BgL_arg3678z00_1497 = CDR(BgL_pairz00_2285);
							}
							{	/* Coerce/coerce.scm 204 */
								obj_t BgL_arg3681z00_1500;

								BgL_typez00_bglt BgL_arg3682z00_1501;

								{	/* Coerce/coerce.scm 204 */
									obj_t BgL_pairz00_2287;

									{
										BgL_externz00_bglt BgL_auxz00_4560;

										BgL_auxz00_4560 = (BgL_externz00_bglt) (BgL_nodez00_1484);
										BgL_pairz00_2287 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4560))->
											BgL_exprza2za2);
									}
									BgL_arg3681z00_1500 = CAR(CDR(BgL_pairz00_2287));
								}
								BgL_arg3682z00_1501 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1484))->
									BgL_otypez00);
								{	/* Coerce/coerce.scm 204 */
									BgL_nodez00_bglt BgL_res3869z00_2321;

									{	/* Coerce/coerce.scm 204 */
										BgL_nodez00_bglt BgL_nodez00_2292;

										bool_t BgL_safez00_2295;

										BgL_nodez00_2292 = (BgL_nodez00_bglt) (BgL_arg3681z00_1500);
										BgL_safez00_2295 = CBOOL(BgL_safez00_1487);
										{	/* Coerce/coerce.scm 204 */
											obj_t BgL_method3484z00_2296;

											{	/* Coerce/coerce.scm 204 */
												BgL_objectz00_bglt BgL_objz00_2297;

												BgL_objz00_2297 =
													(BgL_objectz00_bglt) (BgL_nodez00_2292);
												{	/* Coerce/coerce.scm 204 */
													long BgL_objzd2classzd2numz00_2298;

													BgL_objzd2classzd2numz00_2298 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2297);
													{	/* Coerce/coerce.scm 204 */
														obj_t BgL_arg2551z00_2299;

														BgL_arg2551z00_2299 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 204 */
															obj_t BgL_arrayz00_2301;

															int BgL_offsetz00_2302;

															BgL_arrayz00_2301 = BgL_arg2551z00_2299;
															BgL_offsetz00_2302 =
																(int) (BgL_objzd2classzd2numz00_2298);
															{	/* Coerce/coerce.scm 204 */
																long BgL_offsetz00_2303;

																BgL_offsetz00_2303 =
																	((long) (BgL_offsetz00_2302) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 204 */
																	long BgL_modz00_2304;

																	{	/* Coerce/coerce.scm 204 */
																		int BgL_arg2553z00_2305;

																		BgL_arg2553z00_2305 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 204 */
																			long BgL_auxz00_4576;

																			BgL_auxz00_4576 =
																				(long) (BgL_arg2553z00_2305);
																			BgL_modz00_2304 =
																				(BgL_offsetz00_2303 / BgL_auxz00_4576);
																	}}
																	{	/* Coerce/coerce.scm 204 */
																		long BgL_restz00_2306;

																		{	/* Coerce/coerce.scm 204 */
																			int BgL_arg2552z00_2307;

																			BgL_arg2552z00_2307 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 204 */
																				long BgL_auxz00_4580;

																				BgL_auxz00_4580 =
																					(long) (BgL_arg2552z00_2307);
																				BgL_restz00_2306 =
																					(BgL_offsetz00_2303 %
																					BgL_auxz00_4580);
																		}}
																		{	/* Coerce/coerce.scm 204 */

																			BgL_method3484z00_2296 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2301,
																					(int) (BgL_modz00_2304)),
																				(int) (BgL_restz00_2306));
											}}}}}}}}
											BgL_res3869z00_2321 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2296) (BgL_method3484z00_2296,
													(obj_t) (BgL_nodez00_2292), BgL_callerz00_1485,
													(obj_t) (BgL_arg3682z00_1501),
													BBOOL(BgL_safez00_2295), BEOA));
									}}
									BgL_arg3679z00_1498 = BgL_res3869z00_2321;
							}}
							{	/* Coerce/coerce.scm 204 */
								obj_t BgL_auxz00_4593;

								BgL_auxz00_4593 = (obj_t) (BgL_arg3679z00_1498);
								SET_CAR(BgL_arg3678z00_1497, BgL_auxz00_4593);
						}}
						{	/* Coerce/coerce.scm 205 */
							obj_t BgL_arg3684z00_1503;

							BgL_nodez00_bglt BgL_arg3685z00_1504;

							{	/* Coerce/coerce.scm 205 */
								obj_t BgL_pairz00_2325;

								{
									BgL_externz00_bglt BgL_auxz00_4596;

									BgL_auxz00_4596 = (BgL_externz00_bglt) (BgL_nodez00_1484);
									BgL_pairz00_2325 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4596))->
										BgL_exprza2za2);
								}
								BgL_arg3684z00_1503 = CDR(CDR(BgL_pairz00_2325));
							}
							{	/* Coerce/coerce.scm 205 */
								obj_t BgL_arg3687z00_1506;

								{	/* Coerce/coerce.scm 205 */
									obj_t BgL_pairz00_2330;

									{
										BgL_externz00_bglt BgL_auxz00_4601;

										BgL_auxz00_4601 = (BgL_externz00_bglt) (BgL_nodez00_1484);
										BgL_pairz00_2330 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4601))->
											BgL_exprza2za2);
									}
									BgL_arg3687z00_1506 = CAR(CDR(CDR(BgL_pairz00_2330)));
								}
								{	/* Coerce/coerce.scm 205 */
									BgL_nodez00_bglt BgL_res3872z00_2365;

									{	/* Coerce/coerce.scm 205 */
										BgL_nodez00_bglt BgL_nodez00_2336;

										BgL_typez00_bglt BgL_toz00_2338;

										bool_t BgL_safez00_2339;

										BgL_nodez00_2336 = (BgL_nodez00_bglt) (BgL_arg3687z00_1506);
										BgL_toz00_2338 = (BgL_typez00_bglt) (BgL_ftypez00_1491);
										BgL_safez00_2339 = CBOOL(BgL_safez00_1487);
										{	/* Coerce/coerce.scm 205 */
											obj_t BgL_method3484z00_2340;

											{	/* Coerce/coerce.scm 205 */
												BgL_objectz00_bglt BgL_objz00_2341;

												BgL_objz00_2341 =
													(BgL_objectz00_bglt) (BgL_nodez00_2336);
												{	/* Coerce/coerce.scm 205 */
													long BgL_objzd2classzd2numz00_2342;

													BgL_objzd2classzd2numz00_2342 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2341);
													{	/* Coerce/coerce.scm 205 */
														obj_t BgL_arg2551z00_2343;

														BgL_arg2551z00_2343 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 205 */
															obj_t BgL_arrayz00_2345;

															int BgL_offsetz00_2346;

															BgL_arrayz00_2345 = BgL_arg2551z00_2343;
															BgL_offsetz00_2346 =
																(int) (BgL_objzd2classzd2numz00_2342);
															{	/* Coerce/coerce.scm 205 */
																long BgL_offsetz00_2347;

																BgL_offsetz00_2347 =
																	((long) (BgL_offsetz00_2346) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 205 */
																	long BgL_modz00_2348;

																	{	/* Coerce/coerce.scm 205 */
																		int BgL_arg2553z00_2349;

																		BgL_arg2553z00_2349 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 205 */
																			long BgL_auxz00_4618;

																			BgL_auxz00_4618 =
																				(long) (BgL_arg2553z00_2349);
																			BgL_modz00_2348 =
																				(BgL_offsetz00_2347 / BgL_auxz00_4618);
																	}}
																	{	/* Coerce/coerce.scm 205 */
																		long BgL_restz00_2350;

																		{	/* Coerce/coerce.scm 205 */
																			int BgL_arg2552z00_2351;

																			BgL_arg2552z00_2351 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 205 */
																				long BgL_auxz00_4622;

																				BgL_auxz00_4622 =
																					(long) (BgL_arg2552z00_2351);
																				BgL_restz00_2350 =
																					(BgL_offsetz00_2347 %
																					BgL_auxz00_4622);
																		}}
																		{	/* Coerce/coerce.scm 205 */

																			BgL_method3484z00_2340 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2345,
																					(int) (BgL_modz00_2348)),
																				(int) (BgL_restz00_2350));
											}}}}}}}}
											BgL_res3872z00_2365 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2340) (BgL_method3484z00_2340,
													(obj_t) (BgL_nodez00_2336), BgL_callerz00_1485,
													(obj_t) (BgL_toz00_2338), BBOOL(BgL_safez00_2339),
													BEOA));
									}}
									BgL_arg3685z00_1504 = BgL_res3872z00_2365;
							}}
							{	/* Coerce/coerce.scm 205 */
								obj_t BgL_auxz00_4635;

								BgL_auxz00_4635 = (obj_t) (BgL_arg3685z00_1504);
								SET_CAR(BgL_arg3684z00_1503, BgL_auxz00_4635);
						}}
						{	/* Coerce/coerce.scm 206 */
							BgL_typez00_bglt BgL_arg3689z00_1508;

							{
								BgL_nodez00_bglt BgL_auxz00_4638;

								BgL_auxz00_4638 = (BgL_nodez00_bglt) (BgL_nodez00_1484);
								BgL_arg3689z00_1508 =
									(((BgL_nodez00_bglt) CREF(BgL_auxz00_4638))->BgL_typez00);
							}
							BgL_auxz00_4511 =
								BGl_convertz12z12zzcoerce_convertz00(
								(BgL_nodez00_bglt) (BgL_nodez00_1484), BgL_arg3689z00_1508,
								(BgL_typez00_bglt) (BgL_toz00_1486), CBOOL(BgL_safez00_1487));
					}}
					return (obj_t) (BgL_auxz00_4511);
				}
			}
		}
	}



/* coerce!-vref3507 */
	obj_t BGl_coercez12zd2vref3507zc0zzcoerce_coercez00(obj_t BgL_envz00_3327,
		obj_t BgL_nodez00_3328, obj_t BgL_callerz00_3329, obj_t BgL_toz00_3330,
		obj_t BgL_safez00_3331)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 183 */
			{
				BgL_vrefz00_bglt BgL_nodez00_1461;

				obj_t BgL_callerz00_1462;

				obj_t BgL_toz00_1463;

				obj_t BgL_safez00_1464;

				{	/* Coerce/coerce.scm 184 */
					BgL_nodez00_bglt BgL_auxz00_4647;

					BgL_nodez00_1461 = (BgL_vrefz00_bglt) (BgL_nodez00_3328);
					BgL_callerz00_1462 = BgL_callerz00_3329;
					BgL_toz00_1463 = BgL_toz00_3330;
					BgL_safez00_1464 = BgL_safez00_3331;
					{	/* Coerce/coerce.scm 191 */
						obj_t BgL_ftypez00_1468;

						{	/* Coerce/coerce.scm 191 */
							bool_t BgL_testz00_4648;

							{	/* Coerce/coerce.scm 191 */
								BgL_typez00_bglt BgL_arg3671z00_1481;

								BgL_arg3671z00_1481 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1461))->BgL_ftypez00);
								BgL_testz00_4648 =
									(
									(obj_t) (BgL_arg3671z00_1481) ==
									BGl_za2_za2z00zztype_cachez00);
							}
							if (BgL_testz00_4648)
								{	/* Coerce/coerce.scm 191 */
									BgL_ftypez00_1468 = BGl_za2objza2z00zztype_cachez00;
								}
							else
								{	/* Coerce/coerce.scm 191 */
									BgL_ftypez00_1468 =
										(obj_t) (
										(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1461))->
											BgL_ftypez00));
								}
						}
						{	/* Coerce/coerce.scm 192 */
							obj_t BgL_arg3659z00_1469;

							BgL_nodez00_bglt BgL_arg3660z00_1470;

							{
								BgL_externz00_bglt BgL_auxz00_4654;

								BgL_auxz00_4654 = (BgL_externz00_bglt) (BgL_nodez00_1461);
								BgL_arg3659z00_1469 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4654))->
									BgL_exprza2za2);
							}
							{	/* Coerce/coerce.scm 192 */
								obj_t BgL_arg3661z00_1471;

								BgL_typez00_bglt BgL_arg3662z00_1472;

								{	/* Coerce/coerce.scm 192 */
									obj_t BgL_pairz00_2172;

									{
										BgL_externz00_bglt BgL_auxz00_4657;

										BgL_auxz00_4657 = (BgL_externz00_bglt) (BgL_nodez00_1461);
										BgL_pairz00_2172 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4657))->
											BgL_exprza2za2);
									}
									BgL_arg3661z00_1471 = CAR(BgL_pairz00_2172);
								}
								BgL_arg3662z00_1472 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1461))->BgL_vtypez00);
								{	/* Coerce/coerce.scm 192 */
									BgL_nodez00_bglt BgL_res3860z00_2203;

									{	/* Coerce/coerce.scm 192 */
										BgL_nodez00_bglt BgL_nodez00_2174;

										bool_t BgL_safez00_2177;

										BgL_nodez00_2174 = (BgL_nodez00_bglt) (BgL_arg3661z00_1471);
										BgL_safez00_2177 = CBOOL(BgL_safez00_1464);
										{	/* Coerce/coerce.scm 192 */
											obj_t BgL_method3484z00_2178;

											{	/* Coerce/coerce.scm 192 */
												BgL_objectz00_bglt BgL_objz00_2179;

												BgL_objz00_2179 =
													(BgL_objectz00_bglt) (BgL_nodez00_2174);
												{	/* Coerce/coerce.scm 192 */
													long BgL_objzd2classzd2numz00_2180;

													BgL_objzd2classzd2numz00_2180 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2179);
													{	/* Coerce/coerce.scm 192 */
														obj_t BgL_arg2551z00_2181;

														BgL_arg2551z00_2181 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 192 */
															obj_t BgL_arrayz00_2183;

															int BgL_offsetz00_2184;

															BgL_arrayz00_2183 = BgL_arg2551z00_2181;
															BgL_offsetz00_2184 =
																(int) (BgL_objzd2classzd2numz00_2180);
															{	/* Coerce/coerce.scm 192 */
																long BgL_offsetz00_2185;

																BgL_offsetz00_2185 =
																	((long) (BgL_offsetz00_2184) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 192 */
																	long BgL_modz00_2186;

																	{	/* Coerce/coerce.scm 192 */
																		int BgL_arg2553z00_2187;

																		BgL_arg2553z00_2187 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 192 */
																			long BgL_auxz00_4672;

																			BgL_auxz00_4672 =
																				(long) (BgL_arg2553z00_2187);
																			BgL_modz00_2186 =
																				(BgL_offsetz00_2185 / BgL_auxz00_4672);
																	}}
																	{	/* Coerce/coerce.scm 192 */
																		long BgL_restz00_2188;

																		{	/* Coerce/coerce.scm 192 */
																			int BgL_arg2552z00_2189;

																			BgL_arg2552z00_2189 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 192 */
																				long BgL_auxz00_4676;

																				BgL_auxz00_4676 =
																					(long) (BgL_arg2552z00_2189);
																				BgL_restz00_2188 =
																					(BgL_offsetz00_2185 %
																					BgL_auxz00_4676);
																		}}
																		{	/* Coerce/coerce.scm 192 */

																			BgL_method3484z00_2178 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2183,
																					(int) (BgL_modz00_2186)),
																				(int) (BgL_restz00_2188));
											}}}}}}}}
											BgL_res3860z00_2203 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2178) (BgL_method3484z00_2178,
													(obj_t) (BgL_nodez00_2174), BgL_callerz00_1462,
													(obj_t) (BgL_arg3662z00_1472),
													BBOOL(BgL_safez00_2177), BEOA));
									}}
									BgL_arg3660z00_1470 = BgL_res3860z00_2203;
							}}
							{	/* Coerce/coerce.scm 192 */
								obj_t BgL_auxz00_4689;

								BgL_auxz00_4689 = (obj_t) (BgL_arg3660z00_1470);
								SET_CAR(BgL_arg3659z00_1469, BgL_auxz00_4689);
						}}
						{	/* Coerce/coerce.scm 193 */
							obj_t BgL_arg3664z00_1474;

							BgL_nodez00_bglt BgL_arg3665z00_1475;

							{	/* Coerce/coerce.scm 193 */
								obj_t BgL_pairz00_2207;

								{
									BgL_externz00_bglt BgL_auxz00_4692;

									BgL_auxz00_4692 = (BgL_externz00_bglt) (BgL_nodez00_1461);
									BgL_pairz00_2207 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4692))->
										BgL_exprza2za2);
								}
								BgL_arg3664z00_1474 = CDR(BgL_pairz00_2207);
							}
							{	/* Coerce/coerce.scm 193 */
								obj_t BgL_arg3667z00_1477;

								BgL_typez00_bglt BgL_arg3668z00_1478;

								{	/* Coerce/coerce.scm 193 */
									obj_t BgL_pairz00_2209;

									{
										BgL_externz00_bglt BgL_auxz00_4696;

										BgL_auxz00_4696 = (BgL_externz00_bglt) (BgL_nodez00_1461);
										BgL_pairz00_2209 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4696))->
											BgL_exprza2za2);
									}
									BgL_arg3667z00_1477 = CAR(CDR(BgL_pairz00_2209));
								}
								BgL_arg3668z00_1478 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1461))->BgL_otypez00);
								{	/* Coerce/coerce.scm 193 */
									BgL_nodez00_bglt BgL_res3863z00_2243;

									{	/* Coerce/coerce.scm 193 */
										BgL_nodez00_bglt BgL_nodez00_2214;

										bool_t BgL_safez00_2217;

										BgL_nodez00_2214 = (BgL_nodez00_bglt) (BgL_arg3667z00_1477);
										BgL_safez00_2217 = CBOOL(BgL_safez00_1464);
										{	/* Coerce/coerce.scm 193 */
											obj_t BgL_method3484z00_2218;

											{	/* Coerce/coerce.scm 193 */
												BgL_objectz00_bglt BgL_objz00_2219;

												BgL_objz00_2219 =
													(BgL_objectz00_bglt) (BgL_nodez00_2214);
												{	/* Coerce/coerce.scm 193 */
													long BgL_objzd2classzd2numz00_2220;

													BgL_objzd2classzd2numz00_2220 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2219);
													{	/* Coerce/coerce.scm 193 */
														obj_t BgL_arg2551z00_2221;

														BgL_arg2551z00_2221 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 193 */
															obj_t BgL_arrayz00_2223;

															int BgL_offsetz00_2224;

															BgL_arrayz00_2223 = BgL_arg2551z00_2221;
															BgL_offsetz00_2224 =
																(int) (BgL_objzd2classzd2numz00_2220);
															{	/* Coerce/coerce.scm 193 */
																long BgL_offsetz00_2225;

																BgL_offsetz00_2225 =
																	((long) (BgL_offsetz00_2224) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 193 */
																	long BgL_modz00_2226;

																	{	/* Coerce/coerce.scm 193 */
																		int BgL_arg2553z00_2227;

																		BgL_arg2553z00_2227 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 193 */
																			long BgL_auxz00_4712;

																			BgL_auxz00_4712 =
																				(long) (BgL_arg2553z00_2227);
																			BgL_modz00_2226 =
																				(BgL_offsetz00_2225 / BgL_auxz00_4712);
																	}}
																	{	/* Coerce/coerce.scm 193 */
																		long BgL_restz00_2228;

																		{	/* Coerce/coerce.scm 193 */
																			int BgL_arg2552z00_2229;

																			BgL_arg2552z00_2229 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 193 */
																				long BgL_auxz00_4716;

																				BgL_auxz00_4716 =
																					(long) (BgL_arg2552z00_2229);
																				BgL_restz00_2228 =
																					(BgL_offsetz00_2225 %
																					BgL_auxz00_4716);
																		}}
																		{	/* Coerce/coerce.scm 193 */

																			BgL_method3484z00_2218 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2223,
																					(int) (BgL_modz00_2226)),
																				(int) (BgL_restz00_2228));
											}}}}}}}}
											BgL_res3863z00_2243 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3484z00_2218) (BgL_method3484z00_2218,
													(obj_t) (BgL_nodez00_2214), BgL_callerz00_1462,
													(obj_t) (BgL_arg3668z00_1478),
													BBOOL(BgL_safez00_2217), BEOA));
									}}
									BgL_arg3665z00_1475 = BgL_res3863z00_2243;
							}}
							{	/* Coerce/coerce.scm 193 */
								obj_t BgL_auxz00_4729;

								BgL_auxz00_4729 = (obj_t) (BgL_arg3665z00_1475);
								SET_CAR(BgL_arg3664z00_1474, BgL_auxz00_4729);
						}}
						BgL_auxz00_4647 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1461),
							(BgL_typez00_bglt) (BgL_ftypez00_1468),
							(BgL_typez00_bglt) (BgL_toz00_1463), CBOOL(BgL_safez00_1464));
					}
					return (obj_t) (BgL_auxz00_4647);
				}
			}
		}
	}



/* coerce!-valloc3505 */
	obj_t BGl_coercez12zd2valloc3505zc0zzcoerce_coercez00(obj_t BgL_envz00_3332,
		obj_t BgL_nodez00_3333, obj_t BgL_callerz00_3334, obj_t BgL_toz00_3335,
		obj_t BgL_safez00_3336)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 175 */
			{
				BgL_vallocz00_bglt BgL_nodez00_1446;

				obj_t BgL_callerz00_1447;

				obj_t BgL_toz00_1448;

				obj_t BgL_safez00_1449;

				{	/* Coerce/coerce.scm 176 */
					BgL_nodez00_bglt BgL_auxz00_4739;

					BgL_nodez00_1446 = (BgL_vallocz00_bglt) (BgL_nodez00_3333);
					BgL_callerz00_1447 = BgL_callerz00_3334;
					BgL_toz00_1448 = BgL_toz00_3335;
					BgL_safez00_1449 = BgL_safez00_3336;
					{	/* Coerce/coerce.scm 177 */
						obj_t BgL_arg3652z00_1453;

						BgL_nodez00_bglt BgL_arg3653z00_1454;

						{
							BgL_externz00_bglt BgL_auxz00_4740;

							BgL_auxz00_4740 = (BgL_externz00_bglt) (BgL_nodez00_1446);
							BgL_arg3652z00_1453 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4740))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 177 */
							obj_t BgL_arg3654z00_1455;

							BgL_typez00_bglt BgL_arg3655z00_1456;

							{	/* Coerce/coerce.scm 177 */
								obj_t BgL_pairz00_2133;

								{
									BgL_externz00_bglt BgL_auxz00_4743;

									BgL_auxz00_4743 = (BgL_externz00_bglt) (BgL_nodez00_1446);
									BgL_pairz00_2133 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4743))->
										BgL_exprza2za2);
								}
								BgL_arg3654z00_1455 = CAR(BgL_pairz00_2133);
							}
							BgL_arg3655z00_1456 =
								(((BgL_vallocz00_bglt) CREF(BgL_nodez00_1446))->BgL_otypez00);
							{	/* Coerce/coerce.scm 177 */
								BgL_nodez00_bglt BgL_res3857z00_2164;

								{	/* Coerce/coerce.scm 177 */
									BgL_nodez00_bglt BgL_nodez00_2135;

									bool_t BgL_safez00_2138;

									BgL_nodez00_2135 = (BgL_nodez00_bglt) (BgL_arg3654z00_1455);
									BgL_safez00_2138 = CBOOL(BgL_safez00_1449);
									{	/* Coerce/coerce.scm 177 */
										obj_t BgL_method3484z00_2139;

										{	/* Coerce/coerce.scm 177 */
											BgL_objectz00_bglt BgL_objz00_2140;

											BgL_objz00_2140 = (BgL_objectz00_bglt) (BgL_nodez00_2135);
											{	/* Coerce/coerce.scm 177 */
												long BgL_objzd2classzd2numz00_2141;

												BgL_objzd2classzd2numz00_2141 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2140);
												{	/* Coerce/coerce.scm 177 */
													obj_t BgL_arg2551z00_2142;

													BgL_arg2551z00_2142 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 177 */
														obj_t BgL_arrayz00_2144;

														int BgL_offsetz00_2145;

														BgL_arrayz00_2144 = BgL_arg2551z00_2142;
														BgL_offsetz00_2145 =
															(int) (BgL_objzd2classzd2numz00_2141);
														{	/* Coerce/coerce.scm 177 */
															long BgL_offsetz00_2146;

															BgL_offsetz00_2146 =
																((long) (BgL_offsetz00_2145) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 177 */
																long BgL_modz00_2147;

																{	/* Coerce/coerce.scm 177 */
																	int BgL_arg2553z00_2148;

																	BgL_arg2553z00_2148 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 177 */
																		long BgL_auxz00_4758;

																		BgL_auxz00_4758 =
																			(long) (BgL_arg2553z00_2148);
																		BgL_modz00_2147 =
																			(BgL_offsetz00_2146 / BgL_auxz00_4758);
																}}
																{	/* Coerce/coerce.scm 177 */
																	long BgL_restz00_2149;

																	{	/* Coerce/coerce.scm 177 */
																		int BgL_arg2552z00_2150;

																		BgL_arg2552z00_2150 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 177 */
																			long BgL_auxz00_4762;

																			BgL_auxz00_4762 =
																				(long) (BgL_arg2552z00_2150);
																			BgL_restz00_2149 =
																				(BgL_offsetz00_2146 % BgL_auxz00_4762);
																	}}
																	{	/* Coerce/coerce.scm 177 */

																		BgL_method3484z00_2139 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2144,
																				(int) (BgL_modz00_2147)),
																			(int) (BgL_restz00_2149));
										}}}}}}}}
										BgL_res3857z00_2164 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2139) (BgL_method3484z00_2139,
												(obj_t) (BgL_nodez00_2135), BgL_callerz00_1447,
												(obj_t) (BgL_arg3655z00_1456), BBOOL(BgL_safez00_2138),
												BEOA));
								}}
								BgL_arg3653z00_1454 = BgL_res3857z00_2164;
						}}
						{	/* Coerce/coerce.scm 177 */
							obj_t BgL_auxz00_4775;

							BgL_auxz00_4775 = (obj_t) (BgL_arg3653z00_1454);
							SET_CAR(BgL_arg3652z00_1453, BgL_auxz00_4775);
					}}
					{	/* Coerce/coerce.scm 178 */
						BgL_typez00_bglt BgL_arg3657z00_1458;

						{
							BgL_nodez00_bglt BgL_auxz00_4778;

							BgL_auxz00_4778 = (BgL_nodez00_bglt) (BgL_nodez00_1446);
							BgL_arg3657z00_1458 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4778))->BgL_typez00);
						}
						BgL_auxz00_4739 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1446), BgL_arg3657z00_1458,
							(BgL_typez00_bglt) (BgL_toz00_1448), CBOOL(BgL_safez00_1449));
					}
					return (obj_t) (BgL_auxz00_4739);
				}
			}
		}
	}



/* coerce!-new3503 */
	obj_t BGl_coercez12zd2new3503zc0zzcoerce_coercez00(obj_t BgL_envz00_3337,
		obj_t BgL_nodez00_3338, obj_t BgL_callerz00_3339, obj_t BgL_toz00_3340,
		obj_t BgL_safez00_3341)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 159 */
			{
				BgL_newz00_bglt BgL_nodez00_1424;

				obj_t BgL_callerz00_1425;

				obj_t BgL_toz00_1426;

				obj_t BgL_safez00_1427;

				{	/* Coerce/coerce.scm 160 */
					BgL_nodez00_bglt BgL_auxz00_4787;

					BgL_nodez00_1424 = (BgL_newz00_bglt) (BgL_nodez00_3338);
					BgL_callerz00_1425 = BgL_callerz00_3339;
					BgL_toz00_1426 = BgL_toz00_3340;
					BgL_safez00_1427 = BgL_safez00_3341;
					{
						obj_t BgL_lz00_1433;

						{	/* Coerce/coerce.scm 161 */
							obj_t BgL_arg3641z00_1432;

							{
								BgL_externz00_bglt BgL_auxz00_4788;

								BgL_auxz00_4788 = (BgL_externz00_bglt) (BgL_nodez00_1424);
								BgL_arg3641z00_1432 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4788))->
									BgL_exprza2za2);
							}
							BgL_lz00_1433 = BgL_arg3641z00_1432;
						BgL_zc3anonymousza33642ze3z83_1434:
							if (NULLP(BgL_lz00_1433))
								{	/* Coerce/coerce.scm 163 */
									BgL_typez00_bglt BgL_arg3644z00_1436;

									{
										BgL_nodez00_bglt BgL_auxz00_4793;

										BgL_auxz00_4793 = (BgL_nodez00_bglt) (BgL_nodez00_1424);
										BgL_arg3644z00_1436 =
											(((BgL_nodez00_bglt) CREF(BgL_auxz00_4793))->BgL_typez00);
									}
									BGl_convertz12z12zzcoerce_convertz00(
										(BgL_nodez00_bglt) (BgL_nodez00_1424), BgL_arg3644z00_1436,
										(BgL_typez00_bglt) (BgL_toz00_1426),
										CBOOL(BgL_safez00_1427));
								}
							else
								{	/* Coerce/coerce.scm 162 */
									{	/* Coerce/coerce.scm 165 */
										BgL_nodez00_bglt BgL_arg3645z00_1437;

										{	/* Coerce/coerce.scm 165 */
											obj_t BgL_arg3646z00_1438;

											BgL_typez00_bglt BgL_arg3647z00_1439;

											BgL_arg3646z00_1438 = CAR(BgL_lz00_1433);
											{	/* Coerce/coerce.scm 167 */
												obj_t BgL_arg3648z00_1440;

												BgL_arg3648z00_1440 = CAR(BgL_lz00_1433);
												BgL_arg3647z00_1439 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3648z00_1440));
											}
											{	/* Coerce/coerce.scm 165 */
												BgL_nodez00_bglt BgL_res3854z00_2126;

												{	/* Coerce/coerce.scm 165 */
													BgL_nodez00_bglt BgL_nodez00_2097;

													bool_t BgL_safez00_2100;

													BgL_nodez00_2097 =
														(BgL_nodez00_bglt) (BgL_arg3646z00_1438);
													BgL_safez00_2100 = CBOOL(BgL_safez00_1427);
													{	/* Coerce/coerce.scm 165 */
														obj_t BgL_method3484z00_2101;

														{	/* Coerce/coerce.scm 165 */
															BgL_objectz00_bglt BgL_objz00_2102;

															BgL_objz00_2102 =
																(BgL_objectz00_bglt) (BgL_nodez00_2097);
															{	/* Coerce/coerce.scm 165 */
																long BgL_objzd2classzd2numz00_2103;

																BgL_objzd2classzd2numz00_2103 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2102);
																{	/* Coerce/coerce.scm 165 */
																	obj_t BgL_arg2551z00_2104;

																	BgL_arg2551z00_2104 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 165 */
																		obj_t BgL_arrayz00_2106;

																		int BgL_offsetz00_2107;

																		BgL_arrayz00_2106 = BgL_arg2551z00_2104;
																		BgL_offsetz00_2107 =
																			(int) (BgL_objzd2classzd2numz00_2103);
																		{	/* Coerce/coerce.scm 165 */
																			long BgL_offsetz00_2108;

																			BgL_offsetz00_2108 =
																				(
																				(long) (BgL_offsetz00_2107) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 165 */
																				long BgL_modz00_2109;

																				{	/* Coerce/coerce.scm 165 */
																					int BgL_arg2553z00_2110;

																					BgL_arg2553z00_2110 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 165 */
																						long BgL_auxz00_4814;

																						BgL_auxz00_4814 =
																							(long) (BgL_arg2553z00_2110);
																						BgL_modz00_2109 =
																							(BgL_offsetz00_2108 /
																							BgL_auxz00_4814);
																				}}
																				{	/* Coerce/coerce.scm 165 */
																					long BgL_restz00_2111;

																					{	/* Coerce/coerce.scm 165 */
																						int BgL_arg2552z00_2112;

																						BgL_arg2552z00_2112 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 165 */
																							long BgL_auxz00_4818;

																							BgL_auxz00_4818 =
																								(long) (BgL_arg2552z00_2112);
																							BgL_restz00_2111 =
																								(BgL_offsetz00_2108 %
																								BgL_auxz00_4818);
																					}}
																					{	/* Coerce/coerce.scm 165 */

																						BgL_method3484z00_2101 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2106,
																								(int) (BgL_modz00_2109)),
																							(int) (BgL_restz00_2111));
														}}}}}}}}
														BgL_res3854z00_2126 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3484z00_2101) (BgL_method3484z00_2101,
																(obj_t) (BgL_nodez00_2097), BgL_callerz00_1425,
																(obj_t) (BgL_arg3647z00_1439),
																BBOOL(BgL_safez00_2100), BEOA));
												}}
												BgL_arg3645z00_1437 = BgL_res3854z00_2126;
										}}
										{	/* Coerce/coerce.scm 165 */
											obj_t BgL_auxz00_4831;

											BgL_auxz00_4831 = (obj_t) (BgL_arg3645z00_1437);
											SET_CAR(BgL_lz00_1433, BgL_auxz00_4831);
									}}
									{
										obj_t BgL_lz00_4834;

										BgL_lz00_4834 = CDR(BgL_lz00_1433);
										BgL_lz00_1433 = BgL_lz00_4834;
										goto BgL_zc3anonymousza33642ze3z83_1434;
									}
								}
						}
					}
					{	/* Coerce/coerce.scm 170 */
						BgL_typez00_bglt BgL_arg3650z00_1443;

						{
							BgL_nodez00_bglt BgL_auxz00_4836;

							BgL_auxz00_4836 = (BgL_nodez00_bglt) (BgL_nodez00_1424);
							BgL_arg3650z00_1443 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4836))->BgL_typez00);
						}
						BgL_auxz00_4787 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1424), BgL_arg3650z00_1443,
							(BgL_typez00_bglt) (BgL_toz00_1426), CBOOL(BgL_safez00_1427));
					}
					return (obj_t) (BgL_auxz00_4787);
				}
			}
		}
	}



/* coerce!-setfield3501 */
	obj_t BGl_coercez12zd2setfield3501zc0zzcoerce_coercez00(obj_t BgL_envz00_3342,
		obj_t BgL_nodez00_3343, obj_t BgL_callerz00_3344, obj_t BgL_toz00_3345,
		obj_t BgL_safez00_3346)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 150 */
			{
				BgL_setfieldz00_bglt BgL_nodez00_1405;

				obj_t BgL_callerz00_1406;

				obj_t BgL_toz00_1407;

				obj_t BgL_safez00_1408;

				{	/* Coerce/coerce.scm 151 */
					BgL_nodez00_bglt BgL_auxz00_4845;

					BgL_nodez00_1405 = (BgL_setfieldz00_bglt) (BgL_nodez00_3343);
					BgL_callerz00_1406 = BgL_callerz00_3344;
					BgL_toz00_1407 = BgL_toz00_3345;
					BgL_safez00_1408 = BgL_safez00_3346;
					{	/* Coerce/coerce.scm 152 */
						obj_t BgL_arg3628z00_1412;

						BgL_nodez00_bglt BgL_arg3629z00_1413;

						{
							BgL_externz00_bglt BgL_auxz00_4846;

							BgL_auxz00_4846 = (BgL_externz00_bglt) (BgL_nodez00_1405);
							BgL_arg3628z00_1412 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4846))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 152 */
							obj_t BgL_arg3630z00_1414;

							{	/* Coerce/coerce.scm 152 */
								obj_t BgL_pairz00_2019;

								{
									BgL_externz00_bglt BgL_auxz00_4849;

									BgL_auxz00_4849 = (BgL_externz00_bglt) (BgL_nodez00_1405);
									BgL_pairz00_2019 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4849))->
										BgL_exprza2za2);
								}
								BgL_arg3630z00_1414 = CAR(BgL_pairz00_2019);
							}
							{	/* Coerce/coerce.scm 152 */
								BgL_nodez00_bglt BgL_res3848z00_2049;

								{	/* Coerce/coerce.scm 152 */
									BgL_nodez00_bglt BgL_nodez00_2020;

									BgL_typez00_bglt BgL_toz00_2022;

									bool_t BgL_safez00_2023;

									BgL_nodez00_2020 = (BgL_nodez00_bglt) (BgL_arg3630z00_1414);
									BgL_toz00_2022 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2023 = CBOOL(BgL_safez00_1408);
									{	/* Coerce/coerce.scm 152 */
										obj_t BgL_method3484z00_2024;

										{	/* Coerce/coerce.scm 152 */
											BgL_objectz00_bglt BgL_objz00_2025;

											BgL_objz00_2025 = (BgL_objectz00_bglt) (BgL_nodez00_2020);
											{	/* Coerce/coerce.scm 152 */
												long BgL_objzd2classzd2numz00_2026;

												BgL_objzd2classzd2numz00_2026 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2025);
												{	/* Coerce/coerce.scm 152 */
													obj_t BgL_arg2551z00_2027;

													BgL_arg2551z00_2027 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 152 */
														obj_t BgL_arrayz00_2029;

														int BgL_offsetz00_2030;

														BgL_arrayz00_2029 = BgL_arg2551z00_2027;
														BgL_offsetz00_2030 =
															(int) (BgL_objzd2classzd2numz00_2026);
														{	/* Coerce/coerce.scm 152 */
															long BgL_offsetz00_2031;

															BgL_offsetz00_2031 =
																((long) (BgL_offsetz00_2030) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 152 */
																long BgL_modz00_2032;

																{	/* Coerce/coerce.scm 152 */
																	int BgL_arg2553z00_2033;

																	BgL_arg2553z00_2033 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 152 */
																		long BgL_auxz00_4864;

																		BgL_auxz00_4864 =
																			(long) (BgL_arg2553z00_2033);
																		BgL_modz00_2032 =
																			(BgL_offsetz00_2031 / BgL_auxz00_4864);
																}}
																{	/* Coerce/coerce.scm 152 */
																	long BgL_restz00_2034;

																	{	/* Coerce/coerce.scm 152 */
																		int BgL_arg2552z00_2035;

																		BgL_arg2552z00_2035 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 152 */
																			long BgL_auxz00_4868;

																			BgL_auxz00_4868 =
																				(long) (BgL_arg2552z00_2035);
																			BgL_restz00_2034 =
																				(BgL_offsetz00_2031 % BgL_auxz00_4868);
																	}}
																	{	/* Coerce/coerce.scm 152 */

																		BgL_method3484z00_2024 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2029,
																				(int) (BgL_modz00_2032)),
																			(int) (BgL_restz00_2034));
										}}}}}}}}
										BgL_res3848z00_2049 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2024) (BgL_method3484z00_2024,
												(obj_t) (BgL_nodez00_2020), BgL_callerz00_1406,
												(obj_t) (BgL_toz00_2022), BBOOL(BgL_safez00_2023),
												BEOA));
								}}
								BgL_arg3629z00_1413 = BgL_res3848z00_2049;
						}}
						{	/* Coerce/coerce.scm 152 */
							obj_t BgL_auxz00_4881;

							BgL_auxz00_4881 = (obj_t) (BgL_arg3629z00_1413);
							SET_CAR(BgL_arg3628z00_1412, BgL_auxz00_4881);
					}}
					{	/* Coerce/coerce.scm 153 */
						obj_t BgL_arg3632z00_1416;

						BgL_nodez00_bglt BgL_arg3635z00_1417;

						{	/* Coerce/coerce.scm 153 */
							obj_t BgL_pairz00_2053;

							{
								BgL_externz00_bglt BgL_auxz00_4884;

								BgL_auxz00_4884 = (BgL_externz00_bglt) (BgL_nodez00_1405);
								BgL_pairz00_2053 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4884))->
									BgL_exprza2za2);
							}
							BgL_arg3632z00_1416 = CDR(BgL_pairz00_2053);
						}
						{	/* Coerce/coerce.scm 153 */
							obj_t BgL_arg3637z00_1419;

							BgL_typez00_bglt BgL_arg3638z00_1420;

							{	/* Coerce/coerce.scm 153 */
								obj_t BgL_pairz00_2055;

								{
									BgL_externz00_bglt BgL_auxz00_4888;

									BgL_auxz00_4888 = (BgL_externz00_bglt) (BgL_nodez00_1405);
									BgL_pairz00_2055 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4888))->
										BgL_exprza2za2);
								}
								BgL_arg3637z00_1419 = CAR(CDR(BgL_pairz00_2055));
							}
							BgL_arg3638z00_1420 =
								(((BgL_setfieldz00_bglt) CREF(BgL_nodez00_1405))->BgL_ftypez00);
							{	/* Coerce/coerce.scm 153 */
								BgL_nodez00_bglt BgL_res3851z00_2089;

								{	/* Coerce/coerce.scm 153 */
									BgL_nodez00_bglt BgL_nodez00_2060;

									bool_t BgL_safez00_2063;

									BgL_nodez00_2060 = (BgL_nodez00_bglt) (BgL_arg3637z00_1419);
									BgL_safez00_2063 = CBOOL(BgL_safez00_1408);
									{	/* Coerce/coerce.scm 153 */
										obj_t BgL_method3484z00_2064;

										{	/* Coerce/coerce.scm 153 */
											BgL_objectz00_bglt BgL_objz00_2065;

											BgL_objz00_2065 = (BgL_objectz00_bglt) (BgL_nodez00_2060);
											{	/* Coerce/coerce.scm 153 */
												long BgL_objzd2classzd2numz00_2066;

												BgL_objzd2classzd2numz00_2066 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2065);
												{	/* Coerce/coerce.scm 153 */
													obj_t BgL_arg2551z00_2067;

													BgL_arg2551z00_2067 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 153 */
														obj_t BgL_arrayz00_2069;

														int BgL_offsetz00_2070;

														BgL_arrayz00_2069 = BgL_arg2551z00_2067;
														BgL_offsetz00_2070 =
															(int) (BgL_objzd2classzd2numz00_2066);
														{	/* Coerce/coerce.scm 153 */
															long BgL_offsetz00_2071;

															BgL_offsetz00_2071 =
																((long) (BgL_offsetz00_2070) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 153 */
																long BgL_modz00_2072;

																{	/* Coerce/coerce.scm 153 */
																	int BgL_arg2553z00_2073;

																	BgL_arg2553z00_2073 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 153 */
																		long BgL_auxz00_4904;

																		BgL_auxz00_4904 =
																			(long) (BgL_arg2553z00_2073);
																		BgL_modz00_2072 =
																			(BgL_offsetz00_2071 / BgL_auxz00_4904);
																}}
																{	/* Coerce/coerce.scm 153 */
																	long BgL_restz00_2074;

																	{	/* Coerce/coerce.scm 153 */
																		int BgL_arg2552z00_2075;

																		BgL_arg2552z00_2075 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 153 */
																			long BgL_auxz00_4908;

																			BgL_auxz00_4908 =
																				(long) (BgL_arg2552z00_2075);
																			BgL_restz00_2074 =
																				(BgL_offsetz00_2071 % BgL_auxz00_4908);
																	}}
																	{	/* Coerce/coerce.scm 153 */

																		BgL_method3484z00_2064 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2069,
																				(int) (BgL_modz00_2072)),
																			(int) (BgL_restz00_2074));
										}}}}}}}}
										BgL_res3851z00_2089 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_2064) (BgL_method3484z00_2064,
												(obj_t) (BgL_nodez00_2060), BgL_callerz00_1406,
												(obj_t) (BgL_arg3638z00_1420), BBOOL(BgL_safez00_2063),
												BEOA));
								}}
								BgL_arg3635z00_1417 = BgL_res3851z00_2089;
						}}
						{	/* Coerce/coerce.scm 153 */
							obj_t BgL_auxz00_4921;

							BgL_auxz00_4921 = (obj_t) (BgL_arg3635z00_1417);
							SET_CAR(BgL_arg3632z00_1416, BgL_auxz00_4921);
					}}
					BgL_auxz00_4845 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1405),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1407), CBOOL(BgL_safez00_1408));
					return (obj_t) (BgL_auxz00_4845);
				}
			}
		}
	}



/* coerce!-getfield3499 */
	obj_t BGl_coercez12zd2getfield3499zc0zzcoerce_coercez00(obj_t BgL_envz00_3347,
		obj_t BgL_nodez00_3348, obj_t BgL_callerz00_3349, obj_t BgL_toz00_3350,
		obj_t BgL_safez00_3351)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 139 */
			{
				BgL_getfieldz00_bglt BgL_nodez00_1391;

				obj_t BgL_callerz00_1392;

				obj_t BgL_toz00_1393;

				obj_t BgL_safez00_1394;

				{	/* Coerce/coerce.scm 140 */
					BgL_nodez00_bglt BgL_auxz00_4931;

					BgL_nodez00_1391 = (BgL_getfieldz00_bglt) (BgL_nodez00_3348);
					BgL_callerz00_1392 = BgL_callerz00_3349;
					BgL_toz00_1393 = BgL_toz00_3350;
					BgL_safez00_1394 = BgL_safez00_3351;
					{	/* Coerce/coerce.scm 144 */
						obj_t BgL_arg3622z00_1398;

						BgL_nodez00_bglt BgL_arg3623z00_1399;

						{
							BgL_externz00_bglt BgL_auxz00_4932;

							BgL_auxz00_4932 = (BgL_externz00_bglt) (BgL_nodez00_1391);
							BgL_arg3622z00_1398 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4932))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 144 */
							obj_t BgL_arg3624z00_1400;

							{	/* Coerce/coerce.scm 144 */
								obj_t BgL_pairz00_1983;

								{
									BgL_externz00_bglt BgL_auxz00_4935;

									BgL_auxz00_4935 = (BgL_externz00_bglt) (BgL_nodez00_1391);
									BgL_pairz00_1983 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4935))->
										BgL_exprza2za2);
								}
								BgL_arg3624z00_1400 = CAR(BgL_pairz00_1983);
							}
							{	/* Coerce/coerce.scm 144 */
								BgL_nodez00_bglt BgL_res3845z00_2013;

								{	/* Coerce/coerce.scm 144 */
									BgL_nodez00_bglt BgL_nodez00_1984;

									BgL_typez00_bglt BgL_toz00_1986;

									bool_t BgL_safez00_1987;

									BgL_nodez00_1984 = (BgL_nodez00_bglt) (BgL_arg3624z00_1400);
									BgL_toz00_1986 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_1987 = CBOOL(BgL_safez00_1394);
									{	/* Coerce/coerce.scm 144 */
										obj_t BgL_method3484z00_1988;

										{	/* Coerce/coerce.scm 144 */
											BgL_objectz00_bglt BgL_objz00_1989;

											BgL_objz00_1989 = (BgL_objectz00_bglt) (BgL_nodez00_1984);
											{	/* Coerce/coerce.scm 144 */
												long BgL_objzd2classzd2numz00_1990;

												BgL_objzd2classzd2numz00_1990 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1989);
												{	/* Coerce/coerce.scm 144 */
													obj_t BgL_arg2551z00_1991;

													BgL_arg2551z00_1991 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 144 */
														obj_t BgL_arrayz00_1993;

														int BgL_offsetz00_1994;

														BgL_arrayz00_1993 = BgL_arg2551z00_1991;
														BgL_offsetz00_1994 =
															(int) (BgL_objzd2classzd2numz00_1990);
														{	/* Coerce/coerce.scm 144 */
															long BgL_offsetz00_1995;

															BgL_offsetz00_1995 =
																((long) (BgL_offsetz00_1994) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 144 */
																long BgL_modz00_1996;

																{	/* Coerce/coerce.scm 144 */
																	int BgL_arg2553z00_1997;

																	BgL_arg2553z00_1997 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 144 */
																		long BgL_auxz00_4950;

																		BgL_auxz00_4950 =
																			(long) (BgL_arg2553z00_1997);
																		BgL_modz00_1996 =
																			(BgL_offsetz00_1995 / BgL_auxz00_4950);
																}}
																{	/* Coerce/coerce.scm 144 */
																	long BgL_restz00_1998;

																	{	/* Coerce/coerce.scm 144 */
																		int BgL_arg2552z00_1999;

																		BgL_arg2552z00_1999 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 144 */
																			long BgL_auxz00_4954;

																			BgL_auxz00_4954 =
																				(long) (BgL_arg2552z00_1999);
																			BgL_restz00_1998 =
																				(BgL_offsetz00_1995 % BgL_auxz00_4954);
																	}}
																	{	/* Coerce/coerce.scm 144 */

																		BgL_method3484z00_1988 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1993,
																				(int) (BgL_modz00_1996)),
																			(int) (BgL_restz00_1998));
										}}}}}}}}
										BgL_res3845z00_2013 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3484z00_1988) (BgL_method3484z00_1988,
												(obj_t) (BgL_nodez00_1984), BgL_callerz00_1392,
												(obj_t) (BgL_toz00_1986), BBOOL(BgL_safez00_1987),
												BEOA));
								}}
								BgL_arg3623z00_1399 = BgL_res3845z00_2013;
						}}
						{	/* Coerce/coerce.scm 144 */
							obj_t BgL_auxz00_4967;

							BgL_auxz00_4967 = (obj_t) (BgL_arg3623z00_1399);
							SET_CAR(BgL_arg3622z00_1398, BgL_auxz00_4967);
					}}
					{	/* Coerce/coerce.scm 145 */
						BgL_typez00_bglt BgL_arg3626z00_1402;

						BgL_arg3626z00_1402 =
							(((BgL_getfieldz00_bglt) CREF(BgL_nodez00_1391))->BgL_ftypez00);
						BgL_auxz00_4931 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1391), BgL_arg3626z00_1402,
							(BgL_typez00_bglt) (BgL_toz00_1393), CBOOL(BgL_safez00_1394));
					}
					return (obj_t) (BgL_auxz00_4931);
				}
			}
		}
	}



/* coerce!-extern3497 */
	obj_t BGl_coercez12zd2extern3497zc0zzcoerce_coercez00(obj_t BgL_envz00_3352,
		obj_t BgL_nodez00_3353, obj_t BgL_callerz00_3354, obj_t BgL_toz00_3355,
		obj_t BgL_safez00_3356)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 124 */
			{
				BgL_externz00_bglt BgL_nodez00_1370;

				obj_t BgL_callerz00_1371;

				obj_t BgL_toz00_1372;

				obj_t BgL_safez00_1373;

				{	/* Coerce/coerce.scm 125 */
					BgL_nodez00_bglt BgL_auxz00_4977;

					BgL_nodez00_1370 = (BgL_externz00_bglt) (BgL_nodez00_3353);
					BgL_callerz00_1371 = BgL_callerz00_3354;
					BgL_toz00_1372 = BgL_toz00_3355;
					BgL_safez00_1373 = BgL_safez00_3356;
					{
						obj_t BgL_valuesz00_1379;

						{	/* Coerce/coerce.scm 126 */
							obj_t BgL_arg3612z00_1378;

							BgL_arg3612z00_1378 =
								(((BgL_externz00_bglt) CREF(BgL_nodez00_1370))->BgL_exprza2za2);
							BgL_valuesz00_1379 = BgL_arg3612z00_1378;
						BgL_zc3anonymousza33613ze3z83_1380:
							if (NULLP(BgL_valuesz00_1379))
								{	/* Coerce/coerce.scm 127 */
									BgL_auxz00_4977 =
										BGl_convertz12z12zzcoerce_convertz00(
										(BgL_nodez00_bglt) (BgL_nodez00_1370),
										BGl_typeofz00zztype_typeofz00(
											(BgL_nodez00_bglt) (BgL_nodez00_1370)),
										(BgL_typez00_bglt) (BgL_toz00_1372),
										CBOOL(BgL_safez00_1373));
								}
							else
								{	/* Coerce/coerce.scm 127 */
									{	/* Coerce/coerce.scm 130 */
										BgL_nodez00_bglt BgL_arg3616z00_1383;

										{	/* Coerce/coerce.scm 130 */
											obj_t BgL_arg3617z00_1384;

											BgL_typez00_bglt BgL_arg3618z00_1385;

											BgL_arg3617z00_1384 = CAR(BgL_valuesz00_1379);
											{	/* Coerce/coerce.scm 132 */
												obj_t BgL_arg3619z00_1386;

												BgL_arg3619z00_1386 = CAR(BgL_valuesz00_1379);
												BgL_arg3618z00_1385 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3619z00_1386));
											}
											{	/* Coerce/coerce.scm 130 */
												BgL_nodez00_bglt BgL_res3842z00_1977;

												{	/* Coerce/coerce.scm 130 */
													BgL_nodez00_bglt BgL_nodez00_1948;

													bool_t BgL_safez00_1951;

													BgL_nodez00_1948 =
														(BgL_nodez00_bglt) (BgL_arg3617z00_1384);
													BgL_safez00_1951 = CBOOL(BgL_safez00_1373);
													{	/* Coerce/coerce.scm 130 */
														obj_t BgL_method3484z00_1952;

														{	/* Coerce/coerce.scm 130 */
															BgL_objectz00_bglt BgL_objz00_1953;

															BgL_objz00_1953 =
																(BgL_objectz00_bglt) (BgL_nodez00_1948);
															{	/* Coerce/coerce.scm 130 */
																long BgL_objzd2classzd2numz00_1954;

																BgL_objzd2classzd2numz00_1954 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1953);
																{	/* Coerce/coerce.scm 130 */
																	obj_t BgL_arg2551z00_1955;

																	BgL_arg2551z00_1955 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 130 */
																		obj_t BgL_arrayz00_1957;

																		int BgL_offsetz00_1958;

																		BgL_arrayz00_1957 = BgL_arg2551z00_1955;
																		BgL_offsetz00_1958 =
																			(int) (BgL_objzd2classzd2numz00_1954);
																		{	/* Coerce/coerce.scm 130 */
																			long BgL_offsetz00_1959;

																			BgL_offsetz00_1959 =
																				(
																				(long) (BgL_offsetz00_1958) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 130 */
																				long BgL_modz00_1960;

																				{	/* Coerce/coerce.scm 130 */
																					int BgL_arg2553z00_1961;

																					BgL_arg2553z00_1961 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 130 */
																						long BgL_auxz00_5001;

																						BgL_auxz00_5001 =
																							(long) (BgL_arg2553z00_1961);
																						BgL_modz00_1960 =
																							(BgL_offsetz00_1959 /
																							BgL_auxz00_5001);
																				}}
																				{	/* Coerce/coerce.scm 130 */
																					long BgL_restz00_1962;

																					{	/* Coerce/coerce.scm 130 */
																						int BgL_arg2552z00_1963;

																						BgL_arg2552z00_1963 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 130 */
																							long BgL_auxz00_5005;

																							BgL_auxz00_5005 =
																								(long) (BgL_arg2552z00_1963);
																							BgL_restz00_1962 =
																								(BgL_offsetz00_1959 %
																								BgL_auxz00_5005);
																					}}
																					{	/* Coerce/coerce.scm 130 */

																						BgL_method3484z00_1952 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1957,
																								(int) (BgL_modz00_1960)),
																							(int) (BgL_restz00_1962));
														}}}}}}}}
														BgL_res3842z00_1977 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3484z00_1952) (BgL_method3484z00_1952,
																(obj_t) (BgL_nodez00_1948), BgL_callerz00_1371,
																(obj_t) (BgL_arg3618z00_1385),
																BBOOL(BgL_safez00_1951), BEOA));
												}}
												BgL_arg3616z00_1383 = BgL_res3842z00_1977;
										}}
										{	/* Coerce/coerce.scm 130 */
											obj_t BgL_auxz00_5018;

											BgL_auxz00_5018 = (obj_t) (BgL_arg3616z00_1383);
											SET_CAR(BgL_valuesz00_1379, BgL_auxz00_5018);
									}}
									{
										obj_t BgL_valuesz00_5021;

										BgL_valuesz00_5021 = CDR(BgL_valuesz00_1379);
										BgL_valuesz00_1379 = BgL_valuesz00_5021;
										goto BgL_zc3anonymousza33613ze3z83_1380;
									}
								}
						}
					}
					return (obj_t) (BgL_auxz00_4977);
				}
			}
		}
	}



/* coerce!-sequence3495 */
	obj_t BGl_coercez12zd2sequence3495zc0zzcoerce_coercez00(obj_t BgL_envz00_3357,
		obj_t BgL_nodez00_3358, obj_t BgL_callerz00_3359, obj_t BgL_toz00_3360,
		obj_t BgL_safez00_3361)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 105 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1347;

				obj_t BgL_callerz00_1348;

				obj_t BgL_toz00_1349;

				obj_t BgL_safez00_1350;

				{	/* Coerce/coerce.scm 106 */
					BgL_sequencez00_bglt BgL_auxz00_5025;

					BgL_nodez00_1347 = (BgL_sequencez00_bglt) (BgL_nodez00_3358);
					BgL_callerz00_1348 = BgL_callerz00_3359;
					BgL_toz00_1349 = BgL_toz00_3360;
					BgL_safez00_1350 = BgL_safez00_3361;
					{
						obj_t BgL_hookz00_1356;

						{	/* Coerce/coerce.scm 107 */
							obj_t BgL_arg3600z00_1355;

							BgL_arg3600z00_1355 =
								(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1347))->BgL_nodesz00);
							BgL_hookz00_1356 = BgL_arg3600z00_1355;
						BgL_zc3anonymousza33601ze3z83_1357:
							if (NULLP(CDR(BgL_hookz00_1356)))
								{	/* Coerce/coerce.scm 108 */
									{	/* Coerce/coerce.scm 110 */
										BgL_nodez00_bglt BgL_arg3603z00_1359;

										{	/* Coerce/coerce.scm 110 */
											obj_t BgL_arg3604z00_1360;

											BgL_arg3604z00_1360 = CAR(BgL_hookz00_1356);
											{	/* Coerce/coerce.scm 110 */
												BgL_nodez00_bglt BgL_res3836z00_1906;

												{	/* Coerce/coerce.scm 110 */
													BgL_nodez00_bglt BgL_nodez00_1877;

													BgL_typez00_bglt BgL_toz00_1879;

													bool_t BgL_safez00_1880;

													BgL_nodez00_1877 =
														(BgL_nodez00_bglt) (BgL_arg3604z00_1360);
													BgL_toz00_1879 = (BgL_typez00_bglt) (BgL_toz00_1349);
													BgL_safez00_1880 = CBOOL(BgL_safez00_1350);
													{	/* Coerce/coerce.scm 110 */
														obj_t BgL_method3484z00_1881;

														{	/* Coerce/coerce.scm 110 */
															BgL_objectz00_bglt BgL_objz00_1882;

															BgL_objz00_1882 =
																(BgL_objectz00_bglt) (BgL_nodez00_1877);
															{	/* Coerce/coerce.scm 110 */
																long BgL_objzd2classzd2numz00_1883;

																BgL_objzd2classzd2numz00_1883 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1882);
																{	/* Coerce/coerce.scm 110 */
																	obj_t BgL_arg2551z00_1884;

																	BgL_arg2551z00_1884 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 110 */
																		obj_t BgL_arrayz00_1886;

																		int BgL_offsetz00_1887;

																		BgL_arrayz00_1886 = BgL_arg2551z00_1884;
																		BgL_offsetz00_1887 =
																			(int) (BgL_objzd2classzd2numz00_1883);
																		{	/* Coerce/coerce.scm 110 */
																			long BgL_offsetz00_1888;

																			BgL_offsetz00_1888 =
																				(
																				(long) (BgL_offsetz00_1887) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 110 */
																				long BgL_modz00_1889;

																				{	/* Coerce/coerce.scm 110 */
																					int BgL_arg2553z00_1890;

																					BgL_arg2553z00_1890 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 110 */
																						long BgL_auxz00_5042;

																						BgL_auxz00_5042 =
																							(long) (BgL_arg2553z00_1890);
																						BgL_modz00_1889 =
																							(BgL_offsetz00_1888 /
																							BgL_auxz00_5042);
																				}}
																				{	/* Coerce/coerce.scm 110 */
																					long BgL_restz00_1891;

																					{	/* Coerce/coerce.scm 110 */
																						int BgL_arg2552z00_1892;

																						BgL_arg2552z00_1892 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 110 */
																							long BgL_auxz00_5046;

																							BgL_auxz00_5046 =
																								(long) (BgL_arg2552z00_1892);
																							BgL_restz00_1891 =
																								(BgL_offsetz00_1888 %
																								BgL_auxz00_5046);
																					}}
																					{	/* Coerce/coerce.scm 110 */

																						BgL_method3484z00_1881 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1886,
																								(int) (BgL_modz00_1889)),
																							(int) (BgL_restz00_1891));
														}}}}}}}}
														BgL_res3836z00_1906 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3484z00_1881) (BgL_method3484z00_1881,
																(obj_t) (BgL_nodez00_1877), BgL_callerz00_1348,
																(obj_t) (BgL_toz00_1879),
																BBOOL(BgL_safez00_1880), BEOA));
												}}
												BgL_arg3603z00_1359 = BgL_res3836z00_1906;
										}}
										{	/* Coerce/coerce.scm 110 */
											obj_t BgL_auxz00_5059;

											BgL_auxz00_5059 = (obj_t) (BgL_arg3603z00_1359);
											SET_CAR(BgL_hookz00_1356, BgL_auxz00_5059);
									}}
									BgL_auxz00_5025 = BgL_nodez00_1347;
								}
							else
								{	/* Coerce/coerce.scm 108 */
									{	/* Coerce/coerce.scm 115 */
										BgL_nodez00_bglt BgL_arg3605z00_1361;

										{	/* Coerce/coerce.scm 115 */
											obj_t BgL_arg3606z00_1362;

											BgL_typez00_bglt BgL_arg3607z00_1363;

											BgL_arg3606z00_1362 = CAR(BgL_hookz00_1356);
											{	/* Coerce/coerce.scm 117 */
												obj_t BgL_arg3608z00_1364;

												BgL_arg3608z00_1364 = CAR(BgL_hookz00_1356);
												BgL_arg3607z00_1363 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3608z00_1364));
											}
											{	/* Coerce/coerce.scm 115 */
												BgL_nodez00_bglt BgL_res3839z00_1940;

												{	/* Coerce/coerce.scm 115 */
													BgL_nodez00_bglt BgL_nodez00_1911;

													bool_t BgL_safez00_1914;

													BgL_nodez00_1911 =
														(BgL_nodez00_bglt) (BgL_arg3606z00_1362);
													BgL_safez00_1914 = CBOOL(BgL_safez00_1350);
													{	/* Coerce/coerce.scm 115 */
														obj_t BgL_method3484z00_1915;

														{	/* Coerce/coerce.scm 115 */
															BgL_objectz00_bglt BgL_objz00_1916;

															BgL_objz00_1916 =
																(BgL_objectz00_bglt) (BgL_nodez00_1911);
															{	/* Coerce/coerce.scm 115 */
																long BgL_objzd2classzd2numz00_1917;

																BgL_objzd2classzd2numz00_1917 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1916);
																{	/* Coerce/coerce.scm 115 */
																	obj_t BgL_arg2551z00_1918;

																	BgL_arg2551z00_1918 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 115 */
																		obj_t BgL_arrayz00_1920;

																		int BgL_offsetz00_1921;

																		BgL_arrayz00_1920 = BgL_arg2551z00_1918;
																		BgL_offsetz00_1921 =
																			(int) (BgL_objzd2classzd2numz00_1917);
																		{	/* Coerce/coerce.scm 115 */
																			long BgL_offsetz00_1922;

																			BgL_offsetz00_1922 =
																				(
																				(long) (BgL_offsetz00_1921) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 115 */
																				long BgL_modz00_1923;

																				{	/* Coerce/coerce.scm 115 */
																					int BgL_arg2553z00_1924;

																					BgL_arg2553z00_1924 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 115 */
																						long BgL_auxz00_5076;

																						BgL_auxz00_5076 =
																							(long) (BgL_arg2553z00_1924);
																						BgL_modz00_1923 =
																							(BgL_offsetz00_1922 /
																							BgL_auxz00_5076);
																				}}
																				{	/* Coerce/coerce.scm 115 */
																					long BgL_restz00_1925;

																					{	/* Coerce/coerce.scm 115 */
																						int BgL_arg2552z00_1926;

																						BgL_arg2552z00_1926 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 115 */
																							long BgL_auxz00_5080;

																							BgL_auxz00_5080 =
																								(long) (BgL_arg2552z00_1926);
																							BgL_restz00_1925 =
																								(BgL_offsetz00_1922 %
																								BgL_auxz00_5080);
																					}}
																					{	/* Coerce/coerce.scm 115 */

																						BgL_method3484z00_1915 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1920,
																								(int) (BgL_modz00_1923)),
																							(int) (BgL_restz00_1925));
														}}}}}}}}
														BgL_res3839z00_1940 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3484z00_1915) (BgL_method3484z00_1915,
																(obj_t) (BgL_nodez00_1911), BgL_callerz00_1348,
																(obj_t) (BgL_arg3607z00_1363),
																BBOOL(BgL_safez00_1914), BEOA));
												}}
												BgL_arg3605z00_1361 = BgL_res3839z00_1940;
										}}
										{	/* Coerce/coerce.scm 115 */
											obj_t BgL_auxz00_5093;

											BgL_auxz00_5093 = (obj_t) (BgL_arg3605z00_1361);
											SET_CAR(BgL_hookz00_1356, BgL_auxz00_5093);
									}}
									{
										obj_t BgL_hookz00_5096;

										BgL_hookz00_5096 = CDR(BgL_hookz00_1356);
										BgL_hookz00_1356 = BgL_hookz00_5096;
										goto BgL_zc3anonymousza33601ze3z83_1357;
									}
								}
						}
					}
					return (obj_t) (BgL_auxz00_5025);
				}
			}
		}
	}



/* coerce!-closure3492 */
	obj_t BGl_coercez12zd2closure3492zc0zzcoerce_coercez00(obj_t BgL_envz00_3362,
		obj_t BgL_nodez00_3363, obj_t BgL_callerz00_3364, obj_t BgL_toz00_3365,
		obj_t BgL_safez00_3366)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 99 */
			{
				BgL_closurez00_bglt BgL_nodez00_1336;

				obj_t BgL_callerz00_1337;

				obj_t BgL_toz00_1338;

				obj_t BgL_safez00_1339;

				BgL_nodez00_1336 = (BgL_closurez00_bglt) (BgL_nodez00_3363);
				BgL_callerz00_1337 = BgL_callerz00_3364;
				BgL_toz00_1338 = BgL_toz00_3365;
				BgL_safez00_1339 = BgL_safez00_3366;
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string3968z00zzcoerce_coercez00,
					BGl_string3969z00zzcoerce_coercez00,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1336)));
			}
		}
	}



/* coerce!-var3490 */
	obj_t BGl_coercez12zd2var3490zc0zzcoerce_coercez00(obj_t BgL_envz00_3367,
		obj_t BgL_nodez00_3368, obj_t BgL_callerz00_3369, obj_t BgL_toz00_3370,
		obj_t BgL_safez00_3371)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 91 */
			{
				BgL_varz00_bglt BgL_nodez00_1326;

				obj_t BgL_callerz00_1327;

				obj_t BgL_toz00_1328;

				obj_t BgL_safez00_1329;

				{	/* Coerce/coerce.scm 93 */
					BgL_nodez00_bglt BgL_auxz00_5104;

					BgL_nodez00_1326 = (BgL_varz00_bglt) (BgL_nodez00_3368);
					BgL_callerz00_1327 = BgL_callerz00_3369;
					BgL_toz00_1328 = BgL_toz00_3370;
					BgL_safez00_1329 = BgL_safez00_3371;
					BgL_auxz00_5104 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1326),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1326)),
						(BgL_typez00_bglt) (BgL_toz00_1328), CBOOL(BgL_safez00_1329));
					return (obj_t) (BgL_auxz00_5104);
				}
			}
		}
	}



/* coerce!-kwote3488 */
	obj_t BGl_coercez12zd2kwote3488zc0zzcoerce_coercez00(obj_t BgL_envz00_3372,
		obj_t BgL_nodez00_3373, obj_t BgL_callerz00_3374, obj_t BgL_toz00_3375,
		obj_t BgL_safez00_3376)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 85 */
			{
				BgL_kwotez00_bglt BgL_nodez00_1317;

				obj_t BgL_callerz00_1318;

				obj_t BgL_toz00_1319;

				obj_t BgL_safez00_1320;

				{	/* Coerce/coerce.scm 86 */
					BgL_nodez00_bglt BgL_auxz00_5113;

					BgL_nodez00_1317 = (BgL_kwotez00_bglt) (BgL_nodez00_3373);
					BgL_callerz00_1318 = BgL_callerz00_3374;
					BgL_toz00_1319 = BgL_toz00_3375;
					BgL_safez00_1320 = BgL_safez00_3376;
					BgL_auxz00_5113 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1317),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1317)),
						(BgL_typez00_bglt) (BgL_toz00_1319), CBOOL(BgL_safez00_1320));
					return (obj_t) (BgL_auxz00_5113);
				}
			}
		}
	}



/* coerce!-atom3486 */
	obj_t BGl_coercez12zd2atom3486zc0zzcoerce_coercez00(obj_t BgL_envz00_3377,
		obj_t BgL_nodez00_3378, obj_t BgL_callerz00_3379, obj_t BgL_toz00_3380,
		obj_t BgL_safez00_3381)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 79 */
			{
				BgL_atomz00_bglt BgL_nodez00_1308;

				obj_t BgL_callerz00_1309;

				obj_t BgL_toz00_1310;

				obj_t BgL_safez00_1311;

				{	/* Coerce/coerce.scm 80 */
					BgL_nodez00_bglt BgL_auxz00_5122;

					BgL_nodez00_1308 = (BgL_atomz00_bglt) (BgL_nodez00_3378);
					BgL_callerz00_1309 = BgL_callerz00_3379;
					BgL_toz00_1310 = BgL_toz00_3380;
					BgL_safez00_1311 = BgL_safez00_3381;
					BgL_auxz00_5122 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1308),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1308)),
						(BgL_typez00_bglt) (BgL_toz00_1310), CBOOL(BgL_safez00_1311));
					return (obj_t) (BgL_auxz00_5122);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 451733024),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 269647501),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(((long) 30250399),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_convertz00(((long) 65499856),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_appz00(((long) 130975358),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_applyz00(((long) 414524937),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(((long) 427175850),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 470955713),
				BSTRING_TO_STRING(BGl_string3970z00zzcoerce_coercez00));
		}
	}

#ifdef __cplusplus
}
#endif
