/*===========================================================================*/
/*   (Effect/cgraph.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Effect/cgraph.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_localzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                      *BgL_localzf2fromzf2_bglt;

	typedef struct BgL_globalzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                       *BgL_globalzf2fromzf2_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_callzd2graphz12zd2app3341z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_callzd2graphz12zd2setzd2exzd2i3364z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	extern BgL_localz00_bglt BGl_makezd2localzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, bool_t,
		long);
	static obj_t BGl_callzd2graphz12zd2sequence3339z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00();
	static obj_t BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00(obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	BGL_EXPORTED_DEF obj_t BGl_globalzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt,
		BgL_variablez00_bglt);
	static obj_t
		BGl_callzd2graphz12zd2boxzd2setz123372zd2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	static obj_t BGl__fillzd2globalzf2fromz12z32zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl__makezd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2conditio3353z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2extern3347z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_callzd2graphz12zd2appzd2ly3343zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern BgL_valuez00_bglt BGl_valuezd2nilzd2zzast_varz00();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_savezd2callz12zd2local3380z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_savezd2callz12zd2global3376z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__getzd2varzf2allz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl__globalzf2fromzf3z01zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_fillzd2localzf2fromz12z32zzeffect_cgraphz00(BgL_localzf2fromzf2_bglt,
		obj_t);
	static obj_t
		BGl_callzd2graphz12zd2jumpzd2exzd23366z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl__callzd2graphz12zd2default3336z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__callzd2graphz12zc0zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00(obj_t);
	static obj_t BGl_callzd2graphz12zd2cast3349z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2makezd2box3368zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2setq3351z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_callzd2graphz12zd2select3357z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2funcall3345z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	static obj_t BGl__fillzd2localzf2fromz12z32zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzeffect_cgraphz00();
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_z52allocatezd2globalzf2fromz72zzeffect_cgraphz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_savezd2callz12zd2globalzf2fr3378ze0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t, BgL_typez00_bglt,
		BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, bool_t, long, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_savezd2callz12zd2localzf2fro3382ze0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_objectzd2ze3structzd2globa3384ze3zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t BGl__localzf2fromzf3z01zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_localzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_callzd2graphz12zd2fail3355z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2boxzd2ref3370zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_typezd2nilzd2zztype_typez00();
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl__savezd2callz12zc0zzeffect_cgraphz00(obj_t, obj_t, obj_t);
	static obj_t BGl__funzd2callzd2graphz12z12zzeffect_cgraphz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00();
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	static obj_t BGl__localzf2fromzd2nilz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl__savezd2callz12zd2default3373z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
	static obj_t
		BGl_savezd2callz12zd2default3373z12zzeffect_cgraphz00(BgL_variablez00_bglt,
		BgL_variablez00_bglt);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl__makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	extern BgL_globalz00_bglt BGl_makezd2globalzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t
		BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	extern obj_t BGl_cfunz00zzast_varz00;
	static bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_callzd2graphz12zd2letzd2fun3359zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00();
	static obj_t BGl_objectzd2ze3structzd2local3388ze3zzeffect_cgraphz00(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_callzd2graphz12zd2letzd2var3361zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_structzb2objectzd2ze3objec3386z83zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
	static obj_t BGl_structzb2objectzd2ze3objec3390z83zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_localz00_bglt
		BGl_z52allocatezd2localzf2fromz72zzeffect_cgraphz00();
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_fillzd2globalzf2fromz12z32zzeffect_cgraphz00(BgL_globalzf2fromzf2_bglt,
		obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_fillzd2localzf2fromz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl__fillza7d2localza7f23712z00,
		BGl__fillzd2localzf2fromz12z32zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_savezd2callz12zd2default3373zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__saveza7d2callza712za73713za7,
		BGl__savezd2callz12zd2default3373z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_resetzd2effectzd2tablesz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__resetza7d2effectza73714z00,
		BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2varzf2sidezd2effectzd2envz20zzeffect_cgraphz00,
		BgL_bgl__getza7d2varza7f2sid3715z00,
		BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_fillzd2globalzf2fromz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl__fillza7d2globalza7f3716z00,
		BGl__fillzd2globalzf2fromz12z32zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2globalzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__makeza7d2globalza7f3717z00,
		BGl__makezd2globalzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 17);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2localzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__makeza7d2localza7f23718z00,
		BGl__makezd2localzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 11);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl__callza7d2graphza7123719z00,
		BGl__callzd2graphz12zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_wideningzd2globalzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__wideningza7d2glob3720za7,
		BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl__saveza7d2callza712za73721za7,
		BGl__savezd2callz12zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_localzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl__localza7f2fromza7f33722z00,
		BGl__localzf2fromzf3z01zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_callzd2graphz12zd2default3336zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__callza7d2graphza7123723z00,
		BGl__callzd2graphz12zd2default3336z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_globalzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl__globalza7f2fromza7f3724z00,
		BGl__globalzf2fromzf3z01zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__globalza7f2fromza7d3725z00,
		BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_funzd2callzd2graphz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__funza7d2callza7d2gr3726z00,
		BGl__funzd2callzd2graphz12z12zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2globalzf2fromzd2envza0zzeffect_cgraphz00,
		BgL_bgl__za752allocateza7d2g3727z00,
		BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2localzf2fromzd2envza0zzeffect_cgraphz00,
		BgL_bgl__za752allocateza7d2l3728z00,
		BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_wideningzd2localzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__wideningza7d2loca3729za7,
		BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3678z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73730za7,
		BGl_callzd2graphz12zd2sequence3339z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3680z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73731za7,
		BGl_callzd2graphz12zd2appzd2ly3343zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3679z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73732za7,
		BGl_callzd2graphz12zd2app3341z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3681z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73733za7,
		BGl_callzd2graphz12zd2funcall3345z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3682z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73734za7,
		BGl_callzd2graphz12zd2extern3347z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3683z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73735za7,
		BGl_callzd2graphz12zd2cast3349z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3684z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73736za7,
		BGl_callzd2graphz12zd2setq3351z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3685z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73737za7,
		BGl_callzd2graphz12zd2conditio3353z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3686z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73738za7,
		BGl_callzd2graphz12zd2fail3355z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3687z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73739za7,
		BGl_callzd2graphz12zd2select3357z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3688z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73740za7,
		BGl_callzd2graphz12zd2letzd2fun3359zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3700z00zzeffect_cgraphz00,
		BgL_bgl_structza7b2objectza73741z00,
		BGl_structzb2objectzd2ze3objec3386z83zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3690z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73742za7,
		BGl_callzd2graphz12zd2setzd2exzd2i3364z12zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3689z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73743za7,
		BGl_callzd2graphz12zd2letzd2var3361zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3701z00zzeffect_cgraphz00,
		BgL_bgl_objectza7d2za7e3stru3744z00,
		BGl_objectzd2ze3structzd2local3388ze3zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3691z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73745za7,
		BGl_callzd2graphz12zd2jumpzd2exzd23366z12zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3702z00zzeffect_cgraphz00,
		BgL_bgl_structza7b2objectza73746z00,
		BGl_structzb2objectzd2ze3objec3390z83zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3692z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73747za7,
		BGl_callzd2graphz12zd2makezd2box3368zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3693z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73748za7,
		BGl_callzd2graphz12zd2boxzd2ref3370zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3694z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73749za7,
		BGl_callzd2graphz12zd2boxzd2setz123372zd2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3695z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3750za7,
		BGl_savezd2callz12zd2global3376z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3696z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3751za7,
		BGl_savezd2callz12zd2globalzf2fr3378ze0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3697z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3752za7,
		BGl_savezd2callz12zd2local3380z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3698z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3753za7,
		BGl_savezd2callz12zd2localzf2fro3382ze0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3699z00zzeffect_cgraphz00,
		BgL_bgl_objectza7d2za7e3stru3754z00,
		BGl_objectzd2ze3structzd2globa3384ze3zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2varzf2allzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__getza7d2varza7f2all3755z00,
		BGl__getzd2varzf2allz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__localza7f2fromza7d23756z00,
		BGl__localzf2fromzd2nilz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string3676z00zzeffect_cgraphz00,
		BgL_bgl_string3676za700za7za7e3757za7, "", 0);
	      DEFINE_STRING(BGl_string3677z00zzeffect_cgraphz00,
		BgL_bgl_string3677za700za7za7e3758za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3703z00zzeffect_cgraphz00,
		BgL_bgl_string3703za700za7za7e3759za7, "effect_cgraph", 13);
	      DEFINE_STRING(BGl_string3704z00zzeffect_cgraphz00,
		BgL_bgl_string3704za700za7za7e3760za7,
		"import save-call!-default3373 done _ global/from local/from nothing ", 68);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long
		BgL_checksumz00_2903, char *BgL_fromz00_2904)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzeffect_cgraphz00))
				{
					BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_cnstzd2initzd2zzeffect_cgraphz00();
					BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_objectzd2initzd2zzeffect_cgraphz00();
					BGl_genericzd2initzd2zzeffect_cgraphz00();
					BGl_methodzd2initzd2zzeffect_cgraphz00();
					BGl_toplevelzd2initzd2zzeffect_cgraphz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"effect_cgraph");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 15 */
				obj_t BgL_cportz00_2870;

				BgL_cportz00_2870 =
					bgl_open_input_string(BGl_string3704z00zzeffect_cgraphz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2871;

					BgL_iz00_2871 = ((long) 6);
				BgL_loopz00_2872:
					if ((BgL_iz00_2871 == ((long) -1)))
						{	/* Effect/cgraph.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Effect/cgraph.scm 15 */
							{	/* Effect/cgraph.scm 15 */
								obj_t BgL_arg3706z00_2874;

								{	/* Effect/cgraph.scm 15 */

									{	/* Effect/cgraph.scm 15 */
										obj_t BgL_locationz00_2876;

										BgL_locationz00_2876 = BBOOL(((bool_t) 0));
										{	/* Effect/cgraph.scm 15 */

											BgL_arg3706z00_2874 =
												BGl_readz00zz__readerz00(BgL_cportz00_2870,
												BgL_locationz00_2876);
										}
									}
								}
								{	/* Effect/cgraph.scm 15 */
									int BgL_auxz00_2925;

									BgL_auxz00_2925 = (int) (BgL_iz00_2871);
									CNST_TABLE_SET(BgL_auxz00_2925, BgL_arg3706z00_2874);
							}}
							{	/* Effect/cgraph.scm 15 */
								int BgL_auxz00_2877;

								BgL_auxz00_2877 = (int) ((BgL_iz00_2871 - ((long) 1)));
								{
									long BgL_iz00_2930;

									BgL_iz00_2930 = (long) (BgL_auxz00_2877);
									BgL_iz00_2871 = BgL_iz00_2930;
									goto BgL_loopz00_2872;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}
	}



/* fun-call-graph! */
	BGL_EXPORTED_DEF obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_variablez00_1)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 30 */
			BGl_za2varzf2allza2zf2zzeffect_cgraphz00 =
				MAKE_PAIR(
				(obj_t) (BgL_variablez00_1), BGl_za2varzf2allza2zf2zzeffect_cgraphz00);
			{	/* Effect/cgraph.scm 32 */
				obj_t BgL_arg3391z00_843;

				{	/* Effect/cgraph.scm 32 */
					BgL_sfunz00_bglt BgL_obj1791z00_1547;

					BgL_obj1791z00_1547 =
						(BgL_sfunz00_bglt) (
						(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00));
					BgL_arg3391z00_843 =
						(((BgL_sfunz00_bglt) CREF(BgL_obj1791z00_1547))->BgL_bodyz00);
				}
				{	/* Effect/cgraph.scm 32 */
					BgL_nodez00_bglt BgL_nodez00_1548;

					BgL_nodez00_1548 = (BgL_nodez00_bglt) (BgL_arg3391z00_843);
					{	/* Effect/cgraph.scm 32 */
						obj_t BgL_method3337z00_1550;

						{	/* Effect/cgraph.scm 32 */
							BgL_objectz00_bglt BgL_objz00_1551;

							BgL_objz00_1551 = (BgL_objectz00_bglt) (BgL_nodez00_1548);
							{	/* Effect/cgraph.scm 32 */
								long BgL_objzd2classzd2numz00_1552;

								BgL_objzd2classzd2numz00_1552 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_1551);
								{	/* Effect/cgraph.scm 32 */
									obj_t BgL_arg2551z00_1553;

									BgL_arg2551z00_1553 =
										PROCEDURE_REF
										(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
										(int) (((long) 1)));
									{	/* Effect/cgraph.scm 32 */
										obj_t BgL_arrayz00_1555;

										int BgL_offsetz00_1556;

										BgL_arrayz00_1555 = BgL_arg2551z00_1553;
										BgL_offsetz00_1556 = (int) (BgL_objzd2classzd2numz00_1552);
										{	/* Effect/cgraph.scm 32 */
											long BgL_offsetz00_1557;

											BgL_offsetz00_1557 =
												((long) (BgL_offsetz00_1556) - OBJECT_TYPE);
											{	/* Effect/cgraph.scm 32 */
												long BgL_modz00_1558;

												{	/* Effect/cgraph.scm 32 */
													int BgL_arg2553z00_1559;

													BgL_arg2553z00_1559 = (int) (((long) 8));
													{	/* Effect/cgraph.scm 32 */
														long BgL_auxz00_2946;

														BgL_auxz00_2946 = (long) (BgL_arg2553z00_1559);
														BgL_modz00_1558 =
															(BgL_offsetz00_1557 / BgL_auxz00_2946);
												}}
												{	/* Effect/cgraph.scm 32 */
													long BgL_restz00_1560;

													{	/* Effect/cgraph.scm 32 */
														int BgL_arg2552z00_1561;

														BgL_arg2552z00_1561 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 32 */
															long BgL_auxz00_2950;

															BgL_auxz00_2950 = (long) (BgL_arg2552z00_1561);
															BgL_restz00_1560 =
																(BgL_offsetz00_1557 % BgL_auxz00_2950);
													}}
													{	/* Effect/cgraph.scm 32 */

														BgL_method3337z00_1550 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_1555,
																(int) (BgL_modz00_1558)),
															(int) (BgL_restz00_1560));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3337z00_1550) (BgL_method3337z00_1550,
							(obj_t) (BgL_nodez00_1548), (obj_t) (BgL_variablez00_1), BEOA);
					}
				}
			}
		}
	}



/* _fun-call-graph! */
	obj_t BGl__funzd2callzd2graphz12z12zzeffect_cgraphz00(obj_t BgL_envz00_2702,
		obj_t BgL_variablez00_2703)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 30 */
			return
				BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2703));
		}
	}



/* call-graph*! */
	bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t BgL_nodeza2za2_40,
		obj_t BgL_ownerz00_41)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 197 */
			{
				obj_t BgL_l3332z00_846;

				BgL_l3332z00_846 = BgL_nodeza2za2_40;
			BgL_zc3anonymousza33393ze3z83_847:
				if (PAIRP(BgL_l3332z00_846))
					{	/* Effect/cgraph.scm 198 */
						{	/* Effect/cgraph.scm 198 */
							obj_t BgL_nodez00_849;

							BgL_nodez00_849 = CAR(BgL_l3332z00_846);
							{	/* Effect/cgraph.scm 198 */
								BgL_nodez00_bglt BgL_nodez00_1577;

								BgL_variablez00_bglt BgL_ownerz00_1578;

								BgL_nodez00_1577 = (BgL_nodez00_bglt) (BgL_nodez00_849);
								BgL_ownerz00_1578 = (BgL_variablez00_bglt) (BgL_ownerz00_41);
								{	/* Effect/cgraph.scm 198 */
									obj_t BgL_method3337z00_1579;

									{	/* Effect/cgraph.scm 198 */
										BgL_objectz00_bglt BgL_objz00_1580;

										BgL_objz00_1580 = (BgL_objectz00_bglt) (BgL_nodez00_1577);
										{	/* Effect/cgraph.scm 198 */
											long BgL_objzd2classzd2numz00_1581;

											BgL_objzd2classzd2numz00_1581 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1580);
											{	/* Effect/cgraph.scm 198 */
												obj_t BgL_arg2551z00_1582;

												BgL_arg2551z00_1582 =
													PROCEDURE_REF
													(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
													(int) (((long) 1)));
												{	/* Effect/cgraph.scm 198 */
													obj_t BgL_arrayz00_1584;

													int BgL_offsetz00_1585;

													BgL_arrayz00_1584 = BgL_arg2551z00_1582;
													BgL_offsetz00_1585 =
														(int) (BgL_objzd2classzd2numz00_1581);
													{	/* Effect/cgraph.scm 198 */
														long BgL_offsetz00_1586;

														BgL_offsetz00_1586 =
															((long) (BgL_offsetz00_1585) - OBJECT_TYPE);
														{	/* Effect/cgraph.scm 198 */
															long BgL_modz00_1587;

															{	/* Effect/cgraph.scm 198 */
																int BgL_arg2553z00_1588;

																BgL_arg2553z00_1588 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 198 */
																	long BgL_auxz00_2976;

																	BgL_auxz00_2976 =
																		(long) (BgL_arg2553z00_1588);
																	BgL_modz00_1587 =
																		(BgL_offsetz00_1586 / BgL_auxz00_2976);
															}}
															{	/* Effect/cgraph.scm 198 */
																long BgL_restz00_1589;

																{	/* Effect/cgraph.scm 198 */
																	int BgL_arg2552z00_1590;

																	BgL_arg2552z00_1590 = (int) (((long) 8));
																	{	/* Effect/cgraph.scm 198 */
																		long BgL_auxz00_2980;

																		BgL_auxz00_2980 =
																			(long) (BgL_arg2552z00_1590);
																		BgL_restz00_1589 =
																			(BgL_offsetz00_1586 % BgL_auxz00_2980);
																}}
																{	/* Effect/cgraph.scm 198 */

																	BgL_method3337z00_1579 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1584,
																			(int) (BgL_modz00_1587)),
																		(int) (BgL_restz00_1589));
									}}}}}}}}
									PROCEDURE_ENTRY(BgL_method3337z00_1579)
										(BgL_method3337z00_1579, (obj_t) (BgL_nodez00_1577),
										(obj_t) (BgL_ownerz00_1578), BEOA);
						}}}
						{
							obj_t BgL_l3332z00_2991;

							BgL_l3332z00_2991 = CDR(BgL_l3332z00_846);
							BgL_l3332z00_846 = BgL_l3332z00_2991;
							goto BgL_zc3anonymousza33393ze3z83_847;
						}
					}
				else
					{	/* Effect/cgraph.scm 198 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* get-var/side-effect */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 242 */
			return BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00;
		}
	}



/* _get-var/side-effect */
	obj_t BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00(obj_t
		BgL_envz00_2707)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 242 */
			return BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00;
		}
	}



/* get-var/all */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 253 */
			return BGl_za2varzf2allza2zf2zzeffect_cgraphz00;
		}
	}



/* _get-var/all */
	obj_t BGl__getzd2varzf2allz20zzeffect_cgraphz00(obj_t BgL_envz00_2708)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 253 */
			return BGl_za2varzf2allza2zf2zzeffect_cgraphz00;
		}
	}



/* reset-effect-tables! */
	BGL_EXPORTED_DEF obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 264 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}
	}



/* _reset-effect-tables! */
	obj_t BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2709)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 264 */
			return BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
		}
	}



/* mark-side-effect! */
	obj_t BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_vz00_54)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 271 */
			{	/* Effect/cgraph.scm 273 */
				BgL_valuez00_bglt BgL_funz00_852;

				BgL_funz00_852 =
					(((BgL_variablez00_bglt) CREF(BgL_vz00_54))->BgL_valuez00);
				{	/* Effect/cgraph.scm 275 */
					bool_t BgL_testz00_2995;

					{	/* Effect/cgraph.scm 275 */
						BgL_funz00_bglt BgL_obj1722z00_1606;

						BgL_obj1722z00_1606 = (BgL_funz00_bglt) (BgL_funz00_852);
						BgL_testz00_2995 =
							CBOOL(
							(((BgL_funz00_bglt) CREF(BgL_obj1722z00_1606))->
								BgL_sidezd2effectzf3z21));
					}
					if (BgL_testz00_2995)
						{	/* Effect/cgraph.scm 275 */
							if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
										(obj_t) (BgL_vz00_54),
										BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00)))
								{	/* Effect/cgraph.scm 278 */
									return CNST_TABLE_REF(((long) 0));
								}
							else
								{	/* Effect/cgraph.scm 278 */
									return (BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
										MAKE_PAIR(
											(obj_t) (BgL_vz00_54),
											BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00),
										BUNSPEC);
								}
						}
					else
						{	/* Effect/cgraph.scm 275 */
							BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
								MAKE_PAIR(
								(obj_t) (BgL_vz00_54),
								BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00);
							{
								BgL_funz00_bglt BgL_auxz00_3008;

								BgL_auxz00_3008 = (BgL_funz00_bglt) (BgL_funz00_852);
								return
									((((BgL_funz00_bglt) CREF(BgL_auxz00_3008))->
										BgL_sidezd2effectzf3z21) = ((obj_t) BTRUE), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 20 */
				obj_t BgL_arg3398z00_855;

				obj_t BgL_arg3399z00_856;

				obj_t BgL_arg3402z00_859;

				BgL_arg3398z00_855 = CNST_TABLE_REF(((long) 1));
				BgL_arg3399z00_856 = BGl_localz00zzast_varz00;
				{	/* Effect/cgraph.scm 20 */
					obj_t BgL_v3334z00_860;

					BgL_v3334z00_860 = create_vector((int) (((long) 0)));
					BgL_arg3402z00_859 = BgL_v3334z00_860;
				}
				BGl_localzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3398z00_855,
					BgL_arg3399z00_856, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2localzf2fromzd2envza0zzeffect_cgraphz00,
					BGl_localzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
					BGl_localzf2fromzf3zd2envzd3zzeffect_cgraphz00, ((long) 443584018),
					BFALSE, BFALSE, BgL_arg3402z00_859);
			}
			{	/* Effect/cgraph.scm 21 */
				obj_t BgL_arg3403z00_861;

				obj_t BgL_arg3404z00_862;

				obj_t BgL_arg3407z00_865;

				BgL_arg3403z00_861 = CNST_TABLE_REF(((long) 2));
				BgL_arg3404z00_862 = BGl_globalz00zzast_varz00;
				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_v3335z00_866;

					BgL_v3335z00_866 = create_vector((int) (((long) 0)));
					BgL_arg3407z00_865 = BgL_v3335z00_866;
				}
				BGl_globalzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3403z00_861,
					BgL_arg3404z00_862, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2globalzf2fromzd2envza0zzeffect_cgraphz00,
					BGl_globalzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
					BGl_globalzf2fromzf3zd2envzd3zzeffect_cgraphz00, ((long) 410954352),
					BFALSE, BFALSE, BgL_arg3407z00_865);
			}
			BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
			return (BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 =
				BUNSPEC, BUNSPEC);
		}
	}



/* global/from? */
	BGL_EXPORTED_DEF bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_obj3234z00_55)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3234z00_55,
				BGl_globalzf2fromzf2zzeffect_cgraphz00);
		}
	}



/* _global/from? */
	obj_t BGl__globalzf2fromzf3z01zzeffect_cgraphz00(obj_t BgL_envz00_2716,
		obj_t BgL_obj3234z00_2717)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3234z00_2717,
					BGl_globalzf2fromzf2zzeffect_cgraphz00));
		}
	}



/* widening-global/from */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_from3201z00_59)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalzf2fromzf2_bglt BgL_new3202z00_1609;

				BgL_new3202z00_1609 =
					((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_globalzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_res3591z00_1613;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_new3224z00_1610;

						BgL_new3224z00_1610 = BgL_new3202z00_1609;
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_from3223z00_1612;

							BgL_from3223z00_1612 = BgL_from3201z00_59;
							((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3224z00_1610))->
									BgL_fromz00) = ((obj_t) BgL_from3223z00_1612), BUNSPEC);
							BgL_res3591z00_1613 = BgL_new3224z00_1610;
					}} BgL_res3591z00_1613;
				}
				return BgL_new3202z00_1609;
			}
		}
	}



/* _widening-global/from */
	obj_t BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t
		BgL_envz00_2718, obj_t BgL_from3201z00_2719)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				(obj_t) (BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00
				(BgL_from3201z00_2719));
		}
	}



/* make-global/from */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_id3205z00_60,
		obj_t BgL_name3206z00_61, BgL_typez00_bglt BgL_type3207z00_62,
		BgL_valuez00_bglt BgL_value3208z00_63, obj_t BgL_access3209z00_64,
		obj_t BgL_fastzd2alpha3210zd2_65, obj_t BgL_removable3211z00_66,
		long BgL_occurrence3212z00_67, obj_t BgL_module3213z00_68,
		obj_t BgL_import3214z00_69, bool_t BgL_evaluablezf33215zf3_70,
		obj_t BgL_library3216z00_71, bool_t BgL_userzf33217zf3_72,
		obj_t BgL_pragma3218z00_73, obj_t BgL_src3219z00_74,
		obj_t BgL_jvmzd2typezd2name3220z00_75, obj_t BgL_from3204z00_76)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_aux3221z00_1614;

				BgL_aux3221z00_1614 =
					BGl_makezd2globalzd2zzast_varz00(BgL_id3205z00_60, BgL_name3206z00_61,
					BgL_type3207z00_62, BgL_value3208z00_63, BgL_access3209z00_64,
					BgL_fastzd2alpha3210zd2_65, BgL_removable3211z00_66,
					BgL_occurrence3212z00_67, BgL_module3213z00_68, BgL_import3214z00_69,
					BgL_evaluablezf33215zf3_70, BgL_library3216z00_71,
					BgL_userzf33217zf3_72, BgL_pragma3218z00_73, BgL_src3219z00_74,
					BgL_jvmzd2typezd2name3220z00_75);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3221z00_1614),
					BGl_classzd2numzd2zz__objectz00
					(BGl_globalzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_arg3409z00_1616;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_res3593z00_1626;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalzf2fromzf2_bglt BgL_new3202z00_1621;

							BgL_new3202z00_1621 =
								((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalzf2fromzf2_bgl))));
							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_res3592z00_1625;

								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_new3224z00_1622;

									BgL_new3224z00_1622 = BgL_new3202z00_1621;
									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_from3223z00_1624;

										BgL_from3223z00_1624 = BgL_from3204z00_76;
										((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3224z00_1622))->
												BgL_fromz00) = ((obj_t) BgL_from3223z00_1624), BUNSPEC);
										BgL_res3592z00_1625 = BgL_new3224z00_1622;
								}} BgL_res3592z00_1625;
							}
							BgL_res3593z00_1626 = BgL_new3202z00_1621;
						}
						BgL_arg3409z00_1616 = BgL_res3593z00_1626;
					}
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_auxz00_3034;

						BgL_objectz00_bglt BgL_auxz00_3032;

						BgL_auxz00_3034 = (obj_t) (BgL_arg3409z00_1616);
						BgL_auxz00_3032 = (BgL_objectz00_bglt) (BgL_aux3221z00_1614);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3032, BgL_auxz00_3034);
				}}
				return
					((BgL_globalzf2fromzf2_bglt)
					(BgL_globalzf2fromzf2_bglt) (BgL_aux3221z00_1614));
			}
		}
	}



/* _make-global/from */
	obj_t BGl__makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_envz00_2720,
		obj_t BgL_id3205z00_2721, obj_t BgL_name3206z00_2722,
		obj_t BgL_type3207z00_2723, obj_t BgL_value3208z00_2724,
		obj_t BgL_access3209z00_2725, obj_t BgL_fastzd2alpha3210zd2_2726,
		obj_t BgL_removable3211z00_2727, obj_t BgL_occurrence3212z00_2728,
		obj_t BgL_module3213z00_2729, obj_t BgL_import3214z00_2730,
		obj_t BgL_evaluablezf33215zf3_2731, obj_t BgL_library3216z00_2732,
		obj_t BgL_userzf33217zf3_2733, obj_t BgL_pragma3218z00_2734,
		obj_t BgL_src3219z00_2735, obj_t BgL_jvmzd2typezd2name3220z00_2736,
		obj_t BgL_from3204z00_2737)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				(obj_t) (BGl_makezd2globalzf2fromz20zzeffect_cgraphz00
				(BgL_id3205z00_2721, BgL_name3206z00_2722,
					(BgL_typez00_bglt) (BgL_type3207z00_2723),
					(BgL_valuez00_bglt) (BgL_value3208z00_2724), BgL_access3209z00_2725,
					BgL_fastzd2alpha3210zd2_2726, BgL_removable3211z00_2727,
					(long) CINT(BgL_occurrence3212z00_2728), BgL_module3213z00_2729,
					BgL_import3214z00_2730, CBOOL(BgL_evaluablezf33215zf3_2731),
					BgL_library3216z00_2732, CBOOL(BgL_userzf33217zf3_2733),
					BgL_pragma3218z00_2734, BgL_src3219z00_2735,
					BgL_jvmzd2typezd2name3220z00_2736, BgL_from3204z00_2737));
		}
	}



/* fill-global/from! */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_fillzd2globalzf2fromz12z32zzeffect_cgraphz00(BgL_globalzf2fromzf2_bglt
		BgL_new3224z00_77, obj_t BgL_from3223z00_78)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				obj_t BgL_from3223z00_2879;

				BgL_from3223z00_2879 = BgL_from3223z00_78;
				((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3224z00_77))->BgL_fromz00) =
					((obj_t) BgL_from3223z00_2879), BUNSPEC);
				return BgL_new3224z00_77;
			}
		}
	}



/* _fill-global/from! */
	obj_t BGl__fillzd2globalzf2fromz12z32zzeffect_cgraphz00(obj_t BgL_envz00_2738,
		obj_t BgL_new3224z00_2739, obj_t BgL_from3223z00_2740)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3047;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_res3707z00_2883;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_new3224z00_2880;

						BgL_new3224z00_2880 =
							(BgL_globalzf2fromzf2_bglt) (BgL_new3224z00_2739);
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_from3223z00_2882;

							BgL_from3223z00_2882 = BgL_from3223z00_2740;
							((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3224z00_2880))->
									BgL_fromz00) = ((obj_t) BgL_from3223z00_2882), BUNSPEC);
							BgL_res3707z00_2883 = BgL_new3224z00_2880;
						}
					}
					BgL_auxz00_3047 = BgL_res3707z00_2883;
				}
				return (obj_t) (BgL_auxz00_3047);
			}
		}
	}



/* %allocate-global/from */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_z52allocatezd2globalzf2fromz72zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_new3227z00_2884;

				BgL_new3227z00_2884 =
					((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_globalz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3227z00_2884),
					BGl_classzd2numzd2zz__objectz00
					(BGl_globalzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 21 */
					BgL_objectz00_bglt BgL_auxz00_3055;

					BgL_auxz00_3055 = (BgL_objectz00_bglt) (BgL_new3227z00_2884);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_3055, BFALSE);
				}
				return BgL_new3227z00_2884;
			}
		}
	}



/* _%allocate-global/from */
	obj_t BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00(obj_t
		BgL_envz00_2714)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_auxz00_3058;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalz00_bglt BgL_res3708z00_2888;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalz00_bglt BgL_new3227z00_2886;

						BgL_new3227z00_2886 =
							((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_globalz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3227z00_2886),
							BGl_classzd2numzd2zz__objectz00
							(BGl_globalzf2fromzf2zzeffect_cgraphz00));
						{	/* Effect/cgraph.scm 21 */
							BgL_objectz00_bglt BgL_auxz00_3063;

							BgL_auxz00_3063 = (BgL_objectz00_bglt) (BgL_new3227z00_2886);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3063, BFALSE);
						}
						BgL_res3708z00_2888 = BgL_new3227z00_2886;
					}
					BgL_auxz00_3058 = BgL_res3708z00_2888;
				}
				return (obj_t) (BgL_auxz00_3058);
			}
		}
	}



/* global/from-nil */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			if ((BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 == BUNSPEC))
				{	/* Effect/cgraph.scm 21 */
					{	/* Effect/cgraph.scm 21 */
						BgL_globalz00_bglt BgL_res3594z00_1636;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalz00_bglt BgL_new1657z00_1632;

							BgL_new1657z00_1632 =
								((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1657z00_1632),
								BGl_classzd2numzd2zz__objectz00(BGl_globalz00zzast_varz00));
							{	/* Effect/cgraph.scm 21 */
								BgL_objectz00_bglt BgL_auxz00_3073;

								BgL_auxz00_3073 = (BgL_objectz00_bglt) (BgL_new1657z00_1632);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3073, BFALSE);
							}
							BgL_res3594z00_1636 = BgL_new1657z00_1632;
						}
						BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 =
							(obj_t) (BgL_res3594z00_1636);
					}
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_arg3412z00_876;

						BgL_typez00_bglt BgL_arg3413z00_877;

						BgL_valuez00_bglt BgL_arg3415z00_878;

						obj_t BgL_arg3417z00_880;

						BgL_arg3412z00_876 = CNST_TABLE_REF(((long) 3));
						BgL_arg3413z00_877 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3415z00_878 = BGl_valuezd2nilzd2zzast_varz00();
						BgL_arg3417z00_880 = CNST_TABLE_REF(((long) 3));
						{	/* Effect/cgraph.scm 21 */
							BgL_globalz00_bglt BgL_res3595z00_1670;

							{	/* Effect/cgraph.scm 21 */
								BgL_globalz00_bglt BgL_new1639z00_1637;

								BgL_new1639z00_1637 =
									(BgL_globalz00_bglt)
									(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
								{	/* Effect/cgraph.scm 21 */
									obj_t BgL_id1623z00_1654;

									obj_t BgL_name1624z00_1655;

									BgL_typez00_bglt BgL_type1625z00_1656;

									BgL_valuez00_bglt BgL_value1626z00_1657;

									obj_t BgL_access1627z00_1658;

									obj_t BgL_fastzd2alpha1628zd2_1659;

									obj_t BgL_removable1629z00_1660;

									long BgL_occurrence1630z00_1661;

									obj_t BgL_module1631z00_1662;

									obj_t BgL_import1632z00_1663;

									bool_t BgL_evaluablezf31633zf3_1664;

									obj_t BgL_library1634z00_1665;

									bool_t BgL_userzf31635zf3_1666;

									obj_t BgL_pragma1636z00_1667;

									obj_t BgL_src1637z00_1668;

									obj_t BgL_jvmzd2typezd2name1638z00_1669;

									BgL_id1623z00_1654 = BgL_arg3412z00_876;
									BgL_name1624z00_1655 = BUNSPEC;
									BgL_type1625z00_1656 = BgL_arg3413z00_877;
									BgL_value1626z00_1657 = BgL_arg3415z00_878;
									BgL_access1627z00_1658 = BUNSPEC;
									BgL_fastzd2alpha1628zd2_1659 = BUNSPEC;
									BgL_removable1629z00_1660 = BUNSPEC;
									BgL_occurrence1630z00_1661 = ((long) 0);
									BgL_module1631z00_1662 = BgL_arg3417z00_880;
									BgL_import1632z00_1663 = BUNSPEC;
									BgL_evaluablezf31633zf3_1664 = ((bool_t) 0);
									BgL_library1634z00_1665 = BUNSPEC;
									BgL_userzf31635zf3_1666 = ((bool_t) 0);
									BgL_pragma1636z00_1667 = BUNSPEC;
									BgL_src1637z00_1668 = BUNSPEC;
									BgL_jvmzd2typezd2name1638z00_1669 =
										BGl_string3676z00zzeffect_cgraphz00;
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_idz00) = ((obj_t) BgL_id1623z00_1654), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_namez00) = ((obj_t) BgL_name1624z00_1655), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1625z00_1656), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1626z00_1657), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_accessz00) =
										((obj_t) BgL_access1627z00_1658), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1628zd2_1659), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_removablez00) =
										((obj_t) BgL_removable1629z00_1660), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1630z00_1661), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_modulez00) =
										((obj_t) BgL_module1631z00_1662), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_importz00) =
										((obj_t) BgL_import1632z00_1663), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_evaluablezf3zf3) =
										((bool_t) BgL_evaluablezf31633zf3_1664), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_libraryz00) =
										((obj_t) BgL_library1634z00_1665), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31635zf3_1666), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_pragmaz00) =
										((obj_t) BgL_pragma1636z00_1667), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_srcz00) = ((obj_t) BgL_src1637z00_1668), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1639z00_1637))->
											BgL_jvmzd2typezd2namez00) =
										((obj_t) BgL_jvmzd2typezd2name1638z00_1669), BUNSPEC);
									BgL_res3595z00_1670 = BgL_new1639z00_1637;
							}} BgL_res3595z00_1670;
					}}
					{	/* Effect/cgraph.scm 21 */
						long BgL_arg3419z00_882;

						BgL_arg3419z00_882 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_globalzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00),
							BgL_arg3419z00_882);
					}
					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_arg3420z00_883;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalzf2fromzf2_bglt BgL_res3597z00_1679;

							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_new3202z00_1674;

								BgL_new3202z00_1674 =
									((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_globalzf2fromzf2_bgl))));
								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_res3596z00_1678;

									{	/* Effect/cgraph.scm 21 */
										BgL_globalzf2fromzf2_bglt BgL_new3224z00_1675;

										BgL_new3224z00_1675 = BgL_new3202z00_1674;
										{	/* Effect/cgraph.scm 21 */
											obj_t BgL_from3223z00_1677;

											BgL_from3223z00_1677 = BUNSPEC;
											((((BgL_globalzf2fromzf2_bglt)
														CREF(BgL_new3224z00_1675))->BgL_fromz00) =
												((obj_t) BgL_from3223z00_1677), BUNSPEC);
											BgL_res3596z00_1678 = BgL_new3224z00_1675;
									}} BgL_res3596z00_1678;
								}
								BgL_res3597z00_1679 = BgL_new3202z00_1674;
							}
							BgL_arg3420z00_883 = BgL_res3597z00_1679;
						}
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_auxz00_3105;

							BgL_objectz00_bglt BgL_auxz00_3103;

							BgL_auxz00_3105 = (obj_t) (BgL_arg3420z00_883);
							BgL_auxz00_3103 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3103, BgL_auxz00_3105);
				}}}
			else
				{	/* Effect/cgraph.scm 21 */
					BFALSE;
				}
			return
				(BgL_globalzf2fromzf2_bglt)
				(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
		}
	}



/* _global/from-nil */
	obj_t BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00(obj_t BgL_envz00_2715)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return (obj_t) (BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00());
		}
	}



/* local/from? */
	BGL_EXPORTED_DEF bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_obj3170z00_82)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3170z00_82,
				BGl_localzf2fromzf2zzeffect_cgraphz00);
		}
	}



/* _local/from? */
	obj_t BGl__localzf2fromzf3z01zzeffect_cgraphz00(obj_t BgL_envz00_2712,
		obj_t BgL_obj3170z00_2713)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3170z00_2713,
					BGl_localzf2fromzf2zzeffect_cgraphz00));
		}
	}



/* widening-local/from */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_from3143z00_86)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localzf2fromzf2_bglt BgL_new3144z00_1680;

				BgL_new3144z00_1680 =
					((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_localzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_res3598z00_1684;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_new3160z00_1681;

						BgL_new3160z00_1681 = BgL_new3144z00_1680;
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_from3159z00_1683;

							BgL_from3159z00_1683 = BgL_from3143z00_86;
							((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3160z00_1681))->
									BgL_fromz00) = ((obj_t) BgL_from3159z00_1683), BUNSPEC);
							BgL_res3598z00_1684 = BgL_new3160z00_1681;
					}} BgL_res3598z00_1684;
				}
				return BgL_new3144z00_1680;
			}
		}
	}



/* _widening-local/from */
	obj_t BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_envz00_2741,
		obj_t BgL_from3143z00_2742)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				(obj_t) (BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00
				(BgL_from3143z00_2742));
		}
	}



/* make-local/from */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_id3147z00_87,
		obj_t BgL_name3148z00_88, BgL_typez00_bglt BgL_type3149z00_89,
		BgL_valuez00_bglt BgL_value3150z00_90, obj_t BgL_access3151z00_91,
		obj_t BgL_fastzd2alpha3152zd2_92, obj_t BgL_removable3153z00_93,
		long BgL_occurrence3154z00_94, bool_t BgL_userzf33155zf3_95,
		long BgL_key3156z00_96, obj_t BgL_from3146z00_97)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_aux3157z00_1685;

				BgL_aux3157z00_1685 =
					BGl_makezd2localzd2zzast_varz00(BgL_id3147z00_87, BgL_name3148z00_88,
					BgL_type3149z00_89, BgL_value3150z00_90, BgL_access3151z00_91,
					BgL_fastzd2alpha3152zd2_92, BgL_removable3153z00_93,
					BgL_occurrence3154z00_94, BgL_userzf33155zf3_95, BgL_key3156z00_96);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3157z00_1685),
					BGl_classzd2numzd2zz__objectz00
					(BGl_localzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_arg3422z00_1687;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_res3600z00_1697;

						{	/* Effect/cgraph.scm 20 */
							BgL_localzf2fromzf2_bglt BgL_new3144z00_1692;

							BgL_new3144z00_1692 =
								((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_localzf2fromzf2_bgl))));
							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_res3599z00_1696;

								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_new3160z00_1693;

									BgL_new3160z00_1693 = BgL_new3144z00_1692;
									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_from3159z00_1695;

										BgL_from3159z00_1695 = BgL_from3146z00_97;
										((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3160z00_1693))->
												BgL_fromz00) = ((obj_t) BgL_from3159z00_1695), BUNSPEC);
										BgL_res3599z00_1696 = BgL_new3160z00_1693;
								}} BgL_res3599z00_1696;
							}
							BgL_res3600z00_1697 = BgL_new3144z00_1692;
						}
						BgL_arg3422z00_1687 = BgL_res3600z00_1697;
					}
					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_auxz00_3126;

						BgL_objectz00_bglt BgL_auxz00_3124;

						BgL_auxz00_3126 = (obj_t) (BgL_arg3422z00_1687);
						BgL_auxz00_3124 = (BgL_objectz00_bglt) (BgL_aux3157z00_1685);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3124, BgL_auxz00_3126);
				}}
				return
					((BgL_localzf2fromzf2_bglt)
					(BgL_localzf2fromzf2_bglt) (BgL_aux3157z00_1685));
			}
		}
	}



/* _make-local/from */
	obj_t BGl__makezd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_envz00_2743,
		obj_t BgL_id3147z00_2744, obj_t BgL_name3148z00_2745,
		obj_t BgL_type3149z00_2746, obj_t BgL_value3150z00_2747,
		obj_t BgL_access3151z00_2748, obj_t BgL_fastzd2alpha3152zd2_2749,
		obj_t BgL_removable3153z00_2750, obj_t BgL_occurrence3154z00_2751,
		obj_t BgL_userzf33155zf3_2752, obj_t BgL_key3156z00_2753,
		obj_t BgL_from3146z00_2754)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				(obj_t) (BGl_makezd2localzf2fromz20zzeffect_cgraphz00
				(BgL_id3147z00_2744, BgL_name3148z00_2745,
					(BgL_typez00_bglt) (BgL_type3149z00_2746),
					(BgL_valuez00_bglt) (BgL_value3150z00_2747), BgL_access3151z00_2748,
					BgL_fastzd2alpha3152zd2_2749, BgL_removable3153z00_2750,
					(long) CINT(BgL_occurrence3154z00_2751),
					CBOOL(BgL_userzf33155zf3_2752), (long) CINT(BgL_key3156z00_2753),
					BgL_from3146z00_2754));
		}
	}



/* fill-local/from! */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_fillzd2localzf2fromz12z32zzeffect_cgraphz00(BgL_localzf2fromzf2_bglt
		BgL_new3160z00_98, obj_t BgL_from3159z00_99)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				obj_t BgL_from3159z00_2890;

				BgL_from3159z00_2890 = BgL_from3159z00_99;
				((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3160z00_98))->BgL_fromz00) =
					((obj_t) BgL_from3159z00_2890), BUNSPEC);
				return BgL_new3160z00_98;
			}
		}
	}



/* _fill-local/from! */
	obj_t BGl__fillzd2localzf2fromz12z32zzeffect_cgraphz00(obj_t BgL_envz00_2755,
		obj_t BgL_new3160z00_2756, obj_t BgL_from3159z00_2757)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localzf2fromzf2_bglt BgL_auxz00_3139;

				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_res3709z00_2894;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_new3160z00_2891;

						BgL_new3160z00_2891 =
							(BgL_localzf2fromzf2_bglt) (BgL_new3160z00_2756);
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_from3159z00_2893;

							BgL_from3159z00_2893 = BgL_from3159z00_2757;
							((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3160z00_2891))->
									BgL_fromz00) = ((obj_t) BgL_from3159z00_2893), BUNSPEC);
							BgL_res3709z00_2894 = BgL_new3160z00_2891;
						}
					}
					BgL_auxz00_3139 = BgL_res3709z00_2894;
				}
				return (obj_t) (BgL_auxz00_3139);
			}
		}
	}



/* %allocate-local/from */
	BGL_EXPORTED_DEF BgL_localz00_bglt
		BGl_z52allocatezd2localzf2fromz72zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_new3163z00_2895;

				BgL_new3163z00_2895 =
					((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_localz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3163z00_2895),
					BGl_classzd2numzd2zz__objectz00
					(BGl_localzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 20 */
					BgL_objectz00_bglt BgL_auxz00_3147;

					BgL_auxz00_3147 = (BgL_objectz00_bglt) (BgL_new3163z00_2895);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_3147, BFALSE);
				}
				return BgL_new3163z00_2895;
			}
		}
	}



/* _%allocate-local/from */
	obj_t BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00(obj_t
		BgL_envz00_2710)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_auxz00_3150;

				{	/* Effect/cgraph.scm 20 */
					BgL_localz00_bglt BgL_res3710z00_2899;

					{	/* Effect/cgraph.scm 20 */
						BgL_localz00_bglt BgL_new3163z00_2897;

						BgL_new3163z00_2897 =
							((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_localz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3163z00_2897),
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00));
						{	/* Effect/cgraph.scm 20 */
							BgL_objectz00_bglt BgL_auxz00_3155;

							BgL_auxz00_3155 = (BgL_objectz00_bglt) (BgL_new3163z00_2897);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3155, BFALSE);
						}
						BgL_res3710z00_2899 = BgL_new3163z00_2897;
					}
					BgL_auxz00_3150 = BgL_res3710z00_2899;
				}
				return (obj_t) (BgL_auxz00_3150);
			}
		}
	}



/* local/from-nil */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			if ((BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 == BUNSPEC))
				{	/* Effect/cgraph.scm 20 */
					{	/* Effect/cgraph.scm 20 */
						BgL_localz00_bglt BgL_res3601z00_1707;

						{	/* Effect/cgraph.scm 20 */
							BgL_localz00_bglt BgL_new1718z00_1703;

							BgL_new1718z00_1703 =
								((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_localz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1718z00_1703),
								BGl_classzd2numzd2zz__objectz00(BGl_localz00zzast_varz00));
							{	/* Effect/cgraph.scm 20 */
								BgL_objectz00_bglt BgL_auxz00_3165;

								BgL_auxz00_3165 = (BgL_objectz00_bglt) (BgL_new1718z00_1703);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3165, BFALSE);
							}
							BgL_res3601z00_1707 = BgL_new1718z00_1703;
						}
						BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 =
							(obj_t) (BgL_res3601z00_1707);
					}
					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_arg3425z00_893;

						BgL_typez00_bglt BgL_arg3426z00_894;

						BgL_valuez00_bglt BgL_arg3427z00_895;

						BgL_arg3425z00_893 = CNST_TABLE_REF(((long) 3));
						BgL_arg3426z00_894 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3427z00_895 = BGl_valuezd2nilzd2zzast_varz00();
						{	/* Effect/cgraph.scm 20 */
							BgL_localz00_bglt BgL_res3602z00_1729;

							{	/* Effect/cgraph.scm 20 */
								BgL_localz00_bglt BgL_new1706z00_1708;

								BgL_new1706z00_1708 =
									(BgL_localz00_bglt)
									(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
								{	/* Effect/cgraph.scm 20 */
									obj_t BgL_id1696z00_1719;

									obj_t BgL_name1697z00_1720;

									BgL_typez00_bglt BgL_type1698z00_1721;

									BgL_valuez00_bglt BgL_value1699z00_1722;

									obj_t BgL_access1700z00_1723;

									obj_t BgL_fastzd2alpha1701zd2_1724;

									obj_t BgL_removable1702z00_1725;

									long BgL_occurrence1703z00_1726;

									bool_t BgL_userzf31704zf3_1727;

									long BgL_key1705z00_1728;

									BgL_id1696z00_1719 = BgL_arg3425z00_893;
									BgL_name1697z00_1720 = BUNSPEC;
									BgL_type1698z00_1721 = BgL_arg3426z00_894;
									BgL_value1699z00_1722 = BgL_arg3427z00_895;
									BgL_access1700z00_1723 = BUNSPEC;
									BgL_fastzd2alpha1701zd2_1724 = BUNSPEC;
									BgL_removable1702z00_1725 = BUNSPEC;
									BgL_occurrence1703z00_1726 = ((long) 0);
									BgL_userzf31704zf3_1727 = ((bool_t) 0);
									BgL_key1705z00_1728 = ((long) 0);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_idz00) = ((obj_t) BgL_id1696z00_1719), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_namez00) = ((obj_t) BgL_name1697z00_1720), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1698z00_1721), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1699z00_1722), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_accessz00) =
										((obj_t) BgL_access1700z00_1723), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1701zd2_1724), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_removablez00) =
										((obj_t) BgL_removable1702z00_1725), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1703z00_1726), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31704zf3_1727), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1706z00_1708))->
											BgL_keyz00) = ((long) BgL_key1705z00_1728), BUNSPEC);
									BgL_res3602z00_1729 = BgL_new1706z00_1708;
							}} BgL_res3602z00_1729;
					}}
					{	/* Effect/cgraph.scm 20 */
						long BgL_arg3430z00_898;

						BgL_arg3430z00_898 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00),
							BgL_arg3430z00_898);
					}
					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_arg3431z00_899;

						{	/* Effect/cgraph.scm 20 */
							BgL_localzf2fromzf2_bglt BgL_res3604z00_1738;

							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_new3144z00_1733;

								BgL_new3144z00_1733 =
									((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_localzf2fromzf2_bgl))));
								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_res3603z00_1737;

									{	/* Effect/cgraph.scm 20 */
										BgL_localzf2fromzf2_bglt BgL_new3160z00_1734;

										BgL_new3160z00_1734 = BgL_new3144z00_1733;
										{	/* Effect/cgraph.scm 20 */
											obj_t BgL_from3159z00_1736;

											BgL_from3159z00_1736 = BUNSPEC;
											((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3160z00_1734))->
													BgL_fromz00) =
												((obj_t) BgL_from3159z00_1736), BUNSPEC);
											BgL_res3603z00_1737 = BgL_new3160z00_1734;
									}} BgL_res3603z00_1737;
								}
								BgL_res3604z00_1738 = BgL_new3144z00_1733;
							}
							BgL_arg3431z00_899 = BgL_res3604z00_1738;
						}
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_auxz00_3190;

							BgL_objectz00_bglt BgL_auxz00_3188;

							BgL_auxz00_3190 = (obj_t) (BgL_arg3431z00_899);
							BgL_auxz00_3188 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3188, BgL_auxz00_3190);
				}}}
			else
				{	/* Effect/cgraph.scm 20 */
					BFALSE;
				}
			return
				(BgL_localzf2fromzf2_bglt)
				(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
		}
	}



/* _local/from-nil */
	obj_t BGl__localzf2fromzd2nilz20zzeffect_cgraphz00(obj_t BgL_envz00_2711)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return (obj_t) (BGl_localzf2fromzd2nilz20zzeffect_cgraphz00());
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_callzd2graphz12zd2default3336zd2envzc0zzeffect_cgraphz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_savezd2callz12zd2default3373zd2envzc0zzeffect_cgraphz00);
		}
	}



/* call-graph! */
	obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt BgL_nodez00_2,
		BgL_variablez00_bglt BgL_ownerz00_3)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 37 */
			{	/* Effect/cgraph.scm 37 */
				obj_t BgL_method3337z00_1773;

				{	/* Effect/cgraph.scm 37 */
					BgL_objectz00_bglt BgL_objz00_1774;

					BgL_objz00_1774 = (BgL_objectz00_bglt) (BgL_nodez00_2);
					{	/* Effect/cgraph.scm 37 */
						long BgL_objzd2classzd2numz00_1775;

						BgL_objzd2classzd2numz00_1775 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1774);
						{	/* Effect/cgraph.scm 37 */
							obj_t BgL_arg2551z00_1776;

							BgL_arg2551z00_1776 =
								PROCEDURE_REF(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 37 */
								obj_t BgL_arrayz00_1778;

								int BgL_offsetz00_1779;

								BgL_arrayz00_1778 = BgL_arg2551z00_1776;
								BgL_offsetz00_1779 = (int) (BgL_objzd2classzd2numz00_1775);
								{	/* Effect/cgraph.scm 37 */
									long BgL_offsetz00_1780;

									BgL_offsetz00_1780 =
										((long) (BgL_offsetz00_1779) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 37 */
										long BgL_modz00_1781;

										{	/* Effect/cgraph.scm 37 */
											int BgL_arg2553z00_1782;

											BgL_arg2553z00_1782 = (int) (((long) 8));
											{	/* Effect/cgraph.scm 37 */
												long BgL_auxz00_3206;

												BgL_auxz00_3206 = (long) (BgL_arg2553z00_1782);
												BgL_modz00_1781 =
													(BgL_offsetz00_1780 / BgL_auxz00_3206);
										}}
										{	/* Effect/cgraph.scm 37 */
											long BgL_restz00_1783;

											{	/* Effect/cgraph.scm 37 */
												int BgL_arg2552z00_1784;

												BgL_arg2552z00_1784 = (int) (((long) 8));
												{	/* Effect/cgraph.scm 37 */
													long BgL_auxz00_3210;

													BgL_auxz00_3210 = (long) (BgL_arg2552z00_1784);
													BgL_restz00_1783 =
														(BgL_offsetz00_1780 % BgL_auxz00_3210);
											}}
											{	/* Effect/cgraph.scm 37 */

												BgL_method3337z00_1773 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1778,
														(int) (BgL_modz00_1781)), (int) (BgL_restz00_1783));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3337z00_1773) (BgL_method3337z00_1773,
					(obj_t) (BgL_nodez00_2), (obj_t) (BgL_ownerz00_3), BEOA);
			}
		}
	}



/* _call-graph! */
	obj_t BGl__callzd2graphz12zc0zzeffect_cgraphz00(obj_t BgL_envz00_2704,
		obj_t BgL_nodez00_2705, obj_t BgL_ownerz00_2706)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 37 */
			return
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2705),
				(BgL_variablez00_bglt) (BgL_ownerz00_2706));
		}
	}



/* _call-graph!-default3336 */
	obj_t BGl__callzd2graphz12zd2default3336z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2758, obj_t BgL_nodez00_2759, obj_t BgL_ownerz00_2760)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 38 */
				obj_t BgL_res3711z00_2902;

				BgL_res3711z00_2902 = CNST_TABLE_REF(((long) 4));
				return BgL_res3711z00_2902;
			}
		}
	}



/* save-call! */
	obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_calleez00_42, BgL_variablez00_bglt BgL_ownerz00_43)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 203 */
			{	/* Effect/cgraph.scm 203 */
				obj_t BgL_method3374z00_1798;

				{	/* Effect/cgraph.scm 203 */
					BgL_objectz00_bglt BgL_objz00_1799;

					BgL_objz00_1799 = (BgL_objectz00_bglt) (BgL_calleez00_42);
					{	/* Effect/cgraph.scm 203 */
						long BgL_objzd2classzd2numz00_1800;

						BgL_objzd2classzd2numz00_1800 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1799);
						{	/* Effect/cgraph.scm 203 */
							obj_t BgL_arg2551z00_1801;

							BgL_arg2551z00_1801 =
								PROCEDURE_REF(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 203 */
								obj_t BgL_arrayz00_1803;

								int BgL_offsetz00_1804;

								BgL_arrayz00_1803 = BgL_arg2551z00_1801;
								BgL_offsetz00_1804 = (int) (BgL_objzd2classzd2numz00_1800);
								{	/* Effect/cgraph.scm 203 */
									long BgL_offsetz00_1805;

									BgL_offsetz00_1805 =
										((long) (BgL_offsetz00_1804) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 203 */
										long BgL_modz00_1806;

										{	/* Effect/cgraph.scm 203 */
											int BgL_arg2553z00_1807;

											BgL_arg2553z00_1807 = (int) (((long) 8));
											{	/* Effect/cgraph.scm 203 */
												long BgL_auxz00_3233;

												BgL_auxz00_3233 = (long) (BgL_arg2553z00_1807);
												BgL_modz00_1806 =
													(BgL_offsetz00_1805 / BgL_auxz00_3233);
										}}
										{	/* Effect/cgraph.scm 203 */
											long BgL_restz00_1808;

											{	/* Effect/cgraph.scm 203 */
												int BgL_arg2552z00_1809;

												BgL_arg2552z00_1809 = (int) (((long) 8));
												{	/* Effect/cgraph.scm 203 */
													long BgL_auxz00_3237;

													BgL_auxz00_3237 = (long) (BgL_arg2552z00_1809);
													BgL_restz00_1808 =
														(BgL_offsetz00_1805 % BgL_auxz00_3237);
											}}
											{	/* Effect/cgraph.scm 203 */

												BgL_method3374z00_1798 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1803,
														(int) (BgL_modz00_1806)), (int) (BgL_restz00_1808));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3374z00_1798) (BgL_method3374z00_1798,
					(obj_t) (BgL_calleez00_42), (obj_t) (BgL_ownerz00_43), BEOA);
			}
		}
	}



/* _save-call! */
	obj_t BGl__savezd2callz12zc0zzeffect_cgraphz00(obj_t BgL_envz00_2761,
		obj_t BgL_calleez00_2762, obj_t BgL_ownerz00_2763)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 203 */
			return
				BGl_savezd2callz12zc0zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_calleez00_2762),
				(BgL_variablez00_bglt) (BgL_ownerz00_2763));
		}
	}



/* save-call!-default3373 */
	obj_t
		BGl_savezd2callz12zd2default3373z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_calleez00_44, BgL_variablez00_bglt BgL_ownerz00_45)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 5)),
				BGl_string3677z00zzeffect_cgraphz00, (obj_t) (BgL_calleez00_44));
		}
	}



/* _save-call!-default3373 */
	obj_t BGl__savezd2callz12zd2default3373z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2764, obj_t BgL_calleez00_2765, obj_t BgL_ownerz00_2766)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			return
				BGl_savezd2callz12zd2default3373z12zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_calleez00_2765),
				(BgL_variablez00_bglt) (BgL_ownerz00_2766));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3678z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appz00zzast_nodez00, BGl_proc3679z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3680z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3681z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_externz00zzast_nodez00, BGl_proc3682z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_castz00zzast_nodez00, BGl_proc3683z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setqz00zzast_nodez00, BGl_proc3684z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3685z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_failz00zzast_nodez00, BGl_proc3686z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_selectz00zzast_nodez00, BGl_proc3687z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3688z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3689z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3690z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3691z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3692z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3693z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3694z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalz00zzast_varz00, BGl_proc3695z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3696z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localz00zzast_varz00, BGl_proc3697z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3698z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3699z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3700z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3701z00zzeffect_cgraphz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3702z00zzeffect_cgraphz00);
		}
	}



/* struct+object->objec3390 */
	obj_t BGl_structzb2objectzd2ze3objec3390z83zzeffect_cgraphz00(obj_t
		BgL_envz00_2797, obj_t BgL_oz00_2798, obj_t BgL_sz00_2799)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{
				BgL_localzf2fromzf2_bglt BgL_oz00_1534;

				obj_t BgL_sz00_1535;

				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_auxz00_3282;

					BgL_oz00_1534 = (BgL_localzf2fromzf2_bglt) (BgL_oz00_2798);
					BgL_sz00_1535 = BgL_sz00_2799;
					{

						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_old3167z00_1538;

							obj_t BgL_aux3168z00_1539;

							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_nextzd2method3389zd2_1544;

								BgL_nextzd2method3389zd2_1544 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1534),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_localzf2fromzf2zzeffect_cgraphz00);
								if (PROCEDUREP(BgL_nextzd2method3389zd2_1544))
									{	/* Effect/cgraph.scm 20 */
										BgL_old3167z00_1538 =
											PROCEDURE_ENTRY(BgL_nextzd2method3389zd2_1544)
											(BgL_nextzd2method3389zd2_1544, (obj_t) (BgL_oz00_1534),
											BgL_sz00_1535, BEOA);
									}
								else
									{	/* Effect/cgraph.scm 20 */
										BgL_old3167z00_1538 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1534), BgL_sz00_1535));
									}
							}
							BgL_aux3168z00_1539 =
								STRUCT_REF(BgL_sz00_1535, (int) (((long) 0)));
							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_new3169z00_1540;

								BgL_new3169z00_1540 =
									((BgL_localzf2fromzf2_bglt) (BgL_old3167z00_1538));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3169z00_1540),
									BGl_classzd2numzd2zz__objectz00
									(BGl_localzf2fromzf2zzeffect_cgraphz00));
								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_arg3584z00_1542;

									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_arg3585z00_1543;

										BgL_arg3585z00_1543 =
											STRUCT_REF(BgL_aux3168z00_1539, (int) (((long) 0)));
										{	/* Effect/cgraph.scm 20 */
											BgL_localzf2fromzf2_bglt BgL_res3672z00_2700;

											{	/* Effect/cgraph.scm 20 */
												BgL_localzf2fromzf2_bglt BgL_new3144z00_2695;

												BgL_new3144z00_2695 =
													((BgL_localzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_localzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 20 */
													BgL_localzf2fromzf2_bglt BgL_res3671z00_2699;

													{	/* Effect/cgraph.scm 20 */
														BgL_localzf2fromzf2_bglt BgL_new3160z00_2696;

														BgL_new3160z00_2696 = BgL_new3144z00_2695;
														{	/* Effect/cgraph.scm 20 */
															obj_t BgL_from3159z00_2698;

															BgL_from3159z00_2698 = BgL_arg3585z00_1543;
															((((BgL_localzf2fromzf2_bglt)
																		CREF(BgL_new3160z00_2696))->BgL_fromz00) =
																((obj_t) BgL_from3159z00_2698), BUNSPEC);
															BgL_res3671z00_2699 = BgL_new3160z00_2696;
													}} BgL_res3671z00_2699;
												}
												BgL_res3672z00_2700 = BgL_new3144z00_2695;
											}
											BgL_arg3584z00_1542 = BgL_res3672z00_2700;
									}}
									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_auxz00_3305;

										BgL_objectz00_bglt BgL_auxz00_3303;

										BgL_auxz00_3305 = (obj_t) (BgL_arg3584z00_1542);
										BgL_auxz00_3303 =
											(BgL_objectz00_bglt) (BgL_new3169z00_1540);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3303, BgL_auxz00_3305);
								}}
								BgL_auxz00_3282 = BgL_new3169z00_1540;
					}}}
					return (obj_t) (BgL_auxz00_3282);
				}
			}
		}
	}



/* object->struct-local3388 */
	obj_t BGl_objectzd2ze3structzd2local3388ze3zzeffect_cgraphz00(obj_t
		BgL_envz00_2800, obj_t BgL_obj3164z00_2801)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{
				BgL_localzf2fromzf2_bglt BgL_obj3164z00_1524;

				BgL_obj3164z00_1524 = (BgL_localzf2fromzf2_bglt) (BgL_obj3164z00_2801);
				{

					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_res3165z00_1527;

						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_nextzd2method3387zd2_1532;

							BgL_nextzd2method3387zd2_1532 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3164z00_1524),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_localzf2fromzf2zzeffect_cgraphz00);
							if (PROCEDUREP(BgL_nextzd2method3387zd2_1532))
								{	/* Effect/cgraph.scm 20 */
									BgL_res3165z00_1527 =
										PROCEDURE_ENTRY(BgL_nextzd2method3387zd2_1532)
										(BgL_nextzd2method3387zd2_1532,
										(obj_t) (BgL_obj3164z00_1524), BEOA);
								}
							else
								{	/* Effect/cgraph.scm 20 */
									BgL_res3165z00_1527 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3164z00_1524));
								}
						}
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_aux3166z00_1528;

							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_keyz00_2671;

								BgL_keyz00_2671 = CNST_TABLE_REF(((long) 1));
								BgL_aux3166z00_1528 =
									make_struct(BgL_keyz00_2671, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_arg3579z00_1530;

								{
									obj_t BgL_auxz00_3322;

									{	/* Effect/cgraph.scm 20 */
										BgL_objectz00_bglt BgL_auxz00_3323;

										BgL_auxz00_3323 =
											(BgL_objectz00_bglt) (BgL_obj3164z00_1524);
										BgL_auxz00_3322 = BGL_OBJECT_WIDENING(BgL_auxz00_3323);
									}
									BgL_arg3579z00_1530 =
										(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3322))->
										BgL_fromz00);
								}
								{	/* Effect/cgraph.scm 20 */
									int BgL_auxz00_3327;

									BgL_auxz00_3327 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3166z00_1528, BgL_auxz00_3327,
										BgL_arg3579z00_1530);
							}}
							{	/* Effect/cgraph.scm 20 */
								int BgL_auxz00_3330;

								BgL_auxz00_3330 = (int) (((long) 0));
								STRUCT_SET(BgL_res3165z00_1527, BgL_auxz00_3330,
									BgL_aux3166z00_1528);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_auxz00_3333;

								BgL_auxz00_3333 = STRUCT_KEY(BgL_res3165z00_1527);
								STRUCT_KEY_SET(BgL_aux3166z00_1528, BgL_auxz00_3333);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_kz00_2686;

								BgL_kz00_2686 = CNST_TABLE_REF(((long) 1));
								STRUCT_KEY_SET(BgL_res3165z00_1527, BgL_kz00_2686);
							}
							return BgL_res3165z00_1527;
						}
					}
				}
			}
		}
	}



/* struct+object->objec3386 */
	obj_t BGl_structzb2objectzd2ze3objec3386z83zzeffect_cgraphz00(obj_t
		BgL_envz00_2802, obj_t BgL_oz00_2803, obj_t BgL_sz00_2804)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_globalzf2fromzf2_bglt BgL_oz00_1512;

				obj_t BgL_sz00_1513;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_auxz00_3339;

					BgL_oz00_1512 = (BgL_globalzf2fromzf2_bglt) (BgL_oz00_2803);
					BgL_sz00_1513 = BgL_sz00_2804;
					{

						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_old3231z00_1516;

							obj_t BgL_aux3232z00_1517;

							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_nextzd2method3385zd2_1522;

								BgL_nextzd2method3385zd2_1522 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1512),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_globalzf2fromzf2zzeffect_cgraphz00);
								if (PROCEDUREP(BgL_nextzd2method3385zd2_1522))
									{	/* Effect/cgraph.scm 21 */
										BgL_old3231z00_1516 =
											PROCEDURE_ENTRY(BgL_nextzd2method3385zd2_1522)
											(BgL_nextzd2method3385zd2_1522, (obj_t) (BgL_oz00_1512),
											BgL_sz00_1513, BEOA);
									}
								else
									{	/* Effect/cgraph.scm 21 */
										BgL_old3231z00_1516 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1512), BgL_sz00_1513));
									}
							}
							BgL_aux3232z00_1517 =
								STRUCT_REF(BgL_sz00_1513, (int) (((long) 0)));
							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_new3233z00_1518;

								BgL_new3233z00_1518 =
									((BgL_globalzf2fromzf2_bglt) (BgL_old3231z00_1516));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3233z00_1518),
									BGl_classzd2numzd2zz__objectz00
									(BGl_globalzf2fromzf2zzeffect_cgraphz00));
								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_arg3575z00_1520;

									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_arg3576z00_1521;

										BgL_arg3576z00_1521 =
											STRUCT_REF(BgL_aux3232z00_1517, (int) (((long) 0)));
										{	/* Effect/cgraph.scm 21 */
											BgL_globalzf2fromzf2_bglt BgL_res3669z00_2669;

											{	/* Effect/cgraph.scm 21 */
												BgL_globalzf2fromzf2_bglt BgL_new3202z00_2664;

												BgL_new3202z00_2664 =
													((BgL_globalzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_globalzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 21 */
													BgL_globalzf2fromzf2_bglt BgL_res3668z00_2668;

													{	/* Effect/cgraph.scm 21 */
														BgL_globalzf2fromzf2_bglt BgL_new3224z00_2665;

														BgL_new3224z00_2665 = BgL_new3202z00_2664;
														{	/* Effect/cgraph.scm 21 */
															obj_t BgL_from3223z00_2667;

															BgL_from3223z00_2667 = BgL_arg3576z00_1521;
															((((BgL_globalzf2fromzf2_bglt)
																		CREF(BgL_new3224z00_2665))->BgL_fromz00) =
																((obj_t) BgL_from3223z00_2667), BUNSPEC);
															BgL_res3668z00_2668 = BgL_new3224z00_2665;
													}} BgL_res3668z00_2668;
												}
												BgL_res3669z00_2669 = BgL_new3202z00_2664;
											}
											BgL_arg3575z00_1520 = BgL_res3669z00_2669;
									}}
									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_auxz00_3362;

										BgL_objectz00_bglt BgL_auxz00_3360;

										BgL_auxz00_3362 = (obj_t) (BgL_arg3575z00_1520);
										BgL_auxz00_3360 =
											(BgL_objectz00_bglt) (BgL_new3233z00_1518);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3360, BgL_auxz00_3362);
								}}
								BgL_auxz00_3339 = BgL_new3233z00_1518;
					}}}
					return (obj_t) (BgL_auxz00_3339);
				}
			}
		}
	}



/* object->struct-globa3384 */
	obj_t BGl_objectzd2ze3structzd2globa3384ze3zzeffect_cgraphz00(obj_t
		BgL_envz00_2805, obj_t BgL_obj3228z00_2806)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_globalzf2fromzf2_bglt BgL_obj3228z00_1502;

				BgL_obj3228z00_1502 = (BgL_globalzf2fromzf2_bglt) (BgL_obj3228z00_2806);
				{

					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_res3229z00_1505;

						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_nextzd2method3383zd2_1510;

							BgL_nextzd2method3383zd2_1510 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3228z00_1502),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_globalzf2fromzf2zzeffect_cgraphz00);
							if (PROCEDUREP(BgL_nextzd2method3383zd2_1510))
								{	/* Effect/cgraph.scm 21 */
									BgL_res3229z00_1505 =
										PROCEDURE_ENTRY(BgL_nextzd2method3383zd2_1510)
										(BgL_nextzd2method3383zd2_1510,
										(obj_t) (BgL_obj3228z00_1502), BEOA);
								}
							else
								{	/* Effect/cgraph.scm 21 */
									BgL_res3229z00_1505 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3228z00_1502));
								}
						}
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_aux3230z00_1506;

							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_keyz00_2640;

								BgL_keyz00_2640 = CNST_TABLE_REF(((long) 2));
								BgL_aux3230z00_1506 =
									make_struct(BgL_keyz00_2640, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_arg3570z00_1508;

								{
									obj_t BgL_auxz00_3379;

									{	/* Effect/cgraph.scm 21 */
										BgL_objectz00_bglt BgL_auxz00_3380;

										BgL_auxz00_3380 =
											(BgL_objectz00_bglt) (BgL_obj3228z00_1502);
										BgL_auxz00_3379 = BGL_OBJECT_WIDENING(BgL_auxz00_3380);
									}
									BgL_arg3570z00_1508 =
										(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3379))->
										BgL_fromz00);
								}
								{	/* Effect/cgraph.scm 21 */
									int BgL_auxz00_3384;

									BgL_auxz00_3384 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3230z00_1506, BgL_auxz00_3384,
										BgL_arg3570z00_1508);
							}}
							{	/* Effect/cgraph.scm 21 */
								int BgL_auxz00_3387;

								BgL_auxz00_3387 = (int) (((long) 0));
								STRUCT_SET(BgL_res3229z00_1505, BgL_auxz00_3387,
									BgL_aux3230z00_1506);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_auxz00_3390;

								BgL_auxz00_3390 = STRUCT_KEY(BgL_res3229z00_1505);
								STRUCT_KEY_SET(BgL_aux3230z00_1506, BgL_auxz00_3390);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_kz00_2655;

								BgL_kz00_2655 = CNST_TABLE_REF(((long) 2));
								STRUCT_KEY_SET(BgL_res3229z00_1505, BgL_kz00_2655);
							}
							return BgL_res3229z00_1505;
						}
					}
				}
			}
		}
	}



/* save-call!-local/fro3382 */
	obj_t BGl_savezd2callz12zd2localzf2fro3382ze0zzeffect_cgraphz00(obj_t
		BgL_envz00_2807, obj_t BgL_calleez00_2808, obj_t BgL_ownerz00_2809)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 234 */
			{
				BgL_localzf2fromzf2_bglt BgL_calleez00_1491;

				obj_t BgL_ownerz00_1492;

				BgL_calleez00_1491 = (BgL_localzf2fromzf2_bglt) (BgL_calleez00_2808);
				BgL_ownerz00_1492 = BgL_ownerz00_2809;
				{	/* Effect/cgraph.scm 236 */
					bool_t BgL_testz00_3396;

					{	/* Effect/cgraph.scm 236 */
						obj_t BgL_auxz00_3397;

						{	/* Effect/cgraph.scm 236 */
							obj_t BgL_auxz00_3398;

							{
								obj_t BgL_auxz00_3399;

								{	/* Effect/cgraph.scm 236 */
									BgL_objectz00_bglt BgL_auxz00_3400;

									BgL_auxz00_3400 = (BgL_objectz00_bglt) (BgL_calleez00_1491);
									BgL_auxz00_3399 = BGL_OBJECT_WIDENING(BgL_auxz00_3400);
								}
								BgL_auxz00_3398 =
									(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3399))->
									BgL_fromz00);
							}
							BgL_auxz00_3397 =
								BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_1492,
								BgL_auxz00_3398);
						}
						BgL_testz00_3396 = CBOOL(BgL_auxz00_3397);
					}
					if (BgL_testz00_3396)
						{	/* Effect/cgraph.scm 236 */
							return BFALSE;
						}
					else
						{	/* Effect/cgraph.scm 237 */
							obj_t BgL_arg3565z00_1497;

							{	/* Effect/cgraph.scm 237 */
								obj_t BgL_arg3566z00_1498;

								{
									obj_t BgL_auxz00_3406;

									{	/* Effect/cgraph.scm 237 */
										BgL_objectz00_bglt BgL_auxz00_3407;

										BgL_auxz00_3407 = (BgL_objectz00_bglt) (BgL_calleez00_1491);
										BgL_auxz00_3406 = BGL_OBJECT_WIDENING(BgL_auxz00_3407);
									}
									BgL_arg3566z00_1498 =
										(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3406))->
										BgL_fromz00);
								}
								BgL_arg3565z00_1497 =
									MAKE_PAIR(BgL_ownerz00_1492, BgL_arg3566z00_1498);
							}
							{
								obj_t BgL_auxz00_3412;

								{	/* Effect/cgraph.scm 237 */
									BgL_objectz00_bglt BgL_auxz00_3413;

									BgL_auxz00_3413 = (BgL_objectz00_bglt) (BgL_calleez00_1491);
									BgL_auxz00_3412 = BGL_OBJECT_WIDENING(BgL_auxz00_3413);
								}
								return
									((((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3412))->
										BgL_fromz00) = ((obj_t) BgL_arg3565z00_1497), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* save-call!-local3380 */
	obj_t BGl_savezd2callz12zd2local3380z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2810, obj_t BgL_calleez00_2811, obj_t BgL_ownerz00_2812)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 228 */
			{
				BgL_localz00_bglt BgL_calleez00_1481;

				obj_t BgL_ownerz00_1482;

				BgL_calleez00_1481 = (BgL_localz00_bglt) (BgL_calleez00_2811);
				BgL_ownerz00_1482 = BgL_ownerz00_2812;
				{	/* Effect/cgraph.scm 229 */
					BgL_localz00_bglt BgL_arg3560z00_1485;

					{	/* Effect/cgraph.scm 229 */
						BgL_localz00_bglt BgL_obj3320z00_1486;

						BgL_obj3320z00_1486 = ((BgL_localz00_bglt) BgL_calleez00_1481);
						{	/* Effect/cgraph.scm 229 */
							BgL_localzf2fromzf2_bglt BgL_arg3561z00_1487;

							{	/* Effect/cgraph.scm 229 */
								BgL_localzf2fromzf2_bglt BgL_res3664z00_2606;

								{	/* Effect/cgraph.scm 229 */
									BgL_localzf2fromzf2_bglt BgL_new3144z00_2601;

									BgL_new3144z00_2601 =
										((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_localzf2fromzf2_bgl))));
									{	/* Effect/cgraph.scm 229 */
										BgL_localzf2fromzf2_bglt BgL_res3663z00_2605;

										{	/* Effect/cgraph.scm 229 */
											BgL_localzf2fromzf2_bglt BgL_new3160z00_2602;

											BgL_new3160z00_2602 = BgL_new3144z00_2601;
											{	/* Effect/cgraph.scm 229 */
												obj_t BgL_from3159z00_2604;

												BgL_from3159z00_2604 = BNIL;
												((((BgL_localzf2fromzf2_bglt)
															CREF(BgL_new3160z00_2602))->BgL_fromz00) =
													((obj_t) BgL_from3159z00_2604), BUNSPEC);
												BgL_res3663z00_2605 = BgL_new3160z00_2602;
										}} BgL_res3663z00_2605;
									}
									BgL_res3664z00_2606 = BgL_new3144z00_2601;
								}
								BgL_arg3561z00_1487 = BgL_res3664z00_2606;
							}
							{	/* Effect/cgraph.scm 229 */
								obj_t BgL_auxz00_3423;

								BgL_objectz00_bglt BgL_auxz00_3421;

								BgL_auxz00_3423 = (obj_t) (BgL_arg3561z00_1487);
								BgL_auxz00_3421 = (BgL_objectz00_bglt) (BgL_obj3320z00_1486);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3421, BgL_auxz00_3423);
						}}
						BGL_OBJECT_CLASS_NUM_SET(
							(BgL_objectz00_bglt) (BgL_obj3320z00_1486),
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00));
						BgL_arg3560z00_1485 = BgL_obj3320z00_1486;
					}
					{	/* Effect/cgraph.scm 229 */
						BgL_variablez00_bglt BgL_calleez00_2609;

						BgL_variablez00_bglt BgL_ownerz00_2610;

						BgL_calleez00_2609 = (BgL_variablez00_bglt) (BgL_arg3560z00_1485);
						BgL_ownerz00_2610 = (BgL_variablez00_bglt) (BgL_ownerz00_1482);
						{	/* Effect/cgraph.scm 229 */
							obj_t BgL_method3374z00_2611;

							{	/* Effect/cgraph.scm 229 */
								BgL_objectz00_bglt BgL_objz00_2612;

								BgL_objz00_2612 = (BgL_objectz00_bglt) (BgL_calleez00_2609);
								{	/* Effect/cgraph.scm 229 */
									long BgL_objzd2classzd2numz00_2613;

									BgL_objzd2classzd2numz00_2613 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2612);
									{	/* Effect/cgraph.scm 229 */
										obj_t BgL_arg2551z00_2614;

										BgL_arg2551z00_2614 =
											PROCEDURE_REF
											(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 229 */
											obj_t BgL_arrayz00_2616;

											int BgL_offsetz00_2617;

											BgL_arrayz00_2616 = BgL_arg2551z00_2614;
											BgL_offsetz00_2617 =
												(int) (BgL_objzd2classzd2numz00_2613);
											{	/* Effect/cgraph.scm 229 */
												long BgL_offsetz00_2618;

												BgL_offsetz00_2618 =
													((long) (BgL_offsetz00_2617) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 229 */
													long BgL_modz00_2619;

													{	/* Effect/cgraph.scm 229 */
														int BgL_arg2553z00_2620;

														BgL_arg2553z00_2620 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 229 */
															long BgL_auxz00_3439;

															BgL_auxz00_3439 = (long) (BgL_arg2553z00_2620);
															BgL_modz00_2619 =
																(BgL_offsetz00_2618 / BgL_auxz00_3439);
													}}
													{	/* Effect/cgraph.scm 229 */
														long BgL_restz00_2621;

														{	/* Effect/cgraph.scm 229 */
															int BgL_arg2552z00_2622;

															BgL_arg2552z00_2622 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 229 */
																long BgL_auxz00_3443;

																BgL_auxz00_3443 = (long) (BgL_arg2552z00_2622);
																BgL_restz00_2621 =
																	(BgL_offsetz00_2618 % BgL_auxz00_3443);
														}}
														{	/* Effect/cgraph.scm 229 */

															BgL_method3374z00_2611 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2616,
																	(int) (BgL_modz00_2619)),
																(int) (BgL_restz00_2621));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3374z00_2611) (BgL_method3374z00_2611,
								(obj_t) (BgL_calleez00_2609),
								(obj_t) (BgL_ownerz00_2610), BEOA);
						}
					}
				}
			}
		}
	}



/* save-call!-global/fr3378 */
	obj_t BGl_savezd2callz12zd2globalzf2fr3378ze0zzeffect_cgraphz00(obj_t
		BgL_envz00_2813, obj_t BgL_calleez00_2814, obj_t BgL_ownerz00_2815)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 220 */
			{
				BgL_globalzf2fromzf2_bglt BgL_calleez00_1470;

				obj_t BgL_ownerz00_1471;

				BgL_calleez00_1470 = (BgL_globalzf2fromzf2_bglt) (BgL_calleez00_2814);
				BgL_ownerz00_1471 = BgL_ownerz00_2815;
				{	/* Effect/cgraph.scm 222 */
					bool_t BgL_testz00_3455;

					{	/* Effect/cgraph.scm 222 */
						obj_t BgL_auxz00_3456;

						{	/* Effect/cgraph.scm 222 */
							obj_t BgL_auxz00_3457;

							{
								obj_t BgL_auxz00_3458;

								{	/* Effect/cgraph.scm 222 */
									BgL_objectz00_bglt BgL_auxz00_3459;

									BgL_auxz00_3459 = (BgL_objectz00_bglt) (BgL_calleez00_1470);
									BgL_auxz00_3458 = BGL_OBJECT_WIDENING(BgL_auxz00_3459);
								}
								BgL_auxz00_3457 =
									(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3458))->
									BgL_fromz00);
							}
							BgL_auxz00_3456 =
								BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_1471,
								BgL_auxz00_3457);
						}
						BgL_testz00_3455 = CBOOL(BgL_auxz00_3456);
					}
					if (BgL_testz00_3455)
						{	/* Effect/cgraph.scm 222 */
							return BFALSE;
						}
					else
						{	/* Effect/cgraph.scm 223 */
							obj_t BgL_arg3556z00_1476;

							{	/* Effect/cgraph.scm 223 */
								obj_t BgL_arg3557z00_1477;

								{
									obj_t BgL_auxz00_3465;

									{	/* Effect/cgraph.scm 223 */
										BgL_objectz00_bglt BgL_auxz00_3466;

										BgL_auxz00_3466 = (BgL_objectz00_bglt) (BgL_calleez00_1470);
										BgL_auxz00_3465 = BGL_OBJECT_WIDENING(BgL_auxz00_3466);
									}
									BgL_arg3557z00_1477 =
										(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3465))->
										BgL_fromz00);
								}
								BgL_arg3556z00_1476 =
									MAKE_PAIR(BgL_ownerz00_1471, BgL_arg3557z00_1477);
							}
							{
								obj_t BgL_auxz00_3471;

								{	/* Effect/cgraph.scm 223 */
									BgL_objectz00_bglt BgL_auxz00_3472;

									BgL_auxz00_3472 = (BgL_objectz00_bglt) (BgL_calleez00_1470);
									BgL_auxz00_3471 = BGL_OBJECT_WIDENING(BgL_auxz00_3472);
								}
								return
									((((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3471))->
										BgL_fromz00) = ((obj_t) BgL_arg3556z00_1476), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* save-call!-global3376 */
	obj_t BGl_savezd2callz12zd2global3376z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2816, obj_t BgL_calleez00_2817, obj_t BgL_ownerz00_2818)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 208 */
			{
				BgL_globalz00_bglt BgL_calleez00_1453;

				obj_t BgL_ownerz00_1454;

				BgL_calleez00_1453 = (BgL_globalz00_bglt) (BgL_calleez00_2817);
				BgL_ownerz00_1454 = BgL_ownerz00_2818;
				{	/* Effect/cgraph.scm 209 */
					BgL_valuez00_bglt BgL_funz00_1457;

					{
						BgL_variablez00_bglt BgL_auxz00_3477;

						BgL_auxz00_3477 = (BgL_variablez00_bglt) (BgL_calleez00_1453);
						BgL_funz00_1457 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3477))->BgL_valuez00);
					}
					{	/* Effect/cgraph.scm 210 */
						bool_t BgL_testz00_3480;

						{	/* Effect/cgraph.scm 210 */
							bool_t BgL_testz00_3481;

							{	/* Effect/cgraph.scm 210 */
								obj_t BgL_obj1926z00_2556;

								BgL_obj1926z00_2556 = (obj_t) (BgL_funz00_1457);
								BgL_testz00_3481 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1926z00_2556,
									BGl_cfunz00zzast_varz00);
							}
							if (BgL_testz00_3481)
								{	/* Effect/cgraph.scm 210 */
									BgL_testz00_3480 = ((bool_t) 1);
								}
							else
								{	/* Effect/cgraph.scm 211 */
									bool_t BgL_testz00_3484;

									{	/* Effect/cgraph.scm 211 */
										obj_t BgL_obj1862z00_2557;

										BgL_obj1862z00_2557 = (obj_t) (BgL_funz00_1457);
										BgL_testz00_3484 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1862z00_2557,
											BGl_sfunz00zzast_varz00);
									}
									if (BgL_testz00_3484)
										{	/* Effect/cgraph.scm 211 */
											BgL_testz00_3480 =
												(
												(((BgL_globalz00_bglt) CREF(BgL_calleez00_1453))->
													BgL_importz00) == CNST_TABLE_REF(((long) 6)));
										}
									else
										{	/* Effect/cgraph.scm 211 */
											BgL_testz00_3480 = ((bool_t) 0);
										}
								}
						}
						if (BgL_testz00_3480)
							{	/* Effect/cgraph.scm 213 */
								bool_t BgL_testz00_3490;

								{	/* Effect/cgraph.scm 213 */
									BgL_funz00_bglt BgL_obj1722z00_2559;

									BgL_obj1722z00_2559 = (BgL_funz00_bglt) (BgL_funz00_1457);
									BgL_testz00_3490 =
										CBOOL(
										(((BgL_funz00_bglt) CREF(BgL_obj1722z00_2559))->
											BgL_sidezd2effectzf3z21));
								}
								if (BgL_testz00_3490)
									{	/* Effect/cgraph.scm 213 */
										return
											BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
											(BgL_variablez00_bglt) (BgL_ownerz00_1454));
									}
								else
									{	/* Effect/cgraph.scm 213 */
										return BFALSE;
									}
							}
						else
							{	/* Effect/cgraph.scm 215 */
								BgL_globalz00_bglt BgL_arg3548z00_1460;

								{	/* Effect/cgraph.scm 215 */
									BgL_globalz00_bglt BgL_obj3317z00_1461;

									BgL_obj3317z00_1461 =
										((BgL_globalz00_bglt) BgL_calleez00_1453);
									{	/* Effect/cgraph.scm 215 */
										BgL_globalzf2fromzf2_bglt BgL_arg3549z00_1462;

										{	/* Effect/cgraph.scm 215 */
											BgL_globalzf2fromzf2_bglt BgL_res3660z00_2566;

											{	/* Effect/cgraph.scm 215 */
												BgL_globalzf2fromzf2_bglt BgL_new3202z00_2561;

												BgL_new3202z00_2561 =
													((BgL_globalzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_globalzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 215 */
													BgL_globalzf2fromzf2_bglt BgL_res3659z00_2565;

													{	/* Effect/cgraph.scm 215 */
														BgL_globalzf2fromzf2_bglt BgL_new3224z00_2562;

														BgL_new3224z00_2562 = BgL_new3202z00_2561;
														{	/* Effect/cgraph.scm 215 */
															obj_t BgL_from3223z00_2564;

															BgL_from3223z00_2564 = BNIL;
															((((BgL_globalzf2fromzf2_bglt)
																		CREF(BgL_new3224z00_2562))->BgL_fromz00) =
																((obj_t) BgL_from3223z00_2564), BUNSPEC);
															BgL_res3659z00_2565 = BgL_new3224z00_2562;
													}} BgL_res3659z00_2565;
												}
												BgL_res3660z00_2566 = BgL_new3202z00_2561;
											}
											BgL_arg3549z00_1462 = BgL_res3660z00_2566;
										}
										{	/* Effect/cgraph.scm 215 */
											obj_t BgL_auxz00_3501;

											BgL_objectz00_bglt BgL_auxz00_3499;

											BgL_auxz00_3501 = (obj_t) (BgL_arg3549z00_1462);
											BgL_auxz00_3499 =
												(BgL_objectz00_bglt) (BgL_obj3317z00_1461);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_3499, BgL_auxz00_3501);
									}}
									BGL_OBJECT_CLASS_NUM_SET(
										(BgL_objectz00_bglt) (BgL_obj3317z00_1461),
										BGl_classzd2numzd2zz__objectz00
										(BGl_globalzf2fromzf2zzeffect_cgraphz00));
									BgL_arg3548z00_1460 = BgL_obj3317z00_1461;
								}
								{	/* Effect/cgraph.scm 215 */
									BgL_variablez00_bglt BgL_calleez00_2569;

									BgL_variablez00_bglt BgL_ownerz00_2570;

									BgL_calleez00_2569 =
										(BgL_variablez00_bglt) (BgL_arg3548z00_1460);
									BgL_ownerz00_2570 =
										(BgL_variablez00_bglt) (BgL_ownerz00_1454);
									{	/* Effect/cgraph.scm 215 */
										obj_t BgL_method3374z00_2571;

										{	/* Effect/cgraph.scm 215 */
											BgL_objectz00_bglt BgL_objz00_2572;

											BgL_objz00_2572 =
												(BgL_objectz00_bglt) (BgL_calleez00_2569);
											{	/* Effect/cgraph.scm 215 */
												long BgL_objzd2classzd2numz00_2573;

												BgL_objzd2classzd2numz00_2573 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2572);
												{	/* Effect/cgraph.scm 215 */
													obj_t BgL_arg2551z00_2574;

													BgL_arg2551z00_2574 =
														PROCEDURE_REF
														(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
														(int) (((long) 1)));
													{	/* Effect/cgraph.scm 215 */
														obj_t BgL_arrayz00_2576;

														int BgL_offsetz00_2577;

														BgL_arrayz00_2576 = BgL_arg2551z00_2574;
														BgL_offsetz00_2577 =
															(int) (BgL_objzd2classzd2numz00_2573);
														{	/* Effect/cgraph.scm 215 */
															long BgL_offsetz00_2578;

															BgL_offsetz00_2578 =
																((long) (BgL_offsetz00_2577) - OBJECT_TYPE);
															{	/* Effect/cgraph.scm 215 */
																long BgL_modz00_2579;

																{	/* Effect/cgraph.scm 215 */
																	int BgL_arg2553z00_2580;

																	BgL_arg2553z00_2580 = (int) (((long) 8));
																	{	/* Effect/cgraph.scm 215 */
																		long BgL_auxz00_3517;

																		BgL_auxz00_3517 =
																			(long) (BgL_arg2553z00_2580);
																		BgL_modz00_2579 =
																			(BgL_offsetz00_2578 / BgL_auxz00_3517);
																}}
																{	/* Effect/cgraph.scm 215 */
																	long BgL_restz00_2581;

																	{	/* Effect/cgraph.scm 215 */
																		int BgL_arg2552z00_2582;

																		BgL_arg2552z00_2582 = (int) (((long) 8));
																		{	/* Effect/cgraph.scm 215 */
																			long BgL_auxz00_3521;

																			BgL_auxz00_3521 =
																				(long) (BgL_arg2552z00_2582);
																			BgL_restz00_2581 =
																				(BgL_offsetz00_2578 % BgL_auxz00_3521);
																	}}
																	{	/* Effect/cgraph.scm 215 */

																		BgL_method3374z00_2571 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2576,
																				(int) (BgL_modz00_2579)),
																			(int) (BgL_restz00_2581));
										}}}}}}}}
										return
											PROCEDURE_ENTRY(BgL_method3374z00_2571)
											(BgL_method3374z00_2571, (obj_t) (BgL_calleez00_2569),
											(obj_t) (BgL_ownerz00_2570), BEOA);
									}
								}
							}
					}
				}
			}
		}
	}



/* call-graph!-box-set!3372 */
	obj_t BGl_callzd2graphz12zd2boxzd2setz123372zd2zzeffect_cgraphz00(obj_t
		BgL_envz00_2819, obj_t BgL_nodez00_2820, obj_t BgL_ownerz00_2821)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 187 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1440;

				obj_t BgL_ownerz00_1441;

				BgL_nodez00_1440 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2820);
				BgL_ownerz00_1441 = BgL_ownerz00_2821;
				{	/* Effect/cgraph.scm 189 */
					bool_t BgL_testz00_3533;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_ownerz00_1441,
							BGl_localz00zzast_varz00))
						{	/* Effect/cgraph.scm 189 */
							BgL_testz00_3533 = ((bool_t) 1);
						}
					else
						{	/* Effect/cgraph.scm 189 */
							BgL_variablez00_bglt BgL_arg3541z00_1447;

							{	/* Effect/cgraph.scm 189 */
								BgL_varz00_bglt BgL_obj2061z00_2497;

								BgL_obj2061z00_2497 =
									(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1440))->
									BgL_varz00);
								BgL_arg3541z00_1447 =
									(((BgL_varz00_bglt) CREF(BgL_obj2061z00_2497))->
									BgL_variablez00);
							}
							{	/* Effect/cgraph.scm 189 */
								obj_t BgL_obj1658z00_2498;

								BgL_obj1658z00_2498 = (obj_t) (BgL_arg3541z00_1447);
								BgL_testz00_3533 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_2498,
									BGl_globalz00zzast_varz00);
							}
						}
					if (BgL_testz00_3533)
						{	/* Effect/cgraph.scm 189 */
							BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
								(BgL_variablez00_bglt) (BgL_ownerz00_1441));
						}
					else
						{	/* Effect/cgraph.scm 189 */
							BFALSE;
						}
				}
				{	/* Effect/cgraph.scm 191 */
					BgL_varz00_bglt BgL_arg3543z00_1449;

					BgL_arg3543z00_1449 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1440))->BgL_varz00);
					{	/* Effect/cgraph.scm 191 */
						BgL_nodez00_bglt BgL_nodez00_2500;

						BgL_variablez00_bglt BgL_ownerz00_2501;

						BgL_nodez00_2500 = (BgL_nodez00_bglt) (BgL_arg3543z00_1449);
						BgL_ownerz00_2501 = (BgL_variablez00_bglt) (BgL_ownerz00_1441);
						{	/* Effect/cgraph.scm 191 */
							obj_t BgL_method3337z00_2502;

							{	/* Effect/cgraph.scm 191 */
								BgL_objectz00_bglt BgL_objz00_2503;

								BgL_objz00_2503 = (BgL_objectz00_bglt) (BgL_nodez00_2500);
								{	/* Effect/cgraph.scm 191 */
									long BgL_objzd2classzd2numz00_2504;

									BgL_objzd2classzd2numz00_2504 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2503);
									{	/* Effect/cgraph.scm 191 */
										obj_t BgL_arg2551z00_2505;

										BgL_arg2551z00_2505 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 191 */
											obj_t BgL_arrayz00_2507;

											int BgL_offsetz00_2508;

											BgL_arrayz00_2507 = BgL_arg2551z00_2505;
											BgL_offsetz00_2508 =
												(int) (BgL_objzd2classzd2numz00_2504);
											{	/* Effect/cgraph.scm 191 */
												long BgL_offsetz00_2509;

												BgL_offsetz00_2509 =
													((long) (BgL_offsetz00_2508) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 191 */
													long BgL_modz00_2510;

													{	/* Effect/cgraph.scm 191 */
														int BgL_arg2553z00_2511;

														BgL_arg2553z00_2511 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 191 */
															long BgL_auxz00_3553;

															BgL_auxz00_3553 = (long) (BgL_arg2553z00_2511);
															BgL_modz00_2510 =
																(BgL_offsetz00_2509 / BgL_auxz00_3553);
													}}
													{	/* Effect/cgraph.scm 191 */
														long BgL_restz00_2512;

														{	/* Effect/cgraph.scm 191 */
															int BgL_arg2552z00_2513;

															BgL_arg2552z00_2513 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 191 */
																long BgL_auxz00_3557;

																BgL_auxz00_3557 = (long) (BgL_arg2552z00_2513);
																BgL_restz00_2512 =
																	(BgL_offsetz00_2509 % BgL_auxz00_3557);
														}}
														{	/* Effect/cgraph.scm 191 */

															BgL_method3337z00_2502 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2507,
																	(int) (BgL_modz00_2510)),
																(int) (BgL_restz00_2512));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2502) (BgL_method3337z00_2502,
								(obj_t) (BgL_nodez00_2500), (obj_t) (BgL_ownerz00_2501), BEOA);
				}}}
				{	/* Effect/cgraph.scm 192 */
					BgL_nodez00_bglt BgL_arg3544z00_1450;

					BgL_arg3544z00_1450 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1440))->BgL_valuez00);
					{	/* Effect/cgraph.scm 192 */
						BgL_variablez00_bglt BgL_ownerz00_2529;

						BgL_ownerz00_2529 = (BgL_variablez00_bglt) (BgL_ownerz00_1441);
						{	/* Effect/cgraph.scm 192 */
							obj_t BgL_method3337z00_2530;

							{	/* Effect/cgraph.scm 192 */
								BgL_objectz00_bglt BgL_objz00_2531;

								BgL_objz00_2531 = (BgL_objectz00_bglt) (BgL_arg3544z00_1450);
								{	/* Effect/cgraph.scm 192 */
									long BgL_objzd2classzd2numz00_2532;

									BgL_objzd2classzd2numz00_2532 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2531);
									{	/* Effect/cgraph.scm 192 */
										obj_t BgL_arg2551z00_2533;

										BgL_arg2551z00_2533 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 192 */
											obj_t BgL_arrayz00_2535;

											int BgL_offsetz00_2536;

											BgL_arrayz00_2535 = BgL_arg2551z00_2533;
											BgL_offsetz00_2536 =
												(int) (BgL_objzd2classzd2numz00_2532);
											{	/* Effect/cgraph.scm 192 */
												long BgL_offsetz00_2537;

												BgL_offsetz00_2537 =
													((long) (BgL_offsetz00_2536) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 192 */
													long BgL_modz00_2538;

													{	/* Effect/cgraph.scm 192 */
														int BgL_arg2553z00_2539;

														BgL_arg2553z00_2539 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 192 */
															long BgL_auxz00_3578;

															BgL_auxz00_3578 = (long) (BgL_arg2553z00_2539);
															BgL_modz00_2538 =
																(BgL_offsetz00_2537 / BgL_auxz00_3578);
													}}
													{	/* Effect/cgraph.scm 192 */
														long BgL_restz00_2540;

														{	/* Effect/cgraph.scm 192 */
															int BgL_arg2552z00_2541;

															BgL_arg2552z00_2541 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 192 */
																long BgL_auxz00_3582;

																BgL_auxz00_3582 = (long) (BgL_arg2552z00_2541);
																BgL_restz00_2540 =
																	(BgL_offsetz00_2537 % BgL_auxz00_3582);
														}}
														{	/* Effect/cgraph.scm 192 */

															BgL_method3337z00_2530 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2535,
																	(int) (BgL_modz00_2538)),
																(int) (BgL_restz00_2540));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2530) (BgL_method3337z00_2530,
								(obj_t) (BgL_arg3544z00_1450),
								(obj_t) (BgL_ownerz00_2529), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-box-ref3370 */
	obj_t BGl_callzd2graphz12zd2boxzd2ref3370zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2822, obj_t BgL_nodez00_2823, obj_t BgL_ownerz00_2824)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 179 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1433;

				obj_t BgL_ownerz00_1434;

				BgL_nodez00_1433 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2823);
				BgL_ownerz00_1434 = BgL_ownerz00_2824;
				{	/* Effect/cgraph.scm 180 */
					BgL_varz00_bglt BgL_arg3537z00_2466;

					BgL_arg3537z00_2466 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1433))->BgL_varz00);
					{	/* Effect/cgraph.scm 180 */
						BgL_nodez00_bglt BgL_nodez00_2468;

						BgL_variablez00_bglt BgL_ownerz00_2469;

						BgL_nodez00_2468 = (BgL_nodez00_bglt) (BgL_arg3537z00_2466);
						BgL_ownerz00_2469 = (BgL_variablez00_bglt) (BgL_ownerz00_1434);
						{	/* Effect/cgraph.scm 180 */
							obj_t BgL_method3337z00_2470;

							{	/* Effect/cgraph.scm 180 */
								BgL_objectz00_bglt BgL_objz00_2471;

								BgL_objz00_2471 = (BgL_objectz00_bglt) (BgL_nodez00_2468);
								{	/* Effect/cgraph.scm 180 */
									long BgL_objzd2classzd2numz00_2472;

									BgL_objzd2classzd2numz00_2472 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2471);
									{	/* Effect/cgraph.scm 180 */
										obj_t BgL_arg2551z00_2473;

										BgL_arg2551z00_2473 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 180 */
											obj_t BgL_arrayz00_2475;

											int BgL_offsetz00_2476;

											BgL_arrayz00_2475 = BgL_arg2551z00_2473;
											BgL_offsetz00_2476 =
												(int) (BgL_objzd2classzd2numz00_2472);
											{	/* Effect/cgraph.scm 180 */
												long BgL_offsetz00_2477;

												BgL_offsetz00_2477 =
													((long) (BgL_offsetz00_2476) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 180 */
													long BgL_modz00_2478;

													{	/* Effect/cgraph.scm 180 */
														int BgL_arg2553z00_2479;

														BgL_arg2553z00_2479 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 180 */
															long BgL_auxz00_3605;

															BgL_auxz00_3605 = (long) (BgL_arg2553z00_2479);
															BgL_modz00_2478 =
																(BgL_offsetz00_2477 / BgL_auxz00_3605);
													}}
													{	/* Effect/cgraph.scm 180 */
														long BgL_restz00_2480;

														{	/* Effect/cgraph.scm 180 */
															int BgL_arg2552z00_2481;

															BgL_arg2552z00_2481 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 180 */
																long BgL_auxz00_3609;

																BgL_auxz00_3609 = (long) (BgL_arg2552z00_2481);
																BgL_restz00_2480 =
																	(BgL_offsetz00_2477 % BgL_auxz00_3609);
														}}
														{	/* Effect/cgraph.scm 180 */

															BgL_method3337z00_2470 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2475,
																	(int) (BgL_modz00_2478)),
																(int) (BgL_restz00_2480));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2470) (BgL_method3337z00_2470,
								(obj_t) (BgL_nodez00_2468), (obj_t) (BgL_ownerz00_2469), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-make-box3368 */
	obj_t BGl_callzd2graphz12zd2makezd2box3368zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2825, obj_t BgL_nodez00_2826, obj_t BgL_ownerz00_2827)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 173 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1426;

				obj_t BgL_ownerz00_1427;

				BgL_nodez00_1426 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2826);
				BgL_ownerz00_1427 = BgL_ownerz00_2827;
				{	/* Effect/cgraph.scm 174 */
					BgL_nodez00_bglt BgL_arg3535z00_2437;

					BgL_arg3535z00_2437 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1426))->BgL_valuez00);
					{	/* Effect/cgraph.scm 174 */
						BgL_variablez00_bglt BgL_ownerz00_2440;

						BgL_ownerz00_2440 = (BgL_variablez00_bglt) (BgL_ownerz00_1427);
						{	/* Effect/cgraph.scm 174 */
							obj_t BgL_method3337z00_2441;

							{	/* Effect/cgraph.scm 174 */
								BgL_objectz00_bglt BgL_objz00_2442;

								BgL_objz00_2442 = (BgL_objectz00_bglt) (BgL_arg3535z00_2437);
								{	/* Effect/cgraph.scm 174 */
									long BgL_objzd2classzd2numz00_2443;

									BgL_objzd2classzd2numz00_2443 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2442);
									{	/* Effect/cgraph.scm 174 */
										obj_t BgL_arg2551z00_2444;

										BgL_arg2551z00_2444 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 174 */
											obj_t BgL_arrayz00_2446;

											int BgL_offsetz00_2447;

											BgL_arrayz00_2446 = BgL_arg2551z00_2444;
											BgL_offsetz00_2447 =
												(int) (BgL_objzd2classzd2numz00_2443);
											{	/* Effect/cgraph.scm 174 */
												long BgL_offsetz00_2448;

												BgL_offsetz00_2448 =
													((long) (BgL_offsetz00_2447) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 174 */
													long BgL_modz00_2449;

													{	/* Effect/cgraph.scm 174 */
														int BgL_arg2553z00_2450;

														BgL_arg2553z00_2450 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 174 */
															long BgL_auxz00_3631;

															BgL_auxz00_3631 = (long) (BgL_arg2553z00_2450);
															BgL_modz00_2449 =
																(BgL_offsetz00_2448 / BgL_auxz00_3631);
													}}
													{	/* Effect/cgraph.scm 174 */
														long BgL_restz00_2451;

														{	/* Effect/cgraph.scm 174 */
															int BgL_arg2552z00_2452;

															BgL_arg2552z00_2452 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 174 */
																long BgL_auxz00_3635;

																BgL_auxz00_3635 = (long) (BgL_arg2552z00_2452);
																BgL_restz00_2451 =
																	(BgL_offsetz00_2448 % BgL_auxz00_3635);
														}}
														{	/* Effect/cgraph.scm 174 */

															BgL_method3337z00_2441 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2446,
																	(int) (BgL_modz00_2449)),
																(int) (BgL_restz00_2451));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2441) (BgL_method3337z00_2441,
								(obj_t) (BgL_arg3535z00_2437),
								(obj_t) (BgL_ownerz00_2440), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-jump-ex-3366 */
	obj_t BGl_callzd2graphz12zd2jumpzd2exzd23366z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2828, obj_t BgL_nodez00_2829, obj_t BgL_ownerz00_2830)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 164 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1417;

				obj_t BgL_ownerz00_1418;

				BgL_nodez00_1417 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2829);
				BgL_ownerz00_1418 = BgL_ownerz00_2830;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1418));
				{	/* Effect/cgraph.scm 167 */
					BgL_nodez00_bglt BgL_arg3532z00_1422;

					BgL_arg3532z00_1422 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1417))->
						BgL_exitz00);
					{	/* Effect/cgraph.scm 167 */
						BgL_variablez00_bglt BgL_ownerz00_2383;

						BgL_ownerz00_2383 = (BgL_variablez00_bglt) (BgL_ownerz00_1418);
						{	/* Effect/cgraph.scm 167 */
							obj_t BgL_method3337z00_2384;

							{	/* Effect/cgraph.scm 167 */
								BgL_objectz00_bglt BgL_objz00_2385;

								BgL_objz00_2385 = (BgL_objectz00_bglt) (BgL_arg3532z00_1422);
								{	/* Effect/cgraph.scm 167 */
									long BgL_objzd2classzd2numz00_2386;

									BgL_objzd2classzd2numz00_2386 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2385);
									{	/* Effect/cgraph.scm 167 */
										obj_t BgL_arg2551z00_2387;

										BgL_arg2551z00_2387 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 167 */
											obj_t BgL_arrayz00_2389;

											int BgL_offsetz00_2390;

											BgL_arrayz00_2389 = BgL_arg2551z00_2387;
											BgL_offsetz00_2390 =
												(int) (BgL_objzd2classzd2numz00_2386);
											{	/* Effect/cgraph.scm 167 */
												long BgL_offsetz00_2391;

												BgL_offsetz00_2391 =
													((long) (BgL_offsetz00_2390) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 167 */
													long BgL_modz00_2392;

													{	/* Effect/cgraph.scm 167 */
														int BgL_arg2553z00_2393;

														BgL_arg2553z00_2393 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 167 */
															long BgL_auxz00_3659;

															BgL_auxz00_3659 = (long) (BgL_arg2553z00_2393);
															BgL_modz00_2392 =
																(BgL_offsetz00_2391 / BgL_auxz00_3659);
													}}
													{	/* Effect/cgraph.scm 167 */
														long BgL_restz00_2394;

														{	/* Effect/cgraph.scm 167 */
															int BgL_arg2552z00_2395;

															BgL_arg2552z00_2395 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 167 */
																long BgL_auxz00_3663;

																BgL_auxz00_3663 = (long) (BgL_arg2552z00_2395);
																BgL_restz00_2394 =
																	(BgL_offsetz00_2391 % BgL_auxz00_3663);
														}}
														{	/* Effect/cgraph.scm 167 */

															BgL_method3337z00_2384 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2389,
																	(int) (BgL_modz00_2392)),
																(int) (BgL_restz00_2394));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2384) (BgL_method3337z00_2384,
								(obj_t) (BgL_arg3532z00_1422),
								(obj_t) (BgL_ownerz00_2383), BEOA);
				}}}
				{	/* Effect/cgraph.scm 168 */
					BgL_nodez00_bglt BgL_arg3533z00_1423;

					BgL_arg3533z00_1423 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1417))->
						BgL_valuez00);
					{	/* Effect/cgraph.scm 168 */
						BgL_variablez00_bglt BgL_ownerz00_2411;

						BgL_ownerz00_2411 = (BgL_variablez00_bglt) (BgL_ownerz00_1418);
						{	/* Effect/cgraph.scm 168 */
							obj_t BgL_method3337z00_2412;

							{	/* Effect/cgraph.scm 168 */
								BgL_objectz00_bglt BgL_objz00_2413;

								BgL_objz00_2413 = (BgL_objectz00_bglt) (BgL_arg3533z00_1423);
								{	/* Effect/cgraph.scm 168 */
									long BgL_objzd2classzd2numz00_2414;

									BgL_objzd2classzd2numz00_2414 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2413);
									{	/* Effect/cgraph.scm 168 */
										obj_t BgL_arg2551z00_2415;

										BgL_arg2551z00_2415 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 168 */
											obj_t BgL_arrayz00_2417;

											int BgL_offsetz00_2418;

											BgL_arrayz00_2417 = BgL_arg2551z00_2415;
											BgL_offsetz00_2418 =
												(int) (BgL_objzd2classzd2numz00_2414);
											{	/* Effect/cgraph.scm 168 */
												long BgL_offsetz00_2419;

												BgL_offsetz00_2419 =
													((long) (BgL_offsetz00_2418) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 168 */
													long BgL_modz00_2420;

													{	/* Effect/cgraph.scm 168 */
														int BgL_arg2553z00_2421;

														BgL_arg2553z00_2421 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 168 */
															long BgL_auxz00_3684;

															BgL_auxz00_3684 = (long) (BgL_arg2553z00_2421);
															BgL_modz00_2420 =
																(BgL_offsetz00_2419 / BgL_auxz00_3684);
													}}
													{	/* Effect/cgraph.scm 168 */
														long BgL_restz00_2422;

														{	/* Effect/cgraph.scm 168 */
															int BgL_arg2552z00_2423;

															BgL_arg2552z00_2423 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 168 */
																long BgL_auxz00_3688;

																BgL_auxz00_3688 = (long) (BgL_arg2552z00_2423);
																BgL_restz00_2422 =
																	(BgL_offsetz00_2419 % BgL_auxz00_3688);
														}}
														{	/* Effect/cgraph.scm 168 */

															BgL_method3337z00_2412 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2417,
																	(int) (BgL_modz00_2420)),
																(int) (BgL_restz00_2422));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2412) (BgL_method3337z00_2412,
								(obj_t) (BgL_arg3533z00_1423),
								(obj_t) (BgL_ownerz00_2411), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-set-ex-i3364 */
	obj_t BGl_callzd2graphz12zd2setzd2exzd2i3364z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2831, obj_t BgL_nodez00_2832, obj_t BgL_ownerz00_2833)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 156 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1409;

				obj_t BgL_ownerz00_1410;

				BgL_nodez00_1409 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2832);
				BgL_ownerz00_1410 = BgL_ownerz00_2833;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1410));
				{	/* Effect/cgraph.scm 159 */
					BgL_nodez00_bglt BgL_arg3530z00_2352;

					BgL_arg3530z00_2352 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1409))->BgL_bodyz00);
					{	/* Effect/cgraph.scm 159 */
						BgL_variablez00_bglt BgL_ownerz00_2355;

						BgL_ownerz00_2355 = (BgL_variablez00_bglt) (BgL_ownerz00_1410);
						{	/* Effect/cgraph.scm 159 */
							obj_t BgL_method3337z00_2356;

							{	/* Effect/cgraph.scm 159 */
								BgL_objectz00_bglt BgL_objz00_2357;

								BgL_objz00_2357 = (BgL_objectz00_bglt) (BgL_arg3530z00_2352);
								{	/* Effect/cgraph.scm 159 */
									long BgL_objzd2classzd2numz00_2358;

									BgL_objzd2classzd2numz00_2358 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2357);
									{	/* Effect/cgraph.scm 159 */
										obj_t BgL_arg2551z00_2359;

										BgL_arg2551z00_2359 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 159 */
											obj_t BgL_arrayz00_2361;

											int BgL_offsetz00_2362;

											BgL_arrayz00_2361 = BgL_arg2551z00_2359;
											BgL_offsetz00_2362 =
												(int) (BgL_objzd2classzd2numz00_2358);
											{	/* Effect/cgraph.scm 159 */
												long BgL_offsetz00_2363;

												BgL_offsetz00_2363 =
													((long) (BgL_offsetz00_2362) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 159 */
													long BgL_modz00_2364;

													{	/* Effect/cgraph.scm 159 */
														int BgL_arg2553z00_2365;

														BgL_arg2553z00_2365 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 159 */
															long BgL_auxz00_3712;

															BgL_auxz00_3712 = (long) (BgL_arg2553z00_2365);
															BgL_modz00_2364 =
																(BgL_offsetz00_2363 / BgL_auxz00_3712);
													}}
													{	/* Effect/cgraph.scm 159 */
														long BgL_restz00_2366;

														{	/* Effect/cgraph.scm 159 */
															int BgL_arg2552z00_2367;

															BgL_arg2552z00_2367 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 159 */
																long BgL_auxz00_3716;

																BgL_auxz00_3716 = (long) (BgL_arg2552z00_2367);
																BgL_restz00_2366 =
																	(BgL_offsetz00_2363 % BgL_auxz00_3716);
														}}
														{	/* Effect/cgraph.scm 159 */

															BgL_method3337z00_2356 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2361,
																	(int) (BgL_modz00_2364)),
																(int) (BgL_restz00_2366));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2356) (BgL_method3337z00_2356,
								(obj_t) (BgL_arg3530z00_2352),
								(obj_t) (BgL_ownerz00_2355), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-let-var3361 */
	obj_t BGl_callzd2graphz12zd2letzd2var3361zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2834, obj_t BgL_nodez00_2835, obj_t BgL_ownerz00_2836)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 146 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1392;

				obj_t BgL_ownerz00_1393;

				{	/* Effect/cgraph.scm 147 */
					bool_t BgL_auxz00_3728;

					BgL_nodez00_1392 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2835);
					BgL_ownerz00_1393 = BgL_ownerz00_2836;
					{	/* Effect/cgraph.scm 148 */
						BgL_nodez00_bglt BgL_arg3524z00_1397;

						BgL_arg3524z00_1397 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1392))->BgL_bodyz00);
						{	/* Effect/cgraph.scm 148 */
							BgL_variablez00_bglt BgL_ownerz00_2294;

							BgL_ownerz00_2294 = (BgL_variablez00_bglt) (BgL_ownerz00_1393);
							{	/* Effect/cgraph.scm 148 */
								obj_t BgL_method3337z00_2295;

								{	/* Effect/cgraph.scm 148 */
									BgL_objectz00_bglt BgL_objz00_2296;

									BgL_objz00_2296 = (BgL_objectz00_bglt) (BgL_arg3524z00_1397);
									{	/* Effect/cgraph.scm 148 */
										long BgL_objzd2classzd2numz00_2297;

										BgL_objzd2classzd2numz00_2297 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2296);
										{	/* Effect/cgraph.scm 148 */
											obj_t BgL_arg2551z00_2298;

											BgL_arg2551z00_2298 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 148 */
												obj_t BgL_arrayz00_2300;

												int BgL_offsetz00_2301;

												BgL_arrayz00_2300 = BgL_arg2551z00_2298;
												BgL_offsetz00_2301 =
													(int) (BgL_objzd2classzd2numz00_2297);
												{	/* Effect/cgraph.scm 148 */
													long BgL_offsetz00_2302;

													BgL_offsetz00_2302 =
														((long) (BgL_offsetz00_2301) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 148 */
														long BgL_modz00_2303;

														{	/* Effect/cgraph.scm 148 */
															int BgL_arg2553z00_2304;

															BgL_arg2553z00_2304 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 148 */
																long BgL_auxz00_3739;

																BgL_auxz00_3739 = (long) (BgL_arg2553z00_2304);
																BgL_modz00_2303 =
																	(BgL_offsetz00_2302 / BgL_auxz00_3739);
														}}
														{	/* Effect/cgraph.scm 148 */
															long BgL_restz00_2305;

															{	/* Effect/cgraph.scm 148 */
																int BgL_arg2552z00_2306;

																BgL_arg2552z00_2306 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 148 */
																	long BgL_auxz00_3743;

																	BgL_auxz00_3743 =
																		(long) (BgL_arg2552z00_2306);
																	BgL_restz00_2305 =
																		(BgL_offsetz00_2302 % BgL_auxz00_3743);
															}}
															{	/* Effect/cgraph.scm 148 */

																BgL_method3337z00_2295 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2300,
																		(int) (BgL_modz00_2303)),
																	(int) (BgL_restz00_2305));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3337z00_2295) (BgL_method3337z00_2295,
									(obj_t) (BgL_arg3524z00_1397),
									(obj_t) (BgL_ownerz00_2294), BEOA);
					}}}
					{	/* Effect/cgraph.scm 149 */
						obj_t BgL_g3331z00_1398;

						BgL_g3331z00_1398 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1392))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3329z00_1400;

							BgL_l3329z00_1400 = BgL_g3331z00_1398;
						BgL_zc3anonymousza33525ze3z83_1401:
							if (PAIRP(BgL_l3329z00_1400))
								{	/* Effect/cgraph.scm 149 */
									{	/* Effect/cgraph.scm 150 */
										obj_t BgL_bindingz00_1403;

										BgL_bindingz00_1403 = CAR(BgL_l3329z00_1400);
										{	/* Effect/cgraph.scm 150 */
											obj_t BgL_arg3527z00_1404;

											BgL_arg3527z00_1404 = CDR(BgL_bindingz00_1403);
											{	/* Effect/cgraph.scm 150 */
												BgL_nodez00_bglt BgL_nodez00_2324;

												BgL_variablez00_bglt BgL_ownerz00_2325;

												BgL_nodez00_2324 =
													(BgL_nodez00_bglt) (BgL_arg3527z00_1404);
												BgL_ownerz00_2325 =
													(BgL_variablez00_bglt) (BgL_ownerz00_1393);
												{	/* Effect/cgraph.scm 150 */
													obj_t BgL_method3337z00_2326;

													{	/* Effect/cgraph.scm 150 */
														BgL_objectz00_bglt BgL_objz00_2327;

														BgL_objz00_2327 =
															(BgL_objectz00_bglt) (BgL_nodez00_2324);
														{	/* Effect/cgraph.scm 150 */
															long BgL_objzd2classzd2numz00_2328;

															BgL_objzd2classzd2numz00_2328 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2327);
															{	/* Effect/cgraph.scm 150 */
																obj_t BgL_arg2551z00_2329;

																BgL_arg2551z00_2329 =
																	PROCEDURE_REF
																	(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
																	(int) (((long) 1)));
																{	/* Effect/cgraph.scm 150 */
																	obj_t BgL_arrayz00_2331;

																	int BgL_offsetz00_2332;

																	BgL_arrayz00_2331 = BgL_arg2551z00_2329;
																	BgL_offsetz00_2332 =
																		(int) (BgL_objzd2classzd2numz00_2328);
																	{	/* Effect/cgraph.scm 150 */
																		long BgL_offsetz00_2333;

																		BgL_offsetz00_2333 =
																			(
																			(long) (BgL_offsetz00_2332) -
																			OBJECT_TYPE);
																		{	/* Effect/cgraph.scm 150 */
																			long BgL_modz00_2334;

																			{	/* Effect/cgraph.scm 150 */
																				int BgL_arg2553z00_2335;

																				BgL_arg2553z00_2335 =
																					(int) (((long) 8));
																				{	/* Effect/cgraph.scm 150 */
																					long BgL_auxz00_3769;

																					BgL_auxz00_3769 =
																						(long) (BgL_arg2553z00_2335);
																					BgL_modz00_2334 =
																						(BgL_offsetz00_2333 /
																						BgL_auxz00_3769);
																			}}
																			{	/* Effect/cgraph.scm 150 */
																				long BgL_restz00_2336;

																				{	/* Effect/cgraph.scm 150 */
																					int BgL_arg2552z00_2337;

																					BgL_arg2552z00_2337 =
																						(int) (((long) 8));
																					{	/* Effect/cgraph.scm 150 */
																						long BgL_auxz00_3773;

																						BgL_auxz00_3773 =
																							(long) (BgL_arg2552z00_2337);
																						BgL_restz00_2336 =
																							(BgL_offsetz00_2333 %
																							BgL_auxz00_3773);
																				}}
																				{	/* Effect/cgraph.scm 150 */

																					BgL_method3337z00_2326 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2331,
																							(int) (BgL_modz00_2334)),
																						(int) (BgL_restz00_2336));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method3337z00_2326)
														(BgL_method3337z00_2326, (obj_t) (BgL_nodez00_2324),
														(obj_t) (BgL_ownerz00_2325), BEOA);
									}}}}
									{
										obj_t BgL_l3329z00_3784;

										BgL_l3329z00_3784 = CDR(BgL_l3329z00_1400);
										BgL_l3329z00_1400 = BgL_l3329z00_3784;
										goto BgL_zc3anonymousza33525ze3z83_1401;
									}
								}
							else
								{	/* Effect/cgraph.scm 149 */
									BgL_auxz00_3728 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3728);
				}
			}
		}
	}



/* call-graph!-let-fun3359 */
	obj_t BGl_callzd2graphz12zd2letzd2fun3359zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2837, obj_t BgL_nodez00_2838, obj_t BgL_ownerz00_2839)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 136 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1376;

				obj_t BgL_ownerz00_1377;

				BgL_nodez00_1376 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2838);
				BgL_ownerz00_1377 = BgL_ownerz00_2839;
				{	/* Effect/cgraph.scm 138 */
					obj_t BgL_g3328z00_1381;

					BgL_g3328z00_1381 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1376))->BgL_localsz00);
					{
						obj_t BgL_l3326z00_1383;

						BgL_l3326z00_1383 = BgL_g3328z00_1381;
					BgL_zc3anonymousza33519ze3z83_1384:
						if (PAIRP(BgL_l3326z00_1383))
							{	/* Effect/cgraph.scm 138 */
								{	/* Effect/cgraph.scm 139 */
									obj_t BgL_localz00_1386;

									BgL_localz00_1386 = CAR(BgL_l3326z00_1383);
									BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
										(BgL_variablez00_bglt) (BgL_localz00_1386));
								}
								{
									obj_t BgL_l3326z00_3794;

									BgL_l3326z00_3794 = CDR(BgL_l3326z00_1383);
									BgL_l3326z00_1383 = BgL_l3326z00_3794;
									goto BgL_zc3anonymousza33519ze3z83_1384;
								}
							}
						else
							{	/* Effect/cgraph.scm 138 */
								((bool_t) 1);
							}
					}
				}
				{	/* Effect/cgraph.scm 141 */
					BgL_nodez00_bglt BgL_arg3522z00_1389;

					BgL_arg3522z00_1389 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1376))->BgL_bodyz00);
					{	/* Effect/cgraph.scm 141 */
						BgL_variablez00_bglt BgL_ownerz00_2266;

						BgL_ownerz00_2266 = (BgL_variablez00_bglt) (BgL_ownerz00_1377);
						{	/* Effect/cgraph.scm 141 */
							obj_t BgL_method3337z00_2267;

							{	/* Effect/cgraph.scm 141 */
								BgL_objectz00_bglt BgL_objz00_2268;

								BgL_objz00_2268 = (BgL_objectz00_bglt) (BgL_arg3522z00_1389);
								{	/* Effect/cgraph.scm 141 */
									long BgL_objzd2classzd2numz00_2269;

									BgL_objzd2classzd2numz00_2269 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2268);
									{	/* Effect/cgraph.scm 141 */
										obj_t BgL_arg2551z00_2270;

										BgL_arg2551z00_2270 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 141 */
											obj_t BgL_arrayz00_2272;

											int BgL_offsetz00_2273;

											BgL_arrayz00_2272 = BgL_arg2551z00_2270;
											BgL_offsetz00_2273 =
												(int) (BgL_objzd2classzd2numz00_2269);
											{	/* Effect/cgraph.scm 141 */
												long BgL_offsetz00_2274;

												BgL_offsetz00_2274 =
													((long) (BgL_offsetz00_2273) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 141 */
													long BgL_modz00_2275;

													{	/* Effect/cgraph.scm 141 */
														int BgL_arg2553z00_2276;

														BgL_arg2553z00_2276 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 141 */
															long BgL_auxz00_3806;

															BgL_auxz00_3806 = (long) (BgL_arg2553z00_2276);
															BgL_modz00_2275 =
																(BgL_offsetz00_2274 / BgL_auxz00_3806);
													}}
													{	/* Effect/cgraph.scm 141 */
														long BgL_restz00_2277;

														{	/* Effect/cgraph.scm 141 */
															int BgL_arg2552z00_2278;

															BgL_arg2552z00_2278 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 141 */
																long BgL_auxz00_3810;

																BgL_auxz00_3810 = (long) (BgL_arg2552z00_2278);
																BgL_restz00_2277 =
																	(BgL_offsetz00_2274 % BgL_auxz00_3810);
														}}
														{	/* Effect/cgraph.scm 141 */

															BgL_method3337z00_2267 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2272,
																	(int) (BgL_modz00_2275)),
																(int) (BgL_restz00_2277));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2267) (BgL_method3337z00_2267,
								(obj_t) (BgL_arg3522z00_1389),
								(obj_t) (BgL_ownerz00_2266), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-select3357 */
	obj_t BGl_callzd2graphz12zd2select3357z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2840, obj_t BgL_nodez00_2841, obj_t BgL_ownerz00_2842)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 126 */
			{
				BgL_selectz00_bglt BgL_nodez00_1359;

				obj_t BgL_ownerz00_1360;

				{	/* Effect/cgraph.scm 127 */
					bool_t BgL_auxz00_3822;

					BgL_nodez00_1359 = (BgL_selectz00_bglt) (BgL_nodez00_2841);
					BgL_ownerz00_1360 = BgL_ownerz00_2842;
					{	/* Effect/cgraph.scm 128 */
						BgL_nodez00_bglt BgL_arg3513z00_1364;

						BgL_arg3513z00_1364 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1359))->BgL_testz00);
						{	/* Effect/cgraph.scm 128 */
							BgL_variablez00_bglt BgL_ownerz00_2202;

							BgL_ownerz00_2202 = (BgL_variablez00_bglt) (BgL_ownerz00_1360);
							{	/* Effect/cgraph.scm 128 */
								obj_t BgL_method3337z00_2203;

								{	/* Effect/cgraph.scm 128 */
									BgL_objectz00_bglt BgL_objz00_2204;

									BgL_objz00_2204 = (BgL_objectz00_bglt) (BgL_arg3513z00_1364);
									{	/* Effect/cgraph.scm 128 */
										long BgL_objzd2classzd2numz00_2205;

										BgL_objzd2classzd2numz00_2205 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2204);
										{	/* Effect/cgraph.scm 128 */
											obj_t BgL_arg2551z00_2206;

											BgL_arg2551z00_2206 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 128 */
												obj_t BgL_arrayz00_2208;

												int BgL_offsetz00_2209;

												BgL_arrayz00_2208 = BgL_arg2551z00_2206;
												BgL_offsetz00_2209 =
													(int) (BgL_objzd2classzd2numz00_2205);
												{	/* Effect/cgraph.scm 128 */
													long BgL_offsetz00_2210;

													BgL_offsetz00_2210 =
														((long) (BgL_offsetz00_2209) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 128 */
														long BgL_modz00_2211;

														{	/* Effect/cgraph.scm 128 */
															int BgL_arg2553z00_2212;

															BgL_arg2553z00_2212 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 128 */
																long BgL_auxz00_3833;

																BgL_auxz00_3833 = (long) (BgL_arg2553z00_2212);
																BgL_modz00_2211 =
																	(BgL_offsetz00_2210 / BgL_auxz00_3833);
														}}
														{	/* Effect/cgraph.scm 128 */
															long BgL_restz00_2213;

															{	/* Effect/cgraph.scm 128 */
																int BgL_arg2552z00_2214;

																BgL_arg2552z00_2214 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 128 */
																	long BgL_auxz00_3837;

																	BgL_auxz00_3837 =
																		(long) (BgL_arg2552z00_2214);
																	BgL_restz00_2213 =
																		(BgL_offsetz00_2210 % BgL_auxz00_3837);
															}}
															{	/* Effect/cgraph.scm 128 */

																BgL_method3337z00_2203 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2208,
																		(int) (BgL_modz00_2211)),
																	(int) (BgL_restz00_2213));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3337z00_2203) (BgL_method3337z00_2203,
									(obj_t) (BgL_arg3513z00_1364),
									(obj_t) (BgL_ownerz00_2202), BEOA);
					}}}
					{	/* Effect/cgraph.scm 129 */
						obj_t BgL_g3325z00_1365;

						BgL_g3325z00_1365 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1359))->BgL_clausesz00);
						{
							obj_t BgL_l3323z00_1367;

							BgL_l3323z00_1367 = BgL_g3325z00_1365;
						BgL_zc3anonymousza33514ze3z83_1368:
							if (PAIRP(BgL_l3323z00_1367))
								{	/* Effect/cgraph.scm 129 */
									{	/* Effect/cgraph.scm 130 */
										obj_t BgL_clausez00_1370;

										BgL_clausez00_1370 = CAR(BgL_l3323z00_1367);
										{	/* Effect/cgraph.scm 130 */
											obj_t BgL_arg3516z00_1371;

											BgL_arg3516z00_1371 = CDR(BgL_clausez00_1370);
											{	/* Effect/cgraph.scm 130 */
												BgL_nodez00_bglt BgL_nodez00_2232;

												BgL_variablez00_bglt BgL_ownerz00_2233;

												BgL_nodez00_2232 =
													(BgL_nodez00_bglt) (BgL_arg3516z00_1371);
												BgL_ownerz00_2233 =
													(BgL_variablez00_bglt) (BgL_ownerz00_1360);
												{	/* Effect/cgraph.scm 130 */
													obj_t BgL_method3337z00_2234;

													{	/* Effect/cgraph.scm 130 */
														BgL_objectz00_bglt BgL_objz00_2235;

														BgL_objz00_2235 =
															(BgL_objectz00_bglt) (BgL_nodez00_2232);
														{	/* Effect/cgraph.scm 130 */
															long BgL_objzd2classzd2numz00_2236;

															BgL_objzd2classzd2numz00_2236 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2235);
															{	/* Effect/cgraph.scm 130 */
																obj_t BgL_arg2551z00_2237;

																BgL_arg2551z00_2237 =
																	PROCEDURE_REF
																	(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
																	(int) (((long) 1)));
																{	/* Effect/cgraph.scm 130 */
																	obj_t BgL_arrayz00_2239;

																	int BgL_offsetz00_2240;

																	BgL_arrayz00_2239 = BgL_arg2551z00_2237;
																	BgL_offsetz00_2240 =
																		(int) (BgL_objzd2classzd2numz00_2236);
																	{	/* Effect/cgraph.scm 130 */
																		long BgL_offsetz00_2241;

																		BgL_offsetz00_2241 =
																			(
																			(long) (BgL_offsetz00_2240) -
																			OBJECT_TYPE);
																		{	/* Effect/cgraph.scm 130 */
																			long BgL_modz00_2242;

																			{	/* Effect/cgraph.scm 130 */
																				int BgL_arg2553z00_2243;

																				BgL_arg2553z00_2243 =
																					(int) (((long) 8));
																				{	/* Effect/cgraph.scm 130 */
																					long BgL_auxz00_3863;

																					BgL_auxz00_3863 =
																						(long) (BgL_arg2553z00_2243);
																					BgL_modz00_2242 =
																						(BgL_offsetz00_2241 /
																						BgL_auxz00_3863);
																			}}
																			{	/* Effect/cgraph.scm 130 */
																				long BgL_restz00_2244;

																				{	/* Effect/cgraph.scm 130 */
																					int BgL_arg2552z00_2245;

																					BgL_arg2552z00_2245 =
																						(int) (((long) 8));
																					{	/* Effect/cgraph.scm 130 */
																						long BgL_auxz00_3867;

																						BgL_auxz00_3867 =
																							(long) (BgL_arg2552z00_2245);
																						BgL_restz00_2244 =
																							(BgL_offsetz00_2241 %
																							BgL_auxz00_3867);
																				}}
																				{	/* Effect/cgraph.scm 130 */

																					BgL_method3337z00_2234 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2239,
																							(int) (BgL_modz00_2242)),
																						(int) (BgL_restz00_2244));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method3337z00_2234)
														(BgL_method3337z00_2234, (obj_t) (BgL_nodez00_2232),
														(obj_t) (BgL_ownerz00_2233), BEOA);
									}}}}
									{
										obj_t BgL_l3323z00_3878;

										BgL_l3323z00_3878 = CDR(BgL_l3323z00_1367);
										BgL_l3323z00_1367 = BgL_l3323z00_3878;
										goto BgL_zc3anonymousza33514ze3z83_1368;
									}
								}
							else
								{	/* Effect/cgraph.scm 129 */
									BgL_auxz00_3822 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3822);
				}
			}
		}
	}



/* call-graph!-fail3355 */
	obj_t BGl_callzd2graphz12zd2fail3355z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2843, obj_t BgL_nodez00_2844, obj_t BgL_ownerz00_2845)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 116 */
			{
				BgL_failz00_bglt BgL_nodez00_1349;

				obj_t BgL_ownerz00_1350;

				BgL_nodez00_1349 = (BgL_failz00_bglt) (BgL_nodez00_2844);
				BgL_ownerz00_1350 = BgL_ownerz00_2845;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1350));
				{	/* Effect/cgraph.scm 119 */
					BgL_nodez00_bglt BgL_arg3509z00_1354;

					BgL_arg3509z00_1354 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1349))->BgL_procz00);
					{	/* Effect/cgraph.scm 119 */
						BgL_variablez00_bglt BgL_ownerz00_2118;

						BgL_ownerz00_2118 = (BgL_variablez00_bglt) (BgL_ownerz00_1350);
						{	/* Effect/cgraph.scm 119 */
							obj_t BgL_method3337z00_2119;

							{	/* Effect/cgraph.scm 119 */
								BgL_objectz00_bglt BgL_objz00_2120;

								BgL_objz00_2120 = (BgL_objectz00_bglt) (BgL_arg3509z00_1354);
								{	/* Effect/cgraph.scm 119 */
									long BgL_objzd2classzd2numz00_2121;

									BgL_objzd2classzd2numz00_2121 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2120);
									{	/* Effect/cgraph.scm 119 */
										obj_t BgL_arg2551z00_2122;

										BgL_arg2551z00_2122 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 119 */
											obj_t BgL_arrayz00_2124;

											int BgL_offsetz00_2125;

											BgL_arrayz00_2124 = BgL_arg2551z00_2122;
											BgL_offsetz00_2125 =
												(int) (BgL_objzd2classzd2numz00_2121);
											{	/* Effect/cgraph.scm 119 */
												long BgL_offsetz00_2126;

												BgL_offsetz00_2126 =
													((long) (BgL_offsetz00_2125) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 119 */
													long BgL_modz00_2127;

													{	/* Effect/cgraph.scm 119 */
														int BgL_arg2553z00_2128;

														BgL_arg2553z00_2128 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 119 */
															long BgL_auxz00_3894;

															BgL_auxz00_3894 = (long) (BgL_arg2553z00_2128);
															BgL_modz00_2127 =
																(BgL_offsetz00_2126 / BgL_auxz00_3894);
													}}
													{	/* Effect/cgraph.scm 119 */
														long BgL_restz00_2129;

														{	/* Effect/cgraph.scm 119 */
															int BgL_arg2552z00_2130;

															BgL_arg2552z00_2130 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 119 */
																long BgL_auxz00_3898;

																BgL_auxz00_3898 = (long) (BgL_arg2552z00_2130);
																BgL_restz00_2129 =
																	(BgL_offsetz00_2126 % BgL_auxz00_3898);
														}}
														{	/* Effect/cgraph.scm 119 */

															BgL_method3337z00_2119 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2124,
																	(int) (BgL_modz00_2127)),
																(int) (BgL_restz00_2129));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2119) (BgL_method3337z00_2119,
								(obj_t) (BgL_arg3509z00_1354),
								(obj_t) (BgL_ownerz00_2118), BEOA);
				}}}
				{	/* Effect/cgraph.scm 120 */
					BgL_nodez00_bglt BgL_arg3510z00_1355;

					BgL_arg3510z00_1355 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1349))->BgL_msgz00);
					{	/* Effect/cgraph.scm 120 */
						BgL_variablez00_bglt BgL_ownerz00_2146;

						BgL_ownerz00_2146 = (BgL_variablez00_bglt) (BgL_ownerz00_1350);
						{	/* Effect/cgraph.scm 120 */
							obj_t BgL_method3337z00_2147;

							{	/* Effect/cgraph.scm 120 */
								BgL_objectz00_bglt BgL_objz00_2148;

								BgL_objz00_2148 = (BgL_objectz00_bglt) (BgL_arg3510z00_1355);
								{	/* Effect/cgraph.scm 120 */
									long BgL_objzd2classzd2numz00_2149;

									BgL_objzd2classzd2numz00_2149 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2148);
									{	/* Effect/cgraph.scm 120 */
										obj_t BgL_arg2551z00_2150;

										BgL_arg2551z00_2150 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 120 */
											obj_t BgL_arrayz00_2152;

											int BgL_offsetz00_2153;

											BgL_arrayz00_2152 = BgL_arg2551z00_2150;
											BgL_offsetz00_2153 =
												(int) (BgL_objzd2classzd2numz00_2149);
											{	/* Effect/cgraph.scm 120 */
												long BgL_offsetz00_2154;

												BgL_offsetz00_2154 =
													((long) (BgL_offsetz00_2153) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 120 */
													long BgL_modz00_2155;

													{	/* Effect/cgraph.scm 120 */
														int BgL_arg2553z00_2156;

														BgL_arg2553z00_2156 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 120 */
															long BgL_auxz00_3919;

															BgL_auxz00_3919 = (long) (BgL_arg2553z00_2156);
															BgL_modz00_2155 =
																(BgL_offsetz00_2154 / BgL_auxz00_3919);
													}}
													{	/* Effect/cgraph.scm 120 */
														long BgL_restz00_2157;

														{	/* Effect/cgraph.scm 120 */
															int BgL_arg2552z00_2158;

															BgL_arg2552z00_2158 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 120 */
																long BgL_auxz00_3923;

																BgL_auxz00_3923 = (long) (BgL_arg2552z00_2158);
																BgL_restz00_2157 =
																	(BgL_offsetz00_2154 % BgL_auxz00_3923);
														}}
														{	/* Effect/cgraph.scm 120 */

															BgL_method3337z00_2147 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2152,
																	(int) (BgL_modz00_2155)),
																(int) (BgL_restz00_2157));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2147) (BgL_method3337z00_2147,
								(obj_t) (BgL_arg3510z00_1355),
								(obj_t) (BgL_ownerz00_2146), BEOA);
				}}}
				{	/* Effect/cgraph.scm 121 */
					BgL_nodez00_bglt BgL_arg3511z00_1356;

					BgL_arg3511z00_1356 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1349))->BgL_objz00);
					{	/* Effect/cgraph.scm 121 */
						BgL_variablez00_bglt BgL_ownerz00_2174;

						BgL_ownerz00_2174 = (BgL_variablez00_bglt) (BgL_ownerz00_1350);
						{	/* Effect/cgraph.scm 121 */
							obj_t BgL_method3337z00_2175;

							{	/* Effect/cgraph.scm 121 */
								BgL_objectz00_bglt BgL_objz00_2176;

								BgL_objz00_2176 = (BgL_objectz00_bglt) (BgL_arg3511z00_1356);
								{	/* Effect/cgraph.scm 121 */
									long BgL_objzd2classzd2numz00_2177;

									BgL_objzd2classzd2numz00_2177 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2176);
									{	/* Effect/cgraph.scm 121 */
										obj_t BgL_arg2551z00_2178;

										BgL_arg2551z00_2178 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 121 */
											obj_t BgL_arrayz00_2180;

											int BgL_offsetz00_2181;

											BgL_arrayz00_2180 = BgL_arg2551z00_2178;
											BgL_offsetz00_2181 =
												(int) (BgL_objzd2classzd2numz00_2177);
											{	/* Effect/cgraph.scm 121 */
												long BgL_offsetz00_2182;

												BgL_offsetz00_2182 =
													((long) (BgL_offsetz00_2181) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 121 */
													long BgL_modz00_2183;

													{	/* Effect/cgraph.scm 121 */
														int BgL_arg2553z00_2184;

														BgL_arg2553z00_2184 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 121 */
															long BgL_auxz00_3944;

															BgL_auxz00_3944 = (long) (BgL_arg2553z00_2184);
															BgL_modz00_2183 =
																(BgL_offsetz00_2182 / BgL_auxz00_3944);
													}}
													{	/* Effect/cgraph.scm 121 */
														long BgL_restz00_2185;

														{	/* Effect/cgraph.scm 121 */
															int BgL_arg2552z00_2186;

															BgL_arg2552z00_2186 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 121 */
																long BgL_auxz00_3948;

																BgL_auxz00_3948 = (long) (BgL_arg2552z00_2186);
																BgL_restz00_2185 =
																	(BgL_offsetz00_2182 % BgL_auxz00_3948);
														}}
														{	/* Effect/cgraph.scm 121 */

															BgL_method3337z00_2175 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2180,
																	(int) (BgL_modz00_2183)),
																(int) (BgL_restz00_2185));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2175) (BgL_method3337z00_2175,
								(obj_t) (BgL_arg3511z00_1356),
								(obj_t) (BgL_ownerz00_2174), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-conditio3353 */
	obj_t BGl_callzd2graphz12zd2conditio3353z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2846, obj_t BgL_nodez00_2847, obj_t BgL_ownerz00_2848)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 107 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1339;

				obj_t BgL_ownerz00_1340;

				BgL_nodez00_1339 = (BgL_conditionalz00_bglt) (BgL_nodez00_2847);
				BgL_ownerz00_1340 = BgL_ownerz00_2848;
				{	/* Effect/cgraph.scm 109 */
					BgL_nodez00_bglt BgL_arg3505z00_1344;

					BgL_arg3505z00_1344 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1339))->BgL_testz00);
					{	/* Effect/cgraph.scm 109 */
						BgL_variablez00_bglt BgL_ownerz00_2034;

						BgL_ownerz00_2034 = (BgL_variablez00_bglt) (BgL_ownerz00_1340);
						{	/* Effect/cgraph.scm 109 */
							obj_t BgL_method3337z00_2035;

							{	/* Effect/cgraph.scm 109 */
								BgL_objectz00_bglt BgL_objz00_2036;

								BgL_objz00_2036 = (BgL_objectz00_bglt) (BgL_arg3505z00_1344);
								{	/* Effect/cgraph.scm 109 */
									long BgL_objzd2classzd2numz00_2037;

									BgL_objzd2classzd2numz00_2037 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2036);
									{	/* Effect/cgraph.scm 109 */
										obj_t BgL_arg2551z00_2038;

										BgL_arg2551z00_2038 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 109 */
											obj_t BgL_arrayz00_2040;

											int BgL_offsetz00_2041;

											BgL_arrayz00_2040 = BgL_arg2551z00_2038;
											BgL_offsetz00_2041 =
												(int) (BgL_objzd2classzd2numz00_2037);
											{	/* Effect/cgraph.scm 109 */
												long BgL_offsetz00_2042;

												BgL_offsetz00_2042 =
													((long) (BgL_offsetz00_2041) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 109 */
													long BgL_modz00_2043;

													{	/* Effect/cgraph.scm 109 */
														int BgL_arg2553z00_2044;

														BgL_arg2553z00_2044 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 109 */
															long BgL_auxz00_3970;

															BgL_auxz00_3970 = (long) (BgL_arg2553z00_2044);
															BgL_modz00_2043 =
																(BgL_offsetz00_2042 / BgL_auxz00_3970);
													}}
													{	/* Effect/cgraph.scm 109 */
														long BgL_restz00_2045;

														{	/* Effect/cgraph.scm 109 */
															int BgL_arg2552z00_2046;

															BgL_arg2552z00_2046 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 109 */
																long BgL_auxz00_3974;

																BgL_auxz00_3974 = (long) (BgL_arg2552z00_2046);
																BgL_restz00_2045 =
																	(BgL_offsetz00_2042 % BgL_auxz00_3974);
														}}
														{	/* Effect/cgraph.scm 109 */

															BgL_method3337z00_2035 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2040,
																	(int) (BgL_modz00_2043)),
																(int) (BgL_restz00_2045));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2035) (BgL_method3337z00_2035,
								(obj_t) (BgL_arg3505z00_1344),
								(obj_t) (BgL_ownerz00_2034), BEOA);
				}}}
				{	/* Effect/cgraph.scm 110 */
					BgL_nodez00_bglt BgL_arg3506z00_1345;

					BgL_arg3506z00_1345 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1339))->BgL_truez00);
					{	/* Effect/cgraph.scm 110 */
						BgL_variablez00_bglt BgL_ownerz00_2062;

						BgL_ownerz00_2062 = (BgL_variablez00_bglt) (BgL_ownerz00_1340);
						{	/* Effect/cgraph.scm 110 */
							obj_t BgL_method3337z00_2063;

							{	/* Effect/cgraph.scm 110 */
								BgL_objectz00_bglt BgL_objz00_2064;

								BgL_objz00_2064 = (BgL_objectz00_bglt) (BgL_arg3506z00_1345);
								{	/* Effect/cgraph.scm 110 */
									long BgL_objzd2classzd2numz00_2065;

									BgL_objzd2classzd2numz00_2065 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2064);
									{	/* Effect/cgraph.scm 110 */
										obj_t BgL_arg2551z00_2066;

										BgL_arg2551z00_2066 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 110 */
											obj_t BgL_arrayz00_2068;

											int BgL_offsetz00_2069;

											BgL_arrayz00_2068 = BgL_arg2551z00_2066;
											BgL_offsetz00_2069 =
												(int) (BgL_objzd2classzd2numz00_2065);
											{	/* Effect/cgraph.scm 110 */
												long BgL_offsetz00_2070;

												BgL_offsetz00_2070 =
													((long) (BgL_offsetz00_2069) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 110 */
													long BgL_modz00_2071;

													{	/* Effect/cgraph.scm 110 */
														int BgL_arg2553z00_2072;

														BgL_arg2553z00_2072 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 110 */
															long BgL_auxz00_3995;

															BgL_auxz00_3995 = (long) (BgL_arg2553z00_2072);
															BgL_modz00_2071 =
																(BgL_offsetz00_2070 / BgL_auxz00_3995);
													}}
													{	/* Effect/cgraph.scm 110 */
														long BgL_restz00_2073;

														{	/* Effect/cgraph.scm 110 */
															int BgL_arg2552z00_2074;

															BgL_arg2552z00_2074 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 110 */
																long BgL_auxz00_3999;

																BgL_auxz00_3999 = (long) (BgL_arg2552z00_2074);
																BgL_restz00_2073 =
																	(BgL_offsetz00_2070 % BgL_auxz00_3999);
														}}
														{	/* Effect/cgraph.scm 110 */

															BgL_method3337z00_2063 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2068,
																	(int) (BgL_modz00_2071)),
																(int) (BgL_restz00_2073));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_2063) (BgL_method3337z00_2063,
								(obj_t) (BgL_arg3506z00_1345),
								(obj_t) (BgL_ownerz00_2062), BEOA);
				}}}
				{	/* Effect/cgraph.scm 111 */
					BgL_nodez00_bglt BgL_arg3507z00_1346;

					BgL_arg3507z00_1346 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1339))->BgL_falsez00);
					{	/* Effect/cgraph.scm 111 */
						BgL_variablez00_bglt BgL_ownerz00_2090;

						BgL_ownerz00_2090 = (BgL_variablez00_bglt) (BgL_ownerz00_1340);
						{	/* Effect/cgraph.scm 111 */
							obj_t BgL_method3337z00_2091;

							{	/* Effect/cgraph.scm 111 */
								BgL_objectz00_bglt BgL_objz00_2092;

								BgL_objz00_2092 = (BgL_objectz00_bglt) (BgL_arg3507z00_1346);
								{	/* Effect/cgraph.scm 111 */
									long BgL_objzd2classzd2numz00_2093;

									BgL_objzd2classzd2numz00_2093 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2092);
									{	/* Effect/cgraph.scm 111 */
										obj_t BgL_arg2551z00_2094;

										BgL_arg2551z00_2094 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 111 */
											obj_t BgL_arrayz00_2096;

											int BgL_offsetz00_2097;

											BgL_arrayz00_2096 = BgL_arg2551z00_2094;
											BgL_offsetz00_2097 =
												(int) (BgL_objzd2classzd2numz00_2093);
											{	/* Effect/cgraph.scm 111 */
												long BgL_offsetz00_2098;

												BgL_offsetz00_2098 =
													((long) (BgL_offsetz00_2097) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 111 */
													long BgL_modz00_2099;

													{	/* Effect/cgraph.scm 111 */
														int BgL_arg2553z00_2100;

														BgL_arg2553z00_2100 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 111 */
															long BgL_auxz00_4020;

															BgL_auxz00_4020 = (long) (BgL_arg2553z00_2100);
															BgL_modz00_2099 =
																(BgL_offsetz00_2098 / BgL_auxz00_4020);
													}}
													{	/* Effect/cgraph.scm 111 */
														long BgL_restz00_2101;

														{	/* Effect/cgraph.scm 111 */
															int BgL_arg2552z00_2102;

															BgL_arg2552z00_2102 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 111 */
																long BgL_auxz00_4024;

																BgL_auxz00_4024 = (long) (BgL_arg2552z00_2102);
																BgL_restz00_2101 =
																	(BgL_offsetz00_2098 % BgL_auxz00_4024);
														}}
														{	/* Effect/cgraph.scm 111 */

															BgL_method3337z00_2091 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2096,
																	(int) (BgL_modz00_2099)),
																(int) (BgL_restz00_2101));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2091) (BgL_method3337z00_2091,
								(obj_t) (BgL_arg3507z00_1346),
								(obj_t) (BgL_ownerz00_2090), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-setq3351 */
	obj_t BGl_callzd2graphz12zd2setq3351z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2849, obj_t BgL_nodez00_2850, obj_t BgL_ownerz00_2851)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 97 */
			{
				BgL_setqz00_bglt BgL_nodez00_1326;

				obj_t BgL_ownerz00_1327;

				BgL_nodez00_1326 = (BgL_setqz00_bglt) (BgL_nodez00_2850);
				BgL_ownerz00_1327 = BgL_ownerz00_2851;
				{	/* Effect/cgraph.scm 99 */
					bool_t BgL_testz00_4036;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_ownerz00_1327,
							BGl_localz00zzast_varz00))
						{	/* Effect/cgraph.scm 99 */
							BgL_testz00_4036 = ((bool_t) 1);
						}
					else
						{	/* Effect/cgraph.scm 99 */
							BgL_variablez00_bglt BgL_arg3500z00_1333;

							{	/* Effect/cgraph.scm 99 */
								BgL_varz00_bglt BgL_obj2061z00_1974;

								BgL_obj2061z00_1974 =
									(((BgL_setqz00_bglt) CREF(BgL_nodez00_1326))->BgL_varz00);
								BgL_arg3500z00_1333 =
									(((BgL_varz00_bglt) CREF(BgL_obj2061z00_1974))->
									BgL_variablez00);
							}
							{	/* Effect/cgraph.scm 99 */
								obj_t BgL_obj1658z00_1975;

								BgL_obj1658z00_1975 = (obj_t) (BgL_arg3500z00_1333);
								BgL_testz00_4036 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_1975,
									BGl_globalz00zzast_varz00);
							}
						}
					if (BgL_testz00_4036)
						{	/* Effect/cgraph.scm 99 */
							BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
								(BgL_variablez00_bglt) (BgL_ownerz00_1327));
						}
					else
						{	/* Effect/cgraph.scm 99 */
							BFALSE;
						}
				}
				{	/* Effect/cgraph.scm 101 */
					BgL_varz00_bglt BgL_arg3502z00_1335;

					BgL_arg3502z00_1335 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1326))->BgL_varz00);
					{	/* Effect/cgraph.scm 101 */
						BgL_nodez00_bglt BgL_nodez00_1977;

						BgL_variablez00_bglt BgL_ownerz00_1978;

						BgL_nodez00_1977 = (BgL_nodez00_bglt) (BgL_arg3502z00_1335);
						BgL_ownerz00_1978 = (BgL_variablez00_bglt) (BgL_ownerz00_1327);
						{	/* Effect/cgraph.scm 101 */
							obj_t BgL_method3337z00_1979;

							{	/* Effect/cgraph.scm 101 */
								BgL_objectz00_bglt BgL_objz00_1980;

								BgL_objz00_1980 = (BgL_objectz00_bglt) (BgL_nodez00_1977);
								{	/* Effect/cgraph.scm 101 */
									long BgL_objzd2classzd2numz00_1981;

									BgL_objzd2classzd2numz00_1981 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1980);
									{	/* Effect/cgraph.scm 101 */
										obj_t BgL_arg2551z00_1982;

										BgL_arg2551z00_1982 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 101 */
											obj_t BgL_arrayz00_1984;

											int BgL_offsetz00_1985;

											BgL_arrayz00_1984 = BgL_arg2551z00_1982;
											BgL_offsetz00_1985 =
												(int) (BgL_objzd2classzd2numz00_1981);
											{	/* Effect/cgraph.scm 101 */
												long BgL_offsetz00_1986;

												BgL_offsetz00_1986 =
													((long) (BgL_offsetz00_1985) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 101 */
													long BgL_modz00_1987;

													{	/* Effect/cgraph.scm 101 */
														int BgL_arg2553z00_1988;

														BgL_arg2553z00_1988 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 101 */
															long BgL_auxz00_4056;

															BgL_auxz00_4056 = (long) (BgL_arg2553z00_1988);
															BgL_modz00_1987 =
																(BgL_offsetz00_1986 / BgL_auxz00_4056);
													}}
													{	/* Effect/cgraph.scm 101 */
														long BgL_restz00_1989;

														{	/* Effect/cgraph.scm 101 */
															int BgL_arg2552z00_1990;

															BgL_arg2552z00_1990 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 101 */
																long BgL_auxz00_4060;

																BgL_auxz00_4060 = (long) (BgL_arg2552z00_1990);
																BgL_restz00_1989 =
																	(BgL_offsetz00_1986 % BgL_auxz00_4060);
														}}
														{	/* Effect/cgraph.scm 101 */

															BgL_method3337z00_1979 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1984,
																	(int) (BgL_modz00_1987)),
																(int) (BgL_restz00_1989));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_1979) (BgL_method3337z00_1979,
								(obj_t) (BgL_nodez00_1977), (obj_t) (BgL_ownerz00_1978), BEOA);
				}}}
				{	/* Effect/cgraph.scm 102 */
					BgL_nodez00_bglt BgL_arg3503z00_1336;

					BgL_arg3503z00_1336 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1326))->BgL_valuez00);
					{	/* Effect/cgraph.scm 102 */
						BgL_variablez00_bglt BgL_ownerz00_2006;

						BgL_ownerz00_2006 = (BgL_variablez00_bglt) (BgL_ownerz00_1327);
						{	/* Effect/cgraph.scm 102 */
							obj_t BgL_method3337z00_2007;

							{	/* Effect/cgraph.scm 102 */
								BgL_objectz00_bglt BgL_objz00_2008;

								BgL_objz00_2008 = (BgL_objectz00_bglt) (BgL_arg3503z00_1336);
								{	/* Effect/cgraph.scm 102 */
									long BgL_objzd2classzd2numz00_2009;

									BgL_objzd2classzd2numz00_2009 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2008);
									{	/* Effect/cgraph.scm 102 */
										obj_t BgL_arg2551z00_2010;

										BgL_arg2551z00_2010 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 102 */
											obj_t BgL_arrayz00_2012;

											int BgL_offsetz00_2013;

											BgL_arrayz00_2012 = BgL_arg2551z00_2010;
											BgL_offsetz00_2013 =
												(int) (BgL_objzd2classzd2numz00_2009);
											{	/* Effect/cgraph.scm 102 */
												long BgL_offsetz00_2014;

												BgL_offsetz00_2014 =
													((long) (BgL_offsetz00_2013) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 102 */
													long BgL_modz00_2015;

													{	/* Effect/cgraph.scm 102 */
														int BgL_arg2553z00_2016;

														BgL_arg2553z00_2016 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 102 */
															long BgL_auxz00_4081;

															BgL_auxz00_4081 = (long) (BgL_arg2553z00_2016);
															BgL_modz00_2015 =
																(BgL_offsetz00_2014 / BgL_auxz00_4081);
													}}
													{	/* Effect/cgraph.scm 102 */
														long BgL_restz00_2017;

														{	/* Effect/cgraph.scm 102 */
															int BgL_arg2552z00_2018;

															BgL_arg2552z00_2018 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 102 */
																long BgL_auxz00_4085;

																BgL_auxz00_4085 = (long) (BgL_arg2552z00_2018);
																BgL_restz00_2017 =
																	(BgL_offsetz00_2014 % BgL_auxz00_4085);
														}}
														{	/* Effect/cgraph.scm 102 */

															BgL_method3337z00_2007 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2012,
																	(int) (BgL_modz00_2015)),
																(int) (BgL_restz00_2017));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_2007) (BgL_method3337z00_2007,
								(obj_t) (BgL_arg3503z00_1336),
								(obj_t) (BgL_ownerz00_2006), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-cast3349 */
	obj_t BGl_callzd2graphz12zd2cast3349z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2852, obj_t BgL_nodez00_2853, obj_t BgL_ownerz00_2854)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 86 */
			{
				BgL_castz00_bglt BgL_nodez00_1318;

				obj_t BgL_ownerz00_1319;

				BgL_nodez00_1318 = (BgL_castz00_bglt) (BgL_nodez00_2853);
				BgL_ownerz00_1319 = BgL_ownerz00_2854;
				{	/* Effect/cgraph.scm 87 */
					BgL_nodez00_bglt BgL_arg3496z00_1943;

					BgL_arg3496z00_1943 =
						(((BgL_castz00_bglt) CREF(BgL_nodez00_1318))->BgL_argz00);
					{	/* Effect/cgraph.scm 87 */
						BgL_variablez00_bglt BgL_ownerz00_1946;

						BgL_ownerz00_1946 = (BgL_variablez00_bglt) (BgL_ownerz00_1319);
						{	/* Effect/cgraph.scm 87 */
							obj_t BgL_method3337z00_1947;

							{	/* Effect/cgraph.scm 87 */
								BgL_objectz00_bglt BgL_objz00_1948;

								BgL_objz00_1948 = (BgL_objectz00_bglt) (BgL_arg3496z00_1943);
								{	/* Effect/cgraph.scm 87 */
									long BgL_objzd2classzd2numz00_1949;

									BgL_objzd2classzd2numz00_1949 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1948);
									{	/* Effect/cgraph.scm 87 */
										obj_t BgL_arg2551z00_1950;

										BgL_arg2551z00_1950 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 87 */
											obj_t BgL_arrayz00_1952;

											int BgL_offsetz00_1953;

											BgL_arrayz00_1952 = BgL_arg2551z00_1950;
											BgL_offsetz00_1953 =
												(int) (BgL_objzd2classzd2numz00_1949);
											{	/* Effect/cgraph.scm 87 */
												long BgL_offsetz00_1954;

												BgL_offsetz00_1954 =
													((long) (BgL_offsetz00_1953) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 87 */
													long BgL_modz00_1955;

													{	/* Effect/cgraph.scm 87 */
														int BgL_arg2553z00_1956;

														BgL_arg2553z00_1956 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 87 */
															long BgL_auxz00_4107;

															BgL_auxz00_4107 = (long) (BgL_arg2553z00_1956);
															BgL_modz00_1955 =
																(BgL_offsetz00_1954 / BgL_auxz00_4107);
													}}
													{	/* Effect/cgraph.scm 87 */
														long BgL_restz00_1957;

														{	/* Effect/cgraph.scm 87 */
															int BgL_arg2552z00_1958;

															BgL_arg2552z00_1958 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 87 */
																long BgL_auxz00_4111;

																BgL_auxz00_4111 = (long) (BgL_arg2552z00_1958);
																BgL_restz00_1957 =
																	(BgL_offsetz00_1954 % BgL_auxz00_4111);
														}}
														{	/* Effect/cgraph.scm 87 */

															BgL_method3337z00_1947 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1952,
																	(int) (BgL_modz00_1955)),
																(int) (BgL_restz00_1957));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_1947) (BgL_method3337z00_1947,
								(obj_t) (BgL_arg3496z00_1943),
								(obj_t) (BgL_ownerz00_1946), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-extern3347 */
	obj_t BGl_callzd2graphz12zd2extern3347z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2855, obj_t BgL_nodez00_2856, obj_t BgL_ownerz00_2857)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 77 */
			{
				BgL_externz00_bglt BgL_nodez00_1309;

				obj_t BgL_ownerz00_1310;

				{	/* Effect/cgraph.scm 78 */
					bool_t BgL_auxz00_4123;

					BgL_nodez00_1309 = (BgL_externz00_bglt) (BgL_nodez00_2856);
					BgL_ownerz00_1310 = BgL_ownerz00_2857;
					{	/* Effect/cgraph.scm 79 */
						bool_t BgL_testz00_4124;

						{	/* Effect/cgraph.scm 79 */
							BgL_nodezf2effectzf2_bglt BgL_obj2015z00_1940;

							BgL_obj2015z00_1940 =
								(BgL_nodezf2effectzf2_bglt) (BgL_nodez00_1309);
							BgL_testz00_4124 =
								CBOOL(
								(((BgL_nodezf2effectzf2_bglt) CREF(BgL_obj2015z00_1940))->
									BgL_sidezd2effectzf3z21));
						}
						if (BgL_testz00_4124)
							{	/* Effect/cgraph.scm 79 */
								BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
									(BgL_variablez00_bglt) (BgL_ownerz00_1310));
							}
						else
							{	/* Effect/cgraph.scm 79 */
								BFALSE;
							}
					}
					{	/* Effect/cgraph.scm 81 */
						obj_t BgL_arg3494z00_1315;

						BgL_arg3494z00_1315 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1309))->BgL_exprza2za2);
						BgL_auxz00_4123 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3494z00_1315,
							BgL_ownerz00_1310);
					}
					return BBOOL(BgL_auxz00_4123);
				}
			}
		}
	}



/* call-graph!-funcall3345 */
	obj_t BGl_callzd2graphz12zd2funcall3345z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2858, obj_t BgL_nodez00_2859, obj_t BgL_ownerz00_2860)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 68 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1300;

				obj_t BgL_ownerz00_1301;

				{	/* Effect/cgraph.scm 69 */
					bool_t BgL_auxz00_4134;

					BgL_nodez00_1300 = (BgL_funcallz00_bglt) (BgL_nodez00_2859);
					BgL_ownerz00_1301 = BgL_ownerz00_2860;
					BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
						(BgL_variablez00_bglt) (BgL_ownerz00_1301));
					{	/* Effect/cgraph.scm 71 */
						BgL_nodez00_bglt BgL_arg3489z00_1305;

						BgL_arg3489z00_1305 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1300))->BgL_funz00);
						{	/* Effect/cgraph.scm 71 */
							BgL_variablez00_bglt BgL_ownerz00_1913;

							BgL_ownerz00_1913 = (BgL_variablez00_bglt) (BgL_ownerz00_1301);
							{	/* Effect/cgraph.scm 71 */
								obj_t BgL_method3337z00_1914;

								{	/* Effect/cgraph.scm 71 */
									BgL_objectz00_bglt BgL_objz00_1915;

									BgL_objz00_1915 = (BgL_objectz00_bglt) (BgL_arg3489z00_1305);
									{	/* Effect/cgraph.scm 71 */
										long BgL_objzd2classzd2numz00_1916;

										BgL_objzd2classzd2numz00_1916 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1915);
										{	/* Effect/cgraph.scm 71 */
											obj_t BgL_arg2551z00_1917;

											BgL_arg2551z00_1917 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 71 */
												obj_t BgL_arrayz00_1919;

												int BgL_offsetz00_1920;

												BgL_arrayz00_1919 = BgL_arg2551z00_1917;
												BgL_offsetz00_1920 =
													(int) (BgL_objzd2classzd2numz00_1916);
												{	/* Effect/cgraph.scm 71 */
													long BgL_offsetz00_1921;

													BgL_offsetz00_1921 =
														((long) (BgL_offsetz00_1920) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 71 */
														long BgL_modz00_1922;

														{	/* Effect/cgraph.scm 71 */
															int BgL_arg2553z00_1923;

															BgL_arg2553z00_1923 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 71 */
																long BgL_auxz00_4147;

																BgL_auxz00_4147 = (long) (BgL_arg2553z00_1923);
																BgL_modz00_1922 =
																	(BgL_offsetz00_1921 / BgL_auxz00_4147);
														}}
														{	/* Effect/cgraph.scm 71 */
															long BgL_restz00_1924;

															{	/* Effect/cgraph.scm 71 */
																int BgL_arg2552z00_1925;

																BgL_arg2552z00_1925 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 71 */
																	long BgL_auxz00_4151;

																	BgL_auxz00_4151 =
																		(long) (BgL_arg2552z00_1925);
																	BgL_restz00_1924 =
																		(BgL_offsetz00_1921 % BgL_auxz00_4151);
															}}
															{	/* Effect/cgraph.scm 71 */

																BgL_method3337z00_1914 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1919,
																		(int) (BgL_modz00_1922)),
																	(int) (BgL_restz00_1924));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3337z00_1914) (BgL_method3337z00_1914,
									(obj_t) (BgL_arg3489z00_1305),
									(obj_t) (BgL_ownerz00_1913), BEOA);
					}}}
					{	/* Effect/cgraph.scm 72 */
						obj_t BgL_arg3491z00_1306;

						BgL_arg3491z00_1306 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1300))->BgL_argsz00);
						BgL_auxz00_4134 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3491z00_1306,
							BgL_ownerz00_1301);
					}
					return BBOOL(BgL_auxz00_4134);
				}
			}
		}
	}



/* call-graph!-app-ly3343 */
	obj_t BGl_callzd2graphz12zd2appzd2ly3343zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2861, obj_t BgL_nodez00_2862, obj_t BgL_ownerz00_2863)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 59 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1291;

				obj_t BgL_ownerz00_1292;

				BgL_nodez00_1291 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2862);
				BgL_ownerz00_1292 = BgL_ownerz00_2863;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1292));
				{	/* Effect/cgraph.scm 62 */
					BgL_nodez00_bglt BgL_arg3486z00_1296;

					BgL_arg3486z00_1296 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1291))->BgL_funz00);
					{	/* Effect/cgraph.scm 62 */
						BgL_variablez00_bglt BgL_ownerz00_1857;

						BgL_ownerz00_1857 = (BgL_variablez00_bglt) (BgL_ownerz00_1292);
						{	/* Effect/cgraph.scm 62 */
							obj_t BgL_method3337z00_1858;

							{	/* Effect/cgraph.scm 62 */
								BgL_objectz00_bglt BgL_objz00_1859;

								BgL_objz00_1859 = (BgL_objectz00_bglt) (BgL_arg3486z00_1296);
								{	/* Effect/cgraph.scm 62 */
									long BgL_objzd2classzd2numz00_1860;

									BgL_objzd2classzd2numz00_1860 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1859);
									{	/* Effect/cgraph.scm 62 */
										obj_t BgL_arg2551z00_1861;

										BgL_arg2551z00_1861 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 62 */
											obj_t BgL_arrayz00_1863;

											int BgL_offsetz00_1864;

											BgL_arrayz00_1863 = BgL_arg2551z00_1861;
											BgL_offsetz00_1864 =
												(int) (BgL_objzd2classzd2numz00_1860);
											{	/* Effect/cgraph.scm 62 */
												long BgL_offsetz00_1865;

												BgL_offsetz00_1865 =
													((long) (BgL_offsetz00_1864) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 62 */
													long BgL_modz00_1866;

													{	/* Effect/cgraph.scm 62 */
														int BgL_arg2553z00_1867;

														BgL_arg2553z00_1867 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 62 */
															long BgL_auxz00_4178;

															BgL_auxz00_4178 = (long) (BgL_arg2553z00_1867);
															BgL_modz00_1866 =
																(BgL_offsetz00_1865 / BgL_auxz00_4178);
													}}
													{	/* Effect/cgraph.scm 62 */
														long BgL_restz00_1868;

														{	/* Effect/cgraph.scm 62 */
															int BgL_arg2552z00_1869;

															BgL_arg2552z00_1869 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 62 */
																long BgL_auxz00_4182;

																BgL_auxz00_4182 = (long) (BgL_arg2552z00_1869);
																BgL_restz00_1868 =
																	(BgL_offsetz00_1865 % BgL_auxz00_4182);
														}}
														{	/* Effect/cgraph.scm 62 */

															BgL_method3337z00_1858 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1863,
																	(int) (BgL_modz00_1866)),
																(int) (BgL_restz00_1868));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3337z00_1858) (BgL_method3337z00_1858,
								(obj_t) (BgL_arg3486z00_1296),
								(obj_t) (BgL_ownerz00_1857), BEOA);
				}}}
				{	/* Effect/cgraph.scm 63 */
					BgL_nodez00_bglt BgL_arg3487z00_1297;

					BgL_arg3487z00_1297 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1291))->BgL_argz00);
					{	/* Effect/cgraph.scm 63 */
						BgL_variablez00_bglt BgL_ownerz00_1885;

						BgL_ownerz00_1885 = (BgL_variablez00_bglt) (BgL_ownerz00_1292);
						{	/* Effect/cgraph.scm 63 */
							obj_t BgL_method3337z00_1886;

							{	/* Effect/cgraph.scm 63 */
								BgL_objectz00_bglt BgL_objz00_1887;

								BgL_objz00_1887 = (BgL_objectz00_bglt) (BgL_arg3487z00_1297);
								{	/* Effect/cgraph.scm 63 */
									long BgL_objzd2classzd2numz00_1888;

									BgL_objzd2classzd2numz00_1888 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1887);
									{	/* Effect/cgraph.scm 63 */
										obj_t BgL_arg2551z00_1889;

										BgL_arg2551z00_1889 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 63 */
											obj_t BgL_arrayz00_1891;

											int BgL_offsetz00_1892;

											BgL_arrayz00_1891 = BgL_arg2551z00_1889;
											BgL_offsetz00_1892 =
												(int) (BgL_objzd2classzd2numz00_1888);
											{	/* Effect/cgraph.scm 63 */
												long BgL_offsetz00_1893;

												BgL_offsetz00_1893 =
													((long) (BgL_offsetz00_1892) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 63 */
													long BgL_modz00_1894;

													{	/* Effect/cgraph.scm 63 */
														int BgL_arg2553z00_1895;

														BgL_arg2553z00_1895 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 63 */
															long BgL_auxz00_4203;

															BgL_auxz00_4203 = (long) (BgL_arg2553z00_1895);
															BgL_modz00_1894 =
																(BgL_offsetz00_1893 / BgL_auxz00_4203);
													}}
													{	/* Effect/cgraph.scm 63 */
														long BgL_restz00_1896;

														{	/* Effect/cgraph.scm 63 */
															int BgL_arg2552z00_1897;

															BgL_arg2552z00_1897 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 63 */
																long BgL_auxz00_4207;

																BgL_auxz00_4207 = (long) (BgL_arg2552z00_1897);
																BgL_restz00_1896 =
																	(BgL_offsetz00_1893 % BgL_auxz00_4207);
														}}
														{	/* Effect/cgraph.scm 63 */

															BgL_method3337z00_1886 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1891,
																	(int) (BgL_modz00_1894)),
																(int) (BgL_restz00_1896));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3337z00_1886) (BgL_method3337z00_1886,
								(obj_t) (BgL_arg3487z00_1297),
								(obj_t) (BgL_ownerz00_1885), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-app3341 */
	obj_t BGl_callzd2graphz12zd2app3341z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2864, obj_t BgL_nodez00_2865, obj_t BgL_ownerz00_2866)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 49 */
			{
				BgL_appz00_bglt BgL_nodez00_1281;

				obj_t BgL_ownerz00_1282;

				{	/* Effect/cgraph.scm 50 */
					bool_t BgL_auxz00_4219;

					BgL_nodez00_1281 = (BgL_appz00_bglt) (BgL_nodez00_2865);
					BgL_ownerz00_1282 = BgL_ownerz00_2866;
					{	/* Effect/cgraph.scm 53 */
						BgL_variablez00_bglt BgL_arg3482z00_1286;

						{	/* Effect/cgraph.scm 53 */
							BgL_varz00_bglt BgL_obj2061z00_1826;

							BgL_obj2061z00_1826 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1281))->BgL_funz00);
							BgL_arg3482z00_1286 =
								(((BgL_varz00_bglt) CREF(BgL_obj2061z00_1826))->
								BgL_variablez00);
						}
						{	/* Effect/cgraph.scm 53 */
							BgL_variablez00_bglt BgL_ownerz00_1828;

							BgL_ownerz00_1828 = (BgL_variablez00_bglt) (BgL_ownerz00_1282);
							{	/* Effect/cgraph.scm 53 */
								obj_t BgL_method3374z00_1829;

								{	/* Effect/cgraph.scm 53 */
									BgL_objectz00_bglt BgL_objz00_1830;

									BgL_objz00_1830 = (BgL_objectz00_bglt) (BgL_arg3482z00_1286);
									{	/* Effect/cgraph.scm 53 */
										long BgL_objzd2classzd2numz00_1831;

										BgL_objzd2classzd2numz00_1831 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1830);
										{	/* Effect/cgraph.scm 53 */
											obj_t BgL_arg2551z00_1832;

											BgL_arg2551z00_1832 =
												PROCEDURE_REF
												(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 53 */
												obj_t BgL_arrayz00_1834;

												int BgL_offsetz00_1835;

												BgL_arrayz00_1834 = BgL_arg2551z00_1832;
												BgL_offsetz00_1835 =
													(int) (BgL_objzd2classzd2numz00_1831);
												{	/* Effect/cgraph.scm 53 */
													long BgL_offsetz00_1836;

													BgL_offsetz00_1836 =
														((long) (BgL_offsetz00_1835) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 53 */
														long BgL_modz00_1837;

														{	/* Effect/cgraph.scm 53 */
															int BgL_arg2553z00_1838;

															BgL_arg2553z00_1838 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 53 */
																long BgL_auxz00_4231;

																BgL_auxz00_4231 = (long) (BgL_arg2553z00_1838);
																BgL_modz00_1837 =
																	(BgL_offsetz00_1836 / BgL_auxz00_4231);
														}}
														{	/* Effect/cgraph.scm 53 */
															long BgL_restz00_1839;

															{	/* Effect/cgraph.scm 53 */
																int BgL_arg2552z00_1840;

																BgL_arg2552z00_1840 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 53 */
																	long BgL_auxz00_4235;

																	BgL_auxz00_4235 =
																		(long) (BgL_arg2552z00_1840);
																	BgL_restz00_1839 =
																		(BgL_offsetz00_1836 % BgL_auxz00_4235);
															}}
															{	/* Effect/cgraph.scm 53 */

																BgL_method3374z00_1829 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1834,
																		(int) (BgL_modz00_1837)),
																	(int) (BgL_restz00_1839));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3374z00_1829) (BgL_method3374z00_1829,
									(obj_t) (BgL_arg3482z00_1286),
									(obj_t) (BgL_ownerz00_1828), BEOA);
					}}}
					{	/* Effect/cgraph.scm 54 */
						obj_t BgL_arg3484z00_1288;

						BgL_arg3484z00_1288 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1281))->BgL_argsz00);
						BgL_auxz00_4219 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3484z00_1288,
							BgL_ownerz00_1282);
					}
					return BBOOL(BgL_auxz00_4219);
				}
			}
		}
	}



/* call-graph!-sequence3339 */
	obj_t BGl_callzd2graphz12zd2sequence3339z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2867, obj_t BgL_nodez00_2868, obj_t BgL_ownerz00_2869)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 43 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1274;

				obj_t BgL_ownerz00_1275;

				{	/* Effect/cgraph.scm 44 */
					bool_t BgL_auxz00_4250;

					BgL_nodez00_1274 = (BgL_sequencez00_bglt) (BgL_nodez00_2868);
					BgL_ownerz00_1275 = BgL_ownerz00_2869;
					{	/* Effect/cgraph.scm 44 */
						obj_t BgL_arg3480z00_1823;

						BgL_arg3480z00_1823 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1274))->BgL_nodesz00);
						BgL_auxz00_4250 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3480z00_1823,
							BgL_ownerz00_1275);
					}
					return BBOOL(BgL_auxz00_4250);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3703z00zzeffect_cgraphz00));
		}
	}

#ifdef __cplusplus
}
#endif
