/*===========================================================================*/
/*   (Inline/inline.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Inline/inline.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2atom3260z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2letzd2fun3288zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_makezd2isfunzd2zzinline_inlinez00(long, obj_t, obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, BgL_nodez00_bglt, obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00();
	static obj_t BGl_inlinezd2nodezd2letzd2var3290zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_nodezd2nilzd2zzast_nodez00();
	static obj_t BGl__inlinezd2sfunz12zc0zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzinline_inlinez00();
	BGL_EXPORTED_DECL BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzinline_inlinez00();
	BGL_IMPORT long bgl_list_length(obj_t);
	BGL_EXPORTED_DECL bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t);
	static obj_t BGl_inlinezd2nodezd2cast3278z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl__inlinezd2nodezd2default3257z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_alphatiza7eza7zzast_alphatiza7eza7(obj_t, obj_t,
		obj_t, BgL_nodez00_bglt);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2setzd2exzd2i3292z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__makezd2isfunzd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2sequence3268z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2setq3280z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_objectzd2ze3structzd2isfun3302ze3zzinline_inlinez00(obj_t,
		obj_t);
	extern BgL_sfunz00_bglt BGl_makezd2sfunzd2zzast_varz00(long, obj_t, obj_t,
		obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3257z00zzinline_inlinez00(BgL_nodez00_bglt, long,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2boxzd2setz123300zc0zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2extern3276z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt, long, obj_t);
	static obj_t BGl_inlinezd2nodezd2appzd2ly3272zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzinline_inlinez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2conditio3282z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	static obj_t BGl_inlinezd2nodezd2app3270z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00;
	static obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_inlinezd2nodezd2funcall3274z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzinline_inlinez00();
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt,
		BgL_nodez00_bglt, obj_t);
	static obj_t BGl__wideningzd2isfunzd2zzinline_inlinez00(obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2jumpzd2exzd23294z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__inlinezd2nodezd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2fail3284z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt, long,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2makezd2box3296zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl__fillzd2isfunz12zc0zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2select3286z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	extern BgL_nodez00_bglt BGl_inlinezd2appzd2zzinline_appz00(BgL_appz00_bglt,
		long, obj_t);
	static obj_t BGl_inlinezd2nodezd2boxzd2ref3298zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2var3262z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_inlinezd2nodezd2kwote3265z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2kfactorza2z00zzinline_walkz00;
	extern bool_t BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_bglt,
		long, long, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_isfunz00zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_structzb2objectzd2ze3objec3304z83zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzinline_inlinez00();
	static obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
	static obj_t __cnst[5];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__isfunza7f3za7f3za7za7in3617z00, BGl__isfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_sfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__sfunza7f3za7f3za7za7inl3618z00, BGl__sfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7d3619z00,
		BGl__inlinezd2nodezd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_inlinezd2nodeza2z12zd2envzb0zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7a3620z00,
		BGl__inlinezd2nodeza2z12z62zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_inlinezd2sfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__inlineza7d2sfunza713621z00,
		BGl__inlinezd2sfunz12zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_wideningzd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__wideningza7d2isfu3622za7,
		BGl__wideningzd2isfunzd2zzinline_inlinez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
		BgL_bgl__za752allocateza7d2i3623z00,
		BGl__z52allocatezd2isfunz80zzinline_inlinez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
		BgL_bgl__isfunza7d2nilza7d2za73624za7,
		BGl__isfunzd2nilzd2zzinline_inlinez00, 0L, BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_inlinezd2nodezd2default3257zd2envzd2zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7d3625z00,
		BGl__inlinezd2nodezd2default3257z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_fillzd2isfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__fillza7d2isfunza7123626z00,
		BGl__fillzd2isfunz12zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_makezd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__makeza7d2isfunza7d23627z00, BGl__makezd2isfunzd2zzinline_inlinez00,
		0L, BUNSPEC, 19);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3600z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23628z00,
		BGl_inlinezd2nodezd2fail3284z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3590z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23629z00,
		BGl_inlinezd2nodezd2var3262z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3589z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23630z00,
		BGl_inlinezd2nodezd2atom3260z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3601z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23631z00,
		BGl_inlinezd2nodezd2select3286z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3591z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23632z00,
		BGl_inlinezd2nodezd2kwote3265z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3602z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23633z00,
		BGl_inlinezd2nodezd2letzd2fun3288zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3592z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23634z00,
		BGl_inlinezd2nodezd2sequence3268z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3603z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23635z00,
		BGl_inlinezd2nodezd2letzd2var3290zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3593z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23636z00,
		BGl_inlinezd2nodezd2app3270z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3604z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23637z00,
		BGl_inlinezd2nodezd2setzd2exzd2i3292z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3594z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23638z00,
		BGl_inlinezd2nodezd2appzd2ly3272zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3605z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23639z00,
		BGl_inlinezd2nodezd2jumpzd2exzd23294z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3595z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23640z00,
		BGl_inlinezd2nodezd2funcall3274z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3606z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23641z00,
		BGl_inlinezd2nodezd2makezd2box3296zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3596z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23642z00,
		BGl_inlinezd2nodezd2extern3276z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3607z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23643z00,
		BGl_inlinezd2nodezd2boxzd2ref3298zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3597z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23644z00,
		BGl_inlinezd2nodezd2cast3278z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3608z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23645z00,
		BGl_inlinezd2nodezd2boxzd2setz123300zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3598z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23646z00,
		BGl_inlinezd2nodezd2setq3280z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3610z00zzinline_inlinez00,
		BgL_bgl_structza7b2objectza73647z00,
		BGl_structzb2objectzd2ze3objec3304z83zzinline_inlinez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3609z00zzinline_inlinez00,
		BgL_bgl_objectza7d2za7e3stru3648z00,
		BGl_objectzd2ze3structzd2isfun3302ze3zzinline_inlinez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3599z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23649z00,
		BGl_inlinezd2nodezd2conditio3282z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;
	   
		 
		DEFINE_STRING(BGl_string3588z00zzinline_inlinez00,
		BgL_bgl_string3588za700za7za7i3650za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3611z00zzinline_inlinez00,
		BgL_bgl_string3611za700za7za7i3651za7, "inline_inline", 13);
	      DEFINE_STRING(BGl_string3612z00zzinline_inlinez00,
		BgL_bgl_string3612za700za7za7i3652za7,
		"read static inline-node-default3257 isfun done ", 47);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long
		BgL_checksumz00_2740, char *BgL_fromz00_2741)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzinline_inlinez00))
				{
					BGl_requirezd2initializa7ationz75zzinline_inlinez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
					BGl_cnstzd2initzd2zzinline_inlinez00();
					BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
					BGl_objectzd2initzd2zzinline_inlinez00();
					BGl_genericzd2initzd2zzinline_inlinez00();
					BGl_methodzd2initzd2zzinline_inlinez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "inline_inline");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"inline_inline");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 15 */
				obj_t BgL_cportz00_2711;

				BgL_cportz00_2711 =
					bgl_open_input_string(BGl_string3612z00zzinline_inlinez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2712;

					BgL_iz00_2712 = ((long) 4);
				BgL_loopz00_2713:
					if ((BgL_iz00_2712 == ((long) -1)))
						{	/* Inline/inline.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Inline/inline.scm 15 */
							{	/* Inline/inline.scm 15 */
								obj_t BgL_arg3614z00_2715;

								{	/* Inline/inline.scm 15 */

									{	/* Inline/inline.scm 15 */
										obj_t BgL_locationz00_2717;

										BgL_locationz00_2717 = BBOOL(((bool_t) 0));
										{	/* Inline/inline.scm 15 */

											BgL_arg3614z00_2715 =
												BGl_readz00zz__readerz00(BgL_cportz00_2711,
												BgL_locationz00_2717);
										}
									}
								}
								{	/* Inline/inline.scm 15 */
									int BgL_auxz00_2761;

									BgL_auxz00_2761 = (int) (BgL_iz00_2712);
									CNST_TABLE_SET(BgL_auxz00_2761, BgL_arg3614z00_2715);
							}}
							{	/* Inline/inline.scm 15 */
								int BgL_auxz00_2718;

								BgL_auxz00_2718 = (int) ((BgL_iz00_2712 - ((long) 1)));
								{
									long BgL_iz00_2766;

									BgL_iz00_2766 = (long) (BgL_auxz00_2718);
									BgL_iz00_2712 = BgL_iz00_2766;
									goto BgL_loopz00_2713;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return BUNSPEC;
		}
	}



/* inline-sfun! */
	BGL_EXPORTED_DEF obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt
		BgL_variablez00_1, long BgL_kfactorz00_2, obj_t BgL_stackz00_3)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			{	/* Inline/inline.scm 37 */
				BgL_valuez00_bglt BgL_sfunz00_845;

				BgL_sfunz00_845 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00);
				{	/* Inline/inline.scm 37 */
					obj_t BgL_isfunz00_846;

					if (BGl_iszd2azf3z21zz__objectz00
						(BGl_sfunzf3zd2envz21zzinline_inlinez00,
							BGl_isfunz00zzinline_inlinez00))
						{	/* Inline/inline.scm 38 */
							BgL_isfunz00_846 = (obj_t) (BgL_sfunz00_845);
						}
					else
						{	/* Inline/inline.scm 40 */
							BgL_sfunz00_bglt BgL_obj3234z00_858;

							BgL_obj3234z00_858 =
								((BgL_sfunz00_bglt) (BgL_sfunz00_bglt) (BgL_sfunz00_845));
							{	/* Inline/inline.scm 40 */
								BgL_isfunz00_bglt BgL_arg3316z00_859;

								{	/* Inline/inline.scm 40 */
									obj_t BgL_arg3317z00_860;

									{
										BgL_sfunz00_bglt BgL_auxz00_2774;

										BgL_auxz00_2774 = (BgL_sfunz00_bglt) (BgL_sfunz00_845);
										BgL_arg3317z00_860 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2774))->BgL_bodyz00);
									}
									{	/* Inline/inline.scm 40 */
										BgL_isfunz00_bglt BgL_res3497z00_1532;

										{	/* Inline/inline.scm 40 */
											BgL_nodez00_bglt BgL_originalzd2body3143zd2_1523;

											BgL_originalzd2body3143zd2_1523 =
												(BgL_nodez00_bglt) (BgL_arg3317z00_860);
											{	/* Inline/inline.scm 40 */
												BgL_isfunz00_bglt BgL_new3145z00_1525;

												BgL_new3145z00_1525 =
													((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																BgL_isfunz00_bgl))));
												{	/* Inline/inline.scm 40 */
													BgL_isfunz00_bglt BgL_res3496z00_1531;

													{	/* Inline/inline.scm 40 */
														BgL_isfunz00_bglt BgL_new3170z00_1526;

														BgL_new3170z00_1526 = BgL_new3145z00_1525;
														{	/* Inline/inline.scm 40 */
															BgL_nodez00_bglt BgL_originalzd2body3168zd2_1529;

															obj_t BgL_recursivezd2calls3169zd2_1530;

															BgL_originalzd2body3168zd2_1529 =
																BgL_originalzd2body3143zd2_1523;
															BgL_recursivezd2calls3169zd2_1530 = BUNSPEC;
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3170z00_1526))->
																	BgL_originalzd2bodyzd2) =
																((BgL_nodez00_bglt)
																	BgL_originalzd2body3168zd2_1529), BUNSPEC);
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3170z00_1526))->
																	BgL_recursivezd2callszd2) =
																((obj_t) BgL_recursivezd2calls3169zd2_1530),
																BUNSPEC);
															BgL_res3496z00_1531 = BgL_new3170z00_1526;
													}} BgL_res3496z00_1531;
												}
												BgL_res3497z00_1532 = BgL_new3145z00_1525;
										}}
										BgL_arg3316z00_859 = BgL_res3497z00_1532;
								}}
								{	/* Inline/inline.scm 40 */
									obj_t BgL_auxz00_2783;

									BgL_objectz00_bglt BgL_auxz00_2781;

									BgL_auxz00_2783 = (obj_t) (BgL_arg3316z00_859);
									BgL_auxz00_2781 = (BgL_objectz00_bglt) (BgL_obj3234z00_858);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_2781, BgL_auxz00_2783);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_obj3234z00_858),
								BGl_classzd2numzd2zz__objectz00
								(BGl_isfunz00zzinline_inlinez00));
							BgL_isfunz00_846 = (obj_t) (BgL_obj3234z00_858);
						}
					{	/* Inline/inline.scm 38 */
						BgL_nodez00_bglt BgL_ozd2bodyzd2_847;

						{	/* Inline/inline.scm 41 */
							BgL_isfunz00_bglt BgL_obj3182z00_1535;

							BgL_obj3182z00_1535 = (BgL_isfunz00_bglt) (BgL_isfunz00_846);
							{
								obj_t BgL_auxz00_2791;

								{	/* Inline/inline.scm 41 */
									BgL_objectz00_bglt BgL_auxz00_2792;

									BgL_auxz00_2792 = (BgL_objectz00_bglt) (BgL_obj3182z00_1535);
									BgL_auxz00_2791 = BGL_OBJECT_WIDENING(BgL_auxz00_2792);
								}
								BgL_ozd2bodyzd2_847 =
									(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2791))->
									BgL_originalzd2bodyzd2);
						}}
						{	/* Inline/inline.scm 41 */
							BgL_nodez00_bglt BgL_inlzd2bodyzd2_848;

							{	/* Inline/inline.scm 42 */
								bool_t BgL_testz00_2796;

								{	/* Inline/inline.scm 44 */
									long BgL_arg3308z00_852;

									{	/* Inline/inline.scm 44 */
										long BgL_auxz00_2797;

										{	/* Inline/inline.scm 44 */
											obj_t BgL_auxz00_2798;

											{
												BgL_sfunz00_bglt BgL_auxz00_2799;

												BgL_auxz00_2799 = (BgL_sfunz00_bglt) (BgL_sfunz00_845);
												BgL_auxz00_2798 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2799))->
													BgL_argsz00);
											}
											BgL_auxz00_2797 = bgl_list_length(BgL_auxz00_2798);
										}
										BgL_arg3308z00_852 = (((long) 1) + BgL_auxz00_2797);
									}
									BgL_testz00_2796 =
										BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_1,
										(long) CINT(BGl_za2kfactorza2z00zzinline_walkz00),
										BgL_arg3308z00_852, BNIL);
								}
								if (BgL_testz00_2796)
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_848 =
											BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL, BFALSE,
											BgL_ozd2bodyzd2_847);
									}
								else
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_848 = BgL_ozd2bodyzd2_847;
									}
							}
							{	/* Inline/inline.scm 42 */

								{	/* Inline/inline.scm 55 */
									BgL_nodez00_bglt BgL_arg3305z00_849;

									{	/* Inline/inline.scm 55 */
										obj_t BgL_arg3306z00_850;

										BgL_arg3306z00_850 =
											MAKE_PAIR((obj_t) (BgL_variablez00_1), BgL_stackz00_3);
										{	/* Inline/inline.scm 53 */
											BgL_nodez00_bglt BgL_res3500z00_1567;

											{	/* Inline/inline.scm 53 */
												obj_t BgL_method3258z00_1542;

												{	/* Inline/inline.scm 53 */
													BgL_objectz00_bglt BgL_objz00_1543;

													BgL_objz00_1543 =
														(BgL_objectz00_bglt) (BgL_inlzd2bodyzd2_848);
													{	/* Inline/inline.scm 53 */
														long BgL_objzd2classzd2numz00_1544;

														BgL_objzd2classzd2numz00_1544 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1543);
														{	/* Inline/inline.scm 53 */
															obj_t BgL_arg2551z00_1545;

															BgL_arg2551z00_1545 =
																PROCEDURE_REF
																(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																(int) (((long) 1)));
															{	/* Inline/inline.scm 53 */
																obj_t BgL_arrayz00_1547;

																int BgL_offsetz00_1548;

																BgL_arrayz00_1547 = BgL_arg2551z00_1545;
																BgL_offsetz00_1548 =
																	(int) (BgL_objzd2classzd2numz00_1544);
																{	/* Inline/inline.scm 53 */
																	long BgL_offsetz00_1549;

																	BgL_offsetz00_1549 =
																		((long) (BgL_offsetz00_1548) - OBJECT_TYPE);
																	{	/* Inline/inline.scm 53 */
																		long BgL_modz00_1550;

																		{	/* Inline/inline.scm 53 */
																			int BgL_arg2553z00_1551;

																			BgL_arg2553z00_1551 = (int) (((long) 8));
																			{	/* Inline/inline.scm 53 */
																				long BgL_auxz00_2817;

																				BgL_auxz00_2817 =
																					(long) (BgL_arg2553z00_1551);
																				BgL_modz00_1550 =
																					(BgL_offsetz00_1549 /
																					BgL_auxz00_2817);
																		}}
																		{	/* Inline/inline.scm 53 */
																			long BgL_restz00_1552;

																			{	/* Inline/inline.scm 53 */
																				int BgL_arg2552z00_1553;

																				BgL_arg2552z00_1553 =
																					(int) (((long) 8));
																				{	/* Inline/inline.scm 53 */
																					long BgL_auxz00_2821;

																					BgL_auxz00_2821 =
																						(long) (BgL_arg2552z00_1553);
																					BgL_restz00_1552 =
																						(BgL_offsetz00_1549 %
																						BgL_auxz00_2821);
																			}}
																			{	/* Inline/inline.scm 53 */

																				BgL_method3258z00_1542 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1547,
																						(int) (BgL_modz00_1550)),
																					(int) (BgL_restz00_1552));
												}}}}}}}}
												BgL_res3500z00_1567 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3258z00_1542) (BgL_method3258z00_1542,
														(obj_t) (BgL_inlzd2bodyzd2_848),
														BINT(BgL_kfactorz00_2), BgL_arg3306z00_850, BEOA));
											}
											BgL_arg3305z00_849 = BgL_res3500z00_1567;
									}}
									{
										obj_t BgL_auxz00_2835;

										BgL_sfunz00_bglt BgL_auxz00_2833;

										BgL_auxz00_2835 = (obj_t) (BgL_arg3305z00_849);
										BgL_auxz00_2833 = (BgL_sfunz00_bglt) (BgL_sfunz00_845);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2833))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_2835), BUNSPEC);
								}}
								return BNIL;
							}
						}
					}
				}
			}
		}
	}



/* _inline-sfun! */
	obj_t BGl__inlinezd2sfunz12zc0zzinline_inlinez00(obj_t BgL_envz00_2550,
		obj_t BgL_variablez00_2551, obj_t BgL_kfactorz00_2552,
		obj_t BgL_stackz00_2553)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			return
				BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
				(BgL_variablez00_bglt) (BgL_variablez00_2551),
				(long) CINT(BgL_kfactorz00_2552), BgL_stackz00_2553);
		}
	}



/* inline-node*! */
	BGL_EXPORTED_DEF obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t
		BgL_nodeza2za2_70, obj_t BgL_kfactorz00_71, obj_t BgL_stackz00_72)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
		BGl_inlinezd2nodeza2z12z62zzinline_inlinez00:
			if (NULLP(BgL_nodeza2za2_70))
				{	/* Inline/inline.scm 239 */
					return CNST_TABLE_REF(((long) 0));
				}
			else
				{	/* Inline/inline.scm 239 */
					{	/* Inline/inline.scm 242 */
						BgL_nodez00_bglt BgL_arg3320z00_863;

						{	/* Inline/inline.scm 242 */
							obj_t BgL_arg3321z00_864;

							BgL_arg3321z00_864 = CAR(BgL_nodeza2za2_70);
							{	/* Inline/inline.scm 242 */
								BgL_nodez00_bglt BgL_res3503z00_1600;

								{	/* Inline/inline.scm 242 */
									BgL_nodez00_bglt BgL_nodez00_1572;

									long BgL_kfactorz00_1573;

									BgL_nodez00_1572 = (BgL_nodez00_bglt) (BgL_arg3321z00_864);
									BgL_kfactorz00_1573 = (long) CINT(BgL_kfactorz00_71);
									{	/* Inline/inline.scm 242 */
										obj_t BgL_method3258z00_1575;

										{	/* Inline/inline.scm 242 */
											BgL_objectz00_bglt BgL_objz00_1576;

											BgL_objz00_1576 = (BgL_objectz00_bglt) (BgL_nodez00_1572);
											{	/* Inline/inline.scm 242 */
												long BgL_objzd2classzd2numz00_1577;

												BgL_objzd2classzd2numz00_1577 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1576);
												{	/* Inline/inline.scm 242 */
													obj_t BgL_arg2551z00_1578;

													BgL_arg2551z00_1578 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 242 */
														obj_t BgL_arrayz00_1580;

														int BgL_offsetz00_1581;

														BgL_arrayz00_1580 = BgL_arg2551z00_1578;
														BgL_offsetz00_1581 =
															(int) (BgL_objzd2classzd2numz00_1577);
														{	/* Inline/inline.scm 242 */
															long BgL_offsetz00_1582;

															BgL_offsetz00_1582 =
																((long) (BgL_offsetz00_1581) - OBJECT_TYPE);
															{	/* Inline/inline.scm 242 */
																long BgL_modz00_1583;

																{	/* Inline/inline.scm 242 */
																	int BgL_arg2553z00_1584;

																	BgL_arg2553z00_1584 = (int) (((long) 8));
																	{	/* Inline/inline.scm 242 */
																		long BgL_auxz00_2855;

																		BgL_auxz00_2855 =
																			(long) (BgL_arg2553z00_1584);
																		BgL_modz00_1583 =
																			(BgL_offsetz00_1582 / BgL_auxz00_2855);
																}}
																{	/* Inline/inline.scm 242 */
																	long BgL_restz00_1585;

																	{	/* Inline/inline.scm 242 */
																		int BgL_arg2552z00_1586;

																		BgL_arg2552z00_1586 = (int) (((long) 8));
																		{	/* Inline/inline.scm 242 */
																			long BgL_auxz00_2859;

																			BgL_auxz00_2859 =
																				(long) (BgL_arg2552z00_1586);
																			BgL_restz00_1585 =
																				(BgL_offsetz00_1582 % BgL_auxz00_2859);
																	}}
																	{	/* Inline/inline.scm 242 */

																		BgL_method3258z00_1575 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1580,
																				(int) (BgL_modz00_1583)),
																			(int) (BgL_restz00_1585));
										}}}}}}}}
										BgL_res3503z00_1600 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1575) (BgL_method3258z00_1575,
												(obj_t) (BgL_nodez00_1572), BINT(BgL_kfactorz00_1573),
												BgL_stackz00_72, BEOA));
								}}
								BgL_arg3320z00_863 = BgL_res3503z00_1600;
						}}
						{	/* Inline/inline.scm 242 */
							obj_t BgL_auxz00_2871;

							BgL_auxz00_2871 = (obj_t) (BgL_arg3320z00_863);
							SET_CAR(BgL_nodeza2za2_70, BgL_auxz00_2871);
					}}
					{
						obj_t BgL_nodeza2za2_2874;

						BgL_nodeza2za2_2874 = CDR(BgL_nodeza2za2_70);
						BgL_nodeza2za2_70 = BgL_nodeza2za2_2874;
						goto BGl_inlinezd2nodeza2z12z62zzinline_inlinez00;
					}
				}
		}
	}



/* _inline-node*! */
	obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t BgL_envz00_2560,
		obj_t BgL_nodeza2za2_2561, obj_t BgL_kfactorz00_2562,
		obj_t BgL_stackz00_2563)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
			return
				BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_nodeza2za2_2561,
				BgL_kfactorz00_2562, BgL_stackz00_2563);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 25 */
				obj_t BgL_arg3324z00_866;

				obj_t BgL_arg3325z00_867;

				obj_t BgL_arg3328z00_870;

				BgL_arg3324z00_866 = CNST_TABLE_REF(((long) 1));
				BgL_arg3325z00_867 = BGl_sfunz00zzast_varz00;
				{	/* Inline/inline.scm 25 */
					obj_t BgL_v3256z00_871;

					BgL_v3256z00_871 = create_vector((int) (((long) 0)));
					BgL_arg3328z00_870 = BgL_v3256z00_871;
				}
				BGl_isfunz00zzinline_inlinez00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3324z00_866,
					BgL_arg3325z00_867, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
					BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
					BGl_isfunzf3zd2envz21zzinline_inlinez00, ((long) 461696808), BFALSE,
					BFALSE, BgL_arg3328z00_870);
			}
			return (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC, BUNSPEC);
		}
	}



/* isfun? */
	BGL_EXPORTED_DEF bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t
		BgL_obj3181z00_73)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3181z00_73,
				BGl_isfunz00zzinline_inlinez00);
		}
	}



/* _isfun? */
	obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2566,
		obj_t BgL_obj3181z00_2567)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3181z00_2567,
					BGl_isfunz00zzinline_inlinez00));
		}
	}



/* widening-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt
		BgL_originalzd2body3143zd2_77, obj_t BgL_recursivezd2calls3144zd2_78)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_new3145z00_1604;

				BgL_new3145z00_1604 =
					((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_isfunz00_bgl))));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3504z00_1610;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3170z00_1605;

						BgL_new3170z00_1605 = BgL_new3145z00_1604;
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3168zd2_1608;

							obj_t BgL_recursivezd2calls3169zd2_1609;

							BgL_originalzd2body3168zd2_1608 = BgL_originalzd2body3143zd2_77;
							BgL_recursivezd2calls3169zd2_1609 =
								BgL_recursivezd2calls3144zd2_78;
							((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1605))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3168zd2_1608), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1605))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3169zd2_1609), BUNSPEC);
							BgL_res3504z00_1610 = BgL_new3170z00_1605;
					}} BgL_res3504z00_1610;
				}
				return BgL_new3145z00_1604;
			}
		}
	}



/* _widening-isfun */
	obj_t BGl__wideningzd2isfunzd2zzinline_inlinez00(obj_t BgL_envz00_2568,
		obj_t BgL_originalzd2body3143zd2_2569,
		obj_t BgL_recursivezd2calls3144zd2_2570)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_wideningzd2isfunzd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_originalzd2body3143zd2_2569),
					BgL_recursivezd2calls3144zd2_2570));
		}
	}



/* make-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_makezd2isfunzd2zzinline_inlinez00(long
		BgL_arity3149z00_79, obj_t BgL_sidezd2effectzf33150z21_80,
		obj_t BgL_predicatezd2of3151zd2_81, obj_t BgL_stackzd2allocator3152zd2_82,
		bool_t BgL_topzf33153zf3_83, obj_t BgL_thezd2closure3154zd2_84,
		obj_t BgL_effect3155z00_85, obj_t BgL_property3156z00_86,
		obj_t BgL_args3157z00_87, obj_t BgL_argszd2name3158zd2_88,
		obj_t BgL_body3159z00_89, obj_t BgL_class3160z00_90,
		obj_t BgL_dssslzd2keywords3161zd2_91, obj_t BgL_loc3162z00_92,
		obj_t BgL_optionals3163z00_93, obj_t BgL_keys3164z00_94,
		obj_t BgL_thezd2closurezd2global3165z00_95,
		BgL_nodez00_bglt BgL_originalzd2body3147zd2_96,
		obj_t BgL_recursivezd2calls3148zd2_97)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_aux3166z00_1611;

				BgL_aux3166z00_1611 =
					BGl_makezd2sfunzd2zzast_varz00(BgL_arity3149z00_79,
					BgL_sidezd2effectzf33150z21_80, BgL_predicatezd2of3151zd2_81,
					BgL_stackzd2allocator3152zd2_82, BgL_topzf33153zf3_83,
					BgL_thezd2closure3154zd2_84, BgL_effect3155z00_85,
					BgL_property3156z00_86, BgL_args3157z00_87, BgL_argszd2name3158zd2_88,
					BgL_body3159z00_89, BgL_class3160z00_90,
					BgL_dssslzd2keywords3161zd2_91, BgL_loc3162z00_92,
					BgL_optionals3163z00_93, BgL_keys3164z00_94,
					BgL_thezd2closurezd2global3165z00_95);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3166z00_1611),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_arg3330z00_1613;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_res3506z00_1626;

						{	/* Inline/inline.scm 25 */
							BgL_isfunz00_bglt BgL_new3145z00_1619;

							BgL_new3145z00_1619 =
								((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_isfunz00_bgl))));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3505z00_1625;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3170z00_1620;

									BgL_new3170z00_1620 = BgL_new3145z00_1619;
									{	/* Inline/inline.scm 25 */
										BgL_nodez00_bglt BgL_originalzd2body3168zd2_1623;

										obj_t BgL_recursivezd2calls3169zd2_1624;

										BgL_originalzd2body3168zd2_1623 =
											BgL_originalzd2body3147zd2_96;
										BgL_recursivezd2calls3169zd2_1624 =
											BgL_recursivezd2calls3148zd2_97;
										((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1620))->
												BgL_originalzd2bodyzd2) =
											((BgL_nodez00_bglt) BgL_originalzd2body3168zd2_1623),
											BUNSPEC);
										((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1620))->
												BgL_recursivezd2callszd2) =
											((obj_t) BgL_recursivezd2calls3169zd2_1624), BUNSPEC);
										BgL_res3505z00_1625 = BgL_new3170z00_1620;
								}} BgL_res3505z00_1625;
							}
							BgL_res3506z00_1626 = BgL_new3145z00_1619;
						}
						BgL_arg3330z00_1613 = BgL_res3506z00_1626;
					}
					{	/* Inline/inline.scm 25 */
						obj_t BgL_auxz00_2899;

						BgL_objectz00_bglt BgL_auxz00_2897;

						BgL_auxz00_2899 = (obj_t) (BgL_arg3330z00_1613);
						BgL_auxz00_2897 = (BgL_objectz00_bglt) (BgL_aux3166z00_1611);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_2897, BgL_auxz00_2899);
				}}
				return ((BgL_isfunz00_bglt) (BgL_isfunz00_bglt) (BgL_aux3166z00_1611));
			}
		}
	}



/* _make-isfun */
	obj_t BGl__makezd2isfunzd2zzinline_inlinez00(obj_t BgL_envz00_2571,
		obj_t BgL_arity3149z00_2572, obj_t BgL_sidezd2effectzf33150z21_2573,
		obj_t BgL_predicatezd2of3151zd2_2574,
		obj_t BgL_stackzd2allocator3152zd2_2575, obj_t BgL_topzf33153zf3_2576,
		obj_t BgL_thezd2closure3154zd2_2577, obj_t BgL_effect3155z00_2578,
		obj_t BgL_property3156z00_2579, obj_t BgL_args3157z00_2580,
		obj_t BgL_argszd2name3158zd2_2581, obj_t BgL_body3159z00_2582,
		obj_t BgL_class3160z00_2583, obj_t BgL_dssslzd2keywords3161zd2_2584,
		obj_t BgL_loc3162z00_2585, obj_t BgL_optionals3163z00_2586,
		obj_t BgL_keys3164z00_2587, obj_t BgL_thezd2closurezd2global3165z00_2588,
		obj_t BgL_originalzd2body3147zd2_2589,
		obj_t BgL_recursivezd2calls3148zd2_2590)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_makezd2isfunzd2zzinline_inlinez00(
					(long) CINT(BgL_arity3149z00_2572), BgL_sidezd2effectzf33150z21_2573,
					BgL_predicatezd2of3151zd2_2574, BgL_stackzd2allocator3152zd2_2575,
					CBOOL(BgL_topzf33153zf3_2576), BgL_thezd2closure3154zd2_2577,
					BgL_effect3155z00_2578, BgL_property3156z00_2579,
					BgL_args3157z00_2580, BgL_argszd2name3158zd2_2581,
					BgL_body3159z00_2582, BgL_class3160z00_2583,
					BgL_dssslzd2keywords3161zd2_2584, BgL_loc3162z00_2585,
					BgL_optionals3163z00_2586, BgL_keys3164z00_2587,
					BgL_thezd2closurezd2global3165z00_2588,
					(BgL_nodez00_bglt) (BgL_originalzd2body3147zd2_2589),
					BgL_recursivezd2calls3148zd2_2590));
		}
	}



/* fill-isfun! */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt
		BgL_new3170z00_98, BgL_nodez00_bglt BgL_originalzd2body3168zd2_99,
		obj_t BgL_recursivezd2calls3169zd2_100)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_nodez00_bglt BgL_originalzd2body3168zd2_2720;

				obj_t BgL_recursivezd2calls3169zd2_2721;

				BgL_originalzd2body3168zd2_2720 = BgL_originalzd2body3168zd2_99;
				BgL_recursivezd2calls3169zd2_2721 = BgL_recursivezd2calls3169zd2_100;
				((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_98))->
						BgL_originalzd2bodyzd2) =
					((BgL_nodez00_bglt) BgL_originalzd2body3168zd2_2720), BUNSPEC);
				((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_98))->
						BgL_recursivezd2callszd2) =
					((obj_t) BgL_recursivezd2calls3169zd2_2721), BUNSPEC);
				return BgL_new3170z00_98;
			}
		}
	}



/* _fill-isfun! */
	obj_t BGl__fillzd2isfunz12zc0zzinline_inlinez00(obj_t BgL_envz00_2591,
		obj_t BgL_new3170z00_2592, obj_t BgL_originalzd2body3168zd2_2593,
		obj_t BgL_recursivezd2calls3169zd2_2594)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_auxz00_2911;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3615z00_2727;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3170z00_2722;

						BgL_nodez00_bglt BgL_originalzd2body3168zd2_2723;

						BgL_new3170z00_2722 = (BgL_isfunz00_bglt) (BgL_new3170z00_2592);
						BgL_originalzd2body3168zd2_2723 =
							(BgL_nodez00_bglt) (BgL_originalzd2body3168zd2_2593);
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3168zd2_2725;

							obj_t BgL_recursivezd2calls3169zd2_2726;

							BgL_originalzd2body3168zd2_2725 = BgL_originalzd2body3168zd2_2723;
							BgL_recursivezd2calls3169zd2_2726 =
								BgL_recursivezd2calls3169zd2_2594;
							((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_2722))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3168zd2_2725), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_2722))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3169zd2_2726), BUNSPEC);
							BgL_res3615z00_2727 = BgL_new3170z00_2722;
						}
					}
					BgL_auxz00_2911 = BgL_res3615z00_2727;
				}
				return (obj_t) (BgL_auxz00_2911);
			}
		}
	}



/* %allocate-isfun */
	BGL_EXPORTED_DEF BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_new3174z00_2728;

				BgL_new3174z00_2728 =
					((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct BgL_sfunz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET(
					(BgL_objectz00_bglt) (BgL_new3174z00_2728),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_objectz00_bglt BgL_auxz00_2921;

					BgL_auxz00_2921 = (BgL_objectz00_bglt) (BgL_new3174z00_2728);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_2921, BFALSE);
				}
				return BgL_new3174z00_2728;
			}
		}
	}



/* _%allocate-isfun */
	obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t BgL_envz00_2564)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_auxz00_2924;

				{	/* Inline/inline.scm 25 */
					BgL_sfunz00_bglt BgL_res3616z00_2732;

					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_new3174z00_2730;

						BgL_new3174z00_2730 =
							((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_sfunz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3174z00_2730),
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
						{	/* Inline/inline.scm 25 */
							BgL_objectz00_bglt BgL_auxz00_2929;

							BgL_auxz00_2929 = (BgL_objectz00_bglt) (BgL_new3174z00_2730);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2929, BFALSE);
						}
						BgL_res3616z00_2732 = BgL_new3174z00_2730;
					}
					BgL_auxz00_2924 = BgL_res3616z00_2732;
				}
				return (obj_t) (BgL_auxz00_2924);
			}
		}
	}



/* isfun-nil */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			if ((BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 == BUNSPEC))
				{	/* Inline/inline.scm 25 */
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3507z00_1637;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1861z00_1633;

							BgL_new1861z00_1633 =
								((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_sfunz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1861z00_1633),
								BGl_classzd2numzd2zz__objectz00(BGl_sfunz00zzast_varz00));
							{	/* Inline/inline.scm 25 */
								BgL_objectz00_bglt BgL_auxz00_2939;

								BgL_auxz00_2939 = (BgL_objectz00_bglt) (BgL_new1861z00_1633);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2939, BFALSE);
							}
							BgL_res3507z00_1637 = BgL_new1861z00_1633;
						}
						BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 =
							(obj_t) (BgL_res3507z00_1637);
					}
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3508z00_1673;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1842z00_1638;

							BgL_new1842z00_1638 =
								(BgL_sfunz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							{	/* Inline/inline.scm 25 */
								long BgL_arity1825z00_1656;

								obj_t BgL_sidezd2effectzf31826z21_1657;

								obj_t BgL_predicatezd2of1827zd2_1658;

								obj_t BgL_stackzd2allocator1828zd2_1659;

								bool_t BgL_topzf31829zf3_1660;

								obj_t BgL_thezd2closure1830zd2_1661;

								obj_t BgL_effect1831z00_1662;

								obj_t BgL_property1832z00_1663;

								obj_t BgL_args1833z00_1664;

								obj_t BgL_argszd2name1834zd2_1665;

								obj_t BgL_body1835z00_1666;

								obj_t BgL_class1836z00_1667;

								obj_t BgL_dssslzd2keywords1837zd2_1668;

								obj_t BgL_loc1838z00_1669;

								obj_t BgL_optionals1839z00_1670;

								obj_t BgL_keys1840z00_1671;

								obj_t BgL_thezd2closurezd2global1841z00_1672;

								BgL_arity1825z00_1656 = ((long) 0);
								BgL_sidezd2effectzf31826z21_1657 = BUNSPEC;
								BgL_predicatezd2of1827zd2_1658 = BUNSPEC;
								BgL_stackzd2allocator1828zd2_1659 = BUNSPEC;
								BgL_topzf31829zf3_1660 = ((bool_t) 0);
								BgL_thezd2closure1830zd2_1661 = BUNSPEC;
								BgL_effect1831z00_1662 = BUNSPEC;
								BgL_property1832z00_1663 = BUNSPEC;
								BgL_args1833z00_1664 = BUNSPEC;
								BgL_argszd2name1834zd2_1665 = BUNSPEC;
								BgL_body1835z00_1666 = BUNSPEC;
								BgL_class1836z00_1667 = BUNSPEC;
								BgL_dssslzd2keywords1837zd2_1668 = BUNSPEC;
								BgL_loc1838z00_1669 = BUNSPEC;
								BgL_optionals1839z00_1670 = BUNSPEC;
								BgL_keys1840z00_1671 = BUNSPEC;
								BgL_thezd2closurezd2global1841z00_1672 = BUNSPEC;
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_arityz00) = ((long) BgL_arity1825z00_1656), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_sidezd2effectzf3z21) =
									((obj_t) BgL_sidezd2effectzf31826z21_1657), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_predicatezd2of1827zd2_1658), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_stackzd2allocatorzd2) =
									((obj_t) BgL_stackzd2allocator1828zd2_1659), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_topzf3zf3) =
									((bool_t) BgL_topzf31829zf3_1660), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_thezd2closurezd2) =
									((obj_t) BgL_thezd2closure1830zd2_1661), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_effectz00) = ((obj_t) BgL_effect1831z00_1662), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_propertyz00) =
									((obj_t) BgL_property1832z00_1663), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->BgL_argsz00) =
									((obj_t) BgL_args1833z00_1664), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_argszd2namezd2) =
									((obj_t) BgL_argszd2name1834zd2_1665), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->BgL_bodyz00) =
									((obj_t) BgL_body1835z00_1666), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_classz00) = ((obj_t) BgL_class1836z00_1667), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_dssslzd2keywordszd2) =
									((obj_t) BgL_dssslzd2keywords1837zd2_1668), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->BgL_locz00) =
									((obj_t) BgL_loc1838z00_1669), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_optionalsz00) =
									((obj_t) BgL_optionals1839z00_1670), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->BgL_keysz00) =
									((obj_t) BgL_keys1840z00_1671), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1842z00_1638))->
										BgL_thezd2closurezd2globalz00) =
									((obj_t) BgL_thezd2closurezd2global1841z00_1672), BUNSPEC);
								BgL_res3508z00_1673 = BgL_new1842z00_1638;
						}} BgL_res3508z00_1673;
					}
					{	/* Inline/inline.scm 25 */
						long BgL_arg3333z00_882;

						BgL_arg3333z00_882 =
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00);
						BGL_OBJECT_CLASS_NUM_SET(
							(BgL_objectz00_bglt)
							(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00),
							BgL_arg3333z00_882);
					}
					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_arg3334z00_883;

						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_arg3335z00_884;

							BgL_arg3335z00_884 = BGl_nodezd2nilzd2zzast_nodez00();
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3510z00_1685;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3145z00_1678;

									BgL_new3145z00_1678 =
										((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_isfunz00_bgl))));
									{	/* Inline/inline.scm 25 */
										BgL_isfunz00_bglt BgL_res3509z00_1684;

										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_new3170z00_1679;

											BgL_new3170z00_1679 = BgL_new3145z00_1678;
											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3168zd2_1682;

												obj_t BgL_recursivezd2calls3169zd2_1683;

												BgL_originalzd2body3168zd2_1682 = BgL_arg3335z00_884;
												BgL_recursivezd2calls3169zd2_1683 = BUNSPEC;
												((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1679))->
														BgL_originalzd2bodyzd2) =
													((BgL_nodez00_bglt) BgL_originalzd2body3168zd2_1682),
													BUNSPEC);
												((((BgL_isfunz00_bglt) CREF(BgL_new3170z00_1679))->
														BgL_recursivezd2callszd2) =
													((obj_t) BgL_recursivezd2calls3169zd2_1683), BUNSPEC);
												BgL_res3509z00_1684 = BgL_new3170z00_1679;
										}} BgL_res3509z00_1684;
									}
									BgL_res3510z00_1685 = BgL_new3145z00_1678;
								}
								BgL_arg3334z00_883 = BgL_res3510z00_1685;
						}}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_auxz00_2970;

							BgL_objectz00_bglt BgL_auxz00_2968;

							BgL_auxz00_2970 = (obj_t) (BgL_arg3334z00_883);
							BgL_auxz00_2968 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2968, BgL_auxz00_2970);
				}}}
			else
				{	/* Inline/inline.scm 25 */
					BFALSE;
				}
			return
				(BgL_isfunz00_bglt) (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
		}
	}



/* _isfun-nil */
	obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t BgL_envz00_2565)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return (obj_t) (BGl_isfunzd2nilzd2zzinline_inlinez00());
		}
	}



/* _sfun? */
	obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2554,
		obj_t BgL_obj1862z00_2555)
	{
		AN_OBJECT;
		{	/* Ast/var.scm 94 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj1862z00_2555,
					BGl_sfunz00zzast_varz00));
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_inlinezd2nodezd2default3257zd2envzd2zzinline_inlinez00);
		}
	}



/* inline-node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt BgL_nodez00_4,
		long BgL_kfactorz00_5, obj_t BgL_stackz00_6)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			{	/* Inline/inline.scm 62 */
				obj_t BgL_method3258z00_1707;

				{	/* Inline/inline.scm 62 */
					BgL_objectz00_bglt BgL_objz00_1708;

					BgL_objz00_1708 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Inline/inline.scm 62 */
						long BgL_objzd2classzd2numz00_1709;

						BgL_objzd2classzd2numz00_1709 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1708);
						{	/* Inline/inline.scm 62 */
							obj_t BgL_arg2551z00_1710;

							BgL_arg2551z00_1710 =
								PROCEDURE_REF(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
								(int) (((long) 1)));
							{	/* Inline/inline.scm 62 */
								obj_t BgL_arrayz00_1712;

								int BgL_offsetz00_1713;

								BgL_arrayz00_1712 = BgL_arg2551z00_1710;
								BgL_offsetz00_1713 = (int) (BgL_objzd2classzd2numz00_1709);
								{	/* Inline/inline.scm 62 */
									long BgL_offsetz00_1714;

									BgL_offsetz00_1714 =
										((long) (BgL_offsetz00_1713) - OBJECT_TYPE);
									{	/* Inline/inline.scm 62 */
										long BgL_modz00_1715;

										{	/* Inline/inline.scm 62 */
											int BgL_arg2553z00_1716;

											BgL_arg2553z00_1716 = (int) (((long) 8));
											{	/* Inline/inline.scm 62 */
												long BgL_auxz00_2987;

												BgL_auxz00_2987 = (long) (BgL_arg2553z00_1716);
												BgL_modz00_1715 =
													(BgL_offsetz00_1714 / BgL_auxz00_2987);
										}}
										{	/* Inline/inline.scm 62 */
											long BgL_restz00_1717;

											{	/* Inline/inline.scm 62 */
												int BgL_arg2552z00_1718;

												BgL_arg2552z00_1718 = (int) (((long) 8));
												{	/* Inline/inline.scm 62 */
													long BgL_auxz00_2991;

													BgL_auxz00_2991 = (long) (BgL_arg2552z00_1718);
													BgL_restz00_1717 =
														(BgL_offsetz00_1714 % BgL_auxz00_2991);
											}}
											{	/* Inline/inline.scm 62 */

												BgL_method3258z00_1707 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1712,
														(int) (BgL_modz00_1715)), (int) (BgL_restz00_1717));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3258z00_1707)
					(BgL_method3258z00_1707, (obj_t) (BgL_nodez00_4),
						BINT(BgL_kfactorz00_5), BgL_stackz00_6, BEOA));
			}
		}
	}



/* _inline-node */
	obj_t BGl__inlinezd2nodezd2zzinline_inlinez00(obj_t BgL_envz00_2556,
		obj_t BgL_nodez00_2557, obj_t BgL_kfactorz00_2558, obj_t BgL_stackz00_2559)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			return
				(obj_t) (BGl_inlinezd2nodezd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2557),
					(long) CINT(BgL_kfactorz00_2558), BgL_stackz00_2559));
		}
	}



/* inline-node-default3257 */
	BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3257z00zzinline_inlinez00(BgL_nodez00_bglt
		BgL_nodez00_7, long BgL_kfactorz00_8, obj_t BgL_stackz00_9)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string3588z00zzinline_inlinez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _inline-node-default3257 */
	obj_t BGl__inlinezd2nodezd2default3257z00zzinline_inlinez00(obj_t
		BgL_envz00_2595, obj_t BgL_nodez00_2596, obj_t BgL_kfactorz00_2597,
		obj_t BgL_stackz00_2598)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(obj_t) (BGl_inlinezd2nodezd2default3257z00zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2596),
					(long) CINT(BgL_kfactorz00_2597), BgL_stackz00_2598));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_atomz00zzast_nodez00,
				BGl_proc3589z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_varz00zzast_nodez00,
				BGl_proc3590z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_kwotez00zzast_nodez00, BGl_proc3591z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_sequencez00zzast_nodez00, BGl_proc3592z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_appz00zzast_nodez00,
				BGl_proc3593z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3594z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_funcallz00zzast_nodez00, BGl_proc3595z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_externz00zzast_nodez00, BGl_proc3596z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_castz00zzast_nodez00,
				BGl_proc3597z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_setqz00zzast_nodez00,
				BGl_proc3598z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3599z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_failz00zzast_nodez00,
				BGl_proc3600z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_selectz00zzast_nodez00, BGl_proc3601z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3602z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3603z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3604z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3605z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3606z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3607z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3608z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3609z00zzinline_inlinez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3610z00zzinline_inlinez00);
		}
	}



/* struct+object->objec3304 */
	obj_t BGl_structzb2objectzd2ze3objec3304z83zzinline_inlinez00(obj_t
		BgL_envz00_2626, obj_t BgL_oz00_2627, obj_t BgL_sz00_2628)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_oz00_1508;

				obj_t BgL_sz00_1509;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_auxz00_3037;

					BgL_oz00_1508 = (BgL_isfunz00_bglt) (BgL_oz00_2627);
					BgL_sz00_1509 = BgL_sz00_2628;
					{

						{	/* Inline/inline.scm 25 */
							obj_t BgL_old3178z00_1512;

							obj_t BgL_aux3179z00_1513;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_nextzd2method3303zd2_1519;

								BgL_nextzd2method3303zd2_1519 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1508),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_isfunz00zzinline_inlinez00);
								if (PROCEDUREP(BgL_nextzd2method3303zd2_1519))
									{	/* Inline/inline.scm 25 */
										BgL_old3178z00_1512 =
											PROCEDURE_ENTRY(BgL_nextzd2method3303zd2_1519)
											(BgL_nextzd2method3303zd2_1519, (obj_t) (BgL_oz00_1508),
											BgL_sz00_1509, BEOA);
									}
								else
									{	/* Inline/inline.scm 25 */
										BgL_old3178z00_1512 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1508), BgL_sz00_1509));
									}
							}
							BgL_aux3179z00_1513 =
								STRUCT_REF(BgL_sz00_1509, (int) (((long) 0)));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_new3180z00_1514;

								BgL_new3180z00_1514 =
									((BgL_isfunz00_bglt) (BgL_old3178z00_1512));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3180z00_1514),
									BGl_classzd2numzd2zz__objectz00
									(BGl_isfunz00zzinline_inlinez00));
								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_arg3492z00_1516;

									{	/* Inline/inline.scm 25 */
										obj_t BgL_arg3493z00_1517;

										obj_t BgL_arg3494z00_1518;

										BgL_arg3493z00_1517 =
											STRUCT_REF(BgL_aux3179z00_1513, (int) (((long) 0)));
										BgL_arg3494z00_1518 =
											STRUCT_REF(BgL_aux3179z00_1513, (int) (((long) 1)));
										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_res3584z00_2548;

											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3143zd2_2539;

												BgL_originalzd2body3143zd2_2539 =
													(BgL_nodez00_bglt) (BgL_arg3493z00_1517);
												{	/* Inline/inline.scm 25 */
													BgL_isfunz00_bglt BgL_new3145z00_2541;

													BgL_new3145z00_2541 =
														((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																	BgL_isfunz00_bgl))));
													{	/* Inline/inline.scm 25 */
														BgL_isfunz00_bglt BgL_res3583z00_2547;

														{	/* Inline/inline.scm 25 */
															BgL_isfunz00_bglt BgL_new3170z00_2542;

															BgL_new3170z00_2542 = BgL_new3145z00_2541;
															{	/* Inline/inline.scm 25 */
																BgL_nodez00_bglt
																	BgL_originalzd2body3168zd2_2545;
																obj_t BgL_recursivezd2calls3169zd2_2546;

																BgL_originalzd2body3168zd2_2545 =
																	BgL_originalzd2body3143zd2_2539;
																BgL_recursivezd2calls3169zd2_2546 =
																	BgL_arg3494z00_1518;
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3170z00_2542))->
																		BgL_originalzd2bodyzd2) =
																	((BgL_nodez00_bglt)
																		BgL_originalzd2body3168zd2_2545), BUNSPEC);
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3170z00_2542))->
																		BgL_recursivezd2callszd2) =
																	((obj_t) BgL_recursivezd2calls3169zd2_2546),
																	BUNSPEC);
																BgL_res3583z00_2547 = BgL_new3170z00_2542;
														}} BgL_res3583z00_2547;
													}
													BgL_res3584z00_2548 = BgL_new3145z00_2541;
											}}
											BgL_arg3492z00_1516 = BgL_res3584z00_2548;
									}}
									{	/* Inline/inline.scm 25 */
										obj_t BgL_auxz00_3064;

										BgL_objectz00_bglt BgL_auxz00_3062;

										BgL_auxz00_3064 = (obj_t) (BgL_arg3492z00_1516);
										BgL_auxz00_3062 =
											(BgL_objectz00_bglt) (BgL_new3180z00_1514);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3062, BgL_auxz00_3064);
								}}
								BgL_auxz00_3037 = BgL_new3180z00_1514;
					}}}
					return (obj_t) (BgL_auxz00_3037);
				}
			}
		}
	}



/* object->struct-isfun3302 */
	obj_t BGl_objectzd2ze3structzd2isfun3302ze3zzinline_inlinez00(obj_t
		BgL_envz00_2629, obj_t BgL_obj3175z00_2630)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_obj3175z00_1496;

				BgL_obj3175z00_1496 = (BgL_isfunz00_bglt) (BgL_obj3175z00_2630);
				{

					{	/* Inline/inline.scm 25 */
						obj_t BgL_res3176z00_1499;

						{	/* Inline/inline.scm 25 */
							obj_t BgL_nextzd2method3301zd2_1506;

							BgL_nextzd2method3301zd2_1506 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3175z00_1496),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_isfunz00zzinline_inlinez00);
							if (PROCEDUREP(BgL_nextzd2method3301zd2_1506))
								{	/* Inline/inline.scm 25 */
									BgL_res3176z00_1499 =
										PROCEDURE_ENTRY(BgL_nextzd2method3301zd2_1506)
										(BgL_nextzd2method3301zd2_1506,
										(obj_t) (BgL_obj3175z00_1496), BEOA);
								}
							else
								{	/* Inline/inline.scm 25 */
									BgL_res3176z00_1499 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3175z00_1496));
								}
						}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_aux3177z00_1500;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_keyz00_2510;

								BgL_keyz00_2510 = CNST_TABLE_REF(((long) 1));
								BgL_aux3177z00_1500 =
									make_struct(BgL_keyz00_2510, (int) (((long) 2)), BUNSPEC);
							}
							{	/* Inline/inline.scm 25 */
								BgL_nodez00_bglt BgL_arg3485z00_1502;

								{
									obj_t BgL_auxz00_3081;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3082;

										BgL_auxz00_3082 =
											(BgL_objectz00_bglt) (BgL_obj3175z00_1496);
										BgL_auxz00_3081 = BGL_OBJECT_WIDENING(BgL_auxz00_3082);
									}
									BgL_arg3485z00_1502 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3081))->
										BgL_originalzd2bodyzd2);
								}
								{	/* Inline/inline.scm 25 */
									obj_t BgL_auxz00_3088;

									int BgL_auxz00_3086;

									BgL_auxz00_3088 = (obj_t) (BgL_arg3485z00_1502);
									BgL_auxz00_3086 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3177z00_1500, BgL_auxz00_3086,
										BgL_auxz00_3088);
							}}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_arg3487z00_1504;

								{
									obj_t BgL_auxz00_3091;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3092;

										BgL_auxz00_3092 =
											(BgL_objectz00_bglt) (BgL_obj3175z00_1496);
										BgL_auxz00_3091 = BGL_OBJECT_WIDENING(BgL_auxz00_3092);
									}
									BgL_arg3487z00_1504 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3091))->
										BgL_recursivezd2callszd2);
								}
								{	/* Inline/inline.scm 25 */
									int BgL_auxz00_3096;

									BgL_auxz00_3096 = (int) (((long) 1));
									STRUCT_SET(BgL_aux3177z00_1500, BgL_auxz00_3096,
										BgL_arg3487z00_1504);
							}}
							{	/* Inline/inline.scm 25 */
								int BgL_auxz00_3099;

								BgL_auxz00_3099 = (int) (((long) 0));
								STRUCT_SET(BgL_res3176z00_1499, BgL_auxz00_3099,
									BgL_aux3177z00_1500);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_auxz00_3102;

								BgL_auxz00_3102 = STRUCT_KEY(BgL_res3176z00_1499);
								STRUCT_KEY_SET(BgL_aux3177z00_1500, BgL_auxz00_3102);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_kz00_2529;

								BgL_kz00_2529 = CNST_TABLE_REF(((long) 1));
								STRUCT_KEY_SET(BgL_res3176z00_1499, BgL_kz00_2529);
							}
							return BgL_res3176z00_1499;
						}
					}
				}
			}
		}
	}



/* inline-node-box-set!3300 */
	obj_t BGl_inlinezd2nodezd2boxzd2setz123300zc0zzinline_inlinez00(obj_t
		BgL_envz00_2631, obj_t BgL_nodez00_2632, obj_t BgL_kfactorz00_2633,
		obj_t BgL_stackz00_2634)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 229 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1484;

				obj_t BgL_kfactorz00_1485;

				obj_t BgL_stackz00_1486;

				{	/* Inline/inline.scm 230 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_3108;

					BgL_nodez00_1484 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2632);
					BgL_kfactorz00_1485 = BgL_kfactorz00_2633;
					BgL_stackz00_1486 = BgL_stackz00_2634;
					{	/* Inline/inline.scm 231 */
						BgL_nodez00_bglt BgL_arg3479z00_1490;

						{	/* Inline/inline.scm 231 */
							BgL_varz00_bglt BgL_arg3480z00_1491;

							BgL_arg3480z00_1491 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1484))->
								BgL_varz00);
							{	/* Inline/inline.scm 231 */
								BgL_nodez00_bglt BgL_res3578z00_2475;

								{	/* Inline/inline.scm 231 */
									BgL_nodez00_bglt BgL_nodez00_2447;

									long BgL_kfactorz00_2448;

									BgL_nodez00_2447 = (BgL_nodez00_bglt) (BgL_arg3480z00_1491);
									BgL_kfactorz00_2448 = (long) CINT(BgL_kfactorz00_1485);
									{	/* Inline/inline.scm 231 */
										obj_t BgL_method3258z00_2450;

										{	/* Inline/inline.scm 231 */
											BgL_objectz00_bglt BgL_objz00_2451;

											BgL_objz00_2451 = (BgL_objectz00_bglt) (BgL_nodez00_2447);
											{	/* Inline/inline.scm 231 */
												long BgL_objzd2classzd2numz00_2452;

												BgL_objzd2classzd2numz00_2452 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2451);
												{	/* Inline/inline.scm 231 */
													obj_t BgL_arg2551z00_2453;

													BgL_arg2551z00_2453 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 231 */
														obj_t BgL_arrayz00_2455;

														int BgL_offsetz00_2456;

														BgL_arrayz00_2455 = BgL_arg2551z00_2453;
														BgL_offsetz00_2456 =
															(int) (BgL_objzd2classzd2numz00_2452);
														{	/* Inline/inline.scm 231 */
															long BgL_offsetz00_2457;

															BgL_offsetz00_2457 =
																((long) (BgL_offsetz00_2456) - OBJECT_TYPE);
															{	/* Inline/inline.scm 231 */
																long BgL_modz00_2458;

																{	/* Inline/inline.scm 231 */
																	int BgL_arg2553z00_2459;

																	BgL_arg2553z00_2459 = (int) (((long) 8));
																	{	/* Inline/inline.scm 231 */
																		long BgL_auxz00_3120;

																		BgL_auxz00_3120 =
																			(long) (BgL_arg2553z00_2459);
																		BgL_modz00_2458 =
																			(BgL_offsetz00_2457 / BgL_auxz00_3120);
																}}
																{	/* Inline/inline.scm 231 */
																	long BgL_restz00_2460;

																	{	/* Inline/inline.scm 231 */
																		int BgL_arg2552z00_2461;

																		BgL_arg2552z00_2461 = (int) (((long) 8));
																		{	/* Inline/inline.scm 231 */
																			long BgL_auxz00_3124;

																			BgL_auxz00_3124 =
																				(long) (BgL_arg2552z00_2461);
																			BgL_restz00_2460 =
																				(BgL_offsetz00_2457 % BgL_auxz00_3124);
																	}}
																	{	/* Inline/inline.scm 231 */

																		BgL_method3258z00_2450 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2455,
																				(int) (BgL_modz00_2458)),
																			(int) (BgL_restz00_2460));
										}}}}}}}}
										BgL_res3578z00_2475 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2450) (BgL_method3258z00_2450,
												(obj_t) (BgL_nodez00_2447), BINT(BgL_kfactorz00_2448),
												BgL_stackz00_1486, BEOA));
								}}
								BgL_arg3479z00_1490 = BgL_res3578z00_2475;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3136;

							BgL_auxz00_3136 = (BgL_varz00_bglt) (BgL_arg3479z00_1490);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1484))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3136), BUNSPEC);
					}}
					{	/* Inline/inline.scm 232 */
						BgL_nodez00_bglt BgL_arg3481z00_1492;

						{	/* Inline/inline.scm 232 */
							BgL_nodez00_bglt BgL_arg3482z00_1493;

							BgL_arg3482z00_1493 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1484))->
								BgL_valuez00);
							{	/* Inline/inline.scm 232 */
								BgL_nodez00_bglt BgL_res3581z00_2507;

								{	/* Inline/inline.scm 232 */
									long BgL_kfactorz00_2480;

									BgL_kfactorz00_2480 = (long) CINT(BgL_kfactorz00_1485);
									{	/* Inline/inline.scm 232 */
										obj_t BgL_method3258z00_2482;

										{	/* Inline/inline.scm 232 */
											BgL_objectz00_bglt BgL_objz00_2483;

											BgL_objz00_2483 =
												(BgL_objectz00_bglt) (BgL_arg3482z00_1493);
											{	/* Inline/inline.scm 232 */
												long BgL_objzd2classzd2numz00_2484;

												BgL_objzd2classzd2numz00_2484 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2483);
												{	/* Inline/inline.scm 232 */
													obj_t BgL_arg2551z00_2485;

													BgL_arg2551z00_2485 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 232 */
														obj_t BgL_arrayz00_2487;

														int BgL_offsetz00_2488;

														BgL_arrayz00_2487 = BgL_arg2551z00_2485;
														BgL_offsetz00_2488 =
															(int) (BgL_objzd2classzd2numz00_2484);
														{	/* Inline/inline.scm 232 */
															long BgL_offsetz00_2489;

															BgL_offsetz00_2489 =
																((long) (BgL_offsetz00_2488) - OBJECT_TYPE);
															{	/* Inline/inline.scm 232 */
																long BgL_modz00_2490;

																{	/* Inline/inline.scm 232 */
																	int BgL_arg2553z00_2491;

																	BgL_arg2553z00_2491 = (int) (((long) 8));
																	{	/* Inline/inline.scm 232 */
																		long BgL_auxz00_3149;

																		BgL_auxz00_3149 =
																			(long) (BgL_arg2553z00_2491);
																		BgL_modz00_2490 =
																			(BgL_offsetz00_2489 / BgL_auxz00_3149);
																}}
																{	/* Inline/inline.scm 232 */
																	long BgL_restz00_2492;

																	{	/* Inline/inline.scm 232 */
																		int BgL_arg2552z00_2493;

																		BgL_arg2552z00_2493 = (int) (((long) 8));
																		{	/* Inline/inline.scm 232 */
																			long BgL_auxz00_3153;

																			BgL_auxz00_3153 =
																				(long) (BgL_arg2552z00_2493);
																			BgL_restz00_2492 =
																				(BgL_offsetz00_2489 % BgL_auxz00_3153);
																	}}
																	{	/* Inline/inline.scm 232 */

																		BgL_method3258z00_2482 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2487,
																				(int) (BgL_modz00_2490)),
																			(int) (BgL_restz00_2492));
										}}}}}}}}
										BgL_res3581z00_2507 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2482) (BgL_method3258z00_2482,
												(obj_t) (BgL_arg3482z00_1493),
												BINT(BgL_kfactorz00_2480), BgL_stackz00_1486, BEOA));
								}}
								BgL_arg3481z00_1492 = BgL_res3581z00_2507;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1484))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3481z00_1492), BUNSPEC);
					}
					BgL_auxz00_3108 = BgL_nodez00_1484;
					return (obj_t) (BgL_auxz00_3108);
				}
			}
		}
	}



/* inline-node-box-ref3298 */
	obj_t BGl_inlinezd2nodezd2boxzd2ref3298zd2zzinline_inlinez00(obj_t
		BgL_envz00_2635, obj_t BgL_nodez00_2636, obj_t BgL_kfactorz00_2637,
		obj_t BgL_stackz00_2638)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 222 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1475;

				obj_t BgL_kfactorz00_1476;

				obj_t BgL_stackz00_1477;

				{	/* Inline/inline.scm 223 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_3168;

					BgL_nodez00_1475 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2636);
					BgL_kfactorz00_1476 = BgL_kfactorz00_2637;
					BgL_stackz00_1477 = BgL_stackz00_2638;
					{	/* Inline/inline.scm 223 */
						BgL_nodez00_bglt BgL_arg3476z00_2412;

						{	/* Inline/inline.scm 223 */
							BgL_varz00_bglt BgL_arg3477z00_2413;

							BgL_arg3477z00_2413 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1475))->BgL_varz00);
							{	/* Inline/inline.scm 223 */
								BgL_nodez00_bglt BgL_res3575z00_2443;

								{	/* Inline/inline.scm 223 */
									BgL_nodez00_bglt BgL_nodez00_2415;

									long BgL_kfactorz00_2416;

									BgL_nodez00_2415 = (BgL_nodez00_bglt) (BgL_arg3477z00_2413);
									BgL_kfactorz00_2416 = (long) CINT(BgL_kfactorz00_1476);
									{	/* Inline/inline.scm 223 */
										obj_t BgL_method3258z00_2418;

										{	/* Inline/inline.scm 223 */
											BgL_objectz00_bglt BgL_objz00_2419;

											BgL_objz00_2419 = (BgL_objectz00_bglt) (BgL_nodez00_2415);
											{	/* Inline/inline.scm 223 */
												long BgL_objzd2classzd2numz00_2420;

												BgL_objzd2classzd2numz00_2420 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2419);
												{	/* Inline/inline.scm 223 */
													obj_t BgL_arg2551z00_2421;

													BgL_arg2551z00_2421 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 223 */
														obj_t BgL_arrayz00_2423;

														int BgL_offsetz00_2424;

														BgL_arrayz00_2423 = BgL_arg2551z00_2421;
														BgL_offsetz00_2424 =
															(int) (BgL_objzd2classzd2numz00_2420);
														{	/* Inline/inline.scm 223 */
															long BgL_offsetz00_2425;

															BgL_offsetz00_2425 =
																((long) (BgL_offsetz00_2424) - OBJECT_TYPE);
															{	/* Inline/inline.scm 223 */
																long BgL_modz00_2426;

																{	/* Inline/inline.scm 223 */
																	int BgL_arg2553z00_2427;

																	BgL_arg2553z00_2427 = (int) (((long) 8));
																	{	/* Inline/inline.scm 223 */
																		long BgL_auxz00_3180;

																		BgL_auxz00_3180 =
																			(long) (BgL_arg2553z00_2427);
																		BgL_modz00_2426 =
																			(BgL_offsetz00_2425 / BgL_auxz00_3180);
																}}
																{	/* Inline/inline.scm 223 */
																	long BgL_restz00_2428;

																	{	/* Inline/inline.scm 223 */
																		int BgL_arg2552z00_2429;

																		BgL_arg2552z00_2429 = (int) (((long) 8));
																		{	/* Inline/inline.scm 223 */
																			long BgL_auxz00_3184;

																			BgL_auxz00_3184 =
																				(long) (BgL_arg2552z00_2429);
																			BgL_restz00_2428 =
																				(BgL_offsetz00_2425 % BgL_auxz00_3184);
																	}}
																	{	/* Inline/inline.scm 223 */

																		BgL_method3258z00_2418 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2423,
																				(int) (BgL_modz00_2426)),
																			(int) (BgL_restz00_2428));
										}}}}}}}}
										BgL_res3575z00_2443 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2418) (BgL_method3258z00_2418,
												(obj_t) (BgL_nodez00_2415), BINT(BgL_kfactorz00_2416),
												BgL_stackz00_1477, BEOA));
								}}
								BgL_arg3476z00_2412 = BgL_res3575z00_2443;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3196;

							BgL_auxz00_3196 = (BgL_varz00_bglt) (BgL_arg3476z00_2412);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1475))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3196), BUNSPEC);
					}}
					BgL_auxz00_3168 = BgL_nodez00_1475;
					return (obj_t) (BgL_auxz00_3168);
				}
			}
		}
	}



/* inline-node-make-box3296 */
	obj_t BGl_inlinezd2nodezd2makezd2box3296zd2zzinline_inlinez00(obj_t
		BgL_envz00_2639, obj_t BgL_nodez00_2640, obj_t BgL_kfactorz00_2641,
		obj_t BgL_stackz00_2642)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 215 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1466;

				obj_t BgL_kfactorz00_1467;

				obj_t BgL_stackz00_1468;

				{	/* Inline/inline.scm 216 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3201;

					BgL_nodez00_1466 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2640);
					BgL_kfactorz00_1467 = BgL_kfactorz00_2641;
					BgL_stackz00_1468 = BgL_stackz00_2642;
					{	/* Inline/inline.scm 216 */
						BgL_nodez00_bglt BgL_arg3473z00_2378;

						{	/* Inline/inline.scm 216 */
							BgL_nodez00_bglt BgL_arg3474z00_2379;

							BgL_arg3474z00_2379 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1466))->
								BgL_valuez00);
							{	/* Inline/inline.scm 216 */
								BgL_nodez00_bglt BgL_res3572z00_2409;

								{	/* Inline/inline.scm 216 */
									long BgL_kfactorz00_2382;

									BgL_kfactorz00_2382 = (long) CINT(BgL_kfactorz00_1467);
									{	/* Inline/inline.scm 216 */
										obj_t BgL_method3258z00_2384;

										{	/* Inline/inline.scm 216 */
											BgL_objectz00_bglt BgL_objz00_2385;

											BgL_objz00_2385 =
												(BgL_objectz00_bglt) (BgL_arg3474z00_2379);
											{	/* Inline/inline.scm 216 */
												long BgL_objzd2classzd2numz00_2386;

												BgL_objzd2classzd2numz00_2386 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2385);
												{	/* Inline/inline.scm 216 */
													obj_t BgL_arg2551z00_2387;

													BgL_arg2551z00_2387 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 216 */
														obj_t BgL_arrayz00_2389;

														int BgL_offsetz00_2390;

														BgL_arrayz00_2389 = BgL_arg2551z00_2387;
														BgL_offsetz00_2390 =
															(int) (BgL_objzd2classzd2numz00_2386);
														{	/* Inline/inline.scm 216 */
															long BgL_offsetz00_2391;

															BgL_offsetz00_2391 =
																((long) (BgL_offsetz00_2390) - OBJECT_TYPE);
															{	/* Inline/inline.scm 216 */
																long BgL_modz00_2392;

																{	/* Inline/inline.scm 216 */
																	int BgL_arg2553z00_2393;

																	BgL_arg2553z00_2393 = (int) (((long) 8));
																	{	/* Inline/inline.scm 216 */
																		long BgL_auxz00_3212;

																		BgL_auxz00_3212 =
																			(long) (BgL_arg2553z00_2393);
																		BgL_modz00_2392 =
																			(BgL_offsetz00_2391 / BgL_auxz00_3212);
																}}
																{	/* Inline/inline.scm 216 */
																	long BgL_restz00_2394;

																	{	/* Inline/inline.scm 216 */
																		int BgL_arg2552z00_2395;

																		BgL_arg2552z00_2395 = (int) (((long) 8));
																		{	/* Inline/inline.scm 216 */
																			long BgL_auxz00_3216;

																			BgL_auxz00_3216 =
																				(long) (BgL_arg2552z00_2395);
																			BgL_restz00_2394 =
																				(BgL_offsetz00_2391 % BgL_auxz00_3216);
																	}}
																	{	/* Inline/inline.scm 216 */

																		BgL_method3258z00_2384 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2389,
																				(int) (BgL_modz00_2392)),
																			(int) (BgL_restz00_2394));
										}}}}}}}}
										BgL_res3572z00_2409 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2384) (BgL_method3258z00_2384,
												(obj_t) (BgL_arg3474z00_2379),
												BINT(BgL_kfactorz00_2382), BgL_stackz00_1468, BEOA));
								}}
								BgL_arg3473z00_2378 = BgL_res3572z00_2409;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1466))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3473z00_2378), BUNSPEC);
					}
					BgL_auxz00_3201 = BgL_nodez00_1466;
					return (obj_t) (BgL_auxz00_3201);
				}
			}
		}
	}



/* inline-node-jump-ex-3294 */
	obj_t BGl_inlinezd2nodezd2jumpzd2exzd23294z00zzinline_inlinez00(obj_t
		BgL_envz00_2643, obj_t BgL_nodez00_2644, obj_t BgL_kfactorz00_2645,
		obj_t BgL_stackz00_2646)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 206 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1454;

				obj_t BgL_kfactorz00_1455;

				obj_t BgL_stackz00_1456;

				{	/* Inline/inline.scm 207 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3231;

					BgL_nodez00_1454 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2644);
					BgL_kfactorz00_1455 = BgL_kfactorz00_2645;
					BgL_stackz00_1456 = BgL_stackz00_2646;
					{	/* Inline/inline.scm 208 */
						BgL_nodez00_bglt BgL_arg3468z00_1460;

						{	/* Inline/inline.scm 208 */
							BgL_nodez00_bglt BgL_arg3469z00_1461;

							BgL_arg3469z00_1461 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1454))->
								BgL_exitz00);
							{	/* Inline/inline.scm 208 */
								BgL_nodez00_bglt BgL_res3566z00_2343;

								{	/* Inline/inline.scm 208 */
									long BgL_kfactorz00_2316;

									BgL_kfactorz00_2316 = (long) CINT(BgL_kfactorz00_1455);
									{	/* Inline/inline.scm 208 */
										obj_t BgL_method3258z00_2318;

										{	/* Inline/inline.scm 208 */
											BgL_objectz00_bglt BgL_objz00_2319;

											BgL_objz00_2319 =
												(BgL_objectz00_bglt) (BgL_arg3469z00_1461);
											{	/* Inline/inline.scm 208 */
												long BgL_objzd2classzd2numz00_2320;

												BgL_objzd2classzd2numz00_2320 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2319);
												{	/* Inline/inline.scm 208 */
													obj_t BgL_arg2551z00_2321;

													BgL_arg2551z00_2321 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 208 */
														obj_t BgL_arrayz00_2323;

														int BgL_offsetz00_2324;

														BgL_arrayz00_2323 = BgL_arg2551z00_2321;
														BgL_offsetz00_2324 =
															(int) (BgL_objzd2classzd2numz00_2320);
														{	/* Inline/inline.scm 208 */
															long BgL_offsetz00_2325;

															BgL_offsetz00_2325 =
																((long) (BgL_offsetz00_2324) - OBJECT_TYPE);
															{	/* Inline/inline.scm 208 */
																long BgL_modz00_2326;

																{	/* Inline/inline.scm 208 */
																	int BgL_arg2553z00_2327;

																	BgL_arg2553z00_2327 = (int) (((long) 8));
																	{	/* Inline/inline.scm 208 */
																		long BgL_auxz00_3242;

																		BgL_auxz00_3242 =
																			(long) (BgL_arg2553z00_2327);
																		BgL_modz00_2326 =
																			(BgL_offsetz00_2325 / BgL_auxz00_3242);
																}}
																{	/* Inline/inline.scm 208 */
																	long BgL_restz00_2328;

																	{	/* Inline/inline.scm 208 */
																		int BgL_arg2552z00_2329;

																		BgL_arg2552z00_2329 = (int) (((long) 8));
																		{	/* Inline/inline.scm 208 */
																			long BgL_auxz00_3246;

																			BgL_auxz00_3246 =
																				(long) (BgL_arg2552z00_2329);
																			BgL_restz00_2328 =
																				(BgL_offsetz00_2325 % BgL_auxz00_3246);
																	}}
																	{	/* Inline/inline.scm 208 */

																		BgL_method3258z00_2318 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2323,
																				(int) (BgL_modz00_2326)),
																			(int) (BgL_restz00_2328));
										}}}}}}}}
										BgL_res3566z00_2343 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2318) (BgL_method3258z00_2318,
												(obj_t) (BgL_arg3469z00_1461),
												BINT(BgL_kfactorz00_2316), BgL_stackz00_1456, BEOA));
								}}
								BgL_arg3468z00_1460 = BgL_res3566z00_2343;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1454))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3468z00_1460), BUNSPEC);
					}
					{	/* Inline/inline.scm 209 */
						BgL_nodez00_bglt BgL_arg3470z00_1462;

						{	/* Inline/inline.scm 209 */
							BgL_nodez00_bglt BgL_arg3471z00_1463;

							BgL_arg3471z00_1463 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1454))->
								BgL_valuez00);
							{	/* Inline/inline.scm 209 */
								BgL_nodez00_bglt BgL_res3569z00_2375;

								{	/* Inline/inline.scm 209 */
									long BgL_kfactorz00_2348;

									BgL_kfactorz00_2348 = (long) CINT(BgL_kfactorz00_1455);
									{	/* Inline/inline.scm 209 */
										obj_t BgL_method3258z00_2350;

										{	/* Inline/inline.scm 209 */
											BgL_objectz00_bglt BgL_objz00_2351;

											BgL_objz00_2351 =
												(BgL_objectz00_bglt) (BgL_arg3471z00_1463);
											{	/* Inline/inline.scm 209 */
												long BgL_objzd2classzd2numz00_2352;

												BgL_objzd2classzd2numz00_2352 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2351);
												{	/* Inline/inline.scm 209 */
													obj_t BgL_arg2551z00_2353;

													BgL_arg2551z00_2353 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 209 */
														obj_t BgL_arrayz00_2355;

														int BgL_offsetz00_2356;

														BgL_arrayz00_2355 = BgL_arg2551z00_2353;
														BgL_offsetz00_2356 =
															(int) (BgL_objzd2classzd2numz00_2352);
														{	/* Inline/inline.scm 209 */
															long BgL_offsetz00_2357;

															BgL_offsetz00_2357 =
																((long) (BgL_offsetz00_2356) - OBJECT_TYPE);
															{	/* Inline/inline.scm 209 */
																long BgL_modz00_2358;

																{	/* Inline/inline.scm 209 */
																	int BgL_arg2553z00_2359;

																	BgL_arg2553z00_2359 = (int) (((long) 8));
																	{	/* Inline/inline.scm 209 */
																		long BgL_auxz00_3269;

																		BgL_auxz00_3269 =
																			(long) (BgL_arg2553z00_2359);
																		BgL_modz00_2358 =
																			(BgL_offsetz00_2357 / BgL_auxz00_3269);
																}}
																{	/* Inline/inline.scm 209 */
																	long BgL_restz00_2360;

																	{	/* Inline/inline.scm 209 */
																		int BgL_arg2552z00_2361;

																		BgL_arg2552z00_2361 = (int) (((long) 8));
																		{	/* Inline/inline.scm 209 */
																			long BgL_auxz00_3273;

																			BgL_auxz00_3273 =
																				(long) (BgL_arg2552z00_2361);
																			BgL_restz00_2360 =
																				(BgL_offsetz00_2357 % BgL_auxz00_3273);
																	}}
																	{	/* Inline/inline.scm 209 */

																		BgL_method3258z00_2350 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2355,
																				(int) (BgL_modz00_2358)),
																			(int) (BgL_restz00_2360));
										}}}}}}}}
										BgL_res3569z00_2375 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2350) (BgL_method3258z00_2350,
												(obj_t) (BgL_arg3471z00_1463),
												BINT(BgL_kfactorz00_2348), BgL_stackz00_1456, BEOA));
								}}
								BgL_arg3470z00_1462 = BgL_res3569z00_2375;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1454))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3470z00_1462), BUNSPEC);
					}
					BgL_auxz00_3231 = BgL_nodez00_1454;
					return (obj_t) (BgL_auxz00_3231);
				}
			}
		}
	}



/* inline-node-set-ex-i3292 */
	obj_t BGl_inlinezd2nodezd2setzd2exzd2i3292z00zzinline_inlinez00(obj_t
		BgL_envz00_2647, obj_t BgL_nodez00_2648, obj_t BgL_kfactorz00_2649,
		obj_t BgL_stackz00_2650)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 199 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1445;

				obj_t BgL_kfactorz00_1446;

				obj_t BgL_stackz00_1447;

				{	/* Inline/inline.scm 200 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3288;

					BgL_nodez00_1445 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2648);
					BgL_kfactorz00_1446 = BgL_kfactorz00_2649;
					BgL_stackz00_1447 = BgL_stackz00_2650;
					{	/* Inline/inline.scm 200 */
						BgL_nodez00_bglt BgL_arg3465z00_2280;

						{	/* Inline/inline.scm 200 */
							BgL_nodez00_bglt BgL_arg3466z00_2281;

							BgL_arg3466z00_2281 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1445))->
								BgL_bodyz00);
							{	/* Inline/inline.scm 200 */
								BgL_nodez00_bglt BgL_res3563z00_2311;

								{	/* Inline/inline.scm 200 */
									long BgL_kfactorz00_2284;

									BgL_kfactorz00_2284 = (long) CINT(BgL_kfactorz00_1446);
									{	/* Inline/inline.scm 200 */
										obj_t BgL_method3258z00_2286;

										{	/* Inline/inline.scm 200 */
											BgL_objectz00_bglt BgL_objz00_2287;

											BgL_objz00_2287 =
												(BgL_objectz00_bglt) (BgL_arg3466z00_2281);
											{	/* Inline/inline.scm 200 */
												long BgL_objzd2classzd2numz00_2288;

												BgL_objzd2classzd2numz00_2288 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2287);
												{	/* Inline/inline.scm 200 */
													obj_t BgL_arg2551z00_2289;

													BgL_arg2551z00_2289 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 200 */
														obj_t BgL_arrayz00_2291;

														int BgL_offsetz00_2292;

														BgL_arrayz00_2291 = BgL_arg2551z00_2289;
														BgL_offsetz00_2292 =
															(int) (BgL_objzd2classzd2numz00_2288);
														{	/* Inline/inline.scm 200 */
															long BgL_offsetz00_2293;

															BgL_offsetz00_2293 =
																((long) (BgL_offsetz00_2292) - OBJECT_TYPE);
															{	/* Inline/inline.scm 200 */
																long BgL_modz00_2294;

																{	/* Inline/inline.scm 200 */
																	int BgL_arg2553z00_2295;

																	BgL_arg2553z00_2295 = (int) (((long) 8));
																	{	/* Inline/inline.scm 200 */
																		long BgL_auxz00_3299;

																		BgL_auxz00_3299 =
																			(long) (BgL_arg2553z00_2295);
																		BgL_modz00_2294 =
																			(BgL_offsetz00_2293 / BgL_auxz00_3299);
																}}
																{	/* Inline/inline.scm 200 */
																	long BgL_restz00_2296;

																	{	/* Inline/inline.scm 200 */
																		int BgL_arg2552z00_2297;

																		BgL_arg2552z00_2297 = (int) (((long) 8));
																		{	/* Inline/inline.scm 200 */
																			long BgL_auxz00_3303;

																			BgL_auxz00_3303 =
																				(long) (BgL_arg2552z00_2297);
																			BgL_restz00_2296 =
																				(BgL_offsetz00_2293 % BgL_auxz00_3303);
																	}}
																	{	/* Inline/inline.scm 200 */

																		BgL_method3258z00_2286 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2291,
																				(int) (BgL_modz00_2294)),
																			(int) (BgL_restz00_2296));
										}}}}}}}}
										BgL_res3563z00_2311 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2286) (BgL_method3258z00_2286,
												(obj_t) (BgL_arg3466z00_2281),
												BINT(BgL_kfactorz00_2284), BgL_stackz00_1447, BEOA));
								}}
								BgL_arg3465z00_2280 = BgL_res3563z00_2311;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1445))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3465z00_2280), BUNSPEC);
					}
					BgL_auxz00_3288 = BgL_nodez00_1445;
					return (obj_t) (BgL_auxz00_3288);
				}
			}
		}
	}



/* inline-node-let-var3290 */
	obj_t BGl_inlinezd2nodezd2letzd2var3290zd2zzinline_inlinez00(obj_t
		BgL_envz00_2651, obj_t BgL_nodez00_2652, obj_t BgL_kfactorz00_2653,
		obj_t BgL_stackz00_2654)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 189 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1426;

				obj_t BgL_kfactorz00_1427;

				obj_t BgL_stackz00_1428;

				{	/* Inline/inline.scm 190 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3318;

					BgL_nodez00_1426 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2652);
					BgL_kfactorz00_1427 = BgL_kfactorz00_2653;
					BgL_stackz00_1428 = BgL_stackz00_2654;
					{	/* Inline/inline.scm 190 */
						obj_t BgL_g3255z00_1431;

						BgL_g3255z00_1431 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1426))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3253z00_1433;

							BgL_l3253z00_1433 = BgL_g3255z00_1431;
						BgL_zc3anonymousza33457ze3z83_1434:
							if (PAIRP(BgL_l3253z00_1433))
								{	/* Inline/inline.scm 192 */
									{	/* Inline/inline.scm 191 */
										obj_t BgL_bindingz00_1436;

										BgL_bindingz00_1436 = CAR(BgL_l3253z00_1433);
										{	/* Inline/inline.scm 191 */
											BgL_nodez00_bglt BgL_arg3459z00_1437;

											{	/* Inline/inline.scm 191 */
												obj_t BgL_arg3460z00_1438;

												BgL_arg3460z00_1438 = CDR(BgL_bindingz00_1436);
												{	/* Inline/inline.scm 191 */
													BgL_nodez00_bglt BgL_res3557z00_2244;

													{	/* Inline/inline.scm 191 */
														BgL_nodez00_bglt BgL_nodez00_2216;

														long BgL_kfactorz00_2217;

														BgL_nodez00_2216 =
															(BgL_nodez00_bglt) (BgL_arg3460z00_1438);
														BgL_kfactorz00_2217 =
															(long) CINT(BgL_kfactorz00_1427);
														{	/* Inline/inline.scm 191 */
															obj_t BgL_method3258z00_2219;

															{	/* Inline/inline.scm 191 */
																BgL_objectz00_bglt BgL_objz00_2220;

																BgL_objz00_2220 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2216);
																{	/* Inline/inline.scm 191 */
																	long BgL_objzd2classzd2numz00_2221;

																	BgL_objzd2classzd2numz00_2221 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2220);
																	{	/* Inline/inline.scm 191 */
																		obj_t BgL_arg2551z00_2222;

																		BgL_arg2551z00_2222 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 191 */
																			obj_t BgL_arrayz00_2224;

																			int BgL_offsetz00_2225;

																			BgL_arrayz00_2224 = BgL_arg2551z00_2222;
																			BgL_offsetz00_2225 =
																				(int) (BgL_objzd2classzd2numz00_2221);
																			{	/* Inline/inline.scm 191 */
																				long BgL_offsetz00_2226;

																				BgL_offsetz00_2226 =
																					(
																					(long) (BgL_offsetz00_2225) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 191 */
																					long BgL_modz00_2227;

																					{	/* Inline/inline.scm 191 */
																						int BgL_arg2553z00_2228;

																						BgL_arg2553z00_2228 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 191 */
																							long BgL_auxz00_3334;

																							BgL_auxz00_3334 =
																								(long) (BgL_arg2553z00_2228);
																							BgL_modz00_2227 =
																								(BgL_offsetz00_2226 /
																								BgL_auxz00_3334);
																					}}
																					{	/* Inline/inline.scm 191 */
																						long BgL_restz00_2229;

																						{	/* Inline/inline.scm 191 */
																							int BgL_arg2552z00_2230;

																							BgL_arg2552z00_2230 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 191 */
																								long BgL_auxz00_3338;

																								BgL_auxz00_3338 =
																									(long) (BgL_arg2552z00_2230);
																								BgL_restz00_2229 =
																									(BgL_offsetz00_2226 %
																									BgL_auxz00_3338);
																						}}
																						{	/* Inline/inline.scm 191 */

																							BgL_method3258z00_2219 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2224,
																									(int) (BgL_modz00_2227)),
																								(int) (BgL_restz00_2229));
															}}}}}}}}
															BgL_res3557z00_2244 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3258z00_2219)
																(BgL_method3258z00_2219,
																	(obj_t) (BgL_nodez00_2216),
																	BINT(BgL_kfactorz00_2217), BgL_stackz00_1428,
																	BEOA));
													}}
													BgL_arg3459z00_1437 = BgL_res3557z00_2244;
											}}
											{	/* Inline/inline.scm 191 */
												obj_t BgL_auxz00_3350;

												BgL_auxz00_3350 = (obj_t) (BgL_arg3459z00_1437);
												SET_CDR(BgL_bindingz00_1436, BgL_auxz00_3350);
									}}}
									{
										obj_t BgL_l3253z00_3353;

										BgL_l3253z00_3353 = CDR(BgL_l3253z00_1433);
										BgL_l3253z00_1433 = BgL_l3253z00_3353;
										goto BgL_zc3anonymousza33457ze3z83_1434;
									}
								}
							else
								{	/* Inline/inline.scm 192 */
									((bool_t) 1);
								}
						}
					}
					{	/* Inline/inline.scm 193 */
						BgL_nodez00_bglt BgL_arg3462z00_1441;

						{	/* Inline/inline.scm 193 */
							BgL_nodez00_bglt BgL_arg3463z00_1442;

							BgL_arg3463z00_1442 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1426))->BgL_bodyz00);
							{	/* Inline/inline.scm 193 */
								BgL_nodez00_bglt BgL_res3560z00_2277;

								{	/* Inline/inline.scm 193 */
									long BgL_kfactorz00_2250;

									BgL_kfactorz00_2250 = (long) CINT(BgL_kfactorz00_1427);
									{	/* Inline/inline.scm 193 */
										obj_t BgL_method3258z00_2252;

										{	/* Inline/inline.scm 193 */
											BgL_objectz00_bglt BgL_objz00_2253;

											BgL_objz00_2253 =
												(BgL_objectz00_bglt) (BgL_arg3463z00_1442);
											{	/* Inline/inline.scm 193 */
												long BgL_objzd2classzd2numz00_2254;

												BgL_objzd2classzd2numz00_2254 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2253);
												{	/* Inline/inline.scm 193 */
													obj_t BgL_arg2551z00_2255;

													BgL_arg2551z00_2255 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 193 */
														obj_t BgL_arrayz00_2257;

														int BgL_offsetz00_2258;

														BgL_arrayz00_2257 = BgL_arg2551z00_2255;
														BgL_offsetz00_2258 =
															(int) (BgL_objzd2classzd2numz00_2254);
														{	/* Inline/inline.scm 193 */
															long BgL_offsetz00_2259;

															BgL_offsetz00_2259 =
																((long) (BgL_offsetz00_2258) - OBJECT_TYPE);
															{	/* Inline/inline.scm 193 */
																long BgL_modz00_2260;

																{	/* Inline/inline.scm 193 */
																	int BgL_arg2553z00_2261;

																	BgL_arg2553z00_2261 = (int) (((long) 8));
																	{	/* Inline/inline.scm 193 */
																		long BgL_auxz00_3365;

																		BgL_auxz00_3365 =
																			(long) (BgL_arg2553z00_2261);
																		BgL_modz00_2260 =
																			(BgL_offsetz00_2259 / BgL_auxz00_3365);
																}}
																{	/* Inline/inline.scm 193 */
																	long BgL_restz00_2262;

																	{	/* Inline/inline.scm 193 */
																		int BgL_arg2552z00_2263;

																		BgL_arg2552z00_2263 = (int) (((long) 8));
																		{	/* Inline/inline.scm 193 */
																			long BgL_auxz00_3369;

																			BgL_auxz00_3369 =
																				(long) (BgL_arg2552z00_2263);
																			BgL_restz00_2262 =
																				(BgL_offsetz00_2259 % BgL_auxz00_3369);
																	}}
																	{	/* Inline/inline.scm 193 */

																		BgL_method3258z00_2252 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2257,
																				(int) (BgL_modz00_2260)),
																			(int) (BgL_restz00_2262));
										}}}}}}}}
										BgL_res3560z00_2277 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2252) (BgL_method3258z00_2252,
												(obj_t) (BgL_arg3463z00_1442),
												BINT(BgL_kfactorz00_2250), BgL_stackz00_1428, BEOA));
								}}
								BgL_arg3462z00_1441 = BgL_res3560z00_2277;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1426))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3462z00_1441), BUNSPEC);
					}
					BgL_auxz00_3318 = BgL_nodez00_1426;
					return (obj_t) (BgL_auxz00_3318);
				}
			}
		}
	}



/* inline-node-let-fun3288 */
	obj_t BGl_inlinezd2nodezd2letzd2fun3288zd2zzinline_inlinez00(obj_t
		BgL_envz00_2655, obj_t BgL_nodez00_2656, obj_t BgL_kfactorz00_2657,
		obj_t BgL_stackz00_2658)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 179 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1409;

				obj_t BgL_kfactorz00_1410;

				obj_t BgL_stackz00_1411;

				{	/* Inline/inline.scm 180 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3384;

					BgL_nodez00_1409 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2656);
					BgL_kfactorz00_1410 = BgL_kfactorz00_2657;
					BgL_stackz00_1411 = BgL_stackz00_2658;
					{	/* Inline/inline.scm 180 */
						BgL_nodez00_bglt BgL_arg3451z00_1414;

						{	/* Inline/inline.scm 180 */
							BgL_nodez00_bglt BgL_arg3452z00_1415;

							BgL_arg3452z00_1415 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1409))->BgL_bodyz00);
							{	/* Inline/inline.scm 180 */
								BgL_nodez00_bglt BgL_res3554z00_2205;

								{	/* Inline/inline.scm 180 */
									long BgL_kfactorz00_2178;

									BgL_kfactorz00_2178 = (long) CINT(BgL_kfactorz00_1410);
									{	/* Inline/inline.scm 180 */
										obj_t BgL_method3258z00_2180;

										{	/* Inline/inline.scm 180 */
											BgL_objectz00_bglt BgL_objz00_2181;

											BgL_objz00_2181 =
												(BgL_objectz00_bglt) (BgL_arg3452z00_1415);
											{	/* Inline/inline.scm 180 */
												long BgL_objzd2classzd2numz00_2182;

												BgL_objzd2classzd2numz00_2182 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2181);
												{	/* Inline/inline.scm 180 */
													obj_t BgL_arg2551z00_2183;

													BgL_arg2551z00_2183 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 180 */
														obj_t BgL_arrayz00_2185;

														int BgL_offsetz00_2186;

														BgL_arrayz00_2185 = BgL_arg2551z00_2183;
														BgL_offsetz00_2186 =
															(int) (BgL_objzd2classzd2numz00_2182);
														{	/* Inline/inline.scm 180 */
															long BgL_offsetz00_2187;

															BgL_offsetz00_2187 =
																((long) (BgL_offsetz00_2186) - OBJECT_TYPE);
															{	/* Inline/inline.scm 180 */
																long BgL_modz00_2188;

																{	/* Inline/inline.scm 180 */
																	int BgL_arg2553z00_2189;

																	BgL_arg2553z00_2189 = (int) (((long) 8));
																	{	/* Inline/inline.scm 180 */
																		long BgL_auxz00_3395;

																		BgL_auxz00_3395 =
																			(long) (BgL_arg2553z00_2189);
																		BgL_modz00_2188 =
																			(BgL_offsetz00_2187 / BgL_auxz00_3395);
																}}
																{	/* Inline/inline.scm 180 */
																	long BgL_restz00_2190;

																	{	/* Inline/inline.scm 180 */
																		int BgL_arg2552z00_2191;

																		BgL_arg2552z00_2191 = (int) (((long) 8));
																		{	/* Inline/inline.scm 180 */
																			long BgL_auxz00_3399;

																			BgL_auxz00_3399 =
																				(long) (BgL_arg2552z00_2191);
																			BgL_restz00_2190 =
																				(BgL_offsetz00_2187 % BgL_auxz00_3399);
																	}}
																	{	/* Inline/inline.scm 180 */

																		BgL_method3258z00_2180 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2185,
																				(int) (BgL_modz00_2188)),
																			(int) (BgL_restz00_2190));
										}}}}}}}}
										BgL_res3554z00_2205 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2180) (BgL_method3258z00_2180,
												(obj_t) (BgL_arg3452z00_1415),
												BINT(BgL_kfactorz00_2178), BgL_stackz00_1411, BEOA));
								}}
								BgL_arg3451z00_1414 = BgL_res3554z00_2205;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1409))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3451z00_1414), BUNSPEC);
					}
					{	/* Inline/inline.scm 181 */
						obj_t BgL_g3252z00_1416;

						BgL_g3252z00_1416 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1409))->BgL_localsz00);
						{
							obj_t BgL_l3250z00_1418;

							BgL_l3250z00_1418 = BgL_g3252z00_1416;
						BgL_zc3anonymousza33453ze3z83_1419:
							if (PAIRP(BgL_l3250z00_1418))
								{	/* Inline/inline.scm 183 */
									{	/* Inline/inline.scm 182 */
										obj_t BgL_localz00_1421;

										BgL_localz00_1421 = CAR(BgL_l3250z00_1418);
										BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
											(BgL_variablez00_bglt) (BgL_localz00_1421),
											(long) CINT(BgL_kfactorz00_1410), BgL_stackz00_1411);
									}
									{
										obj_t BgL_l3250z00_3419;

										BgL_l3250z00_3419 = CDR(BgL_l3250z00_1418);
										BgL_l3250z00_1418 = BgL_l3250z00_3419;
										goto BgL_zc3anonymousza33453ze3z83_1419;
									}
								}
							else
								{	/* Inline/inline.scm 183 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3384 = BgL_nodez00_1409;
					return (obj_t) (BgL_auxz00_3384);
				}
			}
		}
	}



/* inline-node-select3286 */
	obj_t BGl_inlinezd2nodezd2select3286z00zzinline_inlinez00(obj_t
		BgL_envz00_2659, obj_t BgL_nodez00_2660, obj_t BgL_kfactorz00_2661,
		obj_t BgL_stackz00_2662)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 169 */
			{
				BgL_selectz00_bglt BgL_nodez00_1390;

				obj_t BgL_kfactorz00_1391;

				obj_t BgL_stackz00_1392;

				{	/* Inline/inline.scm 170 */
					BgL_selectz00_bglt BgL_auxz00_3423;

					BgL_nodez00_1390 = (BgL_selectz00_bglt) (BgL_nodez00_2660);
					BgL_kfactorz00_1391 = BgL_kfactorz00_2661;
					BgL_stackz00_1392 = BgL_stackz00_2662;
					{	/* Inline/inline.scm 170 */
						BgL_nodez00_bglt BgL_arg3443z00_1395;

						{	/* Inline/inline.scm 170 */
							BgL_nodez00_bglt BgL_arg3444z00_1396;

							BgL_arg3444z00_1396 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1390))->BgL_testz00);
							{	/* Inline/inline.scm 170 */
								BgL_nodez00_bglt BgL_res3548z00_2137;

								{	/* Inline/inline.scm 170 */
									long BgL_kfactorz00_2110;

									BgL_kfactorz00_2110 = (long) CINT(BgL_kfactorz00_1391);
									{	/* Inline/inline.scm 170 */
										obj_t BgL_method3258z00_2112;

										{	/* Inline/inline.scm 170 */
											BgL_objectz00_bglt BgL_objz00_2113;

											BgL_objz00_2113 =
												(BgL_objectz00_bglt) (BgL_arg3444z00_1396);
											{	/* Inline/inline.scm 170 */
												long BgL_objzd2classzd2numz00_2114;

												BgL_objzd2classzd2numz00_2114 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2113);
												{	/* Inline/inline.scm 170 */
													obj_t BgL_arg2551z00_2115;

													BgL_arg2551z00_2115 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 170 */
														obj_t BgL_arrayz00_2117;

														int BgL_offsetz00_2118;

														BgL_arrayz00_2117 = BgL_arg2551z00_2115;
														BgL_offsetz00_2118 =
															(int) (BgL_objzd2classzd2numz00_2114);
														{	/* Inline/inline.scm 170 */
															long BgL_offsetz00_2119;

															BgL_offsetz00_2119 =
																((long) (BgL_offsetz00_2118) - OBJECT_TYPE);
															{	/* Inline/inline.scm 170 */
																long BgL_modz00_2120;

																{	/* Inline/inline.scm 170 */
																	int BgL_arg2553z00_2121;

																	BgL_arg2553z00_2121 = (int) (((long) 8));
																	{	/* Inline/inline.scm 170 */
																		long BgL_auxz00_3434;

																		BgL_auxz00_3434 =
																			(long) (BgL_arg2553z00_2121);
																		BgL_modz00_2120 =
																			(BgL_offsetz00_2119 / BgL_auxz00_3434);
																}}
																{	/* Inline/inline.scm 170 */
																	long BgL_restz00_2122;

																	{	/* Inline/inline.scm 170 */
																		int BgL_arg2552z00_2123;

																		BgL_arg2552z00_2123 = (int) (((long) 8));
																		{	/* Inline/inline.scm 170 */
																			long BgL_auxz00_3438;

																			BgL_auxz00_3438 =
																				(long) (BgL_arg2552z00_2123);
																			BgL_restz00_2122 =
																				(BgL_offsetz00_2119 % BgL_auxz00_3438);
																	}}
																	{	/* Inline/inline.scm 170 */

																		BgL_method3258z00_2112 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2117,
																				(int) (BgL_modz00_2120)),
																			(int) (BgL_restz00_2122));
										}}}}}}}}
										BgL_res3548z00_2137 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2112) (BgL_method3258z00_2112,
												(obj_t) (BgL_arg3444z00_1396),
												BINT(BgL_kfactorz00_2110), BgL_stackz00_1392, BEOA));
								}}
								BgL_arg3443z00_1395 = BgL_res3548z00_2137;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1390))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3443z00_1395), BUNSPEC);
					}
					{	/* Inline/inline.scm 171 */
						obj_t BgL_g3249z00_1397;

						BgL_g3249z00_1397 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1390))->BgL_clausesz00);
						{
							obj_t BgL_l3247z00_1399;

							BgL_l3247z00_1399 = BgL_g3249z00_1397;
						BgL_zc3anonymousza33445ze3z83_1400:
							if (PAIRP(BgL_l3247z00_1399))
								{	/* Inline/inline.scm 173 */
									{	/* Inline/inline.scm 172 */
										obj_t BgL_clausez00_1402;

										BgL_clausez00_1402 = CAR(BgL_l3247z00_1399);
										{	/* Inline/inline.scm 172 */
											BgL_nodez00_bglt BgL_arg3447z00_1403;

											{	/* Inline/inline.scm 172 */
												obj_t BgL_arg3448z00_1404;

												BgL_arg3448z00_1404 = CDR(BgL_clausez00_1402);
												{	/* Inline/inline.scm 172 */
													BgL_nodez00_bglt BgL_res3551z00_2172;

													{	/* Inline/inline.scm 172 */
														BgL_nodez00_bglt BgL_nodez00_2144;

														long BgL_kfactorz00_2145;

														BgL_nodez00_2144 =
															(BgL_nodez00_bglt) (BgL_arg3448z00_1404);
														BgL_kfactorz00_2145 =
															(long) CINT(BgL_kfactorz00_1391);
														{	/* Inline/inline.scm 172 */
															obj_t BgL_method3258z00_2147;

															{	/* Inline/inline.scm 172 */
																BgL_objectz00_bglt BgL_objz00_2148;

																BgL_objz00_2148 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2144);
																{	/* Inline/inline.scm 172 */
																	long BgL_objzd2classzd2numz00_2149;

																	BgL_objzd2classzd2numz00_2149 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2148);
																	{	/* Inline/inline.scm 172 */
																		obj_t BgL_arg2551z00_2150;

																		BgL_arg2551z00_2150 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 172 */
																			obj_t BgL_arrayz00_2152;

																			int BgL_offsetz00_2153;

																			BgL_arrayz00_2152 = BgL_arg2551z00_2150;
																			BgL_offsetz00_2153 =
																				(int) (BgL_objzd2classzd2numz00_2149);
																			{	/* Inline/inline.scm 172 */
																				long BgL_offsetz00_2154;

																				BgL_offsetz00_2154 =
																					(
																					(long) (BgL_offsetz00_2153) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 172 */
																					long BgL_modz00_2155;

																					{	/* Inline/inline.scm 172 */
																						int BgL_arg2553z00_2156;

																						BgL_arg2553z00_2156 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 172 */
																							long BgL_auxz00_3466;

																							BgL_auxz00_3466 =
																								(long) (BgL_arg2553z00_2156);
																							BgL_modz00_2155 =
																								(BgL_offsetz00_2154 /
																								BgL_auxz00_3466);
																					}}
																					{	/* Inline/inline.scm 172 */
																						long BgL_restz00_2157;

																						{	/* Inline/inline.scm 172 */
																							int BgL_arg2552z00_2158;

																							BgL_arg2552z00_2158 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 172 */
																								long BgL_auxz00_3470;

																								BgL_auxz00_3470 =
																									(long) (BgL_arg2552z00_2158);
																								BgL_restz00_2157 =
																									(BgL_offsetz00_2154 %
																									BgL_auxz00_3470);
																						}}
																						{	/* Inline/inline.scm 172 */

																							BgL_method3258z00_2147 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2152,
																									(int) (BgL_modz00_2155)),
																								(int) (BgL_restz00_2157));
															}}}}}}}}
															BgL_res3551z00_2172 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3258z00_2147)
																(BgL_method3258z00_2147,
																	(obj_t) (BgL_nodez00_2144),
																	BINT(BgL_kfactorz00_2145), BgL_stackz00_1392,
																	BEOA));
													}}
													BgL_arg3447z00_1403 = BgL_res3551z00_2172;
											}}
											{	/* Inline/inline.scm 172 */
												obj_t BgL_auxz00_3482;

												BgL_auxz00_3482 = (obj_t) (BgL_arg3447z00_1403);
												SET_CDR(BgL_clausez00_1402, BgL_auxz00_3482);
									}}}
									{
										obj_t BgL_l3247z00_3485;

										BgL_l3247z00_3485 = CDR(BgL_l3247z00_1399);
										BgL_l3247z00_1399 = BgL_l3247z00_3485;
										goto BgL_zc3anonymousza33445ze3z83_1400;
									}
								}
							else
								{	/* Inline/inline.scm 173 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3423 = BgL_nodez00_1390;
					return (obj_t) (BgL_auxz00_3423);
				}
			}
		}
	}



/* inline-node-fail3284 */
	obj_t BGl_inlinezd2nodezd2fail3284z00zzinline_inlinez00(obj_t BgL_envz00_2663,
		obj_t BgL_nodez00_2664, obj_t BgL_kfactorz00_2665, obj_t BgL_stackz00_2666)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 159 */
			{
				BgL_failz00_bglt BgL_nodez00_1376;

				obj_t BgL_kfactorz00_1377;

				obj_t BgL_stackz00_1378;

				{	/* Inline/inline.scm 160 */
					BgL_failz00_bglt BgL_auxz00_3489;

					BgL_nodez00_1376 = (BgL_failz00_bglt) (BgL_nodez00_2664);
					BgL_kfactorz00_1377 = BgL_kfactorz00_2665;
					BgL_stackz00_1378 = BgL_stackz00_2666;
					{	/* Inline/inline.scm 161 */
						BgL_nodez00_bglt BgL_arg3436z00_1382;

						{	/* Inline/inline.scm 161 */
							BgL_nodez00_bglt BgL_arg3437z00_1383;

							BgL_arg3437z00_1383 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_procz00);
							{	/* Inline/inline.scm 161 */
								BgL_nodez00_bglt BgL_res3539z00_2041;

								{	/* Inline/inline.scm 161 */
									long BgL_kfactorz00_2014;

									BgL_kfactorz00_2014 = (long) CINT(BgL_kfactorz00_1377);
									{	/* Inline/inline.scm 161 */
										obj_t BgL_method3258z00_2016;

										{	/* Inline/inline.scm 161 */
											BgL_objectz00_bglt BgL_objz00_2017;

											BgL_objz00_2017 =
												(BgL_objectz00_bglt) (BgL_arg3437z00_1383);
											{	/* Inline/inline.scm 161 */
												long BgL_objzd2classzd2numz00_2018;

												BgL_objzd2classzd2numz00_2018 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2017);
												{	/* Inline/inline.scm 161 */
													obj_t BgL_arg2551z00_2019;

													BgL_arg2551z00_2019 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 161 */
														obj_t BgL_arrayz00_2021;

														int BgL_offsetz00_2022;

														BgL_arrayz00_2021 = BgL_arg2551z00_2019;
														BgL_offsetz00_2022 =
															(int) (BgL_objzd2classzd2numz00_2018);
														{	/* Inline/inline.scm 161 */
															long BgL_offsetz00_2023;

															BgL_offsetz00_2023 =
																((long) (BgL_offsetz00_2022) - OBJECT_TYPE);
															{	/* Inline/inline.scm 161 */
																long BgL_modz00_2024;

																{	/* Inline/inline.scm 161 */
																	int BgL_arg2553z00_2025;

																	BgL_arg2553z00_2025 = (int) (((long) 8));
																	{	/* Inline/inline.scm 161 */
																		long BgL_auxz00_3500;

																		BgL_auxz00_3500 =
																			(long) (BgL_arg2553z00_2025);
																		BgL_modz00_2024 =
																			(BgL_offsetz00_2023 / BgL_auxz00_3500);
																}}
																{	/* Inline/inline.scm 161 */
																	long BgL_restz00_2026;

																	{	/* Inline/inline.scm 161 */
																		int BgL_arg2552z00_2027;

																		BgL_arg2552z00_2027 = (int) (((long) 8));
																		{	/* Inline/inline.scm 161 */
																			long BgL_auxz00_3504;

																			BgL_auxz00_3504 =
																				(long) (BgL_arg2552z00_2027);
																			BgL_restz00_2026 =
																				(BgL_offsetz00_2023 % BgL_auxz00_3504);
																	}}
																	{	/* Inline/inline.scm 161 */

																		BgL_method3258z00_2016 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2021,
																				(int) (BgL_modz00_2024)),
																			(int) (BgL_restz00_2026));
										}}}}}}}}
										BgL_res3539z00_2041 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2016) (BgL_method3258z00_2016,
												(obj_t) (BgL_arg3437z00_1383),
												BINT(BgL_kfactorz00_2014), BgL_stackz00_1378, BEOA));
								}}
								BgL_arg3436z00_1382 = BgL_res3539z00_2041;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3436z00_1382), BUNSPEC);
					}
					{	/* Inline/inline.scm 162 */
						BgL_nodez00_bglt BgL_arg3438z00_1384;

						{	/* Inline/inline.scm 162 */
							BgL_nodez00_bglt BgL_arg3439z00_1385;

							BgL_arg3439z00_1385 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_msgz00);
							{	/* Inline/inline.scm 162 */
								BgL_nodez00_bglt BgL_res3542z00_2073;

								{	/* Inline/inline.scm 162 */
									long BgL_kfactorz00_2046;

									BgL_kfactorz00_2046 = (long) CINT(BgL_kfactorz00_1377);
									{	/* Inline/inline.scm 162 */
										obj_t BgL_method3258z00_2048;

										{	/* Inline/inline.scm 162 */
											BgL_objectz00_bglt BgL_objz00_2049;

											BgL_objz00_2049 =
												(BgL_objectz00_bglt) (BgL_arg3439z00_1385);
											{	/* Inline/inline.scm 162 */
												long BgL_objzd2classzd2numz00_2050;

												BgL_objzd2classzd2numz00_2050 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2049);
												{	/* Inline/inline.scm 162 */
													obj_t BgL_arg2551z00_2051;

													BgL_arg2551z00_2051 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 162 */
														obj_t BgL_arrayz00_2053;

														int BgL_offsetz00_2054;

														BgL_arrayz00_2053 = BgL_arg2551z00_2051;
														BgL_offsetz00_2054 =
															(int) (BgL_objzd2classzd2numz00_2050);
														{	/* Inline/inline.scm 162 */
															long BgL_offsetz00_2055;

															BgL_offsetz00_2055 =
																((long) (BgL_offsetz00_2054) - OBJECT_TYPE);
															{	/* Inline/inline.scm 162 */
																long BgL_modz00_2056;

																{	/* Inline/inline.scm 162 */
																	int BgL_arg2553z00_2057;

																	BgL_arg2553z00_2057 = (int) (((long) 8));
																	{	/* Inline/inline.scm 162 */
																		long BgL_auxz00_3527;

																		BgL_auxz00_3527 =
																			(long) (BgL_arg2553z00_2057);
																		BgL_modz00_2056 =
																			(BgL_offsetz00_2055 / BgL_auxz00_3527);
																}}
																{	/* Inline/inline.scm 162 */
																	long BgL_restz00_2058;

																	{	/* Inline/inline.scm 162 */
																		int BgL_arg2552z00_2059;

																		BgL_arg2552z00_2059 = (int) (((long) 8));
																		{	/* Inline/inline.scm 162 */
																			long BgL_auxz00_3531;

																			BgL_auxz00_3531 =
																				(long) (BgL_arg2552z00_2059);
																			BgL_restz00_2058 =
																				(BgL_offsetz00_2055 % BgL_auxz00_3531);
																	}}
																	{	/* Inline/inline.scm 162 */

																		BgL_method3258z00_2048 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2053,
																				(int) (BgL_modz00_2056)),
																			(int) (BgL_restz00_2058));
										}}}}}}}}
										BgL_res3542z00_2073 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2048) (BgL_method3258z00_2048,
												(obj_t) (BgL_arg3439z00_1385),
												BINT(BgL_kfactorz00_2046), BgL_stackz00_1378, BEOA));
								}}
								BgL_arg3438z00_1384 = BgL_res3542z00_2073;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3438z00_1384), BUNSPEC);
					}
					{	/* Inline/inline.scm 163 */
						BgL_nodez00_bglt BgL_arg3440z00_1386;

						{	/* Inline/inline.scm 163 */
							BgL_nodez00_bglt BgL_arg3441z00_1387;

							BgL_arg3441z00_1387 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_objz00);
							{	/* Inline/inline.scm 163 */
								BgL_nodez00_bglt BgL_res3545z00_2105;

								{	/* Inline/inline.scm 163 */
									long BgL_kfactorz00_2078;

									BgL_kfactorz00_2078 = (long) CINT(BgL_kfactorz00_1377);
									{	/* Inline/inline.scm 163 */
										obj_t BgL_method3258z00_2080;

										{	/* Inline/inline.scm 163 */
											BgL_objectz00_bglt BgL_objz00_2081;

											BgL_objz00_2081 =
												(BgL_objectz00_bglt) (BgL_arg3441z00_1387);
											{	/* Inline/inline.scm 163 */
												long BgL_objzd2classzd2numz00_2082;

												BgL_objzd2classzd2numz00_2082 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2081);
												{	/* Inline/inline.scm 163 */
													obj_t BgL_arg2551z00_2083;

													BgL_arg2551z00_2083 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 163 */
														obj_t BgL_arrayz00_2085;

														int BgL_offsetz00_2086;

														BgL_arrayz00_2085 = BgL_arg2551z00_2083;
														BgL_offsetz00_2086 =
															(int) (BgL_objzd2classzd2numz00_2082);
														{	/* Inline/inline.scm 163 */
															long BgL_offsetz00_2087;

															BgL_offsetz00_2087 =
																((long) (BgL_offsetz00_2086) - OBJECT_TYPE);
															{	/* Inline/inline.scm 163 */
																long BgL_modz00_2088;

																{	/* Inline/inline.scm 163 */
																	int BgL_arg2553z00_2089;

																	BgL_arg2553z00_2089 = (int) (((long) 8));
																	{	/* Inline/inline.scm 163 */
																		long BgL_auxz00_3554;

																		BgL_auxz00_3554 =
																			(long) (BgL_arg2553z00_2089);
																		BgL_modz00_2088 =
																			(BgL_offsetz00_2087 / BgL_auxz00_3554);
																}}
																{	/* Inline/inline.scm 163 */
																	long BgL_restz00_2090;

																	{	/* Inline/inline.scm 163 */
																		int BgL_arg2552z00_2091;

																		BgL_arg2552z00_2091 = (int) (((long) 8));
																		{	/* Inline/inline.scm 163 */
																			long BgL_auxz00_3558;

																			BgL_auxz00_3558 =
																				(long) (BgL_arg2552z00_2091);
																			BgL_restz00_2090 =
																				(BgL_offsetz00_2087 % BgL_auxz00_3558);
																	}}
																	{	/* Inline/inline.scm 163 */

																		BgL_method3258z00_2080 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2085,
																				(int) (BgL_modz00_2088)),
																			(int) (BgL_restz00_2090));
										}}}}}}}}
										BgL_res3545z00_2105 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_2080) (BgL_method3258z00_2080,
												(obj_t) (BgL_arg3441z00_1387),
												BINT(BgL_kfactorz00_2078), BgL_stackz00_1378, BEOA));
								}}
								BgL_arg3440z00_1386 = BgL_res3545z00_2105;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1376))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3440z00_1386), BUNSPEC);
					}
					BgL_auxz00_3489 = BgL_nodez00_1376;
					return (obj_t) (BgL_auxz00_3489);
				}
			}
		}
	}



/* inline-node-conditio3282 */
	obj_t BGl_inlinezd2nodezd2conditio3282z00zzinline_inlinez00(obj_t
		BgL_envz00_2667, obj_t BgL_nodez00_2668, obj_t BgL_kfactorz00_2669,
		obj_t BgL_stackz00_2670)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 149 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1362;

				obj_t BgL_kfactorz00_1363;

				obj_t BgL_stackz00_1364;

				{	/* Inline/inline.scm 150 */
					BgL_conditionalz00_bglt BgL_auxz00_3573;

					BgL_nodez00_1362 = (BgL_conditionalz00_bglt) (BgL_nodez00_2668);
					BgL_kfactorz00_1363 = BgL_kfactorz00_2669;
					BgL_stackz00_1364 = BgL_stackz00_2670;
					{	/* Inline/inline.scm 151 */
						BgL_nodez00_bglt BgL_arg3428z00_1368;

						{	/* Inline/inline.scm 151 */
							BgL_nodez00_bglt BgL_arg3429z00_1369;

							BgL_arg3429z00_1369 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->
								BgL_testz00);
							{	/* Inline/inline.scm 151 */
								BgL_nodez00_bglt BgL_res3530z00_1945;

								{	/* Inline/inline.scm 151 */
									long BgL_kfactorz00_1918;

									BgL_kfactorz00_1918 = (long) CINT(BgL_kfactorz00_1363);
									{	/* Inline/inline.scm 151 */
										obj_t BgL_method3258z00_1920;

										{	/* Inline/inline.scm 151 */
											BgL_objectz00_bglt BgL_objz00_1921;

											BgL_objz00_1921 =
												(BgL_objectz00_bglt) (BgL_arg3429z00_1369);
											{	/* Inline/inline.scm 151 */
												long BgL_objzd2classzd2numz00_1922;

												BgL_objzd2classzd2numz00_1922 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1921);
												{	/* Inline/inline.scm 151 */
													obj_t BgL_arg2551z00_1923;

													BgL_arg2551z00_1923 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 151 */
														obj_t BgL_arrayz00_1925;

														int BgL_offsetz00_1926;

														BgL_arrayz00_1925 = BgL_arg2551z00_1923;
														BgL_offsetz00_1926 =
															(int) (BgL_objzd2classzd2numz00_1922);
														{	/* Inline/inline.scm 151 */
															long BgL_offsetz00_1927;

															BgL_offsetz00_1927 =
																((long) (BgL_offsetz00_1926) - OBJECT_TYPE);
															{	/* Inline/inline.scm 151 */
																long BgL_modz00_1928;

																{	/* Inline/inline.scm 151 */
																	int BgL_arg2553z00_1929;

																	BgL_arg2553z00_1929 = (int) (((long) 8));
																	{	/* Inline/inline.scm 151 */
																		long BgL_auxz00_3584;

																		BgL_auxz00_3584 =
																			(long) (BgL_arg2553z00_1929);
																		BgL_modz00_1928 =
																			(BgL_offsetz00_1927 / BgL_auxz00_3584);
																}}
																{	/* Inline/inline.scm 151 */
																	long BgL_restz00_1930;

																	{	/* Inline/inline.scm 151 */
																		int BgL_arg2552z00_1931;

																		BgL_arg2552z00_1931 = (int) (((long) 8));
																		{	/* Inline/inline.scm 151 */
																			long BgL_auxz00_3588;

																			BgL_auxz00_3588 =
																				(long) (BgL_arg2552z00_1931);
																			BgL_restz00_1930 =
																				(BgL_offsetz00_1927 % BgL_auxz00_3588);
																	}}
																	{	/* Inline/inline.scm 151 */

																		BgL_method3258z00_1920 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1925,
																				(int) (BgL_modz00_1928)),
																			(int) (BgL_restz00_1930));
										}}}}}}}}
										BgL_res3530z00_1945 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1920) (BgL_method3258z00_1920,
												(obj_t) (BgL_arg3429z00_1369),
												BINT(BgL_kfactorz00_1918), BgL_stackz00_1364, BEOA));
								}}
								BgL_arg3428z00_1368 = BgL_res3530z00_1945;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3428z00_1368), BUNSPEC);
					}
					{	/* Inline/inline.scm 152 */
						BgL_nodez00_bglt BgL_arg3430z00_1370;

						{	/* Inline/inline.scm 152 */
							BgL_nodez00_bglt BgL_arg3431z00_1371;

							BgL_arg3431z00_1371 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->
								BgL_truez00);
							{	/* Inline/inline.scm 152 */
								BgL_nodez00_bglt BgL_res3533z00_1977;

								{	/* Inline/inline.scm 152 */
									long BgL_kfactorz00_1950;

									BgL_kfactorz00_1950 = (long) CINT(BgL_kfactorz00_1363);
									{	/* Inline/inline.scm 152 */
										obj_t BgL_method3258z00_1952;

										{	/* Inline/inline.scm 152 */
											BgL_objectz00_bglt BgL_objz00_1953;

											BgL_objz00_1953 =
												(BgL_objectz00_bglt) (BgL_arg3431z00_1371);
											{	/* Inline/inline.scm 152 */
												long BgL_objzd2classzd2numz00_1954;

												BgL_objzd2classzd2numz00_1954 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1953);
												{	/* Inline/inline.scm 152 */
													obj_t BgL_arg2551z00_1955;

													BgL_arg2551z00_1955 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 152 */
														obj_t BgL_arrayz00_1957;

														int BgL_offsetz00_1958;

														BgL_arrayz00_1957 = BgL_arg2551z00_1955;
														BgL_offsetz00_1958 =
															(int) (BgL_objzd2classzd2numz00_1954);
														{	/* Inline/inline.scm 152 */
															long BgL_offsetz00_1959;

															BgL_offsetz00_1959 =
																((long) (BgL_offsetz00_1958) - OBJECT_TYPE);
															{	/* Inline/inline.scm 152 */
																long BgL_modz00_1960;

																{	/* Inline/inline.scm 152 */
																	int BgL_arg2553z00_1961;

																	BgL_arg2553z00_1961 = (int) (((long) 8));
																	{	/* Inline/inline.scm 152 */
																		long BgL_auxz00_3611;

																		BgL_auxz00_3611 =
																			(long) (BgL_arg2553z00_1961);
																		BgL_modz00_1960 =
																			(BgL_offsetz00_1959 / BgL_auxz00_3611);
																}}
																{	/* Inline/inline.scm 152 */
																	long BgL_restz00_1962;

																	{	/* Inline/inline.scm 152 */
																		int BgL_arg2552z00_1963;

																		BgL_arg2552z00_1963 = (int) (((long) 8));
																		{	/* Inline/inline.scm 152 */
																			long BgL_auxz00_3615;

																			BgL_auxz00_3615 =
																				(long) (BgL_arg2552z00_1963);
																			BgL_restz00_1962 =
																				(BgL_offsetz00_1959 % BgL_auxz00_3615);
																	}}
																	{	/* Inline/inline.scm 152 */

																		BgL_method3258z00_1952 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1957,
																				(int) (BgL_modz00_1960)),
																			(int) (BgL_restz00_1962));
										}}}}}}}}
										BgL_res3533z00_1977 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1952) (BgL_method3258z00_1952,
												(obj_t) (BgL_arg3431z00_1371),
												BINT(BgL_kfactorz00_1950), BgL_stackz00_1364, BEOA));
								}}
								BgL_arg3430z00_1370 = BgL_res3533z00_1977;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3430z00_1370), BUNSPEC);
					}
					{	/* Inline/inline.scm 153 */
						BgL_nodez00_bglt BgL_arg3433z00_1372;

						{	/* Inline/inline.scm 153 */
							BgL_nodez00_bglt BgL_arg3434z00_1373;

							BgL_arg3434z00_1373 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->
								BgL_falsez00);
							{	/* Inline/inline.scm 153 */
								BgL_nodez00_bglt BgL_res3536z00_2009;

								{	/* Inline/inline.scm 153 */
									long BgL_kfactorz00_1982;

									BgL_kfactorz00_1982 = (long) CINT(BgL_kfactorz00_1363);
									{	/* Inline/inline.scm 153 */
										obj_t BgL_method3258z00_1984;

										{	/* Inline/inline.scm 153 */
											BgL_objectz00_bglt BgL_objz00_1985;

											BgL_objz00_1985 =
												(BgL_objectz00_bglt) (BgL_arg3434z00_1373);
											{	/* Inline/inline.scm 153 */
												long BgL_objzd2classzd2numz00_1986;

												BgL_objzd2classzd2numz00_1986 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1985);
												{	/* Inline/inline.scm 153 */
													obj_t BgL_arg2551z00_1987;

													BgL_arg2551z00_1987 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 153 */
														obj_t BgL_arrayz00_1989;

														int BgL_offsetz00_1990;

														BgL_arrayz00_1989 = BgL_arg2551z00_1987;
														BgL_offsetz00_1990 =
															(int) (BgL_objzd2classzd2numz00_1986);
														{	/* Inline/inline.scm 153 */
															long BgL_offsetz00_1991;

															BgL_offsetz00_1991 =
																((long) (BgL_offsetz00_1990) - OBJECT_TYPE);
															{	/* Inline/inline.scm 153 */
																long BgL_modz00_1992;

																{	/* Inline/inline.scm 153 */
																	int BgL_arg2553z00_1993;

																	BgL_arg2553z00_1993 = (int) (((long) 8));
																	{	/* Inline/inline.scm 153 */
																		long BgL_auxz00_3638;

																		BgL_auxz00_3638 =
																			(long) (BgL_arg2553z00_1993);
																		BgL_modz00_1992 =
																			(BgL_offsetz00_1991 / BgL_auxz00_3638);
																}}
																{	/* Inline/inline.scm 153 */
																	long BgL_restz00_1994;

																	{	/* Inline/inline.scm 153 */
																		int BgL_arg2552z00_1995;

																		BgL_arg2552z00_1995 = (int) (((long) 8));
																		{	/* Inline/inline.scm 153 */
																			long BgL_auxz00_3642;

																			BgL_auxz00_3642 =
																				(long) (BgL_arg2552z00_1995);
																			BgL_restz00_1994 =
																				(BgL_offsetz00_1991 % BgL_auxz00_3642);
																	}}
																	{	/* Inline/inline.scm 153 */

																		BgL_method3258z00_1984 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1989,
																				(int) (BgL_modz00_1992)),
																			(int) (BgL_restz00_1994));
										}}}}}}}}
										BgL_res3536z00_2009 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1984) (BgL_method3258z00_1984,
												(obj_t) (BgL_arg3434z00_1373),
												BINT(BgL_kfactorz00_1982), BgL_stackz00_1364, BEOA));
								}}
								BgL_arg3433z00_1372 = BgL_res3536z00_2009;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1362))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3433z00_1372), BUNSPEC);
					}
					BgL_auxz00_3573 = BgL_nodez00_1362;
					return (obj_t) (BgL_auxz00_3573);
				}
			}
		}
	}



/* inline-node-setq3280 */
	obj_t BGl_inlinezd2nodezd2setq3280z00zzinline_inlinez00(obj_t BgL_envz00_2671,
		obj_t BgL_nodez00_2672, obj_t BgL_kfactorz00_2673, obj_t BgL_stackz00_2674)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 142 */
			{
				BgL_setqz00_bglt BgL_nodez00_1353;

				obj_t BgL_kfactorz00_1354;

				obj_t BgL_stackz00_1355;

				{	/* Inline/inline.scm 143 */
					BgL_setqz00_bglt BgL_auxz00_3657;

					BgL_nodez00_1353 = (BgL_setqz00_bglt) (BgL_nodez00_2672);
					BgL_kfactorz00_1354 = BgL_kfactorz00_2673;
					BgL_stackz00_1355 = BgL_stackz00_2674;
					{	/* Inline/inline.scm 143 */
						BgL_nodez00_bglt BgL_arg3425z00_1882;

						{	/* Inline/inline.scm 143 */
							BgL_nodez00_bglt BgL_arg3426z00_1883;

							BgL_arg3426z00_1883 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1353))->BgL_valuez00);
							{	/* Inline/inline.scm 143 */
								BgL_nodez00_bglt BgL_res3527z00_1913;

								{	/* Inline/inline.scm 143 */
									long BgL_kfactorz00_1886;

									BgL_kfactorz00_1886 = (long) CINT(BgL_kfactorz00_1354);
									{	/* Inline/inline.scm 143 */
										obj_t BgL_method3258z00_1888;

										{	/* Inline/inline.scm 143 */
											BgL_objectz00_bglt BgL_objz00_1889;

											BgL_objz00_1889 =
												(BgL_objectz00_bglt) (BgL_arg3426z00_1883);
											{	/* Inline/inline.scm 143 */
												long BgL_objzd2classzd2numz00_1890;

												BgL_objzd2classzd2numz00_1890 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1889);
												{	/* Inline/inline.scm 143 */
													obj_t BgL_arg2551z00_1891;

													BgL_arg2551z00_1891 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 143 */
														obj_t BgL_arrayz00_1893;

														int BgL_offsetz00_1894;

														BgL_arrayz00_1893 = BgL_arg2551z00_1891;
														BgL_offsetz00_1894 =
															(int) (BgL_objzd2classzd2numz00_1890);
														{	/* Inline/inline.scm 143 */
															long BgL_offsetz00_1895;

															BgL_offsetz00_1895 =
																((long) (BgL_offsetz00_1894) - OBJECT_TYPE);
															{	/* Inline/inline.scm 143 */
																long BgL_modz00_1896;

																{	/* Inline/inline.scm 143 */
																	int BgL_arg2553z00_1897;

																	BgL_arg2553z00_1897 = (int) (((long) 8));
																	{	/* Inline/inline.scm 143 */
																		long BgL_auxz00_3668;

																		BgL_auxz00_3668 =
																			(long) (BgL_arg2553z00_1897);
																		BgL_modz00_1896 =
																			(BgL_offsetz00_1895 / BgL_auxz00_3668);
																}}
																{	/* Inline/inline.scm 143 */
																	long BgL_restz00_1898;

																	{	/* Inline/inline.scm 143 */
																		int BgL_arg2552z00_1899;

																		BgL_arg2552z00_1899 = (int) (((long) 8));
																		{	/* Inline/inline.scm 143 */
																			long BgL_auxz00_3672;

																			BgL_auxz00_3672 =
																				(long) (BgL_arg2552z00_1899);
																			BgL_restz00_1898 =
																				(BgL_offsetz00_1895 % BgL_auxz00_3672);
																	}}
																	{	/* Inline/inline.scm 143 */

																		BgL_method3258z00_1888 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1893,
																				(int) (BgL_modz00_1896)),
																			(int) (BgL_restz00_1898));
										}}}}}}}}
										BgL_res3527z00_1913 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1888) (BgL_method3258z00_1888,
												(obj_t) (BgL_arg3426z00_1883),
												BINT(BgL_kfactorz00_1886), BgL_stackz00_1355, BEOA));
								}}
								BgL_arg3425z00_1882 = BgL_res3527z00_1913;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1353))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3425z00_1882), BUNSPEC);
					}
					BgL_auxz00_3657 = BgL_nodez00_1353;
					return (obj_t) (BgL_auxz00_3657);
				}
			}
		}
	}



/* inline-node-cast3278 */
	obj_t BGl_inlinezd2nodezd2cast3278z00zzinline_inlinez00(obj_t BgL_envz00_2675,
		obj_t BgL_nodez00_2676, obj_t BgL_kfactorz00_2677, obj_t BgL_stackz00_2678)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 135 */
			{
				BgL_castz00_bglt BgL_nodez00_1345;

				obj_t BgL_kfactorz00_1346;

				obj_t BgL_stackz00_1347;

				{	/* Inline/inline.scm 136 */
					BgL_castz00_bglt BgL_auxz00_3687;

					BgL_nodez00_1345 = (BgL_castz00_bglt) (BgL_nodez00_2676);
					BgL_kfactorz00_1346 = BgL_kfactorz00_2677;
					BgL_stackz00_1347 = BgL_stackz00_2678;
					{	/* Inline/inline.scm 136 */
						BgL_nodez00_bglt BgL_arg3423z00_1851;

						BgL_arg3423z00_1851 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1345))->BgL_argz00);
						{	/* Inline/inline.scm 136 */
							BgL_nodez00_bglt BgL_res3524z00_1881;

							{	/* Inline/inline.scm 136 */
								long BgL_kfactorz00_1854;

								BgL_kfactorz00_1854 = (long) CINT(BgL_kfactorz00_1346);
								{	/* Inline/inline.scm 136 */
									obj_t BgL_method3258z00_1856;

									{	/* Inline/inline.scm 136 */
										BgL_objectz00_bglt BgL_objz00_1857;

										BgL_objz00_1857 =
											(BgL_objectz00_bglt) (BgL_arg3423z00_1851);
										{	/* Inline/inline.scm 136 */
											long BgL_objzd2classzd2numz00_1858;

											BgL_objzd2classzd2numz00_1858 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1857);
											{	/* Inline/inline.scm 136 */
												obj_t BgL_arg2551z00_1859;

												BgL_arg2551z00_1859 =
													PROCEDURE_REF
													(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
													(int) (((long) 1)));
												{	/* Inline/inline.scm 136 */
													obj_t BgL_arrayz00_1861;

													int BgL_offsetz00_1862;

													BgL_arrayz00_1861 = BgL_arg2551z00_1859;
													BgL_offsetz00_1862 =
														(int) (BgL_objzd2classzd2numz00_1858);
													{	/* Inline/inline.scm 136 */
														long BgL_offsetz00_1863;

														BgL_offsetz00_1863 =
															((long) (BgL_offsetz00_1862) - OBJECT_TYPE);
														{	/* Inline/inline.scm 136 */
															long BgL_modz00_1864;

															{	/* Inline/inline.scm 136 */
																int BgL_arg2553z00_1865;

																BgL_arg2553z00_1865 = (int) (((long) 8));
																{	/* Inline/inline.scm 136 */
																	long BgL_auxz00_3698;

																	BgL_auxz00_3698 =
																		(long) (BgL_arg2553z00_1865);
																	BgL_modz00_1864 =
																		(BgL_offsetz00_1863 / BgL_auxz00_3698);
															}}
															{	/* Inline/inline.scm 136 */
																long BgL_restz00_1866;

																{	/* Inline/inline.scm 136 */
																	int BgL_arg2552z00_1867;

																	BgL_arg2552z00_1867 = (int) (((long) 8));
																	{	/* Inline/inline.scm 136 */
																		long BgL_auxz00_3702;

																		BgL_auxz00_3702 =
																			(long) (BgL_arg2552z00_1867);
																		BgL_restz00_1866 =
																			(BgL_offsetz00_1863 % BgL_auxz00_3702);
																}}
																{	/* Inline/inline.scm 136 */

																	BgL_method3258z00_1856 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1861,
																			(int) (BgL_modz00_1864)),
																		(int) (BgL_restz00_1866));
									}}}}}}}}
									BgL_res3524z00_1881 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3258z00_1856)
										(BgL_method3258z00_1856, (obj_t) (BgL_arg3423z00_1851),
											BINT(BgL_kfactorz00_1854), BgL_stackz00_1347, BEOA));
							}} BgL_res3524z00_1881;
					}}
					BgL_auxz00_3687 = BgL_nodez00_1345;
					return (obj_t) (BgL_auxz00_3687);
				}
			}
		}
	}



/* inline-node-extern3276 */
	obj_t BGl_inlinezd2nodezd2extern3276z00zzinline_inlinez00(obj_t
		BgL_envz00_2679, obj_t BgL_nodez00_2680, obj_t BgL_kfactorz00_2681,
		obj_t BgL_stackz00_2682)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 128 */
			{
				BgL_externz00_bglt BgL_nodez00_1337;

				obj_t BgL_kfactorz00_1338;

				obj_t BgL_stackz00_1339;

				{	/* Inline/inline.scm 129 */
					BgL_externz00_bglt BgL_auxz00_3716;

					BgL_nodez00_1337 = (BgL_externz00_bglt) (BgL_nodez00_2680);
					BgL_kfactorz00_1338 = BgL_kfactorz00_2681;
					BgL_stackz00_1339 = BgL_stackz00_2682;
					{	/* Inline/inline.scm 129 */
						obj_t BgL_arg3421z00_1849;

						BgL_arg3421z00_1849 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1337))->BgL_exprza2za2);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3421z00_1849,
							BgL_kfactorz00_1338, BgL_stackz00_1339);
					}
					BgL_auxz00_3716 = BgL_nodez00_1337;
					return (obj_t) (BgL_auxz00_3716);
				}
			}
		}
	}



/* inline-node-funcall3274 */
	obj_t BGl_inlinezd2nodezd2funcall3274z00zzinline_inlinez00(obj_t
		BgL_envz00_2683, obj_t BgL_nodez00_2684, obj_t BgL_kfactorz00_2685,
		obj_t BgL_stackz00_2686)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 118 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1327;

				obj_t BgL_kfactorz00_1328;

				obj_t BgL_stackz00_1329;

				{	/* Inline/inline.scm 120 */
					BgL_funcallz00_bglt BgL_auxz00_3721;

					BgL_nodez00_1327 = (BgL_funcallz00_bglt) (BgL_nodez00_2684);
					BgL_kfactorz00_1328 = BgL_kfactorz00_2685;
					BgL_stackz00_1329 = BgL_stackz00_2686;
					{	/* Inline/inline.scm 120 */
						long BgL_za71za7_1814;

						BgL_za71za7_1814 =
							(long) CINT(BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00);
						BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00 =
							BINT((BgL_za71za7_1814 + ((long) 1)));
					}
					{	/* Inline/inline.scm 121 */
						BgL_nodez00_bglt BgL_arg3417z00_1332;

						{	/* Inline/inline.scm 121 */
							BgL_nodez00_bglt BgL_arg3418z00_1333;

							BgL_arg3418z00_1333 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1327))->BgL_funz00);
							{	/* Inline/inline.scm 121 */
								BgL_nodez00_bglt BgL_res3521z00_1845;

								{	/* Inline/inline.scm 121 */
									long BgL_kfactorz00_1818;

									BgL_kfactorz00_1818 = (long) CINT(BgL_kfactorz00_1328);
									{	/* Inline/inline.scm 121 */
										obj_t BgL_method3258z00_1820;

										{	/* Inline/inline.scm 121 */
											BgL_objectz00_bglt BgL_objz00_1821;

											BgL_objz00_1821 =
												(BgL_objectz00_bglt) (BgL_arg3418z00_1333);
											{	/* Inline/inline.scm 121 */
												long BgL_objzd2classzd2numz00_1822;

												BgL_objzd2classzd2numz00_1822 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1821);
												{	/* Inline/inline.scm 121 */
													obj_t BgL_arg2551z00_1823;

													BgL_arg2551z00_1823 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 121 */
														obj_t BgL_arrayz00_1825;

														int BgL_offsetz00_1826;

														BgL_arrayz00_1825 = BgL_arg2551z00_1823;
														BgL_offsetz00_1826 =
															(int) (BgL_objzd2classzd2numz00_1822);
														{	/* Inline/inline.scm 121 */
															long BgL_offsetz00_1827;

															BgL_offsetz00_1827 =
																((long) (BgL_offsetz00_1826) - OBJECT_TYPE);
															{	/* Inline/inline.scm 121 */
																long BgL_modz00_1828;

																{	/* Inline/inline.scm 121 */
																	int BgL_arg2553z00_1829;

																	BgL_arg2553z00_1829 = (int) (((long) 8));
																	{	/* Inline/inline.scm 121 */
																		long BgL_auxz00_3735;

																		BgL_auxz00_3735 =
																			(long) (BgL_arg2553z00_1829);
																		BgL_modz00_1828 =
																			(BgL_offsetz00_1827 / BgL_auxz00_3735);
																}}
																{	/* Inline/inline.scm 121 */
																	long BgL_restz00_1830;

																	{	/* Inline/inline.scm 121 */
																		int BgL_arg2552z00_1831;

																		BgL_arg2552z00_1831 = (int) (((long) 8));
																		{	/* Inline/inline.scm 121 */
																			long BgL_auxz00_3739;

																			BgL_auxz00_3739 =
																				(long) (BgL_arg2552z00_1831);
																			BgL_restz00_1830 =
																				(BgL_offsetz00_1827 % BgL_auxz00_3739);
																	}}
																	{	/* Inline/inline.scm 121 */

																		BgL_method3258z00_1820 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1825,
																				(int) (BgL_modz00_1828)),
																			(int) (BgL_restz00_1830));
										}}}}}}}}
										BgL_res3521z00_1845 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1820) (BgL_method3258z00_1820,
												(obj_t) (BgL_arg3418z00_1333),
												BINT(BgL_kfactorz00_1818), BgL_stackz00_1329, BEOA));
								}}
								BgL_arg3417z00_1332 = BgL_res3521z00_1845;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1327))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3417z00_1332), BUNSPEC);
					}
					{	/* Inline/inline.scm 122 */
						obj_t BgL_arg3419z00_1334;

						BgL_arg3419z00_1334 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1327))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3419z00_1334,
							BgL_kfactorz00_1328, BgL_stackz00_1329);
					}
					BgL_auxz00_3721 = BgL_nodez00_1327;
					return (obj_t) (BgL_auxz00_3721);
				}
			}
		}
	}



/* inline-node-app-ly3272 */
	obj_t BGl_inlinezd2nodezd2appzd2ly3272zd2zzinline_inlinez00(obj_t
		BgL_envz00_2687, obj_t BgL_nodez00_2688, obj_t BgL_kfactorz00_2689,
		obj_t BgL_stackz00_2690)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 109 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1315;

				obj_t BgL_kfactorz00_1316;

				obj_t BgL_stackz00_1317;

				{	/* Inline/inline.scm 110 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_3756;

					BgL_nodez00_1315 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2688);
					BgL_kfactorz00_1316 = BgL_kfactorz00_2689;
					BgL_stackz00_1317 = BgL_stackz00_2690;
					{	/* Inline/inline.scm 111 */
						BgL_nodez00_bglt BgL_arg3411z00_1321;

						{	/* Inline/inline.scm 111 */
							BgL_nodez00_bglt BgL_arg3412z00_1322;

							BgL_arg3412z00_1322 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_funz00);
							{	/* Inline/inline.scm 111 */
								BgL_nodez00_bglt BgL_res3515z00_1779;

								{	/* Inline/inline.scm 111 */
									long BgL_kfactorz00_1752;

									BgL_kfactorz00_1752 = (long) CINT(BgL_kfactorz00_1316);
									{	/* Inline/inline.scm 111 */
										obj_t BgL_method3258z00_1754;

										{	/* Inline/inline.scm 111 */
											BgL_objectz00_bglt BgL_objz00_1755;

											BgL_objz00_1755 =
												(BgL_objectz00_bglt) (BgL_arg3412z00_1322);
											{	/* Inline/inline.scm 111 */
												long BgL_objzd2classzd2numz00_1756;

												BgL_objzd2classzd2numz00_1756 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1755);
												{	/* Inline/inline.scm 111 */
													obj_t BgL_arg2551z00_1757;

													BgL_arg2551z00_1757 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 111 */
														obj_t BgL_arrayz00_1759;

														int BgL_offsetz00_1760;

														BgL_arrayz00_1759 = BgL_arg2551z00_1757;
														BgL_offsetz00_1760 =
															(int) (BgL_objzd2classzd2numz00_1756);
														{	/* Inline/inline.scm 111 */
															long BgL_offsetz00_1761;

															BgL_offsetz00_1761 =
																((long) (BgL_offsetz00_1760) - OBJECT_TYPE);
															{	/* Inline/inline.scm 111 */
																long BgL_modz00_1762;

																{	/* Inline/inline.scm 111 */
																	int BgL_arg2553z00_1763;

																	BgL_arg2553z00_1763 = (int) (((long) 8));
																	{	/* Inline/inline.scm 111 */
																		long BgL_auxz00_3767;

																		BgL_auxz00_3767 =
																			(long) (BgL_arg2553z00_1763);
																		BgL_modz00_1762 =
																			(BgL_offsetz00_1761 / BgL_auxz00_3767);
																}}
																{	/* Inline/inline.scm 111 */
																	long BgL_restz00_1764;

																	{	/* Inline/inline.scm 111 */
																		int BgL_arg2552z00_1765;

																		BgL_arg2552z00_1765 = (int) (((long) 8));
																		{	/* Inline/inline.scm 111 */
																			long BgL_auxz00_3771;

																			BgL_auxz00_3771 =
																				(long) (BgL_arg2552z00_1765);
																			BgL_restz00_1764 =
																				(BgL_offsetz00_1761 % BgL_auxz00_3771);
																	}}
																	{	/* Inline/inline.scm 111 */

																		BgL_method3258z00_1754 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1759,
																				(int) (BgL_modz00_1762)),
																			(int) (BgL_restz00_1764));
										}}}}}}}}
										BgL_res3515z00_1779 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1754) (BgL_method3258z00_1754,
												(obj_t) (BgL_arg3412z00_1322),
												BINT(BgL_kfactorz00_1752), BgL_stackz00_1317, BEOA));
								}}
								BgL_arg3411z00_1321 = BgL_res3515z00_1779;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3411z00_1321), BUNSPEC);
					}
					{	/* Inline/inline.scm 112 */
						BgL_nodez00_bglt BgL_arg3413z00_1323;

						{	/* Inline/inline.scm 112 */
							BgL_nodez00_bglt BgL_arg3415z00_1324;

							BgL_arg3415z00_1324 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_argz00);
							{	/* Inline/inline.scm 112 */
								BgL_nodez00_bglt BgL_res3518z00_1811;

								{	/* Inline/inline.scm 112 */
									long BgL_kfactorz00_1784;

									BgL_kfactorz00_1784 = (long) CINT(BgL_kfactorz00_1316);
									{	/* Inline/inline.scm 112 */
										obj_t BgL_method3258z00_1786;

										{	/* Inline/inline.scm 112 */
											BgL_objectz00_bglt BgL_objz00_1787;

											BgL_objz00_1787 =
												(BgL_objectz00_bglt) (BgL_arg3415z00_1324);
											{	/* Inline/inline.scm 112 */
												long BgL_objzd2classzd2numz00_1788;

												BgL_objzd2classzd2numz00_1788 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1787);
												{	/* Inline/inline.scm 112 */
													obj_t BgL_arg2551z00_1789;

													BgL_arg2551z00_1789 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 112 */
														obj_t BgL_arrayz00_1791;

														int BgL_offsetz00_1792;

														BgL_arrayz00_1791 = BgL_arg2551z00_1789;
														BgL_offsetz00_1792 =
															(int) (BgL_objzd2classzd2numz00_1788);
														{	/* Inline/inline.scm 112 */
															long BgL_offsetz00_1793;

															BgL_offsetz00_1793 =
																((long) (BgL_offsetz00_1792) - OBJECT_TYPE);
															{	/* Inline/inline.scm 112 */
																long BgL_modz00_1794;

																{	/* Inline/inline.scm 112 */
																	int BgL_arg2553z00_1795;

																	BgL_arg2553z00_1795 = (int) (((long) 8));
																	{	/* Inline/inline.scm 112 */
																		long BgL_auxz00_3794;

																		BgL_auxz00_3794 =
																			(long) (BgL_arg2553z00_1795);
																		BgL_modz00_1794 =
																			(BgL_offsetz00_1793 / BgL_auxz00_3794);
																}}
																{	/* Inline/inline.scm 112 */
																	long BgL_restz00_1796;

																	{	/* Inline/inline.scm 112 */
																		int BgL_arg2552z00_1797;

																		BgL_arg2552z00_1797 = (int) (((long) 8));
																		{	/* Inline/inline.scm 112 */
																			long BgL_auxz00_3798;

																			BgL_auxz00_3798 =
																				(long) (BgL_arg2552z00_1797);
																			BgL_restz00_1796 =
																				(BgL_offsetz00_1793 % BgL_auxz00_3798);
																	}}
																	{	/* Inline/inline.scm 112 */

																		BgL_method3258z00_1786 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1791,
																				(int) (BgL_modz00_1794)),
																			(int) (BgL_restz00_1796));
										}}}}}}}}
										BgL_res3518z00_1811 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3258z00_1786) (BgL_method3258z00_1786,
												(obj_t) (BgL_arg3415z00_1324),
												BINT(BgL_kfactorz00_1784), BgL_stackz00_1317, BEOA));
								}}
								BgL_arg3413z00_1323 = BgL_res3518z00_1811;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3413z00_1323), BUNSPEC);
					}
					BgL_auxz00_3756 = BgL_nodez00_1315;
					return (obj_t) (BgL_auxz00_3756);
				}
			}
		}
	}



/* inline-node-app3270 */
	obj_t BGl_inlinezd2nodezd2app3270z00zzinline_inlinez00(obj_t BgL_envz00_2691,
		obj_t BgL_nodez00_2692, obj_t BgL_kfactorz00_2693, obj_t BgL_stackz00_2694)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 102 */
			{
				BgL_appz00_bglt BgL_nodez00_1307;

				obj_t BgL_kfactorz00_1308;

				obj_t BgL_stackz00_1309;

				{	/* Inline/inline.scm 103 */
					BgL_nodez00_bglt BgL_auxz00_3813;

					BgL_nodez00_1307 = (BgL_appz00_bglt) (BgL_nodez00_2692);
					BgL_kfactorz00_1308 = BgL_kfactorz00_2693;
					BgL_stackz00_1309 = BgL_stackz00_2694;
					{	/* Inline/inline.scm 103 */
						obj_t BgL_arg3409z00_1748;

						BgL_arg3409z00_1748 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1307))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3409z00_1748,
							BgL_kfactorz00_1308, BgL_stackz00_1309);
					}
					BgL_auxz00_3813 =
						BGl_inlinezd2appzd2zzinline_appz00(BgL_nodez00_1307,
						(long) CINT(BgL_kfactorz00_1308), BgL_stackz00_1309);
					return (obj_t) (BgL_auxz00_3813);
				}
			}
		}
	}



/* inline-node-sequence3268 */
	obj_t BGl_inlinezd2nodezd2sequence3268z00zzinline_inlinez00(obj_t
		BgL_envz00_2695, obj_t BgL_nodez00_2696, obj_t BgL_kfactorz00_2697,
		obj_t BgL_stackz00_2698)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 95 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1299;

				obj_t BgL_kfactorz00_1300;

				obj_t BgL_stackz00_1301;

				{	/* Inline/inline.scm 96 */
					BgL_sequencez00_bglt BgL_auxz00_3820;

					BgL_nodez00_1299 = (BgL_sequencez00_bglt) (BgL_nodez00_2696);
					BgL_kfactorz00_1300 = BgL_kfactorz00_2697;
					BgL_stackz00_1301 = BgL_stackz00_2698;
					{	/* Inline/inline.scm 96 */
						obj_t BgL_arg3407z00_1746;

						BgL_arg3407z00_1746 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1299))->BgL_nodesz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3407z00_1746,
							BgL_kfactorz00_1300, BgL_stackz00_1301);
					}
					BgL_auxz00_3820 = BgL_nodez00_1299;
					return (obj_t) (BgL_auxz00_3820);
				}
			}
		}
	}



/* inline-node-kwote3265 */
	obj_t BGl_inlinezd2nodezd2kwote3265z00zzinline_inlinez00(obj_t
		BgL_envz00_2699, obj_t BgL_nodez00_2700, obj_t BgL_kfactorz00_2701,
		obj_t BgL_stackz00_2702)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 89 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2700));
		}
	}



/* inline-node-var3262 */
	obj_t BGl_inlinezd2nodezd2var3262z00zzinline_inlinez00(obj_t BgL_envz00_2703,
		obj_t BgL_nodez00_2704, obj_t BgL_kfactorz00_2705, obj_t BgL_stackz00_2706)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 73 */
			{
				BgL_varz00_bglt BgL_nodez00_1265;

				obj_t BgL_kfactorz00_1266;

				obj_t BgL_stackz00_1267;

				BgL_nodez00_1265 = (BgL_varz00_bglt) (BgL_nodez00_2704);
				BgL_kfactorz00_1266 = BgL_kfactorz00_2705;
				BgL_stackz00_1267 = BgL_stackz00_2706;
				{	/* Inline/inline.scm 75 */
					bool_t BgL_testz00_3827;

					if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) > ((long) 0)))
						{	/* Inline/inline.scm 76 */
							bool_t BgL_testz00_3831;

							{	/* Inline/inline.scm 76 */
								BgL_variablez00_bglt BgL_arg3404z00_1289;

								BgL_arg3404z00_1289 =
									(((BgL_varz00_bglt) CREF(BgL_nodez00_1265))->BgL_variablez00);
								{	/* Inline/inline.scm 76 */
									obj_t BgL_obj1658z00_1735;

									BgL_obj1658z00_1735 = (obj_t) (BgL_arg3404z00_1289);
									BgL_testz00_3831 =
										BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_1735,
										BGl_globalz00zzast_varz00);
							}}
							if (BgL_testz00_3831)
								{	/* Inline/inline.scm 77 */
									bool_t BgL_testz00_3835;

									{	/* Inline/inline.scm 77 */
										obj_t BgL_auxz00_3836;

										{	/* Inline/inline.scm 77 */
											BgL_globalz00_bglt BgL_obj1586z00_1737;

											BgL_obj1586z00_1737 =
												(BgL_globalz00_bglt) (
												(((BgL_varz00_bglt) CREF(BgL_nodez00_1265))->
													BgL_variablez00));
											BgL_auxz00_3836 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1586z00_1737))->
												BgL_importz00);
										}
										BgL_testz00_3835 =
											(BgL_auxz00_3836 == CNST_TABLE_REF(((long) 3)));
									}
									if (BgL_testz00_3835)
										{	/* Inline/inline.scm 78 */
											bool_t BgL_testz00_3842;

											{	/* Inline/inline.scm 78 */
												obj_t BgL_auxz00_3843;

												{	/* Inline/inline.scm 78 */
													BgL_variablez00_bglt BgL_obj1521z00_1739;

													BgL_obj1521z00_1739 =
														(((BgL_varz00_bglt) CREF(BgL_nodez00_1265))->
														BgL_variablez00);
													BgL_auxz00_3843 =
														(((BgL_variablez00_bglt)
															CREF(BgL_obj1521z00_1739))->BgL_accessz00);
												}
												BgL_testz00_3842 =
													(BgL_auxz00_3843 == CNST_TABLE_REF(((long) 4)));
											}
											if (BgL_testz00_3842)
												{	/* Inline/inline.scm 79 */
													obj_t BgL_arg3396z00_1281;

													{	/* Inline/inline.scm 79 */
														BgL_globalz00_bglt BgL_obj1601z00_1741;

														BgL_obj1601z00_1741 =
															(BgL_globalz00_bglt) (
															(((BgL_varz00_bglt) CREF(BgL_nodez00_1265))->
																BgL_variablez00));
														BgL_arg3396z00_1281 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1601z00_1741))->BgL_srcz00);
													}
													BgL_testz00_3827 =
														BGl_iszd2azf3z21zz__objectz00(BgL_arg3396z00_1281,
														BGl_atomz00zzast_nodez00);
												}
											else
												{	/* Inline/inline.scm 78 */
													BgL_testz00_3827 = ((bool_t) 0);
												}
										}
									else
										{	/* Inline/inline.scm 77 */
											BgL_testz00_3827 = ((bool_t) 0);
										}
								}
							else
								{	/* Inline/inline.scm 76 */
									BgL_testz00_3827 = ((bool_t) 0);
								}
						}
					else
						{	/* Inline/inline.scm 75 */
							BgL_testz00_3827 = ((bool_t) 0);
						}
					if (BgL_testz00_3827)
						{	/* Inline/inline.scm 75 */
							{	/* Inline/inline.scm 83 */
								obj_t BgL_arg3389z00_1274;

								obj_t BgL_arg3390z00_1275;

								{
									BgL_nodez00_bglt BgL_auxz00_3852;

									BgL_auxz00_3852 = (BgL_nodez00_bglt) (BgL_nodez00_1265);
									BgL_arg3389z00_1274 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3852))->BgL_locz00);
								}
								{	/* Inline/inline.scm 83 */
									BgL_globalz00_bglt BgL_obj1601z00_1745;

									BgL_obj1601z00_1745 =
										(BgL_globalz00_bglt) (
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1265))->
											BgL_variablez00));
									BgL_arg3390z00_1275 =
										(((BgL_globalz00_bglt) CREF(BgL_obj1601z00_1745))->
										BgL_srcz00);
								}
								return
									(obj_t) (BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL,
										BgL_arg3389z00_1274,
										(BgL_nodez00_bglt) (BgL_arg3390z00_1275)));
							}
						}
					else
						{	/* Inline/inline.scm 75 */
							return (obj_t) (BgL_nodez00_1265);
						}
				}
			}
		}
	}



/* inline-node-atom3260 */
	obj_t BGl_inlinezd2nodezd2atom3260z00zzinline_inlinez00(obj_t BgL_envz00_2707,
		obj_t BgL_nodez00_2708, obj_t BgL_kfactorz00_2709, obj_t BgL_stackz00_2710)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 67 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2708));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 175384950),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_appz00(((long) 472786230),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(((long) 509694479),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3611z00zzinline_inlinez00));
		}
	}

#ifdef __cplusplus
}
#endif
