/*===========================================================================*/
/*   (Object/creator.scm)                                                    */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Object/creator.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;

	typedef struct BgL_jclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		obj_t BgL_packagez00;
	}                *BgL_jclassz00_bglt;

	typedef struct BgL_slotz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_srcz00;
		obj_t BgL_classzd2ownerzd2;
		obj_t BgL_typez00;
		bool_t BgL_readzd2onlyzf3z21;
		obj_t BgL_defaultzd2valuezd2;
		obj_t BgL_virtualzd2numzd2;
		obj_t BgL_getterz00;
		obj_t BgL_setterz00;
		obj_t BgL_indexedz00;
		obj_t BgL_userzd2infozd2;
	}              *BgL_slotz00_bglt;


	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t
		BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t
		BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_producezd2modulezd2clausez12z12zzmodule_modulez00(obj_t);
	static obj_t
		BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00
		(BgL_jclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_za2profilezd2modeza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzobject_creatorz00 = BUNSPEC;
	static obj_t
		BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_epairifyza2za2zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzobject_creatorz00();
	static obj_t BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	static obj_t
		BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern bool_t BGl_widezd2classzf3z21zzobject_classz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_importzd2parserzd2zzmodule_impusez00(obj_t, obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2setz12zf2wideningz32zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzobject_creatorz00();
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static obj_t
		BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzobject_creatorz00();
	extern obj_t BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static bool_t BGl_inlinezd2creatorszf3z21zzobject_creatorz00();
	extern obj_t
		BGl_findzd2classzd2constructorsz00zzobject_classz00(BgL_tclassz00_bglt);
	static obj_t
		BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzobject_creatorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_impusez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_nilz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_sawzd2widezd2classzd2idzd2zzobject_classz00(obj_t);
	static obj_t BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_stringzd2sanszd2z42z42zztype_toolsz00(obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_genzd2classzd2allocatez12z12zzobject_creatorz00(obj_t, obj_t,
		BgL_globalz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_genzd2widezd2classzd2nilzd2zzobject_nilz00(BgL_tclassz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00(obj_t);
	static obj_t BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t
		BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00
		(BgL_jclassz00_bglt, obj_t, obj_t);
	static obj_t
		BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_genzd2onezd2constructorz00zzobject_creatorz00(obj_t,
		BgL_jclassz00_bglt, obj_t);
	static obj_t BGl_alloczd2wideningzd2zzobject_creatorz00(obj_t,
		BgL_tclassz00_bglt);
	extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t
		BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt,
		obj_t);
	extern obj_t BGl_za2sawza2z00zzengine_paramz00;
	extern obj_t BGl_za2passza2z00zzengine_paramz00;
	static obj_t
		BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typezd2ofzd2idz00zzast_identz00(obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
	static obj_t
		BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00(obj_t,
		BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_genzd2plainzd2classzd2nilzd2zzobject_nilz00(BgL_tclassz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t
		BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static obj_t BGl_genzd2classzd2fillz12z12zzobject_creatorz00(obj_t, obj_t,
		BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzobject_creatorz00();
	static obj_t BGl_genzd2classzd2makez12z12zzobject_creatorz00(obj_t, obj_t,
		obj_t, BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzobject_creatorz00();
	static obj_t __cnst[39];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2javazd2classzd2creatorzd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2javaza7d3405z00,
		BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2widezd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2wideza7d2cl3406z00,
		BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2plainzd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2plainza7d2c3407z00,
		BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2widezd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2wideza7d3408z00,
		BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2javazd2classzd2constructorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2javaza7d2cl3409z00,
		BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);
	      DEFINE_STRING(BGl_string3400z00zzobject_creatorz00,
		BgL_bgl_string3400za700za7za7o3410za7, ")BREF( GC_MALLOC ( sizeof(", 26);
	      DEFINE_STRING(BGl_string3401z00zzobject_creatorz00,
		BgL_bgl_string3401za700za7za7o3411za7, "object_creator", 14);
	      DEFINE_STRING(BGl_string3402z00zzobject_creatorz00,
		BgL_bgl_string3402za700za7za7o3412za7,
		"cast aux object-widening-set! class-num __object @ object-class-num-set! +fx done =fx if labels loop free-pragma allocator pragma jvm begin let ::long i export quote define obj widening- o inline static new define-inline %allocate- widening - make make- ! fill- (make-heap make-add-heap) ",
		288);
	      DEFINE_STRING(BGl_string3396z00zzobject_creatorz00,
		BgL_bgl_string3396za700za7za7o3413za7, "))))", 4);
	      DEFINE_STRING(BGl_string3397z00zzobject_creatorz00,
		BgL_bgl_string3397za700za7za7o3414za7, ")BREF( GC_MALLOC (sizeof(", 25);
	      DEFINE_STRING(BGl_string3398z00zzobject_creatorz00,
		BgL_bgl_string3398za700za7za7o3415za7, "((", 2);
	      DEFINE_STRING(BGl_string3399z00zzobject_creatorz00,
		BgL_bgl_string3399za700za7za7o3416za7, ") )))", 5);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2plainzd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2plainza73417z00,
		BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzobject_creatorz00(long
		BgL_checksumz00_2115, char *BgL_fromz00_2116)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzobject_creatorz00))
				{
					BGl_requirezd2initializa7ationz75zzobject_creatorz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzobject_creatorz00();
					BGl_cnstzd2initzd2zzobject_creatorz00();
					BGl_importedzd2moduleszd2initz00zzobject_creatorz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"object_creator");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			{	/* Object/creator.scm 21 */
				obj_t BgL_cportz00_2107;

				BgL_cportz00_2107 =
					bgl_open_input_string(BGl_string3402z00zzobject_creatorz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2108;

					BgL_iz00_2108 = ((long) 38);
				BgL_loopz00_2109:
					if ((BgL_iz00_2108 == ((long) -1)))
						{	/* Object/creator.scm 21 */
							return BUNSPEC;
						}
					else
						{	/* Object/creator.scm 21 */
							{	/* Object/creator.scm 21 */
								obj_t BgL_arg3404z00_2111;

								{	/* Object/creator.scm 21 */

									{	/* Object/creator.scm 21 */
										obj_t BgL_locationz00_2113;

										BgL_locationz00_2113 = BBOOL(((bool_t) 0));
										{	/* Object/creator.scm 21 */

											BgL_arg3404z00_2111 =
												BGl_readz00zz__readerz00(BgL_cportz00_2107,
												BgL_locationz00_2113);
										}
									}
								}
								{	/* Object/creator.scm 21 */
									int BgL_auxz00_2133;

									BgL_auxz00_2133 = (int) (BgL_iz00_2108);
									CNST_TABLE_SET(BgL_auxz00_2133, BgL_arg3404z00_2111);
							}}
							{	/* Object/creator.scm 21 */
								int BgL_auxz00_2114;

								BgL_auxz00_2114 = (int) ((BgL_iz00_2108 - ((long) 1)));
								{
									long BgL_iz00_2138;

									BgL_iz00_2138 = (long) (BgL_auxz00_2114);
									BgL_iz00_2108 = BgL_iz00_2138;
									goto BgL_loopz00_2109;
								}
							}
						}
				}
			}
		}
	}



/* inline-creators? */
	bool_t BGl_inlinezd2creatorszf3z21zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 56 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Object/creator.scm 58 */
					bool_t BgL_testz00_2143;

					{	/* Object/creator.scm 58 */
						bool_t BgL__ortest_2425z00_588;

						{	/* Object/creator.scm 58 */
							bool_t BgL_testz00_2144;

							{	/* Object/creator.scm 58 */
								bool_t BgL_res3390z00_1799;

								{	/* Object/creator.scm 58 */
									obj_t BgL_objz00_1789;

									BgL_objz00_1789 =
										BGl_za2profilezd2modeza2zd2zzengine_paramz00;
									if (INTEGERP(BgL_objz00_1789))
										{	/* Object/creator.scm 58 */
											BgL_res3390z00_1799 = ((bool_t) 1);
										}
									else
										{	/* Object/creator.scm 58 */
											if (REALP(BgL_objz00_1789))
												{	/* Object/creator.scm 58 */
													BgL_res3390z00_1799 = ((bool_t) 1);
												}
											else
												{	/* Object/creator.scm 58 */
													if (ELONGP(BgL_objz00_1789))
														{	/* Object/creator.scm 58 */
															BgL_res3390z00_1799 = ((bool_t) 1);
														}
													else
														{	/* Object/creator.scm 58 */
															if (LLONGP(BgL_objz00_1789))
																{	/* Object/creator.scm 58 */
																	BgL_res3390z00_1799 = ((bool_t) 1);
																}
															else
																{	/* Object/creator.scm 58 */
																	BgL_res3390z00_1799 =
																		BIGNUMP(BgL_objz00_1789);
																}
														}
												}
										}
								}
								BgL_testz00_2144 = BgL_res3390z00_1799;
							}
							if (BgL_testz00_2144)
								{	/* Object/creator.scm 58 */
									BgL__ortest_2425z00_588 = ((bool_t) 0);
								}
							else
								{	/* Object/creator.scm 58 */
									BgL__ortest_2425z00_588 = ((bool_t) 1);
								}
						}
						if (BgL__ortest_2425z00_588)
							{	/* Object/creator.scm 58 */
								BgL_testz00_2143 = BgL__ortest_2425z00_588;
							}
						else
							{	/* Object/creator.scm 58 */
								BgL_testz00_2143 =
									(
									(long) CINT(BGl_za2profilezd2modeza2zd2zzengine_paramz00) <
									((long) 1));
					}}
					if (BgL_testz00_2143)
						{	/* Object/creator.scm 58 */
							if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
									(BGl_za2passza2z00zzengine_paramz00,
										CNST_TABLE_REF(((long) 0)))))
								{	/* Object/creator.scm 60 */
									return ((bool_t) 0);
								}
							else
								{	/* Object/creator.scm 60 */
									return ((bool_t) 1);
								}
						}
					else
						{	/* Object/creator.scm 58 */
							return ((bool_t) 0);
						}
				}
			else
				{	/* Object/creator.scm 57 */
					return ((bool_t) 0);
				}
		}
	}



/* gen-plain-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_classz00_1, obj_t BgL_srczd2defzd2_2, obj_t BgL_importz00_3)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 65 */
			{	/* Object/creator.scm 66 */
				obj_t BgL_arg2494z00_590;

				obj_t BgL_arg2495z00_591;

				obj_t BgL_arg2496z00_592;

				BgL_arg2494z00_590 =
					BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_1, BgL_srczd2defzd2_2, BgL_importz00_3);
				BgL_arg2495z00_591 =
					BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_1, BgL_srczd2defzd2_2, BgL_importz00_3);
				BgL_arg2496z00_592 =
					BGl_genzd2plainzd2classzd2nilzd2zzobject_nilz00(BgL_classz00_1,
					BgL_srczd2defzd2_2, BgL_importz00_3);
				{	/* Object/creator.scm 66 */
					obj_t BgL_list2497z00_593;

					{	/* Object/creator.scm 66 */
						obj_t BgL_arg2498z00_594;

						{	/* Object/creator.scm 66 */
							obj_t BgL_arg2502z00_595;

							BgL_arg2502z00_595 = MAKE_PAIR(BgL_arg2496z00_592, BNIL);
							BgL_arg2498z00_594 =
								MAKE_PAIR(BgL_arg2495z00_591, BgL_arg2502z00_595);
						}
						BgL_list2497z00_593 =
							MAKE_PAIR(BgL_arg2494z00_590, BgL_arg2498z00_594);
					}
					return
						BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2497z00_593);
				}
			}
		}
	}



/* _gen-plain-class-creators */
	obj_t BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2079, obj_t BgL_classz00_2080, obj_t BgL_srczd2defzd2_2081,
		obj_t BgL_importz00_2082)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 65 */
			return
				BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2080), BgL_srczd2defzd2_2081,
				BgL_importz00_2082);
		}
	}



/* gen-inline-plain-class-creators */
	obj_t
		BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_4, obj_t BgL_srczd2defzd2_5,
		obj_t BgL_importz00_6)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 76 */
			{	/* Object/creator.scm 78 */
				obj_t BgL_idz00_597;

				{
					BgL_typez00_bglt BgL_auxz00_2170;

					BgL_auxz00_2170 = (BgL_typez00_bglt) (BgL_classz00_4);
					BgL_idz00_597 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_2170))->BgL_idz00);
				}
				{	/* Object/creator.scm 78 */
					BgL_globalz00_bglt BgL_holderz00_598;

					{
						obj_t BgL_auxz00_2173;

						{	/* Object/creator.scm 79 */
							BgL_objectz00_bglt BgL_auxz00_2174;

							BgL_auxz00_2174 = (BgL_objectz00_bglt) (BgL_classz00_4);
							BgL_auxz00_2173 = BGL_OBJECT_WIDENING(BgL_auxz00_2174);
						}
						BgL_holderz00_598 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2173))->BgL_holderz00);
					}
					{	/* Object/creator.scm 79 */
						obj_t BgL_fillzd2idzd2_599;

						{	/* Object/creator.scm 80 */
							obj_t BgL_list2524z00_604;

							{	/* Object/creator.scm 80 */
								obj_t BgL_arg2529z00_605;

								obj_t BgL_arg2536z00_606;

								BgL_arg2529z00_605 = CNST_TABLE_REF(((long) 1));
								{	/* Object/creator.scm 80 */
									obj_t BgL_arg2537z00_607;

									BgL_arg2537z00_607 =
										MAKE_PAIR(CNST_TABLE_REF(((long) 2)), BNIL);
									BgL_arg2536z00_606 =
										MAKE_PAIR(BgL_idz00_597, BgL_arg2537z00_607);
								}
								BgL_list2524z00_604 =
									MAKE_PAIR(BgL_arg2529z00_605, BgL_arg2536z00_606);
							}
							BgL_fillzd2idzd2_599 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2524z00_604);
						}
						{	/* Object/creator.scm 80 */

							{	/* Object/creator.scm 81 */
								obj_t BgL_arg2510z00_600;

								obj_t BgL_arg2516z00_601;

								BgL_arg2510z00_600 =
									BGl_genzd2classzd2fillz12z12zzobject_creatorz00
									(BgL_fillzd2idzd2_599, BgL_idz00_597, BgL_classz00_4,
									BgL_srczd2defzd2_5, BgL_importz00_6);
								BgL_arg2516z00_601 =
									BGl_genzd2classzd2allocatez12z12zzobject_creatorz00
									(BgL_idz00_597, (obj_t) (BgL_classz00_4), BgL_holderz00_598,
									BgL_srczd2defzd2_5, BgL_importz00_6);
								{	/* Object/creator.scm 81 */
									obj_t BgL_list2517z00_602;

									{	/* Object/creator.scm 81 */
										obj_t BgL_arg2523z00_603;

										BgL_arg2523z00_603 = MAKE_PAIR(BgL_arg2516z00_601, BNIL);
										BgL_list2517z00_602 =
											MAKE_PAIR(BgL_arg2510z00_600, BgL_arg2523z00_603);
									}
									return BgL_list2517z00_602;
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-noinline-plain-class-creators */
	obj_t
		BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_7, obj_t BgL_srczd2defzd2_8,
		obj_t BgL_importz00_9)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 87 */
			{	/* Object/creator.scm 89 */
				bool_t BgL_testz00_2189;

				{
					obj_t BgL_auxz00_2190;

					{	/* Object/creator.scm 89 */
						BgL_objectz00_bglt BgL_auxz00_2191;

						BgL_auxz00_2191 = (BgL_objectz00_bglt) (BgL_classz00_7);
						BgL_auxz00_2190 = BGL_OBJECT_WIDENING(BgL_auxz00_2191);
					}
					BgL_testz00_2189 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2190))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2189)
					{	/* Object/creator.scm 89 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 91 */
						obj_t BgL_idz00_610;

						{
							BgL_typez00_bglt BgL_auxz00_2195;

							BgL_auxz00_2195 = (BgL_typez00_bglt) (BgL_classz00_7);
							BgL_idz00_610 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2195))->BgL_idz00);
						}
						{	/* Object/creator.scm 91 */
							obj_t BgL_mkzd2idzd2_611;

							{	/* Object/creator.scm 92 */
								obj_t BgL_arg2555z00_614;

								{	/* Object/creator.scm 92 */
									obj_t BgL_arg2557z00_615;

									obj_t BgL_arg2558z00_616;

									{	/* Object/creator.scm 92 */
										obj_t BgL_symbolz00_1808;

										BgL_symbolz00_1808 = CNST_TABLE_REF(((long) 3));
										BgL_arg2557z00_615 = SYMBOL_TO_STRING(BgL_symbolz00_1808);
									}
									BgL_arg2558z00_616 = SYMBOL_TO_STRING(BgL_idz00_610);
									{	/* Object/creator.scm 92 */
										obj_t BgL_list2559z00_617;

										{	/* Object/creator.scm 92 */
											obj_t BgL_arg2560z00_618;

											BgL_arg2560z00_618 = MAKE_PAIR(BgL_arg2558z00_616, BNIL);
											BgL_list2559z00_617 =
												MAKE_PAIR(BgL_arg2557z00_615, BgL_arg2560z00_618);
										}
										BgL_arg2555z00_614 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2559z00_617);
								}}
								BgL_mkzd2idzd2_611 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2555z00_614));
							}
							{	/* Object/creator.scm 92 */

								{	/* Object/creator.scm 93 */
									obj_t BgL_arg2550z00_612;

									BgL_arg2550z00_612 =
										BGl_genzd2classzd2makez12z12zzobject_creatorz00
										(CNST_TABLE_REF(((long) 4)), BgL_mkzd2idzd2_611,
										BgL_idz00_610, BgL_classz00_7, BgL_srczd2defzd2_8,
										BgL_importz00_9);
									{	/* Object/creator.scm 93 */
										obj_t BgL_list2551z00_613;

										BgL_list2551z00_613 = MAKE_PAIR(BgL_arg2550z00_612, BNIL);
										return BgL_list2551z00_613;
									}
								}
							}
						}
					}
			}
		}
	}



/* gen-wide-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_classz00_10, obj_t BgL_srczd2defzd2_11, obj_t BgL_importz00_12)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 98 */
			{	/* Object/creator.scm 99 */
				obj_t BgL_arg2561z00_619;

				obj_t BgL_arg2562z00_620;

				obj_t BgL_arg2563z00_621;

				BgL_arg2561z00_619 =
					BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_10, BgL_srczd2defzd2_11, BgL_importz00_12);
				BgL_arg2562z00_620 =
					BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_10, BgL_srczd2defzd2_11, BgL_importz00_12);
				BgL_arg2563z00_621 =
					BGl_genzd2widezd2classzd2nilzd2zzobject_nilz00(BgL_classz00_10,
					BgL_srczd2defzd2_11, BgL_importz00_12);
				{	/* Object/creator.scm 99 */
					obj_t BgL_list2564z00_622;

					{	/* Object/creator.scm 99 */
						obj_t BgL_arg2565z00_623;

						{	/* Object/creator.scm 99 */
							obj_t BgL_arg2568z00_624;

							BgL_arg2568z00_624 = MAKE_PAIR(BgL_arg2563z00_621, BNIL);
							BgL_arg2565z00_623 =
								MAKE_PAIR(BgL_arg2562z00_620, BgL_arg2568z00_624);
						}
						BgL_list2564z00_622 =
							MAKE_PAIR(BgL_arg2561z00_619, BgL_arg2565z00_623);
					}
					return
						BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2564z00_622);
				}
			}
		}
	}



/* _gen-wide-class-creators */
	obj_t BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2083, obj_t BgL_classz00_2084, obj_t BgL_srczd2defzd2_2085,
		obj_t BgL_importz00_2086)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 98 */
			return
				BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2084), BgL_srczd2defzd2_2085,
				BgL_importz00_2086);
		}
	}



/* gen-noinline-wide-class-creators */
	obj_t
		BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_13, obj_t BgL_srczd2defzd2_14,
		obj_t BgL_importz00_15)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 106 */
			{	/* Object/creator.scm 108 */
				bool_t BgL_testz00_2218;

				{
					obj_t BgL_auxz00_2219;

					{	/* Object/creator.scm 108 */
						BgL_objectz00_bglt BgL_auxz00_2220;

						BgL_auxz00_2220 = (BgL_objectz00_bglt) (BgL_classz00_13);
						BgL_auxz00_2219 = BGL_OBJECT_WIDENING(BgL_auxz00_2220);
					}
					BgL_testz00_2218 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2219))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2218)
					{	/* Object/creator.scm 108 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 110 */
						obj_t BgL_fillzd2idzd2_627;

						obj_t BgL_wideningz00_628;

						{	/* Object/creator.scm 110 */
							obj_t BgL_arg2578z00_637;

							obj_t BgL_arg2579z00_638;

							obj_t BgL_arg2580z00_639;

							BgL_arg2578z00_637 = CNST_TABLE_REF(((long) 1));
							{
								BgL_typez00_bglt BgL_auxz00_2225;

								BgL_auxz00_2225 = (BgL_typez00_bglt) (BgL_classz00_13);
								BgL_arg2579z00_638 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2225))->BgL_idz00);
							}
							BgL_arg2580z00_639 = CNST_TABLE_REF(((long) 2));
							{	/* Object/creator.scm 110 */
								obj_t BgL_list2581z00_640;

								{	/* Object/creator.scm 110 */
									obj_t BgL_arg2582z00_641;

									{	/* Object/creator.scm 110 */
										obj_t BgL_arg2583z00_642;

										BgL_arg2583z00_642 = MAKE_PAIR(BgL_arg2580z00_639, BNIL);
										BgL_arg2582z00_641 =
											MAKE_PAIR(BgL_arg2579z00_638, BgL_arg2583z00_642);
									}
									BgL_list2581z00_640 =
										MAKE_PAIR(BgL_arg2578z00_637, BgL_arg2582z00_641);
								}
								BgL_fillzd2idzd2_627 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2581z00_640);
						}}
						{	/* Object/creator.scm 111 */
							obj_t BgL_arg2584z00_643;

							obj_t BgL_arg2585z00_644;

							obj_t BgL_arg2586z00_645;

							{
								obj_t BgL_auxz00_2233;

								{	/* Object/creator.scm 111 */
									BgL_objectz00_bglt BgL_auxz00_2234;

									BgL_auxz00_2234 = (BgL_objectz00_bglt) (BgL_classz00_13);
									BgL_auxz00_2233 = BGL_OBJECT_WIDENING(BgL_auxz00_2234);
								}
								BgL_arg2584z00_643 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2233))->
									BgL_wideningz00);
							}
							BgL_arg2585z00_644 = CNST_TABLE_REF(((long) 5));
							{
								BgL_typez00_bglt BgL_auxz00_2239;

								BgL_auxz00_2239 = (BgL_typez00_bglt) (BgL_classz00_13);
								BgL_arg2586z00_645 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2239))->BgL_idz00);
							}
							{	/* Object/creator.scm 111 */
								obj_t BgL_list2587z00_646;

								{	/* Object/creator.scm 111 */
									obj_t BgL_arg2588z00_647;

									{	/* Object/creator.scm 111 */
										obj_t BgL_arg2589z00_648;

										BgL_arg2589z00_648 = MAKE_PAIR(BgL_arg2586z00_645, BNIL);
										BgL_arg2588z00_647 =
											MAKE_PAIR(BgL_arg2585z00_644, BgL_arg2589z00_648);
									}
									BgL_list2587z00_646 =
										MAKE_PAIR(BgL_arg2584z00_643, BgL_arg2588z00_647);
								}
								BgL_wideningz00_628 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2587z00_646);
						}}
						{	/* Object/creator.scm 113 */
							obj_t BgL_arg2570z00_630;

							obj_t BgL_arg2571z00_631;

							{	/* Object/creator.scm 113 */
								obj_t BgL_arg2575z00_634;

								obj_t BgL_arg2576z00_635;

								BgL_arg2575z00_634 = CNST_TABLE_REF(((long) 6));
								{
									BgL_typez00_bglt BgL_auxz00_2247;

									BgL_auxz00_2247 = (BgL_typez00_bglt) (BgL_classz00_13);
									BgL_arg2576z00_635 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2247))->BgL_idz00);
								}
								BgL_arg2570z00_630 =
									BGl_genzd2classzd2makez12z12zzobject_creatorz00
									(BgL_arg2575z00_634, BgL_wideningz00_628, BgL_arg2576z00_635,
									BgL_classz00_13, BgL_srczd2defzd2_14, BgL_importz00_15);
							}
							{	/* Object/creator.scm 114 */
								obj_t BgL_arg2577z00_636;

								{
									BgL_typez00_bglt BgL_auxz00_2251;

									BgL_auxz00_2251 = (BgL_typez00_bglt) (BgL_classz00_13);
									BgL_arg2577z00_636 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2251))->BgL_idz00);
								}
								BgL_arg2571z00_631 =
									BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00
									(BgL_arg2577z00_636, BgL_classz00_13, BgL_srczd2defzd2_14,
									BgL_importz00_15);
							}
							{	/* Object/creator.scm 113 */
								obj_t BgL_list2572z00_632;

								{	/* Object/creator.scm 113 */
									obj_t BgL_arg2574z00_633;

									BgL_arg2574z00_633 = MAKE_PAIR(BgL_arg2571z00_631, BNIL);
									BgL_list2572z00_632 =
										MAKE_PAIR(BgL_arg2570z00_630, BgL_arg2574z00_633);
								}
								return BgL_list2572z00_632;
							}
						}
					}
			}
		}
	}



/* gen-inline-wide-class-creators */
	obj_t
		BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_16, obj_t BgL_srczd2defzd2_17,
		obj_t BgL_importz00_18)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 119 */
			{	/* Object/creator.scm 121 */
				bool_t BgL_testz00_2257;

				{
					obj_t BgL_auxz00_2258;

					{	/* Object/creator.scm 121 */
						BgL_objectz00_bglt BgL_auxz00_2259;

						BgL_auxz00_2259 = (BgL_objectz00_bglt) (BgL_classz00_16);
						BgL_auxz00_2258 = BGL_OBJECT_WIDENING(BgL_auxz00_2259);
					}
					BgL_testz00_2257 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2258))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2257)
					{	/* Object/creator.scm 121 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 123 */
						obj_t BgL_fillzd2idzd2_651;

						obj_t BgL_wideningz00_652;

						obj_t BgL_superz00_653;

						{	/* Object/creator.scm 123 */
							obj_t BgL_arg2598z00_661;

							obj_t BgL_arg2600z00_662;

							obj_t BgL_arg2601z00_663;

							BgL_arg2598z00_661 = CNST_TABLE_REF(((long) 1));
							{
								BgL_typez00_bglt BgL_auxz00_2264;

								BgL_auxz00_2264 = (BgL_typez00_bglt) (BgL_classz00_16);
								BgL_arg2600z00_662 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2264))->BgL_idz00);
							}
							BgL_arg2601z00_663 = CNST_TABLE_REF(((long) 2));
							{	/* Object/creator.scm 123 */
								obj_t BgL_list2602z00_664;

								{	/* Object/creator.scm 123 */
									obj_t BgL_arg2603z00_665;

									{	/* Object/creator.scm 123 */
										obj_t BgL_arg2604z00_666;

										BgL_arg2604z00_666 = MAKE_PAIR(BgL_arg2601z00_663, BNIL);
										BgL_arg2603z00_665 =
											MAKE_PAIR(BgL_arg2600z00_662, BgL_arg2604z00_666);
									}
									BgL_list2602z00_664 =
										MAKE_PAIR(BgL_arg2598z00_661, BgL_arg2603z00_665);
								}
								BgL_fillzd2idzd2_651 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2602z00_664);
						}}
						{	/* Object/creator.scm 124 */
							obj_t BgL_arg2606z00_667;

							obj_t BgL_arg2607z00_668;

							obj_t BgL_arg2608z00_669;

							{
								obj_t BgL_auxz00_2272;

								{	/* Object/creator.scm 124 */
									BgL_objectz00_bglt BgL_auxz00_2273;

									BgL_auxz00_2273 = (BgL_objectz00_bglt) (BgL_classz00_16);
									BgL_auxz00_2272 = BGL_OBJECT_WIDENING(BgL_auxz00_2273);
								}
								BgL_arg2606z00_667 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2272))->
									BgL_wideningz00);
							}
							BgL_arg2607z00_668 = CNST_TABLE_REF(((long) 5));
							{
								BgL_typez00_bglt BgL_auxz00_2278;

								BgL_auxz00_2278 = (BgL_typez00_bglt) (BgL_classz00_16);
								BgL_arg2608z00_669 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2278))->BgL_idz00);
							}
							{	/* Object/creator.scm 124 */
								obj_t BgL_list2609z00_670;

								{	/* Object/creator.scm 124 */
									obj_t BgL_arg2610z00_671;

									{	/* Object/creator.scm 124 */
										obj_t BgL_arg2611z00_672;

										BgL_arg2611z00_672 = MAKE_PAIR(BgL_arg2608z00_669, BNIL);
										BgL_arg2610z00_671 =
											MAKE_PAIR(BgL_arg2607z00_668, BgL_arg2611z00_672);
									}
									BgL_list2609z00_670 =
										MAKE_PAIR(BgL_arg2606z00_667, BgL_arg2610z00_671);
								}
								BgL_wideningz00_652 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2609z00_670);
						}}
						{
							obj_t BgL_auxz00_2285;

							{	/* Object/creator.scm 125 */
								BgL_objectz00_bglt BgL_auxz00_2286;

								BgL_auxz00_2286 = (BgL_objectz00_bglt) (BgL_classz00_16);
								BgL_auxz00_2285 = BGL_OBJECT_WIDENING(BgL_auxz00_2286);
							}
							BgL_superz00_653 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2285))->
								BgL_itszd2superzd2);
						}
						{	/* Object/creator.scm 126 */
							obj_t BgL_arg2591z00_654;

							obj_t BgL_arg2592z00_655;

							{	/* Object/creator.scm 126 */
								obj_t BgL_arg2595z00_658;

								{
									BgL_typez00_bglt BgL_auxz00_2290;

									BgL_auxz00_2290 = (BgL_typez00_bglt) (BgL_classz00_16);
									BgL_arg2595z00_658 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2290))->BgL_idz00);
								}
								BgL_arg2591z00_654 =
									BGl_genzd2classzd2fillz12z12zzobject_creatorz00
									(BgL_fillzd2idzd2_651, BgL_arg2595z00_658, BgL_classz00_16,
									BgL_srczd2defzd2_17, BgL_importz00_18);
							}
							{	/* Object/creator.scm 127 */
								obj_t BgL_arg2596z00_659;

								BgL_globalz00_bglt BgL_arg2597z00_660;

								{
									BgL_typez00_bglt BgL_auxz00_2294;

									BgL_auxz00_2294 = (BgL_typez00_bglt) (BgL_classz00_16);
									BgL_arg2596z00_659 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2294))->BgL_idz00);
								}
								{
									obj_t BgL_auxz00_2297;

									{	/* Object/creator.scm 127 */
										BgL_objectz00_bglt BgL_auxz00_2298;

										BgL_auxz00_2298 = (BgL_objectz00_bglt) (BgL_classz00_16);
										BgL_auxz00_2297 = BGL_OBJECT_WIDENING(BgL_auxz00_2298);
									}
									BgL_arg2597z00_660 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2297))->
										BgL_holderz00);
								}
								BgL_arg2592z00_655 =
									BGl_genzd2classzd2allocatez12z12zzobject_creatorz00
									(BgL_arg2596z00_659, BgL_superz00_653, BgL_arg2597z00_660,
									BgL_srczd2defzd2_17, BgL_importz00_18);
							}
							{	/* Object/creator.scm 126 */
								obj_t BgL_list2593z00_656;

								{	/* Object/creator.scm 126 */
									obj_t BgL_arg2594z00_657;

									BgL_arg2594z00_657 = MAKE_PAIR(BgL_arg2592z00_655, BNIL);
									BgL_list2593z00_656 =
										MAKE_PAIR(BgL_arg2591z00_654, BgL_arg2594z00_657);
								}
								return BgL_list2593z00_656;
							}
						}
					}
			}
		}
	}



/* gen-java-class-creator */
	obj_t
		BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt
		BgL_classz00_19, obj_t BgL_srczd2defzd2_20)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 132 */
			{	/* Object/creator.scm 133 */
				obj_t BgL_idz00_673;

				{
					BgL_typez00_bglt BgL_auxz00_2305;

					BgL_auxz00_2305 = (BgL_typez00_bglt) (BgL_classz00_19);
					BgL_idz00_673 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_2305))->BgL_idz00);
				}
				{	/* Object/creator.scm 133 */
					obj_t BgL_alloczd2idzd2_674;

					{	/* Object/creator.scm 134 */
						obj_t BgL_arg2634z00_699;

						{	/* Object/creator.scm 134 */
							obj_t BgL_arg2635z00_700;

							obj_t BgL_arg2636z00_701;

							{	/* Object/creator.scm 134 */
								obj_t BgL_symbolz00_1833;

								BgL_symbolz00_1833 = CNST_TABLE_REF(((long) 7));
								BgL_arg2635z00_700 = SYMBOL_TO_STRING(BgL_symbolz00_1833);
							}
							BgL_arg2636z00_701 = SYMBOL_TO_STRING(BgL_idz00_673);
							{	/* Object/creator.scm 134 */
								obj_t BgL_list2637z00_702;

								{	/* Object/creator.scm 134 */
									obj_t BgL_arg2638z00_703;

									BgL_arg2638z00_703 = MAKE_PAIR(BgL_arg2636z00_701, BNIL);
									BgL_list2637z00_702 =
										MAKE_PAIR(BgL_arg2635z00_700, BgL_arg2638z00_703);
								}
								BgL_arg2634z00_699 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list2637z00_702);
						}}
						BgL_alloczd2idzd2_674 =
							string_to_symbol(BSTRING_TO_STRING(BgL_arg2634z00_699));
					}
					{	/* Object/creator.scm 134 */

						{

							{	/* Object/creator.scm 138 */
								obj_t BgL_arg2612z00_676;

								{	/* Object/creator.scm 138 */
									obj_t BgL_arg2613z00_677;

									obj_t BgL_arg2614z00_678;

									BgL_arg2613z00_677 = CNST_TABLE_REF(((long) 10));
									{	/* Object/creator.scm 138 */
										obj_t BgL_arg2615z00_679;

										{	/* Object/creator.scm 138 */
											obj_t BgL_arg2618z00_682;

											obj_t BgL_arg2619z00_683;

											BgL_arg2618z00_682 = CNST_TABLE_REF(((long) 11));
											{	/* Object/creator.scm 138 */
												obj_t BgL_list2620z00_684;

												BgL_list2620z00_684 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg2619z00_683 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_alloczd2idzd2_674, BgL_list2620z00_684);
											}
											BgL_arg2615z00_679 =
												MAKE_PAIR(BgL_arg2618z00_682, BgL_arg2619z00_683);
										}
										{	/* Object/creator.scm 138 */
											obj_t BgL_list2617z00_681;

											BgL_list2617z00_681 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg2614z00_678 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg2615z00_679, BgL_list2617z00_681);
									}}
									BgL_arg2612z00_676 =
										MAKE_PAIR(BgL_arg2613z00_677, BgL_arg2614z00_678);
								}
								BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
									(BgL_arg2612z00_676);
							}
							{	/* Object/creator.scm 139 */
								obj_t BgL_arg2621z00_685;

								{	/* Object/creator.scm 139 */
									obj_t BgL_arg2623z00_687;

									{	/* Object/creator.scm 136 */
										obj_t BgL_arg2626z00_690;

										obj_t BgL_arg2627z00_691;

										BgL_arg2626z00_690 = CNST_TABLE_REF(((long) 8));
										{	/* Object/creator.scm 136 */
											obj_t BgL_arg2628z00_692;

											obj_t BgL_arg2629z00_693;

											BgL_arg2628z00_692 =
												MAKE_PAIR(BgL_alloczd2idzd2_674, BNIL);
											BgL_arg2629z00_693 =
												BGl_makezd2privatezd2sexpz00zzast_privatez00
												(CNST_TABLE_REF(((long) 9)), BgL_idz00_673, BNIL);
											{	/* Object/creator.scm 136 */
												obj_t BgL_list2631z00_695;

												{	/* Object/creator.scm 136 */
													obj_t BgL_arg2632z00_696;

													BgL_arg2632z00_696 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2631z00_695 =
														MAKE_PAIR(BgL_arg2629z00_693, BgL_arg2632z00_696);
												}
												BgL_arg2627z00_691 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2628z00_692, BgL_list2631z00_695);
										}}
										BgL_arg2623z00_687 =
											MAKE_PAIR(BgL_arg2626z00_690, BgL_arg2627z00_691);
									}
									{	/* Object/creator.scm 139 */
										obj_t BgL_list2624z00_688;

										BgL_list2624z00_688 = MAKE_PAIR(BgL_srczd2defzd2_20, BNIL);
										BgL_arg2621z00_685 =
											BGl_epairifyza2za2zztools_miscz00(BgL_arg2623z00_687,
											BgL_list2624z00_688);
								}}
								{	/* Object/creator.scm 139 */
									obj_t BgL_list2622z00_686;

									BgL_list2622z00_686 = MAKE_PAIR(BgL_arg2621z00_685, BNIL);
									return BgL_list2622z00_686;
								}
							}
						}
					}
				}
			}
		}
	}



/* import-plain-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_21, obj_t BgL_srczd2defzd2_22,
		obj_t BgL_modulez00_23)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 144 */
			BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_classz00_21,
				BgL_srczd2defzd2_22, BgL_modulez00_23);
			{	/* Object/creator.scm 146 */
				bool_t BgL_testz00_2337;

				{
					obj_t BgL_auxz00_2338;

					{	/* Object/creator.scm 146 */
						BgL_objectz00_bglt BgL_auxz00_2339;

						BgL_auxz00_2339 = (BgL_objectz00_bglt) (BgL_classz00_21);
						BgL_auxz00_2338 = BGL_OBJECT_WIDENING(BgL_auxz00_2339);
					}
					BgL_testz00_2337 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2338))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2337)
					{	/* Object/creator.scm 146 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 146 */
						if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
							{	/* Object/creator.scm 148 */
								BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
								return
									BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22,
									CNST_TABLE_REF(((long) 10)));
							}
						else
							{	/* Object/creator.scm 148 */
								BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
								return
									BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
							}
					}
			}
		}
	}



/* _import-plain-class-creators */
	obj_t BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2087, obj_t BgL_classz00_2088, obj_t BgL_srczd2defzd2_2089,
		obj_t BgL_modulez00_2090)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 144 */
			return
				BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2088), BgL_srczd2defzd2_2089,
				BgL_modulez00_2090);
		}
	}



/* import-inline-plain-class-creators */
	obj_t
		BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_24, obj_t BgL_srczd2defzd2_25,
		obj_t BgL_modulez00_26)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 160 */
			{	/* Object/creator.scm 162 */
				obj_t BgL_mkzd2idzd2_707;

				{	/* Object/creator.scm 162 */
					obj_t BgL_arg2668z00_741;

					{	/* Object/creator.scm 162 */
						obj_t BgL_arg2669z00_742;

						obj_t BgL_arg2670z00_743;

						{	/* Object/creator.scm 162 */
							obj_t BgL_symbolz00_1839;

							BgL_symbolz00_1839 = CNST_TABLE_REF(((long) 3));
							BgL_arg2669z00_742 = SYMBOL_TO_STRING(BgL_symbolz00_1839);
						}
						{	/* Object/creator.scm 162 */
							obj_t BgL_arg2673z00_746;

							{
								BgL_typez00_bglt BgL_auxz00_2354;

								BgL_auxz00_2354 = (BgL_typez00_bglt) (BgL_classz00_24);
								BgL_arg2673z00_746 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2354))->BgL_idz00);
							}
							BgL_arg2670z00_743 = SYMBOL_TO_STRING(BgL_arg2673z00_746);
						}
						{	/* Object/creator.scm 162 */
							obj_t BgL_list2671z00_744;

							{	/* Object/creator.scm 162 */
								obj_t BgL_arg2672z00_745;

								BgL_arg2672z00_745 = MAKE_PAIR(BgL_arg2670z00_743, BNIL);
								BgL_list2671z00_744 =
									MAKE_PAIR(BgL_arg2669z00_742, BgL_arg2672z00_745);
							}
							BgL_arg2668z00_741 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2671z00_744);
					}}
					BgL_mkzd2idzd2_707 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2668z00_741));
				}
				{	/* Object/creator.scm 162 */
					obj_t BgL_fillzd2idzd2_708;

					{	/* Object/creator.scm 163 */
						obj_t BgL_arg2662z00_735;

						obj_t BgL_arg2663z00_736;

						obj_t BgL_arg2664z00_737;

						BgL_arg2662z00_735 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2364;

							BgL_auxz00_2364 = (BgL_typez00_bglt) (BgL_classz00_24);
							BgL_arg2663z00_736 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2364))->BgL_idz00);
						}
						BgL_arg2664z00_737 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 163 */
							obj_t BgL_list2665z00_738;

							{	/* Object/creator.scm 163 */
								obj_t BgL_arg2666z00_739;

								{	/* Object/creator.scm 163 */
									obj_t BgL_arg2667z00_740;

									BgL_arg2667z00_740 = MAKE_PAIR(BgL_arg2664z00_737, BNIL);
									BgL_arg2666z00_739 =
										MAKE_PAIR(BgL_arg2663z00_736, BgL_arg2667z00_740);
								}
								BgL_list2665z00_738 =
									MAKE_PAIR(BgL_arg2662z00_735, BgL_arg2666z00_739);
							}
							BgL_fillzd2idzd2_708 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2665z00_738);
					}}
					{	/* Object/creator.scm 163 */
						obj_t BgL_mkzd2tidzd2_709;

						{	/* Object/creator.scm 164 */
							obj_t BgL_arg2661z00_734;

							{
								BgL_typez00_bglt BgL_auxz00_2372;

								BgL_auxz00_2372 = (BgL_typez00_bglt) (BgL_classz00_24);
								BgL_arg2661z00_734 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2372))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_709 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_707,
								BgL_arg2661z00_734);
						}
						{	/* Object/creator.scm 164 */
							obj_t BgL_fzd2idszd2_710;

							{	/* Object/creator.scm 165 */
								obj_t BgL_arg2660z00_733;

								{
									obj_t BgL_auxz00_2376;

									{	/* Object/creator.scm 165 */
										BgL_objectz00_bglt BgL_auxz00_2377;

										BgL_auxz00_2377 = (BgL_objectz00_bglt) (BgL_classz00_24);
										BgL_auxz00_2376 = BGL_OBJECT_WIDENING(BgL_auxz00_2377);
									}
									BgL_arg2660z00_733 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2376))->
										BgL_slotsz00);
								}
								BgL_fzd2idszd2_710 =
									BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
									(BgL_arg2660z00_733);
							}
							{	/* Object/creator.scm 165 */
								obj_t BgL_fzd2tidszd2_711;

								{	/* Object/creator.scm 166 */
									obj_t BgL_arg2659z00_732;

									{
										obj_t BgL_auxz00_2382;

										{	/* Object/creator.scm 166 */
											BgL_objectz00_bglt BgL_auxz00_2383;

											BgL_auxz00_2383 = (BgL_objectz00_bglt) (BgL_classz00_24);
											BgL_auxz00_2382 = BGL_OBJECT_WIDENING(BgL_auxz00_2383);
										}
										BgL_arg2659z00_732 =
											(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2382))->
											BgL_slotsz00);
									}
									BgL_fzd2tidszd2_711 =
										BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
										(BgL_fzd2idszd2_710, BgL_arg2659z00_732);
								}
								{	/* Object/creator.scm 166 */
									obj_t BgL_toz00_712;

									{	/* Object/creator.scm 167 */
										obj_t BgL_arg2655z00_729;

										obj_t BgL_arg2657z00_730;

										BgL_arg2655z00_729 =
											BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
											(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
														12))));
										{
											BgL_typez00_bglt BgL_auxz00_2391;

											BgL_auxz00_2391 = (BgL_typez00_bglt) (BgL_classz00_24);
											BgL_arg2657z00_730 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2391))->BgL_idz00);
										}
										BgL_toz00_712 =
											BGl_makezd2typedzd2identz00zzast_identz00
											(BgL_arg2655z00_729, BgL_arg2657z00_730);
									}
									{	/* Object/creator.scm 167 */
										obj_t BgL_alloczd2idzd2_713;

										{	/* Object/creator.scm 168 */
											obj_t BgL_arg2649z00_723;

											{	/* Object/creator.scm 168 */
												obj_t BgL_arg2650z00_724;

												obj_t BgL_arg2651z00_725;

												{	/* Object/creator.scm 168 */
													obj_t BgL_symbolz00_1848;

													BgL_symbolz00_1848 = CNST_TABLE_REF(((long) 7));
													BgL_arg2650z00_724 =
														SYMBOL_TO_STRING(BgL_symbolz00_1848);
												}
												{	/* Object/creator.scm 168 */
													obj_t BgL_arg2654z00_728;

													{
														BgL_typez00_bglt BgL_auxz00_2397;

														BgL_auxz00_2397 =
															(BgL_typez00_bglt) (BgL_classz00_24);
														BgL_arg2654z00_728 =
															(((BgL_typez00_bglt) CREF(BgL_auxz00_2397))->
															BgL_idz00);
													}
													BgL_arg2651z00_725 =
														SYMBOL_TO_STRING(BgL_arg2654z00_728);
												}
												{	/* Object/creator.scm 168 */
													obj_t BgL_list2652z00_726;

													{	/* Object/creator.scm 168 */
														obj_t BgL_arg2653z00_727;

														BgL_arg2653z00_727 =
															MAKE_PAIR(BgL_arg2651z00_725, BNIL);
														BgL_list2652z00_726 =
															MAKE_PAIR(BgL_arg2650z00_724, BgL_arg2653z00_727);
													}
													BgL_arg2649z00_723 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list2652z00_726);
											}}
											BgL_alloczd2idzd2_713 =
												string_to_symbol(BSTRING_TO_STRING(BgL_arg2649z00_723));
										}
										{	/* Object/creator.scm 168 */
											obj_t BgL_alloczd2tidzd2_714;

											{	/* Object/creator.scm 169 */
												obj_t BgL_arg2648z00_722;

												{
													BgL_typez00_bglt BgL_auxz00_2406;

													BgL_auxz00_2406 =
														(BgL_typez00_bglt) (BgL_classz00_24);
													BgL_arg2648z00_722 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2406))->
														BgL_idz00);
												}
												BgL_alloczd2tidzd2_714 =
													BGl_makezd2typedzd2identz00zzast_identz00
													(BgL_alloczd2idzd2_713, BgL_arg2648z00_722);
											}
											{	/* Object/creator.scm 169 */

												{	/* Object/creator.scm 171 */
													obj_t BgL_arg2641z00_715;

													BgL_arg2641z00_715 =
														MAKE_PAIR(BgL_alloczd2tidzd2_714, BNIL);
													BGl_importzd2parserzd2zzmodule_impusez00
														(BgL_modulez00_26, BgL_arg2641z00_715, BNIL);
												}
												{	/* Object/creator.scm 172 */
													obj_t BgL_arg2643z00_717;

													{	/* Object/creator.scm 172 */
														obj_t BgL_arg2645z00_719;

														{	/* Object/creator.scm 172 */
															obj_t BgL_arg2646z00_720;

															BgL_arg2646z00_720 =
																BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																(BgL_fzd2tidszd2_711, BNIL);
															{	/* Object/creator.scm 172 */
																obj_t BgL_list2647z00_721;

																BgL_list2647z00_721 =
																	MAKE_PAIR(BgL_arg2646z00_720, BNIL);
																BgL_arg2645z00_719 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_toz00_712, BgL_list2647z00_721);
														}}
														BgL_arg2643z00_717 =
															MAKE_PAIR(BgL_fillzd2idzd2_708,
															BgL_arg2645z00_719);
													}
													BGl_importzd2parserzd2zzmodule_impusez00
														(BgL_modulez00_26, BgL_arg2643z00_717, BNIL);
												}
												return BNIL;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-noinline-plain-class-creators */
	obj_t
		BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_27, obj_t BgL_srczd2defzd2_28,
		obj_t BgL_modulez00_29)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 179 */
			{	/* Object/creator.scm 181 */
				obj_t BgL_mkzd2idzd2_748;

				{	/* Object/creator.scm 181 */
					obj_t BgL_arg2680z00_758;

					{	/* Object/creator.scm 181 */
						obj_t BgL_arg2681z00_759;

						obj_t BgL_arg2682z00_760;

						{	/* Object/creator.scm 181 */
							obj_t BgL_symbolz00_1853;

							BgL_symbolz00_1853 = CNST_TABLE_REF(((long) 3));
							BgL_arg2681z00_759 = SYMBOL_TO_STRING(BgL_symbolz00_1853);
						}
						{	/* Object/creator.scm 181 */
							obj_t BgL_arg2685z00_763;

							{
								BgL_typez00_bglt BgL_auxz00_2419;

								BgL_auxz00_2419 = (BgL_typez00_bglt) (BgL_classz00_27);
								BgL_arg2685z00_763 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2419))->BgL_idz00);
							}
							BgL_arg2682z00_760 = SYMBOL_TO_STRING(BgL_arg2685z00_763);
						}
						{	/* Object/creator.scm 181 */
							obj_t BgL_list2683z00_761;

							{	/* Object/creator.scm 181 */
								obj_t BgL_arg2684z00_762;

								BgL_arg2684z00_762 = MAKE_PAIR(BgL_arg2682z00_760, BNIL);
								BgL_list2683z00_761 =
									MAKE_PAIR(BgL_arg2681z00_759, BgL_arg2684z00_762);
							}
							BgL_arg2680z00_758 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2683z00_761);
					}}
					BgL_mkzd2idzd2_748 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2680z00_758));
				}
				{	/* Object/creator.scm 181 */
					obj_t BgL_mkzd2tidzd2_749;

					{	/* Object/creator.scm 182 */
						obj_t BgL_arg2679z00_757;

						{
							BgL_typez00_bglt BgL_auxz00_2428;

							BgL_auxz00_2428 = (BgL_typez00_bglt) (BgL_classz00_27);
							BgL_arg2679z00_757 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2428))->BgL_idz00);
						}
						BgL_mkzd2tidzd2_749 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_748,
							BgL_arg2679z00_757);
					}
					{	/* Object/creator.scm 182 */
						obj_t BgL_fzd2idszd2_750;

						{	/* Object/creator.scm 183 */
							obj_t BgL_arg2678z00_756;

							{
								obj_t BgL_auxz00_2432;

								{	/* Object/creator.scm 183 */
									BgL_objectz00_bglt BgL_auxz00_2433;

									BgL_auxz00_2433 = (BgL_objectz00_bglt) (BgL_classz00_27);
									BgL_auxz00_2432 = BGL_OBJECT_WIDENING(BgL_auxz00_2433);
								}
								BgL_arg2678z00_756 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2432))->BgL_slotsz00);
							}
							BgL_fzd2idszd2_750 =
								BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
								(BgL_arg2678z00_756);
						}
						{	/* Object/creator.scm 183 */
							obj_t BgL_fzd2tidszd2_751;

							{	/* Object/creator.scm 184 */
								obj_t BgL_arg2677z00_755;

								{
									obj_t BgL_auxz00_2438;

									{	/* Object/creator.scm 184 */
										BgL_objectz00_bglt BgL_auxz00_2439;

										BgL_auxz00_2439 = (BgL_objectz00_bglt) (BgL_classz00_27);
										BgL_auxz00_2438 = BGL_OBJECT_WIDENING(BgL_auxz00_2439);
									}
									BgL_arg2677z00_755 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2438))->
										BgL_slotsz00);
								}
								BgL_fzd2tidszd2_751 =
									BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
									(BgL_fzd2idszd2_750, BgL_arg2677z00_755);
							}
							{	/* Object/creator.scm 184 */

								{	/* Object/creator.scm 186 */
									obj_t BgL_arg2674z00_752;

									BgL_arg2674z00_752 =
										MAKE_PAIR(BgL_mkzd2tidzd2_749,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_fzd2tidszd2_751, BNIL));
									BGl_importzd2parserzd2zzmodule_impusez00(BgL_modulez00_29,
										BgL_arg2674z00_752, BNIL);
								}
								return BNIL;
							}
						}
					}
				}
			}
		}
	}



/* import-wide-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_30, obj_t BgL_srczd2defzd2_31,
		obj_t BgL_modulez00_32)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 193 */
			BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_classz00_30,
				BgL_srczd2defzd2_31, BgL_modulez00_32);
			{	/* Object/creator.scm 195 */
				bool_t BgL_testz00_2448;

				{
					obj_t BgL_auxz00_2449;

					{	/* Object/creator.scm 195 */
						BgL_objectz00_bglt BgL_auxz00_2450;

						BgL_auxz00_2450 = (BgL_objectz00_bglt) (BgL_classz00_30);
						BgL_auxz00_2449 = BGL_OBJECT_WIDENING(BgL_auxz00_2450);
					}
					BgL_testz00_2448 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2449))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2448)
					{	/* Object/creator.scm 195 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 195 */
						if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
							{	/* Object/creator.scm 197 */
								BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
								return
									BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31,
									CNST_TABLE_REF(((long) 10)));
							}
						else
							{	/* Object/creator.scm 197 */
								BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
								return
									BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
							}
					}
			}
		}
	}



/* _import-wide-class-creators */
	obj_t BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2091, obj_t BgL_classz00_2092, obj_t BgL_srczd2defzd2_2093,
		obj_t BgL_modulez00_2094)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 193 */
			return
				BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2092), BgL_srczd2defzd2_2093,
				BgL_modulez00_2094);
		}
	}



/* import-inline-wide-class-creators */
	obj_t
		BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_33, obj_t BgL_srczd2defzd2_34,
		obj_t BgL_modulez00_35)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 209 */
			{	/* Object/creator.scm 211 */
				obj_t BgL_mkzd2idzd2_767;

				{	/* Object/creator.scm 211 */
					obj_t BgL_arg2723z00_810;

					{	/* Object/creator.scm 211 */
						obj_t BgL_arg2724z00_811;

						obj_t BgL_arg2725z00_812;

						{	/* Object/creator.scm 211 */
							obj_t BgL_symbolz00_1861;

							BgL_symbolz00_1861 = CNST_TABLE_REF(((long) 3));
							BgL_arg2724z00_811 = SYMBOL_TO_STRING(BgL_symbolz00_1861);
						}
						{	/* Object/creator.scm 211 */
							obj_t BgL_arg2729z00_815;

							{
								BgL_typez00_bglt BgL_auxz00_2465;

								BgL_auxz00_2465 = (BgL_typez00_bglt) (BgL_classz00_33);
								BgL_arg2729z00_815 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2465))->BgL_idz00);
							}
							BgL_arg2725z00_812 = SYMBOL_TO_STRING(BgL_arg2729z00_815);
						}
						{	/* Object/creator.scm 211 */
							obj_t BgL_list2726z00_813;

							{	/* Object/creator.scm 211 */
								obj_t BgL_arg2727z00_814;

								BgL_arg2727z00_814 = MAKE_PAIR(BgL_arg2725z00_812, BNIL);
								BgL_list2726z00_813 =
									MAKE_PAIR(BgL_arg2724z00_811, BgL_arg2727z00_814);
							}
							BgL_arg2723z00_810 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2726z00_813);
					}}
					BgL_mkzd2idzd2_767 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2723z00_810));
				}
				{	/* Object/creator.scm 211 */
					obj_t BgL_fillzd2idzd2_768;

					{	/* Object/creator.scm 212 */
						obj_t BgL_arg2716z00_804;

						obj_t BgL_arg2717z00_805;

						obj_t BgL_arg2718z00_806;

						BgL_arg2716z00_804 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2475;

							BgL_auxz00_2475 = (BgL_typez00_bglt) (BgL_classz00_33);
							BgL_arg2717z00_805 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2475))->BgL_idz00);
						}
						BgL_arg2718z00_806 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 212 */
							obj_t BgL_list2719z00_807;

							{	/* Object/creator.scm 212 */
								obj_t BgL_arg2720z00_808;

								{	/* Object/creator.scm 212 */
									obj_t BgL_arg2721z00_809;

									BgL_arg2721z00_809 = MAKE_PAIR(BgL_arg2718z00_806, BNIL);
									BgL_arg2720z00_808 =
										MAKE_PAIR(BgL_arg2717z00_805, BgL_arg2721z00_809);
								}
								BgL_list2719z00_807 =
									MAKE_PAIR(BgL_arg2716z00_804, BgL_arg2720z00_808);
							}
							BgL_fillzd2idzd2_768 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2719z00_807);
					}}
					{	/* Object/creator.scm 212 */
						obj_t BgL_mkzd2tidzd2_769;

						{	/* Object/creator.scm 213 */
							obj_t BgL_arg2715z00_803;

							{
								BgL_typez00_bglt BgL_auxz00_2483;

								BgL_auxz00_2483 = (BgL_typez00_bglt) (BgL_classz00_33);
								BgL_arg2715z00_803 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2483))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_769 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_767,
								BgL_arg2715z00_803);
						}
						{	/* Object/creator.scm 213 */
							obj_t BgL_alloczd2widezd2_770;

							{	/* Object/creator.scm 214 */
								obj_t BgL_arg2709z00_797;

								{	/* Object/creator.scm 214 */
									obj_t BgL_arg2710z00_798;

									obj_t BgL_arg2711z00_799;

									{	/* Object/creator.scm 214 */
										obj_t BgL_symbolz00_1867;

										BgL_symbolz00_1867 = CNST_TABLE_REF(((long) 13));
										BgL_arg2710z00_798 = SYMBOL_TO_STRING(BgL_symbolz00_1867);
									}
									{	/* Object/creator.scm 214 */
										obj_t BgL_arg2714z00_802;

										{
											BgL_typez00_bglt BgL_auxz00_2489;

											BgL_auxz00_2489 = (BgL_typez00_bglt) (BgL_classz00_33);
											BgL_arg2714z00_802 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2489))->BgL_idz00);
										}
										BgL_arg2711z00_799 = SYMBOL_TO_STRING(BgL_arg2714z00_802);
									}
									{	/* Object/creator.scm 214 */
										obj_t BgL_list2712z00_800;

										{	/* Object/creator.scm 214 */
											obj_t BgL_arg2713z00_801;

											BgL_arg2713z00_801 = MAKE_PAIR(BgL_arg2711z00_799, BNIL);
											BgL_list2712z00_800 =
												MAKE_PAIR(BgL_arg2710z00_798, BgL_arg2713z00_801);
										}
										BgL_arg2709z00_797 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2712z00_800);
								}}
								BgL_alloczd2widezd2_770 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2709z00_797));
							}
							{	/* Object/creator.scm 214 */
								obj_t BgL_talloczd2widezd2_771;

								{	/* Object/creator.scm 215 */
									obj_t BgL_arg2708z00_796;

									{
										BgL_typez00_bglt BgL_auxz00_2498;

										BgL_auxz00_2498 = (BgL_typez00_bglt) (BgL_classz00_33);
										BgL_arg2708z00_796 =
											(((BgL_typez00_bglt) CREF(BgL_auxz00_2498))->BgL_idz00);
									}
									BgL_talloczd2widezd2_771 =
										BGl_makezd2typedzd2identz00zzast_identz00
										(BgL_alloczd2widezd2_770, BgL_arg2708z00_796);
								}
								{	/* Object/creator.scm 215 */
									obj_t BgL_fzd2idszd2_772;

									{	/* Object/creator.scm 216 */
										obj_t BgL_arg2707z00_795;

										{
											obj_t BgL_auxz00_2502;

											{	/* Object/creator.scm 216 */
												BgL_objectz00_bglt BgL_auxz00_2503;

												BgL_auxz00_2503 =
													(BgL_objectz00_bglt) (BgL_classz00_33);
												BgL_auxz00_2502 = BGL_OBJECT_WIDENING(BgL_auxz00_2503);
											}
											BgL_arg2707z00_795 =
												(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2502))->
												BgL_slotsz00);
										}
										BgL_fzd2idszd2_772 =
											BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
											(BgL_arg2707z00_795);
									}
									{	/* Object/creator.scm 216 */
										obj_t BgL_fzd2tidszd2_773;

										{	/* Object/creator.scm 217 */
											obj_t BgL_arg2706z00_794;

											{
												obj_t BgL_auxz00_2508;

												{	/* Object/creator.scm 217 */
													BgL_objectz00_bglt BgL_auxz00_2509;

													BgL_auxz00_2509 =
														(BgL_objectz00_bglt) (BgL_classz00_33);
													BgL_auxz00_2508 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2509);
												}
												BgL_arg2706z00_794 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2508))->
													BgL_slotsz00);
											}
											BgL_fzd2tidszd2_773 =
												BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
												(BgL_fzd2idszd2_772, BgL_arg2706z00_794);
										}
										{	/* Object/creator.scm 217 */
											obj_t BgL_toz00_774;

											{	/* Object/creator.scm 218 */
												obj_t BgL_arg2703z00_791;

												obj_t BgL_arg2704z00_792;

												BgL_arg2703z00_791 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 12))));
												{
													BgL_typez00_bglt BgL_auxz00_2517;

													BgL_auxz00_2517 =
														(BgL_typez00_bglt) (BgL_classz00_33);
													BgL_arg2704z00_792 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2517))->
														BgL_idz00);
												}
												BgL_toz00_774 =
													BGl_makezd2typedzd2identz00zzast_identz00
													(BgL_arg2703z00_791, BgL_arg2704z00_792);
											}
											{	/* Object/creator.scm 218 */
												obj_t BgL_alloczd2idzd2_775;

												{	/* Object/creator.scm 219 */
													obj_t BgL_arg2697z00_785;

													{	/* Object/creator.scm 219 */
														obj_t BgL_arg2698z00_786;

														obj_t BgL_arg2699z00_787;

														{	/* Object/creator.scm 219 */
															obj_t BgL_symbolz00_1875;

															BgL_symbolz00_1875 = CNST_TABLE_REF(((long) 7));
															BgL_arg2698z00_786 =
																SYMBOL_TO_STRING(BgL_symbolz00_1875);
														}
														{	/* Object/creator.scm 219 */
															obj_t BgL_arg2702z00_790;

															{
																BgL_typez00_bglt BgL_auxz00_2523;

																BgL_auxz00_2523 =
																	(BgL_typez00_bglt) (BgL_classz00_33);
																BgL_arg2702z00_790 =
																	(((BgL_typez00_bglt) CREF(BgL_auxz00_2523))->
																	BgL_idz00);
															}
															BgL_arg2699z00_787 =
																SYMBOL_TO_STRING(BgL_arg2702z00_790);
														}
														{	/* Object/creator.scm 219 */
															obj_t BgL_list2700z00_788;

															{	/* Object/creator.scm 219 */
																obj_t BgL_arg2701z00_789;

																BgL_arg2701z00_789 =
																	MAKE_PAIR(BgL_arg2699z00_787, BNIL);
																BgL_list2700z00_788 =
																	MAKE_PAIR(BgL_arg2698z00_786,
																	BgL_arg2701z00_789);
															}
															BgL_arg2697z00_785 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list2700z00_788);
													}}
													BgL_alloczd2idzd2_775 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg2697z00_785));
												}
												{	/* Object/creator.scm 219 */
													obj_t BgL_alloczd2tidzd2_776;

													{	/* Object/creator.scm 220 */
														obj_t BgL_arg2696z00_784;

														{
															BgL_typez00_bglt BgL_auxz00_2532;

															BgL_auxz00_2532 =
																(BgL_typez00_bglt) (BgL_classz00_33);
															BgL_arg2696z00_784 =
																(((BgL_typez00_bglt) CREF(BgL_auxz00_2532))->
																BgL_idz00);
														}
														BgL_alloczd2tidzd2_776 =
															BGl_makezd2typedzd2identz00zzast_identz00
															(BgL_alloczd2idzd2_775, BgL_arg2696z00_784);
													}
													{	/* Object/creator.scm 220 */

														{	/* Object/creator.scm 222 */
															obj_t BgL_arg2688z00_777;

															BgL_arg2688z00_777 =
																MAKE_PAIR(BgL_alloczd2tidzd2_776, BNIL);
															BGl_importzd2parserzd2zzmodule_impusez00
																(BgL_modulez00_35, BgL_arg2688z00_777, BNIL);
														}
														{	/* Object/creator.scm 223 */
															obj_t BgL_arg2690z00_779;

															{	/* Object/creator.scm 223 */
																obj_t BgL_arg2693z00_781;

																{	/* Object/creator.scm 223 */
																	obj_t BgL_arg2694z00_782;

																	BgL_arg2694z00_782 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_fzd2tidszd2_773, BNIL);
																	{	/* Object/creator.scm 223 */
																		obj_t BgL_list2695z00_783;

																		BgL_list2695z00_783 =
																			MAKE_PAIR(BgL_arg2694z00_782, BNIL);
																		BgL_arg2693z00_781 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_toz00_774, BgL_list2695z00_783);
																}}
																BgL_arg2690z00_779 =
																	MAKE_PAIR(BgL_fillzd2idzd2_768,
																	BgL_arg2693z00_781);
															}
															BGl_importzd2parserzd2zzmodule_impusez00
																(BgL_modulez00_35, BgL_arg2690z00_779, BNIL);
														}
														return BNIL;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-noinline-wide-class-creators */
	obj_t
		BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_36, obj_t BgL_srczd2defzd2_37,
		obj_t BgL_modulez00_38)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 230 */
			{	/* Object/creator.scm 232 */
				obj_t BgL_mkzd2idzd2_817;

				{	/* Object/creator.scm 232 */
					obj_t BgL_arg2754z00_852;

					{	/* Object/creator.scm 232 */
						obj_t BgL_arg2755z00_853;

						obj_t BgL_arg2756z00_854;

						{	/* Object/creator.scm 232 */
							obj_t BgL_symbolz00_1880;

							BgL_symbolz00_1880 = CNST_TABLE_REF(((long) 3));
							BgL_arg2755z00_853 = SYMBOL_TO_STRING(BgL_symbolz00_1880);
						}
						{	/* Object/creator.scm 232 */
							obj_t BgL_arg2760z00_857;

							{
								BgL_typez00_bglt BgL_auxz00_2545;

								BgL_auxz00_2545 = (BgL_typez00_bglt) (BgL_classz00_36);
								BgL_arg2760z00_857 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2545))->BgL_idz00);
							}
							BgL_arg2756z00_854 = SYMBOL_TO_STRING(BgL_arg2760z00_857);
						}
						{	/* Object/creator.scm 232 */
							obj_t BgL_list2757z00_855;

							{	/* Object/creator.scm 232 */
								obj_t BgL_arg2759z00_856;

								BgL_arg2759z00_856 = MAKE_PAIR(BgL_arg2756z00_854, BNIL);
								BgL_list2757z00_855 =
									MAKE_PAIR(BgL_arg2755z00_853, BgL_arg2759z00_856);
							}
							BgL_arg2754z00_852 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2757z00_855);
					}}
					BgL_mkzd2idzd2_817 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2754z00_852));
				}
				{	/* Object/creator.scm 232 */
					obj_t BgL_fillzd2idzd2_818;

					{	/* Object/creator.scm 233 */
						obj_t BgL_arg2748z00_846;

						obj_t BgL_arg2749z00_847;

						obj_t BgL_arg2750z00_848;

						BgL_arg2748z00_846 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2555;

							BgL_auxz00_2555 = (BgL_typez00_bglt) (BgL_classz00_36);
							BgL_arg2749z00_847 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2555))->BgL_idz00);
						}
						BgL_arg2750z00_848 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 233 */
							obj_t BgL_list2751z00_849;

							{	/* Object/creator.scm 233 */
								obj_t BgL_arg2752z00_850;

								{	/* Object/creator.scm 233 */
									obj_t BgL_arg2753z00_851;

									BgL_arg2753z00_851 = MAKE_PAIR(BgL_arg2750z00_848, BNIL);
									BgL_arg2752z00_850 =
										MAKE_PAIR(BgL_arg2749z00_847, BgL_arg2753z00_851);
								}
								BgL_list2751z00_849 =
									MAKE_PAIR(BgL_arg2748z00_846, BgL_arg2752z00_850);
							}
							BgL_fillzd2idzd2_818 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2751z00_849);
					}}
					{	/* Object/creator.scm 233 */
						obj_t BgL_mkzd2tidzd2_819;

						{	/* Object/creator.scm 234 */
							obj_t BgL_arg2747z00_845;

							{
								BgL_typez00_bglt BgL_auxz00_2563;

								BgL_auxz00_2563 = (BgL_typez00_bglt) (BgL_classz00_36);
								BgL_arg2747z00_845 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2563))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_819 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_817,
								BgL_arg2747z00_845);
						}
						{	/* Object/creator.scm 234 */
							obj_t BgL_alloczd2widezd2_820;

							{	/* Object/creator.scm 235 */
								obj_t BgL_arg2741z00_839;

								{	/* Object/creator.scm 235 */
									obj_t BgL_arg2742z00_840;

									obj_t BgL_arg2743z00_841;

									{	/* Object/creator.scm 235 */
										obj_t BgL_symbolz00_1886;

										BgL_symbolz00_1886 = CNST_TABLE_REF(((long) 13));
										BgL_arg2742z00_840 = SYMBOL_TO_STRING(BgL_symbolz00_1886);
									}
									{	/* Object/creator.scm 235 */
										obj_t BgL_arg2746z00_844;

										{
											BgL_typez00_bglt BgL_auxz00_2569;

											BgL_auxz00_2569 = (BgL_typez00_bglt) (BgL_classz00_36);
											BgL_arg2746z00_844 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2569))->BgL_idz00);
										}
										BgL_arg2743z00_841 = SYMBOL_TO_STRING(BgL_arg2746z00_844);
									}
									{	/* Object/creator.scm 235 */
										obj_t BgL_list2744z00_842;

										{	/* Object/creator.scm 235 */
											obj_t BgL_arg2745z00_843;

											BgL_arg2745z00_843 = MAKE_PAIR(BgL_arg2743z00_841, BNIL);
											BgL_list2744z00_842 =
												MAKE_PAIR(BgL_arg2742z00_840, BgL_arg2745z00_843);
										}
										BgL_arg2741z00_839 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2744z00_842);
								}}
								BgL_alloczd2widezd2_820 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2741z00_839));
							}
							{	/* Object/creator.scm 235 */
								obj_t BgL_tidz00_821;

								if (CBOOL(BGl_za2sawza2z00zzengine_paramz00))
									{	/* Object/creator.scm 240 */
										obj_t BgL_arg2740z00_838;

										{
											BgL_typez00_bglt BgL_auxz00_2580;

											BgL_auxz00_2580 = (BgL_typez00_bglt) (BgL_classz00_36);
											BgL_arg2740z00_838 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2580))->BgL_idz00);
										}
										BgL_tidz00_821 =
											BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
											(BgL_arg2740z00_838);
									}
								else
									{	/* Object/creator.scm 240 */
										BgL_tidz00_821 = CNST_TABLE_REF(((long) 14));
									}
								{	/* Object/creator.scm 240 */
									obj_t BgL_talloczd2widezd2_822;

									BgL_talloczd2widezd2_822 =
										BGl_makezd2typedzd2identz00zzast_identz00
										(BgL_alloczd2widezd2_820, BgL_tidz00_821);
									{	/* Object/creator.scm 241 */
										obj_t BgL_fzd2idszd2_823;

										{	/* Object/creator.scm 242 */
											obj_t BgL_arg2739z00_837;

											{
												obj_t BgL_auxz00_2586;

												{	/* Object/creator.scm 242 */
													BgL_objectz00_bglt BgL_auxz00_2587;

													BgL_auxz00_2587 =
														(BgL_objectz00_bglt) (BgL_classz00_36);
													BgL_auxz00_2586 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2587);
												}
												BgL_arg2739z00_837 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2586))->
													BgL_slotsz00);
											}
											BgL_fzd2idszd2_823 =
												BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
												(BgL_arg2739z00_837);
										}
										{	/* Object/creator.scm 242 */
											obj_t BgL_fzd2tidszd2_824;

											{	/* Object/creator.scm 243 */
												obj_t BgL_arg2738z00_836;

												{
													obj_t BgL_auxz00_2592;

													{	/* Object/creator.scm 243 */
														BgL_objectz00_bglt BgL_auxz00_2593;

														BgL_auxz00_2593 =
															(BgL_objectz00_bglt) (BgL_classz00_36);
														BgL_auxz00_2592 =
															BGL_OBJECT_WIDENING(BgL_auxz00_2593);
													}
													BgL_arg2738z00_836 =
														(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2592))->
														BgL_slotsz00);
												}
												BgL_fzd2tidszd2_824 =
													BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
													(BgL_fzd2idszd2_823, BgL_arg2738z00_836);
											}
											{	/* Object/creator.scm 243 */
												obj_t BgL_sslotsz00_825;

												{	/* Object/creator.scm 244 */
													BgL_tclassz00_bglt BgL_obj2134z00_1894;

													{	/* Object/creator.scm 244 */
														obj_t BgL_auxz00_2598;

														{
															obj_t BgL_auxz00_2599;

															{	/* Object/creator.scm 244 */
																BgL_objectz00_bglt BgL_auxz00_2600;

																BgL_auxz00_2600 =
																	(BgL_objectz00_bglt) (BgL_classz00_36);
																BgL_auxz00_2599 =
																	BGL_OBJECT_WIDENING(BgL_auxz00_2600);
															}
															BgL_auxz00_2598 =
																(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2599))->
																BgL_itszd2superzd2);
														}
														BgL_obj2134z00_1894 =
															(BgL_tclassz00_bglt) (BgL_auxz00_2598);
													}
													{
														obj_t BgL_auxz00_2605;

														{	/* Object/creator.scm 244 */
															BgL_objectz00_bglt BgL_auxz00_2606;

															BgL_auxz00_2606 =
																(BgL_objectz00_bglt) (BgL_obj2134z00_1894);
															BgL_auxz00_2605 =
																BGL_OBJECT_WIDENING(BgL_auxz00_2606);
														}
														BgL_sslotsz00_825 =
															(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2605))->
															BgL_slotsz00);
												}}
												{	/* Object/creator.scm 244 */
													obj_t BgL_szd2idszd2_826;

													BgL_szd2idszd2_826 =
														BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
														(BgL_sslotsz00_825);
													{	/* Object/creator.scm 245 */
														obj_t BgL_szd2tidszd2_827;

														BgL_szd2tidszd2_827 =
															BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
															(BgL_szd2idszd2_826, BgL_sslotsz00_825);
														{	/* Object/creator.scm 246 */

															{	/* Object/creator.scm 248 */
																obj_t BgL_arg2730z00_828;

																BgL_arg2730z00_828 =
																	MAKE_PAIR(BgL_mkzd2tidzd2_819,
																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																	(BgL_szd2tidszd2_827,
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_fzd2tidszd2_824, BNIL)));
																BGl_importzd2parserzd2zzmodule_impusez00
																	(BgL_modulez00_38, BgL_arg2730z00_828, BNIL);
															}
															{	/* Object/creator.scm 249 */
																obj_t BgL_arg2734z00_832;

																BgL_arg2734z00_832 =
																	MAKE_PAIR(BgL_talloczd2widezd2_822,
																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																	(BgL_fzd2tidszd2_824, BNIL));
																BGl_importzd2parserzd2zzmodule_impusez00
																	(BgL_modulez00_38, BgL_arg2734z00_832, BNIL);
															}
															return BNIL;
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-java-class-creator */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt
		BgL_classz00_39, obj_t BgL_constrsz00_40, obj_t BgL_srczd2defzd2_41)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 256 */
			if (PAIRP(BgL_constrsz00_40))
				{	/* Object/creator.scm 257 */
					return
						BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00
						(BgL_classz00_39, BgL_srczd2defzd2_41);
				}
			else
				{	/* Object/creator.scm 257 */
					return BNIL;
				}
		}
	}



/* _import-java-class-creator */
	obj_t BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00(obj_t
		BgL_envz00_2095, obj_t BgL_classz00_2096, obj_t BgL_constrsz00_2097,
		obj_t BgL_srczd2defzd2_2098)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 256 */
			return
				BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00(
				(BgL_jclassz00_bglt) (BgL_classz00_2096), BgL_constrsz00_2097,
				BgL_srczd2defzd2_2098);
		}
	}



/* gen-java-class-constructors */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00
		(BgL_jclassz00_bglt BgL_classz00_42, obj_t BgL_constrsz00_43,
		obj_t BgL_srczd2defzd2_44)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 264 */
			if (NULLP(BgL_constrsz00_43))
				{	/* Object/creator.scm 294 */
					return BNIL;
				}
			else
				{	/* Object/creator.scm 294 */
					obj_t BgL_head2461z00_862;

					BgL_head2461z00_862 =
						MAKE_PAIR(BGl_genzd2onezd2constructorz00zzobject_creatorz00
						(BgL_constrsz00_43, BgL_classz00_42, CAR(BgL_constrsz00_43)), BNIL);
					{	/* Object/creator.scm 294 */
						obj_t BgL_g2464z00_863;

						BgL_g2464z00_863 = CDR(BgL_constrsz00_43);
						{
							obj_t BgL_l2459z00_865;

							obj_t BgL_tail2462z00_866;

							BgL_l2459z00_865 = BgL_g2464z00_863;
							BgL_tail2462z00_866 = BgL_head2461z00_862;
						BgL_zc3anonymousza32763ze3z83_867:
							if (NULLP(BgL_l2459z00_865))
								{	/* Object/creator.scm 294 */
									return BgL_head2461z00_862;
								}
							else
								{	/* Object/creator.scm 294 */
									obj_t BgL_newtail2463z00_869;

									BgL_newtail2463z00_869 =
										MAKE_PAIR(BGl_genzd2onezd2constructorz00zzobject_creatorz00
										(BgL_constrsz00_43, BgL_classz00_42, CAR(BgL_l2459z00_865)),
										BNIL);
									SET_CDR(BgL_tail2462z00_866, BgL_newtail2463z00_869);
									{
										obj_t BgL_tail2462z00_2638;

										obj_t BgL_l2459z00_2636;

										BgL_l2459z00_2636 = CDR(BgL_l2459z00_865);
										BgL_tail2462z00_2638 = BgL_newtail2463z00_869;
										BgL_tail2462z00_866 = BgL_tail2462z00_2638;
										BgL_l2459z00_865 = BgL_l2459z00_2636;
										goto BgL_zc3anonymousza32763ze3z83_867;
									}
								}
						}
					}
				}
		}
	}



/* gen-one-constructor */
	obj_t BGl_genzd2onezd2constructorz00zzobject_creatorz00(obj_t
		BgL_constrsz00_2106, BgL_jclassz00_bglt BgL_classz00_2105,
		obj_t BgL_constrz00_878)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 293 */
			{
				obj_t BgL_identz00_880;

				obj_t BgL_argszd2typezd2_881;

				if (PAIRP(BgL_constrz00_878))
					{	/* Object/creator.scm 293 */
						BgL_identz00_880 = CAR(BgL_constrz00_878);
						BgL_argszd2typezd2_881 = CDR(BgL_constrz00_878);
						{	/* Object/creator.scm 271 */
							obj_t BgL_jidz00_887;

							{
								BgL_typez00_bglt BgL_auxz00_2641;

								BgL_auxz00_2641 = (BgL_typez00_bglt) (BgL_classz00_2105);
								BgL_jidz00_887 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2641))->BgL_idz00);
							}
							{	/* Object/creator.scm 271 */
								obj_t BgL_locz00_888;

								BgL_locz00_888 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_constrsz00_2106);
								{	/* Object/creator.scm 272 */
									obj_t BgL_cidz00_889;

									BgL_cidz00_889 =
										BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(BgL_identz00_880,
										BgL_locz00_888);
									{	/* Object/creator.scm 273 */
										obj_t BgL_tidz00_890;

										{	/* Object/creator.scm 274 */
											obj_t BgL_arg2835z00_982;

											{	/* Object/creator.scm 274 */
												obj_t BgL_list2836z00_983;

												{	/* Object/creator.scm 274 */
													obj_t BgL_arg2837z00_984;

													{	/* Object/creator.scm 274 */
														obj_t BgL_arg2838z00_985;

														obj_t BgL_arg2839z00_986;

														BgL_arg2838z00_985 = CNST_TABLE_REF(((long) 5));
														BgL_arg2839z00_986 =
															MAKE_PAIR(BgL_cidz00_889, BNIL);
														BgL_arg2837z00_984 =
															MAKE_PAIR(BgL_arg2838z00_985, BgL_arg2839z00_986);
													}
													BgL_list2836z00_983 =
														MAKE_PAIR(BgL_jidz00_887, BgL_arg2837z00_984);
												}
												BgL_arg2835z00_982 =
													BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
													(BgL_list2836z00_983);
											}
											BgL_tidz00_890 =
												BGl_makezd2typedzd2identz00zzast_identz00
												(BgL_arg2835z00_982, BgL_jidz00_887);
										}
										{	/* Object/creator.scm 274 */
											obj_t BgL_argszd2idzd2_891;

											if (NULLP(BgL_argszd2typezd2_881))
												{	/* Object/creator.scm 275 */
													BgL_argszd2idzd2_891 = BNIL;
												}
											else
												{	/* Object/creator.scm 275 */
													obj_t BgL_head2445z00_968;

													BgL_head2445z00_968 = MAKE_PAIR(BNIL, BNIL);
													{
														obj_t BgL_l2443z00_970;

														obj_t BgL_tail2446z00_971;

														BgL_l2443z00_970 = BgL_argszd2typezd2_881;
														BgL_tail2446z00_971 = BgL_head2445z00_968;
													BgL_zc3anonymousza32829ze3z83_972:
														if (NULLP(BgL_l2443z00_970))
															{	/* Object/creator.scm 275 */
																BgL_argszd2idzd2_891 = CDR(BgL_head2445z00_968);
															}
														else
															{	/* Object/creator.scm 275 */
																obj_t BgL_newtail2447z00_974;

																{	/* Object/creator.scm 275 */
																	obj_t BgL_arg2832z00_976;

																	{	/* Object/creator.scm 275 */
																		obj_t BgL_arg2834z00_979;

																		{	/* Object/creator.scm 275 */

																			{	/* Object/creator.scm 275 */

																				BgL_arg2834z00_979 =
																					BGl_gensymz00zz__r4_symbols_6_4z00
																					(BFALSE);
																			}
																		}
																		BgL_arg2832z00_976 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BgL_arg2834z00_979);
																	}
																	BgL_newtail2447z00_974 =
																		MAKE_PAIR(BgL_arg2832z00_976, BNIL);
																}
																SET_CDR(BgL_tail2446z00_971,
																	BgL_newtail2447z00_974);
																{
																	obj_t BgL_tail2446z00_2664;

																	obj_t BgL_l2443z00_2662;

																	BgL_l2443z00_2662 = CDR(BgL_l2443z00_970);
																	BgL_tail2446z00_2664 = BgL_newtail2447z00_974;
																	BgL_tail2446z00_971 = BgL_tail2446z00_2664;
																	BgL_l2443z00_970 = BgL_l2443z00_2662;
																	goto BgL_zc3anonymousza32829ze3z83_972;
																}
															}
													}
												}
											{	/* Object/creator.scm 275 */
												obj_t BgL_selfz00_892;

												{	/* Object/creator.scm 277 */
													obj_t BgL_arg2827z00_964;

													{	/* Object/creator.scm 277 */

														{	/* Object/creator.scm 277 */

															BgL_arg2827z00_964 =
																BGl_gensymz00zz__r4_symbols_6_4z00(BFALSE);
														}
													}
													BgL_selfz00_892 =
														BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
														(BgL_arg2827z00_964);
												}
												{	/* Object/creator.scm 277 */
													obj_t BgL_tselfz00_893;

													BgL_tselfz00_893 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_selfz00_892, BgL_jidz00_887);
													{	/* Object/creator.scm 278 */
														obj_t BgL_targsz00_894;

														if (NULLP(BgL_argszd2idzd2_891))
															{	/* Object/creator.scm 279 */
																BgL_targsz00_894 = BNIL;
															}
														else
															{	/* Object/creator.scm 279 */
																obj_t BgL_head2450z00_944;

																BgL_head2450z00_944 = MAKE_PAIR(BNIL, BNIL);
																{
																	obj_t BgL_ll2448z00_946;

																	obj_t BgL_ll2449z00_947;

																	obj_t BgL_tail2451z00_948;

																	BgL_ll2448z00_946 = BgL_argszd2idzd2_891;
																	BgL_ll2449z00_947 = BgL_argszd2typezd2_881;
																	BgL_tail2451z00_948 = BgL_head2450z00_944;
																BgL_zc3anonymousza32815ze3z83_949:
																	if (NULLP(BgL_ll2448z00_946))
																		{	/* Object/creator.scm 279 */
																			BgL_targsz00_894 =
																				CDR(BgL_head2450z00_944);
																		}
																	else
																		{	/* Object/creator.scm 279 */
																			obj_t BgL_newtail2452z00_951;

																			{	/* Object/creator.scm 279 */
																				obj_t BgL_arg2820z00_954;

																				{	/* Object/creator.scm 279 */
																					obj_t BgL_idz00_956;

																					obj_t BgL_typez00_957;

																					BgL_idz00_956 =
																						CAR(BgL_ll2448z00_946);
																					BgL_typez00_957 =
																						CAR(BgL_ll2449z00_947);
																					{	/* Object/creator.scm 280 */
																						obj_t BgL_arg2822z00_958;

																						{	/* Object/creator.scm 280 */
																							obj_t BgL_arg2823z00_959;

																							obj_t BgL_arg2824z00_960;

																							BgL_arg2823z00_959 =
																								SYMBOL_TO_STRING(BgL_idz00_956);
																							BgL_arg2824z00_960 =
																								SYMBOL_TO_STRING
																								(BgL_typez00_957);
																							{	/* Object/creator.scm 280 */
																								obj_t BgL_list2825z00_961;

																								{	/* Object/creator.scm 280 */
																									obj_t BgL_arg2826z00_962;

																									BgL_arg2826z00_962 =
																										MAKE_PAIR
																										(BgL_arg2824z00_960, BNIL);
																									BgL_list2825z00_961 =
																										MAKE_PAIR
																										(BgL_arg2823z00_959,
																										BgL_arg2826z00_962);
																								}
																								BgL_arg2822z00_958 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list2825z00_961);
																							}
																						}
																						BgL_arg2820z00_954 =
																							string_to_symbol(BSTRING_TO_STRING
																							(BgL_arg2822z00_958));
																					}
																				}
																				BgL_newtail2452z00_951 =
																					MAKE_PAIR(BgL_arg2820z00_954, BNIL);
																			}
																			SET_CDR(BgL_tail2451z00_948,
																				BgL_newtail2452z00_951);
																			{
																				obj_t BgL_tail2451z00_2689;

																				obj_t BgL_ll2449z00_2687;

																				obj_t BgL_ll2448z00_2685;

																				BgL_ll2448z00_2685 =
																					CDR(BgL_ll2448z00_946);
																				BgL_ll2449z00_2687 =
																					CDR(BgL_ll2449z00_947);
																				BgL_tail2451z00_2689 =
																					BgL_newtail2452z00_951;
																				BgL_tail2451z00_948 =
																					BgL_tail2451z00_2689;
																				BgL_ll2449z00_947 = BgL_ll2449z00_2687;
																				BgL_ll2448z00_946 = BgL_ll2448z00_2685;
																				goto BgL_zc3anonymousza32815ze3z83_949;
																			}
																		}
																}
															}
														{	/* Object/creator.scm 279 */
															obj_t BgL_defz00_895;

															{	/* Object/creator.scm 282 */
																obj_t BgL_arg2784z00_905;

																obj_t BgL_arg2785z00_906;

																BgL_arg2784z00_905 =
																	CNST_TABLE_REF(((long) 15));
																{	/* Object/creator.scm 282 */
																	obj_t BgL_arg2786z00_907;

																	obj_t BgL_arg2787z00_908;

																	BgL_arg2786z00_907 =
																		MAKE_PAIR(BgL_tidz00_890,
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_targsz00_894, BNIL));
																	{	/* Object/creator.scm 284 */
																		obj_t BgL_runner2813z00_940;

																		{	/* Object/creator.scm 284 */
																			obj_t BgL_arg2792z00_913;

																			obj_t BgL_arg2793z00_914;

																			BgL_arg2792z00_913 =
																				CNST_TABLE_REF(((long) 9));
																			{	/* Object/creator.scm 285 */
																				obj_t BgL_arg2797z00_918;

																				obj_t BgL_arg2798z00_919;

																				BgL_arg2797z00_918 =
																					CNST_TABLE_REF(((long) 16));
																				{	/* Object/creator.scm 285 */
																					obj_t BgL_arg2800z00_920;

																					if (NULLP(BgL_argszd2typezd2_881))
																						{	/* Object/creator.scm 285 */
																							BgL_arg2800z00_920 = BNIL;
																						}
																					else
																						{	/* Object/creator.scm 285 */
																							obj_t BgL_head2456z00_925;

																							BgL_head2456z00_925 =
																								MAKE_PAIR(BNIL, BNIL);
																							{
																								obj_t BgL_l2454z00_927;

																								obj_t BgL_tail2457z00_928;

																								BgL_l2454z00_927 =
																									BgL_argszd2typezd2_881;
																								BgL_tail2457z00_928 =
																									BgL_head2456z00_925;
																							BgL_zc3anonymousza32805ze3z83_929:
																								if (NULLP
																									(BgL_l2454z00_927))
																									{	/* Object/creator.scm 285 */
																										BgL_arg2800z00_920 =
																											CDR(BgL_head2456z00_925);
																									}
																								else
																									{	/* Object/creator.scm 285 */
																										obj_t
																											BgL_newtail2458z00_931;
																										{	/* Object/creator.scm 285 */
																											obj_t BgL_arg2808z00_933;

																											{	/* Object/creator.scm 285 */
																												obj_t BgL_az00_935;

																												BgL_az00_935 =
																													CAR(BgL_l2454z00_927);
																												{
																													BgL_typez00_bglt
																														BgL_auxz00_2702;
																													BgL_auxz00_2702 =
																														BGl_typezd2ofzd2idz00zzast_identz00
																														(BgL_az00_935,
																														BgL_locz00_888);
																													BgL_arg2808z00_933 =
																														(((BgL_typez00_bglt)
																															CREF
																															(BgL_auxz00_2702))->
																														BgL_idz00);
																												}
																											}
																											BgL_newtail2458z00_931 =
																												MAKE_PAIR
																												(BgL_arg2808z00_933,
																												BNIL);
																										}
																										SET_CDR(BgL_tail2457z00_928,
																											BgL_newtail2458z00_931);
																										{
																											obj_t
																												BgL_tail2457z00_2709;
																											obj_t BgL_l2454z00_2707;

																											BgL_l2454z00_2707 =
																												CDR(BgL_l2454z00_927);
																											BgL_tail2457z00_2709 =
																												BgL_newtail2458z00_931;
																											BgL_tail2457z00_928 =
																												BgL_tail2457z00_2709;
																											BgL_l2454z00_927 =
																												BgL_l2454z00_2707;
																											goto
																												BgL_zc3anonymousza32805ze3z83_929;
																										}
																									}
																							}
																						}
																					{	/* Object/creator.scm 285 */
																						obj_t BgL_list2803z00_922;

																						BgL_list2803z00_922 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2798z00_919 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2800z00_920,
																							BgL_list2803z00_922);
																					}
																				}
																				BgL_arg2793z00_914 =
																					MAKE_PAIR(BgL_arg2797z00_918,
																					BgL_arg2798z00_919);
																			}
																			{	/* Object/creator.scm 284 */
																				obj_t BgL_list2794z00_915;

																				{	/* Object/creator.scm 284 */
																					obj_t BgL_arg2795z00_916;

																					{	/* Object/creator.scm 284 */
																						obj_t BgL_arg2796z00_917;

																						BgL_arg2796z00_917 =
																							MAKE_PAIR(BgL_argszd2idzd2_891,
																							BNIL);
																						BgL_arg2795z00_916 =
																							MAKE_PAIR(BgL_arg2793z00_914,
																							BgL_arg2796z00_917);
																					}
																					BgL_list2794z00_915 =
																						MAKE_PAIR(BgL_jidz00_887,
																						BgL_arg2795z00_916);
																				}
																				BgL_runner2813z00_940 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2792z00_913,
																					BgL_list2794z00_915);
																			}
																		}
																		{	/* Object/creator.scm 284 */
																			obj_t BgL_aux2811z00_938;

																			BgL_aux2811z00_938 =
																				CAR(BgL_runner2813z00_940);
																			BgL_runner2813z00_940 =
																				CDR(BgL_runner2813z00_940);
																			{	/* Object/creator.scm 284 */
																				obj_t BgL_aux2812z00_939;

																				BgL_aux2812z00_939 =
																					CAR(BgL_runner2813z00_940);
																				BgL_runner2813z00_940 =
																					CDR(BgL_runner2813z00_940);
																				BgL_arg2787z00_908 =
																					BGl_makezd2privatezd2sexpz00zzast_privatez00
																					(BgL_aux2811z00_938,
																					BgL_aux2812z00_939,
																					BgL_runner2813z00_940);
																			}
																		}
																	}
																	{	/* Object/creator.scm 282 */
																		obj_t BgL_list2789z00_910;

																		{	/* Object/creator.scm 282 */
																			obj_t BgL_arg2790z00_911;

																			BgL_arg2790z00_911 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2789z00_910 =
																				MAKE_PAIR(BgL_arg2787z00_908,
																				BgL_arg2790z00_911);
																		}
																		BgL_arg2785z00_906 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2786z00_907, BgL_list2789z00_910);
																	}
																}
																BgL_defz00_895 =
																	MAKE_PAIR(BgL_arg2784z00_905,
																	BgL_arg2785z00_906);
															}
															{	/* Object/creator.scm 282 */
																obj_t BgL_scopez00_896;

																if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
																	{	/* Object/creator.scm 290 */
																		BgL_scopez00_896 =
																			CNST_TABLE_REF(((long) 10));
																	}
																else
																	{	/* Object/creator.scm 290 */
																		BgL_scopez00_896 =
																			CNST_TABLE_REF(((long) 17));
																	}
																{	/* Object/creator.scm 290 */
																	obj_t BgL_modz00_897;

																	{	/* Object/creator.scm 291 */
																		obj_t BgL_arg2777z00_899;

																		{	/* Object/creator.scm 291 */
																			obj_t BgL_arg2778z00_900;

																			BgL_arg2778z00_900 =
																				MAKE_PAIR(BgL_tidz00_890,
																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																				(BgL_argszd2typezd2_881, BNIL));
																			{	/* Object/creator.scm 291 */
																				obj_t BgL_list2780z00_902;

																				BgL_list2780z00_902 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2777z00_899 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2778z00_900,
																					BgL_list2780z00_902);
																		}}
																		BgL_modz00_897 =
																			MAKE_PAIR(BgL_scopez00_896,
																			BgL_arg2777z00_899);
																	}
																	{	/* Object/creator.scm 291 */

																		BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																			(BgL_modz00_897);
																		{	/* Object/creator.scm 293 */
																			obj_t BgL_list2776z00_898;

																			BgL_list2776z00_898 =
																				MAKE_PAIR(BgL_constrz00_878, BNIL);
																			return
																				BGl_epairifyza2za2zztools_miscz00
																				(BgL_defz00_895, BgL_list2776z00_898);
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				else
					{	/* Object/creator.scm 293 */
						return BFALSE;
					}
			}
		}
	}



/* _gen-java-class-constructors */
	obj_t BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2099, obj_t BgL_classz00_2100, obj_t BgL_constrsz00_2101,
		obj_t BgL_srczd2defzd2_2102)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 264 */
			return
				BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00(
				(BgL_jclassz00_bglt) (BgL_classz00_2100), BgL_constrsz00_2101,
				BgL_srczd2defzd2_2102);
		}
	}



/* gen-class-fill! */
	obj_t BGl_genzd2classzd2fillz12z12zzobject_creatorz00(obj_t
		BgL_fillzd2idzd2_45, obj_t BgL_idz00_46, BgL_tclassz00_bglt BgL_typez00_47,
		obj_t BgL_srczd2defzd2_48, obj_t BgL_importz00_49)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 302 */
			{	/* Object/creator.scm 303 */
				obj_t BgL_tidz00_988;

				{	/* Object/creator.scm 303 */
					bool_t BgL_testz00_2742;

					if (BGl_widezd2classzf3z21zzobject_classz00((obj_t) (BgL_typez00_47)))
						{	/* Object/creator.scm 303 */
							BgL_testz00_2742 = CBOOL(BGl_za2sawza2z00zzengine_paramz00);
						}
					else
						{	/* Object/creator.scm 303 */
							BgL_testz00_2742 = ((bool_t) 0);
						}
					if (BgL_testz00_2742)
						{	/* Object/creator.scm 304 */
							obj_t BgL_arg2889z00_1062;

							{
								BgL_typez00_bglt BgL_auxz00_2747;

								BgL_auxz00_2747 = (BgL_typez00_bglt) (BgL_typez00_47);
								BgL_arg2889z00_1062 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2747))->BgL_idz00);
							}
							BgL_tidz00_988 =
								BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
								(BgL_arg2889z00_1062);
						}
					else
						{
							BgL_typez00_bglt BgL_auxz00_2751;

							BgL_auxz00_2751 = (BgL_typez00_bglt) (BgL_typez00_47);
							BgL_tidz00_988 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2751))->BgL_idz00);
						}
				}
				{	/* Object/creator.scm 303 */
					obj_t BgL_slotsz00_989;

					{
						obj_t BgL_auxz00_2754;

						{	/* Object/creator.scm 306 */
							BgL_objectz00_bglt BgL_auxz00_2755;

							BgL_auxz00_2755 = (BgL_objectz00_bglt) (BgL_typez00_47);
							BgL_auxz00_2754 = BGL_OBJECT_WIDENING(BgL_auxz00_2755);
						}
						BgL_slotsz00_989 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2754))->BgL_slotsz00);
					}
					{	/* Object/creator.scm 306 */
						obj_t BgL_fillzd2tidzd2_990;

						BgL_fillzd2tidzd2_990 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_fillzd2idzd2_45,
							BgL_tidz00_988);
						{	/* Object/creator.scm 307 */
							obj_t BgL_fzd2idszd2_991;

							BgL_fzd2idszd2_991 =
								BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
								(BgL_slotsz00_989);
							{	/* Object/creator.scm 308 */
								obj_t BgL_fzd2tidszd2_992;

								BgL_fzd2tidszd2_992 =
									BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
									(BgL_fzd2idszd2_991, BgL_slotsz00_989);
								{	/* Object/creator.scm 309 */
									obj_t BgL_newz00_993;

									BgL_newz00_993 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													9))));
									{	/* Object/creator.scm 310 */
										obj_t BgL_tnewz00_994;

										{	/* Object/creator.scm 311 */
											bool_t BgL_testz00_2765;

											if (BGl_widezd2classzf3z21zzobject_classz00(
													(obj_t) (BgL_typez00_47)))
												{	/* Object/creator.scm 312 */
													obj_t BgL_arg2885z00_1059;

													BgL_arg2885z00_1059 =
														BGl_thezd2backendzd2zzbackend_backendz00();
													{
														BgL_backendz00_bglt BgL_auxz00_2770;

														BgL_auxz00_2770 =
															(BgL_backendz00_bglt) (BgL_arg2885z00_1059);
														BgL_testz00_2765 =
															(((BgL_backendz00_bglt) CREF(BgL_auxz00_2770))->
															BgL_typedz00);
													}
												}
											else
												{	/* Object/creator.scm 311 */
													BgL_testz00_2765 = ((bool_t) 0);
												}
											if (BgL_testz00_2765)
												{	/* Object/creator.scm 311 */
													BgL_tnewz00_994 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_newz00_993, CNST_TABLE_REF(((long) 14)));
												}
											else
												{	/* Object/creator.scm 311 */
													BgL_tnewz00_994 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_newz00_993, BgL_tidz00_988);
												}
										}
										{	/* Object/creator.scm 311 */
											obj_t BgL_ridz00_995;

											BgL_ridz00_995 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 18))));
											{	/* Object/creator.scm 315 */
												obj_t BgL_rtidz00_996;

												{	/* Object/creator.scm 316 */
													obj_t BgL_arg2877z00_1051;

													{	/* Object/creator.scm 316 */
														obj_t BgL_arg2878z00_1052;

														obj_t BgL_arg2879z00_1053;

														BgL_arg2878z00_1052 =
															SYMBOL_TO_STRING(BgL_ridz00_995);
														{	/* Object/creator.scm 316 */
															obj_t BgL_symbolz00_1961;

															BgL_symbolz00_1961 = CNST_TABLE_REF(((long) 19));
															BgL_arg2879z00_1053 =
																SYMBOL_TO_STRING(BgL_symbolz00_1961);
														}
														{	/* Object/creator.scm 316 */
															obj_t BgL_list2880z00_1054;

															{	/* Object/creator.scm 316 */
																obj_t BgL_arg2881z00_1055;

																BgL_arg2881z00_1055 =
																	MAKE_PAIR(BgL_arg2879z00_1053, BNIL);
																BgL_list2880z00_1054 =
																	MAKE_PAIR(BgL_arg2878z00_1052,
																	BgL_arg2881z00_1055);
															}
															BgL_arg2877z00_1051 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list2880z00_1054);
													}}
													BgL_rtidz00_996 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg2877z00_1051));
												}
												{	/* Object/creator.scm 316 */

													{

														{	/* Object/creator.scm 326 */
															obj_t BgL_protoz00_998;

															obj_t BgL_bodyz00_999;

															{	/* Object/creator.scm 326 */
																obj_t BgL_arg2853z00_1013;

																{	/* Object/creator.scm 326 */
																	obj_t BgL_list2854z00_1014;

																	BgL_list2854z00_1014 =
																		MAKE_PAIR(BgL_fzd2tidszd2_992, BNIL);
																	BgL_arg2853z00_1013 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_tnewz00_994, BgL_list2854z00_1014);
																}
																BgL_protoz00_998 =
																	MAKE_PAIR(BgL_fillzd2tidzd2_990,
																	BgL_arg2853z00_1013);
															}
															{	/* Object/creator.scm 319 */
																obj_t BgL_alloczd2idzd2_1017;

																{	/* Object/creator.scm 320 */
																	obj_t BgL_arg2872z00_1045;

																	{	/* Object/creator.scm 320 */
																		obj_t BgL_arg2873z00_1046;

																		obj_t BgL_arg2874z00_1047;

																		{	/* Object/creator.scm 320 */
																			obj_t BgL_symbolz00_1964;

																			BgL_symbolz00_1964 =
																				CNST_TABLE_REF(((long) 7));
																			BgL_arg2873z00_1046 =
																				SYMBOL_TO_STRING(BgL_symbolz00_1964);
																		}
																		BgL_arg2874z00_1047 =
																			SYMBOL_TO_STRING(BgL_idz00_46);
																		{	/* Object/creator.scm 320 */
																			obj_t BgL_list2875z00_1048;

																			{	/* Object/creator.scm 320 */
																				obj_t BgL_arg2876z00_1049;

																				BgL_arg2876z00_1049 =
																					MAKE_PAIR(BgL_arg2874z00_1047, BNIL);
																				BgL_list2875z00_1048 =
																					MAKE_PAIR(BgL_arg2873z00_1046,
																					BgL_arg2876z00_1049);
																			}
																			BgL_arg2872z00_1045 =
																				BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																				(BgL_list2875z00_1048);
																	}}
																	BgL_alloczd2idzd2_1017 =
																		string_to_symbol(BSTRING_TO_STRING
																		(BgL_arg2872z00_1045));
																}
																{	/* Object/creator.scm 320 */

																	{	/* Object/creator.scm 321 */
																		obj_t BgL_arg2856z00_1018;

																		obj_t BgL_arg2857z00_1019;

																		BgL_arg2856z00_1018 =
																			CNST_TABLE_REF(((long) 20));
																		{	/* Object/creator.scm 321 */
																			obj_t BgL_arg2858z00_1020;

																			obj_t BgL_arg2859z00_1021;

																			if (NULLP(BgL_fzd2tidszd2_992))
																				{	/* Object/creator.scm 321 */
																					BgL_arg2858z00_1020 = BNIL;
																				}
																			else
																				{	/* Object/creator.scm 321 */
																					obj_t BgL_head2467z00_1026;

																					BgL_head2467z00_1026 =
																						MAKE_PAIR(BNIL, BNIL);
																					{
																						obj_t BgL_ll2465z00_1028;

																						obj_t BgL_ll2466z00_1029;

																						obj_t BgL_tail2468z00_1030;

																						BgL_ll2465z00_1028 =
																							BgL_fzd2tidszd2_992;
																						BgL_ll2466z00_1029 =
																							BgL_fzd2idszd2_991;
																						BgL_tail2468z00_1030 =
																							BgL_head2467z00_1026;
																					BgL_zc3anonymousza32862ze3z83_1031:
																						if (NULLP(BgL_ll2465z00_1028))
																							{	/* Object/creator.scm 321 */
																								BgL_arg2858z00_1020 =
																									CDR(BgL_head2467z00_1026);
																							}
																						else
																							{	/* Object/creator.scm 321 */
																								obj_t BgL_newtail2469z00_1033;

																								{	/* Object/creator.scm 321 */
																									obj_t BgL_arg2866z00_1036;

																									{	/* Object/creator.scm 321 */
																										obj_t BgL_ftz00_1038;

																										obj_t BgL_fz00_1039;

																										BgL_ftz00_1038 =
																											CAR(BgL_ll2465z00_1028);
																										BgL_fz00_1039 =
																											CAR(BgL_ll2466z00_1029);
																										{	/* Object/creator.scm 321 */
																											obj_t BgL_arg2868z00_1040;

																											{	/* Object/creator.scm 321 */
																												obj_t
																													BgL_list2869z00_1041;
																												BgL_list2869z00_1041 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_arg2868z00_1040 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_fz00_1039,
																													BgL_list2869z00_1041);
																											}
																											BgL_arg2866z00_1036 =
																												MAKE_PAIR
																												(BgL_ftz00_1038,
																												BgL_arg2868z00_1040);
																										}
																									}
																									BgL_newtail2469z00_1033 =
																										MAKE_PAIR
																										(BgL_arg2866z00_1036, BNIL);
																								}
																								SET_CDR(BgL_tail2468z00_1030,
																									BgL_newtail2469z00_1033);
																								{
																									obj_t BgL_tail2468z00_2816;

																									obj_t BgL_ll2466z00_2814;

																									obj_t BgL_ll2465z00_2812;

																									BgL_ll2465z00_2812 =
																										CDR(BgL_ll2465z00_1028);
																									BgL_ll2466z00_2814 =
																										CDR(BgL_ll2466z00_1029);
																									BgL_tail2468z00_2816 =
																										BgL_newtail2469z00_1033;
																									BgL_tail2468z00_1030 =
																										BgL_tail2468z00_2816;
																									BgL_ll2466z00_1029 =
																										BgL_ll2466z00_2814;
																									BgL_ll2465z00_1028 =
																										BgL_ll2465z00_2812;
																									goto
																										BgL_zc3anonymousza32862ze3z83_1031;
																								}
																							}
																					}
																				}
																			{	/* Object/creator.scm 322 */
																				obj_t BgL_arg2870z00_1043;

																				obj_t BgL_arg2871z00_1044;

																				BgL_arg2870z00_1043 =
																					BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00
																					(BgL_typez00_47, BgL_newz00_993,
																					BgL_ridz00_995, BgL_rtidz00_996,
																					BgL_slotsz00_989, BgL_fzd2idszd2_991);
																				BgL_arg2871z00_1044 =
																					MAKE_PAIR(BgL_newz00_993, BNIL);
																				BgL_arg2859z00_1021 =
																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2870z00_1043,
																					BgL_arg2871z00_1044);
																			}
																			{	/* Object/creator.scm 321 */
																				obj_t BgL_list2860z00_1022;

																				BgL_list2860z00_1022 =
																					MAKE_PAIR(BgL_arg2859z00_1021, BNIL);
																				BgL_arg2857z00_1019 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2858z00_1020,
																					BgL_list2860z00_1022);
																			}
																		}
																		BgL_bodyz00_999 =
																			MAKE_PAIR(BgL_arg2856z00_1018,
																			BgL_arg2857z00_1019);
																	}
																}
															}
															{	/* Object/creator.scm 329 */
																obj_t BgL_arg2840z00_1000;

																{	/* Object/creator.scm 329 */
																	obj_t BgL_arg2841z00_1001;

																	{	/* Object/creator.scm 329 */
																		obj_t BgL_arg2842z00_1002;

																		{	/* Object/creator.scm 329 */
																			obj_t BgL_arg2845z00_1005;

																			obj_t BgL_arg2846z00_1006;

																			BgL_arg2845z00_1005 =
																				CNST_TABLE_REF(((long) 11));
																			BgL_arg2846z00_1006 =
																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																				(BgL_protoz00_998, BNIL);
																			BgL_arg2842z00_1002 =
																				MAKE_PAIR(BgL_arg2845z00_1005,
																				BgL_arg2846z00_1006);
																		}
																		{	/* Object/creator.scm 329 */
																			obj_t BgL_list2844z00_1004;

																			BgL_list2844z00_1004 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2841z00_1001 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2842z00_1002,
																				BgL_list2844z00_1004);
																	}}
																	BgL_arg2840z00_1000 =
																		MAKE_PAIR(BgL_importz00_49,
																		BgL_arg2841z00_1001);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2840z00_1000);
															}
															{	/* Object/creator.scm 331 */
																obj_t BgL_arg2847z00_1007;

																{	/* Object/creator.scm 331 */
																	obj_t BgL_arg2849z00_1009;

																	obj_t BgL_arg2850z00_1010;

																	BgL_arg2849z00_1009 =
																		CNST_TABLE_REF(((long) 8));
																	{	/* Object/creator.scm 331 */
																		obj_t BgL_list2851z00_1011;

																		{	/* Object/creator.scm 331 */
																			obj_t BgL_arg2852z00_1012;

																			BgL_arg2852z00_1012 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2851z00_1011 =
																				MAKE_PAIR(BgL_bodyz00_999,
																				BgL_arg2852z00_1012);
																		}
																		BgL_arg2850z00_1010 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_protoz00_998, BgL_list2851z00_1011);
																	}
																	BgL_arg2847z00_1007 =
																		MAKE_PAIR(BgL_arg2849z00_1009,
																		BgL_arg2850z00_1010);
																}
																{	/* Object/creator.scm 331 */
																	obj_t BgL_list2848z00_1008;

																	BgL_list2848z00_1008 =
																		MAKE_PAIR(BgL_srczd2defzd2_48, BNIL);
																	return
																		BGl_epairifyza2za2zztools_miscz00
																		(BgL_arg2847z00_1007, BgL_list2848z00_1008);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-class-make! */
	obj_t BGl_genzd2classzd2makez12z12zzobject_creatorz00(obj_t
		BgL_wideningz00_50, obj_t BgL_mkzd2idzd2_51, obj_t BgL_idz00_52,
		BgL_tclassz00_bglt BgL_typez00_53, obj_t BgL_srczd2defzd2_54,
		obj_t BgL_importz00_55)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 338 */
			{	/* Object/creator.scm 339 */
				obj_t BgL_tidz00_1064;

				{	/* Object/creator.scm 339 */
					bool_t BgL_testz00_2837;

					if ((BgL_wideningz00_50 == CNST_TABLE_REF(((long) 6))))
						{	/* Object/creator.scm 339 */
							if (BGl_widezd2classzf3z21zzobject_classz00(
									(obj_t) (BgL_typez00_53)))
								{	/* Object/creator.scm 340 */
									BgL_testz00_2837 = CBOOL(BGl_za2sawza2z00zzengine_paramz00);
								}
							else
								{	/* Object/creator.scm 340 */
									BgL_testz00_2837 = ((bool_t) 0);
								}
						}
					else
						{	/* Object/creator.scm 339 */
							BgL_testz00_2837 = ((bool_t) 0);
						}
					if (BgL_testz00_2837)
						{	/* Object/creator.scm 342 */
							obj_t BgL_arg3036z00_1251;

							{
								BgL_typez00_bglt BgL_auxz00_2845;

								BgL_auxz00_2845 = (BgL_typez00_bglt) (BgL_typez00_53);
								BgL_arg3036z00_1251 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2845))->BgL_idz00);
							}
							BgL_tidz00_1064 =
								BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
								(BgL_arg3036z00_1251);
						}
					else
						{
							BgL_typez00_bglt BgL_auxz00_2849;

							BgL_auxz00_2849 = (BgL_typez00_bglt) (BgL_typez00_53);
							BgL_tidz00_1064 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2849))->BgL_idz00);
						}
				}
				{	/* Object/creator.scm 339 */
					obj_t BgL_slotsz00_1065;

					{
						obj_t BgL_auxz00_2852;

						{	/* Object/creator.scm 344 */
							BgL_objectz00_bglt BgL_auxz00_2853;

							BgL_auxz00_2853 = (BgL_objectz00_bglt) (BgL_typez00_53);
							BgL_auxz00_2852 = BGL_OBJECT_WIDENING(BgL_auxz00_2853);
						}
						BgL_slotsz00_1065 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2852))->BgL_slotsz00);
					}
					{	/* Object/creator.scm 345 */
						obj_t BgL_constrsz00_1067;

						BgL_constrsz00_1067 =
							BGl_findzd2classzd2constructorsz00zzobject_classz00
							(BgL_typez00_53);
						{	/* Object/creator.scm 346 */
							obj_t BgL_mkzd2tidzd2_1068;

							BgL_mkzd2tidzd2_1068 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_51,
								BgL_tidz00_1064);
							{	/* Object/creator.scm 349 */
								obj_t BgL_fillzd2idzd2_1069;

								{	/* Object/creator.scm 350 */
									obj_t BgL_list3031z00_1246;

									{	/* Object/creator.scm 350 */
										obj_t BgL_arg3032z00_1247;

										obj_t BgL_arg3033z00_1248;

										BgL_arg3032z00_1247 = CNST_TABLE_REF(((long) 1));
										{	/* Object/creator.scm 350 */
											obj_t BgL_arg3034z00_1249;

											BgL_arg3034z00_1249 =
												MAKE_PAIR(CNST_TABLE_REF(((long) 2)), BNIL);
											BgL_arg3033z00_1248 =
												MAKE_PAIR(BgL_idz00_52, BgL_arg3034z00_1249);
										}
										BgL_list3031z00_1246 =
											MAKE_PAIR(BgL_arg3032z00_1247, BgL_arg3033z00_1248);
									}
									BgL_fillzd2idzd2_1069 =
										BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
										(BgL_list3031z00_1246);
								}
								{	/* Object/creator.scm 350 */
									obj_t BgL_fzd2idszd2_1070;

									BgL_fzd2idszd2_1070 =
										BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
										(BgL_slotsz00_1065);
									{	/* Object/creator.scm 351 */
										obj_t BgL_fzd2tidszd2_1071;

										BgL_fzd2tidszd2_1071 =
											BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
											(BgL_fzd2idszd2_1070, BgL_slotsz00_1065);
										{	/* Object/creator.scm 352 */
											obj_t BgL_newz00_1072;

											BgL_newz00_1072 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 9))));
											{	/* Object/creator.scm 353 */
												obj_t BgL_ridz00_1073;

												BgL_ridz00_1073 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 18))));
												{	/* Object/creator.scm 354 */
													obj_t BgL_rtidz00_1074;

													{	/* Object/creator.scm 355 */
														obj_t BgL_arg3024z00_1239;

														{	/* Object/creator.scm 355 */
															obj_t BgL_arg3025z00_1240;

															obj_t BgL_arg3026z00_1241;

															BgL_arg3025z00_1240 =
																SYMBOL_TO_STRING(BgL_ridz00_1073);
															{	/* Object/creator.scm 355 */
																obj_t BgL_symbolz00_1985;

																BgL_symbolz00_1985 =
																	CNST_TABLE_REF(((long) 19));
																BgL_arg3026z00_1241 =
																	SYMBOL_TO_STRING(BgL_symbolz00_1985);
															}
															{	/* Object/creator.scm 355 */
																obj_t BgL_list3027z00_1242;

																{	/* Object/creator.scm 355 */
																	obj_t BgL_arg3028z00_1243;

																	BgL_arg3028z00_1243 =
																		MAKE_PAIR(BgL_arg3026z00_1241, BNIL);
																	BgL_list3027z00_1242 =
																		MAKE_PAIR(BgL_arg3025z00_1240,
																		BgL_arg3028z00_1243);
																}
																BgL_arg3024z00_1239 =
																	BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																	(BgL_list3027z00_1242);
														}}
														BgL_rtidz00_1074 =
															string_to_symbol(BSTRING_TO_STRING
															(BgL_arg3024z00_1239));
													}
													{	/* Object/creator.scm 355 */

														{

															{	/* Object/creator.scm 403 */
																obj_t BgL_arg2891z00_1079;

																{	/* Object/creator.scm 403 */
																	obj_t BgL_arg2892z00_1080;

																	{	/* Object/creator.scm 403 */
																		obj_t BgL_arg2893z00_1081;

																		BgL_arg2893z00_1081 =
																			MAKE_PAIR(BgL_mkzd2tidzd2_1068,
																			BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																			(BgL_fzd2tidszd2_1071, BNIL));
																		{	/* Object/creator.scm 403 */
																			obj_t BgL_list2895z00_1083;

																			BgL_list2895z00_1083 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2892z00_1080 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2893z00_1081,
																				BgL_list2895z00_1083);
																	}}
																	BgL_arg2891z00_1079 =
																		MAKE_PAIR(BgL_importz00_55,
																		BgL_arg2892z00_1080);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2891z00_1079);
															}
															{	/* Object/creator.scm 404 */
																obj_t BgL_arg2897z00_1085;

																{	/* Object/creator.scm 404 */
																	obj_t BgL_arg2898z00_1086;

																	obj_t BgL_arg2899z00_1087;

																	BgL_arg2898z00_1086 =
																		CNST_TABLE_REF(((long) 23));
																	{	/* Object/creator.scm 404 */
																		obj_t BgL_arg2900z00_1088;

																		{	/* Object/creator.scm 404 */
																			obj_t BgL_arg2903z00_1091;

																			{	/* Object/creator.scm 404 */
																				obj_t BgL_list2904z00_1092;

																				BgL_list2904z00_1092 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2903z00_1091 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(CNST_TABLE_REF(((long) 24)),
																					BgL_list2904z00_1092);
																			}
																			BgL_arg2900z00_1088 =
																				MAKE_PAIR(BgL_mkzd2idzd2_51,
																				BgL_arg2903z00_1091);
																		}
																		{	/* Object/creator.scm 404 */
																			obj_t BgL_list2902z00_1090;

																			BgL_list2902z00_1090 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2899z00_1087 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2900z00_1088,
																				BgL_list2902z00_1090);
																	}}
																	BgL_arg2897z00_1085 =
																		MAKE_PAIR(BgL_arg2898z00_1086,
																		BgL_arg2899z00_1087);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2897z00_1085);
															}
															{	/* Object/creator.scm 406 */
																obj_t BgL_protoz00_1093;

																obj_t BgL_bodyz00_1094;

																BgL_protoz00_1093 =
																	MAKE_PAIR(BgL_mkzd2tidzd2_1068,
																	BgL_fzd2tidszd2_1071);
																{	/* Object/creator.scm 399 */
																	bool_t BgL_testz00_2897;

																	{	/* Object/creator.scm 399 */
																		obj_t BgL_arg2913z00_1103;

																		obj_t BgL_arg2914z00_1104;

																		{	/* Object/creator.scm 399 */
																			obj_t BgL_arg2915z00_1105;

																			BgL_arg2915z00_1105 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_2899;

																				BgL_auxz00_2899 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2915z00_1105);
																				BgL_arg2913z00_1103 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_2899))->
																					BgL_languagez00);
																		}}
																		BgL_arg2914z00_1104 =
																			CNST_TABLE_REF(((long) 22));
																		BgL_testz00_2897 =
																			(BgL_arg2913z00_1103 ==
																			BgL_arg2914z00_1104);
																	}
																	if (BgL_testz00_2897)
																		{	/* Object/creator.scm 399 */
																			{	/* Object/creator.scm 371 */
																				obj_t BgL_alloczd2idzd2_1158;

																				{	/* Object/creator.scm 371 */
																					obj_t BgL_arg2997z00_1203;

																					{	/* Object/creator.scm 371 */
																						obj_t BgL_arg2998z00_1204;

																						obj_t BgL_arg2999z00_1205;

																						{	/* Object/creator.scm 371 */
																							obj_t BgL_symbolz00_2003;

																							BgL_symbolz00_2003 =
																								CNST_TABLE_REF(((long) 7));
																							BgL_arg2998z00_1204 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_2003);
																						}
																						BgL_arg2999z00_1205 =
																							SYMBOL_TO_STRING(BgL_idz00_52);
																						{	/* Object/creator.scm 371 */
																							obj_t BgL_list3000z00_1206;

																							{	/* Object/creator.scm 371 */
																								obj_t BgL_arg3001z00_1207;

																								BgL_arg3001z00_1207 =
																									MAKE_PAIR(BgL_arg2999z00_1205,
																									BNIL);
																								BgL_list3000z00_1206 =
																									MAKE_PAIR(BgL_arg2998z00_1204,
																									BgL_arg3001z00_1207);
																							}
																							BgL_arg2997z00_1203 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list3000z00_1206);
																					}}
																					BgL_alloczd2idzd2_1158 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg2997z00_1203));
																				}
																				{	/* Object/creator.scm 371 */

																					{	/* Object/creator.scm 372 */
																						obj_t BgL_arg2959z00_1159;

																						obj_t BgL_arg2960z00_1160;

																						BgL_arg2959z00_1159 =
																							CNST_TABLE_REF(((long) 20));
																						{	/* Object/creator.scm 372 */
																							obj_t BgL_arg2961z00_1161;

																							obj_t BgL_arg2962z00_1162;

																							{	/* Object/creator.scm 372 */
																								obj_t BgL_arg2966z00_1166;

																								{	/* Object/creator.scm 372 */
																									obj_t BgL_arg2968z00_1168;

																									obj_t BgL_arg2969z00_1169;

																									BgL_arg2968z00_1168 =
																										BGl_makezd2typedzd2identz00zzast_identz00
																										(BgL_newz00_1072,
																										BgL_tidz00_1064);
																									{	/* Object/creator.scm 373 */
																										obj_t BgL_arg2970z00_1170;

																										if (
																											(BgL_wideningz00_50 ==
																												CNST_TABLE_REF(((long)
																														6))))
																											{	/* Object/creator.scm 373 */
																												BgL_arg2970z00_1170 =
																													BGl_alloczd2wideningzd2zzobject_creatorz00
																													(BgL_tidz00_1064,
																													BgL_typez00_53);
																											}
																										else
																											{	/* Object/creator.scm 373 */
																												BgL_arg2970z00_1170 =
																													MAKE_PAIR
																													(BgL_alloczd2idzd2_1158,
																													BNIL);
																											}
																										{	/* Object/creator.scm 372 */
																											obj_t
																												BgL_list2972z00_1172;
																											BgL_list2972z00_1172 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2969z00_1169 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2970z00_1170,
																												BgL_list2972z00_1172);
																										}
																									}
																									BgL_arg2966z00_1166 =
																										MAKE_PAIR
																										(BgL_arg2968z00_1168,
																										BgL_arg2969z00_1169);
																								}
																								BgL_arg2961z00_1161 =
																									MAKE_PAIR(BgL_arg2966z00_1166,
																									BNIL);
																							}
																							{	/* Object/creator.scm 376 */
																								obj_t BgL_arg2974z00_1174;

																								obj_t BgL_arg2975z00_1175;

																								BgL_arg2974z00_1174 =
																									CNST_TABLE_REF(((long) 21));
																								{	/* Object/creator.scm 378 */
																									obj_t BgL_arg2976z00_1176;

																									obj_t BgL_arg2977z00_1177;

																									{	/* Object/creator.scm 378 */
																										obj_t BgL_arg2979z00_1179;

																										{	/* Object/creator.scm 378 */
																											obj_t BgL_arg2980z00_1180;

																											BgL_arg2980z00_1180 =
																												BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																												(BgL_fzd2idszd2_1070,
																												BNIL);
																											{	/* Object/creator.scm 378 */
																												obj_t
																													BgL_list2981z00_1181;
																												BgL_list2981z00_1181 =
																													MAKE_PAIR
																													(BgL_arg2980z00_1180,
																													BNIL);
																												BgL_arg2979z00_1179 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_newz00_1072,
																													BgL_list2981z00_1181);
																										}}
																										BgL_arg2976z00_1176 =
																											MAKE_PAIR
																											(BgL_fillzd2idzd2_1069,
																											BgL_arg2979z00_1179);
																									}
																									{	/* Object/creator.scm 380 */
																										obj_t BgL_arg2982z00_1182;

																										obj_t BgL_arg2983z00_1183;

																										{	/* Object/creator.scm 380 */
																											bool_t BgL_testz00_2928;

																											if (PAIRP
																												(BgL_constrsz00_1067))
																												{	/* Object/creator.scm 380 */
																													if (
																														(BgL_wideningz00_50
																															==
																															CNST_TABLE_REF((
																																	(long) 6))))
																														{	/* Object/creator.scm 380 */
																															BgL_testz00_2928 =
																																((bool_t) 0);
																														}
																													else
																														{	/* Object/creator.scm 380 */
																															BgL_testz00_2928 =
																																((bool_t) 1);
																														}
																												}
																											else
																												{	/* Object/creator.scm 380 */
																													BgL_testz00_2928 =
																														((bool_t) 0);
																												}
																											if (BgL_testz00_2928)
																												{	/* Object/creator.scm 380 */
																													if (NULLP
																														(BgL_constrsz00_1067))
																														{	/* Object/creator.scm 381 */
																															BgL_arg2982z00_1182
																																= BNIL;
																														}
																													else
																														{	/* Object/creator.scm 381 */
																															obj_t
																																BgL_head2478z00_1187;
																															BgL_head2478z00_1187
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															{
																																obj_t
																																	BgL_l2476z00_1189;
																																obj_t
																																	BgL_tail2479z00_1190;
																																BgL_l2476z00_1189
																																	=
																																	BgL_constrsz00_1067;
																																BgL_tail2479z00_1190
																																	=
																																	BgL_head2478z00_1187;
																															BgL_zc3anonymousza32986ze3z83_1191:
																																if (NULLP
																																	(BgL_l2476z00_1189))
																																	{	/* Object/creator.scm 381 */
																																		BgL_arg2982z00_1182
																																			=
																																			CDR
																																			(BgL_head2478z00_1187);
																																	}
																																else
																																	{	/* Object/creator.scm 381 */
																																		obj_t
																																			BgL_newtail2480z00_1193;
																																		{	/* Object/creator.scm 381 */
																																			obj_t
																																				BgL_arg2991z00_1195;
																																			{	/* Object/creator.scm 381 */
																																				obj_t
																																					BgL_constrz00_1197;
																																				BgL_constrz00_1197
																																					=
																																					CAR
																																					(BgL_l2476z00_1189);
																																				{	/* Object/creator.scm 381 */
																																					obj_t
																																						BgL_arg2993z00_1198;
																																					{	/* Object/creator.scm 381 */
																																						obj_t
																																							BgL_list2994z00_1199;
																																						BgL_list2994z00_1199
																																							=
																																							MAKE_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_arg2993z00_1198
																																							=
																																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_newz00_1072,
																																							BgL_list2994z00_1199);
																																					}
																																					BgL_arg2991z00_1195
																																						=
																																						MAKE_PAIR
																																						(BgL_constrz00_1197,
																																						BgL_arg2993z00_1198);
																																				}
																																			}
																																			BgL_newtail2480z00_1193
																																				=
																																				MAKE_PAIR
																																				(BgL_arg2991z00_1195,
																																				BNIL);
																																		}
																																		SET_CDR
																																			(BgL_tail2479z00_1190,
																																			BgL_newtail2480z00_1193);
																																		{
																																			obj_t
																																				BgL_tail2479z00_2948;
																																			obj_t
																																				BgL_l2476z00_2946;
																																			BgL_l2476z00_2946
																																				=
																																				CDR
																																				(BgL_l2476z00_1189);
																																			BgL_tail2479z00_2948
																																				=
																																				BgL_newtail2480z00_1193;
																																			BgL_tail2479z00_1190
																																				=
																																				BgL_tail2479z00_2948;
																																			BgL_l2476z00_1189
																																				=
																																				BgL_l2476z00_2946;
																																			goto
																																				BgL_zc3anonymousza32986ze3z83_1191;
																																		}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Object/creator.scm 380 */
																													BgL_arg2982z00_1182 =
																														BNIL;
																												}
																										}
																										BgL_arg2983z00_1183 =
																											MAKE_PAIR(BgL_newz00_1072,
																											BNIL);
																										BgL_arg2977z00_1177 =
																											BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2982z00_1182,
																											BgL_arg2983z00_1183);
																									}
																									{	/* Object/creator.scm 376 */
																										obj_t BgL_list2978z00_1178;

																										BgL_list2978z00_1178 =
																											MAKE_PAIR
																											(BgL_arg2977z00_1177,
																											BNIL);
																										BgL_arg2975z00_1175 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2976z00_1176,
																											BgL_list2978z00_1178);
																									}
																								}
																								BgL_arg2962z00_1162 =
																									MAKE_PAIR(BgL_arg2974z00_1174,
																									BgL_arg2975z00_1175);
																							}
																							{	/* Object/creator.scm 372 */
																								obj_t BgL_list2964z00_1164;

																								{	/* Object/creator.scm 372 */
																									obj_t BgL_arg2965z00_1165;

																									BgL_arg2965z00_1165 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list2964z00_1164 =
																										MAKE_PAIR
																										(BgL_arg2962z00_1162,
																										BgL_arg2965z00_1165);
																								}
																								BgL_arg2960z00_1160 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2961z00_1161,
																									BgL_list2964z00_1164);
																							}
																						}
																						BgL_bodyz00_1094 =
																							MAKE_PAIR(BgL_arg2959z00_1159,
																							BgL_arg2960z00_1160);
																					}
																				}
																			}
																		}
																	else
																		{	/* Object/creator.scm 399 */
																			{	/* Object/creator.scm 385 */
																				obj_t BgL_alloczd2idzd2_1107;

																				{	/* Object/creator.scm 385 */
																					obj_t BgL_arg2953z00_1152;

																					{	/* Object/creator.scm 385 */
																						obj_t BgL_arg2954z00_1153;

																						obj_t BgL_arg2955z00_1154;

																						{	/* Object/creator.scm 385 */
																							obj_t BgL_symbolz00_1988;

																							BgL_symbolz00_1988 =
																								CNST_TABLE_REF(((long) 7));
																							BgL_arg2954z00_1153 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_1988);
																						}
																						BgL_arg2955z00_1154 =
																							SYMBOL_TO_STRING(BgL_idz00_52);
																						{	/* Object/creator.scm 385 */
																							obj_t BgL_list2956z00_1155;

																							{	/* Object/creator.scm 385 */
																								obj_t BgL_arg2957z00_1156;

																								BgL_arg2957z00_1156 =
																									MAKE_PAIR(BgL_arg2955z00_1154,
																									BNIL);
																								BgL_list2956z00_1155 =
																									MAKE_PAIR(BgL_arg2954z00_1153,
																									BgL_arg2957z00_1156);
																							}
																							BgL_arg2953z00_1152 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list2956z00_1155);
																					}}
																					BgL_alloczd2idzd2_1107 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg2953z00_1152));
																				}
																				{	/* Object/creator.scm 385 */

																					{	/* Object/creator.scm 386 */
																						obj_t BgL_arg2917z00_1108;

																						obj_t BgL_arg2918z00_1109;

																						BgL_arg2917z00_1108 =
																							CNST_TABLE_REF(((long) 20));
																						{	/* Object/creator.scm 386 */
																							obj_t BgL_arg2919z00_1110;

																							obj_t BgL_arg2920z00_1111;

																							{	/* Object/creator.scm 386 */
																								obj_t BgL_arg2924z00_1115;

																								{	/* Object/creator.scm 386 */
																									obj_t BgL_arg2926z00_1117;

																									obj_t BgL_arg2927z00_1118;

																									BgL_arg2926z00_1117 =
																										BGl_makezd2typedzd2identz00zzast_identz00
																										(BgL_newz00_1072,
																										BgL_tidz00_1064);
																									{	/* Object/creator.scm 387 */
																										obj_t BgL_arg2928z00_1119;

																										if (
																											(BgL_wideningz00_50 ==
																												CNST_TABLE_REF(((long)
																														6))))
																											{	/* Object/creator.scm 387 */
																												BgL_arg2928z00_1119 =
																													BGl_alloczd2wideningzd2zzobject_creatorz00
																													(BgL_tidz00_1064,
																													BgL_typez00_53);
																											}
																										else
																											{	/* Object/creator.scm 387 */
																												BgL_arg2928z00_1119 =
																													MAKE_PAIR
																													(BgL_alloczd2idzd2_1107,
																													BNIL);
																											}
																										{	/* Object/creator.scm 386 */
																											obj_t
																												BgL_list2930z00_1121;
																											BgL_list2930z00_1121 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2927z00_1118 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2928z00_1119,
																												BgL_list2930z00_1121);
																										}
																									}
																									BgL_arg2924z00_1115 =
																										MAKE_PAIR
																										(BgL_arg2926z00_1117,
																										BgL_arg2927z00_1118);
																								}
																								BgL_arg2919z00_1110 =
																									MAKE_PAIR(BgL_arg2924z00_1115,
																									BNIL);
																							}
																							{	/* Object/creator.scm 390 */
																								obj_t BgL_arg2932z00_1123;

																								obj_t BgL_arg2933z00_1124;

																								BgL_arg2932z00_1123 =
																									CNST_TABLE_REF(((long) 21));
																								{	/* Object/creator.scm 392 */
																									obj_t BgL_arg2934z00_1125;

																									obj_t BgL_arg2935z00_1126;

																									{	/* Object/creator.scm 392 */
																										obj_t BgL_arg2937z00_1128;

																										{	/* Object/creator.scm 392 */
																											obj_t BgL_arg2938z00_1129;

																											BgL_arg2938z00_1129 =
																												BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																												(BgL_fzd2idszd2_1070,
																												BNIL);
																											{	/* Object/creator.scm 392 */
																												obj_t
																													BgL_list2939z00_1130;
																												BgL_list2939z00_1130 =
																													MAKE_PAIR
																													(BgL_arg2938z00_1129,
																													BNIL);
																												BgL_arg2937z00_1128 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_newz00_1072,
																													BgL_list2939z00_1130);
																										}}
																										BgL_arg2934z00_1125 =
																											MAKE_PAIR
																											(BgL_fillzd2idzd2_1069,
																											BgL_arg2937z00_1128);
																									}
																									{	/* Object/creator.scm 394 */
																										obj_t BgL_arg2940z00_1131;

																										obj_t BgL_arg2941z00_1132;

																										{	/* Object/creator.scm 394 */
																											bool_t BgL_testz00_2982;

																											if (PAIRP
																												(BgL_constrsz00_1067))
																												{	/* Object/creator.scm 394 */
																													if (
																														(BgL_wideningz00_50
																															==
																															CNST_TABLE_REF((
																																	(long) 6))))
																														{	/* Object/creator.scm 394 */
																															BgL_testz00_2982 =
																																((bool_t) 0);
																														}
																													else
																														{	/* Object/creator.scm 394 */
																															BgL_testz00_2982 =
																																((bool_t) 1);
																														}
																												}
																											else
																												{	/* Object/creator.scm 394 */
																													BgL_testz00_2982 =
																														((bool_t) 0);
																												}
																											if (BgL_testz00_2982)
																												{	/* Object/creator.scm 394 */
																													if (NULLP
																														(BgL_constrsz00_1067))
																														{	/* Object/creator.scm 395 */
																															BgL_arg2940z00_1131
																																= BNIL;
																														}
																													else
																														{	/* Object/creator.scm 395 */
																															obj_t
																																BgL_head2473z00_1136;
																															BgL_head2473z00_1136
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															{
																																obj_t
																																	BgL_l2471z00_1138;
																																obj_t
																																	BgL_tail2474z00_1139;
																																BgL_l2471z00_1138
																																	=
																																	BgL_constrsz00_1067;
																																BgL_tail2474z00_1139
																																	=
																																	BgL_head2473z00_1136;
																															BgL_zc3anonymousza32944ze3z83_1140:
																																if (NULLP
																																	(BgL_l2471z00_1138))
																																	{	/* Object/creator.scm 395 */
																																		BgL_arg2940z00_1131
																																			=
																																			CDR
																																			(BgL_head2473z00_1136);
																																	}
																																else
																																	{	/* Object/creator.scm 395 */
																																		obj_t
																																			BgL_newtail2475z00_1142;
																																		{	/* Object/creator.scm 395 */
																																			obj_t
																																				BgL_arg2947z00_1144;
																																			{	/* Object/creator.scm 395 */
																																				obj_t
																																					BgL_constrz00_1146;
																																				BgL_constrz00_1146
																																					=
																																					CAR
																																					(BgL_l2471z00_1138);
																																				{	/* Object/creator.scm 395 */
																																					obj_t
																																						BgL_arg2949z00_1147;
																																					{	/* Object/creator.scm 395 */
																																						obj_t
																																							BgL_list2950z00_1148;
																																						BgL_list2950z00_1148
																																							=
																																							MAKE_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_arg2949z00_1147
																																							=
																																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_newz00_1072,
																																							BgL_list2950z00_1148);
																																					}
																																					BgL_arg2947z00_1144
																																						=
																																						MAKE_PAIR
																																						(BgL_constrz00_1146,
																																						BgL_arg2949z00_1147);
																																				}
																																			}
																																			BgL_newtail2475z00_1142
																																				=
																																				MAKE_PAIR
																																				(BgL_arg2947z00_1144,
																																				BNIL);
																																		}
																																		SET_CDR
																																			(BgL_tail2474z00_1139,
																																			BgL_newtail2475z00_1142);
																																		{
																																			obj_t
																																				BgL_tail2474z00_3002;
																																			obj_t
																																				BgL_l2471z00_3000;
																																			BgL_l2471z00_3000
																																				=
																																				CDR
																																				(BgL_l2471z00_1138);
																																			BgL_tail2474z00_3002
																																				=
																																				BgL_newtail2475z00_1142;
																																			BgL_tail2474z00_1139
																																				=
																																				BgL_tail2474z00_3002;
																																			BgL_l2471z00_1138
																																				=
																																				BgL_l2471z00_3000;
																																			goto
																																				BgL_zc3anonymousza32944ze3z83_1140;
																																		}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Object/creator.scm 394 */
																													BgL_arg2940z00_1131 =
																														BNIL;
																												}
																										}
																										BgL_arg2941z00_1132 =
																											MAKE_PAIR(BgL_newz00_1072,
																											BNIL);
																										BgL_arg2935z00_1126 =
																											BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2940z00_1131,
																											BgL_arg2941z00_1132);
																									}
																									{	/* Object/creator.scm 390 */
																										obj_t BgL_list2936z00_1127;

																										BgL_list2936z00_1127 =
																											MAKE_PAIR
																											(BgL_arg2935z00_1126,
																											BNIL);
																										BgL_arg2933z00_1124 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2934z00_1125,
																											BgL_list2936z00_1127);
																									}
																								}
																								BgL_arg2920z00_1111 =
																									MAKE_PAIR(BgL_arg2932z00_1123,
																									BgL_arg2933z00_1124);
																							}
																							{	/* Object/creator.scm 386 */
																								obj_t BgL_list2922z00_1113;

																								{	/* Object/creator.scm 386 */
																									obj_t BgL_arg2923z00_1114;

																									BgL_arg2923z00_1114 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list2922z00_1113 =
																										MAKE_PAIR
																										(BgL_arg2920z00_1111,
																										BgL_arg2923z00_1114);
																								}
																								BgL_arg2918z00_1109 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2919z00_1110,
																									BgL_list2922z00_1113);
																							}
																						}
																						BgL_bodyz00_1094 =
																							MAKE_PAIR(BgL_arg2917z00_1108,
																							BgL_arg2918z00_1109);
																					}
																				}
																			}
																		}
																}
																{	/* Object/creator.scm 408 */
																	obj_t BgL_arg2905z00_1095;

																	{	/* Object/creator.scm 408 */
																		obj_t BgL_arg2907z00_1097;

																		obj_t BgL_arg2908z00_1098;

																		BgL_arg2907z00_1097 =
																			CNST_TABLE_REF(((long) 15));
																		{	/* Object/creator.scm 408 */
																			obj_t BgL_list2909z00_1099;

																			{	/* Object/creator.scm 408 */
																				obj_t BgL_arg2910z00_1100;

																				BgL_arg2910z00_1100 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2909z00_1099 =
																					MAKE_PAIR(BgL_bodyz00_1094,
																					BgL_arg2910z00_1100);
																			}
																			BgL_arg2908z00_1098 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_protoz00_1093,
																				BgL_list2909z00_1099);
																		}
																		BgL_arg2905z00_1095 =
																			MAKE_PAIR(BgL_arg2907z00_1097,
																			BgL_arg2908z00_1098);
																	}
																	{	/* Object/creator.scm 408 */
																		obj_t BgL_list2906z00_1096;

																		BgL_list2906z00_1096 =
																			MAKE_PAIR(BgL_srczd2defzd2_54, BNIL);
																		return
																			BGl_epairifyza2za2zztools_miscz00
																			(BgL_arg2905z00_1095,
																			BgL_list2906z00_1096);
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* alloc-widening */
	obj_t BGl_alloczd2wideningzd2zzobject_creatorz00(obj_t BgL_tidz00_2104,
		BgL_tclassz00_bglt BgL_typez00_2103)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 364 */
			{

				{	/* Object/creator.scm 367 */
					bool_t BgL_testz00_3019;

					{	/* Object/creator.scm 367 */
						obj_t BgL_arg3005z00_1212;

						BgL_arg3005z00_1212 = BGl_thezd2backendzd2zzbackend_backendz00();
						{
							BgL_backendz00_bglt BgL_auxz00_3021;

							BgL_auxz00_3021 = (BgL_backendz00_bglt) (BgL_arg3005z00_1212);
							BgL_testz00_3019 =
								(((BgL_backendz00_bglt) CREF(BgL_auxz00_3021))->
								BgL_pragmazd2supportzd2);
						}
					}
					if (BgL_testz00_3019)
						{	/* Object/creator.scm 367 */
							{	/* Object/creator.scm 358 */
								obj_t BgL_tnamez00_1216;

								obj_t BgL_siza7eofza7_1217;

								{	/* Object/creator.scm 358 */
									obj_t BgL_arg3021z00_1230;

									{
										BgL_typez00_bglt BgL_auxz00_3024;

										BgL_auxz00_3024 = (BgL_typez00_bglt) (BgL_typez00_2103);
										BgL_arg3021z00_1230 =
											(((BgL_typez00_bglt) CREF(BgL_auxz00_3024))->BgL_namez00);
									}
									BgL_tnamez00_1216 =
										BGl_stringzd2sanszd2z42z42zztype_toolsz00
										(BgL_arg3021z00_1230);
								}
								{	/* Object/creator.scm 359 */
									bool_t BgL_testz00_3028;

									{	/* Object/creator.scm 359 */
										obj_t BgL_auxz00_3029;

										{
											BgL_typez00_bglt BgL_auxz00_3030;

											BgL_auxz00_3030 = (BgL_typez00_bglt) (BgL_typez00_2103);
											BgL_auxz00_3029 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3030))->
												BgL_siza7eza7);
										}
										BgL_testz00_3028 = STRINGP(BgL_auxz00_3029);
									}
									if (BgL_testz00_3028)
										{
											BgL_typez00_bglt BgL_auxz00_3034;

											BgL_auxz00_3034 = (BgL_typez00_bglt) (BgL_typez00_2103);
											BgL_siza7eofza7_1217 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3034))->
												BgL_siza7eza7);
										}
									else
										{
											BgL_typez00_bglt BgL_auxz00_3037;

											BgL_auxz00_3037 = (BgL_typez00_bglt) (BgL_typez00_2103);
											BgL_siza7eofza7_1217 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3037))->
												BgL_namez00);
										}
								}
								{	/* Object/creator.scm 362 */
									obj_t BgL_arg3009z00_1218;

									obj_t BgL_arg3010z00_1219;

									BgL_arg3009z00_1218 =
										BGl_makezd2typedzd2identz00zzast_identz00(CNST_TABLE_REF((
												(long) 25)), BgL_tidz00_2104);
									{	/* Object/creator.scm 363 */
										obj_t BgL_arg3011z00_1220;

										{	/* Object/creator.scm 363 */
											obj_t BgL_list3014z00_1223;

											{	/* Object/creator.scm 363 */
												obj_t BgL_arg3016z00_1225;

												{	/* Object/creator.scm 363 */
													obj_t BgL_arg3017z00_1226;

													{	/* Object/creator.scm 363 */
														obj_t BgL_arg3019z00_1228;

														{	/* Object/creator.scm 363 */
															obj_t BgL_arg3020z00_1229;

															BgL_arg3020z00_1229 =
																MAKE_PAIR(BGl_string3396z00zzobject_creatorz00,
																BNIL);
															BgL_arg3019z00_1228 =
																MAKE_PAIR(BgL_siza7eofza7_1217,
																BgL_arg3020z00_1229);
														}
														BgL_arg3017z00_1226 =
															MAKE_PAIR(BGl_string3397z00zzobject_creatorz00,
															BgL_arg3019z00_1228);
													}
													BgL_arg3016z00_1225 =
														MAKE_PAIR(BgL_tnamez00_1216, BgL_arg3017z00_1226);
												}
												BgL_list3014z00_1223 =
													MAKE_PAIR(BGl_string3398z00zzobject_creatorz00,
													BgL_arg3016z00_1225);
											}
											BgL_arg3011z00_1220 =
												BGl_stringzd2appendzd2zz__r4_strings_6_7z00
												(BgL_list3014z00_1223);
										}
										{	/* Object/creator.scm 362 */
											obj_t BgL_list3013z00_1222;

											BgL_list3013z00_1222 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3010z00_1219 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg3011z00_1220, BgL_list3013z00_1222);
									}}
									return MAKE_PAIR(BgL_arg3009z00_1218, BgL_arg3010z00_1219);
								}
							}
						}
					else
						{	/* Object/creator.scm 367 */
							return
								BGl_makezd2privatezd2sexpz00zzast_privatez00(CNST_TABLE_REF((
										(long) 9)), BgL_tidz00_2104, BNIL);
		}}}}
	}



/* make-class-slot-make! */
	obj_t
		BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_typez00_56, obj_t BgL_newz00_57, obj_t BgL_ridz00_58,
		obj_t BgL_rtidz00_59, obj_t BgL_slotsz00_60, obj_t BgL_fzd2idszd2_61)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 413 */
			{
				obj_t BgL_slotz00_1274;

				obj_t BgL_formalz00_1275;

				obj_t BgL_flenz00_1276;

				{
					obj_t BgL_slotsz00_1257;

					obj_t BgL_fzd2idszd2_1258;

					obj_t BgL_resz00_1259;

					obj_t BgL_lenzd2idzd2_1260;

					BgL_slotsz00_1257 = BgL_slotsz00_60;
					BgL_fzd2idszd2_1258 = BgL_fzd2idszd2_61;
					BgL_resz00_1259 = BNIL;
					BgL_lenzd2idzd2_1260 = BUNSPEC;
				BgL_zc3anonymousza33039ze3z83_1261:
					if (NULLP(BgL_slotsz00_1257))
						{	/* Object/creator.scm 443 */
							return bgl_reverse_bang(BgL_resz00_1259);
						}
					else
						{	/* Object/creator.scm 445 */
							bool_t BgL_testz00_3056;

							{	/* Object/creator.scm 445 */
								obj_t BgL_arg3050z00_1272;

								BgL_arg3050z00_1272 = CAR(BgL_slotsz00_1257);
								BgL_testz00_3056 =
									BGl_slotzd2virtualzf3z21zzobject_slotsz00(
									(BgL_slotz00_bglt) (BgL_arg3050z00_1272));
							}
							if (BgL_testz00_3056)
								{
									obj_t BgL_slotsz00_3060;

									BgL_slotsz00_3060 = CDR(BgL_slotsz00_1257);
									BgL_slotsz00_1257 = BgL_slotsz00_3060;
									goto BgL_zc3anonymousza33039ze3z83_1261;
								}
							else
								{	/* Object/creator.scm 448 */
									obj_t BgL_arg3043z00_1265;

									obj_t BgL_arg3044z00_1266;

									obj_t BgL_arg3045z00_1267;

									obj_t BgL_arg3046z00_1268;

									BgL_arg3043z00_1265 = CDR(BgL_slotsz00_1257);
									BgL_arg3044z00_1266 = CDR(BgL_fzd2idszd2_1258);
									{	/* Object/creator.scm 450 */
										obj_t BgL_auxz00_3064;

										BgL_slotz00_1274 = CAR(BgL_slotsz00_1257);
										BgL_formalz00_1275 = CAR(BgL_fzd2idszd2_1258);
										BgL_flenz00_1276 = BgL_lenzd2idzd2_1260;
										{	/* Object/creator.scm 415 */
											obj_t BgL_loopz00_1278;

											BgL_loopz00_1278 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 26))));
											{	/* Object/creator.scm 417 */
												bool_t BgL_testz00_3068;

												{	/* Object/creator.scm 417 */
													BgL_slotz00_bglt BgL_obj2357z00_2032;

													BgL_obj2357z00_2032 =
														(BgL_slotz00_bglt) (BgL_slotz00_1274);
													BgL_testz00_3068 =
														CBOOL(
														(((BgL_slotz00_bglt) CREF(BgL_obj2357z00_2032))->
															BgL_indexedz00));
												}
												if (BgL_testz00_3068)
													{	/* Object/creator.scm 420 */
														obj_t BgL_arg3053z00_1280;

														obj_t BgL_arg3054z00_1281;

														BgL_arg3053z00_1280 = CNST_TABLE_REF(((long) 21));
														{	/* Object/creator.scm 421 */
															obj_t BgL_arg3055z00_1282;

															obj_t BgL_arg3056z00_1283;

															BgL_arg3055z00_1282 =
																BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
																((BgL_typez00_bglt) (BgL_typez00_56),
																(BgL_slotz00_bglt) (BgL_slotz00_1274),
																BgL_newz00_57, BgL_flenz00_1276);
															{	/* Object/creator.scm 423 */
																obj_t BgL_arg3060z00_1287;

																obj_t BgL_arg3061z00_1288;

																BgL_arg3060z00_1287 =
																	CNST_TABLE_REF(((long) 27));
																{	/* Object/creator.scm 423 */
																	obj_t BgL_arg3062z00_1289;

																	obj_t BgL_arg3063z00_1290;

																	{	/* Object/creator.scm 423 */
																		obj_t BgL_arg3068z00_1294;

																		{	/* Object/creator.scm 423 */
																			obj_t BgL_arg3070z00_1296;

																			{	/* Object/creator.scm 423 */
																				obj_t BgL_arg3071z00_1297;

																				obj_t BgL_arg3072z00_1298;

																				BgL_arg3071z00_1297 =
																					MAKE_PAIR(BgL_rtidz00_59, BNIL);
																				{	/* Object/creator.scm 424 */
																					obj_t BgL_arg3076z00_1302;

																					obj_t BgL_arg3077z00_1303;

																					BgL_arg3076z00_1302 =
																						CNST_TABLE_REF(((long) 28));
																					{	/* Object/creator.scm 424 */
																						obj_t BgL_arg3078z00_1304;

																						obj_t BgL_arg3079z00_1305;

																						obj_t BgL_arg3080z00_1306;

																						{	/* Object/creator.scm 424 */
																							obj_t BgL_arg3085z00_1311;

																							obj_t BgL_arg3086z00_1312;

																							BgL_arg3085z00_1311 =
																								CNST_TABLE_REF(((long) 29));
																							{	/* Object/creator.scm 424 */
																								obj_t BgL_list3087z00_1313;

																								{	/* Object/creator.scm 424 */
																									obj_t BgL_arg3088z00_1314;

																									BgL_arg3088z00_1314 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3087z00_1313 =
																										MAKE_PAIR(BgL_flenz00_1276,
																										BgL_arg3088z00_1314);
																								}
																								BgL_arg3086z00_1312 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_ridz00_58,
																									BgL_list3087z00_1313);
																							}
																							BgL_arg3078z00_1304 =
																								MAKE_PAIR(BgL_arg3085z00_1311,
																								BgL_arg3086z00_1312);
																						}
																						{	/* Object/creator.scm 425 */
																							obj_t BgL_arg3089z00_1315;

																							obj_t BgL_arg3090z00_1316;

																							BgL_arg3089z00_1315 =
																								CNST_TABLE_REF(((long) 16));
																							{	/* Object/creator.scm 425 */
																								obj_t BgL_list3091z00_1317;

																								BgL_list3091z00_1317 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3090z00_1316 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(CNST_TABLE_REF(((long) 30)),
																									BgL_list3091z00_1317);
																							}
																							BgL_arg3079z00_1305 =
																								MAKE_PAIR(BgL_arg3089z00_1315,
																								BgL_arg3090z00_1316);
																						}
																						{	/* Object/creator.scm 426 */
																							obj_t BgL_arg3092z00_1318;

																							obj_t BgL_arg3093z00_1319;

																							BgL_arg3092z00_1318 =
																								CNST_TABLE_REF(((long) 21));
																							{	/* Object/creator.scm 427 */
																								obj_t BgL_arg3094z00_1320;

																								obj_t BgL_arg3095z00_1321;

																								BgL_arg3094z00_1320 =
																									BGl_makezd2pragmazd2indexedzd2setz12zf2wideningz32zzobject_toolsz00
																									((BgL_typez00_bglt)
																									(BgL_typez00_56),
																									(BgL_slotz00_bglt)
																									(BgL_slotz00_1274),
																									BgL_newz00_57,
																									BgL_formalz00_1275,
																									BgL_ridz00_58, BFALSE);
																								{	/* Object/creator.scm 434 */
																									obj_t BgL_arg3099z00_1325;

																									{	/* Object/creator.scm 434 */
																										obj_t BgL_arg3100z00_1326;

																										{	/* Object/creator.scm 434 */
																											obj_t BgL_arg3103z00_1329;

																											obj_t BgL_arg3104z00_1330;

																											BgL_arg3103z00_1329 =
																												CNST_TABLE_REF(((long)
																													31));
																											{	/* Object/creator.scm 434 */
																												obj_t
																													BgL_list3105z00_1331;
																												{	/* Object/creator.scm 434 */
																													obj_t
																														BgL_arg3107z00_1333;
																													BgL_arg3107z00_1333 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list3105z00_1331 =
																														MAKE_PAIR(BINT((
																																(long) 1)),
																														BgL_arg3107z00_1333);
																												}
																												BgL_arg3104z00_1330 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_ridz00_58,
																													BgL_list3105z00_1331);
																											}
																											BgL_arg3100z00_1326 =
																												MAKE_PAIR
																												(BgL_arg3103z00_1329,
																												BgL_arg3104z00_1330);
																										}
																										{	/* Object/creator.scm 434 */
																											obj_t
																												BgL_list3102z00_1328;
																											BgL_list3102z00_1328 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg3099z00_1325 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg3100z00_1326,
																												BgL_list3102z00_1328);
																									}}
																									BgL_arg3095z00_1321 =
																										MAKE_PAIR(BgL_loopz00_1278,
																										BgL_arg3099z00_1325);
																								}
																								{	/* Object/creator.scm 426 */
																									obj_t BgL_list3097z00_1323;

																									{	/* Object/creator.scm 426 */
																										obj_t BgL_arg3098z00_1324;

																										BgL_arg3098z00_1324 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list3097z00_1323 =
																											MAKE_PAIR
																											(BgL_arg3095z00_1321,
																											BgL_arg3098z00_1324);
																									}
																									BgL_arg3093z00_1319 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3094z00_1320,
																										BgL_list3097z00_1323);
																							}}
																							BgL_arg3080z00_1306 =
																								MAKE_PAIR(BgL_arg3092z00_1318,
																								BgL_arg3093z00_1319);
																						}
																						{	/* Object/creator.scm 424 */
																							obj_t BgL_list3082z00_1308;

																							{	/* Object/creator.scm 424 */
																								obj_t BgL_arg3083z00_1309;

																								{	/* Object/creator.scm 424 */
																									obj_t BgL_arg3084z00_1310;

																									BgL_arg3084z00_1310 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg3083z00_1309 =
																										MAKE_PAIR
																										(BgL_arg3080z00_1306,
																										BgL_arg3084z00_1310);
																								}
																								BgL_list3082z00_1308 =
																									MAKE_PAIR(BgL_arg3079z00_1305,
																									BgL_arg3083z00_1309);
																							}
																							BgL_arg3077z00_1303 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg3078z00_1304,
																								BgL_list3082z00_1308);
																					}}
																					BgL_arg3072z00_1298 =
																						MAKE_PAIR(BgL_arg3076z00_1302,
																						BgL_arg3077z00_1303);
																				}
																				{	/* Object/creator.scm 423 */
																					obj_t BgL_list3074z00_1300;

																					{	/* Object/creator.scm 423 */
																						obj_t BgL_arg3075z00_1301;

																						BgL_arg3075z00_1301 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_list3074z00_1300 =
																							MAKE_PAIR(BgL_arg3072z00_1298,
																							BgL_arg3075z00_1301);
																					}
																					BgL_arg3070z00_1296 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3071z00_1297,
																						BgL_list3074z00_1300);
																			}}
																			BgL_arg3068z00_1294 =
																				MAKE_PAIR(BgL_loopz00_1278,
																				BgL_arg3070z00_1296);
																		}
																		BgL_arg3062z00_1289 =
																			MAKE_PAIR(BgL_arg3068z00_1294, BNIL);
																	}
																	{	/* Object/creator.scm 435 */
																		obj_t BgL_arg3108z00_1334;

																		{	/* Object/creator.scm 435 */
																			obj_t BgL_list3109z00_1335;

																			BgL_list3109z00_1335 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3108z00_1334 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BINT(((long) 0)),
																				BgL_list3109z00_1335);
																		}
																		BgL_arg3063z00_1290 =
																			MAKE_PAIR(BgL_loopz00_1278,
																			BgL_arg3108z00_1334);
																	}
																	{	/* Object/creator.scm 423 */
																		obj_t BgL_list3066z00_1292;

																		{	/* Object/creator.scm 423 */
																			obj_t BgL_arg3067z00_1293;

																			BgL_arg3067z00_1293 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list3066z00_1292 =
																				MAKE_PAIR(BgL_arg3063z00_1290,
																				BgL_arg3067z00_1293);
																		}
																		BgL_arg3061z00_1288 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg3062z00_1289,
																			BgL_list3066z00_1292);
																}}
																BgL_arg3056z00_1283 =
																	MAKE_PAIR(BgL_arg3060z00_1287,
																	BgL_arg3061z00_1288);
															}
															{	/* Object/creator.scm 420 */
																obj_t BgL_list3058z00_1285;

																{	/* Object/creator.scm 420 */
																	obj_t BgL_arg3059z00_1286;

																	BgL_arg3059z00_1286 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list3058z00_1285 =
																		MAKE_PAIR(BgL_arg3056z00_1283,
																		BgL_arg3059z00_1286);
																}
																BgL_arg3054z00_1281 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3055z00_1282, BgL_list3058z00_1285);
														}}
														BgL_auxz00_3064 =
															MAKE_PAIR(BgL_arg3053z00_1280,
															BgL_arg3054z00_1281);
													}
												else
													{	/* Object/creator.scm 417 */
														BgL_auxz00_3064 =
															BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00
															((BgL_typez00_bglt) (BgL_typez00_56),
															(BgL_slotz00_bglt) (BgL_slotz00_1274),
															BgL_newz00_57, BgL_formalz00_1275);
													}
											}
										}
										BgL_arg3045z00_1267 =
											MAKE_PAIR(BgL_auxz00_3064, BgL_resz00_1259);
									}
									BgL_arg3046z00_1268 = CAR(BgL_fzd2idszd2_1258);
									{
										obj_t BgL_lenzd2idzd2_3138;

										obj_t BgL_resz00_3137;

										obj_t BgL_fzd2idszd2_3136;

										obj_t BgL_slotsz00_3135;

										BgL_slotsz00_3135 = BgL_arg3043z00_1265;
										BgL_fzd2idszd2_3136 = BgL_arg3044z00_1266;
										BgL_resz00_3137 = BgL_arg3045z00_1267;
										BgL_lenzd2idzd2_3138 = BgL_arg3046z00_1268;
										BgL_lenzd2idzd2_1260 = BgL_lenzd2idzd2_3138;
										BgL_resz00_1259 = BgL_resz00_3137;
										BgL_fzd2idszd2_1258 = BgL_fzd2idszd2_3136;
										BgL_slotsz00_1257 = BgL_slotsz00_3135;
										goto BgL_zc3anonymousza33039ze3z83_1261;
									}
								}
						}
				}
			}
		}
	}



/* gen-class-allocate! */
	obj_t BGl_genzd2classzd2allocatez12z12zzobject_creatorz00(obj_t BgL_idz00_62,
		obj_t BgL_typez00_63, BgL_globalz00_bglt BgL_holderz00_64,
		obj_t BgL_srczd2defzd2_65, obj_t BgL_importz00_66)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 456 */
			{	/* Object/creator.scm 457 */
				obj_t BgL_tidz00_1338;

				{
					BgL_typez00_bglt BgL_auxz00_3139;

					BgL_auxz00_3139 = (BgL_typez00_bglt) (BgL_typez00_63);
					BgL_tidz00_1338 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_3139))->BgL_idz00);
				}
				{	/* Object/creator.scm 457 */
					obj_t BgL_alloczd2idzd2_1339;

					{	/* Object/creator.scm 458 */
						obj_t BgL_arg3247z00_1486;

						{	/* Object/creator.scm 458 */
							obj_t BgL_arg3248z00_1487;

							obj_t BgL_arg3249z00_1488;

							{	/* Object/creator.scm 458 */
								obj_t BgL_symbolz00_2034;

								BgL_symbolz00_2034 = CNST_TABLE_REF(((long) 7));
								BgL_arg3248z00_1487 = SYMBOL_TO_STRING(BgL_symbolz00_2034);
							}
							BgL_arg3249z00_1488 = SYMBOL_TO_STRING(BgL_idz00_62);
							{	/* Object/creator.scm 458 */
								obj_t BgL_list3250z00_1489;

								{	/* Object/creator.scm 458 */
									obj_t BgL_arg3251z00_1490;

									BgL_arg3251z00_1490 = MAKE_PAIR(BgL_arg3249z00_1488, BNIL);
									BgL_list3250z00_1489 =
										MAKE_PAIR(BgL_arg3248z00_1487, BgL_arg3251z00_1490);
								}
								BgL_arg3247z00_1486 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list3250z00_1489);
						}}
						BgL_alloczd2idzd2_1339 =
							string_to_symbol(BSTRING_TO_STRING(BgL_arg3247z00_1486));
					}
					{	/* Object/creator.scm 458 */
						obj_t BgL_alloczd2tidzd2_1340;

						BgL_alloczd2tidzd2_1340 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_alloczd2idzd2_1339,
							BgL_tidz00_1338);
						{	/* Object/creator.scm 459 */
							obj_t BgL_newz00_1341;

							BgL_newz00_1341 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											9))));
							{	/* Object/creator.scm 460 */

								{
									obj_t BgL_typez00_1462;

									{	/* Object/creator.scm 490 */
										obj_t BgL_arg3111z00_1345;

										{	/* Object/creator.scm 490 */
											obj_t BgL_arg3112z00_1346;

											{	/* Object/creator.scm 490 */
												obj_t BgL_arg3113z00_1347;

												{	/* Object/creator.scm 490 */
													obj_t BgL_arg3116z00_1350;

													obj_t BgL_arg3117z00_1351;

													BgL_arg3116z00_1350 = CNST_TABLE_REF(((long) 11));
													{	/* Object/creator.scm 490 */
														obj_t BgL_list3118z00_1352;

														BgL_list3118z00_1352 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3117z00_1351 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_alloczd2tidzd2_1340, BgL_list3118z00_1352);
													}
													BgL_arg3113z00_1347 =
														MAKE_PAIR(BgL_arg3116z00_1350, BgL_arg3117z00_1351);
												}
												{	/* Object/creator.scm 490 */
													obj_t BgL_list3115z00_1349;

													BgL_list3115z00_1349 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3112z00_1346 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3113z00_1347, BgL_list3115z00_1349);
											}}
											BgL_arg3111z00_1345 =
												MAKE_PAIR(BgL_importz00_66, BgL_arg3112z00_1346);
										}
										BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
											(BgL_arg3111z00_1345);
									}
									{	/* Object/creator.scm 491 */
										obj_t BgL_arg3119z00_1353;

										{	/* Object/creator.scm 491 */
											bool_t BgL_testz00_3162;

											{	/* Object/creator.scm 491 */
												obj_t BgL_arg3122z00_1356;

												BgL_arg3122z00_1356 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_3164;

													BgL_auxz00_3164 =
														(BgL_backendz00_bglt) (BgL_arg3122z00_1356);
													BgL_testz00_3162 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_3164))->
														BgL_pragmazd2supportzd2);
											}}
											if (BgL_testz00_3162)
												{	/* Object/creator.scm 491 */
													{	/* Object/creator.scm 471 */
														obj_t BgL_arg3177z00_1411;

														obj_t BgL_arg3178z00_1412;

														BgL_arg3177z00_1411 = CNST_TABLE_REF(((long) 8));
														{	/* Object/creator.scm 471 */
															obj_t BgL_arg3179z00_1413;

															obj_t BgL_arg3180z00_1414;

															BgL_arg3179z00_1413 =
																MAKE_PAIR(BgL_alloczd2tidzd2_1340, BNIL);
															{	/* Object/creator.scm 472 */
																obj_t BgL_arg3184z00_1418;

																obj_t BgL_arg3185z00_1419;

																BgL_arg3184z00_1418 =
																	CNST_TABLE_REF(((long) 20));
																{	/* Object/creator.scm 472 */
																	obj_t BgL_arg3186z00_1420;

																	obj_t BgL_arg3187z00_1421;

																	obj_t BgL_arg3188z00_1422;

																	{	/* Object/creator.scm 472 */
																		obj_t BgL_arg3194z00_1428;

																		{	/* Object/creator.scm 472 */
																			obj_t BgL_arg3196z00_1430;

																			obj_t BgL_arg3197z00_1431;

																			BgL_arg3196z00_1430 =
																				BGl_makezd2typedzd2identz00zzast_identz00
																				(BgL_newz00_1341, BgL_tidz00_1338);
																			{	/* Object/creator.scm 472 */
																				obj_t BgL_arg3198z00_1432;

																				BgL_typez00_1462 = BgL_typez00_63;
																				{	/* Object/creator.scm 462 */
																					obj_t BgL_tidz00_1464;

																					obj_t BgL_tnamez00_1465;

																					obj_t BgL_siza7eofza7_1466;

																					{
																						BgL_typez00_bglt BgL_auxz00_3171;

																						BgL_auxz00_3171 =
																							(BgL_typez00_bglt)
																							(BgL_typez00_1462);
																						BgL_tidz00_1464 =
																							(((BgL_typez00_bglt)
																								CREF(BgL_auxz00_3171))->
																							BgL_idz00);
																					}
																					{	/* Object/creator.scm 463 */
																						obj_t BgL_arg3243z00_1479;

																						{
																							BgL_typez00_bglt BgL_auxz00_3174;

																							BgL_auxz00_3174 =
																								(BgL_typez00_bglt)
																								(BgL_typez00_1462);
																							BgL_arg3243z00_1479 =
																								(((BgL_typez00_bglt)
																									CREF(BgL_auxz00_3174))->
																								BgL_namez00);
																						}
																						BgL_tnamez00_1465 =
																							BGl_stringzd2sanszd2z42z42zztype_toolsz00
																							(BgL_arg3243z00_1479);
																					}
																					{	/* Object/creator.scm 464 */
																						bool_t BgL_testz00_3178;

																						{	/* Object/creator.scm 464 */
																							obj_t BgL_auxz00_3179;

																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3180;
																								BgL_auxz00_3180 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1462);
																								BgL_auxz00_3179 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3180))->
																									BgL_siza7eza7);
																							}
																							BgL_testz00_3178 =
																								STRINGP(BgL_auxz00_3179);
																						}
																						if (BgL_testz00_3178)
																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3184;
																								BgL_auxz00_3184 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1462);
																								BgL_siza7eofza7_1466 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3184))->
																									BgL_siza7eza7);
																							}
																						else
																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3187;
																								BgL_auxz00_3187 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1462);
																								BgL_siza7eofza7_1466 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3187))->
																									BgL_namez00);
																							}
																					}
																					{	/* Object/creator.scm 467 */
																						obj_t BgL_arg3231z00_1467;

																						obj_t BgL_arg3232z00_1468;

																						BgL_arg3231z00_1467 =
																							BGl_makezd2typedzd2identz00zzast_identz00
																							(CNST_TABLE_REF(((long) 25)),
																							BgL_tidz00_1464);
																						{	/* Object/creator.scm 468 */
																							obj_t BgL_arg3233z00_1469;

																							{	/* Object/creator.scm 468 */
																								obj_t BgL_list3236z00_1472;

																								{	/* Object/creator.scm 468 */
																									obj_t BgL_arg3238z00_1474;

																									{	/* Object/creator.scm 468 */
																										obj_t BgL_arg3239z00_1475;

																										{	/* Object/creator.scm 468 */
																											obj_t BgL_arg3241z00_1477;

																											{	/* Object/creator.scm 468 */
																												obj_t
																													BgL_arg3242z00_1478;
																												BgL_arg3242z00_1478 =
																													MAKE_PAIR
																													(BGl_string3399z00zzobject_creatorz00,
																													BNIL);
																												BgL_arg3241z00_1477 =
																													MAKE_PAIR
																													(BgL_siza7eofza7_1466,
																													BgL_arg3242z00_1478);
																											}
																											BgL_arg3239z00_1475 =
																												MAKE_PAIR
																												(BGl_string3400z00zzobject_creatorz00,
																												BgL_arg3241z00_1477);
																										}
																										BgL_arg3238z00_1474 =
																											MAKE_PAIR
																											(BgL_tnamez00_1465,
																											BgL_arg3239z00_1475);
																									}
																									BgL_list3236z00_1472 =
																										MAKE_PAIR
																										(BGl_string3398z00zzobject_creatorz00,
																										BgL_arg3238z00_1474);
																								}
																								BgL_arg3233z00_1469 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list3236z00_1472);
																							}
																							{	/* Object/creator.scm 467 */
																								obj_t BgL_list3235z00_1471;

																								BgL_list3235z00_1471 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3232z00_1468 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3233z00_1469,
																									BgL_list3235z00_1471);
																						}}
																						BgL_arg3198z00_1432 =
																							MAKE_PAIR(BgL_arg3231z00_1467,
																							BgL_arg3232z00_1468);
																				}}
																				{	/* Object/creator.scm 472 */
																					obj_t BgL_list3200z00_1434;

																					BgL_list3200z00_1434 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3197z00_1431 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3198z00_1432,
																						BgL_list3200z00_1434);
																			}}
																			BgL_arg3194z00_1428 =
																				MAKE_PAIR(BgL_arg3196z00_1430,
																				BgL_arg3197z00_1431);
																		}
																		BgL_arg3186z00_1420 =
																			MAKE_PAIR(BgL_arg3194z00_1428, BNIL);
																	}
																	{	/* Object/creator.scm 473 */
																		obj_t BgL_arg3201z00_1435;

																		obj_t BgL_arg3202z00_1436;

																		BgL_arg3201z00_1435 =
																			CNST_TABLE_REF(((long) 32));
																		{	/* Object/creator.scm 474 */
																			obj_t BgL_arg3203z00_1437;

																			{	/* Object/creator.scm 474 */
																				obj_t BgL_arg3207z00_1441;

																				obj_t BgL_arg3208z00_1442;

																				{	/* Object/creator.scm 474 */
																					obj_t BgL_arg3209z00_1443;

																					obj_t BgL_arg3210z00_1444;

																					BgL_arg3209z00_1443 =
																						CNST_TABLE_REF(((long) 33));
																					{	/* Object/creator.scm 474 */
																						obj_t BgL_list3211z00_1445;

																						{	/* Object/creator.scm 474 */
																							obj_t BgL_arg3212z00_1446;

																							obj_t BgL_arg3213z00_1447;

																							BgL_arg3212z00_1446 =
																								CNST_TABLE_REF(((long) 34));
																							BgL_arg3213z00_1447 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3211z00_1445 =
																								MAKE_PAIR(BgL_arg3212z00_1446,
																								BgL_arg3213z00_1447);
																						}
																						BgL_arg3210z00_1444 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 35)),
																							BgL_list3211z00_1445);
																					}
																					BgL_arg3207z00_1441 =
																						MAKE_PAIR(BgL_arg3209z00_1443,
																						BgL_arg3210z00_1444);
																				}
																				{	/* Object/creator.scm 475 */
																					obj_t BgL_arg3214z00_1448;

																					{	/* Object/creator.scm 475 */
																						obj_t BgL_arg3218z00_1451;

																						obj_t BgL_arg3219z00_1452;

																						BgL_arg3218z00_1451 =
																							CNST_TABLE_REF(((long) 33));
																						{	/* Object/creator.scm 475 */
																							obj_t BgL_arg3221z00_1453;

																							obj_t BgL_arg3222z00_1454;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3214;
																								BgL_auxz00_3214 =
																									(BgL_variablez00_bglt)
																									(BgL_holderz00_64);
																								BgL_arg3221z00_1453 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3214))->
																									BgL_idz00);
																							}
																							BgL_arg3222z00_1454 =
																								(((BgL_globalz00_bglt)
																									CREF(BgL_holderz00_64))->
																								BgL_modulez00);
																							{	/* Object/creator.scm 475 */
																								obj_t BgL_list3224z00_1456;

																								{	/* Object/creator.scm 475 */
																									obj_t BgL_arg3225z00_1457;

																									BgL_arg3225z00_1457 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3224z00_1456 =
																										MAKE_PAIR
																										(BgL_arg3222z00_1454,
																										BgL_arg3225z00_1457);
																								}
																								BgL_arg3219z00_1452 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3221z00_1453,
																									BgL_list3224z00_1456);
																						}}
																						BgL_arg3214z00_1448 =
																							MAKE_PAIR(BgL_arg3218z00_1451,
																							BgL_arg3219z00_1452);
																					}
																					{	/* Object/creator.scm 474 */
																						obj_t BgL_list3216z00_1450;

																						BgL_list3216z00_1450 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3208z00_1442 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg3214z00_1448,
																							BgL_list3216z00_1450);
																				}}
																				BgL_arg3203z00_1437 =
																					MAKE_PAIR(BgL_arg3207z00_1441,
																					BgL_arg3208z00_1442);
																			}
																			{	/* Object/creator.scm 473 */
																				obj_t BgL_list3205z00_1439;

																				{	/* Object/creator.scm 473 */
																					obj_t BgL_arg3206z00_1440;

																					BgL_arg3206z00_1440 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_list3205z00_1439 =
																						MAKE_PAIR(BgL_arg3203z00_1437,
																						BgL_arg3206z00_1440);
																				}
																				BgL_arg3202z00_1436 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_newz00_1341,
																					BgL_list3205z00_1439);
																		}}
																		BgL_arg3187z00_1421 =
																			MAKE_PAIR(BgL_arg3201z00_1435,
																			BgL_arg3202z00_1436);
																	}
																	{	/* Object/creator.scm 477 */
																		obj_t BgL_arg3226z00_1458;

																		obj_t BgL_arg3227z00_1459;

																		BgL_arg3226z00_1458 =
																			CNST_TABLE_REF(((long) 36));
																		{	/* Object/creator.scm 477 */
																			obj_t BgL_list3228z00_1460;

																			{	/* Object/creator.scm 477 */
																				obj_t BgL_arg3229z00_1461;

																				BgL_arg3229z00_1461 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3228z00_1460 =
																					MAKE_PAIR(BFALSE,
																					BgL_arg3229z00_1461);
																			}
																			BgL_arg3227z00_1459 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_newz00_1341, BgL_list3228z00_1460);
																		}
																		BgL_arg3188z00_1422 =
																			MAKE_PAIR(BgL_arg3226z00_1458,
																			BgL_arg3227z00_1459);
																	}
																	{	/* Object/creator.scm 472 */
																		obj_t BgL_list3190z00_1424;

																		{	/* Object/creator.scm 472 */
																			obj_t BgL_arg3191z00_1425;

																			{	/* Object/creator.scm 472 */
																				obj_t BgL_arg3192z00_1426;

																				{	/* Object/creator.scm 472 */
																					obj_t BgL_arg3193z00_1427;

																					BgL_arg3193z00_1427 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3192z00_1426 =
																						MAKE_PAIR(BgL_newz00_1341,
																						BgL_arg3193z00_1427);
																				}
																				BgL_arg3191z00_1425 =
																					MAKE_PAIR(BgL_arg3188z00_1422,
																					BgL_arg3192z00_1426);
																			}
																			BgL_list3190z00_1424 =
																				MAKE_PAIR(BgL_arg3187z00_1421,
																				BgL_arg3191z00_1425);
																		}
																		BgL_arg3185z00_1419 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg3186z00_1420,
																			BgL_list3190z00_1424);
																}}
																BgL_arg3180z00_1414 =
																	MAKE_PAIR(BgL_arg3184z00_1418,
																	BgL_arg3185z00_1419);
															}
															{	/* Object/creator.scm 471 */
																obj_t BgL_list3182z00_1416;

																{	/* Object/creator.scm 471 */
																	obj_t BgL_arg3183z00_1417;

																	BgL_arg3183z00_1417 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list3182z00_1416 =
																		MAKE_PAIR(BgL_arg3180z00_1414,
																		BgL_arg3183z00_1417);
																}
																BgL_arg3178z00_1412 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3179z00_1413, BgL_list3182z00_1416);
														}}
														BgL_arg3119z00_1353 =
															MAKE_PAIR(BgL_arg3177z00_1411,
															BgL_arg3178z00_1412);
												}}
											else
												{	/* Object/creator.scm 491 */
													{	/* Object/creator.scm 480 */
														obj_t BgL_arg3124z00_1358;

														obj_t BgL_arg3125z00_1359;

														BgL_arg3124z00_1358 = CNST_TABLE_REF(((long) 8));
														{	/* Object/creator.scm 480 */
															obj_t BgL_arg3126z00_1360;

															obj_t BgL_arg3127z00_1361;

															BgL_arg3126z00_1360 =
																MAKE_PAIR(BgL_alloczd2tidzd2_1340, BNIL);
															{	/* Object/creator.scm 481 */
																obj_t BgL_arg3131z00_1365;

																obj_t BgL_arg3132z00_1366;

																BgL_arg3131z00_1365 =
																	CNST_TABLE_REF(((long) 20));
																{	/* Object/creator.scm 481 */
																	obj_t BgL_arg3133z00_1367;

																	obj_t BgL_arg3134z00_1368;

																	obj_t BgL_arg3135z00_1369;

																	{	/* Object/creator.scm 481 */
																		obj_t BgL_arg3141z00_1375;

																		{	/* Object/creator.scm 481 */
																			obj_t BgL_arg3143z00_1377;

																			obj_t BgL_arg3144z00_1378;

																			BgL_arg3143z00_1377 =
																				BGl_makezd2typedzd2identz00zzast_identz00
																				(BgL_newz00_1341, BgL_tidz00_1338);
																			{	/* Object/creator.scm 482 */
																				obj_t BgL_arg3145z00_1379;

																				BgL_arg3145z00_1379 =
																					BGl_makezd2privatezd2sexpz00zzast_privatez00
																					(CNST_TABLE_REF(((long) 9)),
																					BgL_tidz00_1338, BNIL);
																				{	/* Object/creator.scm 481 */
																					obj_t BgL_list3147z00_1381;

																					BgL_list3147z00_1381 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3144z00_1378 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3145z00_1379,
																						BgL_list3147z00_1381);
																			}}
																			BgL_arg3141z00_1375 =
																				MAKE_PAIR(BgL_arg3143z00_1377,
																				BgL_arg3144z00_1378);
																		}
																		BgL_arg3133z00_1367 =
																			MAKE_PAIR(BgL_arg3141z00_1375, BNIL);
																	}
																	{	/* Object/creator.scm 483 */
																		obj_t BgL_arg3149z00_1383;

																		obj_t BgL_arg3150z00_1384;

																		BgL_arg3149z00_1383 =
																			CNST_TABLE_REF(((long) 32));
																		{	/* Object/creator.scm 484 */
																			obj_t BgL_arg3151z00_1385;

																			{	/* Object/creator.scm 484 */
																				obj_t BgL_arg3155z00_1389;

																				obj_t BgL_arg3156z00_1390;

																				{	/* Object/creator.scm 484 */
																					obj_t BgL_arg3157z00_1391;

																					obj_t BgL_arg3158z00_1392;

																					BgL_arg3157z00_1391 =
																						CNST_TABLE_REF(((long) 33));
																					{	/* Object/creator.scm 484 */
																						obj_t BgL_list3159z00_1393;

																						{	/* Object/creator.scm 484 */
																							obj_t BgL_arg3160z00_1394;

																							obj_t BgL_arg3161z00_1395;

																							BgL_arg3160z00_1394 =
																								CNST_TABLE_REF(((long) 34));
																							BgL_arg3161z00_1395 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3159z00_1393 =
																								MAKE_PAIR(BgL_arg3160z00_1394,
																								BgL_arg3161z00_1395);
																						}
																						BgL_arg3158z00_1392 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 35)),
																							BgL_list3159z00_1393);
																					}
																					BgL_arg3155z00_1389 =
																						MAKE_PAIR(BgL_arg3157z00_1391,
																						BgL_arg3158z00_1392);
																				}
																				{	/* Object/creator.scm 485 */
																					obj_t BgL_arg3162z00_1396;

																					{	/* Object/creator.scm 485 */
																						obj_t BgL_arg3165z00_1399;

																						obj_t BgL_arg3166z00_1400;

																						BgL_arg3165z00_1399 =
																							CNST_TABLE_REF(((long) 33));
																						{	/* Object/creator.scm 485 */
																							obj_t BgL_arg3167z00_1401;

																							obj_t BgL_arg3168z00_1402;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3263;
																								BgL_auxz00_3263 =
																									(BgL_variablez00_bglt)
																									(BgL_holderz00_64);
																								BgL_arg3167z00_1401 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3263))->
																									BgL_idz00);
																							}
																							BgL_arg3168z00_1402 =
																								(((BgL_globalz00_bglt)
																									CREF(BgL_holderz00_64))->
																								BgL_modulez00);
																							{	/* Object/creator.scm 485 */
																								obj_t BgL_list3170z00_1404;

																								{	/* Object/creator.scm 485 */
																									obj_t BgL_arg3171z00_1405;

																									BgL_arg3171z00_1405 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3170z00_1404 =
																										MAKE_PAIR
																										(BgL_arg3168z00_1402,
																										BgL_arg3171z00_1405);
																								}
																								BgL_arg3166z00_1400 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3167z00_1401,
																									BgL_list3170z00_1404);
																						}}
																						BgL_arg3162z00_1396 =
																							MAKE_PAIR(BgL_arg3165z00_1399,
																							BgL_arg3166z00_1400);
																					}
																					{	/* Object/creator.scm 484 */
																						obj_t BgL_list3164z00_1398;

																						BgL_list3164z00_1398 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3156z00_1390 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg3162z00_1396,
																							BgL_list3164z00_1398);
																				}}
																				BgL_arg3151z00_1385 =
																					MAKE_PAIR(BgL_arg3155z00_1389,
																					BgL_arg3156z00_1390);
																			}
																			{	/* Object/creator.scm 483 */
																				obj_t BgL_list3153z00_1387;

																				{	/* Object/creator.scm 483 */
																					obj_t BgL_arg3154z00_1388;

																					BgL_arg3154z00_1388 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_list3153z00_1387 =
																						MAKE_PAIR(BgL_arg3151z00_1385,
																						BgL_arg3154z00_1388);
																				}
																				BgL_arg3150z00_1384 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_newz00_1341,
																					BgL_list3153z00_1387);
																		}}
																		BgL_arg3134z00_1368 =
																			MAKE_PAIR(BgL_arg3149z00_1383,
																			BgL_arg3150z00_1384);
																	}
																	{	/* Object/creator.scm 487 */
																		obj_t BgL_arg3172z00_1406;

																		obj_t BgL_arg3173z00_1407;

																		BgL_arg3172z00_1406 =
																			CNST_TABLE_REF(((long) 36));
																		{	/* Object/creator.scm 487 */
																			obj_t BgL_list3174z00_1408;

																			{	/* Object/creator.scm 487 */
																				obj_t BgL_arg3175z00_1409;

																				BgL_arg3175z00_1409 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3174z00_1408 =
																					MAKE_PAIR(BFALSE,
																					BgL_arg3175z00_1409);
																			}
																			BgL_arg3173z00_1407 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_newz00_1341, BgL_list3174z00_1408);
																		}
																		BgL_arg3135z00_1369 =
																			MAKE_PAIR(BgL_arg3172z00_1406,
																			BgL_arg3173z00_1407);
																	}
																	{	/* Object/creator.scm 481 */
																		obj_t BgL_list3137z00_1371;

																		{	/* Object/creator.scm 481 */
																			obj_t BgL_arg3138z00_1372;

																			{	/* Object/creator.scm 481 */
																				obj_t BgL_arg3139z00_1373;

																				{	/* Object/creator.scm 481 */
																					obj_t BgL_arg3140z00_1374;

																					BgL_arg3140z00_1374 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3139z00_1373 =
																						MAKE_PAIR(BgL_newz00_1341,
																						BgL_arg3140z00_1374);
																				}
																				BgL_arg3138z00_1372 =
																					MAKE_PAIR(BgL_arg3135z00_1369,
																					BgL_arg3139z00_1373);
																			}
																			BgL_list3137z00_1371 =
																				MAKE_PAIR(BgL_arg3134z00_1368,
																				BgL_arg3138z00_1372);
																		}
																		BgL_arg3132z00_1366 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg3133z00_1367,
																			BgL_list3137z00_1371);
																}}
																BgL_arg3127z00_1361 =
																	MAKE_PAIR(BgL_arg3131z00_1365,
																	BgL_arg3132z00_1366);
															}
															{	/* Object/creator.scm 480 */
																obj_t BgL_list3129z00_1363;

																{	/* Object/creator.scm 480 */
																	obj_t BgL_arg3130z00_1364;

																	BgL_arg3130z00_1364 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list3129z00_1363 =
																		MAKE_PAIR(BgL_arg3127z00_1361,
																		BgL_arg3130z00_1364);
																}
																BgL_arg3125z00_1359 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3126z00_1360, BgL_list3129z00_1363);
														}}
														BgL_arg3119z00_1353 =
															MAKE_PAIR(BgL_arg3124z00_1358,
															BgL_arg3125z00_1359);
										}}}
										{	/* Object/creator.scm 491 */
											obj_t BgL_list3120z00_1354;

											BgL_list3120z00_1354 =
												MAKE_PAIR(BgL_srczd2defzd2_65, BNIL);
											return
												BGl_epairifyza2za2zztools_miscz00(BgL_arg3119z00_1353,
												BgL_list3120z00_1354);
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-wide-class-make! */
	obj_t BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00(obj_t
		BgL_idz00_67, BgL_tclassz00_bglt BgL_typez00_68, obj_t BgL_srczd2defzd2_69,
		obj_t BgL_importz00_70)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 499 */
			{	/* Object/creator.scm 500 */
				obj_t BgL_mkzd2heapzd2idz00_1491;

				{	/* Object/creator.scm 500 */
					obj_t BgL_arg3366z00_1623;

					{	/* Object/creator.scm 500 */
						obj_t BgL_arg3367z00_1624;

						obj_t BgL_arg3368z00_1625;

						{	/* Object/creator.scm 500 */
							obj_t BgL_symbolz00_2048;

							BgL_symbolz00_2048 = CNST_TABLE_REF(((long) 3));
							BgL_arg3367z00_1624 = SYMBOL_TO_STRING(BgL_symbolz00_2048);
						}
						BgL_arg3368z00_1625 = SYMBOL_TO_STRING(BgL_idz00_67);
						{	/* Object/creator.scm 500 */
							obj_t BgL_list3369z00_1626;

							{	/* Object/creator.scm 500 */
								obj_t BgL_arg3370z00_1627;

								BgL_arg3370z00_1627 = MAKE_PAIR(BgL_arg3368z00_1625, BNIL);
								BgL_list3369z00_1626 =
									MAKE_PAIR(BgL_arg3367z00_1624, BgL_arg3370z00_1627);
							}
							BgL_arg3366z00_1623 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list3369z00_1626);
					}}
					BgL_mkzd2heapzd2idz00_1491 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg3366z00_1623));
				}
				{	/* Object/creator.scm 500 */
					obj_t BgL_superz00_1492;

					{
						obj_t BgL_auxz00_3303;

						{	/* Object/creator.scm 501 */
							BgL_objectz00_bglt BgL_auxz00_3304;

							BgL_auxz00_3304 = (BgL_objectz00_bglt) (BgL_typez00_68);
							BgL_auxz00_3303 = BGL_OBJECT_WIDENING(BgL_auxz00_3304);
						}
						BgL_superz00_1492 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3303))->
							BgL_itszd2superzd2);
					}
					{	/* Object/creator.scm 501 */
						obj_t BgL_slotsz00_1493;

						{
							obj_t BgL_auxz00_3308;

							{	/* Object/creator.scm 502 */
								BgL_objectz00_bglt BgL_auxz00_3309;

								BgL_auxz00_3309 = (BgL_objectz00_bglt) (BgL_typez00_68);
								BgL_auxz00_3308 = BGL_OBJECT_WIDENING(BgL_auxz00_3309);
							}
							BgL_slotsz00_1493 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3308))->BgL_slotsz00);
						}
						{	/* Object/creator.scm 502 */
							obj_t BgL_sslotsz00_1494;

							{	/* Object/creator.scm 503 */
								BgL_tclassz00_bglt BgL_obj2134z00_2053;

								BgL_obj2134z00_2053 = (BgL_tclassz00_bglt) (BgL_superz00_1492);
								{
									obj_t BgL_auxz00_3314;

									{	/* Object/creator.scm 503 */
										BgL_objectz00_bglt BgL_auxz00_3315;

										BgL_auxz00_3315 =
											(BgL_objectz00_bglt) (BgL_obj2134z00_2053);
										BgL_auxz00_3314 = BGL_OBJECT_WIDENING(BgL_auxz00_3315);
									}
									BgL_sslotsz00_1494 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3314))->
										BgL_slotsz00);
							}}
							{	/* Object/creator.scm 503 */
								BgL_globalz00_bglt BgL_holderz00_1495;

								{
									obj_t BgL_auxz00_3319;

									{	/* Object/creator.scm 504 */
										BgL_objectz00_bglt BgL_auxz00_3320;

										BgL_auxz00_3320 = (BgL_objectz00_bglt) (BgL_typez00_68);
										BgL_auxz00_3319 = BGL_OBJECT_WIDENING(BgL_auxz00_3320);
									}
									BgL_holderz00_1495 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3319))->
										BgL_holderz00);
								}
								{	/* Object/creator.scm 504 */
									obj_t BgL_constrsz00_1496;

									BgL_constrsz00_1496 =
										BGl_findzd2classzd2constructorsz00zzobject_classz00
										(BgL_typez00_68);
									{	/* Object/creator.scm 505 */
										obj_t BgL_tidz00_1497;

										{
											BgL_typez00_bglt BgL_auxz00_3325;

											BgL_auxz00_3325 = (BgL_typez00_bglt) (BgL_typez00_68);
											BgL_tidz00_1497 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3325))->BgL_idz00);
										}
										{	/* Object/creator.scm 506 */
											obj_t BgL_stidz00_1498;

											{
												BgL_typez00_bglt BgL_auxz00_3328;

												BgL_auxz00_3328 =
													(BgL_typez00_bglt) (BgL_superz00_1492);
												BgL_stidz00_1498 =
													(((BgL_typez00_bglt) CREF(BgL_auxz00_3328))->
													BgL_idz00);
											}
											{	/* Object/creator.scm 507 */
												obj_t BgL_mkzd2tidzd2_1499;

												{	/* Object/creator.scm 508 */
													obj_t BgL_arg3360z00_1617;

													{	/* Object/creator.scm 508 */
														obj_t BgL_arg3361z00_1618;

														{	/* Object/creator.scm 508 */
															obj_t BgL_arg3362z00_1619;

															obj_t BgL_arg3363z00_1620;

															{	/* Object/creator.scm 508 */
																obj_t BgL_symbolz00_2057;

																BgL_symbolz00_2057 = CNST_TABLE_REF(((long) 3));
																BgL_arg3362z00_1619 =
																	SYMBOL_TO_STRING(BgL_symbolz00_2057);
															}
															BgL_arg3363z00_1620 =
																SYMBOL_TO_STRING(BgL_idz00_67);
															{	/* Object/creator.scm 508 */
																obj_t BgL_list3364z00_1621;

																{	/* Object/creator.scm 508 */
																	obj_t BgL_arg3365z00_1622;

																	BgL_arg3365z00_1622 =
																		MAKE_PAIR(BgL_arg3363z00_1620, BNIL);
																	BgL_list3364z00_1621 =
																		MAKE_PAIR(BgL_arg3362z00_1619,
																		BgL_arg3365z00_1622);
																}
																BgL_arg3361z00_1618 =
																	BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																	(BgL_list3364z00_1621);
														}}
														BgL_arg3360z00_1617 =
															string_to_symbol(BSTRING_TO_STRING
															(BgL_arg3361z00_1618));
													}
													BgL_mkzd2tidzd2_1499 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_arg3360z00_1617, BgL_tidz00_1497);
												}
												{	/* Object/creator.scm 508 */
													obj_t BgL_fzd2idszd2_1500;

													BgL_fzd2idszd2_1500 =
														BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
														(BgL_slotsz00_1493);
													{	/* Object/creator.scm 509 */
														obj_t BgL_sfzd2idszd2_1501;

														BgL_sfzd2idszd2_1501 =
															BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
															(BgL_sslotsz00_1494);
														{	/* Object/creator.scm 510 */
															obj_t BgL_fzd2tidszd2_1502;

															BgL_fzd2tidszd2_1502 =
																BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
																(BgL_fzd2idszd2_1500, BgL_slotsz00_1493);
															{	/* Object/creator.scm 511 */
																obj_t BgL_sfzd2tidszd2_1503;

																BgL_sfzd2tidszd2_1503 =
																	BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
																	(BgL_sfzd2idszd2_1501, BgL_sslotsz00_1494);
																{	/* Object/creator.scm 512 */
																	obj_t BgL_wideningz00_1504;

																	{	/* Object/creator.scm 514 */
																		obj_t BgL_arg3354z00_1611;

																		obj_t BgL_arg3355z00_1612;

																		obj_t BgL_arg3356z00_1613;

																		{
																			obj_t BgL_auxz00_3344;

																			{	/* Object/creator.scm 514 */
																				BgL_objectz00_bglt BgL_auxz00_3345;

																				BgL_auxz00_3345 =
																					(BgL_objectz00_bglt) (BgL_typez00_68);
																				BgL_auxz00_3344 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_3345);
																			}
																			BgL_arg3354z00_1611 =
																				(((BgL_tclassz00_bglt)
																					CREF(BgL_auxz00_3344))->
																				BgL_wideningz00);
																		}
																		BgL_arg3355z00_1612 =
																			CNST_TABLE_REF(((long) 5));
																		{
																			BgL_typez00_bglt BgL_auxz00_3350;

																			BgL_auxz00_3350 =
																				(BgL_typez00_bglt) (BgL_typez00_68);
																			BgL_arg3356z00_1613 =
																				(((BgL_typez00_bglt)
																					CREF(BgL_auxz00_3350))->BgL_idz00);
																		}
																		{	/* Object/creator.scm 513 */
																			obj_t BgL_list3357z00_1614;

																			{	/* Object/creator.scm 513 */
																				obj_t BgL_arg3358z00_1615;

																				{	/* Object/creator.scm 513 */
																					obj_t BgL_arg3359z00_1616;

																					BgL_arg3359z00_1616 =
																						MAKE_PAIR(BgL_arg3356z00_1613,
																						BNIL);
																					BgL_arg3358z00_1615 =
																						MAKE_PAIR(BgL_arg3355z00_1612,
																						BgL_arg3359z00_1616);
																				}
																				BgL_list3357z00_1614 =
																					MAKE_PAIR(BgL_arg3354z00_1611,
																					BgL_arg3358z00_1615);
																			}
																			BgL_wideningz00_1504 =
																				BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																				(BgL_list3357z00_1614);
																	}}
																	{	/* Object/creator.scm 513 */
																		obj_t BgL_auxz00_1505;

																		BgL_auxz00_1505 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BGl_gensymz00zz__r4_symbols_6_4z00
																			(CNST_TABLE_REF(((long) 37))));
																		{	/* Object/creator.scm 515 */
																			obj_t BgL_newz00_1506;

																			BgL_newz00_1506 =
																				BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																				(BGl_gensymz00zz__r4_symbols_6_4z00
																				(CNST_TABLE_REF(((long) 9))));
																			{	/* Object/creator.scm 516 */
																				obj_t BgL_mkzd2classzd2idz00_1507;

																				{	/* Object/creator.scm 517 */
																					obj_t BgL_arg3347z00_1604;

																					{	/* Object/creator.scm 517 */
																						obj_t BgL_arg3348z00_1605;

																						obj_t BgL_arg3349z00_1606;

																						{	/* Object/creator.scm 517 */
																							obj_t BgL_symbolz00_2062;

																							BgL_symbolz00_2062 =
																								CNST_TABLE_REF(((long) 3));
																							BgL_arg3348z00_1605 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_2062);
																						}
																						BgL_arg3349z00_1606 =
																							SYMBOL_TO_STRING
																							(BgL_stidz00_1498);
																						{	/* Object/creator.scm 517 */
																							obj_t BgL_list3350z00_1607;

																							{	/* Object/creator.scm 517 */
																								obj_t BgL_arg3351z00_1608;

																								BgL_arg3351z00_1608 =
																									MAKE_PAIR(BgL_arg3349z00_1606,
																									BNIL);
																								BgL_list3350z00_1607 =
																									MAKE_PAIR(BgL_arg3348z00_1605,
																									BgL_arg3351z00_1608);
																							}
																							BgL_arg3347z00_1604 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list3350z00_1607);
																					}}
																					BgL_mkzd2classzd2idz00_1507 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg3347z00_1604));
																				}
																				{	/* Object/creator.scm 517 */

																					{	/* Object/creator.scm 519 */
																						obj_t BgL_arg3252z00_1508;

																						{	/* Object/creator.scm 519 */
																							obj_t BgL_arg3253z00_1509;

																							{	/* Object/creator.scm 519 */
																								obj_t BgL_arg3254z00_1510;

																								BgL_arg3254z00_1510 =
																									MAKE_PAIR
																									(BgL_mkzd2tidzd2_1499,
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_sfzd2tidszd2_1503,
																										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																										(BgL_fzd2tidszd2_1502,
																											BNIL)));
																								{	/* Object/creator.scm 519 */
																									obj_t BgL_list3256z00_1512;

																									BgL_list3256z00_1512 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg3253z00_1509 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3254z00_1510,
																										BgL_list3256z00_1512);
																							}}
																							BgL_arg3252z00_1508 =
																								MAKE_PAIR(BgL_importz00_70,
																								BgL_arg3253z00_1509);
																						}
																						BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																							(BgL_arg3252z00_1508);
																					}
																					{	/* Object/creator.scm 521 */
																						obj_t BgL_arg3259z00_1515;

																						{	/* Object/creator.scm 521 */
																							obj_t BgL_arg3261z00_1517;

																							obj_t BgL_arg3262z00_1518;

																							BgL_arg3261z00_1517 =
																								CNST_TABLE_REF(((long) 15));
																							{	/* Object/creator.scm 521 */
																								obj_t BgL_arg3263z00_1519;

																								obj_t BgL_arg3264z00_1520;

																								BgL_arg3263z00_1519 =
																									MAKE_PAIR
																									(BgL_mkzd2tidzd2_1499,
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_sfzd2tidszd2_1503,
																										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																										(BgL_fzd2tidszd2_1502,
																											BNIL)));
																								{	/* Object/creator.scm 524 */
																									obj_t BgL_arg3271z00_1526;

																									obj_t BgL_arg3272z00_1527;

																									BgL_arg3271z00_1526 =
																										CNST_TABLE_REF(((long) 20));
																									{	/* Object/creator.scm 524 */
																										obj_t BgL_arg3273z00_1528;

																										obj_t BgL_arg3274z00_1529;

																										obj_t BgL_arg3275z00_1530;

																										obj_t BgL_arg3277z00_1531;

																										{	/* Object/creator.scm 524 */
																											obj_t BgL_arg3284z00_1537;

																											{	/* Object/creator.scm 524 */
																												obj_t
																													BgL_arg3286z00_1539;
																												obj_t
																													BgL_arg3287z00_1540;
																												BgL_arg3286z00_1539 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_auxz00_1505,
																													BgL_stidz00_1498);
																												{	/* Object/creator.scm 525 */
																													obj_t
																														BgL_arg3288z00_1541;
																													BgL_arg3288z00_1541 =
																														MAKE_PAIR
																														(BgL_mkzd2classzd2idz00_1507,
																														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																														(BgL_sfzd2idszd2_1501,
																															BNIL));
																													{	/* Object/creator.scm 524 */
																														obj_t
																															BgL_list3290z00_1543;
																														BgL_list3290z00_1543
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_arg3287z00_1540
																															=
																															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																															(BgL_arg3288z00_1541,
																															BgL_list3290z00_1543);
																												}}
																												BgL_arg3284z00_1537 =
																													MAKE_PAIR
																													(BgL_arg3286z00_1539,
																													BgL_arg3287z00_1540);
																											}
																											BgL_arg3273z00_1528 =
																												MAKE_PAIR
																												(BgL_arg3284z00_1537,
																												BNIL);
																										}
																										{	/* Object/creator.scm 529 */
																											obj_t BgL_arg3292z00_1545;

																											obj_t BgL_arg3293z00_1546;

																											BgL_arg3292z00_1545 =
																												CNST_TABLE_REF(((long)
																													32));
																											{	/* Object/creator.scm 531 */
																												obj_t
																													BgL_arg3294z00_1547;
																												{	/* Object/creator.scm 531 */
																													obj_t
																														BgL_arg3298z00_1551;
																													obj_t
																														BgL_arg3299z00_1552;
																													BgL_arg3298z00_1551 =
																														CNST_TABLE_REF((
																															(long) 35));
																													{	/* Object/creator.scm 531 */
																														obj_t
																															BgL_arg3300z00_1553;
																														{	/* Object/creator.scm 531 */
																															obj_t
																																BgL_arg3303z00_1556;
																															obj_t
																																BgL_arg3304z00_1557;
																															BgL_arg3303z00_1556
																																=
																																CNST_TABLE_REF((
																																	(long) 33));
																															{	/* Object/creator.scm 531 */
																																obj_t
																																	BgL_arg3305z00_1558;
																																obj_t
																																	BgL_arg3306z00_1559;
																																{
																																	BgL_variablez00_bglt
																																		BgL_auxz00_3393;
																																	BgL_auxz00_3393
																																		=
																																		(BgL_variablez00_bglt)
																																		(BgL_holderz00_1495);
																																	BgL_arg3305z00_1558
																																		=
																																		(((BgL_variablez00_bglt) CREF(BgL_auxz00_3393))->BgL_idz00);
																																}
																																BgL_arg3306z00_1559
																																	=
																																	(((BgL_globalz00_bglt) CREF(BgL_holderz00_1495))->BgL_modulez00);
																																{	/* Object/creator.scm 531 */
																																	obj_t
																																		BgL_list3309z00_1561;
																																	{	/* Object/creator.scm 531 */
																																		obj_t
																																			BgL_arg3310z00_1562;
																																		BgL_arg3310z00_1562
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_list3309z00_1561
																																			=
																																			MAKE_PAIR
																																			(BgL_arg3306z00_1559,
																																			BgL_arg3310z00_1562);
																																	}
																																	BgL_arg3304z00_1557
																																		=
																																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																		(BgL_arg3305z00_1558,
																																		BgL_list3309z00_1561);
																															}}
																															BgL_arg3300z00_1553
																																=
																																MAKE_PAIR
																																(BgL_arg3303z00_1556,
																																BgL_arg3304z00_1557);
																														}
																														{	/* Object/creator.scm 531 */
																															obj_t
																																BgL_list3302z00_1555;
																															BgL_list3302z00_1555
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg3299z00_1552
																																=
																																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																(BgL_arg3300z00_1553,
																																BgL_list3302z00_1555);
																													}}
																													BgL_arg3294z00_1547 =
																														MAKE_PAIR
																														(BgL_arg3298z00_1551,
																														BgL_arg3299z00_1552);
																												}
																												{	/* Object/creator.scm 529 */
																													obj_t
																														BgL_list3296z00_1549;
																													{	/* Object/creator.scm 529 */
																														obj_t
																															BgL_arg3297z00_1550;
																														BgL_arg3297z00_1550
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_list3296z00_1549
																															=
																															MAKE_PAIR
																															(BgL_arg3294z00_1547,
																															BgL_arg3297z00_1550);
																													}
																													BgL_arg3293z00_1546 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_auxz00_1505,
																														BgL_list3296z00_1549);
																											}}
																											BgL_arg3274z00_1529 =
																												MAKE_PAIR
																												(BgL_arg3292z00_1545,
																												BgL_arg3293z00_1546);
																										}
																										{	/* Object/creator.scm 534 */
																											obj_t BgL_arg3311z00_1563;

																											obj_t BgL_arg3314z00_1564;

																											BgL_arg3311z00_1563 =
																												CNST_TABLE_REF(((long)
																													36));
																											{	/* Object/creator.scm 534 */
																												obj_t
																													BgL_arg3315z00_1565;
																												BgL_arg3315z00_1565 =
																													MAKE_PAIR
																													(BgL_wideningz00_1504,
																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																													(BgL_fzd2idszd2_1500,
																														BNIL));
																												{	/* Object/creator.scm 534 */
																													obj_t
																														BgL_list3317z00_1567;
																													{	/* Object/creator.scm 534 */
																														obj_t
																															BgL_arg3318z00_1568;
																														BgL_arg3318z00_1568
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_list3317z00_1567
																															=
																															MAKE_PAIR
																															(BgL_arg3315z00_1565,
																															BgL_arg3318z00_1568);
																													}
																													BgL_arg3314z00_1564 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_auxz00_1505,
																														BgL_list3317z00_1567);
																											}}
																											BgL_arg3275z00_1530 =
																												MAKE_PAIR
																												(BgL_arg3311z00_1563,
																												BgL_arg3314z00_1564);
																										}
																										{	/* Object/creator.scm 536 */
																											obj_t BgL_arg3320z00_1570;

																											obj_t BgL_arg3321z00_1571;

																											BgL_arg3320z00_1570 =
																												CNST_TABLE_REF(((long)
																													20));
																											{	/* Object/creator.scm 536 */
																												obj_t
																													BgL_arg3323z00_1572;
																												obj_t
																													BgL_arg3324z00_1573;
																												{	/* Object/creator.scm 536 */
																													obj_t
																														BgL_arg3326z00_1575;
																													{	/* Object/creator.scm 536 */
																														obj_t
																															BgL_arg3328z00_1577;
																														obj_t
																															BgL_arg3329z00_1578;
																														BgL_arg3328z00_1577
																															=
																															BGl_makezd2typedzd2identz00zzast_identz00
																															(BgL_newz00_1506,
																															BgL_tidz00_1497);
																														{	/* Object/creator.scm 537 */
																															obj_t
																																BgL_arg3330z00_1579;
																															{	/* Object/creator.scm 537 */
																																obj_t
																																	BgL_list3333z00_1582;
																																BgL_list3333z00_1582
																																	=
																																	MAKE_PAIR
																																	(BgL_auxz00_1505,
																																	BNIL);
																																BgL_arg3330z00_1579
																																	=
																																	BGl_makezd2privatezd2sexpz00zzast_privatez00
																																	(CNST_TABLE_REF
																																	(((long) 38)),
																																	BgL_tidz00_1497,
																																	BgL_list3333z00_1582);
																															}
																															{	/* Object/creator.scm 536 */
																																obj_t
																																	BgL_list3332z00_1581;
																																BgL_list3332z00_1581
																																	=
																																	MAKE_PAIR
																																	(BNIL, BNIL);
																																BgL_arg3329z00_1578
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_arg3330z00_1579,
																																	BgL_list3332z00_1581);
																														}}
																														BgL_arg3326z00_1575
																															=
																															MAKE_PAIR
																															(BgL_arg3328z00_1577,
																															BgL_arg3329z00_1578);
																													}
																													BgL_arg3323z00_1572 =
																														MAKE_PAIR
																														(BgL_arg3326z00_1575,
																														BNIL);
																												}
																												{	/* Object/creator.scm 540 */
																													obj_t
																														BgL_arg3334z00_1583;
																													obj_t
																														BgL_arg3335z00_1584;
																													{	/* Object/creator.scm 540 */
																														bool_t
																															BgL_testz00_3424;
																														if (PAIRP
																															(BgL_constrsz00_1496))
																															{	/* Object/creator.scm 540 */
																																if (
																																	(BgL_wideningz00_1504
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				6))))
																																	{	/* Object/creator.scm 541 */
																																		BgL_testz00_3424
																																			=
																																			((bool_t)
																																			0);
																																	}
																																else
																																	{	/* Object/creator.scm 541 */
																																		BgL_testz00_3424
																																			=
																																			((bool_t)
																																			1);
																																	}
																															}
																														else
																															{	/* Object/creator.scm 540 */
																																BgL_testz00_3424
																																	=
																																	((bool_t) 0);
																															}
																														if (BgL_testz00_3424)
																															{	/* Object/creator.scm 540 */
																																if (NULLP
																																	(BgL_constrsz00_1496))
																																	{	/* Object/creator.scm 542 */
																																		BgL_arg3334z00_1583
																																			= BNIL;
																																	}
																																else
																																	{	/* Object/creator.scm 542 */
																																		obj_t
																																			BgL_head2483z00_1588;
																																		BgL_head2483z00_1588
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		{
																																			obj_t
																																				BgL_l2481z00_1590;
																																			obj_t
																																				BgL_tail2484z00_1591;
																																			BgL_l2481z00_1590
																																				=
																																				BgL_constrsz00_1496;
																																			BgL_tail2484z00_1591
																																				=
																																				BgL_head2483z00_1588;
																																		BgL_zc3anonymousza33338ze3z83_1592:
																																			if (NULLP
																																				(BgL_l2481z00_1590))
																																				{	/* Object/creator.scm 542 */
																																					BgL_arg3334z00_1583
																																						=
																																						CDR
																																						(BgL_head2483z00_1588);
																																				}
																																			else
																																				{	/* Object/creator.scm 542 */
																																					obj_t
																																						BgL_newtail2485z00_1594;
																																					{	/* Object/creator.scm 542 */
																																						obj_t
																																							BgL_arg3341z00_1596;
																																						{	/* Object/creator.scm 542 */
																																							obj_t
																																								BgL_constrz00_1598;
																																							BgL_constrz00_1598
																																								=
																																								CAR
																																								(BgL_l2481z00_1590);
																																							{	/* Object/creator.scm 542 */
																																								obj_t
																																									BgL_arg3343z00_1599;
																																								{	/* Object/creator.scm 542 */
																																									obj_t
																																										BgL_list3344z00_1600;
																																									BgL_list3344z00_1600
																																										=
																																										MAKE_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_arg3343z00_1599
																																										=
																																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																										(BgL_newz00_1506,
																																										BgL_list3344z00_1600);
																																								}
																																								BgL_arg3341z00_1596
																																									=
																																									MAKE_PAIR
																																									(BgL_constrz00_1598,
																																									BgL_arg3343z00_1599);
																																							}
																																						}
																																						BgL_newtail2485z00_1594
																																							=
																																							MAKE_PAIR
																																							(BgL_arg3341z00_1596,
																																							BNIL);
																																					}
																																					SET_CDR
																																						(BgL_tail2484z00_1591,
																																						BgL_newtail2485z00_1594);
																																					{
																																						obj_t
																																							BgL_tail2484z00_3444;
																																						obj_t
																																							BgL_l2481z00_3442;
																																						BgL_l2481z00_3442
																																							=
																																							CDR
																																							(BgL_l2481z00_1590);
																																						BgL_tail2484z00_3444
																																							=
																																							BgL_newtail2485z00_1594;
																																						BgL_tail2484z00_1591
																																							=
																																							BgL_tail2484z00_3444;
																																						BgL_l2481z00_1590
																																							=
																																							BgL_l2481z00_3442;
																																						goto
																																							BgL_zc3anonymousza33338ze3z83_1592;
																																					}
																																				}
																																		}
																																	}
																															}
																														else
																															{	/* Object/creator.scm 540 */
																																BgL_arg3334z00_1583
																																	= BNIL;
																															}
																													}
																													BgL_arg3335z00_1584 =
																														MAKE_PAIR
																														(BgL_newz00_1506,
																														BNIL);
																													BgL_arg3324z00_1573 =
																														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg3334z00_1583,
																														BgL_arg3335z00_1584);
																												}
																												{	/* Object/creator.scm 536 */
																													obj_t
																														BgL_list3325z00_1574;
																													BgL_list3325z00_1574 =
																														MAKE_PAIR
																														(BgL_arg3324z00_1573,
																														BNIL);
																													BgL_arg3321z00_1571 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg3323z00_1572,
																														BgL_list3325z00_1574);
																												}
																											}
																											BgL_arg3277z00_1531 =
																												MAKE_PAIR
																												(BgL_arg3320z00_1570,
																												BgL_arg3321z00_1571);
																										}
																										{	/* Object/creator.scm 524 */
																											obj_t
																												BgL_list3279z00_1533;
																											{	/* Object/creator.scm 524 */
																												obj_t
																													BgL_arg3280z00_1534;
																												{	/* Object/creator.scm 524 */
																													obj_t
																														BgL_arg3281z00_1535;
																													{	/* Object/creator.scm 524 */
																														obj_t
																															BgL_arg3283z00_1536;
																														BgL_arg3283z00_1536
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_arg3281z00_1535
																															=
																															MAKE_PAIR
																															(BgL_arg3277z00_1531,
																															BgL_arg3283z00_1536);
																													}
																													BgL_arg3280z00_1534 =
																														MAKE_PAIR
																														(BgL_arg3275z00_1530,
																														BgL_arg3281z00_1535);
																												}
																												BgL_list3279z00_1533 =
																													MAKE_PAIR
																													(BgL_arg3274z00_1529,
																													BgL_arg3280z00_1534);
																											}
																											BgL_arg3272z00_1527 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg3273z00_1528,
																												BgL_list3279z00_1533);
																										}
																									}
																									BgL_arg3264z00_1520 =
																										MAKE_PAIR
																										(BgL_arg3271z00_1526,
																										BgL_arg3272z00_1527);
																								}
																								{	/* Object/creator.scm 521 */
																									obj_t BgL_list3267z00_1522;

																									{	/* Object/creator.scm 521 */
																										obj_t BgL_arg3268z00_1523;

																										BgL_arg3268z00_1523 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list3267z00_1522 =
																											MAKE_PAIR
																											(BgL_arg3264z00_1520,
																											BgL_arg3268z00_1523);
																									}
																									BgL_arg3262z00_1518 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3263z00_1519,
																										BgL_list3267z00_1522);
																								}
																							}
																							BgL_arg3259z00_1515 =
																								MAKE_PAIR(BgL_arg3261z00_1517,
																								BgL_arg3262z00_1518);
																						}
																						{	/* Object/creator.scm 521 */
																							obj_t BgL_list3260z00_1516;

																							BgL_list3260z00_1516 =
																								MAKE_PAIR(BgL_srczd2defzd2_69,
																								BNIL);
																							return
																								BGl_epairifyza2za2zztools_miscz00
																								(BgL_arg3259z00_1515,
																								BgL_list3260z00_1516);
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 195902195),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_structz00(((long) 112894054),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 17869975),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long) 405988581),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_nilz00(((long) 169673641),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_impusez00(((long) 468691571),
				BSTRING_TO_STRING(BGl_string3401z00zzobject_creatorz00));
		}
	}

#ifdef __cplusplus
}
#endif
