/*===========================================================================*/
/*   (Reduce/ftypec.scm)                                                     */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Reduce/ftypec.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_nodezd2typecz12zc0zzreduce_flowzd2typeczd2(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static long BGl_za2typezd2checkszd2removedza2z00zzreduce_flowzd2typeczd2;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzreduce_flowzd2typeczd2();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t
		BGl__nodezd2typecz12zd2default3471z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl__nodezd2typecz12zc0zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2select3490z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzreduce_flowzd2typeczd2(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzreduce_flowzd2typeczd2();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_nodezd2typecz12zd2cast3482z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2setzd2exzd2i3497z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2sequence3474z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t
		BGl_nodezd2typecz12zd2boxzd2setz123503zd2zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t
		BGl_nodezd2typecz12zd2funcall3478z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2conditio3486z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t BGl_nodezd2typecz12zd2setq3484z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t
		BGl__reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2(obj_t,
		obj_t);
	static obj_t BGl_methodzd2initzd2zzreduce_flowzd2typeczd2();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t
		BGl_nodezd2typecz12zd2jumpzd2exzd23499z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2(obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzreduce_flowzd2typeczd2 =
		BUNSPEC;
	static long BGl_za2typezd2checkszd2remainingza2z00zzreduce_flowzd2typeczd2;
	static obj_t BGl_genericzd2initzd2zzreduce_flowzd2typeczd2();
	static obj_t
		BGl_nodezd2typecz12zd2boxzd2ref3505zc0zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_nodezd2typecz12zd2fail3488z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2makezd2box3501zc0zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzreduce_flowzd2typeczd2();
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_nodezd2typecz12zd2app3507z12zzreduce_flowzd2typeczd2(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2letzd2fun3492zc0zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2letzd2var3495zc0zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_nodezd2typecz12zd2extern3480z12zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzreduce_flowzd2typeczd2();
	static obj_t
		BGl_nodezd2typecz12zd2appzd2ly3476zc0zzreduce_flowzd2typeczd2(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[2];


	   
		 
		DEFINE_STRING(BGl_string3802z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3802za700za7za7r3827za7, "      flow type check        ", 29);
	      DEFINE_STRING(BGl_string3803z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3803za700za7za7r3828za7, ")\n", 2);
	      DEFINE_STRING(BGl_string3804z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3804za700za7za7r3829za7, ") (remaining : ", 15);
	      DEFINE_STRING(BGl_string3805z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3805za700za7za7r3830za7, "(removed : ", 11);
	      DEFINE_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3823za700za7za7r3831za7, "reduce_flow-typec", 17);
	      DEFINE_STRING(BGl_string3824z00zzreduce_flowzd2typeczd2,
		BgL_bgl_string3824za700za7za7r3832za7, "read done ", 10);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
		BgL_bgl__nodeza7d2typecza7123833z00,
		BGl__nodezd2typecz12zc0zzreduce_flowzd2typeczd2, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_nodezd2typecz12zd2default3471zd2envzc0zzreduce_flowzd2typeczd2,
		BgL_bgl__nodeza7d2typecza7123834z00,
		BGl__nodezd2typecz12zd2default3471z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3806z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73835za7,
		BGl_nodezd2typecz12zd2sequence3474z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3807z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73836za7,
		BGl_nodezd2typecz12zd2appzd2ly3476zc0zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3808z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73837za7,
		BGl_nodezd2typecz12zd2funcall3478z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3810z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73838za7,
		BGl_nodezd2typecz12zd2cast3482z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3809z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73839za7,
		BGl_nodezd2typecz12zd2extern3480z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3811z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73840za7,
		BGl_nodezd2typecz12zd2setq3484z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3812z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73841za7,
		BGl_nodezd2typecz12zd2conditio3486z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3813z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73842za7,
		BGl_nodezd2typecz12zd2fail3488z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3814z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73843za7,
		BGl_nodezd2typecz12zd2select3490z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3815z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73844za7,
		BGl_nodezd2typecz12zd2letzd2fun3492zc0zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3816z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73845za7,
		BGl_nodezd2typecz12zd2letzd2var3495zc0zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3817z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73846za7,
		BGl_nodezd2typecz12zd2setzd2exzd2i3497z12zzreduce_flowzd2typeczd2, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3818z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73847za7,
		BGl_nodezd2typecz12zd2jumpzd2exzd23499z12zzreduce_flowzd2typeczd2, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3820z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73848za7,
		BGl_nodezd2typecz12zd2boxzd2setz123503zd2zzreduce_flowzd2typeczd2, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3819z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73849za7,
		BGl_nodezd2typecz12zd2makezd2box3501zc0zzreduce_flowzd2typeczd2, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3821z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73850za7,
		BGl_nodezd2typecz12zd2boxzd2ref3505zc0zzreduce_flowzd2typeczd2, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3822z00zzreduce_flowzd2typeczd2,
		BgL_bgl_nodeza7d2typecza712za73851za7,
		BGl_nodezd2typecz12zd2app3507z12zzreduce_flowzd2typeczd2, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_reducezd2flowzd2typezd2checkz12zd2envz12zzreduce_flowzd2typeczd2,
		BgL_bgl__reduceza7d2flowza7d3852z00,
		BGl__reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2, 0L,
		BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzreduce_flowzd2typeczd2(long
		BgL_checksumz00_2695, char *BgL_fromz00_2696)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzreduce_flowzd2typeczd2))
				{
					BGl_requirezd2initializa7ationz75zzreduce_flowzd2typeczd2 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzreduce_flowzd2typeczd2();
					BGl_cnstzd2initzd2zzreduce_flowzd2typeczd2();
					BGl_importedzd2moduleszd2initz00zzreduce_flowzd2typeczd2();
					BGl_genericzd2initzd2zzreduce_flowzd2typeczd2();
					BGl_methodzd2initzd2zzreduce_flowzd2typeczd2();
					BGl_toplevelzd2initzd2zzreduce_flowzd2typeczd2();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"reduce_flow-typec");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"reduce_flow-typec");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"reduce_flow-typec");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			{	/* Reduce/ftypec.scm 15 */
				obj_t BgL_cportz00_2685;

				BgL_cportz00_2685 =
					bgl_open_input_string(BGl_string3824z00zzreduce_flowzd2typeczd2,
					(int) (((long) 0)));
				{
					long BgL_iz00_2686;

					BgL_iz00_2686 = ((long) 1);
				BgL_loopz00_2687:
					if ((BgL_iz00_2686 == ((long) -1)))
						{	/* Reduce/ftypec.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Reduce/ftypec.scm 15 */
							{	/* Reduce/ftypec.scm 15 */
								obj_t BgL_arg3826z00_2689;

								{	/* Reduce/ftypec.scm 15 */

									{	/* Reduce/ftypec.scm 15 */
										obj_t BgL_locationz00_2691;

										BgL_locationz00_2691 = BBOOL(((bool_t) 0));
										{	/* Reduce/ftypec.scm 15 */

											BgL_arg3826z00_2689 =
												BGl_readz00zz__readerz00(BgL_cportz00_2685,
												BgL_locationz00_2691);
										}
									}
								}
								{	/* Reduce/ftypec.scm 15 */
									int BgL_auxz00_2715;

									BgL_auxz00_2715 = (int) (BgL_iz00_2686);
									CNST_TABLE_SET(BgL_auxz00_2715, BgL_arg3826z00_2689);
							}}
							{	/* Reduce/ftypec.scm 15 */
								int BgL_auxz00_2692;

								BgL_auxz00_2692 = (int) ((BgL_iz00_2686 - ((long) 1)));
								{
									long BgL_iz00_2720;

									BgL_iz00_2720 = (long) (BgL_auxz00_2692);
									BgL_iz00_2686 = BgL_iz00_2720;
									goto BgL_loopz00_2687;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			BGl_za2typezd2checkszd2remainingza2z00zzreduce_flowzd2typeczd2 =
				((long) 0);
			BGl_za2typezd2checkszd2removedza2z00zzreduce_flowzd2typeczd2 = ((long) 0);
			return BUNSPEC;
		}
	}



/* reduce-flow-type-check! */
	BGL_EXPORTED_DEF obj_t
		BGl_reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 54 */
			{	/* Reduce/ftypec.scm 55 */
				obj_t BgL_list3508z00_832;

				BgL_list3508z00_832 =
					MAKE_PAIR(BGl_string3802z00zzreduce_flowzd2typeczd2, BNIL);
				BGl_verbosez00zztools_speekz00(BINT(((long) 2)), BgL_list3508z00_832);
			}
			{
				obj_t BgL_l3460z00_834;

				BgL_l3460z00_834 = BgL_globalsz00_1;
			BgL_zc3anonymousza33509ze3z83_835:
				if (PAIRP(BgL_l3460z00_834))
					{	/* Reduce/ftypec.scm 56 */
						{	/* Reduce/ftypec.scm 57 */
							obj_t BgL_globalz00_837;

							BgL_globalz00_837 = CAR(BgL_l3460z00_834);
							{	/* Reduce/ftypec.scm 57 */
								BgL_valuez00_bglt BgL_funz00_838;

								{
									BgL_variablez00_bglt BgL_auxz00_2728;

									BgL_auxz00_2728 = (BgL_variablez00_bglt) (BgL_globalz00_837);
									BgL_funz00_838 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2728))->
										BgL_valuez00);
								}
								{	/* Reduce/ftypec.scm 57 */
									obj_t BgL_nodez00_839;

									{
										BgL_sfunz00_bglt BgL_auxz00_2731;

										BgL_auxz00_2731 = (BgL_sfunz00_bglt) (BgL_funz00_838);
										BgL_nodez00_839 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2731))->BgL_bodyz00);
									}
									{	/* Reduce/ftypec.scm 58 */

										{	/* Reduce/ftypec.scm 59 */
											BgL_nodez00_bglt BgL_arg3511z00_840;

											{	/* Reduce/ftypec.scm 59 */
												BgL_nodez00_bglt BgL_res3706z00_1557;

												{	/* Reduce/ftypec.scm 59 */
													BgL_nodez00_bglt BgL_nodez00_1530;

													BgL_nodez00_1530 =
														(BgL_nodez00_bglt) (BgL_nodez00_839);
													{	/* Reduce/ftypec.scm 59 */
														obj_t BgL_method3472z00_1532;

														{	/* Reduce/ftypec.scm 59 */
															BgL_objectz00_bglt BgL_objz00_1533;

															BgL_objz00_1533 =
																(BgL_objectz00_bglt) (BgL_nodez00_1530);
															{	/* Reduce/ftypec.scm 59 */
																long BgL_objzd2classzd2numz00_1534;

																BgL_objzd2classzd2numz00_1534 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1533);
																{	/* Reduce/ftypec.scm 59 */
																	obj_t BgL_arg2551z00_1535;

																	BgL_arg2551z00_1535 =
																		PROCEDURE_REF
																		(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																		(int) (((long) 1)));
																	{	/* Reduce/ftypec.scm 59 */
																		obj_t BgL_arrayz00_1537;

																		int BgL_offsetz00_1538;

																		BgL_arrayz00_1537 = BgL_arg2551z00_1535;
																		BgL_offsetz00_1538 =
																			(int) (BgL_objzd2classzd2numz00_1534);
																		{	/* Reduce/ftypec.scm 59 */
																			long BgL_offsetz00_1539;

																			BgL_offsetz00_1539 =
																				(
																				(long) (BgL_offsetz00_1538) -
																				OBJECT_TYPE);
																			{	/* Reduce/ftypec.scm 59 */
																				long BgL_modz00_1540;

																				{	/* Reduce/ftypec.scm 59 */
																					int BgL_arg2553z00_1541;

																					BgL_arg2553z00_1541 =
																						(int) (((long) 8));
																					{	/* Reduce/ftypec.scm 59 */
																						long BgL_auxz00_2743;

																						BgL_auxz00_2743 =
																							(long) (BgL_arg2553z00_1541);
																						BgL_modz00_1540 =
																							(BgL_offsetz00_1539 /
																							BgL_auxz00_2743);
																				}}
																				{	/* Reduce/ftypec.scm 59 */
																					long BgL_restz00_1542;

																					{	/* Reduce/ftypec.scm 59 */
																						int BgL_arg2552z00_1543;

																						BgL_arg2552z00_1543 =
																							(int) (((long) 8));
																						{	/* Reduce/ftypec.scm 59 */
																							long BgL_auxz00_2747;

																							BgL_auxz00_2747 =
																								(long) (BgL_arg2552z00_1543);
																							BgL_restz00_1542 =
																								(BgL_offsetz00_1539 %
																								BgL_auxz00_2747);
																					}}
																					{	/* Reduce/ftypec.scm 59 */

																						BgL_method3472z00_1532 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1537,
																								(int) (BgL_modz00_1540)),
																							(int) (BgL_restz00_1542));
														}}}}}}}}
														BgL_res3706z00_1557 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3472z00_1532) (BgL_method3472z00_1532,
																(obj_t) (BgL_nodez00_1530), BNIL, BEOA));
												}}
												BgL_arg3511z00_840 = BgL_res3706z00_1557;
											}
											{
												obj_t BgL_auxz00_2760;

												BgL_sfunz00_bglt BgL_auxz00_2758;

												BgL_auxz00_2760 = (obj_t) (BgL_arg3511z00_840);
												BgL_auxz00_2758 = (BgL_sfunz00_bglt) (BgL_funz00_838);
												((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2758))->
														BgL_bodyz00) = ((obj_t) BgL_auxz00_2760), BUNSPEC);
										}} BUNSPEC;
						}}}}
						{
							obj_t BgL_l3460z00_2763;

							BgL_l3460z00_2763 = CDR(BgL_l3460z00_834);
							BgL_l3460z00_834 = BgL_l3460z00_2763;
							goto BgL_zc3anonymousza33509ze3z83_835;
						}
					}
				else
					{	/* Reduce/ftypec.scm 56 */
						((bool_t) 1);
					}
			}
			{	/* Reduce/ftypec.scm 62 */
				obj_t BgL_list3513z00_843;

				{	/* Reduce/ftypec.scm 62 */
					obj_t BgL_arg3515z00_845;

					{	/* Reduce/ftypec.scm 62 */
						obj_t BgL_arg3516z00_846;

						{	/* Reduce/ftypec.scm 62 */
							obj_t BgL_arg3518z00_848;

							{	/* Reduce/ftypec.scm 62 */
								obj_t BgL_arg3519z00_849;

								BgL_arg3519z00_849 =
									MAKE_PAIR(BGl_string3803z00zzreduce_flowzd2typeczd2, BNIL);
								BgL_arg3518z00_848 =
									MAKE_PAIR(BINT
									(BGl_za2typezd2checkszd2remainingza2z00zzreduce_flowzd2typeczd2),
									BgL_arg3519z00_849);
							}
							BgL_arg3516z00_846 =
								MAKE_PAIR(BGl_string3804z00zzreduce_flowzd2typeczd2,
								BgL_arg3518z00_848);
						}
						BgL_arg3515z00_845 =
							MAKE_PAIR(BINT
							(BGl_za2typezd2checkszd2removedza2z00zzreduce_flowzd2typeczd2),
							BgL_arg3516z00_846);
					}
					BgL_list3513z00_843 =
						MAKE_PAIR(BGl_string3805z00zzreduce_flowzd2typeczd2,
						BgL_arg3515z00_845);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 2)), BgL_list3513z00_843);
			}
			return BgL_globalsz00_1;
		}
	}



/* _reduce-flow-type-check! */
	obj_t BGl__reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2609, obj_t BgL_globalsz00_2610)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 54 */
			return
				BGl_reducezd2flowzd2typezd2checkz12zc0zzreduce_flowzd2typeczd2
				(BgL_globalsz00_2610);
		}
	}



/* node-typec*! */
	obj_t BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2(obj_t
		BgL_nodeza2za2_38, obj_t BgL_stackz00_39)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 285 */
			{
				obj_t BgL_nodeza2za2_851;

				BgL_nodeza2za2_851 = BgL_nodeza2za2_38;
			BgL_zc3anonymousza33520ze3z83_852:
				if (NULLP(BgL_nodeza2za2_851))
					{	/* Reduce/ftypec.scm 287 */
						return CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Reduce/ftypec.scm 287 */
						{	/* Reduce/ftypec.scm 290 */
							BgL_nodez00_bglt BgL_arg3522z00_854;

							{	/* Reduce/ftypec.scm 290 */
								obj_t BgL_arg3523z00_855;

								BgL_arg3523z00_855 = CAR(BgL_nodeza2za2_851);
								{	/* Reduce/ftypec.scm 290 */
									BgL_nodez00_bglt BgL_res3709z00_1590;

									{	/* Reduce/ftypec.scm 290 */
										BgL_nodez00_bglt BgL_nodez00_1563;

										BgL_nodez00_1563 = (BgL_nodez00_bglt) (BgL_arg3523z00_855);
										{	/* Reduce/ftypec.scm 290 */
											obj_t BgL_method3472z00_1565;

											{	/* Reduce/ftypec.scm 290 */
												BgL_objectz00_bglt BgL_objz00_1566;

												BgL_objz00_1566 =
													(BgL_objectz00_bglt) (BgL_nodez00_1563);
												{	/* Reduce/ftypec.scm 290 */
													long BgL_objzd2classzd2numz00_1567;

													BgL_objzd2classzd2numz00_1567 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1566);
													{	/* Reduce/ftypec.scm 290 */
														obj_t BgL_arg2551z00_1568;

														BgL_arg2551z00_1568 =
															PROCEDURE_REF
															(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
															(int) (((long) 1)));
														{	/* Reduce/ftypec.scm 290 */
															obj_t BgL_arrayz00_1570;

															int BgL_offsetz00_1571;

															BgL_arrayz00_1570 = BgL_arg2551z00_1568;
															BgL_offsetz00_1571 =
																(int) (BgL_objzd2classzd2numz00_1567);
															{	/* Reduce/ftypec.scm 290 */
																long BgL_offsetz00_1572;

																BgL_offsetz00_1572 =
																	((long) (BgL_offsetz00_1571) - OBJECT_TYPE);
																{	/* Reduce/ftypec.scm 290 */
																	long BgL_modz00_1573;

																	{	/* Reduce/ftypec.scm 290 */
																		int BgL_arg2553z00_1574;

																		BgL_arg2553z00_1574 = (int) (((long) 8));
																		{	/* Reduce/ftypec.scm 290 */
																			long BgL_auxz00_2788;

																			BgL_auxz00_2788 =
																				(long) (BgL_arg2553z00_1574);
																			BgL_modz00_1573 =
																				(BgL_offsetz00_1572 / BgL_auxz00_2788);
																	}}
																	{	/* Reduce/ftypec.scm 290 */
																		long BgL_restz00_1575;

																		{	/* Reduce/ftypec.scm 290 */
																			int BgL_arg2552z00_1576;

																			BgL_arg2552z00_1576 = (int) (((long) 8));
																			{	/* Reduce/ftypec.scm 290 */
																				long BgL_auxz00_2792;

																				BgL_auxz00_2792 =
																					(long) (BgL_arg2552z00_1576);
																				BgL_restz00_1575 =
																					(BgL_offsetz00_1572 %
																					BgL_auxz00_2792);
																		}}
																		{	/* Reduce/ftypec.scm 290 */

																			BgL_method3472z00_1565 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1570,
																					(int) (BgL_modz00_1573)),
																				(int) (BgL_restz00_1575));
											}}}}}}}}
											BgL_res3709z00_1590 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3472z00_1565) (BgL_method3472z00_1565,
													(obj_t) (BgL_nodez00_1563), BgL_stackz00_39, BEOA));
									}}
									BgL_arg3522z00_854 = BgL_res3709z00_1590;
							}}
							{	/* Reduce/ftypec.scm 290 */
								obj_t BgL_auxz00_2803;

								BgL_auxz00_2803 = (obj_t) (BgL_arg3522z00_854);
								SET_CAR(BgL_nodeza2za2_851, BgL_auxz00_2803);
						}}
						{
							obj_t BgL_nodeza2za2_2806;

							BgL_nodeza2za2_2806 = CDR(BgL_nodeza2za2_851);
							BgL_nodeza2za2_851 = BgL_nodeza2za2_2806;
							goto BgL_zc3anonymousza33520ze3z83_852;
						}
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_nodezd2typecz12zd2default3471zd2envzc0zzreduce_flowzd2typeczd2);
		}
	}



/* node-typec! */
	BgL_nodez00_bglt
		BGl_nodezd2typecz12zc0zzreduce_flowzd2typeczd2(BgL_nodez00_bglt
		BgL_nodez00_2, obj_t BgL_stackz00_3)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 76 */
			{	/* Reduce/ftypec.scm 76 */
				obj_t BgL_method3472z00_1594;

				{	/* Reduce/ftypec.scm 76 */
					BgL_objectz00_bglt BgL_objz00_1595;

					BgL_objz00_1595 = (BgL_objectz00_bglt) (BgL_nodez00_2);
					{	/* Reduce/ftypec.scm 76 */
						long BgL_objzd2classzd2numz00_1596;

						BgL_objzd2classzd2numz00_1596 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1595);
						{	/* Reduce/ftypec.scm 76 */
							obj_t BgL_arg2551z00_1597;

							BgL_arg2551z00_1597 =
								PROCEDURE_REF
								(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
								(int) (((long) 1)));
							{	/* Reduce/ftypec.scm 76 */
								obj_t BgL_arrayz00_1599;

								int BgL_offsetz00_1600;

								BgL_arrayz00_1599 = BgL_arg2551z00_1597;
								BgL_offsetz00_1600 = (int) (BgL_objzd2classzd2numz00_1596);
								{	/* Reduce/ftypec.scm 76 */
									long BgL_offsetz00_1601;

									BgL_offsetz00_1601 =
										((long) (BgL_offsetz00_1600) - OBJECT_TYPE);
									{	/* Reduce/ftypec.scm 76 */
										long BgL_modz00_1602;

										{	/* Reduce/ftypec.scm 76 */
											int BgL_arg2553z00_1603;

											BgL_arg2553z00_1603 = (int) (((long) 8));
											{	/* Reduce/ftypec.scm 76 */
												long BgL_auxz00_2817;

												BgL_auxz00_2817 = (long) (BgL_arg2553z00_1603);
												BgL_modz00_1602 =
													(BgL_offsetz00_1601 / BgL_auxz00_2817);
										}}
										{	/* Reduce/ftypec.scm 76 */
											long BgL_restz00_1604;

											{	/* Reduce/ftypec.scm 76 */
												int BgL_arg2552z00_1605;

												BgL_arg2552z00_1605 = (int) (((long) 8));
												{	/* Reduce/ftypec.scm 76 */
													long BgL_auxz00_2821;

													BgL_auxz00_2821 = (long) (BgL_arg2552z00_1605);
													BgL_restz00_1604 =
														(BgL_offsetz00_1601 % BgL_auxz00_2821);
											}}
											{	/* Reduce/ftypec.scm 76 */

												BgL_method3472z00_1594 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1599,
														(int) (BgL_modz00_1602)), (int) (BgL_restz00_1604));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1594)
					(BgL_method3472z00_1594, (obj_t) (BgL_nodez00_2), BgL_stackz00_3,
						BEOA));
			}
		}
	}



/* _node-typec! */
	obj_t BGl__nodezd2typecz12zc0zzreduce_flowzd2typeczd2(obj_t BgL_envz00_2611,
		obj_t BgL_nodez00_2612, obj_t BgL_stackz00_2613)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 76 */
			return
				(obj_t) (BGl_nodezd2typecz12zc0zzreduce_flowzd2typeczd2(
					(BgL_nodez00_bglt) (BgL_nodez00_2612), BgL_stackz00_2613));
		}
	}



/* _node-typec!-default3471 */
	obj_t BGl__nodezd2typecz12zd2default3471z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2614, obj_t BgL_nodez00_2615, obj_t BgL_stackz00_2616)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_2615));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_sequencez00zzast_nodez00, BGl_proc3806z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3807z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_funcallz00zzast_nodez00, BGl_proc3808z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_externz00zzast_nodez00, BGl_proc3809z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_castz00zzast_nodez00, BGl_proc3810z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_setqz00zzast_nodez00, BGl_proc3811z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_conditionalz00zzast_nodez00,
				BGl_proc3812z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_failz00zzast_nodez00, BGl_proc3813z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_selectz00zzast_nodez00, BGl_proc3814z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3815z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3816z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3817z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3818z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3819z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3820z00zzreduce_flowzd2typeczd2);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3821z00zzreduce_flowzd2typeczd2);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
				BGl_appz00zzast_nodez00, BGl_proc3822z00zzreduce_flowzd2typeczd2);
		}
	}



/* node-typec!-app3507 */
	obj_t BGl_nodezd2typecz12zd2app3507z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2634, obj_t BgL_nodez00_2635, obj_t BgL_stackz00_2636)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 301 */
			{
				BgL_appz00_bglt BgL_nodez00_1518;

				obj_t BgL_stackz00_1519;

				{	/* Reduce/ftypec.scm 302 */
					BgL_appz00_bglt BgL_auxz00_2854;

					BgL_nodez00_1518 = (BgL_appz00_bglt) (BgL_nodez00_2635);
					BgL_stackz00_1519 = BgL_stackz00_2636;
					{	/* Reduce/ftypec.scm 302 */
						obj_t BgL_arg3702z00_2607;

						BgL_arg3702z00_2607 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1518))->BgL_argsz00);
						BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2
							(BgL_arg3702z00_2607, BgL_stackz00_1519);
					}
					BgL_auxz00_2854 = BgL_nodez00_1518;
					return (obj_t) (BgL_auxz00_2854);
				}
			}
		}
	}



/* node-typec!-box-ref3505 */
	obj_t BGl_nodezd2typecz12zd2boxzd2ref3505zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2637, obj_t BgL_nodez00_2638, obj_t BgL_stackz00_2639)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 277 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1509;

				obj_t BgL_stackz00_1510;

				{	/* Reduce/ftypec.scm 278 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_2859;

					BgL_nodez00_1509 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2638);
					BgL_stackz00_1510 = BgL_stackz00_2639;
					{	/* Reduce/ftypec.scm 278 */
						BgL_nodez00_bglt BgL_arg3699z00_2573;

						{	/* Reduce/ftypec.scm 278 */
							BgL_varz00_bglt BgL_arg3700z00_2574;

							BgL_arg3700z00_2574 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1509))->BgL_varz00);
							{	/* Reduce/ftypec.scm 278 */
								BgL_nodez00_bglt BgL_res3801z00_2603;

								{	/* Reduce/ftypec.scm 278 */
									BgL_nodez00_bglt BgL_nodez00_2576;

									BgL_nodez00_2576 = (BgL_nodez00_bglt) (BgL_arg3700z00_2574);
									{	/* Reduce/ftypec.scm 278 */
										obj_t BgL_method3472z00_2578;

										{	/* Reduce/ftypec.scm 278 */
											BgL_objectz00_bglt BgL_objz00_2579;

											BgL_objz00_2579 = (BgL_objectz00_bglt) (BgL_nodez00_2576);
											{	/* Reduce/ftypec.scm 278 */
												long BgL_objzd2classzd2numz00_2580;

												BgL_objzd2classzd2numz00_2580 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2579);
												{	/* Reduce/ftypec.scm 278 */
													obj_t BgL_arg2551z00_2581;

													BgL_arg2551z00_2581 =
														PROCEDURE_REF
														(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
														(int) (((long) 1)));
													{	/* Reduce/ftypec.scm 278 */
														obj_t BgL_arrayz00_2583;

														int BgL_offsetz00_2584;

														BgL_arrayz00_2583 = BgL_arg2551z00_2581;
														BgL_offsetz00_2584 =
															(int) (BgL_objzd2classzd2numz00_2580);
														{	/* Reduce/ftypec.scm 278 */
															long BgL_offsetz00_2585;

															BgL_offsetz00_2585 =
																((long) (BgL_offsetz00_2584) - OBJECT_TYPE);
															{	/* Reduce/ftypec.scm 278 */
																long BgL_modz00_2586;

																{	/* Reduce/ftypec.scm 278 */
																	int BgL_arg2553z00_2587;

																	BgL_arg2553z00_2587 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 278 */
																		long BgL_auxz00_2870;

																		BgL_auxz00_2870 =
																			(long) (BgL_arg2553z00_2587);
																		BgL_modz00_2586 =
																			(BgL_offsetz00_2585 / BgL_auxz00_2870);
																}}
																{	/* Reduce/ftypec.scm 278 */
																	long BgL_restz00_2588;

																	{	/* Reduce/ftypec.scm 278 */
																		int BgL_arg2552z00_2589;

																		BgL_arg2552z00_2589 = (int) (((long) 8));
																		{	/* Reduce/ftypec.scm 278 */
																			long BgL_auxz00_2874;

																			BgL_auxz00_2874 =
																				(long) (BgL_arg2552z00_2589);
																			BgL_restz00_2588 =
																				(BgL_offsetz00_2585 % BgL_auxz00_2874);
																	}}
																	{	/* Reduce/ftypec.scm 278 */

																		BgL_method3472z00_2578 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2583,
																				(int) (BgL_modz00_2586)),
																			(int) (BgL_restz00_2588));
										}}}}}}}}
										BgL_res3801z00_2603 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3472z00_2578) (BgL_method3472z00_2578,
												(obj_t) (BgL_nodez00_2576), BgL_stackz00_1510, BEOA));
								}}
								BgL_arg3699z00_2573 = BgL_res3801z00_2603;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2885;

							BgL_auxz00_2885 = (BgL_varz00_bglt) (BgL_arg3699z00_2573);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1509))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_2885), BUNSPEC);
					}}
					BgL_auxz00_2859 = BgL_nodez00_1509;
					return (obj_t) (BgL_auxz00_2859);
				}
			}
		}
	}



/* node-typec!-box-set!3503 */
	obj_t BGl_nodezd2typecz12zd2boxzd2setz123503zd2zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2640, obj_t BgL_nodez00_2641, obj_t BgL_stackz00_2642)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 268 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1498;

				obj_t BgL_stackz00_1499;

				{	/* Reduce/ftypec.scm 269 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_2890;

					BgL_nodez00_1498 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2641);
					BgL_stackz00_1499 = BgL_stackz00_2642;
					{	/* Reduce/ftypec.scm 270 */
						BgL_nodez00_bglt BgL_arg3694z00_1503;

						{	/* Reduce/ftypec.scm 270 */
							BgL_varz00_bglt BgL_arg3695z00_1504;

							BgL_arg3695z00_1504 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1498))->
								BgL_varz00);
							{	/* Reduce/ftypec.scm 270 */
								BgL_nodez00_bglt BgL_res3795z00_2538;

								{	/* Reduce/ftypec.scm 270 */
									BgL_nodez00_bglt BgL_nodez00_2511;

									BgL_nodez00_2511 = (BgL_nodez00_bglt) (BgL_arg3695z00_1504);
									{	/* Reduce/ftypec.scm 270 */
										obj_t BgL_method3472z00_2513;

										{	/* Reduce/ftypec.scm 270 */
											BgL_objectz00_bglt BgL_objz00_2514;

											BgL_objz00_2514 = (BgL_objectz00_bglt) (BgL_nodez00_2511);
											{	/* Reduce/ftypec.scm 270 */
												long BgL_objzd2classzd2numz00_2515;

												BgL_objzd2classzd2numz00_2515 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2514);
												{	/* Reduce/ftypec.scm 270 */
													obj_t BgL_arg2551z00_2516;

													BgL_arg2551z00_2516 =
														PROCEDURE_REF
														(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
														(int) (((long) 1)));
													{	/* Reduce/ftypec.scm 270 */
														obj_t BgL_arrayz00_2518;

														int BgL_offsetz00_2519;

														BgL_arrayz00_2518 = BgL_arg2551z00_2516;
														BgL_offsetz00_2519 =
															(int) (BgL_objzd2classzd2numz00_2515);
														{	/* Reduce/ftypec.scm 270 */
															long BgL_offsetz00_2520;

															BgL_offsetz00_2520 =
																((long) (BgL_offsetz00_2519) - OBJECT_TYPE);
															{	/* Reduce/ftypec.scm 270 */
																long BgL_modz00_2521;

																{	/* Reduce/ftypec.scm 270 */
																	int BgL_arg2553z00_2522;

																	BgL_arg2553z00_2522 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 270 */
																		long BgL_auxz00_2901;

																		BgL_auxz00_2901 =
																			(long) (BgL_arg2553z00_2522);
																		BgL_modz00_2521 =
																			(BgL_offsetz00_2520 / BgL_auxz00_2901);
																}}
																{	/* Reduce/ftypec.scm 270 */
																	long BgL_restz00_2523;

																	{	/* Reduce/ftypec.scm 270 */
																		int BgL_arg2552z00_2524;

																		BgL_arg2552z00_2524 = (int) (((long) 8));
																		{	/* Reduce/ftypec.scm 270 */
																			long BgL_auxz00_2905;

																			BgL_auxz00_2905 =
																				(long) (BgL_arg2552z00_2524);
																			BgL_restz00_2523 =
																				(BgL_offsetz00_2520 % BgL_auxz00_2905);
																	}}
																	{	/* Reduce/ftypec.scm 270 */

																		BgL_method3472z00_2513 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2518,
																				(int) (BgL_modz00_2521)),
																			(int) (BgL_restz00_2523));
										}}}}}}}}
										BgL_res3795z00_2538 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3472z00_2513) (BgL_method3472z00_2513,
												(obj_t) (BgL_nodez00_2511), BgL_stackz00_1499, BEOA));
								}}
								BgL_arg3694z00_1503 = BgL_res3795z00_2538;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2916;

							BgL_auxz00_2916 = (BgL_varz00_bglt) (BgL_arg3694z00_1503);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1498))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_2916), BUNSPEC);
					}}
					{	/* Reduce/ftypec.scm 271 */
						BgL_nodez00_bglt BgL_arg3696z00_1505;

						{	/* Reduce/ftypec.scm 271 */
							BgL_nodez00_bglt BgL_arg3697z00_1506;

							BgL_arg3697z00_1506 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1498))->
								BgL_valuez00);
							{	/* Reduce/ftypec.scm 271 */
								BgL_nodez00_bglt BgL_res3798z00_2569;

								{	/* Reduce/ftypec.scm 271 */
									obj_t BgL_method3472z00_2544;

									{	/* Reduce/ftypec.scm 271 */
										BgL_objectz00_bglt BgL_objz00_2545;

										BgL_objz00_2545 =
											(BgL_objectz00_bglt) (BgL_arg3697z00_1506);
										{	/* Reduce/ftypec.scm 271 */
											long BgL_objzd2classzd2numz00_2546;

											BgL_objzd2classzd2numz00_2546 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2545);
											{	/* Reduce/ftypec.scm 271 */
												obj_t BgL_arg2551z00_2547;

												BgL_arg2551z00_2547 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 271 */
													obj_t BgL_arrayz00_2549;

													int BgL_offsetz00_2550;

													BgL_arrayz00_2549 = BgL_arg2551z00_2547;
													BgL_offsetz00_2550 =
														(int) (BgL_objzd2classzd2numz00_2546);
													{	/* Reduce/ftypec.scm 271 */
														long BgL_offsetz00_2551;

														BgL_offsetz00_2551 =
															((long) (BgL_offsetz00_2550) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 271 */
															long BgL_modz00_2552;

															{	/* Reduce/ftypec.scm 271 */
																int BgL_arg2553z00_2553;

																BgL_arg2553z00_2553 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 271 */
																	long BgL_auxz00_2928;

																	BgL_auxz00_2928 =
																		(long) (BgL_arg2553z00_2553);
																	BgL_modz00_2552 =
																		(BgL_offsetz00_2551 / BgL_auxz00_2928);
															}}
															{	/* Reduce/ftypec.scm 271 */
																long BgL_restz00_2554;

																{	/* Reduce/ftypec.scm 271 */
																	int BgL_arg2552z00_2555;

																	BgL_arg2552z00_2555 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 271 */
																		long BgL_auxz00_2932;

																		BgL_auxz00_2932 =
																			(long) (BgL_arg2552z00_2555);
																		BgL_restz00_2554 =
																			(BgL_offsetz00_2551 % BgL_auxz00_2932);
																}}
																{	/* Reduce/ftypec.scm 271 */

																	BgL_method3472z00_2544 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2549,
																			(int) (BgL_modz00_2552)),
																		(int) (BgL_restz00_2554));
									}}}}}}}}
									BgL_res3798z00_2569 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2544)
										(BgL_method3472z00_2544, (obj_t) (BgL_arg3697z00_1506),
											BgL_stackz00_1499, BEOA));
								}
								BgL_arg3696z00_1505 = BgL_res3798z00_2569;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1498))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3696z00_1505), BUNSPEC);
					}
					BgL_auxz00_2890 = BgL_nodez00_1498;
					return (obj_t) (BgL_auxz00_2890);
				}
			}
		}
	}



/* node-typec!-make-box3501 */
	obj_t BGl_nodezd2typecz12zd2makezd2box3501zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2643, obj_t BgL_nodez00_2644, obj_t BgL_stackz00_2645)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 260 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1489;

				obj_t BgL_stackz00_1490;

				{	/* Reduce/ftypec.scm 261 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_2946;

					BgL_nodez00_1489 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2644);
					BgL_stackz00_1490 = BgL_stackz00_2645;
					{	/* Reduce/ftypec.scm 261 */
						BgL_nodez00_bglt BgL_arg3691z00_2477;

						{	/* Reduce/ftypec.scm 261 */
							BgL_nodez00_bglt BgL_arg3692z00_2478;

							BgL_arg3692z00_2478 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1489))->
								BgL_valuez00);
							{	/* Reduce/ftypec.scm 261 */
								BgL_nodez00_bglt BgL_res3792z00_2507;

								{	/* Reduce/ftypec.scm 261 */
									obj_t BgL_method3472z00_2482;

									{	/* Reduce/ftypec.scm 261 */
										BgL_objectz00_bglt BgL_objz00_2483;

										BgL_objz00_2483 =
											(BgL_objectz00_bglt) (BgL_arg3692z00_2478);
										{	/* Reduce/ftypec.scm 261 */
											long BgL_objzd2classzd2numz00_2484;

											BgL_objzd2classzd2numz00_2484 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2483);
											{	/* Reduce/ftypec.scm 261 */
												obj_t BgL_arg2551z00_2485;

												BgL_arg2551z00_2485 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 261 */
													obj_t BgL_arrayz00_2487;

													int BgL_offsetz00_2488;

													BgL_arrayz00_2487 = BgL_arg2551z00_2485;
													BgL_offsetz00_2488 =
														(int) (BgL_objzd2classzd2numz00_2484);
													{	/* Reduce/ftypec.scm 261 */
														long BgL_offsetz00_2489;

														BgL_offsetz00_2489 =
															((long) (BgL_offsetz00_2488) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 261 */
															long BgL_modz00_2490;

															{	/* Reduce/ftypec.scm 261 */
																int BgL_arg2553z00_2491;

																BgL_arg2553z00_2491 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 261 */
																	long BgL_auxz00_2956;

																	BgL_auxz00_2956 =
																		(long) (BgL_arg2553z00_2491);
																	BgL_modz00_2490 =
																		(BgL_offsetz00_2489 / BgL_auxz00_2956);
															}}
															{	/* Reduce/ftypec.scm 261 */
																long BgL_restz00_2492;

																{	/* Reduce/ftypec.scm 261 */
																	int BgL_arg2552z00_2493;

																	BgL_arg2552z00_2493 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 261 */
																		long BgL_auxz00_2960;

																		BgL_auxz00_2960 =
																			(long) (BgL_arg2552z00_2493);
																		BgL_restz00_2492 =
																			(BgL_offsetz00_2489 % BgL_auxz00_2960);
																}}
																{	/* Reduce/ftypec.scm 261 */

																	BgL_method3472z00_2482 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2487,
																			(int) (BgL_modz00_2490)),
																		(int) (BgL_restz00_2492));
									}}}}}}}}
									BgL_res3792z00_2507 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2482)
										(BgL_method3472z00_2482, (obj_t) (BgL_arg3692z00_2478),
											BgL_stackz00_1490, BEOA));
								}
								BgL_arg3691z00_2477 = BgL_res3792z00_2507;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1489))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3691z00_2477), BUNSPEC);
					}
					BgL_auxz00_2946 = BgL_nodez00_1489;
					return (obj_t) (BgL_auxz00_2946);
				}
			}
		}
	}



/* node-typec!-jump-ex-3499 */
	obj_t BGl_nodezd2typecz12zd2jumpzd2exzd23499z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2646, obj_t BgL_nodez00_2647, obj_t BgL_stackz00_2648)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 251 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1478;

				obj_t BgL_stackz00_1479;

				{	/* Reduce/ftypec.scm 252 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_2974;

					BgL_nodez00_1478 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2647);
					BgL_stackz00_1479 = BgL_stackz00_2648;
					{	/* Reduce/ftypec.scm 253 */
						BgL_nodez00_bglt BgL_arg3686z00_1483;

						{	/* Reduce/ftypec.scm 253 */
							BgL_nodez00_bglt BgL_arg3687z00_1484;

							BgL_arg3687z00_1484 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1478))->
								BgL_exitz00);
							{	/* Reduce/ftypec.scm 253 */
								BgL_nodez00_bglt BgL_res3786z00_2442;

								{	/* Reduce/ftypec.scm 253 */
									obj_t BgL_method3472z00_2417;

									{	/* Reduce/ftypec.scm 253 */
										BgL_objectz00_bglt BgL_objz00_2418;

										BgL_objz00_2418 =
											(BgL_objectz00_bglt) (BgL_arg3687z00_1484);
										{	/* Reduce/ftypec.scm 253 */
											long BgL_objzd2classzd2numz00_2419;

											BgL_objzd2classzd2numz00_2419 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2418);
											{	/* Reduce/ftypec.scm 253 */
												obj_t BgL_arg2551z00_2420;

												BgL_arg2551z00_2420 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 253 */
													obj_t BgL_arrayz00_2422;

													int BgL_offsetz00_2423;

													BgL_arrayz00_2422 = BgL_arg2551z00_2420;
													BgL_offsetz00_2423 =
														(int) (BgL_objzd2classzd2numz00_2419);
													{	/* Reduce/ftypec.scm 253 */
														long BgL_offsetz00_2424;

														BgL_offsetz00_2424 =
															((long) (BgL_offsetz00_2423) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 253 */
															long BgL_modz00_2425;

															{	/* Reduce/ftypec.scm 253 */
																int BgL_arg2553z00_2426;

																BgL_arg2553z00_2426 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 253 */
																	long BgL_auxz00_2984;

																	BgL_auxz00_2984 =
																		(long) (BgL_arg2553z00_2426);
																	BgL_modz00_2425 =
																		(BgL_offsetz00_2424 / BgL_auxz00_2984);
															}}
															{	/* Reduce/ftypec.scm 253 */
																long BgL_restz00_2427;

																{	/* Reduce/ftypec.scm 253 */
																	int BgL_arg2552z00_2428;

																	BgL_arg2552z00_2428 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 253 */
																		long BgL_auxz00_2988;

																		BgL_auxz00_2988 =
																			(long) (BgL_arg2552z00_2428);
																		BgL_restz00_2427 =
																			(BgL_offsetz00_2424 % BgL_auxz00_2988);
																}}
																{	/* Reduce/ftypec.scm 253 */

																	BgL_method3472z00_2417 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2422,
																			(int) (BgL_modz00_2425)),
																		(int) (BgL_restz00_2427));
									}}}}}}}}
									BgL_res3786z00_2442 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2417)
										(BgL_method3472z00_2417, (obj_t) (BgL_arg3687z00_1484),
											BgL_stackz00_1479, BEOA));
								}
								BgL_arg3686z00_1483 = BgL_res3786z00_2442;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1478))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3686z00_1483), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 254 */
						BgL_nodez00_bglt BgL_arg3688z00_1485;

						{	/* Reduce/ftypec.scm 254 */
							BgL_nodez00_bglt BgL_arg3689z00_1486;

							BgL_arg3689z00_1486 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1478))->
								BgL_valuez00);
							{	/* Reduce/ftypec.scm 254 */
								BgL_nodez00_bglt BgL_res3789z00_2473;

								{	/* Reduce/ftypec.scm 254 */
									obj_t BgL_method3472z00_2448;

									{	/* Reduce/ftypec.scm 254 */
										BgL_objectz00_bglt BgL_objz00_2449;

										BgL_objz00_2449 =
											(BgL_objectz00_bglt) (BgL_arg3689z00_1486);
										{	/* Reduce/ftypec.scm 254 */
											long BgL_objzd2classzd2numz00_2450;

											BgL_objzd2classzd2numz00_2450 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2449);
											{	/* Reduce/ftypec.scm 254 */
												obj_t BgL_arg2551z00_2451;

												BgL_arg2551z00_2451 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 254 */
													obj_t BgL_arrayz00_2453;

													int BgL_offsetz00_2454;

													BgL_arrayz00_2453 = BgL_arg2551z00_2451;
													BgL_offsetz00_2454 =
														(int) (BgL_objzd2classzd2numz00_2450);
													{	/* Reduce/ftypec.scm 254 */
														long BgL_offsetz00_2455;

														BgL_offsetz00_2455 =
															((long) (BgL_offsetz00_2454) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 254 */
															long BgL_modz00_2456;

															{	/* Reduce/ftypec.scm 254 */
																int BgL_arg2553z00_2457;

																BgL_arg2553z00_2457 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 254 */
																	long BgL_auxz00_3009;

																	BgL_auxz00_3009 =
																		(long) (BgL_arg2553z00_2457);
																	BgL_modz00_2456 =
																		(BgL_offsetz00_2455 / BgL_auxz00_3009);
															}}
															{	/* Reduce/ftypec.scm 254 */
																long BgL_restz00_2458;

																{	/* Reduce/ftypec.scm 254 */
																	int BgL_arg2552z00_2459;

																	BgL_arg2552z00_2459 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 254 */
																		long BgL_auxz00_3013;

																		BgL_auxz00_3013 =
																			(long) (BgL_arg2552z00_2459);
																		BgL_restz00_2458 =
																			(BgL_offsetz00_2455 % BgL_auxz00_3013);
																}}
																{	/* Reduce/ftypec.scm 254 */

																	BgL_method3472z00_2448 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2453,
																			(int) (BgL_modz00_2456)),
																		(int) (BgL_restz00_2458));
									}}}}}}}}
									BgL_res3789z00_2473 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2448)
										(BgL_method3472z00_2448, (obj_t) (BgL_arg3689z00_1486),
											BgL_stackz00_1479, BEOA));
								}
								BgL_arg3688z00_1485 = BgL_res3789z00_2473;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1478))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3688z00_1485), BUNSPEC);
					}
					BgL_auxz00_2974 = BgL_nodez00_1478;
					return (obj_t) (BgL_auxz00_2974);
				}
			}
		}
	}



/* node-typec!-set-ex-i3497 */
	obj_t BGl_nodezd2typecz12zd2setzd2exzd2i3497z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2649, obj_t BgL_nodez00_2650, obj_t BgL_stackz00_2651)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 242 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1467;

				obj_t BgL_stackz00_1468;

				{	/* Reduce/ftypec.scm 243 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3027;

					BgL_nodez00_1467 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2650);
					BgL_stackz00_1468 = BgL_stackz00_2651;
					{	/* Reduce/ftypec.scm 244 */
						BgL_nodez00_bglt BgL_arg3681z00_1472;

						{	/* Reduce/ftypec.scm 244 */
							BgL_nodez00_bglt BgL_arg3682z00_1473;

							BgL_arg3682z00_1473 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1467))->
								BgL_bodyz00);
							{	/* Reduce/ftypec.scm 244 */
								BgL_nodez00_bglt BgL_res3780z00_2380;

								{	/* Reduce/ftypec.scm 244 */
									obj_t BgL_method3472z00_2355;

									{	/* Reduce/ftypec.scm 244 */
										BgL_objectz00_bglt BgL_objz00_2356;

										BgL_objz00_2356 =
											(BgL_objectz00_bglt) (BgL_arg3682z00_1473);
										{	/* Reduce/ftypec.scm 244 */
											long BgL_objzd2classzd2numz00_2357;

											BgL_objzd2classzd2numz00_2357 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2356);
											{	/* Reduce/ftypec.scm 244 */
												obj_t BgL_arg2551z00_2358;

												BgL_arg2551z00_2358 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 244 */
													obj_t BgL_arrayz00_2360;

													int BgL_offsetz00_2361;

													BgL_arrayz00_2360 = BgL_arg2551z00_2358;
													BgL_offsetz00_2361 =
														(int) (BgL_objzd2classzd2numz00_2357);
													{	/* Reduce/ftypec.scm 244 */
														long BgL_offsetz00_2362;

														BgL_offsetz00_2362 =
															((long) (BgL_offsetz00_2361) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 244 */
															long BgL_modz00_2363;

															{	/* Reduce/ftypec.scm 244 */
																int BgL_arg2553z00_2364;

																BgL_arg2553z00_2364 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 244 */
																	long BgL_auxz00_3037;

																	BgL_auxz00_3037 =
																		(long) (BgL_arg2553z00_2364);
																	BgL_modz00_2363 =
																		(BgL_offsetz00_2362 / BgL_auxz00_3037);
															}}
															{	/* Reduce/ftypec.scm 244 */
																long BgL_restz00_2365;

																{	/* Reduce/ftypec.scm 244 */
																	int BgL_arg2552z00_2366;

																	BgL_arg2552z00_2366 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 244 */
																		long BgL_auxz00_3041;

																		BgL_auxz00_3041 =
																			(long) (BgL_arg2552z00_2366);
																		BgL_restz00_2365 =
																			(BgL_offsetz00_2362 % BgL_auxz00_3041);
																}}
																{	/* Reduce/ftypec.scm 244 */

																	BgL_method3472z00_2355 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2360,
																			(int) (BgL_modz00_2363)),
																		(int) (BgL_restz00_2365));
									}}}}}}}}
									BgL_res3780z00_2380 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2355)
										(BgL_method3472z00_2355, (obj_t) (BgL_arg3682z00_1473),
											BgL_stackz00_1468, BEOA));
								}
								BgL_arg3681z00_1472 = BgL_res3780z00_2380;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1467))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3681z00_1472), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 245 */
						BgL_nodez00_bglt BgL_arg3683z00_1474;

						{	/* Reduce/ftypec.scm 245 */
							BgL_varz00_bglt BgL_arg3684z00_1475;

							BgL_arg3684z00_1475 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1467))->
								BgL_varz00);
							{	/* Reduce/ftypec.scm 245 */
								BgL_nodez00_bglt BgL_res3783z00_2411;

								{	/* Reduce/ftypec.scm 245 */
									BgL_nodez00_bglt BgL_nodez00_2384;

									BgL_nodez00_2384 = (BgL_nodez00_bglt) (BgL_arg3684z00_1475);
									{	/* Reduce/ftypec.scm 245 */
										obj_t BgL_method3472z00_2386;

										{	/* Reduce/ftypec.scm 245 */
											BgL_objectz00_bglt BgL_objz00_2387;

											BgL_objz00_2387 = (BgL_objectz00_bglt) (BgL_nodez00_2384);
											{	/* Reduce/ftypec.scm 245 */
												long BgL_objzd2classzd2numz00_2388;

												BgL_objzd2classzd2numz00_2388 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2387);
												{	/* Reduce/ftypec.scm 245 */
													obj_t BgL_arg2551z00_2389;

													BgL_arg2551z00_2389 =
														PROCEDURE_REF
														(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
														(int) (((long) 1)));
													{	/* Reduce/ftypec.scm 245 */
														obj_t BgL_arrayz00_2391;

														int BgL_offsetz00_2392;

														BgL_arrayz00_2391 = BgL_arg2551z00_2389;
														BgL_offsetz00_2392 =
															(int) (BgL_objzd2classzd2numz00_2388);
														{	/* Reduce/ftypec.scm 245 */
															long BgL_offsetz00_2393;

															BgL_offsetz00_2393 =
																((long) (BgL_offsetz00_2392) - OBJECT_TYPE);
															{	/* Reduce/ftypec.scm 245 */
																long BgL_modz00_2394;

																{	/* Reduce/ftypec.scm 245 */
																	int BgL_arg2553z00_2395;

																	BgL_arg2553z00_2395 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 245 */
																		long BgL_auxz00_3063;

																		BgL_auxz00_3063 =
																			(long) (BgL_arg2553z00_2395);
																		BgL_modz00_2394 =
																			(BgL_offsetz00_2393 / BgL_auxz00_3063);
																}}
																{	/* Reduce/ftypec.scm 245 */
																	long BgL_restz00_2396;

																	{	/* Reduce/ftypec.scm 245 */
																		int BgL_arg2552z00_2397;

																		BgL_arg2552z00_2397 = (int) (((long) 8));
																		{	/* Reduce/ftypec.scm 245 */
																			long BgL_auxz00_3067;

																			BgL_auxz00_3067 =
																				(long) (BgL_arg2552z00_2397);
																			BgL_restz00_2396 =
																				(BgL_offsetz00_2393 % BgL_auxz00_3067);
																	}}
																	{	/* Reduce/ftypec.scm 245 */

																		BgL_method3472z00_2386 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2391,
																				(int) (BgL_modz00_2394)),
																			(int) (BgL_restz00_2396));
										}}}}}}}}
										BgL_res3783z00_2411 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3472z00_2386) (BgL_method3472z00_2386,
												(obj_t) (BgL_nodez00_2384), BgL_stackz00_1468, BEOA));
								}}
								BgL_arg3683z00_1474 = BgL_res3783z00_2411;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3078;

							BgL_auxz00_3078 = (BgL_varz00_bglt) (BgL_arg3683z00_1474);
							((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1467))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3078), BUNSPEC);
					}}
					BgL_auxz00_3027 = BgL_nodez00_1467;
					return (obj_t) (BgL_auxz00_3027);
				}
			}
		}
	}



/* node-typec!-let-var3495 */
	obj_t BGl_nodezd2typecz12zd2letzd2var3495zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2652, obj_t BgL_nodez00_2653, obj_t BgL_stackz00_2654)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 231 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1448;

				obj_t BgL_stackz00_1449;

				{	/* Reduce/ftypec.scm 232 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3083;

					BgL_nodez00_1448 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2653);
					BgL_stackz00_1449 = BgL_stackz00_2654;
					{	/* Reduce/ftypec.scm 233 */
						obj_t BgL_g3470z00_1453;

						BgL_g3470z00_1453 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1448))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3468z00_1455;

							BgL_l3468z00_1455 = BgL_g3470z00_1453;
						BgL_zc3anonymousza33673ze3z83_1456:
							if (PAIRP(BgL_l3468z00_1455))
								{	/* Reduce/ftypec.scm 233 */
									{	/* Reduce/ftypec.scm 234 */
										obj_t BgL_bindingz00_1458;

										BgL_bindingz00_1458 = CAR(BgL_l3468z00_1455);
										{	/* Reduce/ftypec.scm 234 */
											BgL_nodez00_bglt BgL_arg3675z00_1459;

											{	/* Reduce/ftypec.scm 234 */
												obj_t BgL_arg3676z00_1460;

												BgL_arg3676z00_1460 = CDR(BgL_bindingz00_1458);
												{	/* Reduce/ftypec.scm 234 */
													BgL_nodez00_bglt BgL_res3774z00_2317;

													{	/* Reduce/ftypec.scm 234 */
														BgL_nodez00_bglt BgL_nodez00_2290;

														BgL_nodez00_2290 =
															(BgL_nodez00_bglt) (BgL_arg3676z00_1460);
														{	/* Reduce/ftypec.scm 234 */
															obj_t BgL_method3472z00_2292;

															{	/* Reduce/ftypec.scm 234 */
																BgL_objectz00_bglt BgL_objz00_2293;

																BgL_objz00_2293 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2290);
																{	/* Reduce/ftypec.scm 234 */
																	long BgL_objzd2classzd2numz00_2294;

																	BgL_objzd2classzd2numz00_2294 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2293);
																	{	/* Reduce/ftypec.scm 234 */
																		obj_t BgL_arg2551z00_2295;

																		BgL_arg2551z00_2295 =
																			PROCEDURE_REF
																			(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																			(int) (((long) 1)));
																		{	/* Reduce/ftypec.scm 234 */
																			obj_t BgL_arrayz00_2297;

																			int BgL_offsetz00_2298;

																			BgL_arrayz00_2297 = BgL_arg2551z00_2295;
																			BgL_offsetz00_2298 =
																				(int) (BgL_objzd2classzd2numz00_2294);
																			{	/* Reduce/ftypec.scm 234 */
																				long BgL_offsetz00_2299;

																				BgL_offsetz00_2299 =
																					(
																					(long) (BgL_offsetz00_2298) -
																					OBJECT_TYPE);
																				{	/* Reduce/ftypec.scm 234 */
																					long BgL_modz00_2300;

																					{	/* Reduce/ftypec.scm 234 */
																						int BgL_arg2553z00_2301;

																						BgL_arg2553z00_2301 =
																							(int) (((long) 8));
																						{	/* Reduce/ftypec.scm 234 */
																							long BgL_auxz00_3098;

																							BgL_auxz00_3098 =
																								(long) (BgL_arg2553z00_2301);
																							BgL_modz00_2300 =
																								(BgL_offsetz00_2299 /
																								BgL_auxz00_3098);
																					}}
																					{	/* Reduce/ftypec.scm 234 */
																						long BgL_restz00_2302;

																						{	/* Reduce/ftypec.scm 234 */
																							int BgL_arg2552z00_2303;

																							BgL_arg2552z00_2303 =
																								(int) (((long) 8));
																							{	/* Reduce/ftypec.scm 234 */
																								long BgL_auxz00_3102;

																								BgL_auxz00_3102 =
																									(long) (BgL_arg2552z00_2303);
																								BgL_restz00_2302 =
																									(BgL_offsetz00_2299 %
																									BgL_auxz00_3102);
																						}}
																						{	/* Reduce/ftypec.scm 234 */

																							BgL_method3472z00_2292 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2297,
																									(int) (BgL_modz00_2300)),
																								(int) (BgL_restz00_2302));
															}}}}}}}}
															BgL_res3774z00_2317 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3472z00_2292)
																(BgL_method3472z00_2292,
																	(obj_t) (BgL_nodez00_2290), BgL_stackz00_1449,
																	BEOA));
													}}
													BgL_arg3675z00_1459 = BgL_res3774z00_2317;
											}}
											{	/* Reduce/ftypec.scm 234 */
												obj_t BgL_auxz00_3113;

												BgL_auxz00_3113 = (obj_t) (BgL_arg3675z00_1459);
												SET_CDR(BgL_bindingz00_1458, BgL_auxz00_3113);
									}}}
									{
										obj_t BgL_l3468z00_3116;

										BgL_l3468z00_3116 = CDR(BgL_l3468z00_1455);
										BgL_l3468z00_1455 = BgL_l3468z00_3116;
										goto BgL_zc3anonymousza33673ze3z83_1456;
									}
								}
							else
								{	/* Reduce/ftypec.scm 233 */
									((bool_t) 1);
								}
						}
					}
					{	/* Reduce/ftypec.scm 236 */
						BgL_nodez00_bglt BgL_arg3678z00_1463;

						{	/* Reduce/ftypec.scm 236 */
							BgL_nodez00_bglt BgL_arg3679z00_1464;

							BgL_arg3679z00_1464 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1448))->BgL_bodyz00);
							{	/* Reduce/ftypec.scm 236 */
								BgL_nodez00_bglt BgL_res3777z00_2349;

								{	/* Reduce/ftypec.scm 236 */
									obj_t BgL_method3472z00_2324;

									{	/* Reduce/ftypec.scm 236 */
										BgL_objectz00_bglt BgL_objz00_2325;

										BgL_objz00_2325 =
											(BgL_objectz00_bglt) (BgL_arg3679z00_1464);
										{	/* Reduce/ftypec.scm 236 */
											long BgL_objzd2classzd2numz00_2326;

											BgL_objzd2classzd2numz00_2326 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2325);
											{	/* Reduce/ftypec.scm 236 */
												obj_t BgL_arg2551z00_2327;

												BgL_arg2551z00_2327 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 236 */
													obj_t BgL_arrayz00_2329;

													int BgL_offsetz00_2330;

													BgL_arrayz00_2329 = BgL_arg2551z00_2327;
													BgL_offsetz00_2330 =
														(int) (BgL_objzd2classzd2numz00_2326);
													{	/* Reduce/ftypec.scm 236 */
														long BgL_offsetz00_2331;

														BgL_offsetz00_2331 =
															((long) (BgL_offsetz00_2330) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 236 */
															long BgL_modz00_2332;

															{	/* Reduce/ftypec.scm 236 */
																int BgL_arg2553z00_2333;

																BgL_arg2553z00_2333 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 236 */
																	long BgL_auxz00_3127;

																	BgL_auxz00_3127 =
																		(long) (BgL_arg2553z00_2333);
																	BgL_modz00_2332 =
																		(BgL_offsetz00_2331 / BgL_auxz00_3127);
															}}
															{	/* Reduce/ftypec.scm 236 */
																long BgL_restz00_2334;

																{	/* Reduce/ftypec.scm 236 */
																	int BgL_arg2552z00_2335;

																	BgL_arg2552z00_2335 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 236 */
																		long BgL_auxz00_3131;

																		BgL_auxz00_3131 =
																			(long) (BgL_arg2552z00_2335);
																		BgL_restz00_2334 =
																			(BgL_offsetz00_2331 % BgL_auxz00_3131);
																}}
																{	/* Reduce/ftypec.scm 236 */

																	BgL_method3472z00_2324 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2329,
																			(int) (BgL_modz00_2332)),
																		(int) (BgL_restz00_2334));
									}}}}}}}}
									BgL_res3777z00_2349 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2324)
										(BgL_method3472z00_2324, (obj_t) (BgL_arg3679z00_1464),
											BgL_stackz00_1449, BEOA));
								}
								BgL_arg3678z00_1463 = BgL_res3777z00_2349;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1448))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3678z00_1463), BUNSPEC);
					}
					BgL_auxz00_3083 = BgL_nodez00_1448;
					return (obj_t) (BgL_auxz00_3083);
				}
			}
		}
	}



/* node-typec!-let-fun3492 */
	obj_t BGl_nodezd2typecz12zd2letzd2fun3492zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2655, obj_t BgL_nodez00_2656, obj_t BgL_stackz00_2657)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 219 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1428;

				obj_t BgL_stackz00_1429;

				{	/* Reduce/ftypec.scm 220 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3145;

					BgL_nodez00_1428 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2656);
					BgL_stackz00_1429 = BgL_stackz00_2657;
					{	/* Reduce/ftypec.scm 221 */
						obj_t BgL_g3467z00_1433;

						BgL_g3467z00_1433 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1428))->BgL_localsz00);
						{
							obj_t BgL_l3465z00_1435;

							BgL_l3465z00_1435 = BgL_g3467z00_1433;
						BgL_zc3anonymousza33665ze3z83_1436:
							if (PAIRP(BgL_l3465z00_1435))
								{	/* Reduce/ftypec.scm 221 */
									{	/* Reduce/ftypec.scm 222 */
										obj_t BgL_localz00_1438;

										BgL_localz00_1438 = CAR(BgL_l3465z00_1435);
										{	/* Reduce/ftypec.scm 222 */
											BgL_valuez00_bglt BgL_funz00_1439;

											{
												BgL_variablez00_bglt BgL_auxz00_3150;

												BgL_auxz00_3150 =
													(BgL_variablez00_bglt) (BgL_localz00_1438);
												BgL_funz00_1439 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3150))->
													BgL_valuez00);
											}
											{	/* Reduce/ftypec.scm 223 */
												BgL_nodez00_bglt BgL_arg3667z00_1440;

												{	/* Reduce/ftypec.scm 223 */
													obj_t BgL_arg3668z00_1441;

													{
														BgL_sfunz00_bglt BgL_auxz00_3153;

														BgL_auxz00_3153 =
															(BgL_sfunz00_bglt) (BgL_funz00_1439);
														BgL_arg3668z00_1441 =
															(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3153))->
															BgL_bodyz00);
													}
													{	/* Reduce/ftypec.scm 223 */
														BgL_nodez00_bglt BgL_res3768z00_2251;

														{	/* Reduce/ftypec.scm 223 */
															BgL_nodez00_bglt BgL_nodez00_2224;

															BgL_nodez00_2224 =
																(BgL_nodez00_bglt) (BgL_arg3668z00_1441);
															{	/* Reduce/ftypec.scm 223 */
																obj_t BgL_method3472z00_2226;

																{	/* Reduce/ftypec.scm 223 */
																	BgL_objectz00_bglt BgL_objz00_2227;

																	BgL_objz00_2227 =
																		(BgL_objectz00_bglt) (BgL_nodez00_2224);
																	{	/* Reduce/ftypec.scm 223 */
																		long BgL_objzd2classzd2numz00_2228;

																		BgL_objzd2classzd2numz00_2228 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_2227);
																		{	/* Reduce/ftypec.scm 223 */
																			obj_t BgL_arg2551z00_2229;

																			BgL_arg2551z00_2229 =
																				PROCEDURE_REF
																				(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																				(int) (((long) 1)));
																			{	/* Reduce/ftypec.scm 223 */
																				obj_t BgL_arrayz00_2231;

																				int BgL_offsetz00_2232;

																				BgL_arrayz00_2231 = BgL_arg2551z00_2229;
																				BgL_offsetz00_2232 =
																					(int) (BgL_objzd2classzd2numz00_2228);
																				{	/* Reduce/ftypec.scm 223 */
																					long BgL_offsetz00_2233;

																					BgL_offsetz00_2233 =
																						(
																						(long) (BgL_offsetz00_2232) -
																						OBJECT_TYPE);
																					{	/* Reduce/ftypec.scm 223 */
																						long BgL_modz00_2234;

																						{	/* Reduce/ftypec.scm 223 */
																							int BgL_arg2553z00_2235;

																							BgL_arg2553z00_2235 =
																								(int) (((long) 8));
																							{	/* Reduce/ftypec.scm 223 */
																								long BgL_auxz00_3165;

																								BgL_auxz00_3165 =
																									(long) (BgL_arg2553z00_2235);
																								BgL_modz00_2234 =
																									(BgL_offsetz00_2233 /
																									BgL_auxz00_3165);
																						}}
																						{	/* Reduce/ftypec.scm 223 */
																							long BgL_restz00_2236;

																							{	/* Reduce/ftypec.scm 223 */
																								int BgL_arg2552z00_2237;

																								BgL_arg2552z00_2237 =
																									(int) (((long) 8));
																								{	/* Reduce/ftypec.scm 223 */
																									long BgL_auxz00_3169;

																									BgL_auxz00_3169 =
																										(long)
																										(BgL_arg2552z00_2237);
																									BgL_restz00_2236 =
																										(BgL_offsetz00_2233 %
																										BgL_auxz00_3169);
																							}}
																							{	/* Reduce/ftypec.scm 223 */

																								BgL_method3472z00_2226 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_2231,
																										(int) (BgL_modz00_2234)),
																									(int) (BgL_restz00_2236));
																}}}}}}}}
																BgL_res3768z00_2251 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3472z00_2226)
																	(BgL_method3472z00_2226,
																		(obj_t) (BgL_nodez00_2224),
																		BgL_stackz00_1429, BEOA));
														}}
														BgL_arg3667z00_1440 = BgL_res3768z00_2251;
												}}
												{
													obj_t BgL_auxz00_3182;

													BgL_sfunz00_bglt BgL_auxz00_3180;

													BgL_auxz00_3182 = (obj_t) (BgL_arg3667z00_1440);
													BgL_auxz00_3180 =
														(BgL_sfunz00_bglt) (BgL_funz00_1439);
													((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3180))->
															BgL_bodyz00) =
														((obj_t) BgL_auxz00_3182), BUNSPEC);
									}}}}
									{
										obj_t BgL_l3465z00_3185;

										BgL_l3465z00_3185 = CDR(BgL_l3465z00_1435);
										BgL_l3465z00_1435 = BgL_l3465z00_3185;
										goto BgL_zc3anonymousza33665ze3z83_1436;
									}
								}
							else
								{	/* Reduce/ftypec.scm 221 */
									((bool_t) 1);
								}
						}
					}
					{	/* Reduce/ftypec.scm 225 */
						BgL_nodez00_bglt BgL_arg3670z00_1444;

						{	/* Reduce/ftypec.scm 225 */
							BgL_nodez00_bglt BgL_arg3671z00_1445;

							BgL_arg3671z00_1445 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1428))->BgL_bodyz00);
							{	/* Reduce/ftypec.scm 225 */
								BgL_nodez00_bglt BgL_res3771z00_2283;

								{	/* Reduce/ftypec.scm 225 */
									obj_t BgL_method3472z00_2258;

									{	/* Reduce/ftypec.scm 225 */
										BgL_objectz00_bglt BgL_objz00_2259;

										BgL_objz00_2259 =
											(BgL_objectz00_bglt) (BgL_arg3671z00_1445);
										{	/* Reduce/ftypec.scm 225 */
											long BgL_objzd2classzd2numz00_2260;

											BgL_objzd2classzd2numz00_2260 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2259);
											{	/* Reduce/ftypec.scm 225 */
												obj_t BgL_arg2551z00_2261;

												BgL_arg2551z00_2261 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 225 */
													obj_t BgL_arrayz00_2263;

													int BgL_offsetz00_2264;

													BgL_arrayz00_2263 = BgL_arg2551z00_2261;
													BgL_offsetz00_2264 =
														(int) (BgL_objzd2classzd2numz00_2260);
													{	/* Reduce/ftypec.scm 225 */
														long BgL_offsetz00_2265;

														BgL_offsetz00_2265 =
															((long) (BgL_offsetz00_2264) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 225 */
															long BgL_modz00_2266;

															{	/* Reduce/ftypec.scm 225 */
																int BgL_arg2553z00_2267;

																BgL_arg2553z00_2267 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 225 */
																	long BgL_auxz00_3196;

																	BgL_auxz00_3196 =
																		(long) (BgL_arg2553z00_2267);
																	BgL_modz00_2266 =
																		(BgL_offsetz00_2265 / BgL_auxz00_3196);
															}}
															{	/* Reduce/ftypec.scm 225 */
																long BgL_restz00_2268;

																{	/* Reduce/ftypec.scm 225 */
																	int BgL_arg2552z00_2269;

																	BgL_arg2552z00_2269 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 225 */
																		long BgL_auxz00_3200;

																		BgL_auxz00_3200 =
																			(long) (BgL_arg2552z00_2269);
																		BgL_restz00_2268 =
																			(BgL_offsetz00_2265 % BgL_auxz00_3200);
																}}
																{	/* Reduce/ftypec.scm 225 */

																	BgL_method3472z00_2258 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2263,
																			(int) (BgL_modz00_2266)),
																		(int) (BgL_restz00_2268));
									}}}}}}}}
									BgL_res3771z00_2283 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2258)
										(BgL_method3472z00_2258, (obj_t) (BgL_arg3671z00_1445),
											BgL_stackz00_1429, BEOA));
								}
								BgL_arg3670z00_1444 = BgL_res3771z00_2283;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1428))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3670z00_1444), BUNSPEC);
					}
					BgL_auxz00_3145 = BgL_nodez00_1428;
					return (obj_t) (BgL_auxz00_3145);
				}
			}
		}
	}



/* node-typec!-select3490 */
	obj_t BGl_nodezd2typecz12zd2select3490z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2658, obj_t BgL_nodez00_2659, obj_t BgL_stackz00_2660)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 208 */
			{
				BgL_selectz00_bglt BgL_nodez00_1409;

				obj_t BgL_stackz00_1410;

				{	/* Reduce/ftypec.scm 209 */
					BgL_selectz00_bglt BgL_auxz00_3214;

					BgL_nodez00_1409 = (BgL_selectz00_bglt) (BgL_nodez00_2659);
					BgL_stackz00_1410 = BgL_stackz00_2660;
					{	/* Reduce/ftypec.scm 210 */
						BgL_nodez00_bglt BgL_arg3657z00_1414;

						{	/* Reduce/ftypec.scm 210 */
							BgL_nodez00_bglt BgL_arg3658z00_1415;

							BgL_arg3658z00_1415 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1409))->BgL_testz00);
							{	/* Reduce/ftypec.scm 210 */
								BgL_nodez00_bglt BgL_res3762z00_2181;

								{	/* Reduce/ftypec.scm 210 */
									obj_t BgL_method3472z00_2156;

									{	/* Reduce/ftypec.scm 210 */
										BgL_objectz00_bglt BgL_objz00_2157;

										BgL_objz00_2157 =
											(BgL_objectz00_bglt) (BgL_arg3658z00_1415);
										{	/* Reduce/ftypec.scm 210 */
											long BgL_objzd2classzd2numz00_2158;

											BgL_objzd2classzd2numz00_2158 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2157);
											{	/* Reduce/ftypec.scm 210 */
												obj_t BgL_arg2551z00_2159;

												BgL_arg2551z00_2159 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 210 */
													obj_t BgL_arrayz00_2161;

													int BgL_offsetz00_2162;

													BgL_arrayz00_2161 = BgL_arg2551z00_2159;
													BgL_offsetz00_2162 =
														(int) (BgL_objzd2classzd2numz00_2158);
													{	/* Reduce/ftypec.scm 210 */
														long BgL_offsetz00_2163;

														BgL_offsetz00_2163 =
															((long) (BgL_offsetz00_2162) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 210 */
															long BgL_modz00_2164;

															{	/* Reduce/ftypec.scm 210 */
																int BgL_arg2553z00_2165;

																BgL_arg2553z00_2165 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 210 */
																	long BgL_auxz00_3224;

																	BgL_auxz00_3224 =
																		(long) (BgL_arg2553z00_2165);
																	BgL_modz00_2164 =
																		(BgL_offsetz00_2163 / BgL_auxz00_3224);
															}}
															{	/* Reduce/ftypec.scm 210 */
																long BgL_restz00_2166;

																{	/* Reduce/ftypec.scm 210 */
																	int BgL_arg2552z00_2167;

																	BgL_arg2552z00_2167 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 210 */
																		long BgL_auxz00_3228;

																		BgL_auxz00_3228 =
																			(long) (BgL_arg2552z00_2167);
																		BgL_restz00_2166 =
																			(BgL_offsetz00_2163 % BgL_auxz00_3228);
																}}
																{	/* Reduce/ftypec.scm 210 */

																	BgL_method3472z00_2156 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2161,
																			(int) (BgL_modz00_2164)),
																		(int) (BgL_restz00_2166));
									}}}}}}}}
									BgL_res3762z00_2181 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2156)
										(BgL_method3472z00_2156, (obj_t) (BgL_arg3658z00_1415),
											BgL_stackz00_1410, BEOA));
								}
								BgL_arg3657z00_1414 = BgL_res3762z00_2181;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1409))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3657z00_1414), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 211 */
						obj_t BgL_g3464z00_1416;

						BgL_g3464z00_1416 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1409))->BgL_clausesz00);
						{
							obj_t BgL_l3462z00_1418;

							BgL_l3462z00_1418 = BgL_g3464z00_1416;
						BgL_zc3anonymousza33659ze3z83_1419:
							if (PAIRP(BgL_l3462z00_1418))
								{	/* Reduce/ftypec.scm 211 */
									{	/* Reduce/ftypec.scm 212 */
										obj_t BgL_clausez00_1421;

										BgL_clausez00_1421 = CAR(BgL_l3462z00_1418);
										{	/* Reduce/ftypec.scm 212 */
											BgL_nodez00_bglt BgL_arg3661z00_1422;

											{	/* Reduce/ftypec.scm 212 */
												obj_t BgL_arg3662z00_1423;

												BgL_arg3662z00_1423 = CDR(BgL_clausez00_1421);
												{	/* Reduce/ftypec.scm 212 */
													BgL_nodez00_bglt BgL_res3765z00_2215;

													{	/* Reduce/ftypec.scm 212 */
														BgL_nodez00_bglt BgL_nodez00_2188;

														BgL_nodez00_2188 =
															(BgL_nodez00_bglt) (BgL_arg3662z00_1423);
														{	/* Reduce/ftypec.scm 212 */
															obj_t BgL_method3472z00_2190;

															{	/* Reduce/ftypec.scm 212 */
																BgL_objectz00_bglt BgL_objz00_2191;

																BgL_objz00_2191 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2188);
																{	/* Reduce/ftypec.scm 212 */
																	long BgL_objzd2classzd2numz00_2192;

																	BgL_objzd2classzd2numz00_2192 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2191);
																	{	/* Reduce/ftypec.scm 212 */
																		obj_t BgL_arg2551z00_2193;

																		BgL_arg2551z00_2193 =
																			PROCEDURE_REF
																			(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																			(int) (((long) 1)));
																		{	/* Reduce/ftypec.scm 212 */
																			obj_t BgL_arrayz00_2195;

																			int BgL_offsetz00_2196;

																			BgL_arrayz00_2195 = BgL_arg2551z00_2193;
																			BgL_offsetz00_2196 =
																				(int) (BgL_objzd2classzd2numz00_2192);
																			{	/* Reduce/ftypec.scm 212 */
																				long BgL_offsetz00_2197;

																				BgL_offsetz00_2197 =
																					(
																					(long) (BgL_offsetz00_2196) -
																					OBJECT_TYPE);
																				{	/* Reduce/ftypec.scm 212 */
																					long BgL_modz00_2198;

																					{	/* Reduce/ftypec.scm 212 */
																						int BgL_arg2553z00_2199;

																						BgL_arg2553z00_2199 =
																							(int) (((long) 8));
																						{	/* Reduce/ftypec.scm 212 */
																							long BgL_auxz00_3254;

																							BgL_auxz00_3254 =
																								(long) (BgL_arg2553z00_2199);
																							BgL_modz00_2198 =
																								(BgL_offsetz00_2197 /
																								BgL_auxz00_3254);
																					}}
																					{	/* Reduce/ftypec.scm 212 */
																						long BgL_restz00_2200;

																						{	/* Reduce/ftypec.scm 212 */
																							int BgL_arg2552z00_2201;

																							BgL_arg2552z00_2201 =
																								(int) (((long) 8));
																							{	/* Reduce/ftypec.scm 212 */
																								long BgL_auxz00_3258;

																								BgL_auxz00_3258 =
																									(long) (BgL_arg2552z00_2201);
																								BgL_restz00_2200 =
																									(BgL_offsetz00_2197 %
																									BgL_auxz00_3258);
																						}}
																						{	/* Reduce/ftypec.scm 212 */

																							BgL_method3472z00_2190 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2195,
																									(int) (BgL_modz00_2198)),
																								(int) (BgL_restz00_2200));
															}}}}}}}}
															BgL_res3765z00_2215 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3472z00_2190)
																(BgL_method3472z00_2190,
																	(obj_t) (BgL_nodez00_2188), BgL_stackz00_1410,
																	BEOA));
													}}
													BgL_arg3661z00_1422 = BgL_res3765z00_2215;
											}}
											{	/* Reduce/ftypec.scm 212 */
												obj_t BgL_auxz00_3269;

												BgL_auxz00_3269 = (obj_t) (BgL_arg3661z00_1422);
												SET_CDR(BgL_clausez00_1421, BgL_auxz00_3269);
									}}}
									{
										obj_t BgL_l3462z00_3272;

										BgL_l3462z00_3272 = CDR(BgL_l3462z00_1418);
										BgL_l3462z00_1418 = BgL_l3462z00_3272;
										goto BgL_zc3anonymousza33659ze3z83_1419;
									}
								}
							else
								{	/* Reduce/ftypec.scm 211 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3214 = BgL_nodez00_1409;
					return (obj_t) (BgL_auxz00_3214);
				}
			}
		}
	}



/* node-typec!-fail3488 */
	obj_t BGl_nodezd2typecz12zd2fail3488z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2661, obj_t BgL_nodez00_2662, obj_t BgL_stackz00_2663)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 198 */
			{
				BgL_failz00_bglt BgL_nodez00_1396;

				obj_t BgL_stackz00_1397;

				{	/* Reduce/ftypec.scm 199 */
					BgL_failz00_bglt BgL_auxz00_3276;

					BgL_nodez00_1396 = (BgL_failz00_bglt) (BgL_nodez00_2662);
					BgL_stackz00_1397 = BgL_stackz00_2663;
					{	/* Reduce/ftypec.scm 200 */
						BgL_nodez00_bglt BgL_arg3650z00_1401;

						{	/* Reduce/ftypec.scm 200 */
							BgL_nodez00_bglt BgL_arg3651z00_1402;

							BgL_arg3651z00_1402 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_procz00);
							{	/* Reduce/ftypec.scm 200 */
								BgL_nodez00_bglt BgL_res3753z00_2088;

								{	/* Reduce/ftypec.scm 200 */
									obj_t BgL_method3472z00_2063;

									{	/* Reduce/ftypec.scm 200 */
										BgL_objectz00_bglt BgL_objz00_2064;

										BgL_objz00_2064 =
											(BgL_objectz00_bglt) (BgL_arg3651z00_1402);
										{	/* Reduce/ftypec.scm 200 */
											long BgL_objzd2classzd2numz00_2065;

											BgL_objzd2classzd2numz00_2065 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2064);
											{	/* Reduce/ftypec.scm 200 */
												obj_t BgL_arg2551z00_2066;

												BgL_arg2551z00_2066 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 200 */
													obj_t BgL_arrayz00_2068;

													int BgL_offsetz00_2069;

													BgL_arrayz00_2068 = BgL_arg2551z00_2066;
													BgL_offsetz00_2069 =
														(int) (BgL_objzd2classzd2numz00_2065);
													{	/* Reduce/ftypec.scm 200 */
														long BgL_offsetz00_2070;

														BgL_offsetz00_2070 =
															((long) (BgL_offsetz00_2069) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 200 */
															long BgL_modz00_2071;

															{	/* Reduce/ftypec.scm 200 */
																int BgL_arg2553z00_2072;

																BgL_arg2553z00_2072 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 200 */
																	long BgL_auxz00_3286;

																	BgL_auxz00_3286 =
																		(long) (BgL_arg2553z00_2072);
																	BgL_modz00_2071 =
																		(BgL_offsetz00_2070 / BgL_auxz00_3286);
															}}
															{	/* Reduce/ftypec.scm 200 */
																long BgL_restz00_2073;

																{	/* Reduce/ftypec.scm 200 */
																	int BgL_arg2552z00_2074;

																	BgL_arg2552z00_2074 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 200 */
																		long BgL_auxz00_3290;

																		BgL_auxz00_3290 =
																			(long) (BgL_arg2552z00_2074);
																		BgL_restz00_2073 =
																			(BgL_offsetz00_2070 % BgL_auxz00_3290);
																}}
																{	/* Reduce/ftypec.scm 200 */

																	BgL_method3472z00_2063 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2068,
																			(int) (BgL_modz00_2071)),
																		(int) (BgL_restz00_2073));
									}}}}}}}}
									BgL_res3753z00_2088 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2063)
										(BgL_method3472z00_2063, (obj_t) (BgL_arg3651z00_1402),
											BgL_stackz00_1397, BEOA));
								}
								BgL_arg3650z00_1401 = BgL_res3753z00_2088;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3650z00_1401), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 201 */
						BgL_nodez00_bglt BgL_arg3652z00_1403;

						{	/* Reduce/ftypec.scm 201 */
							BgL_nodez00_bglt BgL_arg3653z00_1404;

							BgL_arg3653z00_1404 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_msgz00);
							{	/* Reduce/ftypec.scm 201 */
								BgL_nodez00_bglt BgL_res3756z00_2119;

								{	/* Reduce/ftypec.scm 201 */
									obj_t BgL_method3472z00_2094;

									{	/* Reduce/ftypec.scm 201 */
										BgL_objectz00_bglt BgL_objz00_2095;

										BgL_objz00_2095 =
											(BgL_objectz00_bglt) (BgL_arg3653z00_1404);
										{	/* Reduce/ftypec.scm 201 */
											long BgL_objzd2classzd2numz00_2096;

											BgL_objzd2classzd2numz00_2096 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2095);
											{	/* Reduce/ftypec.scm 201 */
												obj_t BgL_arg2551z00_2097;

												BgL_arg2551z00_2097 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 201 */
													obj_t BgL_arrayz00_2099;

													int BgL_offsetz00_2100;

													BgL_arrayz00_2099 = BgL_arg2551z00_2097;
													BgL_offsetz00_2100 =
														(int) (BgL_objzd2classzd2numz00_2096);
													{	/* Reduce/ftypec.scm 201 */
														long BgL_offsetz00_2101;

														BgL_offsetz00_2101 =
															((long) (BgL_offsetz00_2100) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 201 */
															long BgL_modz00_2102;

															{	/* Reduce/ftypec.scm 201 */
																int BgL_arg2553z00_2103;

																BgL_arg2553z00_2103 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 201 */
																	long BgL_auxz00_3311;

																	BgL_auxz00_3311 =
																		(long) (BgL_arg2553z00_2103);
																	BgL_modz00_2102 =
																		(BgL_offsetz00_2101 / BgL_auxz00_3311);
															}}
															{	/* Reduce/ftypec.scm 201 */
																long BgL_restz00_2104;

																{	/* Reduce/ftypec.scm 201 */
																	int BgL_arg2552z00_2105;

																	BgL_arg2552z00_2105 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 201 */
																		long BgL_auxz00_3315;

																		BgL_auxz00_3315 =
																			(long) (BgL_arg2552z00_2105);
																		BgL_restz00_2104 =
																			(BgL_offsetz00_2101 % BgL_auxz00_3315);
																}}
																{	/* Reduce/ftypec.scm 201 */

																	BgL_method3472z00_2094 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2099,
																			(int) (BgL_modz00_2102)),
																		(int) (BgL_restz00_2104));
									}}}}}}}}
									BgL_res3756z00_2119 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2094)
										(BgL_method3472z00_2094, (obj_t) (BgL_arg3653z00_1404),
											BgL_stackz00_1397, BEOA));
								}
								BgL_arg3652z00_1403 = BgL_res3756z00_2119;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3652z00_1403), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 202 */
						BgL_nodez00_bglt BgL_arg3654z00_1405;

						{	/* Reduce/ftypec.scm 202 */
							BgL_nodez00_bglt BgL_arg3655z00_1406;

							BgL_arg3655z00_1406 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_objz00);
							{	/* Reduce/ftypec.scm 202 */
								BgL_nodez00_bglt BgL_res3759z00_2150;

								{	/* Reduce/ftypec.scm 202 */
									obj_t BgL_method3472z00_2125;

									{	/* Reduce/ftypec.scm 202 */
										BgL_objectz00_bglt BgL_objz00_2126;

										BgL_objz00_2126 =
											(BgL_objectz00_bglt) (BgL_arg3655z00_1406);
										{	/* Reduce/ftypec.scm 202 */
											long BgL_objzd2classzd2numz00_2127;

											BgL_objzd2classzd2numz00_2127 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2126);
											{	/* Reduce/ftypec.scm 202 */
												obj_t BgL_arg2551z00_2128;

												BgL_arg2551z00_2128 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 202 */
													obj_t BgL_arrayz00_2130;

													int BgL_offsetz00_2131;

													BgL_arrayz00_2130 = BgL_arg2551z00_2128;
													BgL_offsetz00_2131 =
														(int) (BgL_objzd2classzd2numz00_2127);
													{	/* Reduce/ftypec.scm 202 */
														long BgL_offsetz00_2132;

														BgL_offsetz00_2132 =
															((long) (BgL_offsetz00_2131) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 202 */
															long BgL_modz00_2133;

															{	/* Reduce/ftypec.scm 202 */
																int BgL_arg2553z00_2134;

																BgL_arg2553z00_2134 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 202 */
																	long BgL_auxz00_3336;

																	BgL_auxz00_3336 =
																		(long) (BgL_arg2553z00_2134);
																	BgL_modz00_2133 =
																		(BgL_offsetz00_2132 / BgL_auxz00_3336);
															}}
															{	/* Reduce/ftypec.scm 202 */
																long BgL_restz00_2135;

																{	/* Reduce/ftypec.scm 202 */
																	int BgL_arg2552z00_2136;

																	BgL_arg2552z00_2136 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 202 */
																		long BgL_auxz00_3340;

																		BgL_auxz00_3340 =
																			(long) (BgL_arg2552z00_2136);
																		BgL_restz00_2135 =
																			(BgL_offsetz00_2132 % BgL_auxz00_3340);
																}}
																{	/* Reduce/ftypec.scm 202 */

																	BgL_method3472z00_2125 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2130,
																			(int) (BgL_modz00_2133)),
																		(int) (BgL_restz00_2135));
									}}}}}}}}
									BgL_res3759z00_2150 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_2125)
										(BgL_method3472z00_2125, (obj_t) (BgL_arg3655z00_1406),
											BgL_stackz00_1397, BEOA));
								}
								BgL_arg3654z00_1405 = BgL_res3759z00_2150;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1396))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3654z00_1405), BUNSPEC);
					}
					BgL_auxz00_3276 = BgL_nodez00_1396;
					return (obj_t) (BgL_auxz00_3276);
				}
			}
		}
	}



/* node-typec!-conditio3486 */
	obj_t BGl_nodezd2typecz12zd2conditio3486z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2664, obj_t BgL_nodez00_2665, obj_t BgL_stackz00_2666)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 133 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1307;

				obj_t BgL_stackz00_1308;

				BgL_nodez00_1307 = (BgL_conditionalz00_bglt) (BgL_nodez00_2665);
				BgL_stackz00_1308 = BgL_stackz00_2666;
				{
					BgL_nodez00_bglt BgL_nodez00_1370;

					{	/* Reduce/ftypec.scm 169 */
						BgL_nodez00_bglt BgL_arg3596z00_1314;

						{	/* Reduce/ftypec.scm 169 */
							BgL_nodez00_bglt BgL_arg3597z00_1315;

							BgL_arg3597z00_1315 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
								BgL_testz00);
							{	/* Reduce/ftypec.scm 169 */
								BgL_nodez00_bglt BgL_res3732z00_1840;

								{	/* Reduce/ftypec.scm 169 */
									obj_t BgL_method3472z00_1815;

									{	/* Reduce/ftypec.scm 169 */
										BgL_objectz00_bglt BgL_objz00_1816;

										BgL_objz00_1816 =
											(BgL_objectz00_bglt) (BgL_arg3597z00_1315);
										{	/* Reduce/ftypec.scm 169 */
											long BgL_objzd2classzd2numz00_1817;

											BgL_objzd2classzd2numz00_1817 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1816);
											{	/* Reduce/ftypec.scm 169 */
												obj_t BgL_arg2551z00_1818;

												BgL_arg2551z00_1818 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 169 */
													obj_t BgL_arrayz00_1820;

													int BgL_offsetz00_1821;

													BgL_arrayz00_1820 = BgL_arg2551z00_1818;
													BgL_offsetz00_1821 =
														(int) (BgL_objzd2classzd2numz00_1817);
													{	/* Reduce/ftypec.scm 169 */
														long BgL_offsetz00_1822;

														BgL_offsetz00_1822 =
															((long) (BgL_offsetz00_1821) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 169 */
															long BgL_modz00_1823;

															{	/* Reduce/ftypec.scm 169 */
																int BgL_arg2553z00_1824;

																BgL_arg2553z00_1824 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 169 */
																	long BgL_auxz00_3363;

																	BgL_auxz00_3363 =
																		(long) (BgL_arg2553z00_1824);
																	BgL_modz00_1823 =
																		(BgL_offsetz00_1822 / BgL_auxz00_3363);
															}}
															{	/* Reduce/ftypec.scm 169 */
																long BgL_restz00_1825;

																{	/* Reduce/ftypec.scm 169 */
																	int BgL_arg2552z00_1826;

																	BgL_arg2552z00_1826 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 169 */
																		long BgL_auxz00_3367;

																		BgL_auxz00_3367 =
																			(long) (BgL_arg2552z00_1826);
																		BgL_restz00_1825 =
																			(BgL_offsetz00_1822 % BgL_auxz00_3367);
																}}
																{	/* Reduce/ftypec.scm 169 */

																	BgL_method3472z00_1815 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1820,
																			(int) (BgL_modz00_1823)),
																		(int) (BgL_restz00_1825));
									}}}}}}}}
									BgL_res3732z00_1840 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1815)
										(BgL_method3472z00_1815, (obj_t) (BgL_arg3597z00_1315),
											BgL_stackz00_1308, BEOA));
								}
								BgL_arg3596z00_1314 = BgL_res3732z00_1840;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3596z00_1314), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 170 */
						obj_t BgL_typecz00_1316;

						BgL_nodez00_1370 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->BgL_testz00);
						{	/* Reduce/ftypec.scm 135 */
							bool_t BgL_testz00_3379;

							{	/* Reduce/ftypec.scm 135 */
								obj_t BgL_obj2183z00_2043;

								BgL_obj2183z00_2043 = (obj_t) (BgL_nodez00_1370);
								BgL_testz00_3379 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2183z00_2043,
									BGl_appz00zzast_nodez00);
							}
							if (BgL_testz00_3379)
								{	/* Reduce/ftypec.scm 137 */
									bool_t BgL_testz00_3382;

									{	/* Reduce/ftypec.scm 137 */
										obj_t BgL_auxz00_3383;

										{
											BgL_appz00_bglt BgL_auxz00_3384;

											BgL_auxz00_3384 = (BgL_appz00_bglt) (BgL_nodez00_1370);
											BgL_auxz00_3383 =
												(((BgL_appz00_bglt) CREF(BgL_auxz00_3384))->
												BgL_argsz00);
										}
										BgL_testz00_3382 = PAIRP(BgL_auxz00_3383);
									}
									if (BgL_testz00_3382)
										{	/* Reduce/ftypec.scm 138 */
											bool_t BgL_testz00_3388;

											{	/* Reduce/ftypec.scm 138 */
												obj_t BgL_auxz00_3389;

												{	/* Reduce/ftypec.scm 138 */
													obj_t BgL_pairz00_2047;

													{
														BgL_appz00_bglt BgL_auxz00_3390;

														BgL_auxz00_3390 =
															(BgL_appz00_bglt) (BgL_nodez00_1370);
														BgL_pairz00_2047 =
															(((BgL_appz00_bglt) CREF(BgL_auxz00_3390))->
															BgL_argsz00);
													}
													BgL_auxz00_3389 = CDR(BgL_pairz00_2047);
												}
												BgL_testz00_3388 = NULLP(BgL_auxz00_3389);
											}
											if (BgL_testz00_3388)
												{	/* Reduce/ftypec.scm 139 */
													bool_t BgL_testz00_3395;

													{	/* Reduce/ftypec.scm 139 */
														obj_t BgL_arg3644z00_1387;

														{	/* Reduce/ftypec.scm 139 */
															obj_t BgL_pairz00_2050;

															{
																BgL_appz00_bglt BgL_auxz00_3396;

																BgL_auxz00_3396 =
																	(BgL_appz00_bglt) (BgL_nodez00_1370);
																BgL_pairz00_2050 =
																	(((BgL_appz00_bglt) CREF(BgL_auxz00_3396))->
																	BgL_argsz00);
															}
															BgL_arg3644z00_1387 = CAR(BgL_pairz00_2050);
														}
														BgL_testz00_3395 =
															BGl_iszd2azf3z21zz__objectz00(BgL_arg3644z00_1387,
															BGl_varz00zzast_nodez00);
													}
													if (BgL_testz00_3395)
														{	/* Reduce/ftypec.scm 140 */
															bool_t BgL_testz00_3401;

															{	/* Reduce/ftypec.scm 140 */
																obj_t BgL_auxz00_3402;

																{	/* Reduce/ftypec.scm 140 */
																	BgL_variablez00_bglt BgL_arg3641z00_1384;

																	{	/* Reduce/ftypec.scm 140 */
																		BgL_varz00_bglt BgL_obj2061z00_2054;

																		{	/* Reduce/ftypec.scm 140 */
																			obj_t BgL_auxz00_3403;

																			{	/* Reduce/ftypec.scm 140 */
																				obj_t BgL_pairz00_2053;

																				{
																					BgL_appz00_bglt BgL_auxz00_3404;

																					BgL_auxz00_3404 =
																						(BgL_appz00_bglt)
																						(BgL_nodez00_1370);
																					BgL_pairz00_2053 =
																						(((BgL_appz00_bglt)
																							CREF(BgL_auxz00_3404))->
																						BgL_argsz00);
																				}
																				BgL_auxz00_3403 = CAR(BgL_pairz00_2053);
																			}
																			BgL_obj2061z00_2054 =
																				(BgL_varz00_bglt) (BgL_auxz00_3403);
																		}
																		BgL_arg3641z00_1384 =
																			(((BgL_varz00_bglt)
																				CREF(BgL_obj2061z00_2054))->
																			BgL_variablez00);
																	}
																	BgL_auxz00_3402 =
																		(((BgL_variablez00_bglt)
																			CREF(BgL_arg3641z00_1384))->
																		BgL_accessz00);
																}
																BgL_testz00_3401 =
																	(BgL_auxz00_3402 ==
																	CNST_TABLE_REF(((long) 1)));
															}
															if (BgL_testz00_3401)
																{	/* Reduce/ftypec.scm 141 */
																	BgL_varz00_bglt BgL_funz00_1378;

																	{
																		BgL_appz00_bglt BgL_auxz00_3413;

																		BgL_auxz00_3413 =
																			(BgL_appz00_bglt) (BgL_nodez00_1370);
																		BgL_funz00_1378 =
																			(((BgL_appz00_bglt)
																				CREF(BgL_auxz00_3413))->BgL_funz00);
																	}
																	{	/* Reduce/ftypec.scm 143 */

																		{	/* Reduce/ftypec.scm 143 */
																			BgL_funz00_bglt BgL_obj1725z00_2059;

																			{	/* Reduce/ftypec.scm 143 */
																				BgL_valuez00_bglt BgL_auxz00_3416;

																				{	/* Reduce/ftypec.scm 142 */
																					BgL_variablez00_bglt
																						BgL_obj1518z00_2058;
																					BgL_obj1518z00_2058 =
																						(((BgL_varz00_bglt)
																							CREF(BgL_funz00_1378))->
																						BgL_variablez00);
																					BgL_auxz00_3416 =
																						(((BgL_variablez00_bglt)
																							CREF(BgL_obj1518z00_2058))->
																						BgL_valuez00);
																				}
																				BgL_obj1725z00_2059 =
																					(BgL_funz00_bglt) (BgL_auxz00_3416);
																			}
																			BgL_typecz00_1316 =
																				(((BgL_funz00_bglt)
																					CREF(BgL_obj1725z00_2059))->
																				BgL_predicatezd2ofzd2);
																		}
																	}
																}
															else
																{	/* Reduce/ftypec.scm 140 */
																	BgL_typecz00_1316 = BFALSE;
																}
														}
													else
														{	/* Reduce/ftypec.scm 139 */
															BgL_typecz00_1316 = BFALSE;
														}
												}
											else
												{	/* Reduce/ftypec.scm 138 */
													BgL_typecz00_1316 = BFALSE;
												}
										}
									else
										{	/* Reduce/ftypec.scm 137 */
											BgL_typecz00_1316 = BFALSE;
										}
								}
							else
								{	/* Reduce/ftypec.scm 135 */
									BgL_typecz00_1316 = BFALSE;
								}
						}
						if (BGl_iszd2azf3z21zz__objectz00(BgL_typecz00_1316,
								BGl_typez00zztype_typez00))
							{	/* Reduce/ftypec.scm 176 */
								obj_t BgL_argsz00_1318;

								{	/* Reduce/ftypec.scm 176 */
									BgL_appz00_bglt BgL_obj2159z00_1846;

									BgL_obj2159z00_1846 =
										(BgL_appz00_bglt) (
										(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
											BgL_testz00));
									BgL_argsz00_1318 =
										(((BgL_appz00_bglt) CREF(BgL_obj2159z00_1846))->
										BgL_argsz00);
								}
								{	/* Reduce/ftypec.scm 176 */
									BgL_variablez00_bglt BgL_varz00_1319;

									{	/* Reduce/ftypec.scm 177 */
										BgL_varz00_bglt BgL_obj2061z00_1848;

										{	/* Reduce/ftypec.scm 177 */
											obj_t BgL_pairz00_1847;

											BgL_pairz00_1847 = BgL_argsz00_1318;
											BgL_obj2061z00_1848 =
												(BgL_varz00_bglt) (CAR(BgL_pairz00_1847));
										}
										BgL_varz00_1319 =
											(((BgL_varz00_bglt) CREF(BgL_obj2061z00_1848))->
											BgL_variablez00);
									}
									{	/* Reduce/ftypec.scm 177 */
										obj_t BgL_typesz00_1320;

										BgL_typesz00_1320 =
											BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
											(obj_t) (BgL_varz00_1319), BgL_stackz00_1308);
										{	/* Reduce/ftypec.scm 178 */
											obj_t BgL_tzd2stackzd2_1321;

											{	/* Reduce/ftypec.scm 179 */
												obj_t BgL_arg3611z00_1335;

												{	/* Reduce/ftypec.scm 179 */
													obj_t BgL_arg3612z00_1336;

													BgL_arg3612z00_1336 =
														MAKE_PAIR(BgL_typecz00_1316, BTRUE);
													BgL_arg3611z00_1335 =
														MAKE_PAIR(
														(obj_t) (BgL_varz00_1319), BgL_arg3612z00_1336);
												}
												BgL_tzd2stackzd2_1321 =
													MAKE_PAIR(BgL_arg3611z00_1335, BgL_stackz00_1308);
											}
											{	/* Reduce/ftypec.scm 179 */
												obj_t BgL_fzd2stackzd2_1322;

												{	/* Reduce/ftypec.scm 180 */
													obj_t BgL_arg3609z00_1333;

													{	/* Reduce/ftypec.scm 180 */
														obj_t BgL_arg3610z00_1334;

														BgL_arg3610z00_1334 =
															MAKE_PAIR(BgL_typecz00_1316, BFALSE);
														BgL_arg3609z00_1333 =
															MAKE_PAIR(
															(obj_t) (BgL_varz00_1319), BgL_arg3610z00_1334);
													}
													BgL_fzd2stackzd2_1322 =
														MAKE_PAIR(BgL_arg3609z00_1333, BgL_stackz00_1308);
												}
												{	/* Reduce/ftypec.scm 180 */

													{	/* Reduce/ftypec.scm 181 */
														bool_t BgL_testz00_3440;

														if (CBOOL(BgL_typesz00_1320))
															{	/* Reduce/ftypec.scm 181 */
																bool_t BgL_testz00_3443;

																{	/* Reduce/ftypec.scm 181 */
																	obj_t BgL_auxz00_3444;

																	{	/* Reduce/ftypec.scm 181 */
																		obj_t BgL_pairz00_1849;

																		BgL_pairz00_1849 = BgL_typesz00_1320;
																		BgL_auxz00_3444 =
																			CAR(CDR(BgL_pairz00_1849));
																	}
																	BgL_testz00_3443 =
																		(BgL_auxz00_3444 == BgL_typecz00_1316);
																}
																if (BgL_testz00_3443)
																	{	/* Reduce/ftypec.scm 181 */
																		BgL_testz00_3440 = ((bool_t) 0);
																	}
																else
																	{	/* Reduce/ftypec.scm 181 */
																		BgL_testz00_3440 = ((bool_t) 1);
																	}
															}
														else
															{	/* Reduce/ftypec.scm 181 */
																BgL_testz00_3440 = ((bool_t) 1);
															}
														if (BgL_testz00_3440)
															{	/* Reduce/ftypec.scm 181 */
																BGl_za2typezd2checkszd2remainingza2z00zzreduce_flowzd2typeczd2
																	=
																	(((long) 1) +
																	BGl_za2typezd2checkszd2remainingza2z00zzreduce_flowzd2typeczd2);
																{	/* Reduce/ftypec.scm 185 */
																	BgL_nodez00_bglt BgL_arg3600z00_1324;

																	{	/* Reduce/ftypec.scm 185 */
																		BgL_nodez00_bglt BgL_arg3601z00_1325;

																		BgL_arg3601z00_1325 =
																			(((BgL_conditionalz00_bglt)
																				CREF(BgL_nodez00_1307))->BgL_truez00);
																		{	/* Reduce/ftypec.scm 185 */
																			BgL_nodez00_bglt BgL_res3735z00_1883;

																			{	/* Reduce/ftypec.scm 185 */
																				obj_t BgL_method3472z00_1858;

																				{	/* Reduce/ftypec.scm 185 */
																					BgL_objectz00_bglt BgL_objz00_1859;

																					BgL_objz00_1859 =
																						(BgL_objectz00_bglt)
																						(BgL_arg3601z00_1325);
																					{	/* Reduce/ftypec.scm 185 */
																						long BgL_objzd2classzd2numz00_1860;

																						BgL_objzd2classzd2numz00_1860 =
																							BGL_OBJECT_CLASS_NUM
																							(BgL_objz00_1859);
																						{	/* Reduce/ftypec.scm 185 */
																							obj_t BgL_arg2551z00_1861;

																							BgL_arg2551z00_1861 =
																								PROCEDURE_REF
																								(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																								(int) (((long) 1)));
																							{	/* Reduce/ftypec.scm 185 */
																								obj_t BgL_arrayz00_1863;

																								int BgL_offsetz00_1864;

																								BgL_arrayz00_1863 =
																									BgL_arg2551z00_1861;
																								BgL_offsetz00_1864 =
																									(int)
																									(BgL_objzd2classzd2numz00_1860);
																								{	/* Reduce/ftypec.scm 185 */
																									long BgL_offsetz00_1865;

																									BgL_offsetz00_1865 =
																										(
																										(long) (BgL_offsetz00_1864)
																										- OBJECT_TYPE);
																									{	/* Reduce/ftypec.scm 185 */
																										long BgL_modz00_1866;

																										{	/* Reduce/ftypec.scm 185 */
																											int BgL_arg2553z00_1867;

																											BgL_arg2553z00_1867 =
																												(int) (((long) 8));
																											{	/* Reduce/ftypec.scm 185 */
																												long BgL_auxz00_3458;

																												BgL_auxz00_3458 =
																													(long)
																													(BgL_arg2553z00_1867);
																												BgL_modz00_1866 =
																													(BgL_offsetz00_1865 /
																													BgL_auxz00_3458);
																										}}
																										{	/* Reduce/ftypec.scm 185 */
																											long BgL_restz00_1868;

																											{	/* Reduce/ftypec.scm 185 */
																												int BgL_arg2552z00_1869;

																												BgL_arg2552z00_1869 =
																													(int) (((long) 8));
																												{	/* Reduce/ftypec.scm 185 */
																													long BgL_auxz00_3462;

																													BgL_auxz00_3462 =
																														(long)
																														(BgL_arg2552z00_1869);
																													BgL_restz00_1868 =
																														(BgL_offsetz00_1865
																														% BgL_auxz00_3462);
																											}}
																											{	/* Reduce/ftypec.scm 185 */

																												BgL_method3472z00_1858 =
																													VECTOR_REF(VECTOR_REF
																													(BgL_arrayz00_1863,
																														(int)
																														(BgL_modz00_1866)),
																													(int)
																													(BgL_restz00_1868));
																				}}}}}}}}
																				BgL_res3735z00_1883 =
																					(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																					(BgL_method3472z00_1858)
																					(BgL_method3472z00_1858,
																						(obj_t) (BgL_arg3601z00_1325),
																						BgL_tzd2stackzd2_1321, BEOA));
																			}
																			BgL_arg3600z00_1324 = BgL_res3735z00_1883;
																	}}
																	((((BgL_conditionalz00_bglt)
																				CREF(BgL_nodez00_1307))->BgL_truez00) =
																		((BgL_nodez00_bglt) BgL_arg3600z00_1324),
																		BUNSPEC);
																}
																{	/* Reduce/ftypec.scm 186 */
																	BgL_nodez00_bglt BgL_arg3602z00_1326;

																	{	/* Reduce/ftypec.scm 186 */
																		BgL_nodez00_bglt BgL_arg3603z00_1327;

																		BgL_arg3603z00_1327 =
																			(((BgL_conditionalz00_bglt)
																				CREF(BgL_nodez00_1307))->BgL_falsez00);
																		{	/* Reduce/ftypec.scm 186 */
																			BgL_nodez00_bglt BgL_res3738z00_1914;

																			{	/* Reduce/ftypec.scm 186 */
																				obj_t BgL_method3472z00_1889;

																				{	/* Reduce/ftypec.scm 186 */
																					BgL_objectz00_bglt BgL_objz00_1890;

																					BgL_objz00_1890 =
																						(BgL_objectz00_bglt)
																						(BgL_arg3603z00_1327);
																					{	/* Reduce/ftypec.scm 186 */
																						long BgL_objzd2classzd2numz00_1891;

																						BgL_objzd2classzd2numz00_1891 =
																							BGL_OBJECT_CLASS_NUM
																							(BgL_objz00_1890);
																						{	/* Reduce/ftypec.scm 186 */
																							obj_t BgL_arg2551z00_1892;

																							BgL_arg2551z00_1892 =
																								PROCEDURE_REF
																								(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																								(int) (((long) 1)));
																							{	/* Reduce/ftypec.scm 186 */
																								obj_t BgL_arrayz00_1894;

																								int BgL_offsetz00_1895;

																								BgL_arrayz00_1894 =
																									BgL_arg2551z00_1892;
																								BgL_offsetz00_1895 =
																									(int)
																									(BgL_objzd2classzd2numz00_1891);
																								{	/* Reduce/ftypec.scm 186 */
																									long BgL_offsetz00_1896;

																									BgL_offsetz00_1896 =
																										(
																										(long) (BgL_offsetz00_1895)
																										- OBJECT_TYPE);
																									{	/* Reduce/ftypec.scm 186 */
																										long BgL_modz00_1897;

																										{	/* Reduce/ftypec.scm 186 */
																											int BgL_arg2553z00_1898;

																											BgL_arg2553z00_1898 =
																												(int) (((long) 8));
																											{	/* Reduce/ftypec.scm 186 */
																												long BgL_auxz00_3483;

																												BgL_auxz00_3483 =
																													(long)
																													(BgL_arg2553z00_1898);
																												BgL_modz00_1897 =
																													(BgL_offsetz00_1896 /
																													BgL_auxz00_3483);
																										}}
																										{	/* Reduce/ftypec.scm 186 */
																											long BgL_restz00_1899;

																											{	/* Reduce/ftypec.scm 186 */
																												int BgL_arg2552z00_1900;

																												BgL_arg2552z00_1900 =
																													(int) (((long) 8));
																												{	/* Reduce/ftypec.scm 186 */
																													long BgL_auxz00_3487;

																													BgL_auxz00_3487 =
																														(long)
																														(BgL_arg2552z00_1900);
																													BgL_restz00_1899 =
																														(BgL_offsetz00_1896
																														% BgL_auxz00_3487);
																											}}
																											{	/* Reduce/ftypec.scm 186 */

																												BgL_method3472z00_1889 =
																													VECTOR_REF(VECTOR_REF
																													(BgL_arrayz00_1894,
																														(int)
																														(BgL_modz00_1897)),
																													(int)
																													(BgL_restz00_1899));
																				}}}}}}}}
																				BgL_res3738z00_1914 =
																					(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																					(BgL_method3472z00_1889)
																					(BgL_method3472z00_1889,
																						(obj_t) (BgL_arg3603z00_1327),
																						BgL_fzd2stackzd2_1322, BEOA));
																			}
																			BgL_arg3602z00_1326 = BgL_res3738z00_1914;
																	}}
																	((((BgL_conditionalz00_bglt)
																				CREF(BgL_nodez00_1307))->BgL_falsez00) =
																		((BgL_nodez00_bglt) BgL_arg3602z00_1326),
																		BUNSPEC);
																}
																return (obj_t) (BgL_nodez00_1307);
															}
														else
															{	/* Reduce/ftypec.scm 181 */
																BGl_za2typezd2checkszd2removedza2z00zzreduce_flowzd2typeczd2
																	=
																	(((long) 1) +
																	BGl_za2typezd2checkszd2removedza2z00zzreduce_flowzd2typeczd2);
																{	/* Reduce/ftypec.scm 191 */
																	bool_t BgL_testz00_3501;

																	{	/* Reduce/ftypec.scm 191 */
																		obj_t BgL_pairz00_1919;

																		BgL_pairz00_1919 = BgL_typesz00_1320;
																		{	/* Reduce/ftypec.scm 191 */
																			obj_t BgL_pairz00_1922;

																			BgL_pairz00_1922 = CDR(BgL_pairz00_1919);
																			BgL_testz00_3501 =
																				CBOOL(CDR(BgL_pairz00_1922));
																	}}
																	if (BgL_testz00_3501)
																		{	/* Reduce/ftypec.scm 192 */
																			BgL_nodez00_bglt BgL_arg3605z00_1329;

																			BgL_arg3605z00_1329 =
																				(((BgL_conditionalz00_bglt)
																					CREF(BgL_nodez00_1307))->BgL_truez00);
																			{	/* Reduce/ftypec.scm 192 */
																				BgL_nodez00_bglt BgL_res3741z00_1951;

																				{	/* Reduce/ftypec.scm 192 */
																					obj_t BgL_method3472z00_1926;

																					{	/* Reduce/ftypec.scm 192 */
																						BgL_objectz00_bglt BgL_objz00_1927;

																						BgL_objz00_1927 =
																							(BgL_objectz00_bglt)
																							(BgL_arg3605z00_1329);
																						{	/* Reduce/ftypec.scm 192 */
																							long
																								BgL_objzd2classzd2numz00_1928;
																							BgL_objzd2classzd2numz00_1928 =
																								BGL_OBJECT_CLASS_NUM
																								(BgL_objz00_1927);
																							{	/* Reduce/ftypec.scm 192 */
																								obj_t BgL_arg2551z00_1929;

																								BgL_arg2551z00_1929 =
																									PROCEDURE_REF
																									(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																									(int) (((long) 1)));
																								{	/* Reduce/ftypec.scm 192 */
																									obj_t BgL_arrayz00_1931;

																									int BgL_offsetz00_1932;

																									BgL_arrayz00_1931 =
																										BgL_arg2551z00_1929;
																									BgL_offsetz00_1932 =
																										(int)
																										(BgL_objzd2classzd2numz00_1928);
																									{	/* Reduce/ftypec.scm 192 */
																										long BgL_offsetz00_1933;

																										BgL_offsetz00_1933 =
																											(
																											(long)
																											(BgL_offsetz00_1932) -
																											OBJECT_TYPE);
																										{	/* Reduce/ftypec.scm 192 */
																											long BgL_modz00_1934;

																											{	/* Reduce/ftypec.scm 192 */
																												int BgL_arg2553z00_1935;

																												BgL_arg2553z00_1935 =
																													(int) (((long) 8));
																												{	/* Reduce/ftypec.scm 192 */
																													long BgL_auxz00_3514;

																													BgL_auxz00_3514 =
																														(long)
																														(BgL_arg2553z00_1935);
																													BgL_modz00_1934 =
																														(BgL_offsetz00_1933
																														/ BgL_auxz00_3514);
																											}}
																											{	/* Reduce/ftypec.scm 192 */
																												long BgL_restz00_1936;

																												{	/* Reduce/ftypec.scm 192 */
																													int
																														BgL_arg2552z00_1937;
																													BgL_arg2552z00_1937 =
																														(int) (((long) 8));
																													{	/* Reduce/ftypec.scm 192 */
																														long
																															BgL_auxz00_3518;
																														BgL_auxz00_3518 =
																															(long)
																															(BgL_arg2552z00_1937);
																														BgL_restz00_1936 =
																															(BgL_offsetz00_1933
																															%
																															BgL_auxz00_3518);
																												}}
																												{	/* Reduce/ftypec.scm 192 */

																													BgL_method3472z00_1926
																														=
																														VECTOR_REF
																														(VECTOR_REF
																														(BgL_arrayz00_1931,
																															(int)
																															(BgL_modz00_1934)),
																														(int)
																														(BgL_restz00_1936));
																					}}}}}}}}
																					BgL_res3741z00_1951 =
																						(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																						(BgL_method3472z00_1926)
																						(BgL_method3472z00_1926,
																							(obj_t) (BgL_arg3605z00_1329),
																							BgL_tzd2stackzd2_1321, BEOA));
																				}
																				return (obj_t) (BgL_res3741z00_1951);
																			}
																		}
																	else
																		{	/* Reduce/ftypec.scm 193 */
																			BgL_nodez00_bglt BgL_arg3606z00_1330;

																			BgL_arg3606z00_1330 =
																				(((BgL_conditionalz00_bglt)
																					CREF(BgL_nodez00_1307))->
																				BgL_falsez00);
																			{	/* Reduce/ftypec.scm 193 */
																				BgL_nodez00_bglt BgL_res3744z00_1980;

																				{	/* Reduce/ftypec.scm 193 */
																					obj_t BgL_method3472z00_1955;

																					{	/* Reduce/ftypec.scm 193 */
																						BgL_objectz00_bglt BgL_objz00_1956;

																						BgL_objz00_1956 =
																							(BgL_objectz00_bglt)
																							(BgL_arg3606z00_1330);
																						{	/* Reduce/ftypec.scm 193 */
																							long
																								BgL_objzd2classzd2numz00_1957;
																							BgL_objzd2classzd2numz00_1957 =
																								BGL_OBJECT_CLASS_NUM
																								(BgL_objz00_1956);
																							{	/* Reduce/ftypec.scm 193 */
																								obj_t BgL_arg2551z00_1958;

																								BgL_arg2551z00_1958 =
																									PROCEDURE_REF
																									(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																									(int) (((long) 1)));
																								{	/* Reduce/ftypec.scm 193 */
																									obj_t BgL_arrayz00_1960;

																									int BgL_offsetz00_1961;

																									BgL_arrayz00_1960 =
																										BgL_arg2551z00_1958;
																									BgL_offsetz00_1961 =
																										(int)
																										(BgL_objzd2classzd2numz00_1957);
																									{	/* Reduce/ftypec.scm 193 */
																										long BgL_offsetz00_1962;

																										BgL_offsetz00_1962 =
																											(
																											(long)
																											(BgL_offsetz00_1961) -
																											OBJECT_TYPE);
																										{	/* Reduce/ftypec.scm 193 */
																											long BgL_modz00_1963;

																											{	/* Reduce/ftypec.scm 193 */
																												int BgL_arg2553z00_1964;

																												BgL_arg2553z00_1964 =
																													(int) (((long) 8));
																												{	/* Reduce/ftypec.scm 193 */
																													long BgL_auxz00_3539;

																													BgL_auxz00_3539 =
																														(long)
																														(BgL_arg2553z00_1964);
																													BgL_modz00_1963 =
																														(BgL_offsetz00_1962
																														/ BgL_auxz00_3539);
																											}}
																											{	/* Reduce/ftypec.scm 193 */
																												long BgL_restz00_1965;

																												{	/* Reduce/ftypec.scm 193 */
																													int
																														BgL_arg2552z00_1966;
																													BgL_arg2552z00_1966 =
																														(int) (((long) 8));
																													{	/* Reduce/ftypec.scm 193 */
																														long
																															BgL_auxz00_3543;
																														BgL_auxz00_3543 =
																															(long)
																															(BgL_arg2552z00_1966);
																														BgL_restz00_1965 =
																															(BgL_offsetz00_1962
																															%
																															BgL_auxz00_3543);
																												}}
																												{	/* Reduce/ftypec.scm 193 */

																													BgL_method3472z00_1955
																														=
																														VECTOR_REF
																														(VECTOR_REF
																														(BgL_arrayz00_1960,
																															(int)
																															(BgL_modz00_1963)),
																														(int)
																														(BgL_restz00_1965));
																					}}}}}}}}
																					BgL_res3744z00_1980 =
																						(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																						(BgL_method3472z00_1955)
																						(BgL_method3472z00_1955,
																							(obj_t) (BgL_arg3606z00_1330),
																							BgL_fzd2stackzd2_1322, BEOA));
																				}
																				return (obj_t) (BgL_res3744z00_1980);
																			}
																		}
																}
															}
													}
												}
											}
										}
									}
								}
							}
						else
							{	/* Reduce/ftypec.scm 171 */
								{	/* Reduce/ftypec.scm 173 */
									BgL_nodez00_bglt BgL_arg3615z00_1339;

									{	/* Reduce/ftypec.scm 173 */
										BgL_nodez00_bglt BgL_arg3616z00_1340;

										BgL_arg3616z00_1340 =
											(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
											BgL_truez00);
										{	/* Reduce/ftypec.scm 173 */
											BgL_nodez00_bglt BgL_res3747z00_2009;

											{	/* Reduce/ftypec.scm 173 */
												obj_t BgL_method3472z00_1984;

												{	/* Reduce/ftypec.scm 173 */
													BgL_objectz00_bglt BgL_objz00_1985;

													BgL_objz00_1985 =
														(BgL_objectz00_bglt) (BgL_arg3616z00_1340);
													{	/* Reduce/ftypec.scm 173 */
														long BgL_objzd2classzd2numz00_1986;

														BgL_objzd2classzd2numz00_1986 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1985);
														{	/* Reduce/ftypec.scm 173 */
															obj_t BgL_arg2551z00_1987;

															BgL_arg2551z00_1987 =
																PROCEDURE_REF
																(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																(int) (((long) 1)));
															{	/* Reduce/ftypec.scm 173 */
																obj_t BgL_arrayz00_1989;

																int BgL_offsetz00_1990;

																BgL_arrayz00_1989 = BgL_arg2551z00_1987;
																BgL_offsetz00_1990 =
																	(int) (BgL_objzd2classzd2numz00_1986);
																{	/* Reduce/ftypec.scm 173 */
																	long BgL_offsetz00_1991;

																	BgL_offsetz00_1991 =
																		((long) (BgL_offsetz00_1990) - OBJECT_TYPE);
																	{	/* Reduce/ftypec.scm 173 */
																		long BgL_modz00_1992;

																		{	/* Reduce/ftypec.scm 173 */
																			int BgL_arg2553z00_1993;

																			BgL_arg2553z00_1993 = (int) (((long) 8));
																			{	/* Reduce/ftypec.scm 173 */
																				long BgL_auxz00_3564;

																				BgL_auxz00_3564 =
																					(long) (BgL_arg2553z00_1993);
																				BgL_modz00_1992 =
																					(BgL_offsetz00_1991 /
																					BgL_auxz00_3564);
																		}}
																		{	/* Reduce/ftypec.scm 173 */
																			long BgL_restz00_1994;

																			{	/* Reduce/ftypec.scm 173 */
																				int BgL_arg2552z00_1995;

																				BgL_arg2552z00_1995 =
																					(int) (((long) 8));
																				{	/* Reduce/ftypec.scm 173 */
																					long BgL_auxz00_3568;

																					BgL_auxz00_3568 =
																						(long) (BgL_arg2552z00_1995);
																					BgL_restz00_1994 =
																						(BgL_offsetz00_1991 %
																						BgL_auxz00_3568);
																			}}
																			{	/* Reduce/ftypec.scm 173 */

																				BgL_method3472z00_1984 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1989,
																						(int) (BgL_modz00_1992)),
																					(int) (BgL_restz00_1994));
												}}}}}}}}
												BgL_res3747z00_2009 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3472z00_1984) (BgL_method3472z00_1984,
														(obj_t) (BgL_arg3616z00_1340), BgL_stackz00_1308,
														BEOA));
											}
											BgL_arg3615z00_1339 = BgL_res3747z00_2009;
									}}
									((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
											BgL_truez00) =
										((BgL_nodez00_bglt) BgL_arg3615z00_1339), BUNSPEC);
								}
								{	/* Reduce/ftypec.scm 174 */
									BgL_nodez00_bglt BgL_arg3617z00_1341;

									{	/* Reduce/ftypec.scm 174 */
										BgL_nodez00_bglt BgL_arg3618z00_1342;

										BgL_arg3618z00_1342 =
											(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
											BgL_falsez00);
										{	/* Reduce/ftypec.scm 174 */
											BgL_nodez00_bglt BgL_res3750z00_2040;

											{	/* Reduce/ftypec.scm 174 */
												obj_t BgL_method3472z00_2015;

												{	/* Reduce/ftypec.scm 174 */
													BgL_objectz00_bglt BgL_objz00_2016;

													BgL_objz00_2016 =
														(BgL_objectz00_bglt) (BgL_arg3618z00_1342);
													{	/* Reduce/ftypec.scm 174 */
														long BgL_objzd2classzd2numz00_2017;

														BgL_objzd2classzd2numz00_2017 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2016);
														{	/* Reduce/ftypec.scm 174 */
															obj_t BgL_arg2551z00_2018;

															BgL_arg2551z00_2018 =
																PROCEDURE_REF
																(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
																(int) (((long) 1)));
															{	/* Reduce/ftypec.scm 174 */
																obj_t BgL_arrayz00_2020;

																int BgL_offsetz00_2021;

																BgL_arrayz00_2020 = BgL_arg2551z00_2018;
																BgL_offsetz00_2021 =
																	(int) (BgL_objzd2classzd2numz00_2017);
																{	/* Reduce/ftypec.scm 174 */
																	long BgL_offsetz00_2022;

																	BgL_offsetz00_2022 =
																		((long) (BgL_offsetz00_2021) - OBJECT_TYPE);
																	{	/* Reduce/ftypec.scm 174 */
																		long BgL_modz00_2023;

																		{	/* Reduce/ftypec.scm 174 */
																			int BgL_arg2553z00_2024;

																			BgL_arg2553z00_2024 = (int) (((long) 8));
																			{	/* Reduce/ftypec.scm 174 */
																				long BgL_auxz00_3589;

																				BgL_auxz00_3589 =
																					(long) (BgL_arg2553z00_2024);
																				BgL_modz00_2023 =
																					(BgL_offsetz00_2022 /
																					BgL_auxz00_3589);
																		}}
																		{	/* Reduce/ftypec.scm 174 */
																			long BgL_restz00_2025;

																			{	/* Reduce/ftypec.scm 174 */
																				int BgL_arg2552z00_2026;

																				BgL_arg2552z00_2026 =
																					(int) (((long) 8));
																				{	/* Reduce/ftypec.scm 174 */
																					long BgL_auxz00_3593;

																					BgL_auxz00_3593 =
																						(long) (BgL_arg2552z00_2026);
																					BgL_restz00_2025 =
																						(BgL_offsetz00_2022 %
																						BgL_auxz00_3593);
																			}}
																			{	/* Reduce/ftypec.scm 174 */

																				BgL_method3472z00_2015 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2020,
																						(int) (BgL_modz00_2023)),
																					(int) (BgL_restz00_2025));
												}}}}}}}}
												BgL_res3750z00_2040 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3472z00_2015) (BgL_method3472z00_2015,
														(obj_t) (BgL_arg3618z00_1342), BgL_stackz00_1308,
														BEOA));
											}
											BgL_arg3617z00_1341 = BgL_res3750z00_2040;
									}}
									((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1307))->
											BgL_falsez00) =
										((BgL_nodez00_bglt) BgL_arg3617z00_1341), BUNSPEC);
								}
								return (obj_t) (BgL_nodez00_1307);
							}
					}
				}
			}
		}
	}



/* node-typec!-setq3484 */
	obj_t BGl_nodezd2typecz12zd2setq3484z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2667, obj_t BgL_nodez00_2668, obj_t BgL_stackz00_2669)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 124 */
			{
				BgL_setqz00_bglt BgL_nodez00_1296;

				obj_t BgL_stackz00_1297;

				{	/* Reduce/ftypec.scm 125 */
					BgL_setqz00_bglt BgL_auxz00_3607;

					BgL_nodez00_1296 = (BgL_setqz00_bglt) (BgL_nodez00_2668);
					BgL_stackz00_1297 = BgL_stackz00_2669;
					{	/* Reduce/ftypec.scm 126 */
						BgL_nodez00_bglt BgL_arg3591z00_1301;

						{	/* Reduce/ftypec.scm 126 */
							BgL_nodez00_bglt BgL_arg3592z00_1302;

							BgL_arg3592z00_1302 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1296))->BgL_valuez00);
							{	/* Reduce/ftypec.scm 126 */
								BgL_nodez00_bglt BgL_res3726z00_1778;

								{	/* Reduce/ftypec.scm 126 */
									obj_t BgL_method3472z00_1753;

									{	/* Reduce/ftypec.scm 126 */
										BgL_objectz00_bglt BgL_objz00_1754;

										BgL_objz00_1754 =
											(BgL_objectz00_bglt) (BgL_arg3592z00_1302);
										{	/* Reduce/ftypec.scm 126 */
											long BgL_objzd2classzd2numz00_1755;

											BgL_objzd2classzd2numz00_1755 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1754);
											{	/* Reduce/ftypec.scm 126 */
												obj_t BgL_arg2551z00_1756;

												BgL_arg2551z00_1756 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 126 */
													obj_t BgL_arrayz00_1758;

													int BgL_offsetz00_1759;

													BgL_arrayz00_1758 = BgL_arg2551z00_1756;
													BgL_offsetz00_1759 =
														(int) (BgL_objzd2classzd2numz00_1755);
													{	/* Reduce/ftypec.scm 126 */
														long BgL_offsetz00_1760;

														BgL_offsetz00_1760 =
															((long) (BgL_offsetz00_1759) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 126 */
															long BgL_modz00_1761;

															{	/* Reduce/ftypec.scm 126 */
																int BgL_arg2553z00_1762;

																BgL_arg2553z00_1762 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 126 */
																	long BgL_auxz00_3617;

																	BgL_auxz00_3617 =
																		(long) (BgL_arg2553z00_1762);
																	BgL_modz00_1761 =
																		(BgL_offsetz00_1760 / BgL_auxz00_3617);
															}}
															{	/* Reduce/ftypec.scm 126 */
																long BgL_restz00_1763;

																{	/* Reduce/ftypec.scm 126 */
																	int BgL_arg2552z00_1764;

																	BgL_arg2552z00_1764 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 126 */
																		long BgL_auxz00_3621;

																		BgL_auxz00_3621 =
																			(long) (BgL_arg2552z00_1764);
																		BgL_restz00_1763 =
																			(BgL_offsetz00_1760 % BgL_auxz00_3621);
																}}
																{	/* Reduce/ftypec.scm 126 */

																	BgL_method3472z00_1753 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1758,
																			(int) (BgL_modz00_1761)),
																		(int) (BgL_restz00_1763));
									}}}}}}}}
									BgL_res3726z00_1778 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1753)
										(BgL_method3472z00_1753, (obj_t) (BgL_arg3592z00_1302),
											BgL_stackz00_1297, BEOA));
								}
								BgL_arg3591z00_1301 = BgL_res3726z00_1778;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1296))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3591z00_1301), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 127 */
						BgL_nodez00_bglt BgL_arg3593z00_1303;

						{	/* Reduce/ftypec.scm 127 */
							BgL_varz00_bglt BgL_arg3594z00_1304;

							BgL_arg3594z00_1304 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1296))->BgL_varz00);
							{	/* Reduce/ftypec.scm 127 */
								BgL_nodez00_bglt BgL_res3729z00_1809;

								{	/* Reduce/ftypec.scm 127 */
									BgL_nodez00_bglt BgL_nodez00_1782;

									BgL_nodez00_1782 = (BgL_nodez00_bglt) (BgL_arg3594z00_1304);
									{	/* Reduce/ftypec.scm 127 */
										obj_t BgL_method3472z00_1784;

										{	/* Reduce/ftypec.scm 127 */
											BgL_objectz00_bglt BgL_objz00_1785;

											BgL_objz00_1785 = (BgL_objectz00_bglt) (BgL_nodez00_1782);
											{	/* Reduce/ftypec.scm 127 */
												long BgL_objzd2classzd2numz00_1786;

												BgL_objzd2classzd2numz00_1786 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1785);
												{	/* Reduce/ftypec.scm 127 */
													obj_t BgL_arg2551z00_1787;

													BgL_arg2551z00_1787 =
														PROCEDURE_REF
														(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
														(int) (((long) 1)));
													{	/* Reduce/ftypec.scm 127 */
														obj_t BgL_arrayz00_1789;

														int BgL_offsetz00_1790;

														BgL_arrayz00_1789 = BgL_arg2551z00_1787;
														BgL_offsetz00_1790 =
															(int) (BgL_objzd2classzd2numz00_1786);
														{	/* Reduce/ftypec.scm 127 */
															long BgL_offsetz00_1791;

															BgL_offsetz00_1791 =
																((long) (BgL_offsetz00_1790) - OBJECT_TYPE);
															{	/* Reduce/ftypec.scm 127 */
																long BgL_modz00_1792;

																{	/* Reduce/ftypec.scm 127 */
																	int BgL_arg2553z00_1793;

																	BgL_arg2553z00_1793 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 127 */
																		long BgL_auxz00_3643;

																		BgL_auxz00_3643 =
																			(long) (BgL_arg2553z00_1793);
																		BgL_modz00_1792 =
																			(BgL_offsetz00_1791 / BgL_auxz00_3643);
																}}
																{	/* Reduce/ftypec.scm 127 */
																	long BgL_restz00_1794;

																	{	/* Reduce/ftypec.scm 127 */
																		int BgL_arg2552z00_1795;

																		BgL_arg2552z00_1795 = (int) (((long) 8));
																		{	/* Reduce/ftypec.scm 127 */
																			long BgL_auxz00_3647;

																			BgL_auxz00_3647 =
																				(long) (BgL_arg2552z00_1795);
																			BgL_restz00_1794 =
																				(BgL_offsetz00_1791 % BgL_auxz00_3647);
																	}}
																	{	/* Reduce/ftypec.scm 127 */

																		BgL_method3472z00_1784 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1789,
																				(int) (BgL_modz00_1792)),
																			(int) (BgL_restz00_1794));
										}}}}}}}}
										BgL_res3729z00_1809 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3472z00_1784) (BgL_method3472z00_1784,
												(obj_t) (BgL_nodez00_1782), BgL_stackz00_1297, BEOA));
								}}
								BgL_arg3593z00_1303 = BgL_res3729z00_1809;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3658;

							BgL_auxz00_3658 = (BgL_varz00_bglt) (BgL_arg3593z00_1303);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1296))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3658), BUNSPEC);
					}}
					BgL_auxz00_3607 = BgL_nodez00_1296;
					return (obj_t) (BgL_auxz00_3607);
				}
			}
		}
	}



/* node-typec!-cast3482 */
	obj_t BGl_nodezd2typecz12zd2cast3482z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2670, obj_t BgL_nodez00_2671, obj_t BgL_stackz00_2672)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 116 */
			{
				BgL_castz00_bglt BgL_nodez00_1288;

				obj_t BgL_stackz00_1289;

				{	/* Reduce/ftypec.scm 117 */
					BgL_castz00_bglt BgL_auxz00_3663;

					BgL_nodez00_1288 = (BgL_castz00_bglt) (BgL_nodez00_2671);
					BgL_stackz00_1289 = BgL_stackz00_2672;
					{	/* Reduce/ftypec.scm 117 */
						BgL_nodez00_bglt BgL_arg3589z00_1720;

						BgL_arg3589z00_1720 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1288))->BgL_argz00);
						{	/* Reduce/ftypec.scm 117 */
							BgL_nodez00_bglt BgL_res3723z00_1749;

							{	/* Reduce/ftypec.scm 117 */
								obj_t BgL_method3472z00_1724;

								{	/* Reduce/ftypec.scm 117 */
									BgL_objectz00_bglt BgL_objz00_1725;

									BgL_objz00_1725 = (BgL_objectz00_bglt) (BgL_arg3589z00_1720);
									{	/* Reduce/ftypec.scm 117 */
										long BgL_objzd2classzd2numz00_1726;

										BgL_objzd2classzd2numz00_1726 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1725);
										{	/* Reduce/ftypec.scm 117 */
											obj_t BgL_arg2551z00_1727;

											BgL_arg2551z00_1727 =
												PROCEDURE_REF
												(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
												(int) (((long) 1)));
											{	/* Reduce/ftypec.scm 117 */
												obj_t BgL_arrayz00_1729;

												int BgL_offsetz00_1730;

												BgL_arrayz00_1729 = BgL_arg2551z00_1727;
												BgL_offsetz00_1730 =
													(int) (BgL_objzd2classzd2numz00_1726);
												{	/* Reduce/ftypec.scm 117 */
													long BgL_offsetz00_1731;

													BgL_offsetz00_1731 =
														((long) (BgL_offsetz00_1730) - OBJECT_TYPE);
													{	/* Reduce/ftypec.scm 117 */
														long BgL_modz00_1732;

														{	/* Reduce/ftypec.scm 117 */
															int BgL_arg2553z00_1733;

															BgL_arg2553z00_1733 = (int) (((long) 8));
															{	/* Reduce/ftypec.scm 117 */
																long BgL_auxz00_3673;

																BgL_auxz00_3673 = (long) (BgL_arg2553z00_1733);
																BgL_modz00_1732 =
																	(BgL_offsetz00_1731 / BgL_auxz00_3673);
														}}
														{	/* Reduce/ftypec.scm 117 */
															long BgL_restz00_1734;

															{	/* Reduce/ftypec.scm 117 */
																int BgL_arg2552z00_1735;

																BgL_arg2552z00_1735 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 117 */
																	long BgL_auxz00_3677;

																	BgL_auxz00_3677 =
																		(long) (BgL_arg2552z00_1735);
																	BgL_restz00_1734 =
																		(BgL_offsetz00_1731 % BgL_auxz00_3677);
															}}
															{	/* Reduce/ftypec.scm 117 */

																BgL_method3472z00_1724 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1729,
																		(int) (BgL_modz00_1732)),
																	(int) (BgL_restz00_1734));
								}}}}}}}}
								BgL_res3723z00_1749 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1724)
									(BgL_method3472z00_1724, (obj_t) (BgL_arg3589z00_1720),
										BgL_stackz00_1289, BEOA));
							} BgL_res3723z00_1749;
					}}
					BgL_auxz00_3663 = BgL_nodez00_1288;
					return (obj_t) (BgL_auxz00_3663);
				}
			}
		}
	}



/* node-typec!-extern3480 */
	obj_t BGl_nodezd2typecz12zd2extern3480z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2673, obj_t BgL_nodez00_2674, obj_t BgL_stackz00_2675)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 108 */
			{
				BgL_externz00_bglt BgL_nodez00_1280;

				obj_t BgL_stackz00_1281;

				{	/* Reduce/ftypec.scm 109 */
					BgL_externz00_bglt BgL_auxz00_3690;

					BgL_nodez00_1280 = (BgL_externz00_bglt) (BgL_nodez00_2674);
					BgL_stackz00_1281 = BgL_stackz00_2675;
					{	/* Reduce/ftypec.scm 109 */
						obj_t BgL_arg3587z00_1717;

						BgL_arg3587z00_1717 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1280))->BgL_exprza2za2);
						BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2
							(BgL_arg3587z00_1717, BgL_stackz00_1281);
					}
					BgL_auxz00_3690 = BgL_nodez00_1280;
					return (obj_t) (BgL_auxz00_3690);
				}
			}
		}
	}



/* node-typec!-funcall3478 */
	obj_t BGl_nodezd2typecz12zd2funcall3478z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2676, obj_t BgL_nodez00_2677, obj_t BgL_stackz00_2678)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 99 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1270;

				obj_t BgL_stackz00_1271;

				{	/* Reduce/ftypec.scm 100 */
					BgL_funcallz00_bglt BgL_auxz00_3695;

					BgL_nodez00_1270 = (BgL_funcallz00_bglt) (BgL_nodez00_2677);
					BgL_stackz00_1271 = BgL_stackz00_2678;
					{	/* Reduce/ftypec.scm 101 */
						BgL_nodez00_bglt BgL_arg3583z00_1275;

						{	/* Reduce/ftypec.scm 101 */
							BgL_nodez00_bglt BgL_arg3584z00_1276;

							BgL_arg3584z00_1276 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1270))->BgL_funz00);
							{	/* Reduce/ftypec.scm 101 */
								BgL_nodez00_bglt BgL_res3720z00_1712;

								{	/* Reduce/ftypec.scm 101 */
									obj_t BgL_method3472z00_1687;

									{	/* Reduce/ftypec.scm 101 */
										BgL_objectz00_bglt BgL_objz00_1688;

										BgL_objz00_1688 =
											(BgL_objectz00_bglt) (BgL_arg3584z00_1276);
										{	/* Reduce/ftypec.scm 101 */
											long BgL_objzd2classzd2numz00_1689;

											BgL_objzd2classzd2numz00_1689 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1688);
											{	/* Reduce/ftypec.scm 101 */
												obj_t BgL_arg2551z00_1690;

												BgL_arg2551z00_1690 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 101 */
													obj_t BgL_arrayz00_1692;

													int BgL_offsetz00_1693;

													BgL_arrayz00_1692 = BgL_arg2551z00_1690;
													BgL_offsetz00_1693 =
														(int) (BgL_objzd2classzd2numz00_1689);
													{	/* Reduce/ftypec.scm 101 */
														long BgL_offsetz00_1694;

														BgL_offsetz00_1694 =
															((long) (BgL_offsetz00_1693) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 101 */
															long BgL_modz00_1695;

															{	/* Reduce/ftypec.scm 101 */
																int BgL_arg2553z00_1696;

																BgL_arg2553z00_1696 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 101 */
																	long BgL_auxz00_3705;

																	BgL_auxz00_3705 =
																		(long) (BgL_arg2553z00_1696);
																	BgL_modz00_1695 =
																		(BgL_offsetz00_1694 / BgL_auxz00_3705);
															}}
															{	/* Reduce/ftypec.scm 101 */
																long BgL_restz00_1697;

																{	/* Reduce/ftypec.scm 101 */
																	int BgL_arg2552z00_1698;

																	BgL_arg2552z00_1698 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 101 */
																		long BgL_auxz00_3709;

																		BgL_auxz00_3709 =
																			(long) (BgL_arg2552z00_1698);
																		BgL_restz00_1697 =
																			(BgL_offsetz00_1694 % BgL_auxz00_3709);
																}}
																{	/* Reduce/ftypec.scm 101 */

																	BgL_method3472z00_1687 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1692,
																			(int) (BgL_modz00_1695)),
																		(int) (BgL_restz00_1697));
									}}}}}}}}
									BgL_res3720z00_1712 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1687)
										(BgL_method3472z00_1687, (obj_t) (BgL_arg3584z00_1276),
											BgL_stackz00_1271, BEOA));
								}
								BgL_arg3583z00_1275 = BgL_res3720z00_1712;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1270))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3583z00_1275), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 102 */
						obj_t BgL_arg3585z00_1277;

						BgL_arg3585z00_1277 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1270))->BgL_argsz00);
						BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2
							(BgL_arg3585z00_1277, BgL_stackz00_1271);
					}
					BgL_auxz00_3695 = BgL_nodez00_1270;
					return (obj_t) (BgL_auxz00_3695);
				}
			}
		}
	}



/* node-typec!-app-ly3476 */
	obj_t BGl_nodezd2typecz12zd2appzd2ly3476zc0zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2679, obj_t BgL_nodez00_2680, obj_t BgL_stackz00_2681)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 90 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1259;

				obj_t BgL_stackz00_1260;

				{	/* Reduce/ftypec.scm 91 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_3725;

					BgL_nodez00_1259 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2680);
					BgL_stackz00_1260 = BgL_stackz00_2681;
					{	/* Reduce/ftypec.scm 92 */
						BgL_nodez00_bglt BgL_arg3577z00_1264;

						{	/* Reduce/ftypec.scm 92 */
							BgL_nodez00_bglt BgL_arg3578z00_1265;

							BgL_arg3578z00_1265 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1259))->BgL_funz00);
							{	/* Reduce/ftypec.scm 92 */
								BgL_nodez00_bglt BgL_res3714z00_1650;

								{	/* Reduce/ftypec.scm 92 */
									obj_t BgL_method3472z00_1625;

									{	/* Reduce/ftypec.scm 92 */
										BgL_objectz00_bglt BgL_objz00_1626;

										BgL_objz00_1626 =
											(BgL_objectz00_bglt) (BgL_arg3578z00_1265);
										{	/* Reduce/ftypec.scm 92 */
											long BgL_objzd2classzd2numz00_1627;

											BgL_objzd2classzd2numz00_1627 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1626);
											{	/* Reduce/ftypec.scm 92 */
												obj_t BgL_arg2551z00_1628;

												BgL_arg2551z00_1628 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 92 */
													obj_t BgL_arrayz00_1630;

													int BgL_offsetz00_1631;

													BgL_arrayz00_1630 = BgL_arg2551z00_1628;
													BgL_offsetz00_1631 =
														(int) (BgL_objzd2classzd2numz00_1627);
													{	/* Reduce/ftypec.scm 92 */
														long BgL_offsetz00_1632;

														BgL_offsetz00_1632 =
															((long) (BgL_offsetz00_1631) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 92 */
															long BgL_modz00_1633;

															{	/* Reduce/ftypec.scm 92 */
																int BgL_arg2553z00_1634;

																BgL_arg2553z00_1634 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 92 */
																	long BgL_auxz00_3735;

																	BgL_auxz00_3735 =
																		(long) (BgL_arg2553z00_1634);
																	BgL_modz00_1633 =
																		(BgL_offsetz00_1632 / BgL_auxz00_3735);
															}}
															{	/* Reduce/ftypec.scm 92 */
																long BgL_restz00_1635;

																{	/* Reduce/ftypec.scm 92 */
																	int BgL_arg2552z00_1636;

																	BgL_arg2552z00_1636 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 92 */
																		long BgL_auxz00_3739;

																		BgL_auxz00_3739 =
																			(long) (BgL_arg2552z00_1636);
																		BgL_restz00_1635 =
																			(BgL_offsetz00_1632 % BgL_auxz00_3739);
																}}
																{	/* Reduce/ftypec.scm 92 */

																	BgL_method3472z00_1625 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1630,
																			(int) (BgL_modz00_1633)),
																		(int) (BgL_restz00_1635));
									}}}}}}}}
									BgL_res3714z00_1650 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1625)
										(BgL_method3472z00_1625, (obj_t) (BgL_arg3578z00_1265),
											BgL_stackz00_1260, BEOA));
								}
								BgL_arg3577z00_1264 = BgL_res3714z00_1650;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1259))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3577z00_1264), BUNSPEC);
					}
					{	/* Reduce/ftypec.scm 93 */
						BgL_nodez00_bglt BgL_arg3579z00_1266;

						{	/* Reduce/ftypec.scm 93 */
							BgL_nodez00_bglt BgL_arg3581z00_1267;

							BgL_arg3581z00_1267 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1259))->BgL_argz00);
							{	/* Reduce/ftypec.scm 93 */
								BgL_nodez00_bglt BgL_res3717z00_1681;

								{	/* Reduce/ftypec.scm 93 */
									obj_t BgL_method3472z00_1656;

									{	/* Reduce/ftypec.scm 93 */
										BgL_objectz00_bglt BgL_objz00_1657;

										BgL_objz00_1657 =
											(BgL_objectz00_bglt) (BgL_arg3581z00_1267);
										{	/* Reduce/ftypec.scm 93 */
											long BgL_objzd2classzd2numz00_1658;

											BgL_objzd2classzd2numz00_1658 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1657);
											{	/* Reduce/ftypec.scm 93 */
												obj_t BgL_arg2551z00_1659;

												BgL_arg2551z00_1659 =
													PROCEDURE_REF
													(BGl_nodezd2typecz12zd2envz12zzreduce_flowzd2typeczd2,
													(int) (((long) 1)));
												{	/* Reduce/ftypec.scm 93 */
													obj_t BgL_arrayz00_1661;

													int BgL_offsetz00_1662;

													BgL_arrayz00_1661 = BgL_arg2551z00_1659;
													BgL_offsetz00_1662 =
														(int) (BgL_objzd2classzd2numz00_1658);
													{	/* Reduce/ftypec.scm 93 */
														long BgL_offsetz00_1663;

														BgL_offsetz00_1663 =
															((long) (BgL_offsetz00_1662) - OBJECT_TYPE);
														{	/* Reduce/ftypec.scm 93 */
															long BgL_modz00_1664;

															{	/* Reduce/ftypec.scm 93 */
																int BgL_arg2553z00_1665;

																BgL_arg2553z00_1665 = (int) (((long) 8));
																{	/* Reduce/ftypec.scm 93 */
																	long BgL_auxz00_3760;

																	BgL_auxz00_3760 =
																		(long) (BgL_arg2553z00_1665);
																	BgL_modz00_1664 =
																		(BgL_offsetz00_1663 / BgL_auxz00_3760);
															}}
															{	/* Reduce/ftypec.scm 93 */
																long BgL_restz00_1666;

																{	/* Reduce/ftypec.scm 93 */
																	int BgL_arg2552z00_1667;

																	BgL_arg2552z00_1667 = (int) (((long) 8));
																	{	/* Reduce/ftypec.scm 93 */
																		long BgL_auxz00_3764;

																		BgL_auxz00_3764 =
																			(long) (BgL_arg2552z00_1667);
																		BgL_restz00_1666 =
																			(BgL_offsetz00_1663 % BgL_auxz00_3764);
																}}
																{	/* Reduce/ftypec.scm 93 */

																	BgL_method3472z00_1656 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1661,
																			(int) (BgL_modz00_1664)),
																		(int) (BgL_restz00_1666));
									}}}}}}}}
									BgL_res3717z00_1681 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3472z00_1656)
										(BgL_method3472z00_1656, (obj_t) (BgL_arg3581z00_1267),
											BgL_stackz00_1260, BEOA));
								}
								BgL_arg3579z00_1266 = BgL_res3717z00_1681;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1259))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3579z00_1266), BUNSPEC);
					}
					BgL_auxz00_3725 = BgL_nodez00_1259;
					return (obj_t) (BgL_auxz00_3725);
				}
			}
		}
	}



/* node-typec!-sequence3474 */
	obj_t BGl_nodezd2typecz12zd2sequence3474z12zzreduce_flowzd2typeczd2(obj_t
		BgL_envz00_2682, obj_t BgL_nodez00_2683, obj_t BgL_stackz00_2684)
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 82 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1251;

				obj_t BgL_stackz00_1252;

				{	/* Reduce/ftypec.scm 83 */
					BgL_sequencez00_bglt BgL_auxz00_3778;

					BgL_nodez00_1251 = (BgL_sequencez00_bglt) (BgL_nodez00_2683);
					BgL_stackz00_1252 = BgL_stackz00_2684;
					{	/* Reduce/ftypec.scm 83 */
						obj_t BgL_arg3575z00_1620;

						BgL_arg3575z00_1620 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1251))->BgL_nodesz00);
						BGl_nodezd2typecza2z12z62zzreduce_flowzd2typeczd2
							(BgL_arg3575z00_1620, BgL_stackz00_1252);
					}
					BgL_auxz00_3778 = BgL_nodez00_1251;
					return (obj_t) (BgL_auxz00_3778);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzreduce_flowzd2typeczd2()
	{
		AN_OBJECT;
		{	/* Reduce/ftypec.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 269647501),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 470955713),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 498901618),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
			return
				BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3823z00zzreduce_flowzd2typeczd2));
		}
	}

#ifdef __cplusplus
}
#endif
