/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_findzd2lastzd2nodezd2letzd2f3324z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3359z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2extern3340z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2appzd2l3308z00zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2appzd2ly3336zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2setzd2e3326z00zztrace_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2condition3346z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_tracezd2nodezd2letzd2fun3352zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2sequence3332z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2app3334z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2setq3314zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2letzd2v3322z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2letzd2var3354zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_findzd2lastzd2nodezd2app3306zd2zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2setz123366zc0zztrace_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_tracezd2nodezd2select3350z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2tracezd2nodezd23370zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2tracezd2nodezd23372zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__findzd2lastzd2nodez00zztrace_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl__toplevelzd2tracezd2nodez00zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2selec3320zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2setzd2exzd2it3356z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00;
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	static obj_t BGl_findzd2lastzd2nodezd2fail3318zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2funca3310zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl__tracezd2nodezd2zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl__findzd2lastzd2nodezd2defau3301zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_za2bmemzd2profilingza2zd2zzengine_paramz00;
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2nodezd2makezd2box3361zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_pragmaz00zzast_nodez00;
	static obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_findzd2lastzd2nodezd2seque3304zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_findzd2lastzd2nodezd2condi3316zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t BGl_tracezd2nodezd2cast3342z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl__tracezd2nodezd2default3329z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	static obj_t BGl__toplevelzd2tracezd2nodezd23367zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2funcall3338z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2setq3344z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2jumpzd23328z00zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_findzd2lastzd2nodezd2exter3312zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2ref3364zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2fail3348z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string3860z00zztrace_walkz00,
		BgL_bgl_string3860za700za7za7t3907za7, "Trace", 5);
	      DEFINE_STRING(BGl_string3861z00zztrace_walkz00,
		BgL_bgl_string3861za700za7za7t3908za7, "   . ", 5);
	      DEFINE_STRING(BGl_string3862z00zztrace_walkz00,
		BgL_bgl_string3862za700za7za7t3909za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string3863z00zztrace_walkz00,
		BgL_bgl_string3863za700za7za7t3910za7, " error", 6);
	      DEFINE_STRING(BGl_string3864z00zztrace_walkz00,
		BgL_bgl_string3864za700za7za7t3911za7, "s", 1);
	      DEFINE_STRING(BGl_string3865z00zztrace_walkz00,
		BgL_bgl_string3865za700za7za7t3912za7, "", 0);
	      DEFINE_STRING(BGl_string3866z00zztrace_walkz00,
		BgL_bgl_string3866za700za7za7t3913za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string3867z00zztrace_walkz00,
		BgL_bgl_string3867za700za7za7t3914za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string3868z00zztrace_walkz00,
		BgL_bgl_string3868za700za7za7t3915za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string3870z00zztrace_walkz00,
		BgL_bgl_string3870za700za7za7t3916za7, ", ~a:~a", 7);
	      DEFINE_STRING(BGl_string3869z00zztrace_walkz00,
		BgL_bgl_string3869za700za7za7t3917za7, "%import@", 8);
	      DEFINE_STRING(BGl_string3903z00zztrace_walkz00,
		BgL_bgl_string3903za700za7za7t3918za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string3904z00zztrace_walkz00,
		BgL_bgl_string3904za700za7za7t3919za7,
		"done value ($pop-trace) $pop-trace $push-trace quote let location |:| symbol aux no-trace imported-modules-init toplevel-init pass-started ",
		139);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_findzd2lastzd2nodezd2defau3301zd2envz00zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3920z00,
		BGl__findzd2lastzd2nodezd2defau3301zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl__traceza7d2nodeza7d23921z00, BGl__tracezd2nodezd2zztrace_walkz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3922z00,
		BGl__findzd2lastzd2nodez00zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3923za7,
		BGl__toplevelzd2tracezd2nodez00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl__traceza7d2walkza7123924z00, BGl__tracezd2walkz12zc0zztrace_walkz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_tracezd2nodezd2default3329zd2envzd2zztrace_walkz00,
		BgL_bgl__traceza7d2nodeza7d23925z00,
		BGl__tracezd2nodezd2default3329z00zztrace_walkz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_toplevelzd2tracezd2nodezd23367zd2envz00zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3926za7,
		BGl__toplevelzd2tracezd2nodezd23367zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3871z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3927z00,
		BGl_findzd2lastzd2nodezd2seque3304zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3872z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3928z00,
		BGl_findzd2lastzd2nodezd2app3306zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3873z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3929z00,
		BGl_findzd2lastzd2nodezd2appzd2l3308z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3874z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3930z00,
		BGl_findzd2lastzd2nodezd2funca3310zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3875z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3931z00,
		BGl_findzd2lastzd2nodezd2exter3312zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3876z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3932z00,
		BGl_findzd2lastzd2nodezd2setq3314zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3877z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3933z00,
		BGl_findzd2lastzd2nodezd2condi3316zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3878z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3934z00,
		BGl_findzd2lastzd2nodezd2fail3318zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3880z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3935z00,
		BGl_findzd2lastzd2nodezd2letzd2v3322z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3879z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3936z00,
		BGl_findzd2lastzd2nodezd2selec3320zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3881z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3937z00,
		BGl_findzd2lastzd2nodezd2letzd2f3324z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3882z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3938z00,
		BGl_findzd2lastzd2nodezd2setzd2e3326z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3883z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3939z00,
		BGl_findzd2lastzd2nodezd2jumpzd23328z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3884z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3940z00,
		BGl_tracezd2nodezd2sequence3332z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3885z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3941z00,
		BGl_tracezd2nodezd2app3334z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3886z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3942z00,
		BGl_tracezd2nodezd2appzd2ly3336zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3887z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3943z00,
		BGl_tracezd2nodezd2funcall3338z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3888z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2e3944z00,
		BGl_tracezd2nodezd2extern3340z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3900z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3945z00,
		BGl_tracezd2nodezd2boxzd2setz123366zc0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3890z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3946z00,
		BGl_tracezd2nodezd2setq3344z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3889z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3947z00,
		BGl_tracezd2nodezd2cast3342z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3901z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3948za7,
		BGl_toplevelzd2tracezd2nodezd23370zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3891z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3949z00,
		BGl_tracezd2nodezd2condition3346z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3902z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3950za7,
		BGl_toplevelzd2tracezd2nodezd23372zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3892z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3951z00,
		BGl_tracezd2nodezd2fail3348z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3893z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3952z00,
		BGl_tracezd2nodezd2select3350z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3894z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3953z00,
		BGl_tracezd2nodezd2letzd2fun3352zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3895z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3954z00,
		BGl_tracezd2nodezd2letzd2var3354zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3896z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3955z00,
		BGl_tracezd2nodezd2setzd2exzd2it3356z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3897z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2j3956z00,
		BGl_tracezd2nodezd2jumpzd2exzd2i3359z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3898z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2m3957z00,
		BGl_tracezd2nodezd2makezd2box3361zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3899z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3958z00,
		BGl_tracezd2nodezd2boxzd2ref3364zd2zztrace_walkz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_3463, char *BgL_fromz00_3464)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_3451;

				BgL_cportz00_3451 =
					bgl_open_input_string(BGl_string3904z00zztrace_walkz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3452;

					BgL_iz00_3452 = ((long) 14);
				BgL_loopz00_3453:
					if ((BgL_iz00_3452 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg3906z00_3455;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_3457;

										BgL_locationz00_3457 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg3906z00_3455 =
												BGl_readz00zz__readerz00(BgL_cportz00_3451,
												BgL_locationz00_3457);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_auxz00_3488;

									BgL_auxz00_3488 = (int) (BgL_iz00_3452);
									CNST_TABLE_SET(BgL_auxz00_3488, BgL_arg3906z00_3455);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_3458;

								BgL_auxz00_3458 = (int) ((BgL_iz00_3452 - ((long) 1)));
								{
									long BgL_iz00_3493;

									BgL_iz00_3493 = (long) (BgL_auxz00_3458);
									BgL_iz00_3452 = BgL_iz00_3493;
									goto BgL_loopz00_3453;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_15)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			{	/* Trace/walk.scm 37 */
				obj_t BgL_list3382z00_924;

				{	/* Trace/walk.scm 37 */
					obj_t BgL_arg3384z00_926;

					{	/* Trace/walk.scm 37 */
						obj_t BgL_arg3386z00_928;

						BgL_arg3386z00_928 = MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
						BgL_arg3384z00_926 =
							MAKE_PAIR(BGl_string3860z00zztrace_walkz00, BgL_arg3386z00_928);
					}
					BgL_list3382z00_924 =
						MAKE_PAIR(BGl_string3861z00zztrace_walkz00, BgL_arg3384z00_926);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list3382z00_924);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string3860z00zztrace_walkz00;
			{
				obj_t BgL_hooksz00_932;

				obj_t BgL_hnamesz00_933;

				BgL_hooksz00_932 = BNIL;
				BgL_hnamesz00_933 = BNIL;
			BgL_zc3anonymousza33387ze3z83_934:
				if (NULLP(BgL_hooksz00_932))
					{	/* Trace/walk.scm 37 */
						CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Trace/walk.scm 37 */
						bool_t BgL_testz00_3505;

						{	/* Trace/walk.scm 37 */
							obj_t BgL_fun3395z00_942;

							BgL_fun3395z00_942 = CAR(BgL_hooksz00_932);
							BgL_testz00_3505 =
								CBOOL(PROCEDURE_ENTRY(BgL_fun3395z00_942) (BgL_fun3395z00_942,
									BEOA));
						}
						if (BgL_testz00_3505)
							{
								obj_t BgL_hnamesz00_3512;

								obj_t BgL_hooksz00_3510;

								BgL_hooksz00_3510 = CDR(BgL_hooksz00_932);
								BgL_hnamesz00_3512 = CDR(BgL_hnamesz00_933);
								BgL_hnamesz00_933 = BgL_hnamesz00_3512;
								BgL_hooksz00_932 = BgL_hooksz00_3510;
								goto BgL_zc3anonymousza33387ze3z83_934;
							}
						else
							{	/* Trace/walk.scm 37 */
								BGl_internalzd2errorzd2zztools_errorz00
									(BGl_string3860z00zztrace_walkz00,
									BGl_string3862z00zztrace_walkz00, CAR(BgL_hnamesz00_933));
							}
					}
			}
			{	/* Trace/walk.scm 43 */
				obj_t BgL_idz00_945;

				BgL_idz00_945 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 43 */
					obj_t BgL_gloz00_946;

					{	/* Trace/walk.scm 44 */
						obj_t BgL_list3400z00_951;

						BgL_list3400z00_951 =
							MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_946 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_945,
							BgL_list3400z00_951);
					}
					{	/* Trace/walk.scm 44 */

						if (BGl_iszd2azf3z21zz__objectz00(BgL_gloz00_946,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 46 */
								BgL_valuez00_bglt BgL_instance3252z00_948;

								{
									BgL_variablez00_bglt BgL_auxz00_3521;

									BgL_auxz00_3521 = (BgL_variablez00_bglt) (BgL_gloz00_946);
									BgL_instance3252z00_948 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3521))->
										BgL_valuez00);
								}
								{	/* Trace/walk.scm 47 */
									BgL_nodez00_bglt BgL_arg3398z00_949;

									{	/* Trace/walk.scm 47 */
										obj_t BgL_arg3399z00_950;

										{
											BgL_sfunz00_bglt BgL_auxz00_3524;

											BgL_auxz00_3524 =
												(BgL_sfunz00_bglt) (BgL_instance3252z00_948);
											BgL_arg3399z00_950 =
												(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3524))->
												BgL_bodyz00);
										}
										{	/* Trace/walk.scm 47 */
											BgL_nodez00_bglt BgL_res3740z00_1871;

											{	/* Trace/walk.scm 47 */
												BgL_nodez00_bglt BgL_nodez00_1845;

												BgL_nodez00_1845 =
													(BgL_nodez00_bglt) (BgL_arg3399z00_950);
												{	/* Trace/walk.scm 47 */
													obj_t BgL_method3368z00_1846;

													{	/* Trace/walk.scm 47 */
														BgL_objectz00_bglt BgL_objz00_1847;

														BgL_objz00_1847 =
															(BgL_objectz00_bglt) (BgL_nodez00_1845);
														{	/* Trace/walk.scm 47 */
															long BgL_objzd2classzd2numz00_1848;

															BgL_objzd2classzd2numz00_1848 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1847);
															{	/* Trace/walk.scm 47 */
																obj_t BgL_arg2551z00_1849;

																BgL_arg2551z00_1849 =
																	PROCEDURE_REF
																	(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
																	(int) (((long) 1)));
																{	/* Trace/walk.scm 47 */
																	obj_t BgL_arrayz00_1851;

																	int BgL_offsetz00_1852;

																	BgL_arrayz00_1851 = BgL_arg2551z00_1849;
																	BgL_offsetz00_1852 =
																		(int) (BgL_objzd2classzd2numz00_1848);
																	{	/* Trace/walk.scm 47 */
																		long BgL_offsetz00_1853;

																		BgL_offsetz00_1853 =
																			(
																			(long) (BgL_offsetz00_1852) -
																			OBJECT_TYPE);
																		{	/* Trace/walk.scm 47 */
																			long BgL_modz00_1854;

																			{	/* Trace/walk.scm 47 */
																				int BgL_arg2553z00_1855;

																				BgL_arg2553z00_1855 =
																					(int) (((long) 8));
																				{	/* Trace/walk.scm 47 */
																					long BgL_auxz00_3536;

																					BgL_auxz00_3536 =
																						(long) (BgL_arg2553z00_1855);
																					BgL_modz00_1854 =
																						(BgL_offsetz00_1853 /
																						BgL_auxz00_3536);
																			}}
																			{	/* Trace/walk.scm 47 */
																				long BgL_restz00_1856;

																				{	/* Trace/walk.scm 47 */
																					int BgL_arg2552z00_1857;

																					BgL_arg2552z00_1857 =
																						(int) (((long) 8));
																					{	/* Trace/walk.scm 47 */
																						long BgL_auxz00_3540;

																						BgL_auxz00_3540 =
																							(long) (BgL_arg2552z00_1857);
																						BgL_restz00_1856 =
																							(BgL_offsetz00_1853 %
																							BgL_auxz00_3540);
																				}}
																				{	/* Trace/walk.scm 47 */

																					BgL_method3368z00_1846 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1851,
																							(int) (BgL_modz00_1854)),
																						(int) (BgL_restz00_1856));
													}}}}}}}}
													BgL_res3740z00_1871 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3368z00_1846) (BgL_method3368z00_1846,
															(obj_t) (BgL_nodez00_1845), BEOA));
											}}
											BgL_arg3398z00_949 = BgL_res3740z00_1871;
									}}
									{
										obj_t BgL_auxz00_3553;

										BgL_sfunz00_bglt BgL_auxz00_3551;

										BgL_auxz00_3553 = (obj_t) (BgL_arg3398z00_949);
										BgL_auxz00_3551 =
											(BgL_sfunz00_bglt) (BgL_instance3252z00_948);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3551))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_3553), BUNSPEC);
							}}}
						else
							{	/* Trace/walk.scm 45 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l3289z00_953;

				BgL_l3289z00_953 = BgL_globalsz00_15;
			BgL_zc3anonymousza33401ze3z83_954:
				if (PAIRP(BgL_l3289z00_953))
					{	/* Trace/walk.scm 49 */
						BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3289z00_953), BNIL);
						{
							obj_t BgL_l3289z00_3560;

							BgL_l3289z00_3560 = CDR(BgL_l3289z00_953);
							BgL_l3289z00_953 = BgL_l3289z00_3560;
							goto BgL_zc3anonymousza33401ze3z83_954;
						}
					}
				else
					{	/* Trace/walk.scm 49 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 50 */
					{	/* Trace/walk.scm 50 */
						obj_t BgL_port3291z00_961;

						{	/* Trace/walk.scm 50 */
							obj_t BgL_res3741z00_1880;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_auxz00_3565;

								BgL_auxz00_3565 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3741z00_1880 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_auxz00_3565);
							}
							BgL_port3291z00_961 = BgL_res3741z00_1880;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port3291z00_961);
						bgl_display_string(BGl_string3863z00zztrace_walkz00,
							BgL_port3291z00_961);
						{	/* Trace/walk.scm 50 */
							obj_t BgL_arg3405z00_962;

							{	/* Trace/walk.scm 50 */
								bool_t BgL_testz00_3570;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3570 =
											BGl_2ze3ze3zz__r4_numbers_6_5z00
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
											BINT(((long) 1)));
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3570 = ((bool_t) 0);
									}
								if (BgL_testz00_3570)
									{	/* Trace/walk.scm 50 */
										BgL_arg3405z00_962 = BGl_string3864z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_arg3405z00_962 = BGl_string3865z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg3405z00_962, BgL_port3291z00_961);
						}
						bgl_display_string(BGl_string3866z00zztrace_walkz00,
							BgL_port3291z00_961);
						bgl_display_char(((unsigned char) '\n'), BgL_port3291z00_961);
					}
					{	/* Trace/walk.scm 50 */
						obj_t BgL_list3408z00_965;

						BgL_list3408z00_965 = MAKE_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list3408z00_965);
					}
				}
			else
				{
					obj_t BgL_hooksz00_969;

					obj_t BgL_hnamesz00_970;

					BgL_hooksz00_969 = BNIL;
					BgL_hnamesz00_970 = BNIL;
				BgL_zc3anonymousza33409ze3z83_971:
					if (NULLP(BgL_hooksz00_969))
						{	/* Trace/walk.scm 50 */
							return BgL_globalsz00_15;
						}
					else
						{	/* Trace/walk.scm 50 */
							bool_t BgL_testz00_3583;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_fun3417z00_978;

								BgL_fun3417z00_978 = CAR(BgL_hooksz00_969);
								BgL_testz00_3583 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun3417z00_978) (BgL_fun3417z00_978,
										BEOA));
							}
							if (BgL_testz00_3583)
								{
									obj_t BgL_hnamesz00_3590;

									obj_t BgL_hooksz00_3588;

									BgL_hooksz00_3588 = CDR(BgL_hooksz00_969);
									BgL_hnamesz00_3590 = CDR(BgL_hnamesz00_970);
									BgL_hnamesz00_970 = BgL_hnamesz00_3590;
									BgL_hooksz00_969 = BgL_hooksz00_3588;
									goto BgL_zc3anonymousza33409ze3z83_971;
								}
							else
								{	/* Trace/walk.scm 50 */
									obj_t BgL_arg3416z00_977;

									BgL_arg3416z00_977 = CAR(BgL_hnamesz00_970);
									return
										BGl_internalzd2errorzd2zztools_errorz00
										(BGl_za2currentzd2passza2zd2zzengine_passz00,
										BGl_string3867z00zztrace_walkz00, BgL_arg3416z00_977);
								}
						}
				}
		}
	}



/* _trace-walk! */
	obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t BgL_envz00_3321,
		obj_t BgL_globalsz00_3322)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_3322);
		}
	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_vz00_16)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 61 */
			{	/* Trace/walk.scm 63 */
				bool_t BgL_testz00_3595;

				if (BGl_iszd2azf3z21zz__objectz00(BgL_vz00_16,
						BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 63 */
						obj_t BgL_auxz00_3598;

						{
							BgL_variablez00_bglt BgL_auxz00_3599;

							BgL_auxz00_3599 = (BgL_variablez00_bglt) (BgL_vz00_16);
							BgL_auxz00_3598 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3599))->BgL_idz00);
						}
						BgL_testz00_3595 = (BgL_auxz00_3598 == CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 63 */
						BgL_testz00_3595 = ((bool_t) 0);
					}
				if (BgL_testz00_3595)
					{	/* Trace/walk.scm 64 */
						obj_t BgL_arg3420z00_982;

						{	/* Trace/walk.scm 64 */
							obj_t BgL_arg3421z00_983;

							obj_t BgL_arg3422z00_984;

							BgL_arg3421z00_983 =
								SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
									(BGl_string3868z00zztrace_walkz00)));
							{	/* Trace/walk.scm 64 */
								obj_t BgL_arg3426z00_988;

								{
									BgL_globalz00_bglt BgL_auxz00_3607;

									BgL_auxz00_3607 = (BgL_globalz00_bglt) (BgL_vz00_16);
									BgL_arg3426z00_988 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_3607))->
										BgL_modulez00);
								}
								BgL_arg3422z00_984 = SYMBOL_TO_STRING(BgL_arg3426z00_988);
							}
							{	/* Trace/walk.scm 64 */
								obj_t BgL_list3423z00_985;

								{	/* Trace/walk.scm 64 */
									obj_t BgL_arg3424z00_986;

									BgL_arg3424z00_986 = MAKE_PAIR(BgL_arg3422z00_984, BNIL);
									BgL_list3423z00_985 =
										MAKE_PAIR(BgL_arg3421z00_983, BgL_arg3424z00_986);
								}
								BgL_arg3420z00_982 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list3423z00_985);
							}
						}
						return string_to_symbol(BSTRING_TO_STRING(BgL_arg3420z00_982));
					}
				else
					{	/* Trace/walk.scm 65 */
						bool_t BgL_testz00_3616;

						if (BGl_iszd2azf3z21zz__objectz00(BgL_vz00_16,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 65 */
								obj_t BgL_auxz00_3619;

								{
									BgL_variablez00_bglt BgL_auxz00_3620;

									BgL_auxz00_3620 = (BgL_variablez00_bglt) (BgL_vz00_16);
									BgL_auxz00_3619 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3620))->BgL_idz00);
								}
								BgL_testz00_3616 =
									(BgL_auxz00_3619 == CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 65 */
								BgL_testz00_3616 = ((bool_t) 0);
							}
						if (BgL_testz00_3616)
							{	/* Trace/walk.scm 66 */
								obj_t BgL_arg3428z00_990;

								{	/* Trace/walk.scm 66 */
									obj_t BgL_arg3429z00_991;

									obj_t BgL_arg3430z00_992;

									BgL_arg3429z00_991 =
										SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
											(BGl_string3869z00zztrace_walkz00)));
									{	/* Trace/walk.scm 66 */
										obj_t BgL_arg3435z00_996;

										{
											BgL_globalz00_bglt BgL_auxz00_3628;

											BgL_auxz00_3628 = (BgL_globalz00_bglt) (BgL_vz00_16);
											BgL_arg3435z00_996 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3628))->
												BgL_modulez00);
										}
										BgL_arg3430z00_992 = SYMBOL_TO_STRING(BgL_arg3435z00_996);
									}
									{	/* Trace/walk.scm 66 */
										obj_t BgL_list3431z00_993;

										{	/* Trace/walk.scm 66 */
											obj_t BgL_arg3433z00_994;

											BgL_arg3433z00_994 = MAKE_PAIR(BgL_arg3430z00_992, BNIL);
											BgL_list3431z00_993 =
												MAKE_PAIR(BgL_arg3429z00_991, BgL_arg3433z00_994);
										}
										BgL_arg3428z00_990 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list3431z00_993);
									}
								}
								return string_to_symbol(BSTRING_TO_STRING(BgL_arg3428z00_990));
							}
						else
							{
								BgL_variablez00_bglt BgL_auxz00_3637;

								BgL_auxz00_3637 = (BgL_variablez00_bglt) (BgL_vz00_16);
								return
									(((BgL_variablez00_bglt) CREF(BgL_auxz00_3637))->BgL_idz00);
							}
					}
			}
		}
	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_17,
		obj_t BgL_stackz00_18)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 76 */
			{	/* Trace/walk.scm 77 */
				BgL_valuez00_bglt BgL_funz00_1003;

				{
					BgL_variablez00_bglt BgL_auxz00_3640;

					BgL_auxz00_3640 = (BgL_variablez00_bglt) (BgL_varz00_17);
					BgL_funz00_1003 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_3640))->BgL_valuez00);
				}
				{	/* Trace/walk.scm 77 */
					obj_t BgL_bodyz00_1004;

					{
						BgL_sfunz00_bglt BgL_auxz00_3643;

						BgL_auxz00_3643 = (BgL_sfunz00_bglt) (BgL_funz00_1003);
						BgL_bodyz00_1004 =
							(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3643))->BgL_bodyz00);
					}
					{	/* Trace/walk.scm 78 */
						BgL_typez00_bglt BgL_typez00_1005;

						{
							BgL_variablez00_bglt BgL_auxz00_3646;

							BgL_auxz00_3646 = (BgL_variablez00_bglt) (BgL_varz00_17);
							BgL_typez00_1005 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3646))->BgL_typez00);
						}
						{	/* Trace/walk.scm 79 */
							obj_t BgL_llocz00_1006;

							if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
									BGl_globalz00zzast_varz00))
								{	/* Trace/walk.scm 81 */
									obj_t BgL_arg3457z00_1024;

									{	/* Trace/walk.scm 81 */
										obj_t BgL_auxz00_3651;

										{
											BgL_globalz00_bglt BgL_auxz00_3652;

											BgL_auxz00_3652 = (BgL_globalz00_bglt) (BgL_varz00_17);
											BgL_auxz00_3651 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3652))->
												BgL_srcz00);
										}
										BgL_arg3457z00_1024 =
											BGl_findzd2lastzd2sexpz00zztrace_walkz00(BgL_auxz00_3651);
									}
									BgL_llocz00_1006 =
										BGl_findzd2locationzd2zztools_locationz00
										(BgL_arg3457z00_1024);
								}
							else
								{	/* Trace/walk.scm 82 */
									obj_t BgL_arg3459z00_1026;

									{	/* Trace/walk.scm 82 */
										BgL_nodez00_bglt BgL_nodez00_1913;

										BgL_nodez00_1913 = (BgL_nodez00_bglt) (BgL_bodyz00_1004);
										{	/* Trace/walk.scm 82 */
											obj_t BgL_method3302z00_1914;

											{	/* Trace/walk.scm 82 */
												BgL_objectz00_bglt BgL_objz00_1915;

												BgL_objz00_1915 =
													(BgL_objectz00_bglt) (BgL_nodez00_1913);
												{	/* Trace/walk.scm 82 */
													long BgL_objzd2classzd2numz00_1916;

													BgL_objzd2classzd2numz00_1916 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1915);
													{	/* Trace/walk.scm 82 */
														obj_t BgL_arg2551z00_1917;

														BgL_arg2551z00_1917 =
															PROCEDURE_REF
															(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
															(int) (((long) 1)));
														{	/* Trace/walk.scm 82 */
															obj_t BgL_arrayz00_1919;

															int BgL_offsetz00_1920;

															BgL_arrayz00_1919 = BgL_arg2551z00_1917;
															BgL_offsetz00_1920 =
																(int) (BgL_objzd2classzd2numz00_1916);
															{	/* Trace/walk.scm 82 */
																long BgL_offsetz00_1921;

																BgL_offsetz00_1921 =
																	((long) (BgL_offsetz00_1920) - OBJECT_TYPE);
																{	/* Trace/walk.scm 82 */
																	long BgL_modz00_1922;

																	{	/* Trace/walk.scm 82 */
																		int BgL_arg2553z00_1923;

																		BgL_arg2553z00_1923 = (int) (((long) 8));
																		{	/* Trace/walk.scm 82 */
																			long BgL_auxz00_3666;

																			BgL_auxz00_3666 =
																				(long) (BgL_arg2553z00_1923);
																			BgL_modz00_1922 =
																				(BgL_offsetz00_1921 / BgL_auxz00_3666);
																	}}
																	{	/* Trace/walk.scm 82 */
																		long BgL_restz00_1924;

																		{	/* Trace/walk.scm 82 */
																			int BgL_arg2552z00_1925;

																			BgL_arg2552z00_1925 = (int) (((long) 8));
																			{	/* Trace/walk.scm 82 */
																				long BgL_auxz00_3670;

																				BgL_auxz00_3670 =
																					(long) (BgL_arg2552z00_1925);
																				BgL_restz00_1924 =
																					(BgL_offsetz00_1921 %
																					BgL_auxz00_3670);
																		}}
																		{	/* Trace/walk.scm 82 */

																			BgL_method3302z00_1914 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1919,
																					(int) (BgL_modz00_1922)),
																				(int) (BgL_restz00_1924));
											}}}}}}}}
											BgL_arg3459z00_1026 =
												PROCEDURE_ENTRY(BgL_method3302z00_1914)
												(BgL_method3302z00_1914, (obj_t) (BgL_nodez00_1913),
												BEOA);
									}}
									{
										BgL_nodez00_bglt BgL_auxz00_3680;

										BgL_auxz00_3680 = (BgL_nodez00_bglt) (BgL_arg3459z00_1026);
										BgL_llocz00_1006 =
											(((BgL_nodez00_bglt) CREF(BgL_auxz00_3680))->BgL_locz00);
								}}
							{	/* Trace/walk.scm 80 */

								{	/* Trace/walk.scm 83 */
									bool_t BgL_testz00_3683;

									{	/* Trace/walk.scm 83 */
										bool_t BgL_testz00_3684;

										{	/* Trace/walk.scm 83 */
											BgL_funz00_bglt BgL_obj1725z00_1940;

											BgL_obj1725z00_1940 = (BgL_funz00_bglt) (BgL_funz00_1003);
											BgL_testz00_3684 =
												CBOOL(
												(((BgL_funz00_bglt) CREF(BgL_obj1725z00_1940))->
													BgL_predicatezd2ofzd2));
										}
										if (BgL_testz00_3684)
											{	/* Trace/walk.scm 83 */
												BgL_testz00_3683 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 84 */
												bool_t BgL_testz00_3688;

												{	/* Trace/walk.scm 84 */
													obj_t BgL_auxz00_3689;

													{	/* Trace/walk.scm 84 */
														obj_t BgL_auxz00_3690;

														{
															BgL_sfunz00_bglt BgL_auxz00_3692;

															BgL_auxz00_3692 =
																(BgL_sfunz00_bglt) (BgL_funz00_1003);
															BgL_auxz00_3690 =
																(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3692))->
																BgL_propertyz00);
														}
														BgL_auxz00_3689 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(CNST_TABLE_REF(((long) 3)), BgL_auxz00_3690);
													}
													BgL_testz00_3688 = CBOOL(BgL_auxz00_3689);
												}
												if (BgL_testz00_3688)
													{	/* Trace/walk.scm 84 */
														BgL_testz00_3683 = ((bool_t) 0);
													}
												else
													{	/* Trace/walk.scm 85 */
														obj_t BgL_arg3453z00_1020;

														{
															BgL_variablez00_bglt BgL_auxz00_3697;

															BgL_auxz00_3697 =
																(BgL_variablez00_bglt) (BgL_varz00_17);
															BgL_arg3453z00_1020 =
																(((BgL_variablez00_bglt)
																	CREF(BgL_auxz00_3697))->BgL_idz00);
														}
														BgL_testz00_3683 =
															BGl_userzd2symbolzf3z21zzast_identz00
															(BgL_arg3453z00_1020);
													}
											}
									}
									if (BgL_testz00_3683)
										{	/* Trace/walk.scm 83 */
											BGl_enterzd2functionzd2zztools_errorz00
												(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17));
											{	/* Trace/walk.scm 88 */
												obj_t BgL_newzd2bodyzd2_1009;

												{	/* Trace/walk.scm 88 */
													bool_t BgL_testz00_3703;

													if (
														((long)
															CINT
															(BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00)
															> ((long) 1)))
														{	/* Trace/walk.scm 88 */
															BgL_testz00_3703 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 88 */
															if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
																	BGl_globalz00zzast_varz00))
																{	/* Trace/walk.scm 90 */
																	obj_t BgL_auxz00_3709;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3710;

																		BgL_auxz00_3710 =
																			(BgL_variablez00_bglt) (BgL_varz00_17);
																		BgL_auxz00_3709 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3710))->BgL_idz00);
																	}
																	BgL_testz00_3703 =
																		(BgL_auxz00_3709 ==
																		CNST_TABLE_REF(((long) 1)));
																}
															else
																{	/* Trace/walk.scm 89 */
																	BgL_testz00_3703 = ((bool_t) 0);
																}
														}
													if (BgL_testz00_3703)
														{	/* Trace/walk.scm 99 */
															obj_t BgL_arg3447z00_1013;

															BgL_arg3447z00_1013 =
																MAKE_PAIR(BgL_varz00_17, BgL_stackz00_18);
															{	/* Trace/walk.scm 99 */
																BgL_nodez00_bglt BgL_res3747z00_1974;

																{	/* Trace/walk.scm 99 */
																	BgL_nodez00_bglt BgL_nodez00_1947;

																	BgL_nodez00_1947 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_1004);
																	{	/* Trace/walk.scm 99 */
																		obj_t BgL_method3330z00_1949;

																		{	/* Trace/walk.scm 99 */
																			BgL_objectz00_bglt BgL_objz00_1950;

																			BgL_objz00_1950 =
																				(BgL_objectz00_bglt) (BgL_nodez00_1947);
																			{	/* Trace/walk.scm 99 */
																				long BgL_objzd2classzd2numz00_1951;

																				BgL_objzd2classzd2numz00_1951 =
																					BGL_OBJECT_CLASS_NUM(BgL_objz00_1950);
																				{	/* Trace/walk.scm 99 */
																					obj_t BgL_arg2551z00_1952;

																					BgL_arg2551z00_1952 =
																						PROCEDURE_REF
																						(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																						(int) (((long) 1)));
																					{	/* Trace/walk.scm 99 */
																						obj_t BgL_arrayz00_1954;

																						int BgL_offsetz00_1955;

																						BgL_arrayz00_1954 =
																							BgL_arg2551z00_1952;
																						BgL_offsetz00_1955 =
																							(int)
																							(BgL_objzd2classzd2numz00_1951);
																						{	/* Trace/walk.scm 99 */
																							long BgL_offsetz00_1956;

																							BgL_offsetz00_1956 =
																								(
																								(long) (BgL_offsetz00_1955) -
																								OBJECT_TYPE);
																							{	/* Trace/walk.scm 99 */
																								long BgL_modz00_1957;

																								{	/* Trace/walk.scm 99 */
																									int BgL_arg2553z00_1958;

																									BgL_arg2553z00_1958 =
																										(int) (((long) 8));
																									{	/* Trace/walk.scm 99 */
																										long BgL_auxz00_3725;

																										BgL_auxz00_3725 =
																											(long)
																											(BgL_arg2553z00_1958);
																										BgL_modz00_1957 =
																											(BgL_offsetz00_1956 /
																											BgL_auxz00_3725);
																								}}
																								{	/* Trace/walk.scm 99 */
																									long BgL_restz00_1959;

																									{	/* Trace/walk.scm 99 */
																										int BgL_arg2552z00_1960;

																										BgL_arg2552z00_1960 =
																											(int) (((long) 8));
																										{	/* Trace/walk.scm 99 */
																											long BgL_auxz00_3729;

																											BgL_auxz00_3729 =
																												(long)
																												(BgL_arg2552z00_1960);
																											BgL_restz00_1959 =
																												(BgL_offsetz00_1956 %
																												BgL_auxz00_3729);
																									}}
																									{	/* Trace/walk.scm 99 */

																										BgL_method3330z00_1949 =
																											VECTOR_REF(VECTOR_REF
																											(BgL_arrayz00_1954,
																												(int)
																												(BgL_modz00_1957)),
																											(int) (BgL_restz00_1959));
																		}}}}}}}}
																		BgL_res3747z00_1974 =
																			(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																			(BgL_method3330z00_1949)
																			(BgL_method3330z00_1949,
																				(obj_t) (BgL_nodez00_1947),
																				BgL_arg3447z00_1013, BEOA));
																}}
																BgL_newzd2bodyzd2_1009 =
																	(obj_t) (BgL_res3747z00_1974);
														}}
													else
														{	/* Trace/walk.scm 88 */
															BgL_newzd2bodyzd2_1009 = BgL_bodyz00_1004;
														}
												}
												{	/* Trace/walk.scm 88 */
													BgL_letzd2varzd2_bglt BgL_new2zd2bodyzd2_1010;

													BgL_new2zd2bodyzd2_1010 =
														BGl_makezd2tracedzd2nodez00zztrace_walkz00(
														(BgL_nodez00_bglt) (BgL_newzd2bodyzd2_1009),
														BgL_typez00_1005,
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17),
														BgL_llocz00_1006, BgL_stackz00_18);
													{	/* Trace/walk.scm 101 */

														{
															obj_t BgL_auxz00_3746;

															BgL_sfunz00_bglt BgL_auxz00_3744;

															BgL_auxz00_3746 =
																(obj_t) (BgL_new2zd2bodyzd2_1010);
															BgL_auxz00_3744 =
																(BgL_sfunz00_bglt) (BgL_funz00_1003);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3744))->
																	BgL_bodyz00) =
																((obj_t) BgL_auxz00_3746), BUNSPEC);
														}
														return BGl_leavezd2functionzd2zztools_errorz00();
													}
												}
											}
										}
									else
										{	/* Trace/walk.scm 83 */
											return BFALSE;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_19)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 116 */
			{
				obj_t BgL_sexpz00_1028;

				obj_t BgL_resz00_1029;

				BgL_sexpz00_1028 = BgL_sexpz00_19;
				BgL_resz00_1029 = BgL_sexpz00_19;
			BgL_zc3anonymousza33460ze3z83_1030:
				if (PAIRP(BgL_sexpz00_1028))
					{	/* Trace/walk.scm 122 */
						bool_t BgL_testz00_3752;

						{	/* Trace/walk.scm 122 */
							obj_t BgL_auxz00_3753;

							BgL_auxz00_3753 = CDR(BgL_sexpz00_1028);
							BgL_testz00_3752 = PAIRP(BgL_auxz00_3753);
						}
						if (BgL_testz00_3752)
							{
								obj_t BgL_resz00_3758;

								obj_t BgL_sexpz00_3756;

								BgL_sexpz00_3756 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1028);
								BgL_resz00_3758 = BgL_sexpz00_1028;
								BgL_resz00_1029 = BgL_resz00_3758;
								BgL_sexpz00_1028 = BgL_sexpz00_3756;
								goto BgL_zc3anonymousza33460ze3z83_1030;
							}
						else
							{
								obj_t BgL_resz00_3761;

								obj_t BgL_sexpz00_3759;

								BgL_sexpz00_3759 = CAR(BgL_sexpz00_1028);
								BgL_resz00_3761 = BgL_sexpz00_1028;
								BgL_resz00_1029 = BgL_resz00_3761;
								BgL_sexpz00_1028 = BgL_sexpz00_3759;
								goto BgL_zc3anonymousza33460ze3z83_1030;
							}
					}
				else
					{	/* Trace/walk.scm 120 */
						return BgL_resz00_1029;
					}
			}
		}
	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_35,
		BgL_typez00_bglt BgL_typez00_36, obj_t BgL_symbolz00_37,
		obj_t BgL_llocz00_38, obj_t BgL_stackz00_39)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 232 */
			{	/* Trace/walk.scm 233 */
				obj_t BgL_locz00_1037;

				BgL_locz00_1037 =
					(((BgL_nodez00_bglt) CREF(BgL_nodez00_35))->BgL_locz00);
				{	/* Trace/walk.scm 233 */
					obj_t BgL_auxz00_1038;

					BgL_auxz00_1038 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 4))));
					{	/* Trace/walk.scm 234 */
						obj_t BgL_tauxz00_1039;

						{	/* Trace/walk.scm 235 */
							obj_t BgL_arg3532z00_1112;

							BgL_arg3532z00_1112 =
								(((BgL_typez00_bglt) CREF(BgL_typez00_36))->BgL_idz00);
							BgL_tauxz00_1039 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1038,
								BgL_arg3532z00_1112);
						}
						{	/* Trace/walk.scm 235 */
							obj_t BgL_symz00_1040;

							BgL_symz00_1040 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											5))));
							{	/* Trace/walk.scm 236 */
								obj_t BgL_szb2zb2_1041;

								{	/* Trace/walk.scm 237 */
									bool_t BgL_testz00_3771;

									if (PAIRP(BgL_stackz00_39))
										{	/* Trace/walk.scm 237 */
											obj_t BgL_arg3530z00_1110;

											BgL_arg3530z00_1110 = CAR(BgL_stackz00_39);
											BgL_testz00_3771 =
												BGl_iszd2azf3z21zz__objectz00(BgL_arg3530z00_1110,
												BGl_variablez00zzast_varz00);
										}
									else
										{	/* Trace/walk.scm 237 */
											BgL_testz00_3771 = ((bool_t) 0);
										}
									if (BgL_testz00_3771)
										{	/* Trace/walk.scm 238 */
											obj_t BgL_arg3523z00_1103;

											obj_t BgL_arg3524z00_1104;

											BgL_arg3523z00_1103 = CNST_TABLE_REF(((long) 6));
											{	/* Trace/walk.scm 238 */
												BgL_variablez00_bglt BgL_obj1511z00_1987;

												{	/* Trace/walk.scm 238 */
													obj_t BgL_pairz00_1986;

													BgL_pairz00_1986 = BgL_stackz00_39;
													BgL_obj1511z00_1987 =
														(BgL_variablez00_bglt) (CAR(BgL_pairz00_1986));
												}
												BgL_arg3524z00_1104 =
													(((BgL_variablez00_bglt) CREF(BgL_obj1511z00_1987))->
													BgL_idz00);
											}
											{	/* Trace/walk.scm 238 */
												obj_t BgL_list3525z00_1105;

												{	/* Trace/walk.scm 238 */
													obj_t BgL_arg3526z00_1106;

													{	/* Trace/walk.scm 238 */
														obj_t BgL_arg3527z00_1107;

														BgL_arg3527z00_1107 =
															MAKE_PAIR(BgL_arg3524z00_1104, BNIL);
														BgL_arg3526z00_1106 =
															MAKE_PAIR(BgL_arg3523z00_1103,
															BgL_arg3527z00_1107);
													}
													BgL_list3525z00_1105 =
														MAKE_PAIR(BgL_symbolz00_37, BgL_arg3526z00_1106);
												}
												BgL_szb2zb2_1041 =
													BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
													(BgL_list3525z00_1105);
										}}
									else
										{	/* Trace/walk.scm 237 */
											BgL_szb2zb2_1041 = BgL_symbolz00_37;
										}
								}
								{	/* Trace/walk.scm 237 */
									obj_t BgL_szb2zb2z00_1042;

									{	/* Trace/walk.scm 240 */
										bool_t BgL_testz00_3784;

										{	/* Trace/walk.scm 240 */
											bool_t BgL_testz00_3785;

											if (STRUCTP(BgL_locz00_1037))
												{	/* Trace/walk.scm 240 */
													BgL_testz00_3785 =
														(STRUCT_KEY(BgL_locz00_1037) ==
														CNST_TABLE_REF(((long) 7)));
												}
											else
												{	/* Trace/walk.scm 240 */
													BgL_testz00_3785 = ((bool_t) 0);
												}
											if (BgL_testz00_3785)
												{	/* Trace/walk.scm 240 */
													if (CBOOL
														(BGl_za2bmemzd2profilingza2zd2zzengine_paramz00))
														{	/* Trace/walk.scm 240 */
															BgL_testz00_3784 = ((bool_t) 0);
														}
													else
														{	/* Trace/walk.scm 240 */
															BgL_testz00_3784 = ((bool_t) 1);
														}
												}
											else
												{	/* Trace/walk.scm 240 */
													BgL_testz00_3784 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_3784)
											{	/* Trace/walk.scm 244 */
												obj_t BgL_slocz00_1089;

												{	/* Trace/walk.scm 244 */
													obj_t BgL_arg3517z00_1097;

													obj_t BgL_arg3518z00_1098;

													BgL_arg3517z00_1097 =
														STRUCT_REF(BgL_locz00_1037, (int) (((long) 0)));
													BgL_arg3518z00_1098 =
														STRUCT_REF(BgL_locz00_1037, (int) (((long) 2)));
													{	/* Trace/walk.scm 244 */
														obj_t BgL_list3519z00_1099;

														{	/* Trace/walk.scm 244 */
															obj_t BgL_arg3520z00_1100;

															BgL_arg3520z00_1100 =
																MAKE_PAIR(BgL_arg3518z00_1098, BNIL);
															BgL_list3519z00_1099 =
																MAKE_PAIR(BgL_arg3517z00_1097,
																BgL_arg3520z00_1100);
														}
														BgL_slocz00_1089 =
															BGl_formatz00zz__r4_output_6_10_3z00
															(BGl_string3870z00zztrace_walkz00,
															BgL_list3519z00_1099);
												}}
												{	/* Trace/walk.scm 247 */
													obj_t BgL_arg3510z00_1090;

													{	/* Trace/walk.scm 247 */
														obj_t BgL_arg3511z00_1091;

														obj_t BgL_arg3512z00_1092;

														BgL_arg3511z00_1091 =
															SYMBOL_TO_STRING(BgL_szb2zb2_1041);
														{	/* Trace/walk.scm 247 */
															obj_t BgL_arg3515z00_1095;

															{	/* Trace/walk.scm 247 */
																obj_t BgL_stringz00_2002;

																BgL_stringz00_2002 = BgL_slocz00_1089;
																BgL_arg3515z00_1095 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_stringz00_2002));
															}
															BgL_arg3512z00_1092 =
																SYMBOL_TO_STRING(BgL_arg3515z00_1095);
														}
														{	/* Trace/walk.scm 247 */
															obj_t BgL_list3513z00_1093;

															{	/* Trace/walk.scm 247 */
																obj_t BgL_arg3514z00_1094;

																BgL_arg3514z00_1094 =
																	MAKE_PAIR(BgL_arg3512z00_1092, BNIL);
																BgL_list3513z00_1093 =
																	MAKE_PAIR(BgL_arg3511z00_1091,
																	BgL_arg3514z00_1094);
															}
															BgL_arg3510z00_1090 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list3513z00_1093);
													}}
													BgL_szb2zb2z00_1042 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg3510z00_1090));
											}}
										else
											{	/* Trace/walk.scm 240 */
												BgL_szb2zb2z00_1042 = BgL_szb2zb2_1041;
											}
									}
									{	/* Trace/walk.scm 240 */
										obj_t BgL_expz00_1043;

										{	/* Trace/walk.scm 249 */
											obj_t BgL_arg3468z00_1047;

											obj_t BgL_arg3469z00_1048;

											BgL_arg3468z00_1047 = CNST_TABLE_REF(((long) 8));
											{	/* Trace/walk.scm 249 */
												obj_t BgL_arg3470z00_1049;

												obj_t BgL_arg3471z00_1050;

												{	/* Trace/walk.scm 249 */
													obj_t BgL_arg3475z00_1054;

													{	/* Trace/walk.scm 249 */
														obj_t BgL_arg3477z00_1056;

														{	/* Trace/walk.scm 249 */
															obj_t BgL_arg3478z00_1057;

															{	/* Trace/walk.scm 249 */
																obj_t BgL_arg3481z00_1060;

																obj_t BgL_arg3482z00_1061;

																BgL_arg3481z00_1060 =
																	CNST_TABLE_REF(((long) 9));
																{	/* Trace/walk.scm 249 */
																	obj_t BgL_list3483z00_1062;

																	BgL_list3483z00_1062 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3482z00_1061 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_szb2zb2z00_1042, BgL_list3483z00_1062);
																}
																BgL_arg3478z00_1057 =
																	MAKE_PAIR(BgL_arg3481z00_1060,
																	BgL_arg3482z00_1061);
															}
															{	/* Trace/walk.scm 249 */
																obj_t BgL_list3480z00_1059;

																BgL_list3480z00_1059 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3477z00_1056 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3478z00_1057, BgL_list3480z00_1059);
														}}
														BgL_arg3475z00_1054 =
															MAKE_PAIR(BgL_symz00_1040, BgL_arg3477z00_1056);
													}
													BgL_arg3470z00_1049 =
														MAKE_PAIR(BgL_arg3475z00_1054, BNIL);
												}
												{	/* Trace/walk.scm 250 */
													obj_t BgL_arg3484z00_1063;

													obj_t BgL_arg3485z00_1064;

													BgL_arg3484z00_1063 = CNST_TABLE_REF(((long) 8));
													{	/* Trace/walk.scm 250 */
														obj_t BgL_arg3487z00_1066;

														obj_t BgL_arg3488z00_1067;

														{	/* Trace/walk.scm 251 */
															obj_t BgL_arg3493z00_1072;

															obj_t BgL_arg3494z00_1073;

															BgL_arg3493z00_1072 = CNST_TABLE_REF(((long) 10));
															{	/* Trace/walk.scm 251 */
																obj_t BgL_list3495z00_1074;

																BgL_list3495z00_1074 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3494z00_1073 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_symz00_1040, BgL_list3495z00_1074);
															}
															BgL_arg3487z00_1066 =
																MAKE_PAIR(BgL_arg3493z00_1072,
																BgL_arg3494z00_1073);
														}
														{	/* Trace/walk.scm 252 */
															obj_t BgL_arg3496z00_1075;

															obj_t BgL_arg3497z00_1076;

															BgL_arg3496z00_1075 = CNST_TABLE_REF(((long) 8));
															{	/* Trace/walk.scm 252 */
																obj_t BgL_arg3498z00_1077;

																obj_t BgL_arg3499z00_1078;

																{	/* Trace/walk.scm 252 */
																	obj_t BgL_arg3504z00_1083;

																	{	/* Trace/walk.scm 252 */
																		obj_t BgL_arg3506z00_1085;

																		{	/* Trace/walk.scm 252 */
																			obj_t BgL_list3507z00_1086;

																			BgL_list3507z00_1086 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3506z00_1085 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				((obj_t) (BgL_nodez00_35),
																				BgL_list3507z00_1086);
																		}
																		BgL_arg3504z00_1083 =
																			MAKE_PAIR(BgL_tauxz00_1039,
																			BgL_arg3506z00_1085);
																	}
																	BgL_arg3498z00_1077 =
																		MAKE_PAIR(BgL_arg3504z00_1083, BNIL);
																}
																{	/* Trace/walk.scm 253 */
																	bool_t BgL_testz00_3829;

																	if (STRUCTP(BgL_llocz00_38))
																		{	/* Trace/walk.scm 253 */
																			BgL_testz00_3829 =
																				(STRUCT_KEY(BgL_llocz00_38) ==
																				CNST_TABLE_REF(((long) 7)));
																		}
																	else
																		{	/* Trace/walk.scm 253 */
																			BgL_testz00_3829 = ((bool_t) 0);
																		}
																	if (BgL_testz00_3829)
																		{	/* Trace/walk.scm 254 */
																			obj_t BgL_res3750z00_2015;

																			{	/* Trace/walk.scm 254 */
																				obj_t BgL_obj1z00_2012;

																				BgL_obj1z00_2012 =
																					CNST_TABLE_REF(((long) 11));
																				BgL_res3750z00_2015 =
																					MAKE_EXTENDED_PAIR(BgL_obj1z00_2012,
																					BNIL, BgL_llocz00_38);
																			}
																			BgL_arg3499z00_1078 = BgL_res3750z00_2015;
																		}
																	else
																		{	/* Trace/walk.scm 253 */
																			BgL_arg3499z00_1078 =
																				CNST_TABLE_REF(((long) 12));
																}}
																{	/* Trace/walk.scm 252 */
																	obj_t BgL_list3501z00_1080;

																	{	/* Trace/walk.scm 252 */
																		obj_t BgL_arg3502z00_1081;

																		{	/* Trace/walk.scm 252 */
																			obj_t BgL_arg3503z00_1082;

																			BgL_arg3503z00_1082 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3502z00_1081 =
																				MAKE_PAIR(BgL_auxz00_1038,
																				BgL_arg3503z00_1082);
																		}
																		BgL_list3501z00_1080 =
																			MAKE_PAIR(BgL_arg3499z00_1078,
																			BgL_arg3502z00_1081);
																	}
																	BgL_arg3497z00_1076 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3498z00_1077, BgL_list3501z00_1080);
															}}
															BgL_arg3488z00_1067 =
																MAKE_PAIR(BgL_arg3496z00_1075,
																BgL_arg3497z00_1076);
														}
														{	/* Trace/walk.scm 250 */
															obj_t BgL_list3490z00_1069;

															{	/* Trace/walk.scm 250 */
																obj_t BgL_arg3491z00_1070;

																{	/* Trace/walk.scm 250 */
																	obj_t BgL_arg3492z00_1071;

																	BgL_arg3492z00_1071 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3491z00_1070 =
																		MAKE_PAIR(BgL_arg3488z00_1067,
																		BgL_arg3492z00_1071);
																}
																BgL_list3490z00_1069 =
																	MAKE_PAIR(BgL_arg3487z00_1066,
																	BgL_arg3491z00_1070);
															}
															BgL_arg3485z00_1064 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BNIL, BgL_list3490z00_1069);
													}}
													BgL_arg3471z00_1050 =
														MAKE_PAIR(BgL_arg3484z00_1063, BgL_arg3485z00_1064);
												}
												{	/* Trace/walk.scm 249 */
													obj_t BgL_list3473z00_1052;

													{	/* Trace/walk.scm 249 */
														obj_t BgL_arg3474z00_1053;

														BgL_arg3474z00_1053 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3473z00_1052 =
															MAKE_PAIR(BgL_arg3471z00_1050,
															BgL_arg3474z00_1053);
													}
													BgL_arg3469z00_1048 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3470z00_1049, BgL_list3473z00_1052);
											}}
											BgL_expz00_1043 =
												MAKE_PAIR(BgL_arg3468z00_1047, BgL_arg3469z00_1048);
										}
										{	/* Trace/walk.scm 249 */
											BgL_nodez00_bglt BgL_nodez00_1044;

											BgL_nodez00_1044 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1043,
												BNIL, BgL_locz00_1037, CNST_TABLE_REF(((long) 13)));
											{	/* Trace/walk.scm 257 */

												{	/* Trace/walk.scm 258 */
													bool_t BgL_arg3466z00_1045;

													{	/* Trace/walk.scm 258 */
														obj_t BgL_arg3467z00_1046;

														BgL_arg3467z00_1046 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														{
															BgL_backendz00_bglt BgL_auxz00_3855;

															BgL_auxz00_3855 =
																(BgL_backendz00_bglt) (BgL_arg3467z00_1046);
															BgL_arg3466z00_1045 =
																(((BgL_backendz00_bglt) CREF(BgL_auxz00_3855))->
																BgL_removezd2emptyzd2letz00);
													}}
													{
														BgL_letzd2varzd2_bglt BgL_auxz00_3858;

														BgL_auxz00_3858 =
															(BgL_letzd2varzd2_bglt) (BgL_nodez00_1044);
														((((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_3858))->
																BgL_removablezf3zf3) =
															((bool_t) BgL_arg3466z00_1045), BUNSPEC);
												}}
												return (BgL_letzd2varzd2_bglt) (BgL_nodez00_1044);
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* trace-node*! */
	obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_78,
		obj_t BgL_stackz00_79)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 413 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_78))
				{	/* Trace/walk.scm 414 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 414 */
					{	/* Trace/walk.scm 417 */
						BgL_nodez00_bglt BgL_arg3535z00_1115;

						{	/* Trace/walk.scm 417 */
							obj_t BgL_arg3536z00_1116;

							BgL_arg3536z00_1116 = CAR(BgL_nodeza2za2_78);
							{	/* Trace/walk.scm 417 */
								BgL_nodez00_bglt BgL_res3753z00_2048;

								{	/* Trace/walk.scm 417 */
									BgL_nodez00_bglt BgL_nodez00_2021;

									BgL_nodez00_2021 = (BgL_nodez00_bglt) (BgL_arg3536z00_1116);
									{	/* Trace/walk.scm 417 */
										obj_t BgL_method3330z00_2023;

										{	/* Trace/walk.scm 417 */
											BgL_objectz00_bglt BgL_objz00_2024;

											BgL_objz00_2024 = (BgL_objectz00_bglt) (BgL_nodez00_2021);
											{	/* Trace/walk.scm 417 */
												long BgL_objzd2classzd2numz00_2025;

												BgL_objzd2classzd2numz00_2025 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2024);
												{	/* Trace/walk.scm 417 */
													obj_t BgL_arg2551z00_2026;

													BgL_arg2551z00_2026 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 417 */
														obj_t BgL_arrayz00_2028;

														int BgL_offsetz00_2029;

														BgL_arrayz00_2028 = BgL_arg2551z00_2026;
														BgL_offsetz00_2029 =
															(int) (BgL_objzd2classzd2numz00_2025);
														{	/* Trace/walk.scm 417 */
															long BgL_offsetz00_2030;

															BgL_offsetz00_2030 =
																((long) (BgL_offsetz00_2029) - OBJECT_TYPE);
															{	/* Trace/walk.scm 417 */
																long BgL_modz00_2031;

																{	/* Trace/walk.scm 417 */
																	int BgL_arg2553z00_2032;

																	BgL_arg2553z00_2032 = (int) (((long) 8));
																	{	/* Trace/walk.scm 417 */
																		long BgL_auxz00_3875;

																		BgL_auxz00_3875 =
																			(long) (BgL_arg2553z00_2032);
																		BgL_modz00_2031 =
																			(BgL_offsetz00_2030 / BgL_auxz00_3875);
																}}
																{	/* Trace/walk.scm 417 */
																	long BgL_restz00_2033;

																	{	/* Trace/walk.scm 417 */
																		int BgL_arg2552z00_2034;

																		BgL_arg2552z00_2034 = (int) (((long) 8));
																		{	/* Trace/walk.scm 417 */
																			long BgL_auxz00_3879;

																			BgL_auxz00_3879 =
																				(long) (BgL_arg2552z00_2034);
																			BgL_restz00_2033 =
																				(BgL_offsetz00_2030 % BgL_auxz00_3879);
																	}}
																	{	/* Trace/walk.scm 417 */

																		BgL_method3330z00_2023 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2028,
																				(int) (BgL_modz00_2031)),
																			(int) (BgL_restz00_2033));
										}}}}}}}}
										BgL_res3753z00_2048 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3330z00_2023) (BgL_method3330z00_2023,
												(obj_t) (BgL_nodez00_2021), BgL_stackz00_79, BEOA));
								}}
								BgL_arg3535z00_1115 = BgL_res3753z00_2048;
						}}
						{	/* Trace/walk.scm 417 */
							obj_t BgL_auxz00_3890;

							BgL_auxz00_3890 = (obj_t) (BgL_arg3535z00_1115);
							SET_CAR(BgL_nodeza2za2_78, BgL_auxz00_3890);
					}}
					{
						obj_t BgL_nodeza2za2_3893;

						BgL_nodeza2za2_3893 = CDR(BgL_nodeza2za2_78);
						BgL_nodeza2za2_78 = BgL_nodeza2za2_3893;
						goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
					}
				}
		}
	}



/* toplevel-trace-node*! */
	obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_84)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 458 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_84))
				{	/* Trace/walk.scm 459 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 459 */
					{	/* Trace/walk.scm 462 */
						BgL_nodez00_bglt BgL_arg3539z00_1119;

						{	/* Trace/walk.scm 462 */
							obj_t BgL_arg3540z00_1120;

							BgL_arg3540z00_1120 = CAR(BgL_nodeza2za2_84);
							{	/* Trace/walk.scm 462 */
								BgL_nodez00_bglt BgL_res3756z00_2080;

								{	/* Trace/walk.scm 462 */
									BgL_nodez00_bglt BgL_nodez00_2054;

									BgL_nodez00_2054 = (BgL_nodez00_bglt) (BgL_arg3540z00_1120);
									{	/* Trace/walk.scm 462 */
										obj_t BgL_method3368z00_2055;

										{	/* Trace/walk.scm 462 */
											BgL_objectz00_bglt BgL_objz00_2056;

											BgL_objz00_2056 = (BgL_objectz00_bglt) (BgL_nodez00_2054);
											{	/* Trace/walk.scm 462 */
												long BgL_objzd2classzd2numz00_2057;

												BgL_objzd2classzd2numz00_2057 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2056);
												{	/* Trace/walk.scm 462 */
													obj_t BgL_arg2551z00_2058;

													BgL_arg2551z00_2058 =
														PROCEDURE_REF
														(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 462 */
														obj_t BgL_arrayz00_2060;

														int BgL_offsetz00_2061;

														BgL_arrayz00_2060 = BgL_arg2551z00_2058;
														BgL_offsetz00_2061 =
															(int) (BgL_objzd2classzd2numz00_2057);
														{	/* Trace/walk.scm 462 */
															long BgL_offsetz00_2062;

															BgL_offsetz00_2062 =
																((long) (BgL_offsetz00_2061) - OBJECT_TYPE);
															{	/* Trace/walk.scm 462 */
																long BgL_modz00_2063;

																{	/* Trace/walk.scm 462 */
																	int BgL_arg2553z00_2064;

																	BgL_arg2553z00_2064 = (int) (((long) 8));
																	{	/* Trace/walk.scm 462 */
																		long BgL_auxz00_3908;

																		BgL_auxz00_3908 =
																			(long) (BgL_arg2553z00_2064);
																		BgL_modz00_2063 =
																			(BgL_offsetz00_2062 / BgL_auxz00_3908);
																}}
																{	/* Trace/walk.scm 462 */
																	long BgL_restz00_2065;

																	{	/* Trace/walk.scm 462 */
																		int BgL_arg2552z00_2066;

																		BgL_arg2552z00_2066 = (int) (((long) 8));
																		{	/* Trace/walk.scm 462 */
																			long BgL_auxz00_3912;

																			BgL_auxz00_3912 =
																				(long) (BgL_arg2552z00_2066);
																			BgL_restz00_2065 =
																				(BgL_offsetz00_2062 % BgL_auxz00_3912);
																	}}
																	{	/* Trace/walk.scm 462 */

																		BgL_method3368z00_2055 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2060,
																				(int) (BgL_modz00_2063)),
																			(int) (BgL_restz00_2065));
										}}}}}}}}
										BgL_res3756z00_2080 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3368z00_2055) (BgL_method3368z00_2055,
												(obj_t) (BgL_nodez00_2054), BEOA));
								}}
								BgL_arg3539z00_1119 = BgL_res3756z00_2080;
						}}
						{	/* Trace/walk.scm 462 */
							obj_t BgL_auxz00_3923;

							BgL_auxz00_3923 = (obj_t) (BgL_arg3539z00_1119);
							SET_CAR(BgL_nodeza2za2_84, BgL_auxz00_3923);
					}}
					{
						obj_t BgL_nodeza2za2_3926;

						BgL_nodeza2za2_3926 = CDR(BgL_nodeza2za2_84);
						BgL_nodeza2za2_84 = BgL_nodeza2za2_3926;
						goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_findzd2lastzd2nodezd2defau3301zd2envz00zztrace_walkz00);
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_tracezd2nodezd2default3329zd2envzd2zztrace_walkz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_toplevelzd2tracezd2nodezd23367zd2envz00zztrace_walkz00);
		}
	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_20)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 133 */
			{	/* Trace/walk.scm 133 */
				obj_t BgL_method3302z00_2084;

				{	/* Trace/walk.scm 133 */
					BgL_objectz00_bglt BgL_objz00_2085;

					BgL_objz00_2085 = (BgL_objectz00_bglt) (BgL_nodez00_20);
					{	/* Trace/walk.scm 133 */
						long BgL_objzd2classzd2numz00_2086;

						BgL_objzd2classzd2numz00_2086 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2085);
						{	/* Trace/walk.scm 133 */
							obj_t BgL_arg2551z00_2087;

							BgL_arg2551z00_2087 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 133 */
								obj_t BgL_arrayz00_2089;

								int BgL_offsetz00_2090;

								BgL_arrayz00_2089 = BgL_arg2551z00_2087;
								BgL_offsetz00_2090 = (int) (BgL_objzd2classzd2numz00_2086);
								{	/* Trace/walk.scm 133 */
									long BgL_offsetz00_2091;

									BgL_offsetz00_2091 =
										((long) (BgL_offsetz00_2090) - OBJECT_TYPE);
									{	/* Trace/walk.scm 133 */
										long BgL_modz00_2092;

										{	/* Trace/walk.scm 133 */
											int BgL_arg2553z00_2093;

											BgL_arg2553z00_2093 = (int) (((long) 8));
											{	/* Trace/walk.scm 133 */
												long BgL_auxz00_3939;

												BgL_auxz00_3939 = (long) (BgL_arg2553z00_2093);
												BgL_modz00_2092 =
													(BgL_offsetz00_2091 / BgL_auxz00_3939);
										}}
										{	/* Trace/walk.scm 133 */
											long BgL_restz00_2094;

											{	/* Trace/walk.scm 133 */
												int BgL_arg2552z00_2095;

												BgL_arg2552z00_2095 = (int) (((long) 8));
												{	/* Trace/walk.scm 133 */
													long BgL_auxz00_3943;

													BgL_auxz00_3943 = (long) (BgL_arg2552z00_2095);
													BgL_restz00_2094 =
														(BgL_offsetz00_2091 % BgL_auxz00_3943);
											}}
											{	/* Trace/walk.scm 133 */

												BgL_method3302z00_2084 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2089,
														(int) (BgL_modz00_2092)), (int) (BgL_restz00_2094));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3302z00_2084) (BgL_method3302z00_2084,
					(obj_t) (BgL_nodez00_20), BEOA);
			}
		}
	}



/* _find-last-node */
	obj_t BGl__findzd2lastzd2nodez00zztrace_walkz00(obj_t BgL_envz00_3325,
		obj_t BgL_nodez00_3326)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 133 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(BgL_nodez00_bglt) (BgL_nodez00_3326));
		}
	}



/* _find-last-node-defau3301 */
	obj_t BGl__findzd2lastzd2nodezd2defau3301zd2zztrace_walkz00(obj_t
		BgL_envz00_3330, obj_t BgL_nodez00_3331)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3331));
		}
	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_40, obj_t BgL_stackz00_41)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 264 */
			{	/* Trace/walk.scm 264 */
				obj_t BgL_method3330z00_2109;

				{	/* Trace/walk.scm 264 */
					BgL_objectz00_bglt BgL_objz00_2110;

					BgL_objz00_2110 = (BgL_objectz00_bglt) (BgL_nodez00_40);
					{	/* Trace/walk.scm 264 */
						long BgL_objzd2classzd2numz00_2111;

						BgL_objzd2classzd2numz00_2111 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2110);
						{	/* Trace/walk.scm 264 */
							obj_t BgL_arg2551z00_2112;

							BgL_arg2551z00_2112 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 264 */
								obj_t BgL_arrayz00_2114;

								int BgL_offsetz00_2115;

								BgL_arrayz00_2114 = BgL_arg2551z00_2112;
								BgL_offsetz00_2115 = (int) (BgL_objzd2classzd2numz00_2111);
								{	/* Trace/walk.scm 264 */
									long BgL_offsetz00_2116;

									BgL_offsetz00_2116 =
										((long) (BgL_offsetz00_2115) - OBJECT_TYPE);
									{	/* Trace/walk.scm 264 */
										long BgL_modz00_2117;

										{	/* Trace/walk.scm 264 */
											int BgL_arg2553z00_2118;

											BgL_arg2553z00_2118 = (int) (((long) 8));
											{	/* Trace/walk.scm 264 */
												long BgL_auxz00_3965;

												BgL_auxz00_3965 = (long) (BgL_arg2553z00_2118);
												BgL_modz00_2117 =
													(BgL_offsetz00_2116 / BgL_auxz00_3965);
										}}
										{	/* Trace/walk.scm 264 */
											long BgL_restz00_2119;

											{	/* Trace/walk.scm 264 */
												int BgL_arg2552z00_2120;

												BgL_arg2552z00_2120 = (int) (((long) 8));
												{	/* Trace/walk.scm 264 */
													long BgL_auxz00_3969;

													BgL_auxz00_3969 = (long) (BgL_arg2552z00_2120);
													BgL_restz00_2119 =
														(BgL_offsetz00_2116 % BgL_auxz00_3969);
											}}
											{	/* Trace/walk.scm 264 */

												BgL_method3330z00_2109 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2114,
														(int) (BgL_modz00_2117)), (int) (BgL_restz00_2119));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2109)
					(BgL_method3330z00_2109, (obj_t) (BgL_nodez00_40), BgL_stackz00_41,
						BEOA));
			}
		}
	}



/* _trace-node */
	obj_t BGl__tracezd2nodezd2zztrace_walkz00(obj_t BgL_envz00_3327,
		obj_t BgL_nodez00_3328, obj_t BgL_stackz00_3329)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 264 */
			return
				(obj_t) (BGl_tracezd2nodezd2zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3328), BgL_stackz00_3329));
		}
	}



/* _trace-node-default3329 */
	obj_t BGl__tracezd2nodezd2default3329z00zztrace_walkz00(obj_t BgL_envz00_3332,
		obj_t BgL_nodez00_3333, obj_t BgL_stackz00_3334)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3333));
		}
	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_80)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 423 */
			{	/* Trace/walk.scm 423 */
				obj_t BgL_method3368z00_2134;

				{	/* Trace/walk.scm 423 */
					BgL_objectz00_bglt BgL_objz00_2135;

					BgL_objz00_2135 = (BgL_objectz00_bglt) (BgL_nodez00_80);
					{	/* Trace/walk.scm 423 */
						long BgL_objzd2classzd2numz00_2136;

						BgL_objzd2classzd2numz00_2136 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2135);
						{	/* Trace/walk.scm 423 */
							obj_t BgL_arg2551z00_2137;

							BgL_arg2551z00_2137 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 423 */
								obj_t BgL_arrayz00_2139;

								int BgL_offsetz00_2140;

								BgL_arrayz00_2139 = BgL_arg2551z00_2137;
								BgL_offsetz00_2140 = (int) (BgL_objzd2classzd2numz00_2136);
								{	/* Trace/walk.scm 423 */
									long BgL_offsetz00_2141;

									BgL_offsetz00_2141 =
										((long) (BgL_offsetz00_2140) - OBJECT_TYPE);
									{	/* Trace/walk.scm 423 */
										long BgL_modz00_2142;

										{	/* Trace/walk.scm 423 */
											int BgL_arg2553z00_2143;

											BgL_arg2553z00_2143 = (int) (((long) 8));
											{	/* Trace/walk.scm 423 */
												long BgL_auxz00_3993;

												BgL_auxz00_3993 = (long) (BgL_arg2553z00_2143);
												BgL_modz00_2142 =
													(BgL_offsetz00_2141 / BgL_auxz00_3993);
										}}
										{	/* Trace/walk.scm 423 */
											long BgL_restz00_2144;

											{	/* Trace/walk.scm 423 */
												int BgL_arg2552z00_2145;

												BgL_arg2552z00_2145 = (int) (((long) 8));
												{	/* Trace/walk.scm 423 */
													long BgL_auxz00_3997;

													BgL_auxz00_3997 = (long) (BgL_arg2552z00_2145);
													BgL_restz00_2144 =
														(BgL_offsetz00_2141 % BgL_auxz00_3997);
											}}
											{	/* Trace/walk.scm 423 */

												BgL_method3368z00_2134 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2139,
														(int) (BgL_modz00_2142)), (int) (BgL_restz00_2144));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3368z00_2134)
					(BgL_method3368z00_2134, (obj_t) (BgL_nodez00_80), BEOA));
			}
		}
	}



/* _toplevel-trace-node */
	obj_t BGl__toplevelzd2tracezd2nodez00zztrace_walkz00(obj_t BgL_envz00_3323,
		obj_t BgL_nodez00_3324)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 423 */
			return
				(obj_t) (BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3324)));
		}
	}



/* _toplevel-trace-node-3367 */
	obj_t BGl__toplevelzd2tracezd2nodezd23367zd2zztrace_walkz00(obj_t
		BgL_envz00_3335, obj_t BgL_nodez00_3336)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3336));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3871z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc3872z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3873z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3874z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc3875z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3876z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3877z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc3878z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_selectz00zzast_nodez00, BGl_proc3879z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3880z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3881z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3882z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3883z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3884z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3885z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3886z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3887z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3888z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3889z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3890z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3891z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3892z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3893z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3894z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3895z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3896z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3897z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3898z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3899z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3900z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3901z00zztrace_walkz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3902z00zztrace_walkz00);
		}
	}



/* toplevel-trace-node-3372 */
	obj_t BGl_toplevelzd2tracezd2nodezd23372zd2zztrace_walkz00(obj_t
		BgL_envz00_3369, obj_t BgL_nodez00_3370)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 441 */
			{
				BgL_setqz00_bglt BgL_nodez00_1798;

				{	/* Trace/walk.scm 442 */
					BgL_setqz00_bglt BgL_auxz00_4045;

					BgL_nodez00_1798 = (BgL_setqz00_bglt) (BgL_nodez00_3370);
					{	/* Trace/walk.scm 443 */
						BgL_varz00_bglt BgL_instance3287z00_1802;

						BgL_instance3287z00_1802 =
							(((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->BgL_varz00);
						{	/* Trace/walk.scm 444 */
							bool_t BgL_testz00_4047;

							{	/* Trace/walk.scm 444 */
								bool_t BgL_testz00_4048;

								{	/* Trace/walk.scm 444 */
									BgL_variablez00_bglt BgL_arg3733z00_1821;

									BgL_arg3733z00_1821 =
										(((BgL_varz00_bglt) CREF(BgL_instance3287z00_1802))->
										BgL_variablez00);
									{	/* Trace/walk.scm 444 */
										obj_t BgL_obj1658z00_3304;

										BgL_obj1658z00_3304 = (obj_t) (BgL_arg3733z00_1821);
										BgL_testz00_4048 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1658z00_3304,
											BGl_globalz00zzast_varz00);
									}
								}
								if (BgL_testz00_4048)
									{	/* Trace/walk.scm 445 */
										bool_t BgL_testz00_4052;

										{	/* Trace/walk.scm 445 */
											bool_t BgL_testz00_4053;

											{	/* Trace/walk.scm 445 */
												BgL_nodez00_bglt BgL_arg3732z00_1820;

												BgL_arg3732z00_1820 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->
													BgL_valuez00);
												{	/* Trace/walk.scm 445 */
													obj_t BgL_obj2056z00_3306;

													BgL_obj2056z00_3306 = (obj_t) (BgL_arg3732z00_1820);
													BgL_testz00_4053 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj2056z00_3306,
														BGl_atomz00zzast_nodez00);
												}
											}
											if (BgL_testz00_4053)
												{	/* Trace/walk.scm 445 */
													BgL_testz00_4052 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 446 */
													bool_t BgL_testz00_4057;

													{	/* Trace/walk.scm 446 */
														BgL_nodez00_bglt BgL_arg3731z00_1819;

														BgL_arg3731z00_1819 =
															(((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->
															BgL_valuez00);
														{	/* Trace/walk.scm 446 */
															obj_t BgL_obj2077z00_3308;

															BgL_obj2077z00_3308 =
																(obj_t) (BgL_arg3731z00_1819);
															BgL_testz00_4057 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj2077z00_3308, BGl_varz00zzast_nodez00);
														}
													}
													if (BgL_testz00_4057)
														{	/* Trace/walk.scm 446 */
															BgL_testz00_4052 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 447 */
															bool_t BgL_testz00_4061;

															{	/* Trace/walk.scm 447 */
																BgL_nodez00_bglt BgL_arg3730z00_1818;

																BgL_arg3730z00_1818 =
																	(((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->
																	BgL_valuez00);
																{	/* Trace/walk.scm 447 */
																	obj_t BgL_obj2115z00_3310;

																	BgL_obj2115z00_3310 =
																		(obj_t) (BgL_arg3730z00_1818);
																	BgL_testz00_4061 =
																		BGl_iszd2azf3z21zz__objectz00
																		(BgL_obj2115z00_3310,
																		BGl_kwotez00zzast_nodez00);
																}
															}
															if (BgL_testz00_4061)
																{	/* Trace/walk.scm 447 */
																	BgL_testz00_4052 = ((bool_t) 1);
																}
															else
																{	/* Trace/walk.scm 448 */
																	BgL_nodez00_bglt BgL_arg3729z00_1817;

																	BgL_arg3729z00_1817 =
																		(((BgL_setqz00_bglt)
																			CREF(BgL_nodez00_1798))->BgL_valuez00);
																	{	/* Trace/walk.scm 448 */
																		obj_t BgL_obj2323z00_3312;

																		BgL_obj2323z00_3312 =
																			(obj_t) (BgL_arg3729z00_1817);
																		BgL_testz00_4052 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj2323z00_3312,
																			BGl_pragmaz00zzast_nodez00);
																	}
																}
														}
												}
										}
										if (BgL_testz00_4052)
											{	/* Trace/walk.scm 445 */
												BgL_testz00_4047 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 445 */
												BgL_testz00_4047 = ((bool_t) 1);
											}
									}
								else
									{	/* Trace/walk.scm 444 */
										BgL_testz00_4047 = ((bool_t) 0);
									}
							}
							if (BgL_testz00_4047)
								{	/* Trace/walk.scm 449 */
									obj_t BgL_idz00_1804;

									{	/* Trace/walk.scm 449 */
										BgL_variablez00_bglt BgL_obj1511z00_3314;

										BgL_obj1511z00_3314 =
											(((BgL_varz00_bglt) CREF(BgL_instance3287z00_1802))->
											BgL_variablez00);
										BgL_idz00_1804 =
											(((BgL_variablez00_bglt) CREF(BgL_obj1511z00_3314))->
											BgL_idz00);
									}
									{	/* Trace/walk.scm 449 */
										BgL_typez00_bglt BgL_typez00_1805;

										{	/* Trace/walk.scm 450 */
											BgL_variablez00_bglt BgL_obj1515z00_3316;

											BgL_obj1515z00_3316 =
												(((BgL_varz00_bglt) CREF(BgL_instance3287z00_1802))->
												BgL_variablez00);
											BgL_typez00_1805 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1515z00_3316))->
												BgL_typez00);
										}
										{	/* Trace/walk.scm 450 */
											BgL_letzd2varzd2_bglt BgL_tracez00_1806;

											{	/* Trace/walk.scm 451 */
												BgL_nodez00_bglt BgL_arg3719z00_1807;

												obj_t BgL_arg3720z00_1808;

												BgL_arg3719z00_1807 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->
													BgL_valuez00);
												{
													BgL_nodez00_bglt BgL_auxz00_4073;

													BgL_auxz00_4073 =
														(BgL_nodez00_bglt) (BgL_nodez00_1798);
													BgL_arg3720z00_1808 =
														(((BgL_nodez00_bglt) CREF(BgL_auxz00_4073))->
														BgL_locz00);
												}
												BgL_tracez00_1806 =
													BGl_makezd2tracedzd2nodez00zztrace_walkz00
													(BgL_arg3719z00_1807, BgL_typez00_1805,
													BgL_idz00_1804, BgL_arg3720z00_1808, BNIL);
											}
											{	/* Trace/walk.scm 451 */

												{
													BgL_nodez00_bglt BgL_auxz00_4077;

													BgL_auxz00_4077 =
														(BgL_nodez00_bglt) (BgL_tracez00_1806);
													((((BgL_setqz00_bglt) CREF(BgL_nodez00_1798))->
															BgL_valuez00) =
														((BgL_nodez00_bglt) BgL_auxz00_4077), BUNSPEC);
												}
											}
										}
									}
								}
							else
								{	/* Trace/walk.scm 444 */
									BFALSE;
								}
						}
					}
					BgL_auxz00_4045 = BgL_nodez00_1798;
					return (obj_t) (BgL_auxz00_4045);
				}
			}
		}
	}



/* toplevel-trace-node-3370 */
	obj_t BGl_toplevelzd2tracezd2nodezd23370zd2zztrace_walkz00(obj_t
		BgL_envz00_3371, obj_t BgL_nodez00_3372)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 429 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1792;

				{	/* Trace/walk.scm 430 */
					BgL_sequencez00_bglt BgL_auxz00_4082;

					BgL_nodez00_1792 = (BgL_sequencez00_bglt) (BgL_nodez00_3372);
					{	/* Trace/walk.scm 430 */
						obj_t BgL_arg3716z00_3300;

						BgL_arg3716z00_3300 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1792))->BgL_nodesz00);
						BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00
							(BgL_arg3716z00_3300);
					}
					BgL_auxz00_4082 = BgL_nodez00_1792;
					return (obj_t) (BgL_auxz00_4082);
				}
			}
		}
	}



/* trace-node-box-set!3366 */
	obj_t BGl_tracezd2nodezd2boxzd2setz123366zc0zztrace_walkz00(obj_t
		BgL_envz00_3373, obj_t BgL_nodez00_3374, obj_t BgL_stackz00_3375)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 404 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1781;

				obj_t BgL_stackz00_1782;

				{	/* Trace/walk.scm 405 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_4087;

					BgL_nodez00_1781 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3374);
					BgL_stackz00_1782 = BgL_stackz00_3375;
					{	/* Trace/walk.scm 406 */
						BgL_nodez00_bglt BgL_arg3711z00_1786;

						{	/* Trace/walk.scm 406 */
							BgL_varz00_bglt BgL_arg3712z00_1787;

							BgL_arg3712z00_1787 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1781))->
								BgL_varz00);
							{	/* Trace/walk.scm 406 */
								BgL_nodez00_bglt BgL_res3856z00_3266;

								{	/* Trace/walk.scm 406 */
									BgL_nodez00_bglt BgL_nodez00_3239;

									BgL_nodez00_3239 = (BgL_nodez00_bglt) (BgL_arg3712z00_1787);
									{	/* Trace/walk.scm 406 */
										obj_t BgL_method3330z00_3241;

										{	/* Trace/walk.scm 406 */
											BgL_objectz00_bglt BgL_objz00_3242;

											BgL_objz00_3242 = (BgL_objectz00_bglt) (BgL_nodez00_3239);
											{	/* Trace/walk.scm 406 */
												long BgL_objzd2classzd2numz00_3243;

												BgL_objzd2classzd2numz00_3243 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3242);
												{	/* Trace/walk.scm 406 */
													obj_t BgL_arg2551z00_3244;

													BgL_arg2551z00_3244 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 406 */
														obj_t BgL_arrayz00_3246;

														int BgL_offsetz00_3247;

														BgL_arrayz00_3246 = BgL_arg2551z00_3244;
														BgL_offsetz00_3247 =
															(int) (BgL_objzd2classzd2numz00_3243);
														{	/* Trace/walk.scm 406 */
															long BgL_offsetz00_3248;

															BgL_offsetz00_3248 =
																((long) (BgL_offsetz00_3247) - OBJECT_TYPE);
															{	/* Trace/walk.scm 406 */
																long BgL_modz00_3249;

																{	/* Trace/walk.scm 406 */
																	int BgL_arg2553z00_3250;

																	BgL_arg2553z00_3250 = (int) (((long) 8));
																	{	/* Trace/walk.scm 406 */
																		long BgL_auxz00_4098;

																		BgL_auxz00_4098 =
																			(long) (BgL_arg2553z00_3250);
																		BgL_modz00_3249 =
																			(BgL_offsetz00_3248 / BgL_auxz00_4098);
																}}
																{	/* Trace/walk.scm 406 */
																	long BgL_restz00_3251;

																	{	/* Trace/walk.scm 406 */
																		int BgL_arg2552z00_3252;

																		BgL_arg2552z00_3252 = (int) (((long) 8));
																		{	/* Trace/walk.scm 406 */
																			long BgL_auxz00_4102;

																			BgL_auxz00_4102 =
																				(long) (BgL_arg2552z00_3252);
																			BgL_restz00_3251 =
																				(BgL_offsetz00_3248 % BgL_auxz00_4102);
																	}}
																	{	/* Trace/walk.scm 406 */

																		BgL_method3330z00_3241 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3246,
																				(int) (BgL_modz00_3249)),
																			(int) (BgL_restz00_3251));
										}}}}}}}}
										BgL_res3856z00_3266 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3330z00_3241) (BgL_method3330z00_3241,
												(obj_t) (BgL_nodez00_3239), BgL_stackz00_1782, BEOA));
								}}
								BgL_arg3711z00_1786 = BgL_res3856z00_3266;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4113;

							BgL_auxz00_4113 = (BgL_varz00_bglt) (BgL_arg3711z00_1786);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1781))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_4113), BUNSPEC);
					}}
					{	/* Trace/walk.scm 407 */
						BgL_nodez00_bglt BgL_arg3713z00_1788;

						{	/* Trace/walk.scm 407 */
							BgL_nodez00_bglt BgL_arg3714z00_1789;

							BgL_arg3714z00_1789 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1781))->
								BgL_valuez00);
							{	/* Trace/walk.scm 407 */
								BgL_nodez00_bglt BgL_res3859z00_3297;

								{	/* Trace/walk.scm 407 */
									obj_t BgL_method3330z00_3272;

									{	/* Trace/walk.scm 407 */
										BgL_objectz00_bglt BgL_objz00_3273;

										BgL_objz00_3273 =
											(BgL_objectz00_bglt) (BgL_arg3714z00_1789);
										{	/* Trace/walk.scm 407 */
											long BgL_objzd2classzd2numz00_3274;

											BgL_objzd2classzd2numz00_3274 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3273);
											{	/* Trace/walk.scm 407 */
												obj_t BgL_arg2551z00_3275;

												BgL_arg2551z00_3275 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 407 */
													obj_t BgL_arrayz00_3277;

													int BgL_offsetz00_3278;

													BgL_arrayz00_3277 = BgL_arg2551z00_3275;
													BgL_offsetz00_3278 =
														(int) (BgL_objzd2classzd2numz00_3274);
													{	/* Trace/walk.scm 407 */
														long BgL_offsetz00_3279;

														BgL_offsetz00_3279 =
															((long) (BgL_offsetz00_3278) - OBJECT_TYPE);
														{	/* Trace/walk.scm 407 */
															long BgL_modz00_3280;

															{	/* Trace/walk.scm 407 */
																int BgL_arg2553z00_3281;

																BgL_arg2553z00_3281 = (int) (((long) 8));
																{	/* Trace/walk.scm 407 */
																	long BgL_auxz00_4125;

																	BgL_auxz00_4125 =
																		(long) (BgL_arg2553z00_3281);
																	BgL_modz00_3280 =
																		(BgL_offsetz00_3279 / BgL_auxz00_4125);
															}}
															{	/* Trace/walk.scm 407 */
																long BgL_restz00_3282;

																{	/* Trace/walk.scm 407 */
																	int BgL_arg2552z00_3283;

																	BgL_arg2552z00_3283 = (int) (((long) 8));
																	{	/* Trace/walk.scm 407 */
																		long BgL_auxz00_4129;

																		BgL_auxz00_4129 =
																			(long) (BgL_arg2552z00_3283);
																		BgL_restz00_3282 =
																			(BgL_offsetz00_3279 % BgL_auxz00_4129);
																}}
																{	/* Trace/walk.scm 407 */

																	BgL_method3330z00_3272 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3277,
																			(int) (BgL_modz00_3280)),
																		(int) (BgL_restz00_3282));
									}}}}}}}}
									BgL_res3859z00_3297 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3272)
										(BgL_method3330z00_3272, (obj_t) (BgL_arg3714z00_1789),
											BgL_stackz00_1782, BEOA));
								}
								BgL_arg3713z00_1788 = BgL_res3859z00_3297;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1781))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3713z00_1788), BUNSPEC);
					}
					BgL_auxz00_4087 = BgL_nodez00_1781;
					return (obj_t) (BgL_auxz00_4087);
				}
			}
		}
	}



/* trace-node-box-ref3364 */
	obj_t BGl_tracezd2nodezd2boxzd2ref3364zd2zztrace_walkz00(obj_t
		BgL_envz00_3376, obj_t BgL_nodez00_3377, obj_t BgL_stackz00_3378)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 397 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1773;

				obj_t BgL_stackz00_1774;

				{	/* Trace/walk.scm 398 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_4143;

					BgL_nodez00_1773 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3377);
					BgL_stackz00_1774 = BgL_stackz00_3378;
					{	/* Trace/walk.scm 398 */
						BgL_nodez00_bglt BgL_arg3708z00_3205;

						{	/* Trace/walk.scm 398 */
							BgL_varz00_bglt BgL_arg3709z00_3206;

							BgL_arg3709z00_3206 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1773))->BgL_varz00);
							{	/* Trace/walk.scm 398 */
								BgL_nodez00_bglt BgL_res3853z00_3235;

								{	/* Trace/walk.scm 398 */
									BgL_nodez00_bglt BgL_nodez00_3208;

									BgL_nodez00_3208 = (BgL_nodez00_bglt) (BgL_arg3709z00_3206);
									{	/* Trace/walk.scm 398 */
										obj_t BgL_method3330z00_3210;

										{	/* Trace/walk.scm 398 */
											BgL_objectz00_bglt BgL_objz00_3211;

											BgL_objz00_3211 = (BgL_objectz00_bglt) (BgL_nodez00_3208);
											{	/* Trace/walk.scm 398 */
												long BgL_objzd2classzd2numz00_3212;

												BgL_objzd2classzd2numz00_3212 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3211);
												{	/* Trace/walk.scm 398 */
													obj_t BgL_arg2551z00_3213;

													BgL_arg2551z00_3213 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 398 */
														obj_t BgL_arrayz00_3215;

														int BgL_offsetz00_3216;

														BgL_arrayz00_3215 = BgL_arg2551z00_3213;
														BgL_offsetz00_3216 =
															(int) (BgL_objzd2classzd2numz00_3212);
														{	/* Trace/walk.scm 398 */
															long BgL_offsetz00_3217;

															BgL_offsetz00_3217 =
																((long) (BgL_offsetz00_3216) - OBJECT_TYPE);
															{	/* Trace/walk.scm 398 */
																long BgL_modz00_3218;

																{	/* Trace/walk.scm 398 */
																	int BgL_arg2553z00_3219;

																	BgL_arg2553z00_3219 = (int) (((long) 8));
																	{	/* Trace/walk.scm 398 */
																		long BgL_auxz00_4154;

																		BgL_auxz00_4154 =
																			(long) (BgL_arg2553z00_3219);
																		BgL_modz00_3218 =
																			(BgL_offsetz00_3217 / BgL_auxz00_4154);
																}}
																{	/* Trace/walk.scm 398 */
																	long BgL_restz00_3220;

																	{	/* Trace/walk.scm 398 */
																		int BgL_arg2552z00_3221;

																		BgL_arg2552z00_3221 = (int) (((long) 8));
																		{	/* Trace/walk.scm 398 */
																			long BgL_auxz00_4158;

																			BgL_auxz00_4158 =
																				(long) (BgL_arg2552z00_3221);
																			BgL_restz00_3220 =
																				(BgL_offsetz00_3217 % BgL_auxz00_4158);
																	}}
																	{	/* Trace/walk.scm 398 */

																		BgL_method3330z00_3210 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3215,
																				(int) (BgL_modz00_3218)),
																			(int) (BgL_restz00_3220));
										}}}}}}}}
										BgL_res3853z00_3235 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3330z00_3210) (BgL_method3330z00_3210,
												(obj_t) (BgL_nodez00_3208), BgL_stackz00_1774, BEOA));
								}}
								BgL_arg3708z00_3205 = BgL_res3853z00_3235;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4169;

							BgL_auxz00_4169 = (BgL_varz00_bglt) (BgL_arg3708z00_3205);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1773))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_4169), BUNSPEC);
					}}
					BgL_auxz00_4143 = BgL_nodez00_1773;
					return (obj_t) (BgL_auxz00_4143);
				}
			}
		}
	}



/* trace-node-make-box3361 */
	obj_t BGl_tracezd2nodezd2makezd2box3361zd2zztrace_walkz00(obj_t
		BgL_envz00_3379, obj_t BgL_nodez00_3380, obj_t BgL_stackz00_3381)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 390 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1765;

				obj_t BgL_stackz00_1766;

				{	/* Trace/walk.scm 391 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_4174;

					BgL_nodez00_1765 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3380);
					BgL_stackz00_1766 = BgL_stackz00_3381;
					{	/* Trace/walk.scm 391 */
						BgL_nodez00_bglt BgL_arg3705z00_3172;

						{	/* Trace/walk.scm 391 */
							BgL_nodez00_bglt BgL_arg3706z00_3173;

							BgL_arg3706z00_3173 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1765))->
								BgL_valuez00);
							{	/* Trace/walk.scm 391 */
								BgL_nodez00_bglt BgL_res3850z00_3202;

								{	/* Trace/walk.scm 391 */
									obj_t BgL_method3330z00_3177;

									{	/* Trace/walk.scm 391 */
										BgL_objectz00_bglt BgL_objz00_3178;

										BgL_objz00_3178 =
											(BgL_objectz00_bglt) (BgL_arg3706z00_3173);
										{	/* Trace/walk.scm 391 */
											long BgL_objzd2classzd2numz00_3179;

											BgL_objzd2classzd2numz00_3179 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3178);
											{	/* Trace/walk.scm 391 */
												obj_t BgL_arg2551z00_3180;

												BgL_arg2551z00_3180 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 391 */
													obj_t BgL_arrayz00_3182;

													int BgL_offsetz00_3183;

													BgL_arrayz00_3182 = BgL_arg2551z00_3180;
													BgL_offsetz00_3183 =
														(int) (BgL_objzd2classzd2numz00_3179);
													{	/* Trace/walk.scm 391 */
														long BgL_offsetz00_3184;

														BgL_offsetz00_3184 =
															((long) (BgL_offsetz00_3183) - OBJECT_TYPE);
														{	/* Trace/walk.scm 391 */
															long BgL_modz00_3185;

															{	/* Trace/walk.scm 391 */
																int BgL_arg2553z00_3186;

																BgL_arg2553z00_3186 = (int) (((long) 8));
																{	/* Trace/walk.scm 391 */
																	long BgL_auxz00_4184;

																	BgL_auxz00_4184 =
																		(long) (BgL_arg2553z00_3186);
																	BgL_modz00_3185 =
																		(BgL_offsetz00_3184 / BgL_auxz00_4184);
															}}
															{	/* Trace/walk.scm 391 */
																long BgL_restz00_3187;

																{	/* Trace/walk.scm 391 */
																	int BgL_arg2552z00_3188;

																	BgL_arg2552z00_3188 = (int) (((long) 8));
																	{	/* Trace/walk.scm 391 */
																		long BgL_auxz00_4188;

																		BgL_auxz00_4188 =
																			(long) (BgL_arg2552z00_3188);
																		BgL_restz00_3187 =
																			(BgL_offsetz00_3184 % BgL_auxz00_4188);
																}}
																{	/* Trace/walk.scm 391 */

																	BgL_method3330z00_3177 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3182,
																			(int) (BgL_modz00_3185)),
																		(int) (BgL_restz00_3187));
									}}}}}}}}
									BgL_res3850z00_3202 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3177)
										(BgL_method3330z00_3177, (obj_t) (BgL_arg3706z00_3173),
											BgL_stackz00_1766, BEOA));
								}
								BgL_arg3705z00_3172 = BgL_res3850z00_3202;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1765))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3705z00_3172), BUNSPEC);
					}
					BgL_auxz00_4174 = BgL_nodez00_1765;
					return (obj_t) (BgL_auxz00_4174);
				}
			}
		}
	}



/* trace-node-jump-ex-i3359 */
	obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3359z00zztrace_walkz00(obj_t
		BgL_envz00_3382, obj_t BgL_nodez00_3383, obj_t BgL_stackz00_3384)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 381 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1754;

				obj_t BgL_stackz00_1755;

				{	/* Trace/walk.scm 382 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_4202;

					BgL_nodez00_1754 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3383);
					BgL_stackz00_1755 = BgL_stackz00_3384;
					{	/* Trace/walk.scm 383 */
						BgL_nodez00_bglt BgL_arg3700z00_1759;

						{	/* Trace/walk.scm 383 */
							BgL_nodez00_bglt BgL_arg3701z00_1760;

							BgL_arg3701z00_1760 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_exitz00);
							{	/* Trace/walk.scm 383 */
								BgL_nodez00_bglt BgL_res3844z00_3138;

								{	/* Trace/walk.scm 383 */
									obj_t BgL_method3330z00_3113;

									{	/* Trace/walk.scm 383 */
										BgL_objectz00_bglt BgL_objz00_3114;

										BgL_objz00_3114 =
											(BgL_objectz00_bglt) (BgL_arg3701z00_1760);
										{	/* Trace/walk.scm 383 */
											long BgL_objzd2classzd2numz00_3115;

											BgL_objzd2classzd2numz00_3115 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3114);
											{	/* Trace/walk.scm 383 */
												obj_t BgL_arg2551z00_3116;

												BgL_arg2551z00_3116 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 383 */
													obj_t BgL_arrayz00_3118;

													int BgL_offsetz00_3119;

													BgL_arrayz00_3118 = BgL_arg2551z00_3116;
													BgL_offsetz00_3119 =
														(int) (BgL_objzd2classzd2numz00_3115);
													{	/* Trace/walk.scm 383 */
														long BgL_offsetz00_3120;

														BgL_offsetz00_3120 =
															((long) (BgL_offsetz00_3119) - OBJECT_TYPE);
														{	/* Trace/walk.scm 383 */
															long BgL_modz00_3121;

															{	/* Trace/walk.scm 383 */
																int BgL_arg2553z00_3122;

																BgL_arg2553z00_3122 = (int) (((long) 8));
																{	/* Trace/walk.scm 383 */
																	long BgL_auxz00_4212;

																	BgL_auxz00_4212 =
																		(long) (BgL_arg2553z00_3122);
																	BgL_modz00_3121 =
																		(BgL_offsetz00_3120 / BgL_auxz00_4212);
															}}
															{	/* Trace/walk.scm 383 */
																long BgL_restz00_3123;

																{	/* Trace/walk.scm 383 */
																	int BgL_arg2552z00_3124;

																	BgL_arg2552z00_3124 = (int) (((long) 8));
																	{	/* Trace/walk.scm 383 */
																		long BgL_auxz00_4216;

																		BgL_auxz00_4216 =
																			(long) (BgL_arg2552z00_3124);
																		BgL_restz00_3123 =
																			(BgL_offsetz00_3120 % BgL_auxz00_4216);
																}}
																{	/* Trace/walk.scm 383 */

																	BgL_method3330z00_3113 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3118,
																			(int) (BgL_modz00_3121)),
																		(int) (BgL_restz00_3123));
									}}}}}}}}
									BgL_res3844z00_3138 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3113)
										(BgL_method3330z00_3113, (obj_t) (BgL_arg3701z00_1760),
											BgL_stackz00_1755, BEOA));
								}
								BgL_arg3700z00_1759 = BgL_res3844z00_3138;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3700z00_1759), BUNSPEC);
					}
					{	/* Trace/walk.scm 384 */
						BgL_nodez00_bglt BgL_arg3702z00_1761;

						{	/* Trace/walk.scm 384 */
							BgL_nodez00_bglt BgL_arg3703z00_1762;

							BgL_arg3703z00_1762 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_valuez00);
							{	/* Trace/walk.scm 384 */
								BgL_nodez00_bglt BgL_res3847z00_3169;

								{	/* Trace/walk.scm 384 */
									obj_t BgL_method3330z00_3144;

									{	/* Trace/walk.scm 384 */
										BgL_objectz00_bglt BgL_objz00_3145;

										BgL_objz00_3145 =
											(BgL_objectz00_bglt) (BgL_arg3703z00_1762);
										{	/* Trace/walk.scm 384 */
											long BgL_objzd2classzd2numz00_3146;

											BgL_objzd2classzd2numz00_3146 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3145);
											{	/* Trace/walk.scm 384 */
												obj_t BgL_arg2551z00_3147;

												BgL_arg2551z00_3147 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 384 */
													obj_t BgL_arrayz00_3149;

													int BgL_offsetz00_3150;

													BgL_arrayz00_3149 = BgL_arg2551z00_3147;
													BgL_offsetz00_3150 =
														(int) (BgL_objzd2classzd2numz00_3146);
													{	/* Trace/walk.scm 384 */
														long BgL_offsetz00_3151;

														BgL_offsetz00_3151 =
															((long) (BgL_offsetz00_3150) - OBJECT_TYPE);
														{	/* Trace/walk.scm 384 */
															long BgL_modz00_3152;

															{	/* Trace/walk.scm 384 */
																int BgL_arg2553z00_3153;

																BgL_arg2553z00_3153 = (int) (((long) 8));
																{	/* Trace/walk.scm 384 */
																	long BgL_auxz00_4237;

																	BgL_auxz00_4237 =
																		(long) (BgL_arg2553z00_3153);
																	BgL_modz00_3152 =
																		(BgL_offsetz00_3151 / BgL_auxz00_4237);
															}}
															{	/* Trace/walk.scm 384 */
																long BgL_restz00_3154;

																{	/* Trace/walk.scm 384 */
																	int BgL_arg2552z00_3155;

																	BgL_arg2552z00_3155 = (int) (((long) 8));
																	{	/* Trace/walk.scm 384 */
																		long BgL_auxz00_4241;

																		BgL_auxz00_4241 =
																			(long) (BgL_arg2552z00_3155);
																		BgL_restz00_3154 =
																			(BgL_offsetz00_3151 % BgL_auxz00_4241);
																}}
																{	/* Trace/walk.scm 384 */

																	BgL_method3330z00_3144 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3149,
																			(int) (BgL_modz00_3152)),
																		(int) (BgL_restz00_3154));
									}}}}}}}}
									BgL_res3847z00_3169 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3144)
										(BgL_method3330z00_3144, (obj_t) (BgL_arg3703z00_1762),
											BgL_stackz00_1755, BEOA));
								}
								BgL_arg3702z00_1761 = BgL_res3847z00_3169;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1754))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3702z00_1761), BUNSPEC);
					}
					BgL_auxz00_4202 = BgL_nodez00_1754;
					return (obj_t) (BgL_auxz00_4202);
				}
			}
		}
	}



/* trace-node-set-ex-it3356 */
	obj_t BGl_tracezd2nodezd2setzd2exzd2it3356z00zztrace_walkz00(obj_t
		BgL_envz00_3385, obj_t BgL_nodez00_3386, obj_t BgL_stackz00_3387)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 374 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1746;

				obj_t BgL_stackz00_1747;

				{	/* Trace/walk.scm 375 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_4255;

					BgL_nodez00_1746 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3386);
					BgL_stackz00_1747 = BgL_stackz00_3387;
					{	/* Trace/walk.scm 375 */
						BgL_nodez00_bglt BgL_arg3697z00_3077;

						{	/* Trace/walk.scm 375 */
							BgL_nodez00_bglt BgL_arg3698z00_3078;

							BgL_arg3698z00_3078 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1746))->
								BgL_bodyz00);
							{	/* Trace/walk.scm 375 */
								BgL_nodez00_bglt BgL_res3841z00_3107;

								{	/* Trace/walk.scm 375 */
									obj_t BgL_method3330z00_3082;

									{	/* Trace/walk.scm 375 */
										BgL_objectz00_bglt BgL_objz00_3083;

										BgL_objz00_3083 =
											(BgL_objectz00_bglt) (BgL_arg3698z00_3078);
										{	/* Trace/walk.scm 375 */
											long BgL_objzd2classzd2numz00_3084;

											BgL_objzd2classzd2numz00_3084 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3083);
											{	/* Trace/walk.scm 375 */
												obj_t BgL_arg2551z00_3085;

												BgL_arg2551z00_3085 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 375 */
													obj_t BgL_arrayz00_3087;

													int BgL_offsetz00_3088;

													BgL_arrayz00_3087 = BgL_arg2551z00_3085;
													BgL_offsetz00_3088 =
														(int) (BgL_objzd2classzd2numz00_3084);
													{	/* Trace/walk.scm 375 */
														long BgL_offsetz00_3089;

														BgL_offsetz00_3089 =
															((long) (BgL_offsetz00_3088) - OBJECT_TYPE);
														{	/* Trace/walk.scm 375 */
															long BgL_modz00_3090;

															{	/* Trace/walk.scm 375 */
																int BgL_arg2553z00_3091;

																BgL_arg2553z00_3091 = (int) (((long) 8));
																{	/* Trace/walk.scm 375 */
																	long BgL_auxz00_4265;

																	BgL_auxz00_4265 =
																		(long) (BgL_arg2553z00_3091);
																	BgL_modz00_3090 =
																		(BgL_offsetz00_3089 / BgL_auxz00_4265);
															}}
															{	/* Trace/walk.scm 375 */
																long BgL_restz00_3092;

																{	/* Trace/walk.scm 375 */
																	int BgL_arg2552z00_3093;

																	BgL_arg2552z00_3093 = (int) (((long) 8));
																	{	/* Trace/walk.scm 375 */
																		long BgL_auxz00_4269;

																		BgL_auxz00_4269 =
																			(long) (BgL_arg2552z00_3093);
																		BgL_restz00_3092 =
																			(BgL_offsetz00_3089 % BgL_auxz00_4269);
																}}
																{	/* Trace/walk.scm 375 */

																	BgL_method3330z00_3082 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3087,
																			(int) (BgL_modz00_3090)),
																		(int) (BgL_restz00_3092));
									}}}}}}}}
									BgL_res3841z00_3107 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3082)
										(BgL_method3330z00_3082, (obj_t) (BgL_arg3698z00_3078),
											BgL_stackz00_1747, BEOA));
								}
								BgL_arg3697z00_3077 = BgL_res3841z00_3107;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1746))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3697z00_3077), BUNSPEC);
					}
					BgL_auxz00_4255 = BgL_nodez00_1746;
					return (obj_t) (BgL_auxz00_4255);
				}
			}
		}
	}



/* trace-node-let-var3354 */
	obj_t BGl_tracezd2nodezd2letzd2var3354zd2zztrace_walkz00(obj_t
		BgL_envz00_3388, obj_t BgL_nodez00_3389, obj_t BgL_stackz00_3390)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 363 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1727;

				obj_t BgL_stackz00_1728;

				{	/* Trace/walk.scm 364 */
					BgL_letzd2varzd2_bglt BgL_auxz00_4283;

					BgL_nodez00_1727 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3389);
					BgL_stackz00_1728 = BgL_stackz00_3390;
					{	/* Trace/walk.scm 365 */
						obj_t BgL_g3300z00_1732;

						BgL_g3300z00_1732 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1727))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3298z00_1734;

							BgL_l3298z00_1734 = BgL_g3300z00_1732;
						BgL_zc3anonymousza33689ze3z83_1735:
							if (PAIRP(BgL_l3298z00_1734))
								{	/* Trace/walk.scm 365 */
									{	/* Trace/walk.scm 366 */
										obj_t BgL_bindingz00_1737;

										BgL_bindingz00_1737 = CAR(BgL_l3298z00_1734);
										{	/* Trace/walk.scm 366 */
											BgL_nodez00_bglt BgL_arg3691z00_1738;

											{	/* Trace/walk.scm 366 */
												obj_t BgL_arg3692z00_1739;

												BgL_arg3692z00_1739 = CDR(BgL_bindingz00_1737);
												{	/* Trace/walk.scm 366 */
													BgL_nodez00_bglt BgL_res3835z00_3042;

													{	/* Trace/walk.scm 366 */
														BgL_nodez00_bglt BgL_nodez00_3015;

														BgL_nodez00_3015 =
															(BgL_nodez00_bglt) (BgL_arg3692z00_1739);
														{	/* Trace/walk.scm 366 */
															obj_t BgL_method3330z00_3017;

															{	/* Trace/walk.scm 366 */
																BgL_objectz00_bglt BgL_objz00_3018;

																BgL_objz00_3018 =
																	(BgL_objectz00_bglt) (BgL_nodez00_3015);
																{	/* Trace/walk.scm 366 */
																	long BgL_objzd2classzd2numz00_3019;

																	BgL_objzd2classzd2numz00_3019 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_3018);
																	{	/* Trace/walk.scm 366 */
																		obj_t BgL_arg2551z00_3020;

																		BgL_arg2551z00_3020 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 366 */
																			obj_t BgL_arrayz00_3022;

																			int BgL_offsetz00_3023;

																			BgL_arrayz00_3022 = BgL_arg2551z00_3020;
																			BgL_offsetz00_3023 =
																				(int) (BgL_objzd2classzd2numz00_3019);
																			{	/* Trace/walk.scm 366 */
																				long BgL_offsetz00_3024;

																				BgL_offsetz00_3024 =
																					(
																					(long) (BgL_offsetz00_3023) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 366 */
																					long BgL_modz00_3025;

																					{	/* Trace/walk.scm 366 */
																						int BgL_arg2553z00_3026;

																						BgL_arg2553z00_3026 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 366 */
																							long BgL_auxz00_4298;

																							BgL_auxz00_4298 =
																								(long) (BgL_arg2553z00_3026);
																							BgL_modz00_3025 =
																								(BgL_offsetz00_3024 /
																								BgL_auxz00_4298);
																					}}
																					{	/* Trace/walk.scm 366 */
																						long BgL_restz00_3027;

																						{	/* Trace/walk.scm 366 */
																							int BgL_arg2552z00_3028;

																							BgL_arg2552z00_3028 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 366 */
																								long BgL_auxz00_4302;

																								BgL_auxz00_4302 =
																									(long) (BgL_arg2552z00_3028);
																								BgL_restz00_3027 =
																									(BgL_offsetz00_3024 %
																									BgL_auxz00_4302);
																						}}
																						{	/* Trace/walk.scm 366 */

																							BgL_method3330z00_3017 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_3022,
																									(int) (BgL_modz00_3025)),
																								(int) (BgL_restz00_3027));
															}}}}}}}}
															BgL_res3835z00_3042 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3330z00_3017)
																(BgL_method3330z00_3017,
																	(obj_t) (BgL_nodez00_3015), BgL_stackz00_1728,
																	BEOA));
													}}
													BgL_arg3691z00_1738 = BgL_res3835z00_3042;
											}}
											{	/* Trace/walk.scm 366 */
												obj_t BgL_auxz00_4313;

												BgL_auxz00_4313 = (obj_t) (BgL_arg3691z00_1738);
												SET_CDR(BgL_bindingz00_1737, BgL_auxz00_4313);
									}}}
									{
										obj_t BgL_l3298z00_4316;

										BgL_l3298z00_4316 = CDR(BgL_l3298z00_1734);
										BgL_l3298z00_1734 = BgL_l3298z00_4316;
										goto BgL_zc3anonymousza33689ze3z83_1735;
									}
								}
							else
								{	/* Trace/walk.scm 365 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 368 */
						BgL_nodez00_bglt BgL_arg3694z00_1742;

						{	/* Trace/walk.scm 368 */
							BgL_nodez00_bglt BgL_arg3695z00_1743;

							BgL_arg3695z00_1743 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1727))->BgL_bodyz00);
							{	/* Trace/walk.scm 368 */
								BgL_nodez00_bglt BgL_res3838z00_3074;

								{	/* Trace/walk.scm 368 */
									obj_t BgL_method3330z00_3049;

									{	/* Trace/walk.scm 368 */
										BgL_objectz00_bglt BgL_objz00_3050;

										BgL_objz00_3050 =
											(BgL_objectz00_bglt) (BgL_arg3695z00_1743);
										{	/* Trace/walk.scm 368 */
											long BgL_objzd2classzd2numz00_3051;

											BgL_objzd2classzd2numz00_3051 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3050);
											{	/* Trace/walk.scm 368 */
												obj_t BgL_arg2551z00_3052;

												BgL_arg2551z00_3052 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 368 */
													obj_t BgL_arrayz00_3054;

													int BgL_offsetz00_3055;

													BgL_arrayz00_3054 = BgL_arg2551z00_3052;
													BgL_offsetz00_3055 =
														(int) (BgL_objzd2classzd2numz00_3051);
													{	/* Trace/walk.scm 368 */
														long BgL_offsetz00_3056;

														BgL_offsetz00_3056 =
															((long) (BgL_offsetz00_3055) - OBJECT_TYPE);
														{	/* Trace/walk.scm 368 */
															long BgL_modz00_3057;

															{	/* Trace/walk.scm 368 */
																int BgL_arg2553z00_3058;

																BgL_arg2553z00_3058 = (int) (((long) 8));
																{	/* Trace/walk.scm 368 */
																	long BgL_auxz00_4327;

																	BgL_auxz00_4327 =
																		(long) (BgL_arg2553z00_3058);
																	BgL_modz00_3057 =
																		(BgL_offsetz00_3056 / BgL_auxz00_4327);
															}}
															{	/* Trace/walk.scm 368 */
																long BgL_restz00_3059;

																{	/* Trace/walk.scm 368 */
																	int BgL_arg2552z00_3060;

																	BgL_arg2552z00_3060 = (int) (((long) 8));
																	{	/* Trace/walk.scm 368 */
																		long BgL_auxz00_4331;

																		BgL_auxz00_4331 =
																			(long) (BgL_arg2552z00_3060);
																		BgL_restz00_3059 =
																			(BgL_offsetz00_3056 % BgL_auxz00_4331);
																}}
																{	/* Trace/walk.scm 368 */

																	BgL_method3330z00_3049 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3054,
																			(int) (BgL_modz00_3057)),
																		(int) (BgL_restz00_3059));
									}}}}}}}}
									BgL_res3838z00_3074 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_3049)
										(BgL_method3330z00_3049, (obj_t) (BgL_arg3695z00_1743),
											BgL_stackz00_1728, BEOA));
								}
								BgL_arg3694z00_1742 = BgL_res3838z00_3074;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1727))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3694z00_1742), BUNSPEC);
					}
					BgL_auxz00_4283 = BgL_nodez00_1727;
					return (obj_t) (BgL_auxz00_4283);
				}
			}
		}
	}



/* trace-node-let-fun3352 */
	obj_t BGl_tracezd2nodezd2letzd2fun3352zd2zztrace_walkz00(obj_t
		BgL_envz00_3391, obj_t BgL_nodez00_3392, obj_t BgL_stackz00_3393)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 354 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1710;

				obj_t BgL_stackz00_1711;

				{	/* Trace/walk.scm 355 */
					BgL_letzd2funzd2_bglt BgL_auxz00_4345;

					BgL_nodez00_1710 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3392);
					BgL_stackz00_1711 = BgL_stackz00_3393;
					{	/* Trace/walk.scm 356 */
						obj_t BgL_g3297z00_1715;

						BgL_g3297z00_1715 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1710))->BgL_localsz00);
						{
							obj_t BgL_l3295z00_1717;

							BgL_l3295z00_1717 = BgL_g3297z00_1715;
						BgL_zc3anonymousza33683ze3z83_1718:
							if (PAIRP(BgL_l3295z00_1717))
								{	/* Trace/walk.scm 356 */
									BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3295z00_1717),
										BgL_stackz00_1711);
									{
										obj_t BgL_l3295z00_4351;

										BgL_l3295z00_4351 = CDR(BgL_l3295z00_1717);
										BgL_l3295z00_1717 = BgL_l3295z00_4351;
										goto BgL_zc3anonymousza33683ze3z83_1718;
									}
								}
							else
								{	/* Trace/walk.scm 356 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 357 */
						BgL_nodez00_bglt BgL_arg3686z00_1723;

						{	/* Trace/walk.scm 357 */
							BgL_nodez00_bglt BgL_arg3687z00_1724;

							BgL_arg3687z00_1724 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1710))->BgL_bodyz00);
							{	/* Trace/walk.scm 357 */
								BgL_nodez00_bglt BgL_res3832z00_3008;

								{	/* Trace/walk.scm 357 */
									obj_t BgL_method3330z00_2983;

									{	/* Trace/walk.scm 357 */
										BgL_objectz00_bglt BgL_objz00_2984;

										BgL_objz00_2984 =
											(BgL_objectz00_bglt) (BgL_arg3687z00_1724);
										{	/* Trace/walk.scm 357 */
											long BgL_objzd2classzd2numz00_2985;

											BgL_objzd2classzd2numz00_2985 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2984);
											{	/* Trace/walk.scm 357 */
												obj_t BgL_arg2551z00_2986;

												BgL_arg2551z00_2986 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 357 */
													obj_t BgL_arrayz00_2988;

													int BgL_offsetz00_2989;

													BgL_arrayz00_2988 = BgL_arg2551z00_2986;
													BgL_offsetz00_2989 =
														(int) (BgL_objzd2classzd2numz00_2985);
													{	/* Trace/walk.scm 357 */
														long BgL_offsetz00_2990;

														BgL_offsetz00_2990 =
															((long) (BgL_offsetz00_2989) - OBJECT_TYPE);
														{	/* Trace/walk.scm 357 */
															long BgL_modz00_2991;

															{	/* Trace/walk.scm 357 */
																int BgL_arg2553z00_2992;

																BgL_arg2553z00_2992 = (int) (((long) 8));
																{	/* Trace/walk.scm 357 */
																	long BgL_auxz00_4362;

																	BgL_auxz00_4362 =
																		(long) (BgL_arg2553z00_2992);
																	BgL_modz00_2991 =
																		(BgL_offsetz00_2990 / BgL_auxz00_4362);
															}}
															{	/* Trace/walk.scm 357 */
																long BgL_restz00_2993;

																{	/* Trace/walk.scm 357 */
																	int BgL_arg2552z00_2994;

																	BgL_arg2552z00_2994 = (int) (((long) 8));
																	{	/* Trace/walk.scm 357 */
																		long BgL_auxz00_4366;

																		BgL_auxz00_4366 =
																			(long) (BgL_arg2552z00_2994);
																		BgL_restz00_2993 =
																			(BgL_offsetz00_2990 % BgL_auxz00_4366);
																}}
																{	/* Trace/walk.scm 357 */

																	BgL_method3330z00_2983 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2988,
																			(int) (BgL_modz00_2991)),
																		(int) (BgL_restz00_2993));
									}}}}}}}}
									BgL_res3832z00_3008 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2983)
										(BgL_method3330z00_2983, (obj_t) (BgL_arg3687z00_1724),
											BgL_stackz00_1711, BEOA));
								}
								BgL_arg3686z00_1723 = BgL_res3832z00_3008;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1710))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3686z00_1723), BUNSPEC);
					}
					BgL_auxz00_4345 = BgL_nodez00_1710;
					return (obj_t) (BgL_auxz00_4345);
				}
			}
		}
	}



/* trace-node-select3350 */
	obj_t BGl_tracezd2nodezd2select3350z00zztrace_walkz00(obj_t BgL_envz00_3394,
		obj_t BgL_nodez00_3395, obj_t BgL_stackz00_3396)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 343 */
			{
				BgL_selectz00_bglt BgL_nodez00_1691;

				obj_t BgL_stackz00_1692;

				{	/* Trace/walk.scm 344 */
					BgL_selectz00_bglt BgL_auxz00_4380;

					BgL_nodez00_1691 = (BgL_selectz00_bglt) (BgL_nodez00_3395);
					BgL_stackz00_1692 = BgL_stackz00_3396;
					{	/* Trace/walk.scm 345 */
						BgL_nodez00_bglt BgL_arg3675z00_1696;

						{	/* Trace/walk.scm 345 */
							BgL_nodez00_bglt BgL_arg3676z00_1697;

							BgL_arg3676z00_1697 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1691))->BgL_testz00);
							{	/* Trace/walk.scm 345 */
								BgL_nodez00_bglt BgL_res3826z00_2938;

								{	/* Trace/walk.scm 345 */
									obj_t BgL_method3330z00_2913;

									{	/* Trace/walk.scm 345 */
										BgL_objectz00_bglt BgL_objz00_2914;

										BgL_objz00_2914 =
											(BgL_objectz00_bglt) (BgL_arg3676z00_1697);
										{	/* Trace/walk.scm 345 */
											long BgL_objzd2classzd2numz00_2915;

											BgL_objzd2classzd2numz00_2915 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2914);
											{	/* Trace/walk.scm 345 */
												obj_t BgL_arg2551z00_2916;

												BgL_arg2551z00_2916 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 345 */
													obj_t BgL_arrayz00_2918;

													int BgL_offsetz00_2919;

													BgL_arrayz00_2918 = BgL_arg2551z00_2916;
													BgL_offsetz00_2919 =
														(int) (BgL_objzd2classzd2numz00_2915);
													{	/* Trace/walk.scm 345 */
														long BgL_offsetz00_2920;

														BgL_offsetz00_2920 =
															((long) (BgL_offsetz00_2919) - OBJECT_TYPE);
														{	/* Trace/walk.scm 345 */
															long BgL_modz00_2921;

															{	/* Trace/walk.scm 345 */
																int BgL_arg2553z00_2922;

																BgL_arg2553z00_2922 = (int) (((long) 8));
																{	/* Trace/walk.scm 345 */
																	long BgL_auxz00_4390;

																	BgL_auxz00_4390 =
																		(long) (BgL_arg2553z00_2922);
																	BgL_modz00_2921 =
																		(BgL_offsetz00_2920 / BgL_auxz00_4390);
															}}
															{	/* Trace/walk.scm 345 */
																long BgL_restz00_2923;

																{	/* Trace/walk.scm 345 */
																	int BgL_arg2552z00_2924;

																	BgL_arg2552z00_2924 = (int) (((long) 8));
																	{	/* Trace/walk.scm 345 */
																		long BgL_auxz00_4394;

																		BgL_auxz00_4394 =
																			(long) (BgL_arg2552z00_2924);
																		BgL_restz00_2923 =
																			(BgL_offsetz00_2920 % BgL_auxz00_4394);
																}}
																{	/* Trace/walk.scm 345 */

																	BgL_method3330z00_2913 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2918,
																			(int) (BgL_modz00_2921)),
																		(int) (BgL_restz00_2923));
									}}}}}}}}
									BgL_res3826z00_2938 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2913)
										(BgL_method3330z00_2913, (obj_t) (BgL_arg3676z00_1697),
											BgL_stackz00_1692, BEOA));
								}
								BgL_arg3675z00_1696 = BgL_res3826z00_2938;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1691))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3675z00_1696), BUNSPEC);
					}
					{	/* Trace/walk.scm 346 */
						obj_t BgL_g3294z00_1698;

						BgL_g3294z00_1698 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1691))->BgL_clausesz00);
						{
							obj_t BgL_l3292z00_1700;

							BgL_l3292z00_1700 = BgL_g3294z00_1698;
						BgL_zc3anonymousza33677ze3z83_1701:
							if (PAIRP(BgL_l3292z00_1700))
								{	/* Trace/walk.scm 346 */
									{	/* Trace/walk.scm 347 */
										obj_t BgL_clausez00_1703;

										BgL_clausez00_1703 = CAR(BgL_l3292z00_1700);
										{	/* Trace/walk.scm 347 */
											BgL_nodez00_bglt BgL_arg3679z00_1704;

											{	/* Trace/walk.scm 347 */
												obj_t BgL_arg3680z00_1705;

												BgL_arg3680z00_1705 = CDR(BgL_clausez00_1703);
												{	/* Trace/walk.scm 347 */
													BgL_nodez00_bglt BgL_res3829z00_2972;

													{	/* Trace/walk.scm 347 */
														BgL_nodez00_bglt BgL_nodez00_2945;

														BgL_nodez00_2945 =
															(BgL_nodez00_bglt) (BgL_arg3680z00_1705);
														{	/* Trace/walk.scm 347 */
															obj_t BgL_method3330z00_2947;

															{	/* Trace/walk.scm 347 */
																BgL_objectz00_bglt BgL_objz00_2948;

																BgL_objz00_2948 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2945);
																{	/* Trace/walk.scm 347 */
																	long BgL_objzd2classzd2numz00_2949;

																	BgL_objzd2classzd2numz00_2949 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2948);
																	{	/* Trace/walk.scm 347 */
																		obj_t BgL_arg2551z00_2950;

																		BgL_arg2551z00_2950 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 347 */
																			obj_t BgL_arrayz00_2952;

																			int BgL_offsetz00_2953;

																			BgL_arrayz00_2952 = BgL_arg2551z00_2950;
																			BgL_offsetz00_2953 =
																				(int) (BgL_objzd2classzd2numz00_2949);
																			{	/* Trace/walk.scm 347 */
																				long BgL_offsetz00_2954;

																				BgL_offsetz00_2954 =
																					(
																					(long) (BgL_offsetz00_2953) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 347 */
																					long BgL_modz00_2955;

																					{	/* Trace/walk.scm 347 */
																						int BgL_arg2553z00_2956;

																						BgL_arg2553z00_2956 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 347 */
																							long BgL_auxz00_4420;

																							BgL_auxz00_4420 =
																								(long) (BgL_arg2553z00_2956);
																							BgL_modz00_2955 =
																								(BgL_offsetz00_2954 /
																								BgL_auxz00_4420);
																					}}
																					{	/* Trace/walk.scm 347 */
																						long BgL_restz00_2957;

																						{	/* Trace/walk.scm 347 */
																							int BgL_arg2552z00_2958;

																							BgL_arg2552z00_2958 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 347 */
																								long BgL_auxz00_4424;

																								BgL_auxz00_4424 =
																									(long) (BgL_arg2552z00_2958);
																								BgL_restz00_2957 =
																									(BgL_offsetz00_2954 %
																									BgL_auxz00_4424);
																						}}
																						{	/* Trace/walk.scm 347 */

																							BgL_method3330z00_2947 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2952,
																									(int) (BgL_modz00_2955)),
																								(int) (BgL_restz00_2957));
															}}}}}}}}
															BgL_res3829z00_2972 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3330z00_2947)
																(BgL_method3330z00_2947,
																	(obj_t) (BgL_nodez00_2945), BgL_stackz00_1692,
																	BEOA));
													}}
													BgL_arg3679z00_1704 = BgL_res3829z00_2972;
											}}
											{	/* Trace/walk.scm 347 */
												obj_t BgL_auxz00_4435;

												BgL_auxz00_4435 = (obj_t) (BgL_arg3679z00_1704);
												SET_CDR(BgL_clausez00_1703, BgL_auxz00_4435);
									}}}
									{
										obj_t BgL_l3292z00_4438;

										BgL_l3292z00_4438 = CDR(BgL_l3292z00_1700);
										BgL_l3292z00_1700 = BgL_l3292z00_4438;
										goto BgL_zc3anonymousza33677ze3z83_1701;
									}
								}
							else
								{	/* Trace/walk.scm 346 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_4380 = BgL_nodez00_1691;
					return (obj_t) (BgL_auxz00_4380);
				}
			}
		}
	}



/* trace-node-fail3348 */
	obj_t BGl_tracezd2nodezd2fail3348z00zztrace_walkz00(obj_t BgL_envz00_3397,
		obj_t BgL_nodez00_3398, obj_t BgL_stackz00_3399)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 333 */
			{
				BgL_failz00_bglt BgL_nodez00_1678;

				obj_t BgL_stackz00_1679;

				{	/* Trace/walk.scm 334 */
					BgL_failz00_bglt BgL_auxz00_4442;

					BgL_nodez00_1678 = (BgL_failz00_bglt) (BgL_nodez00_3398);
					BgL_stackz00_1679 = BgL_stackz00_3399;
					{	/* Trace/walk.scm 335 */
						BgL_nodez00_bglt BgL_arg3668z00_1683;

						{	/* Trace/walk.scm 335 */
							BgL_nodez00_bglt BgL_arg3669z00_1684;

							BgL_arg3669z00_1684 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_procz00);
							{	/* Trace/walk.scm 335 */
								BgL_nodez00_bglt BgL_res3817z00_2845;

								{	/* Trace/walk.scm 335 */
									obj_t BgL_method3330z00_2820;

									{	/* Trace/walk.scm 335 */
										BgL_objectz00_bglt BgL_objz00_2821;

										BgL_objz00_2821 =
											(BgL_objectz00_bglt) (BgL_arg3669z00_1684);
										{	/* Trace/walk.scm 335 */
											long BgL_objzd2classzd2numz00_2822;

											BgL_objzd2classzd2numz00_2822 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2821);
											{	/* Trace/walk.scm 335 */
												obj_t BgL_arg2551z00_2823;

												BgL_arg2551z00_2823 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 335 */
													obj_t BgL_arrayz00_2825;

													int BgL_offsetz00_2826;

													BgL_arrayz00_2825 = BgL_arg2551z00_2823;
													BgL_offsetz00_2826 =
														(int) (BgL_objzd2classzd2numz00_2822);
													{	/* Trace/walk.scm 335 */
														long BgL_offsetz00_2827;

														BgL_offsetz00_2827 =
															((long) (BgL_offsetz00_2826) - OBJECT_TYPE);
														{	/* Trace/walk.scm 335 */
															long BgL_modz00_2828;

															{	/* Trace/walk.scm 335 */
																int BgL_arg2553z00_2829;

																BgL_arg2553z00_2829 = (int) (((long) 8));
																{	/* Trace/walk.scm 335 */
																	long BgL_auxz00_4452;

																	BgL_auxz00_4452 =
																		(long) (BgL_arg2553z00_2829);
																	BgL_modz00_2828 =
																		(BgL_offsetz00_2827 / BgL_auxz00_4452);
															}}
															{	/* Trace/walk.scm 335 */
																long BgL_restz00_2830;

																{	/* Trace/walk.scm 335 */
																	int BgL_arg2552z00_2831;

																	BgL_arg2552z00_2831 = (int) (((long) 8));
																	{	/* Trace/walk.scm 335 */
																		long BgL_auxz00_4456;

																		BgL_auxz00_4456 =
																			(long) (BgL_arg2552z00_2831);
																		BgL_restz00_2830 =
																			(BgL_offsetz00_2827 % BgL_auxz00_4456);
																}}
																{	/* Trace/walk.scm 335 */

																	BgL_method3330z00_2820 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2825,
																			(int) (BgL_modz00_2828)),
																		(int) (BgL_restz00_2830));
									}}}}}}}}
									BgL_res3817z00_2845 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2820)
										(BgL_method3330z00_2820, (obj_t) (BgL_arg3669z00_1684),
											BgL_stackz00_1679, BEOA));
								}
								BgL_arg3668z00_1683 = BgL_res3817z00_2845;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3668z00_1683), BUNSPEC);
					}
					{	/* Trace/walk.scm 336 */
						BgL_nodez00_bglt BgL_arg3670z00_1685;

						{	/* Trace/walk.scm 336 */
							BgL_nodez00_bglt BgL_arg3671z00_1686;

							BgL_arg3671z00_1686 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_msgz00);
							{	/* Trace/walk.scm 336 */
								BgL_nodez00_bglt BgL_res3820z00_2876;

								{	/* Trace/walk.scm 336 */
									obj_t BgL_method3330z00_2851;

									{	/* Trace/walk.scm 336 */
										BgL_objectz00_bglt BgL_objz00_2852;

										BgL_objz00_2852 =
											(BgL_objectz00_bglt) (BgL_arg3671z00_1686);
										{	/* Trace/walk.scm 336 */
											long BgL_objzd2classzd2numz00_2853;

											BgL_objzd2classzd2numz00_2853 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2852);
											{	/* Trace/walk.scm 336 */
												obj_t BgL_arg2551z00_2854;

												BgL_arg2551z00_2854 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 336 */
													obj_t BgL_arrayz00_2856;

													int BgL_offsetz00_2857;

													BgL_arrayz00_2856 = BgL_arg2551z00_2854;
													BgL_offsetz00_2857 =
														(int) (BgL_objzd2classzd2numz00_2853);
													{	/* Trace/walk.scm 336 */
														long BgL_offsetz00_2858;

														BgL_offsetz00_2858 =
															((long) (BgL_offsetz00_2857) - OBJECT_TYPE);
														{	/* Trace/walk.scm 336 */
															long BgL_modz00_2859;

															{	/* Trace/walk.scm 336 */
																int BgL_arg2553z00_2860;

																BgL_arg2553z00_2860 = (int) (((long) 8));
																{	/* Trace/walk.scm 336 */
																	long BgL_auxz00_4477;

																	BgL_auxz00_4477 =
																		(long) (BgL_arg2553z00_2860);
																	BgL_modz00_2859 =
																		(BgL_offsetz00_2858 / BgL_auxz00_4477);
															}}
															{	/* Trace/walk.scm 336 */
																long BgL_restz00_2861;

																{	/* Trace/walk.scm 336 */
																	int BgL_arg2552z00_2862;

																	BgL_arg2552z00_2862 = (int) (((long) 8));
																	{	/* Trace/walk.scm 336 */
																		long BgL_auxz00_4481;

																		BgL_auxz00_4481 =
																			(long) (BgL_arg2552z00_2862);
																		BgL_restz00_2861 =
																			(BgL_offsetz00_2858 % BgL_auxz00_4481);
																}}
																{	/* Trace/walk.scm 336 */

																	BgL_method3330z00_2851 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2856,
																			(int) (BgL_modz00_2859)),
																		(int) (BgL_restz00_2861));
									}}}}}}}}
									BgL_res3820z00_2876 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2851)
										(BgL_method3330z00_2851, (obj_t) (BgL_arg3671z00_1686),
											BgL_stackz00_1679, BEOA));
								}
								BgL_arg3670z00_1685 = BgL_res3820z00_2876;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3670z00_1685), BUNSPEC);
					}
					{	/* Trace/walk.scm 337 */
						BgL_nodez00_bglt BgL_arg3672z00_1687;

						{	/* Trace/walk.scm 337 */
							BgL_nodez00_bglt BgL_arg3673z00_1688;

							BgL_arg3673z00_1688 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_objz00);
							{	/* Trace/walk.scm 337 */
								BgL_nodez00_bglt BgL_res3823z00_2907;

								{	/* Trace/walk.scm 337 */
									obj_t BgL_method3330z00_2882;

									{	/* Trace/walk.scm 337 */
										BgL_objectz00_bglt BgL_objz00_2883;

										BgL_objz00_2883 =
											(BgL_objectz00_bglt) (BgL_arg3673z00_1688);
										{	/* Trace/walk.scm 337 */
											long BgL_objzd2classzd2numz00_2884;

											BgL_objzd2classzd2numz00_2884 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2883);
											{	/* Trace/walk.scm 337 */
												obj_t BgL_arg2551z00_2885;

												BgL_arg2551z00_2885 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 337 */
													obj_t BgL_arrayz00_2887;

													int BgL_offsetz00_2888;

													BgL_arrayz00_2887 = BgL_arg2551z00_2885;
													BgL_offsetz00_2888 =
														(int) (BgL_objzd2classzd2numz00_2884);
													{	/* Trace/walk.scm 337 */
														long BgL_offsetz00_2889;

														BgL_offsetz00_2889 =
															((long) (BgL_offsetz00_2888) - OBJECT_TYPE);
														{	/* Trace/walk.scm 337 */
															long BgL_modz00_2890;

															{	/* Trace/walk.scm 337 */
																int BgL_arg2553z00_2891;

																BgL_arg2553z00_2891 = (int) (((long) 8));
																{	/* Trace/walk.scm 337 */
																	long BgL_auxz00_4502;

																	BgL_auxz00_4502 =
																		(long) (BgL_arg2553z00_2891);
																	BgL_modz00_2890 =
																		(BgL_offsetz00_2889 / BgL_auxz00_4502);
															}}
															{	/* Trace/walk.scm 337 */
																long BgL_restz00_2892;

																{	/* Trace/walk.scm 337 */
																	int BgL_arg2552z00_2893;

																	BgL_arg2552z00_2893 = (int) (((long) 8));
																	{	/* Trace/walk.scm 337 */
																		long BgL_auxz00_4506;

																		BgL_auxz00_4506 =
																			(long) (BgL_arg2552z00_2893);
																		BgL_restz00_2892 =
																			(BgL_offsetz00_2889 % BgL_auxz00_4506);
																}}
																{	/* Trace/walk.scm 337 */

																	BgL_method3330z00_2882 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2887,
																			(int) (BgL_modz00_2890)),
																		(int) (BgL_restz00_2892));
									}}}}}}}}
									BgL_res3823z00_2907 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2882)
										(BgL_method3330z00_2882, (obj_t) (BgL_arg3673z00_1688),
											BgL_stackz00_1679, BEOA));
								}
								BgL_arg3672z00_1687 = BgL_res3823z00_2907;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1678))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3672z00_1687), BUNSPEC);
					}
					BgL_auxz00_4442 = BgL_nodez00_1678;
					return (obj_t) (BgL_auxz00_4442);
				}
			}
		}
	}



/* trace-node-condition3346 */
	obj_t BGl_tracezd2nodezd2condition3346z00zztrace_walkz00(obj_t
		BgL_envz00_3400, obj_t BgL_nodez00_3401, obj_t BgL_stackz00_3402)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 323 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1665;

				obj_t BgL_stackz00_1666;

				{	/* Trace/walk.scm 324 */
					BgL_conditionalz00_bglt BgL_auxz00_4520;

					BgL_nodez00_1665 = (BgL_conditionalz00_bglt) (BgL_nodez00_3401);
					BgL_stackz00_1666 = BgL_stackz00_3402;
					{	/* Trace/walk.scm 325 */
						BgL_nodez00_bglt BgL_arg3661z00_1670;

						{	/* Trace/walk.scm 325 */
							BgL_nodez00_bglt BgL_arg3662z00_1671;

							BgL_arg3662z00_1671 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->
								BgL_testz00);
							{	/* Trace/walk.scm 325 */
								BgL_nodez00_bglt BgL_res3808z00_2752;

								{	/* Trace/walk.scm 325 */
									obj_t BgL_method3330z00_2727;

									{	/* Trace/walk.scm 325 */
										BgL_objectz00_bglt BgL_objz00_2728;

										BgL_objz00_2728 =
											(BgL_objectz00_bglt) (BgL_arg3662z00_1671);
										{	/* Trace/walk.scm 325 */
											long BgL_objzd2classzd2numz00_2729;

											BgL_objzd2classzd2numz00_2729 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2728);
											{	/* Trace/walk.scm 325 */
												obj_t BgL_arg2551z00_2730;

												BgL_arg2551z00_2730 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 325 */
													obj_t BgL_arrayz00_2732;

													int BgL_offsetz00_2733;

													BgL_arrayz00_2732 = BgL_arg2551z00_2730;
													BgL_offsetz00_2733 =
														(int) (BgL_objzd2classzd2numz00_2729);
													{	/* Trace/walk.scm 325 */
														long BgL_offsetz00_2734;

														BgL_offsetz00_2734 =
															((long) (BgL_offsetz00_2733) - OBJECT_TYPE);
														{	/* Trace/walk.scm 325 */
															long BgL_modz00_2735;

															{	/* Trace/walk.scm 325 */
																int BgL_arg2553z00_2736;

																BgL_arg2553z00_2736 = (int) (((long) 8));
																{	/* Trace/walk.scm 325 */
																	long BgL_auxz00_4530;

																	BgL_auxz00_4530 =
																		(long) (BgL_arg2553z00_2736);
																	BgL_modz00_2735 =
																		(BgL_offsetz00_2734 / BgL_auxz00_4530);
															}}
															{	/* Trace/walk.scm 325 */
																long BgL_restz00_2737;

																{	/* Trace/walk.scm 325 */
																	int BgL_arg2552z00_2738;

																	BgL_arg2552z00_2738 = (int) (((long) 8));
																	{	/* Trace/walk.scm 325 */
																		long BgL_auxz00_4534;

																		BgL_auxz00_4534 =
																			(long) (BgL_arg2552z00_2738);
																		BgL_restz00_2737 =
																			(BgL_offsetz00_2734 % BgL_auxz00_4534);
																}}
																{	/* Trace/walk.scm 325 */

																	BgL_method3330z00_2727 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2732,
																			(int) (BgL_modz00_2735)),
																		(int) (BgL_restz00_2737));
									}}}}}}}}
									BgL_res3808z00_2752 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2727)
										(BgL_method3330z00_2727, (obj_t) (BgL_arg3662z00_1671),
											BgL_stackz00_1666, BEOA));
								}
								BgL_arg3661z00_1670 = BgL_res3808z00_2752;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3661z00_1670), BUNSPEC);
					}
					{	/* Trace/walk.scm 326 */
						BgL_nodez00_bglt BgL_arg3663z00_1672;

						{	/* Trace/walk.scm 326 */
							BgL_nodez00_bglt BgL_arg3664z00_1673;

							BgL_arg3664z00_1673 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->
								BgL_truez00);
							{	/* Trace/walk.scm 326 */
								BgL_nodez00_bglt BgL_res3811z00_2783;

								{	/* Trace/walk.scm 326 */
									obj_t BgL_method3330z00_2758;

									{	/* Trace/walk.scm 326 */
										BgL_objectz00_bglt BgL_objz00_2759;

										BgL_objz00_2759 =
											(BgL_objectz00_bglt) (BgL_arg3664z00_1673);
										{	/* Trace/walk.scm 326 */
											long BgL_objzd2classzd2numz00_2760;

											BgL_objzd2classzd2numz00_2760 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2759);
											{	/* Trace/walk.scm 326 */
												obj_t BgL_arg2551z00_2761;

												BgL_arg2551z00_2761 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 326 */
													obj_t BgL_arrayz00_2763;

													int BgL_offsetz00_2764;

													BgL_arrayz00_2763 = BgL_arg2551z00_2761;
													BgL_offsetz00_2764 =
														(int) (BgL_objzd2classzd2numz00_2760);
													{	/* Trace/walk.scm 326 */
														long BgL_offsetz00_2765;

														BgL_offsetz00_2765 =
															((long) (BgL_offsetz00_2764) - OBJECT_TYPE);
														{	/* Trace/walk.scm 326 */
															long BgL_modz00_2766;

															{	/* Trace/walk.scm 326 */
																int BgL_arg2553z00_2767;

																BgL_arg2553z00_2767 = (int) (((long) 8));
																{	/* Trace/walk.scm 326 */
																	long BgL_auxz00_4555;

																	BgL_auxz00_4555 =
																		(long) (BgL_arg2553z00_2767);
																	BgL_modz00_2766 =
																		(BgL_offsetz00_2765 / BgL_auxz00_4555);
															}}
															{	/* Trace/walk.scm 326 */
																long BgL_restz00_2768;

																{	/* Trace/walk.scm 326 */
																	int BgL_arg2552z00_2769;

																	BgL_arg2552z00_2769 = (int) (((long) 8));
																	{	/* Trace/walk.scm 326 */
																		long BgL_auxz00_4559;

																		BgL_auxz00_4559 =
																			(long) (BgL_arg2552z00_2769);
																		BgL_restz00_2768 =
																			(BgL_offsetz00_2765 % BgL_auxz00_4559);
																}}
																{	/* Trace/walk.scm 326 */

																	BgL_method3330z00_2758 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2763,
																			(int) (BgL_modz00_2766)),
																		(int) (BgL_restz00_2768));
									}}}}}}}}
									BgL_res3811z00_2783 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2758)
										(BgL_method3330z00_2758, (obj_t) (BgL_arg3664z00_1673),
											BgL_stackz00_1666, BEOA));
								}
								BgL_arg3663z00_1672 = BgL_res3811z00_2783;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3663z00_1672), BUNSPEC);
					}
					{	/* Trace/walk.scm 327 */
						BgL_nodez00_bglt BgL_arg3665z00_1674;

						{	/* Trace/walk.scm 327 */
							BgL_nodez00_bglt BgL_arg3666z00_1675;

							BgL_arg3666z00_1675 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->
								BgL_falsez00);
							{	/* Trace/walk.scm 327 */
								BgL_nodez00_bglt BgL_res3814z00_2814;

								{	/* Trace/walk.scm 327 */
									obj_t BgL_method3330z00_2789;

									{	/* Trace/walk.scm 327 */
										BgL_objectz00_bglt BgL_objz00_2790;

										BgL_objz00_2790 =
											(BgL_objectz00_bglt) (BgL_arg3666z00_1675);
										{	/* Trace/walk.scm 327 */
											long BgL_objzd2classzd2numz00_2791;

											BgL_objzd2classzd2numz00_2791 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2790);
											{	/* Trace/walk.scm 327 */
												obj_t BgL_arg2551z00_2792;

												BgL_arg2551z00_2792 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 327 */
													obj_t BgL_arrayz00_2794;

													int BgL_offsetz00_2795;

													BgL_arrayz00_2794 = BgL_arg2551z00_2792;
													BgL_offsetz00_2795 =
														(int) (BgL_objzd2classzd2numz00_2791);
													{	/* Trace/walk.scm 327 */
														long BgL_offsetz00_2796;

														BgL_offsetz00_2796 =
															((long) (BgL_offsetz00_2795) - OBJECT_TYPE);
														{	/* Trace/walk.scm 327 */
															long BgL_modz00_2797;

															{	/* Trace/walk.scm 327 */
																int BgL_arg2553z00_2798;

																BgL_arg2553z00_2798 = (int) (((long) 8));
																{	/* Trace/walk.scm 327 */
																	long BgL_auxz00_4580;

																	BgL_auxz00_4580 =
																		(long) (BgL_arg2553z00_2798);
																	BgL_modz00_2797 =
																		(BgL_offsetz00_2796 / BgL_auxz00_4580);
															}}
															{	/* Trace/walk.scm 327 */
																long BgL_restz00_2799;

																{	/* Trace/walk.scm 327 */
																	int BgL_arg2552z00_2800;

																	BgL_arg2552z00_2800 = (int) (((long) 8));
																	{	/* Trace/walk.scm 327 */
																		long BgL_auxz00_4584;

																		BgL_auxz00_4584 =
																			(long) (BgL_arg2552z00_2800);
																		BgL_restz00_2799 =
																			(BgL_offsetz00_2796 % BgL_auxz00_4584);
																}}
																{	/* Trace/walk.scm 327 */

																	BgL_method3330z00_2789 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2794,
																			(int) (BgL_modz00_2797)),
																		(int) (BgL_restz00_2799));
									}}}}}}}}
									BgL_res3814z00_2814 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2789)
										(BgL_method3330z00_2789, (obj_t) (BgL_arg3666z00_1675),
											BgL_stackz00_1666, BEOA));
								}
								BgL_arg3665z00_1674 = BgL_res3814z00_2814;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1665))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3665z00_1674), BUNSPEC);
					}
					BgL_auxz00_4520 = BgL_nodez00_1665;
					return (obj_t) (BgL_auxz00_4520);
				}
			}
		}
	}



/* trace-node-setq3344 */
	obj_t BGl_tracezd2nodezd2setq3344z00zztrace_walkz00(obj_t BgL_envz00_3403,
		obj_t BgL_nodez00_3404, obj_t BgL_stackz00_3405)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 316 */
			{
				BgL_setqz00_bglt BgL_nodez00_1657;

				obj_t BgL_stackz00_1658;

				{	/* Trace/walk.scm 317 */
					BgL_setqz00_bglt BgL_auxz00_4598;

					BgL_nodez00_1657 = (BgL_setqz00_bglt) (BgL_nodez00_3404);
					BgL_stackz00_1658 = BgL_stackz00_3405;
					{	/* Trace/walk.scm 317 */
						BgL_nodez00_bglt BgL_arg3658z00_2691;

						{	/* Trace/walk.scm 317 */
							BgL_nodez00_bglt BgL_arg3659z00_2692;

							BgL_arg3659z00_2692 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1657))->BgL_valuez00);
							{	/* Trace/walk.scm 317 */
								BgL_nodez00_bglt BgL_res3805z00_2721;

								{	/* Trace/walk.scm 317 */
									obj_t BgL_method3330z00_2696;

									{	/* Trace/walk.scm 317 */
										BgL_objectz00_bglt BgL_objz00_2697;

										BgL_objz00_2697 =
											(BgL_objectz00_bglt) (BgL_arg3659z00_2692);
										{	/* Trace/walk.scm 317 */
											long BgL_objzd2classzd2numz00_2698;

											BgL_objzd2classzd2numz00_2698 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2697);
											{	/* Trace/walk.scm 317 */
												obj_t BgL_arg2551z00_2699;

												BgL_arg2551z00_2699 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 317 */
													obj_t BgL_arrayz00_2701;

													int BgL_offsetz00_2702;

													BgL_arrayz00_2701 = BgL_arg2551z00_2699;
													BgL_offsetz00_2702 =
														(int) (BgL_objzd2classzd2numz00_2698);
													{	/* Trace/walk.scm 317 */
														long BgL_offsetz00_2703;

														BgL_offsetz00_2703 =
															((long) (BgL_offsetz00_2702) - OBJECT_TYPE);
														{	/* Trace/walk.scm 317 */
															long BgL_modz00_2704;

															{	/* Trace/walk.scm 317 */
																int BgL_arg2553z00_2705;

																BgL_arg2553z00_2705 = (int) (((long) 8));
																{	/* Trace/walk.scm 317 */
																	long BgL_auxz00_4608;

																	BgL_auxz00_4608 =
																		(long) (BgL_arg2553z00_2705);
																	BgL_modz00_2704 =
																		(BgL_offsetz00_2703 / BgL_auxz00_4608);
															}}
															{	/* Trace/walk.scm 317 */
																long BgL_restz00_2706;

																{	/* Trace/walk.scm 317 */
																	int BgL_arg2552z00_2707;

																	BgL_arg2552z00_2707 = (int) (((long) 8));
																	{	/* Trace/walk.scm 317 */
																		long BgL_auxz00_4612;

																		BgL_auxz00_4612 =
																			(long) (BgL_arg2552z00_2707);
																		BgL_restz00_2706 =
																			(BgL_offsetz00_2703 % BgL_auxz00_4612);
																}}
																{	/* Trace/walk.scm 317 */

																	BgL_method3330z00_2696 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2701,
																			(int) (BgL_modz00_2704)),
																		(int) (BgL_restz00_2706));
									}}}}}}}}
									BgL_res3805z00_2721 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2696)
										(BgL_method3330z00_2696, (obj_t) (BgL_arg3659z00_2692),
											BgL_stackz00_1658, BEOA));
								}
								BgL_arg3658z00_2691 = BgL_res3805z00_2721;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1657))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3658z00_2691), BUNSPEC);
					}
					BgL_auxz00_4598 = BgL_nodez00_1657;
					return (obj_t) (BgL_auxz00_4598);
				}
			}
		}
	}



/* trace-node-cast3342 */
	obj_t BGl_tracezd2nodezd2cast3342z00zztrace_walkz00(obj_t BgL_envz00_3406,
		obj_t BgL_nodez00_3407, obj_t BgL_stackz00_3408)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 309 */
			{
				BgL_castz00_bglt BgL_nodez00_1650;

				obj_t BgL_stackz00_1651;

				{	/* Trace/walk.scm 310 */
					BgL_castz00_bglt BgL_auxz00_4626;

					BgL_nodez00_1650 = (BgL_castz00_bglt) (BgL_nodez00_3407);
					BgL_stackz00_1651 = BgL_stackz00_3408;
					{	/* Trace/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3656z00_2661;

						BgL_arg3656z00_2661 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1650))->BgL_argz00);
						{	/* Trace/walk.scm 310 */
							BgL_nodez00_bglt BgL_res3802z00_2690;

							{	/* Trace/walk.scm 310 */
								obj_t BgL_method3330z00_2665;

								{	/* Trace/walk.scm 310 */
									BgL_objectz00_bglt BgL_objz00_2666;

									BgL_objz00_2666 = (BgL_objectz00_bglt) (BgL_arg3656z00_2661);
									{	/* Trace/walk.scm 310 */
										long BgL_objzd2classzd2numz00_2667;

										BgL_objzd2classzd2numz00_2667 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2666);
										{	/* Trace/walk.scm 310 */
											obj_t BgL_arg2551z00_2668;

											BgL_arg2551z00_2668 =
												PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 310 */
												obj_t BgL_arrayz00_2670;

												int BgL_offsetz00_2671;

												BgL_arrayz00_2670 = BgL_arg2551z00_2668;
												BgL_offsetz00_2671 =
													(int) (BgL_objzd2classzd2numz00_2667);
												{	/* Trace/walk.scm 310 */
													long BgL_offsetz00_2672;

													BgL_offsetz00_2672 =
														((long) (BgL_offsetz00_2671) - OBJECT_TYPE);
													{	/* Trace/walk.scm 310 */
														long BgL_modz00_2673;

														{	/* Trace/walk.scm 310 */
															int BgL_arg2553z00_2674;

															BgL_arg2553z00_2674 = (int) (((long) 8));
															{	/* Trace/walk.scm 310 */
																long BgL_auxz00_4636;

																BgL_auxz00_4636 = (long) (BgL_arg2553z00_2674);
																BgL_modz00_2673 =
																	(BgL_offsetz00_2672 / BgL_auxz00_4636);
														}}
														{	/* Trace/walk.scm 310 */
															long BgL_restz00_2675;

															{	/* Trace/walk.scm 310 */
																int BgL_arg2552z00_2676;

																BgL_arg2552z00_2676 = (int) (((long) 8));
																{	/* Trace/walk.scm 310 */
																	long BgL_auxz00_4640;

																	BgL_auxz00_4640 =
																		(long) (BgL_arg2552z00_2676);
																	BgL_restz00_2675 =
																		(BgL_offsetz00_2672 % BgL_auxz00_4640);
															}}
															{	/* Trace/walk.scm 310 */

																BgL_method3330z00_2665 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2670,
																		(int) (BgL_modz00_2673)),
																	(int) (BgL_restz00_2675));
								}}}}}}}}
								BgL_res3802z00_2690 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2665)
									(BgL_method3330z00_2665, (obj_t) (BgL_arg3656z00_2661),
										BgL_stackz00_1651, BEOA));
							} BgL_res3802z00_2690;
					}}
					BgL_auxz00_4626 = BgL_nodez00_1650;
					return (obj_t) (BgL_auxz00_4626);
				}
			}
		}
	}



/* trace-node-extern3340 */
	obj_t BGl_tracezd2nodezd2extern3340z00zztrace_walkz00(obj_t BgL_envz00_3409,
		obj_t BgL_nodez00_3410, obj_t BgL_stackz00_3411)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 302 */
			{
				BgL_externz00_bglt BgL_nodez00_1643;

				obj_t BgL_stackz00_1644;

				{	/* Trace/walk.scm 303 */
					BgL_externz00_bglt BgL_auxz00_4653;

					BgL_nodez00_1643 = (BgL_externz00_bglt) (BgL_nodez00_3410);
					BgL_stackz00_1644 = BgL_stackz00_3411;
					{	/* Trace/walk.scm 303 */
						obj_t BgL_arg3654z00_2659;

						BgL_arg3654z00_2659 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1643))->BgL_exprza2za2);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3654z00_2659,
							BgL_stackz00_1644);
					}
					BgL_auxz00_4653 = BgL_nodez00_1643;
					return (obj_t) (BgL_auxz00_4653);
				}
			}
		}
	}



/* trace-node-funcall3338 */
	obj_t BGl_tracezd2nodezd2funcall3338z00zztrace_walkz00(obj_t BgL_envz00_3412,
		obj_t BgL_nodez00_3413, obj_t BgL_stackz00_3414)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 293 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1633;

				obj_t BgL_stackz00_1634;

				{	/* Trace/walk.scm 294 */
					BgL_funcallz00_bglt BgL_auxz00_4658;

					BgL_nodez00_1633 = (BgL_funcallz00_bglt) (BgL_nodez00_3413);
					BgL_stackz00_1634 = BgL_stackz00_3414;
					{	/* Trace/walk.scm 295 */
						BgL_nodez00_bglt BgL_arg3650z00_1638;

						{	/* Trace/walk.scm 295 */
							BgL_nodez00_bglt BgL_arg3651z00_1639;

							BgL_arg3651z00_1639 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1633))->BgL_funz00);
							{	/* Trace/walk.scm 295 */
								BgL_nodez00_bglt BgL_res3799z00_2655;

								{	/* Trace/walk.scm 295 */
									obj_t BgL_method3330z00_2630;

									{	/* Trace/walk.scm 295 */
										BgL_objectz00_bglt BgL_objz00_2631;

										BgL_objz00_2631 =
											(BgL_objectz00_bglt) (BgL_arg3651z00_1639);
										{	/* Trace/walk.scm 295 */
											long BgL_objzd2classzd2numz00_2632;

											BgL_objzd2classzd2numz00_2632 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2631);
											{	/* Trace/walk.scm 295 */
												obj_t BgL_arg2551z00_2633;

												BgL_arg2551z00_2633 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 295 */
													obj_t BgL_arrayz00_2635;

													int BgL_offsetz00_2636;

													BgL_arrayz00_2635 = BgL_arg2551z00_2633;
													BgL_offsetz00_2636 =
														(int) (BgL_objzd2classzd2numz00_2632);
													{	/* Trace/walk.scm 295 */
														long BgL_offsetz00_2637;

														BgL_offsetz00_2637 =
															((long) (BgL_offsetz00_2636) - OBJECT_TYPE);
														{	/* Trace/walk.scm 295 */
															long BgL_modz00_2638;

															{	/* Trace/walk.scm 295 */
																int BgL_arg2553z00_2639;

																BgL_arg2553z00_2639 = (int) (((long) 8));
																{	/* Trace/walk.scm 295 */
																	long BgL_auxz00_4668;

																	BgL_auxz00_4668 =
																		(long) (BgL_arg2553z00_2639);
																	BgL_modz00_2638 =
																		(BgL_offsetz00_2637 / BgL_auxz00_4668);
															}}
															{	/* Trace/walk.scm 295 */
																long BgL_restz00_2640;

																{	/* Trace/walk.scm 295 */
																	int BgL_arg2552z00_2641;

																	BgL_arg2552z00_2641 = (int) (((long) 8));
																	{	/* Trace/walk.scm 295 */
																		long BgL_auxz00_4672;

																		BgL_auxz00_4672 =
																			(long) (BgL_arg2552z00_2641);
																		BgL_restz00_2640 =
																			(BgL_offsetz00_2637 % BgL_auxz00_4672);
																}}
																{	/* Trace/walk.scm 295 */

																	BgL_method3330z00_2630 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2635,
																			(int) (BgL_modz00_2638)),
																		(int) (BgL_restz00_2640));
									}}}}}}}}
									BgL_res3799z00_2655 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2630)
										(BgL_method3330z00_2630, (obj_t) (BgL_arg3651z00_1639),
											BgL_stackz00_1634, BEOA));
								}
								BgL_arg3650z00_1638 = BgL_res3799z00_2655;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1633))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3650z00_1638), BUNSPEC);
					}
					{	/* Trace/walk.scm 296 */
						obj_t BgL_arg3652z00_1640;

						BgL_arg3652z00_1640 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1633))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3652z00_1640,
							BgL_stackz00_1634);
					}
					BgL_auxz00_4658 = BgL_nodez00_1633;
					return (obj_t) (BgL_auxz00_4658);
				}
			}
		}
	}



/* trace-node-app-ly3336 */
	obj_t BGl_tracezd2nodezd2appzd2ly3336zd2zztrace_walkz00(obj_t BgL_envz00_3415,
		obj_t BgL_nodez00_3416, obj_t BgL_stackz00_3417)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 284 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1622;

				obj_t BgL_stackz00_1623;

				{	/* Trace/walk.scm 285 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_4688;

					BgL_nodez00_1622 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3416);
					BgL_stackz00_1623 = BgL_stackz00_3417;
					{	/* Trace/walk.scm 286 */
						BgL_nodez00_bglt BgL_arg3645z00_1627;

						{	/* Trace/walk.scm 286 */
							BgL_nodez00_bglt BgL_arg3646z00_1628;

							BgL_arg3646z00_1628 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1622))->BgL_funz00);
							{	/* Trace/walk.scm 286 */
								BgL_nodez00_bglt BgL_res3793z00_2593;

								{	/* Trace/walk.scm 286 */
									obj_t BgL_method3330z00_2568;

									{	/* Trace/walk.scm 286 */
										BgL_objectz00_bglt BgL_objz00_2569;

										BgL_objz00_2569 =
											(BgL_objectz00_bglt) (BgL_arg3646z00_1628);
										{	/* Trace/walk.scm 286 */
											long BgL_objzd2classzd2numz00_2570;

											BgL_objzd2classzd2numz00_2570 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2569);
											{	/* Trace/walk.scm 286 */
												obj_t BgL_arg2551z00_2571;

												BgL_arg2551z00_2571 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 286 */
													obj_t BgL_arrayz00_2573;

													int BgL_offsetz00_2574;

													BgL_arrayz00_2573 = BgL_arg2551z00_2571;
													BgL_offsetz00_2574 =
														(int) (BgL_objzd2classzd2numz00_2570);
													{	/* Trace/walk.scm 286 */
														long BgL_offsetz00_2575;

														BgL_offsetz00_2575 =
															((long) (BgL_offsetz00_2574) - OBJECT_TYPE);
														{	/* Trace/walk.scm 286 */
															long BgL_modz00_2576;

															{	/* Trace/walk.scm 286 */
																int BgL_arg2553z00_2577;

																BgL_arg2553z00_2577 = (int) (((long) 8));
																{	/* Trace/walk.scm 286 */
																	long BgL_auxz00_4698;

																	BgL_auxz00_4698 =
																		(long) (BgL_arg2553z00_2577);
																	BgL_modz00_2576 =
																		(BgL_offsetz00_2575 / BgL_auxz00_4698);
															}}
															{	/* Trace/walk.scm 286 */
																long BgL_restz00_2578;

																{	/* Trace/walk.scm 286 */
																	int BgL_arg2552z00_2579;

																	BgL_arg2552z00_2579 = (int) (((long) 8));
																	{	/* Trace/walk.scm 286 */
																		long BgL_auxz00_4702;

																		BgL_auxz00_4702 =
																			(long) (BgL_arg2552z00_2579);
																		BgL_restz00_2578 =
																			(BgL_offsetz00_2575 % BgL_auxz00_4702);
																}}
																{	/* Trace/walk.scm 286 */

																	BgL_method3330z00_2568 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2573,
																			(int) (BgL_modz00_2576)),
																		(int) (BgL_restz00_2578));
									}}}}}}}}
									BgL_res3793z00_2593 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2568)
										(BgL_method3330z00_2568, (obj_t) (BgL_arg3646z00_1628),
											BgL_stackz00_1623, BEOA));
								}
								BgL_arg3645z00_1627 = BgL_res3793z00_2593;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1622))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3645z00_1627), BUNSPEC);
					}
					{	/* Trace/walk.scm 287 */
						BgL_nodez00_bglt BgL_arg3647z00_1629;

						{	/* Trace/walk.scm 287 */
							BgL_nodez00_bglt BgL_arg3648z00_1630;

							BgL_arg3648z00_1630 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1622))->BgL_argz00);
							{	/* Trace/walk.scm 287 */
								BgL_nodez00_bglt BgL_res3796z00_2624;

								{	/* Trace/walk.scm 287 */
									obj_t BgL_method3330z00_2599;

									{	/* Trace/walk.scm 287 */
										BgL_objectz00_bglt BgL_objz00_2600;

										BgL_objz00_2600 =
											(BgL_objectz00_bglt) (BgL_arg3648z00_1630);
										{	/* Trace/walk.scm 287 */
											long BgL_objzd2classzd2numz00_2601;

											BgL_objzd2classzd2numz00_2601 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2600);
											{	/* Trace/walk.scm 287 */
												obj_t BgL_arg2551z00_2602;

												BgL_arg2551z00_2602 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 287 */
													obj_t BgL_arrayz00_2604;

													int BgL_offsetz00_2605;

													BgL_arrayz00_2604 = BgL_arg2551z00_2602;
													BgL_offsetz00_2605 =
														(int) (BgL_objzd2classzd2numz00_2601);
													{	/* Trace/walk.scm 287 */
														long BgL_offsetz00_2606;

														BgL_offsetz00_2606 =
															((long) (BgL_offsetz00_2605) - OBJECT_TYPE);
														{	/* Trace/walk.scm 287 */
															long BgL_modz00_2607;

															{	/* Trace/walk.scm 287 */
																int BgL_arg2553z00_2608;

																BgL_arg2553z00_2608 = (int) (((long) 8));
																{	/* Trace/walk.scm 287 */
																	long BgL_auxz00_4723;

																	BgL_auxz00_4723 =
																		(long) (BgL_arg2553z00_2608);
																	BgL_modz00_2607 =
																		(BgL_offsetz00_2606 / BgL_auxz00_4723);
															}}
															{	/* Trace/walk.scm 287 */
																long BgL_restz00_2609;

																{	/* Trace/walk.scm 287 */
																	int BgL_arg2552z00_2610;

																	BgL_arg2552z00_2610 = (int) (((long) 8));
																	{	/* Trace/walk.scm 287 */
																		long BgL_auxz00_4727;

																		BgL_auxz00_4727 =
																			(long) (BgL_arg2552z00_2610);
																		BgL_restz00_2609 =
																			(BgL_offsetz00_2606 % BgL_auxz00_4727);
																}}
																{	/* Trace/walk.scm 287 */

																	BgL_method3330z00_2599 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2604,
																			(int) (BgL_modz00_2607)),
																		(int) (BgL_restz00_2609));
									}}}}}}}}
									BgL_res3796z00_2624 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3330z00_2599)
										(BgL_method3330z00_2599, (obj_t) (BgL_arg3648z00_1630),
											BgL_stackz00_1623, BEOA));
								}
								BgL_arg3647z00_1629 = BgL_res3796z00_2624;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1622))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3647z00_1629), BUNSPEC);
					}
					BgL_auxz00_4688 = BgL_nodez00_1622;
					return (obj_t) (BgL_auxz00_4688);
				}
			}
		}
	}



/* trace-node-app3334 */
	obj_t BGl_tracezd2nodezd2app3334z00zztrace_walkz00(obj_t BgL_envz00_3418,
		obj_t BgL_nodez00_3419, obj_t BgL_stackz00_3420)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 277 */
			{
				BgL_appz00_bglt BgL_nodez00_1615;

				obj_t BgL_stackz00_1616;

				{	/* Trace/walk.scm 278 */
					BgL_appz00_bglt BgL_auxz00_4741;

					BgL_nodez00_1615 = (BgL_appz00_bglt) (BgL_nodez00_3419);
					BgL_stackz00_1616 = BgL_stackz00_3420;
					{	/* Trace/walk.scm 278 */
						obj_t BgL_arg3643z00_2563;

						BgL_arg3643z00_2563 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1615))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3643z00_2563,
							BgL_stackz00_1616);
					}
					BgL_auxz00_4741 = BgL_nodez00_1615;
					return (obj_t) (BgL_auxz00_4741);
				}
			}
		}
	}



/* trace-node-sequence3332 */
	obj_t BGl_tracezd2nodezd2sequence3332z00zztrace_walkz00(obj_t BgL_envz00_3421,
		obj_t BgL_nodez00_3422, obj_t BgL_stackz00_3423)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 270 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1608;

				obj_t BgL_stackz00_1609;

				{	/* Trace/walk.scm 271 */
					BgL_sequencez00_bglt BgL_auxz00_4746;

					BgL_nodez00_1608 = (BgL_sequencez00_bglt) (BgL_nodez00_3422);
					BgL_stackz00_1609 = BgL_stackz00_3423;
					{	/* Trace/walk.scm 271 */
						obj_t BgL_arg3641z00_2561;

						BgL_arg3641z00_2561 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1608))->BgL_nodesz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3641z00_2561,
							BgL_stackz00_1609);
					}
					BgL_auxz00_4746 = BgL_nodez00_1608;
					return (obj_t) (BgL_auxz00_4746);
				}
			}
		}
	}



/* find-last-node-jump-3328 */
	obj_t BGl_findzd2lastzd2nodezd2jumpzd23328z00zztrace_walkz00(obj_t
		BgL_envz00_3424, obj_t BgL_nodez00_3425)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 226 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1602;

				BgL_nodez00_1602 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3425);
				{	/* Trace/walk.scm 227 */
					BgL_nodez00_bglt BgL_arg3639z00_2533;

					BgL_arg3639z00_2533 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1602))->
						BgL_valuez00);
					{	/* Trace/walk.scm 227 */
						obj_t BgL_method3302z00_2536;

						{	/* Trace/walk.scm 227 */
							BgL_objectz00_bglt BgL_objz00_2537;

							BgL_objz00_2537 = (BgL_objectz00_bglt) (BgL_arg3639z00_2533);
							{	/* Trace/walk.scm 227 */
								long BgL_objzd2classzd2numz00_2538;

								BgL_objzd2classzd2numz00_2538 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2537);
								{	/* Trace/walk.scm 227 */
									obj_t BgL_arg2551z00_2539;

									BgL_arg2551z00_2539 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 227 */
										obj_t BgL_arrayz00_2541;

										int BgL_offsetz00_2542;

										BgL_arrayz00_2541 = BgL_arg2551z00_2539;
										BgL_offsetz00_2542 = (int) (BgL_objzd2classzd2numz00_2538);
										{	/* Trace/walk.scm 227 */
											long BgL_offsetz00_2543;

											BgL_offsetz00_2543 =
												((long) (BgL_offsetz00_2542) - OBJECT_TYPE);
											{	/* Trace/walk.scm 227 */
												long BgL_modz00_2544;

												{	/* Trace/walk.scm 227 */
													int BgL_arg2553z00_2545;

													BgL_arg2553z00_2545 = (int) (((long) 8));
													{	/* Trace/walk.scm 227 */
														long BgL_auxz00_4760;

														BgL_auxz00_4760 = (long) (BgL_arg2553z00_2545);
														BgL_modz00_2544 =
															(BgL_offsetz00_2543 / BgL_auxz00_4760);
												}}
												{	/* Trace/walk.scm 227 */
													long BgL_restz00_2546;

													{	/* Trace/walk.scm 227 */
														int BgL_arg2552z00_2547;

														BgL_arg2552z00_2547 = (int) (((long) 8));
														{	/* Trace/walk.scm 227 */
															long BgL_auxz00_4764;

															BgL_auxz00_4764 = (long) (BgL_arg2552z00_2547);
															BgL_restz00_2546 =
																(BgL_offsetz00_2543 % BgL_auxz00_4764);
													}}
													{	/* Trace/walk.scm 227 */

														BgL_method3302z00_2536 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2541,
																(int) (BgL_modz00_2544)),
															(int) (BgL_restz00_2546));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2536) (BgL_method3302z00_2536,
							(obj_t) (BgL_arg3639z00_2533), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-set-e3326 */
	obj_t BGl_findzd2lastzd2nodezd2setzd2e3326z00zztrace_walkz00(obj_t
		BgL_envz00_3426, obj_t BgL_nodez00_3427)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 220 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1596;

				BgL_nodez00_1596 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3427);
				{	/* Trace/walk.scm 221 */
					BgL_nodez00_bglt BgL_arg3637z00_2505;

					BgL_arg3637z00_2505 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1596))->BgL_bodyz00);
					{	/* Trace/walk.scm 221 */
						obj_t BgL_method3302z00_2508;

						{	/* Trace/walk.scm 221 */
							BgL_objectz00_bglt BgL_objz00_2509;

							BgL_objz00_2509 = (BgL_objectz00_bglt) (BgL_arg3637z00_2505);
							{	/* Trace/walk.scm 221 */
								long BgL_objzd2classzd2numz00_2510;

								BgL_objzd2classzd2numz00_2510 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2509);
								{	/* Trace/walk.scm 221 */
									obj_t BgL_arg2551z00_2511;

									BgL_arg2551z00_2511 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 221 */
										obj_t BgL_arrayz00_2513;

										int BgL_offsetz00_2514;

										BgL_arrayz00_2513 = BgL_arg2551z00_2511;
										BgL_offsetz00_2514 = (int) (BgL_objzd2classzd2numz00_2510);
										{	/* Trace/walk.scm 221 */
											long BgL_offsetz00_2515;

											BgL_offsetz00_2515 =
												((long) (BgL_offsetz00_2514) - OBJECT_TYPE);
											{	/* Trace/walk.scm 221 */
												long BgL_modz00_2516;

												{	/* Trace/walk.scm 221 */
													int BgL_arg2553z00_2517;

													BgL_arg2553z00_2517 = (int) (((long) 8));
													{	/* Trace/walk.scm 221 */
														long BgL_auxz00_4784;

														BgL_auxz00_4784 = (long) (BgL_arg2553z00_2517);
														BgL_modz00_2516 =
															(BgL_offsetz00_2515 / BgL_auxz00_4784);
												}}
												{	/* Trace/walk.scm 221 */
													long BgL_restz00_2518;

													{	/* Trace/walk.scm 221 */
														int BgL_arg2552z00_2519;

														BgL_arg2552z00_2519 = (int) (((long) 8));
														{	/* Trace/walk.scm 221 */
															long BgL_auxz00_4788;

															BgL_auxz00_4788 = (long) (BgL_arg2552z00_2519);
															BgL_restz00_2518 =
																(BgL_offsetz00_2515 % BgL_auxz00_4788);
													}}
													{	/* Trace/walk.scm 221 */

														BgL_method3302z00_2508 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2513,
																(int) (BgL_modz00_2516)),
															(int) (BgL_restz00_2518));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2508) (BgL_method3302z00_2508,
							(obj_t) (BgL_arg3637z00_2505), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-f3324 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2f3324z00zztrace_walkz00(obj_t
		BgL_envz00_3428, obj_t BgL_nodez00_3429)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 214 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1590;

				BgL_nodez00_1590 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3429);
				{	/* Trace/walk.scm 215 */
					BgL_nodez00_bglt BgL_arg3635z00_2477;

					BgL_arg3635z00_2477 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1590))->BgL_bodyz00);
					{	/* Trace/walk.scm 215 */
						obj_t BgL_method3302z00_2480;

						{	/* Trace/walk.scm 215 */
							BgL_objectz00_bglt BgL_objz00_2481;

							BgL_objz00_2481 = (BgL_objectz00_bglt) (BgL_arg3635z00_2477);
							{	/* Trace/walk.scm 215 */
								long BgL_objzd2classzd2numz00_2482;

								BgL_objzd2classzd2numz00_2482 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2481);
								{	/* Trace/walk.scm 215 */
									obj_t BgL_arg2551z00_2483;

									BgL_arg2551z00_2483 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 215 */
										obj_t BgL_arrayz00_2485;

										int BgL_offsetz00_2486;

										BgL_arrayz00_2485 = BgL_arg2551z00_2483;
										BgL_offsetz00_2486 = (int) (BgL_objzd2classzd2numz00_2482);
										{	/* Trace/walk.scm 215 */
											long BgL_offsetz00_2487;

											BgL_offsetz00_2487 =
												((long) (BgL_offsetz00_2486) - OBJECT_TYPE);
											{	/* Trace/walk.scm 215 */
												long BgL_modz00_2488;

												{	/* Trace/walk.scm 215 */
													int BgL_arg2553z00_2489;

													BgL_arg2553z00_2489 = (int) (((long) 8));
													{	/* Trace/walk.scm 215 */
														long BgL_auxz00_4808;

														BgL_auxz00_4808 = (long) (BgL_arg2553z00_2489);
														BgL_modz00_2488 =
															(BgL_offsetz00_2487 / BgL_auxz00_4808);
												}}
												{	/* Trace/walk.scm 215 */
													long BgL_restz00_2490;

													{	/* Trace/walk.scm 215 */
														int BgL_arg2552z00_2491;

														BgL_arg2552z00_2491 = (int) (((long) 8));
														{	/* Trace/walk.scm 215 */
															long BgL_auxz00_4812;

															BgL_auxz00_4812 = (long) (BgL_arg2552z00_2491);
															BgL_restz00_2490 =
																(BgL_offsetz00_2487 % BgL_auxz00_4812);
													}}
													{	/* Trace/walk.scm 215 */

														BgL_method3302z00_2480 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2485,
																(int) (BgL_modz00_2488)),
															(int) (BgL_restz00_2490));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2480) (BgL_method3302z00_2480,
							(obj_t) (BgL_arg3635z00_2477), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-v3322 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2v3322z00zztrace_walkz00(obj_t
		BgL_envz00_3430, obj_t BgL_nodez00_3431)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 208 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1584;

				BgL_nodez00_1584 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3431);
				{	/* Trace/walk.scm 209 */
					BgL_nodez00_bglt BgL_arg3631z00_2449;

					BgL_arg3631z00_2449 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1584))->BgL_bodyz00);
					{	/* Trace/walk.scm 209 */
						obj_t BgL_method3302z00_2452;

						{	/* Trace/walk.scm 209 */
							BgL_objectz00_bglt BgL_objz00_2453;

							BgL_objz00_2453 = (BgL_objectz00_bglt) (BgL_arg3631z00_2449);
							{	/* Trace/walk.scm 209 */
								long BgL_objzd2classzd2numz00_2454;

								BgL_objzd2classzd2numz00_2454 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2453);
								{	/* Trace/walk.scm 209 */
									obj_t BgL_arg2551z00_2455;

									BgL_arg2551z00_2455 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 209 */
										obj_t BgL_arrayz00_2457;

										int BgL_offsetz00_2458;

										BgL_arrayz00_2457 = BgL_arg2551z00_2455;
										BgL_offsetz00_2458 = (int) (BgL_objzd2classzd2numz00_2454);
										{	/* Trace/walk.scm 209 */
											long BgL_offsetz00_2459;

											BgL_offsetz00_2459 =
												((long) (BgL_offsetz00_2458) - OBJECT_TYPE);
											{	/* Trace/walk.scm 209 */
												long BgL_modz00_2460;

												{	/* Trace/walk.scm 209 */
													int BgL_arg2553z00_2461;

													BgL_arg2553z00_2461 = (int) (((long) 8));
													{	/* Trace/walk.scm 209 */
														long BgL_auxz00_4832;

														BgL_auxz00_4832 = (long) (BgL_arg2553z00_2461);
														BgL_modz00_2460 =
															(BgL_offsetz00_2459 / BgL_auxz00_4832);
												}}
												{	/* Trace/walk.scm 209 */
													long BgL_restz00_2462;

													{	/* Trace/walk.scm 209 */
														int BgL_arg2552z00_2463;

														BgL_arg2552z00_2463 = (int) (((long) 8));
														{	/* Trace/walk.scm 209 */
															long BgL_auxz00_4836;

															BgL_auxz00_4836 = (long) (BgL_arg2552z00_2463);
															BgL_restz00_2462 =
																(BgL_offsetz00_2459 % BgL_auxz00_4836);
													}}
													{	/* Trace/walk.scm 209 */

														BgL_method3302z00_2452 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2457,
																(int) (BgL_modz00_2460)),
															(int) (BgL_restz00_2462));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2452) (BgL_method3302z00_2452,
							(obj_t) (BgL_arg3631z00_2449), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-selec3320 */
	obj_t BGl_findzd2lastzd2nodezd2selec3320zd2zztrace_walkz00(obj_t
		BgL_envz00_3432, obj_t BgL_nodez00_3433)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 199 */
			{
				BgL_selectz00_bglt BgL_nodez00_1572;

				BgL_nodez00_1572 = (BgL_selectz00_bglt) (BgL_nodez00_3433);
				{	/* Trace/walk.scm 201 */
					bool_t BgL_testz00_4847;

					{	/* Trace/walk.scm 201 */
						obj_t BgL_auxz00_4848;

						BgL_auxz00_4848 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1572))->BgL_clausesz00);
						BgL_testz00_4847 = PAIRP(BgL_auxz00_4848);
					}
					if (BgL_testz00_4847)
						{	/* Trace/walk.scm 202 */
							obj_t BgL_arg3625z00_1577;

							BgL_arg3625z00_1577 =
								CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1572))->
										BgL_clausesz00)));
							{	/* Trace/walk.scm 202 */
								BgL_nodez00_bglt BgL_nodez00_2422;

								BgL_nodez00_2422 = (BgL_nodez00_bglt) (BgL_arg3625z00_1577);
								{	/* Trace/walk.scm 202 */
									obj_t BgL_method3302z00_2423;

									{	/* Trace/walk.scm 202 */
										BgL_objectz00_bglt BgL_objz00_2424;

										BgL_objz00_2424 = (BgL_objectz00_bglt) (BgL_nodez00_2422);
										{	/* Trace/walk.scm 202 */
											long BgL_objzd2classzd2numz00_2425;

											BgL_objzd2classzd2numz00_2425 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2424);
											{	/* Trace/walk.scm 202 */
												obj_t BgL_arg2551z00_2426;

												BgL_arg2551z00_2426 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 202 */
													obj_t BgL_arrayz00_2428;

													int BgL_offsetz00_2429;

													BgL_arrayz00_2428 = BgL_arg2551z00_2426;
													BgL_offsetz00_2429 =
														(int) (BgL_objzd2classzd2numz00_2425);
													{	/* Trace/walk.scm 202 */
														long BgL_offsetz00_2430;

														BgL_offsetz00_2430 =
															((long) (BgL_offsetz00_2429) - OBJECT_TYPE);
														{	/* Trace/walk.scm 202 */
															long BgL_modz00_2431;

															{	/* Trace/walk.scm 202 */
																int BgL_arg2553z00_2432;

																BgL_arg2553z00_2432 = (int) (((long) 8));
																{	/* Trace/walk.scm 202 */
																	long BgL_auxz00_4863;

																	BgL_auxz00_4863 =
																		(long) (BgL_arg2553z00_2432);
																	BgL_modz00_2431 =
																		(BgL_offsetz00_2430 / BgL_auxz00_4863);
															}}
															{	/* Trace/walk.scm 202 */
																long BgL_restz00_2433;

																{	/* Trace/walk.scm 202 */
																	int BgL_arg2552z00_2434;

																	BgL_arg2552z00_2434 = (int) (((long) 8));
																	{	/* Trace/walk.scm 202 */
																		long BgL_auxz00_4867;

																		BgL_auxz00_4867 =
																			(long) (BgL_arg2552z00_2434);
																		BgL_restz00_2433 =
																			(BgL_offsetz00_2430 % BgL_auxz00_4867);
																}}
																{	/* Trace/walk.scm 202 */

																	BgL_method3302z00_2423 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2428,
																			(int) (BgL_modz00_2431)),
																		(int) (BgL_restz00_2433));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3302z00_2423)
										(BgL_method3302z00_2423, (obj_t) (BgL_nodez00_2422), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 201 */
							return
								BGl_findzd2lastzd2sexpz00zztrace_walkz00(
								(obj_t) (
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1572))->
										BgL_testz00)));
						}
				}
			}
		}
	}



/* find-last-node-fail3318 */
	obj_t BGl_findzd2lastzd2nodezd2fail3318zd2zztrace_walkz00(obj_t
		BgL_envz00_3434, obj_t BgL_nodez00_3435)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 193 */
			{
				BgL_failz00_bglt BgL_nodez00_1566;

				BgL_nodez00_1566 = (BgL_failz00_bglt) (BgL_nodez00_3435);
				{	/* Trace/walk.scm 194 */
					BgL_nodez00_bglt BgL_arg3622z00_2390;

					BgL_arg3622z00_2390 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1566))->BgL_objz00);
					{	/* Trace/walk.scm 194 */
						obj_t BgL_method3302z00_2393;

						{	/* Trace/walk.scm 194 */
							BgL_objectz00_bglt BgL_objz00_2394;

							BgL_objz00_2394 = (BgL_objectz00_bglt) (BgL_arg3622z00_2390);
							{	/* Trace/walk.scm 194 */
								long BgL_objzd2classzd2numz00_2395;

								BgL_objzd2classzd2numz00_2395 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2394);
								{	/* Trace/walk.scm 194 */
									obj_t BgL_arg2551z00_2396;

									BgL_arg2551z00_2396 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 194 */
										obj_t BgL_arrayz00_2398;

										int BgL_offsetz00_2399;

										BgL_arrayz00_2398 = BgL_arg2551z00_2396;
										BgL_offsetz00_2399 = (int) (BgL_objzd2classzd2numz00_2395);
										{	/* Trace/walk.scm 194 */
											long BgL_offsetz00_2400;

											BgL_offsetz00_2400 =
												((long) (BgL_offsetz00_2399) - OBJECT_TYPE);
											{	/* Trace/walk.scm 194 */
												long BgL_modz00_2401;

												{	/* Trace/walk.scm 194 */
													int BgL_arg2553z00_2402;

													BgL_arg2553z00_2402 = (int) (((long) 8));
													{	/* Trace/walk.scm 194 */
														long BgL_auxz00_4890;

														BgL_auxz00_4890 = (long) (BgL_arg2553z00_2402);
														BgL_modz00_2401 =
															(BgL_offsetz00_2400 / BgL_auxz00_4890);
												}}
												{	/* Trace/walk.scm 194 */
													long BgL_restz00_2403;

													{	/* Trace/walk.scm 194 */
														int BgL_arg2552z00_2404;

														BgL_arg2552z00_2404 = (int) (((long) 8));
														{	/* Trace/walk.scm 194 */
															long BgL_auxz00_4894;

															BgL_auxz00_4894 = (long) (BgL_arg2552z00_2404);
															BgL_restz00_2403 =
																(BgL_offsetz00_2400 % BgL_auxz00_4894);
													}}
													{	/* Trace/walk.scm 194 */

														BgL_method3302z00_2393 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2398,
																(int) (BgL_modz00_2401)),
															(int) (BgL_restz00_2403));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2393) (BgL_method3302z00_2393,
							(obj_t) (BgL_arg3622z00_2390), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-condi3316 */
	obj_t BGl_findzd2lastzd2nodezd2condi3316zd2zztrace_walkz00(obj_t
		BgL_envz00_3436, obj_t BgL_nodez00_3437)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 187 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1560;

				BgL_nodez00_1560 = (BgL_conditionalz00_bglt) (BgL_nodez00_3437);
				{	/* Trace/walk.scm 188 */
					BgL_nodez00_bglt BgL_arg3620z00_2362;

					BgL_arg3620z00_2362 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1560))->BgL_falsez00);
					{	/* Trace/walk.scm 188 */
						obj_t BgL_method3302z00_2365;

						{	/* Trace/walk.scm 188 */
							BgL_objectz00_bglt BgL_objz00_2366;

							BgL_objz00_2366 = (BgL_objectz00_bglt) (BgL_arg3620z00_2362);
							{	/* Trace/walk.scm 188 */
								long BgL_objzd2classzd2numz00_2367;

								BgL_objzd2classzd2numz00_2367 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2366);
								{	/* Trace/walk.scm 188 */
									obj_t BgL_arg2551z00_2368;

									BgL_arg2551z00_2368 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 188 */
										obj_t BgL_arrayz00_2370;

										int BgL_offsetz00_2371;

										BgL_arrayz00_2370 = BgL_arg2551z00_2368;
										BgL_offsetz00_2371 = (int) (BgL_objzd2classzd2numz00_2367);
										{	/* Trace/walk.scm 188 */
											long BgL_offsetz00_2372;

											BgL_offsetz00_2372 =
												((long) (BgL_offsetz00_2371) - OBJECT_TYPE);
											{	/* Trace/walk.scm 188 */
												long BgL_modz00_2373;

												{	/* Trace/walk.scm 188 */
													int BgL_arg2553z00_2374;

													BgL_arg2553z00_2374 = (int) (((long) 8));
													{	/* Trace/walk.scm 188 */
														long BgL_auxz00_4914;

														BgL_auxz00_4914 = (long) (BgL_arg2553z00_2374);
														BgL_modz00_2373 =
															(BgL_offsetz00_2372 / BgL_auxz00_4914);
												}}
												{	/* Trace/walk.scm 188 */
													long BgL_restz00_2375;

													{	/* Trace/walk.scm 188 */
														int BgL_arg2552z00_2376;

														BgL_arg2552z00_2376 = (int) (((long) 8));
														{	/* Trace/walk.scm 188 */
															long BgL_auxz00_4918;

															BgL_auxz00_4918 = (long) (BgL_arg2552z00_2376);
															BgL_restz00_2375 =
																(BgL_offsetz00_2372 % BgL_auxz00_4918);
													}}
													{	/* Trace/walk.scm 188 */

														BgL_method3302z00_2365 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2370,
																(int) (BgL_modz00_2373)),
															(int) (BgL_restz00_2375));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2365) (BgL_method3302z00_2365,
							(obj_t) (BgL_arg3620z00_2362), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-setq3314 */
	obj_t BGl_findzd2lastzd2nodezd2setq3314zd2zztrace_walkz00(obj_t
		BgL_envz00_3438, obj_t BgL_nodez00_3439)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 181 */
			{
				BgL_setqz00_bglt BgL_nodez00_1554;

				BgL_nodez00_1554 = (BgL_setqz00_bglt) (BgL_nodez00_3439);
				{	/* Trace/walk.scm 182 */
					BgL_nodez00_bglt BgL_arg3618z00_2334;

					BgL_arg3618z00_2334 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1554))->BgL_valuez00);
					{	/* Trace/walk.scm 182 */
						obj_t BgL_method3302z00_2337;

						{	/* Trace/walk.scm 182 */
							BgL_objectz00_bglt BgL_objz00_2338;

							BgL_objz00_2338 = (BgL_objectz00_bglt) (BgL_arg3618z00_2334);
							{	/* Trace/walk.scm 182 */
								long BgL_objzd2classzd2numz00_2339;

								BgL_objzd2classzd2numz00_2339 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2338);
								{	/* Trace/walk.scm 182 */
									obj_t BgL_arg2551z00_2340;

									BgL_arg2551z00_2340 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 182 */
										obj_t BgL_arrayz00_2342;

										int BgL_offsetz00_2343;

										BgL_arrayz00_2342 = BgL_arg2551z00_2340;
										BgL_offsetz00_2343 = (int) (BgL_objzd2classzd2numz00_2339);
										{	/* Trace/walk.scm 182 */
											long BgL_offsetz00_2344;

											BgL_offsetz00_2344 =
												((long) (BgL_offsetz00_2343) - OBJECT_TYPE);
											{	/* Trace/walk.scm 182 */
												long BgL_modz00_2345;

												{	/* Trace/walk.scm 182 */
													int BgL_arg2553z00_2346;

													BgL_arg2553z00_2346 = (int) (((long) 8));
													{	/* Trace/walk.scm 182 */
														long BgL_auxz00_4938;

														BgL_auxz00_4938 = (long) (BgL_arg2553z00_2346);
														BgL_modz00_2345 =
															(BgL_offsetz00_2344 / BgL_auxz00_4938);
												}}
												{	/* Trace/walk.scm 182 */
													long BgL_restz00_2347;

													{	/* Trace/walk.scm 182 */
														int BgL_arg2552z00_2348;

														BgL_arg2552z00_2348 = (int) (((long) 8));
														{	/* Trace/walk.scm 182 */
															long BgL_auxz00_4942;

															BgL_auxz00_4942 = (long) (BgL_arg2552z00_2348);
															BgL_restz00_2347 =
																(BgL_offsetz00_2344 % BgL_auxz00_4942);
													}}
													{	/* Trace/walk.scm 182 */

														BgL_method3302z00_2337 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2342,
																(int) (BgL_modz00_2345)),
															(int) (BgL_restz00_2347));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2337) (BgL_method3302z00_2337,
							(obj_t) (BgL_arg3618z00_2334), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-exter3312 */
	obj_t BGl_findzd2lastzd2nodezd2exter3312zd2zztrace_walkz00(obj_t
		BgL_envz00_3440, obj_t BgL_nodez00_3441)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 172 */
			{
				BgL_externz00_bglt BgL_nodez00_1543;

				BgL_nodez00_1543 = (BgL_externz00_bglt) (BgL_nodez00_3441);
				{	/* Trace/walk.scm 174 */
					bool_t BgL_testz00_4953;

					{	/* Trace/walk.scm 174 */
						obj_t BgL_auxz00_4954;

						BgL_auxz00_4954 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1543))->BgL_exprza2za2);
						BgL_testz00_4953 = PAIRP(BgL_auxz00_4954);
					}
					if (BgL_testz00_4953)
						{	/* Trace/walk.scm 175 */
							obj_t BgL_arg3613z00_1548;

							BgL_arg3613z00_1548 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_externz00_bglt) CREF(BgL_nodez00_1543))->
										BgL_exprza2za2)));
							{	/* Trace/walk.scm 175 */
								BgL_nodez00_bglt BgL_nodez00_2308;

								BgL_nodez00_2308 = (BgL_nodez00_bglt) (BgL_arg3613z00_1548);
								{	/* Trace/walk.scm 175 */
									obj_t BgL_method3302z00_2309;

									{	/* Trace/walk.scm 175 */
										BgL_objectz00_bglt BgL_objz00_2310;

										BgL_objz00_2310 = (BgL_objectz00_bglt) (BgL_nodez00_2308);
										{	/* Trace/walk.scm 175 */
											long BgL_objzd2classzd2numz00_2311;

											BgL_objzd2classzd2numz00_2311 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2310);
											{	/* Trace/walk.scm 175 */
												obj_t BgL_arg2551z00_2312;

												BgL_arg2551z00_2312 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 175 */
													obj_t BgL_arrayz00_2314;

													int BgL_offsetz00_2315;

													BgL_arrayz00_2314 = BgL_arg2551z00_2312;
													BgL_offsetz00_2315 =
														(int) (BgL_objzd2classzd2numz00_2311);
													{	/* Trace/walk.scm 175 */
														long BgL_offsetz00_2316;

														BgL_offsetz00_2316 =
															((long) (BgL_offsetz00_2315) - OBJECT_TYPE);
														{	/* Trace/walk.scm 175 */
															long BgL_modz00_2317;

															{	/* Trace/walk.scm 175 */
																int BgL_arg2553z00_2318;

																BgL_arg2553z00_2318 = (int) (((long) 8));
																{	/* Trace/walk.scm 175 */
																	long BgL_auxz00_4969;

																	BgL_auxz00_4969 =
																		(long) (BgL_arg2553z00_2318);
																	BgL_modz00_2317 =
																		(BgL_offsetz00_2316 / BgL_auxz00_4969);
															}}
															{	/* Trace/walk.scm 175 */
																long BgL_restz00_2319;

																{	/* Trace/walk.scm 175 */
																	int BgL_arg2552z00_2320;

																	BgL_arg2552z00_2320 = (int) (((long) 8));
																	{	/* Trace/walk.scm 175 */
																		long BgL_auxz00_4973;

																		BgL_auxz00_4973 =
																			(long) (BgL_arg2552z00_2320);
																		BgL_restz00_2319 =
																			(BgL_offsetz00_2316 % BgL_auxz00_4973);
																}}
																{	/* Trace/walk.scm 175 */

																	BgL_method3302z00_2309 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2314,
																			(int) (BgL_modz00_2317)),
																		(int) (BgL_restz00_2319));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3302z00_2309)
										(BgL_method3302z00_2309, (obj_t) (BgL_nodez00_2308), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 174 */
							return (obj_t) (BgL_nodez00_1543);
						}
				}
			}
		}
	}



/* find-last-node-funca3310 */
	obj_t BGl_findzd2lastzd2nodezd2funca3310zd2zztrace_walkz00(obj_t
		BgL_envz00_3442, obj_t BgL_nodez00_3443)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 163 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1531;

				BgL_nodez00_1531 = (BgL_funcallz00_bglt) (BgL_nodez00_3443);
				{	/* Trace/walk.scm 165 */
					bool_t BgL_testz00_4985;

					{	/* Trace/walk.scm 165 */
						obj_t BgL_auxz00_4986;

						BgL_auxz00_4986 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1531))->BgL_argsz00);
						BgL_testz00_4985 = PAIRP(BgL_auxz00_4986);
					}
					if (BgL_testz00_4985)
						{	/* Trace/walk.scm 166 */
							obj_t BgL_arg3606z00_1536;

							BgL_arg3606z00_1536 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1531))->
										BgL_argsz00)));
							{	/* Trace/walk.scm 166 */
								BgL_nodez00_bglt BgL_nodez00_2251;

								BgL_nodez00_2251 = (BgL_nodez00_bglt) (BgL_arg3606z00_1536);
								{	/* Trace/walk.scm 166 */
									obj_t BgL_method3302z00_2252;

									{	/* Trace/walk.scm 166 */
										BgL_objectz00_bglt BgL_objz00_2253;

										BgL_objz00_2253 = (BgL_objectz00_bglt) (BgL_nodez00_2251);
										{	/* Trace/walk.scm 166 */
											long BgL_objzd2classzd2numz00_2254;

											BgL_objzd2classzd2numz00_2254 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2253);
											{	/* Trace/walk.scm 166 */
												obj_t BgL_arg2551z00_2255;

												BgL_arg2551z00_2255 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 166 */
													obj_t BgL_arrayz00_2257;

													int BgL_offsetz00_2258;

													BgL_arrayz00_2257 = BgL_arg2551z00_2255;
													BgL_offsetz00_2258 =
														(int) (BgL_objzd2classzd2numz00_2254);
													{	/* Trace/walk.scm 166 */
														long BgL_offsetz00_2259;

														BgL_offsetz00_2259 =
															((long) (BgL_offsetz00_2258) - OBJECT_TYPE);
														{	/* Trace/walk.scm 166 */
															long BgL_modz00_2260;

															{	/* Trace/walk.scm 166 */
																int BgL_arg2553z00_2261;

																BgL_arg2553z00_2261 = (int) (((long) 8));
																{	/* Trace/walk.scm 166 */
																	long BgL_auxz00_5001;

																	BgL_auxz00_5001 =
																		(long) (BgL_arg2553z00_2261);
																	BgL_modz00_2260 =
																		(BgL_offsetz00_2259 / BgL_auxz00_5001);
															}}
															{	/* Trace/walk.scm 166 */
																long BgL_restz00_2262;

																{	/* Trace/walk.scm 166 */
																	int BgL_arg2552z00_2263;

																	BgL_arg2552z00_2263 = (int) (((long) 8));
																	{	/* Trace/walk.scm 166 */
																		long BgL_auxz00_5005;

																		BgL_auxz00_5005 =
																			(long) (BgL_arg2552z00_2263);
																		BgL_restz00_2262 =
																			(BgL_offsetz00_2259 % BgL_auxz00_5005);
																}}
																{	/* Trace/walk.scm 166 */

																	BgL_method3302z00_2252 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2257,
																			(int) (BgL_modz00_2260)),
																		(int) (BgL_restz00_2262));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3302z00_2252)
										(BgL_method3302z00_2252, (obj_t) (BgL_nodez00_2251), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 167 */
							BgL_nodez00_bglt BgL_arg3609z00_1539;

							BgL_arg3609z00_1539 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1531))->BgL_funz00);
							{	/* Trace/walk.scm 167 */
								obj_t BgL_method3302z00_2279;

								{	/* Trace/walk.scm 167 */
									BgL_objectz00_bglt BgL_objz00_2280;

									BgL_objz00_2280 = (BgL_objectz00_bglt) (BgL_arg3609z00_1539);
									{	/* Trace/walk.scm 167 */
										long BgL_objzd2classzd2numz00_2281;

										BgL_objzd2classzd2numz00_2281 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2280);
										{	/* Trace/walk.scm 167 */
											obj_t BgL_arg2551z00_2282;

											BgL_arg2551z00_2282 =
												PROCEDURE_REF
												(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 167 */
												obj_t BgL_arrayz00_2284;

												int BgL_offsetz00_2285;

												BgL_arrayz00_2284 = BgL_arg2551z00_2282;
												BgL_offsetz00_2285 =
													(int) (BgL_objzd2classzd2numz00_2281);
												{	/* Trace/walk.scm 167 */
													long BgL_offsetz00_2286;

													BgL_offsetz00_2286 =
														((long) (BgL_offsetz00_2285) - OBJECT_TYPE);
													{	/* Trace/walk.scm 167 */
														long BgL_modz00_2287;

														{	/* Trace/walk.scm 167 */
															int BgL_arg2553z00_2288;

															BgL_arg2553z00_2288 = (int) (((long) 8));
															{	/* Trace/walk.scm 167 */
																long BgL_auxz00_5024;

																BgL_auxz00_5024 = (long) (BgL_arg2553z00_2288);
																BgL_modz00_2287 =
																	(BgL_offsetz00_2286 / BgL_auxz00_5024);
														}}
														{	/* Trace/walk.scm 167 */
															long BgL_restz00_2289;

															{	/* Trace/walk.scm 167 */
																int BgL_arg2552z00_2290;

																BgL_arg2552z00_2290 = (int) (((long) 8));
																{	/* Trace/walk.scm 167 */
																	long BgL_auxz00_5028;

																	BgL_auxz00_5028 =
																		(long) (BgL_arg2552z00_2290);
																	BgL_restz00_2289 =
																		(BgL_offsetz00_2286 % BgL_auxz00_5028);
															}}
															{	/* Trace/walk.scm 167 */

																BgL_method3302z00_2279 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2284,
																		(int) (BgL_modz00_2287)),
																	(int) (BgL_restz00_2289));
								}}}}}}}}
								return
									PROCEDURE_ENTRY(BgL_method3302z00_2279)
									(BgL_method3302z00_2279, (obj_t) (BgL_arg3609z00_1539), BEOA);
							}
						}
				}
			}
		}
	}



/* find-last-node-app-l3308 */
	obj_t BGl_findzd2lastzd2nodezd2appzd2l3308z00zztrace_walkz00(obj_t
		BgL_envz00_3444, obj_t BgL_nodez00_3445)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 157 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1525;

				BgL_nodez00_1525 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3445);
				{	/* Trace/walk.scm 158 */
					BgL_nodez00_bglt BgL_arg3603z00_2219;

					BgL_arg3603z00_2219 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1525))->BgL_argz00);
					{	/* Trace/walk.scm 158 */
						obj_t BgL_method3302z00_2222;

						{	/* Trace/walk.scm 158 */
							BgL_objectz00_bglt BgL_objz00_2223;

							BgL_objz00_2223 = (BgL_objectz00_bglt) (BgL_arg3603z00_2219);
							{	/* Trace/walk.scm 158 */
								long BgL_objzd2classzd2numz00_2224;

								BgL_objzd2classzd2numz00_2224 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2223);
								{	/* Trace/walk.scm 158 */
									obj_t BgL_arg2551z00_2225;

									BgL_arg2551z00_2225 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 158 */
										obj_t BgL_arrayz00_2227;

										int BgL_offsetz00_2228;

										BgL_arrayz00_2227 = BgL_arg2551z00_2225;
										BgL_offsetz00_2228 = (int) (BgL_objzd2classzd2numz00_2224);
										{	/* Trace/walk.scm 158 */
											long BgL_offsetz00_2229;

											BgL_offsetz00_2229 =
												((long) (BgL_offsetz00_2228) - OBJECT_TYPE);
											{	/* Trace/walk.scm 158 */
												long BgL_modz00_2230;

												{	/* Trace/walk.scm 158 */
													int BgL_arg2553z00_2231;

													BgL_arg2553z00_2231 = (int) (((long) 8));
													{	/* Trace/walk.scm 158 */
														long BgL_auxz00_5048;

														BgL_auxz00_5048 = (long) (BgL_arg2553z00_2231);
														BgL_modz00_2230 =
															(BgL_offsetz00_2229 / BgL_auxz00_5048);
												}}
												{	/* Trace/walk.scm 158 */
													long BgL_restz00_2232;

													{	/* Trace/walk.scm 158 */
														int BgL_arg2552z00_2233;

														BgL_arg2552z00_2233 = (int) (((long) 8));
														{	/* Trace/walk.scm 158 */
															long BgL_auxz00_5052;

															BgL_auxz00_5052 = (long) (BgL_arg2552z00_2233);
															BgL_restz00_2232 =
																(BgL_offsetz00_2229 % BgL_auxz00_5052);
													}}
													{	/* Trace/walk.scm 158 */

														BgL_method3302z00_2222 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2227,
																(int) (BgL_modz00_2230)),
															(int) (BgL_restz00_2232));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3302z00_2222) (BgL_method3302z00_2222,
							(obj_t) (BgL_arg3603z00_2219), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-app3306 */
	obj_t BGl_findzd2lastzd2nodezd2app3306zd2zztrace_walkz00(obj_t
		BgL_envz00_3446, obj_t BgL_nodez00_3447)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 148 */
			{
				BgL_appz00_bglt BgL_nodez00_1514;

				BgL_nodez00_1514 = (BgL_appz00_bglt) (BgL_nodez00_3447);
				{	/* Trace/walk.scm 150 */
					bool_t BgL_testz00_5063;

					{	/* Trace/walk.scm 150 */
						obj_t BgL_auxz00_5064;

						BgL_auxz00_5064 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1514))->BgL_argsz00);
						BgL_testz00_5063 = PAIRP(BgL_auxz00_5064);
					}
					if (BgL_testz00_5063)
						{	/* Trace/walk.scm 151 */
							obj_t BgL_arg3598z00_1519;

							BgL_arg3598z00_1519 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_appz00_bglt) CREF(BgL_nodez00_1514))->BgL_argsz00)));
							{	/* Trace/walk.scm 151 */
								BgL_nodez00_bglt BgL_nodez00_2193;

								BgL_nodez00_2193 = (BgL_nodez00_bglt) (BgL_arg3598z00_1519);
								{	/* Trace/walk.scm 151 */
									obj_t BgL_method3302z00_2194;

									{	/* Trace/walk.scm 151 */
										BgL_objectz00_bglt BgL_objz00_2195;

										BgL_objz00_2195 = (BgL_objectz00_bglt) (BgL_nodez00_2193);
										{	/* Trace/walk.scm 151 */
											long BgL_objzd2classzd2numz00_2196;

											BgL_objzd2classzd2numz00_2196 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2195);
											{	/* Trace/walk.scm 151 */
												obj_t BgL_arg2551z00_2197;

												BgL_arg2551z00_2197 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 151 */
													obj_t BgL_arrayz00_2199;

													int BgL_offsetz00_2200;

													BgL_arrayz00_2199 = BgL_arg2551z00_2197;
													BgL_offsetz00_2200 =
														(int) (BgL_objzd2classzd2numz00_2196);
													{	/* Trace/walk.scm 151 */
														long BgL_offsetz00_2201;

														BgL_offsetz00_2201 =
															((long) (BgL_offsetz00_2200) - OBJECT_TYPE);
														{	/* Trace/walk.scm 151 */
															long BgL_modz00_2202;

															{	/* Trace/walk.scm 151 */
																int BgL_arg2553z00_2203;

																BgL_arg2553z00_2203 = (int) (((long) 8));
																{	/* Trace/walk.scm 151 */
																	long BgL_auxz00_5079;

																	BgL_auxz00_5079 =
																		(long) (BgL_arg2553z00_2203);
																	BgL_modz00_2202 =
																		(BgL_offsetz00_2201 / BgL_auxz00_5079);
															}}
															{	/* Trace/walk.scm 151 */
																long BgL_restz00_2204;

																{	/* Trace/walk.scm 151 */
																	int BgL_arg2552z00_2205;

																	BgL_arg2552z00_2205 = (int) (((long) 8));
																	{	/* Trace/walk.scm 151 */
																		long BgL_auxz00_5083;

																		BgL_auxz00_5083 =
																			(long) (BgL_arg2552z00_2205);
																		BgL_restz00_2204 =
																			(BgL_offsetz00_2201 % BgL_auxz00_5083);
																}}
																{	/* Trace/walk.scm 151 */

																	BgL_method3302z00_2194 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2199,
																			(int) (BgL_modz00_2202)),
																		(int) (BgL_restz00_2204));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3302z00_2194)
										(BgL_method3302z00_2194, (obj_t) (BgL_nodez00_2193), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 150 */
							return (obj_t) (BgL_nodez00_1514);
						}
				}
			}
		}
	}



/* find-last-node-seque3304 */
	obj_t BGl_findzd2lastzd2nodezd2seque3304zd2zztrace_walkz00(obj_t
		BgL_envz00_3448, obj_t BgL_nodez00_3449)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 139 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1503;

				BgL_nodez00_1503 = (BgL_sequencez00_bglt) (BgL_nodez00_3449);
				{	/* Trace/walk.scm 141 */
					bool_t BgL_testz00_5095;

					{	/* Trace/walk.scm 141 */
						obj_t BgL_auxz00_5096;

						BgL_auxz00_5096 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1503))->BgL_nodesz00);
						BgL_testz00_5095 = PAIRP(BgL_auxz00_5096);
					}
					if (BgL_testz00_5095)
						{	/* Trace/walk.scm 142 */
							obj_t BgL_arg3592z00_1508;

							BgL_arg3592z00_1508 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1503))->
										BgL_nodesz00)));
							{	/* Trace/walk.scm 142 */
								BgL_nodez00_bglt BgL_nodez00_2163;

								BgL_nodez00_2163 = (BgL_nodez00_bglt) (BgL_arg3592z00_1508);
								{	/* Trace/walk.scm 142 */
									obj_t BgL_method3302z00_2164;

									{	/* Trace/walk.scm 142 */
										BgL_objectz00_bglt BgL_objz00_2165;

										BgL_objz00_2165 = (BgL_objectz00_bglt) (BgL_nodez00_2163);
										{	/* Trace/walk.scm 142 */
											long BgL_objzd2classzd2numz00_2166;

											BgL_objzd2classzd2numz00_2166 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2165);
											{	/* Trace/walk.scm 142 */
												obj_t BgL_arg2551z00_2167;

												BgL_arg2551z00_2167 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 142 */
													obj_t BgL_arrayz00_2169;

													int BgL_offsetz00_2170;

													BgL_arrayz00_2169 = BgL_arg2551z00_2167;
													BgL_offsetz00_2170 =
														(int) (BgL_objzd2classzd2numz00_2166);
													{	/* Trace/walk.scm 142 */
														long BgL_offsetz00_2171;

														BgL_offsetz00_2171 =
															((long) (BgL_offsetz00_2170) - OBJECT_TYPE);
														{	/* Trace/walk.scm 142 */
															long BgL_modz00_2172;

															{	/* Trace/walk.scm 142 */
																int BgL_arg2553z00_2173;

																BgL_arg2553z00_2173 = (int) (((long) 8));
																{	/* Trace/walk.scm 142 */
																	long BgL_auxz00_5111;

																	BgL_auxz00_5111 =
																		(long) (BgL_arg2553z00_2173);
																	BgL_modz00_2172 =
																		(BgL_offsetz00_2171 / BgL_auxz00_5111);
															}}
															{	/* Trace/walk.scm 142 */
																long BgL_restz00_2174;

																{	/* Trace/walk.scm 142 */
																	int BgL_arg2552z00_2175;

																	BgL_arg2552z00_2175 = (int) (((long) 8));
																	{	/* Trace/walk.scm 142 */
																		long BgL_auxz00_5115;

																		BgL_auxz00_5115 =
																			(long) (BgL_arg2552z00_2175);
																		BgL_restz00_2174 =
																			(BgL_offsetz00_2171 % BgL_auxz00_5115);
																}}
																{	/* Trace/walk.scm 142 */

																	BgL_method3302z00_2164 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2169,
																			(int) (BgL_modz00_2172)),
																		(int) (BgL_restz00_2174));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3302z00_2164)
										(BgL_method3302z00_2164, (obj_t) (BgL_nodez00_2163), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 141 */
							return (obj_t) (BgL_nodez00_1503);
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 216344604),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 498112980),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 80496154),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 476150904),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3903z00zztrace_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
