/*===========================================================================*/
/*   (Unsafe/bignumber.scm)                                                  */
/*   Bigloo (3.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 1 12:14:45 CEST 2010        */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -srfi bigloo-unsafe -O3 -q +rm -lib-dir /users/serrano/prgm/project/bigloo/lib/3.4a -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Unsafe/bignumber.scm -indent -o objs/obj_u/Unsafe/bignumber.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

/* User header */
#if( BGL_HAVE_GMP == 0 )
#ifdef __cplusplus
extern "C"
{
#endif
	BGL_EXPORTED_DECL obj_t bgl_bignum_lcm(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_bignum_add(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_long_to_bignum(long);
	BGL_EXPORTED_DECL obj_t bgl_seed_rand(long);
	BGL_EXPORTED_DECL bool_t BXPOSITIVE(obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	BGL_EXPORTED_DECL bool_t bgl_bignum_odd(obj_t);
	static obj_t BGl_symbol3165z00zz__bignumz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t bgl_bignum_remainder(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__bignumz00 = BUNSPEC;
	extern bool_t BGl_evenzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_genericzd2initzd2zz__bignumz00();
	static obj_t BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00(obj_t);
	BGL_EXPORTED_DECL obj_t bgl_bignum_sub(obj_t, obj_t);
	static obj_t BGl__z42elongzd2ze3bignumz73zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42fixnumzd2ze3bignumz73zz__bignumz00(obj_t, obj_t);
	extern obj_t BGl_moduloz00zz__r4_numbers_6_5_fixnumz00(obj_t, obj_t);
	static obj_t BGl__z42za7erobxzf3z16zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42negativebxzf3zb1zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_bignum_gcd(obj_t, obj_t);
	static obj_t BGl__z42bignumzd2cmpz90zz__bignumz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2u16vectorzd2zz__srfi4z00(long, obj_t);
	extern long BGl_stringzd2ze3integerz31zz__r4_numbers_6_5_fixnumz00(obj_t,
		obj_t);
	extern obj_t BGl_quotientz00zz__r4_numbers_6_5_fixnumz00(obj_t, obj_t);
	static obj_t BGl_convertz00zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl_makezd2randomzd2u8vectorz00zz__bignumz00(obj_t);
	BGL_EXPORTED_DECL double bgl_bignum_to_flonum(obj_t);
	extern obj_t BGl_assvz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_bignum_abs(obj_t);
	static obj_t BGl_cnstzd2initzd2zz__bignumz00();
	static obj_t BGl_preallocatedzd2bignumszd2zz__bignumz00 = BUNSPEC;
	static bool_t BGl_z42zc3bxz81zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BXNEGATIVE(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__bignumz00();
	static obj_t BGl_z42fixnumzd2ze3bignumzd2freshza1zz__bignumz00(long);
	BGL_EXPORTED_DECL obj_t bgl_elong_to_bignum(long);
	static obj_t BGl__z42negbxz42zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__czd2bignumzd2ze3stringze3zz__bignumz00(obj_t, obj_t, obj_t);
	extern obj_t bgl_make_bignum(obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static long BGl_bignumzd2integerzd2lengthz00zz__bignumz00(obj_t);
	static obj_t BGl_bignumzd2ze3fixnumzd2listze3zz__bignumz00(obj_t, long);
	BGL_EXPORTED_DECL obj_t bgl_string_to_bignum(char *, int);
	static obj_t BGl_bignumzd2subzd2nonnegz00zz__bignumz00(obj_t, obj_t);
	static obj_t BGl_bignumzd2signzd2setz12z12zz__bignumz00(obj_t, int);
	static obj_t BGl__z42bignumzd2ze3flonumz73zz__bignumz00(obj_t, obj_t);
	static obj_t BGl_bignumzd2za7eroz75zz__bignumz00 = BUNSPEC;
	BGL_EXPORTED_DECL long bgl_bignum_to_long(obj_t);
	static obj_t BGl__z42randbxz42zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_flonum_to_bignum(double);
	static obj_t BGl__z42divrembxz42zz__bignumz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zz__bignumz00();
	static obj_t BGl_bignumzd2addzd2nonnegz00zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42oddbxzf3zb1zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t bgl_bignum_even(obj_t);
	static obj_t BGl__z42stringzd2ze3bignumz73zz__bignumz00(obj_t, obj_t, obj_t);
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl__z42lcmbxz42zz__bignumz00(obj_t, obj_t, obj_t);
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl__z42za2bxze0zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl__z42bignumzd2ze3fixnumz73zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42flonumzd2ze3bignumz73zz__bignumz00(obj_t, obj_t);
	static obj_t BGl_bignumzd2sum2zd2zz__bignumz00(obj_t, obj_t, unsigned short,
		obj_t);
	static obj_t BGl_list3174z00zz__bignumz00 = BUNSPEC;
	extern obj_t BGl_memvz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_list3177z00zz__bignumz00 = BUNSPEC;
	static obj_t BGl_list3178z00zz__bignumz00 = BUNSPEC;
	static obj_t BGl_list3180z00zz__bignumz00 = BUNSPEC;
	static obj_t BGl_list3179z00zz__bignumz00 = BUNSPEC;
	static obj_t BGl_list3181z00zz__bignumz00 = BUNSPEC;
	static obj_t BGl_list3182z00zz__bignumz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t bgl_bignum_quotient(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_string_to_integer_obj(char *, long);
	extern obj_t string_to_bstring(char *);
	static unsigned short BGl_bignumzd2signzd2zz__bignumz00(obj_t);
	static obj_t BGl__z42zb2bxzf0zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl__z42llongzd2ze3bignumz73zz__bignumz00(obj_t, obj_t);
	static long BGl_bignumzd2minzd2fixnumzd2divzd2radixz00zz__bignumz00();
	static obj_t BGl__z42stringzd2ze3integerzd2objza1zz__bignumz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__z42seedzd2randz90zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_bignum_neg(obj_t);
	static obj_t BGl_bignumzd2shrinkzd2zz__bignumz00(obj_t, long);
	extern long BGl_modulofxz00zz__r4_numbers_6_5_fixnumz00(long, long);
	static obj_t BGl__z42evenbxzf3zb1zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42zd2bxz90zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl__z42gcdbxz42zz__bignumz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2u8vectorzd2zz__srfi4z00(long, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_bignumzd2divzd2zz__bignumz00(obj_t, obj_t);
	static obj_t BGl__z42absbxz42zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t bgl_llong_to_bignum(BGL_LONGLONG_T);
	BGL_EXPORTED_DECL obj_t bgl_bignum_to_string(obj_t, long);
	BGL_EXPORTED_DECL obj_t bgl_bignum_mul(obj_t, obj_t);
	static obj_t BGl__z42positivebxzf3zb1zz__bignumz00(obj_t, obj_t);
	BGL_EXPORTED_DECL int bgl_bignum_cmp(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BXZERO(obj_t);
	static long BGl_bignumzd2lengthzd2zz__bignumz00(obj_t);
	static obj_t BGl__z42remainderbxz42zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl_fixnumzd2listzd2ze3bignumze3zz__bignumz00(obj_t, long);
	BGL_EXPORTED_DECL obj_t bgl_bignum_div(obj_t, obj_t);
	extern obj_t BGl_u8vectorzd2ze3listz31zz__srfi4z00(obj_t);
	extern obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_methodzd2initzd2zz__bignumz00();
	BGL_EXPORTED_DECL obj_t bgl_rand_bignum(obj_t);
	static obj_t BGl__z42quotientbxz42zz__bignumz00(obj_t, obj_t, obj_t);
	static obj_t BGl_bignumzd2exptzd2zz__bignumz00(obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42absbxzd2envz90zz__bignumz00,
		BgL_bgl__za742absbxza742za7za7__3192z00, BGl__z42absbxz42zz__bignumz00, 0L,
		BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42llongzd2ze3bignumzd2envza1zz__bignumz00,
		BgL_bgl__za742llongza7d2za7e3b3193za7,
		BGl__z42llongzd2ze3bignumz73zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42oddbxzf3zd2envz63zz__bignumz00,
		BgL_bgl__za742oddbxza7f3za7b1za73194z00, BGl__z42oddbxzf3zb1zz__bignumz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42flonumzd2ze3bignumzd2envza1zz__bignumz00,
		BgL_bgl__za742flonumza7d2za7e33195za7,
		BGl__z42flonumzd2ze3bignumz73zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42positivebxzf3zd2envz63zz__bignumz00,
		BgL_bgl__za742positivebxza7f3196z00, BGl__z42positivebxzf3zb1zz__bignumz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42seedzd2randzd2envz42zz__bignumz00,
		BgL_bgl__za742seedza7d2randza73197za7, BGl__z42seedzd2randz90zz__bignumz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42bignumzd2cmpzd2envz42zz__bignumz00,
		BgL_bgl__za742bignumza7d2cmp3198z00, BGl__z42bignumzd2cmpz90zz__bignumz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42bignumzd2ze3fixnumzd2envza1zz__bignumz00,
		BgL_bgl__za742bignumza7d2za7e33199za7,
		BGl__z42bignumzd2ze3fixnumz73zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42za7erobxzf3zd2envzc4zz__bignumz00,
		BgL_bgl__za742za7a7erobxza7f3za73200z00,
		BGl__z42za7erobxzf3z16zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42negbxzd2envz90zz__bignumz00,
		BgL_bgl__za742negbxza742za7za7__3201z00, BGl__z42negbxz42zz__bignumz00, 0L,
		BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3145z00zz__bignumz00,
		BgL_bgl_string3145za700za7za7_3202za7, "_$string->integer-obj", 21);
	      DEFINE_STRING(BGl_string3146z00zz__bignumz00,
		BgL_bgl_string3146za700za7za7_3203za7, "string", 6);
	      DEFINE_STRING(BGl_string3147z00zz__bignumz00,
		BgL_bgl_string3147za700za7za7_3204za7,
		"/tmp/bigloo/runtime/Unsafe/bignumber.scm", 40);
	      DEFINE_STRING(BGl_string3148z00zz__bignumz00,
		BgL_bgl_string3148za700za7za7_3205za7, "long", 4);
	      DEFINE_STRING(BGl_string3150z00zz__bignumz00,
		BgL_bgl_string3150za700za7za7_3206za7, "elong", 5);
	      DEFINE_STRING(BGl_string3149z00zz__bignumz00,
		BgL_bgl_string3149za700za7za7_3207za7, "_$elong->bignum", 15);
	      DEFINE_STRING(BGl_string3151z00zz__bignumz00,
		BgL_bgl_string3151za700za7za7_3208za7, "_$llong->bignum", 15);
	      DEFINE_STRING(BGl_string3152z00zz__bignumz00,
		BgL_bgl_string3152za700za7za7_3209za7, "llong", 5);
	      DEFINE_STRING(BGl_string3153z00zz__bignumz00,
		BgL_bgl_string3153za700za7za7_3210za7, "_$fixnum->bignum", 16);
	      DEFINE_STRING(BGl_string3154z00zz__bignumz00,
		BgL_bgl_string3154za700za7za7_3211za7, "_$zerobx?", 9);
	      DEFINE_STRING(BGl_string3155z00zz__bignumz00,
		BgL_bgl_string3155za700za7za7_3212za7, "bignum", 6);
	      DEFINE_STRING(BGl_string3156z00zz__bignumz00,
		BgL_bgl_string3156za700za7za7_3213za7, "_$negativebx?", 13);
	      DEFINE_STRING(BGl_string3157z00zz__bignumz00,
		BgL_bgl_string3157za700za7za7_3214za7, "_$positivebx?", 13);
	      DEFINE_STRING(BGl_string3158z00zz__bignumz00,
		BgL_bgl_string3158za700za7za7_3215za7, "_$evenbx?", 9);
	      DEFINE_STRING(BGl_string3160z00zz__bignumz00,
		BgL_bgl_string3160za700za7za7_3216za7, "_$bignum-cmp", 12);
	      DEFINE_STRING(BGl_string3159z00zz__bignumz00,
		BgL_bgl_string3159za700za7za7_3217za7, "_$oddbx?", 8);
	      DEFINE_STRING(BGl_string3161z00zz__bignumz00,
		BgL_bgl_string3161za700za7za7_3218za7, "_$+bx", 5);
	      DEFINE_STRING(BGl_string3162z00zz__bignumz00,
		BgL_bgl_string3162za700za7za7_3219za7, "_$-bx", 5);
	      DEFINE_STRING(BGl_string3163z00zz__bignumz00,
		BgL_bgl_string3163za700za7za7_3220za7, "_$negbx", 7);
	      DEFINE_STRING(BGl_string3164z00zz__bignumz00,
		BgL_bgl_string3164za700za7za7_3221za7, "_$*bx", 5);
	      DEFINE_STRING(BGl_string3166z00zz__bignumz00,
		BgL_bgl_string3166za700za7za7_3222za7, "/bx", 3);
	      DEFINE_STRING(BGl_string3167z00zz__bignumz00,
		BgL_bgl_string3167za700za7za7_3223za7, "divide by zero", 14);
	      DEFINE_STRING(BGl_string3168z00zz__bignumz00,
		BgL_bgl_string3168za700za7za7_3224za7, "_$divrembx", 10);
	      DEFINE_STRING(BGl_string3170z00zz__bignumz00,
		BgL_bgl_string3170za700za7za7_3225za7, "_$remainderbx", 13);
	      DEFINE_STRING(BGl_string3169z00zz__bignumz00,
		BgL_bgl_string3169za700za7za7_3226za7, "_$quotientbx", 12);
	      DEFINE_STRING(BGl_string3171z00zz__bignumz00,
		BgL_bgl_string3171za700za7za7_3227za7, "_$absbx", 7);
	      DEFINE_STRING(BGl_string3172z00zz__bignumz00,
		BgL_bgl_string3172za700za7za7_3228za7, "_$gcdbx", 7);
	      DEFINE_STRING(BGl_string3173z00zz__bignumz00,
		BgL_bgl_string3173za700za7za7_3229za7, "_$lcmbx", 7);
	      DEFINE_STRING(BGl_string3175z00zz__bignumz00,
		BgL_bgl_string3175za700za7za7_3230za7,
		"0123456789abcdefghijklmnopqrstuvwxyz", 36);
	      DEFINE_STRING(BGl_string3176z00zz__bignumz00,
		BgL_bgl_string3176za700za7za7_3231za7, "_c-bignum->string", 17);
	      DEFINE_STRING(BGl_string3183z00zz__bignumz00,
		BgL_bgl_string3183za700za7za7_3232za7, "_$string->bignum", 16);
	      DEFINE_STRING(BGl_string3184z00zz__bignumz00,
		BgL_bgl_string3184za700za7za7_3233za7, "int", 3);
	      DEFINE_STRING(BGl_string3185z00zz__bignumz00,
		BgL_bgl_string3185za700za7za7_3234za7, "_$bignum->fixnum", 16);
	      DEFINE_STRING(BGl_string3186z00zz__bignumz00,
		BgL_bgl_string3186za700za7za7_3235za7, "_$seed-rand", 11);
	      DEFINE_STRING(BGl_string3187z00zz__bignumz00,
		BgL_bgl_string3187za700za7za7_3236za7, "_$randbx", 8);
	      DEFINE_STRING(BGl_string3188z00zz__bignumz00,
		BgL_bgl_string3188za700za7za7_3237za7, "_$flonum->bignum", 16);
	      DEFINE_STRING(BGl_string3190z00zz__bignumz00,
		BgL_bgl_string3190za700za7za7_3238za7, "_$bignum->flonum", 16);
	      DEFINE_STRING(BGl_string3189z00zz__bignumz00,
		BgL_bgl_string3189za700za7za7_3239za7, "double", 6);
	      DEFINE_STRING(BGl_string3191z00zz__bignumz00,
		BgL_bgl_string3191za700za7za7_3240za7, "__bignum", 8);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42evenbxzf3zd2envz63zz__bignumz00,
		BgL_bgl__za742evenbxza7f3za7b13241za7, BGl__z42evenbxzf3zb1zz__bignumz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42elongzd2ze3bignumzd2envza1zz__bignumz00,
		BgL_bgl__za742elongza7d2za7e3b3242za7,
		BGl__z42elongzd2ze3bignumz73zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42zd2bxzd2envz42zz__bignumz00,
		BgL_bgl__za742za7d2bxza790za7za7__3243za7, BGl__z42zd2bxz90zz__bignumz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42stringzd2ze3bignumzd2envza1zz__bignumz00,
		BgL_bgl__za742stringza7d2za7e33244za7,
		BGl__z42stringzd2ze3bignumz73zz__bignumz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42zb2bxzd2envz22zz__bignumz00,
		BgL_bgl__za742za7b2bxza7f0za7za7__3245za7, BGl__z42zb2bxzf0zz__bignumz00,
		0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42za2bxzd2envz32zz__bignumz00,
		BgL_bgl__za742za7a2bxza7e0za7za7__3246za7, BGl__z42za2bxze0zz__bignumz00,
		0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42randbxzd2envz90zz__bignumz00,
		BgL_bgl__za742randbxza742za7za7_3247z00, BGl__z42randbxz42zz__bignumz00, 0L,
		BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42divrembxzd2envz90zz__bignumz00,
		BgL_bgl__za742divrembxza742za73248za7, BGl__z42divrembxz42zz__bignumz00, 0L,
		BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42quotientbxzd2envz90zz__bignumz00,
		BgL_bgl__za742quotientbxza743249z00, BGl__z42quotientbxz42zz__bignumz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42fixnumzd2ze3bignumzd2envza1zz__bignumz00,
		BgL_bgl__za742fixnumza7d2za7e33250za7,
		BGl__z42fixnumzd2ze3bignumz73zz__bignumz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_czd2bignumzd2ze3stringzd2envz31zz__bignumz00,
		BgL_bgl__cza7d2bignumza7d2za7e3251za7,
		BGl__czd2bignumzd2ze3stringze3zz__bignumz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z42stringzd2ze3integerzd2objzd2envz73zz__bignumz00,
		BgL_bgl__za742stringza7d2za7e33252za7,
		BGl__z42stringzd2ze3integerzd2objza1zz__bignumz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42lcmbxzd2envz90zz__bignumz00,
		BgL_bgl__za742lcmbxza742za7za7__3253z00, BGl__z42lcmbxz42zz__bignumz00, 0L,
		BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42bignumzd2ze3flonumzd2envza1zz__bignumz00,
		BgL_bgl__za742bignumza7d2za7e33254za7,
		BGl__z42bignumzd2ze3flonumz73zz__bignumz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42negativebxzf3zd2envz63zz__bignumz00,
		BgL_bgl__za742negativebxza7f3255z00, BGl__z42negativebxzf3zb1zz__bignumz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42remainderbxzd2envz90zz__bignumz00,
		BgL_bgl__za742remainderbxza73256z00, BGl__z42remainderbxz42zz__bignumz00,
		0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_z42gcdbxzd2envz90zz__bignumz00,
		BgL_bgl__za742gcdbxza742za7za7__3257z00, BGl__z42gcdbxz42zz__bignumz00, 0L,
		BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long
		BgL_checksumz00_4802, char *BgL_fromz00_4803)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__bignumz00))
				{
					BGl_requirezd2initializa7ationz75zz__bignumz00 = BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__bignumz00();
					BGl_importedzd2moduleszd2initz00zz__bignumz00();
					BGl_toplevelzd2initzd2zz__bignumz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 45 */
			BGl_symbol3165z00zz__bignumz00 =
				bstring_to_symbol(BGl_string3166z00zz__bignumz00);
			BGl_list3174z00zz__bignumz00 = MAKE_PAIR(BINT(((long) 0)), BNIL);
			BGl_list3178z00zz__bignumz00 =
				MAKE_PAIR(BCHAR(((unsigned char) 'x')), BINT(((long) 16)));
			BGl_list3179z00zz__bignumz00 =
				MAKE_PAIR(BCHAR(((unsigned char) 'd')), BINT(((long) 10)));
			BGl_list3180z00zz__bignumz00 =
				MAKE_PAIR(BCHAR(((unsigned char) 'o')), BINT(((long) 8)));
			BGl_list3181z00zz__bignumz00 =
				MAKE_PAIR(BCHAR(((unsigned char) 'b')), BINT(((long) 2)));
			BGl_list3177z00zz__bignumz00 =
				MAKE_PAIR(BGl_list3178z00zz__bignumz00,
				MAKE_PAIR(BGl_list3179z00zz__bignumz00,
					MAKE_PAIR(BGl_list3180z00zz__bignumz00,
						MAKE_PAIR(BGl_list3181z00zz__bignumz00, BNIL))));
			return (BGl_list3182z00zz__bignumz00 =
				MAKE_PAIR(BCHAR(((unsigned char) '+')),
					MAKE_PAIR(BCHAR(((unsigned char) '-')), BNIL)), BUNSPEC);
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 45 */
			{	/* Unsafe/bignumber.scm 319 */
				obj_t BgL_vz00_944;

				BgL_vz00_944 = make_vector((int) (((long) 33)), BFALSE);
				{
					long BgL_iz00_2616;

					long BgL_nz00_2617;

					BgL_iz00_2616 = ((long) 0);
					BgL_nz00_2617 = ((long) -16);
				BgL_loopz00_2615:
					if ((((long) 16) < BgL_nz00_2617))
						{	/* Unsafe/bignumber.scm 320 */
							BGl_preallocatedzd2bignumszd2zz__bignumz00 = BgL_vz00_944;
						}
					else
						{	/* Unsafe/bignumber.scm 320 */
							VECTOR_SET(BgL_vz00_944,
								(int) (BgL_iz00_2616),
								BGl_z42fixnumzd2ze3bignumzd2freshza1zz__bignumz00
								(BgL_nz00_2617));
							{
								long BgL_nz00_4842;

								long BgL_iz00_4840;

								BgL_iz00_4840 = (BgL_iz00_2616 + ((long) 1));
								BgL_nz00_4842 = (BgL_nz00_2617 + ((long) 1));
								BgL_nz00_2617 = BgL_nz00_4842;
								BgL_iz00_2616 = BgL_iz00_4840;
								goto BgL_loopz00_2615;
							}
						}
				}
			}
			return (BGl_bignumzd2za7eroz75zz__bignumz00 =
				bgl_long_to_bignum(((long) 0)), BUNSPEC);
		}
	}



/* $string->integer-obj */
	BGL_EXPORTED_DEF obj_t bgl_string_to_integer_obj(char *BgL_strz00_1,
		long BgL_radixz00_2)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 158 */
			{	/* Unsafe/bignumber.scm 159 */
				obj_t BgL_list1867z00_4798;

				BgL_list1867z00_4798 = MAKE_PAIR(BINT(BgL_radixz00_2), BNIL);
				return
					BINT(BGl_stringzd2ze3integerz31zz__r4_numbers_6_5_fixnumz00
					(string_to_bstring(BgL_strz00_1), BgL_list1867z00_4798));
			}
		}
	}



/* _$string->integer-obj */
	obj_t BGl__z42stringzd2ze3integerzd2objza1zz__bignumz00(obj_t BgL_envz00_4654,
		obj_t BgL_strz00_4655, obj_t BgL_radixz00_4656)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 158 */
			{	/* Unsafe/bignumber.scm 159 */
				char *BgL_strz00_4799;

				long BgL_radixz00_4800;

				{	/* Unsafe/bignumber.scm 159 */
					obj_t BgL_auxz00_4850;

					if (STRINGP(BgL_strz00_4655))
						{	/* Unsafe/bignumber.scm 159 */
							BgL_auxz00_4850 = BgL_strz00_4655;
						}
					else
						{	/* Unsafe/bignumber.scm 159 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3145z00zz__bignumz00, BGl_string3146z00zz__bignumz00,
								BgL_strz00_4655, BGl_string3147z00zz__bignumz00,
								BINT(((long) 7291)));
							exit(-1);
						}
					BgL_strz00_4799 = BSTRING_TO_STRING(BgL_auxz00_4850);
				}
				{	/* Unsafe/bignumber.scm 159 */
					obj_t BgL_auxz00_4857;

					if (INTEGERP(BgL_radixz00_4656))
						{	/* Unsafe/bignumber.scm 159 */
							BgL_auxz00_4857 = BgL_radixz00_4656;
						}
					else
						{	/* Unsafe/bignumber.scm 159 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3145z00zz__bignumz00, BGl_string3148z00zz__bignumz00,
								BgL_radixz00_4656, BGl_string3147z00zz__bignumz00,
								BINT(((long) 7291)));
							exit(-1);
						}
					BgL_radixz00_4800 = (long) CINT(BgL_auxz00_4857);
				}
				{	/* Unsafe/bignumber.scm 159 */
					obj_t BgL_list1867z00_4801;

					BgL_list1867z00_4801 = MAKE_PAIR(BINT(BgL_radixz00_4800), BNIL);
					return
						BINT(BGl_stringzd2ze3integerz31zz__r4_numbers_6_5_fixnumz00
						(string_to_bstring(BgL_strz00_4799), BgL_list1867z00_4801));
				}
			}
		}
	}



/* bignum-min-fixnum-div-radix */
	long BGl_bignumzd2minzd2fixnumzd2divzd2radixz00zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 191 */
			{	/* Unsafe/bignumber.scm 192 */
				long BgL_auxz00_4869;

				BgL_auxz00_4869 = (((long) -2) * (((long) 1) << (int) (((long) 28))));
				return (BgL_auxz00_4869 / ((long) 16384));
		}}
	}



/* bignum-length */
	long BGl_bignumzd2lengthzd2zz__bignumz00(obj_t BgL_bnz00_4)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 213 */
			{	/* Unsafe/bignumber.scm 214 */
				obj_t BgL_arg1900z00_2691;

				BgL_arg1900z00_2691 = BGL_BIGNUM_U16VECT(BgL_bnz00_4);
				return BGL_HVECTOR_LENGTH(BgL_arg1900z00_2691);
			}
		}
	}



/* bignum-sign */
	unsigned short BGl_bignumzd2signzd2zz__bignumz00(obj_t BgL_bnz00_5)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 215 */
			{	/* Unsafe/bignumber.scm 216 */
				obj_t BgL_arg1901z00_2693;

				BgL_arg1901z00_2693 = BGL_BIGNUM_U16VECT(BgL_bnz00_5);
				return BGL_U16VREF(BgL_arg1901z00_2693, ((long) 0));
		}}
	}



/* bignum-sign-set! */
	obj_t BGl_bignumzd2signzd2setz12z12zz__bignumz00(obj_t BgL_bnz00_6,
		int BgL_signz00_7)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 217 */
			{	/* Unsafe/bignumber.scm 218 */
				obj_t BgL_arg1903z00_2695;

				BgL_arg1903z00_2695 = BGL_BIGNUM_U16VECT(BgL_bnz00_6);
				{	/* Unsafe/bignumber.scm 218 */
					unsigned short BgL_auxz00_4879;

					BgL_auxz00_4879 = (unsigned short) (BgL_signz00_7);
					BGL_U16VSET(BgL_arg1903z00_2695, ((long) 0), BgL_auxz00_4879);
				}
				return BUNSPEC;
			}
		}
	}



/* bignum-shrink */
	obj_t BGl_bignumzd2shrinkzd2zz__bignumz00(obj_t BgL_xz00_15,
		long BgL_lenz00_16)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 231 */
			{	/* Unsafe/bignumber.scm 232 */
				obj_t BgL_yz00_989;

				{	/* Unsafe/bignumber.scm 232 */
					obj_t BgL_res2995z00_2711;

					{	/* Unsafe/bignumber.scm 232 */
						int BgL_lenz00_2707;

						BgL_lenz00_2707 = (int) (BgL_lenz00_16);
						{	/* Unsafe/bignumber.scm 232 */
							obj_t BgL_arg1898z00_2708;

							{	/* Unsafe/bignumber.scm 232 */

								BgL_arg1898z00_2708 =
									BGl_makezd2u16vectorzd2zz__srfi4z00(
									(long) (BgL_lenz00_2707), BINT(((long) 0)));
							}
							BgL_res2995z00_2711 = bgl_make_bignum(BgL_arg1898z00_2708);
					}}
					BgL_yz00_989 = BgL_res2995z00_2711;
				}
				{	/* Unsafe/bignumber.scm 233 */
					long BgL_g1772z00_990;

					BgL_g1772z00_990 = (BgL_lenz00_16 - ((long) 1));
					{
						long BgL_iz00_992;

						BgL_iz00_992 = BgL_g1772z00_990;
					BgL_zc3anonymousza31907ze3z83_993:
						if ((BgL_iz00_992 < ((long) 0)))
							{	/* Unsafe/bignumber.scm 234 */
								return BgL_yz00_989;
							}
						else
							{	/* Unsafe/bignumber.scm 234 */
								{	/* Unsafe/bignumber.scm 237 */
									unsigned short BgL_arg1909z00_995;

									{	/* Unsafe/bignumber.scm 237 */
										int BgL_iz00_2717;

										BgL_iz00_2717 = (int) (BgL_iz00_992);
										{	/* Unsafe/bignumber.scm 237 */
											obj_t BgL_arg1905z00_2718;

											BgL_arg1905z00_2718 = BGL_BIGNUM_U16VECT(BgL_xz00_15);
											{	/* Unsafe/bignumber.scm 237 */
												long BgL_auxz00_4892;

												BgL_auxz00_4892 = (long) (BgL_iz00_2717);
												BgL_arg1909z00_995 =
													BGL_U16VREF(BgL_arg1905z00_2718, BgL_auxz00_4892);
									}}}
									{	/* Unsafe/bignumber.scm 237 */
										int BgL_iz00_2720;

										int BgL_digitz00_2721;

										BgL_iz00_2720 = (int) (BgL_iz00_992);
										BgL_digitz00_2721 = (int) (BgL_arg1909z00_995);
										{	/* Unsafe/bignumber.scm 237 */
											obj_t BgL_arg1906z00_2722;

											BgL_arg1906z00_2722 = BGL_BIGNUM_U16VECT(BgL_yz00_989);
											{	/* Unsafe/bignumber.scm 237 */
												unsigned short BgL_auxz00_4900;

												long BgL_auxz00_4898;

												BgL_auxz00_4900 = (unsigned short) (BgL_digitz00_2721);
												BgL_auxz00_4898 = (long) (BgL_iz00_2720);
												BGL_U16VSET(BgL_arg1906z00_2722, BgL_auxz00_4898,
													BgL_auxz00_4900);
											} BUNSPEC;
								}}}
								{
									long BgL_iz00_4903;

									BgL_iz00_4903 = (BgL_iz00_992 - ((long) 1));
									BgL_iz00_992 = BgL_iz00_4903;
									goto BgL_zc3anonymousza31907ze3z83_993;
								}
							}
					}
				}
			}
		}
	}



/* bignum-remove-leading-zeroes */
	obj_t BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00(obj_t
		BgL_xz00_17)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 240 */
			{	/* Unsafe/bignumber.scm 241 */
				unsigned short BgL_signz00_998;

				{	/* Unsafe/bignumber.scm 241 */
					obj_t BgL_arg1901z00_2726;

					BgL_arg1901z00_2726 = BGL_BIGNUM_U16VECT(BgL_xz00_17);
					BgL_signz00_998 = BGL_U16VREF(BgL_arg1901z00_2726, ((long) 0));
				}
				{	/* Unsafe/bignumber.scm 242 */
					obj_t BgL_arg1903z00_2731;

					BgL_arg1903z00_2731 = BGL_BIGNUM_U16VECT(BgL_xz00_17);
					{	/* Unsafe/bignumber.scm 242 */
						unsigned short BgL_auxz00_4908;

						BgL_auxz00_4908 = (unsigned short) (((long) 1));
						BGL_U16VSET(BgL_arg1903z00_2731, ((long) 0), BgL_auxz00_4908);
					} BUNSPEC;
				}
				{	/* Unsafe/bignumber.scm 243 */
					long BgL_g1773z00_999;

					{	/* Unsafe/bignumber.scm 243 */
						long BgL_arg1922z00_1014;

						{	/* Unsafe/bignumber.scm 243 */
							obj_t BgL_arg1900z00_2734;

							BgL_arg1900z00_2734 = BGL_BIGNUM_U16VECT(BgL_xz00_17);
							BgL_arg1922z00_1014 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_2734);
						}
						BgL_g1773z00_999 = (BgL_arg1922z00_1014 - ((long) 1));
					}
					{
						long BgL_iz00_1001;

						BgL_iz00_1001 = BgL_g1773z00_999;
					BgL_zc3anonymousza31911ze3z83_1002:
						{	/* Unsafe/bignumber.scm 244 */
							bool_t BgL_testz00_4914;

							{	/* Unsafe/bignumber.scm 244 */
								unsigned short BgL_arg1920z00_1011;

								{	/* Unsafe/bignumber.scm 244 */
									int BgL_iz00_2739;

									BgL_iz00_2739 = (int) (BgL_iz00_1001);
									{	/* Unsafe/bignumber.scm 244 */
										obj_t BgL_arg1905z00_2740;

										BgL_arg1905z00_2740 = BGL_BIGNUM_U16VECT(BgL_xz00_17);
										{	/* Unsafe/bignumber.scm 244 */
											long BgL_auxz00_4917;

											BgL_auxz00_4917 = (long) (BgL_iz00_2739);
											BgL_arg1920z00_1011 =
												BGL_U16VREF(BgL_arg1905z00_2740, BgL_auxz00_4917);
								}}}
								BgL_testz00_4914 = ((long) (BgL_arg1920z00_1011) == ((long) 0));
							}
							if (BgL_testz00_4914)
								{
									long BgL_iz00_4922;

									BgL_iz00_4922 = (BgL_iz00_1001 - ((long) 1));
									BgL_iz00_1001 = BgL_iz00_4922;
									goto BgL_zc3anonymousza31911ze3z83_1002;
								}
							else
								{	/* Unsafe/bignumber.scm 244 */
									if ((BgL_iz00_1001 == ((long) 0)))
										{	/* Unsafe/bignumber.scm 246 */
											return BGl_bignumzd2za7eroz75zz__bignumz00;
										}
									else
										{	/* Unsafe/bignumber.scm 246 */
											{	/* Unsafe/bignumber.scm 249 */
												int BgL_signz00_2748;

												BgL_signz00_2748 = (int) (BgL_signz00_998);
												{	/* Unsafe/bignumber.scm 249 */
													obj_t BgL_arg1903z00_2749;

													BgL_arg1903z00_2749 = BGL_BIGNUM_U16VECT(BgL_xz00_17);
													{	/* Unsafe/bignumber.scm 249 */
														unsigned short BgL_auxz00_4928;

														BgL_auxz00_4928 =
															(unsigned short) (BgL_signz00_2748);
														BGL_U16VSET(BgL_arg1903z00_2749, ((long) 0),
															BgL_auxz00_4928);
													} BUNSPEC;
											}}
											{	/* Unsafe/bignumber.scm 250 */
												bool_t BgL_testz00_4931;

												{	/* Unsafe/bignumber.scm 250 */
													long BgL_arg1917z00_1008;

													{	/* Unsafe/bignumber.scm 250 */
														long BgL_arg1918z00_1009;

														{	/* Unsafe/bignumber.scm 250 */
															obj_t BgL_arg1900z00_2752;

															BgL_arg1900z00_2752 =
																BGL_BIGNUM_U16VECT(BgL_xz00_17);
															BgL_arg1918z00_1009 =
																BGL_HVECTOR_LENGTH(BgL_arg1900z00_2752);
														}
														BgL_arg1917z00_1008 =
															(BgL_arg1918z00_1009 - ((long) 1));
													}
													BgL_testz00_4931 =
														(BgL_iz00_1001 == BgL_arg1917z00_1008);
												}
												if (BgL_testz00_4931)
													{	/* Unsafe/bignumber.scm 250 */
														return BgL_xz00_17;
													}
												else
													{	/* Unsafe/bignumber.scm 250 */
														return
															BGl_bignumzd2shrinkzd2zz__bignumz00(BgL_xz00_17,
															(BgL_iz00_1001 + ((long) 1)));
		}}}}}}}}}
	}



/* $fixnum->bignum-fresh */
	obj_t BGl_z42fixnumzd2ze3bignumzd2freshza1zz__bignumz00(long BgL_nz00_19)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 258 */
			{	/* Unsafe/bignumber.scm 259 */
				long BgL_negzd2nzd2_1016;

				if ((BgL_nz00_19 < ((long) 0)))
					{	/* Unsafe/bignumber.scm 259 */
						BgL_negzd2nzd2_1016 = BgL_nz00_19;
					}
				else
					{	/* Unsafe/bignumber.scm 259 */
						BgL_negzd2nzd2_1016 = (((long) 0) - BgL_nz00_19);
					}
				{
					long BgL_nbzd2digitszd2_1018;

					long BgL_xz00_1019;

					BgL_nbzd2digitszd2_1018 = ((long) 0);
					BgL_xz00_1019 = BgL_negzd2nzd2_1016;
				BgL_zc3anonymousza31924ze3z83_1020:
					if ((BgL_xz00_1019 == ((long) 0)))
						{	/* Unsafe/bignumber.scm 264 */
							obj_t BgL_rz00_1022;

							{	/* Unsafe/bignumber.scm 264 */
								long BgL_arg1936z00_1037;

								BgL_arg1936z00_1037 = (BgL_nbzd2digitszd2_1018 + ((long) 1));
								{	/* Unsafe/bignumber.scm 264 */
									obj_t BgL_res2996z00_2772;

									{	/* Unsafe/bignumber.scm 264 */
										int BgL_lenz00_2768;

										BgL_lenz00_2768 = (int) (BgL_arg1936z00_1037);
										{	/* Unsafe/bignumber.scm 264 */
											obj_t BgL_arg1898z00_2769;

											{	/* Unsafe/bignumber.scm 264 */

												BgL_arg1898z00_2769 =
													BGl_makezd2u16vectorzd2zz__srfi4z00(
													(long) (BgL_lenz00_2768), BINT(((long) 0)));
											}
											BgL_res2996z00_2772 =
												bgl_make_bignum(BgL_arg1898z00_2769);
									}}
									BgL_rz00_1022 = BgL_res2996z00_2772;
							}}
							if ((BgL_nz00_19 < ((long) 0)))
								{	/* Unsafe/bignumber.scm 266 */
									obj_t BgL_arg1903z00_2778;

									BgL_arg1903z00_2778 = BGL_BIGNUM_U16VECT(BgL_rz00_1022);
									{	/* Unsafe/bignumber.scm 266 */
										unsigned short BgL_auxz00_4952;

										BgL_auxz00_4952 = (unsigned short) (((long) 0));
										BGL_U16VSET(BgL_arg1903z00_2778, ((long) 0),
											BgL_auxz00_4952);
									} BUNSPEC;
								}
							else
								{	/* Unsafe/bignumber.scm 267 */
									obj_t BgL_arg1903z00_2783;

									BgL_arg1903z00_2783 = BGL_BIGNUM_U16VECT(BgL_rz00_1022);
									{	/* Unsafe/bignumber.scm 267 */
										unsigned short BgL_auxz00_4956;

										BgL_auxz00_4956 = (unsigned short) (((long) 1));
										BGL_U16VSET(BgL_arg1903z00_2783, ((long) 0),
											BgL_auxz00_4956);
									} BUNSPEC;
								}
							{
								long BgL_iz00_1025;

								long BgL_xz00_1026;

								BgL_iz00_1025 = ((long) 1);
								BgL_xz00_1026 = BgL_negzd2nzd2_1016;
							BgL_zc3anonymousza31927ze3z83_1027:
								if ((BgL_xz00_1026 == ((long) 0)))
									{	/* Unsafe/bignumber.scm 269 */
										return BgL_rz00_1022;
									}
								else
									{	/* Unsafe/bignumber.scm 269 */
										{	/* Unsafe/bignumber.scm 274 */
											long BgL_arg1929z00_1029;

											{	/* Unsafe/bignumber.scm 274 */
												long BgL_arg1931z00_1031;

												{	/* Unsafe/bignumber.scm 274 */
													long BgL_auxz00_4961;

													BgL_auxz00_4961 = (((long) 1) << (int) (((long) 14)));
													BgL_arg1931z00_1031 =
														(BgL_xz00_1026 % BgL_auxz00_4961);
												}
												BgL_arg1929z00_1029 =
													(((long) 0) - BgL_arg1931z00_1031);
											}
											{	/* Unsafe/bignumber.scm 271 */
												int BgL_iz00_2794;

												int BgL_digitz00_2795;

												BgL_iz00_2794 = (int) (BgL_iz00_1025);
												BgL_digitz00_2795 = (int) (BgL_arg1929z00_1029);
												{	/* Unsafe/bignumber.scm 271 */
													obj_t BgL_arg1906z00_2796;

													BgL_arg1906z00_2796 =
														BGL_BIGNUM_U16VECT(BgL_rz00_1022);
													{	/* Unsafe/bignumber.scm 271 */
														unsigned short BgL_auxz00_4971;

														long BgL_auxz00_4969;

														BgL_auxz00_4971 =
															(unsigned short) (BgL_digitz00_2795);
														BgL_auxz00_4969 = (long) (BgL_iz00_2794);
														BGL_U16VSET(BgL_arg1906z00_2796, BgL_auxz00_4969,
															BgL_auxz00_4971);
													} BUNSPEC;
										}}}
										{	/* Unsafe/bignumber.scm 275 */
											long BgL_arg1933z00_1033;

											long BgL_arg1934z00_1034;

											BgL_arg1933z00_1033 = (BgL_iz00_1025 + ((long) 1));
											{	/* Unsafe/bignumber.scm 275 */
												long BgL_auxz00_4975;

												BgL_auxz00_4975 = (((long) 1) << (int) (((long) 14)));
												BgL_arg1934z00_1034 = (BgL_xz00_1026 / BgL_auxz00_4975);
											}
											{
												long BgL_xz00_4980;

												long BgL_iz00_4979;

												BgL_iz00_4979 = BgL_arg1933z00_1033;
												BgL_xz00_4980 = BgL_arg1934z00_1034;
												BgL_xz00_1026 = BgL_xz00_4980;
												BgL_iz00_1025 = BgL_iz00_4979;
												goto BgL_zc3anonymousza31927ze3z83_1027;
											}
										}
									}
							}
						}
					else
						{	/* Unsafe/bignumber.scm 263 */
							long BgL_arg1937z00_1038;

							long BgL_arg1939z00_1039;

							BgL_arg1937z00_1038 = (BgL_nbzd2digitszd2_1018 + ((long) 1));
							{	/* Unsafe/bignumber.scm 263 */
								long BgL_auxz00_4982;

								BgL_auxz00_4982 = (((long) 1) << (int) (((long) 14)));
								BgL_arg1939z00_1039 = (BgL_xz00_1019 / BgL_auxz00_4982);
							}
							{
								long BgL_xz00_4987;

								long BgL_nbzd2digitszd2_4986;

								BgL_nbzd2digitszd2_4986 = BgL_arg1937z00_1038;
								BgL_xz00_4987 = BgL_arg1939z00_1039;
								BgL_xz00_1019 = BgL_xz00_4987;
								BgL_nbzd2digitszd2_1018 = BgL_nbzd2digitszd2_4986;
								goto BgL_zc3anonymousza31924ze3z83_1020;
							}
						}
				}
			}
		}
	}



/* $elong->bignum */
	BGL_EXPORTED_DEF obj_t bgl_elong_to_bignum(long BgL_nz00_20)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 278 */
			{	/* Unsafe/bignumber.scm 279 */
				long BgL_negzd2nzd2_1043;

				if ((BgL_nz00_20 < ((long) 0)))
					{	/* Unsafe/bignumber.scm 279 */
						BgL_negzd2nzd2_1043 = BgL_nz00_20;
					}
				else
					{	/* Unsafe/bignumber.scm 279 */
						long BgL_res2997z00_2813;

						{	/* Unsafe/bignumber.scm 279 */
							long BgL_auxz00_4990;

							BgL_auxz00_4990 = (((long) 0) - BgL_nz00_20);
							BgL_res2997z00_2813 = LONG_TO_ELONG(BgL_auxz00_4990);
						}
						BgL_negzd2nzd2_1043 = BgL_res2997z00_2813;
					}
				{
					long BgL_nbzd2digitszd2_1045;

					long BgL_xz00_1046;

					BgL_nbzd2digitszd2_1045 = ((long) 0);
					BgL_xz00_1046 = BgL_negzd2nzd2_1043;
				BgL_zc3anonymousza31943ze3z83_1047:
					if ((BgL_xz00_1046 == LONG_TO_ELONG(((long) 0))))
						{	/* Unsafe/bignumber.scm 284 */
							obj_t BgL_rz00_1049;

							{	/* Unsafe/bignumber.scm 284 */
								long BgL_arg1957z00_1066;

								BgL_arg1957z00_1066 = (BgL_nbzd2digitszd2_1045 + ((long) 1));
								{	/* Unsafe/bignumber.scm 284 */
									obj_t BgL_res2998z00_2822;

									{	/* Unsafe/bignumber.scm 284 */
										int BgL_lenz00_2818;

										BgL_lenz00_2818 = (int) (BgL_arg1957z00_1066);
										{	/* Unsafe/bignumber.scm 284 */
											obj_t BgL_arg1898z00_2819;

											{	/* Unsafe/bignumber.scm 284 */

												BgL_arg1898z00_2819 =
													BGl_makezd2u16vectorzd2zz__srfi4z00(
													(long) (BgL_lenz00_2818), BINT(((long) 0)));
											}
											BgL_res2998z00_2822 =
												bgl_make_bignum(BgL_arg1898z00_2819);
									}}
									BgL_rz00_1049 = BgL_res2998z00_2822;
							}}
							if ((BgL_nz00_20 < ((long) 0)))
								{	/* Unsafe/bignumber.scm 286 */
									obj_t BgL_arg1903z00_2828;

									BgL_arg1903z00_2828 = BGL_BIGNUM_U16VECT(BgL_rz00_1049);
									{	/* Unsafe/bignumber.scm 286 */
										unsigned short BgL_auxz00_5005;

										BgL_auxz00_5005 = (unsigned short) (((long) 0));
										BGL_U16VSET(BgL_arg1903z00_2828, ((long) 0),
											BgL_auxz00_5005);
									} BUNSPEC;
								}
							else
								{	/* Unsafe/bignumber.scm 287 */
									obj_t BgL_arg1903z00_2833;

									BgL_arg1903z00_2833 = BGL_BIGNUM_U16VECT(BgL_rz00_1049);
									{	/* Unsafe/bignumber.scm 287 */
										unsigned short BgL_auxz00_5009;

										BgL_auxz00_5009 = (unsigned short) (((long) 1));
										BGL_U16VSET(BgL_arg1903z00_2833, ((long) 0),
											BgL_auxz00_5009);
									} BUNSPEC;
								}
							{
								int BgL_iz00_1052;

								long BgL_xz00_1053;

								BgL_iz00_1052 = (int) (((long) 1));
								BgL_xz00_1053 = BgL_negzd2nzd2_1043;
							BgL_zc3anonymousza31946ze3z83_1054:
								if ((BgL_xz00_1053 == ((long) 0)))
									{	/* Unsafe/bignumber.scm 289 */
										return BgL_rz00_1049;
									}
								else
									{	/* Unsafe/bignumber.scm 289 */
										{	/* Unsafe/bignumber.scm 294 */
											long BgL_arg1948z00_1056;

											{	/* Unsafe/bignumber.scm 294 */
												long BgL_arg1950z00_1058;

												{	/* Unsafe/bignumber.scm 294 */
													long BgL_arg1951z00_1059;

													{	/* Unsafe/bignumber.scm 294 */
														long BgL_arg1952z00_1060;

														{	/* Unsafe/bignumber.scm 294 */
															long BgL_auxz00_5014;

															BgL_auxz00_5014 =
																(((long) 1) << (int) (((long) 14)));
															BgL_arg1952z00_1060 =
																LONG_TO_ELONG(BgL_auxz00_5014);
														}
														BgL_arg1951z00_1059 =
															(BgL_xz00_1053 % BgL_arg1952z00_1060);
													}
													{	/* Unsafe/bignumber.scm 294 */
														long BgL_auxz00_5019;

														BgL_auxz00_5019 =
															ELONG_TO_LONG(BgL_arg1951z00_1059);
														BgL_arg1950z00_1058 =
															ELONG_TO_LONG(BgL_auxz00_5019);
												}}
												{	/* Unsafe/bignumber.scm 294 */
													long BgL_za72za7_2842;

													BgL_za72za7_2842 = ELONG_TO_LONG(BgL_arg1950z00_1058);
													BgL_arg1948z00_1056 = (((long) 0) - BgL_za72za7_2842);
											}}
											{	/* Unsafe/bignumber.scm 291 */
												int BgL_digitz00_2845;

												BgL_digitz00_2845 = (int) (BgL_arg1948z00_1056);
												{	/* Unsafe/bignumber.scm 291 */
													obj_t BgL_arg1906z00_2846;

													BgL_arg1906z00_2846 =
														BGL_BIGNUM_U16VECT(BgL_rz00_1049);
													{	/* Unsafe/bignumber.scm 291 */
														unsigned short BgL_auxz00_5028;

														long BgL_auxz00_5026;

														BgL_auxz00_5028 =
															(unsigned short) (BgL_digitz00_2845);
														BgL_auxz00_5026 = (long) (BgL_iz00_1052);
														BGL_U16VSET(BgL_arg1906z00_2846, BgL_auxz00_5026,
															BgL_auxz00_5028);
													} BUNSPEC;
										}}}
										{	/* Unsafe/bignumber.scm 295 */
											long BgL_arg1954z00_1062;

											long BgL_arg1955z00_1063;

											BgL_arg1954z00_1062 =
												((long) (BgL_iz00_1052) + ((long) 1));
											{	/* Unsafe/bignumber.scm 295 */
												long BgL_arg1956z00_1064;

												BgL_arg1956z00_1064 =
													(((long) 1) << (int) (((long) 14)));
												{	/* Unsafe/bignumber.scm 295 */
													long BgL_n2z00_2852;

													BgL_n2z00_2852 = LONG_TO_ELONG(BgL_arg1956z00_1064);
													BgL_arg1955z00_1063 =
														(BgL_xz00_1053 / BgL_n2z00_2852);
											}}
											{
												long BgL_xz00_5039;

												int BgL_iz00_5037;

												BgL_iz00_5037 = (int) (BgL_arg1954z00_1062);
												BgL_xz00_5039 = BgL_arg1955z00_1063;
												BgL_xz00_1053 = BgL_xz00_5039;
												BgL_iz00_1052 = BgL_iz00_5037;
												goto BgL_zc3anonymousza31946ze3z83_1054;
											}
										}
									}
							}
						}
					else
						{	/* Unsafe/bignumber.scm 283 */
							long BgL_arg1958z00_1067;

							long BgL_arg1959z00_1068;

							BgL_arg1958z00_1067 = (BgL_nbzd2digitszd2_1045 + ((long) 1));
							{	/* Unsafe/bignumber.scm 283 */
								long BgL_arg1960z00_1069;

								BgL_arg1960z00_1069 =
									(LONG_TO_ELONG(((long) 1)) << (int) (((long) 15)));
								BgL_arg1959z00_1068 = (BgL_xz00_1046 / BgL_arg1960z00_1069);
							}
							{
								long BgL_xz00_5047;

								long BgL_nbzd2digitszd2_5046;

								BgL_nbzd2digitszd2_5046 = BgL_arg1958z00_1067;
								BgL_xz00_5047 = BgL_arg1959z00_1068;
								BgL_xz00_1046 = BgL_xz00_5047;
								BgL_nbzd2digitszd2_1045 = BgL_nbzd2digitszd2_5046;
								goto BgL_zc3anonymousza31943ze3z83_1047;
							}
						}
				}
			}
		}
	}



/* _$elong->bignum */
	obj_t BGl__z42elongzd2ze3bignumz73zz__bignumz00(obj_t BgL_envz00_4657,
		obj_t BgL_nz00_4658)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 278 */
			{	/* Unsafe/bignumber.scm 279 */
				long BgL_auxz00_5048;

				{	/* Unsafe/bignumber.scm 279 */
					obj_t BgL_auxz00_5049;

					if (ELONGP(BgL_nz00_4658))
						{	/* Unsafe/bignumber.scm 279 */
							BgL_auxz00_5049 = BgL_nz00_4658;
						}
					else
						{	/* Unsafe/bignumber.scm 279 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3149z00zz__bignumz00, BGl_string3150z00zz__bignumz00,
								BgL_nz00_4658, BGl_string3147z00zz__bignumz00,
								BINT(((long) 11263)));
							exit(-1);
						}
					BgL_auxz00_5048 = BELONG_TO_LONG(BgL_auxz00_5049);
				}
				return bgl_elong_to_bignum(BgL_auxz00_5048);
			}
		}
	}



/* $llong->bignum */
	BGL_EXPORTED_DEF obj_t bgl_llong_to_bignum(BGL_LONGLONG_T BgL_nz00_21)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 298 */
			{	/* Unsafe/bignumber.scm 299 */
				BGL_LONGLONG_T BgL_negzd2nzd2_1072;

				if ((BgL_nz00_21 < ((BGL_LONGLONG_T) 0)))
					{	/* Unsafe/bignumber.scm 299 */
						BgL_negzd2nzd2_1072 = BgL_nz00_21;
					}
				else
					{	/* Unsafe/bignumber.scm 299 */
						BgL_negzd2nzd2_1072 = (((BGL_LONGLONG_T) 0) - BgL_nz00_21);
					}
				{
					long BgL_nbzd2digitszd2_1074;

					BGL_LONGLONG_T BgL_xz00_1075;

					BgL_nbzd2digitszd2_1074 = ((long) 0);
					BgL_xz00_1075 = BgL_negzd2nzd2_1072;
				BgL_zc3anonymousza31962ze3z83_1076:
					if ((BgL_xz00_1075 == LONG_TO_LLONG(((long) 0))))
						{	/* Unsafe/bignumber.scm 304 */
							obj_t BgL_rz00_1078;

							{	/* Unsafe/bignumber.scm 304 */
								long BgL_arg1977z00_1095;

								BgL_arg1977z00_1095 = (BgL_nbzd2digitszd2_1074 + ((long) 1));
								{	/* Unsafe/bignumber.scm 304 */
									obj_t BgL_res2999z00_2871;

									{	/* Unsafe/bignumber.scm 304 */
										int BgL_lenz00_2867;

										BgL_lenz00_2867 = (int) (BgL_arg1977z00_1095);
										{	/* Unsafe/bignumber.scm 304 */
											obj_t BgL_arg1898z00_2868;

											{	/* Unsafe/bignumber.scm 304 */

												BgL_arg1898z00_2868 =
													BGl_makezd2u16vectorzd2zz__srfi4z00(
													(long) (BgL_lenz00_2867), BINT(((long) 0)));
											}
											BgL_res2999z00_2871 =
												bgl_make_bignum(BgL_arg1898z00_2868);
									}}
									BgL_rz00_1078 = BgL_res2999z00_2871;
							}}
							if ((BgL_nz00_21 < ((BGL_LONGLONG_T) 0)))
								{	/* Unsafe/bignumber.scm 306 */
									obj_t BgL_arg1903z00_2877;

									BgL_arg1903z00_2877 = BGL_BIGNUM_U16VECT(BgL_rz00_1078);
									{	/* Unsafe/bignumber.scm 306 */
										unsigned short BgL_auxz00_5072;

										BgL_auxz00_5072 = (unsigned short) (((long) 0));
										BGL_U16VSET(BgL_arg1903z00_2877, ((long) 0),
											BgL_auxz00_5072);
									} BUNSPEC;
								}
							else
								{	/* Unsafe/bignumber.scm 307 */
									obj_t BgL_arg1903z00_2882;

									BgL_arg1903z00_2882 = BGL_BIGNUM_U16VECT(BgL_rz00_1078);
									{	/* Unsafe/bignumber.scm 307 */
										unsigned short BgL_auxz00_5076;

										BgL_auxz00_5076 = (unsigned short) (((long) 1));
										BGL_U16VSET(BgL_arg1903z00_2882, ((long) 0),
											BgL_auxz00_5076);
									} BUNSPEC;
								}
							{
								long BgL_iz00_1081;

								BGL_LONGLONG_T BgL_xz00_1082;

								BgL_iz00_1081 = ((long) 1);
								BgL_xz00_1082 = BgL_negzd2nzd2_1072;
							BgL_zc3anonymousza31965ze3z83_1083:
								if ((BgL_xz00_1082 == ((BGL_LONGLONG_T) 0)))
									{	/* Unsafe/bignumber.scm 309 */
										return BgL_rz00_1078;
									}
								else
									{	/* Unsafe/bignumber.scm 309 */
										{	/* Unsafe/bignumber.scm 314 */
											long BgL_arg1967z00_1085;

											{	/* Unsafe/bignumber.scm 314 */
												long BgL_arg1970z00_1087;

												{	/* Unsafe/bignumber.scm 314 */
													BGL_LONGLONG_T BgL_arg1971z00_1088;

													{	/* Unsafe/bignumber.scm 314 */
														BGL_LONGLONG_T BgL_arg1972z00_1089;

														{	/* Unsafe/bignumber.scm 314 */
															long BgL_auxz00_5081;

															BgL_auxz00_5081 =
																(((long) 1) << (int) (((long) 14)));
															BgL_arg1972z00_1089 =
																LONG_TO_LLONG(BgL_auxz00_5081);
														}
														BgL_arg1971z00_1088 =
															(BgL_xz00_1082 % BgL_arg1972z00_1089);
													}
													BgL_arg1970z00_1087 =
														LLONG_TO_LONG(BgL_arg1971z00_1088);
												}
												BgL_arg1967z00_1085 =
													(((long) 0) - BgL_arg1970z00_1087);
											}
											{	/* Unsafe/bignumber.scm 311 */
												int BgL_iz00_2893;

												int BgL_digitz00_2894;

												BgL_iz00_2893 = (int) (BgL_iz00_1081);
												BgL_digitz00_2894 = (int) (BgL_arg1967z00_1085);
												{	/* Unsafe/bignumber.scm 311 */
													obj_t BgL_arg1906z00_2895;

													BgL_arg1906z00_2895 =
														BGL_BIGNUM_U16VECT(BgL_rz00_1078);
													{	/* Unsafe/bignumber.scm 311 */
														unsigned short BgL_auxz00_5093;

														long BgL_auxz00_5091;

														BgL_auxz00_5093 =
															(unsigned short) (BgL_digitz00_2894);
														BgL_auxz00_5091 = (long) (BgL_iz00_2893);
														BGL_U16VSET(BgL_arg1906z00_2895, BgL_auxz00_5091,
															BgL_auxz00_5093);
													} BUNSPEC;
										}}}
										{	/* Unsafe/bignumber.scm 315 */
											long BgL_arg1974z00_1091;

											BGL_LONGLONG_T BgL_arg1975z00_1092;

											BgL_arg1974z00_1091 = (BgL_iz00_1081 + ((long) 1));
											{	/* Unsafe/bignumber.scm 315 */
												long BgL_arg1976z00_1093;

												BgL_arg1976z00_1093 =
													(((long) 1) << (int) (((long) 14)));
												{	/* Unsafe/bignumber.scm 315 */
													BGL_LONGLONG_T BgL_n2z00_2901;

													BgL_n2z00_2901 = LONG_TO_LLONG(BgL_arg1976z00_1093);
													BgL_arg1975z00_1092 =
														(BgL_xz00_1082 / BgL_n2z00_2901);
											}}
											{
												BGL_LONGLONG_T BgL_xz00_5102;

												long BgL_iz00_5101;

												BgL_iz00_5101 = BgL_arg1974z00_1091;
												BgL_xz00_5102 = BgL_arg1975z00_1092;
												BgL_xz00_1082 = BgL_xz00_5102;
												BgL_iz00_1081 = BgL_iz00_5101;
												goto BgL_zc3anonymousza31965ze3z83_1083;
											}
										}
									}
							}
						}
					else
						{	/* Unsafe/bignumber.scm 303 */
							long BgL_arg1979z00_1096;

							BGL_LONGLONG_T BgL_arg1980z00_1097;

							BgL_arg1979z00_1096 = (BgL_nbzd2digitszd2_1074 + ((long) 1));
							{	/* Unsafe/bignumber.scm 303 */
								BGL_LONGLONG_T BgL_arg1981z00_1098;

								BgL_arg1981z00_1098 =
									(LONG_TO_LLONG(((long) 1)) << (int) (((long) 30)));
								BgL_arg1980z00_1097 = (BgL_xz00_1075 / BgL_arg1981z00_1098);
							}
							{
								BGL_LONGLONG_T BgL_xz00_5109;

								long BgL_nbzd2digitszd2_5108;

								BgL_nbzd2digitszd2_5108 = BgL_arg1979z00_1096;
								BgL_xz00_5109 = BgL_arg1980z00_1097;
								BgL_xz00_1075 = BgL_xz00_5109;
								BgL_nbzd2digitszd2_1074 = BgL_nbzd2digitszd2_5108;
								goto BgL_zc3anonymousza31962ze3z83_1076;
							}
						}
				}
			}
		}
	}



/* _$llong->bignum */
	obj_t BGl__z42llongzd2ze3bignumz73zz__bignumz00(obj_t BgL_envz00_4659,
		obj_t BgL_nz00_4660)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 298 */
			{	/* Unsafe/bignumber.scm 299 */
				BGL_LONGLONG_T BgL_auxz00_5110;

				{	/* Unsafe/bignumber.scm 299 */
					obj_t BgL_auxz00_5111;

					if (LLONGP(BgL_nz00_4660))
						{	/* Unsafe/bignumber.scm 299 */
							BgL_auxz00_5111 = BgL_nz00_4660;
						}
					else
						{	/* Unsafe/bignumber.scm 299 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3151z00zz__bignumz00, BGl_string3152z00zz__bignumz00,
								BgL_nz00_4660, BGl_string3147z00zz__bignumz00,
								BINT(((long) 11952)));
							exit(-1);
						}
					BgL_auxz00_5110 = BLLONG_TO_LLONG(BgL_auxz00_5111);
				}
				return bgl_llong_to_bignum(BgL_auxz00_5110);
			}
		}
	}



/* $fixnum->bignum */
	BGL_EXPORTED_DEF obj_t bgl_long_to_bignum(long BgL_nz00_22)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 327 */
			{	/* Unsafe/bignumber.scm 328 */
				bool_t BgL_testz00_5119;

				if ((BgL_nz00_22 < ((long) -16)))
					{	/* Unsafe/bignumber.scm 328 */
						BgL_testz00_5119 = ((bool_t) 1);
					}
				else
					{	/* Unsafe/bignumber.scm 328 */
						BgL_testz00_5119 = (((long) 16) < BgL_nz00_22);
					}
				if (BgL_testz00_5119)
					{	/* Unsafe/bignumber.scm 328 */
						return
							BGl_z42fixnumzd2ze3bignumzd2freshza1zz__bignumz00(BgL_nz00_22);
					}
				else
					{	/* Unsafe/bignumber.scm 330 */
						long BgL_arg1984z00_1102;

						BgL_arg1984z00_1102 = (BgL_nz00_22 + ((long) 16));
						return
							VECTOR_REF(BGl_preallocatedzd2bignumszd2zz__bignumz00,
							(int) (BgL_arg1984z00_1102));
		}}}
	}



/* _$fixnum->bignum */
	obj_t BGl__z42fixnumzd2ze3bignumz73zz__bignumz00(obj_t BgL_envz00_4661,
		obj_t BgL_nz00_4662)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 327 */
			{	/* Unsafe/bignumber.scm 328 */
				long BgL_auxz00_5127;

				{	/* Unsafe/bignumber.scm 328 */
					obj_t BgL_auxz00_5128;

					if (INTEGERP(BgL_nz00_4662))
						{	/* Unsafe/bignumber.scm 328 */
							BgL_auxz00_5128 = BgL_nz00_4662;
						}
					else
						{	/* Unsafe/bignumber.scm 328 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3153z00zz__bignumz00, BGl_string3148z00zz__bignumz00,
								BgL_nz00_4662, BGl_string3147z00zz__bignumz00,
								BINT(((long) 12844)));
							exit(-1);
						}
					BgL_auxz00_5127 = (long) CINT(BgL_auxz00_5128);
				}
				return bgl_long_to_bignum(BgL_auxz00_5127);
			}
		}
	}



/* $<bx */
	bool_t BGl_z42zc3bxz81zz__bignumz00(obj_t BgL_xz00_25, obj_t BgL_yz00_26)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 352 */
			{	/* Unsafe/bignumber.scm 353 */
				bool_t BgL_testz00_5136;

				{	/* Unsafe/bignumber.scm 353 */
					unsigned short BgL_arg2007z00_1138;

					unsigned short BgL_arg2008z00_1139;

					{	/* Unsafe/bignumber.scm 353 */
						obj_t BgL_arg1901z00_2917;

						BgL_arg1901z00_2917 = BGL_BIGNUM_U16VECT(BgL_xz00_25);
						BgL_arg2007z00_1138 = BGL_U16VREF(BgL_arg1901z00_2917, ((long) 0));
					}
					{	/* Unsafe/bignumber.scm 353 */
						obj_t BgL_arg1901z00_2920;

						BgL_arg1901z00_2920 = BGL_BIGNUM_U16VECT(BgL_yz00_26);
						BgL_arg2008z00_1139 = BGL_U16VREF(BgL_arg1901z00_2920, ((long) 0));
					}
					BgL_testz00_5136 =
						((long) (BgL_arg2007z00_1138) == (long) (BgL_arg2008z00_1139));
				}
				if (BgL_testz00_5136)
					{	/* Unsafe/bignumber.scm 355 */
						long BgL_lenxz00_1121;

						long BgL_lenyz00_1122;

						{	/* Unsafe/bignumber.scm 355 */
							obj_t BgL_arg1900z00_2925;

							BgL_arg1900z00_2925 = BGL_BIGNUM_U16VECT(BgL_xz00_25);
							BgL_lenxz00_1121 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_2925);
						}
						{	/* Unsafe/bignumber.scm 356 */
							obj_t BgL_arg1900z00_2928;

							BgL_arg1900z00_2928 = BGL_BIGNUM_U16VECT(BgL_yz00_26);
							BgL_lenyz00_1122 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_2928);
						}
						if ((BgL_lenxz00_1121 < BgL_lenyz00_1122))
							{	/* Unsafe/bignumber.scm 358 */
								bool_t BgL_testz00_5150;

								{	/* Unsafe/bignumber.scm 358 */
									bool_t BgL_res3000z00_2940;

									{	/* Unsafe/bignumber.scm 358 */
										unsigned short BgL_arg2015z00_2933;

										{	/* Unsafe/bignumber.scm 358 */
											obj_t BgL_arg1901z00_2936;

											BgL_arg1901z00_2936 = BGL_BIGNUM_U16VECT(BgL_xz00_25);
											BgL_arg2015z00_2933 =
												BGL_U16VREF(BgL_arg1901z00_2936, ((long) 0));
										}
										BgL_res3000z00_2940 =
											((long) (BgL_arg2015z00_2933) == ((long) 0));
									}
									BgL_testz00_5150 = BgL_res3000z00_2940;
								}
								if (BgL_testz00_5150)
									{	/* Unsafe/bignumber.scm 358 */
										return ((bool_t) 0);
									}
								else
									{	/* Unsafe/bignumber.scm 358 */
										return ((bool_t) 1);
									}
							}
						else
							{	/* Unsafe/bignumber.scm 357 */
								if ((BgL_lenyz00_1122 < BgL_lenxz00_1121))
									{	/* Unsafe/bignumber.scm 360 */
										bool_t BgL_res3001z00_2951;

										{	/* Unsafe/bignumber.scm 360 */
											unsigned short BgL_arg2015z00_2944;

											{	/* Unsafe/bignumber.scm 360 */
												obj_t BgL_arg1901z00_2947;

												BgL_arg1901z00_2947 = BGL_BIGNUM_U16VECT(BgL_xz00_25);
												BgL_arg2015z00_2944 =
													BGL_U16VREF(BgL_arg1901z00_2947, ((long) 0));
											}
											BgL_res3001z00_2951 =
												((long) (BgL_arg2015z00_2944) == ((long) 0));
										}
										return BgL_res3001z00_2951;
									}
								else
									{	/* Unsafe/bignumber.scm 362 */
										long BgL_g1775z00_1126;

										BgL_g1775z00_1126 = (BgL_lenxz00_1121 - ((long) 1));
										{
											long BgL_iz00_1128;

											BgL_iz00_1128 = BgL_g1775z00_1126;
										BgL_zc3anonymousza32001ze3z83_1129:
											if ((((long) 0) < BgL_iz00_1128))
												{	/* Unsafe/bignumber.scm 364 */
													unsigned short BgL_dxz00_1131;

													unsigned short BgL_dyz00_1132;

													{	/* Unsafe/bignumber.scm 364 */
														int BgL_iz00_2957;

														BgL_iz00_2957 = (int) (BgL_iz00_1128);
														{	/* Unsafe/bignumber.scm 364 */
															obj_t BgL_arg1905z00_2958;

															BgL_arg1905z00_2958 =
																BGL_BIGNUM_U16VECT(BgL_xz00_25);
															{	/* Unsafe/bignumber.scm 364 */
																long BgL_auxz00_5166;

																BgL_auxz00_5166 = (long) (BgL_iz00_2957);
																BgL_dxz00_1131 =
																	BGL_U16VREF(BgL_arg1905z00_2958,
																	BgL_auxz00_5166);
													}}}
													{	/* Unsafe/bignumber.scm 365 */
														int BgL_iz00_2960;

														BgL_iz00_2960 = (int) (BgL_iz00_1128);
														{	/* Unsafe/bignumber.scm 365 */
															obj_t BgL_arg1905z00_2961;

															BgL_arg1905z00_2961 =
																BGL_BIGNUM_U16VECT(BgL_yz00_26);
															{	/* Unsafe/bignumber.scm 365 */
																long BgL_auxz00_5171;

																BgL_auxz00_5171 = (long) (BgL_iz00_2960);
																BgL_dyz00_1132 =
																	BGL_U16VREF(BgL_arg1905z00_2961,
																	BgL_auxz00_5171);
													}}}
													if (
														((long) (BgL_dxz00_1131) < (long) (BgL_dyz00_1132)))
														{	/* Unsafe/bignumber.scm 366 */
															bool_t BgL_testz00_5178;

															{	/* Unsafe/bignumber.scm 366 */
																bool_t BgL_res3002z00_2972;

																{	/* Unsafe/bignumber.scm 366 */
																	unsigned short BgL_arg2015z00_2965;

																	{	/* Unsafe/bignumber.scm 366 */
																		obj_t BgL_arg1901z00_2968;

																		BgL_arg1901z00_2968 =
																			BGL_BIGNUM_U16VECT(BgL_xz00_25);
																		BgL_arg2015z00_2965 =
																			BGL_U16VREF(BgL_arg1901z00_2968,
																			((long) 0));
																	}
																	BgL_res3002z00_2972 =
																		(
																		(long) (BgL_arg2015z00_2965) == ((long) 0));
																}
																BgL_testz00_5178 = BgL_res3002z00_2972;
															}
															if (BgL_testz00_5178)
																{	/* Unsafe/bignumber.scm 366 */
																	return ((bool_t) 0);
																}
															else
																{	/* Unsafe/bignumber.scm 366 */
																	return ((bool_t) 1);
																}
														}
													else
														{	/* Unsafe/bignumber.scm 366 */
															if (
																((long) (BgL_dyz00_1132) <
																	(long) (BgL_dxz00_1131)))
																{	/* Unsafe/bignumber.scm 367 */
																	bool_t BgL_res3003z00_2983;

																	{	/* Unsafe/bignumber.scm 367 */
																		unsigned short BgL_arg2015z00_2976;

																		{	/* Unsafe/bignumber.scm 367 */
																			obj_t BgL_arg1901z00_2979;

																			BgL_arg1901z00_2979 =
																				BGL_BIGNUM_U16VECT(BgL_xz00_25);
																			BgL_arg2015z00_2976 =
																				BGL_U16VREF(BgL_arg1901z00_2979,
																				((long) 0));
																		}
																		BgL_res3003z00_2983 =
																			(
																			(long) (BgL_arg2015z00_2976) ==
																			((long) 0));
																	}
																	return BgL_res3003z00_2983;
																}
															else
																{
																	long BgL_iz00_5191;

																	BgL_iz00_5191 = (BgL_iz00_1128 - ((long) 1));
																	BgL_iz00_1128 = BgL_iz00_5191;
																	goto BgL_zc3anonymousza32001ze3z83_1129;
																}
														}
												}
											else
												{	/* Unsafe/bignumber.scm 363 */
													return ((bool_t) 0);
												}
										}
									}
							}
					}
				else
					{	/* Unsafe/bignumber.scm 354 */
						bool_t BgL_res3004z00_2994;

						{	/* Unsafe/bignumber.scm 354 */
							unsigned short BgL_arg2015z00_2987;

							{	/* Unsafe/bignumber.scm 354 */
								obj_t BgL_arg1901z00_2990;

								BgL_arg1901z00_2990 = BGL_BIGNUM_U16VECT(BgL_xz00_25);
								BgL_arg2015z00_2987 =
									BGL_U16VREF(BgL_arg1901z00_2990, ((long) 0));
							}
							BgL_res3004z00_2994 =
								((long) (BgL_arg2015z00_2987) == ((long) 0));
						}
						return BgL_res3004z00_2994;
					}
			}
		}
	}



/* $zerobx? */
	BGL_EXPORTED_DEF bool_t BXZERO(obj_t BgL_xz00_33)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 380 */
			{	/* Unsafe/bignumber.scm 381 */
				long BgL_arg2011z00_2996;

				{	/* Unsafe/bignumber.scm 381 */
					obj_t BgL_arg1900z00_2999;

					BgL_arg1900z00_2999 = BGL_BIGNUM_U16VECT(BgL_xz00_33);
					BgL_arg2011z00_2996 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_2999);
				}
				return (BgL_arg2011z00_2996 == ((long) 1));
		}}
	}



/* _$zerobx? */
	obj_t BGl__z42za7erobxzf3z16zz__bignumz00(obj_t BgL_envz00_4663,
		obj_t BgL_xz00_4664)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 380 */
			{	/* Unsafe/bignumber.scm 381 */
				bool_t BgL_auxz00_5200;

				{	/* Unsafe/bignumber.scm 381 */
					obj_t BgL_auxz00_5201;

					if (BIGNUMP(BgL_xz00_4664))
						{	/* Unsafe/bignumber.scm 381 */
							BgL_auxz00_5201 = BgL_xz00_4664;
						}
					else
						{	/* Unsafe/bignumber.scm 381 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3154z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4664, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14262)));
							exit(-1);
						}
					BgL_auxz00_5200 = BXZERO(BgL_auxz00_5201);
				}
				return BBOOL(BgL_auxz00_5200);
			}
		}
	}



/* $negativebx? */
	BGL_EXPORTED_DEF bool_t BXNEGATIVE(obj_t BgL_xz00_34)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 383 */
			{	/* Unsafe/bignumber.scm 384 */
				unsigned short BgL_arg2015z00_3003;

				{	/* Unsafe/bignumber.scm 384 */
					obj_t BgL_arg1901z00_3006;

					BgL_arg1901z00_3006 = BGL_BIGNUM_U16VECT(BgL_xz00_34);
					BgL_arg2015z00_3003 = BGL_U16VREF(BgL_arg1901z00_3006, ((long) 0));
				}
				return ((long) (BgL_arg2015z00_3003) == ((long) 0));
		}}
	}



/* _$negativebx? */
	obj_t BGl__z42negativebxzf3zb1zz__bignumz00(obj_t BgL_envz00_4665,
		obj_t BgL_xz00_4666)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 383 */
			{	/* Unsafe/bignumber.scm 384 */
				bool_t BgL_auxz00_5213;

				{	/* Unsafe/bignumber.scm 384 */
					obj_t BgL_auxz00_5214;

					if (BIGNUMP(BgL_xz00_4666))
						{	/* Unsafe/bignumber.scm 384 */
							BgL_auxz00_5214 = BgL_xz00_4666;
						}
					else
						{	/* Unsafe/bignumber.scm 384 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3156z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4666, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14318)));
							exit(-1);
						}
					BgL_auxz00_5213 = BXNEGATIVE(BgL_auxz00_5214);
				}
				return BBOOL(BgL_auxz00_5213);
			}
		}
	}



/* $positivebx? */
	BGL_EXPORTED_DEF bool_t BXPOSITIVE(obj_t BgL_xz00_35)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 386 */
			{	/* Unsafe/bignumber.scm 387 */
				bool_t BgL_testz00_5222;

				{	/* Unsafe/bignumber.scm 387 */
					bool_t BgL_testz00_5223;

					{	/* Unsafe/bignumber.scm 387 */
						bool_t BgL_res3005z00_3020;

						{	/* Unsafe/bignumber.scm 387 */
							long BgL_arg2011z00_3013;

							{	/* Unsafe/bignumber.scm 387 */
								obj_t BgL_arg1900z00_3016;

								BgL_arg1900z00_3016 = BGL_BIGNUM_U16VECT(BgL_xz00_35);
								BgL_arg2011z00_3013 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3016);
							}
							BgL_res3005z00_3020 = (BgL_arg2011z00_3013 == ((long) 1));
						}
						BgL_testz00_5223 = BgL_res3005z00_3020;
					}
					if (BgL_testz00_5223)
						{	/* Unsafe/bignumber.scm 387 */
							BgL_testz00_5222 = ((bool_t) 1);
						}
					else
						{	/* Unsafe/bignumber.scm 387 */
							bool_t BgL_res3006z00_3029;

							{	/* Unsafe/bignumber.scm 387 */
								unsigned short BgL_arg2015z00_3022;

								{	/* Unsafe/bignumber.scm 387 */
									obj_t BgL_arg1901z00_3025;

									BgL_arg1901z00_3025 = BGL_BIGNUM_U16VECT(BgL_xz00_35);
									BgL_arg2015z00_3022 =
										BGL_U16VREF(BgL_arg1901z00_3025, ((long) 0));
								}
								BgL_res3006z00_3029 =
									((long) (BgL_arg2015z00_3022) == ((long) 0));
							}
							BgL_testz00_5222 = BgL_res3006z00_3029;
				}}
				if (BgL_testz00_5222)
					{	/* Unsafe/bignumber.scm 387 */
						return ((bool_t) 0);
					}
				else
					{	/* Unsafe/bignumber.scm 387 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* _$positivebx? */
	obj_t BGl__z42positivebxzf3zb1zz__bignumz00(obj_t BgL_envz00_4667,
		obj_t BgL_xz00_4668)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 386 */
			{	/* Unsafe/bignumber.scm 387 */
				bool_t BgL_auxz00_5231;

				{	/* Unsafe/bignumber.scm 387 */
					obj_t BgL_auxz00_5232;

					if (BIGNUMP(BgL_xz00_4668))
						{	/* Unsafe/bignumber.scm 387 */
							BgL_auxz00_5232 = BgL_xz00_4668;
						}
					else
						{	/* Unsafe/bignumber.scm 387 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3157z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4668, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14376)));
							exit(-1);
						}
					BgL_auxz00_5231 = BXPOSITIVE(BgL_auxz00_5232);
				}
				return BBOOL(BgL_auxz00_5231);
			}
		}
	}



/* $evenbx? */
	BGL_EXPORTED_DEF bool_t bgl_bignum_even(obj_t BgL_xz00_36)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 389 */
			{	/* Unsafe/bignumber.scm 390 */
				bool_t BgL__ortest_1776z00_3030;

				{	/* Unsafe/bignumber.scm 390 */
					bool_t BgL_res3007z00_3040;

					{	/* Unsafe/bignumber.scm 390 */
						long BgL_arg2011z00_3033;

						{	/* Unsafe/bignumber.scm 390 */
							obj_t BgL_arg1900z00_3036;

							BgL_arg1900z00_3036 = BGL_BIGNUM_U16VECT(BgL_xz00_36);
							BgL_arg2011z00_3033 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3036);
						}
						BgL_res3007z00_3040 = (BgL_arg2011z00_3033 == ((long) 1));
					}
					BgL__ortest_1776z00_3030 = BgL_res3007z00_3040;
				}
				if (BgL__ortest_1776z00_3030)
					{	/* Unsafe/bignumber.scm 390 */
						return BgL__ortest_1776z00_3030;
					}
				else
					{	/* Unsafe/bignumber.scm 390 */
						unsigned short BgL_arg2022z00_3031;

						{	/* Unsafe/bignumber.scm 390 */
							obj_t BgL_arg1905z00_3043;

							BgL_arg1905z00_3043 = BGL_BIGNUM_U16VECT(BgL_xz00_36);
							BgL_arg2022z00_3031 =
								BGL_U16VREF(BgL_arg1905z00_3043, ((long) 1));
						}
						return
							BGl_evenzf3zf3zz__r4_numbers_6_5_fixnumz00(BINT
							(BgL_arg2022z00_3031));
					}
			}
		}
	}



/* _$evenbx? */
	obj_t BGl__z42evenbxzf3zb1zz__bignumz00(obj_t BgL_envz00_4669,
		obj_t BgL_xz00_4670)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 389 */
			{	/* Unsafe/bignumber.scm 390 */
				bool_t BgL_auxz00_5248;

				{	/* Unsafe/bignumber.scm 390 */
					obj_t BgL_auxz00_5249;

					if (BIGNUMP(BgL_xz00_4670))
						{	/* Unsafe/bignumber.scm 390 */
							BgL_auxz00_5249 = BgL_xz00_4670;
						}
					else
						{	/* Unsafe/bignumber.scm 390 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3158z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4670, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14438)));
							exit(-1);
						}
					BgL_auxz00_5248 = bgl_bignum_even(BgL_auxz00_5249);
				}
				return BBOOL(BgL_auxz00_5248);
			}
		}
	}



/* $oddbx? */
	BGL_EXPORTED_DEF bool_t bgl_bignum_odd(obj_t BgL_xz00_37)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 392 */
			{	/* Unsafe/bignumber.scm 393 */
				bool_t BgL_testz00_5257;

				{	/* Unsafe/bignumber.scm 393 */
					bool_t BgL_res3009z00_3057;

					{	/* Unsafe/bignumber.scm 393 */
						bool_t BgL__ortest_1776z00_3046;

						BgL__ortest_1776z00_3046 =
							(BGl_bignumzd2lengthzd2zz__bignumz00(BgL_xz00_37) == ((long) 1));
						if (BgL__ortest_1776z00_3046)
							{	/* Unsafe/bignumber.scm 393 */
								BgL_res3009z00_3057 = BgL__ortest_1776z00_3046;
							}
						else
							{	/* Unsafe/bignumber.scm 393 */
								unsigned short BgL_arg2022z00_3047;

								{	/* Unsafe/bignumber.scm 393 */
									obj_t BgL_arg1905z00_3056;

									BgL_arg1905z00_3056 = BGL_BIGNUM_U16VECT(BgL_xz00_37);
									BgL_arg2022z00_3047 =
										BGL_U16VREF(BgL_arg1905z00_3056, ((long) 1));
								}
								BgL_res3009z00_3057 =
									BGl_evenzf3zf3zz__r4_numbers_6_5_fixnumz00(BINT
									(BgL_arg2022z00_3047));
					}}
					BgL_testz00_5257 = BgL_res3009z00_3057;
				}
				if (BgL_testz00_5257)
					{	/* Unsafe/bignumber.scm 393 */
						return ((bool_t) 0);
					}
				else
					{	/* Unsafe/bignumber.scm 393 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* _$oddbx? */
	obj_t BGl__z42oddbxzf3zb1zz__bignumz00(obj_t BgL_envz00_4671,
		obj_t BgL_xz00_4672)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 392 */
			{	/* Unsafe/bignumber.scm 393 */
				bool_t BgL_auxz00_5265;

				{	/* Unsafe/bignumber.scm 393 */
					obj_t BgL_auxz00_5266;

					if (BIGNUMP(BgL_xz00_4672))
						{	/* Unsafe/bignumber.scm 393 */
							BgL_auxz00_5266 = BgL_xz00_4672;
						}
					else
						{	/* Unsafe/bignumber.scm 393 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3159z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4672, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14508)));
							exit(-1);
						}
					BgL_auxz00_5265 = bgl_bignum_odd(BgL_auxz00_5266);
				}
				return BBOOL(BgL_auxz00_5265);
			}
		}
	}



/* $bignum-cmp */
	BGL_EXPORTED_DEF int bgl_bignum_cmp(obj_t BgL_n1z00_38, obj_t BgL_n2z00_39)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 395 */
			if (BGl_z42zc3bxz81zz__bignumz00(BgL_n1z00_38, BgL_n2z00_39))
				{	/* Unsafe/bignumber.scm 397 */
					return (int) (((long) -1));
				}
			else
				{	/* Unsafe/bignumber.scm 397 */
					if (BGl_z42zc3bxz81zz__bignumz00(BgL_n2z00_39, BgL_n1z00_38))
						{	/* Unsafe/bignumber.scm 397 */
							return (int) (((long) 1));
						}
					else
						{	/* Unsafe/bignumber.scm 397 */
							return (int) (((long) 0));
		}}}
	}



/* _$bignum-cmp */
	obj_t BGl__z42bignumzd2cmpz90zz__bignumz00(obj_t BgL_envz00_4673,
		obj_t BgL_n1z00_4674, obj_t BgL_n2z00_4675)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 395 */
			{	/* Unsafe/bignumber.scm 397 */
				int BgL_auxz00_5281;

				{	/* Unsafe/bignumber.scm 397 */
					obj_t BgL_auxz00_5288;

					obj_t BgL_auxz00_5282;

					if (BIGNUMP(BgL_n2z00_4675))
						{	/* Unsafe/bignumber.scm 397 */
							BgL_auxz00_5288 = BgL_n2z00_4675;
						}
					else
						{	/* Unsafe/bignumber.scm 397 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3160z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_n2z00_4675, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14573)));
							exit(-1);
						}
					if (BIGNUMP(BgL_n1z00_4674))
						{	/* Unsafe/bignumber.scm 397 */
							BgL_auxz00_5282 = BgL_n1z00_4674;
						}
					else
						{	/* Unsafe/bignumber.scm 397 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3160z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_n1z00_4674, BGl_string3147z00zz__bignumz00,
								BINT(((long) 14573)));
							exit(-1);
						}
					BgL_auxz00_5281 = bgl_bignum_cmp(BgL_auxz00_5282, BgL_auxz00_5288);
				}
				return BINT(BgL_auxz00_5281);
			}
		}
	}



/* bignum-add-nonneg */
	obj_t BGl_bignumzd2addzd2nonnegz00zz__bignumz00(obj_t BgL_xz00_40,
		obj_t BgL_yz00_41)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 404 */
			{
				obj_t BgL_xz00_1157;

				obj_t BgL_yz00_1158;

				long BgL_lenxz00_1159;

				long BgL_lenyz00_1160;

				{	/* Unsafe/bignumber.scm 443 */
					long BgL_lenxz00_1154;

					long BgL_lenyz00_1155;

					{	/* Unsafe/bignumber.scm 443 */
						obj_t BgL_arg1900z00_3061;

						BgL_arg1900z00_3061 = BGL_BIGNUM_U16VECT(BgL_xz00_40);
						BgL_lenxz00_1154 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3061);
					}
					{	/* Unsafe/bignumber.scm 444 */
						obj_t BgL_arg1900z00_3064;

						BgL_arg1900z00_3064 = BGL_BIGNUM_U16VECT(BgL_yz00_41);
						BgL_lenyz00_1155 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3064);
					}
					if ((BgL_lenxz00_1154 < BgL_lenyz00_1155))
						{	/* Unsafe/bignumber.scm 445 */
							BgL_xz00_1157 = BgL_yz00_41;
							BgL_yz00_1158 = BgL_xz00_40;
							BgL_lenxz00_1159 = BgL_lenyz00_1155;
							BgL_lenyz00_1160 = BgL_lenxz00_1154;
						BgL_zc3anonymousza32027ze3z83_1161:
							{	/* Unsafe/bignumber.scm 407 */
								obj_t BgL_rz00_1162;

								{	/* Unsafe/bignumber.scm 407 */
									long BgL_arg2056z00_1198;

									BgL_arg2056z00_1198 = (BgL_lenxz00_1159 + ((long) 1));
									{	/* Unsafe/bignumber.scm 407 */
										obj_t BgL_res3010z00_3074;

										{	/* Unsafe/bignumber.scm 407 */
											int BgL_lenz00_3070;

											BgL_lenz00_3070 = (int) (BgL_arg2056z00_1198);
											{	/* Unsafe/bignumber.scm 407 */
												obj_t BgL_arg1898z00_3071;

												{	/* Unsafe/bignumber.scm 407 */

													BgL_arg1898z00_3071 =
														BGl_makezd2u16vectorzd2zz__srfi4z00(
														(long) (BgL_lenz00_3070), BINT(((long) 0)));
												}
												BgL_res3010z00_3074 =
													bgl_make_bignum(BgL_arg1898z00_3071);
										}}
										BgL_rz00_1162 = BgL_res3010z00_3074;
								}}
								{	/* Unsafe/bignumber.scm 409 */
									obj_t BgL_arg1903z00_3078;

									BgL_arg1903z00_3078 = BGL_BIGNUM_U16VECT(BgL_rz00_1162);
									{	/* Unsafe/bignumber.scm 409 */
										unsigned short BgL_auxz00_5309;

										BgL_auxz00_5309 = (unsigned short) (((long) 1));
										BGL_U16VSET(BgL_arg1903z00_3078, ((long) 0),
											BgL_auxz00_5309);
									} BUNSPEC;
								}
								{
									long BgL_iz00_1164;

									long BgL_cz00_1165;

									BgL_iz00_1164 = ((long) 1);
									BgL_cz00_1165 = ((long) 0);
								BgL_zc3anonymousza32028ze3z83_1166:
									if ((BgL_iz00_1164 < BgL_lenyz00_1160))
										{	/* Unsafe/bignumber.scm 414 */
											long BgL_wz00_1168;

											{	/* Unsafe/bignumber.scm 414 */
												long BgL_arg2041z00_1177;

												{	/* Unsafe/bignumber.scm 414 */
													unsigned short BgL_arg2042z00_1178;

													unsigned short BgL_arg2043z00_1179;

													{	/* Unsafe/bignumber.scm 414 */
														int BgL_iz00_3083;

														BgL_iz00_3083 = (int) (BgL_iz00_1164);
														{	/* Unsafe/bignumber.scm 414 */
															obj_t BgL_arg1905z00_3084;

															BgL_arg1905z00_3084 =
																BGL_BIGNUM_U16VECT(BgL_xz00_1157);
															{	/* Unsafe/bignumber.scm 414 */
																long BgL_auxz00_5316;

																BgL_auxz00_5316 = (long) (BgL_iz00_3083);
																BgL_arg2042z00_1178 =
																	BGL_U16VREF(BgL_arg1905z00_3084,
																	BgL_auxz00_5316);
													}}}
													{	/* Unsafe/bignumber.scm 415 */
														int BgL_iz00_3086;

														BgL_iz00_3086 = (int) (BgL_iz00_1164);
														{	/* Unsafe/bignumber.scm 415 */
															obj_t BgL_arg1905z00_3087;

															BgL_arg1905z00_3087 =
																BGL_BIGNUM_U16VECT(BgL_yz00_1158);
															{	/* Unsafe/bignumber.scm 415 */
																long BgL_auxz00_5321;

																BgL_auxz00_5321 = (long) (BgL_iz00_3086);
																BgL_arg2043z00_1179 =
																	BGL_U16VREF(BgL_arg1905z00_3087,
																	BgL_auxz00_5321);
													}}}
													BgL_arg2041z00_1177 =
														(
														(long) (BgL_arg2042z00_1178) +
														(long) (BgL_arg2043z00_1179));
												}
												BgL_wz00_1168 = (BgL_arg2041z00_1177 + BgL_cz00_1165);
											}
											if ((BgL_wz00_1168 < (((long) 1) << (int) (((long) 14)))))
												{	/* Unsafe/bignumber.scm 417 */
													{	/* Unsafe/bignumber.scm 419 */
														int BgL_iz00_3097;

														int BgL_digitz00_3098;

														BgL_iz00_3097 = (int) (BgL_iz00_1164);
														BgL_digitz00_3098 = (int) (BgL_wz00_1168);
														{	/* Unsafe/bignumber.scm 419 */
															obj_t BgL_arg1906z00_3099;

															BgL_arg1906z00_3099 =
																BGL_BIGNUM_U16VECT(BgL_rz00_1162);
															{	/* Unsafe/bignumber.scm 419 */
																unsigned short BgL_auxz00_5337;

																long BgL_auxz00_5335;

																BgL_auxz00_5337 =
																	(unsigned short) (BgL_digitz00_3098);
																BgL_auxz00_5335 = (long) (BgL_iz00_3097);
																BGL_U16VSET(BgL_arg1906z00_3099,
																	BgL_auxz00_5335, BgL_auxz00_5337);
															} BUNSPEC;
													}}
													{
														long BgL_cz00_5342;

														long BgL_iz00_5340;

														BgL_iz00_5340 = (BgL_iz00_1164 + ((long) 1));
														BgL_cz00_5342 = ((long) 0);
														BgL_cz00_1165 = BgL_cz00_5342;
														BgL_iz00_1164 = BgL_iz00_5340;
														goto BgL_zc3anonymousza32028ze3z83_1166;
													}
												}
											else
												{	/* Unsafe/bignumber.scm 417 */
													{	/* Unsafe/bignumber.scm 422 */
														long BgL_arg2033z00_1172;

														BgL_arg2033z00_1172 =
															(BgL_wz00_1168 -
															(((long) 1) << (int) (((long) 14))));
														{	/* Unsafe/bignumber.scm 422 */
															int BgL_iz00_3107;

															int BgL_digitz00_3108;

															BgL_iz00_3107 = (int) (BgL_iz00_1164);
															BgL_digitz00_3108 = (int) (BgL_arg2033z00_1172);
															{	/* Unsafe/bignumber.scm 422 */
																obj_t BgL_arg1906z00_3109;

																BgL_arg1906z00_3109 =
																	BGL_BIGNUM_U16VECT(BgL_rz00_1162);
																{	/* Unsafe/bignumber.scm 422 */
																	unsigned short BgL_auxz00_5351;

																	long BgL_auxz00_5349;

																	BgL_auxz00_5351 =
																		(unsigned short) (BgL_digitz00_3108);
																	BgL_auxz00_5349 = (long) (BgL_iz00_3107);
																	BGL_U16VSET(BgL_arg1906z00_3109,
																		BgL_auxz00_5349, BgL_auxz00_5351);
																} BUNSPEC;
													}}}
													{
														long BgL_cz00_5356;

														long BgL_iz00_5354;

														BgL_iz00_5354 = (BgL_iz00_1164 + ((long) 1));
														BgL_cz00_5356 = ((long) 1);
														BgL_cz00_1165 = BgL_cz00_5356;
														BgL_iz00_1164 = BgL_iz00_5354;
														goto BgL_zc3anonymousza32028ze3z83_1166;
													}
												}
										}
									else
										{
											long BgL_iz00_1181;

											long BgL_cz00_1182;

											BgL_iz00_1181 = BgL_iz00_1164;
											BgL_cz00_1182 = BgL_cz00_1165;
										BgL_zc3anonymousza32044ze3z83_1183:
											if ((BgL_iz00_1181 < BgL_lenxz00_1159))
												{	/* Unsafe/bignumber.scm 428 */
													long BgL_wz00_1185;

													{	/* Unsafe/bignumber.scm 428 */
														unsigned short BgL_arg2054z00_1194;

														{	/* Unsafe/bignumber.scm 428 */
															int BgL_iz00_3115;

															BgL_iz00_3115 = (int) (BgL_iz00_1181);
															{	/* Unsafe/bignumber.scm 428 */
																obj_t BgL_arg1905z00_3116;

																BgL_arg1905z00_3116 =
																	BGL_BIGNUM_U16VECT(BgL_xz00_1157);
																{	/* Unsafe/bignumber.scm 428 */
																	long BgL_auxz00_5361;

																	BgL_auxz00_5361 = (long) (BgL_iz00_3115);
																	BgL_arg2054z00_1194 =
																		BGL_U16VREF(BgL_arg1905z00_3116,
																		BgL_auxz00_5361);
														}}}
														BgL_wz00_1185 =
															((long) (BgL_arg2054z00_1194) + BgL_cz00_1182);
													}
													if (
														(BgL_wz00_1185 <
															(((long) 1) << (int) (((long) 14)))))
														{	/* Unsafe/bignumber.scm 429 */
															{	/* Unsafe/bignumber.scm 431 */
																int BgL_iz00_3124;

																int BgL_digitz00_3125;

																BgL_iz00_3124 = (int) (BgL_iz00_1181);
																BgL_digitz00_3125 = (int) (BgL_wz00_1185);
																{	/* Unsafe/bignumber.scm 431 */
																	obj_t BgL_arg1906z00_3126;

																	BgL_arg1906z00_3126 =
																		BGL_BIGNUM_U16VECT(BgL_rz00_1162);
																	{	/* Unsafe/bignumber.scm 431 */
																		unsigned short BgL_auxz00_5375;

																		long BgL_auxz00_5373;

																		BgL_auxz00_5375 =
																			(unsigned short) (BgL_digitz00_3125);
																		BgL_auxz00_5373 = (long) (BgL_iz00_3124);
																		BGL_U16VSET(BgL_arg1906z00_3126,
																			BgL_auxz00_5373, BgL_auxz00_5375);
																	} BUNSPEC;
															}}
															{
																long BgL_cz00_5380;

																long BgL_iz00_5378;

																BgL_iz00_5378 = (BgL_iz00_1181 + ((long) 1));
																BgL_cz00_5380 = ((long) 0);
																BgL_cz00_1182 = BgL_cz00_5380;
																BgL_iz00_1181 = BgL_iz00_5378;
																goto BgL_zc3anonymousza32044ze3z83_1183;
															}
														}
													else
														{	/* Unsafe/bignumber.scm 429 */
															{	/* Unsafe/bignumber.scm 434 */
																long BgL_arg2049z00_1189;

																BgL_arg2049z00_1189 =
																	(BgL_wz00_1185 -
																	(((long) 1) << (int) (((long) 14))));
																{	/* Unsafe/bignumber.scm 434 */
																	int BgL_iz00_3134;

																	int BgL_digitz00_3135;

																	BgL_iz00_3134 = (int) (BgL_iz00_1181);
																	BgL_digitz00_3135 =
																		(int) (BgL_arg2049z00_1189);
																	{	/* Unsafe/bignumber.scm 434 */
																		obj_t BgL_arg1906z00_3136;

																		BgL_arg1906z00_3136 =
																			BGL_BIGNUM_U16VECT(BgL_rz00_1162);
																		{	/* Unsafe/bignumber.scm 434 */
																			unsigned short BgL_auxz00_5389;

																			long BgL_auxz00_5387;

																			BgL_auxz00_5389 =
																				(unsigned short) (BgL_digitz00_3135);
																			BgL_auxz00_5387 = (long) (BgL_iz00_3134);
																			BGL_U16VSET(BgL_arg1906z00_3136,
																				BgL_auxz00_5387, BgL_auxz00_5389);
																		} BUNSPEC;
															}}}
															{
																long BgL_cz00_5394;

																long BgL_iz00_5392;

																BgL_iz00_5392 = (BgL_iz00_1181 + ((long) 1));
																BgL_cz00_5394 = ((long) 1);
																BgL_cz00_1182 = BgL_cz00_5394;
																BgL_iz00_1181 = BgL_iz00_5392;
																goto BgL_zc3anonymousza32044ze3z83_1183;
															}
														}
												}
											else
												{	/* Unsafe/bignumber.scm 426 */
													if ((BgL_cz00_1182 == ((long) 0)))
														{	/* Unsafe/bignumber.scm 437 */
															return
																BGl_bignumzd2shrinkzd2zz__bignumz00
																(BgL_rz00_1162, BgL_lenxz00_1159);
														}
													else
														{	/* Unsafe/bignumber.scm 437 */
															{	/* Unsafe/bignumber.scm 440 */
																int BgL_iz00_3142;

																int BgL_digitz00_3143;

																BgL_iz00_3142 = (int) (BgL_lenxz00_1159);
																BgL_digitz00_3143 = (int) (BgL_cz00_1182);
																{	/* Unsafe/bignumber.scm 440 */
																	obj_t BgL_arg1906z00_3144;

																	BgL_arg1906z00_3144 =
																		BGL_BIGNUM_U16VECT(BgL_rz00_1162);
																	{	/* Unsafe/bignumber.scm 440 */
																		unsigned short BgL_auxz00_5403;

																		long BgL_auxz00_5401;

																		BgL_auxz00_5403 =
																			(unsigned short) (BgL_digitz00_3143);
																		BgL_auxz00_5401 = (long) (BgL_iz00_3142);
																		BGL_U16VSET(BgL_arg1906z00_3144,
																			BgL_auxz00_5401, BgL_auxz00_5403);
																	} BUNSPEC;
															}}
															return BgL_rz00_1162;
														}
												}
										}
								}
							}
						}
					else
						{
							long BgL_lenyz00_5409;

							long BgL_lenxz00_5408;

							obj_t BgL_yz00_5407;

							obj_t BgL_xz00_5406;

							BgL_xz00_5406 = BgL_xz00_40;
							BgL_yz00_5407 = BgL_yz00_41;
							BgL_lenxz00_5408 = BgL_lenxz00_1154;
							BgL_lenyz00_5409 = BgL_lenyz00_1155;
							BgL_lenyz00_1160 = BgL_lenyz00_5409;
							BgL_lenxz00_1159 = BgL_lenxz00_5408;
							BgL_yz00_1158 = BgL_yz00_5407;
							BgL_xz00_1157 = BgL_xz00_5406;
							goto BgL_zc3anonymousza32027ze3z83_1161;
						}
				}
			}
		}
	}



/* bignum-sub-nonneg */
	obj_t BGl_bignumzd2subzd2nonnegz00zz__bignumz00(obj_t BgL_xz00_42,
		obj_t BgL_yz00_43)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 449 */
			{
				obj_t BgL_rz00_1243;

				obj_t BgL_xz00_1204;

				obj_t BgL_yz00_1205;

				long BgL_lenxz00_1206;

				long BgL_lenyz00_1207;

				{	/* Unsafe/bignumber.scm 502 */
					long BgL_arg2057z00_1202;

					long BgL_arg2058z00_1203;

					{	/* Unsafe/bignumber.scm 502 */
						obj_t BgL_arg1900z00_3146;

						BgL_arg1900z00_3146 = BGL_BIGNUM_U16VECT(BgL_xz00_42);
						BgL_arg2057z00_1202 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3146);
					}
					{	/* Unsafe/bignumber.scm 502 */
						obj_t BgL_arg1900z00_3149;

						BgL_arg1900z00_3149 = BGL_BIGNUM_U16VECT(BgL_yz00_43);
						BgL_arg2058z00_1203 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3149);
					}
					BgL_xz00_1204 = BgL_xz00_42;
					BgL_yz00_1205 = BgL_yz00_43;
					BgL_lenxz00_1206 = BgL_arg2057z00_1202;
					BgL_lenyz00_1207 = BgL_arg2058z00_1203;
					{	/* Unsafe/bignumber.scm 466 */
						obj_t BgL_rz00_1209;

						{	/* Unsafe/bignumber.scm 466 */
							obj_t BgL_res3011z00_3155;

							{	/* Unsafe/bignumber.scm 466 */
								int BgL_lenz00_3151;

								BgL_lenz00_3151 = (int) (BgL_lenxz00_1206);
								{	/* Unsafe/bignumber.scm 466 */
									obj_t BgL_arg1898z00_3152;

									{	/* Unsafe/bignumber.scm 466 */

										BgL_arg1898z00_3152 =
											BGl_makezd2u16vectorzd2zz__srfi4z00(
											(long) (BgL_lenz00_3151), BINT(((long) 0)));
									}
									BgL_res3011z00_3155 = bgl_make_bignum(BgL_arg1898z00_3152);
							}}
							BgL_rz00_1209 = BgL_res3011z00_3155;
						}
						{
							long BgL_iz00_1211;

							long BgL_bz00_1212;

							BgL_iz00_1211 = ((long) 1);
							BgL_bz00_1212 = ((long) 0);
						BgL_zc3anonymousza32060ze3z83_1213:
							if ((BgL_iz00_1211 < BgL_lenyz00_1207))
								{	/* Unsafe/bignumber.scm 471 */
									long BgL_wz00_1215;

									{	/* Unsafe/bignumber.scm 471 */
										long BgL_arg2072z00_1223;

										{	/* Unsafe/bignumber.scm 471 */
											unsigned short BgL_arg2073z00_1224;

											unsigned short BgL_arg2074z00_1225;

											{	/* Unsafe/bignumber.scm 471 */
												int BgL_iz00_3159;

												BgL_iz00_3159 = (int) (BgL_iz00_1211);
												{	/* Unsafe/bignumber.scm 471 */
													obj_t BgL_arg1905z00_3160;

													BgL_arg1905z00_3160 =
														BGL_BIGNUM_U16VECT(BgL_xz00_1204);
													{	/* Unsafe/bignumber.scm 471 */
														long BgL_auxz00_5423;

														BgL_auxz00_5423 = (long) (BgL_iz00_3159);
														BgL_arg2073z00_1224 =
															BGL_U16VREF(BgL_arg1905z00_3160, BgL_auxz00_5423);
											}}}
											{	/* Unsafe/bignumber.scm 472 */
												int BgL_iz00_3162;

												BgL_iz00_3162 = (int) (BgL_iz00_1211);
												{	/* Unsafe/bignumber.scm 472 */
													obj_t BgL_arg1905z00_3163;

													BgL_arg1905z00_3163 =
														BGL_BIGNUM_U16VECT(BgL_yz00_1205);
													{	/* Unsafe/bignumber.scm 472 */
														long BgL_auxz00_5428;

														BgL_auxz00_5428 = (long) (BgL_iz00_3162);
														BgL_arg2074z00_1225 =
															BGL_U16VREF(BgL_arg1905z00_3163, BgL_auxz00_5428);
											}}}
											BgL_arg2072z00_1223 =
												(
												(long) (BgL_arg2073z00_1224) -
												(long) (BgL_arg2074z00_1225));
										}
										BgL_wz00_1215 = (BgL_arg2072z00_1223 - BgL_bz00_1212);
									}
									if ((BgL_wz00_1215 < ((long) 0)))
										{	/* Unsafe/bignumber.scm 474 */
											{	/* Unsafe/bignumber.scm 476 */
												long BgL_arg2063z00_1217;

												BgL_arg2063z00_1217 =
													(BgL_wz00_1215 + (((long) 1) << (int) (((long) 14))));
												{	/* Unsafe/bignumber.scm 476 */
													int BgL_iz00_3175;

													int BgL_digitz00_3176;

													BgL_iz00_3175 = (int) (BgL_iz00_1211);
													BgL_digitz00_3176 = (int) (BgL_arg2063z00_1217);
													{	/* Unsafe/bignumber.scm 476 */
														obj_t BgL_arg1906z00_3177;

														BgL_arg1906z00_3177 =
															BGL_BIGNUM_U16VECT(BgL_rz00_1209);
														{	/* Unsafe/bignumber.scm 476 */
															unsigned short BgL_auxz00_5445;

															long BgL_auxz00_5443;

															BgL_auxz00_5445 =
																(unsigned short) (BgL_digitz00_3176);
															BgL_auxz00_5443 = (long) (BgL_iz00_3175);
															BGL_U16VSET(BgL_arg1906z00_3177, BgL_auxz00_5443,
																BgL_auxz00_5445);
														} BUNSPEC;
											}}}
											{
												long BgL_bz00_5450;

												long BgL_iz00_5448;

												BgL_iz00_5448 = (BgL_iz00_1211 + ((long) 1));
												BgL_bz00_5450 = ((long) 1);
												BgL_bz00_1212 = BgL_bz00_5450;
												BgL_iz00_1211 = BgL_iz00_5448;
												goto BgL_zc3anonymousza32060ze3z83_1213;
											}
										}
									else
										{	/* Unsafe/bignumber.scm 474 */
											{	/* Unsafe/bignumber.scm 479 */
												int BgL_iz00_3181;

												int BgL_digitz00_3182;

												BgL_iz00_3181 = (int) (BgL_iz00_1211);
												BgL_digitz00_3182 = (int) (BgL_wz00_1215);
												{	/* Unsafe/bignumber.scm 479 */
													obj_t BgL_arg1906z00_3183;

													BgL_arg1906z00_3183 =
														BGL_BIGNUM_U16VECT(BgL_rz00_1209);
													{	/* Unsafe/bignumber.scm 479 */
														unsigned short BgL_auxz00_5456;

														long BgL_auxz00_5454;

														BgL_auxz00_5456 =
															(unsigned short) (BgL_digitz00_3182);
														BgL_auxz00_5454 = (long) (BgL_iz00_3181);
														BGL_U16VSET(BgL_arg1906z00_3183, BgL_auxz00_5454,
															BgL_auxz00_5456);
													} BUNSPEC;
											}}
											{
												long BgL_bz00_5461;

												long BgL_iz00_5459;

												BgL_iz00_5459 = (BgL_iz00_1211 + ((long) 1));
												BgL_bz00_5461 = ((long) 0);
												BgL_bz00_1212 = BgL_bz00_5461;
												BgL_iz00_1211 = BgL_iz00_5459;
												goto BgL_zc3anonymousza32060ze3z83_1213;
											}
										}
								}
							else
								{
									long BgL_iz00_1227;

									long BgL_bz00_1228;

									BgL_iz00_1227 = BgL_iz00_1211;
									BgL_bz00_1228 = BgL_bz00_1212;
								BgL_zc3anonymousza32075ze3z83_1229:
									if ((BgL_iz00_1227 < BgL_lenxz00_1206))
										{	/* Unsafe/bignumber.scm 485 */
											long BgL_wz00_1231;

											{	/* Unsafe/bignumber.scm 485 */
												unsigned short BgL_arg2085z00_1239;

												{	/* Unsafe/bignumber.scm 485 */
													int BgL_iz00_3189;

													BgL_iz00_3189 = (int) (BgL_iz00_1227);
													{	/* Unsafe/bignumber.scm 485 */
														obj_t BgL_arg1905z00_3190;

														BgL_arg1905z00_3190 =
															BGL_BIGNUM_U16VECT(BgL_xz00_1204);
														{	/* Unsafe/bignumber.scm 485 */
															long BgL_auxz00_5466;

															BgL_auxz00_5466 = (long) (BgL_iz00_3189);
															BgL_arg2085z00_1239 =
																BGL_U16VREF(BgL_arg1905z00_3190,
																BgL_auxz00_5466);
												}}}
												BgL_wz00_1231 =
													((long) (BgL_arg2085z00_1239) - BgL_bz00_1228);
											}
											if ((BgL_wz00_1231 < ((long) 0)))
												{	/* Unsafe/bignumber.scm 486 */
													{	/* Unsafe/bignumber.scm 488 */
														long BgL_arg2079z00_1233;

														BgL_arg2079z00_1233 =
															(BgL_wz00_1231 +
															(((long) 1) << (int) (((long) 14))));
														{	/* Unsafe/bignumber.scm 488 */
															int BgL_iz00_3200;

															int BgL_digitz00_3201;

															BgL_iz00_3200 = (int) (BgL_iz00_1227);
															BgL_digitz00_3201 = (int) (BgL_arg2079z00_1233);
															{	/* Unsafe/bignumber.scm 488 */
																obj_t BgL_arg1906z00_3202;

																BgL_arg1906z00_3202 =
																	BGL_BIGNUM_U16VECT(BgL_rz00_1209);
																{	/* Unsafe/bignumber.scm 488 */
																	unsigned short BgL_auxz00_5481;

																	long BgL_auxz00_5479;

																	BgL_auxz00_5481 =
																		(unsigned short) (BgL_digitz00_3201);
																	BgL_auxz00_5479 = (long) (BgL_iz00_3200);
																	BGL_U16VSET(BgL_arg1906z00_3202,
																		BgL_auxz00_5479, BgL_auxz00_5481);
																} BUNSPEC;
													}}}
													{
														long BgL_bz00_5486;

														long BgL_iz00_5484;

														BgL_iz00_5484 = (BgL_iz00_1227 + ((long) 1));
														BgL_bz00_5486 = ((long) 1);
														BgL_bz00_1228 = BgL_bz00_5486;
														BgL_iz00_1227 = BgL_iz00_5484;
														goto BgL_zc3anonymousza32075ze3z83_1229;
													}
												}
											else
												{	/* Unsafe/bignumber.scm 486 */
													{	/* Unsafe/bignumber.scm 491 */
														int BgL_iz00_3206;

														int BgL_digitz00_3207;

														BgL_iz00_3206 = (int) (BgL_iz00_1227);
														BgL_digitz00_3207 = (int) (BgL_wz00_1231);
														{	/* Unsafe/bignumber.scm 491 */
															obj_t BgL_arg1906z00_3208;

															BgL_arg1906z00_3208 =
																BGL_BIGNUM_U16VECT(BgL_rz00_1209);
															{	/* Unsafe/bignumber.scm 491 */
																unsigned short BgL_auxz00_5492;

																long BgL_auxz00_5490;

																BgL_auxz00_5492 =
																	(unsigned short) (BgL_digitz00_3207);
																BgL_auxz00_5490 = (long) (BgL_iz00_3206);
																BGL_U16VSET(BgL_arg1906z00_3208,
																	BgL_auxz00_5490, BgL_auxz00_5492);
															} BUNSPEC;
													}}
													{
														long BgL_bz00_5497;

														long BgL_iz00_5495;

														BgL_iz00_5495 = (BgL_iz00_1227 + ((long) 1));
														BgL_bz00_5497 = ((long) 0);
														BgL_bz00_1228 = BgL_bz00_5497;
														BgL_iz00_1227 = BgL_iz00_5495;
														goto BgL_zc3anonymousza32075ze3z83_1229;
													}
												}
										}
									else
										{	/* Unsafe/bignumber.scm 483 */
											if ((BgL_bz00_1228 == ((long) 0)))
												{	/* Unsafe/bignumber.scm 495 */
													obj_t BgL_arg1903z00_3216;

													BgL_arg1903z00_3216 =
														BGL_BIGNUM_U16VECT(BgL_rz00_1209);
													{	/* Unsafe/bignumber.scm 495 */
														unsigned short BgL_auxz00_5501;

														BgL_auxz00_5501 = (unsigned short) (((long) 1));
														BGL_U16VSET(BgL_arg1903z00_3216, ((long) 0),
															BgL_auxz00_5501);
													} BUNSPEC;
												}
											else
												{	/* Unsafe/bignumber.scm 494 */
													{	/* Unsafe/bignumber.scm 497 */
														obj_t BgL_arg1903z00_3221;

														BgL_arg1903z00_3221 =
															BGL_BIGNUM_U16VECT(BgL_rz00_1209);
														{	/* Unsafe/bignumber.scm 497 */
															unsigned short BgL_auxz00_5505;

															BgL_auxz00_5505 = (unsigned short) (((long) 0));
															BGL_U16VSET(BgL_arg1903z00_3221, ((long) 0),
																BgL_auxz00_5505);
														} BUNSPEC;
													}
													{	/* Unsafe/bignumber.scm 498 */
														bool_t BgL_auxz00_5508;

														BgL_rz00_1243 = BgL_rz00_1209;
														{	/* Unsafe/bignumber.scm 452 */
															long BgL_lrz00_1245;

															{	/* Unsafe/bignumber.scm 452 */
																obj_t BgL_arg1900z00_3224;

																BgL_arg1900z00_3224 =
																	BGL_BIGNUM_U16VECT(BgL_rz00_1243);
																BgL_lrz00_1245 =
																	BGL_HVECTOR_LENGTH(BgL_arg1900z00_3224);
															}
															{
																long BgL_iz00_1247;

																long BgL_cz00_1248;

																BgL_iz00_1247 = ((long) 1);
																BgL_cz00_1248 = ((long) 0);
															BgL_zc3anonymousza32088ze3z83_1249:
																if ((BgL_iz00_1247 < BgL_lrz00_1245))
																	{	/* Unsafe/bignumber.scm 456 */
																		long BgL_wz00_1251;

																		{	/* Unsafe/bignumber.scm 456 */
																			unsigned short BgL_arg2099z00_1259;

																			{	/* Unsafe/bignumber.scm 456 */
																				int BgL_iz00_3229;

																				BgL_iz00_3229 = (int) (BgL_iz00_1247);
																				{	/* Unsafe/bignumber.scm 456 */
																					obj_t BgL_arg1905z00_3230;

																					BgL_arg1905z00_3230 =
																						BGL_BIGNUM_U16VECT(BgL_rz00_1243);
																					{	/* Unsafe/bignumber.scm 456 */
																						long BgL_auxz00_5515;

																						BgL_auxz00_5515 =
																							(long) (BgL_iz00_3229);
																						BgL_arg2099z00_1259 =
																							BGL_U16VREF(BgL_arg1905z00_3230,
																							BgL_auxz00_5515);
																			}}}
																			BgL_wz00_1251 =
																				(
																				(long) (BgL_arg2099z00_1259) +
																				BgL_cz00_1248);
																		}
																		if ((((long) 0) < BgL_wz00_1251))
																			{	/* Unsafe/bignumber.scm 457 */
																				{	/* Unsafe/bignumber.scm 459 */
																					long BgL_arg2091z00_1253;

																					BgL_arg2091z00_1253 =
																						(
																						(((long) 1) <<
																							(int) (((long) 14))) -
																						BgL_wz00_1251);
																					{	/* Unsafe/bignumber.scm 459 */
																						int BgL_iz00_3240;

																						int BgL_digitz00_3241;

																						BgL_iz00_3240 =
																							(int) (BgL_iz00_1247);
																						BgL_digitz00_3241 =
																							(int) (BgL_arg2091z00_1253);
																						{	/* Unsafe/bignumber.scm 459 */
																							obj_t BgL_arg1906z00_3242;

																							BgL_arg1906z00_3242 =
																								BGL_BIGNUM_U16VECT
																								(BgL_rz00_1243);
																							{	/* Unsafe/bignumber.scm 459 */
																								unsigned short BgL_auxz00_5530;

																								long BgL_auxz00_5528;

																								BgL_auxz00_5530 =
																									(unsigned
																									short) (BgL_digitz00_3241);
																								BgL_auxz00_5528 =
																									(long) (BgL_iz00_3240);
																								BGL_U16VSET(BgL_arg1906z00_3242,
																									BgL_auxz00_5528,
																									BgL_auxz00_5530);
																							} BUNSPEC;
																				}}}
																				{
																					long BgL_cz00_5535;

																					long BgL_iz00_5533;

																					BgL_iz00_5533 =
																						(BgL_iz00_1247 + ((long) 1));
																					BgL_cz00_5535 = ((long) 1);
																					BgL_cz00_1248 = BgL_cz00_5535;
																					BgL_iz00_1247 = BgL_iz00_5533;
																					goto
																						BgL_zc3anonymousza32088ze3z83_1249;
																				}
																			}
																		else
																			{	/* Unsafe/bignumber.scm 457 */
																				{	/* Unsafe/bignumber.scm 462 */
																					int BgL_iz00_3246;

																					BgL_iz00_3246 = (int) (BgL_iz00_1247);
																					{	/* Unsafe/bignumber.scm 462 */
																						obj_t BgL_arg1906z00_3248;

																						BgL_arg1906z00_3248 =
																							BGL_BIGNUM_U16VECT(BgL_rz00_1243);
																						{	/* Unsafe/bignumber.scm 462 */
																							unsigned short BgL_auxz00_5540;

																							long BgL_auxz00_5538;

																							BgL_auxz00_5540 =
																								(unsigned short) (((long) 0));
																							BgL_auxz00_5538 =
																								(long) (BgL_iz00_3246);
																							BGL_U16VSET(BgL_arg1906z00_3248,
																								BgL_auxz00_5538,
																								BgL_auxz00_5540);
																						} BUNSPEC;
																				}}
																				{
																					long BgL_cz00_5545;

																					long BgL_iz00_5543;

																					BgL_iz00_5543 =
																						(BgL_iz00_1247 + ((long) 1));
																					BgL_cz00_5545 = ((long) 0);
																					BgL_cz00_1248 = BgL_cz00_5545;
																					BgL_iz00_1247 = BgL_iz00_5543;
																					goto
																						BgL_zc3anonymousza32088ze3z83_1249;
																				}
																			}
																	}
																else
																	{	/* Unsafe/bignumber.scm 454 */
																		BgL_auxz00_5508 = ((bool_t) 0);
																	}
															}
														}
														BBOOL(BgL_auxz00_5508);
													}
												}
										}
								}
						}
						return
							BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
							(BgL_rz00_1209);
					}
				}
			}
		}
	}



/* bignum-sum2 */
	obj_t BGl_bignumzd2sum2zd2zz__bignumz00(obj_t BgL_xz00_44, obj_t BgL_yz00_45,
		unsigned short BgL_signzd2xzd2_46, obj_t BgL_signzd2yzd2_47)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 504 */
			if (((long) (BgL_signzd2xzd2_46) == (long) CINT(BgL_signzd2yzd2_47)))
				{	/* Unsafe/bignumber.scm 513 */
					obj_t BgL_arg2101z00_1265;

					BgL_arg2101z00_1265 =
						BGl_bignumzd2addzd2nonnegz00zz__bignumz00(BgL_xz00_44, BgL_yz00_45);
					{	/* Unsafe/bignumber.scm 513 */
						bool_t BgL_testz00_5553;

						{	/* Unsafe/bignumber.scm 513 */
							unsigned short BgL_arg2109z00_3256;

							{	/* Unsafe/bignumber.scm 513 */
								obj_t BgL_arg1901z00_3259;

								BgL_arg1901z00_3259 = BGL_BIGNUM_U16VECT(BgL_arg2101z00_1265);
								BgL_arg2109z00_3256 =
									BGL_U16VREF(BgL_arg1901z00_3259, ((long) 0));
							}
							BgL_testz00_5553 =
								((long) (BgL_arg2109z00_3256) == (long) (BgL_signzd2xzd2_46));
						}
						if (BgL_testz00_5553)
							{	/* Unsafe/bignumber.scm 513 */
								BGl_bignumzd2signzd2setz12z12zz__bignumz00(BgL_arg2101z00_1265,
									(int) (((long) 1)));
							}
						else
							{	/* Unsafe/bignumber.scm 513 */
								BGl_bignumzd2signzd2setz12z12zz__bignumz00(BgL_arg2101z00_1265,
									(int) (((long) 0)));
					}}
					return
						BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
						(BgL_arg2101z00_1265);
				}
			else
				{	/* Unsafe/bignumber.scm 514 */
					bool_t BgL_testz00_5564;

					{	/* Unsafe/bignumber.scm 514 */
						long BgL_arg2105z00_1269;

						long BgL_arg2106z00_1270;

						{	/* Unsafe/bignumber.scm 514 */
							obj_t BgL_arg1900z00_3267;

							BgL_arg1900z00_3267 = BGL_BIGNUM_U16VECT(BgL_xz00_44);
							BgL_arg2105z00_1269 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3267);
						}
						{	/* Unsafe/bignumber.scm 514 */
							obj_t BgL_arg1900z00_3270;

							BgL_arg1900z00_3270 = BGL_BIGNUM_U16VECT(BgL_yz00_45);
							BgL_arg2106z00_1270 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3270);
						}
						BgL_testz00_5564 = (BgL_arg2105z00_1269 < BgL_arg2106z00_1270);
					}
					if (BgL_testz00_5564)
						{	/* Unsafe/bignumber.scm 515 */
							obj_t BgL_arg2103z00_1267;

							BgL_arg2103z00_1267 =
								BGl_bignumzd2subzd2nonnegz00zz__bignumz00(BgL_yz00_45,
								BgL_xz00_44);
							{	/* Unsafe/bignumber.scm 515 */
								bool_t BgL_testz00_5571;

								{	/* Unsafe/bignumber.scm 515 */
									unsigned short BgL_arg2109z00_3277;

									{	/* Unsafe/bignumber.scm 515 */
										obj_t BgL_arg1901z00_3280;

										BgL_arg1901z00_3280 =
											BGL_BIGNUM_U16VECT(BgL_arg2103z00_1267);
										BgL_arg2109z00_3277 =
											BGL_U16VREF(BgL_arg1901z00_3280, ((long) 0));
									}
									BgL_testz00_5571 =
										(
										(long) (BgL_arg2109z00_3277) ==
										(long) CINT(BgL_signzd2yzd2_47));
								}
								if (BgL_testz00_5571)
									{	/* Unsafe/bignumber.scm 515 */
										BGl_bignumzd2signzd2setz12z12zz__bignumz00
											(BgL_arg2103z00_1267, (int) (((long) 1)));
									}
								else
									{	/* Unsafe/bignumber.scm 515 */
										BGl_bignumzd2signzd2setz12z12zz__bignumz00
											(BgL_arg2103z00_1267, (int) (((long) 0)));
							}}
							return
								BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
								(BgL_arg2103z00_1267);
						}
					else
						{	/* Unsafe/bignumber.scm 517 */
							obj_t BgL_arg2104z00_1268;

							BgL_arg2104z00_1268 =
								BGl_bignumzd2subzd2nonnegz00zz__bignumz00(BgL_xz00_44,
								BgL_yz00_45);
							{	/* Unsafe/bignumber.scm 517 */
								bool_t BgL_testz00_5583;

								{	/* Unsafe/bignumber.scm 517 */
									unsigned short BgL_arg2109z00_3290;

									{	/* Unsafe/bignumber.scm 517 */
										obj_t BgL_arg1901z00_3293;

										BgL_arg1901z00_3293 =
											BGL_BIGNUM_U16VECT(BgL_arg2104z00_1268);
										BgL_arg2109z00_3290 =
											BGL_U16VREF(BgL_arg1901z00_3293, ((long) 0));
									}
									BgL_testz00_5583 =
										(
										(long) (BgL_arg2109z00_3290) ==
										(long) (BgL_signzd2xzd2_46));
								}
								if (BgL_testz00_5583)
									{	/* Unsafe/bignumber.scm 517 */
										BGl_bignumzd2signzd2setz12z12zz__bignumz00
											(BgL_arg2104z00_1268, (int) (((long) 1)));
									}
								else
									{	/* Unsafe/bignumber.scm 517 */
										BGl_bignumzd2signzd2setz12z12zz__bignumz00
											(BgL_arg2104z00_1268, (int) (((long) 0)));
							}}
							return
								BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
								(BgL_arg2104z00_1268);
						}
				}
		}
	}



/* $+bx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_add(obj_t BgL_xz00_48, obj_t BgL_yz00_49)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 519 */
			{	/* Unsafe/bignumber.scm 520 */
				unsigned short BgL_arg2111z00_3319;

				unsigned short BgL_arg2112z00_3320;

				{	/* Unsafe/bignumber.scm 520 */
					obj_t BgL_arg1901z00_3322;

					BgL_arg1901z00_3322 = BGL_BIGNUM_U16VECT(BgL_xz00_48);
					BgL_arg2111z00_3319 = BGL_U16VREF(BgL_arg1901z00_3322, ((long) 0));
				}
				{	/* Unsafe/bignumber.scm 520 */
					obj_t BgL_arg1901z00_3325;

					BgL_arg1901z00_3325 = BGL_BIGNUM_U16VECT(BgL_yz00_49);
					BgL_arg2112z00_3320 = BGL_U16VREF(BgL_arg1901z00_3325, ((long) 0));
				}
				return
					BGl_bignumzd2sum2zd2zz__bignumz00(BgL_xz00_48, BgL_yz00_49,
					BgL_arg2111z00_3319, BINT(BgL_arg2112z00_3320));
			}
		}
	}



/* _$+bx */
	obj_t BGl__z42zb2bxzf0zz__bignumz00(obj_t BgL_envz00_4676,
		obj_t BgL_xz00_4677, obj_t BgL_yz00_4678)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 519 */
			{	/* Unsafe/bignumber.scm 520 */
				obj_t BgL_auxz00_5606;

				obj_t BgL_auxz00_5600;

				if (BIGNUMP(BgL_yz00_4678))
					{	/* Unsafe/bignumber.scm 520 */
						BgL_auxz00_5606 = BgL_yz00_4678;
					}
				else
					{	/* Unsafe/bignumber.scm 520 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3161z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4678, BGl_string3147z00zz__bignumz00,
							BINT(((long) 17829)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4677))
					{	/* Unsafe/bignumber.scm 520 */
						BgL_auxz00_5600 = BgL_xz00_4677;
					}
				else
					{	/* Unsafe/bignumber.scm 520 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3161z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4677, BGl_string3147z00zz__bignumz00,
							BINT(((long) 17829)));
						exit(-1);
					}
				return bgl_bignum_add(BgL_auxz00_5600, BgL_auxz00_5606);
			}
		}
	}



/* $-bx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_sub(obj_t BgL_xz00_50, obj_t BgL_yz00_51)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 522 */
			{	/* Unsafe/bignumber.scm 523 */
				unsigned short BgL_arg2113z00_3327;

				long BgL_arg2114z00_3328;

				{	/* Unsafe/bignumber.scm 523 */
					obj_t BgL_arg1901z00_3332;

					BgL_arg1901z00_3332 = BGL_BIGNUM_U16VECT(BgL_xz00_50);
					BgL_arg2113z00_3327 = BGL_U16VREF(BgL_arg1901z00_3332, ((long) 0));
				}
				{	/* Unsafe/bignumber.scm 523 */
					unsigned short BgL_arg2116z00_3330;

					{	/* Unsafe/bignumber.scm 523 */
						obj_t BgL_arg1901z00_3335;

						BgL_arg1901z00_3335 = BGL_BIGNUM_U16VECT(BgL_yz00_51);
						BgL_arg2116z00_3330 = BGL_U16VREF(BgL_arg1901z00_3335, ((long) 0));
					}
					BgL_arg2114z00_3328 = (((long) 1) - (long) (BgL_arg2116z00_3330));
				}
				return
					BGl_bignumzd2sum2zd2zz__bignumz00(BgL_xz00_50, BgL_yz00_51,
					BgL_arg2113z00_3327, BINT(BgL_arg2114z00_3328));
			}
		}
	}



/* _$-bx */
	obj_t BGl__z42zd2bxz90zz__bignumz00(obj_t BgL_envz00_4679,
		obj_t BgL_xz00_4680, obj_t BgL_yz00_4681)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 522 */
			{	/* Unsafe/bignumber.scm 523 */
				obj_t BgL_auxz00_5627;

				obj_t BgL_auxz00_5621;

				if (BIGNUMP(BgL_yz00_4681))
					{	/* Unsafe/bignumber.scm 523 */
						BgL_auxz00_5627 = BgL_yz00_4681;
					}
				else
					{	/* Unsafe/bignumber.scm 523 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3162z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4681, BGl_string3147z00zz__bignumz00,
							BINT(((long) 17919)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4680))
					{	/* Unsafe/bignumber.scm 523 */
						BgL_auxz00_5621 = BgL_xz00_4680;
					}
				else
					{	/* Unsafe/bignumber.scm 523 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3162z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4680, BGl_string3147z00zz__bignumz00,
							BINT(((long) 17919)));
						exit(-1);
					}
				return bgl_bignum_sub(BgL_auxz00_5621, BgL_auxz00_5627);
			}
		}
	}



/* $negbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_neg(obj_t BgL_xz00_52)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 525 */
			{	/* Unsafe/bignumber.scm 526 */
				obj_t BgL_res3012z00_3353;

				{	/* Unsafe/bignumber.scm 526 */
					obj_t BgL_xz00_3339;

					BgL_xz00_3339 = BGl_bignumzd2za7eroz75zz__bignumz00;
					{	/* Unsafe/bignumber.scm 526 */
						unsigned short BgL_arg2113z00_3341;

						long BgL_arg2114z00_3342;

						{	/* Unsafe/bignumber.scm 526 */
							obj_t BgL_arg1901z00_3346;

							BgL_arg1901z00_3346 = BGL_BIGNUM_U16VECT(BgL_xz00_3339);
							BgL_arg2113z00_3341 =
								BGL_U16VREF(BgL_arg1901z00_3346, ((long) 0));
						}
						{	/* Unsafe/bignumber.scm 526 */
							unsigned short BgL_arg2116z00_3344;

							{	/* Unsafe/bignumber.scm 526 */
								obj_t BgL_arg1901z00_3349;

								BgL_arg1901z00_3349 = BGL_BIGNUM_U16VECT(BgL_xz00_52);
								BgL_arg2116z00_3344 =
									BGL_U16VREF(BgL_arg1901z00_3349, ((long) 0));
							}
							BgL_arg2114z00_3342 = (((long) 1) - (long) (BgL_arg2116z00_3344));
						}
						BgL_res3012z00_3353 =
							BGl_bignumzd2sum2zd2zz__bignumz00(BgL_xz00_3339, BgL_xz00_52,
							BgL_arg2113z00_3341, BINT(BgL_arg2114z00_3342));
				}}
				return BgL_res3012z00_3353;
			}
		}
	}



/* _$negbx */
	obj_t BGl__z42negbxz42zz__bignumz00(obj_t BgL_envz00_4682,
		obj_t BgL_xz00_4683)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 525 */
			{	/* Unsafe/bignumber.scm 526 */
				obj_t BgL_auxz00_5642;

				if (BIGNUMP(BgL_xz00_4683))
					{	/* Unsafe/bignumber.scm 526 */
						BgL_auxz00_5642 = BgL_xz00_4683;
					}
				else
					{	/* Unsafe/bignumber.scm 526 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3163z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4683, BGl_string3147z00zz__bignumz00,
							BINT(((long) 17968)));
						exit(-1);
					}
				return bgl_bignum_neg(BgL_auxz00_5642);
			}
		}
	}



/* $*bx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_mul(obj_t BgL_xz00_56, obj_t BgL_yz00_57)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 547 */
			{
				obj_t BgL_xz00_1310;

				obj_t BgL_yz00_1311;

				long BgL_lenxz00_1312;

				long BgL_lenyz00_1313;

				{	/* Unsafe/bignumber.scm 578 */
					obj_t BgL_arg2130z00_1307;

					{	/* Unsafe/bignumber.scm 578 */
						long BgL_arg2131z00_1308;

						long BgL_arg2132z00_1309;

						{	/* Unsafe/bignumber.scm 578 */
							obj_t BgL_arg1900z00_3355;

							BgL_arg1900z00_3355 = BGL_BIGNUM_U16VECT(BgL_xz00_56);
							BgL_arg2131z00_1308 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3355);
						}
						{	/* Unsafe/bignumber.scm 578 */
							obj_t BgL_arg1900z00_3358;

							BgL_arg1900z00_3358 = BGL_BIGNUM_U16VECT(BgL_yz00_57);
							BgL_arg2132z00_1309 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3358);
						}
						BgL_xz00_1310 = BgL_xz00_56;
						BgL_yz00_1311 = BgL_yz00_57;
						BgL_lenxz00_1312 = BgL_arg2131z00_1308;
						BgL_lenyz00_1313 = BgL_arg2132z00_1309;
						{	/* Unsafe/bignumber.scm 550 */
							obj_t BgL_rz00_1315;

							{	/* Unsafe/bignumber.scm 550 */
								long BgL_arg2156z00_1346;

								BgL_arg2156z00_1346 =
									((BgL_lenxz00_1312 + BgL_lenyz00_1313) - ((long) 1));
								{	/* Unsafe/bignumber.scm 550 */
									obj_t BgL_res3013z00_3369;

									{	/* Unsafe/bignumber.scm 550 */
										int BgL_lenz00_3365;

										BgL_lenz00_3365 = (int) (BgL_arg2156z00_1346);
										{	/* Unsafe/bignumber.scm 550 */
											obj_t BgL_arg1898z00_3366;

											{	/* Unsafe/bignumber.scm 550 */

												BgL_arg1898z00_3366 =
													BGl_makezd2u16vectorzd2zz__srfi4z00(
													(long) (BgL_lenz00_3365), BINT(((long) 0)));
											}
											BgL_res3013z00_3369 =
												bgl_make_bignum(BgL_arg1898z00_3366);
									}}
									BgL_rz00_1315 = BgL_res3013z00_3369;
							}}
							{	/* Unsafe/bignumber.scm 552 */
								bool_t BgL_testz00_5660;

								{	/* Unsafe/bignumber.scm 552 */
									unsigned short BgL_arg2135z00_1317;

									unsigned short BgL_arg2136z00_1318;

									{	/* Unsafe/bignumber.scm 552 */
										obj_t BgL_arg1901z00_3371;

										BgL_arg1901z00_3371 = BGL_BIGNUM_U16VECT(BgL_xz00_1310);
										BgL_arg2135z00_1317 =
											BGL_U16VREF(BgL_arg1901z00_3371, ((long) 0));
									}
									{	/* Unsafe/bignumber.scm 552 */
										obj_t BgL_arg1901z00_3374;

										BgL_arg1901z00_3374 = BGL_BIGNUM_U16VECT(BgL_yz00_1311);
										BgL_arg2136z00_1318 =
											BGL_U16VREF(BgL_arg1901z00_3374, ((long) 0));
									}
									BgL_testz00_5660 =
										(
										(long) (BgL_arg2135z00_1317) ==
										(long) (BgL_arg2136z00_1318));
								}
								if (BgL_testz00_5660)
									{	/* Unsafe/bignumber.scm 553 */
										obj_t BgL_arg1903z00_3381;

										BgL_arg1903z00_3381 = BGL_BIGNUM_U16VECT(BgL_rz00_1315);
										{	/* Unsafe/bignumber.scm 553 */
											unsigned short BgL_auxz00_5669;

											BgL_auxz00_5669 = (unsigned short) (((long) 1));
											BGL_U16VSET(BgL_arg1903z00_3381, ((long) 0),
												BgL_auxz00_5669);
										} BUNSPEC;
									}
								else
									{	/* Unsafe/bignumber.scm 554 */
										obj_t BgL_arg1903z00_3386;

										BgL_arg1903z00_3386 = BGL_BIGNUM_U16VECT(BgL_rz00_1315);
										{	/* Unsafe/bignumber.scm 554 */
											unsigned short BgL_auxz00_5673;

											BgL_auxz00_5673 = (unsigned short) (((long) 0));
											BGL_U16VSET(BgL_arg1903z00_3386, ((long) 0),
												BgL_auxz00_5673);
										} BUNSPEC;
							}}
							{
								long BgL_jz00_1320;

								BgL_jz00_1320 = ((long) 1);
							BgL_zc3anonymousza32137ze3z83_1321:
								if ((BgL_jz00_1320 < BgL_lenyz00_1313))
									{	/* Unsafe/bignumber.scm 559 */
										unsigned short BgL_dz00_1323;

										{	/* Unsafe/bignumber.scm 559 */
											int BgL_iz00_3391;

											BgL_iz00_3391 = (int) (BgL_jz00_1320);
											{	/* Unsafe/bignumber.scm 559 */
												obj_t BgL_arg1905z00_3392;

												BgL_arg1905z00_3392 = BGL_BIGNUM_U16VECT(BgL_yz00_1311);
												{	/* Unsafe/bignumber.scm 559 */
													long BgL_auxz00_5680;

													BgL_auxz00_5680 = (long) (BgL_iz00_3391);
													BgL_dz00_1323 =
														BGL_U16VREF(BgL_arg1905z00_3392, BgL_auxz00_5680);
										}}}
										if (((long) (BgL_dz00_1323) == ((long) 0)))
											{
												long BgL_jz00_5686;

												BgL_jz00_5686 = (BgL_jz00_1320 + ((long) 1));
												BgL_jz00_1320 = BgL_jz00_5686;
												goto BgL_zc3anonymousza32137ze3z83_1321;
											}
										else
											{
												long BgL_iz00_1327;

												long BgL_kz00_1328;

												long BgL_cz00_1329;

												BgL_iz00_1327 = ((long) 1);
												BgL_kz00_1328 = BgL_jz00_1320;
												BgL_cz00_1329 = ((long) 0);
											BgL_zc3anonymousza32141ze3z83_1330:
												if ((BgL_iz00_1327 < BgL_lenxz00_1312))
													{	/* Unsafe/bignumber.scm 565 */
														long BgL_wz00_1332;

														{	/* Unsafe/bignumber.scm 565 */
															long BgL_arg2149z00_1339;

															long BgL_arg2151z00_1340;

															{	/* Unsafe/bignumber.scm 565 */
																unsigned short BgL_arg2152z00_1341;

																{	/* Unsafe/bignumber.scm 565 */
																	int BgL_iz00_3400;

																	BgL_iz00_3400 = (int) (BgL_kz00_1328);
																	{	/* Unsafe/bignumber.scm 565 */
																		obj_t BgL_arg1905z00_3401;

																		BgL_arg1905z00_3401 =
																			BGL_BIGNUM_U16VECT(BgL_rz00_1315);
																		{	/* Unsafe/bignumber.scm 565 */
																			long BgL_auxz00_5692;

																			BgL_auxz00_5692 = (long) (BgL_iz00_3400);
																			BgL_arg2152z00_1341 =
																				BGL_U16VREF(BgL_arg1905z00_3401,
																				BgL_auxz00_5692);
																}}}
																BgL_arg2149z00_1339 =
																	(
																	(long) (BgL_arg2152z00_1341) + BgL_cz00_1329);
															}
															{	/* Unsafe/bignumber.scm 566 */
																unsigned short BgL_arg2153z00_1342;

																{	/* Unsafe/bignumber.scm 566 */
																	int BgL_iz00_3405;

																	BgL_iz00_3405 = (int) (BgL_iz00_1327);
																	{	/* Unsafe/bignumber.scm 566 */
																		obj_t BgL_arg1905z00_3406;

																		BgL_arg1905z00_3406 =
																			BGL_BIGNUM_U16VECT(BgL_xz00_1310);
																		{	/* Unsafe/bignumber.scm 566 */
																			long BgL_auxz00_5699;

																			BgL_auxz00_5699 = (long) (BgL_iz00_3405);
																			BgL_arg2153z00_1342 =
																				BGL_U16VREF(BgL_arg1905z00_3406,
																				BgL_auxz00_5699);
																}}}
																BgL_arg2151z00_1340 =
																	(
																	(long) (BgL_arg2153z00_1342) *
																	(long) (BgL_dz00_1323));
															}
															BgL_wz00_1332 =
																(BgL_arg2149z00_1339 + BgL_arg2151z00_1340);
														}
														{	/* Unsafe/bignumber.scm 567 */
															obj_t BgL_arg2143z00_1333;

															BgL_arg2143z00_1333 =
																BGl_moduloz00zz__r4_numbers_6_5_fixnumz00(BINT
																(BgL_wz00_1332),
																BINT((((long) 1) << (int) (((long) 14)))));
															{	/* Unsafe/bignumber.scm 567 */
																int BgL_iz00_3414;

																int BgL_digitz00_3415;

																BgL_iz00_3414 = (int) (BgL_kz00_1328);
																BgL_digitz00_3415 = CINT(BgL_arg2143z00_1333);
																{	/* Unsafe/bignumber.scm 567 */
																	obj_t BgL_arg1906z00_3416;

																	BgL_arg1906z00_3416 =
																		BGL_BIGNUM_U16VECT(BgL_rz00_1315);
																	{	/* Unsafe/bignumber.scm 567 */
																		unsigned short BgL_auxz00_5716;

																		long BgL_auxz00_5714;

																		BgL_auxz00_5716 =
																			(unsigned short) (BgL_digitz00_3415);
																		BgL_auxz00_5714 = (long) (BgL_iz00_3414);
																		BGL_U16VSET(BgL_arg1906z00_3416,
																			BgL_auxz00_5714, BgL_auxz00_5716);
																	} BUNSPEC;
														}}}
														{	/* Unsafe/bignumber.scm 568 */
															long BgL_arg2145z00_1335;

															long BgL_arg2146z00_1336;

															long BgL_arg2147z00_1337;

															BgL_arg2145z00_1335 =
																(BgL_iz00_1327 + ((long) 1));
															BgL_arg2146z00_1336 =
																(BgL_kz00_1328 + ((long) 1));
															{	/* Unsafe/bignumber.scm 570 */
																long BgL_auxz00_5721;

																BgL_auxz00_5721 =
																	(((long) 1) << (int) (((long) 14)));
																BgL_arg2147z00_1337 =
																	(BgL_wz00_1332 / BgL_auxz00_5721);
															}
															{
																long BgL_cz00_5727;

																long BgL_kz00_5726;

																long BgL_iz00_5725;

																BgL_iz00_5725 = BgL_arg2145z00_1335;
																BgL_kz00_5726 = BgL_arg2146z00_1336;
																BgL_cz00_5727 = BgL_arg2147z00_1337;
																BgL_cz00_1329 = BgL_cz00_5727;
																BgL_kz00_1328 = BgL_kz00_5726;
																BgL_iz00_1327 = BgL_iz00_5725;
																goto BgL_zc3anonymousza32141ze3z83_1330;
															}
														}
													}
												else
													{	/* Unsafe/bignumber.scm 563 */
														{	/* Unsafe/bignumber.scm 573 */
															int BgL_iz00_3426;

															int BgL_digitz00_3427;

															BgL_iz00_3426 = (int) (BgL_kz00_1328);
															BgL_digitz00_3427 = (int) (BgL_cz00_1329);
															{	/* Unsafe/bignumber.scm 573 */
																obj_t BgL_arg1906z00_3428;

																BgL_arg1906z00_3428 =
																	BGL_BIGNUM_U16VECT(BgL_rz00_1315);
																{	/* Unsafe/bignumber.scm 573 */
																	unsigned short BgL_auxz00_5733;

																	long BgL_auxz00_5731;

																	BgL_auxz00_5733 =
																		(unsigned short) (BgL_digitz00_3427);
																	BgL_auxz00_5731 = (long) (BgL_iz00_3426);
																	BGL_U16VSET(BgL_arg1906z00_3428,
																		BgL_auxz00_5731, BgL_auxz00_5733);
																} BUNSPEC;
														}}
														{
															long BgL_jz00_5736;

															BgL_jz00_5736 = (BgL_jz00_1320 + ((long) 1));
															BgL_jz00_1320 = BgL_jz00_5736;
															goto BgL_zc3anonymousza32137ze3z83_1321;
														}
													}
											}
									}
								else
									{	/* Unsafe/bignumber.scm 557 */
										((bool_t) 0);
									}
							}
							BgL_arg2130z00_1307 =
								BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
								(BgL_rz00_1315);
						}
					}
					return BgL_arg2130z00_1307;
				}
			}
		}
	}



/* _$*bx */
	obj_t BGl__z42za2bxze0zz__bignumz00(obj_t BgL_envz00_4684,
		obj_t BgL_xz00_4685, obj_t BgL_yz00_4686)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 547 */
			{	/* Unsafe/bignumber.scm 550 */
				obj_t BgL_auxz00_5745;

				obj_t BgL_auxz00_5739;

				if (BIGNUMP(BgL_yz00_4686))
					{	/* Unsafe/bignumber.scm 550 */
						BgL_auxz00_5745 = BgL_yz00_4686;
					}
				else
					{	/* Unsafe/bignumber.scm 550 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3164z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4686, BGl_string3147z00zz__bignumz00,
							BINT(((long) 18641)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4685))
					{	/* Unsafe/bignumber.scm 550 */
						BgL_auxz00_5739 = BgL_xz00_4685;
					}
				else
					{	/* Unsafe/bignumber.scm 550 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3164z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4685, BGl_string3147z00zz__bignumz00,
							BINT(((long) 18641)));
						exit(-1);
					}
				return bgl_bignum_mul(BgL_auxz00_5739, BgL_auxz00_5745);
			}
		}
	}



/* bignum-div */
	obj_t BGl_bignumzd2divzd2zz__bignumz00(obj_t BgL_xz00_59, obj_t BgL_yz00_60)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 591 */
			{
				obj_t BgL_xz00_1545;

				obj_t BgL_yz00_1546;

				long BgL_lenxz00_1547;

				long BgL_lenyz00_1548;

				obj_t BgL_rz00_1549;

				obj_t BgL_xz00_1382;

				obj_t BgL_yz00_1383;

				long BgL_lenxz00_1384;

				long BgL_lenyz00_1385;

				obj_t BgL_rz00_1386;

				obj_t BgL_xz00_1368;

				obj_t BgL_yz00_1369;

				long BgL_lenxz00_1370;

				long BgL_lenyz00_1371;

				{	/* Unsafe/bignumber.scm 754 */
					bool_t BgL_testz00_5752;

					{	/* Unsafe/bignumber.scm 754 */
						bool_t BgL_res3014z00_3439;

						{	/* Unsafe/bignumber.scm 754 */
							obj_t BgL_xz00_3431;

							BgL_xz00_3431 = BgL_yz00_60;
							{	/* Unsafe/bignumber.scm 754 */
								long BgL_arg2011z00_3432;

								{	/* Unsafe/bignumber.scm 754 */
									obj_t BgL_arg1900z00_3435;

									BgL_arg1900z00_3435 = BGL_BIGNUM_U16VECT(BgL_xz00_3431);
									BgL_arg2011z00_3432 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3435);
								}
								BgL_res3014z00_3439 = (BgL_arg2011z00_3432 == ((long) 1));
						}}
						BgL_testz00_5752 = BgL_res3014z00_3439;
					}
					if (BgL_testz00_5752)
						{	/* Unsafe/bignumber.scm 754 */
							return
								BGl_errorz00zz__errorz00(BGl_symbol3165z00zz__bignumz00,
								BGl_string3167z00zz__bignumz00, BgL_xz00_59);
						}
					else
						{	/* Unsafe/bignumber.scm 756 */
							long BgL_arg2169z00_1366;

							long BgL_arg2170z00_1367;

							{	/* Unsafe/bignumber.scm 756 */
								obj_t BgL_bnz00_3440;

								BgL_bnz00_3440 = BgL_xz00_59;
								{	/* Unsafe/bignumber.scm 756 */
									obj_t BgL_arg1900z00_3441;

									BgL_arg1900z00_3441 = BGL_BIGNUM_U16VECT(BgL_bnz00_3440);
									BgL_arg2169z00_1366 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3441);
							}}
							{	/* Unsafe/bignumber.scm 756 */
								obj_t BgL_bnz00_3443;

								BgL_bnz00_3443 = BgL_yz00_60;
								{	/* Unsafe/bignumber.scm 756 */
									obj_t BgL_arg1900z00_3444;

									BgL_arg1900z00_3444 = BGL_BIGNUM_U16VECT(BgL_bnz00_3443);
									BgL_arg2170z00_1367 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3444);
							}}
							BgL_xz00_1368 = BgL_xz00_59;
							BgL_yz00_1369 = BgL_yz00_60;
							BgL_lenxz00_1370 = BgL_arg2169z00_1366;
							BgL_lenyz00_1371 = BgL_arg2170z00_1367;
							if ((BgL_lenxz00_1370 < BgL_lenyz00_1371))
								{	/* Unsafe/bignumber.scm 740 */
									return
										MAKE_PAIR(BGl_bignumzd2za7eroz75zz__bignumz00,
										BgL_xz00_1368);
								}
							else
								{	/* Unsafe/bignumber.scm 744 */
									obj_t BgL_rz00_1374;

									{	/* Unsafe/bignumber.scm 744 */
										long BgL_arg2177z00_1379;

										BgL_arg2177z00_1379 =
											((BgL_lenxz00_1370 - BgL_lenyz00_1371) + ((long) 2));
										{	/* Unsafe/bignumber.scm 744 */
											obj_t BgL_res3015z00_3456;

											{	/* Unsafe/bignumber.scm 744 */
												int BgL_lenz00_3452;

												BgL_lenz00_3452 = (int) (BgL_arg2177z00_1379);
												{	/* Unsafe/bignumber.scm 744 */
													obj_t BgL_arg1898z00_3453;

													{	/* Unsafe/bignumber.scm 744 */

														BgL_arg1898z00_3453 =
															BGl_makezd2u16vectorzd2zz__srfi4z00(
															(long) (BgL_lenz00_3452), BINT(((long) 0)));
													}
													BgL_res3015z00_3456 =
														bgl_make_bignum(BgL_arg1898z00_3453);
											}}
											BgL_rz00_1374 = BgL_res3015z00_3456;
									}}
									{	/* Unsafe/bignumber.scm 746 */
										bool_t BgL_testz00_5771;

										{	/* Unsafe/bignumber.scm 746 */
											unsigned short BgL_arg2174z00_1376;

											unsigned short BgL_arg2175z00_1377;

											{	/* Unsafe/bignumber.scm 746 */
												obj_t BgL_bnz00_3457;

												BgL_bnz00_3457 = BgL_xz00_1368;
												{	/* Unsafe/bignumber.scm 746 */
													obj_t BgL_arg1901z00_3458;

													BgL_arg1901z00_3458 =
														BGL_BIGNUM_U16VECT(BgL_bnz00_3457);
													BgL_arg2174z00_1376 =
														BGL_U16VREF(BgL_arg1901z00_3458, ((long) 0));
											}}
											{	/* Unsafe/bignumber.scm 746 */
												obj_t BgL_bnz00_3460;

												BgL_bnz00_3460 = BgL_yz00_1369;
												{	/* Unsafe/bignumber.scm 746 */
													obj_t BgL_arg1901z00_3461;

													BgL_arg1901z00_3461 =
														BGL_BIGNUM_U16VECT(BgL_bnz00_3460);
													BgL_arg2175z00_1377 =
														BGL_U16VREF(BgL_arg1901z00_3461, ((long) 0));
											}}
											BgL_testz00_5771 =
												(
												(long) (BgL_arg2174z00_1376) ==
												(long) (BgL_arg2175z00_1377));
										}
										if (BgL_testz00_5771)
											{	/* Unsafe/bignumber.scm 747 */
												obj_t BgL_arg1903z00_3468;

												BgL_arg1903z00_3468 = BGL_BIGNUM_U16VECT(BgL_rz00_1374);
												{	/* Unsafe/bignumber.scm 747 */
													unsigned short BgL_auxz00_5780;

													BgL_auxz00_5780 = (unsigned short) (((long) 1));
													BGL_U16VSET(BgL_arg1903z00_3468, ((long) 0),
														BgL_auxz00_5780);
												} BUNSPEC;
											}
										else
											{	/* Unsafe/bignumber.scm 748 */
												obj_t BgL_arg1903z00_3473;

												BgL_arg1903z00_3473 = BGL_BIGNUM_U16VECT(BgL_rz00_1374);
												{	/* Unsafe/bignumber.scm 748 */
													unsigned short BgL_auxz00_5784;

													BgL_auxz00_5784 = (unsigned short) (((long) 0));
													BGL_U16VSET(BgL_arg1903z00_3473, ((long) 0),
														BgL_auxz00_5784);
												} BUNSPEC;
									}}
									if ((BgL_lenyz00_1371 == ((long) 2)))
										{	/* Unsafe/bignumber.scm 750 */
											BgL_xz00_1545 = BgL_xz00_1368;
											BgL_yz00_1546 = BgL_yz00_1369;
											BgL_lenxz00_1547 = BgL_lenxz00_1370;
											BgL_lenyz00_1548 = BgL_lenyz00_1371;
											BgL_rz00_1549 = BgL_rz00_1374;
											{	/* Unsafe/bignumber.scm 597 */
												unsigned short BgL_dz00_1551;

												{	/* Unsafe/bignumber.scm 597 */
													obj_t BgL_bnz00_3761;

													BgL_bnz00_3761 = BgL_yz00_1546;
													{	/* Unsafe/bignumber.scm 597 */
														obj_t BgL_arg1905z00_3763;

														BgL_arg1905z00_3763 =
															BGL_BIGNUM_U16VECT(BgL_bnz00_3761);
														BgL_dz00_1551 =
															BGL_U16VREF(BgL_arg1905z00_3763, ((long) 1));
												}}
												{	/* Unsafe/bignumber.scm 598 */
													long BgL_g1781z00_1552;

													BgL_g1781z00_1552 = (BgL_lenxz00_1547 - ((long) 1));
													{
														long BgL_iz00_1554;

														long BgL_kz00_1555;

														BgL_iz00_1554 = BgL_g1781z00_1552;
														BgL_kz00_1555 = ((long) 0);
													BgL_zc3anonymousza32291ze3z83_1556:
														if ((((long) 0) < BgL_iz00_1554))
															{	/* Unsafe/bignumber.scm 600 */
																long BgL_wz00_1558;

																{	/* Unsafe/bignumber.scm 600 */
																	long BgL_arg2297z00_1562;

																	unsigned short BgL_arg2298z00_1563;

																	BgL_arg2297z00_1562 =
																		(BgL_kz00_1555 *
																		(((long) 1) << (int) (((long) 14))));
																	{	/* Unsafe/bignumber.scm 600 */
																		obj_t BgL_bnz00_3772;

																		int BgL_iz00_3773;

																		BgL_bnz00_3772 = BgL_xz00_1545;
																		BgL_iz00_3773 = (int) (BgL_iz00_1554);
																		{	/* Unsafe/bignumber.scm 600 */
																			obj_t BgL_arg1905z00_3774;

																			BgL_arg1905z00_3774 =
																				BGL_BIGNUM_U16VECT(BgL_bnz00_3772);
																			{	/* Unsafe/bignumber.scm 600 */
																				long BgL_auxz00_5799;

																				BgL_auxz00_5799 =
																					(long) (BgL_iz00_3773);
																				BgL_arg2298z00_1563 =
																					BGL_U16VREF(BgL_arg1905z00_3774,
																					BgL_auxz00_5799);
																	}}}
																	BgL_wz00_1558 =
																		(BgL_arg2297z00_1562 +
																		(long) (BgL_arg2298z00_1563));
																}
																{	/* Unsafe/bignumber.scm 601 */
																	long BgL_arg2293z00_1559;

																	{	/* Unsafe/bignumber.scm 601 */
																		long BgL_auxz00_5804;

																		BgL_auxz00_5804 = (long) (BgL_dz00_1551);
																		BgL_arg2293z00_1559 =
																			(BgL_wz00_1558 / BgL_auxz00_5804);
																	}
																	{	/* Unsafe/bignumber.scm 601 */
																		int BgL_iz00_3780;

																		int BgL_digitz00_3781;

																		BgL_iz00_3780 = (int) (BgL_iz00_1554);
																		BgL_digitz00_3781 =
																			(int) (BgL_arg2293z00_1559);
																		{	/* Unsafe/bignumber.scm 601 */
																			obj_t BgL_arg1906z00_3782;

																			BgL_arg1906z00_3782 =
																				BGL_BIGNUM_U16VECT(BgL_rz00_1549);
																			{	/* Unsafe/bignumber.scm 601 */
																				unsigned short BgL_auxz00_5812;

																				long BgL_auxz00_5810;

																				BgL_auxz00_5812 =
																					(unsigned short) (BgL_digitz00_3781);
																				BgL_auxz00_5810 =
																					(long) (BgL_iz00_3780);
																				BGL_U16VSET(BgL_arg1906z00_3782,
																					BgL_auxz00_5810, BgL_auxz00_5812);
																			} BUNSPEC;
																}}}
																{	/* Unsafe/bignumber.scm 602 */
																	long BgL_arg2295z00_1560;

																	long BgL_arg2296z00_1561;

																	BgL_arg2295z00_1560 =
																		(BgL_iz00_1554 - ((long) 1));
																	{	/* Unsafe/bignumber.scm 602 */
																		long BgL_auxz00_5816;

																		BgL_auxz00_5816 = (long) (BgL_dz00_1551);
																		BgL_arg2296z00_1561 =
																			(BgL_wz00_1558 % BgL_auxz00_5816);
																	}
																	{
																		long BgL_kz00_5820;

																		long BgL_iz00_5819;

																		BgL_iz00_5819 = BgL_arg2295z00_1560;
																		BgL_kz00_5820 = BgL_arg2296z00_1561;
																		BgL_kz00_1555 = BgL_kz00_5820;
																		BgL_iz00_1554 = BgL_iz00_5819;
																		goto BgL_zc3anonymousza32291ze3z83_1556;
																	}
																}
															}
														else
															{	/* Unsafe/bignumber.scm 603 */
																obj_t BgL_arg2300z00_1565;

																obj_t BgL_arg2301z00_1566;

																BgL_arg2300z00_1565 =
																	BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
																	(BgL_rz00_1549);
																{	/* Unsafe/bignumber.scm 605 */
																	long BgL_arg2302z00_1567;

																	{	/* Unsafe/bignumber.scm 605 */
																		bool_t BgL_testz00_5822;

																		{	/* Unsafe/bignumber.scm 605 */
																			bool_t BgL_res3018z00_3795;

																			{	/* Unsafe/bignumber.scm 605 */
																				obj_t BgL_xz00_3787;

																				BgL_xz00_3787 = BgL_xz00_1545;
																				{	/* Unsafe/bignumber.scm 605 */
																					unsigned short BgL_arg2015z00_3788;

																					{	/* Unsafe/bignumber.scm 605 */
																						obj_t BgL_arg1901z00_3791;

																						BgL_arg1901z00_3791 =
																							BGL_BIGNUM_U16VECT(BgL_xz00_3787);
																						BgL_arg2015z00_3788 =
																							BGL_U16VREF(BgL_arg1901z00_3791,
																							((long) 0));
																					}
																					BgL_res3018z00_3795 =
																						(
																						(long) (BgL_arg2015z00_3788) ==
																						((long) 0));
																			}}
																			BgL_testz00_5822 = BgL_res3018z00_3795;
																		}
																		if (BgL_testz00_5822)
																			{	/* Unsafe/bignumber.scm 605 */
																				BgL_arg2302z00_1567 =
																					(((long) 0) - BgL_kz00_1555);
																			}
																		else
																			{	/* Unsafe/bignumber.scm 605 */
																				BgL_arg2302z00_1567 = BgL_kz00_1555;
																			}
																	}
																	BgL_arg2301z00_1566 =
																		bgl_long_to_bignum(BgL_arg2302z00_1567);
																}
																return
																	MAKE_PAIR(BgL_arg2300z00_1565,
																	BgL_arg2301z00_1566);
															}
													}
												}
											}
										}
									else
										{	/* Unsafe/bignumber.scm 750 */
											BgL_xz00_1382 = BgL_xz00_1368;
											BgL_yz00_1383 = BgL_yz00_1369;
											BgL_lenxz00_1384 = BgL_lenxz00_1370;
											BgL_lenyz00_1385 = BgL_lenyz00_1371;
											BgL_rz00_1386 = BgL_rz00_1374;
											{	/* Unsafe/bignumber.scm 613 */
												long BgL_g1782z00_1388;

												{	/* Unsafe/bignumber.scm 614 */
													unsigned short BgL_arg2287z00_1542;

													{	/* Unsafe/bignumber.scm 614 */
														long BgL_arg2289z00_1544;

														BgL_arg2289z00_1544 =
															(BgL_lenyz00_1385 - ((long) 1));
														{	/* Unsafe/bignumber.scm 614 */
															obj_t BgL_bnz00_3479;

															int BgL_iz00_3480;

															BgL_bnz00_3479 = BgL_yz00_1383;
															BgL_iz00_3480 = (int) (BgL_arg2289z00_1544);
															{	/* Unsafe/bignumber.scm 614 */
																obj_t BgL_arg1905z00_3481;

																BgL_arg1905z00_3481 =
																	BGL_BIGNUM_U16VECT(BgL_bnz00_3479);
																{	/* Unsafe/bignumber.scm 614 */
																	long BgL_auxz00_5833;

																	BgL_auxz00_5833 = (long) (BgL_iz00_3480);
																	BgL_arg2287z00_1542 =
																		BGL_U16VREF(BgL_arg1905z00_3481,
																		BgL_auxz00_5833);
													}}}}
													BgL_g1782z00_1388 =
														((long) (BgL_arg2287z00_1542) * ((long) 2));
												}
												{
													long BgL_shiftz00_1390;

													long BgL_nz00_1391;

													BgL_shiftz00_1390 = ((long) 1);
													BgL_nz00_1391 = BgL_g1782z00_1388;
												BgL_zc3anonymousza32182ze3z83_1392:
													if (
														(BgL_nz00_1391 <
															(((long) 1) << (int) (((long) 14)))))
														{
															long BgL_nz00_5844;

															long BgL_shiftz00_5842;

															BgL_shiftz00_5842 =
																(BgL_shiftz00_1390 * ((long) 2));
															BgL_nz00_5844 = (BgL_nz00_1391 * ((long) 2));
															BgL_nz00_1391 = BgL_nz00_5844;
															BgL_shiftz00_1390 = BgL_shiftz00_5842;
															goto BgL_zc3anonymousza32182ze3z83_1392;
														}
													else
														{	/* Unsafe/bignumber.scm 618 */
															obj_t BgL_nxz00_1396;

															obj_t BgL_nyz00_1397;

															{	/* Unsafe/bignumber.scm 618 */
																long BgL_arg2285z00_1539;

																BgL_arg2285z00_1539 =
																	(BgL_lenxz00_1384 + ((long) 1));
																{	/* Unsafe/bignumber.scm 618 */
																	obj_t BgL_res3016z00_3498;

																	{	/* Unsafe/bignumber.scm 618 */
																		int BgL_lenz00_3494;

																		BgL_lenz00_3494 =
																			(int) (BgL_arg2285z00_1539);
																		{	/* Unsafe/bignumber.scm 618 */
																			obj_t BgL_arg1898z00_3495;

																			{	/* Unsafe/bignumber.scm 618 */

																				BgL_arg1898z00_3495 =
																					BGl_makezd2u16vectorzd2zz__srfi4z00(
																					(long) (BgL_lenz00_3494),
																					BINT(((long) 0)));
																			}
																			BgL_res3016z00_3498 =
																				bgl_make_bignum(BgL_arg1898z00_3495);
																	}}
																	BgL_nxz00_1396 = BgL_res3016z00_3498;
															}}
															{	/* Unsafe/bignumber.scm 619 */
																obj_t BgL_res3017z00_3503;

																{	/* Unsafe/bignumber.scm 619 */
																	int BgL_lenz00_3499;

																	BgL_lenz00_3499 = (int) (BgL_lenyz00_1385);
																	{	/* Unsafe/bignumber.scm 619 */
																		obj_t BgL_arg1898z00_3500;

																		{	/* Unsafe/bignumber.scm 619 */

																			BgL_arg1898z00_3500 =
																				BGl_makezd2u16vectorzd2zz__srfi4z00(
																				(long) (BgL_lenz00_3499),
																				BINT(((long) 0)));
																		}
																		BgL_res3017z00_3503 =
																			bgl_make_bignum(BgL_arg1898z00_3500);
																}}
																BgL_nyz00_1397 = BgL_res3017z00_3503;
															}
															{	/* Unsafe/bignumber.scm 621 */
																unsigned short BgL_arg2187z00_1398;

																{	/* Unsafe/bignumber.scm 621 */
																	obj_t BgL_bnz00_3504;

																	BgL_bnz00_3504 = BgL_xz00_1382;
																	{	/* Unsafe/bignumber.scm 621 */
																		obj_t BgL_arg1901z00_3505;

																		BgL_arg1901z00_3505 =
																			BGL_BIGNUM_U16VECT(BgL_bnz00_3504);
																		BgL_arg2187z00_1398 =
																			BGL_U16VREF(BgL_arg1901z00_3505,
																			((long) 0));
																}}
																{	/* Unsafe/bignumber.scm 621 */
																	int BgL_signz00_3508;

																	BgL_signz00_3508 =
																		(int) (BgL_arg2187z00_1398);
																	{	/* Unsafe/bignumber.scm 621 */
																		obj_t BgL_arg1903z00_3509;

																		BgL_arg1903z00_3509 =
																			BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																		{	/* Unsafe/bignumber.scm 621 */
																			unsigned short BgL_auxz00_5861;

																			BgL_auxz00_5861 =
																				(unsigned short) (BgL_signz00_3508);
																			BGL_U16VSET(BgL_arg1903z00_3509,
																				((long) 0), BgL_auxz00_5861);
																		} BUNSPEC;
															}}}
															{
																long BgL_iz00_1400;

																long BgL_cz00_1401;

																BgL_iz00_1400 = ((long) 1);
																BgL_cz00_1401 = ((long) 0);
															BgL_zc3anonymousza32188ze3z83_1402:
																if ((BgL_iz00_1400 < BgL_lenxz00_1384))
																	{	/* Unsafe/bignumber.scm 625 */
																		long BgL_wz00_1404;

																		{	/* Unsafe/bignumber.scm 625 */
																			long BgL_arg2195z00_1410;

																			{	/* Unsafe/bignumber.scm 625 */
																				unsigned short BgL_arg2198z00_1411;

																				{	/* Unsafe/bignumber.scm 625 */
																					obj_t BgL_bnz00_3513;

																					int BgL_iz00_3514;

																					BgL_bnz00_3513 = BgL_xz00_1382;
																					BgL_iz00_3514 = (int) (BgL_iz00_1400);
																					{	/* Unsafe/bignumber.scm 625 */
																						obj_t BgL_arg1905z00_3515;

																						BgL_arg1905z00_3515 =
																							BGL_BIGNUM_U16VECT
																							(BgL_bnz00_3513);
																						{	/* Unsafe/bignumber.scm 625 */
																							long BgL_auxz00_5868;

																							BgL_auxz00_5868 =
																								(long) (BgL_iz00_3514);
																							BgL_arg2198z00_1411 =
																								BGL_U16VREF(BgL_arg1905z00_3515,
																								BgL_auxz00_5868);
																				}}}
																				BgL_arg2195z00_1410 =
																					(
																					(long) (BgL_arg2198z00_1411) *
																					BgL_shiftz00_1390);
																			}
																			BgL_wz00_1404 =
																				(BgL_arg2195z00_1410 + BgL_cz00_1401);
																		}
																		{	/* Unsafe/bignumber.scm 626 */
																			obj_t BgL_arg2190z00_1405;

																			BgL_arg2190z00_1405 =
																				BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																				(BINT(BgL_wz00_1404),
																				BINT((((long) 1) << (int) (((long)
																								14)))));
																			{	/* Unsafe/bignumber.scm 626 */
																				int BgL_iz00_3523;

																				int BgL_digitz00_3524;

																				BgL_iz00_3523 = (int) (BgL_iz00_1400);
																				BgL_digitz00_3524 =
																					CINT(BgL_arg2190z00_1405);
																				{	/* Unsafe/bignumber.scm 626 */
																					obj_t BgL_arg1906z00_3525;

																					BgL_arg1906z00_3525 =
																						BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																					{	/* Unsafe/bignumber.scm 626 */
																						unsigned short BgL_auxz00_5884;

																						long BgL_auxz00_5882;

																						BgL_auxz00_5884 =
																							(unsigned
																							short) (BgL_digitz00_3524);
																						BgL_auxz00_5882 =
																							(long) (BgL_iz00_3523);
																						BGL_U16VSET(BgL_arg1906z00_3525,
																							BgL_auxz00_5882, BgL_auxz00_5884);
																					} BUNSPEC;
																		}}}
																		{	/* Unsafe/bignumber.scm 627 */
																			long BgL_arg2192z00_1407;

																			long BgL_arg2193z00_1408;

																			BgL_arg2192z00_1407 =
																				(BgL_iz00_1400 + ((long) 1));
																			{	/* Unsafe/bignumber.scm 627 */
																				long BgL_auxz00_5888;

																				BgL_auxz00_5888 =
																					(((long) 1) << (int) (((long) 14)));
																				BgL_arg2193z00_1408 =
																					(BgL_wz00_1404 / BgL_auxz00_5888);
																			}
																			{
																				long BgL_cz00_5893;

																				long BgL_iz00_5892;

																				BgL_iz00_5892 = BgL_arg2192z00_1407;
																				BgL_cz00_5893 = BgL_arg2193z00_1408;
																				BgL_cz00_1401 = BgL_cz00_5893;
																				BgL_iz00_1400 = BgL_iz00_5892;
																				goto BgL_zc3anonymousza32188ze3z83_1402;
																			}
																		}
																	}
																else
																	{	/* Unsafe/bignumber.scm 628 */
																		int BgL_iz00_3533;

																		int BgL_digitz00_3534;

																		BgL_iz00_3533 = (int) (BgL_iz00_1400);
																		BgL_digitz00_3534 = (int) (BgL_cz00_1401);
																		{	/* Unsafe/bignumber.scm 628 */
																			obj_t BgL_arg1906z00_3535;

																			BgL_arg1906z00_3535 =
																				BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																			{	/* Unsafe/bignumber.scm 628 */
																				unsigned short BgL_auxz00_5899;

																				long BgL_auxz00_5897;

																				BgL_auxz00_5899 =
																					(unsigned short) (BgL_digitz00_3534);
																				BgL_auxz00_5897 =
																					(long) (BgL_iz00_3533);
																				BGL_U16VSET(BgL_arg1906z00_3535,
																					BgL_auxz00_5897, BgL_auxz00_5899);
																			} BUNSPEC;
															}}}
															{
																long BgL_iz00_1414;

																long BgL_cz00_1415;

																BgL_iz00_1414 = ((long) 1);
																BgL_cz00_1415 = ((long) 0);
															BgL_zc3anonymousza32199ze3z83_1416:
																if ((BgL_iz00_1414 < BgL_lenyz00_1385))
																	{	/* Unsafe/bignumber.scm 632 */
																		long BgL_wz00_1418;

																		{	/* Unsafe/bignumber.scm 632 */
																			long BgL_arg2206z00_1424;

																			{	/* Unsafe/bignumber.scm 632 */
																				unsigned short BgL_arg2208z00_1425;

																				{	/* Unsafe/bignumber.scm 632 */
																					obj_t BgL_bnz00_3538;

																					int BgL_iz00_3539;

																					BgL_bnz00_3538 = BgL_yz00_1383;
																					BgL_iz00_3539 = (int) (BgL_iz00_1414);
																					{	/* Unsafe/bignumber.scm 632 */
																						obj_t BgL_arg1905z00_3540;

																						BgL_arg1905z00_3540 =
																							BGL_BIGNUM_U16VECT
																							(BgL_bnz00_3538);
																						{	/* Unsafe/bignumber.scm 632 */
																							long BgL_auxz00_5906;

																							BgL_auxz00_5906 =
																								(long) (BgL_iz00_3539);
																							BgL_arg2208z00_1425 =
																								BGL_U16VREF(BgL_arg1905z00_3540,
																								BgL_auxz00_5906);
																				}}}
																				BgL_arg2206z00_1424 =
																					(
																					(long) (BgL_arg2208z00_1425) *
																					BgL_shiftz00_1390);
																			}
																			BgL_wz00_1418 =
																				(BgL_arg2206z00_1424 + BgL_cz00_1415);
																		}
																		{	/* Unsafe/bignumber.scm 633 */
																			obj_t BgL_arg2201z00_1419;

																			BgL_arg2201z00_1419 =
																				BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																				(BINT(BgL_wz00_1418),
																				BINT((((long) 1) << (int) (((long)
																								14)))));
																			{	/* Unsafe/bignumber.scm 633 */
																				int BgL_iz00_3548;

																				int BgL_digitz00_3549;

																				BgL_iz00_3548 = (int) (BgL_iz00_1414);
																				BgL_digitz00_3549 =
																					CINT(BgL_arg2201z00_1419);
																				{	/* Unsafe/bignumber.scm 633 */
																					obj_t BgL_arg1906z00_3550;

																					BgL_arg1906z00_3550 =
																						BGL_BIGNUM_U16VECT(BgL_nyz00_1397);
																					{	/* Unsafe/bignumber.scm 633 */
																						unsigned short BgL_auxz00_5922;

																						long BgL_auxz00_5920;

																						BgL_auxz00_5922 =
																							(unsigned
																							short) (BgL_digitz00_3549);
																						BgL_auxz00_5920 =
																							(long) (BgL_iz00_3548);
																						BGL_U16VSET(BgL_arg1906z00_3550,
																							BgL_auxz00_5920, BgL_auxz00_5922);
																					} BUNSPEC;
																		}}}
																		{	/* Unsafe/bignumber.scm 634 */
																			long BgL_arg2203z00_1421;

																			long BgL_arg2204z00_1422;

																			BgL_arg2203z00_1421 =
																				(BgL_iz00_1414 + ((long) 1));
																			{	/* Unsafe/bignumber.scm 634 */
																				long BgL_auxz00_5926;

																				BgL_auxz00_5926 =
																					(((long) 1) << (int) (((long) 14)));
																				BgL_arg2204z00_1422 =
																					(BgL_wz00_1418 / BgL_auxz00_5926);
																			}
																			{
																				long BgL_cz00_5931;

																				long BgL_iz00_5930;

																				BgL_iz00_5930 = BgL_arg2203z00_1421;
																				BgL_cz00_5931 = BgL_arg2204z00_1422;
																				BgL_cz00_1415 = BgL_cz00_5931;
																				BgL_iz00_1414 = BgL_iz00_5930;
																				goto BgL_zc3anonymousza32199ze3z83_1416;
																			}
																		}
																	}
																else
																	{	/* Unsafe/bignumber.scm 631 */
																		((bool_t) 0);
																	}
															}
															{
																long BgL_iz00_1428;

																BgL_iz00_1428 = BgL_lenxz00_1384;
															BgL_zc3anonymousza32209ze3z83_1429:
																if ((BgL_iz00_1428 < BgL_lenyz00_1385))
																	{	/* Unsafe/bignumber.scm 637 */
																		((bool_t) 0);
																	}
																else
																	{	/* Unsafe/bignumber.scm 641 */
																		unsigned short BgL_msdzd2ofzd2nyz00_1431;

																		unsigned short
																			BgL_nextzd2msdzd2ofzd2nyzd2_1432;
																		unsigned short BgL_msdzd2ofzd2nxz00_1433;

																		unsigned short
																			BgL_nextzd2msdzd2ofzd2nxzd2_1434;
																		unsigned short
																			BgL_nextzd2nextzd2msdzd2ofzd2nxz00_1435;
																		{	/* Unsafe/bignumber.scm 642 */
																			long BgL_arg2271z00_1518;

																			BgL_arg2271z00_1518 =
																				(BgL_lenyz00_1385 - ((long) 1));
																			{	/* Unsafe/bignumber.scm 642 */
																				int BgL_iz00_3562;

																				BgL_iz00_3562 =
																					(int) (BgL_arg2271z00_1518);
																				{	/* Unsafe/bignumber.scm 642 */
																					obj_t BgL_arg1905z00_3563;

																					BgL_arg1905z00_3563 =
																						BGL_BIGNUM_U16VECT(BgL_nyz00_1397);
																					{	/* Unsafe/bignumber.scm 642 */
																						long BgL_auxz00_5937;

																						BgL_auxz00_5937 =
																							(long) (BgL_iz00_3562);
																						BgL_msdzd2ofzd2nyz00_1431 =
																							BGL_U16VREF(BgL_arg1905z00_3563,
																							BgL_auxz00_5937);
																		}}}}
																		{	/* Unsafe/bignumber.scm 644 */
																			long BgL_arg2272z00_1519;

																			BgL_arg2272z00_1519 =
																				(BgL_lenyz00_1385 - ((long) 2));
																			{	/* Unsafe/bignumber.scm 644 */
																				int BgL_iz00_3567;

																				BgL_iz00_3567 =
																					(int) (BgL_arg2272z00_1519);
																				{	/* Unsafe/bignumber.scm 644 */
																					obj_t BgL_arg1905z00_3568;

																					BgL_arg1905z00_3568 =
																						BGL_BIGNUM_U16VECT(BgL_nyz00_1397);
																					{	/* Unsafe/bignumber.scm 644 */
																						long BgL_auxz00_5943;

																						BgL_auxz00_5943 =
																							(long) (BgL_iz00_3567);
																						BgL_nextzd2msdzd2ofzd2nyzd2_1432 =
																							BGL_U16VREF(BgL_arg1905z00_3568,
																							BgL_auxz00_5943);
																		}}}}
																		{	/* Unsafe/bignumber.scm 646 */
																			int BgL_iz00_3570;

																			BgL_iz00_3570 = (int) (BgL_iz00_1428);
																			{	/* Unsafe/bignumber.scm 646 */
																				obj_t BgL_arg1905z00_3571;

																				BgL_arg1905z00_3571 =
																					BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																				{	/* Unsafe/bignumber.scm 646 */
																					long BgL_auxz00_5948;

																					BgL_auxz00_5948 =
																						(long) (BgL_iz00_3570);
																					BgL_msdzd2ofzd2nxz00_1433 =
																						BGL_U16VREF(BgL_arg1905z00_3571,
																						BgL_auxz00_5948);
																		}}}
																		{	/* Unsafe/bignumber.scm 648 */
																			long BgL_arg2273z00_1520;

																			BgL_arg2273z00_1520 =
																				(BgL_iz00_1428 - ((long) 1));
																			{	/* Unsafe/bignumber.scm 648 */
																				int BgL_iz00_3575;

																				BgL_iz00_3575 =
																					(int) (BgL_arg2273z00_1520);
																				{	/* Unsafe/bignumber.scm 648 */
																					obj_t BgL_arg1905z00_3576;

																					BgL_arg1905z00_3576 =
																						BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																					{	/* Unsafe/bignumber.scm 648 */
																						long BgL_auxz00_5954;

																						BgL_auxz00_5954 =
																							(long) (BgL_iz00_3575);
																						BgL_nextzd2msdzd2ofzd2nxzd2_1434 =
																							BGL_U16VREF(BgL_arg1905z00_3576,
																							BgL_auxz00_5954);
																		}}}}
																		{	/* Unsafe/bignumber.scm 650 */
																			long BgL_arg2274z00_1521;

																			BgL_arg2274z00_1521 =
																				(BgL_iz00_1428 - ((long) 2));
																			{	/* Unsafe/bignumber.scm 650 */
																				int BgL_iz00_3580;

																				BgL_iz00_3580 =
																					(int) (BgL_arg2274z00_1521);
																				{	/* Unsafe/bignumber.scm 650 */
																					obj_t BgL_arg1905z00_3581;

																					BgL_arg1905z00_3581 =
																						BGL_BIGNUM_U16VECT(BgL_nxz00_1396);
																					{	/* Unsafe/bignumber.scm 650 */
																						long BgL_auxz00_5960;

																						BgL_auxz00_5960 =
																							(long) (BgL_iz00_3580);
																						BgL_nextzd2nextzd2msdzd2ofzd2nxz00_1435
																							=
																							BGL_U16VREF(BgL_arg1905z00_3581,
																							BgL_auxz00_5960);
																		}}}}
																		{
																			long BgL_qz00_1502;

																			long BgL_uz00_1503;

																			{	/* Unsafe/bignumber.scm 664 */
																				long BgL_qz00_1437;

																				if (
																					((long) (BgL_msdzd2ofzd2nxz00_1433) ==
																						(long) (BgL_msdzd2ofzd2nyz00_1431)))
																					{	/* Unsafe/bignumber.scm 664 */
																						BgL_qz00_1502 =
																							(
																							(((long) 1) <<
																								(int) (((long) 14))) -
																							((long) 1));
																						BgL_uz00_1503 =
																							((long)
																							(BgL_msdzd2ofzd2nyz00_1431) +
																							(long)
																							(BgL_nextzd2msdzd2ofzd2nxzd2_1434));
																					BgL_zc3anonymousza32261ze3z83_1504:
																						if (
																							(BgL_uz00_1503 <
																								(((long) 1) <<
																									(int) (((long) 14)))))
																							{	/* Unsafe/bignumber.scm 654 */
																								long BgL_temp1z00_1506;

																								BgL_temp1z00_1506 =
																									(BgL_qz00_1502 *
																									(long)
																									(BgL_nextzd2msdzd2ofzd2nyzd2_1432));
																								{	/* Unsafe/bignumber.scm 654 */
																									long BgL_temp2z00_1507;

																									{	/* Unsafe/bignumber.scm 655 */
																										long BgL_auxz00_5973;

																										BgL_auxz00_5973 =
																											(((long) 1) <<
																											(int) (((long) 14)));
																										BgL_temp2z00_1507 =
																											(BgL_temp1z00_1506 /
																											BgL_auxz00_5973);
																									}
																									{	/* Unsafe/bignumber.scm 655 */

																										{	/* Unsafe/bignumber.scm 656 */
																											bool_t BgL_testz00_5977;

																											if (
																												(BgL_uz00_1503 <
																													BgL_temp2z00_1507))
																												{	/* Unsafe/bignumber.scm 656 */
																													BgL_testz00_5977 =
																														((bool_t) 1);
																												}
																											else
																												{	/* Unsafe/bignumber.scm 656 */
																													if (
																														(BgL_temp2z00_1507
																															== BgL_uz00_1503))
																														{	/* Unsafe/bignumber.scm 659 */
																															long
																																BgL_arg2267z00_1513;
																															{	/* Unsafe/bignumber.scm 659 */
																																long
																																	BgL_auxz00_5982;
																																BgL_auxz00_5982
																																	=
																																	(((long) 1) <<
																																	(int) (((long)
																																			14)));
																																BgL_arg2267z00_1513
																																	=
																																	(BgL_temp1z00_1506
																																	%
																																	BgL_auxz00_5982);
																															}
																															BgL_testz00_5977 =
																																(
																																(long)
																																(BgL_nextzd2nextzd2msdzd2ofzd2nxz00_1435)
																																<
																																BgL_arg2267z00_1513);
																														}
																													else
																														{	/* Unsafe/bignumber.scm 657 */
																															BgL_testz00_5977 =
																																((bool_t) 0);
																														}
																												}
																											if (BgL_testz00_5977)
																												{
																													long BgL_uz00_5990;

																													long BgL_qz00_5988;

																													BgL_qz00_5988 =
																														(BgL_qz00_1502 -
																														((long) 1));
																													BgL_uz00_5990 =
																														(BgL_uz00_1503 +
																														(long)
																														(BgL_msdzd2ofzd2nyz00_1431));
																													BgL_uz00_1503 =
																														BgL_uz00_5990;
																													BgL_qz00_1502 =
																														BgL_qz00_5988;
																													goto
																														BgL_zc3anonymousza32261ze3z83_1504;
																												}
																											else
																												{	/* Unsafe/bignumber.scm 656 */
																													BgL_qz00_1437 =
																														BgL_qz00_1502;
																												}
																										}
																									}
																								}
																							}
																						else
																							{	/* Unsafe/bignumber.scm 653 */
																								BgL_qz00_1437 = BgL_qz00_1502;
																							}
																					}
																				else
																					{	/* Unsafe/bignumber.scm 667 */
																						long BgL_tempz00_1497;

																						BgL_tempz00_1497 =
																							(
																							((long)
																								(BgL_msdzd2ofzd2nxz00_1433) *
																								(((long) 1) << (int) (((long)
																											14)))) +
																							(long)
																							(BgL_nextzd2msdzd2ofzd2nxzd2_1434));
																						{	/* Unsafe/bignumber.scm 669 */
																							long BgL_arg2257z00_1498;

																							long BgL_arg2258z00_1499;

																							{	/* Unsafe/bignumber.scm 669 */
																								long BgL_auxz00_6005;

																								BgL_auxz00_6005 =
																									(long)
																									(BgL_msdzd2ofzd2nyz00_1431);
																								BgL_arg2257z00_1498 =
																									(BgL_tempz00_1497 /
																									BgL_auxz00_6005);
																							}
																							BgL_arg2258z00_1499 =
																								BGl_modulofxz00zz__r4_numbers_6_5_fixnumz00
																								(BgL_tempz00_1497,
																								(long)
																								(BgL_msdzd2ofzd2nyz00_1431));
																							{
																								long BgL_uz00_6011;

																								long BgL_qz00_6010;

																								BgL_qz00_6010 =
																									BgL_arg2257z00_1498;
																								BgL_uz00_6011 =
																									BgL_arg2258z00_1499;
																								BgL_uz00_1503 = BgL_uz00_6011;
																								BgL_qz00_1502 = BgL_qz00_6010;
																								goto
																									BgL_zc3anonymousza32261ze3z83_1504;
																							}
																						}
																					}
																				{	/* Unsafe/bignumber.scm 674 */
																					long BgL_g1784z00_1438;

																					BgL_g1784z00_1438 =
																						(BgL_iz00_1428 -
																						(BgL_lenyz00_1385 - ((long) 1)));
																					{
																						long BgL_jz00_1440;

																						long BgL_kz00_1441;

																						long BgL_bz00_1442;

																						BgL_jz00_1440 = ((long) 1);
																						BgL_kz00_1441 = BgL_g1784z00_1438;
																						BgL_bz00_1442 = ((long) 0);
																					BgL_zc3anonymousza32211ze3z83_1443:
																						if (
																							(BgL_jz00_1440 <
																								BgL_lenyz00_1385))
																							{	/* Unsafe/bignumber.scm 679 */
																								long BgL_wz00_1445;

																								{	/* Unsafe/bignumber.scm 679 */
																									long BgL_arg2221z00_1454;

																									long BgL_arg2222z00_1455;

																									{	/* Unsafe/bignumber.scm 679 */
																										unsigned short
																											BgL_arg2223z00_1456;
																										{	/* Unsafe/bignumber.scm 679 */
																											int BgL_iz00_3607;

																											BgL_iz00_3607 =
																												(int) (BgL_kz00_1441);
																											{	/* Unsafe/bignumber.scm 679 */
																												obj_t
																													BgL_arg1905z00_3608;
																												BgL_arg1905z00_3608 =
																													BGL_BIGNUM_U16VECT
																													(BgL_nxz00_1396);
																												{	/* Unsafe/bignumber.scm 679 */
																													long BgL_auxz00_6018;

																													BgL_auxz00_6018 =
																														(long)
																														(BgL_iz00_3607);
																													BgL_arg2223z00_1456 =
																														BGL_U16VREF
																														(BgL_arg1905z00_3608,
																														BgL_auxz00_6018);
																										}}}
																										BgL_arg2221z00_1454 =
																											(
																											(long)
																											(BgL_arg2223z00_1456) +
																											BgL_bz00_1442);
																									}
																									{	/* Unsafe/bignumber.scm 680 */
																										unsigned short
																											BgL_arg2224z00_1457;
																										{	/* Unsafe/bignumber.scm 680 */
																											int BgL_iz00_3612;

																											BgL_iz00_3612 =
																												(int) (BgL_jz00_1440);
																											{	/* Unsafe/bignumber.scm 680 */
																												obj_t
																													BgL_arg1905z00_3613;
																												BgL_arg1905z00_3613 =
																													BGL_BIGNUM_U16VECT
																													(BgL_nyz00_1397);
																												{	/* Unsafe/bignumber.scm 680 */
																													long BgL_auxz00_6025;

																													BgL_auxz00_6025 =
																														(long)
																														(BgL_iz00_3612);
																													BgL_arg2224z00_1457 =
																														BGL_U16VREF
																														(BgL_arg1905z00_3613,
																														BgL_auxz00_6025);
																										}}}
																										BgL_arg2222z00_1455 =
																											(
																											(long)
																											(BgL_arg2224z00_1457) *
																											BgL_qz00_1437);
																									}
																									BgL_wz00_1445 =
																										(BgL_arg2221z00_1454 -
																										BgL_arg2222z00_1455);
																								}
																								{	/* Unsafe/bignumber.scm 684 */
																									obj_t BgL_arg2213z00_1446;

																									BgL_arg2213z00_1446 =
																										BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																										(BINT(BgL_wz00_1445),
																										BINT((((long) 1) <<
																												(int) (((long) 14)))));
																									{	/* Unsafe/bignumber.scm 681 */
																										int BgL_iz00_3621;

																										int BgL_digitz00_3622;

																										BgL_iz00_3621 =
																											(int) (BgL_kz00_1441);
																										BgL_digitz00_3622 =
																											CINT(BgL_arg2213z00_1446);
																										{	/* Unsafe/bignumber.scm 681 */
																											obj_t BgL_arg1906z00_3623;

																											BgL_arg1906z00_3623 =
																												BGL_BIGNUM_U16VECT
																												(BgL_nxz00_1396);
																											{	/* Unsafe/bignumber.scm 681 */
																												unsigned short
																													BgL_auxz00_6041;
																												long BgL_auxz00_6039;

																												BgL_auxz00_6041 =
																													(unsigned
																													short)
																													(BgL_digitz00_3622);
																												BgL_auxz00_6039 =
																													(long)
																													(BgL_iz00_3621);
																												BGL_U16VSET
																													(BgL_arg1906z00_3623,
																													BgL_auxz00_6039,
																													BgL_auxz00_6041);
																											} BUNSPEC;
																								}}}
																								{	/* Unsafe/bignumber.scm 685 */
																									long BgL_arg2215z00_1448;

																									long BgL_arg2216z00_1449;

																									long BgL_arg2217z00_1450;

																									BgL_arg2215z00_1448 =
																										(BgL_jz00_1440 +
																										((long) 1));
																									BgL_arg2216z00_1449 =
																										(BgL_kz00_1441 +
																										((long) 1));
																									{	/* Unsafe/bignumber.scm 687 */
																										long BgL_auxz00_6051;

																										long BgL_auxz00_6046;

																										BgL_auxz00_6051 =
																											(((long) 1) <<
																											(int) (((long) 14)));
																										BgL_auxz00_6046 =
																											(BgL_wz00_1445 -
																											((((long) 1) <<
																													(int) (((long) 14))) -
																												((long) 1)));
																										BgL_arg2217z00_1450 =
																											(BgL_auxz00_6046 /
																											BgL_auxz00_6051);
																									}
																									{
																										long BgL_bz00_6057;

																										long BgL_kz00_6056;

																										long BgL_jz00_6055;

																										BgL_jz00_6055 =
																											BgL_arg2215z00_1448;
																										BgL_kz00_6056 =
																											BgL_arg2216z00_1449;
																										BgL_bz00_6057 =
																											BgL_arg2217z00_1450;
																										BgL_bz00_1442 =
																											BgL_bz00_6057;
																										BgL_kz00_1441 =
																											BgL_kz00_6056;
																										BgL_jz00_1440 =
																											BgL_jz00_6055;
																										goto
																											BgL_zc3anonymousza32211ze3z83_1443;
																									}
																								}
																							}
																						else
																							{	/* Unsafe/bignumber.scm 690 */
																								long BgL_wz00_1458;

																								{	/* Unsafe/bignumber.scm 690 */
																									unsigned short
																										BgL_arg2252z00_1491;
																									{	/* Unsafe/bignumber.scm 690 */
																										int BgL_iz00_3641;

																										BgL_iz00_3641 =
																											(int) (BgL_kz00_1441);
																										{	/* Unsafe/bignumber.scm 690 */
																											obj_t BgL_arg1905z00_3642;

																											BgL_arg1905z00_3642 =
																												BGL_BIGNUM_U16VECT
																												(BgL_nxz00_1396);
																											{	/* Unsafe/bignumber.scm 690 */
																												long BgL_auxz00_6060;

																												BgL_auxz00_6060 =
																													(long)
																													(BgL_iz00_3641);
																												BgL_arg2252z00_1491 =
																													BGL_U16VREF
																													(BgL_arg1905z00_3642,
																													BgL_auxz00_6060);
																									}}}
																									BgL_wz00_1458 =
																										(
																										(long) (BgL_arg2252z00_1491)
																										+ BgL_bz00_1442);
																								}
																								{	/* Unsafe/bignumber.scm 694 */
																									obj_t BgL_arg2225z00_1459;

																									BgL_arg2225z00_1459 =
																										BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																										(BINT(BgL_wz00_1458),
																										BINT((((long) 1) <<
																												(int) (((long) 14)))));
																									{	/* Unsafe/bignumber.scm 691 */
																										int BgL_iz00_3648;

																										int BgL_digitz00_3649;

																										BgL_iz00_3648 =
																											(int) (BgL_kz00_1441);
																										BgL_digitz00_3649 =
																											CINT(BgL_arg2225z00_1459);
																										{	/* Unsafe/bignumber.scm 691 */
																											obj_t BgL_arg1906z00_3650;

																											BgL_arg1906z00_3650 =
																												BGL_BIGNUM_U16VECT
																												(BgL_nxz00_1396);
																											{	/* Unsafe/bignumber.scm 691 */
																												unsigned short
																													BgL_auxz00_6075;
																												long BgL_auxz00_6073;

																												BgL_auxz00_6075 =
																													(unsigned
																													short)
																													(BgL_digitz00_3649);
																												BgL_auxz00_6073 =
																													(long)
																													(BgL_iz00_3648);
																												BGL_U16VSET
																													(BgL_arg1906z00_3650,
																													BgL_auxz00_6073,
																													BgL_auxz00_6075);
																											} BUNSPEC;
																								}}}
																								if (
																									(BgL_wz00_1458 < ((long) 0)))
																									{	/* Unsafe/bignumber.scm 695 */
																										{	/* Unsafe/bignumber.scm 699 */
																											long BgL_arg2228z00_1462;

																											long BgL_arg2229z00_1463;

																											BgL_arg2228z00_1462 =
																												(BgL_iz00_1428 -
																												(BgL_lenyz00_1385 -
																													((long) 1)));
																											BgL_arg2229z00_1463 =
																												(BgL_qz00_1437 -
																												((long) 1));
																											{	/* Unsafe/bignumber.scm 697 */
																												int BgL_iz00_3660;

																												int BgL_digitz00_3661;

																												BgL_iz00_3660 =
																													(int)
																													(BgL_arg2228z00_1462);
																												BgL_digitz00_3661 =
																													(int)
																													(BgL_arg2229z00_1463);
																												{	/* Unsafe/bignumber.scm 697 */
																													obj_t
																														BgL_arg1906z00_3662;
																													BgL_arg1906z00_3662 =
																														BGL_BIGNUM_U16VECT
																														(BgL_rz00_1386);
																													{	/* Unsafe/bignumber.scm 697 */
																														unsigned short
																															BgL_auxz00_6088;
																														long
																															BgL_auxz00_6086;
																														BgL_auxz00_6088 =
																															(unsigned
																															short)
																															(BgL_digitz00_3661);
																														BgL_auxz00_6086 =
																															(long)
																															(BgL_iz00_3660);
																														BGL_U16VSET
																															(BgL_arg1906z00_3662,
																															BgL_auxz00_6086,
																															BgL_auxz00_6088);
																													} BUNSPEC;
																										}}}
																										{	/* Unsafe/bignumber.scm 701 */
																											long BgL_g1785z00_1465;

																											BgL_g1785z00_1465 =
																												(BgL_iz00_1428 -
																												(BgL_lenyz00_1385 -
																													((long) 1)));
																											{
																												long BgL_jz00_1467;

																												long BgL_kz00_1468;

																												long BgL_cz00_1469;

																												BgL_jz00_1467 =
																													((long) 1);
																												BgL_kz00_1468 =
																													BgL_g1785z00_1465;
																												BgL_cz00_1469 =
																													((long) 0);
																											BgL_zc3anonymousza32231ze3z83_1470:
																												if (
																													(BgL_jz00_1467 <
																														BgL_lenyz00_1385))
																													{	/* Unsafe/bignumber.scm 706 */
																														long BgL_wz00_1472;

																														{	/* Unsafe/bignumber.scm 708 */
																															long
																																BgL_arg2239z00_1479;
																															{	/* Unsafe/bignumber.scm 708 */
																																unsigned short
																																	BgL_arg2240z00_1480;
																																unsigned short
																																	BgL_arg2242z00_1481;
																																{	/* Unsafe/bignumber.scm 708 */
																																	int
																																		BgL_iz00_3670;
																																	BgL_iz00_3670
																																		=
																																		(int)
																																		(BgL_kz00_1468);
																																	{	/* Unsafe/bignumber.scm 708 */
																																		obj_t
																																			BgL_arg1905z00_3671;
																																		BgL_arg1905z00_3671
																																			=
																																			BGL_BIGNUM_U16VECT
																																			(BgL_nxz00_1396);
																																		{	/* Unsafe/bignumber.scm 708 */
																																			long
																																				BgL_auxz00_6097;
																																			BgL_auxz00_6097
																																				=
																																				(long)
																																				(BgL_iz00_3670);
																																			BgL_arg2240z00_1480
																																				=
																																				BGL_U16VREF
																																				(BgL_arg1905z00_3671,
																																				BgL_auxz00_6097);
																																}}}
																																{	/* Unsafe/bignumber.scm 709 */
																																	int
																																		BgL_iz00_3673;
																																	BgL_iz00_3673
																																		=
																																		(int)
																																		(BgL_jz00_1467);
																																	{	/* Unsafe/bignumber.scm 709 */
																																		obj_t
																																			BgL_arg1905z00_3674;
																																		BgL_arg1905z00_3674
																																			=
																																			BGL_BIGNUM_U16VECT
																																			(BgL_nyz00_1397);
																																		{	/* Unsafe/bignumber.scm 709 */
																																			long
																																				BgL_auxz00_6102;
																																			BgL_auxz00_6102
																																				=
																																				(long)
																																				(BgL_iz00_3673);
																																			BgL_arg2242z00_1481
																																				=
																																				BGL_U16VREF
																																				(BgL_arg1905z00_3674,
																																				BgL_auxz00_6102);
																																}}}
																																BgL_arg2239z00_1479
																																	=
																																	((long)
																																	(BgL_arg2240z00_1480)
																																	+
																																	(long)
																																	(BgL_arg2242z00_1481));
																															}
																															BgL_wz00_1472 =
																																(BgL_arg2239z00_1479
																																+
																																BgL_cz00_1469);
																														}
																														{	/* Unsafe/bignumber.scm 714 */
																															obj_t
																																BgL_arg2233z00_1473;
																															BgL_arg2233z00_1473
																																=
																																BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																																(BINT
																																(BgL_wz00_1472),
																																BINT((((long) 1)
																																		<<
																																		(int) ((
																																				(long)
																																				14)))));
																															{	/* Unsafe/bignumber.scm 711 */
																																int
																																	BgL_iz00_3682;
																																int
																																	BgL_digitz00_3683;
																																BgL_iz00_3682 =
																																	(int)
																																	(BgL_kz00_1468);
																																BgL_digitz00_3683
																																	=
																																	CINT
																																	(BgL_arg2233z00_1473);
																																{	/* Unsafe/bignumber.scm 711 */
																																	obj_t
																																		BgL_arg1906z00_3684;
																																	BgL_arg1906z00_3684
																																		=
																																		BGL_BIGNUM_U16VECT
																																		(BgL_nxz00_1396);
																																	{	/* Unsafe/bignumber.scm 711 */
																																		unsigned
																																			short
																																			BgL_auxz00_6119;
																																		long
																																			BgL_auxz00_6117;
																																		BgL_auxz00_6119
																																			=
																																			(unsigned
																																			short)
																																			(BgL_digitz00_3683);
																																		BgL_auxz00_6117
																																			=
																																			(long)
																																			(BgL_iz00_3682);
																																		BGL_U16VSET
																																			(BgL_arg1906z00_3684,
																																			BgL_auxz00_6117,
																																			BgL_auxz00_6119);
																																	} BUNSPEC;
																														}}}
																														{	/* Unsafe/bignumber.scm 716 */
																															long
																																BgL_arg2235z00_1475;
																															long
																																BgL_arg2236z00_1476;
																															long
																																BgL_arg2237z00_1477;
																															BgL_arg2235z00_1475
																																=
																																(BgL_jz00_1467 +
																																((long) 1));
																															BgL_arg2236z00_1476
																																=
																																(BgL_kz00_1468 +
																																((long) 1));
																															{	/* Unsafe/bignumber.scm 718 */
																																long
																																	BgL_auxz00_6124;
																																BgL_auxz00_6124
																																	=
																																	(((long) 1) <<
																																	(int) (((long)
																																			14)));
																																BgL_arg2237z00_1477
																																	=
																																	(BgL_wz00_1472
																																	/
																																	BgL_auxz00_6124);
																															}
																															{
																																long
																																	BgL_cz00_6130;
																																long
																																	BgL_kz00_6129;
																																long
																																	BgL_jz00_6128;
																																BgL_jz00_6128 =
																																	BgL_arg2235z00_1475;
																																BgL_kz00_6129 =
																																	BgL_arg2236z00_1476;
																																BgL_cz00_6130 =
																																	BgL_arg2237z00_1477;
																																BgL_cz00_1469 =
																																	BgL_cz00_6130;
																																BgL_kz00_1468 =
																																	BgL_kz00_6129;
																																BgL_jz00_1467 =
																																	BgL_jz00_6128;
																																goto
																																	BgL_zc3anonymousza32231ze3z83_1470;
																															}
																														}
																													}
																												else
																													{	/* Unsafe/bignumber.scm 723 */
																														obj_t
																															BgL_arg2243z00_1482;
																														{	/* Unsafe/bignumber.scm 723 */
																															long
																																BgL_arg2245z00_1483;
																															long
																																BgL_arg2246z00_1484;
																															{	/* Unsafe/bignumber.scm 723 */
																																unsigned short
																																	BgL_arg2247z00_1485;
																																{	/* Unsafe/bignumber.scm 723 */
																																	int
																																		BgL_iz00_3694;
																																	BgL_iz00_3694
																																		=
																																		(int)
																																		(BgL_kz00_1468);
																																	{	/* Unsafe/bignumber.scm 723 */
																																		obj_t
																																			BgL_arg1905z00_3695;
																																		BgL_arg1905z00_3695
																																			=
																																			BGL_BIGNUM_U16VECT
																																			(BgL_nxz00_1396);
																																		{	/* Unsafe/bignumber.scm 723 */
																																			long
																																				BgL_auxz00_6133;
																																			BgL_auxz00_6133
																																				=
																																				(long)
																																				(BgL_iz00_3694);
																																			BgL_arg2247z00_1485
																																				=
																																				BGL_U16VREF
																																				(BgL_arg1905z00_3695,
																																				BgL_auxz00_6133);
																																}}}
																																BgL_arg2245z00_1483
																																	=
																																	((long)
																																	(BgL_arg2247z00_1485)
																																	+
																																	BgL_cz00_1469);
																															}
																															BgL_arg2246z00_1484
																																=
																																(((long) 1) <<
																																(int) (((long)
																																		14)));
																															BgL_arg2243z00_1482
																																=
																																BGl_moduloz00zz__r4_numbers_6_5_fixnumz00
																																(BINT
																																(BgL_arg2245z00_1483),
																																BINT
																																(BgL_arg2246z00_1484));
																														}
																														{	/* Unsafe/bignumber.scm 719 */
																															int BgL_iz00_3701;

																															int
																																BgL_digitz00_3702;
																															BgL_iz00_3701 =
																																(int)
																																(BgL_kz00_1468);
																															BgL_digitz00_3702
																																=
																																CINT
																																(BgL_arg2243z00_1482);
																															{	/* Unsafe/bignumber.scm 719 */
																																obj_t
																																	BgL_arg1906z00_3703;
																																BgL_arg1906z00_3703
																																	=
																																	BGL_BIGNUM_U16VECT
																																	(BgL_nxz00_1396);
																																{	/* Unsafe/bignumber.scm 719 */
																																	unsigned short
																																		BgL_auxz00_6148;
																																	long
																																		BgL_auxz00_6146;
																																	BgL_auxz00_6148
																																		=
																																		(unsigned
																																		short)
																																		(BgL_digitz00_3702);
																																	BgL_auxz00_6146
																																		=
																																		(long)
																																		(BgL_iz00_3701);
																																	BGL_U16VSET
																																		(BgL_arg1906z00_3703,
																																		BgL_auxz00_6146,
																																		BgL_auxz00_6148);
																																} BUNSPEC;
																									}}}}}}
																								else
																									{	/* Unsafe/bignumber.scm 725 */
																										long BgL_arg2249z00_1488;

																										BgL_arg2249z00_1488 =
																											(BgL_iz00_1428 -
																											(BgL_lenyz00_1385 -
																												((long) 1)));
																										{	/* Unsafe/bignumber.scm 725 */
																											int BgL_iz00_3709;

																											int BgL_digitz00_3710;

																											BgL_iz00_3709 =
																												(int)
																												(BgL_arg2249z00_1488);
																											BgL_digitz00_3710 =
																												(int) (BgL_qz00_1437);
																											{	/* Unsafe/bignumber.scm 725 */
																												obj_t
																													BgL_arg1906z00_3711;
																												BgL_arg1906z00_3711 =
																													BGL_BIGNUM_U16VECT
																													(BgL_rz00_1386);
																												{	/* Unsafe/bignumber.scm 725 */
																													unsigned short
																														BgL_auxz00_6158;
																													long BgL_auxz00_6156;

																													BgL_auxz00_6158 =
																														(unsigned
																														short)
																														(BgL_digitz00_3710);
																													BgL_auxz00_6156 =
																														(long)
																														(BgL_iz00_3709);
																													BGL_U16VSET
																														(BgL_arg1906z00_3711,
																														BgL_auxz00_6156,
																														BgL_auxz00_6158);
																												} BUNSPEC;
																									}}}
																								{
																									long BgL_iz00_6161;

																									BgL_iz00_6161 =
																										(BgL_iz00_1428 -
																										((long) 1));
																									BgL_iz00_1428 = BgL_iz00_6161;
																									goto
																										BgL_zc3anonymousza32209ze3z83_1429;
																								}
																							}
																					}
																				}
																			}
																		}
																	}
															}
															{	/* Unsafe/bignumber.scm 728 */
																long BgL_g1786z00_1523;

																BgL_g1786z00_1523 =
																	(BgL_lenyz00_1385 - ((long) 1));
																{
																	long BgL_iz00_1525;

																	long BgL_kz00_1526;

																	BgL_iz00_1525 = BgL_g1786z00_1523;
																	BgL_kz00_1526 = ((long) 0);
																BgL_zc3anonymousza32275ze3z83_1527:
																	if ((((long) 0) < BgL_iz00_1525))
																		{	/* Unsafe/bignumber.scm 730 */
																			long BgL_wz00_1529;

																			{	/* Unsafe/bignumber.scm 730 */
																				long BgL_arg2280z00_1533;

																				unsigned short BgL_arg2281z00_1534;

																				BgL_arg2280z00_1533 =
																					(BgL_kz00_1526 *
																					(((long) 1) << (int) (((long) 14))));
																				{	/* Unsafe/bignumber.scm 731 */
																					int BgL_iz00_3747;

																					BgL_iz00_3747 = (int) (BgL_iz00_1525);
																					{	/* Unsafe/bignumber.scm 731 */
																						obj_t BgL_arg1905z00_3748;

																						BgL_arg1905z00_3748 =
																							BGL_BIGNUM_U16VECT
																							(BgL_nxz00_1396);
																						{	/* Unsafe/bignumber.scm 731 */
																							long BgL_auxz00_6171;

																							BgL_auxz00_6171 =
																								(long) (BgL_iz00_3747);
																							BgL_arg2281z00_1534 =
																								BGL_U16VREF(BgL_arg1905z00_3748,
																								BgL_auxz00_6171);
																				}}}
																				BgL_wz00_1529 =
																					(BgL_arg2280z00_1533 +
																					(long) (BgL_arg2281z00_1534));
																			}
																			{	/* Unsafe/bignumber.scm 732 */
																				long BgL_arg2277z00_1530;

																				BgL_arg2277z00_1530 =
																					(BgL_wz00_1529 / BgL_shiftz00_1390);
																				{	/* Unsafe/bignumber.scm 732 */
																					int BgL_iz00_3754;

																					int BgL_digitz00_3755;

																					BgL_iz00_3754 = (int) (BgL_iz00_1525);
																					BgL_digitz00_3755 =
																						(int) (BgL_arg2277z00_1530);
																					{	/* Unsafe/bignumber.scm 732 */
																						obj_t BgL_arg1906z00_3756;

																						BgL_arg1906z00_3756 =
																							BGL_BIGNUM_U16VECT
																							(BgL_nxz00_1396);
																						{	/* Unsafe/bignumber.scm 732 */
																							unsigned short BgL_auxz00_6182;

																							long BgL_auxz00_6180;

																							BgL_auxz00_6182 =
																								(unsigned
																								short) (BgL_digitz00_3755);
																							BgL_auxz00_6180 =
																								(long) (BgL_iz00_3754);
																							BGL_U16VSET(BgL_arg1906z00_3756,
																								BgL_auxz00_6180,
																								BgL_auxz00_6182);
																						} BUNSPEC;
																			}}}
																			{	/* Unsafe/bignumber.scm 733 */
																				long BgL_arg2278z00_1531;

																				long BgL_arg2279z00_1532;

																				BgL_arg2278z00_1531 =
																					(BgL_iz00_1525 - ((long) 1));
																				BgL_arg2279z00_1532 =
																					(BgL_wz00_1529 % BgL_shiftz00_1390);
																				{
																					long BgL_kz00_6188;

																					long BgL_iz00_6187;

																					BgL_iz00_6187 = BgL_arg2278z00_1531;
																					BgL_kz00_6188 = BgL_arg2279z00_1532;
																					BgL_kz00_1526 = BgL_kz00_6188;
																					BgL_iz00_1525 = BgL_iz00_6187;
																					goto
																						BgL_zc3anonymousza32275ze3z83_1527;
																				}
																			}
																		}
																	else
																		{	/* Unsafe/bignumber.scm 729 */
																			((bool_t) 0);
																		}
																}
															}
															return
																MAKE_PAIR
																(BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
																(BgL_rz00_1386),
																BGl_bignumzd2removezd2leadingzd2za7eroesz75zz__bignumz00
																(BgL_nxz00_1396));
														}
												}
											}
										}
								}
						}
				}
			}
		}
	}



/* $divrembx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_div(obj_t BgL_xz00_61, obj_t BgL_yz00_62)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 758 */
			{	/* Unsafe/bignumber.scm 759 */
				obj_t BgL_vz00_3798;

				BgL_vz00_3798 =
					BGl_bignumzd2divzd2zz__bignumz00(BgL_xz00_61, BgL_yz00_62);
				{	/* Unsafe/bignumber.scm 759 */
					obj_t BgL_val0_1819z00_3799;

					obj_t BgL_val1_1820z00_3800;

					BgL_val0_1819z00_3799 = CAR(BgL_vz00_3798);
					BgL_val1_1820z00_3800 = CDR(BgL_vz00_3798);
					{	/* Unsafe/bignumber.scm 759 */
						int BgL_auxz00_6195;

						BgL_auxz00_6195 = (int) (((long) 2));
						BGL_MVALUES_NUMBER_SET(BgL_auxz00_6195);
					}
					{	/* Unsafe/bignumber.scm 759 */
						int BgL_auxz00_6198;

						BgL_auxz00_6198 = (int) (((long) 1));
						BGL_MVALUES_VAL_SET(BgL_auxz00_6198, BgL_val1_1820z00_3800);
					}
					return BgL_val0_1819z00_3799;
				}
			}
		}
	}



/* _$divrembx */
	obj_t BGl__z42divrembxz42zz__bignumz00(obj_t BgL_envz00_4687,
		obj_t BgL_xz00_4688, obj_t BgL_yz00_4689)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 758 */
			{	/* Unsafe/bignumber.scm 759 */
				obj_t BgL_auxz00_6207;

				obj_t BgL_auxz00_6201;

				if (BIGNUMP(BgL_yz00_4689))
					{	/* Unsafe/bignumber.scm 759 */
						BgL_auxz00_6207 = BgL_yz00_4689;
					}
				else
					{	/* Unsafe/bignumber.scm 759 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3168z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4689, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24738)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4688))
					{	/* Unsafe/bignumber.scm 759 */
						BgL_auxz00_6201 = BgL_xz00_4688;
					}
				else
					{	/* Unsafe/bignumber.scm 759 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3168z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4688, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24738)));
						exit(-1);
					}
				return bgl_bignum_div(BgL_auxz00_6201, BgL_auxz00_6207);
			}
		}
	}



/* $quotientbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_quotient(obj_t BgL_xz00_63,
		obj_t BgL_yz00_64)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 762 */
			return CAR(BGl_bignumzd2divzd2zz__bignumz00(BgL_xz00_63, BgL_yz00_64));
		}
	}



/* _$quotientbx */
	obj_t BGl__z42quotientbxz42zz__bignumz00(obj_t BgL_envz00_4690,
		obj_t BgL_xz00_4691, obj_t BgL_yz00_4692)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 762 */
			{	/* Unsafe/bignumber.scm 763 */
				obj_t BgL_auxz00_6222;

				obj_t BgL_auxz00_6216;

				if (BIGNUMP(BgL_yz00_4692))
					{	/* Unsafe/bignumber.scm 763 */
						BgL_auxz00_6222 = BgL_yz00_4692;
					}
				else
					{	/* Unsafe/bignumber.scm 763 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3169z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4692, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24852)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4691))
					{	/* Unsafe/bignumber.scm 763 */
						BgL_auxz00_6216 = BgL_xz00_4691;
					}
				else
					{	/* Unsafe/bignumber.scm 763 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3169z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4691, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24852)));
						exit(-1);
					}
				return bgl_bignum_quotient(BgL_auxz00_6216, BgL_auxz00_6222);
			}
		}
	}



/* $remainderbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_remainder(obj_t BgL_xz00_65,
		obj_t BgL_yz00_66)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 765 */
			return CDR(BGl_bignumzd2divzd2zz__bignumz00(BgL_xz00_65, BgL_yz00_66));
		}
	}



/* _$remainderbx */
	obj_t BGl__z42remainderbxz42zz__bignumz00(obj_t BgL_envz00_4693,
		obj_t BgL_xz00_4694, obj_t BgL_yz00_4695)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 765 */
			{	/* Unsafe/bignumber.scm 766 */
				obj_t BgL_auxz00_6237;

				obj_t BgL_auxz00_6231;

				if (BIGNUMP(BgL_yz00_4695))
					{	/* Unsafe/bignumber.scm 766 */
						BgL_auxz00_6237 = BgL_yz00_4695;
					}
				else
					{	/* Unsafe/bignumber.scm 766 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3170z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4695, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24926)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4694))
					{	/* Unsafe/bignumber.scm 766 */
						BgL_auxz00_6231 = BgL_xz00_4694;
					}
				else
					{	/* Unsafe/bignumber.scm 766 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3170z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4694, BGl_string3147z00zz__bignumz00,
							BINT(((long) 24926)));
						exit(-1);
					}
				return bgl_bignum_remainder(BgL_auxz00_6231, BgL_auxz00_6237);
			}
		}
	}



/* $absbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_abs(obj_t BgL_xz00_77)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 797 */
			{	/* Unsafe/bignumber.scm 798 */
				bool_t BgL_testz00_6244;

				{	/* Unsafe/bignumber.scm 798 */
					bool_t BgL_res3019z00_3823;

					{	/* Unsafe/bignumber.scm 798 */
						unsigned short BgL_arg2015z00_3816;

						{	/* Unsafe/bignumber.scm 798 */
							obj_t BgL_arg1901z00_3819;

							BgL_arg1901z00_3819 = BGL_BIGNUM_U16VECT(BgL_xz00_77);
							BgL_arg2015z00_3816 =
								BGL_U16VREF(BgL_arg1901z00_3819, ((long) 0));
						}
						BgL_res3019z00_3823 = ((long) (BgL_arg2015z00_3816) == ((long) 0));
					}
					BgL_testz00_6244 = BgL_res3019z00_3823;
				}
				if (BgL_testz00_6244)
					{	/* Unsafe/bignumber.scm 798 */
						return
							bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00, BgL_xz00_77);
					}
				else
					{	/* Unsafe/bignumber.scm 798 */
						return BgL_xz00_77;
					}
			}
		}
	}



/* _$absbx */
	obj_t BGl__z42absbxz42zz__bignumz00(obj_t BgL_envz00_4696,
		obj_t BgL_xz00_4697)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 797 */
			{	/* Unsafe/bignumber.scm 798 */
				obj_t BgL_auxz00_6250;

				if (BIGNUMP(BgL_xz00_4697))
					{	/* Unsafe/bignumber.scm 798 */
						BgL_auxz00_6250 = BgL_xz00_4697;
					}
				else
					{	/* Unsafe/bignumber.scm 798 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3171z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4697, BGl_string3147z00zz__bignumz00,
							BINT(((long) 25763)));
						exit(-1);
					}
				return bgl_bignum_abs(BgL_auxz00_6250);
			}
		}
	}



/* $gcdbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_gcd(obj_t BgL_xz00_78, obj_t BgL_yz00_79)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 802 */
			{	/* Unsafe/bignumber.scm 803 */
				obj_t BgL_g1787z00_3825;

				obj_t BgL_g1788z00_3826;

				{	/* Unsafe/bignumber.scm 803 */
					obj_t BgL_res3021z00_3841;

					{	/* Unsafe/bignumber.scm 803 */
						bool_t BgL_testz00_6257;

						{	/* Unsafe/bignumber.scm 803 */
							bool_t BgL_res3020z00_3839;

							{	/* Unsafe/bignumber.scm 803 */
								unsigned short BgL_arg2015z00_3835;

								BgL_arg2015z00_3835 =
									BGl_bignumzd2signzd2zz__bignumz00(BgL_xz00_78);
								BgL_res3020z00_3839 =
									((long) (BgL_arg2015z00_3835) == ((long) 0));
							}
							BgL_testz00_6257 = BgL_res3020z00_3839;
						}
						if (BgL_testz00_6257)
							{	/* Unsafe/bignumber.scm 803 */
								BgL_res3021z00_3841 =
									bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
									BgL_xz00_78);
							}
						else
							{	/* Unsafe/bignumber.scm 803 */
								BgL_res3021z00_3841 = BgL_xz00_78;
							}
					}
					BgL_g1787z00_3825 = BgL_res3021z00_3841;
				}
				{	/* Unsafe/bignumber.scm 803 */
					obj_t BgL_res3023z00_3851;

					{	/* Unsafe/bignumber.scm 803 */
						bool_t BgL_testz00_6262;

						{	/* Unsafe/bignumber.scm 803 */
							bool_t BgL_res3022z00_3849;

							{	/* Unsafe/bignumber.scm 803 */
								unsigned short BgL_arg2015z00_3845;

								BgL_arg2015z00_3845 =
									BGl_bignumzd2signzd2zz__bignumz00(BgL_yz00_79);
								BgL_res3022z00_3849 =
									((long) (BgL_arg2015z00_3845) == ((long) 0));
							}
							BgL_testz00_6262 = BgL_res3022z00_3849;
						}
						if (BgL_testz00_6262)
							{	/* Unsafe/bignumber.scm 803 */
								BgL_res3023z00_3851 =
									bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
									BgL_yz00_79);
							}
						else
							{	/* Unsafe/bignumber.scm 803 */
								BgL_res3023z00_3851 = BgL_yz00_79;
							}
					}
					BgL_g1788z00_3826 = BgL_res3023z00_3851;
				}
				if (BXZERO(BgL_g1788z00_3826))
					{	/* Unsafe/bignumber.scm 803 */
						return BgL_g1787z00_3825;
					}
				else
					{	/* Unsafe/bignumber.scm 803 */
						obj_t BgL_arg2330z00_3879;

						BgL_arg2330z00_3879 =
							bgl_bignum_remainder(BgL_g1787z00_3825, BgL_g1788z00_3826);
						{
							obj_t BgL_xz00_3853;

							obj_t BgL_yz00_3854;

							BgL_xz00_3853 = BgL_g1788z00_3826;
							BgL_yz00_3854 = BgL_arg2330z00_3879;
						BgL_loopz00_3852:
							if (
								(BGl_bignumzd2lengthzd2zz__bignumz00(BgL_yz00_3854) ==
									((long) 1)))
								{	/* Unsafe/bignumber.scm 803 */
									return BgL_xz00_3853;
								}
							else
								{	/* Unsafe/bignumber.scm 803 */
									obj_t BgL_arg2330z00_3858;

									BgL_arg2330z00_3858 =
										CDR(BGl_bignumzd2divzd2zz__bignumz00(BgL_xz00_3853,
											BgL_yz00_3854));
									if (BXZERO(BgL_arg2330z00_3858))
										{	/* Unsafe/bignumber.scm 803 */
											return BgL_yz00_3854;
										}
									else
										{
											obj_t BgL_yz00_6278;

											obj_t BgL_xz00_6277;

											BgL_xz00_6277 = BgL_arg2330z00_3858;
											BgL_yz00_6278 =
												bgl_bignum_remainder(BgL_yz00_3854,
												BgL_arg2330z00_3858);
											BgL_yz00_3854 = BgL_yz00_6278;
											BgL_xz00_3853 = BgL_xz00_6277;
											goto BgL_loopz00_3852;
										}
								}
						}
					}
			}
		}
	}



/* _$gcdbx */
	obj_t BGl__z42gcdbxz42zz__bignumz00(obj_t BgL_envz00_4698,
		obj_t BgL_xz00_4699, obj_t BgL_yz00_4700)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 802 */
			{	/* Unsafe/bignumber.scm 803 */
				obj_t BgL_auxz00_6286;

				obj_t BgL_auxz00_6280;

				if (BIGNUMP(BgL_yz00_4700))
					{	/* Unsafe/bignumber.scm 803 */
						BgL_auxz00_6286 = BgL_yz00_4700;
					}
				else
					{	/* Unsafe/bignumber.scm 803 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3172z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4700, BGl_string3147z00zz__bignumz00,
							BINT(((long) 25838)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4699))
					{	/* Unsafe/bignumber.scm 803 */
						BgL_auxz00_6280 = BgL_xz00_4699;
					}
				else
					{	/* Unsafe/bignumber.scm 803 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3172z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4699, BGl_string3147z00zz__bignumz00,
							BINT(((long) 25838)));
						exit(-1);
					}
				return bgl_bignum_gcd(BgL_auxz00_6280, BgL_auxz00_6286);
			}
		}
	}



/* $lcmbx */
	BGL_EXPORTED_DEF obj_t bgl_bignum_lcm(obj_t BgL_xz00_80, obj_t BgL_yz00_81)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 808 */
			{	/* Unsafe/bignumber.scm 809 */
				bool_t BgL_testz00_6293;

				{	/* Unsafe/bignumber.scm 809 */
					bool_t BgL_testz00_6294;

					{	/* Unsafe/bignumber.scm 809 */
						bool_t BgL_res3030z00_3932;

						{	/* Unsafe/bignumber.scm 809 */
							long BgL_arg2011z00_3925;

							{	/* Unsafe/bignumber.scm 809 */
								obj_t BgL_arg1900z00_3928;

								BgL_arg1900z00_3928 = BGL_BIGNUM_U16VECT(BgL_xz00_80);
								BgL_arg2011z00_3925 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3928);
							}
							BgL_res3030z00_3932 = (BgL_arg2011z00_3925 == ((long) 1));
						}
						BgL_testz00_6294 = BgL_res3030z00_3932;
					}
					if (BgL_testz00_6294)
						{	/* Unsafe/bignumber.scm 809 */
							BgL_testz00_6293 = ((bool_t) 1);
						}
					else
						{	/* Unsafe/bignumber.scm 809 */
							bool_t BgL_res3031z00_3941;

							{	/* Unsafe/bignumber.scm 809 */
								long BgL_arg2011z00_3934;

								{	/* Unsafe/bignumber.scm 809 */
									obj_t BgL_arg1900z00_3937;

									BgL_arg1900z00_3937 = BGL_BIGNUM_U16VECT(BgL_yz00_81);
									BgL_arg2011z00_3934 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_3937);
								}
								BgL_res3031z00_3941 = (BgL_arg2011z00_3934 == ((long) 1));
							}
							BgL_testz00_6293 = BgL_res3031z00_3941;
				}}
				if (BgL_testz00_6293)
					{	/* Unsafe/bignumber.scm 809 */
						return BGl_bignumzd2za7eroz75zz__bignumz00;
					}
				else
					{	/* Unsafe/bignumber.scm 809 */
						obj_t BgL_arg2332z00_3921;

						obj_t BgL_arg2333z00_3922;

						{	/* Unsafe/bignumber.scm 809 */
							obj_t BgL_arg2334z00_3923;

							BgL_arg2334z00_3923 = bgl_bignum_mul(BgL_xz00_80, BgL_yz00_81);
							{	/* Unsafe/bignumber.scm 809 */
								obj_t BgL_res3033z00_3951;

								{	/* Unsafe/bignumber.scm 809 */
									bool_t BgL_testz00_6302;

									{	/* Unsafe/bignumber.scm 809 */
										bool_t BgL_res3032z00_3949;

										{	/* Unsafe/bignumber.scm 809 */
											unsigned short BgL_arg2015z00_3945;

											BgL_arg2015z00_3945 =
												BGl_bignumzd2signzd2zz__bignumz00(BgL_arg2334z00_3923);
											BgL_res3032z00_3949 =
												((long) (BgL_arg2015z00_3945) == ((long) 0));
										}
										BgL_testz00_6302 = BgL_res3032z00_3949;
									}
									if (BgL_testz00_6302)
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3033z00_3951 =
												bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
												BgL_arg2334z00_3923);
										}
									else
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3033z00_3951 = BgL_arg2334z00_3923;
										}
								}
								BgL_arg2332z00_3921 = BgL_res3033z00_3951;
							}
						}
						{	/* Unsafe/bignumber.scm 809 */
							obj_t BgL_res3038z00_3995;

							{	/* Unsafe/bignumber.scm 809 */
								obj_t BgL_g1787z00_3954;

								obj_t BgL_g1788z00_3955;

								{	/* Unsafe/bignumber.scm 809 */
									obj_t BgL_res3034z00_3964;

									if (BXNEGATIVE(BgL_xz00_80))
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3034z00_3964 =
												bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
												BgL_xz00_80);
										}
									else
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3034z00_3964 = BgL_xz00_80;
										}
									BgL_g1787z00_3954 = BgL_res3034z00_3964;
								}
								{	/* Unsafe/bignumber.scm 809 */
									obj_t BgL_res3035z00_3968;

									if (BXNEGATIVE(BgL_yz00_81))
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3035z00_3968 =
												bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
												BgL_yz00_81);
										}
									else
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3035z00_3968 = BgL_yz00_81;
										}
									BgL_g1788z00_3955 = BgL_res3035z00_3968;
								}
								{
									obj_t BgL_xz00_3970;

									obj_t BgL_yz00_3971;

									BgL_xz00_3970 = BgL_g1787z00_3954;
									BgL_yz00_3971 = BgL_g1788z00_3955;
								BgL_loopz00_3969:
									if (BXZERO(BgL_yz00_3971))
										{	/* Unsafe/bignumber.scm 809 */
											BgL_res3038z00_3995 = BgL_xz00_3970;
										}
									else
										{
											obj_t BgL_yz00_6316;

											obj_t BgL_xz00_6315;

											BgL_xz00_6315 = BgL_yz00_3971;
											BgL_yz00_6316 =
												bgl_bignum_remainder(BgL_xz00_3970, BgL_yz00_3971);
											BgL_yz00_3971 = BgL_yz00_6316;
											BgL_xz00_3970 = BgL_xz00_6315;
											goto BgL_loopz00_3969;
										}
								}
							}
							BgL_arg2333z00_3922 = BgL_res3038z00_3995;
						}
						return
							CAR(BGl_bignumzd2divzd2zz__bignumz00(BgL_arg2332z00_3921,
								BgL_arg2333z00_3922));
					}
			}
		}
	}



/* _$lcmbx */
	obj_t BGl__z42lcmbxz42zz__bignumz00(obj_t BgL_envz00_4701,
		obj_t BgL_xz00_4702, obj_t BgL_yz00_4703)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 808 */
			{	/* Unsafe/bignumber.scm 809 */
				obj_t BgL_auxz00_6326;

				obj_t BgL_auxz00_6320;

				if (BIGNUMP(BgL_yz00_4703))
					{	/* Unsafe/bignumber.scm 809 */
						BgL_auxz00_6326 = BgL_yz00_4703;
					}
				else
					{	/* Unsafe/bignumber.scm 809 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3173z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_yz00_4703, BGl_string3147z00zz__bignumz00,
							BINT(((long) 25975)));
						exit(-1);
					}
				if (BIGNUMP(BgL_xz00_4702))
					{	/* Unsafe/bignumber.scm 809 */
						BgL_auxz00_6320 = BgL_xz00_4702;
					}
				else
					{	/* Unsafe/bignumber.scm 809 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3173z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4702, BGl_string3147z00zz__bignumz00,
							BINT(((long) 25975)));
						exit(-1);
					}
				return bgl_bignum_lcm(BgL_auxz00_6320, BgL_auxz00_6326);
			}
		}
	}



/* bignum-expt */
	obj_t BGl_bignumzd2exptzd2zz__bignumz00(obj_t BgL_xz00_82, obj_t BgL_yz00_83)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 818 */
		BGl_bignumzd2exptzd2zz__bignumz00:
			{	/* Unsafe/bignumber.scm 819 */
				bool_t BgL_testz00_6333;

				{	/* Unsafe/bignumber.scm 819 */
					bool_t BgL_res3040z00_4011;

					{	/* Unsafe/bignumber.scm 819 */
						long BgL_arg2011z00_4004;

						{	/* Unsafe/bignumber.scm 819 */
							obj_t BgL_arg1900z00_4007;

							BgL_arg1900z00_4007 = BGL_BIGNUM_U16VECT(BgL_yz00_83);
							BgL_arg2011z00_4004 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_4007);
						}
						BgL_res3040z00_4011 = (BgL_arg2011z00_4004 == ((long) 1));
					}
					BgL_testz00_6333 = BgL_res3040z00_4011;
				}
				if (BgL_testz00_6333)
					{	/* Unsafe/bignumber.scm 819 */
						return bgl_long_to_bignum(((long) 1));
					}
				else
					{	/* Unsafe/bignumber.scm 821 */
						bool_t BgL_testz00_6338;

						{	/* Unsafe/bignumber.scm 821 */
							bool_t BgL_res3042z00_4024;

							{	/* Unsafe/bignumber.scm 821 */
								bool_t BgL__ortest_1776z00_4013;

								BgL__ortest_1776z00_4013 =
									(BGl_bignumzd2lengthzd2zz__bignumz00(BgL_yz00_83) ==
									((long) 1));
								if (BgL__ortest_1776z00_4013)
									{	/* Unsafe/bignumber.scm 821 */
										BgL_res3042z00_4024 = BgL__ortest_1776z00_4013;
									}
								else
									{	/* Unsafe/bignumber.scm 821 */
										unsigned short BgL_arg2022z00_4014;

										{	/* Unsafe/bignumber.scm 821 */
											obj_t BgL_arg1905z00_4023;

											BgL_arg1905z00_4023 = BGL_BIGNUM_U16VECT(BgL_yz00_83);
											BgL_arg2022z00_4014 =
												BGL_U16VREF(BgL_arg1905z00_4023, ((long) 1));
										}
										BgL_res3042z00_4024 =
											BGl_evenzf3zf3zz__r4_numbers_6_5_fixnumz00(BINT
											(BgL_arg2022z00_4014));
							}}
							BgL_testz00_6338 = BgL_res3042z00_4024;
						}
						if (BgL_testz00_6338)
							{	/* Unsafe/bignumber.scm 823 */
								obj_t BgL_arg2338z00_1625;

								obj_t BgL_arg2339z00_1626;

								BgL_arg2338z00_1625 = bgl_bignum_mul(BgL_xz00_82, BgL_xz00_82);
								{	/* Unsafe/bignumber.scm 824 */
									obj_t BgL_arg2340z00_1627;

									BgL_arg2340z00_1627 = bgl_long_to_bignum(((long) 2));
									BgL_arg2339z00_1626 =
										CAR(BGl_bignumzd2divzd2zz__bignumz00(BgL_yz00_83,
											BgL_arg2340z00_1627));
								}
								{
									obj_t BgL_yz00_6351;

									obj_t BgL_xz00_6350;

									BgL_xz00_6350 = BgL_arg2338z00_1625;
									BgL_yz00_6351 = BgL_arg2339z00_1626;
									BgL_yz00_83 = BgL_yz00_6351;
									BgL_xz00_82 = BgL_xz00_6350;
									goto BGl_bignumzd2exptzd2zz__bignumz00;
								}
							}
						else
							{	/* Unsafe/bignumber.scm 826 */
								obj_t BgL_arg2341z00_1628;

								{	/* Unsafe/bignumber.scm 826 */
									obj_t BgL_arg2342z00_1629;

									{	/* Unsafe/bignumber.scm 826 */
										obj_t BgL_arg2343z00_1630;

										BgL_arg2343z00_1630 = bgl_long_to_bignum(((long) 1));
										{	/* Unsafe/bignumber.scm 826 */
											obj_t BgL_res3044z00_4046;

											{	/* Unsafe/bignumber.scm 826 */
												unsigned short BgL_arg2113z00_4034;

												long BgL_arg2114z00_4035;

												{	/* Unsafe/bignumber.scm 826 */
													obj_t BgL_arg1901z00_4039;

													BgL_arg1901z00_4039 = BGL_BIGNUM_U16VECT(BgL_yz00_83);
													BgL_arg2113z00_4034 =
														BGL_U16VREF(BgL_arg1901z00_4039, ((long) 0));
												}
												{	/* Unsafe/bignumber.scm 826 */
													unsigned short BgL_arg2116z00_4037;

													{	/* Unsafe/bignumber.scm 826 */
														obj_t BgL_arg1901z00_4042;

														BgL_arg1901z00_4042 =
															BGL_BIGNUM_U16VECT(BgL_arg2343z00_1630);
														BgL_arg2116z00_4037 =
															BGL_U16VREF(BgL_arg1901z00_4042, ((long) 0));
													}
													BgL_arg2114z00_4035 =
														(((long) 1) - (long) (BgL_arg2116z00_4037));
												}
												BgL_res3044z00_4046 =
													BGl_bignumzd2sum2zd2zz__bignumz00(BgL_yz00_83,
													BgL_arg2343z00_1630, BgL_arg2113z00_4034,
													BINT(BgL_arg2114z00_4035));
											}
											BgL_arg2342z00_1629 = BgL_res3044z00_4046;
									}}
									BgL_arg2341z00_1628 =
										BGl_bignumzd2exptzd2zz__bignumz00(BgL_xz00_82,
										BgL_arg2342z00_1629);
								}
								return bgl_bignum_mul(BgL_xz00_82, BgL_arg2341z00_1628);
							}
					}
			}
		}
	}



/* bignum-integer-length */
	long BGl_bignumzd2integerzd2lengthz00zz__bignumz00(obj_t BgL_xz00_85)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 837 */
			{	/* Unsafe/bignumber.scm 838 */
				obj_t BgL_nz00_1632;

				{	/* Unsafe/bignumber.scm 838 */
					bool_t BgL_testz00_6363;

					{	/* Unsafe/bignumber.scm 838 */
						bool_t BgL_res3046z00_4071;

						{	/* Unsafe/bignumber.scm 838 */
							unsigned short BgL_arg2015z00_4064;

							{	/* Unsafe/bignumber.scm 838 */
								obj_t BgL_arg1901z00_4067;

								BgL_arg1901z00_4067 = BGL_BIGNUM_U16VECT(BgL_xz00_85);
								BgL_arg2015z00_4064 =
									BGL_U16VREF(BgL_arg1901z00_4067, ((long) 0));
							}
							BgL_res3046z00_4071 =
								((long) (BgL_arg2015z00_4064) == ((long) 0));
						}
						BgL_testz00_6363 = BgL_res3046z00_4071;
					}
					if (BgL_testz00_6363)
						{	/* Unsafe/bignumber.scm 838 */
							BgL_nz00_1632 =
								bgl_bignum_sub(bgl_long_to_bignum(((long) -1)), BgL_xz00_85);
						}
					else
						{	/* Unsafe/bignumber.scm 838 */
							BgL_nz00_1632 = BgL_xz00_85;
						}
				}
				{	/* Unsafe/bignumber.scm 838 */
					long BgL_nbzd2digitszd2_1633;

					{	/* Unsafe/bignumber.scm 839 */
						long BgL_arg2352z00_1647;

						{	/* Unsafe/bignumber.scm 839 */
							obj_t BgL_arg1900z00_4075;

							BgL_arg1900z00_4075 = BGL_BIGNUM_U16VECT(BgL_nz00_1632);
							BgL_arg2352z00_1647 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_4075);
						}
						BgL_nbzd2digitszd2_1633 = (BgL_arg2352z00_1647 - ((long) 1));
					}
					{	/* Unsafe/bignumber.scm 839 */

						if ((BgL_nbzd2digitszd2_1633 == ((long) 0)))
							{	/* Unsafe/bignumber.scm 840 */
								return ((long) 0);
							}
						else
							{	/* Unsafe/bignumber.scm 842 */
								unsigned short BgL_g1789z00_1635;

								long BgL_g1790z00_1636;

								{	/* Unsafe/bignumber.scm 842 */
									int BgL_iz00_4082;

									BgL_iz00_4082 = (int) (BgL_nbzd2digitszd2_1633);
									{	/* Unsafe/bignumber.scm 842 */
										obj_t BgL_arg1905z00_4083;

										BgL_arg1905z00_4083 = BGL_BIGNUM_U16VECT(BgL_nz00_1632);
										{	/* Unsafe/bignumber.scm 842 */
											long BgL_auxz00_6377;

											BgL_auxz00_6377 = (long) (BgL_iz00_4082);
											BgL_g1789z00_1635 =
												BGL_U16VREF(BgL_arg1905z00_4083, BgL_auxz00_6377);
								}}}
								BgL_g1790z00_1636 =
									((BgL_nbzd2digitszd2_1633 - ((long) 1)) * ((long) 14));
								{
									obj_t BgL_dz00_4089;

									long BgL_lenz00_4090;

									BgL_dz00_4089 = BINT(BgL_g1789z00_1635);
									BgL_lenz00_4090 = BgL_g1790z00_1636;
								BgL_loopz00_4088:
									if ((((long) 0) < (long) CINT(BgL_dz00_4089)))
										{	/* Unsafe/bignumber.scm 842 */
											long BgL_arg2348z00_4095;

											long BgL_arg2349z00_4096;

											{	/* Unsafe/bignumber.scm 842 */
												long BgL_auxz00_6385;

												BgL_auxz00_6385 = (long) CINT(BgL_dz00_4089);
												BgL_arg2348z00_4095 = (BgL_auxz00_6385 / ((long) 2));
											}
											BgL_arg2349z00_4096 = (BgL_lenz00_4090 + ((long) 1));
											{
												long BgL_lenz00_6391;

												obj_t BgL_dz00_6389;

												BgL_dz00_6389 = BINT(BgL_arg2348z00_4095);
												BgL_lenz00_6391 = BgL_arg2349z00_4096;
												BgL_lenz00_4090 = BgL_lenz00_6391;
												BgL_dz00_4089 = BgL_dz00_6389;
												goto BgL_loopz00_4088;
											}
										}
									else
										{	/* Unsafe/bignumber.scm 842 */
											return BgL_lenz00_4090;
										}
								}
							}
					}
				}
			}
		}
	}



/* c-bignum->string */
	BGL_EXPORTED_DEF obj_t bgl_bignum_to_string(obj_t BgL_xz00_86,
		long BgL_radixz00_87)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 852 */
			{
				obj_t BgL_signz00_1654;

				obj_t BgL_nz00_1655;

				{	/* Unsafe/bignumber.scm 865 */
					bool_t BgL_testz00_6393;

					{	/* Unsafe/bignumber.scm 865 */
						bool_t BgL_res3047z00_4131;

						{	/* Unsafe/bignumber.scm 865 */
							unsigned short BgL_arg2015z00_4124;

							{	/* Unsafe/bignumber.scm 865 */
								obj_t BgL_arg1901z00_4127;

								BgL_arg1901z00_4127 = BGL_BIGNUM_U16VECT(BgL_xz00_86);
								BgL_arg2015z00_4124 =
									BGL_U16VREF(BgL_arg1901z00_4127, ((long) 0));
							}
							BgL_res3047z00_4131 =
								((long) (BgL_arg2015z00_4124) == ((long) 0));
						}
						BgL_testz00_6393 = BgL_res3047z00_4131;
					}
					if (BgL_testz00_6393)
						{	/* Unsafe/bignumber.scm 865 */
							BgL_signz00_1654 = BCHAR(((unsigned char) '-'));
							BgL_nz00_1655 =
								bgl_bignum_sub(BGl_bignumzd2za7eroz75zz__bignumz00,
								BgL_xz00_86);
						BgL_zc3anonymousza32357ze3z83_1656:
							{	/* Unsafe/bignumber.scm 858 */
								obj_t BgL_digitsz00_1657;

								{	/* Unsafe/bignumber.scm 859 */
									obj_t BgL_l1821z00_1659;

									{	/* Unsafe/bignumber.scm 860 */
										bool_t BgL_testz00_6398;

										{	/* Unsafe/bignumber.scm 860 */
											bool_t BgL_res3048z00_4141;

											{	/* Unsafe/bignumber.scm 860 */
												long BgL_arg2011z00_4134;

												{	/* Unsafe/bignumber.scm 860 */
													obj_t BgL_arg1900z00_4137;

													BgL_arg1900z00_4137 =
														BGL_BIGNUM_U16VECT(BgL_nz00_1655);
													BgL_arg2011z00_4134 =
														BGL_HVECTOR_LENGTH(BgL_arg1900z00_4137);
												}
												BgL_res3048z00_4141 =
													(BgL_arg2011z00_4134 == ((long) 1));
											}
											BgL_testz00_6398 = BgL_res3048z00_4141;
										}
										if (BgL_testz00_6398)
											{	/* Unsafe/bignumber.scm 860 */
												BgL_l1821z00_1659 = BGl_list3174z00zz__bignumz00;
											}
										else
											{	/* Unsafe/bignumber.scm 860 */
												BgL_l1821z00_1659 =
													bgl_reverse
													(BGl_bignumzd2ze3fixnumzd2listze3zz__bignumz00
													(BgL_nz00_1655, (BgL_radixz00_87 - ((long) 1))));
									}}
									if (NULLP(BgL_l1821z00_1659))
										{	/* Unsafe/bignumber.scm 859 */
											BgL_digitsz00_1657 = BNIL;
										}
									else
										{	/* Unsafe/bignumber.scm 859 */
											obj_t BgL_head1823z00_1661;

											{	/* Unsafe/bignumber.scm 859 */
												unsigned char BgL_arg2366z00_1674;

												{	/* Unsafe/bignumber.scm 859 */
													long BgL_auxz00_6407;

													{	/* Unsafe/bignumber.scm 859 */
														obj_t BgL_pairz00_4145;

														BgL_pairz00_4145 = BgL_l1821z00_1659;
														BgL_auxz00_6407 =
															(long) CINT(CAR(BgL_pairz00_4145));
													}
													BgL_arg2366z00_1674 =
														STRING_REF(BGl_string3175z00zz__bignumz00,
														BgL_auxz00_6407);
												}
												BgL_head1823z00_1661 =
													MAKE_PAIR(BCHAR(BgL_arg2366z00_1674), BNIL);
											}
											{	/* Unsafe/bignumber.scm 859 */
												obj_t BgL_g1826z00_1662;

												BgL_g1826z00_1662 = CDR(BgL_l1821z00_1659);
												{
													obj_t BgL_l1821z00_4153;

													obj_t BgL_tail1824z00_4154;

													BgL_l1821z00_4153 = BgL_g1826z00_1662;
													BgL_tail1824z00_4154 = BgL_head1823z00_1661;
												BgL_zc3anonymousza32360ze3z83_4152:
													if (NULLP(BgL_l1821z00_4153))
														{	/* Unsafe/bignumber.scm 859 */
															BgL_digitsz00_1657 = BgL_head1823z00_1661;
														}
													else
														{	/* Unsafe/bignumber.scm 859 */
															obj_t BgL_newtail1825z00_4162;

															{	/* Unsafe/bignumber.scm 859 */
																unsigned char BgL_arg2363z00_4163;

																{	/* Unsafe/bignumber.scm 859 */
																	long BgL_auxz00_6416;

																	{	/* Unsafe/bignumber.scm 859 */
																		obj_t BgL_pairz00_4168;

																		BgL_pairz00_4168 = BgL_l1821z00_4153;
																		BgL_auxz00_6416 =
																			(long) CINT(CAR(BgL_pairz00_4168));
																	}
																	BgL_arg2363z00_4163 =
																		STRING_REF(BGl_string3175z00zz__bignumz00,
																		BgL_auxz00_6416);
																}
																BgL_newtail1825z00_4162 =
																	MAKE_PAIR(BCHAR(BgL_arg2363z00_4163), BNIL);
															}
															SET_CDR(BgL_tail1824z00_4154,
																BgL_newtail1825z00_4162);
															{
																obj_t BgL_tail1824z00_6425;

																obj_t BgL_l1821z00_6423;

																BgL_l1821z00_6423 = CDR(BgL_l1821z00_4153);
																BgL_tail1824z00_6425 = BgL_newtail1825z00_4162;
																BgL_tail1824z00_4154 = BgL_tail1824z00_6425;
																BgL_l1821z00_4153 = BgL_l1821z00_6423;
																goto BgL_zc3anonymousza32360ze3z83_4152;
															}
														}
												}
											}
										}
								}
								{	/* Unsafe/bignumber.scm 863 */
									obj_t BgL_arg2358z00_1658;

									if (CBOOL(BgL_signz00_1654))
										{	/* Unsafe/bignumber.scm 863 */
											BgL_arg2358z00_1658 =
												MAKE_PAIR(BgL_signz00_1654, BgL_digitsz00_1657);
										}
									else
										{	/* Unsafe/bignumber.scm 863 */
											BgL_arg2358z00_1658 = BgL_digitsz00_1657;
										}
									return
										BGl_listzd2ze3stringz31zz__r4_strings_6_7z00
										(BgL_arg2358z00_1658);
								}
							}
						}
					else
						{
							obj_t BgL_nz00_6433;

							obj_t BgL_signz00_6432;

							BgL_signz00_6432 = BFALSE;
							BgL_nz00_6433 = BgL_xz00_86;
							BgL_nz00_1655 = BgL_nz00_6433;
							BgL_signz00_1654 = BgL_signz00_6432;
							goto BgL_zc3anonymousza32357ze3z83_1656;
						}
				}
			}
		}
	}



/* _c-bignum->string */
	obj_t BGl__czd2bignumzd2ze3stringze3zz__bignumz00(obj_t BgL_envz00_4704,
		obj_t BgL_xz00_4705, obj_t BgL_radixz00_4706)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 852 */
			{	/* Unsafe/bignumber.scm 858 */
				long BgL_auxz00_6440;

				obj_t BgL_auxz00_6434;

				{	/* Unsafe/bignumber.scm 858 */
					obj_t BgL_auxz00_6441;

					if (INTEGERP(BgL_radixz00_4706))
						{	/* Unsafe/bignumber.scm 858 */
							BgL_auxz00_6441 = BgL_radixz00_4706;
						}
					else
						{	/* Unsafe/bignumber.scm 858 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3176z00zz__bignumz00, BGl_string3148z00zz__bignumz00,
								BgL_radixz00_4706, BGl_string3147z00zz__bignumz00,
								BINT(((long) 27825)));
							exit(-1);
						}
					BgL_auxz00_6440 = (long) CINT(BgL_auxz00_6441);
				}
				if (BIGNUMP(BgL_xz00_4705))
					{	/* Unsafe/bignumber.scm 858 */
						BgL_auxz00_6434 = BgL_xz00_4705;
					}
				else
					{	/* Unsafe/bignumber.scm 858 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3176z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_xz00_4705, BGl_string3147z00zz__bignumz00,
							BINT(((long) 27825)));
						exit(-1);
					}
				return bgl_bignum_to_string(BgL_auxz00_6434, BgL_auxz00_6440);
			}
		}
	}



/* $string->bignum */
	BGL_EXPORTED_DEF obj_t bgl_string_to_bignum(char *BgL_strz00_88,
		int BgL_radixz00_89)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 869 */
			{
				unsigned char BgL_cz00_1737;

				obj_t BgL_radz00_1738;

				obj_t BgL_radz00_1715;

				obj_t BgL_signz00_1716;

				long BgL_iz00_1717;

				obj_t BgL_radz00_1704;

				long BgL_iz00_1705;

				long BgL_iz00_1688;

				BgL_iz00_1688 = ((long) 0);
				{	/* Unsafe/bignumber.scm 909 */
					obj_t BgL_g1794z00_1690;

					if (
						((BgL_iz00_1688 + ((long) 3)) <=
							STRING_LENGTH(string_to_bstring(BgL_strz00_88))))
						{	/* Unsafe/bignumber.scm 909 */
							if (
								(STRING_REF(string_to_bstring(BgL_strz00_88),
										BgL_iz00_1688) == ((unsigned char) '#')))
								{	/* Unsafe/bignumber.scm 910 */
									BgL_g1794z00_1690 =
										BGl_assvz00zz__r4_pairs_and_lists_6_3z00(BCHAR(tolower
											(STRING_REF(string_to_bstring(BgL_strz00_88),
													(BgL_iz00_1688 + ((long) 1))))),
										BGl_list3177z00zz__bignumz00);
								}
							else
								{	/* Unsafe/bignumber.scm 910 */
									BgL_g1794z00_1690 = BFALSE;
								}
						}
					else
						{	/* Unsafe/bignumber.scm 909 */
							BgL_g1794z00_1690 = BFALSE;
						}
					if (CBOOL(BgL_g1794z00_1690))
						{	/* Unsafe/bignumber.scm 909 */
							BgL_radz00_1704 = CDR(BgL_g1794z00_1690);
							BgL_iz00_1705 = (BgL_iz00_1688 + ((long) 2));
						BgL_zc3anonymousza32383ze3z83_1706:
							{	/* Unsafe/bignumber.scm 902 */
								bool_t BgL_testz00_6466;

								if (
									((BgL_iz00_1705 + ((long) 2)) <=
										STRING_LENGTH(string_to_bstring(BgL_strz00_88))))
									{	/* Unsafe/bignumber.scm 902 */
										BgL_testz00_6466 =
											CBOOL(BGl_memvz00zz__r4_pairs_and_lists_6_3z00(BCHAR
												(STRING_REF(string_to_bstring(BgL_strz00_88),
														BgL_iz00_1705)), BGl_list3182z00zz__bignumz00));
									}
								else
									{	/* Unsafe/bignumber.scm 902 */
										BgL_testz00_6466 = ((bool_t) 0);
									}
								if (BgL_testz00_6466)
									{	/* Unsafe/bignumber.scm 904 */
										unsigned char BgL_arg2385z00_1708;

										long BgL_arg2386z00_1709;

										BgL_arg2385z00_1708 =
											STRING_REF(string_to_bstring(BgL_strz00_88),
											BgL_iz00_1705);
										BgL_arg2386z00_1709 = (BgL_iz00_1705 + ((long) 1));
										BgL_radz00_1715 = BgL_radz00_1704;
										BgL_signz00_1716 = BCHAR(BgL_arg2385z00_1708);
										BgL_iz00_1717 = BgL_arg2386z00_1709;
									BgL_zc3anonymousza32392ze3z83_1718:
										if (
											((BgL_iz00_1717 + ((long) 1)) <=
												STRING_LENGTH(string_to_bstring(BgL_strz00_88))))
											{
												long BgL_iz00_1722;

												obj_t BgL_digitsz00_1723;

												BgL_iz00_1722 = BgL_iz00_1717;
												BgL_digitsz00_1723 = BNIL;
											BgL_zc3anonymousza32394ze3z83_1724:
												if (
													(BgL_iz00_1722 <
														STRING_LENGTH(string_to_bstring(BgL_strz00_88))))
													{	/* Unsafe/bignumber.scm 891 */
														obj_t BgL_dz00_1726;

														BgL_cz00_1737 =
															STRING_REF(string_to_bstring(BgL_strz00_88),
															BgL_iz00_1722);
														BgL_radz00_1738 = BgL_radz00_1715;
														{	/* Unsafe/bignumber.scm 878 */
															bool_t BgL_testz00_6489;

															if ((BgL_cz00_1737 >= ((unsigned char) '0')))
																{	/* Unsafe/bignumber.scm 878 */
																	BgL_testz00_6489 =
																		(BgL_cz00_1737 <= ((unsigned char) '9'));
																}
															else
																{	/* Unsafe/bignumber.scm 878 */
																	BgL_testz00_6489 = ((bool_t) 0);
																}
															if (BgL_testz00_6489)
																{	/* Unsafe/bignumber.scm 879 */
																	long BgL_dz00_4265;

																	BgL_dz00_4265 =
																		((BgL_cz00_1737) - ((long) 48));
																	if (
																		(BgL_dz00_4265 <
																			(long) CINT(BgL_radz00_1738)))
																		{	/* Unsafe/bignumber.scm 879 */
																			BgL_dz00_1726 = BINT(BgL_dz00_4265);
																		}
																	else
																		{	/* Unsafe/bignumber.scm 879 */
																			BgL_dz00_1726 = BFALSE;
																		}
																}
															else
																{	/* Unsafe/bignumber.scm 880 */
																	bool_t BgL_testz00_6499;

																	if ((BgL_cz00_1737 >= ((unsigned char) 'a')))
																		{	/* Unsafe/bignumber.scm 880 */
																			BgL_testz00_6499 =
																				(BgL_cz00_1737 <=
																				((unsigned char) 'z'));
																		}
																	else
																		{	/* Unsafe/bignumber.scm 880 */
																			BgL_testz00_6499 = ((bool_t) 0);
																		}
																	if (BgL_testz00_6499)
																		{	/* Unsafe/bignumber.scm 881 */
																			long BgL_dz00_4278;

																			BgL_dz00_4278 =
																				(((long) 10) +
																				((BgL_cz00_1737) - ((long) 97)));
																			if (
																				(BgL_dz00_4278 <
																					(long) CINT(BgL_radz00_1738)))
																				{	/* Unsafe/bignumber.scm 881 */
																					BgL_dz00_1726 = BINT(BgL_dz00_4278);
																				}
																			else
																				{	/* Unsafe/bignumber.scm 881 */
																					BgL_dz00_1726 = BFALSE;
																				}
																		}
																	else
																		{	/* Unsafe/bignumber.scm 882 */
																			bool_t BgL_testz00_6510;

																			if (
																				(BgL_cz00_1737 >=
																					((unsigned char) 'A')))
																				{	/* Unsafe/bignumber.scm 882 */
																					BgL_testz00_6510 =
																						(BgL_cz00_1737 <=
																						((unsigned char) 'Z'));
																				}
																			else
																				{	/* Unsafe/bignumber.scm 882 */
																					BgL_testz00_6510 = ((bool_t) 0);
																				}
																			if (BgL_testz00_6510)
																				{	/* Unsafe/bignumber.scm 883 */
																					long BgL_dz00_4291;

																					BgL_dz00_4291 =
																						(((long) 10) +
																						((BgL_cz00_1737) - ((long) 65)));
																					if (
																						(BgL_dz00_4291 <
																							(long) CINT(BgL_radz00_1738)))
																						{	/* Unsafe/bignumber.scm 883 */
																							BgL_dz00_1726 =
																								BINT(BgL_dz00_4291);
																						}
																					else
																						{	/* Unsafe/bignumber.scm 883 */
																							BgL_dz00_1726 = BFALSE;
																						}
																				}
																			else
																				{	/* Unsafe/bignumber.scm 882 */
																					BgL_dz00_1726 = BFALSE;
																				}
																		}
																}
														}
														if (CBOOL(BgL_dz00_1726))
															{	/* Unsafe/bignumber.scm 893 */
																long BgL_arg2396z00_1727;

																obj_t BgL_arg2397z00_1728;

																BgL_arg2396z00_1727 =
																	(BgL_iz00_1722 + ((long) 1));
																BgL_arg2397z00_1728 =
																	MAKE_PAIR(BgL_dz00_1726, BgL_digitsz00_1723);
																{
																	obj_t BgL_digitsz00_6528;

																	long BgL_iz00_6527;

																	BgL_iz00_6527 = BgL_arg2396z00_1727;
																	BgL_digitsz00_6528 = BgL_arg2397z00_1728;
																	BgL_digitsz00_1723 = BgL_digitsz00_6528;
																	BgL_iz00_1722 = BgL_iz00_6527;
																	goto BgL_zc3anonymousza32394ze3z83_1724;
																}
															}
														else
															{	/* Unsafe/bignumber.scm 892 */
																return BFALSE;
															}
													}
												else
													{	/* Unsafe/bignumber.scm 895 */
														obj_t BgL_nz00_1730;

														BgL_nz00_1730 =
															BGl_fixnumzd2listzd2ze3bignumze3zz__bignumz00
															(BgL_digitsz00_1723,
															((long) CINT(BgL_radz00_1715) - ((long) 1)));
														{	/* Unsafe/bignumber.scm 896 */
															bool_t BgL_testz00_6532;

															if (CBOOL(BgL_signz00_1716))
																{	/* Unsafe/bignumber.scm 896 */
																	BgL_testz00_6532 =
																		(CCHAR(BgL_signz00_1716) ==
																		((unsigned char) '-'));
																}
															else
																{	/* Unsafe/bignumber.scm 896 */
																	BgL_testz00_6532 = ((bool_t) 0);
																}
															if (BgL_testz00_6532)
																{	/* Unsafe/bignumber.scm 896 */
																	return
																		bgl_bignum_sub
																		(BGl_bignumzd2za7eroz75zz__bignumz00,
																		BgL_nz00_1730);
																}
															else
																{	/* Unsafe/bignumber.scm 896 */
																	return BgL_nz00_1730;
																}
														}
													}
											}
										else
											{	/* Unsafe/bignumber.scm 888 */
												return BFALSE;
											}
									}
								else
									{
										long BgL_iz00_6541;

										obj_t BgL_signz00_6540;

										obj_t BgL_radz00_6539;

										BgL_radz00_6539 = BgL_radz00_1704;
										BgL_signz00_6540 = BFALSE;
										BgL_iz00_6541 = BgL_iz00_1705;
										BgL_iz00_1717 = BgL_iz00_6541;
										BgL_signz00_1716 = BgL_signz00_6540;
										BgL_radz00_1715 = BgL_radz00_6539;
										goto BgL_zc3anonymousza32392ze3z83_1718;
									}
							}
						}
					else
						{
							long BgL_iz00_6546;

							obj_t BgL_radz00_6544;

							BgL_radz00_6544 = BINT(BgL_radixz00_89);
							BgL_iz00_6546 = BgL_iz00_1688;
							BgL_iz00_1705 = BgL_iz00_6546;
							BgL_radz00_1704 = BgL_radz00_6544;
							goto BgL_zc3anonymousza32383ze3z83_1706;
						}
				}
			}
		}
	}



/* _$string->bignum */
	obj_t BGl__z42stringzd2ze3bignumz73zz__bignumz00(obj_t BgL_envz00_4707,
		obj_t BgL_strz00_4708, obj_t BgL_radixz00_4709)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 869 */
			{	/* Unsafe/bignumber.scm 909 */
				int BgL_auxz00_6555;

				char *BgL_auxz00_6547;

				{	/* Unsafe/bignumber.scm 909 */
					obj_t BgL_auxz00_6556;

					if (INTEGERP(BgL_radixz00_4709))
						{	/* Unsafe/bignumber.scm 909 */
							BgL_auxz00_6556 = BgL_radixz00_4709;
						}
					else
						{	/* Unsafe/bignumber.scm 909 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3183z00zz__bignumz00, BGl_string3184z00zz__bignumz00,
								BgL_radixz00_4709, BGl_string3147z00zz__bignumz00,
								BINT(((long) 29391)));
							exit(-1);
						}
					BgL_auxz00_6555 = CINT(BgL_auxz00_6556);
				}
				{	/* Unsafe/bignumber.scm 909 */
					obj_t BgL_auxz00_6548;

					if (STRINGP(BgL_strz00_4708))
						{	/* Unsafe/bignumber.scm 909 */
							BgL_auxz00_6548 = BgL_strz00_4708;
						}
					else
						{	/* Unsafe/bignumber.scm 909 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3183z00zz__bignumz00, BGl_string3146z00zz__bignumz00,
								BgL_strz00_4708, BGl_string3147z00zz__bignumz00,
								BINT(((long) 29391)));
							exit(-1);
						}
					BgL_auxz00_6547 = BSTRING_TO_STRING(BgL_auxz00_6548);
				}
				return bgl_string_to_bignum(BgL_auxz00_6547, BgL_auxz00_6555);
			}
		}
	}



/* bignum->fixnum-list */
	obj_t BGl_bignumzd2ze3fixnumzd2listze3zz__bignumz00(obj_t BgL_xz00_90,
		long BgL_radixzd2minuszd21z00_91)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 927 */
			{	/* Unsafe/bignumber.scm 928 */
				obj_t BgL_bigzd2radixzd2_1768;

				{	/* Unsafe/bignumber.scm 930 */
					obj_t BgL_arg2442z00_1796;

					obj_t BgL_arg2443z00_1797;

					BgL_arg2442z00_1796 = bgl_long_to_bignum(BgL_radixzd2minuszd21z00_91);
					BgL_arg2443z00_1797 = bgl_long_to_bignum(((long) 1));
					{	/* Unsafe/bignumber.scm 929 */
						obj_t BgL_res3049z00_4308;

						{	/* Unsafe/bignumber.scm 929 */
							unsigned short BgL_arg2111z00_4300;

							unsigned short BgL_arg2112z00_4301;

							{	/* Unsafe/bignumber.scm 929 */
								obj_t BgL_arg1901z00_4303;

								BgL_arg1901z00_4303 = BGL_BIGNUM_U16VECT(BgL_arg2442z00_1796);
								BgL_arg2111z00_4300 =
									BGL_U16VREF(BgL_arg1901z00_4303, ((long) 0));
							}
							{	/* Unsafe/bignumber.scm 929 */
								obj_t BgL_arg1901z00_4306;

								BgL_arg1901z00_4306 = BGL_BIGNUM_U16VECT(BgL_arg2443z00_1797);
								BgL_arg2112z00_4301 =
									BGL_U16VREF(BgL_arg1901z00_4306, ((long) 0));
							}
							BgL_res3049z00_4308 =
								BGl_bignumzd2sum2zd2zz__bignumz00(BgL_arg2442z00_1796,
								BgL_arg2443z00_1797, BgL_arg2111z00_4300,
								BINT(BgL_arg2112z00_4301));
						}
						BgL_bigzd2radixzd2_1768 = BgL_res3049z00_4308;
				}}
				{	/* Unsafe/bignumber.scm 928 */
					obj_t BgL_squarezd2serieszd2_1769;

					{	/* Unsafe/bignumber.scm 933 */
						obj_t BgL_g1796z00_1786;

						{	/* Unsafe/bignumber.scm 934 */
							obj_t BgL_list2441z00_1795;

							BgL_list2441z00_1795 = MAKE_PAIR(BgL_bigzd2radixzd2_1768, BNIL);
							BgL_g1796z00_1786 = BgL_list2441z00_1795;
						}
						{
							obj_t BgL_squarez00_4312;

							obj_t BgL_squarezd2listzd2_4313;

							BgL_squarez00_4312 = BgL_bigzd2radixzd2_1768;
							BgL_squarezd2listzd2_4313 = BgL_g1796z00_1786;
						BgL_loopz00_4311:
							{	/* Unsafe/bignumber.scm 933 */
								obj_t BgL_newzd2squarezd2_4317;

								BgL_newzd2squarezd2_4317 =
									bgl_bignum_mul(BgL_squarez00_4312, BgL_squarez00_4312);
								if (BGl_z42zc3bxz81zz__bignumz00(BgL_xz00_90,
										BgL_newzd2squarezd2_4317))
									{	/* Unsafe/bignumber.scm 933 */
										BgL_squarezd2serieszd2_1769 = BgL_squarezd2listzd2_4313;
									}
								else
									{	/* Unsafe/bignumber.scm 933 */
										obj_t BgL_arg2440z00_4319;

										BgL_arg2440z00_4319 =
											MAKE_PAIR(BgL_newzd2squarezd2_4317,
											BgL_squarezd2listzd2_4313);
										{
											obj_t BgL_squarezd2listzd2_6578;

											obj_t BgL_squarez00_6577;

											BgL_squarez00_6577 = BgL_newzd2squarezd2_4317;
											BgL_squarezd2listzd2_6578 = BgL_arg2440z00_4319;
											BgL_squarezd2listzd2_4313 = BgL_squarezd2listzd2_6578;
											BgL_squarez00_4312 = BgL_squarez00_6577;
											goto BgL_loopz00_4311;
										}
									}
							}
						}
					}
					{	/* Unsafe/bignumber.scm 932 */

						return
							BGl_convertz00zz__bignumz00(BgL_xz00_90,
							BgL_squarezd2serieszd2_1769, BNIL);
					}
				}
			}
		}
	}



/* convert */
	obj_t BGl_convertz00zz__bignumz00(obj_t BgL_nz00_1771,
		obj_t BgL_squarezd2serieszd2_1772, obj_t BgL_tailz00_1773)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 957 */
		BGl_convertz00zz__bignumz00:
			if (PAIRP(BgL_squarezd2serieszd2_1772))
				{	/* Unsafe/bignumber.scm 944 */
					obj_t BgL_qrz00_1776;

					BgL_qrz00_1776 =
						BGl_bignumzd2divzd2zz__bignumz00(BgL_nz00_1771,
						CAR(BgL_squarezd2serieszd2_1772));
					{	/* Unsafe/bignumber.scm 944 */
						obj_t BgL_qz00_1777;

						BgL_qz00_1777 = CAR(BgL_qrz00_1776);
						{	/* Unsafe/bignumber.scm 945 */
							obj_t BgL_rz00_1778;

							BgL_rz00_1778 = CDR(BgL_qrz00_1776);
							{	/* Unsafe/bignumber.scm 946 */
								obj_t BgL_newzd2squarezd2seriesz00_1779;

								BgL_newzd2squarezd2seriesz00_1779 =
									CDR(BgL_squarezd2serieszd2_1772);
								{	/* Unsafe/bignumber.scm 947 */

									{
										obj_t BgL_tailz00_6589;

										obj_t BgL_squarezd2serieszd2_6588;

										obj_t BgL_nz00_6587;

										BgL_nz00_6587 = BgL_rz00_1778;
										BgL_squarezd2serieszd2_6588 =
											BgL_newzd2squarezd2seriesz00_1779;
										BgL_tailz00_6589 =
											BGl_convertz00zz__bignumz00(BgL_qz00_1777,
											BgL_newzd2squarezd2seriesz00_1779, BgL_tailz00_1773);
										BgL_tailz00_1773 = BgL_tailz00_6589;
										BgL_squarezd2serieszd2_1772 = BgL_squarezd2serieszd2_6588;
										BgL_nz00_1771 = BgL_nz00_6587;
										goto BGl_convertz00zz__bignumz00;
									}
								}
							}
						}
					}
				}
			else
				{	/* Unsafe/bignumber.scm 953 */
					long BgL_dz00_1782;

					BgL_dz00_1782 = bgl_bignum_to_long(BgL_nz00_1771);
					{	/* Unsafe/bignumber.scm 954 */
						bool_t BgL_testz00_6592;

						if (NULLP(BgL_tailz00_1773))
							{	/* Unsafe/bignumber.scm 954 */
								BgL_testz00_6592 = (BgL_dz00_1782 == ((long) 0));
							}
						else
							{	/* Unsafe/bignumber.scm 954 */
								BgL_testz00_6592 = ((bool_t) 0);
							}
						if (BgL_testz00_6592)
							{	/* Unsafe/bignumber.scm 954 */
								return BgL_tailz00_1773;
							}
						else
							{	/* Unsafe/bignumber.scm 954 */
								return MAKE_PAIR(BINT(BgL_dz00_1782), BgL_tailz00_1773);
							}
					}
				}
		}
	}



/* fixnum-list->bignum */
	obj_t BGl_fixnumzd2listzd2ze3bignumze3zz__bignumz00(obj_t
		BgL_digitzd2listzd2_92, long BgL_radixzd2minuszd21z00_93)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 961 */
			{	/* Unsafe/bignumber.scm 965 */
				obj_t BgL_bigzd2radixzd2_1798;

				{	/* Unsafe/bignumber.scm 967 */
					obj_t BgL_arg2451z00_1811;

					obj_t BgL_arg2452z00_1812;

					BgL_arg2451z00_1811 = bgl_long_to_bignum(BgL_radixzd2minuszd21z00_93);
					BgL_arg2452z00_1812 = bgl_long_to_bignum(((long) 1));
					{	/* Unsafe/bignumber.scm 966 */
						obj_t BgL_res3051z00_4347;

						{	/* Unsafe/bignumber.scm 966 */
							unsigned short BgL_arg2111z00_4339;

							unsigned short BgL_arg2112z00_4340;

							{	/* Unsafe/bignumber.scm 966 */
								obj_t BgL_arg1901z00_4342;

								BgL_arg1901z00_4342 = BGL_BIGNUM_U16VECT(BgL_arg2451z00_1811);
								BgL_arg2111z00_4339 =
									BGL_U16VREF(BgL_arg1901z00_4342, ((long) 0));
							}
							{	/* Unsafe/bignumber.scm 966 */
								obj_t BgL_arg1901z00_4345;

								BgL_arg1901z00_4345 = BGL_BIGNUM_U16VECT(BgL_arg2452z00_1812);
								BgL_arg2112z00_4340 =
									BGL_U16VREF(BgL_arg1901z00_4345, ((long) 0));
							}
							BgL_res3051z00_4347 =
								BGl_bignumzd2sum2zd2zz__bignumz00(BgL_arg2451z00_1811,
								BgL_arg2452z00_1812, BgL_arg2111z00_4339,
								BINT(BgL_arg2112z00_4340));
						}
						BgL_bigzd2radixzd2_1798 = BgL_res3051z00_4347;
				}}
				{	/* Unsafe/bignumber.scm 969 */
					obj_t BgL_g1797z00_1799;

					BgL_g1797z00_1799 = bgl_reverse(BgL_digitzd2listzd2_92);
					{
						obj_t BgL_nz00_4349;

						obj_t BgL_lstz00_4350;

						BgL_nz00_4349 = BGl_bignumzd2za7eroz75zz__bignumz00;
						BgL_lstz00_4350 = BgL_g1797z00_1799;
					BgL_loopz00_4348:
						if (PAIRP(BgL_lstz00_4350))
							{	/* Unsafe/bignumber.scm 969 */
								obj_t BgL_arg2446z00_4358;

								obj_t BgL_arg2447z00_4359;

								{	/* Unsafe/bignumber.scm 969 */
									obj_t BgL_arg2448z00_4360;

									obj_t BgL_arg2449z00_4361;

									BgL_arg2448z00_4360 =
										bgl_bignum_mul(BgL_nz00_4349, BgL_bigzd2radixzd2_1798);
									{	/* Unsafe/bignumber.scm 969 */
										obj_t BgL_arg2450z00_4362;

										BgL_arg2450z00_4362 = CAR(BgL_lstz00_4350);
										BgL_arg2449z00_4361 =
											bgl_long_to_bignum((long) CINT(BgL_arg2450z00_4362));
									}
									{	/* Unsafe/bignumber.scm 969 */
										obj_t BgL_res3052z00_4369;

										{	/* Unsafe/bignumber.scm 969 */
											unsigned short BgL_arg2111z00_4367;

											unsigned short BgL_arg2112z00_4368;

											BgL_arg2111z00_4367 =
												BGl_bignumzd2signzd2zz__bignumz00(BgL_arg2448z00_4360);
											BgL_arg2112z00_4368 =
												BGl_bignumzd2signzd2zz__bignumz00(BgL_arg2449z00_4361);
											BgL_res3052z00_4369 =
												BGl_bignumzd2sum2zd2zz__bignumz00(BgL_arg2448z00_4360,
												BgL_arg2449z00_4361, BgL_arg2111z00_4367,
												BINT(BgL_arg2112z00_4368));
										}
										BgL_arg2446z00_4358 = BgL_res3052z00_4369;
								}}
								BgL_arg2447z00_4359 = CDR(BgL_lstz00_4350);
								{
									obj_t BgL_lstz00_6619;

									obj_t BgL_nz00_6618;

									BgL_nz00_6618 = BgL_arg2446z00_4358;
									BgL_lstz00_6619 = BgL_arg2447z00_4359;
									BgL_lstz00_4350 = BgL_lstz00_6619;
									BgL_nz00_4349 = BgL_nz00_6618;
									goto BgL_loopz00_4348;
								}
							}
						else
							{	/* Unsafe/bignumber.scm 969 */
								return BgL_nz00_4349;
							}
					}
				}
			}
		}
	}



/* $bignum->fixnum */
	BGL_EXPORTED_DEF long bgl_bignum_to_long(obj_t BgL_xz00_94)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 976 */
			{	/* Unsafe/bignumber.scm 977 */
				long BgL_lenxzd2minuszd21z00_1813;

				{	/* Unsafe/bignumber.scm 977 */
					long BgL_arg2466z00_1833;

					{	/* Unsafe/bignumber.scm 977 */
						obj_t BgL_arg1900z00_4408;

						BgL_arg1900z00_4408 = BGL_BIGNUM_U16VECT(BgL_xz00_94);
						BgL_arg2466z00_1833 = BGL_HVECTOR_LENGTH(BgL_arg1900z00_4408);
					}
					BgL_lenxzd2minuszd21z00_1813 = (BgL_arg2466z00_1833 - ((long) 1));
				}
				{
					long BgL_nz00_1815;

					long BgL_iz00_1816;

					{	/* Unsafe/bignumber.scm 978 */
						obj_t BgL_auxz00_6623;

						BgL_nz00_1815 = ((long) 0);
						BgL_iz00_1816 = BgL_lenxzd2minuszd21z00_1813;
					BgL_zc3anonymousza32453ze3z83_1817:
						if ((((long) 0) < BgL_iz00_1816))
							{	/* Unsafe/bignumber.scm 979 */
								if (
									(BgL_nz00_1815 <
										BGl_bignumzd2minzd2fixnumzd2divzd2radixz00zz__bignumz00()))
									{	/* Unsafe/bignumber.scm 980 */
										BgL_auxz00_6623 = BFALSE;
									}
								else
									{	/* Unsafe/bignumber.scm 982 */
										long BgL_mz00_1820;

										unsigned short BgL_dz00_1821;

										BgL_mz00_1820 =
											(BgL_nz00_1815 * (((long) 1) << (int) (((long) 14))));
										{	/* Unsafe/bignumber.scm 983 */
											int BgL_iz00_4421;

											BgL_iz00_4421 = (int) (BgL_iz00_1816);
											{	/* Unsafe/bignumber.scm 983 */
												obj_t BgL_arg1905z00_4422;

												BgL_arg1905z00_4422 = BGL_BIGNUM_U16VECT(BgL_xz00_94);
												{	/* Unsafe/bignumber.scm 983 */
													long BgL_auxz00_6634;

													BgL_auxz00_6634 = (long) (BgL_iz00_4421);
													BgL_dz00_1821 =
														BGL_U16VREF(BgL_arg1905z00_4422, BgL_auxz00_6634);
										}}}
										if (
											(BgL_mz00_1820 <
												((((long) -2) *
														(((long) 1) <<
															(int) (((long) 28)))) + (long) (BgL_dz00_1821))))
											{	/* Unsafe/bignumber.scm 984 */
												BgL_auxz00_6623 = BFALSE;
											}
										else
											{
												long BgL_iz00_6647;

												long BgL_nz00_6644;

												BgL_nz00_6644 =
													(BgL_mz00_1820 - (long) (BgL_dz00_1821));
												BgL_iz00_6647 = (BgL_iz00_1816 - ((long) 1));
												BgL_iz00_1816 = BgL_iz00_6647;
												BgL_nz00_1815 = BgL_nz00_6644;
												goto BgL_zc3anonymousza32453ze3z83_1817;
											}
									}
							}
						else
							{	/* Unsafe/bignumber.scm 988 */
								bool_t BgL_testz00_6649;

								{	/* Unsafe/bignumber.scm 988 */
									bool_t BgL_res3055z00_4445;

									{	/* Unsafe/bignumber.scm 988 */
										unsigned short BgL_arg2015z00_4438;

										{	/* Unsafe/bignumber.scm 988 */
											obj_t BgL_arg1901z00_4441;

											BgL_arg1901z00_4441 = BGL_BIGNUM_U16VECT(BgL_xz00_94);
											BgL_arg2015z00_4438 =
												BGL_U16VREF(BgL_arg1901z00_4441, ((long) 0));
										}
										BgL_res3055z00_4445 =
											((long) (BgL_arg2015z00_4438) == ((long) 0));
									}
									BgL_testz00_6649 = BgL_res3055z00_4445;
								}
								if (BgL_testz00_6649)
									{	/* Unsafe/bignumber.scm 988 */
										BgL_auxz00_6623 = BINT(BgL_nz00_1815);
									}
								else
									{	/* Unsafe/bignumber.scm 988 */
										if (
											(BgL_nz00_1815 ==
												(((long) -2) * (((long) 1) << (int) (((long) 28))))))
											{	/* Unsafe/bignumber.scm 990 */
												BgL_auxz00_6623 = BFALSE;
											}
										else
											{	/* Unsafe/bignumber.scm 990 */
												BgL_auxz00_6623 = BINT((((long) 0) - BgL_nz00_1815));
							}}}
						return (long) CINT(BgL_auxz00_6623);
		}}}}
	}



/* _$bignum->fixnum */
	obj_t BGl__z42bignumzd2ze3fixnumz73zz__bignumz00(obj_t BgL_envz00_4710,
		obj_t BgL_xz00_4711)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 976 */
			{	/* Unsafe/bignumber.scm 977 */
				long BgL_auxz00_6663;

				{	/* Unsafe/bignumber.scm 977 */
					obj_t BgL_auxz00_6664;

					if (BIGNUMP(BgL_xz00_4711))
						{	/* Unsafe/bignumber.scm 977 */
							BgL_auxz00_6664 = BgL_xz00_4711;
						}
					else
						{	/* Unsafe/bignumber.scm 977 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3185z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_xz00_4711, BGl_string3147z00zz__bignumz00,
								BINT(((long) 31350)));
							exit(-1);
						}
					BgL_auxz00_6663 = bgl_bignum_to_long(BgL_auxz00_6664);
				}
				return BINT(BgL_auxz00_6663);
			}
		}
	}



/* $seed-rand */
	BGL_EXPORTED_DEF obj_t bgl_seed_rand(long BgL_seedz00_97)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1036 */
			{	/* Unsafe/bignumber.scm 1037 */
				int BgL_auxz00_6672;

				BgL_auxz00_6672 = (int) (BgL_seedz00_97);
				srand(BgL_auxz00_6672);
			} BUNSPEC;
			return BINT(BgL_seedz00_97);
		}
	}



/* _$seed-rand */
	obj_t BGl__z42seedzd2randz90zz__bignumz00(obj_t BgL_envz00_4712,
		obj_t BgL_seedz00_4713)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1036 */
			{	/* Unsafe/bignumber.scm 1038 */
				long BgL_auxz00_6676;

				{	/* Unsafe/bignumber.scm 1038 */
					obj_t BgL_auxz00_6677;

					if (INTEGERP(BgL_seedz00_4713))
						{	/* Unsafe/bignumber.scm 1038 */
							BgL_auxz00_6677 = BgL_seedz00_4713;
						}
					else
						{	/* Unsafe/bignumber.scm 1038 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3186z00zz__bignumz00, BGl_string3148z00zz__bignumz00,
								BgL_seedz00_4713, BGl_string3147z00zz__bignumz00,
								BINT(((long) 33177)));
							exit(-1);
						}
					BgL_auxz00_6676 = (long) CINT(BgL_auxz00_6677);
				}
				return bgl_seed_rand(BgL_auxz00_6676);
			}
		}
	}



/* make-random-u8vector */
	obj_t BGl_makezd2randomzd2u8vectorz00zz__bignumz00(obj_t BgL_lenz00_98)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1043 */
			{
				obj_t BgL_vecz00_1885;

				{	/* Unsafe/bignumber.scm 1051 */
					obj_t BgL_arg2502z00_1882;

					{	/* Llib/srfi4.scm 231 */

						BgL_arg2502z00_1882 =
							BGl_makezd2u8vectorzd2zz__srfi4z00(
							(long) CINT(BgL_lenz00_98), BINT(((long) 0)));
					}
					BgL_vecz00_1885 = BgL_arg2502z00_1882;
					{	/* Unsafe/bignumber.scm 1045 */
						long BgL_g1798z00_1887;

						{	/* Unsafe/bignumber.scm 1045 */
							long BgL_arg2509z00_1895;

							BgL_arg2509z00_1895 = BGL_HVECTOR_LENGTH(BgL_vecz00_1885);
							BgL_g1798z00_1887 = (BgL_arg2509z00_1895 - ((long) 1));
						}
						{
							long BgL_iz00_1889;

							BgL_iz00_1889 = BgL_g1798z00_1887;
						BgL_zc3anonymousza32505ze3z83_1890:
							if ((BgL_iz00_1889 == ((long) -1)))
								{	/* Unsafe/bignumber.scm 1046 */
									return BgL_vecz00_1885;
								}
							else
								{	/* Unsafe/bignumber.scm 1046 */
									{	/* Unsafe/bignumber.scm 1049 */
										long BgL_arg2507z00_1892;

										{	/* Unsafe/bignumber.scm 1049 */
											long BgL_res3056z00_4463;

											{	/* Unsafe/bignumber.scm 1049 */
												int BgL_arg2731z00_4462;

												BgL_arg2731z00_4462 = rand();
												BgL_res3056z00_4463 =
													BGl_modulofxz00zz__r4_numbers_6_5_fixnumz00(
													(long) (BgL_arg2731z00_4462), ((long) 256));
											}
											BgL_arg2507z00_1892 = BgL_res3056z00_4463;
										}
										{	/* Unsafe/bignumber.scm 1049 */
											unsigned char BgL_auxz00_6695;

											BgL_auxz00_6695 = (unsigned char) (BgL_arg2507z00_1892);
											BGL_U8VSET(BgL_vecz00_1885, BgL_iz00_1889,
												BgL_auxz00_6695);
										} BUNSPEC;
									}
									{
										long BgL_iz00_6698;

										BgL_iz00_6698 = (BgL_iz00_1889 - ((long) 1));
										BgL_iz00_1889 = BgL_iz00_6698;
										goto BgL_zc3anonymousza32505ze3z83_1890;
									}
								}
						}
					}
				}
			}
		}
	}



/* $randbx */
	BGL_EXPORTED_DEF obj_t bgl_rand_bignum(obj_t BgL_rangez00_99)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1056 */
			{	/* Unsafe/bignumber.scm 1057 */
				long BgL_rangezd2bitszd2_1898;

				BgL_rangezd2bitszd2_1898 =
					BGl_bignumzd2integerzd2lengthz00zz__bignumz00(BgL_rangez00_99);
				{	/* Unsafe/bignumber.scm 1057 */
					obj_t BgL_lenz00_1899;

					{	/* Unsafe/bignumber.scm 1058 */
						long BgL_arg2517z00_1913;

						BgL_arg2517z00_1913 = (BgL_rangezd2bitszd2_1898 + ((long) 20));
						BgL_lenz00_1899 =
							BGl_quotientz00zz__r4_numbers_6_5_fixnumz00(BINT
							(BgL_arg2517z00_1913), BINT(((long) 8)));
					}
					{	/* Unsafe/bignumber.scm 1058 */
						obj_t BgL_nz00_1900;

						BgL_nz00_1900 =
							BGl_bignumzd2exptzd2zz__bignumz00(bgl_long_to_bignum(((long)
									256)), bgl_long_to_bignum((long) CINT(BgL_lenz00_1899)));
						{	/* Unsafe/bignumber.scm 1059 */
							obj_t BgL_divisorz00_1901;

							BgL_divisorz00_1901 =
								CAR(BGl_bignumzd2divzd2zz__bignumz00(BgL_nz00_1900,
									BgL_rangez00_99));
							{	/* Unsafe/bignumber.scm 1060 */
								obj_t BgL_limitz00_1902;

								BgL_limitz00_1902 =
									bgl_bignum_mul(BgL_divisorz00_1901, BgL_rangez00_99);
								{	/* Unsafe/bignumber.scm 1061 */

									{

									BgL_zc3anonymousza32511ze3z83_1904:
										{	/* Unsafe/bignumber.scm 1063 */
											obj_t BgL_u8vectz00_1905;

											BgL_u8vectz00_1905 =
												BGl_makezd2randomzd2u8vectorz00zz__bignumz00
												(BgL_lenz00_1899);
											{	/* Unsafe/bignumber.scm 1063 */
												obj_t BgL_xz00_1906;

												BgL_xz00_1906 =
													BGl_fixnumzd2listzd2ze3bignumze3zz__bignumz00
													(BGl_u8vectorzd2ze3listz31zz__srfi4z00
													(BgL_u8vectz00_1905), ((long) 255));
												{	/* Unsafe/bignumber.scm 1064 */

													{	/* Unsafe/bignumber.scm 1065 */
														bool_t BgL_testz00_6715;

														if (BGl_z42zc3bxz81zz__bignumz00(BgL_xz00_1906,
																BgL_limitz00_1902))
															{	/* Unsafe/bignumber.scm 1065 */
																BgL_testz00_6715 = ((bool_t) 0);
															}
														else
															{	/* Unsafe/bignumber.scm 1065 */
																BgL_testz00_6715 = ((bool_t) 1);
															}
														if (BgL_testz00_6715)
															{	/* Unsafe/bignumber.scm 1065 */
																goto BgL_zc3anonymousza32511ze3z83_1904;
															}
														else
															{	/* Unsafe/bignumber.scm 1065 */
																return
																	CAR(BGl_bignumzd2divzd2zz__bignumz00
																	(BgL_xz00_1906, BgL_divisorz00_1901));
															}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* _$randbx */
	obj_t BGl__z42randbxz42zz__bignumz00(obj_t BgL_envz00_4714,
		obj_t BgL_rangez00_4715)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1056 */
			{	/* Unsafe/bignumber.scm 1057 */
				obj_t BgL_auxz00_6720;

				if (BIGNUMP(BgL_rangez00_4715))
					{	/* Unsafe/bignumber.scm 1057 */
						BgL_auxz00_6720 = BgL_rangez00_4715;
					}
				else
					{	/* Unsafe/bignumber.scm 1057 */
						BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
							(BGl_string3187z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
							BgL_rangez00_4715, BGl_string3147z00zz__bignumz00,
							BINT(((long) 33938)));
						exit(-1);
					}
				return bgl_rand_bignum(BgL_auxz00_6720);
			}
		}
	}



/* $flonum->bignum */
	BGL_EXPORTED_DEF obj_t bgl_flonum_to_bignum(double BgL_nz00_100)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1072 */
			{	/* Unsafe/bignumber.scm 1073 */
				long BgL_arg2519z00_4489;

				BgL_arg2519z00_4489 = (long) (BgL_nz00_100);
				return bgl_long_to_bignum(BgL_arg2519z00_4489);
			}
		}
	}



/* _$flonum->bignum */
	obj_t BGl__z42flonumzd2ze3bignumz73zz__bignumz00(obj_t BgL_envz00_4716,
		obj_t BgL_nz00_4717)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1072 */
			{	/* Unsafe/bignumber.scm 1073 */
				double BgL_auxz00_6729;

				{	/* Unsafe/bignumber.scm 1073 */
					obj_t BgL_auxz00_6730;

					if (REALP(BgL_nz00_4717))
						{	/* Unsafe/bignumber.scm 1073 */
							BgL_auxz00_6730 = BgL_nz00_4717;
						}
					else
						{	/* Unsafe/bignumber.scm 1073 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3188z00zz__bignumz00, BGl_string3189z00zz__bignumz00,
								BgL_nz00_4717, BGl_string3147z00zz__bignumz00,
								BINT(((long) 34616)));
							exit(-1);
						}
					BgL_auxz00_6729 = REAL_TO_DOUBLE(BgL_auxz00_6730);
				}
				return bgl_flonum_to_bignum(BgL_auxz00_6729);
			}
		}
	}



/* $bignum->flonum */
	BGL_EXPORTED_DEF double bgl_bignum_to_flonum(obj_t BgL_nz00_101)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1075 */
			{	/* Unsafe/bignumber.scm 1076 */
				long BgL_auxz00_6738;

				BgL_auxz00_6738 = bgl_bignum_to_long(BgL_nz00_101);
				return (double) (BgL_auxz00_6738);
		}}
	}



/* _$bignum->flonum */
	obj_t BGl__z42bignumzd2ze3flonumz73zz__bignumz00(obj_t BgL_envz00_4718,
		obj_t BgL_nz00_4719)
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 1075 */
			{	/* Unsafe/bignumber.scm 1076 */
				double BgL_auxz00_6741;

				{	/* Unsafe/bignumber.scm 1076 */
					obj_t BgL_auxz00_6742;

					if (BIGNUMP(BgL_nz00_4719))
						{	/* Unsafe/bignumber.scm 1076 */
							BgL_auxz00_6742 = BgL_nz00_4719;
						}
					else
						{	/* Unsafe/bignumber.scm 1076 */
							BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
								(BGl_string3190z00zz__bignumz00, BGl_string3155z00zz__bignumz00,
								BgL_nz00_4719, BGl_string3147z00zz__bignumz00,
								BINT(((long) 34687)));
							exit(-1);
						}
					BgL_auxz00_6741 = bgl_bignum_to_flonum(BgL_auxz00_6742);
				}
				return DOUBLE_TO_REAL(BgL_auxz00_6741);
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 45 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 45 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__bignumz00()
	{
		AN_OBJECT;
		{	/* Unsafe/bignumber.scm 45 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 68033950),
				BSTRING_TO_STRING(BGl_string3191z00zz__bignumz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 429190545),
				BSTRING_TO_STRING(BGl_string3191z00zz__bignumz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 500588328),
				BSTRING_TO_STRING(BGl_string3191z00zz__bignumz00));
			return
				BGl_modulezd2initializa7ationz75zz__paramz00(((long) 327583589),
				BSTRING_TO_STRING(BGl_string3191z00zz__bignumz00));
		}
	}

#ifdef __cplusplus
}
#endif
#endif
